/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/base/common/types","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/network","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/extensions/common/extensions","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ae=function(ee){for(var e=[],k=0,i=ee.length;k<i;k++)e[k]=oe[ee[k]];return e};define(oe[51],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function k(A){return A?A.replace(/\$\((.*?)\)/g,(O,R)=>` ${R} `).trim():""}e.getCodiconAriaLabel=k;class i{constructor(O,R,P){this.id=O,this.definition=R,this.description=P,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}e.Codicon=i,i.a=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.commentDraft=new i("comment-draft",{fontCharacter:"\\ec0e"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);var D;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function R(C){if(C instanceof i)return["codicon","codicon-"+C.id];const E=O.exec(C.id);if(!E)return R(i.error);const[,w,p]=E,h=["codicon","codicon-"+w];return p&&h.push("codicon-modifier-"+p.substring(1)),h}A.asClassNameArray=R;function P(C){return R(C).join(" ")}A.asClassName=P;function S(C){return"."+R(C).join(".")}A.asCSSSelector=S})(D=e.CSSIcon||(e.CSSIcon={}))}),define(oe[63],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(O){return(R,P,S)=>{let C=null,E=null;if(typeof S.value=="function"?(C="value",E=S.value):typeof S.get=="function"&&(C="get",E=S.get),!E)throw new Error("not supported");S[C]=O(E,P)}}function i(O,R,P){let S=null,C=null;if(typeof P.value=="function"?(S="value",C=P.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(S="get",C=P.get),!C)throw new Error("not supported");const E=`$memoize$${R}`;P[S]=function(...w){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,w)}),this[E]}}e.memoize=i;function D(O,R,P){return k((S,C)=>{const E=`$debounce$${C}`,w=`$debounce$result$${C}`;return function(...p){this[w]||(this[w]=P?P():void 0),clearTimeout(this[E]),R&&(this[w]=R(this[w],...p),p=[this[w]]),this[E]=setTimeout(()=>{S.apply(this,p),this[w]=P?P():void 0},O)}})}e.debounce=D;function A(O,R,P){return k((S,C)=>{const E=`$throttle$timer$${C}`,w=`$throttle$result$${C}`,p=`$throttle$lastRun$${C}`,h=`$throttle$pending$${C}`;return function(...g){if(this[w]||(this[w]=P?P():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),R&&(this[w]=R(this[w],...g)),this[h])return;const y=this[p]+O;y<=Date.now()?(this[p]=Date.now(),S.apply(this,[this[w]]),this[w]=P?P():void 0):(this[h]=!0,this[E]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),S.apply(this,[this[w]]),this[w]=P?P():void 0},y-Date.now()))}})}e.throttle=A}),define(oe[9],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?m.isErrorNoTelemetry(n)?new m(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=k,e.errorHandler=new k;function i(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=i;function D(f){P(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=D;function A(f){P(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=A;function O(f){if(f instanceof Error){const{name:n,message:s}=f,t=f.stacktrace||f.stack;return{$isError:!0,name:n,message:s,stack:t,noTelemetry:m.isErrorNoTelemetry(f)}}return f}e.transformErrorForSerialization=O;const R="Canceled";function P(f){return f instanceof S?!0:f instanceof Error&&f.name===R&&f.message===R}e.isCancellationError=P;class S extends Error{constructor(){super(R),this.name=this.message}}e.CancellationError=S;function C(){const f=new Error(R);return f.name=f.message,f}e.canceled=C;function E(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=E;function w(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=w;function p(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(f){const n=new Error(`${f} has been disposed`);return n.name="DISPOSED",n}e.disposed=h;function g(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=g;class y extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=y;class l extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=l;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class m extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof m)return n;const s=new m;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class v extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,v.prototype);debugger}}e.BugIndicatingError=v}),define(oe[20],ae([0,1,9]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function i(X,te=0){return X[X.length-(1+te)]}e.tail=i;function D(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.tail2=D;function A(X,te,se=(le,ue)=>le===ue){if(X===te)return!0;if(!X||!te||X.length!==te.length)return!1;for(let le=0,ue=X.length;le<ue;le++)if(!se(X[le],te[le]))return!1;return!0}e.equals=A;function O(X,te){const se=X.length-1;te<se&&(X[te]=X[se]),X.pop()}e.removeFastWithoutKeepingOrder=O;function R(X,te,se){return P(X.length,le=>se(X[le],te))}e.binarySearch=R;function P(X,te){let se=0,le=X-1;for(;se<=le;){const ue=(se+le)/2|0,ye=te(ue);if(ye<0)se=ue+1;else if(ye>0)le=ue-1;else return ue}return-(se+1)}e.binarySearch2=P;function S(X,te){let se=0,le=X.length;if(le===0)return 0;for(;se<le;){const ue=Math.floor((se+le)/2);te(X[ue])?le=ue:se=ue+1}return se}e.findFirstInSorted=S;function C(X,te,se){if(X=X|0,X>=te.length)throw new TypeError("invalid index");const le=te[Math.floor(te.length*Math.random())],ue=[],ye=[],Se=[];for(const be of te){const Ee=se(be,le);Ee<0?ue.push(be):Ee>0?ye.push(be):Se.push(be)}return X<ue.length?C(X,ue,se):X<ue.length+Se.length?Se[0]:C(X-(ue.length+Se.length),ye,se)}e.quickSelect=C;function E(X,te){const se=[];let le;for(const ue of X.slice(0).sort(te))!le||te(le[0],ue)!==0?(le=[ue],se.push(le)):le.push(ue);return se}e.groupBy=E;function w(X,te,se){const le=[];function ue(be,Ee,Ne){if(Ee===0&&Ne.length===0)return;const Fe=le[le.length-1];Fe&&Fe.start+Fe.deleteCount===be?(Fe.deleteCount+=Ee,Fe.toInsert.push(...Ne)):le.push({start:be,deleteCount:Ee,toInsert:Ne})}let ye=0,Se=0;for(;;){if(ye===X.length){ue(ye,0,te.slice(Se));break}if(Se===te.length){ue(ye,X.length-ye,[]);break}const be=X[ye],Ee=te[Se],Ne=se(be,Ee);Ne===0?(ye+=1,Se+=1):Ne<0?(ue(ye,1,[]),ye+=1):Ne>0&&(ue(ye,0,[Ee]),Se+=1)}return le}e.sortedDiff=w;function p(X,te,se){const le=w(X,te,se),ue=[],ye=[];for(const Se of le)ue.push(...X.slice(Se.start,Se.start+Se.deleteCount)),ye.push(...Se.toInsert);return{removed:ue,added:ye}}e.delta=p;function h(X,te,se){if(se===0)return[];const le=X.slice(0,se).sort(te);return y(X,te,le,se,X.length),le}e.top=h;function g(X,te,se,le,ue){return se===0?Promise.resolve([]):new Promise((ye,Se)=>{(async()=>{const be=X.length,Ee=X.slice(0,se).sort(te);for(let Ne=se,Fe=Math.min(se+le,be);Ne<be;Ne=Fe,Fe=Math.min(Fe+le,be)){if(Ne>se&&await new Promise(Ye=>setTimeout(Ye)),ue&&ue.isCancellationRequested)throw new k.CancellationError;y(X,te,Ee,Ne,Fe)}return Ee})().then(ye,Se)})}e.topAsync=g;function y(X,te,se,le,ue){for(const ye=se.length;le<ue;le++){const Se=X[le];if(te(Se,se[ye-1])<0){se.pop();const be=S(se,Ee=>te(Se,Ee)<0);se.splice(be,0,Se)}}}function l(X){return X.filter(te=>!!te)}e.coalesce=l;function d(X){let te=0;for(let se=0;se<X.length;se++)X[se]&&(X[te]=X[se],te+=1);X.length=te}e.coalesceInPlace=d;function m(X,te,se){X.splice(se,0,X.splice(te,1)[0])}e.move=m;function v(X){return!Array.isArray(X)||X.length===0}e.isFalsyOrEmpty=v;function f(X){return Array.isArray(X)&&X.length>0}e.isNonEmptyArray=f;function n(X,te=se=>se){const se=new Set;return X.filter(le=>{const ue=te(le);return se.has(ue)?!1:(se.add(ue),!0)})}e.distinct=n;function s(X){const te=new Set;return se=>{const le=X(se);return te.has(le)?!1:(te.add(le),!0)}}e.uniqueFilter=s;function t(X,te){const se=r(X,te);if(se!==-1)return X[se]}e.findLast=t;function r(X,te){for(let se=X.length-1;se>=0;se--){const le=X[se];if(te(le))return se}return-1}e.lastIndex=r;function o(X,te){return X.length>0?X[0]:te}e.firstOrDefault=o;function c(X,te){return X.length>0?X[X.length-1]:te}e.lastOrDefault=c;function a(X,te,se=(le,ue)=>le===ue){let le=0;for(let ue=0,ye=Math.min(X.length,te.length);ue<ye&&se(X[ue],te[ue]);ue++)le++;return le}e.commonPrefixLength=a;function u(X){return[].concat(...X)}e.flatten=u;function b(X,te){let se=typeof te=="number"?X:0;typeof te=="number"?se=X:(se=0,te=X);const le=[];if(se<=te)for(let ue=se;ue<te;ue++)le.push(ue);else for(let ue=se;ue>te;ue--)le.push(ue);return le}e.range=b;function I(X,te,se){return X.reduce((le,ue)=>(le[te(ue)]=se?se(ue):ue,le),Object.create(null))}e.index=I;function F(X,te){return X.push(te),()=>N(X,te)}e.insert=F;function N(X,te){const se=X.indexOf(te);if(se>-1)return X.splice(se,1),te}e.remove=N;function $(X,te,se){const le=X.slice(0,te),ue=X.slice(te);return le.concat(se,ue)}e.arrayInsert=$;function j(X,te){let se;if(typeof te=="number"){let le=te;se=()=>{const ue=Math.sin(le++)*179426549;return ue-Math.floor(ue)}}else se=Math.random;for(let le=X.length-1;le>0;le-=1){const ue=Math.floor(se()*(le+1)),ye=X[le];X[le]=X[ue],X[ue]=ye}}e.shuffle=j;function L(X,te){const se=X.indexOf(te);se>-1&&(X.splice(se,1),X.unshift(te))}e.pushToStart=L;function M(X,te){const se=X.indexOf(te);se>-1&&(X.splice(se,1),X.push(te))}e.pushToEnd=M;function z(X,te){for(const se of te)X.push(se)}e.pushMany=z;function G(X,te){return Array.isArray(X)?X.map(te):te(X)}e.mapArrayOrNot=G;function W(X){return Array.isArray(X)?X:[X]}e.asArray=W;function _(X){return X[Math.floor(Math.random()*X.length)]}e.getRandomElement=_;function K(X,te){for(const se of X){const le=te(se);if(le!==void 0)return le}}e.mapFind=K;function q(X,te,se){const le=Z(X,te),ue=X.length,ye=se.length;X.length=ue+ye;for(let Se=ue-1;Se>=le;Se--)X[Se+ye]=X[Se];for(let Se=0;Se<ye;Se++)X[Se+le]=se[Se]}e.insertInto=q;function V(X,te,se,le){const ue=Z(X,te),ye=X.splice(ue,se);return q(X,ue,le),ye}e.splice=V;function Z(X,te){return te<0?Math.max(te+X.length,0):Math.min(te,X.length)}var ne;(function(X){function te(ue){return ue<0}X.isLessThan=te;function se(ue){return ue>0}X.isGreaterThan=se;function le(ue){return ue===0}X.isNeitherLessOrGreaterThan=le,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(ne=e.CompareResult||(e.CompareResult={}));function J(X,te){return(se,le)=>te(X(se),X(le))}e.compareBy=J;function x(...X){return(te,se)=>{for(const le of X){const ue=le(te,se);if(!ne.isNeitherLessOrGreaterThan(ue))return ue}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=x;const T=(X,te)=>X-te;e.numberComparator=T;function U(X,te){if(X.length===0)return;let se=X[0];for(let le=1;le<X.length;le++){const ue=X[le];te(ue,se)>0&&(se=ue)}return se}e.findMaxBy=U;function H(X,te){if(X.length===0)return;let se=X[0];for(let le=1;le<X.length;le++){const ue=X[le];te(ue,se)>=0&&(se=ue)}return se}e.findLastMaxBy=H;function B(X,te){return U(X,(se,le)=>-te(se,le))}e.findMinBy=B;class Q{constructor(te){this.f=te,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(te){let se=this.c;for(;se<this.f.length&&te(this.f[se]);)se++;const le=se===this.c?null:this.f.slice(this.c,se);return this.c=se,le}takeFromEndWhile(te){let se=this.d;for(;se>=0&&te(this.f[se]);)se--;const le=se===this.d?null:this.f.slice(se+1,this.d+1);return this.d=se,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const te=this.f[this.c];return this.c++,te}removeLast(){const te=this.f[this.d];return this.d--,te}takeCount(te){const se=this.f.slice(this.c,this.c+te);return this.c+=te,se}}e.ArrayQueue=Q;class re{constructor(te){this.iterate=te}forEach(te){this.iterate(se=>(te(se),!0))}toArray(){const te=[];return this.iterate(se=>(te.push(se),!0)),te}filter(te){return new re(se=>this.iterate(le=>te(le)?se(le):!0))}map(te){return new re(se=>this.iterate(le=>se(te(le))))}some(te){let se=!1;return this.iterate(le=>(se=te(le),!se)),se}findFirst(te){let se;return this.iterate(le=>te(le)?(se=le,!1):!0),se}findLast(te){let se;return this.iterate(le=>(te(le)&&(se=le),!0)),se}findLastMaxBy(te){let se,le=!0;return this.iterate(ue=>((le||ne.isGreaterThan(te(ue,se)))&&(le=!1,se=ue),!0)),se}}e.CallbackIterable=re,re.empty=new re(X=>{})}),define(oe[126],ae([0,1,9]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function i(P,S){if(!P)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=i;function D(P,S="Unreachable"){throw new Error(S)}e.assertNever=D;function A(P){if(!P)throw new k.BugIndicatingError("Assertion Failed")}e.assert=A;function O(P){if(!P()){debugger;P(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=O;function R(P,S){let C=0;for(;C<P.length-1;){const E=P[C],w=P[C+1];if(!S(E,w))return!1;C++}return!0}e.checkAdjacentItems=R}),define(oe[82],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(i){const D=this;let A=!1,O;return function(){return A||(A=!0,O=i.apply(D,arguments)),O}}e.once=k}),define(oe[64],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(i){function D(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}i.is=D;const A=Object.freeze([]);function O(){return A}i.empty=O;function*R(v){yield v}i.single=R;function P(v){return D(v)?v:R(v)}i.wrap=P;function S(v){return v||A}i.from=S;function C(v){return!v||v[Symbol.iterator]().next().done===!0}i.isEmpty=C;function E(v){return v[Symbol.iterator]().next().value}i.first=E;function w(v,f){for(const n of v)if(f(n))return!0;return!1}i.some=w;function p(v,f){for(const n of v)if(f(n))return n}i.find=p;function*h(v,f){for(const n of v)f(n)&&(yield n)}i.filter=h;function*g(v,f){let n=0;for(const s of v)yield f(s,n++)}i.map=g;function*y(...v){for(const f of v)for(const n of f)yield n}i.concat=y;function l(v,f,n){let s=n;for(const t of v)s=f(s,t);return s}i.reduce=l;function*d(v,f,n=v.length){for(f<0&&(f+=v.length),n<0?n+=v.length:n>v.length&&(n=v.length);f<n;f++)yield v[f]}i.slice=d;function m(v,f=Number.POSITIVE_INFINITY){const n=[];if(f===0)return[n,v];const s=v[Symbol.iterator]();for(let t=0;t<f;t++){const r=s.next();if(r.done)return[n,i.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}i.consume=m})(k=e.Iterable||(e.Iterable={}))}),define(oe[35],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var i;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(n){n.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function O(n,s=!1){let t=0;const r=n.length;let o="",c=0,a=16,u=0;function b(M){let z=0,G=0;for(;z<M;){const W=n.charCodeAt(t);if(W>=48&&W<=57)G=G*16+W-48;else if(W>=65&&W<=70)G=G*16+W-65+10;else if(W>=97&&W<=102)G=G*16+W-97+10;else break;t++,z++}return z<M&&(G=-1),G}function I(M){t=M,o="",c=0,a=16,u=0}function F(){const M=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&S(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&S(n.charCodeAt(t)))for(t++;t<n.length&&S(n.charCodeAt(t));)t++;else return u=3,n.substring(M,t);let z=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&S(n.charCodeAt(t))){for(t++;t<n.length&&S(n.charCodeAt(t));)t++;z=t}else u=3;return n.substring(M,z)}function N(){let M="",z=t;for(;;){if(t>=r){M+=n.substring(z,t),u=2;break}const G=n.charCodeAt(t);if(G===34){M+=n.substring(z,t),t++;break}if(G===92){if(M+=n.substring(z,t),t++,t>=r){u=2;break}switch(n.charCodeAt(t++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const _=b(4);_>=0?M+=String.fromCharCode(_):u=4;break}default:u=5}z=t;continue}if(G>=0&&G<=31)if(P(G)){M+=n.substring(z,t),u=2;break}else u=6;t++}return M}function $(){if(o="",u=0,c=t,t>=r)return c=r,a=17;let M=n.charCodeAt(t);if(R(M)){do t++,o+=String.fromCharCode(M),M=n.charCodeAt(t);while(R(M));return a=15}if(P(M))return t++,o+=String.fromCharCode(M),M===13&&n.charCodeAt(t)===10&&(t++,o+=`
`),a=14;switch(M){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,o=N(),a=10;case 47:{const z=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<r&&!P(n.charCodeAt(t));)t++;return o=n.substring(z,t),a=12}if(n.charCodeAt(t+1)===42){t+=2;const G=r-1;let W=!1;for(;t<G;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,W=!0;break}t++}return W||(t++,u=1),o=n.substring(z,t),a=13}return o+=String.fromCharCode(M),t++,a=16}case 45:if(o+=String.fromCharCode(M),t++,t===r||!S(n.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=F(),a=11;default:for(;t<r&&j(M);)t++,M=n.charCodeAt(t);if(c!==t){switch(o=n.substring(c,t),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(M),t++,a=16}}function j(M){if(R(M)||P(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let M;do M=$();while(M>=12&&M<=15);return M}return{setPosition:I,getPosition:()=>t,scan:s?L:$,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>u}}e.createScanner=O;function R(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function P(n){return n===10||n===13||n===8232||n===8233}function S(n){return n>=48&&n<=57}var C;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(C||(C={}));function E(n,s){const t=[],r=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function u(b,I,F,N){c.value=b,c.offset=I,c.length=F,c.type=N,c.colonOffset=void 0,o=c}try{m(n,{onObjectBegin:(b,I)=>{if(s<=b)throw r;o=void 0,a=s>b,t.push("")},onObjectProperty:(b,I,F)=>{if(s<I||(u(b,I,F,"property"),t[t.length-1]=b,s<=I+F))throw r},onObjectEnd:(b,I)=>{if(s<=b)throw r;o=void 0,t.pop()},onArrayBegin:(b,I)=>{if(s<=b)throw r;o=void 0,t.push(0)},onArrayEnd:(b,I)=>{if(s<=b)throw r;o=void 0,t.pop()},onLiteralValue:(b,I,F)=>{if(s<I||(u(b,I,F,f(b)),s<=I+F))throw r},onSeparator:(b,I,F)=>{if(s<=I)throw r;if(b===":"&&o&&o.type==="property")o.colonOffset=I,a=!1,o=void 0;else if(b===","){const N=t[t.length-1];typeof N=="number"?t[t.length-1]=N+1:(a=!0,t[t.length-1]=""),o=void 0}}})}catch(b){if(b!==r)throw b}return{path:t,previousNode:o,isAtPropertyKey:a,matches:b=>{let I=0;for(let F=0;I<b.length&&F<t.length;F++)if(b[I]===t[F]||b[I]==="*")I++;else if(b[I]!=="**")return!1;return I===b.length}}}e.getLocation=E;function w(n,s=[],t=A.DEFAULT){let r=null,o=[];const c=[];function a(b){Array.isArray(o)?o.push(b):r!==null&&(o[r]=b)}return m(n,{onObjectBegin:()=>{const b={};a(b),c.push(o),o=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const b=[];a(b),c.push(o),o=b,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:a,onError:(b,I,F)=>{s.push({error:b,offset:I,length:F})}},t),o[0]}e.parse=w;function p(n,s=[],t=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(b){r.type==="property"&&(r.length=b-r.offset,r=r.parent)}function c(b){return r.children.push(b),b}m(n,{onObjectBegin:b=>{r=c({type:"object",offset:b,length:-1,parent:r,children:[]})},onObjectProperty:(b,I,F)=>{r=c({type:"property",offset:I,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:b,offset:I,length:F,parent:r})},onObjectEnd:(b,I)=>{r.length=b+I-r.offset,r=r.parent,o(b+I)},onArrayBegin:(b,I)=>{r=c({type:"array",offset:b,length:-1,parent:r,children:[]})},onArrayEnd:(b,I)=>{r.length=b+I-r.offset,r=r.parent,o(b+I)},onLiteralValue:(b,I,F)=>{c({type:f(b),offset:I,length:F,parent:r,value:b}),o(I+F)},onSeparator:(b,I,F)=>{r.type==="property"&&(b===":"?r.colonOffset=I:b===","&&o(I))},onError:(b,I,F)=>{s.push({error:b,offset:I,length:F})}},t);const u=r.children[0];return u&&delete u.parent,u}e.parseTree=p;function h(n,s){if(!n)return;let t=n;for(const r of s)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===r){t=c.children[1],o=!0;break}if(!o)return}else{const o=r;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=h;function g(n){if(!n.parent||!n.parent.children)return[];const s=g(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;s.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&s.push(t)}return s}e.getNodePath=g;function y(n){switch(n.type){case"array":return n.children.map(y);case"object":{const s=Object.create(null);for(const t of n.children){const r=t.children[1];r&&(s[t.children[0].value]=y(r))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=y;function l(n,s,t=!1){return s>=n.offset&&s<n.offset+n.length||t&&s===n.offset+n.length}e.contains=l;function d(n,s,t=!1){if(l(n,s,t)){const r=n.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=s;o++){const c=d(r[o],s,t);if(c)return c}return n}}e.findNodeAtOffset=d;function m(n,s,t=A.DEFAULT){const r=O(n,!1);function o(J){return J?()=>J(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(J){return J?x=>J(x,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=o(s.onObjectBegin),u=c(s.onObjectProperty),b=o(s.onObjectEnd),I=o(s.onArrayBegin),F=o(s.onArrayEnd),N=c(s.onLiteralValue),$=c(s.onSeparator),j=o(s.onComment),L=c(s.onError),M=t&&t.disallowComments,z=t&&t.allowTrailingComma;function G(){for(;;){const J=r.scan();switch(r.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:M||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(J){case 12:case 13:M?W(10):j();break;case 16:W(1);break;case 15:case 14:break;default:return J}}}function W(J,x=[],T=[]){if(L(J),x.length+T.length>0){let U=r.getToken();for(;U!==17;){if(x.indexOf(U)!==-1){G();break}else if(T.indexOf(U)!==-1)break;U=G()}}}function _(J){const x=r.getTokenValue();return J?N(x):u(x),G(),!0}function K(){switch(r.getToken()){case 11:{let J=0;try{J=JSON.parse(r.getTokenValue()),typeof J!="number"&&(W(2),J=0)}catch{W(2)}N(J);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return G(),!0}function q(){return r.getToken()!==10?(W(3,[],[2,5]),!1):(_(!1),r.getToken()===6?($(":"),G(),ne()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function V(){a(),G();let J=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(J||W(4,[],[]),$(","),G(),r.getToken()===2&&z)break}else J&&W(6,[],[]);q()||W(4,[],[2,5]),J=!0}return b(),r.getToken()!==2?W(7,[2],[]):G(),!0}function Z(){I(),G();let J=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(J||W(4,[],[]),$(","),G(),r.getToken()===4&&z)break}else J&&W(6,[],[]);ne()||W(4,[],[4,5]),J=!0}return F(),r.getToken()!==4?W(8,[4],[]):G(),!0}function ne(){switch(r.getToken()){case 3:return Z();case 1:return V();case 10:return _(!0);default:return K()}}return G(),r.getToken()===17?t.allowEmptyContent?!0:(W(4,[],[]),!1):ne()?(r.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=m;function v(n,s){const t=O(n),r=[];let o,c=0,a;do switch(a=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:c!==a&&r.push(n.substring(c,a)),s!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,s)),c=t.getPosition();break}while(o!==17);return r.join("")}e.stripComments=v;function f(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(oe[43],ae([0,1,35]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(S,C,E){let w,p,h,g,y;if(C){for(g=C.offset,y=g+C.length,h=g;h>0&&!P(S,h-1);)h--;let a=y;for(;a<S.length&&!P(S,a);)a++;p=S.substring(h,a),w=O(p,E)}else p=S,w=0,h=0,g=0,y=S.length;const l=R(E,S);let d=!1,m=0,v;E.insertSpaces?v=A(" ",E.tabSize||4):v="	";const f=(0,k.createScanner)(p,!1);let n=!1;function s(){return l+A(v,w+m)}function t(){let a=f.scan();for(d=!1;a===15||a===14;)d=d||a===14,a=f.scan();return n=a===16||f.getTokenError()!==0,a}const r=[];function o(a,u,b){!n&&u<y&&b>g&&S.substring(u,b)!==a&&r.push({offset:u,length:b-u,content:a})}let c=t();if(c!==17){const a=f.getTokenOffset()+h,u=A(v,w);o(u,h,a)}for(;c!==17;){let a=f.getTokenOffset()+f.getTokenLength()+h,u=t(),b="";for(;!d&&(u===12||u===13);){const F=f.getTokenOffset()+h;o(" ",a,F),a=f.getTokenOffset()+f.getTokenLength()+h,b=u===12?s():"",u=t()}if(u===2)c!==1&&(m--,b=s());else if(u===4)c!==3&&(m--,b=s());else{switch(c){case 3:case 1:m++,b=s();break;case 5:case 12:b=s();break;case 13:d?b=s():b=" ";break;case 6:b=" ";break;case 10:if(u===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?b=" ":u!==5&&u!==17&&(n=!0);break;case 16:n=!0;break}d&&(u===12||u===13)&&(b=s())}const I=f.getTokenOffset()+h;o(b,a,I),c=u}return r}e.format=i;function D(S,C){const E=JSON.stringify(S,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?E.replace(/\r\n|\r|\n/g,C.eol):E}e.toFormattedString=D;function A(S,C){let E="";for(let w=0;w<C;w++)E+=S;return E}function O(S,C){let E=0,w=0;const p=C.tabSize||4;for(;E<S.length;){const h=S.charAt(E);if(h===" ")w++;else if(h==="	")w+=p;else break;E++}return Math.floor(w/p)}function R(S,C){for(let E=0;E<C.length;E++){const w=C.charAt(E);if(w==="\r")return E+1<C.length&&C.charAt(E+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=R;function P(S,C){return`\r
`.indexOf(S.charAt(C))!==-1}e.isEOL=P}),define(oe[83],ae([0,1,35,43]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(S,C,E){return A(S,C,void 0,E)}e.removeProperty=D;function A(S,C,E,w,p){const h=C.slice(),g=[],y=(0,k.parseTree)(S,g);let l,d;for(;h.length>0&&(d=h.pop(),l=(0,k.findNodeAtLocation)(y,h),l===void 0&&E!==void 0);)typeof d=="string"?E={[d]:E}:E=[E];if(l)if(l.type==="object"&&typeof d=="string"&&Array.isArray(l.children)){const m=(0,k.findNodeAtLocation)(l,[d]);if(m!==void 0)if(E===void 0){if(!m.parent)throw new Error("Malformed AST");const v=l.children.indexOf(m.parent);let f,n=m.parent.offset+m.parent.length;if(v>0){const s=l.children[v-1];f=s.offset+s.length}else f=l.offset+1,l.children.length>1&&(n=l.children[1].offset);return O(S,{offset:f,length:n-f,content:""},w)}else return O(S,{offset:m.offset,length:m.length,content:JSON.stringify(E)},w);else{if(E===void 0)return[];const v=`${JSON.stringify(d)}: ${JSON.stringify(E)}`,f=p?p(l.children.map(s=>s.children[0].value)):l.children.length;let n;if(f>0){const s=l.children[f-1];n={offset:s.offset+s.length,length:0,content:","+v}}else l.children.length===0?n={offset:l.offset+1,length:0,content:v}:n={offset:l.offset+1,length:0,content:v+","};return O(S,n,w)}}else if(l.type==="array"&&typeof d=="number"&&Array.isArray(l.children))if(E!==void 0){const m=`${JSON.stringify(E)}`;let v;if(l.children.length===0||d===0)v={offset:l.offset+1,length:0,content:l.children.length===0?m:m+","};else{const f=d===-1||d>l.children.length?l.children.length:d,n=l.children[f-1];v={offset:n.offset+n.length,length:0,content:","+m}}return O(S,v,w)}else{const m=d,v=l.children[m];let f;if(l.children.length===1)f={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===m){const n=l.children[m-1],s=n.offset+n.length,t=l.offset+l.length;f={offset:s,length:t-2-s,content:""}}else f={offset:v.offset,length:l.children[m+1].offset-v.offset,content:""};return O(S,f,w)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${l.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return O(S,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(E)},w)}}e.setProperty=A;function O(S,C,E){let w=R(S,C),p=C.offset,h=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;p>0&&!(0,i.isEOL)(w,p-1);)p--;for(;h<w.length&&!(0,i.isEOL)(w,h);)h++}const g=(0,i.format)(w,{offset:p,length:h-p},E);for(let l=g.length-1;l>=0;l--){const d=g[l];w=R(w,d),p=Math.min(p,d.offset),h=Math.max(h,d.offset+d.length),h+=d.content.length-d.length}const y=S.length-(w.length-h)-p;return[{offset:p,length:y,content:w.substring(p,h)}]}e.withFormatting=O;function R(S,C){return S.substring(0,C.offset)+C.content+S.substring(C.offset+C.length)}e.applyEdit=R;function P(S,C){const E=C.slice(0).sort((p,h)=>{const g=p.offset-h.offset;return g===0?p.length-h.length:g});let w=S.length;for(let p=E.length-1;p>=0;p--){const h=E[p];if(h.offset+h.length<=w)S=R(S,h);else throw new Error("Overlapping edit");w=h.offset}return S}e.applyEdits=P}),define(oe[127],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(D){this.d=D,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(D){return new k(()=>D(this.getValue()))}}e.Lazy=k}),define(oe[2],ae([0,1,82,64]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let A=null;function O(c){A=c}if(e.setDisposableTracker=O,D){const c="__is_disposable_tracked__";O(new class{trackDisposable(a){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[c]||console.log(u)},3e3)}setParent(a,u){if(a&&a!==d.None)try{a[c]=!0}catch{}}markAsDisposed(a){if(a&&a!==d.None)try{a[c]=!0}catch{}}markAsSingleton(a){}})}function R(c){return A?.trackDisposable(c),c}function P(c){A?.markAsDisposed(c)}function S(c,a){A?.setParent(c,a)}function C(c,a){if(!!A)for(const u of c)A.setParent(u,a)}function E(c){return A?.markAsSingleton(c),c}e.markAsSingleton=E;function w(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=w;function p(c){if(i.Iterable.is(c)){const a=[];for(const u of c)if(u)try{u.dispose()}catch(b){a.push(b)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=p;function h(c){for(const a of c)w(a)&&a.dispose();return[]}e.disposeIfDisposable=h;function g(...c){const a=y(()=>p(c));return C(c,a),a}e.combinedDisposable=g;function y(c){const a=R({dispose:(0,k.once)(()=>{P(a),c()})});return a}e.toDisposable=y;class l{constructor(){this.c=new Set,this.f=!1,R(this)}dispose(){this.f||(P(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{p(this.c)}finally{this.c.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return S(a,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(a),a}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this.q=new l,R(this),S(this.q,this)}dispose(){P(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class m{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&S(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,P(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&S(a,null),a}}e.MutableDisposable=m;class v{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=v;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(a){let u=a;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,P(this))},this}}e.SafeDisposable=f;class n{constructor(){this.a=new Map}acquire(a,...u){let b=this.a.get(a);b||(b={counter:0,object:this.b(a,...u)},this.a.set(a,b));const{object:I}=b,F=(0,k.once)(()=>{--b.counter===0&&(this.c(a,b.object),this.a.delete(a))});return b.counter++,{object:I,dispose:F}}}e.ReferenceCollection=n;class s{constructor(a){this.a=a}async acquire(a,...u){const b=this.a.acquire(a,...u);try{return{object:await b.object,dispose:()=>b.dispose()}}catch(I){throw b.dispose(),I}}}e.AsyncReferenceCollection=s;class t{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=t;function r(c){const a=new l;try{c(a)}finally{a.dispose()}}e.disposeOnReturn=r;class o{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){P(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{p(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get(a){return this.a.get(a)}set(a,u,b=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||this.a.get(a)?.dispose(),this.a.set(a,u)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(oe[84],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(A){this.element=A,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class i{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let A=this.a;for(;A!==k.Undefined;){const O=A.next;A.prev=k.Undefined,A.next=k.Undefined,A=O}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const R=new k(A);if(this.a===k.Undefined)this.a=R,this.b=R;else if(O){const S=this.b;this.b=R,R.prev=S,S.next=R}else{const S=this.a;this.a=R,R.next=S,S.prev=R}this.c+=1;let P=!1;return()=>{P||(P=!0,this.e(R))}}shift(){if(this.a!==k.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==k.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==k.Undefined&&A.next!==k.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===k.Undefined&&A.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):A.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):A.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==k.Undefined;)yield A.element,A=A.next}}e.LinkedList=i}),define(oe[37],ae([0,1]),function(ee,e){"use strict";var k,i,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(h,g,y){let l=h.get(g);return l===void 0&&(l=y,h.set(g,l)),l}e.getOrSet=A;function O(h){const g=[];return h.forEach((y,l)=>{g.push(`${l} => ${y}`)}),`Map(${h.size}) {${g.join(", ")}}`}e.mapToString=O;function R(h){const g=[];return h.forEach(y=>{g.push(y)}),`Set(${h.size}) {${g.join(", ")}}`}e.setToString=R;class P{constructor(g,y){this.uri=g,this.value=y}}class S{constructor(g,y){this[k]="ResourceMap",g instanceof S?(this.b=new Map(g.b),this.c=y??S.a):(this.b=new Map,this.c=g??S.a)}set(g,y){return this.b.set(this.c(g),new P(g,y)),this}get(g){return this.b.get(this.c(g))?.value}has(g){return this.b.has(this.c(g))}get size(){return this.b.size}clear(){this.b.clear()}delete(g){return this.b.delete(this.c(g))}forEach(g,y){typeof y<"u"&&(g=g.bind(y));for(const[l,d]of this.b)g(d.value,d.uri,this)}*values(){for(const g of this.b.values())yield g.value}*keys(){for(const g of this.b.values())yield g.uri}*entries(){for(const g of this.b.values())yield[g.uri,g.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,g]of this.b)yield[g.uri,g.value]}}e.ResourceMap=S,S.a=h=>h.toString();class C{constructor(g,y){this[i]="ResourceSet",!g||typeof g=="function"?this.a=new S(g):(this.a=new S(y),g.forEach(this.add,this))}get size(){return this.a.size}add(g){return this.a.set(g,g),this}clear(){this.a.clear()}delete(g){return this.a.delete(g)}forEach(g,y){this.a.forEach((l,d)=>g.call(y,d,d,this))}has(g){return this.a.has(g)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=C;var E;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class w{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(g){return this.a.has(g)}get(g,y=0){const l=this.a.get(g);if(!!l)return y!==0&&this.j(l,y),l.value}set(g,y,l=0){let d=this.a.get(g);if(d)d.value=y,l!==0&&this.j(d,l);else{switch(d={key:g,value:y,next:void 0,previous:void 0},l){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(g,d),this.d++}return this}delete(g){return!!this.remove(g)}remove(g){const y=this.a.get(g);if(!!y)return this.a.delete(g),this.i(y),this.d--,y.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const g=this.b;return this.a.delete(g.key),this.i(g),this.d--,g.value}forEach(g,y){const l=this.e;let d=this.b;for(;d;){if(y?g.bind(y)(d.value,d.key,this):g(d.value,d.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const g=this,y=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(g.e!==y)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:l.key,done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return d}values(){const g=this,y=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(g.e!==y)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:l.value,done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return d}entries(){const g=this,y=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(g.e!==y)throw new Error("LinkedMap got modified during iteration.");if(l){const m={value:[l.key,l.value],done:!1};return l=l.next,m}else return{value:void 0,done:!0}}};return d}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(g){if(g>=this.size)return;if(g===0){this.clear();return}let y=this.b,l=this.size;for(;y&&l>g;)this.a.delete(y.key),y=y.next,l--;this.b=y,this.d=l,y&&(y.previous=void 0),this.e++}g(g){if(!this.b&&!this.c)this.c=g;else if(this.b)g.next=this.b,this.b.previous=g;else throw new Error("Invalid list");this.b=g,this.e++}h(g){if(!this.b&&!this.c)this.b=g;else if(this.c)g.previous=this.c,this.c.next=g;else throw new Error("Invalid list");this.c=g,this.e++}i(g){if(g===this.b&&g===this.c)this.b=void 0,this.c=void 0;else if(g===this.b){if(!g.next)throw new Error("Invalid list");g.next.previous=void 0,this.b=g.next}else if(g===this.c){if(!g.previous)throw new Error("Invalid list");g.previous.next=void 0,this.c=g.previous}else{const y=g.next,l=g.previous;if(!y||!l)throw new Error("Invalid list");y.previous=l,l.next=y}g.next=void 0,g.previous=void 0,this.e++}j(g,y){if(!this.b||!this.c)throw new Error("Invalid list");if(!(y!==1&&y!==2)){if(y===1){if(g===this.b)return;const l=g.next,d=g.previous;g===this.c?(d.next=void 0,this.c=d):(l.previous=d,d.next=l),g.previous=void 0,g.next=this.b,this.b.previous=g,this.b=g,this.e++}else if(y===2){if(g===this.c)return;const l=g.next,d=g.previous;g===this.b?(l.previous=void 0,this.b=l):(l.previous=d,d.next=l),g.next=void 0,g.previous=this.c,this.c.next=g,this.c=g,this.e++}}}toJSON(){const g=[];return this.forEach((y,l)=>{g.push([l,y])}),g}fromJSON(g){this.clear();for(const[y,l]of g)this.set(y,l)}}e.LinkedMap=w;class p extends w{constructor(g,y=1){super(),this.k=g,this.l=Math.min(Math.max(0,y),1)}get limit(){return this.k}set limit(g){this.k=g,this.m()}get ratio(){return this.l}set ratio(g){this.l=Math.min(Math.max(0,g),1),this.m()}get(g,y=2){return super.get(g,y)}peek(g){return super.get(g,0)}set(g,y){return super.set(g,y,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=p}),define(oe[85],ae([0,1,37]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new k.LRUCache(1e4);function D(S){return P(S,"NFC",i)}e.normalizeNFC=D;const A=new k.LRUCache(1e4);function O(S){return P(S,"NFD",A)}e.normalizeNFD=O;const R=/[^\u0000-\u0080]/;function P(S,C,E){if(!S)return S;const w=E.get(S);if(w)return w;let p;return R.test(S)?p=S.normalize(C):p=S,E.set(S,p),p}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(C){return O(C).replace(S,"")}}()}),function(){function ee(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function O(P){A.push(P,Date.now())}function R(){const P=[];for(let S=0;S<A.length;S+=2)P.push({name:A[S],startTime:A[S+1]});return P}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(D+O.startTime)});return A}};if(typeof process=="object"){const D=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function k(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=k(i))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var i in k)(typeof exports=="object"?exports:ee)[i]=k[i]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function k(i){if(e[i])return e[i].exports;var D=e[i]={i,l:!1,exports:{}};return ee[i].call(D.exports,D,D.exports,k),D.l=!0,D.exports}return k.m=ee,k.c=e,k.d=function(i,D,A){k.o(i,D)||Object.defineProperty(i,D,{enumerable:!0,get:A})},k.r=function(i){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},k.t=function(i,D){if(1&D&&(i=k(i)),8&D||4&D&&typeof i=="object"&&i&&i.__esModule)return i;var A=Object.create(null);if(k.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:i}),2&D&&typeof i!="string")for(var O in i)k.d(A,O,function(R){return i[R]}.bind(null,O));return A},k.n=function(i){var D=i&&i.__esModule?function(){return i.default}:function(){return i};return k.d(D,"a",D),D},k.o=function(i,D){return Object.prototype.hasOwnProperty.call(i,D)},k.p="",k(k.s=0)}([function(ee,e,k){(function(i){var D;e=ee.exports=T,D=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],P=e.src=[],S=0,C=S++;P[C]="0|[1-9]\\d*";var E=S++;P[E]="[0-9]+";var w=S++;P[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=S++;P[p]="("+P[C]+")\\.("+P[C]+")\\.("+P[C]+")";var h=S++;P[h]="("+P[E]+")\\.("+P[E]+")\\.("+P[E]+")";var g=S++;P[g]="(?:"+P[C]+"|"+P[w]+")";var y=S++;P[y]="(?:"+P[E]+"|"+P[w]+")";var l=S++;P[l]="(?:-("+P[g]+"(?:\\."+P[g]+")*))";var d=S++;P[d]="(?:-?("+P[y]+"(?:\\."+P[y]+")*))";var m=S++;P[m]="[0-9A-Za-z-]+";var v=S++;P[v]="(?:\\+("+P[m]+"(?:\\."+P[m]+")*))";var f=S++,n="v?"+P[p]+P[l]+"?"+P[v]+"?";P[f]="^"+n+"$";var s="[v=\\s]*"+P[h]+P[d]+"?"+P[v]+"?",t=S++;P[t]="^"+s+"$";var r=S++;P[r]="((?:<|>)?=?)";var o=S++;P[o]=P[E]+"|x|X|\\*";var c=S++;P[c]=P[C]+"|x|X|\\*";var a=S++;P[a]="[v=\\s]*("+P[c]+")(?:\\.("+P[c]+")(?:\\.("+P[c]+")(?:"+P[l]+")?"+P[v]+"?)?)?";var u=S++;P[u]="[v=\\s]*("+P[o]+")(?:\\.("+P[o]+")(?:\\.("+P[o]+")(?:"+P[d]+")?"+P[v]+"?)?)?";var b=S++;P[b]="^"+P[r]+"\\s*"+P[a]+"$";var I=S++;P[I]="^"+P[r]+"\\s*"+P[u]+"$";var F=S++;P[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=S++;P[N]="(?:~>?)";var $=S++;P[$]="(\\s*)"+P[N]+"\\s+",R[$]=new RegExp(P[$],"g");var j=S++;P[j]="^"+P[N]+P[a]+"$";var L=S++;P[L]="^"+P[N]+P[u]+"$";var M=S++;P[M]="(?:\\^)";var z=S++;P[z]="(\\s*)"+P[M]+"\\s+",R[z]=new RegExp(P[z],"g");var G=S++;P[G]="^"+P[M]+P[a]+"$";var W=S++;P[W]="^"+P[M]+P[u]+"$";var _=S++;P[_]="^"+P[r]+"\\s*("+s+")$|^$";var K=S++;P[K]="^"+P[r]+"\\s*("+n+")$|^$";var q=S++;P[q]="(\\s*)"+P[r]+"\\s*("+s+"|"+P[a]+")",R[q]=new RegExp(P[q],"g");var V=S++;P[V]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var Z=S++;P[Z]="^\\s*("+P[u]+")\\s+-\\s+("+P[u]+")\\s*$";var ne=S++;P[ne]="(<|>)?=?\\s*\\*";for(var J=0;J<35;J++)D(J,P[J]),R[J]||(R[J]=new RegExp(P[J]));function x(ce,de){if(ce instanceof T)return ce;if(typeof ce!="string"||ce.length>A||!(de?R[t]:R[f]).test(ce))return null;try{return new T(ce,de)}catch{return null}}function T(ce,de){if(ce instanceof T){if(ce.loose===de)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof T))return new T(ce,de);D("SemVer",ce,de),this.loose=de;var ge=ce.trim().match(de?R[t]:R[f]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Pe=+Ce;if(Pe>=0&&Pe<O)return Pe}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=x,e.valid=function(ce,de){var ge=x(ce,de);return ge?ge.version:null},e.clean=function(ce,de){var ge=x(ce.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=T,T.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},T.prototype.toString=function(){return this.version},T.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof T||(ce=new T(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},T.prototype.compareMain=function(ce){return ce instanceof T||(ce=new T(ce,this.loose)),H(this.major,ce.major)||H(this.minor,ce.minor)||H(this.patch,ce.patch)},T.prototype.comparePre=function(ce){if(ce instanceof T||(ce=new T(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ce=ce.prerelease[de];if(D("prerelease compare",de,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return H(ge,Ce)}while(++de)},T.prototype.inc=function(ce,de){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,de,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new T(ce,ge).inc(de,Ce).version}catch{return null}},e.diff=function(ce,de){if(X(ce,de))return null;var ge=x(ce),Ce=x(de);if(ge.prerelease.length||Ce.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return Pe},e.compareIdentifiers=H;var U=/^[0-9]+$/;function H(ce,de){var ge=U.test(ce),Ce=U.test(de);return ge&&Ce&&(ce=+ce,de=+de),ge&&!Ce?-1:Ce&&!ge?1:ce<de?-1:ce>de?1:0}function B(ce,de,ge){return new T(ce,ge).compare(new T(de,ge))}function Q(ce,de,ge){return B(ce,de,ge)>0}function re(ce,de,ge){return B(ce,de,ge)<0}function X(ce,de,ge){return B(ce,de,ge)===0}function te(ce,de,ge){return B(ce,de,ge)!==0}function se(ce,de,ge){return B(ce,de,ge)>=0}function le(ce,de,ge){return B(ce,de,ge)<=0}function ue(ce,de,ge,Ce){var Pe;switch(de){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=X(ce,ge,Ce);break;case"!=":Pe=te(ce,ge,Ce);break;case">":Pe=Q(ce,ge,Ce);break;case">=":Pe=se(ce,ge,Ce);break;case"<":Pe=re(ce,ge,Ce);break;case"<=":Pe=le(ce,ge,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function ye(ce,de){if(ce instanceof ye){if(ce.loose===de)return ce;ce=ce.value}if(!(this instanceof ye))return new ye(ce,de);D("comparator",ce,de),this.loose=de,this.parse(ce),this.semver===Se?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,de){return H(de,ce)},e.major=function(ce,de){return new T(ce,de).major},e.minor=function(ce,de){return new T(ce,de).minor},e.patch=function(ce,de){return new T(ce,de).patch},e.compare=B,e.compareLoose=function(ce,de){return B(ce,de,!0)},e.rcompare=function(ce,de,ge){return B(de,ce,ge)},e.sort=function(ce,de){return ce.sort(function(ge,Ce){return e.compare(ge,Ce,de)})},e.rsort=function(ce,de){return ce.sort(function(ge,Ce){return e.rcompare(ge,Ce,de)})},e.gt=Q,e.lt=re,e.eq=X,e.neq=te,e.gte=se,e.lte=le,e.cmp=ue,e.Comparator=ye;var Se={};function be(ce,de){if(ce instanceof be)return ce.loose===de?ce:new be(ce.raw,de);if(ce instanceof ye)return new be(ce.value,de);if(!(this instanceof be))return new be(ce,de);if(this.loose=de,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ee(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Ne(ce,de,ge,Ce,Pe,Ae,De,je,Oe,Me,Be,ke,Te){return((de=Ee(ge)?"":Ee(Ce)?">="+ge+".0.0":Ee(Pe)?">="+ge+"."+Ce+".0":">="+de)+" "+(je=Ee(Oe)?"":Ee(Me)?"<"+(+Oe+1)+".0.0":Ee(Be)?"<"+Oe+"."+(+Me+1)+".0":ke?"<="+Oe+"."+Me+"."+Be+"-"+ke:"<="+je)).trim()}function Fe(ce,de){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<ce.length;ge++)if(D(ce[ge].semver),ce[ge].semver!==Se&&ce[ge].semver.prerelease.length>0){var Ce=ce[ge].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ye(ce,de,ge){try{de=new be(de,ge)}catch{return!1}return de.test(ce)}function ze(ce,de,ge,Ce){var Pe,Ae,De,je,Oe;switch(ce=new T(ce,Ce),de=new be(de,Ce),ge){case">":Pe=Q,Ae=le,De=re,je=">",Oe=">=";break;case"<":Pe=re,Ae=se,De=Q,je="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ye(ce,de,Ce))return!1;for(var Me=0;Me<de.set.length;++Me){var Be=de.set[Me],ke=null,Te=null;if(Be.forEach(function(ie){ie.semver===Se&&(ie=new ye(">=0.0.0")),ke=ke||ie,Te=Te||ie,Pe(ie.semver,ke.semver,Ce)?ke=ie:De(ie.semver,Te.semver,Ce)&&(Te=ie)}),ke.operator===je||ke.operator===Oe||(!Te.operator||Te.operator===je)&&Ae(ce,Te.semver)||Te.operator===Oe&&De(ce,Te.semver))return!1}return!0}ye.prototype.parse=function(ce){var de=this.loose?R[_]:R[K],ge=ce.match(de);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new T(ge[2],this.loose):this.semver=Se},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===Se||(typeof ce=="string"&&(ce=new T(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(ce,de){if(!(ce instanceof ye))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,de),Ye(this.value,ge,de);if(ce.operator==="")return ge=new be(this.value,de),Ye(ce.semver,ge,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ae=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=ue(this.semver,"<",ce.semver,de)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Oe=ue(this.semver,">",ce.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ce||Pe||Ae&&De||je||Oe},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var de=this.loose;ce=ce.trim(),D("range",ce,de);var ge=de?R[Z]:R[V];ce=ce.replace(ge,Ne),D("hyphen replace",ce),ce=ce.replace(R[q],"$1$2$3"),D("comparator trim",ce,R[q]),ce=(ce=(ce=ce.replace(R[$],"$1~")).replace(R[z],"$1^")).split(/\s+/).join(" ");var Ce=de?R[_]:R[K],Pe=ce.split(" ").map(function(Ae){return function(De,je){return D("comp",De),De=function(Oe,Me){return Oe.trim().split(/\s+/).map(function(Be){return function(ke,Te){D("caret",ke,Te);var ie=Te?R[W]:R[G];return ke.replace(ie,function(he,fe,me,we,Ie){var Re;return D("caret",ke,he,fe,me,we,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(we)?Re=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+Ie+" <"+(+fe+1)+".0.0"):(D("no pr"),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+" <"+(+fe+1)+".0.0"),D("caret return",Re),Re})}(Be,Me)}).join(" ")}(De,je),D("caret",De),De=function(Oe,Me){return Oe.trim().split(/\s+/).map(function(Be){return function(ke,Te){var ie=Te?R[L]:R[j];return ke.replace(ie,function(he,fe,me,we,Ie){var Re;return D("tilde",ke,he,fe,me,we,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(we)?Re=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0"):Re=">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0",D("tilde return",Re),Re})}(Be,Me)}).join(" ")}(De,je),D("tildes",De),De=function(Oe,Me){return D("replaceXRanges",Oe,Me),Oe.split(/\s+/).map(function(Be){return function(ke,Te){ke=ke.trim();var ie=Te?R[I]:R[b];return ke.replace(ie,function(he,fe,me,we,Ie,Re){D("xRange",ke,he,fe,me,we,Ie,Re);var He=Ee(me),$e=He||Ee(we),Le=$e||Ee(Ie);return fe==="="&&Le&&(fe=""),He?he=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Le?($e&&(we=0),Le&&(Ie=0),fe===">"?(fe=">=",$e?(me=+me+1,we=0,Ie=0):Le&&(we=+we+1,Ie=0)):fe==="<="&&(fe="<",$e?me=+me+1:we=+we+1),he=fe+me+"."+we+"."+Ie):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Le&&(he=">="+me+"."+we+".0 <"+me+"."+(+we+1)+".0"),D("xRange return",he),he})}(Be,Me)}).join(" ")}(De,je),D("xrange",De),De=function(Oe,Me){return D("replaceStars",Oe,Me),Oe.trim().replace(R[ne],"")}(De,je),D("stars",De),De}(Ae,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ae){return!!Ae.match(Ce)})),Pe=Pe.map(function(Ae){return new ye(Ae,de)})},be.prototype.intersects=function(ce,de){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return ce.set.some(function(Pe){return Pe.every(function(Ae){return Ce.intersects(Ae,de)})})})})},e.toComparators=function(ce,de){return new be(ce,de).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new T(ce,this.loose));for(var de=0;de<this.set.length;de++)if(Fe(this.set[de],ce))return!0;return!1},e.satisfies=Ye,e.maxSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==-1||(Pe=new T(Ce=De,ge)))}),Ce},e.minSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==1||(Pe=new T(Ce=De,ge)))}),Ce},e.validRange=function(ce,de){try{return new be(ce,de).range||"*"}catch{return null}},e.ltr=function(ce,de,ge){return ze(ce,de,"<",ge)},e.gtr=function(ce,de,ge){return ze(ce,de,">",ge)},e.outside=ze,e.prerelease=function(ce,de){var ge=x(ce,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,de,ge){return ce=new be(ce,ge),de=new be(de,ge),ce.intersects(de)},e.coerce=function(ce){if(ce instanceof T)return ce;if(typeof ce!="string")return null;var de=ce.match(R[F]);return de==null?null:x((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,k(1))},function(ee,e){var k,i,D=ee.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(y){if(k===setTimeout)return setTimeout(y,0);if((k===A||!k)&&setTimeout)return k=setTimeout,setTimeout(y,0);try{return k(y,0)}catch{try{return k.call(null,y,0)}catch{return k.call(this,y,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:A}catch{k=A}try{i=typeof clearTimeout=="function"?clearTimeout:O}catch{i=O}})();var P,S=[],C=!1,E=-1;function w(){C&&P&&(C=!1,P.length?S=P.concat(S):E=-1,S.length&&p())}function p(){if(!C){var y=R(w);C=!0;for(var l=S.length;l;){for(P=S,S=[];++E<l;)P&&P[E].run();E=-1,l=S.length}P=null,C=!1,function(d){if(i===clearTimeout)return clearTimeout(d);if((i===O||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(d);try{i(d)}catch{try{return i.call(null,d)}catch{return i.call(this,d)}}}(y)}}function h(y,l){this.fun=y,this.array=l}function g(){}D.nextTick=function(y){var l=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)l[d-1]=arguments[d];S.push(new h(y,l)),S.length!==1||C||R(p)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=g,D.addListener=g,D.once=g,D.off=g,D.removeListener=g,D.removeAllListeners=g,D.emit=g,D.prependListener=g,D.prependOnceListener=g,D.listeners=function(y){return[]},D.binding=function(y){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(y){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(oe[128],ae([0,1]),function(ee,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(R,P,S){this.level=R,this.key=P,this.value=S,this.forward=[]}}const D=void 0;class A{constructor(R,P=2**16){this.comparator=R,this[k]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(P)|0),this.e=new i(this.c,D,D)}get size(){return this.f}clear(){this.e=new i(this.c,D,D)}has(R){return Boolean(A.g(this,R,this.comparator))}get(R){return A.g(this,R,this.comparator)?.value}set(R,P){return A.h(this,R,P,this.comparator)&&(this.f+=1),this}delete(R){const P=A.k(this,R,this.comparator);return P&&(this.f-=1),P}forEach(R,P){let S=this.e.forward[0];for(;S;)R.call(P,S.value,S.key,this),S=S.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",P=this.e.forward[0];for(;P;)R+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return R}static g(R,P,S){let C=R.e;for(let E=R.d-1;E>=0;E--)for(;C.forward[E]&&S(C.forward[E].key,P)<0;)C=C.forward[E];if(C=C.forward[0],C&&S(C.key,P)===0)return C}static h(R,P,S,C){const E=[];let w=R.e;for(let p=R.d-1;p>=0;p--){for(;w.forward[p]&&C(w.forward[p].key,P)<0;)w=w.forward[p];E[p]=w}if(w=w.forward[0],w&&C(w.key,P)===0)return w.value=S,!1;{const p=A.j(R);if(p>R.d){for(let h=R.d;h<p;h++)E[h]=R.e;R.d=p}w=new i(p,P,S);for(let h=0;h<p;h++)w.forward[h]=E[h].forward[h],E[h].forward[h]=w;return!0}}static j(R,P=.5){let S=1;for(;Math.random()<P&&S<R.c;)S+=1;return S}static k(R,P,S){const C=[];let E=R.e;for(let w=R.d-1;w>=0;w--){for(;E.forward[w]&&S(E.forward[w].key,P)<0;)E=E.forward[w];C[w]=E}if(E=E.forward[0],!E||S(E.key,P)!==0)return!1;for(let w=0;w<R.d&&C[w].forward[w]===E;w++)C[w].forward[w]=E.forward[w];for(;R.d>0&&R.e.forward[R.d-1]===D;)R.d-=1;return!0}}e.SkipList=A}),define(oe[44],ae([0,1,9,2]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(v){const f=v;return f?typeof f.read=="function":!1}e.isReadable=D;function A(v){const f=v;return f?[f.on,f.pause,f.resume,f.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=A;function O(v){const f=v;return f?A(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=O;function R(v,f){return new P(v,f)}e.newWriteableStream=R;class P{constructor(f,n){this.e=f,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(n=>n(f))}h(f){this.c.error.length===0?(0,k.onUnexpectedError)(f):this.c.error.slice(0).forEach(n=>n(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,n){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(f,n){if(this.a.destroyed)return;let s;switch(f){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const t=s.indexOf(n);t>=0&&s.splice(t,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(v,f){const n=[];let s;for(;(s=v.read())!==null;)n.push(s);return f(n)}e.consumeReadable=S;function C(v,f,n){const s=[];let t;for(;(t=v.read())!==null&&s.length<n;)s.push(t);return t===null&&s.length>0?f(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const r=t;return t=void 0,r}return v.read()}}}e.peekReadable=C;function E(v,f){return new Promise((n,s)=>{const t=[];w(v,{onData:r=>{f&&t.push(r)},onError:r=>{f?s(r):n(void 0)},onEnd:()=>{n(f?f(t):void 0)}})})}e.consumeStream=E;function w(v,f){let n=!1;return v.on("error",s=>{n||f.onError(s)}),v.on("end",()=>{n||f.onEnd()}),v.on("data",s=>{n||f.onData(s)}),(0,i.toDisposable)(()=>n=!0)}e.listenStream=w;function p(v,f){return new Promise((n,s)=>{const t=new i.DisposableStore,r=[],o=u=>{if(r.push(u),r.length>f)return t.dispose(),v.pause(),n({stream:v,buffer:r,ended:!1})},c=u=>s(u),a=()=>n({stream:v,buffer:r,ended:!0});t.add((0,i.toDisposable)(()=>v.removeListener("error",c))),v.on("error",c),t.add((0,i.toDisposable)(()=>v.removeListener("end",a))),v.on("end",a),t.add((0,i.toDisposable)(()=>v.removeListener("data",o))),v.on("data",o)})}e.peekStream=p;function h(v,f){const n=R(f);return n.end(v),n}e.toStream=h;function g(){const v=R(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=g;function y(v){let f=!1;return{read:()=>f?null:(f=!0,v)}}e.toReadable=y;function l(v,f,n){const s=R(n);return w(v,{onData:t=>s.write(f.data(t)),onError:t=>s.error(f.error?f.error(t):t),onEnd:()=>s.end()}),s}e.transform=l;function d(v,f,n){let s=!1;return{read:()=>{const t=f.read();return s?t:(s=!0,t!==null?n([v,t]):v)}}}e.prefixedReadable=d;function m(v,f,n){let s=!1;const t=R(n);return w(f,{onData:r=>s?t.write(r):(s=!0,t.write(n([v,r]))),onError:r=>t.error(r),onEnd:()=>{s||(s=!0,t.write(v)),t.end()}}),t}e.prefixedStream=m}),define(oe[17],ae([0,1,44]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer<"u";let D,A;class O{static alloc(u){return i?new O(Buffer.allocUnsafe(u)):new O(new Uint8Array(u))}static wrap(u){return i&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new O(u)}static fromString(u,b){return!(b?.dontUseNodeBuffer||!1)&&i?new O(Buffer.from(u)):(D||(D=new TextEncoder),new O(D.encode(u)))}static fromByteArray(u){const b=O.alloc(u.length);for(let I=0,F=u.length;I<F;I++)b.buffer[I]=u[I];return b}static concat(u,b){if(typeof b>"u"){b=0;for(let N=0,$=u.length;N<$;N++)b+=u[N].byteLength}const I=O.alloc(b);let F=0;for(let N=0,$=u.length;N<$;N++){const j=u[N];I.set(j,F),F+=j.byteLength}return I}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=O.alloc(this.byteLength);return u.set(this),u}toString(){return i?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(u,b){return new O(this.buffer.subarray(u,b))}set(u,b){if(u instanceof O)this.buffer.set(u.buffer,b);else if(u instanceof Uint8Array)this.buffer.set(u,b);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),b);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return S(this.buffer,u)}writeUInt32BE(u,b){C(this.buffer,u,b)}readUInt32LE(u){return E(this.buffer,u)}writeUInt32LE(u,b){w(this.buffer,u,b)}readUInt8(u){return p(this.buffer,u)}writeUInt8(u,b){h(this.buffer,u,b)}}e.VSBuffer=O;function R(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0}e.readUInt16LE=R;function P(a,u,b){a[b+0]=u&255,u=u>>>8,a[b+1]=u&255}e.writeUInt16LE=P;function S(a,u){return a[u]*2**24+a[u+1]*2**16+a[u+2]*2**8+a[u+3]}e.readUInt32BE=S;function C(a,u,b){a[b+3]=u,u=u>>>8,a[b+2]=u,u=u>>>8,a[b+1]=u,u=u>>>8,a[b]=u}e.writeUInt32BE=C;function E(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0|a[u+2]<<16>>>0|a[u+3]<<24>>>0}e.readUInt32LE=E;function w(a,u,b){a[b+0]=u&255,u=u>>>8,a[b+1]=u&255,u=u>>>8,a[b+2]=u&255,u=u>>>8,a[b+3]=u&255}e.writeUInt32LE=w;function p(a,u){return a[u]}e.readUInt8=p;function h(a,u,b){a[b]=u}e.writeUInt8=h;function g(a){return k.consumeReadable(a,u=>O.concat(u))}e.readableToBuffer=g;function y(a){return k.toReadable(a)}e.bufferToReadable=y;function l(a){return k.consumeStream(a,u=>O.concat(u))}e.streamToBuffer=l;async function d(a){return a.ended?O.concat(a.buffer):O.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=d;function m(a){return k.toStream(a,u=>O.concat(u))}e.bufferToStream=m;function v(a){return k.transform(a,{data:u=>typeof u=="string"?O.fromString(u):O.wrap(u)},u=>O.concat(u))}e.streamToBufferReadableStream=v;function f(a){return k.newWriteableStream(u=>O.concat(u),a)}e.newWriteableBufferStream=f;function n(a,u){return k.prefixedReadable(a,u,b=>O.concat(b))}e.prefixedBufferReadable=n;function s(a,u){return k.prefixedStream(a,u,b=>O.concat(b))}e.prefixedBufferStream=s;function t(a){let u=0,b=0,I=0;const F=new Uint8Array(Math.floor(a.length/4*3)),N=j=>{switch(b){case 3:F[I++]=u|j,b=0;break;case 2:F[I++]=u|j>>>2,u=j<<6,b=3;break;case 1:F[I++]=u|j>>>4,u=j<<4,b=2;break;default:u=j<<2,b=1}};for(let j=0;j<a.length;j++){const L=a.charCodeAt(j);if(L>=65&&L<=90)N(L-65);else if(L>=97&&L<=122)N(L-97+26);else if(L>=48&&L<=57)N(L-48+52);else if(L===43||L===45)N(62);else if(L===47||L===95)N(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${a[j]}`)}}const $=I;for(;b>0;)N(0);return O.wrap(F).slice(0,$)}e.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},u=!0,b=!1){const I=b?o:r;let F="";const N=a.byteLength%3;let $=0;for(;$<a.byteLength-N;$+=3){const j=a[$+0],L=a[$+1],M=a[$+2];F+=I[j>>>2],F+=I[(j<<4|L>>>4)&63],F+=I[(L<<2|M>>>6)&63],F+=I[M&63]}if(N===1){const j=a[$+0];F+=I[j>>>2],F+=I[j<<4&63],u&&(F+="==")}else if(N===2){const j=a[$+0],L=a[$+1];F+=I[j>>>2],F+=I[(j<<4|L>>>4)&63],F+=I[L<<2&63],u&&(F+="=")}return F}e.encodeBase64=c}),define(oe[13],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function k(s){return typeof s=="string"}e.isString=k;function i(s){return Array.isArray(s)&&s.every(t=>k(t))}e.isStringArray=i;function D(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=D;function A(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}e.isTypedArray=A;function O(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=O;function R(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=R;function P(s){return s===!0||s===!1}e.isBoolean=P;function S(s){return typeof s>"u"}e.isUndefined=S;function C(s){return!E(s)}e.isDefined=C;function E(s){return S(s)||s===null}e.isUndefinedOrNull=E;function w(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=w;function p(s){if(E(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=p;function h(...s){const t=[];for(let r=0;r<s.length;r++){const o=s[r];if(E(o))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(o)}return t}e.assertAllDefined=h;const g=Object.prototype.hasOwnProperty;function y(s){if(!D(s))return!1;for(const t in s)if(g.call(s,t))return!1;return!0}e.isEmptyObject=y;function l(s){return typeof s=="function"}e.isFunction=l;function d(...s){return s.length>0&&s.every(l)}e.areFunctions=d;function m(s,t){const r=Math.min(s.length,t.length);for(let o=0;o<r;o++)v(s[o],t[o])}e.validateConstraints=m;function v(s,t){if(k(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if(s instanceof t)return}catch{}if(!E(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=v;function f(s){return s===null?void 0:s}e.withNullAsUndefined=f;function n(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=n}),define(oe[32],ae([0,1,13]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([m,v])=>{d[m]=v&&typeof v=="object"?i(v):v}),d}e.deepClone=i;function D(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const m=d.shift();Object.freeze(m);for(const v in m)if(A.call(m,v)){const f=m[v];typeof f=="object"&&!Object.isFrozen(f)&&!(0,k.isTypedArray)(f)&&d.push(f)}}return l}e.deepFreeze=D;const A=Object.prototype.hasOwnProperty;function O(l,d){return R(l,d,new Set)}e.cloneAndChange=O;function R(l,d,m){if((0,k.isUndefinedOrNull)(l))return l;const v=d(l);if(typeof v<"u")return v;if(Array.isArray(l)){const f=[];for(const n of l)f.push(R(n,d,m));return f}if((0,k.isObject)(l)){if(m.has(l))throw new Error("Cannot clone recursive data-structure");m.add(l);const f={};for(const n in l)A.call(l,n)&&(f[n]=R(l[n],d,m));return m.delete(l),f}return l}function P(l,d,m=!0){return(0,k.isObject)(l)?((0,k.isObject)(d)&&Object.keys(d).forEach(v=>{v in l?m&&((0,k.isObject)(l[v])&&(0,k.isObject)(d[v])?P(l[v],d[v],m):l[v]=d[v]):l[v]=d[v]}),l):d}e.mixin=P;function S(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let m,v;if(Array.isArray(l)){if(l.length!==d.length)return!1;for(m=0;m<l.length;m++)if(!S(l[m],d[m]))return!1}else{const f=[];for(v in l)f.push(v);f.sort();const n=[];for(v in d)n.push(v);if(n.sort(),!S(f,n))return!1;for(m=0;m<f.length;m++)if(!S(l[f[m]],d[f[m]]))return!1}return!0}e.equals=S;function C(l){const d=new Set;return JSON.stringify(l,(m,v)=>{if((0,k.isObject)(v)||Array.isArray(v)){if(d.has(v))return"[Circular]";d.add(v)}return v})}e.safeStringify=C;function E(l,d){const m=Object.create(null);return!l||!d||Object.keys(d).forEach(f=>{const n=l[f],s=d[f];S(n,s)||(m[f]=s)}),m}e.distinct=E;function w(l,d){const m=d.toLowerCase(),v=Object.keys(l).find(f=>f.toLowerCase()===m);return v?l[v]:l[d]}e.getCaseInsensitive=w;function p(l,d){const m=Object.create(null);for(const[v,f]of Object.entries(l))d(v,f)&&(m[v]=f);return m}e.filter=p;function h(l){let d=[],m=Object.getPrototypeOf(l);for(;Object.prototype!==m;)d=d.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return d}e.getAllPropertyNames=h;function g(l){const d=[];for(const m of h(l))typeof l[m]=="function"&&d.push(m);return d}e.getAllMethodNames=g;function y(l,d){const m=f=>function(){const n=Array.prototype.slice.call(arguments,0);return d(f,n)},v={};for(const f of l)v[f]=m(f);return v}e.createProxyObject=y}),define(oe[31],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(D){return k.test(D)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let P=0;P<R.length;P++)R[P]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let P=0,S="";return S+=O[A[P++]],S+=O[A[P++]],S+=O[A[P++]],S+=O[A[P++]],S+="-",S+=O[A[P++]],S+=O[A[P++]],S+="-",S+=O[A[P++]],S+=O[A[P++]],S+="-",S+=O[A[P++]],S+=O[A[P++]],S+="-",S+=O[A[P++]],S+=O[A[P++]],S+=O[A[P++]],S+=O[A[P++]],S+=O[A[P++]],S+=O[A[P++]],S}}()}),define(oe[129],ae([0,1,34]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(O){const R=O.replace(/\-/g,":").toLowerCase();return!i.has(R)}function A(){const O=(0,k.networkInterfaces)();for(const R in O){const P=O[R];if(P){for(const{mac:S}of P)if(D(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(oe[130],ae([0,1,86]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(R,P,S,C=1){let E=!1;return new Promise(w=>{const p=setTimeout(()=>{if(!E)return E=!0,w(0)},S);D(R,P,C,h=>{if(!E)return E=!0,clearTimeout(p),w(h)})})}e.findFreePort=i;function D(R,P,S,C){if(P===0)return C(0);const E=new k.Socket;E.once("connect",()=>(O(E),D(R+S,P-1,S,C))),E.once("data",()=>{}),E.once("error",w=>(O(E),w.code!=="ECONNREFUSED"?D(R+S,P-1,S,C):C(R))),E.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,P,S,C="127.0.0.1"){let E=!1,w,p=1;const h=k.createServer({pauseOnConnect:!0});function g(y,l){E||(E=!0,h.removeAllListeners(),h.close(),w&&clearTimeout(w),l(y))}return new Promise(y=>{w=setTimeout(()=>{g(0,y)},S),h.on("listening",()=>{g(R,y)}),h.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&p<P?(R++,p++,h.listen(R,C)):g(0,y)}),h.on("close",()=>{g(0,y)}),h.listen(R,C)})}e.findFreePortFaster=A;function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(P){console.error(P)}}}),define(oe[131],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function i(A){return A instanceof D?!0:A instanceof Error&&A.name===k&&A.message===k}e.isOfflineError=i;class D extends Error{constructor(){super(k),this.name=this.message}}e.OfflineError=D}),define(oe[132],ae([0,1,17,9,131]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(P,S){if(!navigator.onLine)throw new D.OfflineError;P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((E,w)=>{C.open(P.type||"GET",P.url||"",!0,P.user,P.password),O(C,P),C.responseType="arraybuffer",C.onerror=p=>w(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=p=>{E({res:{statusCode:C.status,headers:R(C)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=p=>w(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(C.timeout=P.timeout),C.send(P.data),S.onCancellationRequested(()=>{C.abort(),w((0,i.canceled)())})})}e.request=A;function O(P,S){if(S.headers){e:for(const C in S.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(C,S.headers[C])}}}function R(P){const S=Object.create(null);for(const C of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const E=C.indexOf(":");S[C.substr(0,E).trim().toLowerCase()]=C.substr(E+1).trim()}return S}}),define(oe[133],ae([10,11]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(oe[65],ae([0,1,133]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,D=i*60,A=D*24,O=A*7,R=A*30,P=A*365;function S(E,w,p){typeof E!="number"&&(E=E.getTime());const h=Math.round((new Date().getTime()-E)/1e3);if(h<-30)return(0,k.localize)(0,null,S(new Date().getTime()+h*1e3,!1));if(h<30)return(0,k.localize)(1,null);let g;return h<i?(g=h,w?g===1?p?(0,k.localize)(2,null,g):(0,k.localize)(3,null,g):p?(0,k.localize)(4,null,g):(0,k.localize)(5,null,g):g===1?p?(0,k.localize)(6,null,g):(0,k.localize)(7,null,g):p?(0,k.localize)(8,null,g):(0,k.localize)(9,null,g)):h<D?(g=Math.floor(h/i),w?g===1?p?(0,k.localize)(10,null,g):(0,k.localize)(11,null,g):p?(0,k.localize)(12,null,g):(0,k.localize)(13,null,g):g===1?p?(0,k.localize)(14,null,g):(0,k.localize)(15,null,g):p?(0,k.localize)(16,null,g):(0,k.localize)(17,null,g)):h<A?(g=Math.floor(h/D),w?g===1?p?(0,k.localize)(18,null,g):(0,k.localize)(19,null,g):p?(0,k.localize)(20,null,g):(0,k.localize)(21,null,g):g===1?p?(0,k.localize)(22,null,g):(0,k.localize)(23,null,g):p?(0,k.localize)(24,null,g):(0,k.localize)(25,null,g)):h<O?(g=Math.floor(h/A),w?g===1?(0,k.localize)(26,null,g):(0,k.localize)(27,null,g):g===1?(0,k.localize)(28,null,g):(0,k.localize)(29,null,g)):h<R?(g=Math.floor(h/O),w?g===1?p?(0,k.localize)(30,null,g):(0,k.localize)(31,null,g):p?(0,k.localize)(32,null,g):(0,k.localize)(33,null,g):g===1?p?(0,k.localize)(34,null,g):(0,k.localize)(35,null,g):p?(0,k.localize)(36,null,g):(0,k.localize)(37,null,g)):h<P?(g=Math.floor(h/R),w?g===1?p?(0,k.localize)(38,null,g):(0,k.localize)(39,null,g):p?(0,k.localize)(40,null,g):(0,k.localize)(41,null,g):g===1?p?(0,k.localize)(42,null,g):(0,k.localize)(43,null,g):p?(0,k.localize)(44,null,g):(0,k.localize)(45,null,g)):(g=Math.floor(h/P),w?g===1?p?(0,k.localize)(46,null,g):(0,k.localize)(47,null,g):p?(0,k.localize)(48,null,g):(0,k.localize)(49,null,g):g===1?p?(0,k.localize)(50,null,g):(0,k.localize)(51,null,g):p?(0,k.localize)(52,null,g):(0,k.localize)(53,null,g))}e.fromNow=S;function C(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(oe[134],ae([10,11]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,20,13,134]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(E,w){return w&&(E.stack||E.stacktrace)?D.localize(0,null,R(E),O(E.stack)||O(E.stacktrace)):R(E)}function O(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?D.localize(1,null,E.message):E.message||D.localize(2,null)}function P(E=null,w=!1){if(!E)return D.localize(3,null);if(Array.isArray(E)){const p=k.coalesce(E),h=P(p[0],w);return p.length>1?D.localize(4,null,h,p.length):h}if(i.isString(E))return E;if(E.detail){const p=E.detail;if(p.error)return A(p.error,w);if(p.exception)return A(p.exception,w)}return E.stack?A(E,w):E.message?E.message:D.localize(5,null)}e.toErrorMessage=P;function S(E){const w=E;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=S;function C(E,w){let p;return typeof E=="string"?p=new Error(E):p=E,p.actions=w,p}e.createErrorWithActions=C}),define(oe[135],ae([10,11]),function(ee,e){return ee.create("vs/base/common/jsonErrorMessages",e)}),define(oe[136],ae([0,1,135]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function i(D){switch(D){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=i}),define(oe[137],ae([10,11]),function(ee,e){return ee.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,137]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let i=!1,D=!1,A=!1,O=!1,R=!1,P=!1,S=!1,C=!1,E=!1,w=!1,p,h=e.LANGUAGE_DEFAULT,g,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const d=typeof l?.versions?.electron=="string",m=d&&l?.type==="renderer";if(typeof navigator=="object"&&!m)y=navigator.userAgent,i=y.indexOf("Windows")>=0,D=y.indexOf("Macintosh")>=0,C=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=y.indexOf("Linux")>=0,w=y?.indexOf("Mobi")>=0,P=!0,p=k.getConfiguredDefaultLocale(k.localize(0,null))||e.LANGUAGE_DEFAULT,h=p;else if(typeof l=="object"){i=l.platform==="win32",D=l.platform==="darwin",A=l.platform==="linux",O=A&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,S=d,E=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT;const a=l.env.VSCODE_NLS_CONFIG;if(a)try{const u=JSON.parse(a),b=u.availableLanguages["*"];p=u.locale,h=b||e.LANGUAGE_DEFAULT,g=u._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var v;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function f(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=f;let n=0;D?n=1:i?n=3:A&&(n=2),e.isWindows=i,e.isMacintosh=D,e.isLinux=A,e.isLinuxSnap=O,e.isNative=R,e.isElectron=S,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isMobile=w,e.isCI=E,e.platform=n,e.userAgent=y,e.language=h;var s;(function(a){function u(){return e.language}a.value=u;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=b;function I(){return e.language==="en"}a.isDefault=I})(s=e.Language||(e.Language={})),e.locale=p,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let I=0,F=a.length;I<F;I++){const N=a[I];if(N.id===b.data.vscodeScheduleAsyncWork){a.splice(I,1),N.callback();return}}});let u=0;return b=>{const I=++u;a.push({id:I,callback:b}),e.globals.postMessage({vscodeScheduleAsyncWork:I},"*")}}return a=>setTimeout(a)})();var t;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:i?1:3;let r=!0,o=!1;function c(){if(!o){o=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,r=new Uint16Array(a.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[36],ae([0,1,5]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.process<"u"){const D=k.globals.vscode.process;i={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(oe[12],ae([0,1,36]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,D=97,A=90,O=122,R=46,P=47,S=92,C=58,E=63;class w extends Error{constructor(s,t,r){let o;typeof t=="string"&&t.indexOf("not ")===0?(o="must not be",t=t.replace(/^not /,"")):o="must be";const c=s.indexOf(".")!==-1?"property":"argument";let a=`The "${s}" ${c} ${o} of type ${t}`;a+=`. Received type ${typeof r}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function p(n,s){if(n===null||typeof n!="object")throw new w(s,"Object",n)}function h(n,s){if(typeof n!="string")throw new w(s,"string",n)}const g=k.platform==="win32";function y(n){return n===P||n===S}function l(n){return n===P}function d(n){return n>=i&&n<=A||n>=D&&n<=O}function m(n,s,t,r){let o="",c=0,a=-1,u=0,b=0;for(let I=0;I<=n.length;++I){if(I<n.length)b=n.charCodeAt(I);else{if(r(b))break;b=P}if(r(b)){if(!(a===I-1||u===1))if(u===2){if(o.length<2||c!==2||o.charCodeAt(o.length-1)!==R||o.charCodeAt(o.length-2)!==R){if(o.length>2){const F=o.lastIndexOf(t);F===-1?(o="",c=0):(o=o.slice(0,F),c=o.length-1-o.lastIndexOf(t)),a=I,u=0;continue}else if(o.length!==0){o="",c=0,a=I,u=0;continue}}s&&(o+=o.length>0?`${t}..`:"..",c=2)}else o.length>0?o+=`${t}${n.slice(a+1,I)}`:o=n.slice(a+1,I),c=I-a-1;a=I,u=0}else b===R&&u!==-1?++u:u=-1}return o}function v(n,s){p(s,"pathObject");const t=s.dir||s.root,r=s.base||`${s.name||""}${s.ext||""}`;return t?t===s.root?`${t}${r}`:`${t}${n}${r}`:r}e.win32={resolve(...n){let s="",t="",r=!1;for(let o=n.length-1;o>=-1;o--){let c;if(o>=0){if(c=n[o],h(c,"path"),c.length===0)continue}else s.length===0?c=k.cwd():(c=k.env[`=${s}`]||k.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==s.toLowerCase()&&c.charCodeAt(2)===S)&&(c=`${s}\\`));const a=c.length;let u=0,b="",I=!1;const F=c.charCodeAt(0);if(a===1)y(F)&&(u=1,I=!0);else if(y(F))if(I=!0,y(c.charCodeAt(1))){let N=2,$=N;for(;N<a&&!y(c.charCodeAt(N));)N++;if(N<a&&N!==$){const j=c.slice($,N);for($=N;N<a&&y(c.charCodeAt(N));)N++;if(N<a&&N!==$){for($=N;N<a&&!y(c.charCodeAt(N));)N++;(N===a||N!==$)&&(b=`\\\\${j}\\${c.slice($,N)}`,u=N)}}}else u=1;else d(F)&&c.charCodeAt(1)===C&&(b=c.slice(0,2),u=2,a>2&&y(c.charCodeAt(2))&&(I=!0,u=3));if(b.length>0)if(s.length>0){if(b.toLowerCase()!==s.toLowerCase())continue}else s=b;if(r){if(s.length>0)break}else if(t=`${c.slice(u)}\\${t}`,r=I,I&&s.length>0)break}return t=m(t,!r,"\\",y),r?`${s}\\${t}`:`${s}${t}`||"."},normalize(n){h(n,"path");const s=n.length;if(s===0)return".";let t=0,r,o=!1;const c=n.charCodeAt(0);if(s===1)return l(c)?"\\":n;if(y(c))if(o=!0,y(n.charCodeAt(1))){let u=2,b=u;for(;u<s&&!y(n.charCodeAt(u));)u++;if(u<s&&u!==b){const I=n.slice(b,u);for(b=u;u<s&&y(n.charCodeAt(u));)u++;if(u<s&&u!==b){for(b=u;u<s&&!y(n.charCodeAt(u));)u++;if(u===s)return`\\\\${I}\\${n.slice(b)}\\`;u!==b&&(r=`\\\\${I}\\${n.slice(b,u)}`,t=u)}}}else t=1;else d(c)&&n.charCodeAt(1)===C&&(r=n.slice(0,2),t=2,s>2&&y(n.charCodeAt(2))&&(o=!0,t=3));let a=t<s?m(n.slice(t),!o,"\\",y):"";return a.length===0&&!o&&(a="."),a.length>0&&y(n.charCodeAt(s-1))&&(a+="\\"),r===void 0?o?`\\${a}`:a:o?`${r}\\${a}`:`${r}${a}`},isAbsolute(n){h(n,"path");const s=n.length;if(s===0)return!1;const t=n.charCodeAt(0);return y(t)||s>2&&d(t)&&n.charCodeAt(1)===C&&y(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,t;for(let c=0;c<n.length;++c){const a=n[c];h(a,"path"),a.length>0&&(s===void 0?s=t=a:s+=`\\${a}`)}if(s===void 0)return".";let r=!0,o=0;if(typeof t=="string"&&y(t.charCodeAt(0))){++o;const c=t.length;c>1&&y(t.charCodeAt(1))&&(++o,c>2&&(y(t.charCodeAt(2))?++o:r=!1))}if(r){for(;o<s.length&&y(s.charCodeAt(o));)o++;o>=2&&(s=`\\${s.slice(o)}`)}return e.win32.normalize(s)},relative(n,s){if(h(n,"from"),h(s,"to"),n===s)return"";const t=e.win32.resolve(n),r=e.win32.resolve(s);if(t===r||(n=t.toLowerCase(),s=r.toLowerCase(),n===s))return"";let o=0;for(;o<n.length&&n.charCodeAt(o)===S;)o++;let c=n.length;for(;c-1>o&&n.charCodeAt(c-1)===S;)c--;const a=c-o;let u=0;for(;u<s.length&&s.charCodeAt(u)===S;)u++;let b=s.length;for(;b-1>u&&s.charCodeAt(b-1)===S;)b--;const I=b-u,F=a<I?a:I;let N=-1,$=0;for(;$<F;$++){const L=n.charCodeAt(o+$);if(L!==s.charCodeAt(u+$))break;L===S&&(N=$)}if($!==F){if(N===-1)return r}else{if(I>F){if(s.charCodeAt(u+$)===S)return r.slice(u+$+1);if($===2)return r.slice(u+$)}a>F&&(n.charCodeAt(o+$)===S?N=$:$===2&&(N=3)),N===-1&&(N=0)}let j="";for($=o+N+1;$<=c;++$)($===c||n.charCodeAt($)===S)&&(j+=j.length===0?"..":"\\..");return u+=N,j.length>0?`${j}${r.slice(u,b)}`:(r.charCodeAt(u)===S&&++u,r.slice(u,b))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=e.win32.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===S){if(s.charCodeAt(1)===S){const t=s.charCodeAt(2);if(t!==E&&t!==R)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(d(s.charCodeAt(0))&&s.charCodeAt(1)===C&&s.charCodeAt(2)===S)return`\\\\?\\${s}`;return n},dirname(n){h(n,"path");const s=n.length;if(s===0)return".";let t=-1,r=0;const o=n.charCodeAt(0);if(s===1)return y(o)?n:".";if(y(o)){if(t=r=1,y(n.charCodeAt(1))){let u=2,b=u;for(;u<s&&!y(n.charCodeAt(u));)u++;if(u<s&&u!==b){for(b=u;u<s&&y(n.charCodeAt(u));)u++;if(u<s&&u!==b){for(b=u;u<s&&!y(n.charCodeAt(u));)u++;if(u===s)return n;u!==b&&(t=r=u+1)}}}}else d(o)&&n.charCodeAt(1)===C&&(t=s>2&&y(n.charCodeAt(2))?3:2,r=t);let c=-1,a=!0;for(let u=s-1;u>=r;--u)if(y(n.charCodeAt(u))){if(!a){c=u;break}}else a=!1;if(c===-1){if(t===-1)return".";c=t}return n.slice(0,c)},basename(n,s){s!==void 0&&h(s,"ext"),h(n,"path");let t=0,r=-1,o=!0,c;if(n.length>=2&&d(n.charCodeAt(0))&&n.charCodeAt(1)===C&&(t=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let a=s.length-1,u=-1;for(c=n.length-1;c>=t;--c){const b=n.charCodeAt(c);if(y(b)){if(!o){t=c+1;break}}else u===-1&&(o=!1,u=c+1),a>=0&&(b===s.charCodeAt(a)?--a===-1&&(r=c):(a=-1,r=u))}return t===r?r=u:r===-1&&(r=n.length),n.slice(t,r)}for(c=n.length-1;c>=t;--c)if(y(n.charCodeAt(c))){if(!o){t=c+1;break}}else r===-1&&(o=!1,r=c+1);return r===-1?"":n.slice(t,r)},extname(n){h(n,"path");let s=0,t=-1,r=0,o=-1,c=!0,a=0;n.length>=2&&n.charCodeAt(1)===C&&d(n.charCodeAt(0))&&(s=r=2);for(let u=n.length-1;u>=s;--u){const b=n.charCodeAt(u);if(y(b)){if(!c){r=u+1;break}continue}o===-1&&(c=!1,o=u+1),b===R?t===-1?t=u:a!==1&&(a=1):t!==-1&&(a=-1)}return t===-1||o===-1||a===0||a===1&&t===o-1&&t===r+1?"":n.slice(t,o)},format:v.bind(null,"\\"),parse(n){h(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const t=n.length;let r=0,o=n.charCodeAt(0);if(t===1)return y(o)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(y(o)){if(r=1,y(n.charCodeAt(1))){let N=2,$=N;for(;N<t&&!y(n.charCodeAt(N));)N++;if(N<t&&N!==$){for($=N;N<t&&y(n.charCodeAt(N));)N++;if(N<t&&N!==$){for($=N;N<t&&!y(n.charCodeAt(N));)N++;N===t?r=N:N!==$&&(r=N+1)}}}}else if(d(o)&&n.charCodeAt(1)===C){if(t<=2)return s.root=s.dir=n,s;if(r=2,y(n.charCodeAt(2))){if(t===3)return s.root=s.dir=n,s;r=3}}r>0&&(s.root=n.slice(0,r));let c=-1,a=r,u=-1,b=!0,I=n.length-1,F=0;for(;I>=r;--I){if(o=n.charCodeAt(I),y(o)){if(!b){a=I+1;break}continue}u===-1&&(b=!1,u=I+1),o===R?c===-1?c=I:F!==1&&(F=1):c!==-1&&(F=-1)}return u!==-1&&(c===-1||F===0||F===1&&c===u-1&&c===a+1?s.base=s.name=n.slice(a,u):(s.name=n.slice(a,c),s.base=n.slice(a,u),s.ext=n.slice(c,u))),a>0&&a!==r?s.dir=n.slice(0,a-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(g){const n=/\\/g;return()=>{const s=k.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>k.cwd()})();e.posix={resolve(...n){let s="",t=!1;for(let r=n.length-1;r>=-1&&!t;r--){const o=r>=0?n[r]:f();h(o,"path"),o.length!==0&&(s=`${o}/${s}`,t=o.charCodeAt(0)===P)}return s=m(s,!t,"/",l),t?`/${s}`:s.length>0?s:"."},normalize(n){if(h(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===P,t=n.charCodeAt(n.length-1)===P;return n=m(n,!s,"/",l),n.length===0?s?"/":t?"./":".":(t&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return h(n,"path"),n.length>0&&n.charCodeAt(0)===P},join(...n){if(n.length===0)return".";let s;for(let t=0;t<n.length;++t){const r=n[t];h(r,"path"),r.length>0&&(s===void 0?s=r:s+=`/${r}`)}return s===void 0?".":e.posix.normalize(s)},relative(n,s){if(h(n,"from"),h(s,"to"),n===s||(n=e.posix.resolve(n),s=e.posix.resolve(s),n===s))return"";const t=1,r=n.length,o=r-t,c=1,a=s.length-c,u=o<a?o:a;let b=-1,I=0;for(;I<u;I++){const N=n.charCodeAt(t+I);if(N!==s.charCodeAt(c+I))break;N===P&&(b=I)}if(I===u)if(a>u){if(s.charCodeAt(c+I)===P)return s.slice(c+I+1);if(I===0)return s.slice(c+I)}else o>u&&(n.charCodeAt(t+I)===P?b=I:I===0&&(b=0));let F="";for(I=t+b+1;I<=r;++I)(I===r||n.charCodeAt(I)===P)&&(F+=F.length===0?"..":"/..");return`${F}${s.slice(c+b)}`},toNamespacedPath(n){return n},dirname(n){if(h(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===P;let t=-1,r=!0;for(let o=n.length-1;o>=1;--o)if(n.charCodeAt(o)===P){if(!r){t=o;break}}else r=!1;return t===-1?s?"/":".":s&&t===1?"//":n.slice(0,t)},basename(n,s){s!==void 0&&h(s,"ext"),h(n,"path");let t=0,r=-1,o=!0,c;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let a=s.length-1,u=-1;for(c=n.length-1;c>=0;--c){const b=n.charCodeAt(c);if(b===P){if(!o){t=c+1;break}}else u===-1&&(o=!1,u=c+1),a>=0&&(b===s.charCodeAt(a)?--a===-1&&(r=c):(a=-1,r=u))}return t===r?r=u:r===-1&&(r=n.length),n.slice(t,r)}for(c=n.length-1;c>=0;--c)if(n.charCodeAt(c)===P){if(!o){t=c+1;break}}else r===-1&&(o=!1,r=c+1);return r===-1?"":n.slice(t,r)},extname(n){h(n,"path");let s=-1,t=0,r=-1,o=!0,c=0;for(let a=n.length-1;a>=0;--a){const u=n.charCodeAt(a);if(u===P){if(!o){t=a+1;break}continue}r===-1&&(o=!1,r=a+1),u===R?s===-1?s=a:c!==1&&(c=1):s!==-1&&(c=-1)}return s===-1||r===-1||c===0||c===1&&s===r-1&&s===t+1?"":n.slice(s,r)},format:v.bind(null,"/"),parse(n){h(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const t=n.charCodeAt(0)===P;let r;t?(s.root="/",r=1):r=0;let o=-1,c=0,a=-1,u=!0,b=n.length-1,I=0;for(;b>=r;--b){const F=n.charCodeAt(b);if(F===P){if(!u){c=b+1;break}continue}a===-1&&(u=!1,a=b+1),F===R?o===-1?o=b:I!==1&&(I=1):o!==-1&&(I=-1)}if(a!==-1){const F=c===0&&t?1:c;o===-1||I===0||I===1&&o===a-1&&o===c+1?s.base=s.name=n.slice(F,a):(s.name=n.slice(F,o),s.base=n.slice(F,a),s.ext=n.slice(o,a))}return c>0?s.dir=n.slice(0,c-1):t&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g?e.win32.normalize:e.posix.normalize,e.isAbsolute=g?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g?e.win32.join:e.posix.join,e.resolve=g?e.win32.resolve:e.posix.resolve,e.relative=g?e.win32.relative:e.posix.relative,e.dirname=g?e.win32.dirname:e.posix.dirname,e.basename=g?e.win32.basename:e.posix.basename,e.extname=g?e.win32.extname:e.posix.extname,e.format=g?e.win32.format:e.posix.format,e.parse=g?e.win32.parse:e.posix.parse,e.toNamespacedPath=g?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g?e.win32.sep:e.posix.sep,e.delimiter=g?e.win32.delimiter:e.posix.delimiter}),define(oe[138],ae([0,1,12]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const E=(0,k.extname)(C),w=i[E.toLowerCase()];return w!==void 0?w:O(C)}e.getMediaOrTextMime=A;function O(C){const E=(0,k.extname)(C);return D[E.toLowerCase()]}e.getMediaMime=O;function R(C){for(const E in D)if(D[E]===C)return E}e.getExtensionForMimeType=R;const P=/^(.+)\/(.+?)(;.+)?$/;function S(C,E){const w=P.exec(C);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:E?void 0:C}e.normalizeMimeType=S}),define(oe[87],ae([0,1,5]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(R,...P){const S=P.reduce((w,p)=>(w[p]=!0,w),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(w=>!S[w]).forEach(w=>{for(let p=0;p<C.length;p++)if(w.search(C[p])!==-1){delete R[w];break}})}e.sanitizeProcessEnvironment=A;function O(R){!R||(delete R.DEBUG,k.isMacintosh&&delete R.DYLD_LIBRARY_PATH,k.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=O}),define(oe[139],ae([0,1,5]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=k.globals.performance&&typeof k.globals.performance.now=="function";class D{static create(O=!0){return new D(O)}constructor(O){this.a=i&&O,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?k.globals.performance.now():Date.now()}}e.StopWatch=D}),define(oe[3],ae([0,1,9,82,2,84,139]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,P=!1;var S;(function(c){c.None=()=>D.Disposable.None;function a(B){if(P){const{onDidAddListener:Q}=B,re=h.create();let X=0;B.onDidAddListener=()=>{++X===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),Q?.()}}}function u(B,Q){return z(B,()=>{},0,void 0,void 0,Q)}c.defer=u;function b(B){return(Q,re=null,X)=>{let te=!1,se;return se=B(le=>{if(!te)return se?se.dispose():te=!0,Q.call(re,le)},null,X),te&&se.dispose(),se}}c.once=b;function I(B,Q,re){return M((X,te=null,se)=>B(le=>X.call(te,Q(le)),null,se),re)}c.map=I;function F(B,Q,re){return M((X,te=null,se)=>B(le=>{Q(le),X.call(te,le)},null,se),re)}c.forEach=F;function N(B,Q,re){return M((X,te=null,se)=>B(le=>Q(le)&&X.call(te,le),null,se),re)}c.filter=N;function $(B){return B}c.signal=$;function j(...B){return(Q,re=null,X)=>(0,D.combinedDisposable)(...B.map(te=>te(se=>Q.call(re,se),null,X)))}c.any=j;function L(B,Q,re,X){let te=re;return I(B,se=>(te=Q(te,se),te),X)}c.reduce=L;function M(B,Q){let re;const X={onWillAddFirstListener(){re=B(te.fire,te)},onDidRemoveLastListener(){re?.dispose()}};Q||a(X);const te=new y(X);return Q?.add(te),te.event}function z(B,Q,re=100,X=!1,te,se){let le,ue,ye,Se=0;const be={leakWarningThreshold:te,onWillAddFirstListener(){le=B(Ne=>{Se++,ue=Q(ue,Ne),X&&!ye&&(Ee.fire(ue),ue=void 0),clearTimeout(ye),ye=setTimeout(()=>{const Fe=ue;ue=void 0,ye=void 0,(!X||Se>1)&&Ee.fire(Fe),Se=0},re)})},onDidRemoveLastListener(){le.dispose()}};se||a(be);const Ee=new y(be);return se?.add(Ee),Ee.event}c.debounce=z;function G(B,Q=0,re){return c.debounce(B,(X,te)=>X?(X.push(te),X):[te],Q,void 0,void 0,re)}c.accumulate=G;function W(B,Q=(X,te)=>X===te,re){let X=!0,te;return N(B,se=>{const le=X||!Q(se,te);return X=!1,te=se,le},re)}c.latch=W;function _(B,Q,re){return[c.filter(B,Q,re),c.filter(B,X=>!Q(X),re)]}c.split=_;function K(B,Q=!1,re=[]){let X=re.slice(),te=B(ue=>{X?X.push(ue):le.fire(ue)});const se=()=>{X?.forEach(ue=>le.fire(ue)),X=null},le=new y({onWillAddFirstListener(){te||(te=B(ue=>le.fire(ue)))},onDidAddFirstListener(){X&&(Q?setTimeout(se):se())},onDidRemoveLastListener(){te&&te.dispose(),te=null}});return le.event}c.buffer=K;class q{constructor(Q){this.event=Q,this.c=new D.DisposableStore}map(Q){return new q(I(this.event,Q,this.c))}forEach(Q){return new q(F(this.event,Q,this.c))}filter(Q){return new q(N(this.event,Q,this.c))}reduce(Q,re){return new q(L(this.event,Q,re,this.c))}latch(){return new q(W(this.event,void 0,this.c))}debounce(Q,re=100,X=!1,te){return new q(z(this.event,Q,re,X,te,this.c))}on(Q,re,X){return this.event(Q,re,X)}once(Q,re,X){return b(this.event)(Q,re,X)}dispose(){this.c.dispose()}}function V(B){return new q(B)}c.chain=V;function Z(B,Q,re=X=>X){const X=(...ue)=>le.fire(re(...ue)),te=()=>B.on(Q,X),se=()=>B.removeListener(Q,X),le=new y({onWillAddFirstListener:te,onDidRemoveLastListener:se});return le.event}c.fromNodeEventEmitter=Z;function ne(B,Q,re=X=>X){const X=(...ue)=>le.fire(re(...ue)),te=()=>B.addEventListener(Q,X),se=()=>B.removeEventListener(Q,X),le=new y({onWillAddFirstListener:te,onDidRemoveLastListener:se});return le.event}c.fromDOMEventEmitter=ne;function J(B){return new Promise(Q=>b(B)(Q))}c.toPromise=J;function x(B,Q){return Q(void 0),B(re=>Q(re))}c.runAndSubscribe=x;function T(B,Q){let re=null;function X(se){re?.dispose(),re=new D.DisposableStore,Q(se,re)}X(void 0);const te=B(se=>X(se));return(0,D.toDisposable)(()=>{te.dispose(),re?.dispose()})}c.runAndSubscribeWithStore=T;class U{constructor(Q,re){this.obs=Q,this.c=0,this.d=!1;const X={onWillAddFirstListener:()=>{Q.addObserver(this)},onDidRemoveLastListener:()=>{Q.removeObserver(this)}};re||a(X),this.emitter=new y(X),re&&re.add(this.emitter)}beginUpdate(Q){this.c++}handleChange(Q,re){this.d=!0}endUpdate(Q){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function H(B,Q){return new U(B,Q).emitter.event}c.fromObservable=H})(S=e.Event||(e.Event={}));class C{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${C.c++}`,C.all.add(this)}start(a){this.d=new O.StopWatch(!0),this.listenerCount=a}stop(){if(this.d){const a=this.d.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=C,C.all=new Set,C.c=0;let E=-1;function w(c){const a=E;return E=c,{dispose(){E=a}}}e.setGlobalLeakWarningThreshold=w;class p{constructor(a,u=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=u,this.d=0}dispose(){this.c?.clear()}check(a,u){const b=this.threshold;if(b<=0||u<b)return;this.c||(this.c=new Map);const I=this.c.get(a.value)||0;if(this.c.set(a.value,I+1),this.d-=1,this.d<=0){this.d=b*.5;let F,N=0;for(const[$,j]of this.c)(!F||N<j)&&(F=$,N=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${N}):`),console.warn(F)}return()=>{const F=this.c.get(a.value)||0;this.c.set(a.value,F-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(a,u,b){this.callback=a,this.callbackThis=u,this.stack=b,this.subscription=new D.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class y{constructor(a){this.j=!1,this.d=a,this.f=E>0||this.d?.leakWarningThreshold?new p(this.d?.leakWarningThreshold??E):void 0,this.g=this.d?._profName?new C(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(R){const a=Array.from(this.q);queueMicrotask(()=>{for(const u of a)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(a,u,b)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.Disposable.None;const I=this.q.isEmpty();I&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let F,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=h.create(),F=this.f.check(N,this.q.size+1)),R&&(N=N??h.create());const $=new g(a,u,N),j=this.q.push($);I&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,a,u);const L=$.subscription.set(()=>{F?.(),this.j||(j(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return b instanceof D.DisposableStore?b.add(L):Array.isArray(b)&&b.push(L),L}),this.l}fire(a){if(this.q){this.m||(this.m=new d);for(const u of this.q)this.m.push(this,u,a);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=y;class l{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(a,u,b){this.c.push(new m(a,u,b))}clear(a){const u=new A.LinkedList;for(const b of this.c)b.emitter!==a&&u.push(b);this.c=u}deliver(){for(;this.c.size>0;){const a=this.c.shift();try{a.listener.invoke(a.event)}catch(u){(0,k.onUnexpectedError)(u)}}}}e.EventDeliveryQueue=l;class d extends l{clear(a){this.c.clear()}}class m{constructor(a,u,b){this.emitter=a,this.listener=u,this.event=b}}class v extends y{async fireAsync(a,u,b){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const I of this.q)this.c.push([I,a]);for(;this.c.size>0&&!u.isCancellationRequested;){const[I,F]=this.c.shift(),N=[],$={...F,token:u,waitUntil:j=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");b&&(j=b(j,I.callback)),N.push(j)}};try{I.invoke($)}catch(j){(0,k.onUnexpectedError)(j);continue}Object.freeze(N),await Promise.allSettled(N).then(j=>{for(const L of j)L.status==="rejected"&&(0,k.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=v;class f extends y{constructor(a){super(a),this.h=0,this.s=new A.LinkedList,this.t=a?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const a=Array.from(this.s);this.s.clear(),super.fire(this.t(a))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(a){this.q&&(this.h!==0?this.s.push(a):super.fire(a))}}e.PauseableEmitter=f;class n extends f{constructor(a){super(a),this.c=a.delay??100}fire(a){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(a)}}e.DebounceEmitter=n;class s extends y{constructor(a){super(a),this.c=[],this.h=a?.merge}fire(a){!this.hasListeners()||(this.c.push(a),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}e.MicrotaskEmitter=s;class t{constructor(){this.d=!1,this.f=[],this.c=new y({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(a){const u={event:a,listener:null};this.f.push(u),this.d&&this.j(u);const b=()=>{this.d&&this.k(u);const I=this.f.indexOf(u);this.f.splice(I,1)};return(0,D.toDisposable)((0,i.once)(b))}g(){this.d=!0,this.f.forEach(a=>this.j(a))}h(){this.d=!1,this.f.forEach(a=>this.k(a))}j(a){a.listener=a.event(u=>this.c.fire(u))}k(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class r{constructor(){this.c=[]}wrapEvent(a){return(u,b,I)=>a(F=>{const N=this.c[this.c.length-1];N?N.push(()=>u.call(b,F)):u.call(b,F)},void 0,I)}bufferEvents(a){const u=[];this.c.push(u);const b=a();return this.c.pop(),u.forEach(I=>I()),b}}e.EventBufferer=r;class o{constructor(){this.c=!1,this.d=S.None,this.f=D.Disposable.None,this.g=new y({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(a){this.d=a,this.c&&(this.f.dispose(),this.f=a(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(oe[24],ae([0,1,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(R,P){const S=setTimeout(R.bind(P),0);return{dispose(){clearTimeout(S)}}});var D;(function(R){function P(S){return S===R.None||S===R.Cancelled||S instanceof A?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}R.isCancellationToken=P,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(D=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new k.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(P){this.a=void 0,this.b=void 0,this.b=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=D.Cancelled}dispose(P=!1){P&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=D.None}}e.CancellationTokenSource=O}),define(oe[140],ae([0,1,24]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new k.CancellationTokenSource,P=this.b(R.token);return this.a={promise:P,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.Cache=i;class D{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const P=JSON.stringify(R);return this.b!==P&&(this.b=P,this.a=this.c(R)),this.a}}e.LRUCachedFunction=D;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const P=this.b(R);return this.a.set(R,P),P}}e.CachedFunction=A}),define(oe[27],ae([0,1,140,127]),function(ee,e,k,i){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=A;const O=/{(\d+)}/g;function R(ie,...he){return he.length===0?ie:ie.replace(O,function(fe,me){const we=parseInt(me,10);return isNaN(we)||we<0||we>=he.length?fe:he[we]})}e.format=R;const P=/{([^}]+)}/g;function S(ie,he){return ie.replace(P,(fe,me)=>he[me]??fe)}e.format2=S;function C(ie){return ie.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=C;function E(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function w(ie,he){let fe=0;const me=he.charCodeAt(0);for(let we=ie.length-1;we>=0;we--)ie.charCodeAt(we)===me&&fe++;return fe}e.count=w;function p(ie,he,fe="\u2026"){return ie.length<=he?ie:`${ie.substr(0,he)}${fe}`}e.truncate=p;function h(ie,he=" "){const fe=g(ie,he);return y(fe,he)}e.trim=h;function g(ie,he){if(!ie||!he)return ie;const fe=he.length;if(fe===0||ie.length===0)return ie;let me=0;for(;ie.indexOf(he,me)===me;)me=me+fe;return ie.substring(me)}e.ltrim=g;function y(ie,he){if(!ie||!he)return ie;const fe=he.length,me=ie.length;if(fe===0||me===0)return ie;let we=me,Ie=-1;for(;Ie=ie.lastIndexOf(he,we-1),!(Ie===-1||Ie+fe!==we);){if(Ie===0)return"";we=Ie}return ie.substring(0,we)}e.rtrim=y;function l(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function d(ie){return ie.replace(/\*/g,"")}e.stripWildcards=d;function m(ie,he,fe={}){if(!ie)throw new Error("Cannot create regex from empty string");he||(ie=E(ie)),fe.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(ie,me)}e.createRegExp=m;function v(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function f(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function n(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=n;function s(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=s;function t(ie){for(let he=0,fe=ie.length;he<fe;he++){const me=ie.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function r(ie,he=0,fe=ie.length){for(let me=he;me<fe;me++){const we=ie.charCodeAt(me);if(we!==32&&we!==9)return ie.substring(he,me)}return ie.substring(he,fe)}e.getLeadingWhitespace=r;function o(ie,he=ie.length-1){for(let fe=he;fe>=0;fe--){const me=ie.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=o;function c(ie,he,fe){const me=[];let we=0;for(const Ie of ie.matchAll(he)){if(me.push(ie.slice(we,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");we=Ie.index+Ie[0].length,me.push(fe(Ie[0],...Ie.slice(1),Ie.index,ie,Ie.groups))}return me.push(ie.slice(we)),Promise.all(me).then(Ie=>Ie.join(""))}e.replaceAsync=c;function a(ie,he){return ie<he?-1:ie>he?1:0}e.compare=a;function u(ie,he,fe=0,me=ie.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){const $e=ie.charCodeAt(fe),Le=he.charCodeAt(we);if($e<Le)return-1;if($e>Le)return 1}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstring=u;function b(ie,he){return I(ie,he,0,ie.length,0,he.length)}e.compareIgnoreCase=b;function I(ie,he,fe=0,me=ie.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){let $e=ie.charCodeAt(fe),Le=he.charCodeAt(we);if($e===Le)continue;if($e>=128||Le>=128)return u(ie.toLowerCase(),he.toLowerCase(),fe,me,we,Ie);N($e)&&($e-=32),N(Le)&&(Le-=32);const qe=$e-Le;if(qe!==0)return qe}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstringIgnoreCase=I;function F(ie){return ie>=48&&ie<=57}e.isAsciiDigit=F;function N(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=N;function $(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=$;function j(ie,he){return ie.length===he.length&&I(ie,he)===0}e.equalsIgnoreCase=j;function L(ie,he){const fe=he.length;return he.length>ie.length?!1:I(ie,he,0,fe)===0}e.startsWithIgnoreCase=L;function M(ie,he){const fe=Math.min(ie.length,he.length);let me;for(me=0;me<fe;me++)if(ie.charCodeAt(me)!==he.charCodeAt(me))return me;return fe}e.commonPrefixLength=M;function z(ie,he){const fe=Math.min(ie.length,he.length);let me;const we=ie.length-1,Ie=he.length-1;for(me=0;me<fe;me++)if(ie.charCodeAt(we-me)!==he.charCodeAt(Ie-me))return me;return fe}e.commonSuffixLength=z;function G(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=G;function W(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=W;function _(ie,he){return(ie-55296<<10)+(he-56320)+65536}e.computeCodePoint=_;function K(ie,he,fe){const me=ie.charCodeAt(fe);if(G(me)&&fe+1<he){const we=ie.charCodeAt(fe+1);if(W(we))return _(me,we)}return me}e.getNextCodePoint=K;function q(ie,he){const fe=ie.charCodeAt(he-1);if(W(fe)&&he>1){const me=ie.charCodeAt(he-2);if(G(me))return _(me,fe)}return fe}class V{get offset(){return this.e}constructor(he,fe=0){this.c=he,this.d=he.length,this.e=fe}setOffset(he){this.e=he}prevCodePoint(){const he=q(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=K(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=V;class Z{get offset(){return this.c.offset}constructor(he,fe=0){this.c=new V(he,fe)}nextGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.nextCodePoint());if(Ce(we,Re)){fe.setOffset(Ie);break}we=Re}return fe.offset-me}prevGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.prevCodePoint());if(Ce(Re,we)){fe.setOffset(Ie);break}we=Re}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Z;function ne(ie,he){return new Z(ie,he).nextGraphemeLength()}e.nextCharLength=ne;function J(ie,he){return new Z(ie,he).prevGraphemeLength()}e.prevCharLength=J;function x(ie,he){he>0&&W(ie.charCodeAt(he))&&he--;const fe=he+ne(ie,he);return[fe-J(ie,fe),fe]}e.getCharContainingOffset=x;function T(ie){const he=new Z(ie);let fe=0;for(;!he.eol();)fe++,he.nextGraphemeLength();return fe}e.charCount=T;let U;function H(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B(ie){return U||(U=H()),U.test(ie)}e.containsRTL=B;const Q=/^[\t\n\r\x20-\x7E]*$/;function re(ie){return Q.test(ie)}e.isBasicASCII=re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=X;function te(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=te;function se(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=se;function le(ie,he){if(ie.length<he)return ie;const fe=/\b/g;let me=0;for(;fe.test(ie)&&!(ie.length-fe.lastIndex<he);)me=fe.lastIndex,fe.lastIndex+=1;return ie.substring(me).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,Se=/\x1b\[0?m/g;function be(ie){return ie&&(ie=ie.replace(ue,""),ie=ie.replace(ye,""),ie=ie.replace(Se,"")),ie}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Ne(ie){return Ee(ie)?ie.substr(1):ie}e.stripUTF8BOM=Ne;function Fe(ie,he){if(!ie||!he||ie.length<he.length)return!1;const fe=he.length,me=ie.toLowerCase();let we=0,Ie=-1;for(;we<fe;){const Re=me.indexOf(he[we],Ie+1);if(Re<0)return!1;Ie=Re,we++}return!0}e.fuzzyContains=Fe;function Ye(ie,he=!1){return ie?(he&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=Ye;function ze(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=ze;function ce(ie,he=1){if(he===0)return"";let fe=-1;do fe=ie.indexOf(`
`,fe+1),he--;while(he>0&&fe>=0);return fe===-1?ie:(ie[fe-1]==="\r"&&fe--,ie.substr(0,fe))}e.getNLines=ce;function de(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.singleLetterHash=de;function ge(ie){return Ae.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=ge;function Ce(ie,he){return ie===0?he!==5&&he!==7:ie===2&&he===3?!1:ie===4||ie===2||ie===3||he===4||he===2||he===3?!0:!(ie===8&&(he===8||he===9||he===11||he===12)||(ie===11||ie===9)&&(he===9||he===10)||(ie===12||ie===10)&&he===10||he===5||he===13||he===7||ie===1||ie===13&&he===14||ie===6&&he===6)}var Pe;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const fe=this.d,me=fe.length/3;let we=1;for(;we<=me;)if(he<fe[3*we])we=2*we;else if(he>fe[3*we+1])we=2*we+1;else return fe[3*we+2];return 0}}Ae.c=null;function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(ie,he){if(ie===0)return 0;const fe=Oe(ie,he);if(fe!==void 0)return fe;const me=new V(he,ie);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=je;function Oe(ie,he){const fe=new V(he,ie);let me=fe.prevCodePoint();for(;Me(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!se(me))return;let we=fe.offset;return we>0&&fe.prevCodePoint()===8205&&(we=fe.offset),we}function Me(ie){return 127995<=ie&&ie<=127999}var Be;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.d.get(Array.from(he))}static getLocales(){return ke.e.getValue()}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=ke,D=ke,ke.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.d=new k.LRUCachedFunction(ie=>{function he(Le){const qe=new Map;for(let Ge=0;Ge<Le.length;Ge+=2)qe.set(Le[Ge],Le[Ge+1]);return qe}function fe(Le,qe){const Ge=new Map(Le);for(const[et,ot]of qe)Ge.set(et,ot);return Ge}function me(Le,qe){if(!Le)return qe;const Ge=new Map;for(const[et,ot]of Le)qe.has(et)&&Ge.set(et,ot);return Ge}const we=D.c.getValue();let Ie=ie.filter(Le=>!Le.startsWith("_")&&Le in we);Ie.length===0&&(Ie=["_default"]);let Re;for(const Le of Ie){const qe=he(we[Le]);Re=me(Re,qe)}const He=he(we._common),$e=fe(He,Re);return new ke($e)}),ke.e=new i.Lazy(()=>Object.keys(ke.c.getValue()).filter(ie=>!ie.startsWith("_")));class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(he){return Te.e().has(he)}static get codePoints(){return Te.e()}}e.InvisibleCharacters=Te,Te.d=void 0}),define(oe[47],ae([0,1,12,5,27,13]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function O(o){return o===47||o===92}e.isPathSeparator=O;function R(o){return o.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function P(o){return o.indexOf("/")===-1&&(o=R(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=P;function S(o,c=k.posix.sep){if(!o)return"";const a=o.length,u=o.charCodeAt(0);if(O(u)){if(O(o.charCodeAt(1))&&!O(o.charCodeAt(2))){let I=3;const F=I;for(;I<a&&!O(o.charCodeAt(I));I++);if(F!==I&&!O(o.charCodeAt(I+1))){for(I+=1;I<a;I++)if(O(o.charCodeAt(I)))return o.slice(0,I+1).replace(/[\\/]/g,c)}}return c}else if(l(u)&&o.charCodeAt(1)===58)return O(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let b=o.indexOf("://");if(b!==-1){for(b+=3;b<a;b++)if(O(o.charCodeAt(b)))return o.slice(0,b+1)}return""}e.getRoot=S;function C(o){if(!i.isWindows||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let a=2;const u=a;for(;a<o.length&&(c=o.charCodeAt(a),c!==92);a++);return!(u===a||(c=o.charCodeAt(a+1),isNaN(c)||c===92))}e.isUNC=C;const E=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(o,c=i.isWindows){const a=c?E:w;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||c&&p.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=h;function g(o,c,a){const u=o===c;return!a||u?u:!o||!c?!1:(0,D.equalsIgnoreCase)(o,c)}e.isEqual=g;function y(o,c,a,u=k.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(o,c))return!1;if(c.length===o.length)return!0;let I=c.length;return c.charAt(c.length-1)===u&&I--,o.charAt(I)===u}return c.charAt(c.length-1)!==u&&(c+=u),o.indexOf(c)===0}e.isEqualOrParent=y;function l(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=l;function d(o,c){return i.isWindows&&o.endsWith(":")&&(o+=k.sep),(0,k.isAbsolute)(o)||(o=(0,k.join)(c,o)),o=(0,k.normalize)(o),i.isWindows?(o=(0,D.rtrim)(o,k.sep),o.endsWith(":")&&(o+=k.sep)):(o=(0,D.rtrim)(o,k.sep),o||(o=k.sep)),o}e.sanitizeFilePath=d;function m(o){const c=(0,k.normalize)(o);return i.isWindows?o.length>3?!1:v(c)&&(o.length===2||c.charCodeAt(2)===92):c===k.posix.sep}e.isRootOrDriveLetter=m;function v(o,c=i.isWindows){return c?l(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function f(o){return v(o)?o[0]:void 0}e.getDriveLetter=f;function n(o,c,a){return c.length>o.length?-1:o===c?0:(a&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.indexOfPath=n;function s(o){const c=o.split(":");let a,u,b;for(const I of c){const F=Number(I);(0,A.isNumber)(F)?u===void 0?u=F:b===void 0&&(b=F):a=a?[a,I].join(":"):I}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:u!==void 0?u:void 0,column:b!==void 0?b:u!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(o,c,a=8){let u="";for(let I=0;I<a;I++)u+=t.charAt(Math.floor(Math.random()*t.length));let b;return c?b=`${c}-${u}`:b=u,o?(0,k.join)(o,b):b}e.randomPath=r}),define(oe[66],ae([0,1,27]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(l){return D(l,0)}e.hash=i;function D(l,d){switch(typeof l){case"object":return l===null?A(349,d):Array.isArray(l)?P(l,d):S(l,d);case"string":return R(l,d);case"boolean":return O(l,d);case"number":return A(l,d);case"undefined":return A(937,d);default:return A(617,d)}}e.doHash=D;function A(l,d){return(d<<5)-d+l|0}e.numberHash=A;function O(l,d){return A(l?433:863,d)}function R(l,d){d=A(149417,d);for(let m=0,v=l.length;m<v;m++)d=A(l.charCodeAt(m),d);return d}e.stringHash=R;function P(l,d){return d=A(104579,d),l.reduce((m,v)=>D(v,m),d)}function S(l,d){return d=A(181387,d),Object.keys(l).sort().reduce((m,v)=>(m=R(v,m),D(l[v],m)),d)}class C{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=D(d,this.g),this.g}}e.Hasher=C;var E;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function w(l,d,m=32){const v=m-d,f=~((1<<v)-1);return(l<<d|(f&l)>>>v)>>>0}function p(l,d=0,m=l.byteLength,v=0){for(let f=0;f<m;f++)l[d+f]=v}function h(l,d,m="0"){for(;l.length<d;)l=m+l;return l}function g(l,d=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(m=>m.toString(16).padStart(2,"0")).join(""):h((l>>>0).toString(16),d/4)}e.toHexString=g;class y{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const m=d.length;if(m===0)return;const v=this.p;let f=this.r,n=this.u,s,t;for(n!==0?(s=n,t=-1,n=0):(s=d.charCodeAt(0),t=0);;){let r=s;if(k.isHighSurrogate(s))if(t+1<m){const o=d.charCodeAt(t+1);k.isLowSurrogate(o)?(t++,r=k.computeCodePoint(s,o)):r=65533}else{n=s;break}else k.isLowSurrogate(s)&&(r=65533);if(f=this.w(v,f,r),t++,t<m)s=d.charCodeAt(t);else break}this.r=f,this.u=n}w(d,m,v){return v<128?d[m++]=v:v<2048?(d[m++]=192|(v&1984)>>>6,d[m++]=128|(v&63)>>>0):v<65536?(d[m++]=224|(v&61440)>>>12,d[m++]=128|(v&4032)>>>6,d[m++]=128|(v&63)>>>0):(d[m++]=240|(v&1835008)>>>18,d[m++]=128|(v&258048)>>>12,d[m++]=128|(v&4032)>>>6,d[m++]=128|(v&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=y.g,m=this.q;for(let a=0;a<64;a+=4)d.setUint32(a,m.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,w(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let v=this.h,f=this.l,n=this.m,s=this.n,t=this.o,r,o,c;for(let a=0;a<80;a++)a<20?(r=f&n|~f&s,o=1518500249):a<40?(r=f^n^s,o=1859775393):a<60?(r=f&n|f&s|n&s,o=2400959708):(r=f^n^s,o=3395469782),c=w(v,5)+r+t+o+d.getUint32(a*4,!1)&4294967295,t=s,s=n,n=w(f,30),f=v,v=c;this.h=this.h+v&4294967295,this.l=this.l+f&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=y,y.g=new DataView(new ArrayBuffer(320))}),define(oe[88],ae([0,1,27]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(i||(i={})),function(D){const A="error",O="warning",R="warn",P="info",S="ignore";function C(w){return w?k.equalsIgnoreCase(A,w)?D.Error:k.equalsIgnoreCase(O,w)||k.equalsIgnoreCase(R,w)?D.Warning:k.equalsIgnoreCase(P,w)?D.Info:D.Ignore:D.Ignore}D.fromValue=C;function E(w){switch(w){case D.Error:return A;case D.Warning:return O;case D.Info:return P;default:return S}}D.toString=E}(i||(i={})),e.default=i}),define(oe[48],ae([0,1,20,27]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const h=p.charCodeAt(0),g=this.b.charCodeAt(this.c);return h-g}value(){return this.b[this.c]}}e.StringIterator=D;class A{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,i.compareSubstring)(p,this.b,0,p.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class O{constructor(p=!0,h=!0){this.f=p,this.g=h}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let h=p.length-1;h>=0;h--,this.c--){const g=this.b.charCodeAt(h);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===47||this.f&&h===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,i.compareSubstring)(p,this.b,0,p.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=O;var R;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(R||(R={}));class P{constructor(p,h){this.f=p,this.g=h,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(p,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,i.compare)(p,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=P;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(C||(C={}));class E{static forUris(p=()=>!1,h=()=>!1){return new E(new P(p,h))}static forPaths(p=!1){return new E(new O(void 0,!p))}static forStrings(){return new E(new D)}static forConfigKeys(){return new E(new A)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,h){if(h){const g=h.slice(0);(0,k.shuffle)(g);for(const y of g)this.set(y,p)}else{const g=p.slice(0);(0,k.shuffle)(g);for(const y of g)this.set(y[0],y[1])}}set(p,h){const g=this.b.reset(p);let y;this.c||(this.c=new S,this.c.segment=g.value());const l=[];for(y=this.c;;){const m=g.cmp(y.segment);if(m>0)y.left||(y.left=new S,y.left.segment=g.value()),l.push([-1,y]),y=y.left;else if(m<0)y.right||(y.right=new S,y.right.segment=g.value()),l.push([1,y]),y=y.right;else if(g.hasNext())g.next(),y.mid||(y.mid=new S,y.mid.segment=g.value()),l.push([0,y]),y=y.mid;else break}const d=y.value;y.value=h,y.key=p;for(let m=l.length-1;m>=0;m--){const v=l[m][1];v.updateHeight();const f=v.balanceFactor();if(f<-1||f>1){const n=l[m][0],s=l[m+1][0];if(n===1&&s===1)l[m][1]=v.rotateLeft();else if(n===-1&&s===-1)l[m][1]=v.rotateRight();else if(n===1&&s===-1)v.right=l[m+1][1]=l[m+1][1].rotateRight(),l[m][1]=v.rotateLeft();else if(n===-1&&s===1)v.left=l[m+1][1]=l[m+1][1].rotateLeft(),l[m][1]=v.rotateRight();else throw new Error;if(m>0)switch(l[m-1][0]){case-1:l[m-1][1].left=l[m][1];break;case 1:l[m-1][1].right=l[m][1];break;case 0:l[m-1][1].mid=l[m][1];break}else this.c=l[0][1]}}return d}get(p){return this.d(p)?.value}d(p){const h=this.b.reset(p);let g=this.c;for(;g;){const y=h.cmp(g.segment);if(y>0)g=g.left;else if(y<0)g=g.right;else if(h.hasNext())h.next(),g=g.mid;else break}return g}has(p){const h=this.d(p);return!(h?.value===void 0&&h?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,h){const g=this.b.reset(p),y=[];let l=this.c;for(;l;){const d=g.cmp(l.segment);if(d>0)y.push([-1,l]),l=l.left;else if(d<0)y.push([1,l]),l=l.right;else if(g.hasNext())g.next(),y.push([0,l]),l=l.mid;else break}if(!!l){if(h?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const d=this.f(l.right);if(d.key){const{key:m,value:v,segment:f}=d;this.e(d.key,!1),l.key=m,l.value=v,l.segment=f}}else{const d=l.left??l.right;if(y.length>0){const[m,v]=y[y.length-1];switch(m){case-1:v.left=d;break;case 0:v.mid=d;break;case 1:v.right=d;break}}else this.c=d}for(let d=y.length-1;d>=0;d--){const m=y[d][1];m.updateHeight();const v=m.balanceFactor();if(v>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),y[d][1]=m.rotateLeft()):v<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),y[d][1]=m.rotateRight()),d>0)switch(y[d-1][0]){case-1:y[d-1][1].left=y[d][1];break;case 1:y[d-1][1].right=y[d][1];break;case 0:y[d-1][1].mid=y[d][1];break}else this.c=y[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const h=this.b.reset(p);let g=this.c,y;for(;g;){const l=h.cmp(g.segment);if(l>0)g=g.left;else if(l<0)g=g.right;else if(h.hasNext())h.next(),y=g.value||y,g=g.mid;else break}return g&&g.value||y}findSuperstr(p){const h=this.b.reset(p);let g=this.c;for(;g;){const y=h.cmp(g.segment);if(y>0)g=g.left;else if(y<0)g=g.right;else if(h.hasNext())h.next(),g=g.mid;else return g.mid?this.g(g.mid):void 0}}forEach(p){for(const[h,g]of this)p(g,h)}*[Symbol.iterator](){yield*this.g(this.c)}g(p){const h=[];return this.h(p,h),h[Symbol.iterator]()}h(p,h){!p||(p.left&&this.h(p.left,h),p.value&&h.push([p.key,p.value]),p.mid&&this.h(p.mid,h),p.right&&this.h(p.right,h))}_isBalanced(){const p=h=>{if(!h)return!0;const g=h.balanceFactor();return g<-1||g>1?!1:p(h.left)&&p(h.right)};return p(this.c)}}e.TernarySearchTree=E}),define(oe[7],ae([0,1,12,5]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function R(t,r){if(!t.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!D.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!A.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(t,r){return!t&&!r?"file":t}function S(t,r){switch(t){case"https":case"http":case"file":r?r[0]!==E&&(r=E+r):r=E;break}return r}const C="",E="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(r){return r instanceof p?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,o,c,a,u,b=!1){typeof r=="object"?(this.scheme=r.scheme||C,this.authority=r.authority||C,this.path=r.path||C,this.query=r.query||C,this.fragment=r.fragment||C):(this.scheme=P(r,b),this.authority=o||C,this.path=S(this.scheme,c||C),this.query=a||C,this.fragment=u||C,R(this,b))}get fsPath(){return m(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:c,path:a,query:u,fragment:b}=r;return o===void 0?o=this.scheme:o===null&&(o=C),c===void 0?c=this.authority:c===null&&(c=C),a===void 0?a=this.path:a===null&&(a=C),u===void 0?u=this.query:u===null&&(u=C),b===void 0?b=this.fragment:b===null&&(b=C),o===this.scheme&&c===this.authority&&a===this.path&&u===this.query&&b===this.fragment?this:new g(o,c,a,u,b)}static parse(r,o=!1){const c=w.exec(r);return c?new g(c[2]||C,s(c[4]||C),s(c[5]||C),s(c[7]||C),s(c[9]||C),o):new g(C,C,C,C,C)}static file(r){let o=C;if(i.isWindows&&(r=r.replace(/\\/g,E)),r[0]===E&&r[1]===E){const c=r.indexOf(E,2);c===-1?(o=r.substring(2),r=E):(o=r.substring(2,c),r=r.substring(c)||E)}return new g("file",o,r,C,C)}static from(r){const o=new g(r.scheme,r.authority,r.path,r.query,r.fragment);return R(o,!0),o}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return i.isWindows&&r.scheme==="file"?c=p.file(k.win32.join(m(r,!0),...o)).path:c=k.posix.join(r.path,...o),r.with({path:c})}toString(r=!1){return v(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof p)return r;{const o=new g(r);return o._formatted=r.external,o._fsPath=r._sep===h?r.fsPath:null,o}}else return r}}e.URI=p;const h=i.isWindows?1:void 0;class g extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(r=!1){return r?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=h),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(t,r,o){let c,a=-1;for(let u=0;u<t.length;u++){const b=t.charCodeAt(u);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||r&&b===47||o&&b===91||o&&b===93||o&&b===58)a!==-1&&(c+=encodeURIComponent(t.substring(a,u)),a=-1),c!==void 0&&(c+=t.charAt(u));else{c===void 0&&(c=t.substr(0,u));const I=y[b];I!==void 0?(a!==-1&&(c+=encodeURIComponent(t.substring(a,u)),a=-1),c+=I):a===-1&&(a=u)}}return a!==-1&&(c+=encodeURIComponent(t.substring(a))),c!==void 0?c:t}function d(t){let r;for(let o=0;o<t.length;o++){const c=t.charCodeAt(o);c===35||c===63?(r===void 0&&(r=t.substr(0,o)),r+=y[c]):r!==void 0&&(r+=t[o])}return r!==void 0?r:t}function m(t,r){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?r?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,i.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=m;function v(t,r){const o=r?d:l;let c="",{scheme:a,authority:u,path:b,query:I,fragment:F}=t;if(a&&(c+=a,c+=":"),(u||a==="file")&&(c+=E,c+=E),u){let N=u.indexOf("@");if(N!==-1){const $=u.substr(0,N);u=u.substr(N+1),N=$.lastIndexOf(":"),N===-1?c+=o($,!1,!1):(c+=o($.substr(0,N),!1,!1),c+=":",c+=o($.substr(N+1),!1,!0)),c+="@"}u=u.toLowerCase(),N=u.lastIndexOf(":"),N===-1?c+=o(u,!1,!0):(c+=o(u.substr(0,N),!1,!0),c+=u.substr(N))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const N=b.charCodeAt(1);N>=65&&N<=90&&(b=`/${String.fromCharCode(N+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const N=b.charCodeAt(0);N>=65&&N<=90&&(b=`${String.fromCharCode(N+32)}:${b.substr(2)}`)}c+=o(b,!0,!1)}return I&&(c+="?",c+=o(I,!1,!1)),F&&(c+="#",c+=r?F:l(F,!1,!1)),c}function f(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+f(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(t){return t.match(n)?t.replace(n,r=>f(r)):t}}),define(oe[141],ae([0,1,7]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(S){const C=S;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=i;function D(S){const C=[];let E;try{const w=JSON.parse(S.arguments),p=w[w.length-1];p&&p.__$stack&&(w.pop(),E=p.__$stack),C.push(...w)}catch{C.push("Unable to log remote console arguments",S.arguments)}return{args:C,stack:E}}e.parse=D;function A(S){if(typeof S!="string")return A(D(S).stack);const C=S;if(C){const E=O(C),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(w&&w.length===4)return{uri:k.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=A;function O(S){if(!S)return S;const C=S.indexOf(`
`);return C===-1?S:S.substring(0,C)}function R(S,C){const{args:E,stack:w}=D(S),p=typeof E[0]=="string"&&E.length===1;let h=O(w);h&&(h=`(${h.trim()})`);let g=[];if(typeof E[0]=="string"?h&&p?g=[`%c[${C}] %c${E[0]} %c${h}`,P("blue"),P(""),P("grey")]:g=[`%c[${C}] %c${E[0]}`,P("blue"),P(""),...E.slice(1)]:g=[`%c[${C}]%`,P("blue"),...E],h&&!p&&g.push(h),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,g)}e.log=R;function P(S){return`color: ${S}`}}),define(oe[67],ae([0,1,17,27,7]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(S){return JSON.stringify(S,R)}e.stringify=A;function O(S){let C=JSON.parse(S);return C=P(C),C}e.parse=O;function R(S,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,i.regExpFlags)(C)}:C}function P(S,C=0){if(!S||C>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return D.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof k.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let E=0;E<S.length;++E)S[E]=P(S[E],C+1);else for(const E in S)Object.hasOwnProperty.call(S,E)&&(S[E]=P(S[E],C+1))}return S}e.revive=P}),define(oe[21],ae([0,1,5,7]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls",P.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(S){this.d=S}setDelegate(S){this.e=S}setServerRootPath(S){this.f=`${S}/${D.vscodeRemoteResource}`}set(S,C,E){this.a[S]=C,this.b[S]=E}setConnectionToken(S,C){this.c[S]=C}getPreferredWebSchema(){return this.d}rewrite(S){if(this.e)return this.e(S);const C=S.authority;let E=this.a[C];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const w=this.b[C],p=this.c[C];let h=`path=${encodeURIComponent(S.path)}`;return typeof p=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),i.URI.from({scheme:k.isWeb?this.d:D.vscodeRemoteResource,authority:`${E}:${w}`,path:this.f,query:h})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class O{asBrowserUri(S){const C=this.b(S,ee);return this.uriToBrowserUri(C)}uriToBrowserUri(S){return S.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(S):S.scheme===D.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${D.vscodeFileResource}://${O.a}`)?S.with({scheme:D.vscodeFileResource,authority:S.authority||O.a,query:null,fragment:null}):S}asFileUri(S){const C=this.b(S,ee);return this.uriToFileUri(C)}uriToFileUri(S){return S.scheme===D.vscodeFileResource?S.with({scheme:D.file,authority:S.authority!==O.a?S.authority:null,query:null,fragment:null}):S}b(S,C){return i.URI.isUri(S)?S:i.URI.parse(C.toUrl(S))}}O.a="vscode-app",e.FileAccess=new O;var R;(function(P){const S=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);P.CoopAndCoep=Object.freeze(S.get("3"));const C="vscode-coi";function E(p){let h;typeof p=="string"?h=new URL(p).searchParams:p instanceof URL?h=p.searchParams:i.URI.isUri(p)&&(h=new URL(p.toString(!0)).searchParams);const g=h?.get(C);if(!!g)return S.get(g)}P.getHeadersFromQuery=E;function w(p,h,g){if(!globalThis.crossOriginIsolated)return;const y=h&&g?"3":g?"2":"1";p instanceof URLSearchParams?p.set(C,y):p[C]=y}P.addSearchParam=w})(R=e.COI||(e.COI={}))}),define(oe[22],ae([0,1,47,21,12,5,27,7]),function(ee,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(p){return(0,R.uriToFsPath)(p,!0)}e.originalFSPath=P;class S{constructor(h){this.a=h}compare(h,g,y=!1){return h===g?0:(0,O.compare)(this.getComparisonKey(h,y),this.getComparisonKey(g,y))}isEqual(h,g,y=!1){return h===g?!0:!h||!g?!1:this.getComparisonKey(h,y)===this.getComparisonKey(g,y)}getComparisonKey(h,g=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,g,y=!1){if(h.scheme===g.scheme){if(h.scheme===i.Schemas.file)return k.isEqualOrParent(P(h),P(g),this.a(h))&&h.query===g.query&&(y||h.fragment===g.fragment);if((0,e.isEqualAuthority)(h.authority,g.authority))return k.isEqualOrParent(h.path,g.path,this.a(h),"/")&&h.query===g.query&&(y||h.fragment===g.fragment)}return!1}joinPath(h,...g){return R.URI.joinPath(h,...g)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let g;return h.scheme===i.Schemas.file?g=R.URI.file(D.dirname(P(h))).path:(g=D.posix.dirname(h.path),h.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),g="/")),h.with({path:g})}normalizePath(h){if(!h.path.length)return h;let g;return h.scheme===i.Schemas.file?g=R.URI.file(D.normalize(P(h))).path:g=D.posix.normalize(h.path),h.with({path:g})}relativePath(h,g){if(h.scheme!==g.scheme||!(0,e.isEqualAuthority)(h.authority,g.authority))return;if(h.scheme===i.Schemas.file){const d=D.relative(P(h),P(g));return A.isWindows?k.toSlashes(d):d}let y=h.path||"/";const l=g.path||"/";if(this.a(h)){let d=0;for(const m=Math.min(y.length,l.length);d<m&&!(y.charCodeAt(d)!==l.charCodeAt(d)&&y.charAt(d).toLowerCase()!==l.charAt(d).toLowerCase());d++);y=l.substr(0,d)+y.substr(d)}return D.posix.relative(y,l)}resolvePath(h,g){if(h.scheme===i.Schemas.file){const y=R.URI.file(D.resolve(P(h),g));return h.with({authority:y.authority,path:y.path})}return g=k.toPosixPath(g),h.with({path:D.posix.resolve(h.path,g)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,g){return h===g||h!==void 0&&g!==void 0&&(0,O.equalsIgnoreCase)(h,g)}hasTrailingPathSeparator(h,g=D.sep){if(h.scheme===i.Schemas.file){const y=P(h);return y.length>k.getRoot(y).length&&y[y.length-1]===g}else{const y=h.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,g=D.sep){return(0,e.hasTrailingPathSeparator)(h,g)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,g=D.sep){let y=!1;if(h.scheme===i.Schemas.file){const l=P(h);y=l!==void 0&&l.length===k.getRoot(l).length&&l[l.length-1]===g}else{g="/";const l=h.path;y=l.length===1&&l.charCodeAt(l.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(h,g)?h.with({path:h.path+"/"}):h}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(p=>p.scheme===i.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new S(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(p,h){const g=[];for(let y=0;y<p.length;y++){const l=h(p[y]);p.some((d,m)=>m===y?!1:(0,e.isEqualOrParent)(l,h(d)))||g.push(p[y])}return g}e.distinctParents=C;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(g){const y=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(m=>{const[v,f]=m.split(":");v&&f&&y.set(v,f)});const d=g.path.substring(0,g.path.indexOf(";"));return d&&y.set(p.META_DATA_MIME,d),y}p.parseMetaData=h})(E=e.DataUri||(e.DataUri={}));function w(p,h,g){if(h){let y=p.path;return y&&y[0]!==D.posix.sep&&(y=D.posix.sep+y),p.with({scheme:g,authority:h,path:y})}return p.with({scheme:g})}e.toLocalResource=w}),define(oe[6],ae([0,1,24,9,3,2,22,5]),function(ee,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(x){return!!x&&typeof x.then=="function"}e.isThenable=P;function S(x){const T=new k.CancellationTokenSource,U=x(T.token),H=new Promise((B,Q)=>{const re=T.token.onCancellationRequested(()=>{re.dispose(),T.dispose(),Q(new i.CancellationError)});Promise.resolve(U).then(X=>{re.dispose(),T.dispose(),B(X)},X=>{re.dispose(),T.dispose(),Q(X)})});return new class{cancel(){T.cancel()}then(B,Q){return H.then(B,Q)}catch(B){return this.then(void 0,B)}finally(B){return H.finally(B)}}}e.createCancelablePromise=S;function C(x,T,U){return new Promise((H,B)=>{const Q=T.onCancellationRequested(()=>{Q.dispose(),H(U)});x.then(H,B).finally(()=>Q.dispose())})}e.raceCancellation=C;function E(x,T){return new Promise((U,H)=>{const B=T.onCancellationRequested(()=>{B.dispose(),H(new i.CancellationError)});x.then(U,H).finally(()=>B.dispose())})}e.raceCancellationError=E;async function w(x){let T=-1;const U=x.map((B,Q)=>B.then(re=>(T=Q,re))),H=await Promise.race(U);return x.forEach((B,Q)=>{Q!==T&&B.cancel()}),H}e.raceCancellablePromises=w;function p(x,T,U){let H;const B=setTimeout(()=>{H?.(void 0),U?.()},T);return Promise.race([x.finally(()=>clearTimeout(B)),new Promise(Q=>H=Q)])}e.raceTimeout=p;function h(x){return new Promise((T,U)=>{const H=x();P(H)?H.then(T,U):T(H)})}e.asPromise=h;class g{constructor(){this.a=null,this.b=null,this.d=null}queue(T){if(this.a){if(this.d=T,!this.b){const U=()=>{this.b=null;const H=this.queue(this.d);return this.d=null,H};this.b=new Promise(H=>{this.a.then(U,U).then(H)})}return new Promise((U,H)=>{this.b.then(U,H)})}return this.a=T(),new Promise((U,H)=>{this.a.then(B=>{this.a=null,U(B)},B=>{this.a=null,H(B)})})}}e.Throttler=g;class y{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.Sequencer=y;class l{constructor(){this.a=new Map}queue(T,U){const B=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(T)===B&&this.a.delete(T)});return this.a.set(T,B),B}}e.SequencerByKey=l;const d=(x,T)=>{let U=!0;const H=setTimeout(()=>{U=!1,T()},x);return{isTriggered:()=>U,dispose:()=>{clearTimeout(H),U=!1}}},m=x=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,x())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class v{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,U=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((B,Q)=>{this.d=B,this.f=Q}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const H=()=>{this.a=null,this.d?.(null)};return this.a=U===e.MicrotaskDelay?m(H):d(U,H),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=v;class f{constructor(T){this.a=new v(T),this.b=new g}trigger(T,U){return this.a.trigger(()=>this.b.queue(T),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=f;class n{constructor(){this.a=!1,this.b=new Promise((T,U)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class s extends n{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function t(x,T){return T?new Promise((U,H)=>{const B=setTimeout(()=>{Q.dispose(),U()},x),Q=T.onCancellationRequested(()=>{clearTimeout(B),Q.dispose(),H(new i.CancellationError)})}):S(U=>t(x,U))}e.timeout=t;function r(x,T=0){const U=setTimeout(x,T);return(0,A.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=r;function o(x){const T=[];let U=0;const H=x.length;function B(){return U<H?x[U++]():null}function Q(re){re!=null&&T.push(re);const X=B();return X?X.then(Q):Promise.resolve(T)}return Promise.resolve(null).then(Q)}e.sequence=o;function c(x,T=H=>!!H,U=null){let H=0;const B=x.length,Q=()=>{if(H>=B)return Promise.resolve(U);const re=x[H++];return Promise.resolve(re()).then(te=>T(te)?Promise.resolve(te):Q())};return Q()}e.first=c;function a(x,T=H=>!!H,U=null){if(x.length===0)return Promise.resolve(U);let H=x.length;const B=()=>{H=-1;for(const Q of x)Q.cancel?.()};return new Promise((Q,re)=>{for(const X of x)X.then(te=>{--H>=0&&T(te)?(B(),Q(te)):H===0&&Q(U)}).catch(te=>{--H>=0&&(B(),re(te))})})}e.firstParallel=a;class u{constructor(T){this.a=0,this.d=T,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(T){return this.a++,new Promise((U,H)=>{this.f.push({factory:T,c:U,e:H}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const T=this.f.shift();this.b++;const U=T.factory();U.then(T.c,T.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=u;class b extends u{constructor(){super(1)}}e.Queue=b;class I{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const T=new K;return this.b.add(T),T.p}d(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueFor(T,U=O.extUri){const H=U.getComparisonKey(T);let B=this.a.get(H);return B||(B=new b,D.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(H),this.f()}),this.a.set(H,B)),B}f(){!this.d()||this.g()}g(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.g()}}e.ResourceQueue=I;class F{constructor(T,U){this.a=-1,typeof T=="function"&&typeof U=="number"&&this.setIfNotSet(T,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},U)}setIfNotSet(T,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},U))}}e.TimeoutTimer=F;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(T,U){this.cancel(),this.a=setInterval(()=>{T()},U)}}e.IntervalTimer=N;class ${constructor(T,U){this.b=-1,this.a=T,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=$;class j{constructor(T,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=T,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=j;class L extends ${constructor(T,U){super(T,U),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=L;class M extends A.Disposable{constructor(T,U){super(),this.g=T,this.h=U,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...T),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new $(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,R.setTimeout0)(()=>{if(T)return;const U=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.runWhenIdle=(x,T)=>{const U=requestIdleCallback(x,typeof T=="number"?{timeout:T}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(U))}}}}();class z{constructor(T){this.d=!1,this.a=()=>{try{this.f=T()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=z;async function G(x,T,U){let H;for(let B=0;B<U;B++)try{return await x()}catch(Q){H=Q,await t(T)}throw H}e.retry=G;class W{hasPending(T){return this.a?typeof T=="number"?this.a.taskId===T:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(T,U,H){return this.a={taskId:T,cancel:()=>H?.(),promise:U},U.then(()=>this.d(T),()=>this.d(T)),U}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this.b)this.b.run=T;else{let U,H;const B=new Promise((Q,re)=>{U=Q,H=re});this.b={run:T,promise:B,promiseResolve:U,promiseReject:H}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=W;class _{constructor(T,U=()=>Date.now()){this.d=T,this.f=U,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.IntervalCounter=_;class K{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((T,U)=>{this.a=T,this.b=U})}complete(T){return new Promise(U=>{this.a(T),this.f=!0,U()})}error(T){return new Promise(U=>{this.b(T),this.d=!0,U()})}cancel(){new Promise(T=>{this.b(new i.CancellationError),this.d=!0,T()})}}e.DeferredPromise=K;var q;(function(x){async function T(H){let B;const Q=await Promise.all(H.map(re=>re.then(X=>X,X=>{B||(B=X)})));if(typeof B<"u")throw B;return Q}x.settled=T;function U(H){return new Promise(async(B,Q)=>{try{await H(B,Q)}catch(re){Q(re)}})}x.withAsyncBody=U})(q=e.Promises||(e.Promises={}));var V;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(V||(V={}));class Z{static fromArray(T){return new Z(U=>{U.emitMany(T)})}static fromPromise(T){return new Z(async U=>{U.emitMany(await T)})}static fromPromises(T){return new Z(async U=>{await Promise.all(T.map(async H=>U.emitOne(await H)))})}static merge(T){return new Z(async U=>{await Promise.all(T.map(async H=>{for await(const B of H)U.emitOne(B)}))})}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const U={emitOne:H=>this.g(H),emitMany:H=>this.h(H),reject:H=>this.k(H)};try{await Promise.resolve(T(U)),this.j()}catch(H){this.k(H)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(T,U){return new Z(async H=>{for await(const B of T)H.emitOne(U(B))})}map(T){return Z.map(this,T)}static filter(T,U){return new Z(async H=>{for await(const B of T)U(B)&&H.emitOne(B)})}filter(T){return Z.filter(this,T)}static coalesce(T){return Z.filter(T,U=>!!U)}coalesce(){return Z.coalesce(this)}static async toPromise(T){const U=[];for await(const H of T)U.push(H);return U}toPromise(){return Z.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}e.AsyncIterableObject=Z,Z.EMPTY=Z.fromArray([]);class ne extends Z{constructor(T,U){super(U),this.l=T}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ne;function J(x){const T=new k.CancellationTokenSource,U=x(T.token);return new ne(T,async H=>{const B=T.token.onCancellationRequested(()=>{B.dispose(),T.dispose(),H.reject(new i.CancellationError)});try{for await(const Q of U){if(T.token.isCancellationRequested)return;H.emitOne(Q)}B.dispose(),T.dispose()}catch(Q){B.dispose(),T.dispose(),H.reject(Q)}})}e.createCancelableAsyncIterable=J}),define(oe[89],ae([0,1,20,6,47,37,12,5,27]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",E="[^/\\\\]",w=/\//g;function p(K,q){switch(K){case 0:return"";case 1:return`${E}*?`;default:return`(?:${C}|${E}+${C}${q?`|${C}${E}+`:""})*?`}}function h(K,q){if(!K)return[];const V=[];let Z=!1,ne=!1,J="";for(const x of K){switch(x){case q:if(!Z&&!ne){V.push(J),J="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}J+=x}return J&&V.push(J),V}e.splitGlobAware=h;function g(K){if(!K)return"";let q="";const V=h(K,e.GLOB_SPLIT);if(V.every(Z=>Z===e.GLOBSTAR))q=".*";else{let Z=!1;V.forEach((ne,J)=>{if(ne===e.GLOBSTAR){if(Z)return;q+=p(2,J===V.length-1)}else{let x=!1,T="",U=!1,H="";for(const B of ne){if(B!=="}"&&x){T+=B;continue}if(U&&(B!=="]"||!H)){let Q;B==="-"?Q=B:(B==="^"||B==="!")&&!H?Q="^":B===e.GLOB_SPLIT?Q="":Q=(0,P.escapeRegExpCharacters)(B),H+=Q;continue}switch(B){case"{":x=!0;continue;case"[":U=!0;continue;case"}":{q+=`(?:${h(T,",").map(X=>g(X)).join("|")})`,x=!1,T="";break}case"]":{q+="["+H+"]",U=!1,H="";break}case"?":q+=E;continue;case"*":q+=p(1);continue;default:q+=(0,P.escapeRegExpCharacters)(B)}}J<V.length-1&&(V[J+1]!==e.GLOBSTAR||J+2<V.length)&&(q+=C)}Z=ne===e.GLOBSTAR})}return q}const y=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new A.LRUCache(1e4),s=function(){return!1},t=function(){return null};function r(K,q){if(!K)return t;let V;typeof K!="string"?V=K.pattern:V=K,V=V.trim();const Z=`${V}_${!!q.trimForExclusions}`;let ne=n.get(Z);if(ne)return o(ne,K);let J;return y.test(V)?ne=a(V.substr(4),V):(J=l.exec(c(V,q)))?ne=u(J[1],V):(q.trimForExclusions?m:d).test(V)?ne=b(V,q):(J=v.exec(c(V,q)))?ne=I(J[1].substr(1),V,!0):(J=f.exec(c(V,q)))?ne=I(J[1],V,!1):ne=F(V),n.set(Z,ne),o(ne,K)}function o(K,q){if(typeof q=="string")return K;const V=function(Z,ne){return(0,D.isEqualOrParent)(Z,q.base,!R.isLinux)?K((0,P.ltrim)(Z.substr(q.base.length),O.sep),ne):null};return V.allBasenames=K.allBasenames,V.allPaths=K.allPaths,V.basenames=K.basenames,V.patterns=K.patterns,V}function c(K,q){return q.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function a(K,q){return function(V,Z){return typeof V=="string"&&V.endsWith(K)?q:null}}function u(K,q){const V=`/${K}`,Z=`\\${K}`,ne=function(x,T){return typeof x!="string"?null:T?T===K?q:null:x===K||x.endsWith(V)||x.endsWith(Z)?q:null},J=[K];return ne.basenames=J,ne.patterns=[q],ne.allBasenames=J,ne}function b(K,q){const V=W(K.slice(1,-1).split(",").map(T=>r(T,q)).filter(T=>T!==t),K),Z=V.length;if(!Z)return t;if(Z===1)return V[0];const ne=function(T,U){for(let H=0,B=V.length;H<B;H++)if(V[H](T,U))return K;return null},J=V.find(T=>!!T.allBasenames);J&&(ne.allBasenames=J.allBasenames);const x=V.reduce((T,U)=>U.allPaths?T.concat(U.allPaths):T,[]);return x.length&&(ne.allPaths=x),ne}function I(K,q,V){const Z=O.sep===O.posix.sep,ne=Z?K:K.replace(w,O.sep),J=O.sep+ne,x=O.posix.sep+K;let T;return V?T=function(U,H){return typeof U=="string"&&(U===ne||U.endsWith(J)||!Z&&(U===K||U.endsWith(x)))?q:null}:T=function(U,H){return typeof U=="string"&&(U===ne||!Z&&U===K)?q:null},T.allPaths=[(V?"*/":"./")+K],T}function F(K){try{const q=new RegExp(`^${g(K)}$`);return function(V){return q.lastIndex=0,typeof V=="string"&&q.test(V)?K:null}}catch{return t}}function N(K,q,V){return!K||typeof q!="string"?!1:$(K)(q,void 0,V)}e.match=N;function $(K,q={}){if(!K)return s;if(typeof K=="string"||j(K)){const V=r(K,q);if(V===t)return s;const Z=function(ne,J){return!!V(ne,J)};return V.allBasenames&&(Z.allBasenames=V.allBasenames),V.allPaths&&(Z.allPaths=V.allPaths),Z}return z(K,q)}e.parse=$;function j(K){const q=K;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=j;function L(K){return K.allBasenames||[]}e.getBasenameTerms=L;function M(K){return K.allPaths||[]}e.getPathTerms=M;function z(K,q){const V=W(Object.getOwnPropertyNames(K).map(T=>G(T,K[T],q)).filter(T=>T!==t)),Z=V.length;if(!Z)return t;if(!V.some(T=>!!T.requiresSiblings)){if(Z===1)return V[0];const T=function(B,Q){let re;for(let X=0,te=V.length;X<te;X++){const se=V[X](B,Q);if(typeof se=="string")return se;(0,i.isThenable)(se)&&(re||(re=[]),re.push(se))}return re?(async()=>{for(const X of re){const te=await X;if(typeof te=="string")return te}return null})():null},U=V.find(B=>!!B.allBasenames);U&&(T.allBasenames=U.allBasenames);const H=V.reduce((B,Q)=>Q.allPaths?B.concat(Q.allPaths):B,[]);return H.length&&(T.allPaths=H),T}const ne=function(T,U,H){let B,Q;for(let re=0,X=V.length;re<X;re++){const te=V[re];te.requiresSiblings&&H&&(U||(U=(0,O.basename)(T)),B||(B=U.substr(0,U.length-(0,O.extname)(T).length)));const se=te(T,U,B,H);if(typeof se=="string")return se;(0,i.isThenable)(se)&&(Q||(Q=[]),Q.push(se))}return Q?(async()=>{for(const re of Q){const X=await re;if(typeof X=="string")return X}return null})():null},J=V.find(T=>!!T.allBasenames);J&&(ne.allBasenames=J.allBasenames);const x=V.reduce((T,U)=>U.allPaths?T.concat(U.allPaths):T,[]);return x.length&&(ne.allPaths=x),ne}function G(K,q,V){if(q===!1)return t;const Z=r(K,V);if(Z===t)return t;if(typeof q=="boolean")return Z;if(q){const ne=q.when;if(typeof ne=="string"){const J=(x,T,U,H)=>{if(!H||!Z(x,T))return null;const B=ne.replace("$(basename)",()=>U),Q=H(B);return(0,i.isThenable)(Q)?Q.then(re=>re?K:null):Q?K:null};return J.requiresSiblings=!0,J}}return Z}function W(K,q){const V=K.filter(T=>!!T.basenames);if(V.length<2)return K;const Z=V.reduce((T,U)=>{const H=U.basenames;return H?T.concat(H):T},[]);let ne;if(q){ne=[];for(let T=0,U=Z.length;T<U;T++)ne.push(q)}else ne=V.reduce((T,U)=>{const H=U.patterns;return H?T.concat(H):T},[]);const J=function(T,U){if(typeof T!="string")return null;if(!U){let B;for(B=T.length;B>0;B--){const Q=T.charCodeAt(B-1);if(Q===47||Q===92)break}U=T.substr(B)}const H=Z.indexOf(U);return H!==-1?ne[H]:null};J.basenames=Z,J.patterns=ne,J.allBasenames=Z;const x=K.filter(T=>!T.basenames);return x.push(J),x}function _(K,q){return(0,k.equals)(K,q,(V,Z)=>typeof V=="string"&&typeof Z=="string"?V===Z:typeof V!="string"&&typeof Z!="string"?V.base===Z.base&&V.pattern===Z.pattern:!1)}e.patternsEquals=_}),define(oe[142],ae([0,1,7]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(C){return C.toJSON()}class D{constructor(E){this.a=E}transformIncoming(E){const w=this.a.transformIncoming(E);return w===E?E:i(k.URI.from(w))}transformOutgoing(E){const w=this.a.transformOutgoing(E);return w===E?E:i(k.URI.from(w))}transformOutgoingURI(E){const w=this.a.transformOutgoing(E);return w===E?E:k.URI.from(w)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function A(C,E,w){if(!C||w>200)return null;if(typeof C=="object"){if(C instanceof k.URI)return E.transformOutgoing(C);for(const p in C)if(Object.hasOwnProperty.call(C,p)){const h=A(C[p],E,w+1);h!==null&&(C[p]=h)}}return null}function O(C,E){const w=A(C,E,0);return w===null?C:w}e.transformOutgoingURIs=O;function R(C,E,w,p){if(!C||p>200)return null;if(typeof C=="object"){if(C.$mid===1)return w?k.URI.revive(E.transformIncoming(C)):E.transformIncoming(C);for(const h in C)if(Object.hasOwnProperty.call(C,h)){const g=R(C[h],E,w,p+1);g!==null&&(C[h]=g)}}return null}function P(C,E){const w=R(C,E,!1,0);return w===null?C:w}e.transformIncomingURIs=P;function S(C,E){const w=R(C,E,!0,0);return w===null?C:w}e.transformAndReviveIncomingURIs=S}),define(oe[143],ae([0,1,34,9,48,31,129]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(C){return this.a||(this.a=D.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(C)}value(){if(this.b===void 0){let C=0,E=0;const w=(0,k.networkInterfaces)();for(const p in w){const h=w[p];if(h)for(const{mac:g,internal:y}of h)y||(E+=1,this.c(g.toUpperCase())&&(C+=1))}this.b=E>0?C/E:0}return this.b}};let R;async function P(){return R||(R=(async()=>await S()||A.generateUuid())()),R}e.getMachineId=P;async function S(){try{const C=await new Promise((w,p)=>{ee(["crypto"],w,p)}),E=(0,O.getMac)();return C.createHash("sha256").update(E,"utf8").digest("hex")}catch(C){i.onUnexpectedError(C);return}}}),define(oe[28],ae([0,1,52,34,282,6,47,85,12,5,22,7]),function(ee,e,k,i,D,A,O,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function p(z,G=w.UNLINK){if((0,O.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return G===w.UNLINK?g(z):h(z)}async function h(z){try{const G=(0,O.randomPath)((0,i.tmpdir)());try{await k.promises.rename(z,G)}catch(W){return W.code==="ENOENT"?void 0:g(z)}g(G).catch(W=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function g(z){return(0,D.promisify)(k.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function y(z){if((0,O.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function l(z,G){return v(await(G?d(z):(0,D.promisify)(k.readdir)(z)))}async function d(z){try{return await(0,D.promisify)(k.readdir)(z,{withFileTypes:!0})}catch(_){console.warn("[node.js fs] readdir with filetypes failed with error: ",_)}const G=[],W=await l(z);for(const _ of W){let K=!1,q=!1,V=!1;try{const Z=await e.Promises.lstat((0,P.join)(z,_));K=Z.isFile(),q=Z.isDirectory(),V=Z.isSymbolicLink()}catch(Z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Z)}G.push({name:_,isFile:()=>K,isDirectory:()=>q,isSymbolicLink:()=>V})}return G}function m(z){return v(k.readdirSync(z))}e.readdirSync=m;function v(z){return z.map(G=>typeof G=="string"?S.isMacintosh?(0,R.normalizeNFC)(G):G:(G.name=S.isMacintosh?(0,R.normalizeNFC)(G.name):G.name,G))}async function f(z){const G=await l(z),W=[];for(const _ of G)await s.existsDirectory((0,P.join)(z,_))&&W.push(_);return W}function n(z,G=1e3){return new Promise(W=>{let _=!1;const K=setInterval(()=>{_||(_=!0,k.access(z,q=>{_=!1,q&&(clearInterval(K),W(void 0))}))},G)})}e.whenDeleted=n;var s;(function(z){async function G(K){let q;try{if(q=await e.Promises.lstat(K),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(S.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(Z){if(Z.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw Z}throw V}}z.stat=G;async function W(K){try{const{stat:q,symbolicLink:V}=await z.stat(K);return q.isFile()&&V?.dangling!==!0}catch{}return!1}z.existsFile=W;async function _(K){try{const{stat:q,symbolicLink:V}=await z.stat(K);return q.isDirectory()&&V?.dangling!==!0}catch{}return!1}z.existsDirectory=_})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new A.ResourceQueue;function r(z,G,W){return t.queueFor(E.URI.file(z),C.extUriBiasedIgnorePathCase).queue(()=>{const _=b(W);return new Promise((K,q)=>a(z,G,_,V=>V?q(V):K()))})}let o=!0;function c(z){o=z}e.configureFlushOnWrite=c;function a(z,G,W,_){if(!o)return k.writeFile(z,G,{mode:W.mode,flag:W.flag},_);k.open(z,W.flag,W.mode,(K,q)=>{if(K)return _(K);k.writeFile(q,G,V=>{if(V)return k.close(q,()=>_(V));k.fdatasync(q,Z=>(Z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Z),c(!1)),k.close(q,ne=>_(ne))))})})}function u(z,G,W){const _=b(W);if(!o)return k.writeFileSync(z,G,{mode:_.mode,flag:_.flag});const K=k.openSync(z,_.flag,_.mode);try{k.writeFileSync(K,G);try{k.fdatasyncSync(K)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),c(!1)}}finally{k.closeSync(K)}}e.writeFileSync=u;function b(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function I(z,G){if(z!==G)try{await e.Promises.rename(z,G)}catch(W){if(z.toLowerCase()!==G.toLowerCase()&&W.code==="EXDEV"||z.endsWith("."))await F(z,G,{preserveSymlinks:!1}),await p(z,w.MOVE);else throw W}}async function F(z,G,W){return $(z,G,{root:{source:z,target:G},options:W,handledSourcePaths:new Set})}const N=511;async function $(z,G,W){if(W.handledSourcePaths.has(z))return;W.handledSourcePaths.add(z);const{stat:_,symbolicLink:K}=await s.stat(z);if(K){if(W.options.preserveSymlinks)try{return await M(z,G,W)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(K.dangling)return}return _.isDirectory()?j(z,G,_.mode&N,W):L(z,G,_.mode&N)}async function j(z,G,W,_){await e.Promises.mkdir(G,{recursive:!0,mode:W});const K=await l(z);for(const q of K)await $((0,P.join)(z,q),(0,P.join)(G,q),_)}async function L(z,G,W){await e.Promises.copyFile(z,G),await e.Promises.chmod(G,W)}async function M(z,G,W){let _=await e.Promises.readlink(z);(0,O.isEqualOrParent)(_,W.root.source,!S.isLinux)&&(_=(0,P.join)(W.root.target,_.substr(W.root.source.length+1))),await e.Promises.symlink(_,G)}e.Promises=new class{get access(){return(0,D.promisify)(k.access)}get stat(){return(0,D.promisify)(k.stat)}get lstat(){return(0,D.promisify)(k.lstat)}get utimes(){return(0,D.promisify)(k.utimes)}get read(){return(z,G,W,_,K)=>new Promise((q,V)=>{k.read(z,G,W,_,K,(Z,ne,J)=>Z?V(Z):q({bytesRead:ne,buffer:J}))})}get readFile(){return(0,D.promisify)(k.readFile)}get write(){return(z,G,W,_,K)=>new Promise((q,V)=>{k.write(z,G,W,_,K,(Z,ne,J)=>Z?V(Z):q({bytesWritten:ne,buffer:J}))})}get appendFile(){return(0,D.promisify)(k.appendFile)}get fdatasync(){return(0,D.promisify)(k.fdatasync)}get truncate(){return(0,D.promisify)(k.truncate)}get rename(){return(0,D.promisify)(k.rename)}get copyFile(){return(0,D.promisify)(k.copyFile)}get open(){return(0,D.promisify)(k.open)}get close(){return(0,D.promisify)(k.close)}get symlink(){return(0,D.promisify)(k.symlink)}get readlink(){return(0,D.promisify)(k.readlink)}get chmod(){return(0,D.promisify)(k.chmod)}get mkdir(){return(0,D.promisify)(k.mkdir)}get unlink(){return(0,D.promisify)(k.unlink)}get rmdir(){return(0,D.promisify)(k.rmdir)}get realpath(){return(0,D.promisify)(k.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return f}get writeFile(){return r}get rm(){return p}get move(){return I}get copy(){return F}}}),define(oe[144],ae([0,1,52,12,5,27,28]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(w){if(D.isLinux)return w;const p=(0,i.dirname)(w);if(w===p)return w;const h=((0,i.basename)(w)||w).toLowerCase();try{const y=(0,O.readdirSync)(p).filter(l=>l.toLowerCase()===h);if(y.length===1){const l=R(p);if(l)return(0,i.join)(l,y[0])}else if(y.length>1){const l=y.indexOf(h);if(l>=0){const d=R(p);if(d)return(0,i.join)(d,y[l])}}}catch{}return null}e.realcaseSync=R;async function P(w){if(D.isLinux)return w;const p=(0,i.dirname)(w);if(w===p)return w;const h=((0,i.basename)(w)||w).toLowerCase();try{const y=(await O.Promises.readdir(p)).filter(l=>l.toLowerCase()===h);if(y.length===1){const l=await P(p);if(l)return(0,i.join)(l,y[0])}else if(y.length>1){const l=y.indexOf(h);if(l>=0){const d=await P(p);if(d)return(0,i.join)(d,y[l])}}}catch{}return null}e.realcase=P;async function S(w){try{return await O.Promises.realpath(w)}catch{const h=E(w);return await O.Promises.access(h,k.constants.R_OK),h}}e.realpath=S;function C(w){try{return k.realpathSync(w)}catch{const h=E(w);return k.accessSync(h,k.constants.R_OK),h}}e.realpathSync=C;function E(w){return(0,A.rtrim)((0,i.normalize)(w),i.sep)}}),define(oe[90],ae([0,1,34,12,28]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,O=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var P;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(P||(P={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class E{constructor(f,n,s){this.exePath=f,this.displayName=n,this.a=s}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function w({useAlternateBitness:v=!1}={}){return v?S===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:v=!1,findPreview:f=!1}={}){const n=w({useAlternateBitness:v});if(!n)return null;const s=i.join(n,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(s))return null;let t=-1,r=null;for(const a of await D.Promises.readdir(s)){let u=-1;if(f){const I=a.indexOf("-");if(I<0)continue;const F=a.substring(0,I);if(!A.test(F)||a.substring(I+1)!=="preview")continue;u=parseInt(F,10)}else{if(!A.test(a))continue;u=parseInt(a,10)}if(u<=t)continue;const b=i.join(s,a,"pwsh.exe");!await D.SymlinkSupport.existsFile(b)||(r=b,t=u)}if(!r)return null;const o=n.includes("x86")?" (x86)":"",c=f?" Preview":"";return new E(r,`PowerShell${c}${o}`,!0)}async function h({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const f=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:n,pwshMsixName:s}=v?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(f))if(n.test(t)){const r=i.join(f,t,"pwsh.exe");return new E(r,s)}return null}function g(){const v=i.join(k.homedir(),".dotnet","tools","pwsh.exe");return new E(v,".NET Core PowerShell Global Tool")}function y(){const v=i.join(process.env.windir,S===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(v,"Windows PowerShell",!0)}async function*l(){let v=await p();v&&(yield v),v=await p({useAlternateBitness:!0}),v&&(yield v),v=await h(),v&&(yield v),v=g(),v&&(yield v),v=await p({findPreview:!0}),v&&(yield v),v=await h({findPreview:!0}),v&&(yield v),v=await p({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=y(),v&&(yield v)}async function*d(){for await(const v of l())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=d;async function m(){for await(const v of d())return v;return null}e.getFirstAvailablePowerShellInstallation=m}),define(oe[91],ae([0,1,12,5,36,87,13,28]),function(ee,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function P(E=D.env){return E.comspec||"cmd.exe"}e.getWindowsShell=P;function S(E){let w=[],p=!1;const h=function(g){if(p){w.push(g);return}(!E.send(g,l=>{if(l&&console.error(l),p=!1,w.length>0){const d=w.slice(0);w=[],d.forEach(m=>h(m))}})||i.isWindows)&&(p=!0)};return{send:h}}e.createQueuedSender=S;var C;(function(E){async function w(p,h,g){if(k.isAbsolute(p))return p;if(h===void 0&&(h=D.cwd()),k.dirname(p)!=="."||(g===void 0&&O.isString(D.env.PATH)&&(g=D.env.PATH.split(k.delimiter)),g===void 0||g.length===0))return k.join(h,p);async function l(d){if(await R.Promises.exists(d)){let m;try{m=await R.Promises.stat(d)}catch(v){v.message.startsWith("EACCES")&&(m=await R.Promises.lstat(d))}return m?!m.isDirectory():!1}return!1}for(const d of g){let m;if(k.isAbsolute(d)?m=k.join(d,p):m=k.join(h,d,p),await l(m))return m;let v=m+".com";if(await l(v)||(v=m+".exe",await l(v)))return v}return k.join(h,p)}E.findExecutable=w})(C=e.win32||(e.win32={}))}),define(oe[145],ae([0,1,49,21]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(O){return new Promise((R,P)=>{let S;const C=new Map;function E(p,h,g,y,l){const d=C.get(h);if(p===O||d){const m={name:w(g),cmd:g,pid:p,ppid:h,load:y,mem:l};C.set(p,m),p===O&&(S=m),d&&(d.children||(d.children=[]),d.children.push(m),d.children.length>1&&(d.children=d.children.sort((v,f)=>v.pid-f.pid)))}}function w(p){const h=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,l=/--utility-sub-type=network/,d=/--utility-sub-type=node.mojom.NodeService/,m=/--crashes-directory/,v=/\\pipe\\winpty-control/,f=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(m.exec(p))return"electron-crash-reporter";if(v.exec(p))return"winpty-process";if(f.exec(p))return"console-window-host (Windows internal process)";let s=n.exec(p);if(s&&s.length===2){if(s[1]==="renderer")return h.exec(p)?"shared-process":g.exec(p)?"issue-reporter":y.exec(p)?"process-explorer":"window";if(s[1]==="utility"){if(l.exec(p))return"utility-network-service";if(d.exec(p))return"extension-host"}return s[1]}const t=/[a-zA-Z-]+\.js/g;let r="";do s=t.exec(p),s&&(r+=s+" ");while(s);return r&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${r}`:p}if(process.platform==="win32"){const p=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,g)=>{ee(["windows-process-tree"],h,g)}).then(h=>{h.getProcessList(O,g=>{if(!g){P(new Error(`Root process ${O} not found`));return}h.getProcessCpuUsage(g,y=>{const l=new Map;y.forEach(d=>{const m=p(d.commandLine||"");l.set(d.pid,{name:w(m),cmd:m,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),S=l.get(O),S?(l.forEach(d=>{const m=l.get(d.ppid);m&&(m.children||(m.children=[]),m.children.push(d))}),l.forEach(d=>{d.children&&(d.children=d.children.sort((m,v)=>m.pid-v.pid))}),R(S)):P(new Error(`Root process ${O} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let p=function(){let h=[S];const g=[];for(;h.length;){const l=h.shift();l&&(g.push(l.pid),l.children&&(h=h.concat(l.children)))}let y=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);y+=" "+g.join(" "),(0,k.exec)(y,{},(l,d,m)=>{if(l||m)P(l||new Error(m.toString()));else{const v=d.toString().split(`
`);for(let f=0;f<g.length;f++){const n=C.get(g[f]);n.load=parseFloat(v[f])}if(!S){P(new Error(`Root process ${O} not found`));return}R(S)}})};(0,k.exec)("which ps",{},(h,g,y)=>{if(h||y)if(process.platform!=="linux")P(h||new Error(y.toString()));else{const l=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(l,{},(d,m,v)=>{d||v?P(d||new Error(v.toString())):(A(m,E),p())})}else{const l=g.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${l} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,v,f)=>{m||f&&!f.includes("screen size is bogus")?P(m||new Error(f.toString())):(A(v,E),process.platform==="linux"?p():S?R(S):P(new Error(`Root process ${O} not found`)))})}})}})}e.listProcesses=D;function A(O,R){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=O.toString().split(`
`);for(const C of S){const E=P.exec(C.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(oe[146],ae([0,1,34,5,90,91]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function O(E,w){return E===1?i.isWindows?C():A.getWindowsShell(w):P(E,w)}e.getSystemShell=O;let R=null;function P(E,w){if(i.isLinux&&E===2||i.isMacintosh&&E===3)return"/bin/bash";if(!R){let p;if(i.isWindows)p="/bin/bash";else{if(p=w.SHELL,!p)try{p=(0,k.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}R=p}return R}let S=null;async function C(){return S||(S=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),S}});var pe=this&&this.__decorate||function(ee,e,k,i){var D=arguments.length,A=D<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,k):i,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ee,e,k,i);else for(var R=ee.length-1;R>=0;R--)(O=ee[R])&&(A=(D<3?O(A):D>3?O(e,k,A):O(e,k))||A);return D>3&&A&&Object.defineProperty(e,k,A),A};define(oe[39],ae([0,1,20,6,17,24,63,9,3,2,67,27,13]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var p;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(p||(p={}));function h(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(g||(g={}));function y(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(l||(l={}));function d(q){let V=0;for(let Z=0;;Z+=7){const ne=q.read(1);if(V|=(ne.buffer[0]&127)<<Z,!(ne.buffer[0]&128))return V}}const m=t(0);function v(q,V){if(V===0){q.write(m);return}let Z=0;for(let J=V;J!==0;J=J>>>7)Z++;const ne=D.VSBuffer.alloc(Z);for(let J=0;V!==0;J++)ne.buffer[J]=V&127,V=V>>>7,V>0&&(ne.buffer[J]|=128);q.write(ne)}class f{constructor(V){this.b=V,this.a=0}read(V){const Z=this.b.slice(this.a,this.a+V);return this.a+=Z.byteLength,Z}}e.BufferReader=f;class n{constructor(){this.a=[]}get buffer(){return D.VSBuffer.concat(this.a)}write(V){this.a.push(V)}}e.BufferWriter=n;var s;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(s||(s={}));function t(q){const V=D.VSBuffer.alloc(1);return V.writeUInt8(q,0),V}const r={Undefined:t(s.Undefined),String:t(s.String),Buffer:t(s.Buffer),VSBuffer:t(s.VSBuffer),Array:t(s.Array),Object:t(s.Object),Uint:t(s.Int)},o=typeof Buffer<"u";function c(q,V){if(typeof V>"u")q.write(r.Undefined);else if(typeof V=="string"){const Z=D.VSBuffer.fromString(V);q.write(r.String),v(q,Z.byteLength),q.write(Z)}else if(o&&Buffer.isBuffer(V)){const Z=D.VSBuffer.wrap(V);q.write(r.Buffer),v(q,Z.byteLength),q.write(Z)}else if(V instanceof D.VSBuffer)q.write(r.VSBuffer),v(q,V.byteLength),q.write(V);else if(Array.isArray(V)){q.write(r.Array),v(q,V.length);for(const Z of V)c(q,Z)}else if(typeof V=="number"&&(V|0)===V)q.write(r.Uint),v(q,V);else{const Z=D.VSBuffer.fromString(JSON.stringify(V));q.write(r.Object),v(q,Z.byteLength),q.write(Z)}}e.serialize=c;function a(q){switch(q.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return q.read(d(q)).toString();case s.Buffer:return q.read(d(q)).buffer;case s.VSBuffer:return q.read(d(q));case s.Array:{const Z=d(q),ne=[];for(let J=0;J<Z;J++)ne.push(a(q));return ne}case s.Object:return JSON.parse(q.read(d(q)).toString());case s.Int:return d(q)}}e.deserialize=a;class u{constructor(V,Z,ne=null,J=1e3){this.h=V,this.j=Z,this.k=ne,this.l=J,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(V,Z){this.b.set(V,Z),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const Z=this.o([V.type]);this.k?.logOutgoing(Z,0,1,y(V.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([V.type,V.id],V.data);this.k?.logOutgoing(Z,V.id,1,y(V.type),V.data);return}}}o(V,Z=void 0){const ne=new n;return c(ne,V),c(ne,Z),this.p(ne.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const Z=new f(V),ne=a(Z),J=a(Z),x=ne[0];switch(x){case 100:return this.k?.logIncoming(V.byteLength,ne[1],1,`${h(x)}: ${ne[2]}.${ne[3]}`,J),this.s({type:x,id:ne[1],channelName:ne[2],name:ne[3],arg:J});case 102:return this.k?.logIncoming(V.byteLength,ne[1],1,`${h(x)}: ${ne[2]}.${ne[3]}`,J),this.t({type:x,id:ne[1],channelName:ne[2],name:ne[3],arg:J});case 101:return this.k?.logIncoming(V.byteLength,ne[1],1,`${h(x)}`),this.u({type:x,id:ne[1]});case 103:return this.k?.logIncoming(V.byteLength,ne[1],1,`${h(x)}`),this.u({type:x,id:ne[1]})}}s(V){const Z=this.b.get(V.channelName);if(!Z){this.v(V);return}const ne=new A.CancellationTokenSource;let J;try{J=Z.call(this.j,V.name,V.arg,ne.token)}catch(U){J=Promise.reject(U)}const x=V.id;J.then(U=>{this.m({id:x,data:U,type:201}),this.d.delete(V.id)},U=>{U instanceof Error?this.m({id:x,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:x,data:U,type:203}),this.d.delete(V.id)});const T=(0,S.toDisposable)(()=>ne.cancel());this.d.set(V.id,T)}t(V){const Z=this.b.get(V.channelName);if(!Z){this.v(V);return}const ne=V.id,x=Z.listen(this.j,V.name,V.arg)(T=>this.m({id:ne,data:T,type:204}));this.d.set(V.id,x)}u(V){const Z=this.d.get(V.id);Z&&(Z.dispose(),this.d.delete(V.id))}v(V){let Z=this.g.get(V.channelName);Z||(Z=[],this.g.set(V.channelName,Z));const ne=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:V,timeoutTimer:ne})}w(V){const Z=this.g.get(V);if(Z){for(const ne of Z)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=u;var b;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class I{constructor(V,Z=null){this.l=V,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new P.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=Z}getChannel(V){const Z=this;return{call(ne,J,x){return Z.a?Promise.reject(new R.CancellationError):Z.m(V,ne,J,x)},listen(ne,J){return Z.a?P.Event.None:Z.o(V,ne,J)}}}m(V,Z,ne,J=A.CancellationToken.None){const x=this.g++,U={id:x,type:100,channelName:V,name:Z,arg:ne};if(J.isCancellationRequested)return Promise.reject(new R.CancellationError);let H;return new Promise((Q,re)=>{if(J.isCancellationRequested)return re(new R.CancellationError);const X=()=>{const ue=ye=>{switch(ye.type){case 201:this.f.delete(x),Q(ye.data);break;case 202:{this.f.delete(x);const Se=new Error(ye.data.message);Se.stack=Array.isArray(ye.data.stack)?ye.data.stack.join(`
`):ye.data.stack,Se.name=ye.data.name,re(Se);break}case 203:this.f.delete(x),re(ye.data);break}};this.f.set(x,ue),this.p(U)};let te=null;this.b===l.Idle?X():(te=(0,i.createCancelablePromise)(ue=>this.u()),te.then(()=>{te=null,X()}));const se=()=>{te?(te.cancel(),te=null):this.p({id:x,type:101}),re(new R.CancellationError)},le=J.onCancellationRequested(se);H=(0,S.combinedDisposable)((0,S.toDisposable)(se),le),this.d.add(H)}).finally(()=>{this.d.delete(H)})}o(V,Z,ne){const J=this.g++,T={id:J,type:102,channelName:V,name:Z,arg:ne};let U=null;const H=new P.Emitter({onWillAddFirstListener:()=>{U=(0,i.createCancelablePromise)(Q=>this.u()),U.then(()=>{U=null,this.d.add(H),this.p(T)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(H),this.p({id:J,type:103}))}}),B=Q=>H.fire(Q.data);return this.f.set(J,B),H.event}p(V){switch(V.type){case 100:case 102:{const Z=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(Z,V.id,0,`${h(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const Z=this.q([V.type,V.id]);this.j?.logOutgoing(Z,V.id,0,h(V.type));return}}}q(V,Z=void 0){const ne=new n;return c(ne,V),c(ne,Z),this.r(ne.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const Z=new f(V),ne=a(Z),J=a(Z),x=ne[0];switch(x){case 200:return this.j?.logIncoming(V.byteLength,0,0,y(x)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ne[1],0,y(x),J),this.t({type:ne[0],id:ne[1],data:J})}}t(V){if(V.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.dispose)(this.d.values()),this.d.clear()}}pe([O.memoize],I.prototype,"onDidInitializePromise",null),e.ChannelClient=I;class F{get connections(){const V=[];return this.f.forEach(Z=>V.push(Z)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new P.Emitter,this.onDidAddConnection=this.g.event,this.h=new P.Emitter,this.onDidRemoveConnection=this.h.event,V(({protocol:Z,onDidClientDisconnect:ne})=>{P.Event.once(Z.onMessage)(x=>{const T=new f(x),U=a(T),H=new u(Z,U),B=new I(Z);this.a.forEach((re,X)=>H.registerChannel(X,re));const Q={channelServer:H,channelClient:B,ctx:U};this.f.add(Q),this.g.fire(Q),ne(()=>{H.dispose(),B.dispose(),this.f.delete(Q),this.h.fire(Q)})})})}getChannel(V,Z){const ne=this;return{call(J,x,T){let U;if((0,w.isFunction)(Z)){const B=(0,k.getRandomElement)(ne.connections.filter(Z));U=B?Promise.resolve(B):P.Event.toPromise(P.Event.filter(ne.onDidAddConnection,Z))}else U=Z.routeCall(ne,J,x);const H=U.then(B=>B.channelClient.getChannel(V));return $(H).call(J,x,T)},listen(J,x){if((0,w.isFunction)(Z))return ne.j(V,Z,J,x);const T=Z.routeEvent(ne,J,x).then(U=>U.channelClient.getChannel(V));return $(T).listen(J,x)}}}j(V,Z,ne,J){const x=this;let T=new S.DisposableStore;const U=new P.Emitter({onWillAddFirstListener:()=>{T=new S.DisposableStore;const H=new P.EventMultiplexer,B=new Map,Q=X=>{const se=X.channelClient.getChannel(V).listen(ne,J),le=H.add(se);B.set(X,le)},re=X=>{const te=B.get(X);!te||(te.dispose(),B.delete(X))};x.connections.filter(Z).forEach(Q),P.Event.filter(x.onDidAddConnection,Z)(Q,void 0,T),x.onDidRemoveConnection(re,void 0,T),H.event(U.fire,U,T),T.add(H)},onDidRemoveLastListener:()=>{T.dispose()}});return U.event}registerChannel(V,Z){this.a.set(V,Z),this.f.forEach(ne=>{ne.channelServer.registerChannel(V,Z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=F;class N{constructor(V,Z,ne=null){const J=new n;c(J,Z),V.send(J.buffer),this.a=new I(V,ne),this.d=new u(V,Z,ne)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,Z){this.d.registerChannel(V,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function $(q){return{call(V,Z,ne){return q.then(J=>J.call(V,Z,ne))},listen(V,Z){const ne=new P.Relay;return q.then(J=>ne.input=J.listen(V,Z)),ne.event}}}e.getDelayedChannel=$;function j(q){let V=!1;return{call(Z,ne,J){return V?q.call(Z,ne,J):(0,i.timeout)(0).then(()=>V=!0).then(()=>q.call(Z,ne,J))},listen(Z,ne){if(V)return q.listen(Z,ne);const J=new P.Relay;return(0,i.timeout)(0).then(()=>V=!0).then(()=>J.input=q.listen(Z,ne)),J.event}}}e.getNextTickChannel=j;class L{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const Z of V.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await P.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.StaticRouter=L;var M;(function(q){function V(x,T){const U=x,H=T&&T.disableMarshalling,B=new Map;for(const Q in U)ne(Q)&&B.set(Q,P.Event.buffer(U[Q],!0));return new class{listen(Q,re,X){const te=B.get(re);if(te)return te;if(J(re)){const se=U[re];if(typeof se=="function")return se.call(U,X)}throw new Error(`Event not found: ${re}`)}call(Q,re,X){const te=U[re];if(typeof te=="function"){if(!H&&Array.isArray(X))for(let se=0;se<X.length;se++)X[se]=(0,C.revive)(X[se]);return te.apply(U,X)}throw new Error(`Method not found: ${re}`)}}}q.fromService=V;function Z(x,T){const U=T&&T.disableMarshalling;return new Proxy({},{get(H,B){if(typeof B=="string")return T?.properties?.has(B)?T.properties.get(B):J(B)?function(Q){return x.listen(B,Q)}:ne(B)?x.listen(B):async function(...Q){let re;T&&!(0,w.isUndefinedOrNull)(T.context)?re=[T.context,...Q]:re=Q;const X=await x.call(B,re);return U?X:(0,C.revive)(X)};throw new Error(`Property not found: ${String(B)}`)}})}q.toService=Z;function ne(x){return x[0]==="o"&&x[1]==="n"&&E.isUpperAsciiLetter(x.charCodeAt(2))}function J(x){return/^onDynamic/.test(x)&&E.isUpperAsciiLetter(x.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const V=q.toString();if(V!=="[object Object]")return V}return q}function W(q){return Array.isArray(q)?q.map(G):G(q)}function _(q,V,Z,ne,J,x,T){T=W(T);const U=z[J],H=U[ne%U.length];let B=[`%c[${q}]%c[${String(V).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(x)?(B=B.concat(T),B.push(")")):B.push(T),console.log.apply(console,B)}class K{constructor(V,Z){this.d=V,this.f=Z,this.a=0,this.b=0}logOutgoing(V,Z,ne,J,x){this.b+=V,_(this.d,this.b,V,Z,ne,J,x)}logIncoming(V,Z,ne,J,x){this.a+=V,_(this.f,this.a,V,Z,ne,J,x)}}e.IPCLogger=K}),define(oe[147],ae([0,1,17,3,39]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(P){this.a=P,this.onMessage=i.Event.fromDOMEventEmitter(this.a,"message",S=>k.VSBuffer.wrap(S.data)),P.start()}send(P){this.a.postMessage(P.buffer)}disconnect(){this.a.close()}}e.Protocol=A;class O extends D.IPCClient{constructor(P,S){const C=new A(P);super(C,S),this.b=C}dispose(){this.b.disconnect()}}e.Client=O}),define(oe[92],ae([0,1,17,3,2,39]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(O=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(r){r.enableDiagnostics=!1,r.records=[];const o=new WeakMap;let c=0;function a(b,I){if(!o.has(b)){const F=String(++c);o.set(b,F)}return o.get(b)}function u(b,I,F,N){if(!r.enableDiagnostics)return;const $=a(b,I);if(N instanceof k.VSBuffer||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const j=k.VSBuffer.alloc(N.byteLength);j.set(N),r.records.push({timestamp:Date.now(),id:$,label:I,type:F,buff:j})}else r.records.push({timestamp:Date.now(),id:$,label:I,type:F,data:N})}r.traceSocketEvent=u})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var P;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function C(){return S||(S=k.VSBuffer.alloc(0)),S}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(o){this.a.push(o),this.b+=o.byteLength}read(o){return this.c(o,!0)}peek(o){return this.c(o,!1)}c(o,c){if(o===0)return C();if(o>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===o){const I=this.a[0];return c&&(this.a.shift(),this.b-=o),I}if(this.a[0].byteLength>o){const I=this.a[0].slice(0,o);return c&&(this.a[0]=this.a[0].slice(o),this.b-=o),I}const a=k.VSBuffer.alloc(o);let u=0,b=0;for(;o>0;){const I=this.a[b];if(I.byteLength>o){const F=I.slice(0,o);a.set(F,u),u+=o,c&&(this.a[b]=I.slice(o),this.b-=o),o-=o}else a.set(I,u),u+=I.byteLength,c?(this.a.shift(),this.b-=I.byteLength):b++,o-=I.byteLength}return a}}e.ChunkStream=E;var w;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(w||(w={}));function p(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(o,c,a,u){this.type=o,this.id=c,this.ack=a,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends D.Disposable{constructor(o){super(),this.f=this.B(new i.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=o,this.b=!1,this.c=new E,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(o);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,u=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new g(a,u,b,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(o){this.k=null,this.a=!1,this.b=!1,this.c=o,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(o){if(this.a)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=k.VSBuffer.alloc(13);c.writeUInt8(o.type,0),c.writeUInt32BE(o.id,1),c.writeUInt32BE(o.ack,5),c.writeUInt32BE(o.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",o.data),this.j(c,o.data)}g(o,c){const a=this.f===0;return this.d.push(o,c),this.f+=o.byteLength+c.byteLength,a}h(){const o=k.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,o}j(o,c){this.g(o,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const o=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this.c.write(o)}}class d extends D.Disposable{constructor(o){super(),this.f=new i.Emitter,this.onMessage=this.f.event,this.g=new i.Emitter,this.onDidDispose=this.g.event,this.a=o,this.b=this.B(new l(this.a)),this.c=this.B(new y(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(o){this.b.write(new g(1,0,0,o))}}e.Protocol=d;class m extends A.IPCClient{static fromSocket(o,c){return new m(new d(o),c)}get onDidDispose(){return this.b.onDidDispose}constructor(o,c,a=null){super(o,c,a),this.b=o}dispose(){super.dispose();const o=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),o.end()}}e.Client=m;class v{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new i.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(o){this.b?this.d.length>0?this.d.push(o):this.a.fire(o):this.d.push(o)}flushBuffer(){this.d=[]}}e.BufferedEmitter=v;class f{constructor(o){this.data=o,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let o=0,c=this.a;for(;c;)c=c.next,o++;return o}peek(){return this.a?this.a.data:null}toArray(){const o=[];let c=0,a=this.a;for(;a;)o[c++]=a.data,a=a.next;return o}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(o){const c=new f(o);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const o=Date.now();for(let c=0;c<s.a;c++)this.c[c]=o-1e3*c;setInterval(()=>{for(let c=s.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const o=Date.now(),c=(1+s.a)*1e3;let a=0;for(let u=0;u<s.a;u++)o-this.c[u]<=c&&a++;return 1-a/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;class t{get unacknowledgedCount(){return this.c-this.d}constructor(o,c=null,a=s.getInstance()){this.t=new v,this.onControlMessage=this.t.event,this.u=new v,this.onMessage=this.u.event,this.v=new v,this.onDidDispose=this.v.event,this.w=new v,this.onSocketClose=this.w.event,this.x=new v,this.onSocketTimeout=this.x.event,this.s=a,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=o,this.p=new l(this.o),this.r.push(this.p),this.q=new y(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(u=>this.y(u))),this.r.push(this.o.onClose(u=>this.w.fire(u))),c&&this.q.acceptChunk(c),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,D.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const o=new g(5,0,0,C());this.p.write(o),this.p.flush()}sendPause(){const o=new g(7,0,0,C());this.p.write(o)}sendResume(){const o=new g(8,0,0,C());this.p.write(o)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(o,c){this.a=!0,this.r=(0,D.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=o,this.p=new l(this.o),this.r.push(this.p),this.q=new y(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(a=>this.y(a))),this.r.push(this.o.onClose(a=>this.w.fire(a))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const o=new g(3,0,this.h,C());this.p.write(o);const c=this.b.toArray();for(let a=0,u=c.length;a<u;a++)this.p.write(c[a]);this.A()}acceptDisconnect(){this.v.fire()}y(o){if(o.ack>this.d){this.d=o.ack;do{const c=this.b.peek();if(c&&c.id<=o.ack)this.b.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this.g)if(o.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new g(6,0,0,C())))}else this.g=o.id,this.j=Date.now(),this.z(),this.u.fire(o.data);break}case 2:{this.t.fire(o.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const c=this.b.toArray();for(let a=0,u=c.length;a<u;a++)this.p.write(c[a]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(o){const c=++this.c;this.h=this.g;const a=new g(1,c,this.h,o);this.b.push(a),this.a||(this.p.write(a),this.A())}sendControl(o){const c=new g(2,0,0,o);this.p.write(c)}z(){if(this.g<=this.h||this.k)return;const o=Date.now()-this.j;if(o>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-o+5)}A(){if(this.c<=this.d||this.f||this.a)return;const o=this.b.peek(),c=Date.now()-o.writtenTime,a=Date.now()-this.q.lastReadTime,u=Date.now()-this.n;if(c>=2e4&&a>=2e4&&u>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:a});return}const b=Math.max(2e4-c,2e4-a,2e4-u,500);this.f=setTimeout(()=>{this.f=null,this.A()},b)}B(){if(this.g<=this.h)return;this.h=this.g;const o=new g(3,0,this.h,C());this.p.write(o)}C(){const o=new g(9,0,0,C());this.p.write(o)}}e.PersistentProtocol=t}),define(oe[148],ae([0,1,93,3,39,147]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class O extends D.IPCServer{static b(){const P=i.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(S,C)=>C);return i.Event.map(P,S=>{const{port1:C,port2:E}=new MessageChannel,p={protocol:new A.Protocol(C),onDidClientDisconnect:i.Event.fromDOMEventEmitter(C,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[E]),p})}constructor(){super(O.b())}}e.Server=O}),define(oe[68],ae([0,1,49,6,17,24,141,9,3,2,32,91,87,39]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends p.ChannelServer{constructor(l){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",d=>D.VSBuffer.wrap(Buffer.from(d,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=h;class g{constructor(l,d){this.i=l,this.j=d,this.c=new Set,this.g=new Map,this.h=new P.Emitter,this.onDidProcessExit=this.h.event;const m=d&&d.timeout?d.timeout:6e4;this.b=new i.Delayer(m),this.d=null,this.f=null}getChannel(l){const d=this;return{call(m,v,f){return d.k(l,m,v,f)},listen(m,v){return d.l(l,m,v)}}}k(l,d,m,v=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(R.canceled());this.b.cancel();const f=this.n(l),n=(0,i.createCancelablePromise)(r=>f.call(d,m,r)),s=v.onCancellationRequested(()=>n.cancel()),t=(0,S.toDisposable)(()=>n.cancel());return this.c.add(t),n.finally(()=>{s.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(l,d,m){if(!this.b)return P.Event.None;this.b.cancel();let v;const f=new P.Emitter({onWillAddFirstListener:()=>{v=this.n(l).listen(d,m)(f.fire,f),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return f.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,w.removeDangerousEnvVariables)(d.env),this.d=(0,k.fork)(this.i,l,d);const m=new P.Emitter;P.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,O.isRemoteConsoleLog)(o)){(0,O.log)(o,`IPC Library: ${this.j.serverName}`);return}m.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const f=this.j.useQueue?(0,E.createQueuedSender)(this.d):this.d,n=o=>this.d&&this.d.connected&&f.send(o.buffer.toString("base64")),s=m.event,t={send:n,onMessage:s};this.f=new p.ChannelClient(t);const r=()=>this.o();process.once("exit",r),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,c)=>{process.removeListener("exit",r),this.c.forEach(a=>(0,S.dispose)(a)),this.c.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:c})})}return this.f}n(l){let d=this.g.get(l);return d||(d=this.m.getChannel(l),this.g.set(l,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=g}),define(oe[149],ae([0,1,17,9,3,2,12,5,31,39,92]),function(ee,e,k,i,D,A,O,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function E(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class w{traceSocketEvent(a,u){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,u)}constructor(a,u=""){this.f=!0,this.debugLabel=u,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=b=>{if(this.traceSocketEvent("error",{code:b?.code,message:b?.message}),b){if(b.code==="EPIPE")return;(0,i.onUnexpectedError)(b)}},this.socket.on("error",this.a),this.b=b=>{this.traceSocketEvent("close",{hadError:b}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(a){const u=b=>{this.traceSocketEvent("read",b),a(k.VSBuffer.wrap(b))};return this.socket.on("data",u),{dispose:()=>this.socket.off("data",u)}}onClose(a){const u=b=>{a({type:0,hadError:b,error:void 0})};return this.socket.on("close",u),{dispose:()=>this.socket.off("close",u)}}onEnd(a){const u=()=>{a()};return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(a){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,u=>{if(u){if(u.code==="EPIPE")return;(0,i.onUnexpectedError)(u)}})}catch(u){if(u.code==="EPIPE")return;(0,i.onUnexpectedError)(u)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,u)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=w;var p;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var h;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(h||(h={}));class g extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(a,u){this.socket.traceSocketEvent(a,u)}constructor(a,u,b,I){super(),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:u,inflateBytesLength:b?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new y(this,u,b,I,this.f,(F,N)=>this.k(F,N))),this.B(this.a.onError(F=>{console.error(F),(0,i.onUnexpectedError)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new C.ChunkStream,this.B(this.socket.onData(F=>this.l(F))),this.B(this.socket.onClose(F=>this.g.fire(F)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this.f.event(a)}onClose(a){return this.g.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this.a.writeMessage(a)}k(a,u){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let b=2;a.byteLength<126?b+=0:a.byteLength<2**16?b+=2:b+=8;const I=k.VSBuffer.alloc(b);if(u?I.writeUInt8(194,0):I.writeUInt8(130,0),a.byteLength<126)I.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){I.writeUInt8(126,1);let F=1;I.writeUInt8(a.byteLength>>>8&255,++F),I.writeUInt8(a.byteLength>>>0&255,++F)}else{I.writeUInt8(127,1);let F=1;I.writeUInt8(0,++F),I.writeUInt8(0,++F),I.writeUInt8(0,++F),I.writeUInt8(0,++F),I.writeUInt8(a.byteLength>>>24&255,++F),I.writeUInt8(a.byteLength>>>16&255,++F),I.writeUInt8(a.byteLength>>>8&255,++F),I.writeUInt8(a.byteLength>>>0&255,++F)}this.socket.write(k.VSBuffer.concat([I,a]))}end(){this.h=!0,this.socket.end()}l(a){if(a.byteLength!==0){for(this.b.acceptChunk(a);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const u=this.b.peek(this.j.readLen),b=u.readUInt8(0),I=(b&128)>>>7,F=(b&64)>>>6,N=u.readUInt8(1),$=(N&128)>>>7,j=N&127;this.j.state=2,this.j.readLen=2+($?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(F)),this.j.firstFrameOfMessage=Boolean(I),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const u=this.b.read(this.j.readLen),b=u.readUInt8(1),I=(b&128)>>>7;let F=b&127,N=1;F===126?F=u.readUInt8(++N)*2**8+u.readUInt8(++N):F===127&&(F=u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*2**24+u.readUInt8(++N)*2**16+u.readUInt8(++N)*2**8+u.readUInt8(++N));let $=0;I&&($=u.readUInt8(++N)*2**24+u.readUInt8(++N)*2**16+u.readUInt8(++N)*2**8+u.readUInt8(++N)),this.j.state=3,this.j.readLen=F,this.j.mask=$,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const u=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",u),m(u,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",u),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(u,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await D.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class y extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(a,u,b,I,F,N){super(),this.k=a,this.l=F,this.m=N,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new D.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,u?(this.b=this.B(new l(this.k,I,b,{windowBits:15})),this.f=this.B(new d(this.k,{windowBits:15})),this.B(this.b.onError($=>this.a.fire($))),this.B(this.f.onError($=>this.a.fire($)))):(this.b=null,this.f=null)}writeMessage(a){this.g.push(a),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const a=this.g.shift();if(this.f){const u=await this.r(this.f,a);this.m(u,!0)}else this.m(a,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(a,u){return new Promise((b,I)=>{a.write(u),a.flush(F=>b(F))})}acceptFrame(a,u,b){this.h.push({data:a,isCompressed:u,isLastFrameOfMessage:b}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const a=this.h.shift();if(this.b&&a.isCompressed){const u=await this.u(this.b,a.data,a.isLastFrameOfMessage);this.l.fire(u)}else this.l.fire(a.data)}this.s=!1}}u(a,u,b){return new Promise((I,F)=>{a.write(u),b&&a.write(k.VSBuffer.fromByteArray([0,0,255,255])),a.flush(N=>I(N))})}}class l extends A.Disposable{get recordedInflateBytes(){return this.j?k.VSBuffer.concat(this.f):k.VSBuffer.alloc(0)}constructor(a,u,b,I){super(),this.h=a,this.j=u,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=E().zlib.createInflateRaw(I),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(k.VSBuffer.wrap(F))}),b&&(this.h.traceSocketEvent("zlibInflateInitialWrite",b.buffer),this.b.write(b.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(a){this.j&&this.f.push(a.clone()),this.h.traceSocketEvent("zlibInflateWrite",a),this.b.write(a.buffer)}flush(a){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const u=k.VSBuffer.concat(this.g);this.g.length=0,a(u)})}}class d extends A.Disposable{constructor(a,u){super(),this.g=a,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.b=E().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",b=>{this.g.traceSocketEvent("zlibDeflateError",{message:b?.message,code:b?.code}),this.a.fire(b)}),this.b.on("data",b=>{this.g.traceSocketEvent("zlibDeflateData",b),this.f.push(k.VSBuffer.wrap(b))})}write(a){this.g.traceSocketEvent("zlibDeflateWrite",a.buffer),this.b.write(a.buffer)}flush(a){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let u=k.VSBuffer.concat(this.f);this.f.length=0,u=u.slice(0,u.byteLength-4),a(u)})}}function m(c,a){if(a===0)return;const u=c.byteLength>>>2;for(let j=0;j<u;j++){const L=c.readUInt32BE(j*4);c.writeUInt32BE(L^a,j*4)}const b=u*4,I=c.byteLength-b,F=a>>>24&255,N=a>>>16&255,$=a>>>8&255;I>=1&&c.writeUInt8(c.readUInt8(b)^F,b),I>=2&&c.writeUInt8(c.readUInt8(b+1)^N,b+1),I>=3&&c.writeUInt8(c.readUInt8(b+2)^$,b+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const v={[2]:107,[1]:103};function f(){const c=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,O.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):a=(0,O.join)(E().os.tmpdir(),`vscode-ipc-${c}.sock`),s(a),a}e.createRandomIPCHandle=f;function n(c,a,u){const b=E().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${u}-${a}-sock`;let I;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?I=(0,O.join)(e.XDG_RUNTIME_DIR,`vscode-${b.substr(0,8)}-${u}-${a}.sock`):I=(0,O.join)(c,`${u}-${a}.sock`),s(I),I}e.createStaticIPCHandle=n;function s(c){const a=v[R.platform];typeof a=="number"&&c.length>=a&&console.warn(`WARNING: IPC handle "${c}" is longer than ${a} chars, try a shorter --user-data-dir`)}class t extends S.IPCServer{static b(a){const u=D.Event.fromNodeEventEmitter(a,"connection");return D.Event.map(u,b=>({protocol:new C.Protocol(new w(b,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(b,"close"))}))}constructor(a){super(t.b(a)),this.d=a}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function r(c){return new Promise((a,u)=>{const b=E().net.createServer();b.on("error",u),b.listen(c,()=>{b.removeListener("error",u),a(new t(b))})})}e.serve=r;function o(c,a){return new Promise((u,b)=>{const I=E().net.createConnection(c,()=>{I.removeListener("error",b),u(C.Client.fromSocket(new w(I,`ipc-client${a}`),a))});I.once("error",b)})}e.connect=o}),define(oe[69],ae([0,1,6,3,2,13]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var O;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",E[E.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O=e.StorageHint||(e.StorageHint={}));function R(E){const w=E;return w?.changed instanceof Map||w?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var P;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(P=e.StorageState||(e.StorageState={}));class S extends D.Disposable{constructor(w,p=Object.create(null)){super(),this.m=w,this.n=p,this.b=this.B(new i.Emitter),this.onDidChangeStorage=this.b.event,this.c=P.None,this.f=new Map,this.g=new k.ThrottledDelayer(S.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(w=>this.r(w)))}r(w){w.changed?.forEach((p,h)=>this.s(h,p)),w.deleted?.forEach(p=>this.s(p,void 0))}s(w,p){if(this.c===P.Closed)return;let h=!1;(0,A.isUndefinedOrNull)(p)?h=this.f.delete(w):this.f.get(w)!==p&&(this.f.set(w,p),h=!0),h&&this.b.fire(w)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===P.None&&(this.c=P.Initialized,this.n.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(w,p){const h=this.f.get(w);return(0,A.isUndefinedOrNull)(h)?p:h}getBoolean(w,p){const h=this.get(w);return(0,A.isUndefinedOrNull)(h)?p:h==="true"}getNumber(w,p){const h=this.get(w);return(0,A.isUndefinedOrNull)(h)?p:parseInt(h,10)}async set(w,p){if(this.c===P.Closed)return;if((0,A.isUndefinedOrNull)(p))return this.delete(w);const h=String(p);if(this.f.get(w)!==h)return this.f.set(w,h),this.j.set(w,h),this.h.delete(w),this.b.fire(w),this.w()}async delete(w){if(!(this.c===P.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire(w),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=P.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(w).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(w){if(!!this.u)return this.w(w)}async w(w){return this.g.trigger(()=>this.v(),w)}async whenFlushed(){if(!!this.u)return new Promise(w=>this.l.push(w))}isInMemory(){return this.n.hint===O.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=S,S.a=100;class C{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((p,h)=>this.a.set(h,p)),w.delete?.forEach(p=>this.a.delete(p))}async close(){}}e.InMemoryStorageDatabase=C}),define(oe[150],ae([10,11]),function(ee,e){return ee.create("vs/base/node/zip",e)}),define(oe[151],ae([10,11]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[152],ae([10,11]),function(ee,e){return ee.create("vs/platform/environment/node/argv",e)}),define(oe[153],ae([10,11]),function(ee,e){return ee.create("vs/platform/environment/node/argvHelper",e)}),define(oe[154],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[155],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[156],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[157],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[158],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(oe[159],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[160],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[161],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[162],ae([10,11]),function(ee,e){return ee.create("vs/platform/files/common/fileService",e)}),define(oe[163],ae([10,11]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(oe[164],ae([10,11]),function(ee,e){return ee.create("vs/platform/files/common/io",e)}),define(oe[165],ae([10,11]),function(ee,e){return ee.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[166],ae([10,11]),function(ee,e){return ee.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[167],ae([10,11]),function(ee,e){return ee.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(oe[168],ae([10,11]),function(ee,e){return ee.create("vs/platform/request/common/request",e)}),define(oe[169],ae([10,11]),function(ee,e){return ee.create("vs/platform/shell/node/shellEnv",e)}),define(oe[170],ae([10,11]),function(ee,e){return ee.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[171],ae([10,11]),function(ee,e){return ee.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[172],ae([10,11]),function(ee,e){return ee.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[173],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[174],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[175],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[176],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[177],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[178],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[179],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[180],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[181],ae([10,11]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(oe[94],ae([0,1,65,63,21,12,36,22,7]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,A.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return P.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.b.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return P.URI.file((0,A.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(P.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=O.env.VSCODE_PORTABLE;return h?P.URI.file((0,A.join)(h,"argv.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.resolve)(h):(0,A.normalize)((0,A.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?P.URI.file((0,A.resolve)(h)):P.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.resolve)(h);const g=O.env.VSCODE_EXTENSIONS;if(g)return g;const y=O.env.VSCODE_PORTABLE;return y?(0,A.join)(y,"extensions"):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(g=>/^[^:/?#]+?:\/\//.test(g)?P.URI.parse(g):P.URI.file((0,A.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?P.URI.parse(h):P.URI.file((0,A.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const g of this.args.log||[]){const y=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(g);y&&y[1]&&y[2]&&h.push([y[1],y[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return P.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=O.env.VSCODE_PORTABLE;return h?P.URI.file((0,A.join)(h,"policy.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,g,y){this.a=h,this.b=g,this.c=y,this.editSessionId=this.args.editSessionId}}pe([i.memoize],S.prototype,"appRoot",null),pe([i.memoize],S.prototype,"userHome",null),pe([i.memoize],S.prototype,"userDataPath",null),pe([i.memoize],S.prototype,"appSettingsHome",null),pe([i.memoize],S.prototype,"tmpDir",null),pe([i.memoize],S.prototype,"cacheHome",null),pe([i.memoize],S.prototype,"stateResource",null),pe([i.memoize],S.prototype,"userRoamingDataHome",null),pe([i.memoize],S.prototype,"userDataSyncHome",null),pe([i.memoize],S.prototype,"userDataSyncLogResource",null),pe([i.memoize],S.prototype,"editSessionsLogResource",null),pe([i.memoize],S.prototype,"sync",null),pe([i.memoize],S.prototype,"machineSettingsResource",null),pe([i.memoize],S.prototype,"workspaceStorageHome",null),pe([i.memoize],S.prototype,"localHistoryHome",null),pe([i.memoize],S.prototype,"keyboardLayoutResource",null),pe([i.memoize],S.prototype,"argvResource",null),pe([i.memoize],S.prototype,"isExtensionDevelopment",null),pe([i.memoize],S.prototype,"untitledWorkspacesHome",null),pe([i.memoize],S.prototype,"installSourcePath",null),pe([i.memoize],S.prototype,"builtinExtensionsPath",null),pe([i.memoize],S.prototype,"extensionsPath",null),pe([i.memoize],S.prototype,"extensionDevelopmentLocationURI",null),pe([i.memoize],S.prototype,"extensionDevelopmentKind",null),pe([i.memoize],S.prototype,"extensionTestsLocationURI",null),pe([i.memoize],S.prototype,"debugExtensionHost",null),pe([i.memoize],S.prototype,"logLevel",null),pe([i.memoize],S.prototype,"extensionLogLevel",null),pe([i.memoize],S.prototype,"serviceMachineIdResource",null),pe([i.memoize],S.prototype,"telemetryLogResource",null),pe([i.memoize],S.prototype,"disableWorkspaceTrust",null),pe([i.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function C(p,h){return w(p["inspect-extensions"],p["inspect-brk-extensions"],5870,h,p.debugId,p.extensionEnvironment)}e.parseExtensionHostPort=C;function E(p,h){return w(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,h,p.extensionEnvironment)}e.parsePtyHostPort=E;function w(p,h,g,y,l,d){const v=Number(h||p)||(y?null:g),f=v?Boolean(!!h):!1;let n;if(d)try{n=JSON.parse(d)}catch{}return{port:v,break:f,debugId:l,env:n}}}),define(oe[182],ae([0,1,283,5,152]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,D.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},category:{type:"string",cat:"e",description:(0,D.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,D.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,D.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const O={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(g,y,l=O){const d=g.find(c=>c.length>0&&c[0]!=="-"),m={},v=["_"],f=[],n={};let s;for(const c in y){const a=y[c];a.type==="subcommand"?c===d&&(s=a):(a.alias&&(m[c]=a.alias),a.type==="string"||a.type==="string[]"?(v.push(c),a.deprecates&&v.push(...a.deprecates)):a.type==="boolean"&&(f.push(c),a.deprecates&&f.push(...a.deprecates)),a.global&&(n[c]=a))}if(s&&d){const c=n;for(const I in s.options)c[I]=s.options[I];const a=g.filter(I=>I!==d),u=l.getSubcommandReporter?l.getSubcommandReporter(d):void 0,b=R(a,c,u);return{[d]:b,_:[]}}const t=k(g,{string:v,boolean:f,alias:m}),r={},o=t;r._=t._.map(c=>String(c)).filter(c=>c.length>0),delete o._;for(const c in y){const a=y[c];if(a.type==="subcommand")continue;a.alias&&delete o[a.alias];let u=o[c];if(a.deprecates)for(const b of a.deprecates)o.hasOwnProperty(b)&&(u||(u=o[b],u&&l.onDeprecatedOption(b,a.deprecationMessage||(0,D.localize)(36,null,c))),delete o[b]);if(typeof u<"u"){if(a.type==="string[]"){if(Array.isArray(u)||(u=[u]),!a.allowEmptyValue){const b=u.filter(I=>I.length>0);b.length!==u.length&&(l.onEmptyValue(c),u=b.length>0?b:void 0)}}else a.type==="string"&&(Array.isArray(u)?(u=u.pop(),l.onMultipleValues(c,u)):!u&&!a.allowEmptyValue&&(l.onEmptyValue(c),u=void 0));r[c]=u,a.deprecationMessage&&l.onDeprecatedOption(c,a.deprecationMessage)}delete o[c]}for(const c in o)l.onUnknownOption(c);return r}e.parseArgs=R;function P(g,y){let l="";return y.args&&(Array.isArray(y.args)?l=` <${y.args.join("> <")}>`:l=` <${y.args}>`),y.alias?`-${y.alias} --${g}${l}`:`--${g}${l}`}function S(g,y){const l=[];for(const d in g){const m=g[d],v=P(d,m);l.push([v,m.description])}return C(l,y)}e.formatOptions=S;function C(g,y){const d=g.reduce((f,n)=>Math.max(f,n[0].length),12)+2+1;if(y-d<25)return g.reduce((f,n)=>f.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const m=y-d-1,v=[];for(const f of g){const n=f[0],s=w(f[1],m),t=E(d-n.length-2);v.push("  "+n+t+s[0]);for(let r=1;r<s.length;r++)v.push(E(d)+s[r])}return v}function E(g){return" ".repeat(g)}function w(g,y){const l=[];for(;g.length;){const d=g.length<y?g.length:g.lastIndexOf(" ",y),m=g.slice(0,d).trim();g=g.slice(d),l.push(m)}return l}function p(g,y,l,d,m){const v=process.stdout.isTTY&&process.stdout.columns||80,f=m?.noInputFiles!==!0?`[${(0,D.localize)(37,null)}...]`:"",n=[`${g} ${l}`];n.push(""),n.push(`${(0,D.localize)(38,null)}: ${y} [${(0,D.localize)(39,null)}]${f}`),n.push(""),m?.noPipe!==!0&&(i.isWindows?n.push((0,D.localize)(40,null,y)):n.push((0,D.localize)(41,null,y)),n.push(""));const s={},t=[];for(const r in d){const o=d[r];if(o.type==="subcommand")o.description&&t.push({command:r,description:o.description});else if(o.description&&o.cat){let c=s[o.cat];c||(s[o.cat]=c={}),c[r]=o}}for(const r in s){const o=r,c=s[o];c&&(n.push(A[o]),n.push(...S(c,v)),n.push(""))}return t.length&&(n.push((0,D.localize)(42,null)),n.push(...C(t.map(r=>[r.command,r.description]),v)),n.push("")),n.join(`
`)}e.buildHelpMessage=p;function h(g,y){return`${g||(0,D.localize)(43,null)}
${y||(0,D.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=h}),define(oe[183],ae([0,1,284,153,182]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const A=2048;function O(w,p){const h=(v,f)=>{console.warn((0,i.localize)(0,null,v,f))},g=v=>{console.warn((0,i.localize)(1,null,v))},y=(v,f)=>{console.warn((0,i.localize)(2,null,v,f))},l=v=>({onUnknownOption:f=>{v!=="tunnel"&&console.warn((0,i.localize)(3,null,f,v))},onMultipleValues:h,onEmptyValue:g,onDeprecatedOption:y,getSubcommandReporter:v!=="tunnel"?l:void 0}),d={onUnknownOption:v=>{console.warn((0,i.localize)(4,null,v))},onMultipleValues:h,onEmptyValue:g,onDeprecatedOption:y,getSubcommandReporter:l},m=(0,D.parseArgs)(w,D.OPTIONS,p?d:void 0);return m.goto&&m._.forEach(v=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,i.localize)(5,null))),m["max-memory"]&&k(parseInt(m["max-memory"])>=A,`The max-memory argument cannot be specified lower than ${A} MB.`),m}function R(w){const p=w.findIndex(h=>!/^-/.test(h));if(p>-1)return[...w.slice(0,p),...w.slice(p+1)]}function P(w){let[,...p]=w;process.env.VSCODE_DEV&&(p=R(p)||[]);const h=!E(process.env);return O(p,h)}e.parseMainProcessArgv=P;function S(w){let[,,...p]=w;return process.env.VSCODE_DEV&&(p=R(p)||[]),O(p,!0)}e.parseCLIProcessArgv=S;function C(w,...p){const h=w.indexOf("--");return h===-1?w.push(...p):w.splice(h,0,...p),w}e.addArg=C;function E(w){return w.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function ee(e,k,i){function D(O,R){const P=A(O,R),S=[P];return e.isAbsolute(P)||S.unshift(i),e.resolve(...S)}function A(O,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,R);const C=O["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(E,"AppData","Roaming")}break;case"darwin":S=e.join(k.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,R)}return{getUserDataPath:D}}if(typeof define=="function")define(oe[184],ae([285,34,36]),function(e,k,i){return ee(e,k,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=ee(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[185],ae([0,1,34,94,184]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends i.AbstractNativeEnvironmentService{constructor(R,P){super(R,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,D.getUserDataPath)(R,P.nameShort)},P)}}e.NativeEnvironmentService=A}),define(oe[186],ae([0,1,7]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,O=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,P=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(y){const l=y.match(O);return l?l[1]:null}function C(y){if(y.indexOf("://")===-1){const l=y.match(i);return l?S(l[2]):null}try{const l=k.URI.parse(y);if(l.authority)return S(l.authority)}catch{}return null}function E(y,l){const d=new Set;let m;for(;m=R.exec(y);){const f=C(m[1]);f&&d.add(f)}const v=new Set(l);return Array.from(d).map(f=>v.has(f)?f:f.replace(P,"a"))}e.getDomainsOfRemotes=E;function w(y){const l=y.match(A);return l?l[2]:null}function p(y,l,d){return y&&l?(d&&l.endsWith(".git")&&(l=l.substr(0,l.length-4)),l.indexOf("/")===0?`${y}${l}`:`${y}/${l}`):null}function h(y,l){if(y.indexOf("://")===-1){const d=y.match(D);if(d)return p(d[2],d[3],l)}try{const d=k.URI.parse(y);if(d.authority)return p(w(d.authority),d.path,l)}catch{}return null}function g(y,l=!1){const d=[];let m;for(;m=R.exec(y);){const v=h(m[1],l);v&&d.push(v)}return d}e.getRemotes=g}),define(oe[187],ae([0,1,13,156]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(O,R,P){try{A(O,R,P)}catch(S){console.error(S?.message??S)}return O}e.localizeManifest=D;function A(O,R,P){const S=(C,E,w)=>{const p=C[E];if((0,k.isString)(p)){const h=p,g=h.length;if(g>1&&h[0]==="%"&&h[g-1]==="%"){const y=h.substr(1,g-2);let l=R[y];l===void 0&&P&&(l=P[y]);const d=typeof l=="string"?l:l?.message,m=P?.[y],v=typeof m=="string"?m:m?.message;if(!d){v||console.warn(`[${O.name}]: ${(0,i.localize)(0,null,y)}`);return}if(w&&(E==="title"||E==="category")&&v&&v!==d){const f={value:d,original:v};C[E]=f}else C[E]=d}}else if((0,k.isObject)(p))for(const h in p)p.hasOwnProperty(h)&&(h==="commands"?S(p,h,!0):S(p,h,w));else if(Array.isArray(p))for(let h=0;h<p.length;h++)S(p,h,w)};for(const C in O)O.hasOwnProperty(C)&&S(O,C)}}),define(oe[188],ae([0,1,9]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class i{constructor(){this.a=new Map}register(A,O){this.a.set(A,O)}updateManifest(A){if(!(typeof A.main>"u"&&typeof A.browser>"u")&&(A.activationEvents===void 0&&Object.assign(A,{activationEvents:[]}),!(!Array.isArray(A.activationEvents)||!A.contributes)))for(const O in A.contributes){const R=this.a.get(O);if(!R)continue;const P=A.contributes[O],S=Array.isArray(P)?P:[P];try{R(S,A.activationEvents)}catch(C){(0,k.onUnexpectedError)(C)}}}}e.ImplicitActivationEventsImpl=i,e.ImplicitActivationEvents=new i}),define(oe[189],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,O,R,P){return this.a.call("promptImportantExtensionsInstallNotification",[A,O,R,P])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class i{constructor(A){this.a=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${O}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(oe[70],ae([0,1,22,88,161,53]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function P(l){return l=l.trim(),l==="*"||O.test(l)}e.isValidVersionStr=P;function S(l){if(!P(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=l.match(O);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=S;function C(l){if(!l)return null;const d=l.majorBase,m=l.majorMustEqual,v=l.minorBase;let f=l.minorMustEqual;const n=l.patchBase;let s=l.patchMustEqual;l.hasCaret&&(d===0||(f=!1),s=!1);let t=0;if(l.preRelease){const r=R.exec(l.preRelease);if(r){const[,o,c,a]=r;t=Date.UTC(Number(o),Number(c)-1,Number(a))}}return{majorBase:d,majorMustEqual:m,minorBase:v,minorMustEqual:f,patchBase:n,patchMustEqual:s,isMinimum:l.hasGreaterEquals,notBefore:t}}e.normalizeVersion=C;function E(l,d,m){let v;typeof l=="string"?v=C(S(l)):v=l;let f;d instanceof Date?f=d.getTime():typeof d=="string"&&(f=new Date(d).getTime());let n;if(typeof m=="string"?n=C(S(m)):n=m,!v||!n)return!1;const s=v.majorBase,t=v.minorBase,r=v.patchBase;let o=n.majorBase,c=n.minorBase,a=n.patchBase;const u=n.notBefore;let b=n.majorMustEqual,I=n.minorMustEqual,F=n.patchMustEqual;return n.isMinimum?s>o?!0:s<o?!1:t>c?!0:t<c||f&&f<u?!1:r>=a:(s===1&&o===0&&(!b||!I||!F)&&(o=1,c=0,a=0,b=!0,I=!1,F=!1),s<o?!1:s>o?!b:t<c?!1:t>c?!I:r<a?!1:r>a?!F:!(f&&f<u))}e.isValidVersion=E;function w(l,d,m,v,f){const n=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return n.push([i.default.Error,D.localize(0,null)]),n;if(typeof v.name!="string")return n.push([i.default.Error,D.localize(1,null,"name")]),n;if(typeof v.version!="string")return n.push([i.default.Error,D.localize(2,null,"version")]),n;if(!v.engines)return n.push([i.default.Error,D.localize(3,null,"engines")]),n;if(typeof v.engines.vscode!="string")return n.push([i.default.Error,D.localize(4,null,"engines.vscode")]),n;if(typeof v.extensionDependencies<"u"&&!y(v.extensionDependencies))return n.push([i.default.Error,D.localize(5,null,"extensionDependencies")]),n;if(typeof v.activationEvents<"u"){if(!y(v.activationEvents))return n.push([i.default.Error,D.localize(6,null,"activationEvents")]),n;if(typeof v.main>"u"&&typeof v.browser>"u")return n.push([i.default.Error,D.localize(7,null,"activationEvents","main")]),n}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&n.push([i.default.Warning,D.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return n.push([i.default.Error,D.localize(9,null,"main")]),n;{const r=(0,k.joinPath)(m,v.main);(0,k.isEqualOrParent)(r,m)||n.push([i.default.Warning,D.localize(10,null,r.path,m.path)])}if(typeof v.activationEvents>"u")return n.push([i.default.Error,D.localize(11,null,"activationEvents","main")]),n}if(typeof v.browser<"u"){if(typeof v.browser!="string")return n.push([i.default.Error,D.localize(12,null,"browser")]),n;{const r=(0,k.joinPath)(m,v.browser);(0,k.isEqualOrParent)(r,m)||n.push([i.default.Warning,D.localize(13,null,r.path,m.path)])}if(typeof v.activationEvents>"u")return n.push([i.default.Error,D.localize(14,null,"activationEvents","browser")]),n}if(!A.valid(v.version))return n.push([i.default.Error,D.localize(15,null)]),n;const s=[];if(!p(l,d,v,f,s))for(const r of s)n.push([i.default.Error,r]);return n}e.validateExtensionManifest=w;function p(l,d,m,v,f){return v||typeof m.main>"u"&&typeof m.browser>"u"?!0:g(l,d,m.engines.vscode,f)}e.isValidExtensionVersion=p;function h(l,d,m){return l==="*"||g(d,m,l)}e.isEngineValid=h;function g(l,d,m,v=[]){const f=C(S(m));if(!f)return v.push(D.localize(16,null,m)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return v.push(D.localize(17,null,m)),!1}else if(!f.majorMustEqual)return v.push(D.localize(18,null,m)),!1;return E(l,d,f)?!0:(v.push(D.localize(19,null,l,m)),!1)}function y(l){if(!Array.isArray(l))return!1;for(let d=0,m=l.length;d<m;d++)if(typeof l[d]!="string")return!1;return!0}}),define(oe[45],ae([0,1,17,31]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(A,O,R){let P=R&&R.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const C=(await O.readFile(A.serviceMachineIdResource)).value.toString();P=(0,i.isUUID)(C)?C:null}catch{P=null}if(!P){P=(0,i.generateUuid)();try{await O.writeFile(A.serviceMachineIdResource,k.VSBuffer.fromString(P))}catch{}}return R?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=D}),define(oe[54],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(D,A=[],O=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=k}),define(oe[71],ae([0,1,54]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const i=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function A(R,P,S){P instanceof k.SyncDescriptor||(P=new k.SyncDescriptor(P,[],Boolean(S))),i.push([R,P])}e.registerSingleton=A;function O(){return i}e.getSingletonServiceDescriptors=O}),define(oe[190],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class i{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const R=this.lookupOrInsertNode(A),P=this.lookupOrInsertNode(O);R.outgoing.set(P.key,P),P.incoming.set(R.key,R)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let R=this.a.get(O);return R||(R=new k(O,A),this.a.set(O,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,R]of this.a)A.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const R=new Set([A]),P=this.c(O,R);if(P)return P}}c(A,O){for(const[R,P]of A.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const S=this.c(P,O);if(S)return S;O.delete(R)}}}e.Graph=i}),define(oe[4],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(P){return P[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(k=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function i(O,R,P){R[k.DI_TARGET]===R?R[k.DI_DEPENDENCIES].push({id:O,index:P}):(R[k.DI_DEPENDENCIES]=[{id:O,index:P}],R[k.DI_TARGET]=R)}function D(O){if(k.serviceIds.has(O))return k.serviceIds.get(O);const R=function(P,S,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(R,P,C)};return R.toString=()=>O,k.serviceIds.set(O,R),R}e.createDecorator=D;function A(O){return O}e.refineServiceDecorator=A}),define(oe[191],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(oe[16],ae([0,1,13,7,4]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof i.URI)}e.isConfigurationOverrides=A;function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=O;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function S(l,d){const m=Object.create(null);for(const v in l)C(m,v,l[v],d);return m}e.toValuesTree=S;function C(l,d,m,v){const f=d.split("."),n=f.pop();let s=l;for(let t=0;t<f.length;t++){const r=f[t];let o=s[r];switch(typeof o){case"undefined":o=s[r]=Object.create(null);break;case"object":break;default:v(`Ignoring ${d} as ${f.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}s=o}if(typeof s=="object"&&s!==null)try{s[n]=m}catch{v(`Ignoring ${d} as ${f.join(".")} is ${JSON.stringify(s)}`)}else v(`Ignoring ${d} as ${f.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=C;function E(l,d){const m=d.split(".");w(l,m)}e.removeFromValueTree=E;function w(l,d){const m=d.shift();if(d.length===0){delete l[m];return}if(Object.keys(l).indexOf(m)!==-1){const v=l[m];typeof v=="object"&&!Array.isArray(v)&&(w(v,d),Object.keys(v).length===0&&delete l[m])}}function p(l,d,m){function v(s,t){let r=s;for(const o of t){if(typeof r!="object"||r===null)return;r=r[o]}return r}const f=d.split("."),n=v(l,f);return typeof n>"u"?m:n}e.getConfigurationValue=p;function h(l,d,m){Object.keys(d).forEach(v=>{v!=="__proto__"&&(v in l?k.isObject(l[v])&&k.isObject(d[v])?h(l[v],d[v],m):m&&(l[v]=d[v]):l[v]=d[v])})}e.merge=h;function g(l,d,m){const v=l.inspect(d),f=l.inspect(m);return typeof v.userValue<"u"||typeof v.workspaceValue<"u"||typeof v.workspaceFolderValue<"u"?v.value:typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:v.defaultValue}e.getMigratedSettingValue=g;function y(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(oe[192],ae([0,1,5,27,4]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",k.isMacintosh),A.set("isLinux",k.isLinux),A.set("isWindows",k.isWindows),A.set("isWeb",k.isWeb),A.set("isMacNative",k.isMacintosh&&!k.isWeb),A.set("isEdge",k.isEdge),A.set("isFirefox",k.isFirefox),A.set("isChrome",k.isChrome),A.set("isSafari",k.isSafari);const O=Object.prototype.hasOwnProperty;var R;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return E.INSTANCE}static true(){return w.INSTANCE}static has(L){return p.create(L)}static equals(L,M){return h.create(L,M)}static notEquals(L,M){return l.create(L,M)}static regex(L,M){return t.create(L,M)}static in(L,M){return g.create(L,M)}static notIn(L,M){return y.create(L,M)}static not(L){return d.create(L)}static and(...L){return c.create(L,null,!0)}static or(...L){return a.create(L,null,!0)}static greater(L,M){return v.create(L,M)}static greaterEquals(L,M){return f.create(L,M)}static smaller(L,M){return n.create(L,M)}static smallerEquals(L,M){return s.create(L,M)}static deserialize(L,M=!1){if(!!L)return this.c(L,M)}static c(L,M){const z=L.split("||");return a.create(z.map(G=>this.d(G,M)),null,!0)}static d(L,M){const z=L.split("&&");return c.create(z.map(G=>this.f(G,M)),null,!0)}static f(L,M){if(L=L.trim(),L.indexOf("!=")>=0){const z=L.split("!=");return l.create(z[0].trim(),this.g(z[1],M))}if(L.indexOf("==")>=0){const z=L.split("==");return h.create(z[0].trim(),this.g(z[1],M))}if(L.indexOf("=~")>=0){const z=L.split("=~");return t.create(z[0].trim(),this.h(z[1],M))}if(L.indexOf(" not in ")>=0){const z=L.split(" not in ");return y.create(z[0].trim(),this.g(z[1],M))}if(L.indexOf(" in ")>=0){const z=L.split(" in ");return g.create(z[0].trim(),this.g(z[1],M))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const z=L.split(">=");return f.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const z=L.split(">");return v.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const z=L.split("<=");return s.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const z=L.split("<");return n.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(L)?d.create(L.substr(1).trim()):p.create(L)}static g(L,M){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const z=/^'([^']*)'$/.exec(L);return z?z[1].trim():L}static h(L,M){if((0,i.isFalsyOrWhitespace)(L)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const z=L.indexOf("/"),G=L.lastIndexOf("/");if(z===G||z<0){if(M)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const W=L.slice(z+1,G),_=L[G+1]==="i"?"i":"";try{return new RegExp(W,_)}catch(K){if(M)throw new Error(`bad regexp-value '${L}', parse error: ${K}`);return console.warn(`bad regexp-value '${L}', parse error: ${K}`),null}}}e.ContextKeyExpr=P;function S(j,L){const M=j?j.substituteConstants():void 0,z=L?L.substituteConstants():void 0;return!M&&!z?!0:!M||!z?!1:M.equals(z)}e.expressionsAreEqualWithConstantSubstitution=S;function C(j,L){return j.cmp(L)}class E{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class w{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class p{static create(L,M=null){const z=A.get(L);return typeof z=="boolean"?z?w.INSTANCE:E.INSTANCE:new p(L,M)}constructor(L,M){this.key=L,this.c=M,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=A.get(this.key);return typeof L=="boolean"?L?w.INSTANCE:E.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=d.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=p;class h{static create(L,M,z=null){if(typeof M=="boolean")return M?p.create(L,z):d.create(L,z);const G=A.get(L);return typeof G=="boolean"?M===(G?"true":"false")?w.INSTANCE:E.INSTANCE:new h(L,M,z)}constructor(L,M,z){this.c=L,this.d=M,this.f=z,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:I(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const M=L?"true":"false";return this.d===M?w.INSTANCE:E.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class g{static create(L,M){return new g(L,M)}constructor(L,M){this.d=L,this.f=M,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:I(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const M=L.getValue(this.f),z=L.getValue(this.d);return Array.isArray(M)?M.includes(z):typeof z=="string"&&typeof M=="object"&&M!==null?O.call(M,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=g;class y{static create(L,M){return new y(L,M)}constructor(L,M){this.d=L,this.f=M,this.type=11,this.c=g.create(L,M)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=y;class l{static create(L,M,z=null){if(typeof M=="boolean")return M?d.create(L,z):p.create(L,z);const G=A.get(L);return typeof G=="boolean"?M===(G?"true":"false")?E.INSTANCE:w.INSTANCE:new l(L,M,z)}constructor(L,M,z){this.c=L,this.d=M,this.f=z,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:I(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const M=L?"true":"false";return this.d===M?E.INSTANCE:w.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class d{static create(L,M=null){const z=A.get(L);return typeof z=="boolean"?z?E.INSTANCE:w.INSTANCE:new d(L,M)}constructor(L,M){this.c=L,this.d=M,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:b(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=A.get(this.c);return typeof L=="boolean"?L?E.INSTANCE:w.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.ContextKeyNotExpr=d;function m(j,L){if(typeof j=="string"){const M=parseFloat(j);isNaN(M)||(j=M)}return typeof j=="string"||typeof j=="number"?L(j):E.INSTANCE}class v{static create(L,M,z=null){return m(M,G=>new v(L,G,z))}constructor(L,M,z){this.c=L,this.d=M,this.f=z,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:I(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=v;class f{static create(L,M,z=null){return m(M,G=>new f(L,G,z))}constructor(L,M,z){this.c=L,this.d=M,this.f=z,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:I(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=f;class n{static create(L,M,z=null){return m(M,G=>new n(L,G,z))}constructor(L,M,z){this.c=L,this.d=M,this.f=z,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:I(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class s{static create(L,M,z=null){return m(M,G=>new s(L,G,z))}constructor(L,M,z){this.c=L,this.d=M,this.f=z,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:I(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=s;class t{static create(L,M){return new t(L,M)}constructor(L,M){this.d=L,this.f=M,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const M=this.f?this.f.source:"",z=L.f?L.f.source:"";return M<z?-1:M>z?1:0}equals(L){if(L.type===this.type){const M=this.f?this.f.source:"",z=L.f?L.f.source:"";return this.d===L.d&&M===z}return!1}substituteConstants(){return this}evaluate(L){const M=L.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=r.create(this)),this.c}}e.ContextKeyRegexExpr=t;class r{static create(L){return new r(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(L){return new r(this.c.map(L))}negate(){return this.c}}e.ContextKeyNotRegexExpr=r;function o(j){let L=null;for(let M=0,z=j.length;M<z;M++){const G=j[M].substituteConstants();if(j[M]!==G&&L===null){L=[];for(let W=0;W<M;W++)L[W]=j[W]}L!==null&&(L[M]=G)}return L===null?j:L}class c{static create(L,M,z){return c.d(L,M,z)}constructor(L,M){this.expr=L,this.c=M,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let M=0,z=this.expr.length;M<z;M++){const G=C(this.expr[M],L.expr[M]);if(G!==0)return G}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].equals(L.expr[M]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:c.create(L,this.c,!1)}evaluate(L){for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].evaluate(L))return!1;return!0}static d(L,M,z){const G=[];let W=!1;for(const _ of L)if(!!_){if(_.type===1){W=!0;continue}if(_.type===0)return E.INSTANCE;if(_.type===6){G.push(..._.expr);continue}G.push(_)}if(G.length===0&&W)return w.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(C);for(let _=1;_<G.length;_++)G[_-1].equals(G[_])&&(G.splice(_,1),_--);if(G.length===1)return G[0];for(;G.length>1;){const _=G[G.length-1];if(_.type!==9)break;G.pop();const K=G.pop(),q=G.length===0,V=a.create(_.expr.map(Z=>c.create([Z,K],null,z)),null,q);V&&(G.push(V),G.sort(C))}if(G.length===1)return G[0];if(z){for(let _=0;_<G.length;_++)for(let K=_+1;K<G.length;K++)if(G[_].negate().equals(G[K]))return E.INSTANCE;if(G.length===1)return G[0]}return new c(G,M)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const M of this.expr)L.push(...M.keys());return L}map(L){return new c(this.expr.map(M=>M.map(L)),null)}negate(){if(!this.c){const L=[];for(const M of this.expr)L.push(M.negate());this.c=a.create(L,this,!0)}return this.c}}class a{static create(L,M,z){return a.d(L,M,z)}constructor(L,M){this.expr=L,this.c=M,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let M=0,z=this.expr.length;M<z;M++){const G=C(this.expr[M],L.expr[M]);if(G!==0)return G}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].equals(L.expr[M]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:a.create(L,this.c,!1)}evaluate(L){for(let M=0,z=this.expr.length;M<z;M++)if(this.expr[M].evaluate(L))return!0;return!1}static d(L,M,z){let G=[],W=!1;if(L){for(let _=0,K=L.length;_<K;_++){const q=L[_];if(!!q){if(q.type===0){W=!0;continue}if(q.type===1)return w.INSTANCE;if(q.type===9){G=G.concat(q.expr);continue}G.push(q)}}if(G.length===0&&W)return E.INSTANCE;G.sort(C)}if(G.length!==0){if(G.length===1)return G[0];for(let _=1;_<G.length;_++)G[_-1].equals(G[_])&&(G.splice(_,1),_--);if(G.length===1)return G[0];if(z){for(let _=0;_<G.length;_++)for(let K=_+1;K<G.length;K++)if(G[_].negate().equals(G[K]))return w.INSTANCE;if(G.length===1)return G[0]}return new a(G,M)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const M of this.expr)L.push(...M.keys());return L}map(L){return new a(this.expr.map(M=>M.map(L)),null)}negate(){if(!this.c){const L=[];for(const M of this.expr)L.push(M.negate());for(;L.length>1;){const M=L.shift(),z=L.shift(),G=[];for(const W of $(M))for(const _ of $(z))G.push(c.create([W,_],null,!1));L.unshift(a.create(G,null,!1))}this.c=a.create(L,this,!0)}return this.c}}class u extends p{static all(){return u.d.values()}constructor(L,M,z){super(L,null),this.f=M,typeof z=="object"?u.d.push({...z,key:L}):z!==!0&&u.d.push({key:L,description:z,type:M!=null?typeof M:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return h.create(this.key,L)}notEqualsTo(L){return l.create(this.key,L)}}e.RawContextKey=u,u.d=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function b(j,L){return j<L?-1:j>L?1:0}function I(j,L,M,z){return j<M?-1:j>M?1:L<z?-1:L>z?1:0}function F(j,L){if(j.type===0||L.type===1)return!0;if(j.type===9)return L.type===9?N(j.expr,L.expr):!1;if(L.type===9){for(const M of L.expr)if(F(j,M))return!0;return!1}if(j.type===6){if(L.type===6)return N(L.expr,j.expr);for(const M of j.expr)if(F(M,L))return!0;return!1}return j.equals(L)}e.implies=F;function N(j,L){let M=0,z=0;for(;M<j.length&&z<L.length;){const G=j[M].cmp(L[z]);if(G<0)return!1;G===0&&M++,z++}return M===j.length}function $(j){return j.type===9?j.expr:[j]}}),define(oe[95],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function i(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=i;class D{async getPerformanceInfo(O,R){return{}}async getSystemInfo(O,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,R){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.NullDiagnosticsService=D}),define(oe[96],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(oe[15],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[29],ae([0,1,155,4]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function A(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function O(l,d){switch(l){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function R(l,d){return d==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function P(l,d,m){return R(d,m)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===m?!0:S(m).includes(l)}e.isTargetPlatformCompatible=P;function S(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function C(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=C;var E;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var w;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(w=e.SortOrder||(e.SortOrder={}));var p;(function(l){l.Install="install",l.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var h;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var g;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(d,m){super(d),this.code=m,this.name=m}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(oe[193],ae([0,1,3,2,67,32,7,142,29]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(y,l){return O.URI.revive(l?l.transformIncoming(y):y)}function C(y,l){return l?l.transformOutgoingURI(y):y}function E(y,l){l=l||R.DefaultURITransformer;const d=y.manifest;return{...(0,R.transformAndReviveIncomingURIs)({...y,manifest:void 0},l),manifest:d}}function w(y,l){return l?(0,A.cloneAndChange)(y,d=>d instanceof O.URI?l.transformOutgoingURI(d):void 0):y}class p{constructor(l,d){this.a=l,this.b=d,this.onInstallExtension=k.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(l.onDidUninstallExtension,!0)}listen(l,d){const m=this.b(l);switch(d){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,v=>v.map(f=>({...f,local:f.local?w(f.local,m):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(l,d,m){const v=this.b(l);switch(d){case"zip":return this.a.zip(E(m[0],v)).then(f=>C(f,v));case"unzip":return this.a.unzip(S(m[0],v));case"install":return this.a.install(S(m[0],v),(0,D.revive)(m[1]));case"installFromLocation":return this.a.installFromLocation(S(m[0],v),O.URI.revive(m[1]));case"getManifest":return this.a.getManifest(S(m[0],v));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(m[0]);case"installFromGallery":return this.a.installFromGallery(m[0],(0,D.revive)(m[1]));case"uninstall":return this.a.uninstall(E(m[0],v),(0,D.revive)(m[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(m[0],v));case"getInstalled":return this.a.getInstalled(m[0],O.URI.revive(m[1])).then(f=>f.map(n=>w(n,v)));case"getMetadata":return this.a.getMetadata(E(m[0],v));case"updateMetadata":return this.a.updateMetadata(E(m[0],v),m[1]).then(f=>w(f,v));case"updateExtensionScope":return this.a.updateExtensionScope(E(m[0],v),m[1]).then(f=>w(f,v));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(m[0],m[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=p;class h extends i.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}constructor(l){super(),this.j=l,this.c=this.B(new k.Emitter),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=this.B(new k.Emitter),this.B(this.j.listen("onInstallExtension")(d=>this.c.fire({identifier:d.identifier,source:this.k(d.source)?O.URI.revive(d.source):d.source,profileLocation:O.URI.revive(d.profileLocation)}))),this.B(this.j.listen("onDidInstallExtensions")(d=>this.f.fire(d.map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.k(m.source)?O.URI.revive(m.source):m.source,profileLocation:O.URI.revive(m.profileLocation)}))))),this.B(this.j.listen("onUninstallExtension")(d=>this.g.fire({identifier:d.identifier,profileLocation:O.URI.revive(d.profileLocation)}))),this.B(this.j.listen("onDidUninstallExtension")(d=>this.h.fire({...d,profileLocation:O.URI.revive(d.profileLocation)})))}k(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.l||(this.l=this.j.call("getTargetPlatform")),this.l}async canInstall(l){const d=await this.getTargetPlatform();return l.allTargetPlatforms.some(m=>(0,P.isTargetPlatformCompatible)(m,l.allTargetPlatforms,d))}zip(l){return Promise.resolve(this.j.call("zip",[l]).then(d=>O.URI.revive(d)))}unzip(l){return Promise.resolve(this.j.call("unzip",[l]))}install(l,d){return Promise.resolve(this.j.call("install",[l,d])).then(m=>E(m,null))}installFromLocation(l,d){return Promise.resolve(this.j.call("installFromLocation",[l,d])).then(m=>E(m,null))}getManifest(l){return Promise.resolve(this.j.call("getManifest",[l]))}installFromGallery(l,d){return Promise.resolve(this.j.call("installFromGallery",[l,d])).then(m=>E(m,null))}uninstall(l,d){return Promise.resolve(this.j.call("uninstall",[l,d]))}reinstallFromGallery(l){return Promise.resolve(this.j.call("reinstallFromGallery",[l]))}getInstalled(l=null,d){return Promise.resolve(this.j.call("getInstalled",[l,d])).then(m=>m.map(v=>E(v,null)))}getMetadata(l){return Promise.resolve(this.j.call("getMetadata",[l]))}updateMetadata(l,d){return Promise.resolve(this.j.call("updateMetadata",[l,d])).then(m=>E(m,null))}updateExtensionScope(l,d){return Promise.resolve(this.j.call("updateExtensionScope",[l,d])).then(m=>E(m,null))}getExtensionsControlManifest(){return Promise.resolve(this.j.call("getExtensionsControlManifest"))}async download(l,d){const m=await this.j.call("download",[l,d]);return O.URI.revive(m)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class g{constructor(l){this.a=l}listen(l,d){throw new Error("Invalid listen")}call(l,d,m){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(O.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(oe[97],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");class i{b(){return this.a||(this.a=new Promise((A,O)=>ee(["node-vsce-sign"],async R=>A(R),O))),this.a}async verify(A,O){let R;try{R=await this.b()}catch{return!1}return R.verify(A,O)}}e.ExtensionSignatureVerificationService=i}),define(oe[98],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function D(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[14],ae([0,1,48,12,27,13,7,163,4]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function S(W){return W.create===!0}e.isFileOpenForWriteOptions=S;var C;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var E;(function(W){W[W.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var w;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=p;function h(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=h;function g(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=g;function y(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function l(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=l;function d(W){return p(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=d;var m;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(_,K){super(_),this.code=K}}e.FileSystemProviderError=v;function f(W,_){const K=new v(W.toString(),_);return s(K,_),K}e.createFileSystemProviderError=f;function n(W){return W||f((0,R.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=n;function s(W,_){return W.name=_?`${_} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=s;function t(W){if(!W)return m.Unknown;if(W instanceof v)return W.code;const _=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!_)return m.Unknown;switch(_[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=t;function r(W){if(W instanceof I)return W.fileOperationResult;switch(t(W)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var o;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class c{constructor(_,K,q){this.resource=_,this.operation=K,this.target=q}isOperation(_){return this.operation===_}}e.FileOperationEvent=c;var a;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class u{constructor(_,K){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=_;const q=new Map;for(const V of _){const Z=q.get(V.type);switch(Z?Z.push([V.resource,V]):q.set(V.type,[[V.resource,V]]),V.type){case 1:this.rawAdded.push(V.resource);break;case 0:this.rawUpdated.push(V.resource);break;case 2:this.rawDeleted.push(V.resource);break}}for(const[V,Z]of q)switch(V){case 1:this.a=k.TernarySearchTree.forUris(()=>K),this.a.fill(Z);break;case 0:this.b=k.TernarySearchTree.forUris(()=>K),this.b.fill(Z);break;case 2:this.c=k.TernarySearchTree.forUris(()=>K),this.c.fill(Z);break}}contains(_,...K){return this.d(_,{includeChildren:!1},...K)}affects(_,...K){return this.d(_,{includeChildren:!0},...K)}d(_,K,...q){if(!_)return!1;const V=q.length>0;return!!((!V||q.includes(1))&&(this.a?.get(_)||K.includeChildren&&this.a?.findSuperstr(_))||(!V||q.includes(0))&&(this.b?.get(_)||K.includeChildren&&this.b?.findSuperstr(_))||(!V||q.includes(2))&&(this.c?.findSubstr(_)||K.includeChildren&&this.c?.findSuperstr(_)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=u;function b(W,_,K){return!W||!_||W===_||_.length>W.length?!1:(_.charAt(_.length-1)!==i.sep&&(_+=i.sep),K?(0,D.startsWithIgnoreCase)(W,_):W.indexOf(_)===0)}e.isParent=b;class I extends Error{constructor(_,K,q){super(_),this.fileOperationResult=K,this.options=q}}e.FileOperationError=I;class F extends I{constructor(_,K,q){super(_,2,q),this.stat=K}}e.NotModifiedSinceFileOperationError=F;var N;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(N=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var $;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})($=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function j(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=j;async function L(W,_){if(!_.hasProvider(O.URI.from({scheme:W.scheme})))return new Promise(K=>{const q=_.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===W.scheme&&V.added&&(q.dispose(),K())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(_){return(0,A.isNumber)(_)||(_=0),_<M.KB?(0,R.localize)(1,null,_.toFixed(0)):_<M.MB?(0,R.localize)(2,null,(_/M.KB).toFixed(2)):_<M.GB?(0,R.localize)(3,null,(_/M.MB).toFixed(2)):_<M.TB?(0,R.localize)(4,null,(_/M.GB).toFixed(2)):(0,R.localize)(5,null,(_/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var z;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function G(W){return{maxFileSize:W===0?300*M.MB:16*M.GB,maxHeapSize:W===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=G});var Y=this&&this.__param||function(ee,e){return function(k,i){e(k,i,ee)}};define(oe[194],ae([0,1,99,44,14]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(R){this.a=R}async checksum(R){const P=(await this.a.readFileStream(R)).value;return new Promise((S,C)=>{const E=(0,k.createHash)("md5");(0,i.listenStream)(P,{onData:w=>E.update(w.buffer),onError:w=>C(w),onEnd:()=>S(E.digest("base64").replace(/=+$/,""))})})}};A=pe([Y(0,D.IFileService)],A),e.ChecksumService=A}),define(oe[195],ae([0,1,17,38,9,3,2,44,7,31,14]),function(ee,e,k,i,D,A,O,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends O.Disposable{constructor(p,h){super(),this.a=p,this.b=h,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,S.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(p){return this.a.call("stat",[p])}readdir(p){return this.a.call("readdir",[p])}async readFile(p,h){const{buffer:g}=await this.a.call("readFile",[p,h]);return g}readFileStream(p,h,g){const y=(0,R.newWriteableStream)(d=>k.VSBuffer.concat(d.map(m=>k.VSBuffer.wrap(m))).buffer),l=this.a.listen("readFileStream",[p,h])(d=>{if(d instanceof k.VSBuffer)y.write(d.buffer);else{if(d==="end")y.end();else{let m=d;m instanceof Error||(m=(0,C.createFileSystemProviderError)((0,i.toErrorMessage)(m),C.FileSystemProviderErrorCode.Unknown)),y.error(m),y.end()}l.dispose()}});return g.onCancellationRequested(()=>{y.error((0,D.canceled)()),y.end(),l.dispose()}),y}writeFile(p,h,g){return this.a.call("writeFile",[p,k.VSBuffer.wrap(h),g])}open(p,h){return this.a.call("open",[p,h])}close(p){return this.a.call("close",[p])}async read(p,h,g,y,l){const[d,m]=await this.a.call("read",[p,h,l]);return g.set(d.buffer.slice(0,m),y),m}write(p,h,g,y,l){return this.a.call("write",[p,h,k.VSBuffer.wrap(g),y,l])}mkdir(p){return this.a.call("mkdir",[p])}delete(p,h){return this.a.call("delete",[p,h])}rename(p,h,g){return this.a.call("rename",[p,h,g])}copy(p,h,g){return this.a.call("copy",[p,h,g])}cloneFile(p,h){return this.a.call("cloneFile",[p,h])}i(){this.B(this.a.listen("fileChange",[this.h])(p=>{if(Array.isArray(p)){const h=p;this.f.fire(h.map(g=>({resource:P.URI.revive(g.resource),type:g.type})))}else{const h=p;this.g.fire(h)}}))}watch(p,h){const g=(0,S.generateUuid)();return this.a.call("watch",[this.h,g,p,h]),(0,O.toDisposable)(()=>this.a.call("unwatch",[this.h,g]))}}e.DiskFileSystemProviderClient=E}),define(oe[100],ae([0,1,17,9,164,14]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(C,E,w,p,h,g){let y;try{await R(C,E,w,p,h,g)}catch(l){y=l}finally{y&&h.errorTransformer&&(y=h.errorTransformer(y)),typeof y<"u"&&w.error(y),w.end()}}e.readFileIntoStream=O;async function R(C,E,w,p,h,g){P(g);const y=await C.open(E,{create:!1});try{P(g);let l=0,d=0,m=h&&typeof h.length=="number"?h.length:void 0,v=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof m=="number"?m:h.bufferSize)),f=h&&typeof h.position=="number"?h.position:0,n=0;do d=await C.read(y,f,v.buffer,n,v.byteLength-n),f+=d,n+=d,l+=d,typeof m=="number"&&(m-=d),n===v.byteLength&&(await w.write(p(v)),v=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof m=="number"?m:h.bufferSize)),n=0);while(d>0&&(typeof m!="number"||m>0)&&P(g)&&S(l,h));if(n>0){let s=n;typeof m=="number"&&(s=Math.min(n,m)),w.write(p(v.slice(0,s)))}}catch(l){throw(0,A.ensureFileSystemProviderError)(l)}finally{await C.close(y)}}function P(C){if(C.isCancellationRequested)throw(0,i.canceled)();return!0}function S(C,E){if(E?.limits){if(typeof E.limits.memory=="number"&&C>E.limits.memory)throw(0,A.createFileSystemProviderError)((0,D.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&C>E.limits.size)throw(0,A.createFileSystemProviderError)((0,D.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(oe[55],ae([0,1,89,2,12,5,7,14]),function(ee,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(l){return l.recursive===!0}e.isRecursiveWatchRequest=P;class S extends i.Disposable{constructor(d,m,v,f){super(),this.h=d,this.i=m,this.j=v,this.k=f,this.c=this.B(new i.MutableDisposable),this.f=void 0,this.g=0}m(){const d=new i.DisposableStore;this.c.value=d,this.b=this.l(d),this.b.setVerboseLogging(this.j),d.add(this.b.onDidChangeFile(m=>this.h(m))),d.add(this.b.onDidLogMessage(m=>this.i(m))),d.add(this.b.onDidError(m=>this.n(m)))}n(d){this.k.restartOnError?this.g<S.a&&this.f?(this.r(`restarting watcher after error: ${d}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${d}`):this.r(d)}p(d){this.g++,this.m(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.j=d,await this.b?.setVerboseLogging(d)}r(d){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.a=5;class C extends S{constructor(d,m,v){super(d,m,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class E extends S{constructor(d,m,v){super(d,m,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function w(l){return l.map(d=>({type:d.type,resource:O.URI.file(d.path)}))}e.toFileChanges=w;function p(l){const d=new y;for(const m of l)d.processEvent(m);return d.coalesce()}e.coalesceEvents=p;function h(l,d){return typeof d=="string"&&!d.startsWith(k.GLOBSTAR)&&!(0,D.isAbsolute)(d)?{base:l,pattern:d}:d}e.normalizeWatcherPattern=h;function g(l,d){const m=[];for(const v of d)m.push((0,k.parse)(h(l,v)));return m}e.parseWatcherPatterns=g;class y{constructor(){this.a=new Set,this.b=new Map}c(d){return A.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const m=this.b.get(this.c(d));let v=!1;if(m){const f=m.type,n=d.type;m.path!==d.path&&(d.type===2||d.type===1)?v=!0:f===1&&n===2?(this.b.delete(this.c(d)),this.a.delete(m)):f===2&&n===1?m.type=0:f===1&&n===0||(m.type=n)}else v=!0;v&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],m=[];return Array.from(this.a).filter(v=>v.type!==2?(d.push(v),!1):!0).sort((v,f)=>v.path.length-f.path.length).filter(v=>m.some(f=>(0,R.isParent)(v.path,f,!A.isLinux))?!1:(m.push(v.path),!0)).concat(d)}}}),define(oe[196],ae([0,1,52,6,24,47,2,85,12,5,144,28,55]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class p extends O.Disposable{constructor(y,l,d,m){super(),this.k=y,this.l=l,this.m=d,this.n=m,this.c=new i.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},v=>this.l(v)),this.f=this.B(new i.ThrottledDelayer(p.b)),this.g=[],this.h=(0,w.parseWatcherPatterns)(this.k.path,this.k.excludes),this.i=this.k.includes?(0,w.parseWatcherPatterns)(this.k.path,this.k.includes):void 0,this.j=new D.CancellationTokenSource,this.ready=this.r()}async r(){try{const y=await this.s(this.k);if(this.j.token.isCancellationRequested)return;const l=await E.Promises.stat(y);this.B(await this.t(y,l.isDirectory()))}catch(y){y.code!=="ENOENT"?this.w(y):this.z(y)}}async s(y){let l=y.path;try{l=await E.Promises.realpath(y.path),y.path===l&&(l=await(0,C.realcase)(y.path)??y.path),y.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${l})`)}catch{}return l}async t(y,l){if(S.isMacintosh&&(0,A.isEqualOrParent)(y,"/Volumes/",!0))return this.w(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.Disposable.None;const d=new D.CancellationTokenSource(this.j.token),m=new O.DisposableStore;try{const v=(0,P.basename)(y),f=(0,k.watch)(y);m.add((0,O.toDisposable)(()=>{f.removeAllListeners(),f.close()})),this.z(`Started watching: '${y}'`);const n=new Set;if(l)try{for(const t of await E.Promises.readdir(y))n.add(t)}catch(t){this.w(t)}const s=new Map;m.add((0,O.toDisposable)(()=>{for(const[,t]of s)t.dispose();s.clear()})),f.on("error",(t,r)=>{this.w(`Failed to watch ${y} for changes using fs.watch() (${t}, ${r})`),this.dispose()}),f.on("change",(t,r)=>{if(d.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${r}`);let o="";if(r&&(o=r.toString(),S.isMacintosh&&(o=(0,R.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(l)if(t==="rename"){s.get(o)?.dispose();const c=setTimeout(async()=>{if(s.delete(o),o===v&&!await E.Promises.exists(y)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.v((0,P.join)(y,o));if(d.token.isCancellationRequested)return;let u;a?n.has(o)?u=0:(u=1,n.add(o)):(n.delete(o),u=2),this.u({path:(0,P.join)(this.k.path,o),type:u})},p.a);s.set(o,(0,O.toDisposable)(()=>clearTimeout(c)))}else{let c;n.has(o)?c=0:(c=1,n.add(o)),this.u({path:(0,P.join)(this.k.path,o),type:c})}else if(t==="rename"||o!==v){const c=setTimeout(async()=>{const a=await E.Promises.exists(y);d.token.isCancellationRequested||(a?(this.u({path:this.k.path,type:0},!0),m.add(await this.t(y,!1))):(await this.u({path:this.k.path,type:2},!0),this.dispose()))},p.a);m.clear(),m.add((0,O.toDisposable)(()=>clearTimeout(c)))}else this.u({path:this.k.path,type:0},!0)})}catch(v){await E.Promises.exists(y)&&!d.token.isCancellationRequested&&this.w(`Failed to watch ${y} for changes using fs.watch() (${v.toString()})`)}return(0,O.toDisposable)(()=>{d.dispose(!0),m.dispose()})}async u(y,l=!1){if(!this.j.token.isCancellationRequested){this.n&&this.z(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),!l&&this.h.some(d=>d(y.path))?this.n&&this.z(` >> ignored (excluded) ${y.path}`):!l&&this.i&&this.i.length>0&&!this.i.some(d=>d(y.path))?this.n&&this.z(` >> ignored (not included) ${y.path}`):this.g.push(y);try{await this.f.trigger(async()=>{const d=this.g;this.g=[];const m=(0,w.coalesceEvents)(d);if(m.length>0){if(this.n)for(const f of m)this.z(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.c.work(m)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${m.length}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async v(y){if(S.isLinux)return E.Promises.exists(y);try{const l=(0,P.basename)(y);return(await E.Promises.readdir((0,P.dirname)(y))).some(m=>m===l)}catch(l){return this.z(l),!1}}setVerboseLogging(y){this.n=y}w(y){this.j.token.isCancellationRequested||this.m?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}y(y){this.j.token.isCancellationRequested||this.m?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}z(y){!this.j.token.isCancellationRequested&&this.n&&this.m?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.z(`stopping file watcher on ${this.k.path}`),this.j.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=p,p.a=100,p.b=50;async function h(g,y,l,d,m=512){const v=await E.Promises.open(g,"r"),f=Buffer.allocUnsafe(m),n=new D.CancellationTokenSource(d);let s,t=!1;const r={path:g,excludes:[],recursive:!1},o=new p(r,c=>{(async()=>{for(const{type:a}of c)if(a===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:u}=await E.Promises.read(v,f,0,m,null);if(!u||n.token.isCancellationRequested)break;y(f.slice(0,u))}}catch(u){s=new Error(u),n.dispose(!0)}finally{t=!1}}})()});return await o.ready,l(),new Promise((c,a)=>{n.token.onCancellationRequested(async()=>{o.dispose();try{await E.Promises.close(v)}catch(u){s=new Error(u)}s?a(s):c()})})}e.watchFileContents=h}),define(oe[197],ae([0,1,3,89,2,5,196]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new k.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=k.Event.None,this.c=new Map,this.f=!1}async watch(S){const C=this.i(S),E=C.filter(p=>{const h=this.c.get(p.path);return h?!(0,i.patternsEquals)(h.request.excludes,p.excludes)||!(0,i.patternsEquals)(h.request.includes,p.includes):!0}),w=Array.from(this.c.values()).filter(({request:p})=>!C.find(h=>h.path===p.path&&(0,i.patternsEquals)(h.excludes,p.excludes)&&(0,i.patternsEquals)(h.includes,p.includes))).map(({request:p})=>p.path);E.length&&this.j(`Request to start watching: ${E.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"})`).join(",")}`),w.length&&this.j(`Request to stop watching: ${w.join(",")}`);for(const p of w)this.h(p);for(const p of E)this.g(p)}g(S){const C=new O.NodeJSFileWatcherLibrary(S,w=>this.a.fire(w),w=>this.b.fire(w),this.f),E={request:S,instance:C};this.c.set(S.path,E)}async stop(){for(const[S]of this.c)this.h(S);this.c.clear()}h(S){const C=this.c.get(S);C&&(this.c.delete(S),C.instance.dispose())}i(S){const C=new Map;for(const E of S){const w=A.isLinux?E.path:E.path.toLowerCase();C.set(w,E)}return Array.from(C.values())}async setVerboseLogging(S){this.f=S;for(const[,C]of this.c)C.instance.setVerboseLogging(S)}j(S){this.f&&this.b.fire({type:"trace",message:this.k(S)})}k(S,C){return C?`[File Watcher (node.js)] ${S} (path: ${C.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=R}),define(oe[198],ae([0,1,55,197]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends k.AbstractNonRecursiveWatcherClient{constructor(O,R,P){super(O,R,P),this.m()}l(){return new i.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(oe[199],ae([0,1,21,39,68,55]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class O extends A.AbstractUniversalWatcherClient{constructor(P,S,C){super(P,S,C),this.m()}l(P){const S=P.add(new D.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(S.onDidProcessExit(({code:C,signal:E})=>this.n(`terminated by itself with code ${C}, signal: ${E}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=O}),define(oe[72],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...D){this.a=new Map;for(const[A,O]of D)this.set(A,O)}set(D,A){const O=this.a.get(D);return this.a.set(D,A),O}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=k}),define(oe[200],ae([0,1,6,9,2,54,190,4,72,84]),function(ee,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class E extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class w{constructor(y=new P.ServiceCollection,l=!1,d,m=C){this.f=y,this.g=l,this.h=d,this.i=m,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=m?d?._globalGraph??new O.Graph(v=>v):void 0}createChild(y){return new w(y,this.g,this,this.i)}invokeFunction(y,...l){const d=h.traceInvocation(this.i,y);let m=!1;try{return y({get:f=>{if(m)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(f,d);if(!n)throw new Error(`[invokeFunction] unknown service '${f}'`);return n}},...l)}finally{m=!0,d.stop()}}createInstance(y,...l){let d,m;return y instanceof A.SyncDescriptor?(d=h.traceCreation(this.i,y.ctor),m=this.j(y.ctor,y.staticArguments.concat(l),d)):(d=h.traceCreation(this.i,y),m=this.j(y,l,d)),d.stop(),m}j(y,l=[],d){const m=R._util.getServiceDependencies(y).sort((n,s)=>n.index-s.index),v=[];for(const n of m){const s=this.m(n.id,d);s||this.u(`[createInstance] ${y.name} depends on UNKNOWN service ${n.id}.`,!1),v.push(s)}const f=m.length>0?m[0].index:l.length;if(l.length!==f){console.trace(`[createInstance] First service dependency of ${y.name} at position ${f+1} conflicts with ${l.length} static arguments`);const n=f-l.length;n>0?l=l.concat(new Array(n)):l=l.slice(0,f)}return Reflect.construct(y,l.concat(v))}k(y,l){if(this.f.get(y)instanceof A.SyncDescriptor)this.f.set(y,l);else if(this.h)this.h.k(y,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(y){const l=this.f.get(y);return!l&&this.h?this.h.l(y):l}m(y,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(y));const d=this.l(y);return d instanceof A.SyncDescriptor?this.q(y,d,l.branch(y,!0)):(l.branch(y,!1),d)}q(y,l,d){if(this.o.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this.o.add(y);try{return this.r(y,l,d)}finally{this.o.delete(y)}}r(y,l,d){const m=new O.Graph(n=>n.id.toString());let v=0;const f=[{id:y,desc:l,_trace:d}];for(;f.length;){const n=f.pop();if(m.lookupOrInsertNode(n),v++>1e3)throw new E(m);for(const s of R._util.getServiceDependencies(n.desc.ctor)){const t=this.l(s.id);if(t||this.u(`[createInstance] ${y} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),t instanceof A.SyncDescriptor){const r={id:s.id,desc:t,_trace:n._trace.branch(s.id,!0)};m.insertEdge(n,r),f.push(r)}}}for(;;){const n=m.roots();if(n.length===0){if(!m.isEmpty())throw new E(m);break}for(const{data:s}of n){if(this.l(s.id)instanceof A.SyncDescriptor){const r=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,r)}m.removeNode(s)}}return this.l(y)}s(y,l,d=[],m,v){if(this.f.get(y)instanceof A.SyncDescriptor)return this.t(y,l,d,m,v);if(this.h)return this.h.s(y,l,d,m,v);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(y,l,d=[],m,v){if(m){const f=new w(void 0,this.g,this,this.i);f.c=String(y);const n=new Map,s=new k.IdleValue(()=>{const t=f.j(l,d,v);for(const[r,o]of n){const c=t[r];if(typeof c=="function")for(const a of o)c.apply(t,a)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,r){if(!s.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=n.get(r);return a||(a=new S.LinkedList,n.set(r,a)),(b,I,F)=>{const N=a.push([b,I,F]);return(0,D.toDisposable)(N)}}if(r in t)return t[r];const o=s.value;let c=o[r];return typeof c!="function"||(c=c.bind(o),t[r]=c),c},set(t,r,o){return s.value[r]=o,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,d,v)}u(y,l){if(l&&console.warn(y),this.g)throw new Error(y)}}e.InstantiationService=w;var p;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(p||(p={}));class h{static traceInvocation(y,l){return y?new h(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(y,l){return y?new h(1,l.name):h.c}constructor(y,l){this.type=y,this.name=l,this.g=Date.now(),this.h=[]}branch(y,l){const d=new h(3,y.toString());return this.h.push([y,l,d]),d}stop(){const y=Date.now()-this.g;h.f+=y;let l=!1;function d(v,f){const n=[],s=new Array(v+1).join("	");for(const[t,r,o]of f.h)if(r&&o){l=!0,n.push(`${s}CREATES -> ${t}`);const c=d(v+1,o);c&&n.push(c)}else n.push(`${s}uses -> ${t}`);return n.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(y>2||l)&&h.all.add(m.join(`
`))}}e.Trace=h,h.all=new Set,h.c=new class extends h{constructor(){super(0,null)}stop(){}branch(){return this}},h.f=0}),define(oe[201],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(D,A){this.a=D,this.b=A}getChannel(D){return this.a.getChannel(D,this.b)}registerChannel(D,A){this.a.registerChannel(D,A)}}e.MessagePortMainProcessService=k}),define(oe[56],ae([0,1,39,54,71,4]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class O{constructor(p,h,g,y){const l=g.getChannel(p);return R(h)?y.createInstance(new i.SyncDescriptor(h.channelClientCtor,[l])):k.ProxyChannel.toService(l,h?.proxyOptions)}}function R(w){return!!w?.channelClientCtor}e.IMainProcessService=(0,A.createDecorator)("mainProcessService");let P=class extends O{constructor(p,h,g,y){super(p,h,g,y)}};P=pe([Y(2,e.IMainProcessService),Y(3,A.IInstantiationService)],P);function S(w,p,h){(0,D.registerSingleton)(w,new i.SyncDescriptor(P,[p,h],!0))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=(0,A.createDecorator)("sharedProcessService");let C=class extends O{constructor(p,h,g,y){super(p,h,g,y)}};C=pe([Y(2,e.ISharedProcessService),Y(3,A.IInstantiationService)],C);function E(w,p,h){(0,D.registerSingleton)(w,new i.SyncDescriptor(C,[p,h],!0))}e.registerSharedProcessRemoteService=E}),define(oe[73],ae([0,1,24,2,5,166,29,4]),function(ee,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function P(C){return C.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=P,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let S=class extends i.Disposable{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new k.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const h=w.firstPage.filter(g=>g.properties.localizedLanguages?.length&&g.tags.some(y=>y.startsWith("lp-"))).map(g=>{const y=g.properties.localizedLanguages?.[0],l=P(g);return{...this.f(l,y,g),extensionId:g.identifier.id,galleryExtension:g}});return h.push({...this.f("en","English"),extensionId:"default"}),h}f(E,w,p){const h=w??E;let g;if(h!==E&&(g=`(${E})`),E.toLowerCase()===D.language.toLowerCase()&&(g??="",g+=(0,A.localize)(0,null)),p?.installCount){g??="";const y=p.installCount;let l;y>1e6?l=`${Math.floor(y/1e5)/10}M`:y>1e3?l=`${Math.floor(y/1e3)}K`:l=String(y),g+=` $(cloud-download) ${l}`}return{id:E,label:h,description:g}}};S=pe([Y(0,O.IExtensionGalleryService)],S),e.LanguagePackBaseService=S}),define(oe[202],ae([0,1,2,73]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends k.Disposable{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};D=pe([Y(0,i.ILanguagePackService)],D),e.LocalizationsUpdater=D}),define(oe[8],ae([0,1,38,3,2,37,5,7,4]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function S(){return new Date().toISOString()}var C;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function E(c,a,u){switch(a){case C.Trace:c.trace(u);break;case C.Debug:c.debug(u);break;case C.Info:c.info(u);break;case C.Warning:c.warn(u);break;case C.Error:c.error(u);break;case C.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=E;function w(c){let a="";for(let u=0;u<c.length;u++){let b=c[u];if(typeof b=="object")try{b=JSON.stringify(b)}catch{}a+=(u>0?" ":"")+b}return a}e.format=w;class p extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new i.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==C.Off&&this.b<=a}}e.AbstractLogger=p;class h extends p{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...u){this.f(C.Trace)&&this.g(C.Trace,w([a,...u]))}debug(a,...u){this.f(C.Debug)&&this.g(C.Debug,w([a,...u]))}info(a,...u){this.f(C.Info)&&this.g(C.Info,w([a,...u]))}warn(a,...u){this.f(C.Warning)&&this.g(C.Warning,w([a,...u]))}error(a,...u){if(this.f(C.Error))if(a instanceof Error){const b=Array.prototype.slice.call(arguments);b[0]=a.stack,this.g(C.Error,w(b))}else this.g(C.Error,w([a,...u]))}flush(){}}e.AbstractMessageLogger=h;class g extends p{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.g=!O.isWindows}trace(a,...u){this.f(C.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...u):console.log(`[main ${S()}]`,a,...u))}debug(a,...u){this.f(C.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...u):console.log(`[main ${S()}]`,a,...u))}info(a,...u){this.f(C.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...u):console.log(`[main ${S()}]`,a,...u))}warn(a,...u){this.f(C.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,a,...u):console.warn(`[main ${S()}]`,a,...u))}error(a,...u){this.f(C.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,a,...u):console.error(`[main ${S()}]`,a,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class y extends p{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...u){this.f(C.Trace)&&console.log("%cTRACE","color: #888",a,...u)}debug(a,...u){this.f(C.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",a,...u)}info(a,...u){this.f(C.Info)&&console.log("%c INFO","color: #33f",a,...u)}warn(a,...u){this.f(C.Warning)&&console.log("%c WARN","color: #993",a,...u)}error(a,...u){this.f(C.Error)&&console.log("%c  ERR","color: #f33",a,...u)}dispose(){}flush(){}}e.ConsoleLogger=y;class l extends p{constructor(a,u=e.DEFAULT_LOG_LEVEL){super(),this.g=a,this.setLevel(u)}trace(a,...u){this.f(C.Trace)&&this.g.log(C.Trace,[this.h(a),...u])}debug(a,...u){this.f(C.Debug)&&this.g.log(C.Debug,[this.h(a),...u])}info(a,...u){this.f(C.Info)&&this.g.log(C.Info,[this.h(a),...u])}warn(a,...u){this.f(C.Warning)&&this.g.log(C.Warning,[this.h(a),...u])}error(a,...u){this.f(C.Error)&&this.g.log(C.Error,[this.h(a),...u])}h(a){return typeof a=="string"?a:(0,k.toErrorMessage)(a,this.f(C.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class d extends p{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const u of this.g)u.setLevel(a);super.setLevel(a)}trace(a,...u){for(const b of this.g)b.trace(a,...u)}debug(a,...u){for(const b of this.g)b.debug(a,...u)}info(a,...u){for(const b of this.g)b.info(a,...u)}warn(a,...u){for(const b of this.g)b.warn(a,...u)}error(a,...u){for(const b of this.g)b.error(a,...u)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.MultiplexLogService=d;class m extends D.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...u){this.b.trace(a,...u)}debug(a,...u){this.b.debug(a,...u)}info(a,...u){this.b.info(a,...u)}warn(a,...u){this.b.warn(a,...u)}error(a,...u){this.b.error(a,...u)}flush(){this.b.flush()}}e.LogService=m;class v extends D.Disposable{constructor(a,u){super(),this.c=a,this.b=new A.ResourceMap,this.B(u(b=>this.setLevel(b)))}getLoggers(){return[...this.b.values()].map(({logger:a})=>a)}getLogger(a){return this.b.get(a)?.logger}createLogger(a,u,b){let I=this.b.get(a)?.logger;return I||(b=u?.always?C.Trace:b,I=this.f(a,b??this.c,u),this.b.set(a,{logger:I,logLevel:b})),I}setLevel(a,u){const b=R.URI.isUri(a)?a:void 0,I=b?u:a;if(b){const F=this.b.get(b);F&&F.logLevel!==I&&(F.logLevel=I,F.logger.setLevel(I))}else this.c=I,this.b.forEach(({logLevel:F,logger:N})=>{F===void 0&&N.setLevel(this.c)})}getLogLevel(a){return this.b.get(a)?.logLevel}dispose(){this.b.forEach(({logger:a})=>a.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=v;class f{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(a){}getLevel(){return C.Info}trace(a,...u){}debug(a,...u){}info(a,...u){}warn(a,...u){}error(a,...u){}critical(a,...u){}dispose(){}flush(){}}e.NullLogger=f;class n extends f{}e.NullLogService=n;class s extends v{constructor(){super(C.Info,i.Event.None)}f(a,u,b){return new f}}e.NullLoggerService=s;function t(c){if(c.verbose)return C.Trace;if(typeof c.logLevel=="string"){const a=o(c.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function r(c){switch(c){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Off:return"off"}}e.LogLevelToString=r;function o(c){switch(c){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Error;case"off":return C.Off}}e.parseLogLevel=o}),define(oe[203],ae([0,1,6,9,2,12,28,15,8]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends D.Disposable{constructor(E,w){super(),this.a=E,this.b=w,this.B(new k.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,A.basename)(this.a.logsPath),w=(0,A.dirname)(this.a.logsPath),g=(await O.Promises.readdir(w)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==E),y=g.slice(0,Math.max(0,g.length-9));y.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${y.join(", ")}'`),await Promise.all(y.map(l=>O.Promises.rm((0,A.join)(w,l)))))}catch(E){(0,i.onUnexpectedError)(E)}}};S=pe([Y(0,R.IEnvironmentService),Y(1,P.ILogService)],S),e.LogsDataCleaner=S}),define(oe[204],ae([0,1,20,6,9,3,2,12,55,8]),function(ee,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends O.Disposable{constructor(w,p){super(),this.a=w,this.b=p,this.c=this.B(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new i.ThrottledDelayer(0)),this.s=[],this.t=this.B(new i.ThrottledDelayer(0))}watch(w,p){return p.recursive||this.b?.watcher?.forceUniversal?this.l(w,p):this.u(w,p)}l(w,p){const h={path:this.C(w),excludes:p.excludes,includes:p.includes,recursive:p.recursive},g=(0,k.insert)(this.j,h);return this.m(),(0,O.toDisposable)(()=>{g(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(w=>(0,D.onUnexpectedError)(w))}n(){this.h||(this.h=this.B(this.p(p=>this.c.fire((0,P.toFileChanges)(p)),p=>this.z(p),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const p of this.j)(0,P.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const p of this.j)(0,P.isRecursiveWatchRequest)(p)&&w.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(w,p){const h={path:this.C(w),excludes:p.excludes,includes:p.includes,recursive:!1},g=(0,k.insert)(this.s,h);return this.v(),(0,O.toDisposable)(()=>{g(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(w=>(0,D.onUnexpectedError)(w))}w(){return this.r||(this.r=this.B(this.y(w=>this.c.fire((0,P.toFileChanges)(w)),w=>this.z(w),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.r.watch(this.s)}z(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}C(w){return(0,R.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(oe[205],ae([0,1,20,6,17,24,3,66,64,2,48,21,206,22,44,162,14,100,8]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends S.Disposable{constructor(f){super(),this.b=f,this.a=256*1024,this.c=this.B(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new O.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new O.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new O.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new i.ResourceQueue)}registerProvider(f,n){if(this.h.has(f))throw new Error(`A filesystem provider for the scheme '${f}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${f}`);const s=new S.DisposableStore;return this.h.set(f,n),this.c.fire({added:!0,scheme:f,provider:n}),s.add(n.onDidChangeFile(t=>this.Q.fire(new y.FileChangesEvent(t,!this.N(n))))),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.R.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:f}))),(0,S.toDisposable)(()=>{this.c.fire({added:!1,scheme:f,provider:n}),this.h.delete(f),(0,S.dispose)(s)})}getProvider(f){return this.h.get(f)}async activateProvider(f){const n=[];this.f.fire({scheme:f,join(s){n.push(s)}}),!this.h.has(f)&&await i.Promises.settled(n)}async canHandleResource(f){return await this.activateProvider(f.scheme),this.hasProvider(f)}hasProvider(f){return this.h.has(f.scheme)}hasCapability(f,n){const s=this.h.get(f.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return P.Iterable.map(this.h,([f,n])=>({scheme:f,capabilities:n.capabilities}))}async j(f){if(!(0,p.isAbsolutePath)(f))throw new y.FileOperationError((0,g.localize)(0,null,this.mb(f)),8);await this.activateProvider(f.scheme);const n=this.h.get(f.scheme);if(!n){const s=new Error;throw s.name="ENOPRO",s.message=(0,g.localize)(1,null,f.toString()),s}return n}async k(f){const n=await this.j(f);if((0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n)||(0,y.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(f){const n=await this.j(f);if((0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(f,n){try{return await this.n(f,n)}catch(s){throw(0,y.toFileSystemProviderErrorCode)(s)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,g.localize)(2,null,this.mb(f)),1):(0,y.ensureFileSystemProviderError)(s)}}async n(f,n){const s=await this.j(f),t=this.N(s),r=n?.resolveTo,o=n?.resolveSingleChildDescendants,c=n?.resolveMetadata,a=await s.stat(f);let u;return this.p(s,f,a,void 0,!!c,(b,I)=>(u||(u=C.TernarySearchTree.forUris(()=>!t),u.set(f,!0),r&&u.fill(!0,r)),u.get(b.resource)||u.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&o?I===1:!1))}async p(f,n,s,t,r,o){const{providerExtUri:c}=this.M(f),a={resource:n,name:c.basename(n),isFile:(s.type&y.FileType.File)!==0,isDirectory:(s.type&y.FileType.Directory)!==0,isSymbolicLink:(s.type&y.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&y.FilePermission.Readonly)||Boolean(f.capabilities&2048),etag:(0,y.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(a.isDirectory&&o(a,t)){try{const u=await f.readdir(n),b=await i.Promises.settled(u.map(async([I,F])=>{try{const N=c.joinPath(n,I),$=r?await f.stat(N):{type:F};return await this.p(f,N,$,u.length,r,o)}catch(N){return this.b.trace(N),null}}));a.children=(0,k.coalesce)(b)}catch(u){this.b.trace(u),a.children=[]}return a}return a}async resolveAll(f){return i.Promises.settled(f.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(f){const n=await this.j(f),s=await n.stat(f);return this.p(n,f,s,void 0,!0,()=>!1)}async exists(f){const n=await this.j(f);try{return!!await n.stat(f)}catch{return!1}}async canCreateFile(f,n){try{await this.r(f,n)}catch(s){return s}return!0}async r(f,n){if(!n?.overwrite&&await this.exists(f))throw new y.FileOperationError((0,g.localize)(3,null,this.mb(f)),3,n)}async createFile(f,n=D.VSBuffer.fromString(""),s){await this.r(f,s);const t=await this.writeFile(f,n);return this.m.fire(new y.FileOperationEvent(f,0,t)),t}async writeFile(f,n,s){const t=this.kb(await this.l(f),f),{providerExtUri:r}=this.M(t);try{await this.s(t,f,s)||await this.O(t,r.dirname(f));let c;if((0,y.hasReadWriteCapability)(t)&&!(n instanceof D.VSBuffer))if((0,h.isReadableStream)(n)){const a=await(0,h.peekStream)(n,3);a.ended?c=D.VSBuffer.concat(a.buffer):c=a}else c=(0,h.peekReadable)(n,a=>D.VSBuffer.concat(a),3);else c=n;!(0,y.hasOpenReadWriteCloseCapability)(t)||(0,y.hasReadWriteCapability)(t)&&c instanceof D.VSBuffer?await this.bb(t,f,s,c):await this.X(t,f,s,c instanceof D.VSBuffer?(0,D.bufferToReadable)(c):c),this.m.fire(new y.FileOperationEvent(f,4))}catch(o){throw new y.FileOperationError((0,g.localize)(4,null,this.mb(f),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),s)}return this.resolve(f,{resolveMetadata:!0})}async s(f,n,s){if(!!s?.unlock&&!(f.capabilities&8192))throw new Error((0,g.localize)(5,null,this.mb(n)));let r;try{r=await f.stat(n)}catch{return}if((r.type&y.FileType.Directory)!==0)throw new y.FileOperationError((0,g.localize)(6,null,this.mb(n)),0,s);if(this.lb(n,r),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==y.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&s.mtime<r.mtime&&s.etag!==(0,y.etag)({mtime:s.mtime,size:r.size}))throw new y.FileOperationError((0,g.localize)(7,null),3,s);return r}async readFile(f,n,s){const t=await this.k(f);return n?.atomic?this.t(t,f,n,s):this.u(t,f,n,s)}async t(f,n,s,t){return new Promise((r,o)=>{this.W.queueFor(n,this.M(f).providerExtUri).queue(async()=>{try{const c=await this.u(f,n,s,t);r(c)}catch(c){o(c)}})})}async u(f,n,s,t){const r=await this.v(f,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,D.streamToBuffer)(r.value)}}async readFileStream(f,n,s){const t=await this.k(f);return this.v(t,f,n,s)}async v(f,n,s,t){const r=new A.CancellationTokenSource(t),o=this.D(n,s).then(a=>a,a=>{throw r.cancel(),a});let c;try{return typeof s?.etag=="string"&&s.etag!==y.ETAG_DISABLED&&await o,s?.atomic&&(0,y.hasFileAtomicReadCapability)(f)||!((0,y.hasOpenReadWriteCloseCapability)(f)||(0,y.hasFileReadStreamCapability)(f))||(0,y.hasReadWriteCapability)(f)&&s?.preferUnbuffered?c=this.C(f,n,s):(0,y.hasFileReadStreamCapability)(f)?c=this.w(f,n,r.token,s):c=this.z(f,n,r.token,s),{...await o,value:c}}catch(a){c&&await(0,h.consumeStream)(c);const u=(0,g.localize)(8,null,this.mb(n),(0,y.ensureFileSystemProviderError)(a).toString());throw a instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(u,a.stat,s):new y.FileOperationError(u,(0,y.toFileOperationResult)(a),s)}}w(f,n,s,t=Object.create(null)){const r=f.readFileStream(n,t,s);return(0,h.transform)(r,{data:o=>o instanceof D.VSBuffer?o:D.VSBuffer.wrap(o),error:o=>new y.FileOperationError((0,g.localize)(9,null,this.mb(n),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),t)},o=>D.VSBuffer.concat(o))}z(f,n,s,t=Object.create(null)){const r=(0,D.newWriteableBufferStream)();return(0,l.readFileIntoStream)(f,n,r,o=>o,{...t,bufferSize:this.a,errorTransformer:o=>new y.FileOperationError((0,g.localize)(10,null,this.mb(n),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),t)},s),r}C(f,n,s){const t=(0,h.newWriteableStream)(r=>D.VSBuffer.concat(r));return(async()=>{try{let r;s?.atomic&&(0,y.hasFileAtomicReadCapability)(f)?r=await f.readFile(n,{atomic:!0}):r=await f.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.F(n,r.byteLength,s),t.end(D.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async D(f,n){const s=await this.resolve(f,{resolveMetadata:!0});if(s.isDirectory)throw new y.FileOperationError((0,g.localize)(11,null,this.mb(f)),0,n);if(typeof n?.etag=="string"&&n.etag!==y.ETAG_DISABLED&&n.etag===s.etag)throw new y.NotModifiedSinceFileOperationError((0,g.localize)(12,null),s,n);return this.F(f,s.size,n),s}F(f,n,s){if(s?.limits){let t;if(typeof s.limits.memory=="number"&&n>s.limits.memory&&(t=9),typeof s.limits.size=="number"&&n>s.limits.size&&(t=7),typeof t=="number")throw new y.FileOperationError((0,g.localize)(13,null,this.mb(f)),t)}}async canMove(f,n,s){return this.G(f,n,"move",s)}async canCopy(f,n,s){return this.G(f,n,"copy",s)}async G(f,n,s,t){if(f.toString()!==n.toString())try{const r=s==="move"?this.kb(await this.l(f),f):await this.k(f),o=this.kb(await this.l(n),n);await this.L(r,f,o,n,s,t)}catch(r){return r}return!0}async move(f,n,s){const t=this.kb(await this.l(f),f),r=this.kb(await this.l(n),n),o=await this.H(t,f,r,n,"move",!!s),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new y.FileOperationEvent(f,o==="move"?2:3,c)),c}async copy(f,n,s){const t=await this.k(f),r=this.kb(await this.l(n),n),o=await this.H(t,f,r,n,"copy",!!s),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new y.FileOperationEvent(f,o==="copy"?3:2,c)),c}async H(f,n,s,t,r,o){if(n.toString()===t.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:a}=await this.L(f,n,s,t,r,o);if(c&&!a&&o&&await this.del(t,{recursive:!0}),await this.O(s,this.M(s).providerExtUri.dirname(t)),r==="copy"){if(f===s&&(0,y.hasFileFolderCopyCapability)(f))await f.copy(n,t,{overwrite:o});else{const u=await this.resolve(n);u.isDirectory?await this.J(f,u,s,t):await this.I(f,n,s,t)}return r}else return f===s?(await f.rename(n,t,{overwrite:o}),r):(await this.H(f,n,s,t,"copy",o),await this.del(n,{recursive:!0}),"copy")}async I(f,n,s,t){if((0,y.hasOpenReadWriteCloseCapability)(f)&&(0,y.hasOpenReadWriteCloseCapability)(s))return this.db(f,n,s,t);if((0,y.hasOpenReadWriteCloseCapability)(f)&&(0,y.hasReadWriteCapability)(s))return this.jb(f,n,s,t);if((0,y.hasReadWriteCapability)(f)&&(0,y.hasOpenReadWriteCloseCapability)(s))return this.hb(f,n,s,t);if((0,y.hasReadWriteCapability)(f)&&(0,y.hasReadWriteCapability)(s))return this.fb(f,n,s,t)}async J(f,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await i.Promises.settled(n.children.map(async r=>{const o=this.M(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.J(f,await this.resolve(r.resource),s,o):this.I(f,r.resource,s,o)}))}async L(f,n,s,t,r,o){let c=!1;if(f===s){const{providerExtUri:u,isPathCaseSensitive:b}=this.M(f);if(b||(c=u.isEqual(n,t)),c&&r==="copy")throw new Error((0,g.localize)(14,null,this.mb(n),this.mb(t)));if(!c&&u.isEqualOrParent(t,n))throw new Error((0,g.localize)(15,null,this.mb(n),this.mb(t)))}const a=await this.exists(t);if(a&&!c){if(!o)throw new y.FileOperationError((0,g.localize)(16,null,this.mb(n),this.mb(t)),4);if(f===s){const{providerExtUri:u}=this.M(f);if(u.isEqualOrParent(n,t))throw new Error((0,g.localize)(17,null,this.mb(n),this.mb(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:c}}M(f){const n=this.N(f);return{providerExtUri:n?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:n}}N(f){return!!(f.capabilities&1024)}async createFolder(f){const n=this.kb(await this.j(f),f);await this.O(n,f);const s=await this.resolve(f,{resolveMetadata:!0});return this.m.fire(new y.FileOperationEvent(f,0,s)),s}async O(f,n){const s=[],{providerExtUri:t}=this.M(f);for(;!t.isEqual(n,t.dirname(n));)try{if(((await f.stat(n)).type&y.FileType.Directory)===0)throw new Error((0,g.localize)(18,null,this.mb(n)));break}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await f.mkdir(n)}catch(o){if((0,y.toFileSystemProviderErrorCode)(o)!==y.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(f,n){try{await this.P(f,n)}catch(s){return s}return!0}async P(f,n){const s=this.kb(await this.j(f),f);if(!!n?.useTrash&&!(s.capabilities&4096))throw new Error((0,g.localize)(19,null,this.mb(f)));let r;try{r=await s.stat(f)}catch{}if(r)this.lb(f,r);else throw new y.FileOperationError((0,g.localize)(20,null,this.mb(f)),1);if(!!!n?.recursive){const c=await this.resolve(f);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,g.localize)(21,null,this.mb(f)))}return s}async del(f,n){const s=await this.P(f,n),t=!!n?.useTrash,r=!!n?.recursive;await s.delete(f,{recursive:r,useTrash:t}),this.m.fire(new y.FileOperationEvent(f,1))}async cloneFile(f,n){const s=await this.j(f),t=this.kb(await this.l(n),n);if(s===t&&this.M(s).providerExtUri.isEqual(f,n))return;if(s===t&&(0,y.hasFileCloneCapability)(s))return s.cloneFile(f,n);await this.O(t,this.M(t).providerExtUri.dirname(n));const r=this.W.queueFor(f,this.M(s).providerExtUri);return s===t&&(0,y.hasFileFolderCopyCapability)(s)?r.queue(()=>s.copy(f,n,{overwrite:!0})):r.queue(()=>this.I(s,f,t,n))}watch(f,n={recursive:!1,excludes:[]}){const s=new S.DisposableStore;let t=!1,r=()=>{t=!0};return s.add((0,S.toDisposable)(()=>r())),(async()=>{try{const o=await this.U(f,n);t?(0,S.dispose)(o):r=()=>(0,S.dispose)(o)}catch(o){this.b.error(o)}})(),s}async U(f,n){const s=await this.j(f),t=(0,R.hash)([this.M(s).providerExtUri.getComparisonKey(f),n]);let r=this.S.get(t);return r||(r={count:0,disposable:s.watch(f,n)},this.S.set(t,r)),r.count+=1,(0,S.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,S.dispose)(r.disposable),this.S.delete(t)))})}dispose(){super.dispose();for(const[,f]of this.S)(0,S.dispose)(f.disposable);this.S.clear()}async X(f,n,s,t){return this.W.queueFor(n,this.M(f).providerExtUri).queue(async()=>{const r=await f.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,h.isReadableStream)(t)||(0,h.isReadableBufferedStream)(t)?await this.Y(f,r,t):await this.Z(f,r,t)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await f.close(r)}})}async Y(f,n,s){let t=0,r;if((0,h.isReadableBufferedStream)(s)){if(s.buffer.length>0){const o=D.VSBuffer.concat(s.buffer);await this.ab(f,n,o,o.byteLength,t,0),t+=o.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((o,c)=>{(0,h.listenStream)(r,{onData:async a=>{r.pause();try{await this.ab(f,n,a,a.byteLength,t,0)}catch(u){return c(u)}t+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>c(a),onEnd:()=>o()})})}async Z(f,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.ab(f,n,r,r.byteLength,t,0),t+=r.byteLength}async ab(f,n,s,t,r,o){let c=0;for(;c<t;)c+=await f.write(n,r+c,s.buffer,o+c,t-c)}async bb(f,n,s,t){return this.W.queueFor(n,this.M(f).providerExtUri).queue(()=>this.cb(f,n,s,t))}async cb(f,n,s,t){let r;t instanceof D.VSBuffer?r=t:(0,h.isReadableStream)(t)?r=await(0,D.streamToBuffer)(t):(0,h.isReadableBufferedStream)(t)?r=await(0,D.bufferedStreamToBuffer)(t):r=(0,D.readableToBuffer)(t),await f.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async db(f,n,s,t){return this.W.queueFor(t,this.M(s).providerExtUri).queue(()=>this.eb(f,n,s,t))}async eb(f,n,s,t){let r,o;try{r=await f.open(n,{create:!1}),o=await s.open(t,{create:!0,unlock:!1});const c=D.VSBuffer.alloc(this.a);let a=0,u=0,b=0;do b=await f.read(r,a,c.buffer,u,c.byteLength-u),await this.ab(s,o,c,b,a,u),a+=b,u+=b,u===c.byteLength&&(u=0);while(b>0)}catch(c){throw(0,y.ensureFileSystemProviderError)(c)}finally{await i.Promises.settled([typeof r=="number"?f.close(r):Promise.resolve(),typeof o=="number"?s.close(o):Promise.resolve()])}}async fb(f,n,s,t){return this.W.queueFor(t,this.M(s).providerExtUri).queue(()=>this.gb(f,n,s,t))}async gb(f,n,s,t){return s.writeFile(t,await f.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async hb(f,n,s,t){return this.W.queueFor(t,this.M(s).providerExtUri).queue(()=>this.ib(f,n,s,t))}async ib(f,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const o=await f.readFile(n);await this.ab(s,r,D.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await s.close(r)}}async jb(f,n,s,t){const r=await(0,D.streamToBuffer)(this.z(f,n,A.CancellationToken.None));await this.bb(s,t,void 0,r)}kb(f,n){if(f.capabilities&2048)throw new y.FileOperationError((0,g.localize)(22,null,this.mb(n)),6);return f}lb(f,n){if((n.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,g.localize)(23,null,this.mb(f)),6)}mb(f){return f.scheme===E.Schemas.file?f.fsPath:f.toString(!0)}};m=pe([Y(0,d.ILogService)],m),e.FileService=m}),define(oe[207],ae([0,1,52,286,6,37,17,3,47,2,12,5,22,44,28,165,14,100,204,38,199,198]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(k)}catch(s){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(s)}`)}})();class n extends d.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r),this.onDidChangeCapabilities=R.Event.None,this.H=new A.ResourceMap(o=>w.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,E.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:r,symbolicLink:o}=await h.SymlinkSupport.stat(this.C(t));return{type:this.G(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.Y(r)}}async readdir(t){try{const r=await h.Promises.readdir(this.C(t),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,w.joinPath)(t,c.name))).type:a=this.G(c),o.push([c.name,a])}catch(a){this.a.trace(a)}})),o}catch(r){throw this.Y(r)}}G(t,r){let o;return r?.dangling?o=y.FileType.Unknown:t.isFile()?o=y.FileType.File:t.isDirectory()?o=y.FileType.Directory:o=y.FileType.Unknown,r&&(o|=y.FileType.SymbolicLink),o}async I(t){const r=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const c=new D.Barrier;return this.H.set(t,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,S.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.H.get(t)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(t,r){let o;try{r?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),o=await this.I(t));const c=this.C(t);return await h.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{o?.dispose()}}J(t){n.D&&this.a.trace(t)}readFileStream(t,r,o){const c=(0,p.newWriteableStream)(a=>O.VSBuffer.concat(a.map(u=>O.VSBuffer.wrap(u))).buffer);return(0,l.readFileIntoStream)(this,t,c,a=>a.buffer,{...r,bufferSize:256*1024},o),c}async writeFile(t,r,o){let c;try{const a=this.C(t);if(!o.create||!o.overwrite){if(await h.Promises.exists(a)){if(!o.overwrite)throw(0,y.createFileSystemProviderError)((0,g.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,y.createFileSystemProviderError)((0,g.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(c,0,r,0,r.byteLength)}catch(a){throw await this.Z(t,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){n.O=t}async open(t,r){const o=this.C(t);let c;(0,y.isFileOpenForWriteOptions)(r)&&(c=await this.I(t));let a;try{if((0,y.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:b}=await h.SymlinkSupport.stat(o);b.mode&128||await h.Promises.chmod(o,b.mode|128)}catch(b){this.a.trace(b)}let u;if((0,y.isFileOpenForWriteOptions)(r)){if(E.isWindows)try{await h.Promises.truncate(o,0),u="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}u||(u="w")}else u="r";a=await h.Promises.open(o,u)}catch(u){throw c?.dispose(),(0,y.isFileOpenForWriteOptions)(r)?await this.Z(t,u):this.Y(u)}if(this.L.set(a,0),(0,y.isFileOpenForWriteOptions)(r)&&this.N.set(a,t),c){const u=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.M.set(a,c),u&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),u.dispose())}return a}async close(t){const r=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&n.O)try{await h.Promises.fdatasync(t)}catch(o){n.configureFlushOnWrite(!1),this.a.error(o)}return await h.Promises.close(t)}catch(o){throw this.Y(o)}finally{r&&(this.M.get(t)===r&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,o,c,a){const u=this.P(t,r);let b=null;try{b=(await h.Promises.read(t,o,c,a,u)).bytesRead}catch(I){throw this.Y(I)}finally{this.Q(t,u,b)}return b}P(t,r){return r===this.L.get(t)?null:r}Q(t,r,o){const c=this.L.get(t);typeof c=="number"&&(typeof r=="number"||(typeof o=="number"?this.L.set(t,c+o):this.L.delete(t)))}async write(t,r,o,c,a){return(0,D.retry)(()=>this.R(t,r,o,c,a),100,3)}async R(t,r,o,c,a){const u=this.P(t,r);let b=null;try{b=(await h.Promises.write(t,o,c,a,u)).bytesWritten}catch(I){throw await this.Z(this.N.get(t),I)}finally{this.Q(t,u,b)}return b}async mkdir(t){try{await h.Promises.mkdir(this.C(t))}catch(r){throw this.Y(r)}}async delete(t,r){try{const o=this.C(t);r.recursive?await h.Promises.rm(o,h.RimRafMode.MOVE):await h.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(t,r,o){const c=this.C(t),a=this.C(r);if(c!==a)try{await this.S(t,r,"move",o.overwrite),await h.Promises.move(c,a)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,g.localize)(2,null,(0,C.basename)(c),(0,C.basename)((0,C.dirname)(a)),u.toString()))),this.Y(u)}}async copy(t,r,o){const c=this.C(t),a=this.C(r);if(c!==a)try{await this.S(t,r,"copy",o.overwrite),await h.Promises.copy(c,a,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,g.localize)(3,null,(0,C.basename)(c),(0,C.basename)((0,C.dirname)(a)),u.toString()))),this.Y(u)}}async S(t,r,o,c){const a=this.C(t),u=this.C(r);let b=!1;if(!!(this.capabilities&1024)||(b=(0,P.isEqual)(a,u,!0)),b&&o==="copy")throw(0,y.createFileSystemProviderError)((0,g.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!b&&await h.Promises.exists(u)){if(!c)throw(0,y.createFileSystemProviderError)((0,g.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.U(t,r,!1)}async U(t,r,o){const c=this.C(t),a=this.C(r),u=!!(this.capabilities&1024);if((0,P.isEqual)(c,a,!u))return;const b=new S.DisposableStore;try{const[I,F]=await Promise.all([this.I(t),this.I(r)]);b.add(I),b.add(F),o&&await h.Promises.mkdir((0,C.dirname)(a),{recursive:!0}),await h.Promises.copyFile(c,a)}catch(I){if(I.code==="ENOENT"&&!o)return this.U(t,r,!0);throw this.Y(I)}finally{b.dispose()}}p(t,r,o){return new v.UniversalWatcherClient(c=>t(c),c=>r(c),o)}y(t,r,o){return new f.NodeJSWatcherClient(c=>t(c),c=>r(c),o)}Y(t){if(t instanceof y.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=y.FileSystemProviderErrorCode.NoPermissions;break;default:r=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(t,r)}async Z(t,r){let o=this.Y(r);if(t&&o.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await h.SymlinkSupport.stat(this.C(t));c.mode&128||(o=(0,y.createFileSystemProviderError)(r,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return o}}e.DiskFileSystemProvider=n,n.D=!1,n.O=!0}),define(oe[101],ae([0,1,6,3,2,4,8]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,A.createDecorator)("lifecycleSharedProcessService");let R=class extends D.Disposable{constructor(S){super(),this.c=S,this.a=void 0,this.b=this.B(new i.Emitter),this.onWillShutdown=this.b.event}fireOnWillShutdown(){if(this.a)return this.a;this.c.trace("Lifecycle#onWillShutdown.fire()");const S=[];return this.b.fire({join(C){S.push(C)}}),this.a=(async()=>{try{await k.Promises.settled(S)}catch(C){this.c.error(C)}})(),this.a}};R=pe([Y(0,O.ILogService)],R),e.SharedProcessLifecycleService=R}),define(oe[102],ae([0,1,3,7,8]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(w,p){this.a=w,this.b=p,this.onDidChangeLogLevel=k.Event.buffer(w.onDidChangeLogLevel,!0)}listen(w,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(w,p,h){switch(p){case"setLevel":return h[1]?this.b.setLevel(i.URI.revive(h[1]),h[0]):this.a.setLevel(h[0])}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=A;class O{constructor(w){this.a=w}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(w,p){O.setLevel(this.a,w,p)}static setLevel(w,p,h){return w.call("setLevel",[p,h])}}e.LogLevelChannelClient=O;class R{constructor(w){this.b=w,this.a=new Map}listen(w,p){throw new Error(`Event not found: ${p}`)}async call(w,p,h){switch(p){case"createLogger":this.c(i.URI.revive(h[0]),h[1]);return;case"log":return this.e(i.URI.revive(h[0]),h[1]);case"consoleLog":return this.d(h[0],h[1])}throw new Error(`Call not found: ${p}`)}c(w,p){this.a.set(w.toString(),this.b.createLogger(w,p))}d(w,p){let h=console.log;switch(w){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...p)}e(w,p){const h=this.a.get(w.toString());if(!h)throw new Error("Create the logger before logging");for(const[g,y]of p)(0,D.log)(h,g,y)}}e.LoggerChannel=R;class P extends D.AbstractLoggerService{constructor(w,p,h){super(w,p),this.g=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(w,p)=>{this.g.call("consoleLog",[w,p])}})}f(w,p,h){return new S(this.g,w,p,h)}}e.LoggerChannelClient=P;class S extends D.AbstractMessageLogger{constructor(w,p,h,g){super(g?.always),this.m=w,this.n=p,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[p,g]).then(()=>{this.r(this.l),this.k=!0})}g(w,p){const h=[[w,p]];this.k?this.r(h):this.l.push(...h)}r(w){this.m.call("log",[this.n,w])}}class C extends D.LogService{constructor(w,p){super(p),this.c=w,this.B(w.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(w){super.setLevel(w),this.c.setLevel(w)}}e.FollowerLogService=C}),define(oe[57],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(oe[58],ae([0,1,3,64,2,4]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class O extends D.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new k.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(S){const C=Object.keys(this.f).length;return this.f={...S,...this.f},C!==Object.keys(this.f).length&&await this.i(S),i.Iterable.reduce(this.g.entries(),(E,[w,p])=>({...E,[w]:p}),{})}getPolicyValue(S){return this.g.get(S)}serialize(){return i.Iterable.reduce(Object.entries(this.f),(S,[C,E])=>({...S,[C]:{definition:E,value:this.g.get(C)}}),{})}}e.AbstractPolicyService=O;class R{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(oe[208],ae([0,1,3,2,58]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(P){this.b=P,this.a=new i.DisposableStore}listen(P,S){switch(S){case"onDidChange":return k.Event.map(this.b.onDidChange,C=>C.reduce((E,w)=>({...E,[w]:this.b.getPolicyValue(w)??null}),{}),this.a)}throw new Error(`Event not found: ${S}`)}call(P,S,C){switch(S){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${S}`)}dispose(){this.a.dispose()}}e.PolicyChannel=A;class O extends D.AbstractPolicyService{constructor(P,S){super(),this.a=S;for(const C in P){const{definition:E,value:w}=P[C];this.f[C]=E,w!==void 0&&this.g.set(C,w)}this.a.listen("onDidChange")(C=>{for(const E in C){const w=C[E];w===null?this.g.delete(E):this.g.set(E,w)}this.h.fire(Object.keys(C))})}async i(P){const S=await this.a.call("updatePolicyDefinitions",P);for(const C in S)this.g.set(C,S[C])}}e.PolicyChannelClient=O}),define(oe[103],ae([0,1,5,36]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.context<"u"){const A=k.globals.vscode.context.configuration();if(A)D=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:A.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(oe[25],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[209],ae([0,1,6,9,2,12,28,8,25]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends D.Disposable{constructor(E,w,p){super(),this.b=w,this.c=p,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new k.RunOnceScheduler(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const w=Date.now(),p=(0,A.dirname)(E),h=(0,A.basename)(E),g=await O.Promises.readdir(p);await Promise.all(g.map(async y=>{if(y===h)return;const l=(0,A.join)(p,y),d=await O.Promises.stat(l);if(d.isDirectory()&&w-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),O.Promises.rm(l)}))}catch(w){(0,i.onUnexpectedError)(w)}}};S=pe([Y(1,P.IProductService),Y(2,R.ILogService)],S),e.CodeCacheCleaner=S}),define(oe[210],ae([0,1,6,9,2,12,28,15,8,25]),function(ee,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let C=class extends D.Disposable{constructor(w,p,h){super(),this.b=w,this.c=p,this.f=h,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new k.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const w=Object.create(null),p=JSON.parse(await O.Promises.readFile((0,A.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(p)){const m=p[d];w[`${m.hash}.${d}`]=!0}const h=(0,A.join)(this.b.userDataPath,"clp");if(!await O.Promises.exists(h))return;const y=await O.Promises.readdir(h);for(const d of y){if(w[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await O.Promises.rm((0,A.join)(h,d))}const l=Date.now();for(const d of Object.keys(w)){const m=(0,A.join)(h,d),v=await O.Promises.readdir(m);for(const f of v){if(f==="tcf.json")continue;const n=(0,A.join)(m,f),s=await O.Promises.stat(n);s.isDirectory()&&l-s.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(d,f)}`),await O.Promises.rm(n))}}}catch(w){(0,i.onUnexpectedError)(w)}}};C=pe([Y(0,R.INativeEnvironmentService),Y(1,P.ILogService),Y(2,S.IProductService)],C),e.LanguagePackCachedDataCleaner=C}),define(oe[211],ae([0,1,20,2,22,186,14,25]),function(ee,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let P=class extends i.Disposable{constructor(C,E){super(),this.b=C,this.c=E,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,w])=>this.a.set(w.configPath,w))}getConfigBasedTips(C){return this.f(C)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(C){const E=[];for(const[w,p]of this.a)if(!(p.configScheme&&p.configScheme!==C.scheme))try{const h=await this.b.readFile((0,D.joinPath)(C,w)),g=new Map;Object.entries(p.recommendations).forEach(([l,d])=>{if((0,k.isNonEmptyArray)(d.remotes))for(const m of d.remotes)g.set(m,{extensionId:l,extensionName:d.name,configName:p.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled});else E.push({extensionId:l,extensionName:d.name,configName:p.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled})});const y=(0,A.getDomainsOfRemotes)(h.value.toString(),[...g.keys()]);for(const l of y){const d=g.get(l);d&&E.push(d)}}catch{}return E}};P=pe([Y(0,O.IFileService),Y(1,R.IProductService)],P),e.ExtensionTipsService=P}),define(oe[212],ae([0,1,12,4]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var D;(function(A){function O(P){return Boolean(P.samples&&P.timeDeltas)}A.isValidProfile=O;function R(P,S="noAbsolutePaths"){for(const C of P.nodes)C.callFrame&&C.callFrame.url&&((0,k.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,k.join)(S,(0,k.basename)(C.callFrame.url)));return P}A.rewriteAbsolutePaths=R})(D=e.Utils||(e.Utils={}))}),define(oe[213],ae([0,1,31]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this.a=new Map}async startProfiling(A){const R=await(await new Promise((S,C)=>{ee(["v8-inspect-profiler"],S,C)})).startProfiling({port:A.port,checkForPaused:!0}),P=(0,k.generateUuid)();return this.a.set(P,R),P}async stopProfiling(A){const O=this.a.get(A);if(!O)throw new Error(`UNKNOWN session '${A}'`);const R=await O.stop();return this.a.delete(A),R.profile}}e.InspectProfilingService=i}),define(oe[40],ae([0,1,126,13]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(O,R){k.ok(i.isString(O)),k.ok(i.isObject(R)),k.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.Registry=new D}),define(oe[104],ae([0,1,3,40]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new k.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(P,S){this.a[D(P)]=S,this.b.fire(P)}notifySchemaChanged(P){this.b.fire(P)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;i.Registry.add(e.Extensions.JSONContribution,O)}),define(oe[46],ae([0,1,20,3,13,151,16,104,40]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=P.Registry.as(R.Extensions.JSONContribution);class w{constructor(){this.h=new Set,this.i=new i.Emitter,this.onDidSchemaChange=this.i.event,this.j=new i.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const t=this.k(n,s);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const s=this.l(n);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:n,remove:s}){const t=[];t.push(...this.l(s)),t.push(...this.k(n,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,k.distinct)(t)})}registerDefaultConfigurations(n){const s=[],t=[];for(const{overrides:r,source:o}of n)for(const c in r)if(s.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.a.get(c),u=a?.valuesSources??new Map;if(o)for(const N of Object.keys(r[c]))u.set(N,o);const b={...a?.value||{},...r[c]};this.a.set(c,{source:o,value:b,valuesSources:u});const I=(0,O.getLanguageTagSettingPlainKey)(c),F={type:"object",default:b,description:A.localize(1,null,I),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:b,source:D.isString(o)?void 0:o,defaultValueSource:o};t.push(...g(c)),this.d[c]=F,this.b.properties[c]=F}else{this.a.set(c,{value:r[c],source:o});const a=this.d[c];a&&(this.s(c,a),this.o(c,a))}this.registerOverrideIdentifiers(t),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const s=[];for(const{overrides:t,source:r}of n)for(const o in t){const c=this.a.get(o),a=D.isString(r)?r:r?.id,u=D.isString(c?.source)?c?.source:c?.source?.id;if(a===u)if(s.push(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const b=this.d[o];b&&(this.s(o,b),this.o(o,b))}}this.q(),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){for(const s of n)this.h.add(s);this.q()}k(n,s){const t=[];return n.forEach(r=>{t.push(...this.m(r,s,r.extensionInfo,r.restrictedProperties)),this.c.push(r),this.n(r)}),t}l(n){const s=[],t=r=>{if(r.properties)for(const o in r.properties){s.push(o);const c=this.d[o];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[o],this.p(o,r.properties[o])}r.allOf?.forEach(o=>t(o))};for(const r of n){t(r);const o=this.c.indexOf(r);o!==-1&&this.c.splice(o,1)}return s}m(n,s=!0,t,r,o=3){o=D.isUndefinedOrNull(n.scope)?o:n.scope;const c=[],a=n.properties;if(a)for(const b in a){const I=a[b];if(s&&m(b,I)){delete a[b];continue}if(I.source=t,I.defaultDefaultValue=a[b].default,this.s(b,I),e.OVERRIDE_PROPERTY_REGEX.test(b)?I.scope=void 0:(I.scope=D.isUndefinedOrNull(I.scope)?o:I.scope,I.restricted=D.isUndefinedOrNull(I.restricted)?!!r?.includes(b):I.restricted),a[b].hasOwnProperty("included")&&!a[b].included){this.f[b]=a[b],delete a[b];continue}else this.d[b]=a[b],a[b].policy?.name&&this.e.set(a[b].policy.name,b);!a[b].deprecationMessage&&a[b].markdownDeprecationMessage&&(a[b].deprecationMessage=a[b].markdownDeprecationMessage),c.push(b)}const u=n.allOf;if(u)for(const b of u)c.push(...this.m(b,s,t,r,o));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(n){const s=t=>{const r=t.properties;if(r)for(const c in r)this.o(c,r[c]);t.allOf?.forEach(s)};s(n)}o(n,s){switch(e.allSettings.properties[n]=s,s.scope){case 1:e.applicationSettings.properties[n]=s;break;case 2:e.machineSettings.properties[n]=s;break;case 6:e.machineOverridableSettings.properties[n]=s;break;case 3:e.windowSettings.properties[n]=s;break;case 4:e.resourceSettings.properties[n]=s;break;case 5:e.resourceSettings.properties[n]=s,this.g.properties[n]=s;break}}p(n,s){switch(delete e.allSettings.properties[n],s.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}q(){for(const n of this.h.values()){const s=`[${n}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}this.i.fire()}r(){const n={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}s(n,s){const t=this.a.get(n);let r=t?.value,o=t?.source;D.isUndefined(r)&&(r=s.defaultDefaultValue,o=void 0),D.isUndefined(r)&&(r=l(s.type)),s.default=r,s.defaultValueSource=o}}const p="\\[([^\\]]+)\\]",h=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(f){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let s=h.exec(f);for(;s?.length;){const t=s[1].trim();t&&n.push(t),s=h.exec(f)}}return(0,k.distinct)(n)}e.overrideIdentifiersFromKey=g;function y(f){return f.reduce((n,s)=>`${n}[${s}]`,"")}e.keyFromOverrideIdentifiers=y;function l(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const d=new w;P.Registry.add(e.Extensions.Configuration,d);function m(f,n){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?A.localize(7,null,f):d.getConfigurationProperties()[f]!==void 0?A.localize(8,null,f):n.policy?.name&&d.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(9,null,f,n.policy?.name,d.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(6,null)}e.validateProperty=m;function v(){const f=[],n=d.getConfigurationProperties();for(const s of Object.keys(n))f.push([s,n[s].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=v}),define(oe[74],ae([0,1,20,3,35,2,37,32,13,7,16,46,40]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class p{constructor(s={},t=[],r=[],o){this.c=s,this.d=t,this.f=r,this.raw=o,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(t=>{if(t instanceof p)return t;const r=new h("");return r.parseRaw(t),r.configurationModel});this.g=s.reduce((t,r)=>r===t?r:t.merge(r),s[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(s){return s?(0,C.getConfigurationValue)(this.contents,s):this.contents}inspect(s,t){const r=this.rawConfiguration.getValue(s),o=t?this.rawConfiguration.getOverrideValue(s,t):void 0,c=t?this.rawConfiguration.override(t).getValue(s):r;return{value:r,override:o,merged:c}}getOverrideValue(s,t){const r=this.l(t);return r?s?(0,C.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const t=[];for(const r of this.overrides)r.identifiers.includes(s)&&t.push(...r.keys);return k.distinct(t)}getAllOverrideIdentifiers(){const s=[];for(const t of this.overrides)s.push(...t.identifiers);return k.distinct(s)}override(s){let t=this.b.get(s);return t||(t=this.h(s),this.b.set(s,t)),t}merge(...s){const t=R.deepClone(this.contents),r=R.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const a of s)if(c.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.j(t,a.contents);for(const u of a.overrides){const[b]=r.filter(I=>k.equals(I.identifiers,u.identifiers));b?(this.j(b.contents,u.contents),b.keys.push(...u.keys),b.keys=k.distinct(b.keys)):r.push(R.deepClone(u))}for(const u of a.keys)o.indexOf(u)===-1&&o.push(u)}return new p(t,o,r,c.every(a=>a instanceof p)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new p(R.deepClone(this.contents),[...this.keys],R.deepClone(this.overrides))}h(s){const t=this.l(s);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const r={};for(const o of k.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o];const a=t[o];a&&(typeof c=="object"&&typeof a=="object"?(c=R.deepClone(c),this.j(c,a)):c=a),r[o]=c}return new p(r,this.keys,this.overrides)}j(s,t){for(const r of Object.keys(t)){if(r in s&&P.isObject(s[r])&&P.isObject(t[r])){this.j(s[r],t[r]);continue}s[r]=R.deepClone(t[r])}}k(s){return this.a&&!Object.isFrozen(s)?R.deepFreeze(s):s}l(s){let t=null,r=null;const o=c=>{c&&(r?this.j(r,c):r=R.deepClone(c))};for(const c of this.overrides)k.equals(c.identifiers,[s])?t=c.contents:c.identifiers.includes(s)&&o(c.contents);return o(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,t){this.m(s),(0,C.addToValueTree)(this.contents,s,t,r=>{throw new Error(r)})}removeValue(s){this.n(s)&&(0,C.removeFromValueTree)(this.contents,s)}m(s){let t=this.keys.length;for(let r=0;r<t;r++)s.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,s)}n(s){const t=this.keys.indexOf(s);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class h{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,t){if(!P.isUndefinedOrNull(s)){const r=this.g(s);this.parseRaw(r,t)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,t){this.a=s;const{contents:r,keys:o,overrides:c,restricted:a,hasExcludedProperties:u}=this.h(s,t);this.b=new p(r,o,c,u?[s]:void 0),this.c=a||[]}g(s){let t={},r=null,o=[];const c=[],a=[];function u(I){Array.isArray(o)?o.push(I):r!==null&&(o[r]=I)}const b={onObjectBegin:()=>{const I={};u(I),c.push(o),o=I,r=null},onObjectProperty:I=>{r=I},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const I=[];u(I),c.push(o),o=I,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:u,onError:(I,F,N)=>{a.push({error:I,offset:F,length:N})}};if(s)try{D.visit(s,b),t=o[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return t}h(s,t){const r=w.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.j(s,r,!0,t);s=o.raw;const c=(0,C.toValuesTree)(s,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),a=Object.keys(s),u=this.l(s,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:c,keys:a,overrides:u,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(s,t,r,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:c};const a={},u=[];for(const b in s)if(E.OVERRIDE_PROPERTY_REGEX.test(b)&&r){const I=this.j(s[b],t,!1,o);a[b]=I.raw,c=c||I.hasExcludedProperties,u.push(...I.restricted)}else{const I=t[b],F=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&u.push(b),(F===void 0||o.scopes===void 0||o.scopes.includes(F))&&!(o.skipRestricted&&I?.restricted)?a[b]=s[b]:c=!0}return{raw:a,restricted:u,hasExcludedProperties:c}}l(s,t){const r=[];for(const o of Object.keys(s))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const a in s[o])c[a]=s[o][a];r.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,C.toValuesTree)(c,t)})}return r}}e.ConfigurationModelParser=h;class g extends A.Disposable{constructor(s,t,r,o){super(),this.f=s,this.g=t,this.h=o,this.c=this.B(new i.Emitter),this.onDidChange=this.c.event,this.a=new h(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(i.Event.any(i.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),i.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=g;class y{constructor(s,t,r,o,c,a,u,b,I,F,N,$,j){this.a=s,this.b=t,this.value=r,this.overrideIdentifiers=o,this.c=c,this.d=a,this.f=u,this.g=b,this.h=I,this.j=F,this.k=N,this.l=$,this.m=j}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(s,t,r,o,c=new p,a=new p,u=new O.ResourceMap,b=new p,I=new O.ResourceMap,F=!0){this.c=s,this.d=t,this.f=r,this.g=o,this.h=c,this.j=a,this.l=u,this.m=b,this.n=I,this.p=F,this.a=null,this.b=new O.ResourceMap,this.q=null}getValue(s,t,r){return this.s(s,t,r).getValue(s)}updateValue(s,t,r={}){let o;r.resource?(o=this.n.get(r.resource),o||(o=new p,this.n.set(r.resource,o))):o=this.m,t===void 0?o.removeValue(s):o.setValue(s,t),r.resource||(this.a=null)}inspect(s,t,r){const o=this.s(s,t,r),c=this.w(t.resource,r),a=t.resource?this.n.get(t.resource)||this.m:this.m,u=new Set;for(const b of o.overrides)for(const I of b.identifiers)o.getOverrideValue(s,I)!==void 0&&u.add(I);return new y(s,t,o.getValue(s),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this.j.freeze():void 0,c?c.freeze():void 0,a.inspect(s,t.overrideIdentifier))}keys(s){const t=this.w(void 0,s);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.j=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,t){this.l.set(s,t),this.b.delete(s)}deleteFolderConfiguration(s){this.r.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,t){const r=[];if(!t){const{added:o,updated:c,removed:a}=v(this.c,s);t=[...o,...c,...a]}for(const o of t)for(const c of(0,E.overrideIdentifiersFromKey)(o)){const a=this.c.getKeysForOverrideIdentifier(c),u=s.getKeysForOverrideIdentifier(c),b=[...u.filter(I=>a.indexOf(I)===-1),...a.filter(I=>u.indexOf(I)===-1),...a.filter(I=>!R.equals(this.c.override(c).getValue(I),s.override(c).getValue(I)))];r.push([c,b])}return this.updateDefaultConfiguration(s),{keys:t,overrides:r}}compareAndUpdatePolicyConfiguration(s){const{added:t,updated:r,removed:o}=v(this.d,s),c=[...t,...r,...o];return c.length&&this.updatePolicyConfiguration(s),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:t,updated:r,removed:o,overrides:c}=v(this.applicationConfiguration,s),a=[...t,...r,...o];return a.length&&this.updateApplicationConfiguration(s),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(s){const{added:t,updated:r,removed:o,overrides:c}=v(this.localUserConfiguration,s),a=[...t,...r,...o];return a.length&&this.updateLocalUserConfiguration(s),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(s){const{added:t,updated:r,removed:o,overrides:c}=v(this.remoteUserConfiguration,s),a=[...t,...r,...o];return a.length&&this.updateRemoteUserConfiguration(s),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(s){const{added:t,updated:r,removed:o,overrides:c}=v(this.workspaceConfiguration,s),a=[...t,...r,...o];return a.length&&this.updateWorkspaceConfiguration(s),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(s,t){const r=this.r.get(s),{added:o,updated:c,removed:a,overrides:u}=v(r,t),b=[...o,...c,...a];return(b.length||!r)&&this.updateFolderConfiguration(s,t),{keys:b,overrides:u}}compareAndDeleteFolderConfiguration(s){const t=this.r.get(s);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:o,removed:c,overrides:a}=v(t,void 0);return{keys:[...r,...o,...c],overrides:a}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(s,t,r){let o=this.t(t,r);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(o=o.merge(this.d)),o}t({resource:s},t){let r=this.u();if(t&&s){const o=t.getFolder(s);o&&(r=this.v(o.uri)||r);const c=this.n.get(s);c&&(r=r.merge(c))}return r}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(s){let t=this.b.get(s);if(!t){const r=this.u(),o=this.l.get(s);o?(t=r.merge(o),this.p&&(t=t.freeze()),this.b.set(s,t)):t=r}return t}w(s,t){if(t&&s){const r=t.getFolder(s);if(r)return this.l.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((s,t)=>{const{contents:r,overrides:o,keys:c}=this.l.get(t);return s.push([t,{contents:r,overrides:o,keys:c}]),s},[])}}allKeys(){const s=new Set;return this.c.freeze().keys.forEach(t=>s.add(t)),this.userConfiguration.freeze().keys.forEach(t=>s.add(t)),this.j.freeze().keys.forEach(t=>s.add(t)),this.l.forEach(t=>t.freeze().keys.forEach(r=>s.add(r))),[...s.values()]}x(){const s=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.j.freeze().getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.l.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}y(s){const t=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>t.add(r)),this.j.getKeysForOverrideIdentifier(s).forEach(r=>t.add(r)),this.l.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(o=>t.add(o))),[...t.values()]}static parse(s){const t=this.z(s.defaults),r=this.z(s.policy),o=this.z(s.application),c=this.z(s.user),a=this.z(s.workspace),u=s.folders.reduce((b,I)=>(b.set(S.URI.revive(I[0]),this.z(I[1])),b),new O.ResourceMap);return new l(t,r,o,c,new p,a,u,new p,new O.ResourceMap,!1)}static z(s){return new p(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=l;function d(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const s=new Set,t=new Map;for(const o of n)o.keys.forEach(c=>s.add(c)),o.overrides.forEach(([c,a])=>{const u=(0,O.getOrSet)(t,c,new Set);a.forEach(b=>u.add(b))});const r=[];return t.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=d;class m{constructor(s,t,r,o){this.change=s,this.b=t,this.c=r,this.d=o,this.f=void 0;const c=new Set;s.keys.forEach(u=>c.add(u)),s.overrides.forEach(([,u])=>u.forEach(b=>c.add(b))),this.affectedKeys=[...c.values()];const a=new p;this.affectedKeys.forEach(u=>a.setValue(u,{})),this.a=a.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=l.parse(this.b.data)),this.f}affectsConfiguration(s,t){if(this.g(this.a,s)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,t,this.b?.workspace):void 0,o=this.c.getValue(s,t,this.d);return!R.equals(r,o)}return!0}return!1}g(s,t){let r=(0,C.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(s=s[o],!s)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=m;function v(n,s){const{added:t,removed:r,updated:o}=f(s?.rawConfiguration,n?.rawConfiguration),c=[],a=n?.getAllOverrideIdentifiers()||[],u=s?.getAllOverrideIdentifiers()||[];if(s){const b=u.filter(I=>!a.includes(I));for(const I of b)c.push([I,s.getKeysForOverrideIdentifier(I)])}if(n){const b=a.filter(I=>!u.includes(I));for(const I of b)c.push([I,n.getKeysForOverrideIdentifier(I)])}if(s&&n){for(const b of a)if(u.includes(b)){const I=f({contents:n.getOverrideValue(void 0,b)||{},keys:n.getKeysForOverrideIdentifier(b)},{contents:s.getOverrideValue(void 0,b)||{},keys:s.getKeysForOverrideIdentifier(b)});c.push([b,[...I.added,...I.removed,...I.updated]])}}return{added:t,removed:r,updated:o,overrides:c}}function f(n,s){const t=n?s?n.keys.filter(c=>s.keys.indexOf(c)===-1):[...n.keys]:[],r=s?n?s.keys.filter(c=>n.keys.indexOf(c)===-1):[...s.keys]:[],o=[];if(n&&s){for(const c of s.keys)if(n.keys.indexOf(c)!==-1){const a=(0,C.getConfigurationValue)(s.contents,c),u=(0,C.getConfigurationValue)(n.contents,c);R.equals(a,u)||o.push(c)}}return{added:t,removed:r,updated:o}}}),define(oe[214],ae([0,1,20,3,2,32,13,16,74,46,8,58,40]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class p extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new h(this.f())),this.b}async initialize(){return this.b=void 0,this.B(w.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:m})=>this.c(d,m))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(d,m){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}}e.DefaultConfiguration=p;class h extends P.ConfigurationModel{constructor(d={}){const m=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),v=Object.keys(m),f=Object.create(null),n=[];for(const s in m){const t=d[s],r=t!==void 0?t:m[s].default;(0,R.addToValueTree)(f,s,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const s of Object.keys(f))S.OVERRIDE_PROPERTY_REGEX.test(s)&&n.push({identifiers:(0,S.overrideIdentifiersFromKey)(s),keys:Object.keys(f[s]),contents:(0,R.toValuesTree)(f[s],t=>console.error(`Conflict in default settings file: ${t}`))});super(f,v,n)}}e.DefaultConfigurationModel=h;class g{constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let y=class extends D.Disposable{get configurationModel(){return this.b}constructor(d,m,v){super(),this.c=d,this.f=m,this.g=v,this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.i(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.j(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const m={},v=[],f=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(const n of d){const s=f[n];if(!s){v.push(n);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.g.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}v.push(n),m[s.policy.name]={type:s.type}}}return(0,O.isEmptyObject)(m)||await this.f.updatePolicyDefinitions(m),v}i(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const m=w.Registry.as(S.Extensions.Configuration).getPolicyConfigurations(),v=(0,k.coalesce)(d.map(f=>m.get(f)));this.j(v,!0)}j(d,m){this.g.trace("PolicyConfiguration#update",d);const v=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),f=[],n=this.b.isEmpty();for(const s of d){const t=v[s]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(n?r!==void 0:!(0,A.equals)(this.b.getValue(s),r))&&f.push([s,r])}else this.b.getValue(s)!==void 0&&f.push([s,void 0])}if(f.length){this.g.trace("PolicyConfiguration#changed",f);const s=this.b;this.b=new P.ConfigurationModel;for(const t of s.keys)this.b.setValue(t,s.getValue(t));for(const[t,r]of f)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);m&&this.a.fire(this.b)}}};y=pe([Y(1,E.IPolicyService),Y(2,C.ILogService)],y),e.PolicyConfiguration=y}),define(oe[215],ae([0,1,6,3,2,22,16,74,214,58]),function(ee,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends D.Disposable{constructor(w,p,h,g){super(),this.i=w,this.h=this.B(new i.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new P.DefaultConfiguration),this.c=h instanceof S.NullPolicyService?new P.NullPolicyConfiguration:this.B(new P.PolicyConfiguration(this.b,h,g)),this.f=this.B(new R.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,p)),this.a=new R.Configuration(this.b.configurationModel,this.c.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.g=this.B(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:y,properties:l})=>this.k(y,l))),this.B(this.c.onDidChangeConfiguration(y=>this.l(y))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[w,p,h]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.Configuration(w,p,new R.ConfigurationModel,h)}getConfigurationData(){return this.a.toData()}getValue(w,p){const h=typeof w=="string"?w:void 0,g=(0,O.isConfigurationOverrides)(w)?w:(0,O.isConfigurationOverrides)(p)?p:{};return this.a.getValue(h,g,void 0)}updateValue(w,p,h,g){return Promise.reject(new Error("not supported"))}inspect(w){return this.a.inspect(w,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const w=await this.f.loadConfiguration();this.j(w)}j(w){const p=this.a.toData(),h=this.a.compareAndUpdateLocalUserConfiguration(w);this.m(h,p,2)}k(w,p){const h=this.a.toData(),g=this.a.compareAndUpdateDefaultConfiguration(w,p);this.m(g,h,7)}l(w){const p=this.a.toData(),h=this.a.compareAndUpdatePolicyConfiguration(w);this.m(h,p,7)}m(w,p,h){const g=new R.ConfigurationChangeEvent(w,{data:p},this.a);g.source=h,g.sourceConfig=this.n(h),this.h.fire(g)}n(w){switch(w){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(oe[216],ae([0,1,9,4]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var D;(function(O){O.Unknown="Unknown",O.NotAvailable="NotAvailable",O.TemporarilyNotAvailable="TemporarilyNotAvailable",O.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends k.ErrorNoTelemetry{static isNotAvailable(R){return R instanceof A&&R._code===D.NotAvailable}static isTemporarilyNotAvailable(R){return R instanceof A&&R._code===D.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof A&&R._code===D.NoResolverFound}static isHandled(R){return R instanceof A&&R.isHandled}constructor(R,P=D.Unknown,S){super(R),this._message=R,this._code=P,this._detail=S,this.isHandled=P===D.NotAvailable&&S===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(oe[75],ae([0,1,21]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(S){return S.scheme===k.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=i;function D(S){if(!S)return;const C=S.indexOf("+");return C<0?S:S.substr(0,C)}e.getRemoteName=D;function A(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=A;function O(S){const{host:C,port:E}=P(S);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:E}}e.parseAuthorityWithPort=O;function R(S,C){let{host:E,port:w}=P(S);return typeof w>"u"&&(w=C),{host:E,port:w}}e.parseAuthorityWithOptionalPort=R;function P(S){const C=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const E=S.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const w=S.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:S,port:void 0}}}),define(oe[42],ae([0,1,27,4,75]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=A;function O(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var P;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(g){this.value=g,this.c=g.toLowerCase()}static equals(g,y){if(typeof g>"u"||g===null)return typeof y>"u"||y===null;if(typeof y>"u"||y===null)return!1;if(typeof g=="string"||typeof y=="string"){const l=typeof g=="string"?g:g.value,d=typeof y=="string"?y:y.value;return k.equalsIgnoreCase(l,d)}return g.c===y.c}static toKey(g){return typeof g=="string"?g.toLowerCase():g.c}}e.ExtensionIdentifier=S;function C(h){return E(h)}e.isApplicationScopedExtension=C;function E(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function w(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function p(h,g){if(g){const y=`onResolveRemoteAuthority:${(0,D.getRemoteName)(g)}`;return h.activationEvents?.indexOf(y)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[33],ae([0,1,27,29,42,5,7,9,36]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function S(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,k.compareIgnoreCase)(s.id,t.id)===0}e.areSameExtensions=S;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(t){const r=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new E(t.identifier,r,o)}static parse(t){const r=C.exec(t);return r&&r[1]&&r[2]?new E({id:r[1]},r[2],r[4]||void 0):null}constructor(t,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof E?S(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=E;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(s){const t=w.exec(s);return t&&t[1]?[g(t[1]),t[2]]:[g(s),void 0]}e.getIdAndVersion=p;function h(s,t){return`${s}.${t}`}e.getExtensionId=h;function g(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function y(s,t){return g(h(s,t))}e.getGalleryExtensionId=y;function l(s,t){const r=[],o=c=>{for(const a of r)if(a.some(u=>S(t(u),t(c))))return a;return null};for(const c of s){const a=o(c);a?a.push(c):r.push([c])}return r}e.groupByExtension=l;function d(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=d;function m(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function v(s,t){const r=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(a=>!S(a.identifier,{id:c}))){const a=s.filter(u=>S(u.identifier,{id:c}));a.length===1&&(r.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=v;async function f(s,t){if(!A.isLinux)return!1;let r;try{r=(await s.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=f;async function n(s,t){const r=await f(s,t),o=(0,i.getTargetPlatform)(r?"alpine":A.platform,P.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=n}),define(oe[217],ae([0,1,24,33]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function D(A,O,R,P,S){try{const C=await A.getExtensionsControlManifest();if(!C.deprecated)return;const E=await A.getInstalled(1);for(const[w,p]of Object.entries(C.deprecated)){if(!p?.extension)continue;const{id:h,autoMigrate:g,preRelease:y}=p.extension;if(!g)continue;const l=E.find(m=>(0,i.areSameExtensions)(m.identifier,{id:w}));if(!l)continue;const d=(await O.getExtensions([{id:h,preRelease:y}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!d){S.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{S.info(`Migrating '${l.identifier.id}' extension to '${h}' extension...`);const m=!P.getDisabledExtensions().some(f=>(0,i.areSameExtensions)(f,l.identifier));await A.uninstall(l),S.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let v=E.find(f=>(0,i.areSameExtensions)(f.identifier,{id:h}));(!v||!v.isPreReleaseVersion&&m)&&(v=await A.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${v.identifier.id}'`),m||(await P.disableExtension(v.identifier),S.info(`Disabled the pre-release extension '${v.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),g.storage&&(R.addToMigrationList((0,i.getExtensionId)(l.manifest.publisher,l.manifest.name),(0,i.getExtensionId)(v.manifest.publisher,v.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${l.identifier.id}' extension to '${h}' extension.`)}catch(m){S.error(m)}}}catch(C){S.error(C)}}e.migrateUnsupportedExtensions=D}),define(oe[218],ae([0,1,6,9,2,21,5,22,53,13,31,28,16,15,29,33,97,14,8,25]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let v=class yt extends D.Disposable{constructor(n,s,t,r,o,c,a,u){super(),this.h=n,this.i=t,this.j=r,this.k=o,this.l=c,this.m=a,this.n=u,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.w()}async download(n,s){await this.g;const t=(0,R.joinPath)(this.extensionsDownloadDir,this.y(n));try{await this.u(n,t,o=>this.j.download(n,o,s))}catch(o){throw new h.ExtensionManagementError(o.message,h.ExtensionManagementErrorCode.Download)}let r=!1;if(await this.r(n)){const o=await this.t(n);try{r=await this.m.verify(t.fsPath,o.fsPath),this.n.info(`Verified extension: ${n.identifier.id}`,r)}catch(c){throw await this.delete(o),await this.delete(t),new h.ExtensionManagementError(c.code,h.ExtensionManagementErrorCode.Signature)}}return{location:t,verified:r}}async r(n){if(!n.isSigned||await this.h==="linux-armhf")return!1;const t=this.k.getValue("extensions.verifySignature");return(0,S.isBoolean)(t)?t:this.l.quality!=="stable"}async t(n){await this.g;const s=(0,R.joinPath)(this.extensionsDownloadDir,`${this.y(n)}${yt.c}`);return await this.u(n,s,t=>this.j.downloadSignatureArchive(n,t)),s}async u(n,s,t){if(await this.i.exists(s))return;if(s.scheme!==A.Schemas.file){await t(s);return}const r=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.i.exists(r)||await t(r);try{await this.v(r,s,Date.now()+2*60*1e3)}catch(o){try{await this.i.del(r)}catch{}if(o.code==="ENOTEMPTY")this.n.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,s.path);else throw this.n.info(`Rename failed because of ${(0,i.getErrorMessage)(o)}. Deleted the file from downloaded location`,r.path),o}}async delete(n){await this.g,await this.i.del(n)}async v(n,s,t){try{await E.Promises.rename(n.fsPath,s.fsPath)}catch(r){if(O.isWindows&&r&&r.code==="EPERM"&&Date.now()<t)return this.n.info(`Failed renaming ${n} to ${s} with 'EPERM' error. Trying again...`),this.v(n,s,t);throw r}}async w(){try{if(!await this.i.exists(this.extensionsDownloadDir)){this.n.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.i.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const s=[],t=[],r=[];for(const a of n.children)if(a.name.endsWith(yt.c))r.push(a.resource);else{const u=g.ExtensionKey.parse(a.name);u&&t.push([u,a])}const o=(0,g.groupByExtension)(t,([a])=>a),c=[];for(const a of o)a.sort((u,b)=>P.rcompare(u[0].version,b[0].version)),s.push(...a.slice(1).map(u=>u[1].resource)),c.push(a[0][1]);c.sort((a,u)=>a.mtime-u.mtime),s.push(...c.slice(0,Math.max(0,c.length-this.f)).map(a=>a.resource)),s.push(...r),await k.Promises.settled(s.map(a=>(this.n.trace("Deleting from cache",a.path),this.i.del(a))))}}catch(n){this.n.error(n)}}y(n){return this.f?g.ExtensionKey.create(n).toString().toLowerCase():(0,C.generateUuid)()}};v.c=".sigzip",v=pe([Y(1,p.INativeEnvironmentService),Y(2,l.IFileService),Y(3,h.IExtensionGalleryService),Y(4,w.IConfigurationService),Y(5,m.IProductService),Y(6,y.IExtensionSignatureVerificationService),Y(7,d.ILogService)],v),e.ExtensionsDownloader=v}),define(oe[219],ae([0,1,2,12,28,42]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends k.Disposable{constructor(P,S){super(),this.b=P,this.a=(0,i.join)(this.b.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this.B(S.onDidInstallExtensions(C=>this.c(C))),this.B(S.onDidUninstallExtension(C=>this.f(C)))}c(P){P.some(S=>!!S.local)&&this.invalidate()}f(P){P.error||this.invalidate()}invalidate(){D.Promises.rm(this.a,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(oe[220],ae([0,1,3,2,37,33,42]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends i.Disposable{constructor(S,C,E,w,p,h,g){super(),this.f=S,this.g=C,this.h=E,this.i=w,this.j=p,this.k=h,this.l=g,this.a=this.B(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new i.DisposableMap),this.m().then(null,y=>g.error(y))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(S=>this.p(S.added,S.removed))),this.B(this.i.onAddExtensions(S=>this.r(S))),this.B(this.i.onDidAddExtensions(S=>this.s(S))),this.B(this.i.onRemoveExtensions(S=>this.t(S))),this.B(this.i.onDidRemoveExtensions(S=>this.u(S))),this.B(this.k.onDidFilesChange(S=>this.v(S)))}async p(S,C){try{await Promise.all(C.map(E=>(this.c.deleteAndDispose(E.id),this.z(E.extensionsResource)))),S.length&&await Promise.all(S.map(E=>(this.c.set(E.id,(0,i.combinedDisposable)(this.k.watch(this.j.extUri.dirname(E.extensionsResource)),this.k.watch(E.extensionsResource))),this.y(E.extensionsResource))))}catch(E){throw this.l.error(E),E}}async r(S){for(const C of S.extensions)this.D(this.G(C.identifier,C.version),S.profileLocation)}async s(S){for(const C of S.extensions){const E=this.G(C.identifier,C.version);S.error?this.F(E,S.profileLocation):this.D(E,S.profileLocation)}}async t(S){for(const C of S.extensions)this.F(this.G(C.identifier,C.version),S.profileLocation)}async u(S){let C=!1;for(const E of S.extensions){const w=this.G(E.identifier,E.version);S.error?this.D(w,S.profileLocation):(this.F(w,S.profileLocation),C=C||!this.b.has(w))}C&&await this.C()}v(S){for(const C of this.h.profiles)S.contains(C.extensionsResource,0,1)&&this.w(C.extensionsResource)}async w(S){const C=[],E=[],w=await this.i.scanProfileExtensions(S),p=new Set,h=new Set;for(const[g,y]of this.b)y.has(S)&&h.add(g);for(const g of w){const y=this.G(g.identifier,g.version);p.add(y),h.has(y)||(C.push(g.identifier),this.D(y,S))}for(const g of h)if(!p.has(g)){const y=this.H(g);y&&(E.push(y.identifier),this.F(g,S))}(C.length||E.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:S}:void 0,removed:E.length?{extensions:E,profileLocation:S}:void 0})}async y(S){const C=await this.i.scanProfileExtensions(S);for(const E of C)this.D(this.G(E.identifier,E.version),S)}async z(S){for(const C of[...this.b.keys()])this.F(C,S);await this.C()}async C(){const C=(await this.f.getAllUserInstalled()).filter(E=>E.installedTimestamp&&!this.b.has(this.G(E.identifier,E.manifest.version)));C.length&&await this.f.markAsUninstalled(...C)}D(S,C){let E=this.b.get(S);E||this.b.set(S,E=new D.ResourceSet(w=>this.j.extUri.getComparisonKey(w))),E.add(C)}F(S,C){const E=this.b.get(S);E&&E.delete(C),E?.size||this.b.delete(S)}G(S,C){return`${O.ExtensionIdentifier.toKey(S.id)}@${C}`}H(S){const[C,E]=(0,A.getIdAndVersion)(S);return E?{identifier:{id:C},version:E}:void 0}}e.ExtensionsWatcher=R}),define(oe[221],ae([0,1,99,20,6,2,21,12,28,15,29,33,8,73,5,7]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends p.LanguagePackBaseService{constructor(v,f,n,s){super(n),this.h=v,this.i=s,this.g=this.B(new l(f,s)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(v){const n=(await this.g.getLanguagePacks())[h.Language.value()];if(!n){this.i.warn(`No language pack found for ${h.Language.value()}`);return}const s=n.translations[v];return s?g.URI.file(s):void 0}async getInstalledLanguages(){const v=await this.g.getLanguagePacks(),f=Object.keys(v).map(n=>{const s=v[n];return{...this.f(n,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return f.push({...this.f("en","English"),extensionId:"default"}),f.sort((n,s)=>n.label.localeCompare(s.label)),f}async j(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",v.identifier.id),await this.update())}async k(v){const f=await this.g.getLanguagePacks();Object.keys(f).some(n=>f[n]&&f[n].extensions.some(s=>(0,E.areSameExtensions)(s.extensionIdentifier,v.identifier)))&&(this.i.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,f]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),n=await this.g.update(f);return!(0,i.equals)(Object.keys(v),Object.keys(n))}};y=pe([Y(0,C.IExtensionManagementService),Y(1,S.INativeEnvironmentService),Y(2,C.IExtensionGalleryService),Y(3,w.ILogService)],y),e.NativeLanguagePackService=y;let l=class extends A.Disposable{constructor(v,f){super(),this.i=f,this.c={},this.f=(0,R.join)(v.userDataPath,"languagepacks.json"),this.g=new D.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(v){return this.m(f=>{Object.keys(f).forEach(n=>delete f[n]),this.j(f,...v)}).then(()=>this.c)}j(v,...f){for(const n of f)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.k(v,n);Object.keys(v).forEach(n=>this.l(v[n]))}k(v,f){const n=f.identifier,s=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const t of s)if(f.location.scheme===O.Schemas.file&&d(t)){let r=v[t.languageId];r||(r={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},v[t.languageId]=r);const o=r.extensions.filter(c=>(0,E.areSameExtensions)(c.extensionIdentifier,n))[0];o?o.version=f.manifest.version:r.extensions.push({extensionIdentifier:n,version:f.manifest.version});for(const c of t.translations)r.translations[c.id]=(0,R.join)(f.location.fsPath,c.path)}}l(v){if(v){const f=(0,k.createHash)("md5");for(const n of v.extensions)f.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);v.hash=f.digest("hex")}}m(v=()=>null){return this.g.queue(()=>{let f=null;return P.Promises.readFile(this.f,"utf8").then(void 0,n=>n.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(n)).then(n=>{try{return JSON.parse(n)}catch{return{}}}).then(n=>(f=v(n),n)).then(n=>{for(const t of Object.keys(n))n[t]||delete n[t];this.c=n,this.h=!0;const s=JSON.stringify(this.c);return this.i.debug("Writing language packs",s),P.Promises.writeFile(this.f,s)}).then(()=>f,n=>this.i.error(n))})}};l=pe([Y(0,S.INativeEnvironmentService),Y(1,w.ILogService)],l);function d(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const v of m.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(oe[222],ae([0,1,6,17,24,9,3,2,31,92,216,75]),function(ee,e,k,i,D,A,O,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const w=30*1e3;var p;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(p=e.ConnectionType||(e.ConnectionType={}));function h(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(J){const x=new D.CancellationTokenSource;return setTimeout(()=>x.cancel(),J),x.token}function y(J,x){if(J.isCancellationRequested||x.isCancellationRequested)return D.CancellationToken.Cancelled;const T=new D.CancellationTokenSource;return J.onCancellationRequested(()=>T.cancel()),x.onCancellationRequested(()=>T.cancel()),T.token}class l{get didTimeout(){return this.c==="timedout"}constructor(x){this.c="pending",this.d=new R.DisposableStore,this.promise=new Promise((T,U)=>{this.f=T,this.g=U}),x.isCancellationRequested?this.h():this.d.add(x.onCancellationRequested(()=>this.h()))}registerDisposable(x){this.c==="pending"?this.d.add(x):x.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const x=new Error("Time limit reached");return x.code="ETIMEDOUT",x.syscall="connect",x}resolve(x){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(x))}reject(x){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(x))}}function d(J,x){const T=new l(x);return T.registerDisposable(J.onControlMessage(U=>{const H=JSON.parse(U.toString()),B=K(H);B?T.reject(B):T.resolve(H)})),T.promise}function m(J,x,T,U,H,B,Q,re){const X=new l(re);return x.connect(T,U,H,B,Q,(te,se)=>{X.didTimeout?(te&&J.error(te),se?.dispose()):te||!se?X.reject(te):X.resolve(se)}),X.promise}function v(J,x){const T=new l(x);return J.then(U=>{T.didTimeout||T.resolve(U)},U=>{T.didTimeout||T.reject(U)}),T.promise}async function f(J,x,T,U){const H=Z(J,x);J.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let B;try{B=await m(J.logService,J.socketFactory,J.host,J.port,(0,E.getRemoteServerRootPath)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,`renderer-${h(x)}-${J.reconnectionToken}`,U)}catch(se){throw J.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),J.logService.error(se),se}J.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let Q,re;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(B,null),Q=J.reconnectionProtocol,re=!1):(Q=new S.PersistentProtocol(B,null),re=!0),J.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const X=await v(J.signService.createNewMessage((0,P.generateUuid)()),U),te={type:"auth",auth:J.connectionToken||"00000000000000000000",data:X.data};Q.sendControl(i.VSBuffer.fromString(JSON.stringify(te)));try{const se=await d(Q,y(U,g(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(J.logService.trace(`${H} 4/6. received SignRequest control message.`),!await v(J.signService.validate(X,se.signedData),U)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const ue=await v(J.signService.sign(se.data),U),ye={type:"connectionType",commit:J.commit,signedData:ue,desiredConnectionType:x};return T&&(ye.args=T),J.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),Q.sendControl(i.VSBuffer.fromString(JSON.stringify(ye))),{protocol:Q,ownsProtocol:re}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(J.logService.error(`${H} the handshake timed out. Error:`),J.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${H} received error control message when negotiating connection. Error:`),J.logService.error(se)),re&&_(Q),se}}async function n(J,x,T,U){const H=Date.now(),B=Z(J,x),{protocol:Q,ownsProtocol:re}=await f(J,x,T,U),X=new l(U);return X.registerDisposable(Q.onControlMessage(te=>{const se=JSON.parse(te.toString()),le=K(se);le?(J.logService.error(`${B} received error control message when negotiating connection. Error:`),J.logService.error(le),re&&_(Q),X.reject(le)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${ne(H)}!`),X.resolve({protocol:Q,firstMessage:se}))})),X.promise}async function s(J,x){const{protocol:T}=await n(J,1,void 0,x);return{protocol:T}}async function t(J,x,T){const{protocol:U,firstMessage:H}=await n(J,2,x,T),B=H&&H.debugPort;return{protocol:U,debugPort:B}}async function r(J,x,T){const U=Date.now(),H=Z(J,3),{protocol:B}=await f(J,3,x,T);return J.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${ne(U)}!`),B}async function o(J,x,T){const{host:U,port:H,connectionToken:B}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,host:U,port:H,connectionToken:B,reconnectionToken:x,reconnectionProtocol:T,socketFactory:J.socketFactory,signService:J.signService,logService:J.logService}}async function c(J,x,T){return u(J,async U=>{const{protocol:H}=await s(U,D.CancellationToken.None);return new G(J,x,T,U.reconnectionToken,H)})}e.connectRemoteAgentManagement=c;async function a(J,x){return u(J,async T=>{const{protocol:U,debugPort:H}=await t(T,x,D.CancellationToken.None);return new W(J,x,T.reconnectionToken,U,H)})}e.connectRemoteAgentExtensionHost=a;async function u(J,x){for(let U=1;;U++)try{const H=(0,P.generateUuid)(),B=await o(J,H,null);return await x(B)}catch(H){if(U<5)J.logService.error(`[remote-connection][attempt ${U}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(H);else throw J.logService.error(`[remote-connection][attempt ${U}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(H),z.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(H)),H}}async function b(J,x,T){const U=await o(J,(0,P.generateUuid)(),null);return await r(U,{host:x,port:T},D.CancellationToken.None)}e.connectRemoteAgentTunnel=b;function I(J){return(0,k.createCancelablePromise)(x=>new Promise((T,U)=>{const H=setTimeout(T,J*1e3);x.onCancellationRequested(()=>{clearTimeout(H),T()})}))}var F;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class N{constructor(x,T){this.reconnectionToken=x,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=N;class ${constructor(x,T,U,H){this.reconnectionToken=x,this.millisSinceLastIncomingData=T,this.durationSeconds=U,this.c=H,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=$;class j{constructor(x,T,U){this.reconnectionToken=x,this.millisSinceLastIncomingData=T,this.attempt=U,this.type=2}}e.ReconnectionRunningEvent=j;class L{constructor(x,T,U){this.reconnectionToken=x,this.millisSinceLastIncomingData=T,this.attempt=U,this.type=4}}e.ConnectionGainEvent=L;class M{constructor(x,T,U,H){this.reconnectionToken=x,this.millisSinceLastIncomingData=T,this.attempt=U,this.handled=H,this.type=3}}e.ReconnectionPermanentFailureEvent=M;class z extends R.Disposable{static triggerPermanentFailure(x,T,U){this._permanentFailure=!0,this.f=x,this.g=T,this.h=U,this.i.forEach(H=>H.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(x=>x.r())}static debugPauseSocketWriting(){this.i.forEach(x=>x.v())}get k(){return this.c||z._permanentFailure}constructor(x,T,U,H,B){super(),this.m=x,this.n=T,this.reconnectionToken=U,this.protocol=H,this.p=B,this.j=this.B(new O.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new L(this.reconnectionToken,0,0)),this.B(H.onSocketClose(Q=>{const re=V(this.m,this.reconnectionToken,!0);Q?Q.type===0?(this.n.logService.info(`${re} received socket close event (hadError: ${Q.hadError}).`),Q.error&&this.n.logService.error(Q.error)):(this.n.logService.info(`${re} received socket close event (wasClean: ${Q.wasClean}, code: ${Q.code}, reason: ${Q.reason}).`),Q.event&&this.n.logService.error(Q.event)):this.n.logService.info(`${re} received socket close event.`),this.r()})),this.B(H.onSocketTimeout(Q=>{const re=V(this.m,this.reconnectionToken,!0);this.n.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${Q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Q.timeSinceLastReceivedSomeData}).`),this.r()})),z.i.push(this),this.B((0,R.toDisposable)(()=>{const Q=z.i.indexOf(this);Q>=0&&z.i.splice(Q,1)})),this.k&&this.u(z.f,z.g,z.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const x=V(this.m,this.reconnectionToken,!0);this.n.logService.info(`${x} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let U=-1;do{U++;const H=U<T.length?T[U]:T[T.length-1];try{if(H>0){const Q=I(H);this.j.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,Q)),this.n.logService.info(`${x} waiting for ${H} seconds before reconnecting...`);try{await Q}catch{}}if(this.k){this.n.logService.error(`${x} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1)),this.n.logService.info(`${x} resolving connection...`);const B=await o(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${x} connecting to ${B.host}:${B.port}...`),await this.w(B,g(w)),this.n.logService.info(`${x} reconnected!`),this.j.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${x} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(U>360){this.n.logService.error(`${x} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this.n.logService.info(`${x} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this.n.logService.info(`${x} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(B);continue}if((0,A.isCancellationError)(B)){this.n.logService.info(`${x} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(B);continue}if(B instanceof C.RemoteAuthorityResolverError){this.n.logService.error(`${x} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),U+1,C.RemoteAuthorityResolverError.isHandled(B));break}this.n.logService.error(`${x} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}}while(!this.k)}t(x,T,U){this.p?z.triggerPermanentFailure(x,T,U):this.u(x,T,U)}u(x,T,U){this.j.fire(new M(this.reconnectionToken,x,T,U)),_(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=z,z._permanentFailure=!1,z.f=0,z.g=0,z.h=!1,z.i=[];class G extends z{constructor(x,T,U,H,B){super(1,x,H,B,!0),this.client=this.B(new S.Client(B,{remoteAuthority:T,clientId:U},x.ipcLogger))}async w(x,T){await s(x,T)}}e.ManagementPersistentConnection=G;class W extends z{constructor(x,T,U,H,B){super(2,x,U,H,!1),this.y=T,this.debugPort=B}async w(x,T){await t(x,this.y,T)}}e.ExtensionHostPersistentConnection=W;function _(J){try{J.acceptDisconnect();const x=J.getSocket();J.dispose(),x.dispose()}catch(x){(0,A.onUnexpectedError)(x)}}function K(J){if(J&&J.type==="error"){const x=new Error(`Connection error: ${J.reason}`);return x.code="VSCODE_CONNECTION_ERROR",x}return null}function q(J,x){for(;J.length<x;)J+=" ";return J}function V(J,x,T){return`[remote-connection][${q(h(J),13)}][${x.substr(0,5)}\u2026][${T?"reconnect":"initial"}]`}function Z(J,x){return`${V(x,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.host}:${J.port}]`}function ne(J){return`${Date.now()-J} ms`}}),define(oe[223],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[224],ae([0,1,86,149]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,A,O,R,P,S){const C=w=>S(w,void 0),E=k.createConnection({host:D,port:A},()=>{E.removeListener("error",C);const w=Buffer.alloc(16);for(let y=0;y<16;y++)w[y]=Math.round(Math.random()*256);const p=w.toString("base64"),h=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${A}${O}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`];E.write(h.join(`\r
`)+`\r
\r
`);const g=y=>{y.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",g),S(void 0,new i.NodeSocket(E,P)))};E.on("data",g)});E.setNoDelay(!0),E.once("error",C)}}}),define(oe[105],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,k.createDecorator)("IRemoteTunnelService");var i;(function(D){D.disconnected={type:"disconnected"},D.uninitialized={type:"uninitialized"},D.connected=A=>({type:"connected",info:A}),D.connecting=A=>({type:"connecting",progress:A})})(i=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME="remoteTunnelService",e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(oe[225],ae([0,1,132,16,8]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(R,P){this.a=R,this.b=P}async request(R,P){this.b.trace("RequestService#request (browser) - begin",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const S=await(0,k.request)(R,P);return this.b.trace("RequestService#request (browser) - success",R.url),S}catch(S){throw this.b.error("RequestService#request (browser) - error",R.url,S),S}}async resolveProxy(R){}};A=pe([Y(0,i.IConfigurationService),Y(1,D.ILogService)],A),e.RequestService=A}),define(oe[59],ae([0,1,17,168,46,4,40]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function R(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=R;function P(g){return g.res.statusCode===204}async function S(g){return P(g)?null:(await(0,k.streamToBuffer)(g.stream)).toString()}e.asText=S;async function C(g){if(!R(g))throw new Error("Server returned "+g.res.statusCode);return S(g)}e.asTextOrError=C;async function E(g){if(!R(g))throw new Error("Server returned "+g.res.statusCode);if(P(g))return null;const l=(await(0,k.streamToBuffer)(g.stream)).toString();try{return JSON.parse(l)}catch(d){throw d.message+=`:
`+l,d}}e.asJson=E;function w(g){h(g)}e.updateProxyConfigurationsScope=w;let p;function h(g){const y=O.Registry.as(D.Extensions.Configuration),l=p;p={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[p],remove:l?[l]:[]})}h(2)}),define(oe[226],ae([0,1,24,21,14,59]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(P,S){this.a=P,this.b=S}async download(P,S,C=k.CancellationToken.None){if(P.scheme===i.Schemas.file||P.scheme===i.Schemas.vscodeRemote){await this.b.copy(P,S);return}const E={type:"GET",url:P.toString(!0)},w=await this.a.request(E,C);if(w.res.statusCode===200)await this.b.writeFile(S,w.stream);else{const p=await(0,A.asTextOrError)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${p}`)}}};O=pe([Y(0,A.IRequestService),Y(1,D.IFileService)],O),e.DownloadService=O}),define(oe[227],ae([0,1,17,24]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(R){this.a=R}listen(R,P){throw new Error("Invalid listen")}call(R,P,S,C=i.CancellationToken.None){switch(P){case"request":return this.a.request(S[0],C).then(async({res:E,stream:w})=>{const p=await(0,k.streamToBuffer)(w);return[{statusCode:E.statusCode,headers:E.headers},p]});case"resolveProxy":return this.a.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class A{constructor(R){this.a=R}async request(R,P){const[S,C]=await this.a.call("request",[R],P);return{res:S,stream:(0,k.bufferToStream)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.RequestChannelClient=A}),define(oe[228],ae([0,1,13,225,227]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class A{constructor(R,P,S,C){this.c=P,this.d=S,this.e=C,this.a=new i.RequestService(P,C),this.b=new D.RequestChannelClient(R.getChannel("request"))}request(R,P){return this.f().request(R,P)}async resolveProxy(R){return this.f().resolveProxy(R)}f(){return this.g()?(this.e.trace("Using main request service"),this.b):(this.e.trace("Using browser request service"),this.a)}g(){const R=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,k.isBoolean)(R)?R:this.d.quality!=="stable"}}e.SharedProcessRequestService=A}),define(oe[106],ae([0,1,66,4]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(A){return(0,k.hash)({moduleId:A.process.moduleId,windowId:A.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(oe[229],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(oe[230],ae([0,1,93,6,24,3,2,21,31,8,106,229]),function(ee,e,k,i,D,A,O,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let w=class{constructor(g){this.d=g,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(g){const y=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${y})`);const l=(0,C.hash)(g);this.b.has(l)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${y})`),this.f(g));const d=new D.CancellationTokenSource;let m,v,f;this.b.set(l,r=>{d.dispose(!0),m?.terminate(g,D.CancellationToken.None),v?.close(),f?.close(),this.b.delete(l);const o=this.c.get(l);o&&(this.c.delete(l),o({reason:r}))}),m=await this.e(g);const n=new Promise(r=>{this.c.set(l,r)});if(d.token.isCancellationRequested)return n;const{port1:s,port2:t}=new MessageChannel;return v=s,f=t,await m.spawn(g,f,d.token),d.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${y})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",g,[v])),n}e(g){let y=this.a.get(g.process.moduleId);if(!y){this.d.trace(`SharedProcess: creating new web worker (${g.process.moduleId})`);const l=new p(g.process.type,this.d);y=l.init(),l.onDidProcessSelfTerminate(({configuration:d,reason:m})=>{this.f(d,m)}),this.a.set(g.process.moduleId,y)}return y}async disposeWorker(g){return this.f(g)}f(g,y){const l=this.b.get((0,C.hash)(g));l&&(this.d.trace(`SharedProcess: disposeWorker (window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),l(y))}};w=pe([Y(0,S.ILogService)],w),e.SharedProcessWorkerService=w;class p extends O.Disposable{constructor(g,y){super(),this.f=g,this.g=y,this.a=this.B(new A.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const g=new i.DeferredPromise,y=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return y.onerror=l=>{this.g.error(`SharedProcess: worker error (${this.f})`,l.message)},y.onmessageerror=l=>{this.g.error(`SharedProcess: worker message error (${this.f})`,l)},y.onmessage=l=>{const{id:d,message:m,configuration:v,nonce:f}=l.data;switch(d){case E.SharedProcessWorkerMessages.Ready:g.complete(y);break;case E.SharedProcessWorkerMessages.Ack:if(f){const n=this.c.get(f);n&&(this.c.delete(f),n())}break;case E.SharedProcessWorkerMessages.SelfTerminated:v&&m&&this.a.fire({configuration:v,reason:JSON.parse(m)});break;case E.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,m);break;case E.SharedProcessWorkerMessages.Info:m&&this.g.info(m);break;case E.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,m);break;case E.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,m);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,l)}},y.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),g.p}async i(g,y,l){const d=await this.b;if(!y.isCancellationRequested)return new Promise(m=>{const v=(0,P.generateUuid)();this.c.set(v,m);const f={...g,nonce:v};l?d.postMessage(f,[l]):d.postMessage(f),y.onCancellationRequested(()=>{this.c.delete(v)&&m()})})}spawn(g,y,l){const d={id:E.SharedProcessWorkerMessages.Spawn,configuration:g,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(d,l,y)}terminate(g,y){const l={id:E.SharedProcessWorkerMessages.Terminate,configuration:g};return this.i(l,y)}}}),define(oe[231],ae([0,1,63,21,185]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends D.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.vscodeUserData})}}pe([k.memoize],A.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=A}),define(oe[232],ae([0,1,49,12,169,24,38,9,5,31,146,183,6]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let h;async function g(l,d,m){return d["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(m)&&!d["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(m)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=w.Promises.withAsyncBody(async(v,f)=>{const n=new A.CancellationTokenSource,s=setTimeout(()=>{n.dispose(!0),f(new Error((0,D.localize)(0,null)))},p);try{v(await y(l,n.token))}catch(t){!(0,R.isCancellationError)(t)&&!n.token.isCancellationRequested?f(new Error((0,D.localize)(1,null,(0,O.toErrorMessage)(t)))):v({})}finally{clearTimeout(s),n.dispose()}})),h)}e.getResolvedShellEnv=g;async function y(l,d){const m=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",m);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",v);const f=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(f+"({.*})"+f),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",s);const t=await(0,C.getSystemShell)(P.OS,s);return l.trace("getUnixShellEnvironment#shell",t),new Promise((r,o)=>{if(d.isCancellationRequested)return o((0,R.canceled)());const c=(0,i.basename)(t);let a,u;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${b} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,u=["-Login","-Command"]):(a=`'${process.execPath}' ${b} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,c==="tcsh"?u=["-ic"]:u=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),a);const I=(0,k.spawn)(t,[...u,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});d.onCancellationRequested(()=>(I.kill(),o((0,R.canceled)()))),I.on("error",$=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)($)),o($)});const F=[];I.stdout.on("data",$=>F.push($));const N=[];I.stderr.on("data",$=>N.push($)),I.on("close",($,j)=>{const L=Buffer.concat(F).toString("utf8");l.trace("getUnixShellEnvironment#raw",L);const M=Buffer.concat(N).toString("utf8");if(M.trim()&&l.trace("getUnixShellEnvironment#stderr",M),$||j)return o(new Error((0,D.localize)(2,null,$,j)));const z=n.exec(L),G=z?z[1]:"{}";try{const W=JSON.parse(G);m?W.ELECTRON_RUN_AS_NODE=m:delete W.ELECTRON_RUN_AS_NODE,v?W.ELECTRON_NO_ATTACH_CONSOLE=v:delete W.ELECTRON_NO_ATTACH_CONSOLE,delete W.VSCODE_RESOLVING_ENVIRONMENT,delete W.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",W),r(W)}catch(W){l.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(W)),o(W)}})})}}),define(oe[107],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[233],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.b=new Map}c(){return new Promise((D,A)=>ee(["vsda"],D,A))}async createNewMessage(D){try{const A=await this.c(),O=new A.validator;if(O){const R=String(k.a++);return this.b.set(R,O),{id:R,data:O.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,A){if(!D.id)return!0;const O=this.b.get(D.id);if(!O)return!1;this.b.delete(D.id);try{return O.validate(A)==="ok"}catch{return!1}}async sign(D){try{const A=await this.c(),O=new A.signer;if(O)return O.sign(D)}catch{}return D}}e.SignService=k,k.a=1}),define(oe[76],ae([0,1,3,2]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class D extends i.Disposable{constructor(E,w,p){super(),this.a=E,this.b=w,this.c=p}async getItems(){const E={profile:this.b,workspace:this.c},w=await this.a.call("getItems",E);return new Map(w)}updateItems(E){const w={profile:this.b,workspace:this.c};return E.insert&&(w.insert=Array.from(E.insert.entries())),E.delete&&(w.delete=Array.from(E.delete.values())),this.a.call("updateItems",w)}}class A extends D{constructor(E,w){super(E,w,void 0),this.f=this.B(new k.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class O extends A{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=O;class R extends A{constructor(E,w){super(E,w)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class P extends D{constructor(E,w){super(E,void 0,w),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P;class S{constructor(E){this.a=E}isUsed(E){const w={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",w)}}e.StorageClient=S}),define(oe[108],ae([0,1,5,36,7,31]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(S){if(k.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function R(S,C,E,w,p,h,g,y,l,d){const m=Object.create(null);m["common.machineId"]=g,m.sessionID=(0,A.generateUuid)()+Date.now(),m.commitHash=p,m.version=h,m["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,k.PlatformToString)(k.platform),m["common.nodePlatform"]=i.platform,m["common.nodeArch"]=w,m["common.product"]=d||"desktop",y&&(m["common.msftInternal"]=y);let v=0;const f=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),k.isLinuxSnap&&(m["common.snap"]="true");const n=O(E);n&&(m["common.platformDetail"]=n);try{const s=await S.readFile(D.URI.file(l));m["common.source"]=s.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=R;function P(S){const C=i.env.USERDNSDOMAIN;if(!C)return!1;const E=C.toLowerCase();return S.some(w=>E===w)}e.verifyMicrosoftInternalDomain=P}),define(oe[23],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(oe[234],ae([0,1,34,6,35,21,12,5,7,143,28,145,95,14,25,23]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const y=new Map;async function l(n,s){const t=`${n}::${s.join(":")}`,r=y.get(t);if(r)return r;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,a=new Map,u=2e4;function b(F,N,$,j){const L=N.substring(F.length+1);return i.Promises.withAsyncBody(async M=>{let z;try{z=await C.Promises.readdir(N,{withFileTypes:!0})}catch{M();return}if(j.count>=u){j.count+=z.length,j.maxReached=!0,M();return}let G=z.length;if(G===0){M();return}let W=z;j.count+z.length>u&&(j.maxReached=!0,G=u-j.count,W=z.slice(0,G)),j.count+=z.length;for(const _ of W)if(_.isDirectory()){if($.includes(_.name)||await b(F,(0,O.join)(N,_.name),$,j),--G===0){M();return}}else{const K=_.name.lastIndexOf(".");if(K>=0){const q=_.name.substring(K+1);q&&c.set(q,(c.get(q)??0)+1)}for(const q of o)q.relativePathPattern?.test(L)!==!1&&q.filePattern.test(_.name)&&a.set(q.tag,(a.get(q.tag)??0)+1);if(--G===0){M();return}}})}const I=i.Promises.withAsyncBody(async F=>{const N={count:0,maxReached:!1};await b(n,n,s,N);const $=await v(n);F({configFiles:d(a),fileTypes:d(c),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:$})});return y.set(t,I),I}e.collectWorkspaceStats=l;function d(n){return Array.from(n.entries(),([s,t])=>({name:s,count:t})).sort((s,t)=>t.count-s.count)}function m(){const n={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},s=k.cpus();return s&&s.length>0&&(n.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),n}e.getMachineInfo=m;async function v(n){try{const s=new Map,t=(0,O.join)(n,".vscode","launch.json"),r=await C.Promises.readFile(t),o=[],c=(0,D.parse)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${t}`),[];if((0,D.getNodeType)(c)==="object"&&c.configurations)for(const a of c.configurations){const u=a.type;u&&(s.has(u)?s.set(u,s.get(u)+1):s.set(u,1))}return d(s)}catch{return[]}}e.collectLaunchConfigs=v;let f=class{constructor(s,t){this.c=s,this.d=t}f(s){const t=[];return t.push(`OS Version:       ${s.os}`),t.push(`CPUs:             ${s.cpus}`),t.push(`Memory (System):  ${s.memory}`),t.push(`VM:               ${s.vmHint}`),t.join(`
`)}g(s){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const r=k.cpus();return r&&r.length>0&&t.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),t.push(`Memory (System):  ${(k.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||t.push(`Load (avg):       ${k.loadavg().map(o=>Math.round(o)).join(", ")}`),t.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${s.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(s,t){return Promise.all([(0,E.listProcesses)(s.mainPID),this.k(s)]).then(async r=>{let[o,c]=r,a=this.m(s,o);return t.forEach(u=>{if((0,w.isRemoteDiagnosticError)(u))a+=`
${u.errorMessage}`,c+=`
${u.errorMessage}`;else if(a+=`

Remote: ${u.hostName}`,u.processes&&(a+=`
${this.m(s,u.processes)}`),u.workspaceMetadata){c+=`
|  Remote: ${u.hostName}`;for(const b of Object.keys(u.workspaceMetadata)){const I=u.workspaceMetadata[b];let F=`${I.fileCount} files`;I.maxFilesReached&&(F=`more than ${F}`),c+=`|    Folder (${b}): ${F}`,c+=this.h(I)}}}),{processInfo:a,workspaceInfo:c}})}async getSystemInfo(s,t){const{memory:r,vmHint:o,os:c,cpus:a}=m(),u={os:c,memory:r,cpus:a,vmHint:o,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:t};return R.isWindows||(u.load=`${k.loadavg().map(b=>Math.round(b)).join(", ")}`),R.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(s,t){const r=[];return(0,E.listProcesses)(s.mainPID).then(async o=>(r.push(""),r.push(this.g(s)),r.push(""),r.push(this.m(s,o)),s.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(s))),t.forEach(c=>{if((0,w.isRemoteDiagnosticError)(c))r.push(`
${c.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${c.hostName}`),r.push(this.f(c.machineInfo)),c.processes&&r.push(this.m(s,c.processes)),c.workspaceMetadata)for(const a of Object.keys(c.workspaceMetadata)){const u=c.workspaceMetadata[a];let b=`${u.fileCount} files`;u.maxFilesReached&&(b=`more than ${b}`),r.push(`Folder (${a}): ${b}`),r.push(this.h(u))}}),r.push(""),r.push(""),r.join(`
`)))}h(s){const t=[];let o=0;const c=(I,F)=>{const N=` ${I}(${F})`;o+N.length>60?(t.push(a),a="|                 ",o=a.length):o+=N.length,a+=N};let a="|      File types:";const u=10,b=s.fileTypes.length>u?u:s.fileTypes.length;for(let I=0;I<b;I++){const F=s.fileTypes[I];c(F.name,F.count)}if(t.push(a),s.configFiles.length>=0&&(a="|      Conf files:",o=0,s.configFiles.forEach(I=>{c(I.name,I.count)}),t.push(a)),s.launchConfigFiles.length>0){let I="|      Launch Configs:";s.launchConfigFiles.forEach(F=>{I+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),t.push(I)}return t.join(`
`)}j(s){const t=Math.max(...Object.keys(s).map(r=>r.length));return Object.keys(s).map(r=>`${r}:  ${" ".repeat(t-r.length)}  ${s[r]}`).join(`
                  `)}k(s){const t=[],r=[];return s.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(t.push(`|  Window (${o.title})`),o.folderURIs.forEach(c=>{const a=P.URI.revive(c);if(a.scheme===A.Schemas.file){const u=a.fsPath;r.push(l(u,["node_modules",".git"]).then(b=>{let I=`${b.fileCount} files`;b.maxFilesReached&&(I=`more than ${I}`),t.push(`|    Folder (${(0,O.basename)(u)}): ${I}`),t.push(this.h(b))}).catch(b=>{t.push(`|      Error: Unable to collect workspace stats for folder ${u} (${b.toString()})`)}))}else t.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>t.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(s,t){const r=new Map;s.windows.forEach(c=>r.set(c.pid,c.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),t&&this.n(s.mainPID,r,o,t,0),o.join(`
`)}n(s,t,r,o,c){const a=c===0;let u;a?u=o.pid===s?`${this.d.applicationName} main`:"remote agent":(u=`${"  ".repeat(c)} ${o.name}`,o.name==="window"&&(u=`${u} (${t.get(o.pid)})`));const b=process.platform==="win32"?o.mem:k.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(b/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(o.children)&&o.children.forEach(I=>this.n(s,t,r,I,c+1))}async getWorkspaceFileExtensions(s){const t=new Set;for(const{uri:r}of s.folders){const o=P.URI.revive(r);if(o.scheme!==A.Schemas.file)continue;const c=o.fsPath;try{(await l(c,["node_modules",".git"])).fileTypes.forEach(u=>t.add(u.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(s){for(const{uri:t}of s.folders){const r=P.URI.revive(t);if(r.scheme!==A.Schemas.file)continue;const o=r.fsPath;try{const c=await l(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),c.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:a.name,count:a.count})}),c.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:a.name,count:a.count})}),c.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};f=pe([Y(0,g.ITelemetryService),Y(1,h.IProductService)],f),e.DiagnosticsService=f}),define(oe[235],ae([0,1,105,3,23,15,2,8,12,49,25,5,6,101,16,167,34,7]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let d=class extends O.Disposable{constructor(v,f,n,s,t,r){super(),this.p=v,this.r=f,this.s=n,this.t=r,this.b=new i.Emitter,this.onDidTokenFailed=this.b.event,this.c=new i.Emitter,this.onDidChangeTunnelStatus=this.c.event,this.f=new i.Emitter,this.onDidChangeAccount=this.f.event,this.j=k.TunnelStates.disconnected;const o=l.URI.file((0,P.join)(n.logsPath,k.LOG_FILE_NAME));this.g=this.B(s.createLogger(o,{name:k.LOGGER_NAME})),this.k=new w.Delayer(100),this.B(this.g.onDidChangeLogLevel(c=>this.g.info("Log level changed to "+(0,R.LogLevelToString)(c)))),this.B(t.onWillShutdown(c=>{this.i&&(this.i.cancel(),this.i=void 0),this.dispose()})),this.B(r.onDidChangeConfiguration(c=>{c.affectsConfiguration(k.CONFIGURATION_KEY_HOST_NAME)&&this.k.trigger(()=>this.v())}))}async getAccount(){return this.h}async updateAccount(v){if(v&&this.h?v.token!==this.h.token||v.providerId!==this.h.providerId:v!==this.h){this.h=v,this.f.fire(v),v?this.g.info(`Account updated: ${v.accountLabel} (${v.providerId})`):this.g.info("Account reset"),this.p.publicLog2("remoteTunnel.enablement",{enabled:!!v});try{await this.k.trigger(()=>this.v())}catch(f){this.g.error(f)}}return this.j}u(){if(!this.n){let v;E.isMacintosh?v=this.s.appRoot:v=(0,P.dirname)((0,P.dirname)(this.s.appRoot)),this.n=(0,P.join)(v,"bin",`${this.r.tunnelApplicationName}${E.isWindows?".exe":""}`)}return this.n}async v(){if(this.i&&(this.i.cancel(),this.i=void 0),!this.h){this.w(k.TunnelStates.disconnected);return}const{token:v,providerId:f,accountLabel:n}=this.h;this.w(k.TunnelStates.connecting((0,g.localize)(0,null,n,f)));const s=(a,u)=>{a=a.replaceAll(v,"*".repeat(4)),u?this.g.error(a):this.g.info(a),!this.s.isBuilt&&a.startsWith("   Compiling")&&this.w(k.TunnelStates.connecting((0,g.localize)(1,null)))},t=this.y("login",["user","login","--provider",f,"--access-token",v,"--log",(0,R.LogLevelToString)(this.g.getLevel())],s);this.i=t;try{if(await t,this.i!==t)return}catch(a){this.g.error(a),this.i=void 0,this.b.fire(!0),this.w(k.TunnelStates.disconnected);return}const r=this.z();r?this.w(k.TunnelStates.connecting((0,g.localize)(2,null,r))):this.w(k.TunnelStates.connecting((0,g.localize)(3,null)));const o=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,R.LogLevelToString)(this.g.getLevel())];r?o.push("--name",r):o.push("--random-name");const c=this.y("tunnel",o,(a,u)=>{u?this.g.error(a):this.g.info(a);const b=a.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(b){const I={link:b[1],domain:b[2],hostName:b[4]};this.w(k.TunnelStates.connected(I))}else a.match(/error refreshing token/)&&(c.cancel(),this.b.fire(!0),this.w(k.TunnelStates.disconnected))});this.i=c,c.finally(()=>{c===this.i&&(this.g.info("tunnel process terminated"),this.i=void 0,this.h=void 0,this.w(k.TunnelStates.disconnected))})}async getTunnelStatus(){return this.j}w(v){this.j=v,this.c.fire(v)}y(v,f,n=()=>{}){return(0,w.createCancelablePromise)(s=>new Promise((t,r)=>{s.isCancellationRequested&&t();let o;if(s.onCancellationRequested(()=>{o&&(this.g.info(`${v} terminating(${o.pid})`),o.kill())}),!this.s.isBuilt)n("Building tunnel CLI from sources and run",!1),n(`${v} Spawning: cargo run -- tunnel ${f.join(" ")}`,!1),o=(0,S.spawn)("cargo",["run","--","tunnel",...f],{cwd:(0,P.join)(this.s.appRoot,"cli")});else{n("Running tunnel CLI",!1);const c=this.u();n(`${v} Spawning: ${c} tunnel ${f.join(" ")}`,!1),o=(0,S.spawn)(c,["tunnel",...f],{cwd:(0,y.homedir)()})}o.stdout.on("data",c=>{if(o){const a=c.toString();n(a,!1)}}),o.stderr.on("data",c=>{if(o){const a=c.toString();n(a,!0)}}),o.on("exit",c=>{o&&(n(`${v} exit(${o.pid}): + ${c} `,!1),o=void 0,c===0?t():r())}),o.on("error",c=>{o&&(n(`${v} error(${o.pid}): + ${c} `,!0),o=void 0,r())})}))}async getHostName(){return this.z()}z(){let v=this.t.getValue(k.CONFIGURATION_KEY_HOST_NAME)||(0,y.hostname)();return v=v.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),v||void 0}};d=pe([Y(0,D.ITelemetryService),Y(1,C.IProductService),Y(2,A.INativeEnvironmentService),Y(3,R.ILoggerService),Y(4,p.ISharedProcessLifecycleService),Y(5,h.IConfigurationService)],d),e.RemoteTunnelService=d}),define(oe[109],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:R,data:P}){return this.b.forEach(S=>S.log(R,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class i{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(oe[50],ae([0,1,32,13,16,75,108,23]),function(ee,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class P{constructor(c){this.value=c}}e.TrustedTelemetryValue=P;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,a){return Promise.resolve(void 0)}publicLog2(c,a){return this.publicLog(c,a)}publicLogError(c,a){return Promise.resolve(void 0)}publicLogError2(c,a){return this.publicLogError(c,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class C{async publicLog(c,a,u){}async publicLogError(c,a,u){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(o,c){return c.onDidChangeConfiguration(a=>{a.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(a.source),configurationKeys:m(a.sourceConfig)})})}e.configurationTelemetry=E;function w(o,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!o.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=w;function p(o,c){return!(c.isBuilt||c.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=p;function h(o){const c=o.getValue(R.TELEMETRY_SETTING_ID),a=o.getValue("telemetry.enableCrashReporter");if(o.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=h;function g(o){const c={},a={},u={};d(o,u);for(let b in u){b=b.length>150?b.substr(b.length-149):b;const I=u[b];typeof I=="number"?a[b]=I:typeof I=="boolean"?a[b]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${I.length}`),c[b]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(c[b]=I)}return{properties:c,measurements:a}}e.validateTelemetryData=g;const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function l(o){if(!o)return"none";const c=(0,A.getRemoteName)(o);return y.has(c)?c:"other"}e.cleanRemoteAuthority=l;function d(o,c,a=0,u){if(!!o)for(const b of Object.getOwnPropertyNames(o)){const I=o[b],F=u?u+b:b;Array.isArray(I)?c[F]=(0,k.safeStringify)(I):I instanceof Date?c[F]=I.toISOString():(0,i.isObject)(I)?a<2?d(I,c,a+1,F+"."):c[F]=(0,k.safeStringify)(I):c[F]=I}}function m(o){if(!o)return[];const c=[];return v(c,"",o),c}function v(o,c,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(u=>v(o,c?`${c}.${u}`:u,a[u])):o.push(c)}function f(o,c){const a=o.msftInternalDomains||[],u=c.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(a)||u}e.isInternalTelemetry=f;function n(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=n;function s(o,c){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let a=o;const u=[];for(const N of c)for(;;){const $=N.exec(o);if(!$)break;u.push([$.index,N.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let F=0;for(a="";;){const N=I.exec(o);if(!N)break;const $=u.some(([j,L])=>N.index<L&&j<I.lastIndex);!b.test(N[0])&&!$&&(a+=o.substring(F,N.index)+"<REDACTED: user-file-path>",F=I.lastIndex)}return F<o.length&&(a+=o.substr(F)),a}function t(o){if(!o)return o;const c=o.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of a)if(u.regex.test(c))return`<REDACTED: ${u.label}>`;return o}function r(o,c){return(0,k.cloneAndChange)(o,a=>{if(a instanceof P)return a.value;if(typeof a=="string"){let u=a.replaceAll("%20"," ");u=s(u,c);for(const b of c)u=u.replace(b,"");return u=t(u),u}})}e.cleanData=r}),define(oe[236],ae([0,1,45,50]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(A,O,R,P,S,C,E){const w={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${O.nameShort})`};if((0,i.supportsTelemetry)(O,R)&&(0,i.getTelemetryLevel)(P)===3){const p=await(0,k.getServiceMachineId)(R,S,C),{machineId:h}=await E.getTelemetryInfo();w["X-Market-User-Id"]=p,w["VSCode-SessionId"]=h||p}return w}e.resolveMarketplaceHeaders=D}),define(oe[237],ae([0,1,9,32,50]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function R(S,C,E){const w=await new Promise((l,d)=>{ee(["@microsoft/1ds-core-js"],l,d)}),p=await new Promise((l,d)=>{ee(["@microsoft/1ds-post-js"],l,d)}),h=new w.AppInsightsCore,g=new p.PostChannel,y={instrumentationKey:S,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(E){y.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:E};y.extensionConfig[g.identifier]=l}return h.initialize(y,[]),h.addTelemetryInitializer(l=>{C&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),h}class P{constructor(C,E,w,p,h){this.e=C,this.f=E,this.g=w,this.h=h,this.c=A,this.d=O,this.g||(this.g={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}i(C){if(!!this.a){if(typeof this.a!="string"){C(this.a);return}this.b||(this.b=R(this.a,this.e,this.h)),this.b.then(E=>{C(E)},E=>{(0,k.onUnexpectedError)(E),console.error(E)})}}log(C,E){if(!this.a)return;E=(0,i.mixin)(E,this.g),E=(0,D.validateTelemetryData)(E);const w=this.f+"/"+C;try{this.i(p=>{p.pluginVersionString=E?.properties.version??"Unknown",p.track({name:w,baseData:{name:w,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this.a?new Promise(C=>{this.i(E=>{E.unload(!0,()=>{this.a=void 0,C(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(oe[110],ae([0,1,2,15,8,50]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let O=class extends k.Disposable{constructor(P,S,C=""){super(),this.b=C;const E=P.getLogger(S.telemetryLogResource);E?this.a=this.B(E):(this.a=this.B(P.createLogger(S.telemetryLogResource)),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(P,S){this.a.trace(`${this.b}telemetry/${P}`,(0,A.validateTelemetryData)(S))}};O=pe([Y(0,D.ILoggerService),Y(1,i.IEnvironmentService)],O),e.TelemetryLogAppender=O}),define(oe[111],ae([0,1,2,32,5,27,170,16,46,103,25,40,23,50]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let h=class{constructor(l,d,m){this.k=d,this.l=m,this.d={},this.i=new k.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(l,d){this.d[l]=d}m(){let l=(0,p.getTelemetryLevel)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const m=d.usage?3:d.error?2:0;l=Math.min(l,m)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,d=l.sessionID,m=l["common.machineId"],v=l["common.firstSessionDate"],f=l["common.msftInternal"];return{sessionId:d,machineId:m,firstSessionDate:v,msftInternal:f}}dispose(){this.i.dispose()}n(l,d,m){return this.g<d?Promise.resolve(void 0):this.c.then(v=>{m=(0,i.mixin)(m,this.d),m=(0,p.cleanData)(m,this.j),m=(0,i.mixin)(m,v),this.b.forEach(f=>f.log(l,m))},v=>{console.error(v)})}publicLog(l,d){return this.n(l,3,d)}publicLog2(l,d){return this.publicLog(l,d)}publicLogError(l,d){return this.h?this.n(l,2,d):Promise.resolve(void 0)}publicLogError2(l,d){return this.publicLogError(l,d)}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=pe([Y(1,R.IConfigurationService),Y(2,C.IProductService)],h),e.TelemetryService=h;function g(){const y=(0,O.localize)(0,null,S.default.nameLong),l=S.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=D.isWeb?"":(0,O.localize)(3,null),m=(0,O.localize)(4,null),v=(0,O.localize)(5,null),f=(0,O.localize)(6,null),n=(0,O.localize)(7,null),s=`
|       | ${m} | ${v} | ${f} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,O.localize)(8,null);return`
${y} ${l} ${d}

&nbsp;

${n}
${s}

&nbsp;

${t}
`}E.Registry.as(P.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:g(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(P.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,O.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,O.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[238],ae([0,1,287,237]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends i.AbstractOneDataSystemAppender{constructor(O,R,P,S){const C={sendPOST:(E,w)=>{const p={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const h=k.request(E.urlString,p,g=>{g.on("data",function(y){w(g.statusCode??200,g.headers,y.toString())}),g.on("error",function(y){w(0,{})})});h.write(E.data),h.end()}catch{w(0,{})}}};super(O,R,P,S,C)}}e.OneDataSystemAppender=D}),define(oe[239],ae([0,1,21,68,16,15,8,25,23,109,110,111]),function(ee,e,k,i,D,A,O,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let w=class{constructor(h,g,y,l,d){this.b=h,this.c=g,this.d=y,this.e=l,this.f=d,this.a=new Map}async g(h){if(!this.a.has(h.id)){const{machineId:g,sessionId:y}=await this.c.getTelemetryInfo(),l=Object.create(null);l["common.vscodemachineid"]=g,l["common.vscodesessionid"]=y;const d=[h.id,JSON.stringify(l),h.aiKey],v=new i.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),f=[new S.TelemetryAppenderClient(v),new C.TelemetryLogAppender(this.d,this.e,`[${h.id}] `)];this.a.set(h.id,new E.TelemetryService({appenders:f,sendErrorTelemetry:h.sendErrorTelemetry},this.b,this.f))}return this.a.get(h.id)}async publicLog(h,g,y){await(await this.g(h)).publicLog(g,y)}async publicLogError(h,g,y){await(await this.g(h)).publicLogError(g,y)}};w=pe([Y(0,D.IConfigurationService),Y(1,P.ITelemetryService),Y(2,O.ILoggerService),Y(3,A.IEnvironmentService),Y(4,R.IProductService)],w),e.CustomEndpointTelemetryService=w}),define(oe[240],ae([0,1,6,24,3,2,8]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends A.Disposable{constructor(S,C){super(),this.h=C,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new D.Emitter),this.onCreateRequest=this.g.event,this.b=S===void 0?15e3:S}createRequest(S){return new Promise((C,E)=>{const w=++this.a;this.c.set(w,C),this.g.fire({requestId:w,...S});const p=new i.CancellationTokenSource;(0,k.timeout)(this.b,p.token).then(()=>E(`Request ${w} timed out (${this.b}ms)`)),this.f.set(w,[(0,A.toDisposable)(()=>p.cancel())])})}acceptReply(S,C){const E=this.c.get(S);E?(this.c.delete(S),(0,A.dispose)(this.f.get(S)||[]),this.f.delete(S),E(C)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};R=pe([Y(1,O.ILogService)],R),e.RequestStore=R}),define(oe[112],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(m){m.Shell="terminal.integrated.shell.",m.ShellArgs="terminal.integrated.shellArgs.",m.DefaultProfile="terminal.integrated.defaultProfile.",m.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(m){m.ShellLinux="terminal.integrated.shell.linux",m.ShellMacOs="terminal.integrated.shell.osx",m.ShellWindows="terminal.integrated.shell.windows",m.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",m.AutomationShellLinux="terminal.integrated.automationShell.linux",m.AutomationShellMacOs="terminal.integrated.automationShell.osx",m.AutomationShellWindows="terminal.integrated.automationShell.windows",m.AutomationProfileLinux="terminal.integrated.automationProfile.linux",m.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",m.AutomationProfileWindows="terminal.integrated.automationProfile.windows",m.ShellArgsLinux="terminal.integrated.shellArgs.linux",m.ShellArgsMacOs="terminal.integrated.shellArgs.osx",m.ShellArgsWindows="terminal.integrated.shellArgs.windows",m.ProfilesWindows="terminal.integrated.profiles.windows",m.ProfilesMacOs="terminal.integrated.profiles.osx",m.ProfilesLinux="terminal.integrated.profiles.linux",m.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",m.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",m.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",m.UseWslProfiles="terminal.integrated.useWslProfiles",m.TabsDefaultColor="terminal.integrated.tabs.defaultColor",m.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",m.TabsEnabled="terminal.integrated.tabs.enabled",m.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",m.TabsHideCondition="terminal.integrated.tabs.hideCondition",m.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",m.TabsShowActions="terminal.integrated.tabs.showActions",m.TabsLocation="terminal.integrated.tabs.location",m.TabsFocusMode="terminal.integrated.tabs.focusMode",m.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",m.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",m.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",m.CopyOnSelection="terminal.integrated.copyOnSelection",m.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",m.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",m.FontFamily="terminal.integrated.fontFamily",m.FontSize="terminal.integrated.fontSize",m.LetterSpacing="terminal.integrated.letterSpacing",m.LineHeight="terminal.integrated.lineHeight",m.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",m.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",m.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",m.BellDuration="terminal.integrated.bellDuration",m.FontWeight="terminal.integrated.fontWeight",m.FontWeightBold="terminal.integrated.fontWeightBold",m.CursorBlinking="terminal.integrated.cursorBlinking",m.CursorStyle="terminal.integrated.cursorStyle",m.CursorWidth="terminal.integrated.cursorWidth",m.Scrollback="terminal.integrated.scrollback",m.DetectLocale="terminal.integrated.detectLocale",m.DefaultLocation="terminal.integrated.defaultLocation",m.GpuAcceleration="terminal.integrated.gpuAcceleration",m.TerminalTitleSeparator="terminal.integrated.tabs.separator",m.TerminalTitle="terminal.integrated.tabs.title",m.TerminalDescription="terminal.integrated.tabs.description",m.RightClickBehavior="terminal.integrated.rightClickBehavior",m.Cwd="terminal.integrated.cwd",m.ConfirmOnExit="terminal.integrated.confirmOnExit",m.ConfirmOnKill="terminal.integrated.confirmOnKill",m.EnableBell="terminal.integrated.enableBell",m.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",m.AllowChords="terminal.integrated.allowChords",m.AllowMnemonics="terminal.integrated.allowMnemonics",m.EnvMacOs="terminal.integrated.env.osx",m.EnvLinux="terminal.integrated.env.linux",m.EnvWindows="terminal.integrated.env.windows",m.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",m.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",m.ShowExitAlert="terminal.integrated.showExitAlert",m.SplitCwd="terminal.integrated.splitCwd",m.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",m.WordSeparators="terminal.integrated.wordSeparators",m.EnableFileLinks="terminal.integrated.enableFileLinks",m.UnicodeVersion="terminal.integrated.unicodeVersion",m.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",m.LocalEchoEnabled="terminal.integrated.localEchoEnabled",m.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",m.LocalEchoStyle="terminal.integrated.localEchoStyle",m.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",m.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",m.CustomGlyphs="terminal.integrated.customGlyphs",m.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",m.InheritEnv="terminal.integrated.inheritEnv",m.ShowLinkHover="terminal.integrated.showLinkHover",m.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",m.AutoReplies="terminal.integrated.autoReplies",m.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",m.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",m.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",m.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",m.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(m){m.FileName="ptyhost"})(A=e.TerminalLogConstants||(e.TerminalLogConstants={}));var O;(function(m){m.PowerShell="pwsh",m.Bash="bash",m.Fish="fish",m.Sh="sh",m.Csh="csh",m.Ksh="ksh",m.Zsh="zsh"})(O=e.PosixShellType||(e.PosixShellType={}));var R;(function(m){m.CommandPrompt="cmd",m.PowerShell="pwsh",m.Wsl="wsl",m.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var P;(function(m){m[m.Api=0]="Api",m[m.Process=1]="Process",m[m.Sequence=2]="Sequence",m[m.Config=3]="Config"})(P=e.TitleEventSource||(e.TitleEventSource={}));var S;(function(m){m.LocalPty="localPty",m.PtyHost="ptyHost",m.Log="log",m.Heartbeat="heartbeat"})(S=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var C;(function(m){m.Cwd="cwd",m.InitialCwd="initialCwd",m.FixedDimensions="fixedDimensions",m.Title="title",m.ShellType="shellType",m.HasChildProcesses="hasChildProcesses",m.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",m.OverrideDimensions="overrideDimensions",m.FailedShellIntegrationActivation="failedShellIntegrationActivation",m.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(m){m[m.BeatInterval=5e3]="BeatInterval",m[m.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",m[m.SecondWaitMultiplier=1]="SecondWaitMultiplier",m[m.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(m){m[m.Panel=1]="Panel",m[m.Editor=2]="Editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var p;(function(m){m.TerminalView="view",m.Editor="editor"})(p=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(m){m[m.GraceTime=6e4]="GraceTime",m[m.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var g;(function(m){m[m.HighWatermarkChars=1e5]="HighWatermarkChars",m[m.LowWatermarkChars=5e3]="LowWatermarkChars",m[m.CharCountAckSize=5e3]="CharCountAckSize"})(g=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(m){m.GitBash="Git Bash",m.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}));var l;(function(m){m[m.Off=0]="Off",m[m.FinalTerm=1]="FinalTerm",m[m.VSCode=2]="VSCode"})(l=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var d;(function(m){m[m.Unknown=0]="Unknown",m[m.Shutdown=1]="Shutdown",m[m.Process=2]="Process",m[m.User=3]="User",m[m.Extension=4]="Extension"})(d=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(oe[241],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(oe[242],ae([0,1,34,21,32,12,5,36,27,13,28]),function(ee,e,k,i,D,A,O,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let n=0;return f&&f.length===4&&(n=parseInt(f[3])),n}e.getWindowsBuildNumber=E;async function w(f,n,s,t=R.env,r=C.Promises.exists){if(A.isAbsolute(f))return await r(f)?f:void 0;if(n===void 0&&(n=R.cwd()),A.dirname(f)!=="."){const u=A.join(n,f);return await r(u)?u:void 0}const c=(0,D.getCaseInsensitive)(t,"PATH");if(s===void 0&&(0,S.isString)(c)&&(s=c.split(A.delimiter)),s===void 0||s.length===0){const u=A.join(n,f);return await r(u)?u:void 0}for(const u of s){let b;if(A.isAbsolute(u)?b=A.join(u,f):b=A.join(n,u,f),await r(b))return b;if(O.isWindows){let I=b+".com";if(await r(I)||(I=b+".exe",await r(I)))return I}}const a=A.join(n,f);return await r(a)?a:void 0}e.findExecutable=w;function p(f,n,s,t,r){if(!n.shellIntegration.enabled||!f.executable||f.isFeatureTerminal||f.hideFromUser||f.ignoreShellIntegration||O.isWindows&&!n.windowsEnableConpty)return;const o=f.args,c=R.platform==="win32"?A.basename(f.executable).toLowerCase():A.basename(f.executable),a=A.dirname(i.FileAccess.asFileUri("").fsPath);let u;const b={VSCODE_INJECTION:"1"};if(O.isWindows){if(c==="pwsh.exe"||c==="powershell.exe")return!o||m(o)?u=g.get(h.WindowsPwsh):d(o)&&(u=g.get(h.WindowsPwshLogin)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],a,""),{newArgs:u,envMixin:b}):void 0;t.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}switch(c){case"bash":return!o||o.length===0?u=g.get(h.Bash):v(o)&&(b.VSCODE_SHELL_LOGIN="1",u=g.get(h.Bash)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],a),{newArgs:u,envMixin:b}):void 0;case"pwsh":return!o||m(o)?u=g.get(h.Pwsh):d(o)&&(u=g.get(h.PwshLogin)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],a,""),{newArgs:u,envMixin:b}):void 0;case"zsh":{if(!o||o.length===0?u=g.get(h.Zsh):v(o)?u=g.get(h.ZshLogin):(o===g.get(h.Zsh)||o===g.get(h.ZshLogin))&&(u=o),!u)return;u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],a);const I=A.join(k.tmpdir(),`${k.userInfo().username}-${r.applicationName}-zsh`);b.ZDOTDIR=I;const F=s?.ZDOTDIR??k.homedir()??"~";b.USER_ZDOTDIR=F;const N=[];return N.push({source:A.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(I,".zshrc")}),N.push({source:A.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(I,".zprofile")}),N.push({source:A.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(I,".zshenv")}),N.push({source:A.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(I,".zlogin")}),{newArgs:u,envMixin:b,filesToCopy:N}}}t.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}e.getShellIntegrationInjection=p;var h;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(h||(h={}));const g=new Map;g.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(h.Zsh,["-i"]),g.set(h.ZshLogin,["-il"]),g.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const y=["-login","-l"],l=["-nol","-nologo"];function d(f){return typeof f=="string"?y.includes(f.toLowerCase()):f.length===1&&y.includes(f[0].toLowerCase())||f.length===2&&(y.includes(f[0].toLowerCase())||y.includes(f[1].toLowerCase()))&&(l.includes(f[0].toLowerCase())||l.includes(f[1].toLowerCase()))}function m(f){return typeof f=="string"?l.includes(f.toLowerCase()):f.length===0||f?.length===1&&l.includes(f[0].toLowerCase())}function v(f){return f==="string"&&y.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&y.includes(f[0].toLowerCase())}}),define(oe[243],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var k;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(k=e.ColorScheme||(e.ColorScheme={}));function i(A){return A===k.HIGH_CONTRAST_DARK||A===k.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function D(A){return A===k.DARK||A===k.HIGH_CONTRAST_DARK}e.isDark=D}),define(oe[113],ae([0,1,51,3,2,4,40,243]),function(ee,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var P;(function(y){function l(d){return d&&typeof d=="object"&&typeof d.id=="string"}y.isThemeColor=l})(P=e.ThemeColor||(e.ThemeColor={}));function S(y){return{id:y}}e.themeColorFromId=S;var C;(function(y){function l(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||P.isThemeColor(r.color))}y.isThemeIcon=l;const d=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function m(r){const o=d.exec(r);if(!o)return;const[,c]=o;return{id:c}}y.fromString=m;function v(r){return{id:r}}y.fromId=v;function f(r,o){let c=r.id;const a=c.lastIndexOf("~");return a!==-1&&(c=c.substring(0,a)),o&&(c=`${c}~${o}`),{id:c}}y.modify=f;function n(r){const o=r.id.lastIndexOf("~");if(o!==-1)return r.id.substring(o+1)}y.getModifier=n;function s(r,o){return r.id===o.id&&r.color?.id===o.color?.id}y.isEqual=s;function t(r,o){return{id:r.id,color:o?S(o):void 0}}y.asThemeIcon=t,y.asClassNameArray=k.CSSIcon.asClassNameArray,y.asClassName=k.CSSIcon.asClassName,y.asCSSSelector=k.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function E(y){switch(y){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case R.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,D.toDisposable)(()=>{const d=this.a.indexOf(l);this.a.splice(d,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const p=new w;O.Registry.add(e.Extensions.ThemingContribution,p);function h(y){return p.onColorThemeChange(y)}e.registerThemingParticipant=h;class g extends D.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(d=>this.n(d)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,d){let m=this.h.getColor(l);return m&&d&&(m=d(m,this.h)),m?m.toString():null}}e.Themable=g}),define(oe[244],ae([0,1,51,7,172,113]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function O(w,p){const h=[{name:null,description:(0,D.localize)(0,null)}];return h.push(...w.map(g=>({name:g.profileName,description:R(g)}))),p&&h.push(...p.map(g=>({name:g.title,description:P(g)}))),{values:h.map(g=>g.name),markdownDescriptions:h.map(g=>g.description)}}e.createProfileSchemaEnums=O;function R(w){let p=`$(${A.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:k.Codicon.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?p+=`
- args: "${w.args}"`:p+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(p+=`
- overrideName: ${w.overrideName}`),w.color&&(p+=`
- color: ${w.color}`),w.env&&(p+=`
- env: ${JSON.stringify(w.env)}`),p}function P(w){return`$(${A.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:k.Codicon.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function S(w,p){if(!w&&!p)return!0;if(typeof w=="string"&&typeof p=="string")return w===p;if(Array.isArray(w)&&Array.isArray(p)){if(w.length!==p.length)return!1;for(let h=0;h<w.length;h++)if(w[h]!==p[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function C(w,p){if(!w&&!p)return!0;if(!w||!p)return!1;if(A.ThemeIcon.isThemeIcon(w)&&A.ThemeIcon.isThemeIcon(p))return w.id===p.id&&w.color===p.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof p=="object"&&"light"in p&&"dark"in p){const h=w,g=p;if((i.URI.isUri(h.light)||E(h.light))&&(i.URI.isUri(h.dark)||E(h.dark))&&(i.URI.isUri(g.light)||E(g.light))&&(i.URI.isUri(g.dark)||E(g.dark)))return h.light.path===g.light.path&&h.dark.path===g.dark.path}if(i.URI.isUri(w)&&i.URI.isUri(p)||E(w)||E(p)){const h=w,g=p;return h.path===g.path&&h.scheme===g.scheme}return!1}e.terminalIconsEqual=C;function E(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.isUriComponents=E}),define(oe[245],ae([0,1,51,171,46,40,244]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(k.Codicon.getAll(),v=>v.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),v=>`$(${v.id})`)};const R={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),...e.terminalIconSchema},color:{description:(0,i.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},P={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},S={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...R}},C=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),w=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),g=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),y={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:w},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){A.Registry.as(D.Extensions.Configuration).registerConfiguration(y),m()}e.registerTerminalPlatformConfiguration=l;let d;function m(v,f){const n=A.Registry.as(D.Extensions.Configuration);let s;v&&(s=(0,O.createProfileSchemaEnums)(v?.profiles,f));const t=d;d={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:v?.os===3?s?.values:void 0,markdownEnumDescriptions:v?.os===3?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:v?.os===2?s?.values:void 0,markdownEnumDescriptions:v?.os===2?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:v?.os===1?s?.values:void 0,markdownEnumDescriptions:v?.os===1?s?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[d],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=m}),define(oe[246],ae([0,1,49,51,12,5,28,90,242,113]),function(ee,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let C,E=!0;function w(s,t,r,o,c=process.env,a,u,b,I){return a=a||{existsFile:O.SymlinkSupport.existsFile,readFile:O.Promises.readFile},A.isWindows?p(r,a,c,u,o.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:o.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:o.getValue("terminal.integrated.defaultProfile.windows"),I,b):v(a,u,r,s&&typeof s=="object"?{...s}:o.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:o.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,b,c)}e.detectAvailableProfiles=w;async function p(s,t,r,o,c,a,u,b,I){const F=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),N=`${process.env.windir}\\${F?"Sysnative":"System32"}`;let $=!1;(0,P.getWindowsBuildNumber)()>=16299&&($=!0),await y(b);const j=new Map;s&&(j.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),j.set("Windows PowerShell",{path:`${N}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),j.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),j.set("Command Prompt",{path:`${N}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),f(a,j);const L=await h(j.entries(),u,t,r,o,I);if(s||c)try{const M=await d(`${N}\\${$?"wsl":"bash"}.exe`,u);for(const z of M)(!a||!(z.profileName in a))&&L.push(z)}catch{E&&(o?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return L}async function h(s,t,r,o=process.env,c,a){const u=[];for(const[b,I]of s){if(I===null)continue;let F,N,$;if("source"in I){const M=C?.get(I.source);if(!M)continue;F=M.paths,N=I.args||M.args,I.icon?$=g(I.icon):M.icon&&($=M.icon)}else F=Array.isArray(I.path)?I.path:[I.path],N=A.isWindows||Array.isArray(I.args)?I.args:void 0,$=g(I.icon);const j=await a?.(F)||F.slice(),L=await n(b,t,j,r,o,N,I.env,I.overrideName,I.isAutoDetected,c);L?(L.isAutoDetected=I.isAutoDetected,L.icon=$,L.color=I.color,u.push(L)):c?.debug("Terminal profile not validated",b,F)}return c?.debug("Validated terminal profiles",u),u}function g(s){return typeof s=="string"?{id:s}:s}async function y(s){C&&!s||(C=new Map,C.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),C.set("PowerShell",{profileName:"PowerShell",paths:s||await l(),icon:S.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function l(){const s=[];for await(const t of(0,R.enumeratePowerShellInstallations)())s.push(t.exePath);return s}async function d(s,t){const r=[],o=await new Promise((u,b)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,F)=>{if(I)return b("Problem occurred when getting wsl distros");u(F)})});if(!o)return[];const c=new RegExp(/[\r?\n]/),a=o.split(c).filter(u=>u.trim().length>0&&u!=="");for(const u of a){if(u===""||u.startsWith("docker-desktop"))continue;const b=`${u} (WSL)`,I={profileName:b,path:s,args:["-d",`${u}`],isDefault:b===t,icon:m(u),isAutoDetected:!1};r.push(I)}return r}function m(s){return s.includes("Ubuntu")?S.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):s.includes("Debian")?S.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):S.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function v(s,t,r,o,c,a,u,b){const I=new Map;if(r){const F=(await s.readFile("/etc/shells")).toString(),N=a||F.split(`
`).filter(j=>j.trim().indexOf("#")!==0&&j.trim().length>0),$=new Map;for(const j of N){let L=(0,D.basename)(j),M=$.get(L)||0;M++,M>1&&(L=`${L} (${M})`),$.set(L,M),I.set(L,{path:j,isAutoDetected:!0})}}return f(o,I),await h(I.entries(),c,s,b,t,u)}function f(s,t){if(!!s)for(const[r,o]of Object.entries(s))o===null||!("path"in o)&&!("source"in o)?t.delete(r):(o.icon=o.icon||t.get(r)?.icon,t.set(r,o))}async function n(s,t,r,o,c,a,u,b,I,F){if(r.length===0)return Promise.resolve(void 0);const N=r.shift();if(N==="")return n(s,t,r,o,c,a,u,b,I);const $={profileName:s,path:N,args:a,env:u,overrideName:b,isAutoDetected:I,isDefault:s===t};if((0,D.basename)(N)===N){const L=c.PATH?c.PATH.split(D.delimiter):void 0,M=await(0,P.findExecutable)(N,void 0,L,void 0,o.existsFile);return M?($.path=M,$.isFromPath=!0,$):n(s,t,r,o,c,a)}return await o.existsFile((0,D.normalize)(N))?$:n(s,t,r,o,c,a,u,b,I)}}),define(oe[247],ae([0,1,3,2,21,5,39,68,16,15,94,232,8,102,240,112,245,246]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var d;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let m=0,v=class extends i.Disposable{constructor(n,s,t,r){super(),this.C=n,this.D=s,this.F=t,this.G=r,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new k.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new k.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new k.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new k.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new k.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new k.Emitter),this.onProcessData=this.s.event,this.t=this.B(new k.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new k.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new k.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new k.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new k.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new k.Emitter),this.onProcessExit=this.z.event,(0,y.registerTerminalPlatformConfiguration)(),this.c=this.J(),this.B((0,i.toDisposable)(()=>this.M())),this.f=this.B(new h.RequestStore(void 0,this.G)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.L(),this.B(this.D.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.I()}))}initialize(){this.I()}get H(){return this.D.getValue("terminal.integrated.ignoreProcessNames")}async I(){return this.b.refreshIgnoreProcessNames?.(this.H)}async J(){if(A.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this.G,{_:[]},process.env)}catch(n){return this.G.error("ptyHost was unable to resolve shell environment",n),{}}}L(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.F.logsPath],env:{VSCODE_LAST_PTY_ID:m,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},s=(0,C.parsePtyHostPort)(this.F.args,this.F.isBuilt);s&&(s.break&&s.port?n.debugBrk=s.port:!s.break&&s.port&&(n.debug=s.port));const t=new R.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,n);this.m.fire(),O.ProxyChannel.toService(t.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.N()),this.N(),this.B(t.onDidProcessExit(a=>{this.l.fire(a.code),this.i||(this.g<=d.MaxRestarts?(this.G.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.g++,this.restartPtyHost()):this.G.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const o=t.getChannel(g.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(o,this.G.getLevel()),this.B(this.G.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(o,this.G.getLevel())}));const c=O.ProxyChannel.toService(t.getChannel(g.TerminalIpcChannels.PtyHost));return this.B(c.onProcessData(a=>this.s.fire(a))),this.B(c.onProcessReady(a=>this.t.fire(a))),this.B(c.onProcessExit(a=>this.z.fire(a))),this.B(c.onDidChangeProperty(a=>this.y.fire(a))),this.B(c.onProcessReplay(a=>this.u.fire(a))),this.B(c.onProcessOrphanQuestion(a=>this.v.fire(a))),this.B(c.onDidRequestDetach(a=>this.w.fire(a))),[t,c]}dispose(){this.i=!0,super.dispose()}async createProcess(n,s,t,r,o,c,a,u,b,I,F){const N=setTimeout(()=>this.Q(),g.HeartbeatConstants.CreateProcessTimeout),$=await this.b.createProcess(n,s,t,r,o,c,a,u,b,I,F);return clearTimeout(N),m=Math.max(m,$),$}updateTitle(n,s,t){return this.b.updateTitle(n,s,t)}updateIcon(n,s,t,r){return this.b.updateIcon(n,s,t,r)}attachToProcess(n){return this.b.attachToProcess(n)}detachFromProcess(n,s){return this.b.detachFromProcess(n,s)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(n){return this.b.start(n)}shutdown(n,s){return this.b.shutdown(n,s)}input(n,s){return this.b.input(n,s)}processBinary(n,s){return this.b.processBinary(n,s)}resize(n,s,t){return this.b.resize(n,s,t)}acknowledgeDataEvent(n,s){return this.b.acknowledgeDataEvent(n,s)}setUnicodeVersion(n,s){return this.b.setUnicodeVersion(n,s)}getInitialCwd(n){return this.b.getInitialCwd(n)}getCwd(n){return this.b.getCwd(n)}getLatency(n){return this.b.getLatency(n)}orphanQuestionReply(n){return this.b.orphanQuestionReply(n)}installAutoReply(n,s){return this.b.installAutoReply(n,s)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(n){return this.b.uninstallAutoReply(n)}getDefaultSystemShell(n){return this.b.getDefaultSystemShell(n)}async getProfiles(n,s,t,r=!1){const o=await this.c;return(0,l.detectAvailableProfiles)(s,t,r,this.D,o,void 0,this.G,this.S.bind(this,n))}getEnvironment(){return this.b.getEnvironment()}getWslPath(n){return this.b.getWslPath(n)}getRevivedPtyNewId(n){return this.b.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this.b.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this.b.getTerminalLayoutInfo(n)}async requestDetachInstance(n,s){return this.b.requestDetachInstance(n,s)}async acceptDetachInstanceReply(n,s){return this.b.acceptDetachInstanceReply(n,s)}async freePortKillProcess(n){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(n)}async serializeTerminalState(n){return this.b.serializeTerminalState(n)}async reviveTerminalProcesses(n,s){return this.b.reviveTerminalProcesses(n,s)}async refreshProperty(n,s){return this.b.refreshProperty(n,s)}async updateProperty(n,s,t){return this.b.updateProperty(n,s,t)}async restartPtyHost(){this.h=!0,this.M(),[this.a,this.b]=this.L()}M(){this.b.shutdownAll?.(),this.a.dispose()}N(){this.R(),this.j=setTimeout(()=>this.O(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}O(){this.G.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.P(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}P(){this.G.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}Q(){this.R(),this.G.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}R(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}S(n,s){return this.f.createRequest({workspaceId:n,originalText:s})}async acceptPtyHostResolvedVariables(n,s){this.f.acceptReply(n,s)}};v=pe([Y(1,P.IConfigurationService),Y(2,S.IEnvironmentService),Y(3,w.ILogService)],v),e.PtyHostService=v}),define(oe[77],ae([0,1,3,16,4,8]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var O;(function(g){g.Http="http",g.Https="https"})(O=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var P;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=E;function w(g,y,l,d){if(l===1)return!1;if(l===2&&E(y)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(m?.length===4&&parseInt(m[1])>=18)return!1}return g<1024}e.isPortPrivileged=w;class p{constructor(y,l,d){this.remoteAddress=y,this.localAddress=l,this.b=d,this.a=new k.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=p;let h=class{constructor(y,l){this.i=y,this.j=l,this.a=new k.Emitter,this.onTunnelOpened=this.a.event,this.b=new k.Emitter,this.onTunnelClosed=this.b.event,this.c=new k.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const y=this.j.getValue("remote.localPortHost");return!y||y==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(y){return this.e=y,y?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(y){this.f=y.elevation,this.g=y.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const y=[],l=Array.from(this.d.values());for(const d of l){const m=Array.from(d.values());for(const v of m){const f=await v.value;f&&y.push(f)}}return y}async dispose(){for(const y of this.d.values()){for(const{value:l}of y.values())await l.then(d=>d?.dispose());y.clear()}this.d.clear()}setEnvironmentTunnel(y,l,d,m,v){this.o(y,l,Promise.resolve({tunnelRemoteHost:y,tunnelRemotePort:l,localAddress:d,privacy:m,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(y,l){(E(y)||C(y))&&(y=e.LOCALHOST_ADDRESSES[0]);const d=this.q(y,l);if(d)return++d.refcount,d.value}openTunnel(y,l,d,m,v=!1,f,n){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${d} on local port ${m}.`),!y)return;if(l||(l="localhost"),this.e&&this.h.has(d)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(y,l,d,m,v,f,n);return s?s.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,d);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.m(t);return(t.tunnelRemoteHost!==l||t.tunnelRemotePort!==d)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(r),r}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const l=this.d.get(y.tunnelRemoteHost);if(l){const d=l.get(y.tunnelRemotePort);d&&(d.refcount--,await this.n(y.tunnelRemoteHost,y.tunnelRemotePort,d))}}}}async n(y,l,d){if(d.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${l}.`);const m=d.value.then(async v=>{v&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.d.has(y)&&this.d.get(y).delete(l),m}}async closeTunnel(y,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${l} `);const d=this.d.get(y);if(d&&d.has(l)){const m=d.get(l);m.refcount=0,await this.n(y,l,m)}}o(y,l,d){this.d.has(y)||this.d.set(y,new Map),this.d.get(y).set(l,{refcount:1,value:d})}async p(y,l){const d=this.d.get(y);d&&(await d.get(l)||d.delete(l),d.size===0&&this.d.delete(y))}q(y,l){const d=[y];C(y)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):E(y)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const m=d.map(v=>this.d.get(v));for(const v of m){const f=v?.get(l);if(f)return f}}canTunnel(y){return!!S(y)}s(y,l,d,m,v,f,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${d} on local port ${m}.`);const s=d;this.h.add(s);const t=m===void 0?d:m,r={elevationRequired:v?this.isPortPrivileged(t):!1},o={remoteAddress:{host:l,port:d},localAddressPort:m,privacy:f,public:f?f!==R.Private:void 0,protocol:n},c=y.forwardPort(o,r);return c?(this.o(l,d,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),c}};h=pe([Y(0,A.ILogService),Y(1,i.IConfigurationService)],h),e.AbstractTunnelService=h}),define(oe[248],ae([0,1,8,77,2,9,6]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends D.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.DeferredPromise),this.b.p)}setAddress(C){this.a=C,this.b&&(this.b.complete(C),this.b=null)}setTunnel(C){this.B(C)}}let P=class kt extends D.Disposable{constructor(C,E){super(),this.f=C,this.g=E,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(C=>C.dispose())}async createTunnel(){return{id:String(++kt.a)}}async startTunnel(C,E,w,p,h,g){const y=new R,l=await Promise.resolve(this.f.openTunnel(C,y,w,p,h,g));if(!l)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${w}:${p} (remote).`),y.dispose(),new Error("Could not create tunnel");if(this.c.has(E))throw this.c.delete(E),y.dispose(),await l.dispose(),(0,A.canceled)();return y.setTunnel(l),this.b.set(E,y),this.g.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${l.localAddress} (local) to ${w}:${p} (remote).`),{tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress}}async setAddress(C,E){const w=this.b.get(C);!w||w.setAddress(E)}async destroyTunnel(C){const E=this.b.get(C);if(E){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${C}.`),this.b.delete(C),await E.dispose();return}this.c.add(C)}};P.a=0,P=pe([Y(0,i.ISharedTunnelsService),Y(1,k.ILogService)],P),e.SharedProcessTunnelService=P}),define(oe[249],ae([0,1,86,34,130,224,6,2,16,8,25,222,77,107,5]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(v,f,n,s,t){let r;for(let o=3;o&&(r?.dispose(),r=await new y(v,f,n,s,t).waitForReady(),!(t&&D.BROWSER_RESTRICTED_PORTS[t]||!D.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));o--);return r}class y extends R.Disposable{constructor(f,n,s,t,r){super(),this.j=n,this.k=r,this.privacy=w.TunnelPrivacyId.Private,this.i=new Map,this.a=f,this.b=k.createServer(),this.c=new O.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.l(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const f=this.k??this.tunnelRemotePort,n=(0,w.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let s=await(0,D.findFreePortFaster)(f,2,1e3,n),t=null;return this.b.listen(s,this.j),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(f){f.pause();const n=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,E.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),t=s.getSocket().socket,r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&f.write(r.buffer),f.on("end",()=>{f.localAddress&&this.i.delete(f.localAddress),t.end()}),f.on("close",()=>t.end()),f.on("error",()=>{f.localAddress&&this.i.delete(f.localAddress),t.destroy()}),t.on("end",()=>f.end()),t.on("close",()=>f.end()),t.on("error",()=>{f.destroy()}),f.pipe(t),t.pipe(f),f.localAddress&&this.i.set(f.localAddress,()=>{f.end(),t.end()})}}let l=class extends w.AbstractTunnelService{constructor(f,n,s,t,r){super(n,r),this.t=f,this.u=s,this.v=t}isPortPrivileged(f){return(0,w.isPortPrivileged)(f,this.k,h.OS,i.release())}r(f,n,s,t,r,o,c){const a=this.q(n,s);if(a)return++a.refcount,a.value;if(this.e)return this.s(this.e,n,s,t,r,o,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${t}.`);const u={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:f,signService:this.u,logService:this.i,ipcLogger:null},b=g(u,this.k,n,s,t);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,s,b),b}}};l=pe([Y(1,S.ILogService),Y(2,p.ISignService),Y(3,C.IProductService),Y(4,P.IConfigurationService)],l),e.BaseTunnelService=l;let d=class extends l{constructor(f,n,s,t){super(A.nodeSocketFactory,f,n,s,t)}};d=pe([Y(0,S.ILogService),Y(1,p.ISignService),Y(2,C.IProductService),Y(3,P.IConfigurationService)],d),e.TunnelService=d;let m=class extends R.Disposable{constructor(f,n,s,t){super(),this.b=f,this.c=n,this.f=s,this.g=t,this.a=new Map}async openTunnel(f,n,s,t,r,o,c,a){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${r}.`),!this.a.has(f)){const u=new d(this.b,this.f,this.c,this.g);this.B(u),this.a.set(f,u),u.onTunnelClosed(async()=>{(await u.tunnels).length===0&&(u.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(n,s,t,r,o,c,a)}};m=pe([Y(0,S.ILogService),Y(1,C.IProductService),Y(2,p.ISignService),Y(3,P.IConfigurationService)],m),e.SharedTunnelsService=m}),define(oe[30],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(oe[250],ae([0,1,30,71,14,22,128,3,2]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(w){this.uri=w,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let C=class{constructor(w){this.g=w,this.c=new P.DisposableStore,this.f=2**16;const p=new Map,h=g=>{let y=p.get(g.scheme);return y===void 0&&(y=w.hasProvider(g)&&!this.g.hasCapability(g,1024),p.set(g.scheme,y)),y};this.c.add(R.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(g=>{p.delete(g.scheme)})),this.extUri=new A.ExtUri(h),this.d=new O.SkipList((g,y)=>this.extUri.compare(g,y,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,A.normalizePath)(w));const p=this.d.get(w);return p?p.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new S(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((h,g)=>h[1].touch<g[1].touch?1:h[1].touch>g[1].touch?-1:0);S._clock=0,this.d.clear();const p=this.f*.5;for(let h=0;h<p;h++)this.d.set(w[h][0],w[h][1].touch())}};C=pe([Y(0,D.IFileService)],C),e.UriIdentityService=C,(0,i.registerSingleton)(k.IUriIdentityService,C,1)}),define(oe[251],ae([0,1,3,2,14,44,48,17]),function(ee,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends i.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(C,E,w,p){super(),this.c=C,this.f=E,this.g=w,this.h=p,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=O.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(h=>this.i(h)))}watch(C,E){this.b.set(C,C);const w=this.f.watch(this.j(C),E);return(0,i.toDisposable)(()=>{this.b.delete(C),w.dispose()})}stat(C){return this.f.stat(this.j(C))}mkdir(C){return this.f.mkdir(this.j(C))}rename(C,E,w){return this.f.rename(this.j(C),this.j(E),w)}readFile(C){return this.f.readFile(this.j(C),{atomic:!0})}readFileStream(C,E,w){const p=(0,A.newWriteableStream)(h=>R.VSBuffer.concat(h.map(g=>R.VSBuffer.wrap(g))).buffer);return(async()=>{try{const h=await this.readFile(C);p.end(h)}catch(h){p.error(h),p.end()}})(),p}readdir(C){return this.f.readdir(this.j(C))}writeFile(C,E,w){return this.f.writeFile(this.j(C),E,w)}delete(C,E){return this.f.delete(this.j(C),E)}copy(C,E,w){if((0,D.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(C),this.j(E),w);throw new Error("copy not supported")}i(C){const E=[];for(const w of C){if(w.resource.scheme!==this.c)continue;const p=this.k(w.resource);this.b.findSubstr(p)&&E.push({resource:p,type:w.type})}E.length&&(this.h.debug("User data changed"),this.a.fire(E))}j(C){return C.with({scheme:this.c})}k(C){return C.with({scheme:this.g})}}e.FileUserDataProvider=P}),define(oe[60],ae([0,1,83]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(O,R,P,S){const C=(0,k.setProperty)(O,R,P,S)[0];return C&&(O=O.substring(0,C.offset)+C.content+O.substring(C.offset+C.length)),O}e.edit=i;function D(O,R,P){let S=P;for(;S>=0;){if(O.charAt(S)===R.charAt(R.length-1)&&R.length===1)return S+1;if(S--,R.length===2&&S>=0&&O.charAt(S)===R.charAt(0))return S+2}return 0}e.getLineStartOffset=D;function A(O,R,P){let S=P;for(;S>=0;)if(O.charAt(S)===R.charAt(R.length-1)&&R.length===1||(S++,R.length===2&&S>=0&&O.charAt(S)===R.charAt(1)))return S;return O.length-1}e.getLineEndOffset=A}),define(oe[252],ae([0,1,32,53,13]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(p,h,g,y,l,d){const m=[],v=[],f=[];if(!h){const M=p.filter(({identifier:z})=>l.every(G=>G.toLowerCase()!==z.id.toLowerCase()));return{local:{added:m,removed:v,updated:f},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}p=p.map(E),h=h.map(E),g=g?g.map(E):null;const n=new Map,s=M=>{M.uuid&&n.set(M.id.toLowerCase(),M.uuid)};p.forEach(({identifier:M})=>s(M)),h.forEach(({identifier:M})=>s(M)),g?.forEach(({identifier:M})=>s(M));const t=M=>{const z=M.identifier.uuid||n.get(M.identifier.id.toLowerCase());return z?`uuid:${z}`:`id:${M.identifier.id.toLowerCase()}`},r=(M,z)=>(M.set(t(z),z),M),o=p.reduce(r,new Map),c=h.reduce(r,new Map),a=h.reduce((M,z)=>r(M,(0,k.deepClone)(z)),new Map),u=g?g.reduce(r,new Map):null,b=y.reduce(r,new Map),I=l.reduce((M,z)=>{const G=n.get(z.toLowerCase());return M.add(G?`uuid:${G}`:`id:${z.toLowerCase()}`)},new Set),F=d.reduce((M,{id:z,uuid:G})=>(G=G??n.get(z.toLowerCase()),M.add(G?`uuid:${G}`:`id:${z.toLowerCase()}`)),new Set),N=O(o,c,I,!1);if(N.added.size>0||N.removed.size>0||N.updated.size>0){const M=O(u,o,I,!1),z=O(u,c,I,!0),G=(W,_,K,q)=>({...q,installed:_.installed||K.installed,version:K.version&&(!_.installed||i.gt(K.version,_.version))?K.version:_.version,state:P(_,K,u?.get(W)),preRelease:(_.installed?q.preRelease:K.preRelease)??_.preRelease});for(const W of z.removed.values()){const _=o.get(W);if(!_)continue;const K=(0,D.assertIsDefined)(u?.get(W)),q=!F.has(W)&&K.installed;_.installed&&q?v.push(_.identifier):a.set(W,_)}for(const W of z.added.values()){const _=(0,D.assertIsDefined)(c.get(W)),K=o.get(W);if(K){if(N.updated.has(W)){const q=G(W,K,_,_);R(K,_,!1,!1)||f.push(w(q,W)),a.set(W,q)}}else _.installed&&m.push(w(_,W))}for(const W of z.updated.values()){const _=(0,D.assertIsDefined)(c.get(W)),K=(0,D.assertIsDefined)(u?.get(W)),q=o.get(W);if(q)if(!F.has(W)&&K.installed&&q.installed&&!_.installed)v.push(q.identifier);else{const Z=G(W,q,_,_);f.push(w(Z,W)),a.set(W,Z)}else _.installed&&m.push(w(_,W))}for(const W of M.added.values())z.added.has(W)||a.set(W,(0,D.assertIsDefined)(o.get(W)));for(const W of M.updated.values()){if(z.removed.has(W)||z.updated.has(W))continue;const _=(0,D.assertIsDefined)(o.get(W)),K=(0,D.assertIsDefined)(c.get(W));a.set(W,G(W,_,K,_))}for(const W of M.removed.values())z.updated.has(W)||z.removed.has(W)||b.has(W)||!(0,D.assertIsDefined)(c.get(W)).installed||F.has(W)||!(0,D.assertIsDefined)(u?.get(W)).installed||a.delete(W)}const $=[],j=O(c,a,new Set,!0),L=j.added.size>0||j.updated.size>0||j.removed.size>0;return L&&a.forEach((M,z)=>$.push(w(M,z))),{local:{added:m,removed:v,updated:f},remote:L?{added:[...j.added].map(M=>a.get(M)),updated:[...j.updated].map(M=>a.get(M)),removed:[...j.removed].map(M=>c.get(M)),all:$}:null}}e.merge=A;function O(p,h,g,y){const l=p?[...p.keys()].filter(n=>!g.has(n)):[],d=[...h.keys()].filter(n=>!g.has(n)),m=d.filter(n=>l.indexOf(n)===-1).reduce((n,s)=>(n.add(s),n),new Set),v=l.filter(n=>d.indexOf(n)===-1).reduce((n,s)=>(n.add(s),n),new Set),f=new Set;for(const n of l){if(v.has(n))continue;const s=p.get(n),t=h.get(n);(!t||!R(s,t,y,!0))&&f.add(n)}return{added:m,removed:v,updated:f}}function R(p,h,g,y){return!(p.disabled!==h.disabled||y&&p.installed!==h.installed||p.installed&&h.installed&&p.preRelease!==h.preRelease||!C(p.state,h.state)||g&&p.version!==h.version)}function P(p,h,g){const y=p.state,l=h.state,d=g?.state;if(!h.version||y&&i.gt(p.version,h.version))return y;if(l&&i.gt(h.version,p.version)||!y)return l;if(!l)return y;const m=(0,k.deepClone)(y),v=d?S(d,l):{added:Object.keys(l).reduce((n,s)=>(n.add(s),n),new Set),removed:new Set,updated:new Set},f=d?S(d,y):{added:Object.keys(y).reduce((n,s)=>(n.add(s),n),new Set),removed:new Set,updated:new Set};for(const n of[...v.added.values(),...v.updated.values()])m[n]=l[n];for(const n of v.removed.values())f.updated.has(n)||delete m[n];return m}function S(p,h){const g=Object.keys(p),y=Object.keys(h),l=y.filter(v=>g.indexOf(v)===-1).reduce((v,f)=>(v.add(f),v),new Set),d=g.filter(v=>y.indexOf(v)===-1).reduce((v,f)=>(v.add(f),v),new Set),m=new Set;for(const v of g){if(d.has(v))continue;const f=p[v],n=h[v];(0,k.equals)(f,n)||m.add(v)}return{added:l,removed:d,updated:m}}function C(p={},h={}){const{added:g,removed:y,updated:l}=S(p,h);return g.size===0&&y.size===0&&l.size===0}function E(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function w(p,h){const g={identifier:{id:p.identifier.id,uuid:h.startsWith("uuid:")?h.substring(5):void 0},preRelease:!!p.preRelease};return p.version&&(g.version=p.version),p.disabled&&(g.disabled=!0),p.installed&&(g.installed=!0),p.state&&(g.state=p.state),g}}),define(oe[114],ae([0,1,20,16,4]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,P){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return S=S.filter(C=>C!==R&&C!==`-${R}`),P&&S.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(R,P){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return S=S.filter(C=>C!==R&&C!==`-${R}`),P&&S.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(R){const P=R.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),S=this.b().map(w=>w.toLowerCase()),C=[],E=[];if(Array.isArray(S))for(const w of S)w.startsWith("-")?E.push(w.substring(1)):C.push(w);return(0,k.distinct)([...P,...C].filter(w=>E.indexOf(w)===-1))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};A=pe([Y(0,i.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(oe[253],ae([0,1,20,35,32,192,60]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(v){return(0,i.parse)(v)||[]}e.parseKeybindings=R;async function P(v,f,n,s,t){const r=R(v),o=R(f),c=n?R(n):null,a=[...r,...o,...c||[]].map(G=>G.key),u=await t.resolveUserBindings(a),b=C(r,o,c,u);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:v,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};const I=w(r),F=w(o),N=c?w(c):null,$=h(I,F,u),j=N?h(N,I,u):{added:[...I.keys()].reduce((G,W)=>(G.add(W),G),new Set),removed:new Set,updated:new Set},L=N?h(N,F,u):{added:[...F.keys()].reduce((G,W)=>(G.add(W),G),new Set),removed:new Set,updated:new Set},M=S($,j,L);let z=v;for(const G of M.removed.values())M.conflicts.has(G)||(z=d(z,G,s));for(const G of M.added.values()){if(M.conflicts.has(G))continue;const W=F.get(G);if(W.some(_=>_.command!==`-${G}`&&b.conflicts.has(u[_.key]))){M.conflicts.add(G);continue}z=l(z,W,s)}for(const G of M.updated.values()){if(M.conflicts.has(G))continue;const W=F.get(G);if(W.some(_=>_.command!==`-${G}`&&b.conflicts.has(u[_.key]))){M.conflicts.add(G);continue}z=m(z,G,W,s)}return{mergeContent:z,hasChanges:!0,hasConflicts:M.conflicts.size>0}}e.merge=P;function S(v,f,n){const s=new Set,t=new Set,r=new Set,o=new Set;for(const c of f.removed.values())n.updated.has(c)&&o.add(c);for(const c of n.removed.values())o.has(c)||(f.updated.has(c)?o.add(c):t.add(c));for(const c of f.added.values())o.has(c)||n.added.has(c)&&v.updated.has(c)&&o.add(c);for(const c of n.added.values())o.has(c)||(f.added.has(c)?v.updated.has(c)&&o.add(c):s.add(c));for(const c of f.updated.values())o.has(c)||n.updated.has(c)&&v.updated.has(c)&&o.add(c);for(const c of n.updated.values())o.has(c)||(f.updated.has(c)?v.updated.has(c)&&o.add(c):r.add(c));return{added:s,removed:t,updated:r,conflicts:o}}function C(v,f,n,s){const t=new Set,r=E(v,s),o=E(f,s),c=n?E(n,s):null,a=p(r,o);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const u=c?p(c,r):{added:[...r.keys()].reduce((j,L)=>(j.add(L),j),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const b=c?p(c,o):{added:[...o.keys()].reduce((j,L)=>(j.add(L),j),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:I,removed:F,updated:N,conflicts:$}=S(a,u,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:I,removed:F,updated:N,conflicts:$}}function E(v,f){const n=new Map;for(const s of v){const t=f[s.key];let r=n.get(t);r||(r=[],n.set(t,r)),r.push(s)}return n}function w(v){const f=new Map;for(const n of v){const s=n.command[0]==="-"?n.command.substring(1):n.command;let t=f.get(s);t||(t=[],f.set(s,t)),t.push(n)}return f}function p(v,f){const n=[...v.keys()],s=[...f.keys()],t=s.filter(c=>n.indexOf(c)===-1).reduce((c,a)=>(c.add(a),c),new Set),r=n.filter(c=>s.indexOf(c)===-1).reduce((c,a)=>(c.add(a),c),new Set),o=new Set;for(const c of n){if(r.has(c))continue;const a=v.get(c).map(b=>({...b,key:c})),u=f.get(c).map(b=>({...b,key:c}));(0,k.equals)(a,u,(b,I)=>y(b,I))||o.add(c)}return{added:t,removed:r,updated:o}}function h(v,f,n){const s=[...v.keys()],t=[...f.keys()],r=t.filter(a=>s.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),o=s.filter(a=>t.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),c=new Set;for(const a of s){if(o.has(a))continue;const u=v.get(a).map(I=>({...I,key:n[I.key]})),b=f.get(a).map(I=>({...I,key:n[I.key]}));g(u,b)||c.add(a)}return{added:r,removed:o,updated:c}}function g(v,f){return!(!(0,k.equals)(v.filter(({command:n})=>n[0]!=="-"),f.filter(({command:n})=>n[0]!=="-"),(n,s)=>y(n,s))||!(0,k.equals)(v.filter(({command:n})=>n[0]==="-"),f.filter(({command:n})=>n[0]==="-"),(n,s)=>y(n,s)))}function y(v,f){if(v.command!==f.command||v.key!==f.key)return!1;const n=A.ContextKeyExpr.deserialize(v.when),s=A.ContextKeyExpr.deserialize(f.when);return!(n&&!s||!n&&s||n&&s&&!n.equals(s)||!D.equals(v.args,f.args))}function l(v,f,n){for(const s of f)v=O.edit(v,[-1],s,n);return v}function d(v,f,n){const s=R(v);for(let t=s.length-1;t>=0;t--)(s[t].command===f||s[t].command===`-${f}`)&&(v=O.edit(v,[t],void 0,n));return v}function m(v,f,n,s){const t=R(v),r=t.findIndex(o=>o.command===f||o.command===`-${f}`);for(let o=t.length-1;o>=0;o--)(t[o].command===f||t[o].command===`-${f}`)&&(v=O.edit(v,[o],void 0,s));for(let o=n.length-1;o>=0;o--)v=O.edit(v,[r],n[o],s);return v}}),define(oe[254],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(A,O,R){const P={},S={},C=new Set;if(!O)return{local:{added:P,updated:S,removed:[...C.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const E=i(A,O);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:P,updated:S,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=i(R,A),p=i(R,O),h={},g={},y=new Set,l=new Set;for(const d of w.removed.values())p.updated.has(d)?P[d]=O[d]:y.add(d);for(const d of p.removed.values())l.has(d)||(w.updated.has(d)?l.add(d):C.add(d));for(const d of w.updated.values())l.has(d)||(p.updated.has(d)?E.updated.has(d)&&l.add(d):g[d]=A[d]);for(const d of p.updated.values())l.has(d)||(w.updated.has(d)?E.updated.has(d)&&l.add(d):A[d]!==void 0&&(S[d]=O[d]));for(const d of w.added.values())l.has(d)||(p.added.has(d)?E.updated.has(d)&&l.add(d):h[d]=A[d]);for(const d of p.added.values())l.has(d)||(w.added.has(d)?E.updated.has(d)&&l.add(d):P[d]=O[d]);return{local:{added:P,removed:[...C.values()],updated:S},remote:{added:h,removed:[...y.values()],updated:g},conflicts:[...l.values()]}}e.merge=k;function i(A,O){const R=A?Object.keys(A):[],P=O?Object.keys(O):[],S=P.filter(w=>R.indexOf(w)===-1).reduce((w,p)=>(w.add(p),w),new Set),C=R.filter(w=>P.indexOf(w)===-1).reduce((w,p)=>(w.add(p),w),new Set),E=new Set;for(const w of R){if(C.has(w))continue;const p=A[w],h=O[w];p!==h&&E.add(w)}return{added:S,removed:C,updated:E}}function D(A,O){const{added:R,removed:P,updated:S}=i(A,O);return R.size===0&&P.size===0&&S.size===0}e.areSame=D}),define(oe[255],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(D,A,O,R){const P={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!A){const E=D.filter(({id:w})=>!R.includes(w));return E.length?S.added=E:S=null,{local:P,remote:S}}const C=i(D,A,R);if(C.added.length>0||C.removed.length>0||C.updated.length>0){const E=i(O,D,R),w=i(O,A,R);for(const p of w.removed){const h=D.find(g=>g.id===p);h&&P.removed.push(h)}for(const p of w.added){const h=A.find(g=>g.id===p);E.added.includes(p)?C.updated.includes(p)&&P.updated.push(h):P.added.push(h)}for(const p of w.updated)P.updated.push(A.find(h=>h.id===p));for(const p of E.added)w.added.includes(p)||S.added.push(D.find(h=>h.id===p));for(const p of E.updated)w.removed.includes(p)||w.updated.includes(p)||S.updated.push(D.find(h=>h.id===p));for(const p of E.removed){const h=A.find(g=>g.id===p);h&&S.removed.push(h)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:P,remote:S}}e.merge=k;function i(D,A,O){D=D?D.filter(({id:w})=>!O.includes(w)):[],A=A.filter(({id:w})=>!O.includes(w));const R=D.map(({id:w})=>w),P=A.map(({id:w})=>w),S=P.filter(w=>R.indexOf(w)===-1),C=R.filter(w=>P.indexOf(w)===-1),E=[];for(const{id:w,name:p,shortName:h}of D){if(C.includes(w))continue;const g=A.find(y=>y.id===w);(!g||g.name!==p||g.shortName!==h)&&E.push(w)}return{added:S,removed:C,updated:E}}}),define(oe[26],ae([0,1,20,13,178,46,29,4,104,40]),function(ee,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const o=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(c=>!!o[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function E(){const o=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(o).filter(b=>!!o[b].ignoreSync),a=Object.keys(o).filter(b=>o[b].scope===2||o[b].scope===6),u=C();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...a,...u])}e.getDefaultIgnoredSettings=E,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function w(){const o="vscode://schemas/ignoredSettings",c=S.Registry.as(A.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=S.Registry.as(P.Extensions.JSONContribution),u=()=>{const b=C(),I=E().filter(j=>j!==e.CONFIGURATION_SYNC_STORE_KEY),F=Object.keys(A.allSettings.properties).filter(j=>I.indexOf(j)===-1),N=I.filter(j=>b.indexOf(j)===-1),$={items:{type:"string",enum:[...F,...N.map(j=>`-${j}`)]}};a.registerSchema(o,$)};return c.onDidUpdateConfiguration(()=>u())}e.registerConfiguration=w;function p(o){return o&&(0,i.isObject)(o)&&(0,i.isString)(o.id)&&Array.isArray(o.scopes)}e.isAuthenticationProvider=p;var h;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState",o.Profiles="profiles"})(h=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function g(o,...c){return o?[o,...c]:c}e.getPathSegments=g;function y(o,c,a,u){return u.joinPath(a.userDataSyncHome,...g(o,c,`lastSync${c}.json`))}e.getLastSyncResourceUri=y,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function l(o){const c={};return c[e.HEADER_EXECUTION_ID]=o,c}e.createSyncHeaders=l;var d;(function(o){o.Unauthorized="Unauthorized",o.NotFound="NotFound",o.MethodNotFound="MethodNotFound",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoCollection="NoCollection",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyProfiles="LocalTooManyProfiles",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.Unknown="Unknown"})(d=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class m extends Error{constructor(c,a,u,b){super(c),this.code=a,this.resource=u,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=m;class v extends m{constructor(c,a,u,b,I){super(c,u,void 0,I),this.url=a,this.serverCode=b}}e.UserDataSyncStoreError=v;class f extends m{constructor(c,a){super(c,a)}}e.UserDataAutoSyncError=f,function(o){function c(a){if(a instanceof o)return a;const u=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(u&&u[1]){const b=u[2]==="unknown"?void 0:u[2],I=u[3]==="unknown"?void 0:u[3];return new o(a.message,u[1],b,I)}return new o(a.message,"Unknown")}o.toUserDataSyncError=c}(m=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var s;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var t;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(o){return`sync.enable.${o}`}e.getEnablementKey=r,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(oe[256],ae([0,1,32,26]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(O,R,P,S,C){if(!R)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const E=A(O,R);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const w=P?A(P,R):{added:Object.keys(R).reduce((d,m)=>(d.add(m),d),new Set),removed:new Set,updated:new Set},p=P?A(P,O):{added:Object.keys(O).reduce((d,m)=>(d.add(m),d),new Set),removed:new Set,updated:new Set},h={added:{},removed:[],updated:{}},g=k.deepClone(R),y=!P;for(const d of p.added.values())d!==i.SYNC_SERVICE_URL_TYPE&&y&&w.added.has(d)||(g[d]=O[d]);for(const d of p.updated.values())g[d]=O[d];for(const d of p.removed.values())S.unregistered.includes(d)||delete g[d];for(const d of w.added.values()){const m=R[d];if(S.machine.includes(d)){C.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(P&&p.added.has(d))continue;const v=O[d];v&&v.value===m.value||d===i.SYNC_SERVICE_URL_TYPE&&y&&p.added.has(d)||(v?h.updated[d]=m:h.added[d]=m)}for(const d of w.updated.values()){const m=R[d];if(S.machine.includes(d)){C.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(p.updated.has(d)||p.removed.has(d))continue;const v=O[d];v&&v.value===m.value||(h.updated[d]=m)}for(const d of w.removed.values()){if(S.machine.includes(d)){C.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}p.updated.has(d)||p.removed.has(d)||h.removed.push(d)}const l=A(R,g);return{local:h,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:g}}}e.merge=D;function A(O,R){const P=Object.keys(O),S=Object.keys(R),C=S.filter(p=>P.indexOf(p)===-1).reduce((p,h)=>(p.add(h),p),new Set),E=P.filter(p=>S.indexOf(p)===-1).reduce((p,h)=>(p.add(h),p),new Set),w=new Set;for(const p of P){if(E.has(p))continue;const h=O[p],g=R[p];k.equals(h,g)||w.add(p)}return{added:C,removed:E,updated:w}}}),define(oe[257],ae([0,1,20,35,83,43,32,60,26]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(a,u,b){let I=[];b?I=E(b):I=C(u);const F=[],N=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(I))for(const $ of I)$.startsWith("-")?N.push($.substring(1)):F.push($);return(0,k.distinct)([...a,...F].filter($=>N.indexOf($)===-1))}e.getIgnoredSettings=S;function C(a){let u=a.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=a.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:a.getValue("settingsSync.ignoredSettings")||[]}function E(a){const u=(0,i.parse)(a);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function w(a,u){const b=(0,i.parse)(a)||{};let I="{}";for(const F of Object.keys(b)){const N=(0,D.setProperty)(I,[F],b[F],u);I=(0,D.applyEdits)(I,N)}return I}e.removeComments=w;function p(a,u,b,I){if(b.length){const F=c(u),N=(0,i.parse)(u)||{},$=(0,i.parse)(a);if(!$)return a;const j=[];for(const L of b){const M=N[L],z=$[L];M===void 0?a=R.edit(a,[L],void 0,I):z!==void 0?a=R.edit(a,[L],M,I):j.push(n(L,F))}j.sort((L,M)=>L.startOffset-M.startOffset),j.forEach(L=>a=d(L.setting.key,u,a,I))}return a}e.updateIgnoredSettings=p;function h(a,u,b,I,F,N){const $=p(a,u,I,N),j=b!==$,L=b!==u;if(!j&&!L)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!L)return{conflictsSettings:[],localContent:null,remoteContent:$,hasConflicts:!1};if(L&&!j)return{conflictsSettings:[],localContent:p(u,a,I,N),remoteContent:null,hasConflicts:!1};if(b===null&&y(a)){const B=g(a,u,I)?null:p(u,a,I,N);return{conflictsSettings:[],localContent:B,remoteContent:null,hasConflicts:!1}}let M=a,z=u;const G=(0,i.parse)(a),W=(0,i.parse)(u),_=b?(0,i.parse)(b):null,K=I.reduce((B,Q)=>(B.add(Q),B),new Set),q=l(G,W,K),V=l(_,G,K),Z=l(_,W,K),ne=new Map,J=new Set,x=B=>{J.add(B);const Q=F.filter(({key:re})=>re===B)[0];Q?(M=R.edit(M,[B],Q.value,N),z=R.edit(z,[B],Q.value,N)):ne.set(B,{key:B,localValue:G[B],remoteValue:W[B]})};for(const B of V.removed.values())Z.updated.has(B)?x(B):z=R.edit(z,[B],void 0,N);for(const B of Z.removed.values())J.has(B)||(V.updated.has(B)?x(B):M=R.edit(M,[B],void 0,N));for(const B of V.updated.values())J.has(B)||(Z.updated.has(B)?q.updated.has(B)&&x(B):z=R.edit(z,[B],G[B],N));for(const B of Z.updated.values())J.has(B)||(V.updated.has(B)?q.updated.has(B)&&x(B):M=R.edit(M,[B],W[B],N));for(const B of V.added.values())J.has(B)||(Z.added.has(B)?q.updated.has(B)&&x(B):z=d(B,M,z,N));for(const B of Z.added.values())J.has(B)||(V.added.has(B)?q.updated.has(B)&&x(B):M=d(B,z,M,N));const T=ne.size>0||!g(M,z,I),U=T||!g(M,a,[]),H=T||!g(z,u,[]);return{localContent:U?M:null,remoteContent:H?z:null,conflictsSettings:[...ne.values()],hasConflicts:T}}e.merge=h;function g(a,u,b){if(a===u)return!0;const I=(0,i.parse)(a),F=(0,i.parse)(u),N=b.reduce((L,M)=>(L.add(M),L),new Set),$=c(a).filter(L=>!(L.setting&&N.has(L.setting.key))),j=c(u).filter(L=>!(L.setting&&N.has(L.setting.key)));if($.length!==j.length)return!1;for(let L=0;L<$.length;L++){const M=$[L],z=j[L];if(M.setting&&z.setting){if(M.setting.key!==z.setting.key||!O.equals(I[M.setting.key],F[M.setting.key]))return!1}else if(!M.setting&&!z.setting){if(M.value!==z.value)return!1}else return!1}return!0}e.areSame=g;function y(a){return a?c(a).length===0:!0}e.isEmpty=y;function l(a,u,b){const I=a?Object.keys(a).filter(L=>!b.has(L)):[],F=Object.keys(u).filter(L=>!b.has(L)),N=F.filter(L=>I.indexOf(L)===-1).reduce((L,M)=>(L.add(M),L),new Set),$=I.filter(L=>F.indexOf(L)===-1).reduce((L,M)=>(L.add(M),L),new Set),j=new Set;if(a)for(const L of I){if($.has(L))continue;const M=a[L],z=u[L];O.equals(M,z)||j.add(L)}return{added:N,removed:$,updated:j}}function d(a,u,b,I){const F=(0,i.parse)(u),N=c(u),$=c(b),j=m(a,N,$);return v(b,a,F[a],j,$,I)}e.addSetting=d;function m(a,u,b){const I=u.findIndex(N=>N.setting?.key===a),F=u[I-1];if(F){if(F.setting){const $=n(F.setting.key,b);if($)return{index:b.indexOf($),insertAfter:!0}}else{const $=s(I,u);if($){const j=n($.setting.key,b);if(j){const L=t(b.indexOf(j),b),M=r(u,$,u[I]);if(L){const z=r(b,j,L),G=o(M,z);return G?{index:b.indexOf(G),insertAfter:!0}:{index:b.indexOf(L),insertAfter:!1}}else{const z=r(b,j,b[b.length-1]),G=o(M,z);return G?{index:b.indexOf(G),insertAfter:!0}:{index:b.length-1,insertAfter:!0}}}}}const N=u[I+1];if(N)if(N.setting){const $=n(N.setting.key,b);if($)return{index:b.indexOf($),insertAfter:!1}}else{const $=t(I,u);if($){const j=n($.setting.key,b);if(j){const L=s(b.indexOf(j),b),M=r(u,u[I],$);if(L){const z=r(b,L,j),G=o(M.reverse(),z.reverse());return G?{index:b.indexOf(G),insertAfter:!1}:{index:b.indexOf(L),insertAfter:!0}}else{const z=r(b,b[0],j),G=o(M.reverse(),z.reverse());return G?{index:b.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:b.length-1,insertAfter:!0}}function v(a,u,b,I,F,N){let $;return I.index===-1?$=(0,D.setProperty)(a,[u],b,N):$=f(a,u,b,I,F,N).map(j=>(0,D.withFormatting)(a,j,N)[0]),(0,D.applyEdits)(a,$)}function f(a,u,b,I,F,N){const $=`${JSON.stringify(u)}: ${JSON.stringify(b)}`,j=(0,A.getEOL)(N,a),L=F[I.index];if(I.insertAfter){const M=[];if(L.setting)M.push({offset:L.endOffset,length:0,content:","+$});else{const z=t(I.index,F),G=s(I.index,F),W=G?.setting?.commaOffset;G&&W===void 0&&M.push({offset:G.endOffset,length:0,content:","});const _=W!==void 0&&W>L.endOffset;M.push({offset:_?W+1:L.endOffset,length:0,content:z?j+$+",":j+$})}return M}else{if(L.setting)return[{offset:L.startOffset,length:0,content:$+","}];const M=(F[I.index-1]&&!F[I.index-1].setting?j:"")+$+(t(I.index,F)?",":"")+j;return[{offset:L.startOffset,length:0,content:M}]}}function n(a,u){return u.filter(b=>b.setting?.key===a)[0]}function s(a,u){for(let b=a-1;b>=0;b--)if(u[b].setting)return u[b]}function t(a,u){for(let b=a+1;b<u.length;b++)if(u[b].setting)return u[b]}function r(a,u,b){const I=a.indexOf(u),F=a.indexOf(b);return a.filter((N,$)=>I<$&&$<F)}function o(a,u){if(a.length&&u.length){let b=0;for(;b<u.length&&b<a.length;b++)if(a[b].value!==u[b].value)return u[b-1];return u[b-1]}}function c(a){const u=[];let b=-1,I,F;const N={onObjectBegin:$=>{b++},onObjectProperty:($,j,L)=>{b===0&&(I=j,F=$)},onObjectEnd:($,j)=>{b--,b===0&&u.push({startOffset:I,endOffset:$+j,value:a.substring(I,$+j),setting:{key:F,commaOffset:void 0}})},onArrayBegin:($,j)=>{b++},onArrayEnd:($,j)=>{b--,b===0&&u.push({startOffset:I,endOffset:$+j,value:a.substring(I,$+j),setting:{key:F,commaOffset:void 0}})},onLiteralValue:($,j,L)=>{b===0&&u.push({startOffset:I,endOffset:j+L,value:a.substring(I,j+L),setting:{key:F,commaOffset:void 0}})},onSeparator:($,j,L)=>{if(b===0&&$===","){let M=u.length-1;for(;M>=0&&!u[M].setting;M--);const z=u[M];z&&u.splice(M,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:j}})}},onComment:($,j)=>{b===0&&u.push({startOffset:$,endOffset:$+j,value:a.substring($,$+j)})}};return(0,i.visit)(a,N),u}}),define(oe[78],ae([0,1,3,2,4,26]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let O=class extends i.Disposable{get account(){return this.a}constructor(P,S){super(),this.g=P,this.h=S,this.b=this.B(new k.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new k.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(P.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(P.onTokenSucceed(()=>this.f=!1))}async updateAccount(P){(P&&this.a?P.token!==this.a.token||P.authenticationProviderId!==this.a.authenticationProviderId:P!==this.a)&&(this.a=P,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(P))}};O=pe([Y(0,A.IUserDataSyncStoreService),Y(1,A.IUserDataSyncLogService)],O),e.UserDataSyncAccountService=O}),define(oe[258],ae([0,1,2,7]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(w){this.a=w}listen(w,p){switch(p){case"onError":return this.a.onError}throw new Error(`Event not found: ${p}`)}call(w,p,h){switch(p){case"triggerSync":return this.a.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class A{constructor(w){this.a=w}listen(w,p){throw new Error(`Event not found: ${p}`)}call(w,p,h){switch(p){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(i.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class O{constructor(w){this.a=w}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(w){return this.a.call("resolveUserKeybindings",[w])}async resolveFormattingOptions(w){return this.a.call("resolveFormattingOptions",[w])}}e.UserDataSyncUtilServiceClient=O;class R{constructor(w){this.a=w}listen(w,p){switch(p){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${p}`)}async call(w,p,h){switch(p){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(h[0],h[1]);case"setEnablements":return this.a.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class P{constructor(w){this.a=w}listen(w,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(w,p,h){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class S{constructor(w){this.a=w}listen(w,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(w,p,h){switch(p){case"switch":return this.a.switch(h[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class C extends k.Disposable{constructor(w){super(),this.a=w,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(w){return this.a.call("switch",[w])}async getPreviousUserDataSyncStore(){const w=await this.a.call("getPreviousUserDataSyncStore");return this.b(w)}b(w){return{url:i.URI.revive(w.url),type:w.type,defaultUrl:i.URI.revive(w.defaultUrl),insidersUrl:i.URI.revive(w.insidersUrl),stableUrl:i.URI.revive(w.stableUrl),canSwitch:w.canSwitch,authenticationProviders:w.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=C}),define(oe[259],ae([0,1,15,8]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends i.AbstractLogger{constructor(O,R){super(),this.g=this.B(O.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(O,...R){this.g.trace(O,...R)}debug(O,...R){this.g.debug(O,...R)}info(O,...R){this.g.info(O,...R)}warn(O,...R){this.g.warn(O,...R)}error(O,...R){this.g.error(O,...R)}flush(){this.g.flush()}};D=pe([Y(0,i.ILoggerService),Y(1,k.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(oe[260],ae([0,1,6,3,2]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends D.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:P,getActiveWindowId:S}){super(),this.a=this.B(new D.DisposableStore),i.Event.latch(i.Event.any(R,P))(this.f,this,this.a),this.b=(0,k.createCancelablePromise)(()=>S()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=A}),define(oe[115],ae([0,1,181,12,48,22,7,4,21]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function S(s){const t=s;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=S,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function C(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,i.basename)(s)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=s;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=C;function E(s){const t=s;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=E;function w(s){const t=s;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=w;var p;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function h(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=h;function g(s){const t=s;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=g;class y{constructor(t,r,o,c,a){this.h=t,this.j=o,this.k=c,this.l=a,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class l{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function d(s){return new l({uri:s,index:0,name:(0,A.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=d,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(s,t){return A.extUriBiasedIgnorePathCase.isEqualOrParent(s,t.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function v(s){let t;return O.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=v;function f(s,t){return!m(s,t)&&!v(s)}e.isSavedWorkspace=f;function n(s){return(typeof s=="string"?(0,i.extname)(s):(0,A.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(oe[18],ae([0,1,66,3,2,22,7,173,15,14,4,8,115,37,30,6,31,27,13]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function m(t){const r=t;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&O.URI.isUri(r.location)&&O.URI.isUri(r.globalStorageHome)&&O.URI.isUri(r.settingsResource)&&O.URI.isUri(r.keybindingsResource)&&O.URI.isUri(r.tasksResource)&&O.URI.isUri(r.snippetsHome)&&O.URI.isUri(r.extensionsResource))}e.isUserDataProfile=m,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function v(t,r){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:O.URI.revive(t.location).with({scheme:r}),globalStorageHome:O.URI.revive(t.globalStorageHome).with({scheme:r}),settingsResource:O.URI.revive(t.settingsResource).with({scheme:r}),keybindingsResource:O.URI.revive(t.keybindingsResource).with({scheme:r}),tasksResource:O.URI.revive(t.tasksResource).with({scheme:r}),snippetsHome:O.URI.revive(t.snippetsHome).with({scheme:r}),extensionsResource:O.URI.revive(t.extensionsResource)?.with({scheme:r}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=v;function f(t,r,o,c){return{id:t,name:r,location:o,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,A.joinPath)(o,"globalStorage"),settingsResource:(0,A.joinPath)(o,"settings.json"),keybindingsResource:(0,A.joinPath)(o,"keybindings.json"),tasksResource:(0,A.joinPath)(o,"tasks.json"),snippetsHome:(0,A.joinPath)(o,"snippets"),extensionsResource:(0,A.joinPath)(o,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=f;let n=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(r,o,c,a){super(),this.m=r,this.n=o,this.r=c,this.s=a,this.f=!1,this.g=this.B(new i.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new i.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new i.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new i.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new p.ResourceMap},this.profilesHome=(0,A.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(r){this.f!==r&&(this.t=void 0,this.f=r)}isEnabled(){return this.f}get u(){if(!this.t){const r=[];if(this.f)for(const u of this.H()){if(!u.name||!(0,d.isString)(u.name)||!u.location){this.s.warn("Skipping the invalid stored profile",u.location||u.name);continue}r.push(f((0,A.basename)(u.location),u.name,u.location,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}))}let o;const c=new p.ResourceMap,a=f((0,k.hash)(this.m.userRoamingDataHome.path).toString(16),(0,R.localize)(0,null),this.m.userRoamingDataHome);if(r.unshift({...a,extensionsResource:this.M()??a.extensionsResource,isDefault:!0}),r.length){const u=this.J();if(u.workspaces)for(const[b,I]of Object.entries(u.workspaces)){const F=O.URI.parse(b),N=O.URI.parse(I),$=r.find(j=>this.r.extUri.isEqual(j.location,N));$&&c.set(F,$)}if(u.emptyWindow){const b=O.URI.parse(u.emptyWindow);o=r.find(I=>this.r.extUri.isEqual(I.location,b))}}this.t={profiles:r,workspaces:c,emptyWindow:o}}return this.t}async createTransientProfile(r){const o="Temp",c=new RegExp(`${(0,l.escapeRegExpCharacters)(o)}\\s(\\d+)`);let a=0;for(const b of this.profiles){const I=c.exec(b.name),F=I?parseInt(I[1]):0;a=F>a?F:a}const u=`${o} ${a+1}`;return this.createProfile((0,k.hash)((0,y.generateUuid)()).toString(16),u,{transient:!0},r)}async createNamedProfile(r,o,c){return this.createProfile((0,k.hash)((0,y.generateUuid)()).toString(16),r,o,c)}async createProfile(r,o,c,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.v(r,o,c);return a&&await this.setProfileForWorkspace(a,u),u}async v(r,o,c){if(!(0,d.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(o);return a||(a=(async()=>{try{const u=this.profiles.find(F=>F.name===o||F.id===r);if(u)return u;const b=f(r,o,(0,A.joinPath)(this.profilesHome,r),c);await this.n.createFolder(b.location);const I=[];return this.h.fire({profile:b,join(F){I.push(F)}}),await g.Promises.settled(I),this.C([b],[],[]),b}finally{this.k.delete(o)}})(),this.k.set(o,a)),a}async updateProfile(r,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(a=>a.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);return c=f(c.id,o.name??c.name,c.location,{shortName:o.shortName??c.shortName,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags}),this.C([],[],[c]),c}async removeProfile(r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const c=[];this.i.fire({profile:o,join(a){c.push(a)}});try{await Promise.allSettled(c)}catch(a){this.s.error(a)}o.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const a of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.G(),this.C([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(a){this.s.error(a)}}getOrSetProfileForWorkspace(r,o=this.defaultProfile){if(!this.f)return this.defaultProfile;let c=this.w(r);return c||(c=o,this.profiles.length>1&&this.setProfileForWorkspaceSync(r,c)),c}async setProfileForWorkspace(r,o){this.setProfileForWorkspaceSync(r,o)}setProfileForWorkspaceSync(r,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(a=>a.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.F(r,c)}unsetWorkspace(r,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(r,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const r=await this.n.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.l.profiles.filter(o=>!this.z(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}w(r){const o=this.y(r);return O.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindow??this.u.emptyWindow}y(r){return(0,w.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,w.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}z(r){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,r.location)||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,r.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,r.location)||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,r.location)))}C(r,o,c){const a=[...this.profiles,...r],u=[];this.l.profiles=[];for(let b of a)b.isDefault||o.some(I=>b.id===I.id)||(b=c.find(I=>b.id===I.id)??b,b.isTransient?this.l.profiles.push(b):u.push({location:b.location,name:b.name,shortName:b.shortName,useDefaultFlags:b.useDefaultFlags}));this.I(u),this.t=void 0,this.D(r,o,c)}D(r,o,c){this.g.fire({added:r,removed:o,updated:c,all:this.profiles})}F(r,o,c){c=o?.isTransient?!0:c,c||this.F(r,void 0,!0);const a=this.y(r),u=c?this.l:this.u;O.URI.isUri(a)?(u.workspaces.delete(a),o&&u.workspaces.set(a,o)):u.emptyWindow=o,c||this.G()}G(){const r={};for(const[c,a]of this.u.workspaces.entries())r[c.toString()]=a.location.toString();const o=this.u.emptyWindow?.location.toString();this.L({workspaces:r,emptyWindow:o}),this.t=void 0}H(){return[]}I(r){throw new Error("not implemented")}J(){return{}}L(r){throw new Error("not implemented")}M(){}};n.b="userDataProfiles",n.c="profileAssociations",n=pe([Y(0,P.IEnvironmentService),Y(1,S.IFileService),Y(2,h.IUriIdentityService),Y(3,E.ILogService)],n),e.UserDataProfilesService=n;class s extends n{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(r){this.a=r}J(){return this.P}L(r){this.P=r}}e.InMemoryUserDataProfilesService=s}),define(oe[261],ae([0,1,6,2,18]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=class extends i.Disposable{constructor(R){super(),this.B(new k.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};A=pe([Y(0,D.IUserDataProfilesService)],A),e.UserDataProfilesCleaner=A}),define(oe[262],ae([0,1,20,6,24,9,3,2,5,7,154,29,33,42,8,25,23,18]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let d=class extends R.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(t,r,o,c,a){super(),this.t=t,this.u=r,this.v=o,this.w=c,this.y=a,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new O.Emitter),this.m=this.B(new O.Emitter),this.n=this.B(new O.Emitter),this.p=this.B(new O.Emitter),this.s=[],this.B((0,R.toDisposable)(()=>{this.j.forEach(({task:u})=>u.cancel()),this.k.forEach(u=>u.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,E.isTargetPlatformCompatible)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.t.isEnabled())throw new E.ExtensionManagementError(C.localize(0,null),E.ExtensionManagementErrorCode.Internal);const o=await this.G(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw f(this.u,"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(t),error:o}),this.v.error("Failed to install extension.",t.identifier.id),this.v.error(o),v(o)}}async uninstall(t,r={}){return this.v.trace("ExtensionManagementService#uninstall",t.identifier.id),this.I(t,r)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.O(),this.h=t),this.g}registerParticipant(t){this.s.push(t)}async z(t,r,o){const c={...o,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,p.isApplicationScopedExtension)(t)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},a=$=>`${w.ExtensionKey.create($).toString()}${c.profileLocation?`-${c.profileLocation.toString()}`:""}`;if(!S.URI.isUri(r)){const $=this.j.get(a(r));if($){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:j}=await $.task.waitUntilTaskIsFinished();return j}}const u=[],b=[],I=[],F=this.Q(t,r,c);S.URI.isUri(r)||this.j.set(a(r),{task:F,waitingTasks:[]}),this.l.fire({identifier:F.identifier,source:r,profileLocation:c.profileLocation}),this.v.info("Installing extension:",F.identifier.id),u.push({task:F,manifest:t});let N=!1;try{if(c.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",F.identifier.id);else try{const j=await this.F(F.identifier,t,!!c.installOnlyNewlyAddedFromExtensionPack,!!c.installPreReleaseVersion,c.profileLocation),L=await this.getInstalled(void 0,c.profileLocation);for(const{gallery:M,manifest:z}of(0,k.distinct)(j,({gallery:G})=>G.identifier.id)){N=N||!!z.extensionDependencies?.some(_=>(0,w.areSameExtensions)({id:_},F.identifier));const G=a(M),W=this.j.get(G);if(W){if(this.C(F,W.task)){const _=W.task.identifier;this.v.info("Waiting for already requested installing extension",_.id,F.identifier.id),W.waitingTasks.push(F),b.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,K=>K.some(q=>(0,w.areSameExtensions)(q.identifier,_)))).then(K=>{if(this.v.info("Finished waiting for already requested installing extension",_.id,F.identifier.id),!K.find(V=>(0,w.areSameExtensions)(V.identifier,_))?.local)throw new Error(`Extension ${_.id} is not installed`)}))}}else if(!L.some(({identifier:_})=>(0,w.areSameExtensions)(_,M.identifier))){const _=this.Q(z,M,{...c,donotIncludePackAndDependencies:!0});this.j.set(G,{task:_,waitingTasks:[F]}),this.l.fire({identifier:_.identifier,source:M,profileLocation:c.profileLocation}),this.v.info("Installing extension:",_.identifier.id,F.identifier.id),u.push({task:_,manifest:z})}}}catch(j){if(S.URI.isUri(F.source))(0,k.isNonEmptyArray)(t.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",F.identifier.id,j.message),(0,k.isNonEmptyArray)(t.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",F.identifier.id,j.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",F.identifier.id),j}const $=u.reduce((j,{task:L,manifest:M})=>(j.set(L.identifier.id.toLowerCase(),{task:L,manifest:M}),j),new Map);for(;$.size;){let j;const L=[...$.values()].filter(({manifest:M})=>!M.extensionDependencies?.some(z=>$.has(z.toLowerCase())));L.length?j=$.size===1?L:L.filter(({task:M})=>!(M===F&&!N)):(this.v.info("Found extensions with circular dependencies",L.map(({task:M})=>M.identifier.id)),j=[...$.values()]),await this.D(j.map(async({task:M})=>{const z=new Date().getTime();try{const{local:G}=await M.run();if(await this.D(this.s.map(W=>W.postInstall(G,M.source,c,D.CancellationToken.None))),!S.URI.isUri(M.source)){const W=M.operation===3,_=W?void 0:(new Date().getTime()-M.source.lastUpdated)/1e3;if(f(this.u,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(M.source),wasVerified:M.wasVerified,duration:new Date().getTime()-z,durationSinceUpdate:_}),P.isWeb&&M.operation!==3)try{await this.t.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}I.push({local:G,identifier:M.identifier,operation:M.operation,source:M.source,context:c.context,profileLocation:c.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw S.URI.isUri(M.source)||f(this.u,M.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(M.source),wasVerified:M.wasVerified,duration:new Date().getTime()-z,error:G}),this.v.error("Error while installing the extension:",M.identifier.id),G}finally{$.delete(M.identifier.id.toLowerCase())}}))}return b.length&&await this.D(b),I.forEach(({identifier:j})=>this.v.info("Extension installed successfully:",j.id)),this.m.fire(I),I.filter(({identifier:j})=>(0,w.areSameExtensions)(j,F.identifier))[0].local}catch($){if(u.forEach(({task:j})=>j.cancel()),I.length)try{const j=await Promise.allSettled(I.map(({local:L})=>this.R(L,{versionOnly:!0,profileLocation:c.profileLocation}).run()));for(let L=0;L<j.length;L++){const M=j[L],{identifier:z}=I[L];M.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",z.id):this.v.warn("Rollback: Error while uninstalling extension",z.id,(0,A.getErrorMessage)(M.reason))}}catch(j){this.v.warn("Error while rolling back extensions",(0,A.getErrorMessage)(j),I.map(({identifier:L})=>L.id))}throw this.m.fire(u.map(({task:j})=>({identifier:j.identifier,operation:2,source:j.source,context:c.context,profileLocation:c.profileLocation}))),$}finally{for(const{task:$}of u)$.source&&!S.URI.isUri($.source)&&this.j.delete(a($.source))}}C(t,r){for(const[,{task:o,waitingTasks:c}]of this.j.entries())if(o===t&&(c.includes(r)||c.some(a=>this.C(a,r)))||o===r&&c[0]&&!this.C(t,c[0]))return!1;return!0}async D(t){const r=[],o=[],c=await Promise.allSettled(t);for(const a of c)a.status==="fulfilled"?r.push(a.value):o.push(a.reason);if(o.length)throw m(o);return r}async F(t,r,o,c,a){if(!this.t.isEnabled())return[];const u=await this.getInstalled(void 0,a),b=[],I=[],F=async(N,$)=>{b.push(N);const j=$.extensionDependencies||[],L=[...j];if($.extensionPack){const M=o?u.find(z=>(0,w.areSameExtensions)(z.identifier,N)):void 0;for(const z of $.extensionPack)M&&M.manifest.extensionPack&&M.manifest.extensionPack.some(G=>(0,w.areSameExtensions)({id:G},{id:z}))||L.every(G=>!(0,w.areSameExtensions)({id:G},{id:z}))&&L.push(z)}if(L.length){const M=L.filter(z=>b.every(G=>!(0,w.areSameExtensions)(G,{id:z})));if(M.length){const z=await this.t.getExtensions(M.map(G=>({id:G,preRelease:c})),D.CancellationToken.None);for(const G of z){if(b.find(K=>(0,w.areSameExtensions)(K,G.identifier)))continue;const W=j.some(K=>(0,w.areSameExtensions)({id:K},G.identifier));let _;try{_=await this.G(G,!1,c)}catch(K){if(K instanceof E.ExtensionManagementError&&K.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.v.info("Skipping the packed extension as it cannot be installed",G.identifier.id);continue}else throw K}I.push({gallery:_.extension,manifest:_.manifest}),await F(_.extension.identifier,_.manifest)}}}};return await F(t,r),I}async G(t,r,o){if((await this.getExtensionsControlManifest()).malicious.some(b=>(0,w.areSameExtensions)(t.identifier,b)))throw new E.ExtensionManagementError(C.localize(1,null,t.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const b=await this.getTargetPlatform();throw new E.ExtensionManagementError(C.localize(2,null,t.identifier.id,this.w.nameLong,(0,E.TargetPlatformToString)(b)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.H(t,r,o);if(a){if(o&&!r&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(C.localize(3,null,t.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.t.getExtensions([t.identifier],D.CancellationToken.None))[0]?new E.ExtensionManagementError(C.localize(4,null,t.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(C.localize(5,null,t.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",a.identifier.id);const u=await this.t.getManifest(a,D.CancellationToken.None);if(u===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(u.version!==a.version)throw new E.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:u}}async H(t,r,o){const c=await this.getTargetPlatform();let a=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(a=(await this.t.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},D.CancellationToken.None))[0]||null),!a&&await this.t.isExtensionCompatible(t,o,c)&&(a=t),a||(r?a=(await this.t.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},D.CancellationToken.None))[0]||null:a=await this.t.getCompatibleExtension(t,o,c)),a}async I(t,r){const o={...r,profileLocation:t.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},c=N=>`${N.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,a=this.k.get(c(t.identifier));if(a)return this.v.info("Extensions is already requested to uninstall",t.identifier.id),a.waitUntilTaskIsFinished();const u=N=>{const $=this.R(N,o);return this.k.set(c($.extension.identifier),$),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${N.identifier.id}@${N.manifest.version}`),this.n.fire({identifier:N.identifier,profileLocation:o.profileLocation,applicationScoped:N.isApplicationScoped}),$},b=(N,$)=>{$?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,o.profileLocation.toString(),$.message):this.v.error("Failed to uninstall extension:",`${N.identifier.id}@${N.manifest.version}`,$.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${N.identifier.id}@${N.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${N.identifier.id}@${N.manifest.version}`),f(this.u,"extensionGallery:uninstall",{extensionData:(0,w.getLocalExtensionTelemetryData)(N),error:$}),this.p.fire({identifier:N.identifier,error:$?.code,profileLocation:o.profileLocation,applicationScoped:N.isApplicationScoped})},I=[],F=[];try{I.push(u(t));const N=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const $=this.M(t,N);for(const j of $)this.k.has(c(j.identifier))?this.v.info("Extensions is already requested to uninstall",j.identifier.id):I.push(u(j))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.J(I.map($=>$.extension),N,t),await this.D(I.map(async $=>{try{if(await $.run(),await this.D(this.s.map(j=>j.postUninstall($.extension,o,D.CancellationToken.None))),$.extension.identifier.uuid)try{await this.t.reportStatistic($.extension.manifest.publisher,$.extension.manifest.name,$.extension.manifest.version,"uninstall")}catch{}b($.extension)}catch(j){const L=j instanceof E.ExtensionManagementError?j:new E.ExtensionManagementError((0,A.getErrorMessage)(j),E.ExtensionManagementErrorCode.Internal);throw b($.extension,L),L}finally{F.push($)}}))}catch(N){const $=N instanceof E.ExtensionManagementError?N:new E.ExtensionManagementError((0,A.getErrorMessage)(N),E.ExtensionManagementErrorCode.Internal);for(const j of I){try{j.cancel()}catch{}F.includes(j)||b(j.extension,$)}throw $}finally{for(const N of I)this.k.delete(c(N.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",N.extension.identifier.id)}}J(t,r,o){for(const c of t){const a=this.N(c,r);if(a.length){const u=a.filter(b=>!t.some(I=>(0,w.areSameExtensions)(I.identifier,b.identifier)));if(u.length)throw new Error(this.L(c,u,o))}}}L(t,r,o){return o===t?r.length===1?C.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?C.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const a=r.filter(b=>!b.isBuiltin&&c.some(I=>(0,w.areSameExtensions)({id:I},b.identifier))),u=[];for(const b of a)u.push(...this.M(b,r,o));return[...a,...u]}return[]}N(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,w.areSameExtensions)({id:c},t.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const t=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};d=pe([Y(0,E.IExtensionGalleryService),Y(1,y.ITelemetryService),Y(2,h.ILogService),Y(3,g.IProductService),Y(4,l.IUserDataProfilesService)],d),e.AbstractExtensionManagementService=d;function m(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=m;function v(s){if(s instanceof E.ExtensionManagementError)return s;const t=new E.ExtensionManagementError(s.message,E.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function f(s,t,{extensionData:r,wasVerified:o,duration:c,error:a,durationSinceUpdate:u}){let b,I;a&&(a instanceof E.ExtensionManagementError?(b=a.code,a.code===E.ExtensionManagementErrorCode.Signature&&(I=a.message)):b=E.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,wasVerified:o,success:!a,duration:c,errorcode:b,errorcodeDetail:I,durationSinceUpdate:u})}e.reportTelemetry=f;class n{constructor(){this.d=new i.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,i.createCancelablePromise)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,i.createCancelablePromise)(t=>new Promise((r,o)=>{const c=t.onCancellationRequested(()=>{c.dispose(),o(new A.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=n}),define(oe[61],ae([0,1,6,17,2,3,37,7,33,42,14,4,8,18,30,13,21]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let l=class extends D.Disposable{constructor(f,n,s,t){super(),this.h=f,this.i=n,this.j=s,this.k=t,this.a=this.B(new A.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new A.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new A.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new A.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new O.ResourceMap}scanProfileExtensions(f){return this.l(f)}async addExtensionsToProfile(f,n){const s=[],t=[];try{return await this.l(n,r=>{const o=[];for(const c of r)f.some(([a])=>(0,P.areSameExtensions)(a.identifier,c.identifier)&&a.manifest.version!==c.version)?s.push(c):o.push(c);for(const[c,a]of f)if(!o.some(u=>(0,P.areSameExtensions)(u.identifier,c.identifier)&&u.version===c.manifest.version)){const u={identifier:c.identifier,version:c.manifest.version,location:c.location,metadata:a};t.push(u),o.push(u)}return t.length&&this.a.fire({extensions:t,profileLocation:n}),s.length&&this.c.fire({extensions:s,profileLocation:n}),o}),t.length&&this.b.fire({extensions:t,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),t}catch(r){throw t.length&&this.b.fire({extensions:t,error:r,profileLocation:n}),s.length&&this.f.fire({extensions:s,error:r,profileLocation:n}),r}}async removeExtensionFromProfile(f,n){const s=[];this.c.fire({extensions:s,profileLocation:n});try{await this.l(n,t=>{const r=[];for(const o of t)(0,P.areSameExtensions)(o.identifier,f.identifier)?s.push(o):r.push(o);return s.length&&this.c.fire({extensions:s,profileLocation:n}),r}),s.length&&this.f.fire({extensions:s,profileLocation:n})}catch(t){throw s.length&&this.f.fire({extensions:s,error:t,profileLocation:n}),t}}async l(f,n){return this.s(f).queue(async()=>{let s=[],t;try{const r=await this.h.readFile(f);t=JSON.parse(r.value.toString())}catch(r){if((0,C.toFileOperationResult)(r)!==1)throw r;this.j.extUri.isEqual(f,this.i.defaultProfile.extensionsResource)&&(t=await this.r())}if(t){if(!Array.isArray(t))throw new Error(`Invalid extensions content in ${f.toString()}`);let r=!1;for(const o of t){if(!d(o))throw new Error(`Invalid extensions content in ${f.toString()}`);let c;if((0,g.isString)(o.location))c=this.n(f,o.location);else{c=R.URI.revive(o.location);const a=this.m(f,c);a&&(r=!0,o.location=a)}s.push({identifier:o.identifier,location:c,version:o.version,metadata:o.metadata})}r&&await this.h.writeFile(f,i.VSBuffer.fromString(JSON.stringify(t)))}if(n){s=n(s);const r=s.map(o=>({identifier:o.identifier,version:o.version,location:this.m(f,o.location)??o.location.toJSON(),metadata:o.metadata}));await this.h.writeFile(f,i.VSBuffer.fromString(JSON.stringify(r)))}return s})}m(f,n){const s=this.j.extUri.dirname(f).with({scheme:y.Schemas.file});if(this.j.extUri.isEqualOrParent(n,s))return this.j.extUri.relativePath(s,n)}n(f,n){return this.j.extUri.joinPath(this.j.extUri.dirname(f),n).with({scheme:y.Schemas.file})}async r(){return this.p||(this.p=(async()=>{const f=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let n;try{n=(await this.h.readFile(f)).value.toString()}catch(t){if((0,C.toFileOperationResult)(t)===1)return;throw t}this.k.info("Migrating extensions from old default profile location",f.toString());let s;try{const t=JSON.parse(n);Array.isArray(t)&&t.every(r=>d(r))?s=t:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",t)}catch(t){this.k.error(t)}if(s)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,i.VSBuffer.fromString(JSON.stringify(s)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",f.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(t){if((0,C.toFileOperationResult)(t)===3)this.k.info("Migration from old default profile location to new location is done by another window",f.toString(),this.i.defaultProfile.extensionsResource.toString());else throw t}try{await this.h.del(f)}catch(t){(0,C.toFileOperationResult)(t)!==1&&this.k.error(t)}return s})()),this.p}s(f){let n=this.g.get(f);return n||(n=new k.Queue,this.g.set(f,n)),n}};l=pe([Y(0,C.IFileService),Y(1,p.IUserDataProfilesService),Y(2,h.IUriIdentityService),Y(3,w.ILogService)],l),e.ExtensionsProfileScannerService=l;function d(v){return(0,g.isObject)(v)&&(0,S.isIExtensionIdentifier)(v.identifier)&&(m(v.location)||(0,g.isString)(v.location))&&v.version&&(0,g.isString)(v.version)}function m(v){return v?(0,g.isString)(v.path)&&(0,g.isString)(v.scheme):!1}}),define(oe[79],ae([0,1,20,6,32,17,9,35,136,2,21,12,5,22,53,88,13,7,157,15,33,42,70,14,4,8,25,3,67,61,18,30,187,188]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d,m,v,f,n,s,t,r,o,c,a,u,b,I,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var $;(function(_){function K(q,V){if(q===V)return!0;const Z=Object.keys(q),ne=new Set;for(const J of Object.keys(V))ne.add(J);if(Z.length!==ne.size)return!1;for(const J of Z){if(q[J]!==V[J])return!1;ne.delete(J)}return ne.size===0}_.equals=K})($=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let j=class extends S.Disposable{constructor(K,q,V,Z,ne,J,x,T,U,H,B,Q){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=q,this.l=V,this.m=Z,this.n=ne,this.p=J,this.r=x,this.s=T,this.t=U,this.u=H,this.v=B,this.w=Q,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,p.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(z,(0,p.joinPath)(this.m,f.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(z,(0,p.joinPath)(this.m,f.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(M,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,v.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(K,q,V){const[Z,ne]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(q)]),J=V?await this.scanExtensionsUnderDevelopment(K,[...Z,...ne]):[];return this.D(Z,ne,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const q=[];q.push(this.F(!!K.useCache,K.language)),q.push(this.G(K.language,!!K.checkControlFile));const[V,Z]=await Promise.all(q);return this.C([...V,...Z],0,K,!1)}async scanUserExtensions(K){const q=K.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",q);const V=await this.I(q,!!K.profileLocation,1,!K.includeUninstalled,K.language);let ne=await(K.useCache&&!V.devMode&&V.excludeObsolete?this.j:this.k).scanExtensions(V);return ne=await this.C(ne,1,K,!0),this.s.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(K,q){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const V=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(Z=>Z.scheme===C.Schemas.file).map(async Z=>{const ne=await this.I(Z,!1,1,!0,K.language,!1);return(await this.k.scanOneOrMultipleExtensions(ne)).map(x=>(x.type=q.find(T=>(0,v.areSameExtensions)(T.identifier,x.identifier))?.type??x.type,this.k.validate(x,ne)))}))).flat();return this.C(V,"development",K,!0)}return[]}async scanExistingExtension(K,q,V){const Z=await this.I(K,!1,q,!0,V.language),ne=await this.k.scanExtension(Z);return!ne||!V.includeInvalid&&!ne.isValid?null:ne}async scanOneOrMultipleExtensions(K,q,V){const Z=await this.I(K,!1,q,!0,V.language),ne=await this.k.scanOneOrMultipleExtensions(Z);return this.C(ne,q,V,!0)}async scanMetadata(K){const q=(0,p.joinPath)(K,"package.json"),V=(await this.r.readFile(q)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(K,q){const V=(0,p.joinPath)(K,"package.json"),Z=(await this.r.readFile(V)).value.toString(),ne=JSON.parse(Z);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,q.installedTimestamp=q.installedTimestamp||void 0,ne.__metadata={...ne.__metadata,...q},await this.r.writeFile((0,p.joinPath)(K,"package.json"),A.VSBuffer.fromString(JSON.stringify(ne,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const K=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(K))return;let q=(await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource)).length>0;q||(q=await this.r.exists(this.n.defaultProfile.extensionsResource));const V=this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json");let Z=(await this.p.scanProfileExtensions(V)).length>0;if(Z||(Z=await this.r.exists(V)),!q&&!Z){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const ne=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(ne.map(J=>[J,J.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(K,A.VSBuffer.fromString(""))}catch(ne){(0,s.toFileOperationResult)(ne)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.getErrorMessage)(ne))}}catch(K){throw this.s.error(K),K}})()),this.z}async C(K,q,V,Z){return V.includeAllVersions||(K=this.D(q===0?K:void 0,q===1?K:void 0,q==="development"?K:void 0,await this.getTargetPlatform(),Z)),V.includeInvalid||(K=K.filter(ne=>ne.isValid)),K.sort((ne,J)=>{const x=E.basename(ne.location.fsPath),T=E.basename(J.location.fsPath);return x<T?-1:x>T?1:0})}D(K,q,V,Z,ne){const J=(T,U,H)=>{if(T.isValid&&!U.isValid)return!1;if(T.isValid===U.isValid){if(ne&&h.gt(T.manifest.version,U.manifest.version))return this.s.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${T.location.path} with version ${T.manifest.version}`),!1;if(h.eq(T.manifest.version,U.manifest.version)){if(T.type===0)return this.s.debug(`Skipping extension ${U.location.path} in favour of system extension ${T.location.path} with same version`),!1;if(T.targetPlatform===Z)return this.s.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return H?this.s.warn(`Overwriting user extension ${T.location.path} with ${U.location.path}.`):this.s.debug(`Overwriting user extension ${T.location.path} with ${U.location.path}.`),!0},x=new Map;return K?.forEach(T=>{const U=f.ExtensionIdentifier.toKey(T.identifier.id),H=x.get(U);(!H||J(H,T,!1))&&x.set(U,T)}),q?.forEach(T=>{const U=f.ExtensionIdentifier.toKey(T.identifier.id),H=x.get(U);if(!H&&K&&T.type===0){this.s.debug(`Skipping obsolete system extension ${T.location.path}.`);return}(!H||J(H,T,!1))&&x.set(U,T)}),V?.forEach(T=>{const U=f.ExtensionIdentifier.toKey(T.identifier.id),H=x.get(U);(!H||J(H,T,!0))&&x.set(U,T),x.set(U,T)}),[...x.values()]}async F(K,q){this.s.trace("Started scanning system extensions");const V=await this.I(this.systemExtensionsLocation,!1,0,!0,q),ne=await(K&&!V.devMode?this.i:this.k).scanExtensions(V);return this.s.trace("Scanned system extensions:",ne.length),ne}async G(K,q){const V=this.t.isBuilt?[]:this.u.builtInExtensions;if(!V?.length)return[];this.s.trace("Started scanning dev system extensions");const Z=q?await this.H():{},ne=[],J=l.URI.file(E.normalize(E.join(C.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const T of V){const U=Z[T.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":ne.push((0,p.joinPath)(J,T.name));break;default:ne.push(l.URI.file(U));break}}const x=await Promise.all(ne.map(async T=>this.k.scanExtension(await this.I(T,!1,0,!0,K))));return this.s.trace("Scanned dev system extensions:",x.length),(0,k.coalesce)(x)}async H(){try{const K=await this.r.readFile(this.l);return JSON.parse(K.value.toString())}catch{return{}}}async I(K,q,V,Z,ne,J=!0){const x=await this.f(ne??w.language),T=await this.J(K),U=q&&!this.v.extUri.isEqual(K,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,H=U?await this.J(U):void 0;return new L(K,T,U,H,q,V,Z,J,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,ne,x)}async J(K){try{const q=await this.r.stat(K);if(typeof q.mtime=="number")return q.mtime}catch{}}};j=pe([Y(4,b.IUserDataProfilesService),Y(5,u.IExtensionsProfileScannerService),Y(6,s.IFileService),Y(7,r.ILogService),Y(8,m.IEnvironmentService),Y(9,o.IProductService),Y(10,I.IUriIdentityService),Y(11,t.IInstantiationService)],j),e.AbstractExtensionsScannerService=j;class L{constructor(K,q,V,Z,ne,J,x,T,U,H,B,Q,re,X){this.location=K,this.mtime=q,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=Z,this.profile=ne,this.type=J,this.excludeObsolete=x,this.validate=T,this.productVersion=U,this.productDate=H,this.productCommit=B,this.devMode=Q,this.language=re,this.translations=X}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,q){return(0,p.isEqual)(K.location,q.location)&&K.mtime===q.mtime&&(0,p.isEqual)(K.applicationExtensionslocation,q.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&K.profile===q.profile&&K.type===q.type&&K.excludeObsolete===q.excludeObsolete&&K.validate===q.validate&&K.productVersion===q.productVersion&&K.productDate===q.productDate&&K.productCommit===q.productCommit&&K.devMode===q.devMode&&K.language===q.language&&$.equals(K.translations,q.translations)}}let M=class extends S.Disposable{constructor(K,q,V,Z,ne){super(),this.f=K,this.g=q,this.h=V,this.i=Z,this.j=ne}async scanExtensions(K){const q=K.profile?await this.l(K):await this.k(K);let V={};if(K.excludeObsolete&&K.type===1)try{const Z=(await this.i.readFile(this.f)).value.toString();V=JSON.parse(Z)}catch{}return(0,y.isEmptyObject)(V)?q:q.filter(Z=>!V[v.ExtensionKey.create(Z).toString()])}async k(K){const q=await this.i.resolve(K.location);if(!q.children?.length)return[];const V=await Promise.all(q.children.map(async Z=>{if(!Z.isDirectory||K.type===1&&(0,p.basename)(Z.resource).indexOf(".")===0)return null;const ne=new L(Z.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(ne)}));return(0,k.coalesce)(V).sort((Z,ne)=>Z.location.path<ne.location.path?-1:1)}async l(K){let q=await this.m(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){q=q.filter(Z=>!Z.metadata?.isApplicationScoped);const V=await this.m(K.applicationExtensionslocation,Z=>!!Z.metadata?.isApplicationScoped,K);q.push(...V)}return q}async m(K,q,V){const Z=await this.g.scanProfileExtensions(K);if(!Z.length)return[];const ne=await Promise.all(Z.map(async J=>{if(q(J)){const x=new L(J.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(x,J.metadata)}return null}));return(0,k.coalesce)(ne)}async scanOneOrMultipleExtensions(K){try{if(await this.i.exists((0,p.joinPath)(K.location,"package.json"))){const q=await this.scanExtension(K);return q?[q]:[]}else return await this.scanExtensions(K)}catch(q){return this.j.error(`Error scanning extensions at ${K.location.path}:`,(0,O.getErrorMessage)(q)),[]}}async scanExtension(K,q){try{let V=await this.scanExtensionManifest(K.location);if(V){V.publisher||(V.publisher=f.UNDEFINED_PUBLISHER),q=q??V.__metadata,delete V.__metadata;const Z=(0,v.getGalleryExtensionId)(V.publisher,V.name),ne=q?.id?{id:Z,uuid:q.id}:{id:Z},J=q?.isSystem?0:K.type,x=J===0||!!q?.isBuiltin;N.ImplicitActivationEvents.updateManifest(V),V=await this.n(K.location,V,L.createNlsConfiguration(K));const T={type:J,identifier:ne,manifest:V,location:K.location,isBuiltin:x,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return K.validate?this.validate(T,K):T}}catch(V){K.type!==0&&this.j.error(V)}return null}validate(K,q){let V=!0;const Z=(0,n.validateExtensionManifest)(q.productVersion,q.productDate,q.location,K.manifest,K.isBuiltin);for(const[ne,J]of Z)ne===g.default.Error&&(V=!1,this.j.error(this.t(q.location,J)));return K.isValid=V,K.validations=Z,K}async scanExtensionManifest(K){const q=(0,p.joinPath)(K,"package.json");let V;try{V=(await this.i.readFile(q)).value.toString()}catch(ne){return(0,s.toFileOperationResult)(ne)!==1&&this.j.error(this.t(K,(0,d.localize)(0,null,q.path,ne.message))),null}let Z;try{Z=JSON.parse(V)}catch{const J=[];(0,R.parse)(V,J);for(const x of J)this.j.error(this.t(K,(0,d.localize)(1,null,q.path,x.offset,x.length,(0,P.getParseErrorMessage)(x.error))));return null}return(0,R.getNodeType)(Z)!=="object"?(this.j.error(this.t(K,(0,d.localize)(2,null,q.path))),null):Z}async n(K,q,V){const Z=await this.p(K,q,V);if(Z)try{const ne=[],J=await this.r(Z.default,ne);if(ne.length>0)return ne.forEach(T=>{this.j.error(this.t(K,(0,d.localize)(3,null,Z.default?.path,(0,P.getParseErrorMessage)(T.error))))}),q;if((0,R.getNodeType)(Z)!=="object")return this.j.error(this.t(K,(0,d.localize)(4,null,Z.default?.path))),q;const x=Z.values||Object.create(null);return(0,F.localizeManifest)(q,x,J)}catch{}return q}async p(K,q,V){const Z=(0,p.joinPath)(K,"package.nls.json"),ne=(U,H)=>{H.forEach(B=>{this.j.error(this.t(K,(0,d.localize)(5,null,U?.path,(0,P.getParseErrorMessage)(B.error))))})},J=U=>{this.j.error(this.t(K,(0,d.localize)(6,null,U?.path)))},x=`${q.publisher}.${q.name}`,T=V.translations[x];if(T)try{const U=l.URI.file(T),H=(await this.i.readFile(U)).value.toString(),B=[],Q=(0,R.parse)(H,B);return B.length>0?(ne(U,B),{values:void 0,default:Z}):(0,R.getNodeType)(Q)!=="object"?(J(U),{values:void 0,default:Z}):{values:Q.contents?Q.contents.package:void 0,default:Z}}catch{return{values:void 0,default:Z}}else{if(!await this.i.exists(Z))return;let H;try{H=await this.s(K,V)}catch{return}if(!H.localized)return{values:void 0,default:H.original};try{const B=(await this.i.readFile(H.localized)).value.toString(),Q=[],re=(0,R.parse)(B,Q);return Q.length>0?(ne(H.localized,Q),{values:void 0,default:H.original}):(0,R.getNodeType)(re)!=="object"?(J(H.localized),{values:void 0,default:H.original}):{values:re,default:H.original}}catch{return{values:void 0,default:H.original}}}}async r(K,q){if(K)try{const V=(await this.i.readFile(K)).value.toString();return(0,R.parse)(V,q)}catch{}}s(K,q){return new Promise((V,Z)=>{const ne=J=>{const x=(0,p.joinPath)(K,`package.nls.${J}.json`);this.i.exists(x).then(T=>{T&&V({localized:x,original:(0,p.joinPath)(K,"package.nls.json")});const U=J.lastIndexOf("-");U===-1?V({localized:(0,p.joinPath)(K,"package.nls.json"),original:null}):(J=J.substring(0,U),ne(J))})};if(q.devMode||q.pseudo||!q.language)return V({localized:(0,p.joinPath)(K,"package.nls.json"),original:null});ne(q.language)})}t(K,q){return`[${K.path}]: ${q}`}};M=pe([Y(1,u.IExtensionsProfileScannerService),Y(2,I.IUriIdentityService),Y(3,s.IFileService),Y(4,r.ILogService)],M);let z=class extends M{constructor(K,q,V,Z,ne,J){super(q,V,Z,ne,J),this.y=K,this.v=this.B(new i.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(K){const q=await this.z();if(this.u=K,q&&q.input&&L.equals(q.input,this.u))return this.v.trigger(()=>this.D()),q.result.map(Z=>(Z.location=l.URI.revive(Z.location),Z));const V=await super.scanExtensions(K);return await this.C({input:K,result:V}),V}async z(){try{const K=await this.i.readFile(this.y),q=JSON.parse(K.value.toString());return{result:q.result,input:(0,a.revive)(q.input)}}catch(K){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,O.getErrorMessage)(K))}return null}async C(K){try{await this.i.writeFile(this.y,A.VSBuffer.fromString(JSON.stringify(K)))}catch(q){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,O.getErrorMessage)(q))}}async D(){if(!this.u)return;const K=await this.z();if(!K)return;const q=K.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!D.equals(V,q))try{await this.i.del(this.y),this.w.fire()}catch(Z){this.j.error(Z)}}};z=pe([Y(2,u.IExtensionsProfileScannerService),Y(3,I.IUriIdentityService),Y(4,s.IFileService),Y(5,r.ILogService)],z);function G(_,K){const q=(0,v.getExtensionId)(_.manifest.publisher,_.manifest.name);return{id:q,identifier:new f.ExtensionIdentifier(q),isBuiltin:_.type===0,isUserBuiltin:_.type===1&&_.isBuiltin,isUnderDevelopment:K,extensionLocation:_.location,uuid:_.identifier.uuid,targetPlatform:_.targetPlatform,..._.manifest}}e.toExtensionDescription=G;class W extends j{constructor(K,q,V,Z,ne,J,x,T,U,H,B,Q){super(K,q,(0,p.joinPath)(V,".vscode-oss-dev","extensions","control.json"),(0,p.joinPath)(Z,f.MANIFEST_CACHE_FOLDER),ne,J,x,T,U,H,B,Q),this.L=(async()=>{if(w.translationsConfigFile)try{const re=await this.r.readFile(l.URI.file(w.translationsConfigFile));return JSON.parse(re.value.toString())}catch{}return Object.create(null)})()}f(K){return this.L}}e.NativeExtensionsScannerService=W}),define(oe[263],ae([0,1,49,6,38,3,2,21,12,28,8,18]),function(ee,e,k,i,D,A,O,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let w=class extends O.Disposable{constructor(h,g){super(),this.b=h,this.f=g,this.a=new i.Limiter(5)}async postUninstall(h){const g=this.g(h,"uninstall");return g&&(this.f.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(g.script,"uninstall",g.args,!0,h).then(()=>this.f.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),y=>this.f.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${y}`)))),S.Promises.rm(this.j(h)).then(void 0,y=>this.f.error("Error while removing extension storage path",y))}g(h,g){const y=`vscode:${g}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[y]=="string"){const l=h.manifest.scripts[y].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(h.identifier.id,h.manifest.version,`${y} should be a node script`),null):{script:(0,P.join)(h.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(h,g,y,l,d){return new Promise((m,v)=>{const f=this.i(h,g,y,d);let n;const s=t=>{n&&(clearTimeout(n),n=null),t?v(t):m(void 0)};f.on("error",t=>{s((0,D.toErrorMessage)(t)||"Unknown")}),f.on("exit",(t,r)=>{s(t?`post-${g} process exited with code ${t}`:void 0)}),l&&(n=setTimeout(()=>{n=null,f.kill(),v("timed out")},5e3))})}i(h,g,y,l){const d={silent:!0,execArgv:void 0},m=(0,k.fork)(h,[`--type=extension-post-${g}`,...y],d);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const v=A.Event.fromNodeEventEmitter(m.stdout,"data"),f=A.Event.fromNodeEventEmitter(m.stderr,"data");v(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${g}`,t)),f(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${g}`,t));const n=A.Event.any(A.Event.map(v,t=>({data:`%c${t}`,format:[""]})),A.Event.map(f,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(n,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),m}j(h){return(0,P.join)(this.b.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};w=pe([Y(0,E.IUserDataProfilesService),Y(1,C.ILogService)],w),e.ExtensionsLifecycle=w}),define(oe[264],ae([0,1,7,15,61,79,14,4,8,25,30,18]),function(ee,e,k,i,D,A,O,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends A.NativeExtensionsScannerService{constructor(h,g,y,l,d,m,v,f){super(k.URI.file(d.builtinExtensionsPath),k.URI.file(d.extensionsPath),d.userHome,k.URI.file(d.userDataPath),h,g,y,l,d,m,v,f)}};w=pe([Y(0,E.IUserDataProfilesService),Y(1,D.IExtensionsProfileScannerService),Y(2,O.IFileService),Y(3,P.ILogService),Y(4,i.INativeEnvironmentService),Y(5,S.IProductService),Y(6,C.IUriIdentityService),Y(7,R.IInstantiationService)],w),e.ExtensionsScannerService=w}),define(oe[19],ae([0,1,6,3,2,206,13,69,4,18]),function(ee,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,P.createDecorator)("storageService");var C;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var w;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(w=e.StorageTarget||(e.StorageTarget={}));function p(d){const m=d.get(e.TARGET_KEY);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}e.loadKeyTargets=p;class h extends D.Disposable{constructor(m={flushInterval:h.a}){super(),this.j=m,this.b=this.B(new i.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new i.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new i.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new k.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,k.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(m,v){if(v===e.TARGET_KEY){switch(m){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:v,target:this.F(m)[v]})}r(m){this.f.fire({reason:m})}get(m,v,f){return this.L(v)?.get(m,f)}getBoolean(m,v,f){return this.L(v)?.getBoolean(m,f)}getNumber(m,v,f){return this.L(v)?.getNumber(m,f)}store(m,v,f,n){if((0,O.isUndefinedOrNull)(v)){this.remove(m,f);return}this.t(()=>{this.u(m,f,n),this.L(f)?.set(m,v)})}remove(m,v){this.t(()=>{this.u(m,v,void 0),this.L(v)?.delete(m)})}t(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,v){const f=[],n=this.F(m);for(const s of Object.keys(n))n[s]===v&&f.push(s);return f}u(m,v,f){const n=this.F(v);typeof f=="number"?n[m]!==f&&(n[m]=f,this.L(v)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[m]=="number"&&(delete n[m],this.L(v)?.set(e.TARGET_KEY,JSON.stringify(n)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(m){switch(m){case-1:return this.D;case 0:return this.z;default:return this.w}}G(m){const v=this.L(m);return v?p(v):Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=C.NONE){this.f.fire({reason:m});const v=this.L(-1),f=this.L(0),n=this.L(1);switch(m){case C.NONE:await k.Promises.settled([v?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await k.Promises.settled([v?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.L(-1)?.items??new Map,v=this.L(0)?.items??new Map,f=this.L(1)?.items??new Map;return l(m,v,f,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(m,v){return this.r(C.NONE),(0,S.isUserDataProfile)(m)?this.N(m,v):this.O(m,v)}H(m,v){return!(m.id===v.id||g(v)&&g(m))}I(m,v,f,n){this.t(()=>{if(n)for(const[s,t]of m)v.set(s,t);else{const s=new Set;for(const[t,r]of m)s.add(t),v.get(t)!==r&&this.n(f,t);for(const[t]of v.items)s.has(t)||this.n(f,t)}})}}e.AbstractStorageService=h,h.a=60*1e3;function g(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=g;class y extends h{constructor(){super(),this.p=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(m=>this.n(1,m))),this.B(this.P.onDidChangeStorage(m=>this.n(0,m))),this.B(this.p.onDidChangeStorage(m=>this.n(-1,m)))}L(m){switch(m){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(m){return!1}}e.InMemoryStorageService=y;async function l(d,m,v,f,n,s){const t=N=>{try{return JSON.parse(N)}catch{return N}},r=new Map,o=new Map;d.forEach((N,$)=>{r.set($,N),o.set($,t(N))});const c=new Map,a=new Map;m.forEach((N,$)=>{c.set($,N),a.set($,t(N))});const u=new Map,b=new Map;v.forEach((N,$)=>{u.set($,N),b.set($,t(N))}),console.group(f!==n?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const I=[];if(r.forEach((N,$)=>{I.push({key:$,value:N})}),console.table(I),console.groupEnd(),console.log(o),f!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const N=[];c.forEach(($,j)=>{N.push({key:j,value:$})}),console.table(N),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${s})`);const F=[];u.forEach((N,$)=>{F.push({key:$,value:N})}),console.table(F),console.groupEnd(),console.log(b)}e.logStorage=l}),define(oe[116],ae([0,1,3,2,13,29,33,19]),function(ee,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends i.Disposable{constructor(E,w){super(),this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new S(E)),this.B(this.b.onDidChange(p=>this.a.fire({extensions:p,source:"storage"}))),this.B(w.onDidInstallExtensions(p=>p.forEach(({local:h,operation:g})=>{h&&g===4&&this.f(h.identifier)})))}async enableExtension(E,w){return this.f(E)?(this.a.fire({extensions:[E],source:w}),!0):!1}async disableExtension(E,w){return this.c(E)?(this.a.fire({extensions:[E],source:w}),!0):!1}getDisabledExtensions(){return this.h(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const w=this.getDisabledExtensions();return w.every(p=>!(0,O.areSameExtensions)(p,E))?(w.push(E),this.g(w),!0):!1}f(E){const w=this.getDisabledExtensions();for(let p=0;p<w.length;p++){const h=w[p];if((0,O.areSameExtensions)(h,E))return w.splice(p,1),this.g(w),!0}return!1}g(E){this.i(A.DISABLED_EXTENSIONS_STORAGE_PATH,E)}h(E){return this.b.get(E,0)}i(E,w){this.b.set(E,w,0)}};P=pe([Y(0,R.IStorageService),Y(1,A.IExtensionManagementService)],P),e.GlobalExtensionEnablementService=P;class S extends i.Disposable{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new k.Emitter),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(w=>this.f(w)))}get(E,w){let p;return w===0?((0,D.isUndefinedOrNull)(this.a[E])&&(this.a[E]=this.g(E,w)),p=this.a[E]):p=this.g(E,w),JSON.parse(p)}set(E,w,p){const h=JSON.stringify(w.map(({id:y,uuid:l})=>({id:y,uuid:l})));this.g(E,p)!==h&&(p===0&&(w.length?this.a[E]=h:delete this.a[E]),this.h(E,w.length?h:void 0,p))}f(E){if(E.scope===0&&!(0,D.isUndefinedOrNull)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const p=this.get(E.key,E.scope);delete this.a[E.key];const h=this.get(E.key,E.scope),g=p.filter(l=>!h.some(d=>(0,O.areSameExtensions)(l,d))),y=h.filter(l=>!p.some(d=>(0,O.areSameExtensions)(d,l)));(g.length||y.length)&&this.b.fire([...g,...y])}}g(E,w){return this.c.get(E,w,"[]")}h(E,w,p){w?this.c.store(E,w,p,1):this.c.remove(E,p)}}e.StorageManager=S}),define(oe[265],ae([0,1,20,24,9,5,36,13,7,16,15,29,33,70,14,8,25,59,236,19,23]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const f=A.isWeb?"web":(0,E.getTargetPlatform)(A.platform,O.arch);var n;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...T){return String(T.reduce((U,H)=>U|H,0))}var t;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class u{constructor(U=a){this.d=U}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(U,H=this.d.pageSize){return new u({...this.d,pageNumber:U,pageSize:H})}withFilter(U,...H){const B=[...this.d.criteria,...H.length?H.map(Q=>({filterType:U,value:Q})):[{filterType:U}]];return new u({...this.d,criteria:B})}withSortBy(U){return new u({...this.d,sortBy:U})}withSortOrder(U){return new u({...this.d,sortOrder:U})}withFlags(...U){return new u({...this.d,flags:U.reduce((H,B)=>H|B,0)})}withAssetTypes(...U){return new u({...this.d,assetTypes:U})}withSource(U){return new u({...this.d,source:U})}get raw(){const{criteria:U,pageNumber:H,pageSize:B,sortBy:Q,sortOrder:re,flags:X,assetTypes:te}=this.d;return{filters:[{criteria:U,pageNumber:H,pageSize:B,sortBy:Q,sortOrder:re}],assetTypes:te,flags:X}}get searchText(){const U=this.d.criteria.filter(H=>H.filterType===t.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(U=>String(U.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function b(T,U){const H=(T||[]).filter(B=>B.statisticName===U)[0];return H?H.value:0}function I(T){const U="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(B=>B.assetType.indexOf(U)===0).reduce((B,Q)=>{const re=$(T,Q.assetType);return re&&B.push([Q.assetType.substring(U.length),re]),B},[])}function F(T){if(T.properties){const U=T.properties.filter(Q=>Q.key===r.Repository),H=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=U.filter(Q=>H.test(Q.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return $(T,r.Repository)}function N(T){return{uri:`${T.fallbackAssetUri}/${r.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${r.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function $(T,U){return T.files.filter(B=>B.assetType===U)[0]?{uri:`${T.assetUri}/${U}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${U}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function j(T,U){const H=T.properties?T.properties.filter(Q=>Q.key===U):[],B=H.length>0&&H[0].value;return B?B.split(",").map(Q=>(0,w.adoptToGalleryExtensionId)(Q)):[]}function L(T){const U=T.properties?T.properties.filter(H=>H.key===o.Engine):[];return U.length>0&&U[0].value||""}function M(T){const U=T.properties?T.properties.filter(H=>H.key===o.PreRelease):[];return U.length>0&&U[0].value==="true"}function z(T){const U=T.properties?T.properties.filter(B=>B.key===o.LocalizedLanguages):[],H=U.length>0&&U[0].value||"";return H?H.split(","):[]}function G(T){return T.properties?.find(U=>U.key===o.SponsorLink)?.value}function W(T){return T.indexOf("preview")!==-1}function _(T){return T.targetPlatform?(0,E.toTargetPlatform)(T.targetPlatform):"undefined"}function K(T){const U=(0,k.distinct)(T.versions.map(_)),H=!!T.tags?.includes(E.WEB_EXTENSION_TAG),B=U.indexOf("web");return H?B===-1&&U.push("web"):B!==-1&&U.splice(B,1),U}function q(T,U){const H=(0,E.getFallbackTargetPlarforms)(U);for(let B=0;B<T.length;B++){const Q=T[B];if(Q.version===T[B-1]?.version){let re=B;const X=_(Q);if(X===U)for(;re>0&&T[re-1].version===Q.version;)re--;else if(H.includes(X))for(;re>0&&T[re-1].version===Q.version&&_(T[re-1])!==U;)re--;re!==B&&(T.splice(B,1),T.splice(re,0,Q))}}return T}e.sortExtensionVersions=q;function V(T,U,H){T.telemetryData={index:U,querySource:H}}function Z(T,U,H){const B=T.versions[0],Q={manifest:$(U,r.Manifest),readme:$(U,r.Details),changelog:$(U,r.Changelog),license:$(U,r.License),repository:F(U),download:N(U),icon:$(U,r.Icon),signature:$(U,r.Signature),coreTranslations:I(U)};return{identifier:{id:(0,w.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:U.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(B),description:T.shortDescription||"",installCount:b(T.statistics,"install"),rating:b(T.statistics,"averagerating"),ratingCount:b(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:H,assets:Q,properties:{dependencies:j(U,o.Dependency),extensionPack:j(U,o.ExtensionPack),engine:L(U),localizedLanguages:z(U),targetPlatform:_(U),isPreReleaseVersion:M(U)},hasPreReleaseVersion:M(B),hasReleaseVersion:!0,preview:W(T.flags),isSigned:!!Q.signature}}let ne=class{constructor(U,H,B,Q,re,X,te,se){this.k=H,this.l=B,this.n=Q,this.o=re,this.q=X,this.u=te,this.w=se;const le=te.extensionsGallery,ue=le?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.d=ue?le.servicePPEUrl:le?.serviceUrl,this.g=ue?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,d.resolveMarketplaceHeaders)(te.version,te,this.n,this.w,this.q,U,this.o)}x(U=""){return`${this.d}${U}`}isEnabled(){return!!this.d}async getExtensions(U,H,B){const Q=i.CancellationToken.isCancellationToken(H)?{}:H,re=i.CancellationToken.isCancellationToken(H)?H:B,X=[],te=[],se=[],le=[];let ue=!0;for(const be of U){be.uuid?te.push(be.uuid):X.push(be.id);const Ee=!!(be.version||be.preRelease);se.push({id:be.id,uuid:be.uuid,includePreRelease:Ee}),be.version&&le.push({id:be.id,uuid:be.uuid,version:be.version}),ue=ue&&!!be.hasPreRelease&&!Ee}if(!te.length&&!X.length)return[];let ye=new u().withPage(1,U.length);te.length&&(ye=ye.withFilter(t.ExtensionId,...te)),X.length&&(ye=ye.withFilter(t.ExtensionName,...X)),(Q.queryAllVersions||ue)&&(ye=ye.withFlags(ye.flags,n.IncludeVersions)),Q.source&&(ye=ye.withSource(Q.source));const{extensions:Se}=await this.z(ye,{targetPlatform:Q.targetPlatform??f,includePreRelease:se,versions:le,compatible:!!Q.compatible},re);return Q.source&&Se.forEach((be,Ee)=>V(be,Ee,Q.source)),Se}async getCompatibleExtension(U,H,B){if((0,E.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(U,H,B))return U;const Q=new u().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,U.identifier.uuid),{extensions:re}=await this.z(Q,{targetPlatform:B,compatible:!0,includePreRelease:H},i.CancellationToken.None);return re[0]||null}async isExtensionCompatible(U,H,B){if(!(0,E.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,B)||!H&&U.properties.isPreReleaseVersion)return!1;let Q=U.properties.engine;if(!Q){const re=await this.getManifest(U,i.CancellationToken.None);if(!re)throw new Error("Manifest was not found");Q=re.engines.vscode}return(0,p.isEngineValid)(Q,this.u.version,this.u.date)}async y(U,H,B,Q,re){if(!(0,E.isTargetPlatformCompatible)(_(U),Q,re)||H!=="any"&&M(U)!==(H==="prerelease"))return!1;if(B)try{const X=await this.E(U);if(!(0,p.isEngineValid)(X,this.u.version,this.u.date))return!1}catch(X){return this.l.error(`Error while getting the engine for the version ${U.version}.`,(0,D.getErrorMessage)(X)),!1}return!0}async query(U,H){let B=U.text||"";const Q=U.pageSize??50;let re=new u().withPage(1,Q);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ye,Se)=>(re=re.withFilter(t.Category,Se||ye),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ye,Se)=>(re=re.withFilter(t.Tag,Se||ye),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(t.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),re=re.withFilter(t.SearchText,B)),re=re.withSortBy(0)):U.ids?re=re.withFilter(t.ExtensionId,...U.ids):U.names?re=re.withFilter(t.ExtensionName,...U.names):re=re.withSortBy(4),typeof U.sortBy=="number"&&(re=re.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(re=re.withSortOrder(U.sortOrder)),U.source&&(re=re.withSource(U.source));const X=async(ue,ye)=>{const{extensions:Se,total:be}=await this.z(ue,{targetPlatform:f,compatible:!1,includePreRelease:!!U.includePreRelease},ye);return Se.forEach((Ee,Ne)=>V(Ee,(ue.pageNumber-1)*ue.pageSize+Ne,U.source)),{extensions:Se,total:be}},{extensions:te,total:se}=await X(re,H),le=async(ue,ye)=>{if(ye.isCancellationRequested)throw new D.CancellationError;const{extensions:Se}=await X(re.withPage(ue+1),ye);return Se};return{firstPage:te,total:se,pageSize:re.pageSize,getPage:le}}async z(U,H,B){const Q=U.flags;!!(U.flags&n.IncludeLatestVersionOnly)&&!!(U.flags&n.IncludeVersions)&&(U=U.withFlags(U.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(U.flags&n.IncludeLatestVersionOnly)&&!(U.flags&n.IncludeVersions)&&(U=U.withFlags(U.flags,n.IncludeLatestVersionOnly)),H.versions?.length&&(U=U.withFlags(U.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),U=U.withFlags(U.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:re,total:X}=await this.B(U,B);if(!(U.flags&n.IncludeLatestVersionOnly)){const ue=[];for(const ye of re){const Se=await this.A(ye,H);Se&&ue.push(Se)}return{extensions:ue,total:X}}const se=[],le=new Map;for(let ue=0;ue<re.length;ue++){const ye=re[ue],Se={id:(0,w.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},be=(0,R.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(Ne=>(0,w.areSameExtensions)(Ne,Se))?.includePreRelease;if(H.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(K(ye),H.targetPlatform))continue;const Ee=await this.A(ye,H);!Ee||Ee.properties.isPreReleaseVersion&&(!be||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==H.targetPlatform&&Ee.hasPreReleaseVersion?le.set(ye.extensionId,ue):se.push([ue,Ee])}if(le.size){const ue=new Date().getTime(),ye=new u().withFlags(Q&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,le.size).withFilter(t.ExtensionId,...le.keys()),{extensions:Se}=await this.z(ye,H,B);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:le.size});for(const be of Se){const Ee=le.get(be.identifier.uuid);se.push([Ee,be])}}return{extensions:se.sort((ue,ye)=>ue[0]-ye[0]).map(([,ue])=>ue),total:X}}async A(U,H){const B={id:(0,w.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},Q=H.versions?.find(se=>(0,w.areSameExtensions)(se,B))?.version,re=(0,R.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(se=>(0,w.areSameExtensions)(se,B))?.includePreRelease,X=K(U),te=q(U.versions,H.targetPlatform);if(H.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(X,H.targetPlatform))return null;for(let se=0;se<te.length;se++){const le=te[se];if(!(Q&&le.version!==Q)){if(await this.y(le,re?"any":"release",H.compatible,X,H.targetPlatform))return Z(U,le,X);if(Q&&le.version===Q)return null}}return Q||H.compatible?null:Z(U,U.versions[0],X)}async B(U,H){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const B=await this.j,Q=JSON.stringify(U.raw),re={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},X=new Date().getTime();let te,se,le=0;try{if(te=await this.k.request({type:"POST",url:this.g&&U.criteria.some(ye=>ye.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:Q,headers:re},H),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:le};const ue=await(0,l.asJson)(te);if(ue){const ye=ue.results[0],Se=ye.extensions,be=ye.resultMetadata&&ye.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return le=be&&be.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:le}}return{galleryExtensions:[],total:le}}catch(ue){throw se=ue,ue}finally{this.o.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-X,success:!!te&&(0,l.isSuccess)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:se?(0,D.isCancellationError)(se)?"canceled":(0,D.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(U,H,B,Q){if(!this.isEnabled())return;const re=A.isWeb?this.x(`/itemName/${U}.${H}/version/${B}/statType/${Q==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${U}/extensions/${H}/${B}/stats?statType=${Q}`),X=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.j,Accept:X};try{await this.k.request({type:"POST",url:re,headers:se},i.CancellationToken.None)}catch{}}async download(U,H,B){this.l.trace("ExtensionGalleryService#download",U.identifier.id);const Q=(0,w.getGalleryExtensionTelemetryData)(U),re=new Date().getTime(),X=ue=>this.o.publicLog("galleryService:downloadVSIX",{...Q,duration:ue}),te=B===2?"install":B===3?"update":"",se=te?{uri:`${U.assets.download.uri}${P.URI.parse(U.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${U.assets.download.fallbackUri}${P.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:U.assets.download,le=await this.D(se);await this.q.writeFile(H,le.stream),X(new Date().getTime()-re)}async downloadSignatureArchive(U,H){if(!U.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const B=await this.D(U.assets.signature);await this.q.writeFile(H,B.stream)}async getReadme(U,H){if(U.assets.readme){const B=await this.D(U.assets.readme,{},H);return await(0,l.asTextOrError)(B)||""}return""}async getManifest(U,H){if(U.assets.manifest){const B=await this.D(U.assets.manifest,{},H),Q=await(0,l.asTextOrError)(B);return Q?JSON.parse(Q):null}return null}async C(U,H){const B=$(U,r.Manifest);if(!B)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},re=await this.D(B,{headers:Q});return await(0,l.asJson)(re)}async getCoreTranslation(U,H){const B=U.assets.coreTranslations.filter(Q=>Q[0]===H.toUpperCase())[0];if(B){const Q=await this.D(B[1]),re=await(0,l.asTextOrError)(Q);return re?JSON.parse(re):null}return null}async getChangelog(U,H){if(U.assets.changelog){const B=await this.D(U.assets.changelog,{},H);return await(0,l.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(U,H,B){let Q=new u().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?Q=Q.withFilter(t.ExtensionId,U.identifier.uuid):Q=Q.withFilter(t.ExtensionName,U.identifier.id);const{galleryExtensions:re}=await this.B(Q,i.CancellationToken.None);if(!re.length)return[];const X=K(re[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(X,B))return[];const te=[];await Promise.all(re[0].versions.map(async ue=>{try{await this.y(ue,H?"any":"release",!0,X,B)&&te.push(ue)}catch{}}));const se=[],le=new Set;for(const ue of q(te,B))le.has(ue.version)||(le.add(ue.version),se.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:M(ue)}));return se}async D(U,H={},B=i.CancellationToken.None){const Q=await this.j,re={type:"GET"},X={...Q,...H.headers||{}};H={...H,...re,headers:X};const te=U.uri,se=U.fallbackUri,le={...H,url:te};try{const ue=await this.k.request(le,B);if(ue.res.statusCode===200)return ue;const ye=await(0,l.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ye}`)}catch(ue){if((0,D.isCancellationError)(ue))throw ue;const ye=(0,D.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:te,message:ye});const Se={...H,url:se};return this.k.request(Se,B)}}async E(U){let H=L(U);if(!H){const B=await this.C(U,i.CancellationToken.None);if(!B)throw new Error("Manifest was not found");H=B.engines.vscode}return H}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const U=await this.k.request({type:"GET",url:this.h},i.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const H=await(0,l.asJson)(U),B=[],Q={};if(H){for(const re of H.malicious)B.push({id:re});if(H.migrateToPreRelease)for(const[re,X]of Object.entries(H.migrateToPreRelease))(!X.engine||(0,p.isEngineValid)(X.engine,this.u.version,this.u.date))&&(Q[re.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(H.deprecated)for(const[re,X]of Object.entries(H.deprecated))X&&(Q[re.toLowerCase()]=(0,R.isBoolean)(X)?{}:X)}return{malicious:B,deprecated:Q}}};ne=pe([Y(1,l.IRequestService),Y(2,g.ILogService),Y(3,C.IEnvironmentService),Y(4,v.ITelemetryService),Y(5,h.IFileService),Y(6,y.IProductService),Y(7,S.IConfigurationService)],ne);let J=class extends ne{constructor(U,H,B,Q,re,X,te,se){super(U,H,B,Q,re,X,te,se)}};J=pe([Y(0,m.IStorageService),Y(1,l.IRequestService),Y(2,g.ILogService),Y(3,C.IEnvironmentService),Y(4,v.ITelemetryService),Y(5,h.IFileService),Y(6,y.IProductService),Y(7,S.IConfigurationService)],J),e.ExtensionGalleryService=J;let x=class extends ne{constructor(U,H,B,Q,re,X,te){super(void 0,U,H,B,Q,re,X,te)}};x=pe([Y(0,l.IRequestService),Y(1,g.ILogService),Y(2,C.IEnvironmentService),Y(3,v.ITelemetryService),Y(4,h.IFileService),Y(5,y.IProductService),Y(6,S.IConfigurationService)],x),e.ExtensionGalleryServiceWithNoStorageService=x}),define(oe[80],ae([0,1,4,3,2,19,33,25,20,8,13]),function(ee,e,k,i,D,A,O,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let w=class Ze extends D.Disposable{static b(h){return`extensionKeys/${(0,O.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static c(h){const g=E.exec(h);if(g&&g[1])return{id:g[1],version:g[2]}}static async removeOutdatedExtensionVersions(h,g){const y=await h.getInstalled(),l=[];for(const[d,m]of Ze.f(g)){const v=y.find(f=>(0,O.areSameExtensions)(f.identifier,{id:d}))?.manifest.version;for(const f of m)v!==f&&l.push(Ze.b({id:d,version:f}))}for(const d of l)g.remove(d,0)}static f(h){const g=new Map,y=h.keys(0,1);for(const l of y){const d=Ze.c(l);if(d){let m=g.get(d.id.toLowerCase());m||g.set(d.id.toLowerCase(),m=[]),m.push(d.version)}}return g}constructor(h,g,y){super(),this.i=h,this.j=g,this.k=y,this.g=this.B(new i.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Ze.f(h),this.B(this.i.onDidChangeValue(l=>this.l(l)))}l(h){if(h.scope!==0)return;if(this.h.has(h.key.toLowerCase())){this.g.fire();return}const g=Ze.c(h.key);if(g){if(this.i.get(h.key,0)===void 0)this.h.delete(g.id.toLowerCase());else{let y=this.h.get(g.id.toLowerCase());y||this.h.set(g.id.toLowerCase(),y=[]),y.push(g.version),this.g.fire()}return}}m(h){if((0,C.isString)(h))return h;const g=h.manifest?h.manifest.publisher:h.publisher,y=h.manifest?h.manifest.name:h.name;return(0,O.getExtensionId)(g,y)}getExtensionState(h,g){const y=this.m(h),l=this.getExtensionStateRaw(h,g);if(l)try{return JSON.parse(l)}catch(d){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${g}): ${d}`)}}getExtensionStateRaw(h,g){const y=this.m(h),l=this.i.get(y,g?0:1);return l&&l?.length>Ze.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${y}, global: ${g}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(h,g,y){const l=this.m(h);g===void 0?this.i.remove(l,y?0:1):this.i.store(l,JSON.stringify(g),y?0:1,1)}setKeysForSync(h,g){this.i.store(Ze.b(h),JSON.stringify(g),0,1)}getKeysForSync(h){const g=this.j.extensionSyncedKeys?.[h.id.toLowerCase()],y=this.i.get(Ze.b(h),0),l=y?JSON.parse(y):void 0;return l&&g?(0,P.distinct)([...l,...g]):l||g}addToMigrationList(h,g){if(h!==g){const y=this.n.filter(l=>!l.includes(h)&&!l.includes(g));y.push([h,g]),this.n=y}}getSourceExtensionToMigrate(h){const g=this.n.find(([,y])=>h===y);return g?g[0]:void 0}get n(){const h=this.i.get("extensionStorage.migrationList",-1,"[]");try{const g=JSON.parse(h);if(Array.isArray(g))return g}catch{}return[]}set n(h){h.length?this.i.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};w.a=512*1024,w=pe([Y(0,A.IStorageService),Y(1,R.IProductService),Y(2,S.ILogService)],w),e.ExtensionStorageService=w}),define(oe[266],ae([0,1,20,6,3,12,5,36,7,158,15,29,33,211,98,14,57,25,19,23]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const v="extensionTips/promptedExecutableTips",f="extensionTips/lastPromptedMediumImpExeTime";let n=class extends p.ExtensionTipsService{constructor(t,r,o,c,a,u,b,I){super(b,I),this.m=t,this.n=r,this.p=o,this.r=c,this.s=a,this.t=u,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,I.exeBasedExtensionTips&&Object.entries(I.exeBasedExtensionTips).forEach(([F,N])=>{const $=[],j=[],L=[];Object.entries(N.recommendations).forEach(([M,z])=>{z.important?N.important?$.push({extensionId:M,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):j.push({extensionId:M,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):L.push({extensionId:M,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),$.length&&this.g.set(F,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:$}),j.length&&this.h.set(F,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:j}),L.length&&this.j.set(F,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:L})}),(0,i.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.y()})}async getImportantExecutableBasedTips(){const t=await this.I(this.g),r=await this.I(this.h);return[...t,...r]}getOtherExecutableBasedTips(){return this.I(this.j)}async u(){const t=await this.I(this.g),r=await this.I(this.h),o=await this.p.getInstalled();this.k=this.v(t,o),this.l=this.v(r,o)}v(t,r){const o=new Map;t.forEach(I=>o.set(I.extensionId.toLowerCase(),I));const{installed:c,uninstalled:a}=this.H([...o.keys()],r);for(const I of c){const F=o.get(I);F&&this.n.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:I,exeName:F.exeName})}for(const I of a){const F=o.get(I);F&&this.n.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:I,exeName:F.exeName})}const u=this.F(),b=new Map;for(const I of a){const F=o.get(I);if(F&&(!u[F.exeName]||!u[F.exeName].includes(F.extensionId))){let N=b.get(F.exeName);N||(N=[],b.set(F.exeName,N)),N.push(F)}}return b}w(){if(this.k.size===0)return;const[t,r]=[...this.k.entries()][0];this.z(r).then(o=>{switch(o){case"reacted":this.G(r[0].exeName,r);break;case"ignored":this.k.delete(t);break;case"incompatibleWindow":{const c=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(c(()=>this.w()));break}case"toomany":{const c=this.B((0,i.disposableTimeout)(()=>{c.dispose(),this.w()},36e5));break}}})}y(){if(this.l.size===0)return;const t=this.C(),r=Date.now()-t,o=7*24*60*60*1e3;if(r<o){const u=this.B((0,i.disposableTimeout)(()=>{u.dispose(),this.y()},o-r));return}const[c,a]=[...this.l.entries()][0];this.z(a).then(u=>{switch(u){case"reacted":{this.D(Date.now()),this.l.delete(c),this.G(a[0].exeName,a);const b=this.B((0,i.disposableTimeout)(()=>{b.dispose(),this.y()},o));break}case"ignored":this.l.delete(c),this.y();break;case"incompatibleWindow":{const b=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(b(()=>this.y()));break}case"toomany":{const b=this.B((0,i.disposableTimeout)(()=>{b.dispose(),this.y()},36e5));break}}})}async z(t){const r=await this.p.getInstalled(1),o=t.filter(a=>!a.whenNotInstalled||a.whenNotInstalled.every(u=>r.every(b=>!(0,w.areSameExtensions)(b.identifier,{id:u})))).map(({extensionId:a})=>a.toLowerCase()),c=(0,S.localize)(0,null,t[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(o,c,`@exe:"${t[0].exeName}"`,3)}C(){let t=this.r.getNumber(f,-1);return t||(t=Date.now(),this.D(t)),t}D(t){this.r.store(f,t,-1,1)}F(){return JSON.parse(this.r.get(v,-1,"{}"))}G(t,r){const o=this.F();o[t]=r.map(({extensionId:c})=>c.toLowerCase()),this.r.store(v,JSON.stringify(o),-1,0)}H(t,r){const o=[],c=[],a=r.reduce((u,b)=>(u.add(b.identifier.id.toLowerCase()),u),new Set);return t.forEach(u=>{a.has(u.toLowerCase())?o.push(u):c.push(u)}),{installed:o,uninstalled:c}}async I(t){const r=[],o=new Map;for(const c of t.keys()){const a=t.get(c);if(!a||!(0,k.isNonEmptyArray)(a.recommendations))continue;const u=[];O.isWindows?a.windowsPath&&u.push(a.windowsPath.replace("%USERPROFILE%",()=>R.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>R.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>R.env.ProgramFiles).replace("%APPDATA%",()=>R.env.APPDATA).replace("%WINDIR%",()=>R.env.WINDIR)):(u.push((0,A.join)("/usr/local/bin",c)),u.push((0,A.join)("/usr/bin",c)),u.push((0,A.join)(this.m.userHome.fsPath,c)));for(const b of u){let I=o.get(b);if(I===void 0&&(I=await this.b.exists(P.URI.file(b)),o.set(b,I)),I)for(const{extensionId:F,extensionName:N,isExtensionPack:$,whenNotInstalled:j}of a.recommendations)r.push({extensionId:F,extensionName:N,isExtensionPack:$,exeName:c,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:j})}}return r}};n=pe([Y(0,C.INativeEnvironmentService),Y(1,m.ITelemetryService),Y(2,E.IExtensionManagementService),Y(3,d.IStorageService),Y(4,y.INativeHostService),Y(5,h.IExtensionRecommendationNotificationService),Y(6,g.IFileService),Y(7,l.IProductService)],n),e.ExtensionTipsService=n}),define(oe[267],ae([0,1,6,2,22,69,19,76,18]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends O.AbstractStorageService{constructor(E,w,p,h){super(),this.X=E,this.Y=w,this.Z=p,this.ab=h,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new i.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new i.DisposableStore),this.W=this.db(this.X)}bb(){const E=this.B(new R.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),w=this.B(new A.Storage(E));return this.B(w.onDidChangeStorage(p=>this.n(-1,p))),w}cb(E){this.Q.clear(),this.P=E;let w;if((0,O.isProfileUsingDefaultStorage)(E))w=this.s;else{const p=this.Q.add(new R.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),E));w=this.Q.add(new A.Storage(p))}return this.Q.add(w.onDidChangeStorage(p=>this.n(0,p))),w}db(E){this.U.clear(),this.S=E?.id;let w;if(E){const p=this.U.add(new R.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),E));w=this.U.add(new A.Storage(p)),this.U.add(w.onDidChangeStorage(h=>this.n(1,h)))}return w}async J(){await k.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(E){switch(E){case-1:return this.s;case 0:return this.R;default:return this.W}}M(E){switch(E){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,D.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(O.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(E,w){if(!this.H(this.P,E))return;const p=this.R,h=p.items;p!==this.s&&await p.close(),this.R=this.cb(E),await this.R.init(),this.I(h,this.R,0,w)}async O(E,w){const p=this.W,h=p?.items??new Map;await p?.close(),this.W=this.db(E),await this.W.init(),this.I(h,this.W,1,w)}hasScope(E){return(0,P.isUserDataProfile)(E)?this.P.id===E.id:this.S===E.id}}e.NativeStorageService=S}),define(oe[62],ae([0,1,2,69,4,19]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,D.createDecorator)("IUserDataProfileStorageService");let O=class extends k.Disposable{constructor(S){super(),this.a=S}async readStorageData(S){return this.withProfileScopedStorageService(S,async C=>this.b(C))}async updateStorageData(S,C,E){return this.withProfileScopedStorageService(S,async w=>this.c(w,C,E))}async withProfileScopedStorageService(S,C){if(this.a.hasScope(S))return C(this.a);const E=await this.createStorageDatabase(S),w=new R(E);try{await w.initialize();const p=await C(w);return await w.flush(),p}finally{w.dispose(),await this.f(E)}}b(S){const C=new Map,E=w=>{for(const p of S.keys(0,w))C.set(p,{value:S.get(p,0),target:w})};return E(0),E(1),C}c(S,C,E){for(const[w,p]of C)S.store(w,p,0,E)}async f(S){try{await S.close()}finally{(0,k.isDisposable)(S)&&S.dispose()}}};O=pe([Y(0,A.IStorageService)],O),e.AbstractUserDataProfileStorageService=O;class R extends A.AbstractStorageService{constructor(S){super({flushInterval:100}),this.p=this.B(new i.Storage(S))}J(){return this.p.init()}L(S){return S===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(oe[268],ae([0,1,3,2,22,15,56,18]),function(ee,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let P=class extends i.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.b}constructor(C,E,w){super(),this.b=[],this.c=this.B(new k.Emitter),this.onDidChangeProfiles=this.c.event,this.f=!0,this.a=E.getChannel("userDataProfiles"),this.profilesHome=(0,D.joinPath)(w.userRoamingDataHome,"profiles"),this.b=C.map(p=>(0,R.reviveProfile)(p,this.profilesHome.scheme)),this.B(this.a.listen("onDidChangeProfiles")(p=>{const h=p.added.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),g=p.removed.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),y=p.updated.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme));this.b=p.all.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),this.c.fire({added:h,removed:g,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.a.listen("onDidResetWorkspaces")}setEnablement(C){this.f=C}isEnabled(){return this.f}async createNamedProfile(C,E,w){const p=await this.a.call("createNamedProfile",[C,E,w]);return(0,R.reviveProfile)(p,this.profilesHome.scheme)}async createProfile(C,E,w,p){const h=await this.a.call("createProfile",[C,E,w,p]);return(0,R.reviveProfile)(h,this.profilesHome.scheme)}async createTransientProfile(C){const E=await this.a.call("createTransientProfile",[C]);return(0,R.reviveProfile)(E,this.profilesHome.scheme)}async setProfileForWorkspace(C,E){await this.a.call("setProfileForWorkspace",[C,E])}removeProfile(C){return this.a.call("removeProfile",[C])}async updateProfile(C,E){const w=await this.a.call("updateProfile",[C,E]);return(0,R.reviveProfile)(w,this.profilesHome.scheme)}resetWorkspaces(){return this.a.call("resetWorkspaces")}cleanUp(){return this.a.call("cleanUp")}cleanUpTransientProfiles(){return this.a.call("cleanUpTransientProfiles")}};P=pe([Y(1,O.IMainProcessService),Y(2,A.IEnvironmentService)],P),e.UserDataProfilesNativeService=P}),define(oe[269],ae([0,1,3,2,56,8,62,19,76,18,71]),function(ee,e,k,i,D,A,O,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let E=class extends O.AbstractUserDataProfileStorageService{constructor(p,h,g,y){super(g),this.h=p;const l=p.getChannel("profileStorageListener"),d=this.B(new i.MutableDisposable);this.g=this.B(new k.Emitter({onWillAddFirstListener:()=>{d.value=l.listen("onDidChange")(m=>{y.trace("profile storage changes",m),this.g.fire({targetChanges:m.targetChanges.map(v=>(0,S.reviveProfile)(v,h.profilesHome.scheme)),valueChanges:m.valueChanges.map(v=>({...v,profile:(0,S.reviveProfile)(v.profile,h.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.g.event}async createStorageDatabase(p){const h=this.h.getChannel("storage");return(0,R.isProfileUsingDefaultStorage)(p)?new P.ApplicationStorageDatabaseClient(h):new P.ProfileStorageDatabaseClient(h,p)}};E=pe([Y(0,D.IMainProcessService),Y(1,S.IUserDataProfilesService),Y(2,R.IStorageService),Y(3,A.ILogService)],E),e.UserDataProfileStorageService=E,(0,C.registerSingleton)(O.IUserDataProfileStorageService,E,1)}),define(oe[41],ae([0,1,20,6,17,24,3,35,2,27,13,174,16,15,14,8,45,19,23,30,26,18]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(u){return!!(u&&u.ref!==void 0&&typeof u.ref=="string"&&u.ref!==""&&u.syncData!==void 0&&(u.syncData===null||s(u.syncData)))}e.isRemoteUserData=n;function s(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=s;function t(u,b){return`${(0,S.uppercaseFirstLetter)(u)}${b.isDefault?"":` (${b.name})`}`}e.getSyncResourceLogLabel=t;let r=class extends P.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(b,I,F,N,$,j,L,M,z,G,W,_){super(),this.syncResource=b,this.collection=I,this.C=F,this.D=N,this.F=$,this.G=j,this.H=L,this.I=M,this.J=z,this.L=G,this.M=W,this.c=null,this.k="idle",this.l=this.B(new O.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new O.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new i.ThrottledDelayer(50),this.t=this.B(new O.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(b.syncResource,b.profile),this.h=_.extUri,this.f=this.h.joinPath(N.userDataSyncHome,...(0,v.getPathSegments)(b.profile.isDefault?void 0:b.profile.id,b.syncResource)),this.g=this.h.joinPath(this.f,v.PREVIEW_DIR_NAME),this.u=(0,v.getLastSyncResourceUri)(b.profile.isDefault?void 0:b.profile.id,b.syncResource,N,this.h),this.j=(0,y.getServiceMachineId)(N,F,$)}triggerLocalChange(){this.s.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const b=await this.c;this.c=null;const I=await this.S(b.remoteUserData,b.lastSyncUserData,!0,this.lb());this.O(I)}else{this.L.trace(`${this.y}: Checking for local changes...`);const b=await this.getLastSyncUserData();(b?await this.rb(b):!0)&&this.t.fire()}}O(b){this.k!==b&&(this.k=b,this.l.fire(b))}async sync(b,I={}){await this.P(b,!0,this.lb(),I)}async preview(b,I,F={}){return this.P(b,!1,I,F)}async apply(b,I={}){try{this.z={...I};const F=await this.X(b);return this.O(F),this.c}finally{this.z={}}}async P(b,I,F,N){try{if(this.z={...N},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let $="idle";try{const j=await this.getLastSyncUserData(),L=await this.R(b,j);return $=await this.S(L,j,I,F),$==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):$==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O($)}}finally{this.z={}}}async replace(b){const I=this.hb(b);if(!I)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const F=await this.getLastSyncUserData(),N=await this.R(null,F),$=await this.Q(N),j=await this.nb({ref:N.ref,syncData:I},F,$,this.lb(),A.CancellationToken.None),L=[];for(const M of j){const z=await this.pb(M,M.remoteResource,void 0,A.CancellationToken.None),{remoteChange:G}=await this.pb(M,M.previewResource,M.remoteContent,A.CancellationToken.None);L.push([M,{...z,remoteChange:G!==0?G:2}])}await this.qb(N,F,L,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(b){const I=await this.j;return!!b.syncData?.machineId&&b.syncData.machineId===I}async R(b,I){if(I){const F=b?b[this.resource]:void 0;if(I.ref===F||F===void 0&&I.syncData===null)return I}return this.getRemoteUserData(I)}async S(b,I,F,N){if(b.syncData&&b.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new v.UserDataSyncError((0,E.localize)(0,null,this.resource,this.mb,b.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(b,I,F,N)}catch($){if($ instanceof v.UserDataSyncError)switch($.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.S(b,I,F,N);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),b=await this.getRemoteUserData(null),I=await this.getLastSyncUserData(),this.S(b,I,F,N)}throw $}}async U(b,I,F,N){try{const $=await this.Q(b),j=!$&&I===null&&this.db()!==void 0,L=F&&!j;this.c||(this.c=(0,i.createCancelablePromise)(z=>this.bb(b,I,$,L,N,z)));let M=await this.c;if(F&&j){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const z of M.resourcePreviews)M=await this.accept(z.remoteResource)||M}return this.Z(M.resourcePreviews),M.resourcePreviews.some(({mergeState:z})=>z==="conflict")?"hasConflicts":F?await this.X(!1):"syncing"}catch($){throw this.c=null,$}}async merge(b){return await this.W(b,async I=>{const F=await this.ob(I,A.CancellationToken.None);await this.C.writeFile(I.previewResource,D.VSBuffer.fromString(F?.content||""));const N=F&&!F.hasConflicts?await this.pb(I,I.previewResource,void 0,A.CancellationToken.None):void 0;return I.acceptResult=N,I.mergeState=F.hasConflicts?"conflict":N?"accepted":"preview",I.localChange=N?N.localChange:F.localChange,I.remoteChange=N?N.remoteChange:F.remoteChange,I}),this.c}async accept(b,I){return await this.W(b,async F=>{const N=await this.pb(F,b,I,A.CancellationToken.None);return F.acceptResult=N,F.mergeState="accepted",F.localChange=N.localChange,F.remoteChange=N.remoteChange,F}),this.c}async discard(b){return await this.W(b,async I=>{const F=await this.ob(I,A.CancellationToken.None);return await this.C.writeFile(I.previewResource,D.VSBuffer.fromString(F.content||"")),I.acceptResult=void 0,I.mergeState="preview",I.localChange=F.localChange,I.remoteChange=F.remoteChange,I}),this.c}async W(b,I){if(!this.c)return;let F=await this.c;const N=F.resourcePreviews.findIndex(({localResource:$,remoteResource:j,previewResource:L})=>this.h.isEqual($,b)||this.h.isEqual(j,b)||this.h.isEqual(L,b));N!==-1&&(this.c=(0,i.createCancelablePromise)(async $=>{const j=[...F.resourcePreviews];return j[N]=await I(j[N]),{...F,resourcePreviews:j}}),F=await this.c,this.Z(F.resourcePreviews),F.resourcePreviews.some(({mergeState:$})=>$==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(b){if(!this.c)return"idle";const I=await this.c;return I.resourcePreviews.some(({mergeState:F})=>F==="conflict")?"hasConflicts":I.resourcePreviews.some(({mergeState:F})=>F!=="accepted")?"syncing":(await this.qb(I.remoteUserData,I.lastSyncUserData,I.resourcePreviews.map(F=>[F,F.acceptResult]),b),this.c=null,await this.Y(),"idle")}async Y(){try{await this.C.del(this.g,{recursive:!0})}catch{}}Z(b){const I=b.filter(({mergeState:F})=>F==="conflict");(0,k.equals)(this.m,I,(F,N)=>this.h.isEqual(F.previewResource,N.previewResource))||(this.m=I,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const b=await this.getLastSyncUserData();return!!b&&b.syncData!==null}async ab(b){const I=this.c?await this.c:null;if(I)for(const F of I.resourcePreviews){if(this.h.isEqual(F.acceptedResource,b))return F.acceptResult?F.acceptResult.content:null;if(this.h.isEqual(F.remoteResource,b))return F.remoteContent;if(this.h.isEqual(F.localResource,b))return F.localContent;if(this.h.isEqual(F.baseResource,b))return F.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(b){(0,h.toFileOperationResult)(b)!==1&&this.L.error(b)}}async bb(b,I,F,N,$,j){const L=await this.nb(b,I,F,$,j),M=[];for(const z of L){const G=z.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)M.push({...z,acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const W=N?await this.ob(z,j):void 0;if(j.isCancellationRequested)break;await this.C.writeFile(z.previewResource,D.VSBuffer.fromString(W?.content||""));const _=W&&!W.hasConflicts?await this.pb(z,z.previewResource,void 0,j):void 0;M.push({...z,acceptResult:_,mergeState:W?.hasConflicts?"conflict":_?"accepted":"preview",localChange:_?_.localChange:W?W.localChange:z.localChange,remoteChange:_?_.remoteChange:W?W.remoteChange:z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:b,lastSyncUserData:I,resourcePreviews:M,isLastSyncFromCurrentMachine:F}}async getLastSyncUserData(){let b=this.db();if(b||(b=await this.gb()),!b)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const I=JSON.parse(b),F=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!I.version&&!!F&&I.version!==F,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${I.version} is not compatible with current sync state version ${F}.`),await this.resetLocal(),null;let N,$=1;for(;N===void 0&&$++<6;)try{const j=await this.eb();j&&(j.ref===I.ref?N=j.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(j){if(j instanceof h.FileOperationError&&j.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(j instanceof v.UserDataSyncError)throw j;this.L.error(j,$)}}if(N===void 0)try{const j=await this.G.resolveResourceContent(this.resource,I.ref,this.collection,this.z);N=j===null?null:this.hb(j),await this.fb({ref:I.ref,syncData:N})}catch(j){if(j instanceof v.UserDataSyncError&&j.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw j}return N===void 0?null:{...I,syncData:N}}async cb(b,I={}){if(I.ref||I.version)throw new Error("Cannot have core properties as additional");const F=this.I.getResourceSyncStateVersion(this.resource),N={ref:b.ref,version:F,...I};this.F.store(this.v,JSON.stringify(N),-1,1),await this.fb(b)}db(){return this.F.get(this.v,-1)}async eb(){const b=(await this.C.readFile(this.u)).value.toString();try{const I=b?JSON.parse(b):void 0;if(n(I))return I}catch(I){this.L.error(I)}}async fb(b){await this.C.writeFile(this.u,D.VSBuffer.fromString(JSON.stringify(b)))}async gb(){try{const b=await this.C.readFile(this.u),I=JSON.parse(b.value.toString());await this.C.del(this.u),I.ref&&I.content!==void 0&&(this.F.store(this.v,JSON.stringify({...I,content:void 0}),-1,1),await this.fb({ref:I.ref,syncData:I.content===null?null:JSON.parse(I.content)}))}catch(b){b instanceof h.FileOperationError&&b.fileOperationResult===1?this.L.debug(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(b)}return this.F.get(this.v,-1)}async getRemoteUserData(b){const{ref:I,content:F}=await this.ib(b);let N=null;return F!==null&&(N=this.hb(F)),{ref:I,syncData:N}}hb(b){try{const I=JSON.parse(b);if(s(I))return I}catch(I){this.L.error(I)}throw new v.UserDataSyncError((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(b){const I=b?{ref:b.ref,content:b.syncData?JSON.stringify(b.syncData):null}:null;return this.G.readResource(this.resource,I,this.collection,this.z)}async jb(b,I){const F=await this.j,N={version:this.mb,machineId:F,content:b};try{return I=await this.G.writeResource(this.resource,JSON.stringify(N),I,this.collection,this.z),{ref:I,syncData:N}}catch($){throw $ instanceof v.UserDataSyncError&&$.code==="TooLarge"&&($=new v.UserDataSyncError($.message,$.code,this.resource)),$}}async kb(b){const I={version:this.mb,content:b};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(I))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};r=pe([Y(2,h.IFileService),Y(3,p.IEnvironmentService),Y(4,l.IStorageService),Y(5,v.IUserDataSyncStoreService),Y(6,v.IUserDataSyncBackupStoreService),Y(7,v.IUserDataSyncEnablementService),Y(8,d.ITelemetryService),Y(9,v.IUserDataSyncLogService),Y(10,w.IConfigurationService),Y(11,m.IUriIdentityService)],r),e.AbstractSynchroniser=r;let o=class extends r{constructor(b,I,F,N,$,j,L,M,z,G,W,_,K){super(I,F,N,$,j,L,M,z,G,W,_,K),this.i=b,this.B(this.C.watch(this.h.dirname(b))),this.B(this.C.onDidFilesChange(q=>this.tb(q)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(b,I,F){try{I?await this.C.writeFile(this.i,D.VSBuffer.fromString(b),F?void 0:I):await this.C.createFile(this.i,D.VSBuffer.fromString(b),{overwrite:F})}catch(N){throw N instanceof h.FileOperationError&&N.fileOperationResult===1||N instanceof h.FileOperationError&&N.fileOperationResult===3?new v.UserDataSyncError(N.message,"LocalPreconditionFailed"):N}}async sb(){try{await this.C.del(this.i)}catch(b){if(!(b instanceof h.FileOperationError&&b.fileOperationResult===1))throw b}}tb(b){!b.contains(this.i)||this.triggerLocalChange()}};o=pe([Y(3,h.IFileService),Y(4,p.IEnvironmentService),Y(5,l.IStorageService),Y(6,v.IUserDataSyncStoreService),Y(7,v.IUserDataSyncBackupStoreService),Y(8,v.IUserDataSyncEnablementService),Y(9,d.ITelemetryService),Y(10,v.IUserDataSyncLogService),Y(11,w.IConfigurationService),Y(12,m.IUriIdentityService)],o),e.AbstractFileSynchroniser=o;let c=class extends o{constructor(b,I,F,N,$,j,L,M,z,G,W,_,K,q){super(b,I,F,N,$,j,L,M,z,G,W,K,q),this.ub=_,this.wb=void 0}vb(b,I){const F=[],N=(0,R.parse)(b,F,{allowEmptyContent:!0,allowTrailingComma:!0});return F.length>0||!(0,C.isUndefined)(N)&&I!==Array.isArray(N)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};c=pe([Y(3,h.IFileService),Y(4,p.IEnvironmentService),Y(5,l.IStorageService),Y(6,v.IUserDataSyncStoreService),Y(7,v.IUserDataSyncBackupStoreService),Y(8,v.IUserDataSyncEnablementService),Y(9,d.ITelemetryService),Y(10,v.IUserDataSyncLogService),Y(11,v.IUserDataSyncUtilService),Y(12,w.IConfigurationService),Y(13,m.IUriIdentityService)],c),e.AbstractJsonFileSynchroniser=c;let a=class{constructor(b,I,F,N,$,j,L){this.resource=b,this.g=I,this.h=F,this.j=N,this.k=$,this.l=j,this.d=L.extUri,this.f=(0,v.getLastSyncResourceUri)(void 0,this.resource,F,this.d)}async initialize({ref:b,content:I}){if(!I){this.j.info("Remote content does not exist.",this.resource);return}const F=this.m(I);if(!!F)try{await this.doInitialize({ref:b,syncData:F})}catch(N){this.j.error(N)}}m(b){try{const I=JSON.parse(b);if(s(I))return I}catch(I){this.j.error(I)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(b,I={}){if(I.ref||I.version)throw new Error("Cannot have core properties as additional");const F={ref:b.ref,version:void 0,...I};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(F),-1,1),await this.k.writeFile(this.f,D.VSBuffer.fromString(JSON.stringify(b)))}};a=pe([Y(1,f.IUserDataProfilesService),Y(2,p.IEnvironmentService),Y(3,g.ILogService),Y(4,h.IFileService),Y(5,l.IStorageService),Y(6,m.IUriIdentityService)],a),e.AbstractInitializer=a}),define(oe[117],ae([0,1,6,24,9,3,43,2,27,16,15,116,29,33,80,14,4,72,8,19,23,30,18,41,252,114,26,62]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d,m,v,f,n,s,t,r,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function a($,j){const L=JSON.parse($.content);if($.version===1||$.version===2){const M=(await j.getInstalled(0)).filter(z=>z.isBuiltin);for(const z of L)$.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),$.version===2&&M.every(G=>!(0,p.areSameExtensions)(G.identifier,z.identifier))&&(z.installed=!0)}return L}function u($){return JSON.parse($.content)}e.parseExtensions=u;function b($,j){return $.sort((L,M)=>!L.identifier.uuid&&M.identifier.uuid?-1:L.identifier.uuid&&!M.identifier.uuid?1:(0,P.compare)(L.identifier.id,M.identifier.id)),j?(0,O.toFormattedString)($,{}):JSON.stringify($)}e.stringify=b;let I=class extends s.AbstractSynchroniser{constructor(j,L,M,z,G,W,_,K,q,V,Z,ne,J,x,T,U,H){super({syncResource:"extensions",profile:j},L,z,M,G,W,_,ne,J,V,Z,T),this.yb=K,this.zb=q,this.Ab=H,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(F),this.B(A.Event.any(A.Event.filter(this.yb.onDidInstallExtensions,B=>B.some(({local:Q})=>!!Q)),A.Event.filter(this.yb.onDidUninstallExtension,B=>!B.error),A.Event.filter(U.onDidChange,B=>B.valueChanges.some(({profile:Q,changes:re})=>this.syncResource.profile.id===Q.id&&re.some(X=>X.key===w.DISABLED_EXTENSIONS_STORAGE_PATH))),x.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async nb(j,L){const M=j.syncData?await a(j.syncData,this.yb):null,z=L?.skippedExtensions||[],G=L?.builtinExtensions||[],W=L?.syncData?await a(L.syncData,this.yb):null,{localExtensions:_,ignoredExtensions:K}=await this.xb.getLocalExtensions(this.syncResource.profile);M?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:V}=(0,t.merge)(_,M,W,z,K,G),Z={local:q,remote:V,content:this.Db(_,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:V!==null?2:0},ne=this.Jb(_,!1);return[{skippedExtensions:z,builtinExtensions:G,baseResource:this.tb,baseContent:W?this.Jb(W,!1):ne,localResource:this.ub,localContent:ne,localExtensions:_,remoteResource:this.vb,remoteExtensions:M,remoteContent:M?this.Jb(M,!1):null,previewResource:this.sb,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.wb}]}async rb(j){const L=j.syncData?await a(j.syncData,this.yb):null,{localExtensions:M,ignoredExtensions:z}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:G}=(0,t.merge)(M,L,L,j.skippedExtensions||[],z,j.builtinExtensions||[]);return G!==null}Db(j,L,M,z){const G=[...L,...M],W=new Set,_=K=>{W.add(K.id.toLowerCase()),K.uuid&&W.add(K.uuid)};G.forEach(({identifier:K})=>_(K)),z.forEach(_);for(const K of j)W.has(K.identifier.id.toLowerCase())||K.identifier.uuid&&W.has(K.identifier.uuid)||G.push(K);return this.Jb(G,!1)}async ob(j,L){return{...j.previewResult,hasConflicts:!1}}async pb(j,L,M,z){if(this.h.isEqual(L,this.ub))return this.Gb(j);if(this.h.isEqual(L,this.vb))return this.Hb(j);if(this.h.isEqual(L,this.sb))return j.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async Gb(j){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),M=this.zb.getIgnoredExtensions(L),z=(0,t.merge)(j.localExtensions,null,null,j.skippedExtensions,M,j.builtinExtensions),{local:G,remote:W}=z;return{content:j.localContent,local:G,remote:W,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Hb(j){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),M=this.zb.getIgnoredExtensions(L),z=j.remoteContent?JSON.parse(j.remoteContent):null;if(z!==null){const G=(0,t.merge)(j.localExtensions,z,j.localExtensions,[],M,j.builtinExtensions),{local:W,remote:_}=G;return{content:j.remoteContent,local:W,remote:_,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:_!==null?2:0}}else return{content:j.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(j,L,M,z){let{skippedExtensions:G,localExtensions:W}=M[0][0];const{local:_,remote:K,localChange:q,remoteChange:V}=M[0][1];if(q===0&&V===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),q!==0&&(await this.kb(JSON.stringify(W)),G=await this.xb.updateLocalExtensions(_.added,_.removed,_.updated,G,this.syncResource.profile)),K){this.L.trace(`${this.y}: Updating remote extensions...`);const Z=JSON.stringify(K.all);j=await this.jb(Z,z?null:j.ref),this.L.info(`${this.y}: Updated remote extensions.${K.added.length?` Added: ${JSON.stringify(K.added.map(ne=>ne.identifier.id))}.`:""}${K.updated.length?` Updated: ${JSON.stringify(K.updated.map(ne=>ne.identifier.id))}.`:""}${K.removed.length?` Removed: ${JSON.stringify(K.removed.map(ne=>ne.identifier.id))}.`:""}`)}if(L?.ref!==j.ref){this.L.trace(`${this.y}: Updating last synchronized extensions...`);const Z=W.filter(ne=>!ne.installed).map(ne=>ne.identifier);await this.cb(j,{skippedExtensions:G,builtinExtensions:Z}),this.L.info(`${this.y}: Updated last synchronized extensions.${G.length?` Skipped: ${JSON.stringify(G.map(ne=>ne.identifier.id))}.`:""}`)}}async resolveContent(j){if(this.h.isEqual(this.vb,j)||this.h.isEqual(this.tb,j)||this.h.isEqual(this.ub,j)||this.h.isEqual(this.wb,j)){const L=await this.ab(j);return L&&this.Jb(JSON.parse(L),!0)}return null}Jb(j,L){return b(j,L)}async hasLocalData(){try{const{localExtensions:j}=await this.xb.getLocalExtensions(this.syncResource.profile);if(j.some(L=>L.installed||L.disabled))return!0}catch{}return!1}};I=pe([Y(2,C.IEnvironmentService),Y(3,g.IFileService),Y(4,m.IStorageService),Y(5,o.IUserDataSyncStoreService),Y(6,o.IUserDataSyncBackupStoreService),Y(7,w.IExtensionManagementService),Y(8,r.IIgnoredExtensionsManagementService),Y(9,o.IUserDataSyncLogService),Y(10,S.IConfigurationService),Y(11,o.IUserDataSyncEnablementService),Y(12,v.ITelemetryService),Y(13,h.IExtensionStorageService),Y(14,f.IUriIdentityService),Y(15,c.IUserDataProfileStorageService),Y(16,y.IInstantiationService)],I),e.ExtensionsSynchroniser=I;let F=class{constructor(j,L,M,z,G,W){this.a=j,this.b=L,this.c=M,this.d=z,this.f=G,this.g=W}async getLocalExtensions(j){const L=await this.a.getInstalled(void 0,j.extensionsResource),M=this.d.getIgnoredExtensions(L);return{localExtensions:await this.j(j,async(G,W)=>{const _=G.getDisabledExtensions();return L.map(K=>{const{identifier:q,isBuiltin:V,manifest:Z,preRelease:ne}=K,J={identifier:q,preRelease:ne,version:Z.version};_.some(x=>(0,p.areSameExtensions)(x,q))&&(J.disabled=!0),V||(J.installed=!0);try{const x=W.getKeysForSync({id:q.id,version:Z.version});if(x){const T=W.getExtensionState(K,!0)||{};J.state=Object.keys(T).reduce((U,H)=>(x.includes(H)&&(U[H]=T[H]),U),{})}}catch(x){this.g.info(`${(0,s.getSyncResourceLogLabel)("extensions",j)}: Error while parsing extension state`,(0,D.getErrorMessage)(x))}return J})}),ignoredExtensions:M}}async updateLocalExtensions(j,L,M,z,G){const W=(0,s.getSyncResourceLogLabel)("extensions",G);return this.j(G,async(_,K)=>{const q=[],V=[],Z=await this.a.getInstalled(void 0,G.extensionsResource);if(L.length){const J=Z.filter(({identifier:x,isBuiltin:T})=>!T&&L.some(U=>(0,p.areSameExtensions)(x,U)));await k.Promises.settled(J.map(async x=>{this.g.trace(`${W}: Uninstalling local extension...`,x.identifier.id),await this.a.uninstall(x,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:G.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,x.identifier.id),q.push(x.identifier)}))}(j.length||M.length)&&await k.Promises.settled([...j,...M].map(async J=>{const x=Z.find(U=>(0,p.areSameExtensions)(U.identifier,J.identifier));if(x&&x.isBuiltin){J.state&&x.manifest.version===J.version&&this.h(J.state,x,x.manifest.version,K),_.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,J.identifier))!==!!J.disabled&&(J.disabled?(this.g.trace(`${W}: Disabling extension...`,J.identifier.id),await _.disableExtension(J.identifier),this.g.info(`${W}: Disabled extension`,J.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,J.identifier.id),await _.enableExtension(J.identifier),this.g.info(`${W}: Enabled extension`,J.identifier.id))),q.push(J.identifier);return}const T=(await this.c.getExtensions([{...J.identifier,preRelease:J.preRelease}],i.CancellationToken.None))[0];if(J.state&&(x?x.manifest.version===J.version:!!T)&&this.h(J.state,x||T,x?.manifest.version,K),T)try{_.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,J.identifier))!==!!J.disabled&&(J.disabled?(this.g.trace(`${W}: Disabling extension...`,J.identifier.id,T.version),await _.disableExtension(T.identifier),this.g.info(`${W}: Disabled extension`,J.identifier.id,T.version)):(this.g.trace(`${W}: Enabling extension...`,J.identifier.id,T.version),await _.enableExtension(T.identifier),this.g.info(`${W}: Enabled extension`,J.identifier.id,T.version))),(!x||x.preRelease!==J.preRelease)&&(await this.a.canInstall(T)?(this.g.trace(`${W}: Installing extension...`,J.identifier.id,T.version),await this.a.installFromGallery(T,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:J.preRelease,profileLocation:G.extensionsResource}),this.g.info(`${W}: Installed extension.`,J.identifier.id,T.version),q.push(T.identifier)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,T.displayName||T.identifier.id),V.push(J)))}catch(U){V.push(J),U instanceof w.ExtensionManagementError&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatiblePreRelease,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(U.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,T.displayName||T.identifier.id):(this.g.error(U),this.g.info(`${W}: Skipped synchronizing extension`,T.displayName||T.identifier.id))}else V.push(J),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,J.identifier.id)}));const ne=[];for(const J of z)q.some(x=>(0,p.areSameExtensions)(x,J.identifier))||ne.push(J);for(const J of V)ne.some(x=>(0,p.areSameExtensions)(x.identifier,J.identifier))||ne.push(J);return ne})}h(j,L,M,z){const G=z.getExtensionState(L,!0)||{},W=M?z.getKeysForSync({id:L.identifier.id,version:M}):void 0;W?W.forEach(_=>{G[_]=j[_]}):Object.keys(j).forEach(_=>G[_]=j[_]),z.setExtensionState(L,G,!0)}async j(j,L){return this.b.withProfileScopedStorageService(j,async M=>{const z=new R.DisposableStore,G=this.f.createChild(new l.ServiceCollection([m.IStorageService,M])),W=z.add(G.createInstance(E.GlobalExtensionEnablementService)),_=z.add(G.createInstance(h.ExtensionStorageService));try{return await L(W,_)}finally{z.dispose()}})}};F=pe([Y(0,w.IExtensionManagementService),Y(1,c.IUserDataProfileStorageService),Y(2,w.IExtensionGalleryService),Y(3,r.IIgnoredExtensionsManagementService),Y(4,y.IInstantiationService),Y(5,o.IUserDataSyncLogService)],F),e.LocalExtensionsProvider=F;let N=class extends s.AbstractInitializer{constructor(j,L,M,z,G,W,_,K){super("extensions",z,G,W,M,_,K),this.o=j,this.p=L}async q(j){return j.syncData?await a(j.syncData,this.o):null}t(j,L){const M=[],z=[],G=[];for(const W of j){if(this.p.hasToNeverSyncExtension(W.identifier.id))continue;const _=L.find(K=>(0,p.areSameExtensions)(K.identifier,W.identifier));_?(M.push(_),W.disabled&&G.push(W.identifier)):W.installed&&(z.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&G.push(W.identifier))}return{installedExtensions:M,newExtensions:z,disabledExtensions:G,remoteExtensions:j}}};N=pe([Y(0,w.IExtensionManagementService),Y(1,r.IIgnoredExtensionsManagementService),Y(2,g.IFileService),Y(3,n.IUserDataProfilesService),Y(4,C.IEnvironmentService),Y(5,d.ILogService),Y(6,m.IStorageService),Y(7,f.IUriIdentityService)],N),e.AbstractExtensionsInitializer=N}),define(oe[118],ae([0,1,17,9,3,35,43,5,31,16,15,14,8,45,19,23,30,41,60,256,26,18,62,4]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d,m,v,f,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",r=["locale"];function o(F,N){const $=F.storage?Object.keys(F.storage).sort():[],j={};return $.forEach(L=>j[L]=F.storage[L]),F.storage=j,N?(0,O.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=o;const c=1;let a=class extends l.AbstractSynchroniser{constructor(N,$,j,L,M,z,G,W,_,K,q,V,Z,ne){super({syncResource:"globalState",profile:N},$,L,W,V,M,z,_,K,G,q,Z),this.wb=j,this.mb=c,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.sb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.tb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.ub=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.vb=ne.createInstance(u),this.B(L.watch(this.h.dirname(this.D.argvResource))),this.B(D.Event.any(D.Event.filter(L.onDidFilesChange,J=>J.contains(this.D.argvResource)),D.Event.filter(j.onDidChange,J=>!!(J.targetChanges.some(x=>this.syncResource.profile.id===x.id)||J.valueChanges.some(({profile:x,changes:T})=>this.syncResource.profile.id===x.id&&T.some(U=>U.target===0)))))(()=>this.triggerLocalChange()))}async nb(N,$,j){const L=N.syncData?JSON.parse(N.syncData.content):null;$=$===null&&j?N:$;const M=$&&$.syncData?JSON.parse($.syncData.content):null,z=await this.vb.getLocalGlobalState(this.syncResource.profile);L?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=await this.Eb(M),{local:W,remote:_}=(0,m.merge)(z.storage,L?L.storage:null,M?M.storage:null,G,this.L),K={content:null,local:W,remote:_,localChange:Object.keys(W.added).length>0||Object.keys(W.updated).length>0||W.removed.length>0?2:0,remoteChange:_.all!==null?2:0},q=o(z,!1);return[{baseResource:this.r,baseContent:M?o(M,!1):q,localResource:this.sb,localContent:q,localUserData:z,remoteResource:this.tb,remoteContent:L?o(L,!1):null,previewResource:this.p,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.ub,storageKeys:G}]}async rb(N){const $=N.syncData?JSON.parse(N.syncData.content):null;if($===null)return!0;const j=await this.vb.getLocalGlobalState(this.syncResource.profile),L=await this.Eb($),{remote:M}=(0,m.merge)(j.storage,$.storage,$.storage,L,this.L);return M.all!==null}async ob(N,$){return{...N.previewResult,hasConflicts:!1}}async pb(N,$,j,L){if(this.h.isEqual($,this.sb))return this.Bb(N);if(this.h.isEqual($,this.tb))return this.Cb(N);if(this.h.isEqual($,this.p))return N.previewResult;throw new Error(`Invalid Resource: ${$.toString()}`)}async Bb(N){return{content:N.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(N.localUserData.storage),removed:[],updated:[],all:N.localUserData.storage},localChange:0,remoteChange:2}}async Cb(N){if(N.remoteContent!==null){const $=JSON.parse(N.remoteContent),{local:j,remote:L}=(0,m.merge)(N.localUserData.storage,$.storage,null,N.storageKeys,this.L);return{content:N.remoteContent,local:j,remote:L,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:L!==null?2:0}}else return{content:N.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(N,$,j,L){const{localUserData:M}=j[0][0],{local:z,remote:G,localChange:W,remoteChange:_}=j[0][1];if(W===0&&_===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),W!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify(M)),await this.vb.writeLocalGlobalState(z,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),_!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const K=JSON.stringify({storage:G.all});N=await this.jb(K,L?null:N.ref),this.L.info(`${this.y}: Updated remote ui state.${G.added.length?` Added: ${G.added}.`:""}${G.updated.length?` Updated: ${G.updated}.`:""}${G.removed.length?` Removed: ${G.removed}.`:""}`)}$?.ref!==N.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(N),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(N){if(this.h.isEqual(this.tb,N)||this.h.isEqual(this.r,N)||this.h.isEqual(this.sb,N)||this.h.isEqual(this.ub,N)){const $=await this.ab(N);return $&&o(JSON.parse($),!0)}return null}async hasLocalData(){try{const{storage:N}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(N).length>1||N[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(N){const $=await this.wb.readStorageData(this.syncResource.profile),j=[],L=[];for(const[G,W]of $)W.target===0?j.push(G):W.target===1&&L.push(G);const M=[...j,...L],z=N?.storage?Object.keys(N.storage).filter(G=>!G.startsWith(t)&&!M.includes(G)&&$.get(G)!==void 0):[];if(!R.isWeb){const G=[...v.ALL_SYNC_RESOURCES.map(W=>(0,v.getEnablementKey)(W)),v.SYNC_SERVICE_URL_TYPE];z.push(...G),L.push(...G)}return{user:j,machine:L,unregistered:z}}};a=pe([Y(2,n.IUserDataProfileStorageService),Y(3,E.IFileService),Y(4,v.IUserDataSyncStoreService),Y(5,v.IUserDataSyncBackupStoreService),Y(6,v.IUserDataSyncLogService),Y(7,C.IEnvironmentService),Y(8,v.IUserDataSyncEnablementService),Y(9,g.ITelemetryService),Y(10,S.IConfigurationService),Y(11,h.IStorageService),Y(12,y.IUriIdentityService),Y(13,s.IInstantiationService)],a),e.GlobalStateSynchroniser=a;let u=class{constructor(N,$,j,L){this.a=N,this.b=$,this.c=j,this.d=L}async getLocalGlobalState(N){const $={};if(N.isDefault){const L=await this.f(),M=(0,A.parse)(L);for(const z of r)M[z]!==void 0&&($[`${t}${z}`]={version:1,value:M[z]})}const j=await this.c.readStorageData(N);for(const[L,M]of j)M.value&&M.target===0&&($[L]={version:1,value:M.value});return{storage:$}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const N=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),N.value.toString()}catch(N){this.d.debug((0,i.getErrorMessage)(N))}return"{}"}async writeLocalGlobalState({added:N,removed:$,updated:j},L){const M=(0,l.getSyncResourceLogLabel)("globalState",L),z={},G=new Map,W=await this.c.readStorageData(L),_=(K,q)=>{for(const V of K){if(V.startsWith(t)){z[V.substring(t.length)]=q?q[V].value:void 0;continue}if(q){const Z=q[V];Z.value!==W.get(V)?.value&&G.set(V,Z.value)}else W.get(V)!==void 0&&G.set(V,void 0)}};if(_(Object.keys(N),N),_(Object.keys(j),j),_($),Object.keys(z).length){this.d.trace(`${M}: Updating locale...`);const K=await this.f();let q=K;for(const V of Object.keys(z))q=(0,d.edit)(q,[V],z[V],{});K!==q&&(this.d.trace(`${M}: Updating locale...`),await this.a.writeFile(this.b.argvResource,k.VSBuffer.fromString(q)),this.d.info(`${M}: Updated locale.`)),this.d.info(`${M}: Updated locale`)}G.size&&(this.d.trace(`${M}: Updating global state...`),await this.c.updateStorageData(L,G,0),this.d.info(`${M}: Updated global state`,[...G.keys()]))}};u=pe([Y(0,E.IFileService),Y(1,C.IEnvironmentService),Y(2,n.IUserDataProfileStorageService),Y(3,v.IUserDataSyncLogService)],u),e.LocalGlobalStateProvider=u;let b=class extends l.AbstractInitializer{constructor(N,$,j,L,M,z){super("globalState",j,L,M,$,N,z)}async doInitialize(N){const $=N.syncData?JSON.parse(N.syncData.content):null;if(!$){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const j={},L={};for(const M of Object.keys($.storage))M.startsWith(t)?j[M.substring(t.length)]=$.storage[M].value:this.l.get(M,0)===void 0&&(L[M]=$.storage[M].value);if(Object.keys(j).length){let M="{}";try{M=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const z of Object.keys(j))M=(0,d.edit)(M,[z],j[z],{});await this.k.writeFile(this.h.argvResource,k.VSBuffer.fromString(M))}if(Object.keys(L).length)for(const M of Object.keys(L))this.l.store(M,L[M],0,0)}};b=pe([Y(0,h.IStorageService),Y(1,E.IFileService),Y(2,f.IUserDataProfilesService),Y(3,C.IEnvironmentService),Y(4,v.IUserDataSyncLogService),Y(5,y.IUriIdentityService)],b),e.GlobalStateInitializer=b;let I=class{constructor(N,$,j,L,M){this.a=N,this.b=$,this.c=j,this.d=L,this.f=M}getSyncStoreType(N){return this.h(N)?.storage[v.SYNC_SERVICE_URL_TYPE]?.value}async sync(N){const $=(0,v.createSyncHeaders)((0,P.generateUuid)());try{return await this.g(N,$)}catch(j){if(j instanceof v.UserDataSyncError)switch(j.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(N,$)}throw j}}async g(N,$){const j=await this.a.readResource("globalState",null,void 0,$),L=this.h(j)||{storage:{}};L.storage[v.SYNC_SERVICE_URL_TYPE]={value:N,version:c};const M=await(0,p.getServiceMachineId)(this.c,this.d,this.b),z={version:c,machineId:M,content:o(L,!1)};await this.a.writeResource("globalState",JSON.stringify(z),j.ref,void 0,$)}h({content:N}){if(!N)return null;const $=JSON.parse(N);if((0,l.isSyncData)($))return $?JSON.parse($.content):null;throw new Error("Invalid remote data")}};I=pe([Y(1,h.IStorageService),Y(2,C.IEnvironmentService),Y(3,E.IFileService),Y(4,w.ILogService)],I),e.UserDataSyncStoreTypeSynchronizer=I}),define(oe[119],ae([0,1,20,17,3,35,5,13,175,16,15,14,19,23,30,18,41,253,26]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function m(n,s,t){try{const r=JSON.parse(n);if(!s)return(0,R.isUndefined)(r.all)?null:r.all;switch(O.OS){case 2:return(0,R.isUndefined)(r.mac)?null:r.mac;case 3:return(0,R.isUndefined)(r.linux)?null:r.linux;case 1:return(0,R.isUndefined)(r.windows)?null:r.windows}}catch(r){return t.error(r),null}}e.getKeybindingsContentFromSyncContent=m;let v=class extends y.AbstractJsonFileSynchroniser{constructor(s,t,r,o,c,a,u,b,I,F,N,$,j){super(s.keybindingsResource,{syncResource:"keybindings",profile:s},t,b,I,F,r,o,u,$,c,N,a,j),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Bb=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Cb=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Db=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(D.Event.filter(a.onDidChangeConfiguration,L=>L.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async nb(s,t,r,o){const c=s.syncData?m(s.syncData.content,o.keybindingsPerPlatform??this.Lb(),this.L):null;t=t===null&&r?s:t;const a=t?this.Jb(t):null,u=await this.p(),b=await this.xb();let I=null,F=!1,N=!1,$=!1;if(c){let M=u?u.value.toString():"[]";if(M=M||"[]",this.vb(M,!0))throw new d.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==M||a!==c){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const z=await(0,l.merge)(M,c,a,b,this.ub);z.hasChanges&&(I=z.mergeContent,$=z.hasConflicts,F=$||z.mergeContent!==M,N=$||z.mergeContent!==c)}}else u&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),I=u.value.toString(),N=!0);const j={content:$?a:I,localChange:F?u?2:1:0,remoteChange:N?2:0,hasConflicts:$},L=u?u.value.toString():null;return[{fileContent:u,baseResource:this.Ab,baseContent:a,localResource:this.Bb,localContent:L,localChange:j.localChange,remoteResource:this.Cb,remoteContent:c,remoteChange:j.remoteChange,previewResource:this.zb,previewResult:j,acceptedResource:this.Db}]}async rb(s){const t=this.Jb(s);if(t===null)return!0;const r=await this.p(),o=r?r.value.toString():"",c=await this.xb(),a=await(0,l.merge)(o||"[]",t,t,c,this.ub);return a.hasConflicts||a.mergeContent!==t}async ob(s,t){return s.previewResult}async pb(s,t,r,o){if(this.h.isEqual(t,this.Bb))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Cb))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.zb))return r===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(s,t,r,o){const{fileContent:c}=r[0][0];let{content:a,localChange:u,remoteChange:b}=r[0][1];if(u===0&&b===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.vb(a,!0)))throw new d.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),c&&await this.kb(this.Kb(c.value.toString())),await this.r(a||"[]",c,o),this.L.info(`${this.y}: Updated local keybindings`)),b!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const I=this.Kb(a||"[]",s.syncData?.content);s=await this.jb(I,o?null:s.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}t?.ref!==s.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(s,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.p();if(s){const t=(0,A.parse)(s.value.toString());if((0,k.isNonEmptyArray)(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.Cb,s)||this.h.isEqual(this.Ab,s)||this.h.isEqual(this.Bb,s)||this.h.isEqual(this.Db,s)?this.ab(s):null}Jb(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.Lb()?null:m(s.syncData.content,this.Lb(),this.L)}Kb(s,t){let r={};try{r=JSON.parse(t||"{}")}catch(o){this.L.error(o)}switch(this.Lb()?delete r.all:r.all=s,O.OS){case 2:r.mac=s;break;case 3:r.linux=s;break;case 1:r.windows=s;break}return JSON.stringify(r)}Lb(){return!!this.M.getValue(d.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};v=pe([Y(2,d.IUserDataSyncStoreService),Y(3,d.IUserDataSyncBackupStoreService),Y(4,d.IUserDataSyncLogService),Y(5,S.IConfigurationService),Y(6,d.IUserDataSyncEnablementService),Y(7,E.IFileService),Y(8,C.IEnvironmentService),Y(9,w.IStorageService),Y(10,d.IUserDataSyncUtilService),Y(11,p.ITelemetryService),Y(12,h.IUriIdentityService)],v),e.KeybindingsSynchroniser=v;let f=class extends y.AbstractInitializer{constructor(s,t,r,o,c,a){super("keybindings",t,r,o,s,c,a)}async doInitialize(s){const t=s.syncData?this.i(s.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,i.VSBuffer.fromString(t)),await this.n(s)}async c(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,A.parse)(s.value.toString());return!(0,k.isNonEmptyArray)(t)}catch(s){return s.fileOperationResult===1}}i(s){try{return m(s,!0,this.j)}catch(t){return this.j.error(t),null}}};f=pe([Y(0,E.IFileService),Y(1,g.IUserDataProfilesService),Y(2,C.IEnvironmentService),Y(3,d.IUserDataSyncLogService),Y(4,w.IStorageService),Y(5,h.IUriIdentityService)],f),e.KeybindingsInitializer=f}),define(oe[120],ae([0,1,17,3,176,16,74,15,29,14,19,23,30,18,41,60,257,26]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function d(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function m(n){const s=JSON.parse(n);return d(s)?s:{settings:n}}e.parseSettingsSyncContent=m;let v=class extends h.AbstractJsonFileSynchroniser{constructor(s,t,r,o,c,a,u,b,I,F,N,$,j,L){super(s.settingsResource,{syncResource:"settings",profile:s},t,r,o,c,a,u,N,$,b,I,F,L),this.zb=j,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(s){const t=await this.getLastSyncUserData(),r=await this.R(s,t),o=this.Gb(r),c=new O.ConfigurationModelParser(l.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&c.parse(o.settings),c.configurationModel.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(s,t,r){const o=await this.p(),c=await this.xb(),a=this.Gb(s);t=t===null&&r?s:t;const u=t?this.Gb(t):null,b=await this.Kb();let I=null,F=!1,N=!1,$=!1;if(a){let z=o?o.value.toString().trim():"{}";z=z||"{}",this.Lb(z),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const G=(0,y.merge)(z,a.settings,u?u.settings:null,b,[],c);I=G.localContent||G.remoteContent,F=G.localContent!==null,N=G.remoteContent!==null,$=G.hasConflicts}else o&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),I=o.value.toString().trim()||"{}",this.Lb(I),N=!0);const j=o?o.value.toString():null,L=u?.settings??null,M={content:$?L:I,localChange:F?2:0,remoteChange:N?2:0,hasConflicts:$};return[{fileContent:o,baseResource:this.baseResource,baseContent:L,localResource:this.localResource,localContent:j,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async rb(s){const t=this.Gb(s);if(t===null)return!0;const r=await this.p(),o=r?r.value.toString().trim():"",c=await this.Kb(),a=await this.xb();return(0,y.merge)(o||"{}",t.settings,t.settings,c,[],a).remoteContent!==null}async ob(s,t){const r=await this.xb(),o=await this.Kb();return{...s.previewResult,content:s.previewResult.content?(0,y.updateIgnoredSettings)(s.previewResult.content,"{}",o,r):null}}async pb(s,t,r,o){const c=await this.xb(),a=await this.Kb();if(this.h.isEqual(t,this.localResource))return{content:s.fileContent?(0,y.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",a,c):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:s.remoteContent!==null?(0,y.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",a,c):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return r===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:r!==null?(0,y.updateIgnoredSettings)(r,s.fileContent?s.fileContent.value.toString():"{}",a,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(s,t,r,o){const{fileContent:c}=r[0][0];let{content:a,localChange:u,remoteChange:b}=r[0][1];if(u===0&&b===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.Lb(a),u!==0&&(this.L.trace(`${this.y}: Updating local settings...`),c&&await this.kb(JSON.stringify(this.Ib(c.value.toString()))),await this.r(a,c,o),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),b!==0){const I=await this.xb(),F=this.Gb(s),N=await this.Kb(a);a=(0,y.updateIgnoredSettings)(a,F?F.settings:"{}",N,I),this.L.trace(`${this.y}: Updating remote settings...`),s=await this.jb(JSON.stringify(this.Ib(a)),o?null:s.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(s),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.p();if(s){const t=await this.xb(),r=(0,g.edit)(s.value.toString(),[l.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,y.isEmpty)(r)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.ab(s):null}async ab(s){let t=await super.ab(s);if(t){const r=await this.xb(),o=await this.Kb();t=(0,y.updateIgnoredSettings)(t,"{}",o,r)}return t}Gb(s){return s.syncData?this.Hb(s.syncData.content):null}Hb(s){try{return m(s)}catch(t){this.L.error(t)}return null}Ib(s){return{settings:s}}async Kb(s){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const r=i.Event.any(i.Event.filter(this.zb.onDidInstallExtensions,o=>o.some(({local:c})=>!!c)),i.Event.filter(this.zb.onDidUninstallExtension,o=>!o.error))(()=>{r.dispose(),this.Jb=void 0})}const t=await this.Jb;return(0,y.getIgnoredSettings)(t,this.M,s)}Lb(s){if(this.vb(s,!1))throw new l.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};v=pe([Y(2,S.IFileService),Y(3,R.IEnvironmentService),Y(4,C.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncLogService),Y(8,l.IUserDataSyncUtilService),Y(9,A.IConfigurationService),Y(10,l.IUserDataSyncEnablementService),Y(11,E.ITelemetryService),Y(12,P.IExtensionManagementService),Y(13,w.IUriIdentityService)],v),e.SettingsSynchroniser=v;let f=class extends h.AbstractInitializer{constructor(s,t,r,o,c,a){super("settings",t,r,o,s,c,a)}async doInitialize(s){const t=s.syncData?this.i(s.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,k.VSBuffer.fromString(t.settings)),await this.n(s)}async c(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,y.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}i(s){try{return m(s)}catch(t){this.j.error(t)}return null}};f=pe([Y(0,S.IFileService),Y(1,p.IUserDataProfilesService),Y(2,R.IEnvironmentService),Y(3,l.IUserDataSyncLogService),Y(4,C.IStorageService),Y(5,w.IUriIdentityService)],f),e.SettingsInitializer=f}),define(oe[121],ae([0,1,17,3,32,16,15,14,19,23,30,18,41,254,26]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function g(d){return JSON.parse(d.content)}e.parseSnippets=g;let y=class extends w.AbstractSynchroniser{constructor(m,v,f,n,s,t,r,o,c,a,u,b){super({syncResource:"snippets",profile:m},v,n,f,s,t,r,a,u,o,c,b),this.mb=1,this.p=m.snippetsHome,this.B(this.C.watch(f.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(i.Event.filter(this.C.onDidFilesChange,I=>I.affects(this.p))(()=>this.triggerLocalChange()))}async nb(m,v,f){const n=await this.Cb(),s=this.Bb(n),t=m.syncData?this.Ab(m.syncData):null;v=v===null&&f?m:v;const r=v&&v.syncData?this.Ab(v.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const o=(0,p.merge)(s,t,r);return this.wb(o,n,t||{},r||{})}async rb(m){const v=m.syncData?this.Ab(m.syncData):null;if(v===null)return!0;const f=await this.Cb(),n=this.Bb(f),s=(0,p.merge)(n,v,v);return Object.keys(s.remote.added).length>0||Object.keys(s.remote.updated).length>0||s.remote.removed.length>0||s.conflicts.length>0}async ob(m,v){return m.previewResult}async pb(m,v,f,n){if(this.h.isEqualOrParent(v,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(v,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(v,this.g))return f===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:f,localChange:f===null?m.fileContent!==null?3:0:2,remoteChange:f===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async qb(m,v,f,n){const s=f.map(([t,r])=>({...t,acceptResult:r}));s.every(({localChange:t,remoteChange:r})=>t===0&&r===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),s.some(({localChange:t})=>t!==0)&&(await this.xb(s),await this.yb(s,n)),s.some(({remoteChange:t})=>t!==0)&&(m=await this.zb(s,m,n)),v?.ref!==m.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(m),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of s)try{await this.C.del(t)}catch{}}wb(m,v,f,n){const s=new Map;for(const t of Object.keys(m.local.added)){const r={content:m.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(m.local.updated)){const r={content:m.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},o=v[t]?v[t].value.toString():null;s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of m.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0},o=v[t]?v[t].value.toString():null;s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(m.remote.added)){const r={content:m.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},o=v[t]?v[t].value.toString():null;s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(m.remote.updated)){const r={content:m.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},o=v[t]?v[t].value.toString():null;s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of m.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of m.conflicts){const r={content:n[t]??null,hasConflicts:!0,localChange:v[t]?2:1,remoteChange:f[t]?2:1},o=v[t]?v[t].value.toString():null;s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t]||null,localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(v))if(!s.has(t)){const r={content:v[t]?v[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},o=v[t]?v[t].value.toString():null;s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t]||null,localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...s.values()]}async resolveContent(m){return this.h.isEqualOrParent(m,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(m,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(m,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(m,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(m):null}async hasLocalData(){try{const m=await this.Cb();if(Object.keys(m).length)return!0}catch{}return!1}async xb(m){const v={};for(const f of m)f.fileContent&&(v[this.h.basename(f.localResource)]=f.fileContent);await this.kb(JSON.stringify(this.Bb(v)))}async yb(m,v){for(const{fileContent:f,acceptResult:n,localResource:s,remoteResource:t,localChange:r}of m)if(r!==0){const o=t?this.h.basename(t):this.h.basename(s),c=this.h.joinPath(this.p,o);r===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(c)),await this.C.del(c),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(c))):r===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(c)),await this.C.createFile(c,k.VSBuffer.fromString(n.content),{overwrite:v}),this.L.info(`${this.y}: Created snippet`,this.h.basename(c))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(c)),await this.C.writeFile(c,k.VSBuffer.fromString(n.content),v?void 0:f),this.L.info(`${this.y}: Updated snippet`,this.h.basename(c)))}}async zb(m,v,f){const n=v.syncData?this.Ab(v.syncData):{},s=(0,D.deepClone)(n);for(const{acceptResult:t,localResource:r,remoteResource:o,remoteChange:c}of m)if(c!==0){const a=r?this.h.basename(r):this.h.basename(o);c===3?delete s[a]:s[a]=t.content}return(0,p.areSame)(n,s)||(this.L.trace(`${this.y}: Updating remote snippets...`),v=await this.jb(JSON.stringify(s),f?null:v.ref),this.L.info(`${this.y}: Updated remote snippets`)),v}Ab(m){return g(m)}Bb(m){const v={};for(const f of Object.keys(m))v[f]=m[f].value.toString();return v}async Cb(){const m={};let v;try{v=await this.C.resolve(this.p)}catch(f){if(f instanceof R.FileOperationError&&f.fileOperationResult===1)return m;throw f}for(const f of v.children||[]){const n=f.resource,s=this.h.extname(n);if(s===".json"||s===".code-snippets"){const t=this.h.relativePath(this.p,n),r=await this.C.readFile(n);m[t]=r}}return m}};y=pe([Y(2,O.IEnvironmentService),Y(3,R.IFileService),Y(4,P.IStorageService),Y(5,h.IUserDataSyncStoreService),Y(6,h.IUserDataSyncBackupStoreService),Y(7,h.IUserDataSyncLogService),Y(8,A.IConfigurationService),Y(9,h.IUserDataSyncEnablementService),Y(10,S.ITelemetryService),Y(11,C.IUriIdentityService)],y),e.SnippetsSynchroniser=y;let l=class extends w.AbstractInitializer{constructor(m,v,f,n,s,t){super("snippets",v,f,n,m,s,t)}async doInitialize(m){const v=m.syncData?JSON.parse(m.syncData.content):null;if(!v){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(v)){const s=v[n];if(s){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(t,k.VSBuffer.fromString(s)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(m)}async c(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};l=pe([Y(0,R.IFileService),Y(1,E.IUserDataProfilesService),Y(2,O.IEnvironmentService),Y(3,h.IUserDataSyncLogService),Y(4,P.IStorageService),Y(5,C.IUriIdentityService)],l),e.SnippetsInitializer=l}),define(oe[122],ae([0,1,17,16,15,14,19,23,30,18,41,26]),function(ee,e,k,i,D,A,O,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function w(y,l){try{return JSON.parse(y).tasks??null}catch(d){return l.error(d),null}}e.getTasksContentFromSyncContent=w;let p=class extends C.AbstractFileSynchroniser{constructor(l,d,m,v,f,n,s,t,r,o,c,a){super(l.tasksResource,{syncResource:"tasks",profile:l},d,t,r,o,m,v,s,c,f,n,a),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"base"}),this.xb=this.vb.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.yb=this.vb.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.zb=this.vb.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(l,d,m,v){const f=l.syncData?w(l.syncData.content,this.L):null;d=d===null&&m?l:d;const n=d?.syncData?w(d.syncData.content,this.L):null,s=await this.p();let t=null,r=!1,o=!1,c=!1;if(l.syncData){const b=s?s.value.toString():null;if(!n||n!==b||n!==f){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const I=g(b,f,n);t=I.content,c=I.hasConflicts,r=I.hasLocalChanged,o=I.hasRemoteChanged}}else s&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=s.value.toString(),o=!0);const a={content:c?n:t,localChange:r?s?2:1:0,remoteChange:o?2:0,hasConflicts:c},u=s?s.value.toString():null;return[{fileContent:s,baseResource:this.wb,baseContent:n,localResource:this.xb,localContent:u,localChange:a.localChange,remoteResource:this.yb,remoteContent:f,remoteChange:a.remoteChange,previewResource:this.vb,previewResult:a,acceptedResource:this.zb}]}async rb(l){const d=l?.syncData?w(l.syncData.content,this.L):null;if(d===null)return!0;const m=await this.p(),v=m?m.value.toString():null,f=g(v,d,d);return f.hasLocalChanged||f.hasRemoteChanged}async ob(l,d){return l.previewResult}async pb(l,d,m,v){if(this.h.isEqual(d,this.xb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(d,this.yb))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(d,this.vb))return m===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:m,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async qb(l,d,m,v){const{fileContent:f}=m[0][0],{content:n,localChange:s,remoteChange:t}=m[0][1];if(s===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),s!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),f&&await this.kb(JSON.stringify(this.Fb(f.value.toString()))),n?await this.r(n,f,v):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const r=JSON.stringify(this.Fb(n));l=await this.jb(r,v?null:l.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}d?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(l){return this.h.isEqual(this.yb,l)||this.h.isEqual(this.wb,l)||this.h.isEqual(this.xb,l)||this.h.isEqual(this.zb,l)?this.ab(l):null}Fb(l){return l?{tasks:l}:{}}};p=pe([Y(2,E.IUserDataSyncStoreService),Y(3,E.IUserDataSyncBackupStoreService),Y(4,E.IUserDataSyncLogService),Y(5,i.IConfigurationService),Y(6,E.IUserDataSyncEnablementService),Y(7,A.IFileService),Y(8,D.IEnvironmentService),Y(9,O.IStorageService),Y(10,R.ITelemetryService),Y(11,P.IUriIdentityService)],p),e.TasksSynchroniser=p;let h=class extends C.AbstractInitializer{constructor(l,d,m,v,f,n){super("tasks",d,m,v,l,f,n),this.c=this.g.defaultProfile.tasksResource}async doInitialize(l){const d=l.syncData?w(l.syncData.content,this.j):null;if(!d){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,k.VSBuffer.fromString(d)),await this.n(l)}async i(){return this.k.exists(this.c)}};h=pe([Y(0,A.IFileService),Y(1,S.IUserDataProfilesService),Y(2,D.IEnvironmentService),Y(3,E.IUserDataSyncLogService),Y(4,O.IStorageService),Y(5,P.IUriIdentityService)],h),e.TasksInitializer=h;function g(y,l,d){if(y===null&&l===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const m=d!==y,v=d!==l;return!m&&!v?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:m&&!v?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:v&&!m?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[123],ae([0,1,43,16,15,14,19,23,30,18,41,255,26]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let p=class extends C.AbstractSynchroniser{constructor(l,d,m,v,f,n,s,t,r,o,c,a,u){super({syncResource:"profiles",profile:l},d,v,f,n,s,t,c,a,r,o,u),this.r=m,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?g(l.syncData):null}async getRemoteSyncedProfiles(l){const d=await this.getLastSyncUserData(),m=await this.R(l,d);return m?.syncData?g(m.syncData):null}async nb(l,d,m){if(!this.r.isEnabled())throw new w.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const v=l.syncData?g(l.syncData):null,f=d?.syncData?g(d.syncData):null,n=this.zb(),{local:s,remote:t}=(0,E.merge)(n,v,f,[]),r={local:s,remote:t,content:f?this.Ab(f):null,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:t!==null?2:0},o=h(n,!1);return[{baseResource:this.baseResource,baseContent:f?this.Ab(f):null,localResource:this.localResource,localContent:o,remoteResource:this.remoteResource,remoteContent:v?this.Ab(v):null,remoteProfiles:v,previewResource:this.previewResource,previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.acceptedResource}]}async rb(l){const d=l?.syncData?g(l.syncData):null,m=this.zb(),{remote:v}=(0,E.merge)(m,d,d,[]);return!!v?.added.length||!!v?.removed.length||!!v?.updated.length}async ob(l,d){return{...l.previewResult,hasConflicts:!1}}async pb(l,d,m,v){if(this.h.isEqual(d,this.localResource))return this.wb(l);if(this.h.isEqual(d,this.remoteResource))return this.xb(l);if(this.h.isEqual(d,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async wb(l){const d=this.zb(),m=(0,E.merge)(d,null,null,[]),{local:v,remote:f}=m;return{content:l.localContent,local:v,remote:f,localChange:v.added.length>0||v.removed.length>0||v.updated.length>0?2:0,remoteChange:f!==null?2:0}}async xb(l){const d=l.remoteContent?JSON.parse(l.remoteContent):null,m=[],v=[];for(const f of this.zb()){const n=d?.find(s=>s.id===f.id);n&&(m.push({id:f.id,name:f.name,collection:n.collection}),v.push(f))}if(d!==null){const f=(0,E.merge)(v,d,m,[]),{local:n,remote:s}=f;return{content:l.remoteContent,local:n,remote:s,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:s!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(l,d,m,v){const{local:f,remote:n,localChange:s,remoteChange:t}=m[0][1];s===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const r=m[0][0].remoteProfiles||[];if(r.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new w.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(s!==0){await this.kb(h(this.zb(),!1));const o=[];for(const c of f.added)o.push((async()=>{this.L.trace(`${this.y}: Creating '${c.name}' profile...`),await this.r.createProfile(c.id,c.name,{shortName:c.shortName}),this.L.info(`${this.y}: Created profile '${c.name}'.`)})());for(const c of f.removed)o.push((async()=>{this.L.trace(`${this.y}: Removing '${c.name}' profile...`),await this.r.removeProfile(c),this.L.info(`${this.y}: Removed profile '${c.name}'.`)})());for(const c of f.updated){const a=this.r.profiles.find(u=>u.id===c.id);a?o.push((async()=>{this.L.trace(`${this.y}: Updating '${c.name}' profile...`),await this.r.updateProfile(a,{name:c.name,shortName:c.shortName}),this.L.info(`${this.y}: Updated profile '${c.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${c.id}' to update.`)}await Promise.all(o)}if(t!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const o=[],c=r.length+(n?.added.length??0)<=20;if(c)for(const a of n?.added||[]){const u=await this.G.createCollection(this.z);o.push(u),r.push({id:a.id,name:a.name,collection:u,shortName:a.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const a of n?.removed||[])r.splice(r.findIndex(({id:u})=>a.id===u),1);for(const a of n?.updated||[]){const u=r.find(({id:b})=>a.id===b);u&&r.splice(r.indexOf(u),1,{id:a.id,name:a.name,collection:u.collection,shortName:a.shortName})}try{l=await this.updateRemoteProfiles(r,v?null:l.ref),this.L.info(`${this.y}: Updated remote profiles.${c&&n?.added.length?` Added: ${JSON.stringify(n.added.map(a=>a.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(a=>a.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(a=>a.name))}.`:""}`)}catch(a){if(o.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const u of o)await this.G.deleteCollection(u,this.z)}throw a}for(const a of n?.removed||[])await this.G.deleteCollection(a.collection,this.z)}d?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,d){return this.jb(this.Ab(l),d)}async hasLocalData(){return this.zb().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const d=await this.ab(l);return d&&(0,k.toFormattedString)(JSON.parse(d),{})}return null}zb(){return this.r.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Ab(l){return JSON.stringify([...l].sort((d,m)=>d.name.localeCompare(m.name)))}};p=pe([Y(2,S.IUserDataProfilesService),Y(3,A.IFileService),Y(4,D.IEnvironmentService),Y(5,O.IStorageService),Y(6,w.IUserDataSyncStoreService),Y(7,w.IUserDataSyncBackupStoreService),Y(8,w.IUserDataSyncLogService),Y(9,i.IConfigurationService),Y(10,w.IUserDataSyncEnablementService),Y(11,R.ITelemetryService),Y(12,P.IUriIdentityService)],p),e.UserDataProfilesManifestSynchroniser=p;function h(y,l){const d=[...y].sort((m,v)=>m.name.localeCompare(v.name)).map(m=>({id:m.id,name:m.name}));return l?(0,k.toFormattedString)(d,{}):JSON.stringify(d)}e.stringifyLocalProfiles=h;function g(y){return JSON.parse(y.content)}e.parseUserDataProfilesManifest=g}),define(oe[270],ae([0,1,6,17,65,2,22,16,15,14,18,26]),function(ee,e,k,i,D,A,O,R,P,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends A.Disposable{constructor(h,g,y,l,d){super(),this.a=h,this.b=g,this.c=y,this.f=l,this.g=d;for(const m of this.g.profiles)for(const v of E.ALL_SYNC_RESOURCES)this.i(this.h(m,v))}async getAllRefs(h,g){const y=this.h(h,g),l=await this.b.resolve(y);return l.children?l.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.j(m)})):[]}async resolveContent(h,g,y){const l=this.h(h,g),d=(0,O.joinPath)(l,y);try{return(await this.b.readFile(d)).value.toString()}catch(m){return this.f.error(m),null}}async backup(h,g,y){const l=this.h(h,g),d=(0,O.joinPath)(l,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,i.VSBuffer.fromString(y))}catch(m){this.f.error(m)}try{this.i(l)}catch{}}h(h,g){return(0,O.joinPath)(this.a.userDataSyncHome,...h.isDefault?[g]:[h.id,g])}async i(h){try{try{if(!await this.b.exists(h))return}catch{return}const g=await this.b.resolve(h);if(g.children){const y=g.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=y.filter(v=>Date.now()-this.j(v)>l);const m=y.length-d.length;m<10&&(d=d.slice(10-m)),await k.Promises.settled(d.map(async v=>{this.f.info("Deleting from backup",v.resource.path),await this.b.del(v.resource)}))}}catch(g){this.f.error(g)}}j(h){return h.ctime||new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};w=pe([Y(0,P.IEnvironmentService),Y(1,S.IFileService),Y(2,R.IConfigurationService),Y(3,E.IUserDataSyncLogService),Y(4,C.IUserDataProfilesService)],w),e.UserDataSyncBackupStoreService=w}),define(oe[271],ae([0,1,3,2,5,15,19,23,26]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let C=class extends i.Disposable{constructor(w,p,h,g){super(),this.c=w,this.f=p,this.g=h,this.h=g,this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new k.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(w.onDidChangeValue(y=>this.j(y)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(S,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(w){w&&!this.canToggleEnablement()||(this.f.publicLog2(S,{enabled:w}),this.c.store(S,w,-1,1))}isResourceEnabled(w){return this.c.getBoolean((0,P.getEnablementKey)(w),-1,!0)}setResourceEnablement(w,p){if(this.isResourceEnabled(w)!==p){const h=(0,P.getEnablementKey)(w);this.i(h,p)}}getResourceSyncStateVersion(w){}i(w,p){this.c.store(w,p,-1,D.isWeb?0:1)}j(w){if(w.scope!==-1)return;if(S===w.key){this.a.fire(this.isEnabled());return}const p=P.ALL_SYNC_RESOURCES.filter(h=>(0,P.getEnablementKey)(h)===w.key)[0];if(p){this.b.fire([p,this.isResourceEnabled(p)]);return}}};C=pe([Y(0,O.IStorageService),Y(1,R.ITelemetryService),Y(2,A.IEnvironmentService),Y(3,P.IUserDataSyncStoreManagementService)],C),e.UserDataSyncEnablementService=C}),define(oe[81],ae([0,1,3,2,5,27,179,15,14,4,25,45,19,26]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",g="Safari",y="Chrome",l="Edge",d="Firefox",m="Android";function v(s){switch(s){case g:case y:case l:case d:case m:case(0,D.PlatformToString)(0):return!0}return!1}e.isWebPlatform=v;function f(){return D.isSafari?g:D.isChrome?y:D.isEdge?l:D.isFirefox?d:D.isAndroid?m:(0,D.PlatformToString)(D.isWeb?0:D.platform)}let n=class rt extends i.Disposable{constructor(t,r,o,c,a,u){super(),this.h=o,this.i=c,this.j=a,this.k=u,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.getServiceMachineId)(t,r,o)}async getMachines(t){const r=await this.f;return(await this.m(t)).machines.map(c=>({...c,isCurrent:c.id===r}))}async addCurrentMachine(t){const r=await this.f,o=await this.m(t);o.machines.some(({id:c})=>c===r)||(o.machines.push({id:r,name:this.l(o.machines),platform:f()}),await this.n(o))}async removeCurrentMachine(t){const r=await this.f,o=await this.m(t),c=o.machines.filter(({id:a})=>a!==r);c.length!==o.machines.length&&(o.machines=c,await this.n(o))}async renameMachine(t,r,o){const c=await this.m(o),a=c.machines.find(({id:u})=>u===t);if(a){a.name=r,await this.n(c);const u=await this.f;t===u&&this.h.store(h,r,-1,1)}}async setEnablements(t){const r=await this.m();for(const[o,c]of t){const a=r.machines.find(u=>u.id===o);a&&(a.disabled=c?void 0:!0)}await this.n(r)}l(t){const r=this.h.get(h,-1);if(r)return r;const o=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${f()} (${this.k.nameShort})`,c=new RegExp(`${(0,A.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let a=0;for(const u of t){const b=c.exec(u.name),I=b?parseInt(b[1]):0;a=I>a?I:a}return`${o} #${a+1}`}async m(t){this.g=await this.p(t);const r=this.r(this.g);if(r.version!==rt.a)throw new Error((0,O.localize)(0,null,this.k.nameLong));return r}async n(t){const r=JSON.stringify(t),o=await this.i.writeResource(rt.b,r,this.g?.ref||null);this.g={ref:o,content:r},this.c.fire()}async p(t){if(this.g){const r=t&&t.latest?t.latest[rt.b]:void 0;if(this.g.ref===r)return this.g;if(r===void 0&&this.g.content===null)return this.g}return this.i.readResource(rt.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(r){this.j.error(r)}return{version:rt.a,machines:[]}}};n.a=1,n.b="machines",n=pe([Y(0,R.IEnvironmentService),Y(1,P.IFileService),Y(2,w.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncLogService),Y(5,C.IProductService)],n),e.UserDataSyncMachinesService=n}),define(oe[272],ae([0,1,6,65,38,9,3,2,5,22,7,177,25,19,23,26,78,81]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const d="sync.disableMachineEventually",m="sync.sessionId",v="sync.storeUrl",f="sync.productQuality";let n=class extends R.Disposable{get j(){const r=this.z.get(v,-1);return r?C.URI.parse(r):void 0}set j(r){r?this.z.store(v,r.toString(),-1,1):this.z.remove(v,-1)}get l(){return this.z.get(f,-1)}set l(r){r?this.z.store(f,r,-1,1):this.z.remove(f,-1)}constructor(r,o,c,a,u,b,I,F,N,$){super(),this.n=o,this.p=c,this.r=a,this.s=u,this.u=b,this.v=I,this.w=F,this.y=N,this.z=$,this.a=this.B(new R.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new k.ThrottledDelayer(this.O())),this.i=this.j,this.j=o.userDataSyncStore?.url,this.k=this.l,this.l=r.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(o.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.j,o.userDataSyncStore?.url)||(this.i=this.j,this.j=o.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(I.onDidChangeAccount(()=>this.C())),this.B(c.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(u.onDidChangeLocal(j=>this.triggerSync([j],!1,!1))),this.B(O.Event.filter(this.r.onDidChangeResourceEnablement,([,j])=>j)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:r,message:o}=this.F();r?this.a.value===void 0&&(this.a.value=new s(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(c=>this.I(c))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(o&&this.u.info(o),this.a.clear()):o&&this.r.isEnabled()&&this.u.info(o))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(r,o,c){try{this.v.account&&!c&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(m,-1),r?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(a){if(this.u.error(a),o)this.G(!1);else throw a}}G(r){this.r.isEnabled()!==r&&(this.r.setEnablement(r),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(r){if(!r){this.b=0;return}const o=g.UserDataSyncError.toUserDataSyncError(r);o instanceof g.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:o.code,service:this.n.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?P.isWeb&&o.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(o),this.b++),this.h.fire(o)}async J(){this.z.store(d,!0,-1,1),await(0,k.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(d,-1,!1)}M(){this.z.remove(d,-1)}async triggerSync(r,o,c){if(this.a.value===void 0)return this.f.cancel();if(o&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...r),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const a=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:a}),this.N=[],this.a.value&&await this.a.value.sync("Activity",c)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};n=pe([Y(0,w.IProductService),Y(1,g.IUserDataSyncStoreManagementService),Y(2,g.IUserDataSyncStoreService),Y(3,g.IUserDataSyncEnablementService),Y(4,g.IUserDataSyncService),Y(5,g.IUserDataSyncLogService),Y(6,y.IUserDataSyncAccountService),Y(7,h.ITelemetryService),Y(8,l.IUserDataSyncMachinesService),Y(9,p.IStorageService)],n),e.UserDataAutoSyncService=n;class s extends R.Disposable{constructor(r,o,c,a,u,b,I,F){super(),this.j=r,this.k=o,this.l=c,this.m=a,this.n=u,this.p=b,this.r=I,this.s=F,this.b=this.B(new R.MutableDisposable),this.c=this.B(new O.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new O.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,R.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(s.a,!1)}u(){this.b.value=(0,k.disposableTimeout)(()=>this.sync(s.a,!1),this.k)}sync(r,o){const c=(0,k.createCancelablePromise)(async a=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(u){if((0,A.isCancellationError)(u))return}return this.y(r,o,a)});return this.i=c,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,S.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const r=await this.l.getPreviousUserDataSyncStore(),o=this.l.userDataSyncStore;return!!o&&!!r&&(!(0,S.isEqual)(o.defaultUrl,r.defaultUrl)||!(0,S.isEqual)(o.insidersUrl,r.insidersUrl)||!(0,S.isEqual)(o.stableUrl,r.stableUrl))}async y(r,o,c){this.r.info(`Auto Sync: Triggered by ${r}`),this.c.fire();let a;try{await this.z(o,c)}catch(u){if(this.r.error(u),a=u,g.UserDataSyncError.toUserDataSyncError(u).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(o,c),a=void 0}catch(b){this.r.error(b),a=b}}this.f.fire(a)}async z(r,o){if(this.h=await this.n.createSyncTask(this.g,r),o.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new g.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const c=this.s.get(m,-1);if(c&&this.g&&c!==this.g.session)throw this.v()?await this.w()?new g.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const a=await this.p.getMachines(this.g||void 0);if(o.isCancellationRequested)return;const u=a.find(b=>b.isCurrent);if(u?.disabled)throw new g.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(b){throw new g.UserDataAutoSyncError((0,D.toErrorMessage)(b),b instanceof g.UserDataSyncError?b.code:"Unknown")}this.g&&this.g.session!==c&&this.s.store(m,this.g.session,-1,1),!o.isCancellationRequested&&(u||await this.p.addCurrentMachine(this.g||void 0))}register(r){return super.B(r)}}s.a="Interval"}),define(oe[273],ae([0,1,7,180,15,14,45,19,30,26,18,41,121,120,119,16,122,117,118,4,123,43]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class Ve{constructor(t,r,o,c,a,u,b,I,F,N){this.e=t,this.f=r,this.g=o,this.h=a,this.i=u,this.j=b,this.k=I,this.l=F,this.m=N,this.d=c.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.K(t.content,"profiles");return(0,v.parseUserDataProfilesManifest)(r)}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:c,ref:a})=>({created:c,uri:this.I({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:a,node:void 0})}))}async getLocalSyncResourceHandles(t,r){return(await this.f.getAllRefs(r,t)).map(({created:c,ref:a})=>({created:c,uri:this.I({remote:!1,syncResource:t,profile:r.id,collection:void 0,ref:a,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const r=this.J(t),o=r?this.k.profiles.find(c=>c.id===r.profile):void 0;return r&&o?{profile:o,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.J(t);if(!r)return[];const o=this.k.profiles.find(c=>c.id===r.profile);switch(r.syncResource){case"settings":return this.r(t,o);case"keybindings":return this.t(t,o);case"tasks":return this.v(t,o);case"snippets":return this.x(t,o);case"globalState":return this.C(t,o);case"extensions":return this.z(t,o);case"profiles":return this.F(t,o)}}async getMachineId({uri:t}){const r=this.J(t);if(!!r){if(r.remote){if(r.ref){const{content:o}=await this.L(r.syncResource,r.ref,r.collection);if(o)return this.K(o,r.syncResource)?.machineId}return}return(0,O.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.J(t);if(!r||r.node===Ve.a)return null;if(r.ref){const o=await this.n(r.remote,r.syncResource,r.profile,r.collection,r.ref);return r.node&&o?this.o(r.syncResource,o,r.node):o}return!r.remote&&!r.node?this.q(r.syncResource,r.profile):null}async n(t,r,o,c,a){if(t){const{content:b}=await this.L(r,a,c);return b}const u=this.k.profiles.find(b=>b.id===o);return u?this.f.resolveContent(u,r,a):null}o(t,r,o){const c=this.K(r,t);switch(t){case"settings":return this.s(c,o);case"keybindings":return this.u(c,o);case"tasks":return this.w(c,o);case"snippets":return this.y(c,o);case"globalState":return this.D(c,o);case"extensions":return this.A(c,o);case"profiles":return this.G(c,o)}}async q(t,r){const o=this.k.profiles.find(c=>c.id===r);if(!o)return null;switch(t){case"globalState":return this.E(o);case"extensions":return this.B(o);case"profiles":return this.H(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,r){const o=this.d.joinPath(t,"settings.json"),c=r?r.settingsResource:this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}s(t,r){switch(r){case"settings.json":return(0,p.parseSettingsSyncContent)(t.content).settings}return null}t(t,r){const o=this.d.joinPath(t,"keybindings.json"),c=r?r.keybindingsResource:this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}u(t,r){switch(r){case"keybindings.json":return(0,h.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,r){const o=this.d.joinPath(t,"tasks.json"),c=r?r.tasksResource:this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}w(t,r){switch(r){case"tasks.json":return(0,y.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,r){const o=await this.resolveContent(t);if(o){const c=this.K(o,"snippets");if(c){const a=(0,w.parseSnippets)(c),u=[];for(const b of Object.keys(a)){const I=this.d.joinPath(t,b),F=r?this.d.joinPath(r.snippetsHome,b):this.d.joinPath(t,Ve.a);u.push({resource:I,comparableResource:F})}return u}}return[]}y(t,r){return(0,w.parseSnippets)(t)[r]||null}z(t,r){const o=this.d.joinPath(t,"extensions.json"),c=r?this.I({remote:!1,syncResource:"extensions",profile:r.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}A(t,r){switch(r){case"extensions.json":return(0,l.stringify)((0,l.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:r}=await this.m.createInstance(l.LocalExtensionsProvider).getLocalExtensions(t);return(0,l.stringify)(r,!0)}C(t,r){const o=this.d.joinPath(t,"globalState.json"),c=r?this.I({remote:!1,syncResource:"globalState",profile:r.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}D(t,r){switch(r){case"globalState.json":return(0,d.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const r=await this.m.createInstance(d.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,d.stringify)(r,!0)}F(t,r){const o=this.d.joinPath(t,"profiles.json"),c=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:c}]}G(t,r){switch(r){case"profiles.json":return(0,f.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,v.stringifyLocalProfiles)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}I(t){const r=t.remote?Ve.b:Ve.c,o=[t.syncResource,t.profile];return t.collection&&o.push(`collection:${t.collection}`),t.ref&&o.push(`ref:${t.ref}`),t.node&&o.push(t.node),this.d.joinPath(k.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:r,path:"/"}),...o)}J(t){if(t.scheme!==S.USER_DATA_SYNC_SCHEME||t.authority!==Ve.c&&t.authority!==Ve.b)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const o=t.authority===Ve.b,c=r.shift(),a=r.shift();let u,b,I;for(;r.length;){const F=r.shift();F.startsWith("collection:")?u=F.substring(11):F.startsWith("ref:")?b=F.substring(4):I=F}return{remote:o,syncResource:c,profile:a,collection:u,ref:b,node:I}}K(t,r){try{const o=JSON.parse(t);if((0,E.isSyncData)(o))return o}catch(o){this.g.error(o)}throw new S.UserDataSyncError((0,i.localize)(0,null),"IncompatibleRemoteContent",r)}async L(t,r,o){const c=await this.e.resolveResourceContent(t,r,o);return{ref:r,content:c}}};n.a="not-existing-resource",n.b="remote-backup",n.c="local-backup",n=pe([Y(0,S.IUserDataSyncStoreService),Y(1,S.IUserDataSyncBackupStoreService),Y(2,S.IUserDataSyncLogService),Y(3,P.IUriIdentityService),Y(4,D.IEnvironmentService),Y(5,R.IStorageService),Y(6,A.IFileService),Y(7,C.IUserDataProfilesService),Y(8,g.IConfigurationService),Y(9,m.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(oe[274],ae([0,1,20,6,24,38,3,2,22,13,31,16,29,4,19,23,18,117,118,119,120,121,122,123,26]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d,m,v,f,n,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const r="sync.lastSyncTime";let o=class extends R.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(I,F,N,$,j,L,M,z,G){super(),this.v=I,this.w=F,this.y=N,this.z=$,this.C=j,this.D=L,this.F=M,this.G=z,this.H=G,this.f="uninitialized",this.g=this.B(new O.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new O.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new O.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new O.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new O.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new O.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=F.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(r,-1,void 0),this.B((0,R.toDisposable)(()=>this.W()))}async createSyncTask(I,F){this.X(),this.z.info("Sync started.");const N=new Date().getTime(),$=(0,C.generateUuid)();try{const z=(0,t.createSyncHeaders)($);F&&(z["Cache-Control"]="no-cache"),I=await this.v.manifest(I,z)}catch(z){const G=t.UserDataSyncError.toUserDataSyncError(z);throw u(G,$,this.w,this.C),G}const j=!1,L=this;let M;return{manifest:I,async run(){if(j)throw new Error("Can run a task only once");M=(0,i.createCancelablePromise)(z=>L.I(I,!1,$,z)),await M.finally(()=>M=void 0),L.z.info(`Sync done. Took ${new Date().getTime()-N}ms`),L.S()},stop(){return M?.cancel(),L.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const I=new Date().getTime(),F=(0,C.generateUuid)(),N=(0,t.createSyncHeaders)(F);let $;try{$=await this.v.manifest(null,N)}catch(M){const z=t.UserDataSyncError.toUserDataSyncError(M);throw u(z,F,this.w,this.C),z}await this.resetLocal();const j=this,L=new D.CancellationTokenSource;return{id:F,async merge(){return j.I($,!0,F,L.token)},async apply(){try{try{await j.L($,F,L.token)}catch(M){if(t.UserDataSyncError.toUserDataSyncError(M).code==="MethodNotFound")j.z.info("Client is making invalid requests. Cleaning up data..."),await j.cleanUpRemoteData(),j.z.info("Applying manual sync again..."),await j.L($,F,L.token);else throw M}}catch(M){throw j.z.error(M),M}j.z.info(`Sync done. Took ${new Date().getTime()-I}ms`),j.S()},async stop(){L.cancel(),await j.N(),await j.resetLocal()}}}async I(I,F,N,$){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const j=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(j,I,F,N,$));const L=j.enabled.find(M=>M.resource==="profiles");if(L){const M=await L.getLastSyncedProfiles()||[];if($.isCancellationRequested)return;await this.J(M,I,F,N,$)}}finally{this.l.fire(this.k)}}async J(I,F,N,$,j){for(const L of I){if(j.isCancellationRequested)return;const M=this.G.profiles.find(G=>G.id===L.id);if(!M){this.z.error(`Profile with id:${L.id} and name: ${L.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",L.name);const z=this.getOrCreateActiveProfileSynchronizer(M,L);this.k.push(...await this.M(z,F,N,$,j))}for(const[L,M]of this.u.entries())this.G.profiles.some(z=>z.id===M[0].profile.id)||(M[1].dispose(),this.u.delete(L))}async L(I,F,N){const $=this.U();for(const G of $){if(N.isCancellationRequested)return;await G.apply(F,N)}const j=$.find(G=>G.profile.isDefault);if(!j)return;const L=j.enabled.find(G=>G.resource==="profiles");if(!L)return;const z=(await L.getRemoteSyncedProfiles(I?.latest??null)||[]).filter(G=>$.every(W=>W.profile.id!==G.id));z.length&&await this.J(z,I,!1,F,N)}async M(I,F,N,$,j){return(await I.sync(F,N,$,j)).map(([M,z])=>({profile:I.profile,syncResource:M,error:z}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(I=>I.stop()))}async resolveContent(I){const F=await this.H.resolveContent(I);if(F)return F;for(const N of this.U())for(const $ of N.enabled){const j=await $.resolveContent(I);if(j)return j}return null}async replace(I){this.X();const F=this.H.resolveUserDataSyncResource(I);if(!F)return;const N=await this.resolveContent(I.uri);!N||await this.O(F.profile,async $=>{if(F.syncResource===$.resource)return await $.replace(N),!0})}async accept(I,F,N,$){this.X(),await this.O(I.profile,async j=>{if(I.syncResource===j.resource)return await j.accept(F,N),$&&await j.apply((0,S.isBoolean)($)?!1:$.force,(0,t.createSyncHeaders)((0,C.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(I,F){return this.H.getRemoteSyncResourceHandles(I,F)}async getLocalSyncResourceHandles(I,F){return this.H.getLocalSyncResourceHandles(I,F??this.G.defaultProfile)}async getAssociatedResources(I){return this.H.getAssociatedResources(I)}async getMachineId(I){return this.H.getMachineId(I)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async F=>{if(F.resource!=="globalState"&&await F.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async F=>{if(await F.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(I){this.z.error(I)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(r,-1);for(const[I]of this.u.values())try{await I.resetLocal()}catch(F){this.z.error(F)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const I=await this.H.getRemoteSyncedProfiles(),F=I.map(L=>L.collection),N=await this.v.getAllCollections(),$=N.filter(L=>!F.includes(L));$.length&&(this.z.info(`Deleting ${$.length} redundant collections on server`),await Promise.allSettled($.map(L=>this.v.deleteCollection(L))),this.z.info("Deleted redundant collections on server"));const j=I.filter(L=>N.includes(L.collection));if(j.length!==I.length){this.z.info("Updating remote profiles with invalid collections on server");const L=this.y.createInstance(s.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await L.updateRemoteProfiles(j,null),this.z.info("Updated remote profiles on server")}finally{L.dispose()}}}async O(I,F){const N=new R.DisposableStore;try{const $=this.u.get(I.id);if($){const G=await this.P($[0],F,N);return(0,S.isUndefined)(G)?null:G}if(I.isDefault){const G=N.add(this.y.createInstance(c,I,void 0)),W=await this.P(G,F,N);return(0,S.isUndefined)(W)?null:W}if(this.G.isEnabled())return null;const j=N.add(this.y.createInstance(s.UserDataProfilesManifestSynchroniser,I,void 0)),L=await this.v.manifest(null),z=(await j.getRemoteSyncedProfiles(L?.latest??null)||[]).find(G=>G.id===I.id);if(z){const G=N.add(this.y.createInstance(c,I,z.collection)),W=await this.P(G,F,N);return(0,S.isUndefined)(W)?null:W}return null}finally{N.dispose()}}async P(I,F,N){const $=[...I.enabled,...I.disabled.map(j=>N.add(I.createSynchronizer(j)))];for(const j of $){const L=await F(j);if(!(0,S.isUndefined)(L))return L}}Q(I){const F=this.f;this.f!==I&&(this.f=I,this.g.fire(I),F==="hasConflicts"&&this.S())}R(){const I=this.U().map(F=>F.conflicts).flat();(0,k.equals)(this.i,I,(F,N)=>F.profile.id===N.profile.id&&F.syncResource===N.syncResource&&(0,k.equals)(F.conflicts,N.conflicts,($,j)=>(0,P.isEqual)($.previewResource,j.previewResource)))||(this.i=I,this.j.fire(I))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(r,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(I,F){let N=this.u.get(I.id);if(N&&N[0].collection!==F?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.u.delete(I.id)),!N){const $=new R.DisposableStore,j=$.add(this.y.createInstance(c,I,F?.collection));$.add(j.onDidChangeStatus(L=>this.Q(L))),$.add(j.onDidChangeConflicts(L=>this.R())),$.add(j.onDidChangeLocal(L=>this.h.fire(L))),this.u.set(I.id,N=[j,$])}return N[0]}U(){const I=[];for(const[F]of this.u.values())I.push(F);return I}W(){this.u.forEach(([,I])=>I.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};o=pe([Y(0,t.IUserDataSyncStoreService),Y(1,t.IUserDataSyncStoreManagementService),Y(2,p.IInstantiationService),Y(3,t.IUserDataSyncLogService),Y(4,g.ITelemetryService),Y(5,h.IStorageService),Y(6,t.IUserDataSyncEnablementService),Y(7,y.IUserDataProfilesService),Y(8,t.IUserDataSyncResourceProviderService)],o),e.UserDataSyncService=o;let c=class extends R.Disposable{get enabled(){return this.f.sort((I,F)=>I[1]-F[1]).map(([I])=>I)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(I=>!this.l.isResourceEnabled(I))}get status(){return this.g}get conflicts(){return this.j}constructor(I,F,N,$,j,L,M,z,G,W){super(),this.profile=I,this.collection=F,this.l=N,this.m=$,this.n=j,this.r=L,this.t=M,this.u=z,this.v=G,this.w=W,this.f=[],this.g="idle",this.h=this.B(new O.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new O.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new O.Emitter),this.onDidChangeConflicts=this.k.event,this.B(N.onDidChangeResourceEnablement(([_,K])=>this.y(_,K))),this.B((0,R.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,_])=>_.dispose())));for(const _ of t.ALL_SYNC_RESOURCES)N.isResourceEnabled(_)&&this.z(_)}y(I,F){F?this.z(I):this.C(I)}z(I){if(this.f.some(([j])=>j.resource===I))return;if(I==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(I==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const F=new R.DisposableStore,N=F.add(this.createSynchronizer(I));F.add(N.onDidChangeStatus(()=>this.G())),F.add(N.onDidChangeConflicts(()=>this.H())),F.add(N.onDidChangeLocal(()=>this.i.fire(I)));const $=this.I(I);this.f.push([N,$,F])}C(I){const F=this.f.findIndex(([N])=>N.resource===I);if(F!==-1){const[[N,,$]]=this.f.splice(F,1);$.dispose(),this.G(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,j=>this.u.error(j))}}createSynchronizer(I){switch(I){case"settings":return this.m.createInstance(v.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(m.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(f.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(d.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(l.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(s.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(I,F,N,$){if($.isCancellationRequested)return[];const j=this.enabled;if(!j.length)return[];try{const L=[],M=(0,t.createSyncHeaders)(N),z=(this.collection?I?.collections?.[this.collection]?.latest:I?.latest)??null,G=F?await this.D(z):{};for(const W of j){if($.isCancellationRequested)return[];if(!this.l.isResourceEnabled(W.resource))return[];try{if(F){const _=await W.preview(z,G,M);if(_)for(const K of _.resourcePreviews)(K.localChange!==0||K.remoteChange!==0)&&K.mergeState==="preview"&&await W.merge(K.previewResource)}else await W.sync(z,M)}catch(_){const K=t.UserDataSyncError.toUserDataSyncError(_);if(u(K,N,this.r,this.t),a(_))throw K;this.u.error(_),this.u.error(`${W.resource}: ${(0,A.toErrorMessage)(_)}`),L.push([W.resource,K])}}return L}finally{this.G()}}async apply(I,F){const N=(0,t.createSyncHeaders)(I);for(const $ of this.enabled){if(F.isCancellationRequested)return;try{await $.apply(!1,N)}catch(j){const L=t.UserDataSyncError.toUserDataSyncError(j);if(u(L,I,this.r,this.t),a(j))throw L;this.u.error(j),this.u.error(`${$.resource}: ${(0,A.toErrorMessage)(j)}`)}}}async stop(){for(const I of this.enabled)try{I.status!=="idle"&&await I.stop()}catch(F){this.u.error(F)}}async resetLocal(){for(const I of this.enabled)try{await I.resetLocal()}catch(F){this.u.error(`${I.resource}: ${(0,A.toErrorMessage)(F)}`),this.u.error(F)}}async D(I){if(!this.profile.isDefault)return{};const F=this.w.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find($=>$ instanceof v.SettingsSynchroniser);if(N){const $=await N.getRemoteUserDataSyncConfiguration(I);return{...F,...$}}return F}F(I){this.g!==I&&(this.g=I,this.h.fire(I))}G(){return this.H(),this.enabled.some(I=>I.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(I=>I.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const I=this.enabled.filter(F=>F.status==="hasConflicts").filter(F=>F.conflicts.conflicts.length>0).map(F=>F.conflicts);(0,k.equals)(this.j,I,(F,N)=>F.syncResource===N.syncResource&&(0,k.equals)(F.conflicts,N.conflicts,($,j)=>(0,P.isEqual)($.previewResource,j.previewResource)))||(this.j=I,this.k.fire(I))}I(I){switch(I){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};c=pe([Y(2,t.IUserDataSyncEnablementService),Y(3,p.IInstantiationService),Y(4,w.IExtensionGalleryService),Y(5,t.IUserDataSyncStoreManagementService),Y(6,g.ITelemetryService),Y(7,t.IUserDataSyncLogService),Y(8,y.IUserDataProfilesService),Y(9,E.IConfigurationService)],c);function a(b){if(b instanceof t.UserDataSyncError)switch(b.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function u(b,I,F,N){N.publicLog2("sync/error",{code:b.code,serverCode:b instanceof t.UserDataSyncStoreError?String(b.serverCode):void 0,url:b instanceof t.UserDataSyncStoreError?b.url:void 0,resource:b.resource,executionId:I,service:F.userDataSyncStore.url.toString()})}}),define(oe[275],ae([0,1,3,2,7,18,26]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(w,p){return{...w,profile:(0,A.reviveProfile)(w.profile,p.profilesHome.scheme)}}function P(w){return{created:w.created,uri:D.URI.revive(w.uri)}}class S{constructor(p,h,g){this.c=p,this.d=h,this.f=g,this.a=new Map,this.b=new k.Emitter}listen(p,h){switch(h){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${h}`)}async call(p,h,g){try{return await this.g(p,h,g)}catch(y){throw this.f.error(y),y}}async g(p,h,g){switch(h){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(g[0]));case"accept":return this.c.accept(R(g[0],this.d),D.URI.revive(g[1]),g[2],g[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(g[0],(0,A.reviveProfile)(g[1],this.d.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(g[0],g[1]);case"replace":return this.c.replace(P(g[0]));case"getAssociatedResources":return this.c.getAssociatedResources(P(g[0]));case"getMachineId":return this.c.getMachineId(P(g[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(h.startsWith("manualSync/")){const y=h.substring(11),l=g[0],d=this.h(l);switch(g=g.slice(1),y){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(p){const h=this.a.get(this.j(p));if(!h)throw new Error(`Manual sync taks not found: ${p}`);return h}async i(){const p=await this.c.createManualSyncTask();return this.a.set(this.j(p.id),p),p.id}j(p){return`manualSyncTask-${p}`}}e.UserDataSyncChannel=S;let C=class extends i.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(p,h){super(),this.k=h,this.b="uninitialized",this.c=this.B(new k.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new k.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new k.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new k.Emitter),this.onSyncErrors=this.j.event,this.a={call(g,y,l){return p.call(g,y,l).then(null,d=>{throw O.UserDataSyncError.toUserDataSyncError(d)})},listen(g,y){return p.listen(g,y)}},this.a.call("_getInitialData").then(([g,y,l])=>{this.l(g),this.m(y),l&&this.n(l),this.B(this.a.listen("onDidChangeStatus")(d=>this.l(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.n(d)))}),this.B(this.a.listen("onDidChangeConflicts")(g=>this.m(g))),this.B(this.a.listen("onSyncErrors")(g=>this.j.fire(g.map(y=>({...y,error:O.UserDataSyncError.toUserDataSyncError(y.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const p=await this.a.call("createManualSyncTask"),h=this;return new E(p,{async call(y,l,d){return h.a.call(`manualSync/${y}`,[p,...Array.isArray(l)?l:[l]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(p,h,g,y){return this.a.call("accept",[p,h,g,y])}resolveContent(p){return this.a.call("resolveContent",[p])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(p,h){return(await this.a.call("getLocalSyncResourceHandles",[p,h])).map(({created:y,uri:l})=>({created:y,uri:D.URI.revive(l)}))}async getRemoteSyncResourceHandles(p,h){return(await this.a.call("getRemoteSyncResourceHandles",[p,h])).map(({created:y,uri:l})=>({created:y,uri:D.URI.revive(l)}))}async getAssociatedResources(p){return(await this.a.call("getAssociatedResources",[p])).map(({resource:g,comparableResource:y})=>({resource:D.URI.revive(g),comparableResource:D.URI.revive(y)}))}getMachineId(p){return this.a.call("getMachineId",[p])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(p){return this.a.call("replace",[p])}async l(p){this.b=p,this.c.fire(p)}async m(p){this.f=p.map(h=>({syncResource:h.syncResource,profile:(0,A.reviveProfile)(h.profile,this.k.profilesHome.scheme),conflicts:h.conflicts.map(g=>({...g,baseResource:D.URI.revive(g.baseResource),localResource:D.URI.revive(g.localResource),remoteResource:D.URI.revive(g.remoteResource),previewResource:D.URI.revive(g.previewResource)}))})),this.g.fire(this.f)}n(p){this.h!==p&&(this.h=p,this.i.fire(p))}};C=pe([Y(1,A.IUserDataProfilesService)],C),e.UserDataSyncChannelClient=C;class E extends i.Disposable{constructor(p,h){super(),this.id=p,this.a=h}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[276],ae([0,1,6,24,9,3,2,138,5,22,13,7,31,16,15,14,25,59,45,19,26]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const f="sync.previous.store",n="sync.donot-make-requests-until",s="sync.user-session-id",t="sync.machine-session-id",r=100,o=1e3*60*5;let c=class extends O.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(v.SYNC_SERVICE_URL_TYPE,-1)}set c(N){this.h.store(v.SYNC_SERVICE_URL_TYPE,N,-1,P.isWeb?0:1)}constructor(N,$,j){super(),this.f=N,this.g=$,this.h=j,this.a=this.B(new A.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(A.Event.filter(j.onDidChangeValue,L=>L.key===v.SYNC_SERVICE_URL_TYPE&&L.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[v.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(v.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(N,$){N=P.isWeb&&N?.web?{...N,...N.web}:N;const j={...N||{},...$||{}};if(j&&(0,C.isString)(j.url)&&(0,C.isObject)(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every(L=>Array.isArray(j.authenticationProviders[L].scopes))){const L=j,M=!!L.canSwitch&&!$?.url,z=L.url===L.insidersUrl?"insiders":"stable",G=(M?this.c:void 0)||z,W=$?.url||(G==="insiders"?L.insidersUrl:G==="stable"?L.stableUrl:L.url);return{url:E.URI.parse(W),type:G,defaultType:z,defaultUrl:E.URI.parse(L.url),stableUrl:E.URI.parse(L.stableUrl),insidersUrl:E.URI.parse(L.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(L.authenticationProviders).reduce((_,K)=>(_.push({id:K,scopes:L.authenticationProviders[K].scopes}),_),[])}}}};c=pe([Y(0,y.IProductService),Y(1,p.IConfigurationService),Y(2,m.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let a=class extends c{constructor(N,$,j){super(N,$,j);const L=this.h.get(f,-1);L&&(this.k=JSON.parse(L));const M=this.f[v.CONFIGURATION_SYNC_STORE_KEY];M?this.h.store(f,JSON.stringify(M),-1,1):this.h.remove(f,-1)}async switch(N){N!==this.c&&(this.c=N,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};a=pe([Y(0,y.IProductService),Y(1,p.IConfigurationService),Y(2,m.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let u=class extends O.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(N,$,j,L,M,z,G){super(),this.k=j,this.l=L,this.n=G,this.g=this.B(new A.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new A.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(N),this.c=(0,d.getServiceMachineId)(M,z,G).then(W=>{const _={"X-Client-Name":`${$.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":$.version};return $.commit&&(_["X-Client-Commit"]=$.commit),_}),this.f=new I(r,o,this.k,this.l),this.r(),this.B((0,O.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(N,$){this.b={token:N,type:$}}p(N){this.a=N?(0,S.joinPath)(N,"v1"):void 0}r(){const N=this.n.getNumber(n,-1);N&&Date.now()<N&&this.t(new Date(N))}t(N){this.i?.getTime()!==N?.getTime()&&(this.i=N,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(n,this.i.getTime(),-1,1),this.s=(0,k.createCancelablePromise)($=>(0,k.timeout)(this.i.getTime()-Date.now(),$).then(()=>this.t(void 0))),this.s.then(null,$=>null)):this.n.remove(n,-1),this.j.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const j=await this.w($,{type:"GET",headers:N},[],i.CancellationToken.None);return(await(0,l.asJson)(j))?.map(({id:L})=>L)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]=R.Mimes.text;const j=await this.w($,{type:"POST",headers:N},[],i.CancellationToken.None),L=await(0,l.asTextOrError)(j);if(!L)throw new v.UserDataSyncStoreError("Server did not return the collection id",$,"NoCollection",j.res.statusCode,j.res.headers[v.HEADER_OPERATION_ID]);return L}async deleteCollection(N,$={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=N?(0,S.joinPath)(this.a,"collection",N).toString():(0,S.joinPath)(this.a,"collection").toString();$={...$},await this.w(j,{type:"DELETE",headers:$},[],i.CancellationToken.None)}async getAllResourceRefs(N,$){if(!this.a)throw new Error("No settings sync store url configured.");const j=this.u(this.a,$,N),L={},M=await this.w(j.toString(),{type:"GET",headers:L},[],i.CancellationToken.None);return(await(0,l.asJson)(M)||[]).map(({url:G,created:W})=>({ref:(0,S.relativePath)(j,j.with({path:G})),created:W*1e3}))}async resolveResourceContent(N,$,j,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,S.joinPath)(this.u(this.a,j,N),$).toString();L={...L},L["Cache-Control"]="no-cache";const z=await this.w(M,{type:"GET",headers:L},[],i.CancellationToken.None);return await(0,l.asTextOrError)(z)}async deleteResource(N,$,j){if(!this.a)throw new Error("No settings sync store url configured.");const L=$!==null?(0,S.joinPath)(this.u(this.a,j,N),$).toString():this.u(this.a,j,N).toString(),M={};await this.w(L,{type:"DELETE",headers:M},[],i.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,S.joinPath)(this.a,"resource").toString(),$={"Content-Type":R.Mimes.text};await this.w(N,{type:"DELETE",headers:$},[],i.CancellationToken.None)}async readResource(N,$,j,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,S.joinPath)(this.u(this.a,j,N),"latest").toString();L={...L},L["Cache-Control"]="no-cache",$&&(L["If-None-Match"]=$.ref);const z=await this.w(M,{type:"GET",headers:L},[304],i.CancellationToken.None);let G=null;if(z.res.statusCode===304&&(G=$),G===null){const W=z.res.headers.etag;if(!W)throw new v.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",z.res.statusCode,z.res.headers[v.HEADER_OPERATION_ID]);const _=await(0,l.asTextOrError)(z);if(!_&&z.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",M,"EmptyResponse",z.res.statusCode,z.res.headers[v.HEADER_OPERATION_ID]);G={ref:W,content:_}}return G}async writeResource(N,$,j,L,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.u(this.a,L,N).toString();M={...M},M["Content-Type"]=R.Mimes.text,j&&(M["If-Match"]=j);const G=await this.w(z,{type:"POST",data:$,headers:M},[],i.CancellationToken.None),W=G.res.headers.etag;if(!W)throw new v.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",G.res.statusCode,G.res.headers[v.HEADER_OPERATION_ID]);return W}async manifest(N,$={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,S.joinPath)(this.a,"manifest").toString();$={...$},$["Content-Type"]="application/json",N&&($["If-None-Match"]=N.ref);const L=await this.w(j,{type:"GET",headers:$},[304],i.CancellationToken.None);let M=null;if(L.res.statusCode===304&&(M=N),!M){const G=L.res.headers.etag;if(!G)throw new v.UserDataSyncStoreError("Server did not return the ref",j,"NoRef",L.res.statusCode,L.res.headers[v.HEADER_OPERATION_ID]);const W=await(0,l.asTextOrError)(L);if(!W&&L.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",j,"EmptyResponse",L.res.statusCode,L.res.headers[v.HEADER_OPERATION_ID]);W&&(M={...JSON.parse(W),ref:G})}const z=this.n.get(s,-1);return z&&M&&z!==M.session&&this.v(),M===null&&z&&this.v(),M&&this.n.store(s,M.session,-1,1),M}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(N,$,j){return $?(0,S.joinPath)(N,"collection",$,"resource",j):(0,S.joinPath)(N,"resource",j)}v(){this.n.remove(s,-1),this.n.remove(t,-1)}async w(N,$,j,L){if(!this.b)throw new v.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const M=await this.c;$.headers={...$.headers||{},...M,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y($.headers),this.l.trace("Sending request to server",{url:N,type:$.type,headers:{...$.headers,authorization:void 0}});let z;try{z=await this.f.request(N,$,L)}catch(q){if(!(q instanceof v.UserDataSyncStoreError)){let V="RequestFailed";const Z=(0,D.getErrorMessage)(q).toLowerCase();Z.includes("xhr timeout")?V="RequestTimeout":Z.includes("protocol")&&Z.includes("not supported")?V="RequestProtocolNotSupported":Z.includes("request path contains unescaped characters")?V="RequestPathNotEscaped":Z.includes("headers must be an object")?V="RequestHeadersNotObject":(0,D.isCancellationError)(q)&&(V="RequestCanceled"),q=new v.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,V,void 0,void 0)}throw this.l.info("Request failed",N),q}const G=z.res.headers[v.HEADER_OPERATION_ID],W={url:N,status:z.res.statusCode,"execution-id":$.headers[v.HEADER_EXECUTION_ID],"operation-id":G},_=(0,l.isSuccess)(z)||z.res.statusCode&&j.indexOf(z.res.statusCode)!==-1;let K="";if(_?this.l.trace("Request succeeded",W):(this.l.info("Request failed",W),K=await(0,l.asText)(z)||""),z.res.statusCode===401)throw this.b=void 0,this.g.fire(),new v.UserDataSyncStoreError(`Request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",z.res.statusCode,G);if(this.h.fire(),z.res.statusCode===404)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",z.res.statusCode,G);if(z.res.statusCode===405)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because the requested endpoint is not found (405). ${K}`,N,"MethodNotFound",z.res.statusCode,G);if(z.res.statusCode===409)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",z.res.statusCode,G);if(z.res.statusCode===410)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",z.res.statusCode,G);if(z.res.statusCode===412)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",z.res.statusCode,G);if(z.res.statusCode===413)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",z.res.statusCode,G);if(z.res.statusCode===426)throw new v.UserDataSyncStoreError(`${$.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",z.res.statusCode,G);if(z.res.statusCode===429){const q=z.res.headers["retry-after"];throw q?(this.t(new Date(Date.now()+parseInt(q)*1e3)),new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",z.res.statusCode,G)):new v.UserDataSyncStoreError(`${$.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",z.res.statusCode,G)}if(!_)throw new v.UserDataSyncStoreError("Server returned "+z.res.statusCode,N,"Unknown",z.res.statusCode,G);return z}y(N){let $=this.n.get(t,-1);$===void 0&&($=(0,w.generateUuid)(),this.n.store(t,$,-1,1)),N["X-Machine-Session-Id"]=$;const j=this.n.get(s,-1);j!==void 0&&(N["X-User-Session-Id"]=j)}};u=pe([Y(1,y.IProductService),Y(2,l.IRequestService),Y(3,v.IUserDataSyncLogService),Y(4,h.IEnvironmentService),Y(5,g.IFileService),Y(6,m.IStorageService)],u),e.UserDataSyncStoreClient=u;let b=class extends u{constructor(N,$,j,L,M,z,G){super(N.userDataSyncStore?.url,$,j,L,M,z,G),this.B(N.onDidChangeUserDataSyncStore(()=>this.p(N.userDataSyncStore?.url)))}};b=pe([Y(0,v.IUserDataSyncStoreManagementService),Y(1,y.IProductService),Y(2,l.IRequestService),Y(3,v.IUserDataSyncLogService),Y(4,h.IEnvironmentService),Y(5,g.IFileService),Y(6,m.IStorageService)],b),e.UserDataSyncStoreService=b;class I{constructor(N,$,j,L){this.c=N,this.d=$,this.f=j,this.g=L,this.a=[],this.b=void 0}request(N,$,j){if(this.h()&&this.i(),$.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new v.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request($,j)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=I}),define(oe[277],ae([0,1,3,57,25,19,23,272,26,78,81]),function(ee,e,k,i,D,A,O,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends R.UserDataAutoSyncService{constructor(p,h,g,y,l,d,m,v,f,n,s){super(p,h,g,y,l,m,v,f,n,s),this.B(k.Event.debounce(k.Event.any(k.Event.map(d.onDidFocusWindow,()=>"windowFocus"),k.Event.map(d.onDidOpenWindow,()=>"windowOpen")),(t,r)=>t?[...t,r]:[r],1e3)(t=>this.triggerSync(t,!0,!1)))}};E=pe([Y(0,D.IProductService),Y(1,P.IUserDataSyncStoreManagementService),Y(2,P.IUserDataSyncStoreService),Y(3,P.IUserDataSyncEnablementService),Y(4,P.IUserDataSyncService),Y(5,i.INativeHostService),Y(6,P.IUserDataSyncLogService),Y(7,S.IUserDataSyncAccountService),Y(8,O.ITelemetryService),Y(9,C.IUserDataSyncMachinesService),Y(10,A.IStorageService)],E),e.UserDataAutoSyncService=E}),define(oe[278],ae([0,1,99,21,5,22]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function O(S){function C(){let E=S.scheme===i.Schemas.file?(0,A.originalFSPath)(S):S.toString();return D.isLinux||(E=E.toLowerCase()),(0,k.createHash)("md5").update(E).digest("hex")}return{id:C(),configPath:S}}e.getWorkspaceIdentifier=O;function R(S,C){function E(){if(S.scheme!==i.Schemas.file)return(0,k.createHash)("md5").update(S.toString()).digest("hex");if(!C)return;let p;return D.isLinux?p=C.ino:D.isMacintosh?p=C.birthtime.getTime():D.isWindows&&(typeof C.birthtimeMs=="number"?p=Math.floor(C.birthtimeMs):p=C.birthtime.getTime()),(0,k.createHash)("md5").update(S.fsPath).update(p?String(p):"").digest("hex")}const w=E();if(typeof w=="string")return{id:w,uri:S}}e.getSingleFolderWorkspaceIdentifier=R;function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=P}),define(oe[279],ae([0,1,6,9,2,12,28,15,56,8,57,76,115,278]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let h=class extends D.Disposable{constructor(y,l,d,m){super(),this.a=y,this.b=l,this.c=d,this.f=m,this.B(new k.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const y=await O.Promises.readdir(this.a.workspaceStorageHome.fsPath),l=new E.StorageClient(this.f.getChannel("storage"));await Promise.all(y.map(async d=>{const m=(0,A.join)(this.a.workspaceStorageHome.fsPath,d);d.length===p.NON_EMPTY_WORKSPACE_ID_LENGTH||d===w.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(n=>n.workspace?.id===d)||await l.isUsed(m)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await O.Promises.rm(m))}))}catch(y){(0,i.onUnexpectedError)(y)}}};h=pe([Y(0,R.INativeEnvironmentService),Y(1,S.ILogService),Y(2,C.INativeHostService),Y(3,P.IMainProcessService)],h),e.UnusedWorkspaceStorageDataCleaner=h}),define(oe[124],ae([0,1,52,6,12,13,28,150,288,289]),function(ee,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class C extends Error{constructor(n,s){let t=s.message;switch(n){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=n,this.cause=s}}e.ExtractError=C;function E(f){const n=f.externalFileAttributes>>16||33188;return[448,56,7].map(s=>n&s).reduce((s,t)=>s+t,n&61440)}function w(f){if(f instanceof C)return f;let n;return/end of central directory record signature not found/.test(f.message)&&(n="CorruptZip"),new C(n,f)}function p(f,n,s,t,r,o){const c=D.dirname(n),a=D.join(t,c);if(!a.startsWith(t))return Promise.reject(new Error(R.localize(0,null,n)));const u=D.join(t,n);let b;return o.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(O.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((I,F)=>{if(!o.isCancellationRequested)try{b=(0,k.createWriteStream)(u,{mode:s}),b.once("close",()=>I()),b.once("error",F),f.once("error",F),f.pipe(b)}catch(N){F(N)}}))}function h(f,n,s,t){let r=(0,i.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{r.cancel(),f.close()}),new Promise((c,a)=>{const u=new i.Sequencer,b=I=>{I.isCancellationRequested||(o++,f.readEntry())};f.once("error",a),f.once("close",()=>r.then(()=>{t.isCancellationRequested||f.entryCount===o?c():a(new C("Incomplete",new Error(R.localize(1,null,o,f.entryCount))))},a)),f.readEntry(),f.on("entry",I=>{if(t.isCancellationRequested)return;if(!s.sourcePathRegex.test(I.fileName)){b(t);return}const F=I.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(F)){const j=D.join(n,F);r=(0,i.createCancelablePromise)(L=>O.Promises.mkdir(j,{recursive:!0}).then(()=>b(L)).then(void 0,a));return}const N=y(f,I),$=E(I);r=(0,i.createCancelablePromise)(j=>u.queue(()=>N.then(L=>p(L,F,$,n,s,j).then(()=>b(j)))).then(null,a))})})}function g(f,n=!1){return new Promise((s,t)=>{(0,P.open)(f,n?{lazyEntries:!0}:void 0,(r,o)=>{r?t(w(r)):s((0,A.assertIsDefined)(o))})})}function y(f,n){return new Promise((s,t)=>{f.openReadStream(n,(r,o)=>{r?t(w(r)):s((0,A.assertIsDefined)(o))})})}function l(f,n){return new Promise((s,t)=>{const r=new S.ZipFile;n.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const o=(0,k.createWriteStream)(f);r.outputStream.pipe(o),r.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>s(f))})}e.zip=l;function d(f,n,s={},t){const r=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let o=g(f,!0);return s.overwrite&&(o=o.then(c=>O.Promises.rm(n).then(()=>c))),o.then(c=>h(c,n,{sourcePathRegex:r},t))}e.extract=d;function m(f,n){return g(f).then(s=>new Promise((t,r)=>{s.on("entry",o=>{o.fileName===n&&y(s,o).then(c=>t(c),c=>r(c))}),s.once("close",()=>r(new Error(R.localize(2,null,n))))}))}function v(f,n){return m(f,n).then(s=>new Promise((t,r)=>{const o=[];s.once("error",r),s.on("data",c=>o.push(c)),s.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=v}),define(oe[280],ae([0,1,124,160]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(A){return(0,k.buffer)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=D}),define(oe[125],ae([0,1,6,24,38,9,3,2,37,21,12,5,22,53,13,7,31,28,124,159,96,15,262,29,33,61,79,218,263,280,219,220,42,70,14,4,8,25,23,30,18]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d,m,v,f,n,s,t,r,o,c,a,u,b,I,F,N,$,j,L,M,z,G,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,j.refineServiceDecorator)(s.IExtensionManagementService);let _=class extends n.AbstractExtensionManagementService{constructor(T,U,H,B,Q,re,X,te,se,le,ue,ye){super(T,U,H,le,ye),this.Y=Q,this.Z=re,this.ab=X,this.bb=se,this.cb=ue,this.X=new Map,this.kb=new P.ResourceSet;const Se=this.B(te.createInstance(a.ExtensionsLifecycle));this.S=this.B(te.createInstance(K,Ee=>Se.postUninstall(Ee))),this.U=this.B(new b.ExtensionsManifestCache(B,this)),this.W=this.B(te.createInstance(c.ExtensionsDownloader,this.getTargetPlatform()));const be=this.B(new I.ExtensionsWatcher(this,this.Y,ye,re,ue,se,H));this.B(be.onDidChangeExtensionsByAnotherSource(Ee=>this.jb(Ee))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,t.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(T){this.v.trace("ExtensionManagementService#zip",T.identifier.id);const U=await this.ib(T),H=await(0,d.zip)((0,w.joinPath)(this.W.extensionsDownloadDir,(0,y.generateUuid)()).fsPath,U);return g.URI.file(H)}async unzip(T){return this.v.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const{location:U,cleanup:H}=await this.eb(T),B=C.resolve(U.fsPath);try{return await(0,u.getManifest)(B)}finally{await H()}}getInstalled(T,U){return this.S.scanExtensions(T??null,U)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(T,U={}){this.v.trace("ExtensionManagementService#install",T.toString());const{location:H,cleanup:B}=await this.eb(T);try{const Q=await(0,u.getManifest)(C.resolve(H.fsPath));if(Q.engines&&Q.engines.vscode&&!(0,N.isEngineValid)(Q.engines.vscode,this.w.version,this.w.date))throw new Error(m.localize(0,null,(0,t.getGalleryExtensionId)(Q.publisher,Q.name),this.w.version));return await this.z(Q,H,U)}finally{await B()}}async installFromLocation(T,U){this.v.trace("ExtensionManagementService#installFromLocation",T.toString());const H=await this.S.scanUserExtensionAtLocation(T);if(!H)throw new Error(`Cannot find a valid extension from the location ${T.toString()}`);return await this.nb([H],U),this.v.info("Successfully installed extension",H.identifier.id,U.toString()),H}getMetadata(T){return this.Y.scanMetadata(T.location)}async updateMetadata(T,U){this.v.trace("ExtensionManagementService#updateMetadata",T.identifier.id);const H={...U};return U.isPreReleaseVersion&&(H.preRelease=!0),T=await this.S.updateMetadata(T,H),this.U.invalidate(),T}async updateExtensionScope(T,U){return this.v.trace("ExtensionManagementService#updateExtensionScope",T.identifier.id),T=await this.S.updateMetadata(T,{isMachineScoped:U}),this.U.invalidate(),T}async reinstallFromGallery(T){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",T.identifier.id),!this.t.isEnabled())throw new Error(m.localize(1,null));const U=await this.getTargetPlatform(),[H]=await this.t.getExtensions([{...T.identifier,preRelease:T.preRelease}],{targetPlatform:U,compatible:!0},i.CancellationToken.None);if(!H)throw new Error(m.localize(2,null));await this.S.setUninstalled(T);try{await this.S.removeUninstalledExtension(T)}catch(B){throw new Error(m.localize(3,null,(0,D.toErrorMessage)(B)))}await this.installFromGallery(H)}markAsUninstalled(...T){return this.S.setUninstalled(...T)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(T,U){const{location:H}=await this.W.download(T,U);return H}async eb(T){if(T.scheme===S.Schemas.file)return{location:T,async cleanup(){}};this.v.trace("Downloading extension from",T.toString());const U=(0,w.joinPath)(this.W.extensionsDownloadDir,(0,y.generateUuid)());return await this.ab.download(T,U),this.v.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.bb.del(U)}catch(B){this.v.error(B)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(T,U,H){let B;if(g.URI.isUri(U))B=new Z(T,U,H,this.t,this.S,this.v);else{const Q=t.ExtensionKey.create(U).toString();B=this.X.get(Q),B||(this.X.set(Q,B=new V(T,U,H,this.W,this.S,this.v)),B.waitUntilTaskIsFinished().then(()=>this.X.delete(Q)))}return new ne(B,H.profileLocation,this.Z)}R(T,U){return new J(T,U.profileLocation,this.Z)}async ib(T){const U=async B=>{let Q=await l.Promises.readdir(B);Q=Q.map(te=>C.join(B,te));const re=await Promise.all(Q.map(te=>l.Promises.stat(te)));let X=Promise.resolve([]);return re.forEach((te,se)=>{const le=Q[se];te.isFile()&&(X=X.then(ue=>[...ue,le])),te.isDirectory()&&(X=X.then(ue=>U(le).then(ye=>[...ue,...ye])))}),X};return(await U(T.location.fsPath)).map(B=>({path:`extension/${C.relative(T.location.fsPath,B)}`,localPath:B}))}async jb({added:T,removed:U}){if(U)for(const H of U.extensions)this.v.info("Extensions removed from another source",H.id,U.profileLocation.toString()),this.p.fire({identifier:H,profileLocation:U.profileLocation});if(T){const B=(await this.S.scanExtensions(1,T.profileLocation)).filter(Q=>T.extensions.some(re=>(0,t.areSameExtensions)(re,Q.identifier)));this.m.fire(B.map(Q=>(this.v.info("Extensions added from another source",Q.identifier.id,T.profileLocation.toString()),{identifier:Q.identifier,local:Q,profileLocation:T.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(U=>this.kb.add(U)));const T=await this.bb.resolve(this.Y.userExtensionsLocation);for(const U of T.children??[])U.isDirectory&&this.kb.add(U.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(U=>this.mb(U)))}async mb(T){const U=[];for(const H of T.rawAdded){if(this.kb.has(H)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(H),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(H,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(H).startsWith(".")||!(await this.bb.stat(H)).isDirectory)continue;const B=await this.S.scanUserExtensionAtLocation(H);B&&B.installedTimestamp===void 0&&(this.kb.add(H),U.push(B))}U.length&&(await this.nb(U,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",U.map(H=>H.identifier.id)))}async nb(T,U){await this.Z.addExtensionsToProfile(T.map(H=>[H,void 0]),U),this.m.fire(T.map(H=>({local:H,identifier:H.identifier,operation:1,profileLocation:U})))}};_=pe([Y(0,s.IExtensionGalleryService),Y(1,z.ITelemetryService),Y(2,L.ILogService),Y(3,f.INativeEnvironmentService),Y(4,o.IExtensionsScannerService),Y(5,r.IExtensionsProfileScannerService),Y(6,v.IDownloadService),Y(7,j.IInstantiationService),Y(8,$.IFileService),Y(9,M.IProductService),Y(10,G.IUriIdentityService),Y(11,W.IUserDataProfilesService)],_),e.ExtensionManagementService=_;let K=class extends R.Disposable{constructor(T,U,H,B){super(),this.j=T,this.k=U,this.l=H,this.m=B,this.h=this.B(new O.Emitter),this.onExtract=this.h.event,this.c=(0,w.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new k.Queue}async cleanUp(){await this.v()}async scanExtensions(T,U){await this.l.initializeDefaultProfileExtensions();const H={includeInvalid:!0,profileLocation:U};let B=[];return T===null||T===0?B.push(...await this.l.scanAllExtensions({includeInvalid:!0},H,!1)):T===1&&B.push(...await this.l.scanUserExtensions(H)),B=T!==null?B.filter(Q=>Q.type===T):B,Promise.all(B.map(Q=>this.u(Q)))}async scanAllUserExtensions(T){const U=await this.l.scanUserExtensions({includeAllVersions:!T,includeInvalid:!0});return Promise.all(U.map(H=>this.u(H)))}async scanUserExtensionAtLocation(T){try{const U=await this.l.scanExistingExtension(T,1,{includeInvalid:!0});if(U)return await this.u(U)}catch(U){this.m.error(U)}return null}async extractUserExtension(T,U,H,B){await this.l.initializeDefaultProfileExtensions();const Q=T.toString(),re=C.join(this.l.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),X=C.join(this.l.userExtensionsLocation.fsPath,Q);try{await l.Promises.rm(X)}catch{throw new s.ExtensionManagementError(m.localize(4,null,X,T.id),s.ExtensionManagementErrorCode.Delete)}await this.p(T,U,re,B),await this.l.updateMetadata(g.URI.file(re),H);try{this.h.fire(g.URI.file(X)),await this.s(T,re,X,Date.now()+2*60*1e3),this.m.info("Renamed to",X)}catch(te){try{await l.Promises.rm(re)}catch{}if(te.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",T.id);else throw this.m.info(`Rename failed because of ${(0,A.getErrorMessage)(te)}. Deleted from extracted location`,re),te}return this.t(g.URI.file(X),1)}async updateMetadata(T,U){return await this.l.updateMetadata(T.location,U),this.t(T.location,T.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...T){const U=T.map(H=>t.ExtensionKey.create(H));await this.n(H=>U.forEach(B=>{H[B.toString()]=!0,this.m.info("Marked extension as uninstalled",B.toString())}))}async setInstalled(T){await this.n(B=>delete B[T.toString()]);const H=(await this.scanAllUserExtensions(!0)).find(B=>t.ExtensionKey.create(B).equals(T))||null;return H?this.updateMetadata(H,{installedTimestamp:Date.now()}):null}async removeExtension(T,U){this.m.trace(`Deleting ${U} extension from disk`,T.identifier.id,T.location.fsPath),await l.Promises.rm(T.location.fsPath),this.m.info("Deleted from disk",T.identifier.id,T.location.fsPath)}async removeUninstalledExtension(T){await this.removeExtension(T,"uninstalled"),await this.n(U=>delete U[t.ExtensionKey.create(T).toString()])}async n(T){return this.g.queue(async()=>{let U;try{U=await l.Promises.readFile(this.c,"utf8")}catch(B){if(B.code!=="ENOENT")throw B}let H={};if(U)try{H=JSON.parse(U)}catch{}return T&&(T(H),Object.keys(H).length?await l.Promises.writeFile(this.c,JSON.stringify(H)):await l.Promises.rm(this.c)),H})}async p(T,U,H,B){this.m.trace(`Started extracting the extension from ${U} to ${H}`);try{await l.Promises.rm(H)}catch(Q){throw new s.ExtensionManagementError(this.w(Q).message,s.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(U,H,{sourcePath:"extension",overwrite:!0},B),this.m.info(`Extracted extension to ${H}:`,T.id)}catch(Q){try{await l.Promises.rm(H)}catch{}let re=s.ExtensionManagementErrorCode.Extract;throw Q instanceof d.ExtractError&&(Q.type==="CorruptZip"?re=s.ExtensionManagementErrorCode.CorruptZip:Q.type==="Incomplete"&&(re=s.ExtensionManagementErrorCode.IncompleteZip)),new s.ExtensionManagementError(Q.message,re)}}async s(T,U,H,B){try{await l.Promises.rename(U,H)}catch(Q){if(E.isWindows&&Q&&Q.code==="EPERM"&&Date.now()<B)return this.m.info(`Failed renaming ${U} to ${H} with 'EPERM' error. Trying again...`,T.id),this.s(T,U,H,B);throw new s.ExtensionManagementError(Q.message||m.localize(5,null,U,H),Q.code||s.ExtensionManagementErrorCode.Rename)}}async t(T,U){const H=await this.l.scanExistingExtension(T,U,{includeInvalid:!0});if(H)return this.u(H);throw new Error(m.localize(6,null,T.path))}async u(T){const U=await this.k.resolve(T.location);let H,B;return U.children&&(H=U.children.find(({name:Q})=>/^readme(\.txt|\.md|)$/i.test(Q))?.resource,B=U.children.find(({name:Q})=>/^changelog(\.txt|\.md|)$/i.test(Q))?.resource),{identifier:T.identifier,type:T.type,isBuiltin:T.isBuiltin||!!T.metadata?.isBuiltin,location:T.location,manifest:T.manifest,targetPlatform:T.targetPlatform,validations:T.validations,isValid:T.isValid,readmeUrl:H,changelogUrl:B,publisherDisplayName:T.metadata?.publisherDisplayName||null,publisherId:T.metadata?.publisherId||null,isApplicationScoped:!!T.metadata?.isApplicationScoped,isMachineScoped:!!T.metadata?.isMachineScoped,isPreReleaseVersion:!!T.metadata?.isPreReleaseVersion,preRelease:!!T.metadata?.preRelease,installedTimestamp:T.metadata?.installedTimestamp,updated:!!T.metadata?.updated}}async v(){const T=await this.getUninstalledExtensions(),U=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),H=new Set;for(const re of U)T[t.ExtensionKey.create(re).toString()]||H.add(re.identifier.id.toLowerCase());const B=(0,t.groupByExtension)(U,re=>re.identifier);await k.Promises.settled(B.map(async re=>{const X=re.sort((te,se)=>p.rcompare(te.manifest.version,se.manifest.version))[0];H.has(X.identifier.id.toLowerCase())||await this.j(await this.u(X))}));const Q=U.filter(re=>re.metadata&&T[t.ExtensionKey.create(re).toString()]);await k.Promises.settled(Q.map(re=>this.removeUninstalledExtension(re)))}w(T){const U=Array.isArray(T)?T:[T];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((H,B)=>new Error(`${H.message}${H.message?",":""}${B instanceof Error?B.message:B}`),new Error(""))}};K=pe([Y(1,$.IFileService),Y(2,o.IExtensionsScannerService),Y(3,L.ILogService)],K),e.ExtensionsScanner=K;class q extends n.AbstractExtensionTask{get operation(){return(0,h.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(T,U,H,B,Q){super(),this.identifier=T,this.source=U,this.k=H,this.l=B,this.m=Q,this.wasVerified=!1,this.j=2}async n(T,U){try{const H=await this.o(T.key);if(H)return this.l.updateMetadata(H,T.metadata)}catch{throw E.isMacintosh?new s.ExtensionManagementError(m.localize(7,null),s.ExtensionManagementErrorCode.Internal):new s.ExtensionManagementError(m.localize(8,null),s.ExtensionManagementErrorCode.Internal)}return this.q(T,U)}async o(T){if(!await this.p(T))return null;this.m.trace("Removing the extension from uninstalled list:",T.id);const H=await this.l.setInstalled(T);return this.m.info("Removed the extension from uninstalled list:",T.id),H}async p(T){return!!(await this.l.getUninstalledExtensions())[T.toString()]}async q({zipPath:T,key:U,metadata:H},B){const Q=await this.l.extractUserExtension(U,T,H,B);return this.m.info("Extracting completed.",U.id),Q}}class V extends q{constructor(T,U,H,B,Q,re){super(U.identifier,U,H,Q,re),this.s=T,this.t=U,this.u=B}async h(T){const H=(await this.l.scanExtensions(null,void 0)).find(X=>(0,t.areSameExtensions)(X.identifier,this.t.identifier));H&&(this.j=3);const B={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,F.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||H?.isMachineScoped,isBuiltin:this.k.isBuiltin||H?.isBuiltin,isSystem:H?.type===0?!0:void 0,updated:!!H,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,h.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:H?.preRelease)};if(H?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(H,B),metadata:B};const{location:Q,verified:re}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!re,this.w(Q.fsPath),{local:await this.n({zipPath:Q.fsPath,key:t.ExtensionKey.create(this.t),metadata:B},T),metadata:B}}catch(X){try{await this.u.delete(Q)}catch(te){this.m.warn("Error while deleting the downloaded file",Q.toString(),(0,A.getErrorMessage)(te))}throw X}}async w(T){try{await(0,u.getManifest)(T)}catch(U){throw new s.ExtensionManagementError((0,n.joinErrors)(U).message,s.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=V;class Z extends q{constructor(T,U,H,B,Q,re){super({id:(0,t.getGalleryExtensionId)(T.publisher,T.name)},U,H,Q,re),this.s=T,this.t=U,this.u=B}async h(T){const U=new t.ExtensionKey(this.identifier,this.s.version),B=(await this.l.scanExtensions(1,void 0)).find(X=>(0,t.areSameExtensions)(this.identifier,X.identifier)),Q=await this.w(this.identifier.id,this.s.version,T);if(Q.isApplicationScoped=(0,F.isApplicationScopedExtension)(this.s),Q.isMachineScoped=this.k.isMachineScoped||B?.isMachineScoped,Q.isBuiltin=this.k.isBuiltin||B?.isBuiltin,Q.installedTimestamp=Date.now(),B)if(this.j=3,U.equals(new t.ExtensionKey(B.identifier,B.manifest.version)))try{await this.l.removeExtension(B,"existing")}catch{throw new Error(m.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&p.gt(B.manifest.version,this.s.version)&&await this.l.setUninstalled(B);else{const X=await this.o(U);if(X)try{await this.l.removeExtension(X,"existing")}catch{throw new Error(m.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:C.resolve(this.t.fsPath),key:U,metadata:Q},T),metadata:Q}}async w(T,U,H){try{let[B]=await this.u.getExtensions([{id:T,version:U}],H);if(B||([B]=await this.u.getExtensions([{id:T}],H)),B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class ne{constructor(T,U,H){this.d=T,this.g=U,this.h=H,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const T=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[T.local,T.metadata]],this.g),T}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class J extends n.AbstractExtensionTask{constructor(T,U,H){super(),this.extension=T,this.j=U,this.k=H}async h(T){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[281],ae([0,1,2,29,80,217,125,8,19]),function(ee,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=class extends k.Disposable{constructor(E,w,p,h,g,y){super(),E.removeUninstalledExtensions(),(0,A.migrateUnsupportedExtensions)(E,w,p,h,y),D.ExtensionStorageService.removeOutdatedExtensionVersions(E,g)}};S=pe([Y(0,O.INativeServerExtensionManagementService),Y(1,i.IExtensionGalleryService),Y(2,D.IExtensionStorageService),Y(3,i.IGlobalExtensionEnablementService),Y(4,P.IStorageService),Y(5,R.ILogService)],S),e.ExtensionsContributions=S}),define(oe[290],ae([0,1,93,34,38,9,2,21,22,7,39,148,209,210,202,203,279,191,194,16,215,95,234,96,226,15,231,116,265,29,97,193,266,125,98,189,14,205,207,54,4,200,72,201,56,73,221,8,102,57,103,25,59,19,267,108,23,109,110,111,50,239,112,241,247,80,114,26,78,270,258,259,81,271,274,275,276,277,269,62,260,107,233,77,249,223,248,106,230,30,250,5,251,195,213,212,79,264,18,61,208,58,268,228,238,261,235,105,101,273,281]),function(ee,e,k,i,D,A,O,R,P,S,C,E,w,p,h,g,y,l,d,m,v,f,n,s,t,r,o,c,a,u,b,I,F,N,$,j,L,M,z,G,W,_,K,q,V,Z,ne,J,x,T,U,H,B,Q,re,X,te,se,le,ue,ye,Se,be,Ee,Ne,Fe,Ye,ze,ce,de,ge,Ce,Pe,Ae,De,je,Oe,Me,Be,ke,Te,ie,he,fe,me,we,Ie,Re,He,$e,Le,qe,Ge,et,ot,wt,At,Lt,vt,St,Ot,bt,Tt,Nt,Ut,Mt,Ft,Et,Ct,jt,$t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class zt extends O.Disposable{constructor(ve){super(),this.f=ve,this.a=this.B(new E.Server),this.b=void 0,this.c=void 0,this.g()}g(){const ve=async()=>{this.c&&(await this.c.fireOnWillShutdown(),this.c.dispose(),this.c=void 0),this.dispose()};process.once("exit",ve),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Ue="vscode:electron-main->shared-process=disposeWorker",We=(Je,tt)=>{this.h(tt)};k.ipcRenderer.on(Ue,We),this.B((0,O.toDisposable)(()=>k.ipcRenderer.removeListener(Ue,We)))}h(ve){this.b?.disposeWorker(ve)}async open(){const ve=await this.i();(0,ze.registerConfiguration)(),ve.invokeFunction(Ue=>{const We=Ue.get(J.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ue),this.k(We)}),this.B((0,O.combinedDisposable)(ve.createInstance(w.CodeCacheCleaner,this.f.codeCachePath),ve.createInstance(p.LanguagePackCachedDataCleaner),ve.createInstance(y.UnusedWorkspaceStorageDataCleaner),ve.createInstance(g.LogsDataCleaner),ve.createInstance(h.LocalizationsUpdater),ve.createInstance($t.ExtensionsContributions),ve.createInstance(Mt.UserDataProfilesCleaner)))}async i(){const ve=new K.ServiceCollection,Ue={_serviceBrand:void 0,...U.default};ve.set(H.IProductService,Ue);const We=new C.StaticRouter(Qe=>Qe==="main"),Je=new q.MessagePortMainProcessService(this.a,We);ve.set(V.IMainProcessService,Je);const tt=this.f.policiesData?new Ot.PolicyChannelClient(this.f.policiesData,Je.getChannel("policy")):new bt.NullPolicyService;ve.set(bt.IPolicyService,tt);const Ke=new o.SharedProcessEnvironmentService(this.f.args,Ue);ve.set(r.INativeEnvironmentService,Ke);const lt=new x.LogLevelChannelClient(this.a.getChannel("logLevel",We)),it=new x.LoggerChannelClient(this.f.logLevel,lt.onDidChangeLogLevel,Je.getChannel("logger"));ve.set(J.ILoggerService,it);const ht=this.B(new J.MultiplexLogService([this.B(new J.ConsoleLogger(this.f.logLevel)),this.B(it.createLogger((0,P.joinPath)(S.URI.file(Ke.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),xe=this.B(new x.FollowerLogService(lt,ht));ve.set(J.ILogService,xe),this.c=new Ct.SharedProcessLifecycleService(xe),ve.set(Ct.ISharedProcessLifecycleService,this.c),this.b=new He.SharedProcessWorkerService(xe),ve.set(Re.ISharedProcessWorkerService,this.b);const _e=this.B(new M.FileService(xe));ve.set(L.IFileService,_e);const ft=this.B(new z.DiskFileSystemProvider(xe));_e.registerProvider(R.Schemas.file,ft);const dt=this.B(new Ge.FileUserDataProvider(R.Schemas.file,this.B(new et.DiskFileSystemProviderClient(Je.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),R.Schemas.vscodeUserData,xe));_e.registerProvider(R.Schemas.vscodeUserData,dt);const nt=this.B(new Tt.UserDataProfilesNativeService(this.f.profiles,Je,Ke));ve.set(vt.IUserDataProfilesService,nt);const Xe=this.B(new v.ConfigurationService(nt.defaultProfile.settingsResource,_e,tt,xe));ve.set(m.IConfigurationService,Xe);const at=new re.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Je,Ke);ve.set(Q.IStorageService,at),this.B((0,O.toDisposable)(()=>at.flush())),await Promise.all([Xe.initialize(),at.initialize()]),ve.set($e.IUriIdentityService,new Le.UriIdentityService(_e)),ve.set(B.IRequestService,new Nt.SharedProcessRequestService(Je,Xe,Ue,xe)),ve.set(l.IChecksumService,new G.SyncDescriptor(d.ChecksumService,void 0,!1)),ve.set(wt.IV8InspectProfilingService,new G.SyncDescriptor(ot.InspectProfilingService,void 0,!1));const ut=C.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.f.windowId});ve.set(T.INativeHostService,ut),ve.set(s.IDownloadService,new G.SyncDescriptor(t.DownloadService,void 0,!0));const gt=this.B(new Te.ActiveWindowManager(ut)),mt=new C.StaticRouter(Qe=>gt.getActiveClientId().then(pt=>Qe===pt));ve.set($.IExtensionRecommendationNotificationService,new j.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",mt)));let st;const ct=[],Pt=(0,ye.isInternalTelemetry)(Ue,Xe);if((0,ye.supportsTelemetry)(Ue,Ke)){const Qe=new le.TelemetryLogAppender(it,Ke);ct.push(Qe);const{installSourcePath:pt}=Ke;if(Ue.aiConfig?.ariaKey){const Dt=new Ut.OneDataSystemAppender(Pt,"monacoworkbench",null,Ue.aiConfig.ariaKey);this.B((0,O.toDisposable)(()=>Dt.flush())),ct.push(Dt)}st=new ue.TelemetryService({appenders:ct,commonProperties:(0,X.resolveCommonProperties)(_e,(0,i.release)(),(0,i.hostname)(),process.arch,Ue.commit,Ue.version,this.f.machineId,Pt,pt),sendErrorTelemetry:!0,piiPaths:(0,ye.getPiiPathsFromEnvironment)(Ke)},Xe,Ue)}else{st=ye.NullTelemetryService;const Qe=ye.NullAppender;ct.push(Qe)}this.a.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(ct)),ve.set(te.ITelemetryService,st);const qt=new Se.CustomEndpointTelemetryService(Xe,st,it,Ke,Ue);ve.set(te.ICustomEndpointTelemetryService,qt),ve.set(St.IExtensionsProfileScannerService,new G.SyncDescriptor(St.ExtensionsProfileScannerService,void 0,!0)),ve.set(At.IExtensionsScannerService,new G.SyncDescriptor(Lt.ExtensionsScannerService,void 0,!0)),ve.set(b.IExtensionSignatureVerificationService,new G.SyncDescriptor(b.ExtensionSignatureVerificationService,void 0,!0)),ve.set(N.INativeServerExtensionManagementService,new G.SyncDescriptor(N.ExtensionManagementService,void 0,!0)),ve.set(u.IExtensionGalleryService,new G.SyncDescriptor(a.ExtensionGalleryService,void 0,!0)),ve.set(u.IExtensionTipsService,new G.SyncDescriptor(F.ExtensionTipsService,void 0,!1)),ve.set(Z.ILanguagePackService,new G.SyncDescriptor(ne.NativeLanguagePackService,void 0,!1)),ve.set(f.IDiagnosticsService,new G.SyncDescriptor(n.DiagnosticsService,void 0,!1)),ve.set(ce.IUserDataSyncAccountService,new G.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),ve.set(ze.IUserDataSyncLogService,new G.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),ve.set(ze.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),ve.set(u.IGlobalExtensionEnablementService,new G.SyncDescriptor(c.GlobalExtensionEnablementService,void 0,!1)),ve.set(Ye.IIgnoredExtensionsManagementService,new G.SyncDescriptor(Ye.IgnoredExtensionsManagementService,void 0,!0)),ve.set(Fe.IExtensionStorageService,new G.SyncDescriptor(Fe.ExtensionStorageService)),ve.set(ze.IUserDataSyncStoreManagementService,new G.SyncDescriptor(Oe.UserDataSyncStoreManagementService,void 0,!0)),ve.set(ze.IUserDataSyncStoreService,new G.SyncDescriptor(Oe.UserDataSyncStoreService,void 0,!0)),ve.set(Pe.IUserDataSyncMachinesService,new G.SyncDescriptor(Pe.UserDataSyncMachinesService,void 0,!0)),ve.set(ze.IUserDataSyncBackupStoreService,new G.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),ve.set(ze.IUserDataSyncEnablementService,new G.SyncDescriptor(Ae.UserDataSyncEnablementService,void 0,!0)),ve.set(ze.IUserDataSyncService,new G.SyncDescriptor(De.UserDataSyncService,void 0,!1)),ve.set(ke.IUserDataProfileStorageService,new G.SyncDescriptor(Be.UserDataProfileStorageService,void 0,!0)),ve.set(ze.IUserDataSyncResourceProviderService,new G.SyncDescriptor(jt.UserDataSyncResourceProviderService,void 0,!0));const Rt=new Ne.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Xe.getValue("terminal.integrated.persistentSessionScrollback")??100},Xe,Ke,xe);return Rt.initialize(),ve.set(Ee.ILocalPtyService,this.B(Rt)),ve.set(ie.ISignService,new G.SyncDescriptor(he.SignService,void 0,!1)),ve.set(fe.ISharedTunnelsService,new G.SyncDescriptor(me.SharedTunnelsService)),ve.set(we.ISharedProcessTunnelService,new G.SyncDescriptor(Ie.SharedProcessTunnelService)),ve.set(Et.IRemoteTunnelService,new G.SyncDescriptor(Ft.RemoteTunnelService)),new _.InstantiationService(ve)}j(ve){const Ue=new x.LogLevelChannel(ve.get(J.ILogService),ve.get(J.ILoggerService));this.a.registerChannel("logLevel",Ue);const We=new I.ExtensionManagementChannel(ve.get(u.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",We);const Je=C.ProxyChannel.fromService(ve.get(Z.ILanguagePackService));this.a.registerChannel("languagePacks",Je);const tt=C.ProxyChannel.fromService(ve.get(f.IDiagnosticsService));this.a.registerChannel("diagnostics",tt);const Ke=new I.ExtensionTipsChannel(ve.get(u.IExtensionTipsService));this.a.registerChannel("extensionTipsService",Ke);const lt=C.ProxyChannel.fromService(ve.get(l.IChecksumService));this.a.registerChannel("checksum",lt);const it=C.ProxyChannel.fromService(ve.get(wt.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",it);const ht=new ge.UserDataSyncMachinesServiceChannel(ve.get(Pe.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ht);const xe=C.ProxyChannel.fromService(ve.get(te.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",xe);const _e=new ge.UserDataSyncAccountServiceChannel(ve.get(ce.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",_e);const ft=new ge.UserDataSyncStoreManagementServiceChannel(ve.get(ze.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",ft);const dt=new je.UserDataSyncChannel(ve.get(ze.IUserDataSyncService),ve.get(vt.IUserDataProfilesService),ve.get(J.ILogService));this.a.registerChannel("userDataSync",dt);const nt=this.B(ve.get(W.IInstantiationService).createInstance(Me.UserDataAutoSyncService)),Xe=new ge.UserDataAutoSyncChannel(nt);this.a.registerChannel("userDataAutoSync",Xe);const at=ve.get(Ee.ILocalPtyService),ut=C.ProxyChannel.fromService(at);this.a.registerChannel(be.TerminalIpcChannels.LocalPty,ut);const gt=C.ProxyChannel.fromService(ve.get(we.ISharedProcessTunnelService));this.a.registerChannel(we.ipcSharedProcessTunnelChannelName,gt);const mt=C.ProxyChannel.fromService(ve.get(Re.ISharedProcessWorkerService));this.a.registerChannel(Re.ipcSharedProcessWorkerChannelName,mt);const st=C.ProxyChannel.fromService(ve.get(Et.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",st)}k(ve){window.addEventListener("unhandledrejection",Ue=>{(0,A.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,A.setUnexpectedErrorHandler)(Ue=>{const We=(0,D.toErrorMessage)(Ue,!0);!We||ve.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function Bt(It){const ve=new zt(It);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Bt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/44531ffc7b7477dbe82750040d8ed69bae2bb140/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
