/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","electron","vs/base/common/network","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/platform/policy/common/policy","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/common/objects","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ne=function(G){for(var e=[],E=0,t=G.length;E<t;E++)e[E]=ie[G[E]];return e};define(ie[120],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function E(R){return R?R.replace(/\$\((.*?)\)/g,(A,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=E;class t{constructor(A,P,w){this.id=A,this.definition=P,this.description=w,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var k;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function P(b){if(b instanceof t)return["codicon","codicon-"+b.id];const S=A.exec(b.id);if(!S)return P(t.error);const[,y,u]=S,f=["codicon","codicon-"+y];return u&&f.push("codicon-modifier-"+u.substring(1)),f}R.asClassNameArray=P;function w(b){return P(b).join(" ")}R.asClassName=w;function g(b){return"."+P(b).join(".")}R.asCSSSelector=g})(k=e.CSSIcon||(e.CSSIcon={}))}),define(ie[121],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(P,w){const g=Math.pow(10,w);return Math.round(P*g)/g}class t{constructor(w,g,b,S=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,w))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=E(Math.max(Math.min(1,S),0),3)}static equals(w,g){return w.r===g.r&&w.g===g.g&&w.b===g.b&&w.a===g.a}}e.RGBA=t;class k{constructor(w,g,b,S){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,w),0)|0,this.s=E(Math.max(Math.min(1,g),0),3),this.l=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,S),0),3)}static equals(w,g){return w.h===g.h&&w.s===g.s&&w.l===g.l&&w.a===g.a}static fromRGBA(w){const g=w.r/255,b=w.g/255,S=w.b/255,y=w.a,u=Math.max(g,b,S),f=Math.min(g,b,S);let p=0,h=0;const l=(f+u)/2,v=u-f;if(v>0){switch(h=Math.min(l<=.5?v/(2*l):v/(2-2*l),1),u){case g:p=(b-S)/v+(b<S?6:0);break;case b:p=(S-g)/v+2;break;case S:p=(g-b)/v+4;break}p*=60,p=Math.round(p)}return new k(p,h,l,y)}static i(w,g,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?w+(g-w)*6*b:b<1/2?g:b<2/3?w+(g-w)*(2/3-b)*6:w}static toRGBA(w){const g=w.h/360,{s:b,l:S,a:y}=w;let u,f,p;if(b===0)u=f=p=S;else{const h=S<.5?S*(1+b):S+b-S*b,l=2*S-h;u=k.i(l,h,g+1/3),f=k.i(l,h,g),p=k.i(l,h,g-1/3)}return new t(Math.round(u*255),Math.round(f*255),Math.round(p*255),y)}}e.HSLA=k;class R{constructor(w,g,b,S){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,w),0)|0,this.s=E(Math.max(Math.min(1,g),0),3),this.v=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,S),0),3)}static equals(w,g){return w.h===g.h&&w.s===g.s&&w.v===g.v&&w.a===g.a}static fromRGBA(w){const g=w.r/255,b=w.g/255,S=w.b/255,y=Math.max(g,b,S),u=Math.min(g,b,S),f=y-u,p=y===0?0:f/y;let h;return f===0?h=0:y===g?h=((b-S)/f%6+6)%6:y===b?h=(S-g)/f+2:h=(g-b)/f+4,new R(Math.round(h*60),p,y,w.a)}static toRGBA(w){const{h:g,s:b,v:S,a:y}=w,u=S*b,f=u*(1-Math.abs(g/60%2-1)),p=S-u;let[h,l,v]=[0,0,0];return g<60?(h=u,l=f):g<120?(h=f,l=u):g<180?(l=u,v=f):g<240?(l=f,v=u):g<300?(h=f,v=u):g<=360&&(h=u,v=f),h=Math.round((h+p)*255),l=Math.round((l+p)*255),v=Math.round((v+p)*255),new t(h,l,v,y)}}e.HSVA=R;class A{static fromHex(w){return A.Format.CSS.parseHex(w)||A.red}static equals(w,g){return!w&&!g?!0:!w||!g?!1:w.equals(g)}get hsla(){return this.i?this.i:k.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(w){if(w)if(w instanceof t)this.rgba=w;else if(w instanceof k)this.i=w,this.rgba=k.toRGBA(w);else if(w instanceof R)this.j=w,this.rgba=R.toRGBA(w);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(w){return!!w&&t.equals(this.rgba,w.rgba)&&k.equals(this.hsla,w.hsla)&&R.equals(this.hsva,w.hsva)}getRelativeLuminance(){const w=A.k(this.rgba.r),g=A.k(this.rgba.g),b=A.k(this.rgba.b),S=.2126*w+.7152*g+.0722*b;return E(S,4)}static k(w){const g=w/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(w){const g=this.getRelativeLuminance(),b=w.getRelativeLuminance();return g>b?(g+.05)/(b+.05):(b+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(w){const g=this.getRelativeLuminance(),b=w.getRelativeLuminance();return g>b}isDarkerThan(w){const g=this.getRelativeLuminance(),b=w.getRelativeLuminance();return g<b}lighten(w){return new A(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*w,this.hsla.a))}darken(w){return new A(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*w,this.hsla.a))}transparent(w){const{r:g,g:b,b:S,a:y}=this.rgba;return new A(new t(g,b,S,y*w))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(w){const g=w.rgba,b=this.rgba.a,S=g.a,y=b+S*(1-b);if(y<1e-6)return A.transparent;const u=this.rgba.r*b/y+g.r*S*(1-b)/y,f=this.rgba.g*b/y+g.g*S*(1-b)/y,p=this.rgba.b*b/y+g.b*S*(1-b)/y;return new A(new t(u,f,p,y))}makeOpaque(w){if(this.isOpaque()||w.rgba.a!==1)return this;const{r:g,g:b,b:S,a:y}=this.rgba;return new A(new t(w.rgba.r-y*(w.rgba.r-g),w.rgba.g-y*(w.rgba.g-b),w.rgba.b-y*(w.rgba.b-S),1))}flatten(...w){const g=w.reduceRight((b,S)=>A.o(S,b));return A.o(this,g)}static o(w,g){const b=1-w.rgba.a;return new A(new t(b*g.rgba.r+w.rgba.a*w.rgba.r,b*g.rgba.g+w.rgba.a*w.rgba.g,b*g.rgba.b+w.rgba.a*w.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(w,g,b){if(w.isLighterThan(g))return w;b=b||.5;const S=w.getRelativeLuminance(),y=g.getRelativeLuminance();return b=b*(y-S)/y,w.lighten(b)}static getDarkerColor(w,g,b){if(w.isDarkerThan(g))return w;b=b||.5;const S=w.getRelativeLuminance(),y=g.getRelativeLuminance();return b=b*(S-y)/S,w.darken(b)}}e.Color=A,A.white=new A(new t(255,255,255,1)),A.black=new A(new t(0,0,0,1)),A.red=new A(new t(255,0,0,1)),A.blue=new A(new t(0,0,255,1)),A.green=new A(new t(0,255,0,1)),A.cyan=new A(new t(0,255,255,1)),A.lightgrey=new A(new t(211,211,211,1)),A.transparent=new A(new t(0,0,0,0)),function(P){let w;(function(g){let b;(function(S){function y(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:P.Format.CSS.formatRGBA(i)}S.formatRGB=y;function u(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}S.formatRGBA=u;function f(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(i)}S.formatHSL=f;function p(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}S.formatHSLA=p;function h(i){const n=i.toString(16);return n.length!==2?"0"+n:n}function l(i){return`#${h(i.rgba.r)}${h(i.rgba.g)}${h(i.rgba.b)}`}S.formatHex=l;function v(i,n=!1){return n&&i.rgba.a===1?P.Format.CSS.formatHex(i):`#${h(i.rgba.r)}${h(i.rgba.g)}${h(i.rgba.b)}${h(Math.round(i.rgba.a*255))}`}S.formatHexA=v;function C(i){return i.isOpaque()?P.Format.CSS.formatHex(i):P.Format.CSS.formatRGBA(i)}S.format=C;function I(i){const n=i.length;if(n===0||i.charCodeAt(0)!==35)return null;if(n===7){const r=16*m(i.charCodeAt(1))+m(i.charCodeAt(2)),a=16*m(i.charCodeAt(3))+m(i.charCodeAt(4)),s=16*m(i.charCodeAt(5))+m(i.charCodeAt(6));return new P(new t(r,a,s,1))}if(n===9){const r=16*m(i.charCodeAt(1))+m(i.charCodeAt(2)),a=16*m(i.charCodeAt(3))+m(i.charCodeAt(4)),s=16*m(i.charCodeAt(5))+m(i.charCodeAt(6)),c=16*m(i.charCodeAt(7))+m(i.charCodeAt(8));return new P(new t(r,a,s,c/255))}if(n===4){const r=m(i.charCodeAt(1)),a=m(i.charCodeAt(2)),s=m(i.charCodeAt(3));return new P(new t(16*r+r,16*a+a,16*s+s))}if(n===5){const r=m(i.charCodeAt(1)),a=m(i.charCodeAt(2)),s=m(i.charCodeAt(3)),c=m(i.charCodeAt(4));return new P(new t(16*r+r,16*a+a,16*s+s,(16*c+c)/255))}return null}S.parseHex=I;function m(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=g.CSS||(g.CSS={}))})(w=P.Format||(P.Format={}))}(A=e.Color||(e.Color={}))}),define(ie[53],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(A){return(P,w,g)=>{let b=null,S=null;if(typeof g.value=="function"?(b="value",S=g.value):typeof g.get=="function"&&(b="get",S=g.get),!S)throw new Error("not supported");g[b]=A(S,w)}}function t(A,P,w){let g=null,b=null;if(typeof w.value=="function"?(g="value",b=w.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(g="get",b=w.get),!b)throw new Error("not supported");const S=`$memoize$${P}`;w[g]=function(...y){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,y)}),this[S]}}e.memoize=t;function k(A,P,w){return E((g,b)=>{const S=`$debounce$${b}`,y=`$debounce$result$${b}`;return function(...u){this[y]||(this[y]=w?w():void 0),clearTimeout(this[S]),P&&(this[y]=P(this[y],...u),u=[this[y]]),this[S]=setTimeout(()=>{g.apply(this,u),this[y]=w?w():void 0},A)}})}e.debounce=k;function R(A,P,w){return E((g,b)=>{const S=`$throttle$timer$${b}`,y=`$throttle$result$${b}`,u=`$throttle$lastRun$${b}`,f=`$throttle$pending$${b}`;return function(...p){if(this[y]||(this[y]=w?w():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...p)),this[f])return;const h=this[u]+A;h<=Date.now()?(this[u]=Date.now(),g.apply(this,[this[y]]),this[y]=w?w():void 0):(this[f]=!0,this[S]=setTimeout(()=>{this[f]=!1,this[u]=Date.now(),g.apply(this,[this[y]]),this[y]=w?w():void 0},h-Date.now()))}})}e.throttle=R}),define(ie[15],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?C.isErrorNoTelemetry(i)?new C(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(n=>{n(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=E,e.errorHandler=new E;function t(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=t;function k(m){w(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=k;function R(m){w(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=R;function A(m){if(m instanceof Error){const{name:i,message:n}=m,r=m.stacktrace||m.stack;return{$isError:!0,name:i,message:n,stack:r,noTelemetry:C.isErrorNoTelemetry(m)}}return m}e.transformErrorForSerialization=A;const P="Canceled";function w(m){return m instanceof g?!0:m instanceof Error&&m.name===P&&m.message===P}e.isCancellationError=w;class g extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=g;function b(){const m=new Error(P);return m.name=m.message,m}e.canceled=b;function S(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=S;function y(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=y;function u(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=u;function f(m){const i=new Error(`${m} has been disposed`);return i.name="DISPOSED",i}e.disposed=f;function p(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=p;class h extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=h;class l extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=l;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class C extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof C)return i;const n=new C;return n.message=i.message,n.stack=i.stack,n}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=C;class I extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,I.prototype);debugger}}e.BugIndicatingError=I}),define(ie[24],ne([0,1,15]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(B,_=0){return B[B.length-(1+_)]}e.tail=t;function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=k;function R(B,_,Z=(ae,ge)=>ae===ge){if(B===_)return!0;if(!B||!_||B.length!==_.length)return!1;for(let ae=0,ge=B.length;ae<ge;ae++)if(!Z(B[ae],_[ae]))return!1;return!0}e.equals=R;function A(B,_){const Z=B.length-1;_<Z&&(B[_]=B[Z]),B.pop()}e.removeFastWithoutKeepingOrder=A;function P(B,_,Z){return w(B.length,ae=>Z(B[ae],_))}e.binarySearch=P;function w(B,_){let Z=0,ae=B-1;for(;Z<=ae;){const ge=(Z+ae)/2|0,ke=_(ge);if(ke<0)Z=ge+1;else if(ke>0)ae=ge-1;else return ge}return-(Z+1)}e.binarySearch2=w;function g(B,_){let Z=0,ae=B.length;if(ae===0)return 0;for(;Z<ae;){const ge=Math.floor((Z+ae)/2);_(B[ge])?ae=ge:Z=ge+1}return Z}e.findFirstInSorted=g;function b(B,_,Z){if(B=B|0,B>=_.length)throw new TypeError("invalid index");const ae=_[Math.floor(_.length*Math.random())],ge=[],ke=[],Oe=[];for(const De of _){const Le=Z(De,ae);Le<0?ge.push(De):Le>0?ke.push(De):Oe.push(De)}return B<ge.length?b(B,ge,Z):B<ge.length+Oe.length?Oe[0]:b(B-(ge.length+Oe.length),ke,Z)}e.quickSelect=b;function S(B,_){const Z=[];let ae;for(const ge of B.slice(0).sort(_))!ae||_(ae[0],ge)!==0?(ae=[ge],Z.push(ae)):ae.push(ge);return Z}e.groupBy=S;function y(B,_,Z){const ae=[];function ge(De,Le,ve){if(Le===0&&ve.length===0)return;const we=ae[ae.length-1];we&&we.start+we.deleteCount===De?(we.deleteCount+=Le,we.toInsert.push(...ve)):ae.push({start:De,deleteCount:Le,toInsert:ve})}let ke=0,Oe=0;for(;;){if(ke===B.length){ge(ke,0,_.slice(Oe));break}if(Oe===_.length){ge(ke,B.length-ke,[]);break}const De=B[ke],Le=_[Oe],ve=Z(De,Le);ve===0?(ke+=1,Oe+=1):ve<0?(ge(ke,1,[]),ke+=1):ve>0&&(ge(ke,0,[Le]),Oe+=1)}return ae}e.sortedDiff=y;function u(B,_,Z){const ae=y(B,_,Z),ge=[],ke=[];for(const Oe of ae)ge.push(...B.slice(Oe.start,Oe.start+Oe.deleteCount)),ke.push(...Oe.toInsert);return{removed:ge,added:ke}}e.delta=u;function f(B,_,Z){if(Z===0)return[];const ae=B.slice(0,Z).sort(_);return h(B,_,ae,Z,B.length),ae}e.top=f;function p(B,_,Z,ae,ge){return Z===0?Promise.resolve([]):new Promise((ke,Oe)=>{(async()=>{const De=B.length,Le=B.slice(0,Z).sort(_);for(let ve=Z,we=Math.min(Z+ae,De);ve<De;ve=we,we=Math.min(we+ae,De)){if(ve>Z&&await new Promise(ye=>setTimeout(ye)),ge&&ge.isCancellationRequested)throw new E.CancellationError;h(B,_,Le,ve,we)}return Le})().then(ke,Oe)})}e.topAsync=p;function h(B,_,Z,ae,ge){for(const ke=Z.length;ae<ge;ae++){const Oe=B[ae];if(_(Oe,Z[ke-1])<0){Z.pop();const De=g(Z,Le=>_(Oe,Le)<0);Z.splice(De,0,Oe)}}}function l(B){return B.filter(_=>!!_)}e.coalesce=l;function v(B){let _=0;for(let Z=0;Z<B.length;Z++)B[Z]&&(B[_]=B[Z],_+=1);B.length=_}e.coalesceInPlace=v;function C(B,_,Z){B.splice(Z,0,B.splice(_,1)[0])}e.move=C;function I(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=I;function m(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=m;function i(B,_=Z=>Z){const Z=new Set;return B.filter(ae=>{const ge=_(ae);return Z.has(ge)?!1:(Z.add(ge),!0)})}e.distinct=i;function n(B){const _=new Set;return Z=>{const ae=B(Z);return _.has(ae)?!1:(_.add(ae),!0)}}e.uniqueFilter=n;function r(B,_){const Z=a(B,_);if(Z!==-1)return B[Z]}e.findLast=r;function a(B,_){for(let Z=B.length-1;Z>=0;Z--){const ae=B[Z];if(_(ae))return Z}return-1}e.lastIndex=a;function s(B,_){return B.length>0?B[0]:_}e.firstOrDefault=s;function c(B,_){return B.length>0?B[B.length-1]:_}e.lastOrDefault=c;function o(B,_,Z=(ae,ge)=>ae===ge){let ae=0;for(let ge=0,ke=Math.min(B.length,_.length);ge<ke&&Z(B[ge],_[ge]);ge++)ae++;return ae}e.commonPrefixLength=o;function d(B){return[].concat(...B)}e.flatten=d;function D(B,_){let Z=typeof _=="number"?B:0;typeof _=="number"?Z=B:(Z=0,_=B);const ae=[];if(Z<=_)for(let ge=Z;ge<_;ge++)ae.push(ge);else for(let ge=Z;ge>_;ge--)ae.push(ge);return ae}e.range=D;function L(B,_,Z){return B.reduce((ae,ge)=>(ae[_(ge)]=Z?Z(ge):ge,ae),Object.create(null))}e.index=L;function N(B,_){return B.push(_),()=>V(B,_)}e.insert=N;function V(B,_){const Z=B.indexOf(_);if(Z>-1)return B.splice(Z,1),_}e.remove=V;function oe(B,_,Z){const ae=B.slice(0,_),ge=B.slice(_);return ae.concat(Z,ge)}e.arrayInsert=oe;function X(B,_){let Z;if(typeof _=="number"){let ae=_;Z=()=>{const ge=Math.sin(ae++)*179426549;return ge-Math.floor(ge)}}else Z=Math.random;for(let ae=B.length-1;ae>0;ae-=1){const ge=Math.floor(Z()*(ae+1)),ke=B[ae];B[ae]=B[ge],B[ge]=ke}}e.shuffle=X;function Y(B,_){const Z=B.indexOf(_);Z>-1&&(B.splice(Z,1),B.unshift(_))}e.pushToStart=Y;function se(B,_){const Z=B.indexOf(_);Z>-1&&(B.splice(Z,1),B.push(_))}e.pushToEnd=se;function re(B,_){for(const Z of _)B.push(Z)}e.pushMany=re;function fe(B,_){return Array.isArray(B)?B.map(_):_(B)}e.mapArrayOrNot=fe;function J(B){return Array.isArray(B)?B:[B]}e.asArray=J;function le(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=le;function $(B,_){for(const Z of B){const ae=_(Z);if(ae!==void 0)return ae}}e.mapFind=$;function W(B,_,Z){const ae=z(B,_),ge=B.length,ke=Z.length;B.length=ge+ke;for(let Oe=ge-1;Oe>=ae;Oe--)B[Oe+ke]=B[Oe];for(let Oe=0;Oe<ke;Oe++)B[Oe+ae]=Z[Oe]}e.insertInto=W;function T(B,_,Z,ae){const ge=z(B,_),ke=B.splice(ge,Z);return W(B,ge,ae),ke}e.splice=T;function z(B,_){return _<0?Math.max(_+B.length,0):Math.min(_,B.length)}var Q;(function(B){function _(ge){return ge<0}B.isLessThan=_;function Z(ge){return ge>0}B.isGreaterThan=Z;function ae(ge){return ge===0}B.isNeitherLessOrGreaterThan=ae,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function q(B,_){return(Z,ae)=>_(B(Z),B(ae))}e.compareBy=q;function j(...B){return(_,Z)=>{for(const ae of B){const ge=ae(_,Z);if(!Q.isNeitherLessOrGreaterThan(ge))return ge}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=j;const M=(B,_)=>B-_;e.numberComparator=M;function O(B,_){if(B.length===0)return;let Z=B[0];for(let ae=1;ae<B.length;ae++){const ge=B[ae];_(ge,Z)>0&&(Z=ge)}return Z}e.findMaxBy=O;function F(B,_){if(B.length===0)return;let Z=B[0];for(let ae=1;ae<B.length;ae++){const ge=B[ae];_(ge,Z)>=0&&(Z=ge)}return Z}e.findLastMaxBy=F;function U(B,_){return O(B,(Z,ae)=>-_(Z,ae))}e.findMinBy=U;class H{constructor(_){this.f=_,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(_){let Z=this.c;for(;Z<this.f.length&&_(this.f[Z]);)Z++;const ae=Z===this.c?null:this.f.slice(this.c,Z);return this.c=Z,ae}takeFromEndWhile(_){let Z=this.d;for(;Z>=0&&_(this.f[Z]);)Z--;const ae=Z===this.d?null:this.f.slice(Z+1,this.d+1);return this.d=Z,ae}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const _=this.f[this.c];return this.c++,_}removeLast(){const _=this.f[this.d];return this.d--,_}takeCount(_){const Z=this.f.slice(this.c,this.c+_);return this.c+=_,Z}}e.ArrayQueue=H;class x{constructor(_){this.iterate=_}forEach(_){this.iterate(Z=>(_(Z),!0))}toArray(){const _=[];return this.iterate(Z=>(_.push(Z),!0)),_}filter(_){return new x(Z=>this.iterate(ae=>_(ae)?Z(ae):!0))}map(_){return new x(Z=>this.iterate(ae=>Z(_(ae))))}some(_){let Z=!1;return this.iterate(ae=>(Z=_(ae),!Z)),Z}findFirst(_){let Z;return this.iterate(ae=>_(ae)?(Z=ae,!1):!0),Z}findLast(_){let Z;return this.iterate(ae=>(_(ae)&&(Z=ae),!0)),Z}findLastMaxBy(_){let Z,ae=!0;return this.iterate(ge=>((ae||Q.isGreaterThan(_(ge,Z)))&&(ae=!1,Z=ge),!0)),Z}}e.CallbackIterable=x,x.empty=new x(B=>{})}),define(ie[122],ne([0,1,15]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(w,g){if(!w)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=t;function k(w,g="Unreachable"){throw new Error(g)}e.assertNever=k;function R(w){if(!w)throw new E.BugIndicatingError("Assertion Failed")}e.assert=R;function A(w){if(!w()){debugger;w(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function P(w,g){let b=0;for(;b<w.length-1;){const S=w[b],y=w[b+1];if(!g(S,y))return!1;b++}return!0}e.checkAdjacentItems=P}),define(ie[50],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(t){const k=this;let R=!1,A;return function(){return R||(R=!0,A=t.apply(k,arguments)),A}}e.once=E}),define(ie[67],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(t){function k(I){return I&&typeof I=="object"&&typeof I[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function A(){return R}t.empty=A;function*P(I){yield I}t.single=P;function w(I){return k(I)?I:P(I)}t.wrap=w;function g(I){return I||R}t.from=g;function b(I){return!I||I[Symbol.iterator]().next().done===!0}t.isEmpty=b;function S(I){return I[Symbol.iterator]().next().value}t.first=S;function y(I,m){for(const i of I)if(m(i))return!0;return!1}t.some=y;function u(I,m){for(const i of I)if(m(i))return i}t.find=u;function*f(I,m){for(const i of I)m(i)&&(yield i)}t.filter=f;function*p(I,m){let i=0;for(const n of I)yield m(n,i++)}t.map=p;function*h(...I){for(const m of I)for(const i of m)yield i}t.concat=h;function l(I,m,i){let n=i;for(const r of I)n=m(n,r);return n}t.reduce=l;function*v(I,m,i=I.length){for(m<0&&(m+=I.length),i<0?i+=I.length:i>I.length&&(i=I.length);m<i;m++)yield I[m]}t.slice=v;function C(I,m=Number.POSITIVE_INFINITY){const i=[];if(m===0)return[i,I];const n=I[Symbol.iterator]();for(let r=0;r<m;r++){const a=n.next();if(a.done)return[i,t.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return n}}]}t.consume=C})(E=e.Iterable||(e.Iterable={}))}),define(ie[43],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function A(i,n=!1){let r=0;const a=i.length;let s="",c=0,o=16,d=0;function D(se){let re=0,fe=0;for(;re<se;){const J=i.charCodeAt(r);if(J>=48&&J<=57)fe=fe*16+J-48;else if(J>=65&&J<=70)fe=fe*16+J-65+10;else if(J>=97&&J<=102)fe=fe*16+J-97+10;else break;r++,re++}return re<se&&(fe=-1),fe}function L(se){r=se,s="",c=0,o=16,d=0}function N(){const se=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&g(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&g(i.charCodeAt(r)))for(r++;r<i.length&&g(i.charCodeAt(r));)r++;else return d=3,i.substring(se,r);let re=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&g(i.charCodeAt(r))){for(r++;r<i.length&&g(i.charCodeAt(r));)r++;re=r}else d=3;return i.substring(se,re)}function V(){let se="",re=r;for(;;){if(r>=a){se+=i.substring(re,r),d=2;break}const fe=i.charCodeAt(r);if(fe===34){se+=i.substring(re,r),r++;break}if(fe===92){if(se+=i.substring(re,r),r++,r>=a){d=2;break}switch(i.charCodeAt(r++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const le=D(4);le>=0?se+=String.fromCharCode(le):d=4;break}default:d=5}re=r;continue}if(fe>=0&&fe<=31)if(w(fe)){se+=i.substring(re,r),d=2;break}else d=6;r++}return se}function oe(){if(s="",d=0,c=r,r>=a)return c=a,o=17;let se=i.charCodeAt(r);if(P(se)){do r++,s+=String.fromCharCode(se),se=i.charCodeAt(r);while(P(se));return o=15}if(w(se))return r++,s+=String.fromCharCode(se),se===13&&i.charCodeAt(r)===10&&(r++,s+=`
`),o=14;switch(se){case 123:return r++,o=1;case 125:return r++,o=2;case 91:return r++,o=3;case 93:return r++,o=4;case 58:return r++,o=6;case 44:return r++,o=5;case 34:return r++,s=V(),o=10;case 47:{const re=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<a&&!w(i.charCodeAt(r));)r++;return s=i.substring(re,r),o=12}if(i.charCodeAt(r+1)===42){r+=2;const fe=a-1;let J=!1;for(;r<fe;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,J=!0;break}r++}return J||(r++,d=1),s=i.substring(re,r),o=13}return s+=String.fromCharCode(se),r++,o=16}case 45:if(s+=String.fromCharCode(se),r++,r===a||!g(i.charCodeAt(r)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),o=11;default:for(;r<a&&X(se);)r++,se=i.charCodeAt(r);if(c!==r){switch(s=i.substring(c,r),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(se),r++,o=16}}function X(se){if(P(se)||w(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let se;do se=oe();while(se>=12&&se<=15);return se}return{setPosition:L,getPosition:()=>r,scan:n?Y:oe,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>d}}e.createScanner=A;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function w(i){return i===10||i===13||i===8232||i===8233}function g(i){return i>=48&&i<=57}var b;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(b||(b={}));function S(i,n){const r=[],a=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function d(D,L,N,V){c.value=D,c.offset=L,c.length=N,c.type=V,c.colonOffset=void 0,s=c}try{C(i,{onObjectBegin:(D,L)=>{if(n<=D)throw a;s=void 0,o=n>D,r.push("")},onObjectProperty:(D,L,N)=>{if(n<L||(d(D,L,N,"property"),r[r.length-1]=D,n<=L+N))throw a},onObjectEnd:(D,L)=>{if(n<=D)throw a;s=void 0,r.pop()},onArrayBegin:(D,L)=>{if(n<=D)throw a;s=void 0,r.push(0)},onArrayEnd:(D,L)=>{if(n<=D)throw a;s=void 0,r.pop()},onLiteralValue:(D,L,N)=>{if(n<L||(d(D,L,N,m(D)),n<=L+N))throw a},onSeparator:(D,L,N)=>{if(n<=L)throw a;if(D===":"&&s&&s.type==="property")s.colonOffset=L,o=!1,s=void 0;else if(D===","){const V=r[r.length-1];typeof V=="number"?r[r.length-1]=V+1:(o=!0,r[r.length-1]=""),s=void 0}}})}catch(D){if(D!==a)throw D}return{path:r,previousNode:s,isAtPropertyKey:o,matches:D=>{let L=0;for(let N=0;L<D.length&&N<r.length;N++)if(D[L]===r[N]||D[L]==="*")L++;else if(D[L]!=="**")return!1;return L===D.length}}}e.getLocation=S;function y(i,n=[],r=R.DEFAULT){let a=null,s=[];const c=[];function o(D){Array.isArray(s)?s.push(D):a!==null&&(s[a]=D)}return C(i,{onObjectBegin:()=>{const D={};o(D),c.push(s),s=D,a=null},onObjectProperty:D=>{a=D},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const D=[];o(D),c.push(s),s=D,a=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:o,onError:(D,L,N)=>{n.push({error:D,offset:L,length:N})}},r),s[0]}e.parse=y;function u(i,n=[],r=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(D){a.type==="property"&&(a.length=D-a.offset,a=a.parent)}function c(D){return a.children.push(D),D}C(i,{onObjectBegin:D=>{a=c({type:"object",offset:D,length:-1,parent:a,children:[]})},onObjectProperty:(D,L,N)=>{a=c({type:"property",offset:L,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:D,offset:L,length:N,parent:a})},onObjectEnd:(D,L)=>{a.length=D+L-a.offset,a=a.parent,s(D+L)},onArrayBegin:(D,L)=>{a=c({type:"array",offset:D,length:-1,parent:a,children:[]})},onArrayEnd:(D,L)=>{a.length=D+L-a.offset,a=a.parent,s(D+L)},onLiteralValue:(D,L,N)=>{c({type:m(D),offset:L,length:N,parent:a,value:D}),s(L+N)},onSeparator:(D,L,N)=>{a.type==="property"&&(D===":"?a.colonOffset=L:D===","&&s(L))},onError:(D,L,N)=>{n.push({error:D,offset:L,length:N})}},r);const d=a.children[0];return d&&delete d.parent,d}e.parseTree=u;function f(i,n){if(!i)return;let r=i;for(const a of n)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===a){r=c.children[1],s=!0;break}if(!s)return}else{const s=a;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=f;function p(i){if(!i.parent||!i.parent.children)return[];const n=p(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;n.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&n.push(r)}return n}e.getNodePath=p;function h(i){switch(i.type){case"array":return i.children.map(h);case"object":{const n=Object.create(null);for(const r of i.children){const a=r.children[1];a&&(n[r.children[0].value]=h(a))}return n}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=h;function l(i,n,r=!1){return n>=i.offset&&n<i.offset+i.length||r&&n===i.offset+i.length}e.contains=l;function v(i,n,r=!1){if(l(i,n,r)){const a=i.children;if(Array.isArray(a))for(let s=0;s<a.length&&a[s].offset<=n;s++){const c=v(a[s],n,r);if(c)return c}return i}}e.findNodeAtOffset=v;function C(i,n,r=R.DEFAULT){const a=A(i,!1);function s(q){return q?()=>q(a.getTokenOffset(),a.getTokenLength()):()=>!0}function c(q){return q?j=>q(j,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=s(n.onObjectBegin),d=c(n.onObjectProperty),D=s(n.onObjectEnd),L=s(n.onArrayBegin),N=s(n.onArrayEnd),V=c(n.onLiteralValue),oe=c(n.onSeparator),X=s(n.onComment),Y=c(n.onError),se=r&&r.disallowComments,re=r&&r.allowTrailingComma;function fe(){for(;;){const q=a.scan();switch(a.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:se||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(q){case 12:case 13:se?J(10):X();break;case 16:J(1);break;case 15:case 14:break;default:return q}}}function J(q,j=[],M=[]){if(Y(q),j.length+M.length>0){let O=a.getToken();for(;O!==17;){if(j.indexOf(O)!==-1){fe();break}else if(M.indexOf(O)!==-1)break;O=fe()}}}function le(q){const j=a.getTokenValue();return q?V(j):d(j),fe(),!0}function $(){switch(a.getToken()){case 11:{let q=0;try{q=JSON.parse(a.getTokenValue()),typeof q!="number"&&(J(2),q=0)}catch{J(2)}V(q);break}case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return fe(),!0}function W(){return a.getToken()!==10?(J(3,[],[2,5]),!1):(le(!1),a.getToken()===6?(oe(":"),fe(),Q()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function T(){o(),fe();let q=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(q||J(4,[],[]),oe(","),fe(),a.getToken()===2&&re)break}else q&&J(6,[],[]);W()||J(4,[],[2,5]),q=!0}return D(),a.getToken()!==2?J(7,[2],[]):fe(),!0}function z(){L(),fe();let q=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(q||J(4,[],[]),oe(","),fe(),a.getToken()===4&&re)break}else q&&J(6,[],[]);Q()||J(4,[],[4,5]),q=!0}return N(),a.getToken()!==4?J(8,[4],[]):fe(),!0}function Q(){switch(a.getToken()){case 3:return z();case 1:return T();case 10:return le(!0);default:return $()}}return fe(),a.getToken()===17?r.allowEmptyContent?!0:(J(4,[],[]),!1):Q()?(a.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.visit=C;function I(i,n){const r=A(i),a=[];let s,c=0,o;do switch(o=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:c!==o&&a.push(i.substring(c,o)),n!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,n)),c=r.getPosition();break}while(s!==17);return a.join("")}e.stripComments=I;function m(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(ie[123],ne([0,1,43]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(g,b,S){let y,u,f,p,h;if(b){for(p=b.offset,h=p+b.length,f=p;f>0&&!w(g,f-1);)f--;let o=h;for(;o<g.length&&!w(g,o);)o++;u=g.substring(f,o),y=A(u,S)}else u=g,y=0,f=0,p=0,h=g.length;const l=P(S,g);let v=!1,C=0,I;S.insertSpaces?I=R(" ",S.tabSize||4):I="	";const m=(0,E.createScanner)(u,!1);let i=!1;function n(){return l+R(I,y+C)}function r(){let o=m.scan();for(v=!1;o===15||o===14;)v=v||o===14,o=m.scan();return i=o===16||m.getTokenError()!==0,o}const a=[];function s(o,d,D){!i&&d<h&&D>p&&g.substring(d,D)!==o&&a.push({offset:d,length:D-d,content:o})}let c=r();if(c!==17){const o=m.getTokenOffset()+f,d=R(I,y);s(d,f,o)}for(;c!==17;){let o=m.getTokenOffset()+m.getTokenLength()+f,d=r(),D="";for(;!v&&(d===12||d===13);){const N=m.getTokenOffset()+f;s(" ",o,N),o=m.getTokenOffset()+m.getTokenLength()+f,D=d===12?n():"",d=r()}if(d===2)c!==1&&(C--,D=n());else if(d===4)c!==3&&(C--,D=n());else{switch(c){case 3:case 1:C++,D=n();break;case 5:case 12:D=n();break;case 13:v?D=n():D=" ";break;case 6:D=" ";break;case 10:if(d===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?D=" ":d!==5&&d!==17&&(i=!0);break;case 16:i=!0;break}v&&(d===12||d===13)&&(D=n())}const L=m.getTokenOffset()+f;s(D,o,L),c=d}return a}e.format=t;function k(g,b){const S=JSON.stringify(g,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?S.replace(/\r\n|\r|\n/g,b.eol):S}e.toFormattedString=k;function R(g,b){let S="";for(let y=0;y<b;y++)S+=g;return S}function A(g,b){let S=0,y=0;const u=b.tabSize||4;for(;S<g.length;){const f=g.charAt(S);if(f===" ")y++;else if(f==="	")y+=u;else break;S++}return Math.floor(y/u)}function P(g,b){for(let S=0;S<b.length;S++){const y=b.charAt(S);if(y==="\r")return S+1<b.length&&b.charAt(S+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return g&&g.eol||`
`}e.getEOL=P;function w(g,b){return`\r
`.indexOf(g.charAt(b))!==-1}e.isEOL=w}),define(ie[124],ne([0,1,43,123]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(g,b,S){return R(g,b,void 0,S)}e.removeProperty=k;function R(g,b,S,y,u){const f=b.slice(),p=[],h=(0,E.parseTree)(g,p);let l,v;for(;f.length>0&&(v=f.pop(),l=(0,E.findNodeAtLocation)(h,f),l===void 0&&S!==void 0);)typeof v=="string"?S={[v]:S}:S=[S];if(l)if(l.type==="object"&&typeof v=="string"&&Array.isArray(l.children)){const C=(0,E.findNodeAtLocation)(l,[v]);if(C!==void 0)if(S===void 0){if(!C.parent)throw new Error("Malformed AST");const I=l.children.indexOf(C.parent);let m,i=C.parent.offset+C.parent.length;if(I>0){const n=l.children[I-1];m=n.offset+n.length}else m=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return A(g,{offset:m,length:i-m,content:""},y)}else return A(g,{offset:C.offset,length:C.length,content:JSON.stringify(S)},y);else{if(S===void 0)return[];const I=`${JSON.stringify(v)}: ${JSON.stringify(S)}`,m=u?u(l.children.map(n=>n.children[0].value)):l.children.length;let i;if(m>0){const n=l.children[m-1];i={offset:n.offset+n.length,length:0,content:","+I}}else l.children.length===0?i={offset:l.offset+1,length:0,content:I}:i={offset:l.offset+1,length:0,content:I+","};return A(g,i,y)}}else if(l.type==="array"&&typeof v=="number"&&Array.isArray(l.children))if(S!==void 0){const C=`${JSON.stringify(S)}`;let I;if(l.children.length===0||v===0)I={offset:l.offset+1,length:0,content:l.children.length===0?C:C+","};else{const m=v===-1||v>l.children.length?l.children.length:v,i=l.children[m-1];I={offset:i.offset+i.length,length:0,content:","+C}}return A(g,I,y)}else{const C=v,I=l.children[C];let m;if(l.children.length===1)m={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===C){const i=l.children[C-1],n=i.offset+i.length,r=l.offset+l.length;m={offset:n,length:r-2-n,content:""}}else m={offset:I.offset,length:l.children[C+1].offset-I.offset,content:""};return A(g,m,y)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${l.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return A(g,{offset:h?h.offset:0,length:h?h.length:0,content:JSON.stringify(S)},y)}}e.setProperty=R;function A(g,b,S){let y=P(g,b),u=b.offset,f=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;u>0&&!(0,t.isEOL)(y,u-1);)u--;for(;f<y.length&&!(0,t.isEOL)(y,f);)f++}const p=(0,t.format)(y,{offset:u,length:f-u},S);for(let l=p.length-1;l>=0;l--){const v=p[l];y=P(y,v),u=Math.min(u,v.offset),f=Math.max(f,v.offset+v.length),f+=v.content.length-v.length}const h=g.length-(y.length-f)-u;return[{offset:u,length:h,content:y.substring(u,f)}]}e.withFormatting=A;function P(g,b){return g.substring(0,b.offset)+b.content+g.substring(b.offset+b.length)}e.applyEdit=P;function w(g,b){const S=b.slice(0).sort((u,f)=>{const p=u.offset-f.offset;return p===0?u.length-f.length:p});let y=g.length;for(let u=S.length-1;u>=0;u--){const f=S[u];if(f.offset+f.length<=y)g=P(g,f);else throw new Error("Overlapping edit");y=f.offset}return g}e.applyEdits=w}),define(ie[125],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(k){this.d=k,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(k){return new E(()=>k(this.getValue()))}}e.Lazy=E}),define(ie[2],ne([0,1,50,67]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function A(c){R=c}if(e.setDisposableTracker=A,k){const c="__is_disposable_tracked__";A(new class{trackDisposable(o){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(d)},3e3)}setParent(o,d){if(o&&o!==v.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==v.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function P(c){return R?.trackDisposable(c),c}function w(c){R?.markAsDisposed(c)}function g(c,o){R?.setParent(c,o)}function b(c,o){if(!!R)for(const d of c)R.setParent(d,o)}function S(c){return R?.markAsSingleton(c),c}e.markAsSingleton=S;function y(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=y;function u(c){if(t.Iterable.is(c)){const o=[];for(const d of c)if(d)try{d.dispose()}catch(D){o.push(D)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=u;function f(c){for(const o of c)y(o)&&o.dispose();return[]}e.disposeIfDisposable=f;function p(...c){const o=h(()=>u(c));return b(c,o),o}e.combinedDisposable=p;function h(c){const o=P({dispose:(0,E.once)(()=>{w(o),c()})});return o}e.toDisposable=h;class l{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(w(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{u(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return g(o,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this.q=new l,P(this),g(this.q,this)}dispose(){w(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class C{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&g(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&g(o,null),o}}e.MutableDisposable=C;class I{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=I;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(o){let d=o;return this.unset=()=>d=void 0,this.isset=()=>d!==void 0,this.dispose=()=>{d&&(d(),d=void 0,w(this))},this}}e.SafeDisposable=m;class i{constructor(){this.a=new Map}acquire(o,...d){let D=this.a.get(o);D||(D={counter:0,object:this.b(o,...d)},this.a.set(o,D));const{object:L}=D,N=(0,E.once)(()=>{--D.counter===0&&(this.c(o,D.object),this.a.delete(o))});return D.counter++,{object:L,dispose:N}}}e.ReferenceCollection=i;class n{constructor(o){this.a=o}async acquire(o,...d){const D=this.a.acquire(o,...d);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(L){throw D.dispose(),L}}}e.AsyncReferenceCollection=n;class r{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=r;function a(c){const o=new l;try{c(o)}finally{o.dispose()}}e.disposeOnReturn=a;class s{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,d,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(o)?.dispose(),this.a.set(o,d)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(ie[96],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(R){this.element=R,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class t{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let R=this.a;for(;R!==E.Undefined;){const A=R.next;R.prev=E.Undefined,R.next=E.Undefined,R=A}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,A){const P=new E(R);if(this.a===E.Undefined)this.a=P,this.b=P;else if(A){const g=this.b;this.b=P,P.prev=g,g.next=P}else{const g=this.a;this.a=P,P.next=g,g.prev=P}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(P))}}shift(){if(this.a!==E.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==E.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==E.Undefined&&R.next!==E.Undefined){const A=R.prev;A.next=R.next,R.next.prev=A}else R.prev===E.Undefined&&R.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):R.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):R.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==E.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(ie[39],ne([0,1]),function(G,e){"use strict";var E,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(f,p,h){let l=f.get(p);return l===void 0&&(l=h,f.set(p,l)),l}e.getOrSet=R;function A(f){const p=[];return f.forEach((h,l)=>{p.push(`${l} => ${h}`)}),`Map(${f.size}) {${p.join(", ")}}`}e.mapToString=A;function P(f){const p=[];return f.forEach(h=>{p.push(h)}),`Set(${f.size}) {${p.join(", ")}}`}e.setToString=P;class w{constructor(p,h){this.uri=p,this.value=h}}class g{constructor(p,h){this[E]="ResourceMap",p instanceof g?(this.b=new Map(p.b),this.c=h??g.a):(this.b=new Map,this.c=p??g.a)}set(p,h){return this.b.set(this.c(p),new w(p,h)),this}get(p){return this.b.get(this.c(p))?.value}has(p){return this.b.has(this.c(p))}get size(){return this.b.size}clear(){this.b.clear()}delete(p){return this.b.delete(this.c(p))}forEach(p,h){typeof h<"u"&&(p=p.bind(h));for(const[l,v]of this.b)p(v.value,v.uri,this)}*values(){for(const p of this.b.values())yield p.value}*keys(){for(const p of this.b.values())yield p.uri}*entries(){for(const p of this.b.values())yield[p.uri,p.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,p]of this.b)yield[p.uri,p.value]}}e.ResourceMap=g,g.a=f=>f.toString();class b{constructor(p,h){this[t]="ResourceSet",!p||typeof p=="function"?this.a=new g(p):(this.a=new g(h),p.forEach(this.add,this))}get size(){return this.a.size}add(p){return this.a.set(p,p),this}clear(){this.a.clear()}delete(p){return this.a.delete(p)}forEach(p,h){this.a.forEach((l,v)=>p.call(h,v,v,this))}has(p){return this.a.has(p)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var S;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class y{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(p){return this.a.has(p)}get(p,h=0){const l=this.a.get(p);if(!!l)return h!==0&&this.j(l,h),l.value}set(p,h,l=0){let v=this.a.get(p);if(v)v.value=h,l!==0&&this.j(v,l);else{switch(v={key:p,value:h,next:void 0,previous:void 0},l){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(p,v),this.d++}return this}delete(p){return!!this.remove(p)}remove(p){const h=this.a.get(p);if(!!h)return this.a.delete(p),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const p=this.b;return this.a.delete(p.key),this.i(p),this.d--,p.value}forEach(p,h){const l=this.e;let v=this.b;for(;v;){if(h?p.bind(h)(v.value,v.key,this):p(v.value,v.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const p=this,h=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(p.e!==h)throw new Error("LinkedMap got modified during iteration.");if(l){const C={value:l.key,done:!1};return l=l.next,C}else return{value:void 0,done:!0}}};return v}values(){const p=this,h=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(p.e!==h)throw new Error("LinkedMap got modified during iteration.");if(l){const C={value:l.value,done:!1};return l=l.next,C}else return{value:void 0,done:!0}}};return v}entries(){const p=this,h=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(p.e!==h)throw new Error("LinkedMap got modified during iteration.");if(l){const C={value:[l.key,l.value],done:!1};return l=l.next,C}else return{value:void 0,done:!0}}};return v}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(p){if(p>=this.size)return;if(p===0){this.clear();return}let h=this.b,l=this.size;for(;h&&l>p;)this.a.delete(h.key),h=h.next,l--;this.b=h,this.d=l,h&&(h.previous=void 0),this.e++}g(p){if(!this.b&&!this.c)this.c=p;else if(this.b)p.next=this.b,this.b.previous=p;else throw new Error("Invalid list");this.b=p,this.e++}h(p){if(!this.b&&!this.c)this.b=p;else if(this.c)p.previous=this.c,this.c.next=p;else throw new Error("Invalid list");this.c=p,this.e++}i(p){if(p===this.b&&p===this.c)this.b=void 0,this.c=void 0;else if(p===this.b){if(!p.next)throw new Error("Invalid list");p.next.previous=void 0,this.b=p.next}else if(p===this.c){if(!p.previous)throw new Error("Invalid list");p.previous.next=void 0,this.c=p.previous}else{const h=p.next,l=p.previous;if(!h||!l)throw new Error("Invalid list");h.previous=l,l.next=h}p.next=void 0,p.previous=void 0,this.e++}j(p,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(p===this.b)return;const l=p.next,v=p.previous;p===this.c?(v.next=void 0,this.c=v):(l.previous=v,v.next=l),p.previous=void 0,p.next=this.b,this.b.previous=p,this.b=p,this.e++}else if(h===2){if(p===this.c)return;const l=p.next,v=p.previous;p===this.b?(l.previous=void 0,this.b=l):(l.previous=v,v.next=l),p.next=void 0,p.previous=this.c,this.c.next=p,this.c=p,this.e++}}}toJSON(){const p=[];return this.forEach((h,l)=>{p.push([l,h])}),p}fromJSON(p){this.clear();for(const[h,l]of p)this.set(h,l)}}e.LinkedMap=y;class u extends y{constructor(p,h=1){super(),this.k=p,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(p){this.k=p,this.m()}get ratio(){return this.l}set ratio(p){this.l=Math.min(Math.max(0,p),1),this.m()}get(p,h=2){return super.get(p,h)}peek(p){return super.get(p,0)}set(p,h){return super.set(p,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=u}),define(ie[76],ne([0,1,39]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new E.LRUCache(1e4);function k(g){return w(g,"NFC",t)}e.normalizeNFC=k;const R=new E.LRUCache(1e4);function A(g){return w(g,"NFD",R)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function w(g,b,S){if(!g)return g;const y=S.get(g);if(y)return y;let u;return P.test(g)?u=g.normalize(b):u=g,S.set(g,u),u}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(b){return A(b).replace(g,"")}}()}),function(){function G(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function A(w){R.push(w,Date.now())}function P(){const w=[];for(let g=0;g<R.length;g+=2)w.push({name:R[g],startTime:R[g+1]});return w}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(k+A.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function E(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=E(t))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var t in E)(typeof exports=="object"?exports:G)[t]=E[t]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function E(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return G[t].call(k.exports,k,k.exports,E),k.l=!0,k.exports}return E.m=G,E.c=e,E.d=function(t,k,R){E.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},E.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},E.t=function(t,k){if(1&k&&(t=E(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(E.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var A in t)E.d(R,A,function(P){return t[P]}.bind(null,A));return R},E.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return E.d(k,"a",k),k},E.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},E.p="",E(E.s=0)}([function(G,e,E){(function(t){var k;e=G.exports=M,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var te=Array.prototype.slice.call(arguments,0);te.unshift("SEMVER"),console.log.apply(console,te)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],w=e.src=[],g=0,b=g++;w[b]="0|[1-9]\\d*";var S=g++;w[S]="[0-9]+";var y=g++;w[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=g++;w[u]="("+w[b]+")\\.("+w[b]+")\\.("+w[b]+")";var f=g++;w[f]="("+w[S]+")\\.("+w[S]+")\\.("+w[S]+")";var p=g++;w[p]="(?:"+w[b]+"|"+w[y]+")";var h=g++;w[h]="(?:"+w[S]+"|"+w[y]+")";var l=g++;w[l]="(?:-("+w[p]+"(?:\\."+w[p]+")*))";var v=g++;w[v]="(?:-?("+w[h]+"(?:\\."+w[h]+")*))";var C=g++;w[C]="[0-9A-Za-z-]+";var I=g++;w[I]="(?:\\+("+w[C]+"(?:\\."+w[C]+")*))";var m=g++,i="v?"+w[u]+w[l]+"?"+w[I]+"?";w[m]="^"+i+"$";var n="[v=\\s]*"+w[f]+w[v]+"?"+w[I]+"?",r=g++;w[r]="^"+n+"$";var a=g++;w[a]="((?:<|>)?=?)";var s=g++;w[s]=w[S]+"|x|X|\\*";var c=g++;w[c]=w[b]+"|x|X|\\*";var o=g++;w[o]="[v=\\s]*("+w[c]+")(?:\\.("+w[c]+")(?:\\.("+w[c]+")(?:"+w[l]+")?"+w[I]+"?)?)?";var d=g++;w[d]="[v=\\s]*("+w[s]+")(?:\\.("+w[s]+")(?:\\.("+w[s]+")(?:"+w[v]+")?"+w[I]+"?)?)?";var D=g++;w[D]="^"+w[a]+"\\s*"+w[o]+"$";var L=g++;w[L]="^"+w[a]+"\\s*"+w[d]+"$";var N=g++;w[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=g++;w[V]="(?:~>?)";var oe=g++;w[oe]="(\\s*)"+w[V]+"\\s+",P[oe]=new RegExp(w[oe],"g");var X=g++;w[X]="^"+w[V]+w[o]+"$";var Y=g++;w[Y]="^"+w[V]+w[d]+"$";var se=g++;w[se]="(?:\\^)";var re=g++;w[re]="(\\s*)"+w[se]+"\\s+",P[re]=new RegExp(w[re],"g");var fe=g++;w[fe]="^"+w[se]+w[o]+"$";var J=g++;w[J]="^"+w[se]+w[d]+"$";var le=g++;w[le]="^"+w[a]+"\\s*("+n+")$|^$";var $=g++;w[$]="^"+w[a]+"\\s*("+i+")$|^$";var W=g++;w[W]="(\\s*)"+w[a]+"\\s*("+n+"|"+w[o]+")",P[W]=new RegExp(w[W],"g");var T=g++;w[T]="^\\s*("+w[o]+")\\s+-\\s+("+w[o]+")\\s*$";var z=g++;w[z]="^\\s*("+w[d]+")\\s+-\\s+("+w[d]+")\\s*$";var Q=g++;w[Q]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)k(q,w[q]),P[q]||(P[q]=new RegExp(w[q]));function j(te,he){if(te instanceof M)return te;if(typeof te!="string"||te.length>R||!(he?P[r]:P[m]).test(te))return null;try{return new M(te,he)}catch{return null}}function M(te,he){if(te instanceof M){if(te.loose===he)return te;te=te.version}else if(typeof te!="string")throw new TypeError("Invalid Version: "+te);if(te.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof M))return new M(te,he);k("SemVer",te,he),this.loose=he;var de=te.trim().match(he?P[r]:P[m]);if(!de)throw new TypeError("Invalid Version: "+te);if(this.raw=te,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Pe=+be;if(Pe>=0&&Pe<A)return Pe}return be}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=j,e.valid=function(te,he){var de=j(te,he);return de?de.version:null},e.clean=function(te,he){var de=j(te.trim().replace(/^[=v]+/,""),he);return de?de.version:null},e.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(te){return k("SemVer.compare",this.version,this.loose,te),te instanceof M||(te=new M(te,this.loose)),this.compareMain(te)||this.comparePre(te)},M.prototype.compareMain=function(te){return te instanceof M||(te=new M(te,this.loose)),F(this.major,te.major)||F(this.minor,te.minor)||F(this.patch,te.patch)},M.prototype.comparePre=function(te){if(te instanceof M||(te=new M(te,this.loose)),this.prerelease.length&&!te.prerelease.length)return-1;if(!this.prerelease.length&&te.prerelease.length)return 1;if(!this.prerelease.length&&!te.prerelease.length)return 0;var he=0;do{var de=this.prerelease[he],be=te.prerelease[he];if(k("prerelease compare",he,de,be),de===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(de===void 0)return-1;if(de!==be)return F(de,be)}while(++he)},M.prototype.inc=function(te,he){switch(te){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+te)}return this.format(),this.raw=this.version,this},e.inc=function(te,he,de,be){typeof de=="string"&&(be=de,de=void 0);try{return new M(te,de).inc(he,be).version}catch{return null}},e.diff=function(te,he){if(B(te,he))return null;var de=j(te),be=j(he);if(de.prerelease.length||be.prerelease.length){for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==be[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==be[Pe])return Pe},e.compareIdentifiers=F;var O=/^[0-9]+$/;function F(te,he){var de=O.test(te),be=O.test(he);return de&&be&&(te=+te,he=+he),de&&!be?-1:be&&!de?1:te<he?-1:te>he?1:0}function U(te,he,de){return new M(te,de).compare(new M(he,de))}function H(te,he,de){return U(te,he,de)>0}function x(te,he,de){return U(te,he,de)<0}function B(te,he,de){return U(te,he,de)===0}function _(te,he,de){return U(te,he,de)!==0}function Z(te,he,de){return U(te,he,de)>=0}function ae(te,he,de){return U(te,he,de)<=0}function ge(te,he,de,be){var Pe;switch(he){case"===":typeof te=="object"&&(te=te.version),typeof de=="object"&&(de=de.version),Pe=te===de;break;case"!==":typeof te=="object"&&(te=te.version),typeof de=="object"&&(de=de.version),Pe=te!==de;break;case"":case"=":case"==":Pe=B(te,de,be);break;case"!=":Pe=_(te,de,be);break;case">":Pe=H(te,de,be);break;case">=":Pe=Z(te,de,be);break;case"<":Pe=x(te,de,be);break;case"<=":Pe=ae(te,de,be);break;default:throw new TypeError("Invalid operator: "+he)}return Pe}function ke(te,he){if(te instanceof ke){if(te.loose===he)return te;te=te.value}if(!(this instanceof ke))return new ke(te,he);k("comparator",te,he),this.loose=he,this.parse(te),this.semver===Oe?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(te,he){return F(he,te)},e.major=function(te,he){return new M(te,he).major},e.minor=function(te,he){return new M(te,he).minor},e.patch=function(te,he){return new M(te,he).patch},e.compare=U,e.compareLoose=function(te,he){return U(te,he,!0)},e.rcompare=function(te,he,de){return U(he,te,de)},e.sort=function(te,he){return te.sort(function(de,be){return e.compare(de,be,he)})},e.rsort=function(te,he){return te.sort(function(de,be){return e.rcompare(de,be,he)})},e.gt=H,e.lt=x,e.eq=B,e.neq=_,e.gte=Z,e.lte=ae,e.cmp=ge,e.Comparator=ke;var Oe={};function De(te,he){if(te instanceof De)return te.loose===he?te:new De(te.raw,he);if(te instanceof ke)return new De(te.value,he);if(!(this instanceof De))return new De(te,he);if(this.loose=he,this.raw=te,this.set=te.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+te);this.format()}function Le(te){return!te||te.toLowerCase()==="x"||te==="*"}function ve(te,he,de,be,Pe,We,Te,qe,Ue,je,Xe,$e,Ke){return((he=Le(de)?"":Le(be)?">="+de+".0.0":Le(Pe)?">="+de+"."+be+".0":">="+he)+" "+(qe=Le(Ue)?"":Le(je)?"<"+(+Ue+1)+".0.0":Le(Xe)?"<"+Ue+"."+(+je+1)+".0":$e?"<="+Ue+"."+je+"."+Xe+"-"+$e:"<="+qe)).trim()}function we(te,he){for(var de=0;de<te.length;de++)if(!te[de].test(he))return!1;if(he.prerelease.length){for(de=0;de<te.length;de++)if(k(te[de].semver),te[de].semver!==Oe&&te[de].semver.prerelease.length>0){var be=te[de].semver;if(be.major===he.major&&be.minor===he.minor&&be.patch===he.patch)return!0}return!1}return!0}function ye(te,he,de){try{he=new De(he,de)}catch{return!1}return he.test(te)}function Me(te,he,de,be){var Pe,We,Te,qe,Ue;switch(te=new M(te,be),he=new De(he,be),de){case">":Pe=H,We=ae,Te=x,qe=">",Ue=">=";break;case"<":Pe=x,We=Z,Te=H,qe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(te,he,be))return!1;for(var je=0;je<he.set.length;++je){var Xe=he.set[je],$e=null,Ke=null;if(Xe.forEach(function(K){K.semver===Oe&&(K=new ke(">=0.0.0")),$e=$e||K,Ke=Ke||K,Pe(K.semver,$e.semver,be)?$e=K:Te(K.semver,Ke.semver,be)&&(Ke=K)}),$e.operator===qe||$e.operator===Ue||(!Ke.operator||Ke.operator===qe)&&We(te,Ke.semver)||Ke.operator===Ue&&Te(te,Ke.semver))return!1}return!0}ke.prototype.parse=function(te){var he=this.loose?P[le]:P[$],de=te.match(he);if(!de)throw new TypeError("Invalid comparator: "+te);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new M(de[2],this.loose):this.semver=Oe},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(te){return k("Comparator.test",te,this.loose),this.semver===Oe||(typeof te=="string"&&(te=new M(te,this.loose)),ge(te,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(te,he){if(!(te instanceof ke))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new De(te.value,he),ye(this.value,de,he);if(te.operator==="")return de=new De(this.value,he),ye(te.semver,de,he);var be=!(this.operator!==">="&&this.operator!==">"||te.operator!==">="&&te.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||te.operator!=="<="&&te.operator!=="<"),We=this.semver.version===te.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||te.operator!==">="&&te.operator!=="<="),qe=ge(this.semver,"<",te.semver,he)&&(this.operator===">="||this.operator===">")&&(te.operator==="<="||te.operator==="<"),Ue=ge(this.semver,">",te.semver,he)&&(this.operator==="<="||this.operator==="<")&&(te.operator===">="||te.operator===">");return be||Pe||We&&Te||qe||Ue},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(te){return te.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(te){var he=this.loose;te=te.trim(),k("range",te,he);var de=he?P[z]:P[T];te=te.replace(de,ve),k("hyphen replace",te),te=te.replace(P[W],"$1$2$3"),k("comparator trim",te,P[W]),te=(te=(te=te.replace(P[oe],"$1~")).replace(P[re],"$1^")).split(/\s+/).join(" ");var be=he?P[le]:P[$],Pe=te.split(" ").map(function(We){return function(Te,qe){return k("comp",Te),Te=function(Ue,je){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){k("caret",$e,Ke);var K=Ke?P[J]:P[fe];return $e.replace(K,function(ce,ue,me,Se,Ae){var Be;return k("caret",$e,ce,ue,me,Se,Ae),Le(ue)?Be="":Le(me)?Be=">="+ue+".0.0 <"+(+ue+1)+".0.0":Le(Se)?Be=ue==="0"?">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+".0 <"+(+ue+1)+".0.0":Ae?(k("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Be=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+Ae+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+Ae+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+Ae+" <"+(+ue+1)+".0.0"):(k("no pr"),Be=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+" <"+(+ue+1)+".0.0"),k("caret return",Be),Be})}(Xe,je)}).join(" ")}(Te,qe),k("caret",Te),Te=function(Ue,je){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){var K=Ke?P[Y]:P[X];return $e.replace(K,function(ce,ue,me,Se,Ae){var Be;return k("tilde",$e,ce,ue,me,Se,Ae),Le(ue)?Be="":Le(me)?Be=">="+ue+".0.0 <"+(+ue+1)+".0.0":Le(Se)?Be=">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":Ae?(k("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Be=">="+ue+"."+me+"."+Se+Ae+" <"+ue+"."+(+me+1)+".0"):Be=">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0",k("tilde return",Be),Be})}(Xe,je)}).join(" ")}(Te,qe),k("tildes",Te),Te=function(Ue,je){return k("replaceXRanges",Ue,je),Ue.split(/\s+/).map(function(Xe){return function($e,Ke){$e=$e.trim();var K=Ke?P[L]:P[D];return $e.replace(K,function(ce,ue,me,Se,Ae,Be){k("xRange",$e,ce,ue,me,Se,Ae,Be);var it=Le(me),xe=it||Le(Se),He=xe||Le(Ae);return ue==="="&&He&&(ue=""),it?ce=ue===">"||ue==="<"?"<0.0.0":"*":ue&&He?(xe&&(Se=0),He&&(Ae=0),ue===">"?(ue=">=",xe?(me=+me+1,Se=0,Ae=0):He&&(Se=+Se+1,Ae=0)):ue==="<="&&(ue="<",xe?me=+me+1:Se=+Se+1),ce=ue+me+"."+Se+"."+Ae):xe?ce=">="+me+".0.0 <"+(+me+1)+".0.0":He&&(ce=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),k("xRange return",ce),ce})}(Xe,je)}).join(" ")}(Te,qe),k("xrange",Te),Te=function(Ue,je){return k("replaceStars",Ue,je),Ue.trim().replace(P[Q],"")}(Te,qe),k("stars",Te),Te}(We,he)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(We){return!!We.match(be)})),Pe=Pe.map(function(We){return new ke(We,he)})},De.prototype.intersects=function(te,he){if(!(te instanceof De))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(be){return te.set.some(function(Pe){return Pe.every(function(We){return be.intersects(We,he)})})})})},e.toComparators=function(te,he){return new De(te,he).set.map(function(de){return de.map(function(be){return be.value}).join(" ").trim().split(" ")})},De.prototype.test=function(te){if(!te)return!1;typeof te=="string"&&(te=new M(te,this.loose));for(var he=0;he<this.set.length;he++)if(we(this.set[he],te))return!0;return!1},e.satisfies=ye,e.maxSatisfying=function(te,he,de){var be=null,Pe=null;try{var We=new De(he,de)}catch{return null}return te.forEach(function(Te){We.test(Te)&&(be&&Pe.compare(Te)!==-1||(Pe=new M(be=Te,de)))}),be},e.minSatisfying=function(te,he,de){var be=null,Pe=null;try{var We=new De(he,de)}catch{return null}return te.forEach(function(Te){We.test(Te)&&(be&&Pe.compare(Te)!==1||(Pe=new M(be=Te,de)))}),be},e.validRange=function(te,he){try{return new De(te,he).range||"*"}catch{return null}},e.ltr=function(te,he,de){return Me(te,he,"<",de)},e.gtr=function(te,he,de){return Me(te,he,">",de)},e.outside=Me,e.prerelease=function(te,he){var de=j(te,he);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(te,he,de){return te=new De(te,de),he=new De(he,de),te.intersects(he)},e.coerce=function(te){if(te instanceof M)return te;if(typeof te!="string")return null;var he=te.match(P[N]);return he==null?null:j((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,E(1))},function(G,e){var E,t,k=G.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(h){if(E===setTimeout)return setTimeout(h,0);if((E===R||!E)&&setTimeout)return E=setTimeout,setTimeout(h,0);try{return E(h,0)}catch{try{return E.call(null,h,0)}catch{return E.call(this,h,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:R}catch{E=R}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var w,g=[],b=!1,S=-1;function y(){b&&w&&(b=!1,w.length?g=w.concat(g):S=-1,g.length&&u())}function u(){if(!b){var h=P(y);b=!0;for(var l=g.length;l;){for(w=g,g=[];++S<l;)w&&w[S].run();S=-1,l=g.length}w=null,b=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(h)}}function f(h,l){this.fun=h,this.array=l}function p(){}k.nextTick=function(h){var l=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)l[v-1]=arguments[v];g.push(new f(h,l)),g.length!==1||b||P(u)},f.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=p,k.addListener=p,k.once=p,k.off=p,k.removeListener=p,k.removeAllListeners=p,k.emit=p,k.prependListener=p,k.prependOnceListener=p,k.listeners=function(h){return[]},k.binding=function(h){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(h){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ie[126],ne([0,1]),function(G,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(P,w,g){this.level=P,this.key=w,this.value=g,this.forward=[]}}const k=void 0;class R{constructor(P,w=2**16){this.comparator=P,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new t(this.c,k,k)}get size(){return this.f}clear(){this.e=new t(this.c,k,k)}has(P){return Boolean(R.g(this,P,this.comparator))}get(P){return R.g(this,P,this.comparator)?.value}set(P,w){return R.h(this,P,w,this.comparator)&&(this.f+=1),this}delete(P){const w=R.k(this,P,this.comparator);return w&&(this.f-=1),w}forEach(P,w){let g=this.e.forward[0];for(;g;)P.call(w,g.value,g.key,this),g=g.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",w=this.e.forward[0];for(;w;)P+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return P}static g(P,w,g){let b=P.e;for(let S=P.d-1;S>=0;S--)for(;b.forward[S]&&g(b.forward[S].key,w)<0;)b=b.forward[S];if(b=b.forward[0],b&&g(b.key,w)===0)return b}static h(P,w,g,b){const S=[];let y=P.e;for(let u=P.d-1;u>=0;u--){for(;y.forward[u]&&b(y.forward[u].key,w)<0;)y=y.forward[u];S[u]=y}if(y=y.forward[0],y&&b(y.key,w)===0)return y.value=g,!1;{const u=R.j(P);if(u>P.d){for(let f=P.d;f<u;f++)S[f]=P.e;P.d=u}y=new t(u,w,g);for(let f=0;f<u;f++)y.forward[f]=S[f].forward[f],S[f].forward[f]=y;return!0}}static j(P,w=.5){let g=1;for(;Math.random()<w&&g<P.c;)g+=1;return g}static k(P,w,g){const b=[];let S=P.e;for(let y=P.d-1;y>=0;y--){for(;S.forward[y]&&g(S.forward[y].key,w)<0;)S=S.forward[y];b[y]=S}if(S=S.forward[0],!S||g(S.key,w)!==0)return!1;for(let y=0;y<P.d&&b[y].forward[y]===S;y++)b[y].forward[y]=S.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===k;)P.d-=1;return!0}}e.SkipList=R}),define(ie[59],ne([0,1,15,2]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(I){const m=I;return m?typeof m.read=="function":!1}e.isReadable=k;function R(I){const m=I;return m?[m.on,m.pause,m.resume,m.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function A(I){const m=I;return m?R(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=A;function P(I,m){return new w(I,m)}e.newWriteableStream=P;class w{constructor(m,i){this.e=m,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(i=>i(m))}h(m){this.c.error.length===0?(0,E.onUnexpectedError)(m):this.c.error.slice(0).forEach(i=>i(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,i){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(m,i){if(this.a.destroyed)return;let n;switch(m){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(i);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(I,m){const i=[];let n;for(;(n=I.read())!==null;)i.push(n);return m(i)}e.consumeReadable=g;function b(I,m,i){const n=[];let r;for(;(r=I.read())!==null&&n.length<i;)n.push(r);return r===null&&n.length>0?m(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const a=r;return r=void 0,a}return I.read()}}}e.peekReadable=b;function S(I,m){return new Promise((i,n)=>{const r=[];y(I,{onData:a=>{m&&r.push(a)},onError:a=>{m?n(a):i(void 0)},onEnd:()=>{i(m?m(r):void 0)}})})}e.consumeStream=S;function y(I,m){let i=!1;return I.on("error",n=>{i||m.onError(n)}),I.on("end",()=>{i||m.onEnd()}),I.on("data",n=>{i||m.onData(n)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=y;function u(I,m){return new Promise((i,n)=>{const r=new t.DisposableStore,a=[],s=d=>{if(a.push(d),a.length>m)return r.dispose(),I.pause(),i({stream:I,buffer:a,ended:!1})},c=d=>n(d),o=()=>i({stream:I,buffer:a,ended:!0});r.add((0,t.toDisposable)(()=>I.removeListener("error",c))),I.on("error",c),r.add((0,t.toDisposable)(()=>I.removeListener("end",o))),I.on("end",o),r.add((0,t.toDisposable)(()=>I.removeListener("data",s))),I.on("data",s)})}e.peekStream=u;function f(I,m){const i=P(m);return i.end(I),i}e.toStream=f;function p(){const I=P(()=>{throw new Error("not supported")});return I.end(),I}e.emptyStream=p;function h(I){let m=!1;return{read:()=>m?null:(m=!0,I)}}e.toReadable=h;function l(I,m,i){const n=P(i);return y(I,{onData:r=>n.write(m.data(r)),onError:r=>n.error(m.error?m.error(r):r),onEnd:()=>n.end()}),n}e.transform=l;function v(I,m,i){let n=!1;return{read:()=>{const r=m.read();return n?r:(n=!0,r!==null?i([I,r]):I)}}}e.prefixedReadable=v;function C(I,m,i){let n=!1;const r=P(i);return y(m,{onData:a=>n?r.write(a):(n=!0,r.write(i([I,a]))),onError:a=>r.error(a),onEnd:()=>{n||(n=!0,r.write(I)),r.end()}}),r}e.prefixedStream=C}),define(ie[17],ne([0,1,59]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class A{static alloc(d){return t?new A(Buffer.allocUnsafe(d)):new A(new Uint8Array(d))}static wrap(d){return t&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new A(d)}static fromString(d,D){return!(D?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(d)):(k||(k=new TextEncoder),new A(k.encode(d)))}static fromByteArray(d){const D=A.alloc(d.length);for(let L=0,N=d.length;L<N;L++)D.buffer[L]=d[L];return D}static concat(d,D){if(typeof D>"u"){D=0;for(let V=0,oe=d.length;V<oe;V++)D+=d[V].byteLength}const L=A.alloc(D);let N=0;for(let V=0,oe=d.length;V<oe;V++){const X=d[V];L.set(X,N),N+=X.byteLength}return L}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=A.alloc(this.byteLength);return d.set(this),d}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(d,D){return new A(this.buffer.subarray(d,D))}set(d,D){if(d instanceof A)this.buffer.set(d.buffer,D);else if(d instanceof Uint8Array)this.buffer.set(d,D);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),D);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return g(this.buffer,d)}writeUInt32BE(d,D){b(this.buffer,d,D)}readUInt32LE(d){return S(this.buffer,d)}writeUInt32LE(d,D){y(this.buffer,d,D)}readUInt8(d){return u(this.buffer,d)}writeUInt8(d,D){f(this.buffer,d,D)}}e.VSBuffer=A;function P(o,d){return o[d+0]<<0>>>0|o[d+1]<<8>>>0}e.readUInt16LE=P;function w(o,d,D){o[D+0]=d&255,d=d>>>8,o[D+1]=d&255}e.writeUInt16LE=w;function g(o,d){return o[d]*2**24+o[d+1]*2**16+o[d+2]*2**8+o[d+3]}e.readUInt32BE=g;function b(o,d,D){o[D+3]=d,d=d>>>8,o[D+2]=d,d=d>>>8,o[D+1]=d,d=d>>>8,o[D]=d}e.writeUInt32BE=b;function S(o,d){return o[d+0]<<0>>>0|o[d+1]<<8>>>0|o[d+2]<<16>>>0|o[d+3]<<24>>>0}e.readUInt32LE=S;function y(o,d,D){o[D+0]=d&255,d=d>>>8,o[D+1]=d&255,d=d>>>8,o[D+2]=d&255,d=d>>>8,o[D+3]=d&255}e.writeUInt32LE=y;function u(o,d){return o[d]}e.readUInt8=u;function f(o,d,D){o[D]=d}e.writeUInt8=f;function p(o){return E.consumeReadable(o,d=>A.concat(d))}e.readableToBuffer=p;function h(o){return E.toReadable(o)}e.bufferToReadable=h;function l(o){return E.consumeStream(o,d=>A.concat(d))}e.streamToBuffer=l;async function v(o){return o.ended?A.concat(o.buffer):A.concat([...o.buffer,await l(o.stream)])}e.bufferedStreamToBuffer=v;function C(o){return E.toStream(o,d=>A.concat(d))}e.bufferToStream=C;function I(o){return E.transform(o,{data:d=>typeof d=="string"?A.fromString(d):A.wrap(d)},d=>A.concat(d))}e.streamToBufferReadableStream=I;function m(o){return E.newWriteableStream(d=>A.concat(d),o)}e.newWriteableBufferStream=m;function i(o,d){return E.prefixedReadable(o,d,D=>A.concat(D))}e.prefixedBufferReadable=i;function n(o,d){return E.prefixedStream(o,d,D=>A.concat(D))}e.prefixedBufferStream=n;function r(o){let d=0,D=0,L=0;const N=new Uint8Array(Math.floor(o.length/4*3)),V=X=>{switch(D){case 3:N[L++]=d|X,D=0;break;case 2:N[L++]=d|X>>>2,d=X<<6,D=3;break;case 1:N[L++]=d|X>>>4,d=X<<4,D=2;break;default:d=X<<2,D=1}};for(let X=0;X<o.length;X++){const Y=o.charCodeAt(X);if(Y>=65&&Y<=90)V(Y-65);else if(Y>=97&&Y<=122)V(Y-97+26);else if(Y>=48&&Y<=57)V(Y-48+52);else if(Y===43||Y===45)V(62);else if(Y===47||Y===95)V(63);else{if(Y===61)break;throw new SyntaxError(`Unexpected base64 character ${o[X]}`)}}const oe=L;for(;D>0;)V(0);return A.wrap(N).slice(0,oe)}e.decodeBase64=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},d=!0,D=!1){const L=D?s:a;let N="";const V=o.byteLength%3;let oe=0;for(;oe<o.byteLength-V;oe+=3){const X=o[oe+0],Y=o[oe+1],se=o[oe+2];N+=L[X>>>2],N+=L[(X<<4|Y>>>4)&63],N+=L[(Y<<2|se>>>6)&63],N+=L[se&63]}if(V===1){const X=o[oe+0];N+=L[X>>>2],N+=L[X<<4&63],d&&(N+="==")}else if(V===2){const X=o[oe+0],Y=o[oe+1];N+=L[X>>>2],N+=L[(X<<4|Y>>>4)&63],N+=L[Y<<2&63],d&&(N+="=")}return N}e.encodeBase64=c}),define(ie[11],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(n){return typeof n=="string"}e.isString=E;function t(n){return Array.isArray(n)&&n.every(r=>E(r))}e.isStringArray=t;function k(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=k;function R(n){const r=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof r}e.isTypedArray=R;function A(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=A;function P(n){return!!n&&typeof n[Symbol.iterator]=="function"}e.isIterable=P;function w(n){return n===!0||n===!1}e.isBoolean=w;function g(n){return typeof n>"u"}e.isUndefined=g;function b(n){return!S(n)}e.isDefined=b;function S(n){return g(n)||n===null}e.isUndefinedOrNull=S;function y(n,r){if(!n)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=y;function u(n){if(S(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=u;function f(...n){const r=[];for(let a=0;a<n.length;a++){const s=n[a];if(S(s))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);r.push(s)}return r}e.assertAllDefined=f;const p=Object.prototype.hasOwnProperty;function h(n){if(!k(n))return!1;for(const r in n)if(p.call(n,r))return!1;return!0}e.isEmptyObject=h;function l(n){return typeof n=="function"}e.isFunction=l;function v(...n){return n.length>0&&n.every(l)}e.areFunctions=v;function C(n,r){const a=Math.min(n.length,r.length);for(let s=0;s<a;s++)I(n[s],r[s])}e.validateConstraints=C;function I(n,r){if(E(r)){if(typeof n!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(l(r)){try{if(n instanceof r)return}catch{}if(!S(n)&&n.constructor===r||r.length===1&&r.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=I;function m(n){return n===null?void 0:n}e.withNullAsUndefined=m;function i(n){return typeof n>"u"?null:n}e.withUndefinedAsNull=i}),define(ie[44],ne([0,1,11]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const v=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([C,I])=>{v[C]=I&&typeof I=="object"?t(I):I}),v}e.deepClone=t;function k(l){if(!l||typeof l!="object")return l;const v=[l];for(;v.length>0;){const C=v.shift();Object.freeze(C);for(const I in C)if(R.call(C,I)){const m=C[I];typeof m=="object"&&!Object.isFrozen(m)&&!(0,E.isTypedArray)(m)&&v.push(m)}}return l}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function A(l,v){return P(l,v,new Set)}e.cloneAndChange=A;function P(l,v,C){if((0,E.isUndefinedOrNull)(l))return l;const I=v(l);if(typeof I<"u")return I;if(Array.isArray(l)){const m=[];for(const i of l)m.push(P(i,v,C));return m}if((0,E.isObject)(l)){if(C.has(l))throw new Error("Cannot clone recursive data-structure");C.add(l);const m={};for(const i in l)R.call(l,i)&&(m[i]=P(l[i],v,C));return C.delete(l),m}return l}function w(l,v,C=!0){return(0,E.isObject)(l)?((0,E.isObject)(v)&&Object.keys(v).forEach(I=>{I in l?C&&((0,E.isObject)(l[I])&&(0,E.isObject)(v[I])?w(l[I],v[I],C):l[I]=v[I]):l[I]=v[I]}),l):v}e.mixin=w;function g(l,v){if(l===v)return!0;if(l==null||v===null||v===void 0||typeof l!=typeof v||typeof l!="object"||Array.isArray(l)!==Array.isArray(v))return!1;let C,I;if(Array.isArray(l)){if(l.length!==v.length)return!1;for(C=0;C<l.length;C++)if(!g(l[C],v[C]))return!1}else{const m=[];for(I in l)m.push(I);m.sort();const i=[];for(I in v)i.push(I);if(i.sort(),!g(m,i))return!1;for(C=0;C<m.length;C++)if(!g(l[m[C]],v[m[C]]))return!1}return!0}e.equals=g;function b(l){const v=new Set;return JSON.stringify(l,(C,I)=>{if((0,E.isObject)(I)||Array.isArray(I)){if(v.has(I))return"[Circular]";v.add(I)}return I})}e.safeStringify=b;function S(l,v){const C=Object.create(null);return!l||!v||Object.keys(v).forEach(m=>{const i=l[m],n=v[m];g(i,n)||(C[m]=n)}),C}e.distinct=S;function y(l,v){const C=v.toLowerCase(),I=Object.keys(l).find(m=>m.toLowerCase()===C);return I?l[I]:l[v]}e.getCaseInsensitive=y;function u(l,v){const C=Object.create(null);for(const[I,m]of Object.entries(l))v(I,m)&&(C[I]=m);return C}e.filter=u;function f(l){let v=[],C=Object.getPrototypeOf(l);for(;Object.prototype!==C;)v=v.concat(Object.getOwnPropertyNames(C)),C=Object.getPrototypeOf(C);return v}e.getAllPropertyNames=f;function p(l){const v=[];for(const C of f(l))typeof l[C]=="function"&&v.push(C);return v}e.getAllMethodNames=p;function h(l,v){const C=m=>function(){const i=Array.prototype.slice.call(arguments,0);return v(m,i)},I={};for(const m of l)I[m]=C(m);return I}e.createProxyObject=h}),define(ie[29],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return E.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(P){for(let w=0;w<P.length;w++)P[w]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let w=0,g="";return g+=A[R[w++]],g+=A[R[w++]],g+=A[R[w++]],g+=A[R[w++]],g+="-",g+=A[R[w++]],g+=A[R[w++]],g+="-",g+=A[R[w++]],g+=A[R[w++]],g+="-",g+=A[R[w++]],g+=A[R[w++]],g+="-",g+=A[R[w++]],g+=A[R[w++]],g+=A[R[w++]],g+=A[R[w++]],g+=A[R[w++]],g+=A[R[w++]],g}}()}),define(ie[127],ne([0,1,77,40,50]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(A,P){if(await new Promise((b,S)=>{const y=t.createReadStream(A),u=E.createHash("sha1");y.pipe(u);const f=(0,k.once)((p,h)=>{y.removeAllListeners(),u.removeAllListeners(),p?S(p):b(h)});y.once("error",f),y.once("end",f),u.once("error",f),u.once("data",p=>f(void 0,p.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=R}),define(ie[128],ne([0,1,25]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const P=A.replace(/\-/g,":").toLowerCase();return!t.has(P)}function R(){const A=(0,E.networkInterfaces)();for(const P in A){const w=A[P];if(w){for(const{mac:g}of w)if(k(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(ie[97],ne([0,1,78]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(P,w,g,b=1){let S=!1;return new Promise(y=>{const u=setTimeout(()=>{if(!S)return S=!0,y(0)},g);k(P,w,b,f=>{if(!S)return S=!0,clearTimeout(u),y(f)})})}e.findFreePort=t;function k(P,w,g,b){if(w===0)return b(0);const S=new E.Socket;S.once("connect",()=>(A(S),k(P+g,w-1,g,b))),S.once("data",()=>{}),S.once("error",y=>(A(S),y.code!=="ECONNREFUSED"?k(P+g,w-1,g,b):b(P))),S.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(P,w,g,b="127.0.0.1"){let S=!1,y,u=1;const f=E.createServer({pauseOnConnect:!0});function p(h,l){S||(S=!0,f.removeAllListeners(),f.close(),y&&clearTimeout(y),l(h))}return new Promise(h=>{y=setTimeout(()=>{p(0,h)},g),f.on("listening",()=>{p(P,h)}),f.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&u<w?(P++,u++,f.listen(P,b)):p(0,h)}),f.on("close",()=>{p(0,h)}),f.listen(P,b)})}e.findFreePortFaster=R;function A(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(w){console.error(w)}}}),define(ie[129],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ie[130],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(k,R){this.a=k,this.onMessage=R}send(k){try{this.a.send("vscode:message",k.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=E}),define(ie[41],ne([0,1,13,15]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.a=new WeakMap}on(A,P){const w=(g,...b)=>{this.b(A,g)&&P(g,...b)};return this.a.set(P,w),E.ipcMain.on(A,w),this}once(A,P){return E.ipcMain.once(A,(w,...g)=>{this.b(A,w)&&P(w,...g)}),this}handle(A,P){return E.ipcMain.handle(A,(w,...g)=>this.b(A,w)?P(w,...g):Promise.reject(`Invalid channel '${A}' or sender for ipcMain.handle() usage.`)),this}removeHandler(A){return E.ipcMain.removeHandler(A),this}removeListener(A,P){const w=this.a.get(P);return w&&(E.ipcMain.removeListener(A,w),this.a.delete(P)),this}b(A,P){if(!A||!A.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because the channel is unknown.`),!1;const w=P.senderFrame,g=w.url;if(!g)return!0;let b="unknown";try{b=new URL(g).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a malformed URL '${g}'.`),!1}return b!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a bad origin of '${b}'.`),!1):w.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(ie[131],ne([0,1,13,41,11,129]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function A(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(w,g,b,S,y)=>{const u=P(w,S,b);u.popup({window:(0,k.withNullAsUndefined)(E.BrowserWindow.fromWebContents(w.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{u&&w.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,g)}})})}e.registerContextMenuListener=A;function P(w,g,b){const S=new E.Menu;return b.forEach(y=>{let u;y.type==="separator"?u=new E.MenuItem({type:y.type}):Array.isArray(y.submenu)?u=new E.MenuItem({submenu:P(w,g,y.submenu),label:y.label}):u=new E.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(f,p,h)=>w.sender.send(g,y.id,h)}),S.append(u)}),S}}),define(ie[132],ne([12,10]),function(G,e){return G.create("vs/base/common/date",e)}),define(ie[133],ne([0,1,132]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,A=R*7,P=R*30,w=R*365;function g(S,y,u){typeof S!="number"&&(S=S.getTime());const f=Math.round((new Date().getTime()-S)/1e3);if(f<-30)return(0,E.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(f<30)return(0,E.localize)(1,null);let p;return f<t?(p=f,y?p===1?u?(0,E.localize)(2,null,p):(0,E.localize)(3,null,p):u?(0,E.localize)(4,null,p):(0,E.localize)(5,null,p):p===1?u?(0,E.localize)(6,null,p):(0,E.localize)(7,null,p):u?(0,E.localize)(8,null,p):(0,E.localize)(9,null,p)):f<k?(p=Math.floor(f/t),y?p===1?u?(0,E.localize)(10,null,p):(0,E.localize)(11,null,p):u?(0,E.localize)(12,null,p):(0,E.localize)(13,null,p):p===1?u?(0,E.localize)(14,null,p):(0,E.localize)(15,null,p):u?(0,E.localize)(16,null,p):(0,E.localize)(17,null,p)):f<R?(p=Math.floor(f/k),y?p===1?u?(0,E.localize)(18,null,p):(0,E.localize)(19,null,p):u?(0,E.localize)(20,null,p):(0,E.localize)(21,null,p):p===1?u?(0,E.localize)(22,null,p):(0,E.localize)(23,null,p):u?(0,E.localize)(24,null,p):(0,E.localize)(25,null,p)):f<A?(p=Math.floor(f/R),y?p===1?(0,E.localize)(26,null,p):(0,E.localize)(27,null,p):p===1?(0,E.localize)(28,null,p):(0,E.localize)(29,null,p)):f<P?(p=Math.floor(f/A),y?p===1?u?(0,E.localize)(30,null,p):(0,E.localize)(31,null,p):u?(0,E.localize)(32,null,p):(0,E.localize)(33,null,p):p===1?u?(0,E.localize)(34,null,p):(0,E.localize)(35,null,p):u?(0,E.localize)(36,null,p):(0,E.localize)(37,null,p)):f<w?(p=Math.floor(f/P),y?p===1?u?(0,E.localize)(38,null,p):(0,E.localize)(39,null,p):u?(0,E.localize)(40,null,p):(0,E.localize)(41,null,p):p===1?u?(0,E.localize)(42,null,p):(0,E.localize)(43,null,p):u?(0,E.localize)(44,null,p):(0,E.localize)(45,null,p)):(p=Math.floor(f/w),y?p===1?u?(0,E.localize)(46,null,p):(0,E.localize)(47,null,p):u?(0,E.localize)(48,null,p):(0,E.localize)(49,null,p):p===1?u?(0,E.localize)(50,null,p):(0,E.localize)(51,null,p):u?(0,E.localize)(52,null,p):(0,E.localize)(53,null,p))}e.fromNow=g;function b(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ie[134],ne([12,10]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ie[45],ne([0,1,24,11,134]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(S,y){return y&&(S.stack||S.stacktrace)?k.localize(0,null,P(S),A(S.stack)||A(S.stacktrace)):P(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function P(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?k.localize(1,null,S.message):S.message||k.localize(2,null)}function w(S=null,y=!1){if(!S)return k.localize(3,null);if(Array.isArray(S)){const u=E.coalesce(S),f=w(u[0],y);return u.length>1?k.localize(4,null,f,u.length):f}if(t.isString(S))return S;if(S.detail){const u=S.detail;if(u.error)return R(u.error,y);if(u.exception)return R(u.exception,y)}return S.stack?R(S,y):S.message?S.message:k.localize(5,null)}e.toErrorMessage=w;function g(S){const y=S;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=g;function b(S,y){let u;return typeof S=="string"?u=new Error(S):u=S,u.actions=y,u}e.createErrorWithActions=b}),define(ie[135],ne([12,10]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(ie[136],ne([0,1,135]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ie[137],ne([12,10]),function(G,e){return G.create("vs/base/common/platform",e)}),define(ie[4],ne([0,1,137]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,R=!1,A=!1,P=!1,w=!1,g=!1,b=!1,S=!1,y=!1,u,f=e.LANGUAGE_DEFAULT,p,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const v=typeof l?.versions?.electron=="string",C=v&&l?.type==="renderer";if(typeof navigator=="object"&&!C)h=navigator.userAgent,t=h.indexOf("Windows")>=0,k=h.indexOf("Macintosh")>=0,b=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=h.indexOf("Linux")>=0,y=h?.indexOf("Mobi")>=0,w=!0,u=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,f=u;else if(typeof l=="object"){t=l.platform==="win32",k=l.platform==="darwin",R=l.platform==="linux",A=R&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,g=v,S=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const o=l.env.VSCODE_NLS_CONFIG;if(o)try{const d=JSON.parse(o),D=d.availableLanguages["*"];u=d.locale,f=D||e.LANGUAGE_DEFAULT,p=d._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var I;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function m(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let i=0;k?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=R,e.isLinuxSnap=A,e.isNative=P,e.isElectron=g,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=y,e.isCI=S,e.platform=i,e.userAgent=h,e.language=f;var n;(function(o){function d(){return e.language}o.value=d;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=D;function L(){return e.language==="en"}o.isDefault=L})(n=e.Language||(e.Language={})),e.locale=u,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let L=0,N=o.length;L<N;L++){const V=o[L];if(V.id===D.data.vscodeScheduleAsyncWork){o.splice(L,1),V.callback();return}}});let d=0;return D=>{const L=++d;o.push({id:L,callback:D}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return o=>setTimeout(o)})();var r;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||b?2:t?1:3;let a=!0,s=!1;function c(){if(!s){s=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ie[33],ne([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const k=E.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ie[9],ne([0,1,33]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,A=122,P=46,w=47,g=92,b=58,S=63;class y extends Error{constructor(n,r,a){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const c=n.indexOf(".")!==-1?"property":"argument";let o=`The "${n}" ${c} ${s} of type ${r}`;o+=`. Received type ${typeof a}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function u(i,n){if(i===null||typeof i!="object")throw new y(n,"Object",i)}function f(i,n){if(typeof i!="string")throw new y(n,"string",i)}const p=E.platform==="win32";function h(i){return i===w||i===g}function l(i){return i===w}function v(i){return i>=t&&i<=R||i>=k&&i<=A}function C(i,n,r,a){let s="",c=0,o=-1,d=0,D=0;for(let L=0;L<=i.length;++L){if(L<i.length)D=i.charCodeAt(L);else{if(a(D))break;D=w}if(a(D)){if(!(o===L-1||d===1))if(d===2){if(s.length<2||c!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const N=s.lastIndexOf(r);N===-1?(s="",c=0):(s=s.slice(0,N),c=s.length-1-s.lastIndexOf(r)),o=L,d=0;continue}else if(s.length!==0){s="",c=0,o=L,d=0;continue}}n&&(s+=s.length>0?`${r}..`:"..",c=2)}else s.length>0?s+=`${r}${i.slice(o+1,L)}`:s=i.slice(o+1,L),c=L-o-1;o=L,d=0}else D===P&&d!==-1?++d:d=-1}return s}function I(i,n){u(n,"pathObject");const r=n.dir||n.root,a=n.base||`${n.name||""}${n.ext||""}`;return r?r===n.root?`${r}${a}`:`${r}${i}${a}`:a}e.win32={resolve(...i){let n="",r="",a=!1;for(let s=i.length-1;s>=-1;s--){let c;if(s>=0){if(c=i[s],f(c,"path"),c.length===0)continue}else n.length===0?c=E.cwd():(c=E.env[`=${n}`]||E.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==n.toLowerCase()&&c.charCodeAt(2)===g)&&(c=`${n}\\`));const o=c.length;let d=0,D="",L=!1;const N=c.charCodeAt(0);if(o===1)h(N)&&(d=1,L=!0);else if(h(N))if(L=!0,h(c.charCodeAt(1))){let V=2,oe=V;for(;V<o&&!h(c.charCodeAt(V));)V++;if(V<o&&V!==oe){const X=c.slice(oe,V);for(oe=V;V<o&&h(c.charCodeAt(V));)V++;if(V<o&&V!==oe){for(oe=V;V<o&&!h(c.charCodeAt(V));)V++;(V===o||V!==oe)&&(D=`\\\\${X}\\${c.slice(oe,V)}`,d=V)}}}else d=1;else v(N)&&c.charCodeAt(1)===b&&(D=c.slice(0,2),d=2,o>2&&h(c.charCodeAt(2))&&(L=!0,d=3));if(D.length>0)if(n.length>0){if(D.toLowerCase()!==n.toLowerCase())continue}else n=D;if(a){if(n.length>0)break}else if(r=`${c.slice(d)}\\${r}`,a=L,L&&n.length>0)break}return r=C(r,!a,"\\",h),a?`${n}\\${r}`:`${n}${r}`||"."},normalize(i){f(i,"path");const n=i.length;if(n===0)return".";let r=0,a,s=!1;const c=i.charCodeAt(0);if(n===1)return l(c)?"\\":i;if(h(c))if(s=!0,h(i.charCodeAt(1))){let d=2,D=d;for(;d<n&&!h(i.charCodeAt(d));)d++;if(d<n&&d!==D){const L=i.slice(D,d);for(D=d;d<n&&h(i.charCodeAt(d));)d++;if(d<n&&d!==D){for(D=d;d<n&&!h(i.charCodeAt(d));)d++;if(d===n)return`\\\\${L}\\${i.slice(D)}\\`;d!==D&&(a=`\\\\${L}\\${i.slice(D,d)}`,r=d)}}}else r=1;else v(c)&&i.charCodeAt(1)===b&&(a=i.slice(0,2),r=2,n>2&&h(i.charCodeAt(2))&&(s=!0,r=3));let o=r<n?C(i.slice(r),!s,"\\",h):"";return o.length===0&&!s&&(o="."),o.length>0&&h(i.charCodeAt(n-1))&&(o+="\\"),a===void 0?s?`\\${o}`:o:s?`${a}\\${o}`:`${a}${o}`},isAbsolute(i){f(i,"path");const n=i.length;if(n===0)return!1;const r=i.charCodeAt(0);return h(r)||n>2&&v(r)&&i.charCodeAt(1)===b&&h(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let n,r;for(let c=0;c<i.length;++c){const o=i[c];f(o,"path"),o.length>0&&(n===void 0?n=r=o:n+=`\\${o}`)}if(n===void 0)return".";let a=!0,s=0;if(typeof r=="string"&&h(r.charCodeAt(0))){++s;const c=r.length;c>1&&h(r.charCodeAt(1))&&(++s,c>2&&(h(r.charCodeAt(2))?++s:a=!1))}if(a){for(;s<n.length&&h(n.charCodeAt(s));)s++;s>=2&&(n=`\\${n.slice(s)}`)}return e.win32.normalize(n)},relative(i,n){if(f(i,"from"),f(n,"to"),i===n)return"";const r=e.win32.resolve(i),a=e.win32.resolve(n);if(r===a||(i=r.toLowerCase(),n=a.toLowerCase(),i===n))return"";let s=0;for(;s<i.length&&i.charCodeAt(s)===g;)s++;let c=i.length;for(;c-1>s&&i.charCodeAt(c-1)===g;)c--;const o=c-s;let d=0;for(;d<n.length&&n.charCodeAt(d)===g;)d++;let D=n.length;for(;D-1>d&&n.charCodeAt(D-1)===g;)D--;const L=D-d,N=o<L?o:L;let V=-1,oe=0;for(;oe<N;oe++){const Y=i.charCodeAt(s+oe);if(Y!==n.charCodeAt(d+oe))break;Y===g&&(V=oe)}if(oe!==N){if(V===-1)return a}else{if(L>N){if(n.charCodeAt(d+oe)===g)return a.slice(d+oe+1);if(oe===2)return a.slice(d+oe)}o>N&&(i.charCodeAt(s+oe)===g?V=oe:oe===2&&(V=3)),V===-1&&(V=0)}let X="";for(oe=s+V+1;oe<=c;++oe)(oe===c||i.charCodeAt(oe)===g)&&(X+=X.length===0?"..":"\\..");return d+=V,X.length>0?`${X}${a.slice(d,D)}`:(a.charCodeAt(d)===g&&++d,a.slice(d,D))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const n=e.win32.resolve(i);if(n.length<=2)return i;if(n.charCodeAt(0)===g){if(n.charCodeAt(1)===g){const r=n.charCodeAt(2);if(r!==S&&r!==P)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(v(n.charCodeAt(0))&&n.charCodeAt(1)===b&&n.charCodeAt(2)===g)return`\\\\?\\${n}`;return i},dirname(i){f(i,"path");const n=i.length;if(n===0)return".";let r=-1,a=0;const s=i.charCodeAt(0);if(n===1)return h(s)?i:".";if(h(s)){if(r=a=1,h(i.charCodeAt(1))){let d=2,D=d;for(;d<n&&!h(i.charCodeAt(d));)d++;if(d<n&&d!==D){for(D=d;d<n&&h(i.charCodeAt(d));)d++;if(d<n&&d!==D){for(D=d;d<n&&!h(i.charCodeAt(d));)d++;if(d===n)return i;d!==D&&(r=a=d+1)}}}}else v(s)&&i.charCodeAt(1)===b&&(r=n>2&&h(i.charCodeAt(2))?3:2,a=r);let c=-1,o=!0;for(let d=n-1;d>=a;--d)if(h(i.charCodeAt(d))){if(!o){c=d;break}}else o=!1;if(c===-1){if(r===-1)return".";c=r}return i.slice(0,c)},basename(i,n){n!==void 0&&f(n,"ext"),f(i,"path");let r=0,a=-1,s=!0,c;if(i.length>=2&&v(i.charCodeAt(0))&&i.charCodeAt(1)===b&&(r=2),n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let o=n.length-1,d=-1;for(c=i.length-1;c>=r;--c){const D=i.charCodeAt(c);if(h(D)){if(!s){r=c+1;break}}else d===-1&&(s=!1,d=c+1),o>=0&&(D===n.charCodeAt(o)?--o===-1&&(a=c):(o=-1,a=d))}return r===a?a=d:a===-1&&(a=i.length),i.slice(r,a)}for(c=i.length-1;c>=r;--c)if(h(i.charCodeAt(c))){if(!s){r=c+1;break}}else a===-1&&(s=!1,a=c+1);return a===-1?"":i.slice(r,a)},extname(i){f(i,"path");let n=0,r=-1,a=0,s=-1,c=!0,o=0;i.length>=2&&i.charCodeAt(1)===b&&v(i.charCodeAt(0))&&(n=a=2);for(let d=i.length-1;d>=n;--d){const D=i.charCodeAt(d);if(h(D)){if(!c){a=d+1;break}continue}s===-1&&(c=!1,s=d+1),D===P?r===-1?r=d:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||s===-1||o===0||o===1&&r===s-1&&r===a+1?"":i.slice(r,s)},format:I.bind(null,"\\"),parse(i){f(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const r=i.length;let a=0,s=i.charCodeAt(0);if(r===1)return h(s)?(n.root=n.dir=i,n):(n.base=n.name=i,n);if(h(s)){if(a=1,h(i.charCodeAt(1))){let V=2,oe=V;for(;V<r&&!h(i.charCodeAt(V));)V++;if(V<r&&V!==oe){for(oe=V;V<r&&h(i.charCodeAt(V));)V++;if(V<r&&V!==oe){for(oe=V;V<r&&!h(i.charCodeAt(V));)V++;V===r?a=V:V!==oe&&(a=V+1)}}}}else if(v(s)&&i.charCodeAt(1)===b){if(r<=2)return n.root=n.dir=i,n;if(a=2,h(i.charCodeAt(2))){if(r===3)return n.root=n.dir=i,n;a=3}}a>0&&(n.root=i.slice(0,a));let c=-1,o=a,d=-1,D=!0,L=i.length-1,N=0;for(;L>=a;--L){if(s=i.charCodeAt(L),h(s)){if(!D){o=L+1;break}continue}d===-1&&(D=!1,d=L+1),s===P?c===-1?c=L:N!==1&&(N=1):c!==-1&&(N=-1)}return d!==-1&&(c===-1||N===0||N===1&&c===d-1&&c===o+1?n.base=n.name=i.slice(o,d):(n.name=i.slice(o,c),n.base=i.slice(o,d),n.ext=i.slice(c,d))),o>0&&o!==a?n.dir=i.slice(0,o-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(p){const i=/\\/g;return()=>{const n=E.cwd().replace(i,"/");return n.slice(n.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...i){let n="",r=!1;for(let a=i.length-1;a>=-1&&!r;a--){const s=a>=0?i[a]:m();f(s,"path"),s.length!==0&&(n=`${s}/${n}`,r=s.charCodeAt(0)===w)}return n=C(n,!r,"/",l),r?`/${n}`:n.length>0?n:"."},normalize(i){if(f(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===w,r=i.charCodeAt(i.length-1)===w;return i=C(i,!n,"/",l),i.length===0?n?"/":r?"./":".":(r&&(i+="/"),n?`/${i}`:i)},isAbsolute(i){return f(i,"path"),i.length>0&&i.charCodeAt(0)===w},join(...i){if(i.length===0)return".";let n;for(let r=0;r<i.length;++r){const a=i[r];f(a,"path"),a.length>0&&(n===void 0?n=a:n+=`/${a}`)}return n===void 0?".":e.posix.normalize(n)},relative(i,n){if(f(i,"from"),f(n,"to"),i===n||(i=e.posix.resolve(i),n=e.posix.resolve(n),i===n))return"";const r=1,a=i.length,s=a-r,c=1,o=n.length-c,d=s<o?s:o;let D=-1,L=0;for(;L<d;L++){const V=i.charCodeAt(r+L);if(V!==n.charCodeAt(c+L))break;V===w&&(D=L)}if(L===d)if(o>d){if(n.charCodeAt(c+L)===w)return n.slice(c+L+1);if(L===0)return n.slice(c+L)}else s>d&&(i.charCodeAt(r+L)===w?D=L:L===0&&(D=0));let N="";for(L=r+D+1;L<=a;++L)(L===a||i.charCodeAt(L)===w)&&(N+=N.length===0?"..":"/..");return`${N}${n.slice(c+D)}`},toNamespacedPath(i){return i},dirname(i){if(f(i,"path"),i.length===0)return".";const n=i.charCodeAt(0)===w;let r=-1,a=!0;for(let s=i.length-1;s>=1;--s)if(i.charCodeAt(s)===w){if(!a){r=s;break}}else a=!1;return r===-1?n?"/":".":n&&r===1?"//":i.slice(0,r)},basename(i,n){n!==void 0&&f(n,"ext"),f(i,"path");let r=0,a=-1,s=!0,c;if(n!==void 0&&n.length>0&&n.length<=i.length){if(n===i)return"";let o=n.length-1,d=-1;for(c=i.length-1;c>=0;--c){const D=i.charCodeAt(c);if(D===w){if(!s){r=c+1;break}}else d===-1&&(s=!1,d=c+1),o>=0&&(D===n.charCodeAt(o)?--o===-1&&(a=c):(o=-1,a=d))}return r===a?a=d:a===-1&&(a=i.length),i.slice(r,a)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===w){if(!s){r=c+1;break}}else a===-1&&(s=!1,a=c+1);return a===-1?"":i.slice(r,a)},extname(i){f(i,"path");let n=-1,r=0,a=-1,s=!0,c=0;for(let o=i.length-1;o>=0;--o){const d=i.charCodeAt(o);if(d===w){if(!s){r=o+1;break}continue}a===-1&&(s=!1,a=o+1),d===P?n===-1?n=o:c!==1&&(c=1):n!==-1&&(c=-1)}return n===-1||a===-1||c===0||c===1&&n===a-1&&n===r+1?"":i.slice(n,a)},format:I.bind(null,"/"),parse(i){f(i,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return n;const r=i.charCodeAt(0)===w;let a;r?(n.root="/",a=1):a=0;let s=-1,c=0,o=-1,d=!0,D=i.length-1,L=0;for(;D>=a;--D){const N=i.charCodeAt(D);if(N===w){if(!d){c=D+1;break}continue}o===-1&&(d=!1,o=D+1),N===P?s===-1?s=D:L!==1&&(L=1):s!==-1&&(L=-1)}if(o!==-1){const N=c===0&&r?1:c;s===-1||L===0||L===1&&s===o-1&&s===c+1?n.base=n.name=i.slice(N,o):(n.name=i.slice(N,s),n.base=i.slice(N,o),n.ext=i.slice(s,o))}return c>0?n.dir=i.slice(0,c-1):r&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(ie[79],ne([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...w){const g=w.reduce((y,u)=>(y[u]=!0,y),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!g[y]).forEach(y=>{for(let u=0;u<b.length;u++)if(y.search(b[u])!==-1){delete P[y];break}})}e.sanitizeProcessEnvironment=R;function A(P){!P||(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ie[80],ne([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=E.globals.performance&&typeof E.globals.performance.now=="function";class k{static create(A=!0){return new k(A)}constructor(A){this.a=t&&A,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ie[3],ne([0,1,15,50,2,96,80]),function(G,e,E,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,w=!1;var g;(function(c){c.None=()=>k.Disposable.None;function o(U){if(w){const{onDidAddListener:H}=U,x=f.create();let B=0;U.onDidAddListener=()=>{++B===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),x.print()),H?.()}}}function d(U,H){return re(U,()=>{},0,void 0,void 0,H)}c.defer=d;function D(U){return(H,x=null,B)=>{let _=!1,Z;return Z=U(ae=>{if(!_)return Z?Z.dispose():_=!0,H.call(x,ae)},null,B),_&&Z.dispose(),Z}}c.once=D;function L(U,H,x){return se((B,_=null,Z)=>U(ae=>B.call(_,H(ae)),null,Z),x)}c.map=L;function N(U,H,x){return se((B,_=null,Z)=>U(ae=>{H(ae),B.call(_,ae)},null,Z),x)}c.forEach=N;function V(U,H,x){return se((B,_=null,Z)=>U(ae=>H(ae)&&B.call(_,ae),null,Z),x)}c.filter=V;function oe(U){return U}c.signal=oe;function X(...U){return(H,x=null,B)=>(0,k.combinedDisposable)(...U.map(_=>_(Z=>H.call(x,Z),null,B)))}c.any=X;function Y(U,H,x,B){let _=x;return L(U,Z=>(_=H(_,Z),_),B)}c.reduce=Y;function se(U,H){let x;const B={onWillAddFirstListener(){x=U(_.fire,_)},onDidRemoveLastListener(){x?.dispose()}};H||o(B);const _=new h(B);return H?.add(_),_.event}function re(U,H,x=100,B=!1,_,Z){let ae,ge,ke,Oe=0;const De={leakWarningThreshold:_,onWillAddFirstListener(){ae=U(ve=>{Oe++,ge=H(ge,ve),B&&!ke&&(Le.fire(ge),ge=void 0),clearTimeout(ke),ke=setTimeout(()=>{const we=ge;ge=void 0,ke=void 0,(!B||Oe>1)&&Le.fire(we),Oe=0},x)})},onDidRemoveLastListener(){ae.dispose()}};Z||o(De);const Le=new h(De);return Z?.add(Le),Le.event}c.debounce=re;function fe(U,H=0,x){return c.debounce(U,(B,_)=>B?(B.push(_),B):[_],H,void 0,void 0,x)}c.accumulate=fe;function J(U,H=(B,_)=>B===_,x){let B=!0,_;return V(U,Z=>{const ae=B||!H(Z,_);return B=!1,_=Z,ae},x)}c.latch=J;function le(U,H,x){return[c.filter(U,H,x),c.filter(U,B=>!H(B),x)]}c.split=le;function $(U,H=!1,x=[]){let B=x.slice(),_=U(ge=>{B?B.push(ge):ae.fire(ge)});const Z=()=>{B?.forEach(ge=>ae.fire(ge)),B=null},ae=new h({onWillAddFirstListener(){_||(_=U(ge=>ae.fire(ge)))},onDidAddFirstListener(){B&&(H?setTimeout(Z):Z())},onDidRemoveLastListener(){_&&_.dispose(),_=null}});return ae.event}c.buffer=$;class W{constructor(H){this.event=H,this.c=new k.DisposableStore}map(H){return new W(L(this.event,H,this.c))}forEach(H){return new W(N(this.event,H,this.c))}filter(H){return new W(V(this.event,H,this.c))}reduce(H,x){return new W(Y(this.event,H,x,this.c))}latch(){return new W(J(this.event,void 0,this.c))}debounce(H,x=100,B=!1,_){return new W(re(this.event,H,x,B,_,this.c))}on(H,x,B){return this.event(H,x,B)}once(H,x,B){return D(this.event)(H,x,B)}dispose(){this.c.dispose()}}function T(U){return new W(U)}c.chain=T;function z(U,H,x=B=>B){const B=(...ge)=>ae.fire(x(...ge)),_=()=>U.on(H,B),Z=()=>U.removeListener(H,B),ae=new h({onWillAddFirstListener:_,onDidRemoveLastListener:Z});return ae.event}c.fromNodeEventEmitter=z;function Q(U,H,x=B=>B){const B=(...ge)=>ae.fire(x(...ge)),_=()=>U.addEventListener(H,B),Z=()=>U.removeEventListener(H,B),ae=new h({onWillAddFirstListener:_,onDidRemoveLastListener:Z});return ae.event}c.fromDOMEventEmitter=Q;function q(U){return new Promise(H=>D(U)(H))}c.toPromise=q;function j(U,H){return H(void 0),U(x=>H(x))}c.runAndSubscribe=j;function M(U,H){let x=null;function B(Z){x?.dispose(),x=new k.DisposableStore,H(Z,x)}B(void 0);const _=U(Z=>B(Z));return(0,k.toDisposable)(()=>{_.dispose(),x?.dispose()})}c.runAndSubscribeWithStore=M;class O{constructor(H,x){this.obs=H,this.c=0,this.d=!1;const B={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};x||o(B),this.emitter=new h(B),x&&x.add(this.emitter)}beginUpdate(H){this.c++}handleChange(H,x){this.d=!0}endUpdate(H){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function F(U,H){return new O(U,H).emitter.event}c.fromObservable=F})(g=e.Event||(e.Event={}));class b{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${b.c++}`,b.all.add(this)}start(o){this.d=new A.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=b,b.all=new Set,b.c=0;let S=-1;function y(c){const o=S;return S=c,{dispose(){S=o}}}e.setGlobalLeakWarningThreshold=y;class u{constructor(o,d=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=d,this.d=0}dispose(){this.c?.clear()}check(o,d){const D=this.threshold;if(D<=0||d<D)return;this.c||(this.c=new Map);const L=this.c.get(o.value)||0;if(this.c.set(o.value,L+1),this.d-=1,this.d<=0){this.d=D*.5;let N,V=0;for(const[oe,X]of this.c)(!N||V<X)&&(N=oe,V=X);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${V}):`),console.warn(N)}return()=>{const N=this.c.get(o.value)||0;this.c.set(o.value,N-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(o,d,D){this.callback=o,this.callbackThis=d,this.stack=D,this.subscription=new k.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class h{constructor(o){this.j=!1,this.d=o,this.f=S>0||this.d?.leakWarningThreshold?new u(this.d?.leakWarningThreshold??S):void 0,this.g=this.d?._profName?new b(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const o=Array.from(this.q);queueMicrotask(()=>{for(const d of o)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,d,D)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.Disposable.None;const L=this.q.isEmpty();L&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let N,V;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(V=f.create(),N=this.f.check(V,this.q.size+1)),P&&(V=V??f.create());const oe=new p(o,d,V),X=this.q.push(oe);L&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,d);const Y=oe.subscription.set(()=>{N?.(),this.j||(X(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return D instanceof k.DisposableStore?D.add(Y):Array.isArray(D)&&D.push(Y),Y}),this.l}fire(o){if(this.q){this.m||(this.m=new v);for(const d of this.q)this.m.push(this,d,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=h;class l{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(o,d,D){this.c.push(new C(o,d,D))}clear(o){const d=new R.LinkedList;for(const D of this.c)D.emitter!==o&&d.push(D);this.c=d}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(d){(0,E.onUnexpectedError)(d)}}}}e.EventDeliveryQueue=l;class v extends l{clear(o){this.c.clear()}}class C{constructor(o,d,D){this.emitter=o,this.listener=d,this.event=D}}class I extends h{async fireAsync(o,d,D){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const L of this.q)this.c.push([L,o]);for(;this.c.size>0&&!d.isCancellationRequested;){const[L,N]=this.c.shift(),V=[],oe={...N,token:d,waitUntil:X=>{if(Object.isFrozen(V))throw new Error("waitUntil can NOT be called asynchronous");D&&(X=D(X,L.callback)),V.push(X)}};try{L.invoke(oe)}catch(X){(0,E.onUnexpectedError)(X);continue}Object.freeze(V),await Promise.allSettled(V).then(X=>{for(const Y of X)Y.status==="rejected"&&(0,E.onUnexpectedError)(Y.reason)})}}}}e.AsyncEmitter=I;class m extends h{constructor(o){super(o),this.h=0,this.s=new R.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=m;class i extends m{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=i;class n extends h{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(d=>super.fire(d)),this.c=[]}))}}e.MicrotaskEmitter=n;class r{constructor(){this.d=!1,this.f=[],this.c=new h({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const d={event:o,listener:null};this.f.push(d),this.d&&this.j(d);const D=()=>{this.d&&this.k(d);const L=this.f.indexOf(d);this.f.splice(L,1)};return(0,k.toDisposable)((0,t.once)(D))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(d=>this.c.fire(d))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class a{constructor(){this.c=[]}wrapEvent(o){return(d,D,L)=>o(N=>{const V=this.c[this.c.length-1];V?V.push(()=>d.call(D,N)):d.call(D,N)},void 0,L)}bufferEvents(o){const d=[];this.c.push(d);const D=o();return this.c.pop(),d.forEach(L=>L()),D}}e.EventBufferer=a;class s{constructor(){this.c=!1,this.d=g.None,this.f=k.Disposable.None,this.g=new h({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(ie[22],ne([0,1,3]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,w){const g=setTimeout(P.bind(w),0);return{dispose(){clearTimeout(g)}}});var k;(function(P){function w(g){return g===P.None||g===P.Cancelled||g instanceof R?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}P.isCancellationToken=w,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(w){this.a=void 0,this.b=void 0,this.b=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=k.Cancelled}dispose(w=!1){w&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=k.None}}e.CancellationTokenSource=A}),define(ie[138],ne([0,1,22]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new E.CancellationTokenSource,w=this.b(P.token);return this.a={promise:w,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=t;class k{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const w=JSON.stringify(P);return this.b!==w&&(this.b=w,this.a=this.c(P)),this.a}}e.LRUCachedFunction=k;class R{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const w=this.b(P);return this.a.set(P,w),w}}e.CachedFunction=R}),define(ie[26],ne([0,1,138,125]),function(G,e,E,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=R;const A=/{(\d+)}/g;function P(K,...ce){return ce.length===0?K:K.replace(A,function(ue,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=ce.length?ue:ce[Se]})}e.format=P;const w=/{([^}]+)}/g;function g(K,ce){return K.replace(w,(ue,me)=>ce[me]??ue)}e.format2=g;function b(K){return K.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=b;function S(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function y(K,ce){let ue=0;const me=ce.charCodeAt(0);for(let Se=K.length-1;Se>=0;Se--)K.charCodeAt(Se)===me&&ue++;return ue}e.count=y;function u(K,ce,ue="\u2026"){return K.length<=ce?K:`${K.substr(0,ce)}${ue}`}e.truncate=u;function f(K,ce=" "){const ue=p(K,ce);return h(ue,ce)}e.trim=f;function p(K,ce){if(!K||!ce)return K;const ue=ce.length;if(ue===0||K.length===0)return K;let me=0;for(;K.indexOf(ce,me)===me;)me=me+ue;return K.substring(me)}e.ltrim=p;function h(K,ce){if(!K||!ce)return K;const ue=ce.length,me=K.length;if(ue===0||me===0)return K;let Se=me,Ae=-1;for(;Ae=K.lastIndexOf(ce,Se-1),!(Ae===-1||Ae+ue!==Se);){if(Ae===0)return"";Se=Ae}return K.substring(0,Se)}e.rtrim=h;function l(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function v(K){return K.replace(/\*/g,"")}e.stripWildcards=v;function C(K,ce,ue={}){if(!K)throw new Error("Cannot create regex from empty string");ce||(K=S(K)),ue.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let me="";return ue.global&&(me+="g"),ue.matchCase||(me+="i"),ue.multiline&&(me+="m"),ue.unicode&&(me+="u"),new RegExp(K,me)}e.createRegExp=C;function I(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function m(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function i(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=i;function n(K){return K.split(/\r\n|\r|\n/)}e.splitLines=n;function r(K){for(let ce=0,ue=K.length;ce<ue;ce++){const me=K.charCodeAt(ce);if(me!==32&&me!==9)return ce}return-1}e.firstNonWhitespaceIndex=r;function a(K,ce=0,ue=K.length){for(let me=ce;me<ue;me++){const Se=K.charCodeAt(me);if(Se!==32&&Se!==9)return K.substring(ce,me)}return K.substring(ce,ue)}e.getLeadingWhitespace=a;function s(K,ce=K.length-1){for(let ue=ce;ue>=0;ue--){const me=K.charCodeAt(ue);if(me!==32&&me!==9)return ue}return-1}e.lastNonWhitespaceIndex=s;function c(K,ce,ue){const me=[];let Se=0;for(const Ae of K.matchAll(ce)){if(me.push(K.slice(Se,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");Se=Ae.index+Ae[0].length,me.push(ue(Ae[0],...Ae.slice(1),Ae.index,K,Ae.groups))}return me.push(K.slice(Se)),Promise.all(me).then(Ae=>Ae.join(""))}e.replaceAsync=c;function o(K,ce){return K<ce?-1:K>ce?1:0}e.compare=o;function d(K,ce,ue=0,me=K.length,Se=0,Ae=ce.length){for(;ue<me&&Se<Ae;ue++,Se++){const xe=K.charCodeAt(ue),He=ce.charCodeAt(Se);if(xe<He)return-1;if(xe>He)return 1}const Be=me-ue,it=Ae-Se;return Be<it?-1:Be>it?1:0}e.compareSubstring=d;function D(K,ce){return L(K,ce,0,K.length,0,ce.length)}e.compareIgnoreCase=D;function L(K,ce,ue=0,me=K.length,Se=0,Ae=ce.length){for(;ue<me&&Se<Ae;ue++,Se++){let xe=K.charCodeAt(ue),He=ce.charCodeAt(Se);if(xe===He)continue;if(xe>=128||He>=128)return d(K.toLowerCase(),ce.toLowerCase(),ue,me,Se,Ae);V(xe)&&(xe-=32),V(He)&&(He-=32);const tt=xe-He;if(tt!==0)return tt}const Be=me-ue,it=Ae-Se;return Be<it?-1:Be>it?1:0}e.compareSubstringIgnoreCase=L;function N(K){return K>=48&&K<=57}e.isAsciiDigit=N;function V(K){return K>=97&&K<=122}e.isLowerAsciiLetter=V;function oe(K){return K>=65&&K<=90}e.isUpperAsciiLetter=oe;function X(K,ce){return K.length===ce.length&&L(K,ce)===0}e.equalsIgnoreCase=X;function Y(K,ce){const ue=ce.length;return ce.length>K.length?!1:L(K,ce,0,ue)===0}e.startsWithIgnoreCase=Y;function se(K,ce){const ue=Math.min(K.length,ce.length);let me;for(me=0;me<ue;me++)if(K.charCodeAt(me)!==ce.charCodeAt(me))return me;return ue}e.commonPrefixLength=se;function re(K,ce){const ue=Math.min(K.length,ce.length);let me;const Se=K.length-1,Ae=ce.length-1;for(me=0;me<ue;me++)if(K.charCodeAt(Se-me)!==ce.charCodeAt(Ae-me))return me;return ue}e.commonSuffixLength=re;function fe(K){return 55296<=K&&K<=56319}e.isHighSurrogate=fe;function J(K){return 56320<=K&&K<=57343}e.isLowSurrogate=J;function le(K,ce){return(K-55296<<10)+(ce-56320)+65536}e.computeCodePoint=le;function $(K,ce,ue){const me=K.charCodeAt(ue);if(fe(me)&&ue+1<ce){const Se=K.charCodeAt(ue+1);if(J(Se))return le(me,Se)}return me}e.getNextCodePoint=$;function W(K,ce){const ue=K.charCodeAt(ce-1);if(J(ue)&&ce>1){const me=K.charCodeAt(ce-2);if(fe(me))return le(me,ue)}return ue}class T{get offset(){return this.e}constructor(ce,ue=0){this.c=ce,this.d=ce.length,this.e=ue}setOffset(ce){this.e=ce}prevCodePoint(){const ce=W(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=$(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=T;class z{get offset(){return this.c.offset}constructor(ce,ue=0){this.c=new T(ce,ue)}nextGraphemeLength(){const ce=We.getInstance(),ue=this.c,me=ue.offset;let Se=ce.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const Ae=ue.offset,Be=ce.getGraphemeBreakType(ue.nextCodePoint());if(be(Se,Be)){ue.setOffset(Ae);break}Se=Be}return ue.offset-me}prevGraphemeLength(){const ce=We.getInstance(),ue=this.c,me=ue.offset;let Se=ce.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const Ae=ue.offset,Be=ce.getGraphemeBreakType(ue.prevCodePoint());if(be(Be,Se)){ue.setOffset(Ae);break}Se=Be}return me-ue.offset}eol(){return this.c.eol()}}e.GraphemeIterator=z;function Q(K,ce){return new z(K,ce).nextGraphemeLength()}e.nextCharLength=Q;function q(K,ce){return new z(K,ce).prevGraphemeLength()}e.prevCharLength=q;function j(K,ce){ce>0&&J(K.charCodeAt(ce))&&ce--;const ue=ce+Q(K,ce);return[ue-q(K,ue),ue]}e.getCharContainingOffset=j;function M(K){const ce=new z(K);let ue=0;for(;!ce.eol();)ue++,ce.nextGraphemeLength();return ue}e.charCount=M;let O;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(K){return O||(O=F()),O.test(K)}e.containsRTL=U;const H=/^[\t\n\r\x20-\x7E]*$/;function x(K){return H.test(K)}e.isBasicASCII=x,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=B;function _(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=_;function Z(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=Z;function ae(K,ce){if(K.length<ce)return K;const ue=/\b/g;let me=0;for(;ue.test(K)&&!(K.length-ue.lastIndex<ce);)me=ue.lastIndex,ue.lastIndex+=1;return K.substring(me).replace(/^\s/,"")}e.lcut=ae;const ge=/\x1B\x5B[12]?K/g,ke=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function De(K){return K&&(K=K.replace(ge,""),K=K.replace(ke,""),K=K.replace(Oe,"")),K}e.removeAnsiEscapeCodes=De,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function ve(K){return Le(K)?K.substr(1):K}e.stripUTF8BOM=ve;function we(K,ce){if(!K||!ce||K.length<ce.length)return!1;const ue=ce.length,me=K.toLowerCase();let Se=0,Ae=-1;for(;Se<ue;){const Be=me.indexOf(ce[Se],Ae+1);if(Be<0)return!1;Ae=Be,Se++}return!0}e.fuzzyContains=we;function ye(K,ce=!1){return K?(ce&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=ye;function Me(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Me;function te(K,ce=1){if(ce===0)return"";let ue=-1;do ue=K.indexOf(`
`,ue+1),ce--;while(ce>0&&ue>=0);return ue===-1?K:(K[ue-1]==="\r"&&ue--,K.substr(0,ue))}e.getNLines=te;function he(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}e.singleLetterHash=he;function de(K){return We.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=de;function be(K,ce){return K===0?ce!==5&&ce!==7:K===2&&ce===3?!1:K===4||K===2||K===3||ce===4||ce===2||ce===3?!0:!(K===8&&(ce===8||ce===9||ce===11||ce===12)||(K===11||K===9)&&(ce===9||ce===10)||(K===12||K===10)&&ce===10||ce===5||ce===13||ce===7||K===1||K===13&&ce===14||K===6&&ce===6)}var Pe;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Te()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const ue=this.d,me=ue.length/3;let Se=1;for(;Se<=me;)if(ce<ue[3*Se])Se=2*Se;else if(ce>ue[3*Se+1])Se=2*Se+1;else return ue[3*Se+2];return 0}}We.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(K,ce){if(K===0)return 0;const ue=Ue(K,ce);if(ue!==void 0)return ue;const me=new T(ce,K);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=qe;function Ue(K,ce){const ue=new T(ce,K);let me=ue.prevCodePoint();for(;je(me)||me===65039||me===8419;){if(ue.offset===0)return;me=ue.prevCodePoint()}if(!Z(me))return;let Se=ue.offset;return Se>0&&ue.prevCodePoint()===8205&&(Se=ue.offset),Se}function je(K){return 127995<=K&&K<=127999}var Xe;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.noBreakWhitespace="\xA0";class $e{static getInstance(ce){return $e.d.get(Array.from(ce))}static getLocales(){return $e.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=$e,k=$e,$e.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),$e.d=new E.LRUCachedFunction(K=>{function ce(He){const tt=new Map;for(let nt=0;nt<He.length;nt+=2)tt.set(He[nt],He[nt+1]);return tt}function ue(He,tt){const nt=new Map(He);for(const[lt,at]of tt)nt.set(lt,at);return nt}function me(He,tt){if(!He)return tt;const nt=new Map;for(const[lt,at]of He)tt.has(lt)&&nt.set(lt,at);return nt}const Se=k.c.getValue();let Ae=K.filter(He=>!He.startsWith("_")&&He in Se);Ae.length===0&&(Ae=["_default"]);let Be;for(const He of Ae){const tt=ce(Se[He]);Be=me(Be,tt)}const it=ce(Se._common),xe=ue(it,Be);return new $e(xe)}),$e.e=new t.Lazy(()=>Object.keys($e.c.getValue()).filter(K=>!K.startsWith("_")));class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(ce){return Ke.e().has(ce)}static get codePoints(){return Ke.e()}}e.InvisibleCharacters=Ke,Ke.d=void 0}),define(ie[30],ne([0,1,9,4,26,11]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(s){return s===47||s===92}e.isPathSeparator=A;function P(s){return s.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function w(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=w;function g(s,c=E.posix.sep){if(!s)return"";const o=s.length,d=s.charCodeAt(0);if(A(d)){if(A(s.charCodeAt(1))&&!A(s.charCodeAt(2))){let L=3;const N=L;for(;L<o&&!A(s.charCodeAt(L));L++);if(N!==L&&!A(s.charCodeAt(L+1))){for(L+=1;L<o;L++)if(A(s.charCodeAt(L)))return s.slice(0,L+1).replace(/[\\/]/g,c)}}return c}else if(l(d)&&s.charCodeAt(1)===58)return A(s.charCodeAt(2))?s.slice(0,2)+c:s.slice(0,2);let D=s.indexOf("://");if(D!==-1){for(D+=3;D<o;D++)if(A(s.charCodeAt(D)))return s.slice(0,D+1)}return""}e.getRoot=g;function b(s){if(!t.isWindows||!s||s.length<5)return!1;let c=s.charCodeAt(0);if(c!==92||(c=s.charCodeAt(1),c!==92))return!1;let o=2;const d=o;for(;o<s.length&&(c=s.charCodeAt(o),c!==92);o++);return!(d===o||(c=s.charCodeAt(o+1),isNaN(c)||c===92))}e.isUNC=b;const S=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,c=t.isWindows){const o=c?S:y;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||c&&u.test(s)||s==="."||s===".."||c&&s[s.length-1]==="."||c&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function p(s,c,o){const d=s===c;return!o||d?d:!s||!c?!1:(0,k.equalsIgnoreCase)(s,c)}e.isEqual=p;function h(s,c,o,d=E.sep){if(s===c)return!0;if(!s||!c||c.length>s.length)return!1;if(o){if(!(0,k.startsWithIgnoreCase)(s,c))return!1;if(c.length===s.length)return!0;let L=c.length;return c.charAt(c.length-1)===d&&L--,s.charAt(L)===d}return c.charAt(c.length-1)!==d&&(c+=d),s.indexOf(c)===0}e.isEqualOrParent=h;function l(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=l;function v(s,c){return t.isWindows&&s.endsWith(":")&&(s+=E.sep),(0,E.isAbsolute)(s)||(s=(0,E.join)(c,s)),s=(0,E.normalize)(s),t.isWindows?(s=(0,k.rtrim)(s,E.sep),s.endsWith(":")&&(s+=E.sep)):(s=(0,k.rtrim)(s,E.sep),s||(s=E.sep)),s}e.sanitizeFilePath=v;function C(s){const c=(0,E.normalize)(s);return t.isWindows?s.length>3?!1:I(c)&&(s.length===2||c.charCodeAt(2)===92):c===E.posix.sep}e.isRootOrDriveLetter=C;function I(s,c=t.isWindows){return c?l(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=I;function m(s){return I(s)?s[0]:void 0}e.getDriveLetter=m;function i(s,c,o){return c.length>s.length?-1:s===c?0:(o&&(s=s.toLowerCase(),c=c.toLowerCase()),s.indexOf(c))}e.indexOfPath=i;function n(s){const c=s.split(":");let o,d,D;for(const L of c){const N=Number(L);(0,R.isNumber)(N)?d===void 0?d=N:D===void 0&&(D=N):o=o?[o,L].join(":"):L}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:d!==void 0?d:void 0,column:D!==void 0?D:d!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(s,c,o=8){let d="";for(let L=0;L<o;L++)d+=r.charAt(Math.floor(Math.random()*r.length));let D;return c?D=`${c}-${d}`:D=d,s?(0,E.join)(s,D):D}e.randomPath=a}),define(ie[68],ne([0,1,26]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(l){return k(l,0)}e.hash=t;function k(l,v){switch(typeof l){case"object":return l===null?R(349,v):Array.isArray(l)?w(l,v):g(l,v);case"string":return P(l,v);case"boolean":return A(l,v);case"number":return R(l,v);case"undefined":return R(937,v);default:return R(617,v)}}e.doHash=k;function R(l,v){return(v<<5)-v+l|0}e.numberHash=R;function A(l,v){return R(l?433:863,v)}function P(l,v){v=R(149417,v);for(let C=0,I=l.length;C<I;C++)v=R(l.charCodeAt(C),v);return v}e.stringHash=P;function w(l,v){return v=R(104579,v),l.reduce((C,I)=>k(I,C),v)}function g(l,v){return v=R(181387,v),Object.keys(l).sort().reduce((C,I)=>(C=P(I,C),k(l[I],C)),v)}class b{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=k(v,this.g),this.g}}e.Hasher=b;var S;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function y(l,v,C=32){const I=C-v,m=~((1<<I)-1);return(l<<v|(m&l)>>>I)>>>0}function u(l,v=0,C=l.byteLength,I=0){for(let m=0;m<C;m++)l[v+m]=I}function f(l,v,C="0"){for(;l.length<v;)l=C+l;return l}function p(l,v=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(C=>C.toString(16).padStart(2,"0")).join(""):f((l>>>0).toString(16),v/4)}e.toHexString=p;class h{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const C=v.length;if(C===0)return;const I=this.p;let m=this.r,i=this.u,n,r;for(i!==0?(n=i,r=-1,i=0):(n=v.charCodeAt(0),r=0);;){let a=n;if(E.isHighSurrogate(n))if(r+1<C){const s=v.charCodeAt(r+1);E.isLowSurrogate(s)?(r++,a=E.computeCodePoint(n,s)):a=65533}else{i=n;break}else E.isLowSurrogate(n)&&(a=65533);if(m=this.w(I,m,a),r++,r<C)n=v.charCodeAt(r);else break}this.r=m,this.u=i}w(v,C,I){return I<128?v[C++]=I:I<2048?(v[C++]=192|(I&1984)>>>6,v[C++]=128|(I&63)>>>0):I<65536?(v[C++]=224|(I&61440)>>>12,v[C++]=128|(I&4032)>>>6,v[C++]=128|(I&63)>>>0):(v[C++]=240|(I&1835008)>>>18,v[C++]=128|(I&258048)>>>12,v[C++]=128|(I&4032)>>>6,v[C++]=128|(I&63)>>>0),C>=64&&(this.y(),C-=64,this.t+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),C}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=h.g,C=this.q;for(let o=0;o<64;o+=4)v.setUint32(o,C.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)v.setUint32(o,y(v.getUint32(o-12,!1)^v.getUint32(o-32,!1)^v.getUint32(o-56,!1)^v.getUint32(o-64,!1),1),!1);let I=this.h,m=this.l,i=this.m,n=this.n,r=this.o,a,s,c;for(let o=0;o<80;o++)o<20?(a=m&i|~m&n,s=1518500249):o<40?(a=m^i^n,s=1859775393):o<60?(a=m&i|m&n|i&n,s=2400959708):(a=m^i^n,s=3395469782),c=y(I,5)+a+r+s+v.getUint32(o*4,!1)&4294967295,r=n,n=i,i=y(m,30),m=I,I=c;this.h=this.h+I&4294967295,this.l=this.l+m&4294967295,this.m=this.m+i&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}e.StringSHA1=h,h.g=new DataView(new ArrayBuffer(320))}),define(ie[98],ne([0,1,26]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",A="warning",P="warn",w="info",g="ignore";function b(y){return y?E.equalsIgnoreCase(R,y)?k.Error:E.equalsIgnoreCase(A,y)||E.equalsIgnoreCase(P,y)?k.Warning:E.equalsIgnoreCase(w,y)?k.Info:k.Ignore:k.Ignore}k.fromValue=b;function S(y){switch(y){case k.Error:return R;case k.Warning:return A;case k.Info:return w;default:return g}}k.toString=S}(t||(t={})),e.default=t}),define(ie[60],ne([0,1,24,26]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const f=u.charCodeAt(0),p=this.b.charCodeAt(this.c);return f-p}value(){return this.b[this.c]}}e.StringIterator=k;class R{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,t.compareSubstring)(u,this.b,0,u.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class A{constructor(u=!0,f=!0){this.f=u,this.g=f}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let f=u.length-1;f>=0;f--,this.c--){const p=this.b.charCodeAt(f);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,t.compareSubstring)(u,this.b,0,u.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=A;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class w{constructor(u,f){this.f=u,this.g=f,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(u,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,t.compare)(u,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=w;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(b||(b={}));class S{static forUris(u=()=>!1,f=()=>!1){return new S(new w(u,f))}static forPaths(u=!1){return new S(new A(void 0,!u))}static forStrings(){return new S(new k)}static forConfigKeys(){return new S(new R)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,f){if(f){const p=f.slice(0);(0,E.shuffle)(p);for(const h of p)this.set(h,u)}else{const p=u.slice(0);(0,E.shuffle)(p);for(const h of p)this.set(h[0],h[1])}}set(u,f){const p=this.b.reset(u);let h;this.c||(this.c=new g,this.c.segment=p.value());const l=[];for(h=this.c;;){const C=p.cmp(h.segment);if(C>0)h.left||(h.left=new g,h.left.segment=p.value()),l.push([-1,h]),h=h.left;else if(C<0)h.right||(h.right=new g,h.right.segment=p.value()),l.push([1,h]),h=h.right;else if(p.hasNext())p.next(),h.mid||(h.mid=new g,h.mid.segment=p.value()),l.push([0,h]),h=h.mid;else break}const v=h.value;h.value=f,h.key=u;for(let C=l.length-1;C>=0;C--){const I=l[C][1];I.updateHeight();const m=I.balanceFactor();if(m<-1||m>1){const i=l[C][0],n=l[C+1][0];if(i===1&&n===1)l[C][1]=I.rotateLeft();else if(i===-1&&n===-1)l[C][1]=I.rotateRight();else if(i===1&&n===-1)I.right=l[C+1][1]=l[C+1][1].rotateRight(),l[C][1]=I.rotateLeft();else if(i===-1&&n===1)I.left=l[C+1][1]=l[C+1][1].rotateLeft(),l[C][1]=I.rotateRight();else throw new Error;if(C>0)switch(l[C-1][0]){case-1:l[C-1][1].left=l[C][1];break;case 1:l[C-1][1].right=l[C][1];break;case 0:l[C-1][1].mid=l[C][1];break}else this.c=l[0][1]}}return v}get(u){return this.d(u)?.value}d(u){const f=this.b.reset(u);let p=this.c;for(;p;){const h=f.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(f.hasNext())f.next(),p=p.mid;else break}return p}has(u){const f=this.d(u);return!(f?.value===void 0&&f?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,f){const p=this.b.reset(u),h=[];let l=this.c;for(;l;){const v=p.cmp(l.segment);if(v>0)h.push([-1,l]),l=l.left;else if(v<0)h.push([1,l]),l=l.right;else if(p.hasNext())p.next(),h.push([0,l]),l=l.mid;else break}if(!!l){if(f?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const v=this.f(l.right);if(v.key){const{key:C,value:I,segment:m}=v;this.e(v.key,!1),l.key=C,l.value=I,l.segment=m}}else{const v=l.left??l.right;if(h.length>0){const[C,I]=h[h.length-1];switch(C){case-1:I.left=v;break;case 0:I.mid=v;break;case 1:I.right=v;break}}else this.c=v}for(let v=h.length-1;v>=0;v--){const C=h[v][1];C.updateHeight();const I=C.balanceFactor();if(I>1?(C.right.balanceFactor()>=0||(C.right=C.right.rotateRight()),h[v][1]=C.rotateLeft()):I<-1&&(C.left.balanceFactor()<=0||(C.left=C.left.rotateLeft()),h[v][1]=C.rotateRight()),v>0)switch(h[v-1][0]){case-1:h[v-1][1].left=h[v][1];break;case 1:h[v-1][1].right=h[v][1];break;case 0:h[v-1][1].mid=h[v][1];break}else this.c=h[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const f=this.b.reset(u);let p=this.c,h;for(;p;){const l=f.cmp(p.segment);if(l>0)p=p.left;else if(l<0)p=p.right;else if(f.hasNext())f.next(),h=p.value||h,p=p.mid;else break}return p&&p.value||h}findSuperstr(u){const f=this.b.reset(u);let p=this.c;for(;p;){const h=f.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(f.hasNext())f.next(),p=p.mid;else return p.mid?this.g(p.mid):void 0}}forEach(u){for(const[f,p]of this)u(p,f)}*[Symbol.iterator](){yield*this.g(this.c)}g(u){const f=[];return this.h(u,f),f[Symbol.iterator]()}h(u,f){!u||(u.left&&this.h(u.left,f),u.value&&f.push([u.key,u.value]),u.mid&&this.h(u.mid,f),u.right&&this.h(u.right,f))}_isBalanced(){const u=f=>{if(!f)return!0;const p=f.balanceFactor();return p<-1||p>1?!1:u(f.left)&&u(f.right)};return u(this.c)}}e.TernarySearchTree=S}),define(ie[7],ne([0,1,9,4]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,A=/^\/\//;function P(r,a){if(!r.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(r,a){return!r&&!a?"file":r}function g(r,a){switch(r){case"https":case"http":case"file":a?a[0]!==S&&(a=S+a):a=S;break}return a}const b="",S="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(a){return a instanceof u?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,s,c,o,d,D=!1){typeof a=="object"?(this.scheme=a.scheme||b,this.authority=a.authority||b,this.path=a.path||b,this.query=a.query||b,this.fragment=a.fragment||b):(this.scheme=w(a,D),this.authority=s||b,this.path=g(this.scheme,c||b),this.query=o||b,this.fragment=d||b,P(this,D))}get fsPath(){return C(this,!1)}with(a){if(!a)return this;let{scheme:s,authority:c,path:o,query:d,fragment:D}=a;return s===void 0?s=this.scheme:s===null&&(s=b),c===void 0?c=this.authority:c===null&&(c=b),o===void 0?o=this.path:o===null&&(o=b),d===void 0?d=this.query:d===null&&(d=b),D===void 0?D=this.fragment:D===null&&(D=b),s===this.scheme&&c===this.authority&&o===this.path&&d===this.query&&D===this.fragment?this:new p(s,c,o,d,D)}static parse(a,s=!1){const c=y.exec(a);return c?new p(c[2]||b,n(c[4]||b),n(c[5]||b),n(c[7]||b),n(c[9]||b),s):new p(b,b,b,b,b)}static file(a){let s=b;if(t.isWindows&&(a=a.replace(/\\/g,S)),a[0]===S&&a[1]===S){const c=a.indexOf(S,2);c===-1?(s=a.substring(2),a=S):(s=a.substring(2,c),a=a.substring(c)||S)}return new p("file",s,a,b,b)}static from(a){const s=new p(a.scheme,a.authority,a.path,a.query,a.fragment);return P(s,!0),s}static joinPath(a,...s){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&a.scheme==="file"?c=u.file(E.win32.join(C(a,!0),...s)).path:c=E.posix.join(a.path,...s),a.with({path:c})}toString(a=!1){return I(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof u)return a;{const s=new p(a);return s._formatted=a.external,s._fsPath=a._sep===f?a.fsPath:null,s}}else return a}}e.URI=u;const f=t.isWindows?1:void 0;class p extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=C(this,!1)),this._fsPath}toString(a=!1){return a?I(this,!0):(this._formatted||(this._formatted=I(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=f),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(r,a,s){let c,o=-1;for(let d=0;d<r.length;d++){const D=r.charCodeAt(d);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||a&&D===47||s&&D===91||s&&D===93||s&&D===58)o!==-1&&(c+=encodeURIComponent(r.substring(o,d)),o=-1),c!==void 0&&(c+=r.charAt(d));else{c===void 0&&(c=r.substr(0,d));const L=h[D];L!==void 0?(o!==-1&&(c+=encodeURIComponent(r.substring(o,d)),o=-1),c+=L):o===-1&&(o=d)}}return o!==-1&&(c+=encodeURIComponent(r.substring(o))),c!==void 0?c:r}function v(r){let a;for(let s=0;s<r.length;s++){const c=r.charCodeAt(s);c===35||c===63?(a===void 0&&(a=r.substr(0,s)),a+=h[c]):a!==void 0&&(a+=r[s])}return a!==void 0?a:r}function C(r,a){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?a?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=C;function I(r,a){const s=a?v:l;let c="",{scheme:o,authority:d,path:D,query:L,fragment:N}=r;if(o&&(c+=o,c+=":"),(d||o==="file")&&(c+=S,c+=S),d){let V=d.indexOf("@");if(V!==-1){const oe=d.substr(0,V);d=d.substr(V+1),V=oe.lastIndexOf(":"),V===-1?c+=s(oe,!1,!1):(c+=s(oe.substr(0,V),!1,!1),c+=":",c+=s(oe.substr(V+1),!1,!0)),c+="@"}d=d.toLowerCase(),V=d.lastIndexOf(":"),V===-1?c+=s(d,!1,!0):(c+=s(d.substr(0,V),!1,!0),c+=d.substr(V))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const V=D.charCodeAt(1);V>=65&&V<=90&&(D=`/${String.fromCharCode(V+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const V=D.charCodeAt(0);V>=65&&V<=90&&(D=`${String.fromCharCode(V+32)}:${D.substr(2)}`)}c+=s(D,!0,!1)}return L&&(c+="?",c+=s(L,!1,!1)),N&&(c+="#",c+=a?N:l(N,!1,!1)),c}function m(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+m(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(i)?r.replace(i,a=>m(a)):r}}),define(ie[139],ne([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(g){const b=g;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=t;function k(g){const b=[];let S;try{const y=JSON.parse(g.arguments),u=y[y.length-1];u&&u.__$stack&&(y.pop(),S=u.__$stack),b.push(...y)}catch{b.push("Unable to log remote console arguments",g.arguments)}return{args:b,stack:S}}e.parse=k;function R(g){if(typeof g!="string")return R(k(g).stack);const b=g;if(b){const S=A(b),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(y&&y.length===4)return{uri:E.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=R;function A(g){if(!g)return g;const b=g.indexOf(`
`);return b===-1?g:g.substring(0,b)}function P(g,b){const{args:S,stack:y}=k(g),u=typeof S[0]=="string"&&S.length===1;let f=A(y);f&&(f=`(${f.trim()})`);let p=[];if(typeof S[0]=="string"?f&&u?p=[`%c[${b}] %c${S[0]} %c${f}`,w("blue"),w(""),w("grey")]:p=[`%c[${b}] %c${S[0]}`,w("blue"),w(""),...S.slice(1)]:p=[`%c[${b}]%`,w("blue"),...S],f&&!u&&p.push(f),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,p)}e.log=P;function w(g){return`color: ${g}`}}),define(ie[69],ne([0,1,17,26,7]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(g){return JSON.stringify(g,P)}e.stringify=R;function A(g){let b=JSON.parse(g);return b=w(b),b}e.parse=A;function P(g,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,t.regExpFlags)(b)}:b}function w(g,b=0){if(!g||b>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return k.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 16:return new Date(g.source)}if(g instanceof E.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let S=0;S<g.length;++S)g[S]=w(g[S],b+1);else for(const S in g)Object.hasOwnProperty.call(g,S)&&(g[S]=w(g[S],b+1))}return g}e.revive=w}),define(ie[14],ne([0,1,4,7]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g){this.f=`${g}/${k.vscodeRemoteResource}`}set(g,b,S){this.a[g]=b,this.b[g]=S}setConnectionToken(g,b){this.c[g]=b}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)return this.e(g);const b=g.authority;let S=this.a[b];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const y=this.b[b],u=this.c[b];let f=`path=${encodeURIComponent(g.path)}`;return typeof u=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(u)}`),t.URI.from({scheme:E.isWeb?this.d:k.vscodeRemoteResource,authority:`${S}:${y}`,path:this.f,query:f})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(g){const b=this.b(g,G);return this.uriToBrowserUri(b)}uriToBrowserUri(g){return g.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(g):g.scheme===k.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${k.vscodeFileResource}://${A.a}`)?g.with({scheme:k.vscodeFileResource,authority:g.authority||A.a,query:null,fragment:null}):g}asFileUri(g){const b=this.b(g,G);return this.uriToFileUri(b)}uriToFileUri(g){return g.scheme===k.vscodeFileResource?g.with({scheme:k.file,authority:g.authority!==A.a?g.authority:null,query:null,fragment:null}):g}b(g,b){return t.URI.isUri(g)?g:t.URI.parse(b.toUrl(g))}}A.a="vscode-app",e.FileAccess=new A;var P;(function(w){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(g.get("3"));const b="vscode-coi";function S(u){let f;typeof u=="string"?f=new URL(u).searchParams:u instanceof URL?f=u.searchParams:t.URI.isUri(u)&&(f=new URL(u.toString(!0)).searchParams);const p=f?.get(b);if(!!p)return g.get(p)}w.getHeadersFromQuery=S;function y(u,f,p){if(!globalThis.crossOriginIsolated)return;const h=f&&p?"3":p?"2":"1";u instanceof URLSearchParams?u.set(b,h):u[b]=h}w.addSearchParam=y})(P=e.COI||(e.COI={}))}),define(ie[20],ne([0,1,30,14,9,4,26,7]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(u){return(0,P.uriToFsPath)(u,!0)}e.originalFSPath=w;class g{constructor(f){this.a=f}compare(f,p,h=!1){return f===p?0:(0,A.compare)(this.getComparisonKey(f,h),this.getComparisonKey(p,h))}isEqual(f,p,h=!1){return f===p?!0:!f||!p?!1:this.getComparisonKey(f,h)===this.getComparisonKey(p,h)}getComparisonKey(f,p=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,p,h=!1){if(f.scheme===p.scheme){if(f.scheme===t.Schemas.file)return E.isEqualOrParent(w(f),w(p),this.a(f))&&f.query===p.query&&(h||f.fragment===p.fragment);if((0,e.isEqualAuthority)(f.authority,p.authority))return E.isEqualOrParent(f.path,p.path,this.a(f),"/")&&f.query===p.query&&(h||f.fragment===p.fragment)}return!1}joinPath(f,...p){return P.URI.joinPath(f,...p)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return k.posix.basename(f.path)}extname(f){return k.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let p;return f.scheme===t.Schemas.file?p=P.URI.file(k.dirname(w(f))).path:(p=k.posix.dirname(f.path),f.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),p="/")),f.with({path:p})}normalizePath(f){if(!f.path.length)return f;let p;return f.scheme===t.Schemas.file?p=P.URI.file(k.normalize(w(f))).path:p=k.posix.normalize(f.path),f.with({path:p})}relativePath(f,p){if(f.scheme!==p.scheme||!(0,e.isEqualAuthority)(f.authority,p.authority))return;if(f.scheme===t.Schemas.file){const v=k.relative(w(f),w(p));return R.isWindows?E.toSlashes(v):v}let h=f.path||"/";const l=p.path||"/";if(this.a(f)){let v=0;for(const C=Math.min(h.length,l.length);v<C&&!(h.charCodeAt(v)!==l.charCodeAt(v)&&h.charAt(v).toLowerCase()!==l.charAt(v).toLowerCase());v++);h=l.substr(0,v)+h.substr(v)}return k.posix.relative(h,l)}resolvePath(f,p){if(f.scheme===t.Schemas.file){const h=P.URI.file(k.resolve(w(f),p));return f.with({authority:h.authority,path:h.path})}return p=E.toPosixPath(p),f.with({path:k.posix.resolve(f.path,p)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,p){return f===p||f!==void 0&&p!==void 0&&(0,A.equalsIgnoreCase)(f,p)}hasTrailingPathSeparator(f,p=k.sep){if(f.scheme===t.Schemas.file){const h=w(f);return h.length>E.getRoot(h).length&&h[h.length-1]===p}else{const h=f.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,p=k.sep){return(0,e.hasTrailingPathSeparator)(f,p)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,p=k.sep){let h=!1;if(f.scheme===t.Schemas.file){const l=w(f);h=l!==void 0&&l.length===E.getRoot(l).length&&l[l.length-1]===p}else{p="/";const l=f.path;h=l.length===1&&l.charCodeAt(l.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(f,p)?f.with({path:f.path+"/"}):f}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(u=>u.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new g(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(u,f){const p=[];for(let h=0;h<u.length;h++){const l=f(u[h]);u.some((v,C)=>C===h?!1:(0,e.isEqualOrParent)(l,f(v)))||p.push(u[h])}return p}e.distinctParents=b;var S;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function f(p){const h=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(C=>{const[I,m]=C.split(":");I&&m&&h.set(I,m)});const v=p.path.substring(0,p.path.indexOf(";"));return v&&h.set(u.META_DATA_MIME,v),h}u.parseMetaData=f})(S=e.DataUri||(e.DataUri={}));function y(u,f,p){if(f){let h=u.path;return h&&h[0]!==k.posix.sep&&(h=k.posix.sep+h),u.with({scheme:p,authority:f,path:h})}return u.with({scheme:p})}e.toLocalResource=y}),define(ie[8],ne([0,1,22,15,3,2,20,4]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(j){return!!j&&typeof j.then=="function"}e.isThenable=w;function g(j){const M=new E.CancellationTokenSource,O=j(M.token),F=new Promise((U,H)=>{const x=M.token.onCancellationRequested(()=>{x.dispose(),M.dispose(),H(new t.CancellationError)});Promise.resolve(O).then(B=>{x.dispose(),M.dispose(),U(B)},B=>{x.dispose(),M.dispose(),H(B)})});return new class{cancel(){M.cancel()}then(U,H){return F.then(U,H)}catch(U){return this.then(void 0,U)}finally(U){return F.finally(U)}}}e.createCancelablePromise=g;function b(j,M,O){return new Promise((F,U)=>{const H=M.onCancellationRequested(()=>{H.dispose(),F(O)});j.then(F,U).finally(()=>H.dispose())})}e.raceCancellation=b;function S(j,M){return new Promise((O,F)=>{const U=M.onCancellationRequested(()=>{U.dispose(),F(new t.CancellationError)});j.then(O,F).finally(()=>U.dispose())})}e.raceCancellationError=S;async function y(j){let M=-1;const O=j.map((U,H)=>U.then(x=>(M=H,x))),F=await Promise.race(O);return j.forEach((U,H)=>{H!==M&&U.cancel()}),F}e.raceCancellablePromises=y;function u(j,M,O){let F;const U=setTimeout(()=>{F?.(void 0),O?.()},M);return Promise.race([j.finally(()=>clearTimeout(U)),new Promise(H=>F=H)])}e.raceTimeout=u;function f(j){return new Promise((M,O)=>{const F=j();w(F)?F.then(M,O):M(F)})}e.asPromise=f;class p{constructor(){this.a=null,this.b=null,this.d=null}queue(M){if(this.a){if(this.d=M,!this.b){const O=()=>{this.b=null;const F=this.queue(this.d);return this.d=null,F};this.b=new Promise(F=>{this.a.then(O,O).then(F)})}return new Promise((O,F)=>{this.b.then(O,F)})}return this.a=M(),new Promise((O,F)=>{this.a.then(U=>{this.a=null,O(U)},U=>{this.a=null,F(U)})})}}e.Throttler=p;class h{constructor(){this.a=Promise.resolve(null)}queue(M){return this.a=this.a.then(()=>M(),()=>M())}}e.Sequencer=h;class l{constructor(){this.a=new Map}queue(M,O){const U=(this.a.get(M)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.a.get(M)===U&&this.a.delete(M)});return this.a.set(M,U),U}}e.SequencerByKey=l;const v=(j,M)=>{let O=!0;const F=setTimeout(()=>{O=!1,M()},j);return{isTriggered:()=>O,dispose:()=>{clearTimeout(F),O=!1}}},C=j=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,j())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class I{constructor(M){this.defaultDelay=M,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(M,O=this.defaultDelay){this.g=M,this.h(),this.b||(this.b=new Promise((U,H)=>{this.d=U,this.f=H}).then(()=>{if(this.b=null,this.d=null,this.g){const U=this.g;return this.g=null,U()}}));const F=()=>{this.a=null,this.d?.(null)};return this.a=O===e.MicrotaskDelay?C(F):v(O,F),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=I;class m{constructor(M){this.a=new I(M),this.b=new p}trigger(M,O){return this.a.trigger(()=>this.b.queue(M),O)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=m;class i{constructor(){this.a=!1,this.b=new Promise((M,O)=>{this.d=M})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class n extends i{constructor(M){super(),this.f=setTimeout(()=>this.open(),M)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=n;function r(j,M){return M?new Promise((O,F)=>{const U=setTimeout(()=>{H.dispose(),O()},j),H=M.onCancellationRequested(()=>{clearTimeout(U),H.dispose(),F(new t.CancellationError)})}):g(O=>r(j,O))}e.timeout=r;function a(j,M=0){const O=setTimeout(j,M);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=a;function s(j){const M=[];let O=0;const F=j.length;function U(){return O<F?j[O++]():null}function H(x){x!=null&&M.push(x);const B=U();return B?B.then(H):Promise.resolve(M)}return Promise.resolve(null).then(H)}e.sequence=s;function c(j,M=F=>!!F,O=null){let F=0;const U=j.length,H=()=>{if(F>=U)return Promise.resolve(O);const x=j[F++];return Promise.resolve(x()).then(_=>M(_)?Promise.resolve(_):H())};return H()}e.first=c;function o(j,M=F=>!!F,O=null){if(j.length===0)return Promise.resolve(O);let F=j.length;const U=()=>{F=-1;for(const H of j)H.cancel?.()};return new Promise((H,x)=>{for(const B of j)B.then(_=>{--F>=0&&M(_)?(U(),H(_)):F===0&&H(O)}).catch(_=>{--F>=0&&(U(),x(_))})})}e.firstParallel=o;class d{constructor(M){this.a=0,this.d=M,this.f=[],this.b=0,this.g=new k.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(M){return this.a++,new Promise((O,F)=>{this.f.push({factory:M,c:O,e:F}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const M=this.f.shift();this.b++;const O=M.factory();O.then(M.c,M.e),O.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=d;class D extends d{constructor(){super(1)}}e.Queue=D;class L{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const M=new $;return this.b.add(M),M.p}d(){for(const[,M]of this.a)if(M.size>0)return!1;return!0}queueFor(M,O=A.extUri){const F=O.getComparisonKey(M);let U=this.a.get(F);return U||(U=new D,k.Event.once(U.onDrained)(()=>{U?.dispose(),this.a.delete(F),this.f()}),this.a.set(F,U)),U}f(){!this.d()||this.g()}g(){for(const M of this.b)M.complete();this.b.clear()}dispose(){for(const[,M]of this.a)M.dispose();this.a.clear(),this.g()}}e.ResourceQueue=L;class N{constructor(M,O){this.a=-1,typeof M=="function"&&typeof O=="number"&&this.setIfNotSet(M,O)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(M,O){this.cancel(),this.a=setTimeout(()=>{this.a=-1,M()},O)}setIfNotSet(M,O){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,M()},O))}}e.TimeoutTimer=N;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(M,O){this.cancel(),this.a=setInterval(()=>{M()},O)}}e.IntervalTimer=V;class oe{constructor(M,O){this.b=-1,this.a=M,this.d=O,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(M=this.d){this.cancel(),this.b=setTimeout(this.f,M)}get delay(){return this.d}set delay(M){this.d=M}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=oe;class X{constructor(M,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.a=M,this.b=O,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(M=this.b){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(M/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=X;class Y extends oe{constructor(M,O){super(M,O),this.j=[]}work(M){this.j.push(M),this.isScheduled()||this.schedule()}h(){const M=this.j;this.j=[],this.a?.(M)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=Y;class se extends R.Disposable{constructor(M,O){super(),this.g=M,this.h=O,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(M){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+M.length>this.g.maxBufferedWork)return!1}else if(this.pending+M.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...M),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new oe(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{(0,P.setTimeout0)(()=>{if(M)return;const O=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.runWhenIdle=(j,M)=>{const O=requestIdleCallback(j,typeof M=="number"?{timeout:M}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(O))}}}}();class re{constructor(M){this.d=!1,this.a=()=>{try{this.f=M()}catch(O){this.g=O}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=re;async function fe(j,M,O){let F;for(let U=0;U<O;U++)try{return await j()}catch(H){F=H,await r(M)}throw F}e.retry=fe;class J{hasPending(M){return this.a?typeof M=="number"?this.a.taskId===M:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(M,O,F){return this.a={taskId:M,cancel:()=>F?.(),promise:O},O.then(()=>this.d(M),()=>this.d(M)),O}d(M){this.a&&M===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const M=this.b;this.b=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this.b)this.b.run=M;else{let O,F;const U=new Promise((H,x)=>{O=H,F=x});this.b={run:M,promise:U,promiseResolve:O,promiseReject:F}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=J;class le{constructor(M,O=()=>Date.now()){this.d=M,this.f=O,this.a=0,this.b=0}increment(){const M=this.f();return M-this.a>this.d&&(this.a=M,this.b=0),this.b++,this.b}}e.IntervalCounter=le;class ${get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((M,O)=>{this.a=M,this.b=O})}complete(M){return new Promise(O=>{this.a(M),this.f=!0,O()})}error(M){return new Promise(O=>{this.b(M),this.d=!0,O()})}cancel(){new Promise(M=>{this.b(new t.CancellationError),this.d=!0,M()})}}e.DeferredPromise=$;var W;(function(j){async function M(F){let U;const H=await Promise.all(F.map(x=>x.then(B=>B,B=>{U||(U=B)})));if(typeof U<"u")throw U;return H}j.settled=M;function O(F){return new Promise(async(U,H)=>{try{await F(U,H)}catch(x){H(x)}})}j.withAsyncBody=O})(W=e.Promises||(e.Promises={}));var T;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(T||(T={}));class z{static fromArray(M){return new z(O=>{O.emitMany(M)})}static fromPromise(M){return new z(async O=>{O.emitMany(await M)})}static fromPromises(M){return new z(async O=>{await Promise.all(M.map(async F=>O.emitOne(await F)))})}static merge(M){return new z(async O=>{await Promise.all(M.map(async F=>{for await(const U of F)O.emitOne(U)}))})}constructor(M){this.a=0,this.b=[],this.d=null,this.f=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:F=>this.g(F),emitMany:F=>this.h(F),reject:F=>this.k(F)};try{await Promise.resolve(M(O)),this.j()}catch(F){this.k(F)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(M<this.b.length)return{done:!1,value:this.b[M++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(M,O){return new z(async F=>{for await(const U of M)F.emitOne(O(U))})}map(M){return z.map(this,M)}static filter(M,O){return new z(async F=>{for await(const U of M)O(U)&&F.emitOne(U)})}filter(M){return z.filter(this,M)}static coalesce(M){return z.filter(M,O=>!!O)}coalesce(){return z.coalesce(this)}static async toPromise(M){const O=[];for await(const F of M)O.push(F);return O}toPromise(){return z.toPromise(this)}g(M){this.a===0&&(this.b.push(M),this.f.fire())}h(M){this.a===0&&(this.b=this.b.concat(M),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(M){this.a===0&&(this.a=2,this.d=M,this.f.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class Q extends z{constructor(M,O){super(O),this.l=M}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Q;function q(j){const M=new E.CancellationTokenSource,O=j(M.token);return new Q(M,async F=>{const U=M.token.onCancellationRequested(()=>{U.dispose(),M.dispose(),F.reject(new t.CancellationError)});try{for await(const H of O){if(M.token.isCancellationRequested)return;F.emitOne(H)}U.dispose(),M.dispose()}catch(H){U.dispose(),M.dispose(),F.reject(H)}})}e.createCancelableAsyncIterable=q}),define(ie[99],ne([0,1,24,8,30,39,9,4,26]),function(G,e,E,t,k,R,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",S="[^/\\\\]",y=/\//g;function u($,W){switch($){case 0:return"";case 1:return`${S}*?`;default:return`(?:${b}|${S}+${b}${W?`|${b}${S}+`:""})*?`}}function f($,W){if(!$)return[];const T=[];let z=!1,Q=!1,q="";for(const j of $){switch(j){case W:if(!z&&!Q){T.push(q),q="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}q+=j}return q&&T.push(q),T}e.splitGlobAware=f;function p($){if(!$)return"";let W="";const T=f($,e.GLOB_SPLIT);if(T.every(z=>z===e.GLOBSTAR))W=".*";else{let z=!1;T.forEach((Q,q)=>{if(Q===e.GLOBSTAR){if(z)return;W+=u(2,q===T.length-1)}else{let j=!1,M="",O=!1,F="";for(const U of Q){if(U!=="}"&&j){M+=U;continue}if(O&&(U!=="]"||!F)){let H;U==="-"?H=U:(U==="^"||U==="!")&&!F?H="^":U===e.GLOB_SPLIT?H="":H=(0,w.escapeRegExpCharacters)(U),F+=H;continue}switch(U){case"{":j=!0;continue;case"[":O=!0;continue;case"}":{W+=`(?:${f(M,",").map(B=>p(B)).join("|")})`,j=!1,M="";break}case"]":{W+="["+F+"]",O=!1,F="";break}case"?":W+=S;continue;case"*":W+=u(1);continue;default:W+=(0,w.escapeRegExpCharacters)(U)}}q<T.length-1&&(T[q+1]!==e.GLOBSTAR||q+2<T.length)&&(W+=b)}z=Q===e.GLOBSTAR})}return W}const h=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,C=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,I=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),n=function(){return!1},r=function(){return null};function a($,W){if(!$)return r;let T;typeof $!="string"?T=$.pattern:T=$,T=T.trim();const z=`${T}_${!!W.trimForExclusions}`;let Q=i.get(z);if(Q)return s(Q,$);let q;return h.test(T)?Q=o(T.substr(4),T):(q=l.exec(c(T,W)))?Q=d(q[1],T):(W.trimForExclusions?C:v).test(T)?Q=D(T,W):(q=I.exec(c(T,W)))?Q=L(q[1].substr(1),T,!0):(q=m.exec(c(T,W)))?Q=L(q[1],T,!1):Q=N(T),i.set(z,Q),s(Q,$)}function s($,W){if(typeof W=="string")return $;const T=function(z,Q){return(0,k.isEqualOrParent)(z,W.base,!P.isLinux)?$((0,w.ltrim)(z.substr(W.base.length),A.sep),Q):null};return T.allBasenames=$.allBasenames,T.allPaths=$.allPaths,T.basenames=$.basenames,T.patterns=$.patterns,T}function c($,W){return W.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function o($,W){return function(T,z){return typeof T=="string"&&T.endsWith($)?W:null}}function d($,W){const T=`/${$}`,z=`\\${$}`,Q=function(j,M){return typeof j!="string"?null:M?M===$?W:null:j===$||j.endsWith(T)||j.endsWith(z)?W:null},q=[$];return Q.basenames=q,Q.patterns=[W],Q.allBasenames=q,Q}function D($,W){const T=J($.slice(1,-1).split(",").map(M=>a(M,W)).filter(M=>M!==r),$),z=T.length;if(!z)return r;if(z===1)return T[0];const Q=function(M,O){for(let F=0,U=T.length;F<U;F++)if(T[F](M,O))return $;return null},q=T.find(M=>!!M.allBasenames);q&&(Q.allBasenames=q.allBasenames);const j=T.reduce((M,O)=>O.allPaths?M.concat(O.allPaths):M,[]);return j.length&&(Q.allPaths=j),Q}function L($,W,T){const z=A.sep===A.posix.sep,Q=z?$:$.replace(y,A.sep),q=A.sep+Q,j=A.posix.sep+$;let M;return T?M=function(O,F){return typeof O=="string"&&(O===Q||O.endsWith(q)||!z&&(O===$||O.endsWith(j)))?W:null}:M=function(O,F){return typeof O=="string"&&(O===Q||!z&&O===$)?W:null},M.allPaths=[(T?"*/":"./")+$],M}function N($){try{const W=new RegExp(`^${p($)}$`);return function(T){return W.lastIndex=0,typeof T=="string"&&W.test(T)?$:null}}catch{return r}}function V($,W,T){return!$||typeof W!="string"?!1:oe($)(W,void 0,T)}e.match=V;function oe($,W={}){if(!$)return n;if(typeof $=="string"||X($)){const T=a($,W);if(T===r)return n;const z=function(Q,q){return!!T(Q,q)};return T.allBasenames&&(z.allBasenames=T.allBasenames),T.allPaths&&(z.allPaths=T.allPaths),z}return re($,W)}e.parse=oe;function X($){const W=$;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.isRelativePattern=X;function Y($){return $.allBasenames||[]}e.getBasenameTerms=Y;function se($){return $.allPaths||[]}e.getPathTerms=se;function re($,W){const T=J(Object.getOwnPropertyNames($).map(M=>fe(M,$[M],W)).filter(M=>M!==r)),z=T.length;if(!z)return r;if(!T.some(M=>!!M.requiresSiblings)){if(z===1)return T[0];const M=function(U,H){let x;for(let B=0,_=T.length;B<_;B++){const Z=T[B](U,H);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&(x||(x=[]),x.push(Z))}return x?(async()=>{for(const B of x){const _=await B;if(typeof _=="string")return _}return null})():null},O=T.find(U=>!!U.allBasenames);O&&(M.allBasenames=O.allBasenames);const F=T.reduce((U,H)=>H.allPaths?U.concat(H.allPaths):U,[]);return F.length&&(M.allPaths=F),M}const Q=function(M,O,F){let U,H;for(let x=0,B=T.length;x<B;x++){const _=T[x];_.requiresSiblings&&F&&(O||(O=(0,A.basename)(M)),U||(U=O.substr(0,O.length-(0,A.extname)(M).length)));const Z=_(M,O,U,F);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&(H||(H=[]),H.push(Z))}return H?(async()=>{for(const x of H){const B=await x;if(typeof B=="string")return B}return null})():null},q=T.find(M=>!!M.allBasenames);q&&(Q.allBasenames=q.allBasenames);const j=T.reduce((M,O)=>O.allPaths?M.concat(O.allPaths):M,[]);return j.length&&(Q.allPaths=j),Q}function fe($,W,T){if(W===!1)return r;const z=a($,T);if(z===r)return r;if(typeof W=="boolean")return z;if(W){const Q=W.when;if(typeof Q=="string"){const q=(j,M,O,F)=>{if(!F||!z(j,M))return null;const U=Q.replace("$(basename)",()=>O),H=F(U);return(0,t.isThenable)(H)?H.then(x=>x?$:null):H?$:null};return q.requiresSiblings=!0,q}}return z}function J($,W){const T=$.filter(M=>!!M.basenames);if(T.length<2)return $;const z=T.reduce((M,O)=>{const F=O.basenames;return F?M.concat(F):M},[]);let Q;if(W){Q=[];for(let M=0,O=z.length;M<O;M++)Q.push(W)}else Q=T.reduce((M,O)=>{const F=O.patterns;return F?M.concat(F):M},[]);const q=function(M,O){if(typeof M!="string")return null;if(!O){let U;for(U=M.length;U>0;U--){const H=M.charCodeAt(U-1);if(H===47||H===92)break}O=M.substr(U)}const F=z.indexOf(O);return F!==-1?Q[F]:null};q.basenames=z,q.patterns=Q,q.allBasenames=z;const j=$.filter(M=>!M.basenames);return j.push(q),j}function le($,W){return(0,E.equals)($,W,(T,z)=>typeof T=="string"&&typeof z=="string"?T===z:typeof T!="string"&&typeof z!="string"?T.base===z.base&&T.pattern===z.pattern:!1)}e.patternsEquals=le}),define(ie[34],ne([0,1,24,30,9,4,20,26]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(r,a){const{os:s,tildify:c,relative:o}=a;if(o){const L=g(r,o,s);if(typeof L=="string")return L}let d=r.fsPath;if(s===1&&!R.isWindows?d=d.replace(/\//g,"\\"):s!==1&&R.isWindows&&(d=d.replace(/\\/g,"/")),s!==1&&c?.userHome){const L=c.userHome.fsPath;let N;r.scheme!==c.userHome.scheme&&r.path.startsWith(k.posix.sep)?N=c.userHome.with({path:r.path}).fsPath:N=r.fsPath,d=y(N,L,s)}return(s===1?k.win32:k.posix).normalize(b(d,s===1))}e.getPathLabel=w;function g(r,a,s){const c=s===1?k.win32:k.posix,o=s===3?A.extUri:A.extUriIgnorePathCase,d=a.getWorkspace(),D=(0,E.firstOrDefault)(d.folders);if(!D)return;r.scheme!==D.uri.scheme&&r.path.startsWith(k.posix.sep)&&(r=D.uri.with({path:r.path}));const L=a.getWorkspaceFolder(r);if(!L)return;let N;if(o.isEqual(L.uri,r)?N="":N=o.relativePath(L.uri,r)??"",N&&(N=c.normalize(N)),d.folders.length>1&&!a.noPrefix){const V=L.name?L.name:o.basenameOrAuthority(L.uri);N=N?`${V} \u2022 ${N}`:V}return N}function b(r,a=R.isWindows){return(0,t.hasDriveLetter)(r,a)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=b;let S=Object.create(null);function y(r,a,s=R.OS){if(s===1||!r||!a)return r;let c=S.original===a?S.normalized:void 0;c||(c=a,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,P.rtrim)(c,k.posix.sep)}${k.posix.sep}`,S={original:a,normalized:c});let o=r;return R.isWindows&&(o=(0,t.toSlashes)(o)),(s===3?o.startsWith(c):(0,P.startsWithIgnoreCase)(o,c))?`~/${o.substr(c.length)}`:r}e.tildify=y;function u(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=u;const f="\u2026",p="\\\\",h="~";function l(r,a=k.sep){const s=new Array(r.length);let c=!1;for(let o=0;o<r.length;o++){const d=r[o];if(d===""){s[o]=`.${a}`;continue}if(!d){s[o]=d;continue}c=!0;let D="",L=d;L.indexOf(p)===0?(D=L.substr(0,L.indexOf(p)+p.length),L=L.substr(L.indexOf(p)+p.length)):L.indexOf(a)===0?(D=L.substr(0,L.indexOf(a)+a.length),L=L.substr(L.indexOf(a)+a.length)):L.indexOf(h)===0&&(D=L.substr(0,L.indexOf(h)+h.length),L=L.substr(L.indexOf(h)+h.length));const N=L.split(a);for(let V=1;c&&V<=N.length;V++)for(let oe=N.length-V;c&&oe>=0;oe--){c=!1;let X=N.slice(oe,oe+V).join(a);for(let Y=0;!c&&Y<r.length;Y++)if(Y!==o&&r[Y]&&r[Y].indexOf(X)>-1){const se=oe+V===N.length,re=oe>0&&r[Y].indexOf(a)>-1?a+X:X,fe=r[Y].endsWith(re);c=!se||fe}if(!c){let Y="";(N[0].endsWith(":")||D!=="")&&(oe===1&&(oe=0,V++,X=N[0]+a+X),oe>0&&(Y=N[0]+a),Y=D+Y),oe>0&&(Y=Y+f+a),Y=Y+X,oe+V<N.length&&(Y=Y+a+f),s[o]=Y}}c&&(s[o]=d)}return s}e.shorten=l;var v;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function C(r,a=Object.create(null)){const s=[];let c=!1,o="";for(const d of r)if(d==="$"||c&&d==="{")o&&s.push({value:o,type:v.TEXT}),o="",c=!0;else if(d==="}"&&c){const D=a[o];if(typeof D=="string")D.length&&s.push({value:D,type:v.VARIABLE});else if(D){const L=s[s.length-1];(!L||L.type!==v.SEPARATOR)&&s.push({value:D.label,type:v.SEPARATOR})}o="",c=!1}else o+=d;return o&&!c&&s.push({value:o,type:v.TEXT}),s.filter((d,D)=>{if(d.type===v.SEPARATOR){const L=s[D-1],N=s[D+1];return[L,N].every(V=>V&&(V.type===v.VARIABLE||V.type===v.TEXT)&&V.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=C;function I(r,a){return R.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):r.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=I;function m(r,a){return R.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):R.isWindows?r.replace(/&&|&/g,s=>s==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=m;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function n(r){const a=r.indexOf("/")!==-1?k.posix:k.win32,s=a.basename(r),c=a.dirname(r);return s.length?{name:s,parentPath:c}:{name:c,parentPath:""}}e.splitName=n}),define(ie[140],ne([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(b){return b.toJSON()}class k{constructor(S){this.a=S}transformIncoming(S){const y=this.a.transformIncoming(S);return y===S?S:t(E.URI.from(y))}transformOutgoing(S){const y=this.a.transformOutgoing(S);return y===S?S:t(E.URI.from(y))}transformOutgoingURI(S){const y=this.a.transformOutgoing(S);return y===S?S:E.URI.from(y)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function R(b,S,y){if(!b||y>200)return null;if(typeof b=="object"){if(b instanceof E.URI)return S.transformOutgoing(b);for(const u in b)if(Object.hasOwnProperty.call(b,u)){const f=R(b[u],S,y+1);f!==null&&(b[u]=f)}}return null}function A(b,S){const y=R(b,S,0);return y===null?b:y}e.transformOutgoingURIs=A;function P(b,S,y,u){if(!b||u>200)return null;if(typeof b=="object"){if(b.$mid===1)return y?E.URI.revive(S.transformIncoming(b)):S.transformIncoming(b);for(const f in b)if(Object.hasOwnProperty.call(b,f)){const p=P(b[f],S,y,u+1);p!==null&&(b[f]=p)}}return null}function w(b,S){const y=P(b,S,!1,0);return y===null?b:y}e.transformIncomingURIs=w;function g(b,S){const y=P(b,S,!0,0);return y===null?b:y}e.transformAndReviveIncomingURIs=g}),define(ie[81],ne([0,1,25,15,60,29,128]),function(G,e,E,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(b){return this.a||(this.a=k.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,S=0;const y=(0,E.networkInterfaces)();for(const u in y){const f=y[u];if(f)for(const{mac:p,internal:h}of f)h||(S+=1,this.c(p.toUpperCase())&&(b+=1))}this.b=S>0?b/S:0}return this.b}};let P;async function w(){return P||(P=(async()=>await g()||R.generateUuid())()),P}e.getMachineId=w;async function g(){try{const b=await new Promise((y,u)=>{G(["crypto"],y,u)}),S=(0,A.getMac)();return b.createHash("sha256").update(S,"utf8").digest("hex")}catch(b){t.onUnexpectedError(b);return}}}),define(ie[23],ne([0,1,40,25,141,8,30,76,9,4,20,7]),function(G,e,E,t,k,R,A,P,w,g,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function u(re,fe=y.UNLINK){if((0,A.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");return fe===y.UNLINK?p(re):f(re)}async function f(re){try{const fe=(0,A.randomPath)((0,t.tmpdir)());try{await E.promises.rename(re,fe)}catch(J){return J.code==="ENOENT"?void 0:p(re)}p(fe).catch(J=>{})}catch(fe){if(fe.code!=="ENOENT")throw fe}}async function p(re){return(0,k.promisify)(E.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function h(re){if((0,A.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function l(re,fe){return I(await(fe?v(re):(0,k.promisify)(E.readdir)(re)))}async function v(re){try{return await(0,k.promisify)(E.readdir)(re,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const fe=[],J=await l(re);for(const le of J){let $=!1,W=!1,T=!1;try{const z=await e.Promises.lstat((0,w.join)(re,le));$=z.isFile(),W=z.isDirectory(),T=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}fe.push({name:le,isFile:()=>$,isDirectory:()=>W,isSymbolicLink:()=>T})}return fe}function C(re){return I(E.readdirSync(re))}e.readdirSync=C;function I(re){return re.map(fe=>typeof fe=="string"?g.isMacintosh?(0,P.normalizeNFC)(fe):fe:(fe.name=g.isMacintosh?(0,P.normalizeNFC)(fe.name):fe.name,fe))}async function m(re){const fe=await l(re),J=[];for(const le of fe)await n.existsDirectory((0,w.join)(re,le))&&J.push(le);return J}function i(re,fe=1e3){return new Promise(J=>{let le=!1;const $=setInterval(()=>{le||(le=!0,E.access(re,W=>{le=!1,W&&(clearInterval($),J(void 0))}))},fe)})}e.whenDeleted=i;var n;(function(re){async function fe($){let W;try{if(W=await e.Promises.lstat($),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(g.isWindows&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw z}throw T}}re.stat=fe;async function J($){try{const{stat:W,symbolicLink:T}=await re.stat($);return W.isFile()&&T?.dangling!==!0}catch{}return!1}re.existsFile=J;async function le($){try{const{stat:W,symbolicLink:T}=await re.stat($);return W.isDirectory()&&T?.dangling!==!0}catch{}return!1}re.existsDirectory=le})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new R.ResourceQueue;function a(re,fe,J){return r.queueFor(S.URI.file(re),b.extUriBiasedIgnorePathCase).queue(()=>{const le=D(J);return new Promise(($,W)=>o(re,fe,le,T=>T?W(T):$()))})}let s=!0;function c(re){s=re}e.configureFlushOnWrite=c;function o(re,fe,J,le){if(!s)return E.writeFile(re,fe,{mode:J.mode,flag:J.flag},le);E.open(re,J.flag,J.mode,($,W)=>{if($)return le($);E.writeFile(W,fe,T=>{if(T)return E.close(W,()=>le(T));E.fdatasync(W,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),c(!1)),E.close(W,Q=>le(Q))))})})}function d(re,fe,J){const le=D(J);if(!s)return E.writeFileSync(re,fe,{mode:le.mode,flag:le.flag});const $=E.openSync(re,le.flag,le.mode);try{E.writeFileSync($,fe);try{E.fdatasyncSync($)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),c(!1)}}finally{E.closeSync($)}}e.writeFileSync=d;function D(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function L(re,fe){if(re!==fe)try{await e.Promises.rename(re,fe)}catch(J){if(re.toLowerCase()!==fe.toLowerCase()&&J.code==="EXDEV"||re.endsWith("."))await N(re,fe,{preserveSymlinks:!1}),await u(re,y.MOVE);else throw J}}async function N(re,fe,J){return oe(re,fe,{root:{source:re,target:fe},options:J,handledSourcePaths:new Set})}const V=511;async function oe(re,fe,J){if(J.handledSourcePaths.has(re))return;J.handledSourcePaths.add(re);const{stat:le,symbolicLink:$}=await n.stat(re);if($){if(J.options.preserveSymlinks)try{return await se(re,fe,J)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if($.dangling)return}return le.isDirectory()?X(re,fe,le.mode&V,J):Y(re,fe,le.mode&V)}async function X(re,fe,J,le){await e.Promises.mkdir(fe,{recursive:!0,mode:J});const $=await l(re);for(const W of $)await oe((0,w.join)(re,W),(0,w.join)(fe,W),le)}async function Y(re,fe,J){await e.Promises.copyFile(re,fe),await e.Promises.chmod(fe,J)}async function se(re,fe,J){let le=await e.Promises.readlink(re);(0,A.isEqualOrParent)(le,J.root.source,!g.isLinux)&&(le=(0,w.join)(J.root.target,le.substr(J.root.source.length+1))),await e.Promises.symlink(le,fe)}e.Promises=new class{get access(){return(0,k.promisify)(E.access)}get stat(){return(0,k.promisify)(E.stat)}get lstat(){return(0,k.promisify)(E.lstat)}get utimes(){return(0,k.promisify)(E.utimes)}get read(){return(re,fe,J,le,$)=>new Promise((W,T)=>{E.read(re,fe,J,le,$,(z,Q,q)=>z?T(z):W({bytesRead:Q,buffer:q}))})}get readFile(){return(0,k.promisify)(E.readFile)}get write(){return(re,fe,J,le,$)=>new Promise((W,T)=>{E.write(re,fe,J,le,$,(z,Q,q)=>z?T(z):W({bytesWritten:Q,buffer:q}))})}get appendFile(){return(0,k.promisify)(E.appendFile)}get fdatasync(){return(0,k.promisify)(E.fdatasync)}get truncate(){return(0,k.promisify)(E.truncate)}get rename(){return(0,k.promisify)(E.rename)}get copyFile(){return(0,k.promisify)(E.copyFile)}get open(){return(0,k.promisify)(E.open)}get close(){return(0,k.promisify)(E.close)}get symlink(){return(0,k.promisify)(E.symlink)}get readlink(){return(0,k.promisify)(E.readlink)}get chmod(){return(0,k.promisify)(E.chmod)}get mkdir(){return(0,k.promisify)(E.mkdir)}get unlink(){return(0,k.promisify)(E.unlink)}get rmdir(){return(0,k.promisify)(E.rmdir)}get realpath(){return(0,k.promisify)(E.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return m}get writeFile(){return a}get rm(){return u}get move(){return L}get copy(){return N}}}),define(ie[100],ne([0,1,40,9,4,26,23]),function(G,e,E,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(y){if(k.isLinux)return y;const u=(0,t.dirname)(y);if(y===u)return y;const f=((0,t.basename)(y)||y).toLowerCase();try{const h=(0,A.readdirSync)(u).filter(l=>l.toLowerCase()===f);if(h.length===1){const l=P(u);if(l)return(0,t.join)(l,h[0])}else if(h.length>1){const l=h.indexOf(f);if(l>=0){const v=P(u);if(v)return(0,t.join)(v,h[l])}}}catch{}return null}e.realcaseSync=P;async function w(y){if(k.isLinux)return y;const u=(0,t.dirname)(y);if(y===u)return y;const f=((0,t.basename)(y)||y).toLowerCase();try{const h=(await A.Promises.readdir(u)).filter(l=>l.toLowerCase()===f);if(h.length===1){const l=await w(u);if(l)return(0,t.join)(l,h[0])}else if(h.length>1){const l=h.indexOf(f);if(l>=0){const v=await w(u);if(v)return(0,t.join)(v,h[l])}}}catch{}return null}e.realcase=w;async function g(y){try{return await A.Promises.realpath(y)}catch{const f=S(y);return await A.Promises.access(f,E.constants.R_OK),f}}e.realpath=g;function b(y){try{return E.realpathSync(y)}catch{const f=S(y);return E.accessSync(f,E.constants.R_OK),f}}e.realpathSync=b;function S(y){return(0,R.rtrim)((0,t.normalize)(y),t.sep)}}),define(ie[142],ne([0,1,25,9,23]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var w;(function(I){I[I.x64=0]="x64",I[I.x86=1]="x86",I[I.ARM=2]="ARM"})(w||(w={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class S{constructor(m,i,n){this.exePath=m,this.displayName=i,this.a=n}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:I=!1}={}){return I?g===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:I=!1,findPreview:m=!1}={}){const i=y({useAlternateBitness:I});if(!i)return null;const n=t.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(n))return null;let r=-1,a=null;for(const o of await k.Promises.readdir(n)){let d=-1;if(m){const L=o.indexOf("-");if(L<0)continue;const N=o.substring(0,L);if(!R.test(N)||o.substring(L+1)!=="preview")continue;d=parseInt(N,10)}else{if(!R.test(o))continue;d=parseInt(o,10)}if(d<=r)continue;const D=t.join(n,o,"pwsh.exe");!await k.SymlinkSupport.existsFile(D)||(a=D,r=d)}if(!a)return null;const s=i.includes("x86")?" (x86)":"",c=m?" Preview":"";return new S(a,`PowerShell${c}${s}`,!0)}async function f({findPreview:I}={}){if(!process.env.LOCALAPPDATA)return null;const m=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(m))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=I?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await k.Promises.readdir(m))if(i.test(r)){const a=t.join(m,r,"pwsh.exe");return new S(a,n)}return null}function p(){const I=t.join(E.homedir(),".dotnet","tools","pwsh.exe");return new S(I,".NET Core PowerShell Global Tool")}function h(){const I=t.join(process.env.windir,g===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(I,"Windows PowerShell",!0)}async function*l(){let I=await u();I&&(yield I),I=await u({useAlternateBitness:!0}),I&&(yield I),I=await f(),I&&(yield I),I=p(),I&&(yield I),I=await u({findPreview:!0}),I&&(yield I),I=await f({findPreview:!0}),I&&(yield I),I=await u({useAlternateBitness:!0,findPreview:!0}),I&&(yield I),I=h(),I&&(yield I)}async function*v(){for await(const I of l())await I.exists()&&(yield I)}e.enumeratePowerShellInstallations=v;async function C(){for await(const I of v())return I;return null}e.getFirstAvailablePowerShellInstallation=C}),define(ie[82],ne([0,1,9,4,33,79,11,23]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function w(S=k.env){return S.comspec||"cmd.exe"}e.getWindowsShell=w;function g(S){let y=[],u=!1;const f=function(p){if(u){y.push(p);return}(!S.send(p,l=>{if(l&&console.error(l),u=!1,y.length>0){const v=y.slice(0);y=[],v.forEach(C=>f(C))}})||t.isWindows)&&(u=!0)};return{send:f}}e.createQueuedSender=g;var b;(function(S){async function y(u,f,p){if(E.isAbsolute(u))return u;if(f===void 0&&(f=k.cwd()),E.dirname(u)!=="."||(p===void 0&&A.isString(k.env.PATH)&&(p=k.env.PATH.split(E.delimiter)),p===void 0||p.length===0))return E.join(f,u);async function l(v){if(await P.Promises.exists(v)){let C;try{C=await P.Promises.stat(v)}catch(I){I.message.startsWith("EACCES")&&(C=await P.Promises.lstat(v))}return C?!C.isDirectory():!1}return!1}for(const v of p){let C;if(E.isAbsolute(v)?C=E.join(v,u):C=E.join(f,v,u),await l(C))return C;let I=C+".com";if(await l(I)||(I=C+".exe",await l(I)))return I}return E.join(f,u)}S.findExecutable=y})(b=e.win32||(e.win32={}))}),define(ie[101],ne([0,1,46,14]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(A){return new Promise((P,w)=>{let g;const b=new Map;function S(u,f,p,h,l){const v=b.get(f);if(u===A||v){const C={name:y(p),cmd:p,pid:u,ppid:f,load:h,mem:l};b.set(u,C),u===A&&(g=C),v&&(v.children||(v.children=[]),v.children.push(C),v.children.length>1&&(v.children=v.children.sort((I,m)=>I.pid-m.pid)))}}function y(u){const f=/--vscode-window-kind=shared-process/,p=/--vscode-window-kind=issue-reporter/,h=/--vscode-window-kind=process-explorer/,l=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,C=/--crashes-directory/,I=/\\pipe\\winpty-control/,m=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(C.exec(u))return"electron-crash-reporter";if(I.exec(u))return"winpty-process";if(m.exec(u))return"console-window-host (Windows internal process)";let n=i.exec(u);if(n&&n.length===2){if(n[1]==="renderer")return f.exec(u)?"shared-process":p.exec(u)?"issue-reporter":h.exec(u)?"process-explorer":"window";if(n[1]==="utility"){if(l.exec(u))return"utility-network-service";if(v.exec(u))return"extension-host"}return n[1]}const r=/[a-zA-Z-]+\.js/g;let a="";do n=r.exec(u),n&&(a+=n+" ");while(n);return a&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron_node ${a}`:u}if(process.platform==="win32"){const u=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,p)=>{G(["windows-process-tree"],f,p)}).then(f=>{f.getProcessList(A,p=>{if(!p){w(new Error(`Root process ${A} not found`));return}f.getProcessCpuUsage(p,h=>{const l=new Map;h.forEach(v=>{const C=u(v.commandLine||"");l.set(v.pid,{name:y(C),cmd:C,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),g=l.get(A),g?(l.forEach(v=>{const C=l.get(v.ppid);C&&(C.children||(C.children=[]),C.children.push(v))}),l.forEach(v=>{v.children&&(v.children=v.children.sort((C,I)=>C.pid-I.pid))}),P(g)):w(new Error(`Root process ${A} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let u=function(){let f=[g];const p=[];for(;f.length;){const l=f.shift();l&&(p.push(l.pid),l.children&&(f=f.concat(l.children)))}let h=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);h+=" "+p.join(" "),(0,E.exec)(h,{},(l,v,C)=>{if(l||C)w(l||new Error(C.toString()));else{const I=v.toString().split(`
`);for(let m=0;m<p.length;m++){const i=b.get(p[m]);i.load=parseFloat(I[m])}if(!g){w(new Error(`Root process ${A} not found`));return}P(g)}})};(0,E.exec)("which ps",{},(f,p,h)=>{if(f||h)if(process.platform!=="linux")w(f||new Error(h.toString()));else{const l=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(l,{},(v,C,I)=>{v||I?w(v||new Error(I.toString())):(R(C,S),u())})}else{const l=p.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${l} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(C,I,m)=>{C||m&&!m.includes("screen size is bogus")?w(C||new Error(m.toString())):(R(I,S),process.platform==="linux"?u():g?P(g):w(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=k;function R(A,P){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=A.toString().split(`
`);for(const b of g){const S=w.exec(b.trim());S&&S.length===6&&P(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(ie[143],ne([0,1,25,4,142,82]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function A(S,y){return S===1?t.isWindows?b():R.getWindowsShell(y):w(S,y)}e.getSystemShell=A;let P=null;function w(S,y){if(t.isLinux&&S===2||t.isMacintosh&&S===3)return"/bin/bash";if(!P){let u;if(t.isWindows)u="/bin/bash";else{if(u=y.SHELL,!u)try{u=(0,E.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}P=u}return P}let g=null;async function b(){return g||(g=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),g}});var pe=this&&this.__decorate||function(G,e,E,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,E):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(G,e,E,t);else for(var P=G.length-1;P>=0;P--)(A=G[P])&&(R=(k<3?A(R):k>3?A(e,E,R):A(e,E))||R);return k>3&&R&&Object.defineProperty(e,E,R),R};define(ie[47],ne([0,1,24,8,17,22,53,15,3,2,69,26,11]),function(G,e,E,t,k,R,A,P,w,g,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var u;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(u||(u={}));function f(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(p||(p={}));function h(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(l||(l={}));function v(W){let T=0;for(let z=0;;z+=7){const Q=W.read(1);if(T|=(Q.buffer[0]&127)<<z,!(Q.buffer[0]&128))return T}}const C=r(0);function I(W,T){if(T===0){W.write(C);return}let z=0;for(let q=T;q!==0;q=q>>>7)z++;const Q=k.VSBuffer.alloc(z);for(let q=0;T!==0;q++)Q.buffer[q]=T&127,T=T>>>7,T>0&&(Q.buffer[q]|=128);W.write(Q)}class m{constructor(T){this.b=T,this.a=0}read(T){const z=this.b.slice(this.a,this.a+T);return this.a+=z.byteLength,z}}e.BufferReader=m;class i{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(T){this.a.push(T)}}e.BufferWriter=i;var n;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(n||(n={}));function r(W){const T=k.VSBuffer.alloc(1);return T.writeUInt8(W,0),T}const a={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},s=typeof Buffer<"u";function c(W,T){if(typeof T>"u")W.write(a.Undefined);else if(typeof T=="string"){const z=k.VSBuffer.fromString(T);W.write(a.String),I(W,z.byteLength),W.write(z)}else if(s&&Buffer.isBuffer(T)){const z=k.VSBuffer.wrap(T);W.write(a.Buffer),I(W,z.byteLength),W.write(z)}else if(T instanceof k.VSBuffer)W.write(a.VSBuffer),I(W,T.byteLength),W.write(T);else if(Array.isArray(T)){W.write(a.Array),I(W,T.length);for(const z of T)c(W,z)}else if(typeof T=="number"&&(T|0)===T)W.write(a.Uint),I(W,T);else{const z=k.VSBuffer.fromString(JSON.stringify(T));W.write(a.Object),I(W,z.byteLength),W.write(z)}}e.serialize=c;function o(W){switch(W.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return W.read(v(W)).toString();case n.Buffer:return W.read(v(W)).buffer;case n.VSBuffer:return W.read(v(W));case n.Array:{const z=v(W),Q=[];for(let q=0;q<z;q++)Q.push(o(W));return Q}case n.Object:return JSON.parse(W.read(v(W)).toString());case n.Int:return v(W)}}e.deserialize=o;class d{constructor(T,z,Q=null,q=1e3){this.h=T,this.j=z,this.k=Q,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(j=>this.q(j)),this.m({type:200})}registerChannel(T,z){this.b.set(T,z),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const z=this.o([T.type]);this.k?.logOutgoing(z,0,1,h(T.type));return}case 201:case 202:case 204:case 203:{const z=this.o([T.type,T.id],T.data);this.k?.logOutgoing(z,T.id,1,h(T.type),T.data);return}}}o(T,z=void 0){const Q=new i;return c(Q,T),c(Q,z),this.p(Q.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const z=new m(T),Q=o(z),q=o(z),j=Q[0];switch(j){case 100:return this.k?.logIncoming(T.byteLength,Q[1],1,`${f(j)}: ${Q[2]}.${Q[3]}`,q),this.s({type:j,id:Q[1],channelName:Q[2],name:Q[3],arg:q});case 102:return this.k?.logIncoming(T.byteLength,Q[1],1,`${f(j)}: ${Q[2]}.${Q[3]}`,q),this.t({type:j,id:Q[1],channelName:Q[2],name:Q[3],arg:q});case 101:return this.k?.logIncoming(T.byteLength,Q[1],1,`${f(j)}`),this.u({type:j,id:Q[1]});case 103:return this.k?.logIncoming(T.byteLength,Q[1],1,`${f(j)}`),this.u({type:j,id:Q[1]})}}s(T){const z=this.b.get(T.channelName);if(!z){this.v(T);return}const Q=new R.CancellationTokenSource;let q;try{q=z.call(this.j,T.name,T.arg,Q.token)}catch(O){q=Promise.reject(O)}const j=T.id;q.then(O=>{this.m({id:j,data:O,type:201}),this.d.delete(T.id)},O=>{O instanceof Error?this.m({id:j,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.m({id:j,data:O,type:203}),this.d.delete(T.id)});const M=(0,g.toDisposable)(()=>Q.cancel());this.d.set(T.id,M)}t(T){const z=this.b.get(T.channelName);if(!z){this.v(T);return}const Q=T.id,j=z.listen(this.j,T.name,T.arg)(M=>this.m({id:Q,data:M,type:204}));this.d.set(T.id,j)}u(T){const z=this.d.get(T.id);z&&(z.dispose(),this.d.delete(T.id))}v(T){let z=this.g.get(T.channelName);z||(z=[],this.g.set(T.channelName,z));const Q=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:T,timeoutTimer:Q})}w(T){const z=this.g.get(T);if(z){for(const Q of z)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=d;var D;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(T,z=null){this.l=T,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=z}getChannel(T){const z=this;return{call(Q,q,j){return z.a?Promise.reject(new P.CancellationError):z.m(T,Q,q,j)},listen(Q,q){return z.a?w.Event.None:z.o(T,Q,q)}}}m(T,z,Q,q=R.CancellationToken.None){const j=this.g++,O={id:j,type:100,channelName:T,name:z,arg:Q};if(q.isCancellationRequested)return Promise.reject(new P.CancellationError);let F;return new Promise((H,x)=>{if(q.isCancellationRequested)return x(new P.CancellationError);const B=()=>{const ge=ke=>{switch(ke.type){case 201:this.f.delete(j),H(ke.data);break;case 202:{this.f.delete(j);const Oe=new Error(ke.data.message);Oe.stack=Array.isArray(ke.data.stack)?ke.data.stack.join(`
`):ke.data.stack,Oe.name=ke.data.name,x(Oe);break}case 203:this.f.delete(j),x(ke.data);break}};this.f.set(j,ge),this.p(O)};let _=null;this.b===l.Idle?B():(_=(0,t.createCancelablePromise)(ge=>this.u()),_.then(()=>{_=null,B()}));const Z=()=>{_?(_.cancel(),_=null):this.p({id:j,type:101}),x(new P.CancellationError)},ae=q.onCancellationRequested(Z);F=(0,g.combinedDisposable)((0,g.toDisposable)(Z),ae),this.d.add(F)}).finally(()=>{this.d.delete(F)})}o(T,z,Q){const q=this.g++,M={id:q,type:102,channelName:T,name:z,arg:Q};let O=null;const F=new w.Emitter({onWillAddFirstListener:()=>{O=(0,t.createCancelablePromise)(H=>this.u()),O.then(()=>{O=null,this.d.add(F),this.p(M)})},onDidRemoveLastListener:()=>{O?(O.cancel(),O=null):(this.d.delete(F),this.p({id:q,type:103}))}}),U=H=>F.fire(H.data);return this.f.set(q,U),F.event}p(T){switch(T.type){case 100:case 102:{const z=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(z,T.id,0,`${f(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const z=this.q([T.type,T.id]);this.j?.logOutgoing(z,T.id,0,f(T.type));return}}}q(T,z=void 0){const Q=new i;return c(Q,T),c(Q,z),this.r(Q.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const z=new m(T),Q=o(z),q=o(z),j=Q[0];switch(j){case 200:return this.j?.logIncoming(T.byteLength,0,0,h(j)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,Q[1],0,h(j),q),this.t({type:Q[0],id:Q[1],data:q})}}t(T){if(T.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.dispose)(this.d.values()),this.d.clear()}}pe([A.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class N{get connections(){const T=[];return this.f.forEach(z=>T.push(z)),T}constructor(T){this.a=new Map,this.f=new Set,this.g=new w.Emitter,this.onDidAddConnection=this.g.event,this.h=new w.Emitter,this.onDidRemoveConnection=this.h.event,T(({protocol:z,onDidClientDisconnect:Q})=>{w.Event.once(z.onMessage)(j=>{const M=new m(j),O=o(M),F=new d(z,O),U=new L(z);this.a.forEach((x,B)=>F.registerChannel(B,x));const H={channelServer:F,channelClient:U,ctx:O};this.f.add(H),this.g.fire(H),Q(()=>{F.dispose(),U.dispose(),this.f.delete(H),this.h.fire(H)})})})}getChannel(T,z){const Q=this;return{call(q,j,M){let O;if((0,y.isFunction)(z)){const U=(0,E.getRandomElement)(Q.connections.filter(z));O=U?Promise.resolve(U):w.Event.toPromise(w.Event.filter(Q.onDidAddConnection,z))}else O=z.routeCall(Q,q,j);const F=O.then(U=>U.channelClient.getChannel(T));return oe(F).call(q,j,M)},listen(q,j){if((0,y.isFunction)(z))return Q.j(T,z,q,j);const M=z.routeEvent(Q,q,j).then(O=>O.channelClient.getChannel(T));return oe(M).listen(q,j)}}}j(T,z,Q,q){const j=this;let M=new g.DisposableStore;const O=new w.Emitter({onWillAddFirstListener:()=>{M=new g.DisposableStore;const F=new w.EventMultiplexer,U=new Map,H=B=>{const Z=B.channelClient.getChannel(T).listen(Q,q),ae=F.add(Z);U.set(B,ae)},x=B=>{const _=U.get(B);!_||(_.dispose(),U.delete(B))};j.connections.filter(z).forEach(H),w.Event.filter(j.onDidAddConnection,z)(H,void 0,M),j.onDidRemoveConnection(x,void 0,M),F.event(O.fire,O,M),M.add(F)},onDidRemoveLastListener:()=>{M.dispose()}});return O.event}registerChannel(T,z){this.a.set(T,z),this.f.forEach(Q=>{Q.channelServer.registerChannel(T,z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=N;class V{constructor(T,z,Q=null){const q=new i;c(q,z),T.send(q.buffer),this.a=new L(T,Q),this.d=new d(T,z,Q)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,z){this.d.registerChannel(T,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=V;function oe(W){return{call(T,z,Q){return W.then(q=>q.call(T,z,Q))},listen(T,z){const Q=new w.Relay;return W.then(q=>Q.input=q.listen(T,z)),Q.event}}}e.getDelayedChannel=oe;function X(W){let T=!1;return{call(z,Q,q){return T?W.call(z,Q,q):(0,t.timeout)(0).then(()=>T=!0).then(()=>W.call(z,Q,q))},listen(z,Q){if(T)return W.listen(z,Q);const q=new w.Relay;return(0,t.timeout)(0).then(()=>T=!0).then(()=>q.input=W.listen(z,Q)),q.event}}}e.getNextTickChannel=X;class Y{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const z of T.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await w.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.StaticRouter=Y;var se;(function(W){function T(j,M){const O=j,F=M&&M.disableMarshalling,U=new Map;for(const H in O)Q(H)&&U.set(H,w.Event.buffer(O[H],!0));return new class{listen(H,x,B){const _=U.get(x);if(_)return _;if(q(x)){const Z=O[x];if(typeof Z=="function")return Z.call(O,B)}throw new Error(`Event not found: ${x}`)}call(H,x,B){const _=O[x];if(typeof _=="function"){if(!F&&Array.isArray(B))for(let Z=0;Z<B.length;Z++)B[Z]=(0,b.revive)(B[Z]);return _.apply(O,B)}throw new Error(`Method not found: ${x}`)}}}W.fromService=T;function z(j,M){const O=M&&M.disableMarshalling;return new Proxy({},{get(F,U){if(typeof U=="string")return M?.properties?.has(U)?M.properties.get(U):q(U)?function(H){return j.listen(U,H)}:Q(U)?j.listen(U):async function(...H){let x;M&&!(0,y.isUndefinedOrNull)(M.context)?x=[M.context,...H]:x=H;const B=await j.call(U,x);return O?B:(0,b.revive)(B)};throw new Error(`Property not found: ${String(U)}`)}})}W.toService=z;function Q(j){return j[0]==="o"&&j[1]==="n"&&S.isUpperAsciiLetter(j.charCodeAt(2))}function q(j){return/^onDynamic/.test(j)&&S.isUpperAsciiLetter(j.charCodeAt(9))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const T=W.toString();if(T!=="[object Object]")return T}return W}function J(W){return Array.isArray(W)?W.map(fe):fe(W)}function le(W,T,z,Q,q,j,M){M=J(M);const O=re[q],F=O[Q%O.length];let U=[`%c[${W}]%c[${String(T).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${j}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(j)?(U=U.concat(M),U.push(")")):U.push(M),console.log.apply(console,U)}class ${constructor(T,z){this.d=T,this.f=z,this.a=0,this.b=0}logOutgoing(T,z,Q,q,j){this.b+=T,le(this.d,this.b,T,z,Q,q,j)}logIncoming(T,z,Q,q,j){this.a+=T,le(this.f,this.a,T,z,Q,q,j)}}e.IPCLogger=$}),define(ie[144],ne([0,1,17,3,47]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(w){this.a=w,this.onMessage=t.Event.fromDOMEventEmitter(this.a,"message",g=>E.VSBuffer.wrap(g.data)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}e.Protocol=R;class A extends k.IPCClient{constructor(w,g){const b=new R(w);super(b,g),this.b=b}dispose(){this.b.disconnect()}}e.Client=A}),define(ie[102],ne([0,1,17,3,2,47]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(a){a.enableDiagnostics=!1,a.records=[];const s=new WeakMap;let c=0;function o(D,L){if(!s.has(D)){const N=String(++c);s.set(D,N)}return s.get(D)}function d(D,L,N,V){if(!a.enableDiagnostics)return;const oe=o(D,L);if(V instanceof E.VSBuffer||V instanceof Uint8Array||V instanceof ArrayBuffer||ArrayBuffer.isView(V)){const X=E.VSBuffer.alloc(V.byteLength);X.set(V),a.records.push({timestamp:Date.now(),id:oe,label:L,type:N,buff:X})}else a.records.push({timestamp:Date.now(),id:oe,label:L,type:N,data:V})}a.traceSocketEvent=d})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let g=null;function b(){return g||(g=E.VSBuffer.alloc(0)),g}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,c){if(s===0)return b();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const L=this.a[0];return c&&(this.a.shift(),this.b-=s),L}if(this.a[0].byteLength>s){const L=this.a[0].slice(0,s);return c&&(this.a[0]=this.a[0].slice(s),this.b-=s),L}const o=E.VSBuffer.alloc(s);let d=0,D=0;for(;s>0;){const L=this.a[D];if(L.byteLength>s){const N=L.slice(0,s);o.set(N,d),d+=s,c&&(this.a[D]=L.slice(s),this.b-=s),s-=s}else o.set(L,d),d+=L.byteLength,c?(this.a.shift(),this.b-=L.byteLength):D++,s-=L.byteLength}return o}}e.ChunkStream=S;var y;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(y||(y={}));function u(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(s,c,o,d){this.type=s,this.id=c,this.ack=o,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends k.Disposable{constructor(s){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new S,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:u(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,d=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new p(o,d,D,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=E.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:u(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(c,s.data)}g(s,c){const o=this.f===0;return this.d.push(s,c),this.f+=s.byteLength+c.byteLength,o}h(){const s=E.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,c){this.g(s,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class v extends k.Disposable{constructor(s){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new l(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new p(1,0,0,s))}}e.Protocol=v;class C extends R.IPCClient{static fromSocket(s,c){return new C(new v(s),c)}get onDidDispose(){return this.b.onDidDispose}constructor(s,c,o=null){super(s,c,o),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.Client=C;class I{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.BufferedEmitter=I;class m{constructor(s){this.data=s,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let s=0,c=this.a;for(;c;)c=c.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let c=0,o=this.a;for(;o;)s[c++]=o.data,o=o.next;return s}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const c=new m(s);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const s=Date.now();for(let c=0;c<n.a;c++)this.c[c]=s-1e3*c;setInterval(()=>{for(let c=n.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),c=(1+n.a)*1e3;let o=0;for(let d=0;d<n.a;d++)s-this.c[d]<=c&&o++;return 1-o/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;class r{get unacknowledgedCount(){return this.c-this.d}constructor(s,c=null,o=n.getInstance()){this.t=new I,this.onControlMessage=this.t.event,this.u=new I,this.onMessage=this.u.event,this.v=new I,this.onDidDispose=this.v.event,this.w=new I,this.onSocketClose=this.w.event,this.x=new I,this.onSocketTimeout=this.x.event,this.s=o,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=s,this.p=new l(this.o),this.r.push(this.p),this.q=new h(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(d=>this.y(d))),this.r.push(this.o.onClose(d=>this.w.fire(d))),c&&this.q.acceptChunk(c),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,k.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const s=new p(5,0,0,b());this.p.write(s),this.p.flush()}sendPause(){const s=new p(7,0,0,b());this.p.write(s)}sendResume(){const s=new p(8,0,0,b());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,c){this.a=!0,this.r=(0,k.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=new l(this.o),this.r.push(this.p),this.q=new h(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(o=>this.y(o))),this.r.push(this.o.onClose(o=>this.w.fire(o))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new p(3,0,this.h,b());this.p.write(s);const c=this.b.toArray();for(let o=0,d=c.length;o<d;o++)this.p.write(c[o]);this.A()}acceptDisconnect(){this.v.fire()}y(s){if(s.ack>this.d){this.d=s.ack;do{const c=this.b.peek();if(c&&c.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new p(6,0,0,b())))}else this.g=s.id,this.j=Date.now(),this.z(),this.u.fire(s.data);break}case 2:{this.t.fire(s.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const c=this.b.toArray();for(let o=0,d=c.length;o<d;o++)this.p.write(c[o]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const c=++this.c;this.h=this.g;const o=new p(1,c,this.h,s);this.b.push(o),this.a||(this.p.write(o),this.A())}sendControl(s){const c=new p(2,0,0,s);this.p.write(c)}z(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-s+5)}A(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),c=Date.now()-s.writtenTime,o=Date.now()-this.q.lastReadTime,d=Date.now()-this.n;if(c>=2e4&&o>=2e4&&d>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:o});return}const D=Math.max(2e4-c,2e4-o,2e4-d,500);this.f=setTimeout(()=>{this.f=null,this.A()},D)}B(){if(this.g<=this.h)return;this.h=this.g;const s=new p(3,0,this.h,b());this.p.write(s)}C(){const s=new p(9,0,0,b());this.p.write(s)}}e.PersistentProtocol=r}),define(ie[145],ne([0,1,41,17,3,2,47,130]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(b,S){const y=k.Event.fromNodeEventEmitter(E.validatedIpcMain,S,(f,p)=>({event:f,message:p})),u=k.Event.filter(y,({event:f})=>f.sender.id===b);return k.Event.map(u,({message:f})=>f&&t.VSBuffer.wrap(f))}class g extends A.IPCServer{static d(){const S=k.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:y})=>y);return k.Event.map(S,y=>{const u=y.id;g.b.get(u)?.dispose();const p=new k.Emitter;g.b.set(u,(0,R.toDisposable)(()=>p.fire()));const h=w(u,"vscode:message"),l=k.Event.any(k.Event.signal(w(u,"vscode:disconnect")),p.event);return{protocol:new P.Protocol(y,h),onDidClientDisconnect:l}})}constructor(){super(g.d())}}e.Server=g,g.b=new Map}),define(ie[103],ne([0,1,41,3,29,144]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class A extends R.Client{constructor(g,b){super({addEventListener:(S,y)=>g.addListener(S,y),removeEventListener:(S,y)=>g.removeListener(S,y),postMessage:S=>g.postMessage(S),start:()=>g.start(),close:()=>g.close()},b)}}e.Client=A;async function P(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const g=(0,k.generateUuid)();w.webContents.send("vscode:createMessageChannel",g);const b=t.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(y,u)=>({nonce:u,port:y.ports[0]})),{port:S}=await t.Event.toPromise(t.Event.once(t.Event.filter(b,y=>y.nonce===g)));return S}e.connect=P}),define(ie[146],ne([0,1,46,8,17,22,139,15,3,2,44,82,79,47]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends u.ChannelServer{constructor(l){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",v=>k.VSBuffer.wrap(Buffer.from(v,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=f;class p{constructor(l,v){this.i=l,this.j=v,this.c=new Set,this.g=new Map,this.h=new w.Emitter,this.onDidProcessExit=this.h.event;const C=v&&v.timeout?v.timeout:6e4;this.b=new t.Delayer(C),this.d=null,this.f=null}getChannel(l){const v=this;return{call(C,I,m){return v.k(l,C,I,m)},listen(C,I){return v.l(l,C,I)}}}k(l,v,C,I=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(I.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const m=this.n(l),i=(0,t.createCancelablePromise)(a=>m.call(v,C,a)),n=I.onCancellationRequested(()=>i.cancel()),r=(0,g.toDisposable)(()=>i.cancel());return this.c.add(r),i.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(l,v,C){if(!this.b)return w.Event.None;this.b.cancel();let I;const m=new w.Emitter({onWillAddFirstListener:()=>{I=this.n(l).listen(v,C)(m.fire,m),this.c.add(I)},onDidRemoveLastListener:()=>{this.c.delete(I),I.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return m.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],v=Object.create(null);v.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(v.env={...v.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(v.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,y.removeDangerousEnvVariables)(v.env),this.d=(0,E.fork)(this.i,l,v);const C=new w.Emitter;w.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,A.isRemoteConsoleLog)(s)){(0,A.log)(s,`IPC Library: ${this.j.serverName}`);return}C.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const m=this.j.useQueue?(0,S.createQueuedSender)(this.d):this.d,i=s=>this.d&&this.d.connected&&m.send(s.buffer.toString("base64")),n=C.event,r={send:i,onMessage:n};this.f=new u.ChannelClient(r);const a=()=>this.o();process.once("exit",a),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,c)=>{process.removeListener("exit",a),this.c.forEach(o=>(0,g.dispose)(o)),this.c.clear(),s!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:c})})}return this.f}n(l){let v=this.g.get(l);return v||(v=this.m.getChannel(l),this.g.set(l,v)),v}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=p}),define(ie[83],ne([0,1,17,15,3,2,9,4,29,47,102]),function(G,e,E,t,k,R,A,P,w,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function S(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class y{traceSocketEvent(o,d){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,d)}constructor(o,d=""){this.f=!0,this.debugLabel=d,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,t.onUnexpectedError)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const d=D=>{this.traceSocketEvent("read",D),o(E.VSBuffer.wrap(D))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(o){const d=D=>{o({type:0,hadError:D,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(o){const d=()=>{o()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,t.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,t.onUnexpectedError)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=y;var u;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(u||(u={}));var f;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(f||(f={}));class p extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,d){this.socket.traceSocketEvent(o,d)}constructor(o,d,D,L){super(),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:D?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new h(this,d,D,L,this.f,(N,V)=>this.k(N,V))),this.B(this.a.onError(N=>{console.error(N),(0,t.onUnexpectedError)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new b.ChunkStream,this.B(this.socket.onData(N=>this.l(N))),this.B(this.socket.onClose(N=>this.g.fire(N)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this.a.writeMessage(o)}k(o,d){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let D=2;o.byteLength<126?D+=0:o.byteLength<2**16?D+=2:D+=8;const L=E.VSBuffer.alloc(D);if(d?L.writeUInt8(194,0):L.writeUInt8(130,0),o.byteLength<126)L.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){L.writeUInt8(126,1);let N=1;L.writeUInt8(o.byteLength>>>8&255,++N),L.writeUInt8(o.byteLength>>>0&255,++N)}else{L.writeUInt8(127,1);let N=1;L.writeUInt8(0,++N),L.writeUInt8(0,++N),L.writeUInt8(0,++N),L.writeUInt8(0,++N),L.writeUInt8(o.byteLength>>>24&255,++N),L.writeUInt8(o.byteLength>>>16&255,++N),L.writeUInt8(o.byteLength>>>8&255,++N),L.writeUInt8(o.byteLength>>>0&255,++N)}this.socket.write(E.VSBuffer.concat([L,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const d=this.b.peek(this.j.readLen),D=d.readUInt8(0),L=(D&128)>>>7,N=(D&64)>>>6,V=d.readUInt8(1),oe=(V&128)>>>7,X=V&127;this.j.state=2,this.j.readLen=2+(oe?4:0)+(X===126?2:0)+(X===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(N)),this.j.firstFrameOfMessage=Boolean(L),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const d=this.b.read(this.j.readLen),D=d.readUInt8(1),L=(D&128)>>>7;let N=D&127,V=1;N===126?N=d.readUInt8(++V)*2**8+d.readUInt8(++V):N===127&&(N=d.readUInt8(++V)*0+d.readUInt8(++V)*0+d.readUInt8(++V)*0+d.readUInt8(++V)*0+d.readUInt8(++V)*2**24+d.readUInt8(++V)*2**16+d.readUInt8(++V)*2**8+d.readUInt8(++V));let oe=0;L&&(oe=d.readUInt8(++V)*2**24+d.readUInt8(++V)*2**16+d.readUInt8(++V)*2**8+d.readUInt8(++V)),this.j.state=3,this.j.readLen=N,this.j.mask=oe,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const d=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),C(d,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(d,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class h extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(o,d,D,L,N,V){super(),this.k=o,this.l=N,this.m=V,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,d?(this.b=this.B(new l(this.k,L,D,{windowBits:15})),this.f=this.B(new v(this.k,{windowBits:15})),this.B(this.b.onError(oe=>this.a.fire(oe))),this.B(this.f.onError(oe=>this.a.fire(oe)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const d=await this.r(this.f,o);this.m(d,!0)}else this.m(o,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(o,d){return new Promise((D,L)=>{o.write(d),o.flush(N=>D(N))})}acceptFrame(o,d,D){this.h.push({data:o,isCompressed:d,isLastFrameOfMessage:D}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const d=await this.u(this.b,o.data,o.isLastFrameOfMessage);this.l.fire(d)}else this.l.fire(o.data)}this.s=!1}}u(o,d,D){return new Promise((L,N)=>{o.write(d),D&&o.write(E.VSBuffer.fromByteArray([0,0,255,255])),o.flush(V=>L(V))})}}class l extends R.Disposable{get recordedInflateBytes(){return this.j?E.VSBuffer.concat(this.f):E.VSBuffer.alloc(0)}constructor(o,d,D,L){super(),this.h=o,this.j=d,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=S().zlib.createInflateRaw(L),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(E.VSBuffer.wrap(N))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const d=E.VSBuffer.concat(this.g);this.g.length=0,o(d)})}}class v extends R.Disposable{constructor(o,d){super(),this.g=o,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.b=S().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(E.VSBuffer.wrap(D))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let d=E.VSBuffer.concat(this.f);this.f.length=0,d=d.slice(0,d.byteLength-4),o(d)})}}function C(c,o){if(o===0)return;const d=c.byteLength>>>2;for(let X=0;X<d;X++){const Y=c.readUInt32BE(X*4);c.writeUInt32BE(Y^o,X*4)}const D=d*4,L=c.byteLength-D,N=o>>>24&255,V=o>>>16&255,oe=o>>>8&255;L>=1&&c.writeUInt8(c.readUInt8(D)^N,D),L>=2&&c.writeUInt8(c.readUInt8(D+1)^V,D+1),L>=3&&c.writeUInt8(c.readUInt8(D+2)^oe,D+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const I={[2]:107,[1]:103};function m(){const c=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):o=(0,A.join)(S().os.tmpdir(),`vscode-ipc-${c}.sock`),n(o),o}e.createRandomIPCHandle=m;function i(c,o,d){const D=S().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${d}-${o}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${d}-${o}.sock`):L=(0,A.join)(c,`${d}-${o}.sock`),n(L),L}e.createStaticIPCHandle=i;function n(c){const o=I[P.platform];typeof o=="number"&&c.length>=o&&console.warn(`WARNING: IPC handle "${c}" is longer than ${o} chars, try a shorter --user-data-dir`)}class r extends g.IPCServer{static b(o){const d=k.Event.fromNodeEventEmitter(o,"connection");return k.Event.map(d,D=>({protocol:new b.Protocol(new y(D,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(D,"close"))}))}constructor(o){super(r.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=r;function a(c){return new Promise((o,d)=>{const D=S().net.createServer();D.on("error",d),D.listen(c,()=>{D.removeListener("error",d),o(new r(D))})})}e.serve=a;function s(c,o){return new Promise((d,D)=>{const L=S().net.createConnection(c,()=>{L.removeListener("error",D),d(b.Client.fromSocket(new y(L,`ipc-client${o}`),o))});L.once("error",D)})}e.connect=s}),define(ie[104],ne([0,1,8,3,2,11]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A=e.StorageHint||(e.StorageHint={}));function P(S){const y=S;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var w;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(w=e.StorageState||(e.StorageState={}));class g extends k.Disposable{constructor(y,u=Object.create(null)){super(),this.m=y,this.n=u,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=new E.ThrottledDelayer(g.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(y=>this.r(y)))}r(y){y.changed?.forEach((u,f)=>this.s(f,u)),y.deleted?.forEach(u=>this.s(u,void 0))}s(y,u){if(this.c===w.Closed)return;let f=!1;(0,R.isUndefinedOrNull)(u)?f=this.f.delete(y):this.f.get(y)!==u&&(this.f.set(y,u),f=!0),f&&this.b.fire(y)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.n.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(y,u){const f=this.f.get(y);return(0,R.isUndefinedOrNull)(f)?u:f}getBoolean(y,u){const f=this.get(y);return(0,R.isUndefinedOrNull)(f)?u:f==="true"}getNumber(y,u){const f=this.get(y);return(0,R.isUndefinedOrNull)(f)?u:parseInt(f,10)}async set(y,u){if(this.c===w.Closed)return;if((0,R.isUndefinedOrNull)(u))return this.delete(y);const f=String(u);if(this.f.get(y)!==f)return this.f.set(y,f),this.j.set(y,f),this.h.delete(y),this.b.fire(y),this.w()}async delete(y){if(!(this.c===w.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire(y),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=w.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(y).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(y){if(!!this.u)return this.w(y)}async w(y){return this.g.trigger(()=>this.v(),y)}async whenFlushed(){if(!!this.u)return new Promise(y=>this.l.push(y))}isInMemory(){return this.n.hint===A.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=g,g.a=100;class b{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((u,f)=>this.a.set(f,u)),y.delete?.forEach(u=>this.a.delete(u))}async close(){}}e.InMemoryStorageDatabase=b}),define(ie[147],ne([0,1,8,3,39,9,23]),function(G,e,E,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return t.Event.None}constructor(b,S=Object.create(null)){this.g=b,this.h=S,this.c=(0,R.basename)(this.g),this.d=new w(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,S=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(u=>S.set(u.key,u.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${S.size} rows`),S}async updateItems(b){const S=await this.f;return this.j(S,b)}j(b,S){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${S.insert?(0,k.mapToString)(S.insert):"0"}), delete(${S.delete?(0,k.setToString)(S.delete):"0"})`),this.t(b,()=>{const y=S.insert,u=S.delete;if(y&&y.size>0){const f=[];f.push([]);let p=0;y.forEach((h,l)=>{let v=f[p];v.length>P.b&&(p++,v=[],f.push(v)),v.push(l,h)}),f.forEach(h=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(h.length/2).fill("(?,?)").join(",")}`,l=>l.run(h),()=>{const l=[];let v=0;return y.forEach((C,I)=>{l.push(I),v+=C.length}),`Keys: ${l.join(", ")} Length: ${v}`})})}if(u&&u.size){const f=[];f.push([]);let p=0;u.forEach(h=>{let l=f[p];l.length>P.b&&(p++,l=[],f.push(l)),l.push(h)}),f.forEach(h=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(h.length).fill("?").join(",")})`,l=>l.run(h),()=>{const l=[];return u.forEach(v=>{l.push(v)}),`Keys: ${l.join(", ")}`})})}})}async close(b){this.d.trace(`[storage ${this.c}] close()`);const S=await this.f;return this.k(S,b)}k(b,S){return new Promise((y,u)=>{b.db.close(f=>(f&&this.o(b,`[storage ${this.c}] close(): ${f}`),this.g===P.IN_MEMORY_PATH?y():!b.isErroneous&&!b.isInMemory?this.l().then(y,p=>(this.d.error(`[storage ${this.c}] backup(): ${p}`),y())):typeof S=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(p=>{const h=()=>this.k(p,void 0);return this.j(p,{insert:S()}).then(()=>h(),l=>(h(),Promise.reject(l)))})).then(y,u):u(f||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return A.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const S=await this.f,y=await this.r(S,b?"PRAGMA integrity_check":"PRAGMA quick_check"),u=b?y.integrity_check:y.quick_check;return S.isErroneous?`${u} (last error: ${S.lastError})`:S.isInMemory?`${u} (in-memory!)`:u}async n(b,S=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${S})`);try{return await this.p(b)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&S)return await(0,E.timeout)(P.a),this.n(b,!1);try{await A.Promises.unlink(b);try{await A.Promises.rename(this.m(b),b)}catch{}return await this.p(b)}catch(u){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${u}`),this.p(P.IN_MEMORY_PATH)}}}o(b,S){b.isErroneous=!0,b.lastError=S,this.d.error(S)}p(b){return new Promise((S,y)=>{new Promise((u,f)=>{G(["@vscode/sqlite3"],u,f)}).then(u=>{const f={db:new(this.d.isTracing?u.verbose().Database:u.Database)(b,p=>p?f.db&&p.code!=="SQLITE_CANTOPEN"?f.db.close(()=>y(p)):y(p):this.q(f,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>S(f),h=>f.db.close(()=>y(h)))),isInMemory:b===P.IN_MEMORY_PATH};f.db.on("error",p=>this.o(f,`[storage ${this.c}] Error (event): ${p}`)),this.d.isTracing&&f.db.on("trace",p=>this.d.trace(`[storage ${this.c}] Trace (event): ${p}`))},y)})}q(b,S){return new Promise((y,u)=>{b.db.exec(S,f=>f?(this.o(b,`[storage ${this.c}] exec(): ${f}`),u(f)):y())})}r(b,S){return new Promise((y,u)=>{b.db.get(S,(f,p)=>f?(this.o(b,`[storage ${this.c}] get(): ${f}`),u(f)):y(p))})}s(b,S){return new Promise((y,u)=>{b.db.all(S,(f,p)=>f?(this.o(b,`[storage ${this.c}] all(): ${f}`),u(f)):y(p))})}t(b,S){return new Promise((y,u)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),S(),b.db.run("END TRANSACTION",f=>f?(this.o(b,`[storage ${this.c}] transaction(): ${f}`),u(f)):y())})})}u(b,S,y,u){const f=b.db.prepare(S),p=h=>{this.o(b,`[storage ${this.c}] prepare(): ${h} (${S}). Details: ${u()}`)};f.on("error",p),y(f),f.finalize(h=>{h&&p(h),f.removeListener("error",p)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.a=2e3,P.b=256;class w{constructor(b){b&&typeof b.logTrace=="function"&&process.env[w.VSCODE_TRACE_STORAGE]&&(this.a=b.logTrace),b&&typeof b.logError=="function"&&(this.b=b.logError)}get isTracing(){return!!this.a}trace(b){this.a?.(b)}error(b){this.b?.(b)}}w.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ie[148],ne([12,10]),function(G,e){return G.create("vs/code/electron-main/app",e)}),define(ie[149],ne([12,10]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[150],ne([12,10]),function(G,e){return G.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ie[151],ne([12,10]),function(G,e){return G.create("vs/platform/environment/node/argv",e)}),define(ie[152],ne([12,10]),function(G,e){return G.create("vs/platform/environment/node/argvHelper",e)}),define(ie[153],ne([12,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[154],ne([12,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[155],ne([12,10]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[156],ne([12,10]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[157],ne([12,10]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ie[158],ne([12,10]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ie[159],ne([12,10]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ie[160],ne([12,10]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ie[161],ne([12,10]),function(G,e){return G.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ie[162],ne([12,10]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[163],ne([12,10]),function(G,e){return G.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ie[164],ne([12,10]),function(G,e){return G.create("vs/platform/menubar/electron-main/menubar",e)}),define(ie[165],ne([12,10]),function(G,e){return G.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ie[166],ne([12,10]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ie[167],ne([12,10]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(ie[168],ne([12,10]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[169],ne([12,10]),function(G,e){return G.create("vs/platform/update/common/update.config.contribution",e)}),define(ie[170],ne([12,10]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[171],ne([12,10]),function(G,e){return G.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ie[172],ne([12,10]),function(G,e){return G.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ie[173],ne([12,10]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(ie[174],ne([12,10]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ie[175],ne([12,10]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ie[176],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(ie[177],ne([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(A){return typeof A?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(A){let P=[];try{Array.isArray(A.workspaces)&&(P=A.workspaces.map(w=>({workspace:{id:w.id,configPath:E.URI.parse(w.configURIPath)},remoteAuthority:w.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=k;function R(A){let P=[];try{Array.isArray(A.folders)&&(P=A.folders.map(w=>({folderUri:E.URI.parse(w.folderUri),remoteAuthority:w.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=R}),define(ie[178],ne([0,1,3,2]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(P,w,g){switch(w){case"close":return Promise.resolve(this.a.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(P,w,g){switch(w){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,w,g){this.b.call("attach",[P,w,g])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,w){this.b.call("terminate",[P,w])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,w){return this.b.call("openExtensionDevelopmentHostWindow",[P,w])}}e.ExtensionHostDebugChannelClient=R}),define(ie[179],ne([0,1,133,53,14,9,33,20,7]),function(G,e,E,t,k,R,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class g{get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return w.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(w.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=A.env.VSCODE_PORTABLE;return f?w.URI.file((0,R.join)(f,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,R.resolve)(f):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?w.URI.file((0,R.resolve)(f)):w.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,R.resolve)(f);const p=A.env.VSCODE_EXTENSIONS;if(p)return p;const h=A.env.VSCODE_PORTABLE;return h?(0,R.join)(h,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(p=>/^[^:/?#]+?:\/\//.test(p)?w.URI.parse(p):w.URI.file((0,R.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?w.URI.parse(f):w.URI.file((0,R.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const p of this.args.log||[]){const h=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);h&&h[1]&&h[2]&&f.push([h[1],h[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return w.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=A.env.VSCODE_PORTABLE;return f?w.URI.file((0,R.join)(f,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,p,h){this.a=f,this.b=p,this.c=h,this.editSessionId=this.args.editSessionId}}pe([t.memoize],g.prototype,"appRoot",null),pe([t.memoize],g.prototype,"userHome",null),pe([t.memoize],g.prototype,"userDataPath",null),pe([t.memoize],g.prototype,"appSettingsHome",null),pe([t.memoize],g.prototype,"tmpDir",null),pe([t.memoize],g.prototype,"cacheHome",null),pe([t.memoize],g.prototype,"stateResource",null),pe([t.memoize],g.prototype,"userRoamingDataHome",null),pe([t.memoize],g.prototype,"userDataSyncHome",null),pe([t.memoize],g.prototype,"userDataSyncLogResource",null),pe([t.memoize],g.prototype,"editSessionsLogResource",null),pe([t.memoize],g.prototype,"sync",null),pe([t.memoize],g.prototype,"machineSettingsResource",null),pe([t.memoize],g.prototype,"workspaceStorageHome",null),pe([t.memoize],g.prototype,"localHistoryHome",null),pe([t.memoize],g.prototype,"keyboardLayoutResource",null),pe([t.memoize],g.prototype,"argvResource",null),pe([t.memoize],g.prototype,"isExtensionDevelopment",null),pe([t.memoize],g.prototype,"untitledWorkspacesHome",null),pe([t.memoize],g.prototype,"installSourcePath",null),pe([t.memoize],g.prototype,"builtinExtensionsPath",null),pe([t.memoize],g.prototype,"extensionsPath",null),pe([t.memoize],g.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],g.prototype,"extensionDevelopmentKind",null),pe([t.memoize],g.prototype,"extensionTestsLocationURI",null),pe([t.memoize],g.prototype,"debugExtensionHost",null),pe([t.memoize],g.prototype,"logLevel",null),pe([t.memoize],g.prototype,"extensionLogLevel",null),pe([t.memoize],g.prototype,"serviceMachineIdResource",null),pe([t.memoize],g.prototype,"telemetryLogResource",null),pe([t.memoize],g.prototype,"disableWorkspaceTrust",null),pe([t.memoize],g.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=g;function b(u,f){return y(u["inspect-extensions"],u["inspect-brk-extensions"],5870,f,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=b;function S(u,f){return y(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,f,u.extensionEnvironment)}e.parsePtyHostPort=S;function y(u,f,p,h,l,v){const I=Number(f||u)||(h?null:p),m=I?Boolean(!!f):!1;let i;if(v)try{i=JSON.parse(v)}catch{}return{port:I,break:m,debugId:l,env:i}}}),define(ie[105],ne([0,1,279,4,151]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},category:{type:"string",cat:"e",description:(0,k.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(p,h,l=A){const v=p.find(c=>c.length>0&&c[0]!=="-"),C={},I=["_"],m=[],i={};let n;for(const c in h){const o=h[c];o.type==="subcommand"?c===v&&(n=o):(o.alias&&(C[c]=o.alias),o.type==="string"||o.type==="string[]"?(I.push(c),o.deprecates&&I.push(...o.deprecates)):o.type==="boolean"&&(m.push(c),o.deprecates&&m.push(...o.deprecates)),o.global&&(i[c]=o))}if(n&&v){const c=i;for(const L in n.options)c[L]=n.options[L];const o=p.filter(L=>L!==v),d=l.getSubcommandReporter?l.getSubcommandReporter(v):void 0,D=P(o,c,d);return{[v]:D,_:[]}}const r=E(p,{string:I,boolean:m,alias:C}),a={},s=r;a._=r._.map(c=>String(c)).filter(c=>c.length>0),delete s._;for(const c in h){const o=h[c];if(o.type==="subcommand")continue;o.alias&&delete s[o.alias];let d=s[c];if(o.deprecates)for(const D of o.deprecates)s.hasOwnProperty(D)&&(d||(d=s[D],d&&l.onDeprecatedOption(D,o.deprecationMessage||(0,k.localize)(36,null,c))),delete s[D]);if(typeof d<"u"){if(o.type==="string[]"){if(Array.isArray(d)||(d=[d]),!o.allowEmptyValue){const D=d.filter(L=>L.length>0);D.length!==d.length&&(l.onEmptyValue(c),d=D.length>0?D:void 0)}}else o.type==="string"&&(Array.isArray(d)?(d=d.pop(),l.onMultipleValues(c,d)):!d&&!o.allowEmptyValue&&(l.onEmptyValue(c),d=void 0));a[c]=d,o.deprecationMessage&&l.onDeprecatedOption(c,o.deprecationMessage)}delete s[c]}for(const c in s)l.onUnknownOption(c);return a}e.parseArgs=P;function w(p,h){let l="";return h.args&&(Array.isArray(h.args)?l=` <${h.args.join("> <")}>`:l=` <${h.args}>`),h.alias?`-${h.alias} --${p}${l}`:`--${p}${l}`}function g(p,h){const l=[];for(const v in p){const C=p[v],I=w(v,C);l.push([I,C.description])}return b(l,h)}e.formatOptions=g;function b(p,h){const v=p.reduce((m,i)=>Math.max(m,i[0].length),12)+2+1;if(h-v<25)return p.reduce((m,i)=>m.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const C=h-v-1,I=[];for(const m of p){const i=m[0],n=y(m[1],C),r=S(v-i.length-2);I.push("  "+i+r+n[0]);for(let a=1;a<n.length;a++)I.push(S(v)+n[a])}return I}function S(p){return" ".repeat(p)}function y(p,h){const l=[];for(;p.length;){const v=p.length<h?p.length:p.lastIndexOf(" ",h),C=p.slice(0,v).trim();p=p.slice(v),l.push(C)}return l}function u(p,h,l,v,C){const I=process.stdout.isTTY&&process.stdout.columns||80,m=C?.noInputFiles!==!0?`[${(0,k.localize)(37,null)}...]`:"",i=[`${p} ${l}`];i.push(""),i.push(`${(0,k.localize)(38,null)}: ${h} [${(0,k.localize)(39,null)}]${m}`),i.push(""),C?.noPipe!==!0&&(t.isWindows?i.push((0,k.localize)(40,null,h)):i.push((0,k.localize)(41,null,h)),i.push(""));const n={},r=[];for(const a in v){const s=v[a];if(s.type==="subcommand")s.description&&r.push({command:a,description:s.description});else if(s.description&&s.cat){let c=n[s.cat];c||(n[s.cat]=c={}),c[a]=s}}for(const a in n){const s=a,c=n[s];c&&(i.push(R[s]),i.push(...g(c,I)),i.push(""))}return r.length&&(i.push((0,k.localize)(42,null)),i.push(...b(r.map(a=>[a.command,a.description]),I)),i.push("")),i.join(`
`)}e.buildHelpMessage=u;function f(p,h){return`${p||(0,k.localize)(43,null)}
${h||(0,k.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=f}),define(ie[180],ne([0,1,78,178,105]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.f=P}call(P,w,g){return w==="openExtensionDevelopmentHostWindow"?this.g(g[0],g[1]):super.call(P,w,g)}async g(P,w){const g=(0,k.parseArgs)(P,k.OPTIONS);g.debugRenderer=w;const b=g.extensionDevelopmentPath;if(!b)return{success:!1};const[S]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:g,forceProfile:g.profile,forceTempProfile:g["profile-temp"]});if(!w)return{success:!0};const y=S.win;if(!y)return{success:!0};const u=y.webContents.debugger;let f=u.isAttached()?1/0:0;const p=(0,E.createServer)(h=>{f++===0&&u.attach();let l=!1;const v=m=>{l||h.write(JSON.stringify(m)+"\0")},C=(m,i,n,r)=>v({method:i,params:n,sessionId:r});y.on("close",()=>{u.removeListener("message",C),h.end(),l=!0}),u.addListener("message",C);let I=Buffer.alloc(0);h.on("data",m=>{I=Buffer.concat([I,m]);for(let i=I.indexOf(0);i!==-1;i=I.indexOf(0)){let n;try{const r=I.slice(0,i).toString("utf8");I=I.slice(i+1),n=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}u.sendCommand(n.method,n.params,n.sessionId).then(r=>v({id:n.id,sessionId:n.sessionId,result:r})).catch(r=>v({id:n.id,sessionId:n.sessionId,error:{code:0,message:r.message}}))}}),h.on("error",m=>{console.error("error on cdp pipe:",m)}),h.on("close",()=>{l=!0,--f===0&&u.detach()})});return await new Promise(h=>p.listen(0,h)),y.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(ie[61],ne([0,1,280,152,105]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function A(y,u){const f=(I,m)=>{console.warn((0,t.localize)(0,null,I,m))},p=I=>{console.warn((0,t.localize)(1,null,I))},h=(I,m)=>{console.warn((0,t.localize)(2,null,I,m))},l=I=>({onUnknownOption:m=>{I!=="tunnel"&&console.warn((0,t.localize)(3,null,m,I))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:h,getSubcommandReporter:I!=="tunnel"?l:void 0}),v={onUnknownOption:I=>{console.warn((0,t.localize)(4,null,I))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:h,getSubcommandReporter:l},C=(0,k.parseArgs)(y,k.OPTIONS,u?v:void 0);return C.goto&&C._.forEach(I=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,t.localize)(5,null))),C["max-memory"]&&E(parseInt(C["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),C}function P(y){const u=y.findIndex(f=>!/^-/.test(f));if(u>-1)return[...y.slice(0,u),...y.slice(u+1)]}function w(y){let[,...u]=y;process.env.VSCODE_DEV&&(u=P(u)||[]);const f=!S(process.env);return A(u,f)}e.parseMainProcessArgv=w;function g(y){let[,,...u]=y;return process.env.VSCODE_DEV&&(u=P(u)||[]),A(u,!0)}e.parseCLIProcessArgv=g;function b(y,...u){const f=y.indexOf("--");return f===-1?y.push(...u):y.splice(f,0,...u),y}e.addArg=b;function S(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),function(){"use strict";function G(e,E,t){function k(A,P){const w=R(A,P),g=[w];return e.isAbsolute(w)||g.unshift(t),e.resolve(...g)}function R(A,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,P);const b=A["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(S,"AppData","Roaming")}break;case"darwin":g=e.join(E.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,P)}return{getUserDataPath:k}}if(typeof define=="function")define(ie[181],ne([182,25,33]),function(e,E,t){return G(e,E,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=G(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[183],ne([0,1,25,179,181]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(P,w){super(P,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,k.getUserDataPath)(P,w.nameShort)},w)}}e.NativeEnvironmentService=R}),define(ie[184],ne([0,1,40,25,30]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(A){const P=(0,k.randomPath)((0,t.tmpdir)());try{return(0,E.writeFileSync)(P,""),A&&console.log(`Marker file for --wait created: ${P}`),P}catch(w){A&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFileSync=R}),define(ie[185],ne([0,1,11,154]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(A,P,w){try{R(A,P,w)}catch(g){console.error(g?.message??g)}return A}e.localizeManifest=k;function R(A,P,w){const g=(b,S,y)=>{const u=b[S];if((0,E.isString)(u)){const f=u,p=f.length;if(p>1&&f[0]==="%"&&f[p-1]==="%"){const h=f.substr(1,p-2);let l=P[h];l===void 0&&w&&(l=w[h]);const v=typeof l=="string"?l:l?.message,C=w?.[h],I=typeof C=="string"?C:C?.message;if(!v){I||console.warn(`[${A.name}]: ${(0,t.localize)(0,null,h)}`);return}if(y&&(S==="title"||S==="category")&&I&&I!==v){const m={value:v,original:I};b[S]=m}else b[S]=v}}else if((0,E.isObject)(u))for(const f in u)u.hasOwnProperty(f)&&(f==="commands"?g(u,f,!0):g(u,f,y));else if(Array.isArray(u))for(let f=0;f<u.length;f++)g(u,f,y)};for(const b in A)A.hasOwnProperty(b)&&g(A,b)}}),define(ie[186],ne([0,1,15]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(R,A){this.a.set(R,A)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const A in R.contributes){const P=this.a.get(A);if(!P)continue;const w=R.contributes[A],g=Array.isArray(w)?w:[w];try{P(g,R.activationEvents)}catch(b){(0,E.onUnexpectedError)(b)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ie[187],ne([0,1,20,98,156,188]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function w(l){return l=l.trim(),l==="*"||A.test(l)}e.isValidVersionStr=w;function g(l){if(!w(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=l.match(A);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=g;function b(l){if(!l)return null;const v=l.majorBase,C=l.majorMustEqual,I=l.minorBase;let m=l.minorMustEqual;const i=l.patchBase;let n=l.patchMustEqual;l.hasCaret&&(v===0||(m=!1),n=!1);let r=0;if(l.preRelease){const a=P.exec(l.preRelease);if(a){const[,s,c,o]=a;r=Date.UTC(Number(s),Number(c)-1,Number(o))}}return{majorBase:v,majorMustEqual:C,minorBase:I,minorMustEqual:m,patchBase:i,patchMustEqual:n,isMinimum:l.hasGreaterEquals,notBefore:r}}e.normalizeVersion=b;function S(l,v,C){let I;typeof l=="string"?I=b(g(l)):I=l;let m;v instanceof Date?m=v.getTime():typeof v=="string"&&(m=new Date(v).getTime());let i;if(typeof C=="string"?i=b(g(C)):i=C,!I||!i)return!1;const n=I.majorBase,r=I.minorBase,a=I.patchBase;let s=i.majorBase,c=i.minorBase,o=i.patchBase;const d=i.notBefore;let D=i.majorMustEqual,L=i.minorMustEqual,N=i.patchMustEqual;return i.isMinimum?n>s?!0:n<s?!1:r>c?!0:r<c||m&&m<d?!1:a>=o:(n===1&&s===0&&(!D||!L||!N)&&(s=1,c=0,o=0,D=!0,L=!1,N=!1),n<s?!1:n>s?!D:r<c?!1:r>c?!L:a<o?!1:a>o?!N:!(m&&m<d))}e.isValidVersion=S;function y(l,v,C,I,m){const i=[];if(typeof I.publisher<"u"&&typeof I.publisher!="string")return i.push([t.default.Error,k.localize(0,null)]),i;if(typeof I.name!="string")return i.push([t.default.Error,k.localize(1,null,"name")]),i;if(typeof I.version!="string")return i.push([t.default.Error,k.localize(2,null,"version")]),i;if(!I.engines)return i.push([t.default.Error,k.localize(3,null,"engines")]),i;if(typeof I.engines.vscode!="string")return i.push([t.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof I.extensionDependencies<"u"&&!h(I.extensionDependencies))return i.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof I.activationEvents<"u"){if(!h(I.activationEvents))return i.push([t.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof I.main>"u"&&typeof I.browser>"u")return i.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof I.extensionKind<"u"&&typeof I.main>"u"&&i.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof I.main<"u"){if(typeof I.main!="string")return i.push([t.default.Error,k.localize(9,null,"main")]),i;{const a=(0,E.joinPath)(C,I.main);(0,E.isEqualOrParent)(a,C)||i.push([t.default.Warning,k.localize(10,null,a.path,C.path)])}if(typeof I.activationEvents>"u")return i.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof I.browser<"u"){if(typeof I.browser!="string")return i.push([t.default.Error,k.localize(12,null,"browser")]),i;{const a=(0,E.joinPath)(C,I.browser);(0,E.isEqualOrParent)(a,C)||i.push([t.default.Warning,k.localize(13,null,a.path,C.path)])}if(typeof I.activationEvents>"u")return i.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(I.version))return i.push([t.default.Error,k.localize(15,null)]),i;const n=[];if(!u(l,v,I,m,n))for(const a of n)i.push([t.default.Error,a]);return i}e.validateExtensionManifest=y;function u(l,v,C,I,m){return I||typeof C.main>"u"&&typeof C.browser>"u"?!0:p(l,v,C.engines.vscode,m)}e.isValidExtensionVersion=u;function f(l,v,C){return l==="*"||p(v,C,l)}e.isEngineValid=f;function p(l,v,C,I=[]){const m=b(g(C));if(!m)return I.push(k.localize(16,null,C)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return I.push(k.localize(17,null,C)),!1}else if(!m.majorMustEqual)return I.push(k.localize(18,null,C)),!1;return S(l,v,m)?!0:(I.push(k.localize(19,null,l,C)),!1)}function h(l){if(!Array.isArray(l))return!1;for(let v=0,C=l.length;v<C;v++)if(typeof l[v]!="string")return!1;return!0}}),define(ie[189],ne([0,1,17,29]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,A,P){let w=P&&P.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const b=(await A.readFile(R.serviceMachineIdResource)).value.toString();w=(0,t.isUUID)(b)?b:null}catch{w=null}if(!w){w=(0,t.generateUuid)();try{await A.writeFile(R.serviceMachineIdResource,E.VSBuffer.fromString(w))}catch{}}return P?.store("storage.serviceMachineId",w,-1,1),w}e.getServiceMachineId=k}),define(ie[70],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(k,R=[],A=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=E}),define(ie[190],ne([0,1,70]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(P,w,g){w instanceof E.SyncDescriptor||(w=new E.SyncDescriptor(w,[],Boolean(g))),t.push([P,w])}e.registerSingleton=R;function A(){return t}e.getSingletonServiceDescriptors=A}),define(ie[191],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class t{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const A of this.a.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const P=this.lookupOrInsertNode(R),w=this.lookupOrInsertNode(A);P.outgoing.set(w.key,w),w.incoming.set(P.key,P)}removeNode(R){const A=this.b(R);this.a.delete(A);for(const P of this.a.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(R){const A=this.b(R);let P=this.a.get(A);return P||(P=new E(A,R),this.a.set(A,P)),P}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[A,P]of this.a)R.push(`${A}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this.a){const P=new Set([R]),w=this.c(A,P);if(w)return w}}c(R,A){for(const[P,w]of R.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const g=this.c(w,A);if(g)return g;A.delete(P)}}}e.Graph=t}),define(ie[5],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(w){return w[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(E=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(A,P,w){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:A,index:w}):(P[E.DI_DEPENDENCIES]=[{id:A,index:w}],P[E.DI_TARGET]=P)}function k(A){if(E.serviceIds.has(A))return E.serviceIds.get(A);const P=function(w,g,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,w,b)};return P.toString=()=>A,E.serviceIds.set(A,P),P}e.createDecorator=k;function R(A){return A}e.refineServiceDecorator=R}),define(ie[62],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(ie[18],ne([0,1,11,7,5]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof t.URI)}e.isConfigurationOverrides=R;function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function g(l,v){const C=Object.create(null);for(const I in l)b(C,I,l[I],v);return C}e.toValuesTree=g;function b(l,v,C,I){const m=v.split("."),i=m.pop();let n=l;for(let r=0;r<m.length;r++){const a=m[r];let s=n[a];switch(typeof s){case"undefined":s=n[a]=Object.create(null);break;case"object":break;default:I(`Ignoring ${v} as ${m.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[i]=C}catch{I(`Ignoring ${v} as ${m.join(".")} is ${JSON.stringify(n)}`)}else I(`Ignoring ${v} as ${m.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=b;function S(l,v){const C=v.split(".");y(l,C)}e.removeFromValueTree=S;function y(l,v){const C=v.shift();if(v.length===0){delete l[C];return}if(Object.keys(l).indexOf(C)!==-1){const I=l[C];typeof I=="object"&&!Array.isArray(I)&&(y(I,v),Object.keys(I).length===0&&delete l[C])}}function u(l,v,C){function I(n,r){let a=n;for(const s of r){if(typeof a!="object"||a===null)return;a=a[s]}return a}const m=v.split("."),i=I(l,m);return typeof i>"u"?C:i}e.getConfigurationValue=u;function f(l,v,C){Object.keys(v).forEach(I=>{I!=="__proto__"&&(I in l?E.isObject(l[I])&&E.isObject(v[I])?f(l[I],v[I],C):C&&(l[I]=v[I]):l[I]=v[I])})}e.merge=f;function p(l,v,C){const I=l.inspect(v),m=l.inspect(C);return typeof I.userValue<"u"||typeof I.workspaceValue<"u"||typeof I.workspaceFolderValue<"u"?I.value:typeof m.userValue<"u"||typeof m.workspaceValue<"u"||typeof m.workspaceFolderValue<"u"?m.value:I.defaultValue}e.getMigratedSettingValue=p;function h(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=h}),define(ie[71],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(R,A){return this.a[R]?.[A]??null}async setPassword(R,A,P){this.a[R]=this.a[R]??{},this.a[R][A]=P}async deletePassword(R,A){return this.a[R]?.[A]?(delete this.a[R][A],Object.keys(this.a[R]).length===0&&delete this.a[R],!0):!1}async findPassword(R){return JSON.stringify(this.a[R])??null}async findCredentials(R){const A=[];for(const P of Object.keys(this.a[R]||{}))A.push({account:P,password:this.a[R][P]});return A}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(ie[84],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(A,P){return{}}async getSystemInfo(A,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,P){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=k}),define(ie[106],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(ie[35],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ie[27],ne([0,1,53,9,83,35,183,5]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(R.IEnvironmentService);class w extends A.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}pe([E.memoize],w.prototype,"cachedLanguagesPath",null),pe([E.memoize],w.prototype,"backupHome",null),pe([E.memoize],w.prototype,"mainIPCHandle",null),pe([E.memoize],w.prototype,"mainLockfile",null),pe([E.memoize],w.prototype,"disableUpdates",null),pe([E.memoize],w.prototype,"disableKeytar",null),pe([E.memoize],w.prototype,"crossOriginIsolated",null),pe([E.memoize],w.prototype,"codeCachePath",null),pe([E.memoize],w.prototype,"useCodeCache",null),e.EnvironmentMainService=w}),define(ie[192],ne([0,1,153,5]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function A(l,v){switch(l){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function P(l,v){return v==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function w(l,v,C){return P(v,C)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===C?!0:g(C).includes(l)}e.isTargetPlatformCompatible=w;function g(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=g;function b(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=b;var S;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var y;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var u;(function(l){l.Install="install",l.Uninstall="uninstall"})(u=e.StatisticType||(e.StatisticType={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var p;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(v,C){super(v),this.code=C,this.name=C}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ie[193],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(ie[194],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ie[107],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(ie[195],ne([0,1,46,14,9,4,79,23,82,157,107]),function(G,e,E,t,k,R,A,P,w,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const S=g.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:u.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class u extends y{openTerminal(I,m){return this.spawnTerminal(E,I,w.getWindowsShell(),m)}spawnTerminal(I,m,i,n){const r=m.windowsExec||u.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const a=k.basename(r).toLowerCase();if(a==="cmder"||a==="cmder.exe")return I.spawn(r,n?[n]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return r.indexOf(" ")>=0&&s.push('""'),s.push(r),(a==="wt"||a==="wt.exe")&&s.push("-d ."),new Promise((c,o)=>{const d=h(process),D=I.spawn(i,s,{cwd:n,env:d});D.on("error",o),D.on("exit",()=>c())})}runInTerminal(I,m,i,n,r){const a="windowsExec"in r&&r.windowsExec?r.windowsExec:u.getDefaultTerminalWindows();return new Promise((s,c)=>{const o=`"${m} - ${S}"`,d=`""${i.join('" "')}" & pause"`,D=["/c","start",o,"/wait",a,"/c",d],L=Object.assign({},h(process),n);Object.keys(L).filter(oe=>L[oe]===null).forEach(oe=>delete L[oe]);const N={cwd:m,env:L,windowsVerbatimArguments:!0};E.spawn(u.b,D,N).on("error",oe=>{c(l(oe))}),s(void 0)})}static getDefaultTerminalWindows(){if(!u.d){const I=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${I?"Sysnative":"System32"}\\cmd.exe`}return u.d}}e.WindowsExternalTerminalService=u,u.b="cmd.exe";class f extends y{openTerminal(I,m){return this.spawnTerminal(E,I,m)}runInTerminal(I,m,i,n,r){const a=r.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{if(a===b.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const o=a===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`).fsPath,"-t",I||S,"-w",m];for(const V of i)D.push("-a"),D.push(V);if(n){const V=Object.assign({},h(process),n);for(const oe in V){const X=V[oe];X===null?(D.push("-u"),D.push(oe)):(D.push("-e"),D.push(`${oe}=${X}`))}}let L="";const N=E.spawn(f.b,D);N.on("error",V=>{c(l(V))}),N.stderr.on("data",V=>{L+=V.toString()}),N.on("exit",V=>{if(V===0)s(void 0);else if(L){const oe=L.split(`
`,1);c(new Error(oe[0]))}else c(new Error(g.localize(1,null,o,V)))})}else c(new Error(g.localize(2,null,a)))})}spawnTerminal(I,m,i){const n=m.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{const s=["-a",n];i&&s.push(i);const c=h(process),o=I.spawn("/usr/bin/open",s,{cwd:i,env:c});o.on("error",a),o.on("exit",()=>r())})}}e.MacExternalTerminalService=f,f.b="/usr/bin/osascript";class p extends y{openTerminal(I,m){return this.spawnTerminal(E,I,m)}runInTerminal(I,m,i,n,r){const a=r.linuxExec?Promise.resolve(r.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{const o=[];a.then(d=>{d.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const D=`${v(i)}; echo; read -p "${p.b}" -n1;`;o.push(`''${D}''`);const L=Object.assign({},h(process),n);Object.keys(L).filter(X=>L[X]===null).forEach(X=>delete L[X]);const N={cwd:m,env:L};let V="";const oe=E.spawn(d,o,N);oe.on("error",X=>{c(l(X))}),oe.stderr.on("data",X=>{V+=X.toString()}),oe.on("exit",X=>{if(X===0)s(void 0);else if(V){const Y=V.split(`
`,1);c(new Error(Y[0]))}else c(new Error(g.localize(4,null,d,X)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!R.isLinux)p.d=Promise.resolve("xterm");else{const I=await P.Promises.exists("/etc/debian_version");p.d=new Promise(m=>{I?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return p.d}spawnTerminal(I,m,i){const n=m.linuxExec?Promise.resolve(m.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{n.then(s=>{const c=h(process),o=I.spawn(s,[],{cwd:i,env:c});o.on("error",a),o.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=p,p.b=g.localize(3,null);function h(C){const I={...C.env};return(0,A.sanitizeProcessEnvironment)(I),I}function l(C){return"errno"in C&&C.errno==="ENOENT"&&"path"in C&&typeof C.path=="string"?new Error(g.localize(5,null,C.path)):C}function v(C){let I="";for(const m of C)m.indexOf(" ")>=0?I+='"'+m+'"':I+=m,I+=" ";return I}}),define(ie[16],ne([0,1,60,9,26,11,7,159,5]),function(G,e,E,t,k,R,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function g(J){return J.create===!0}e.isFileOpenForWriteOptions=g;var b;(function(J){J[J.Unknown=0]="Unknown",J[J.File=1]="File",J[J.Directory=2]="Directory",J[J.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var S;(function(J){J[J.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var y;(function(J){J[J.None=0]="None",J[J.FileReadWrite=2]="FileReadWrite",J[J.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",J[J.FileReadStream=16]="FileReadStream",J[J.FileFolderCopy=8]="FileFolderCopy",J[J.PathCaseSensitive=1024]="PathCaseSensitive",J[J.Readonly=2048]="Readonly",J[J.Trash=4096]="Trash",J[J.FileWriteUnlock=8192]="FileWriteUnlock",J[J.FileAtomicRead=16384]="FileAtomicRead",J[J.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u(J){return!!(J.capabilities&2)}e.hasReadWriteCapability=u;function f(J){return!!(J.capabilities&8)}e.hasFileFolderCopyCapability=f;function p(J){return!!(J.capabilities&32768)}e.hasFileCloneCapability=p;function h(J){return!!(J.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function l(J){return!!(J.capabilities&16)}e.hasFileReadStreamCapability=l;function v(J){return u(J)?!!(J.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var C;(function(J){J.FileExists="EntryExists",J.FileNotFound="EntryNotFound",J.FileNotADirectory="EntryNotADirectory",J.FileIsADirectory="EntryIsADirectory",J.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",J.FileTooLarge="EntryTooLarge",J.FileWriteLocked="EntryWriteLocked",J.NoPermissions="NoPermissions",J.Unavailable="Unavailable",J.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(le,$){super(le),this.code=$}}e.FileSystemProviderError=I;function m(J,le){const $=new I(J.toString(),le);return n($,le),$}e.createFileSystemProviderError=m;function i(J){return J||m((0,P.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=i;function n(J,le){return J.name=le?`${le} (FileSystemError)`:"FileSystemError",J}e.markAsFileSystemProviderError=n;function r(J){if(!J)return C.Unknown;if(J instanceof I)return J.code;const le=/^(.+) \(FileSystemError\)$/.exec(J.name);if(!le)return C.Unknown;switch(le[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=r;function a(J){if(J instanceof L)return J.fileOperationResult;switch(r(J)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var s;(function(J){J[J.CREATE=0]="CREATE",J[J.DELETE=1]="DELETE",J[J.MOVE=2]="MOVE",J[J.COPY=3]="COPY",J[J.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(le,$,W){this.resource=le,this.operation=$,this.target=W}isOperation(le){return this.operation===le}}e.FileOperationEvent=c;var o;(function(J){J[J.UPDATED=0]="UPDATED",J[J.ADDED=1]="ADDED",J[J.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class d{constructor(le,$){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=le;const W=new Map;for(const T of le){const z=W.get(T.type);switch(z?z.push([T.resource,T]):W.set(T.type,[[T.resource,T]]),T.type){case 1:this.rawAdded.push(T.resource);break;case 0:this.rawUpdated.push(T.resource);break;case 2:this.rawDeleted.push(T.resource);break}}for(const[T,z]of W)switch(T){case 1:this.a=E.TernarySearchTree.forUris(()=>$),this.a.fill(z);break;case 0:this.b=E.TernarySearchTree.forUris(()=>$),this.b.fill(z);break;case 2:this.c=E.TernarySearchTree.forUris(()=>$),this.c.fill(z);break}}contains(le,...$){return this.d(le,{includeChildren:!1},...$)}affects(le,...$){return this.d(le,{includeChildren:!0},...$)}d(le,$,...W){if(!le)return!1;const T=W.length>0;return!!((!T||W.includes(1))&&(this.a?.get(le)||$.includeChildren&&this.a?.findSuperstr(le))||(!T||W.includes(0))&&(this.b?.get(le)||$.includeChildren&&this.b?.findSuperstr(le))||(!T||W.includes(2))&&(this.c?.findSubstr(le)||$.includeChildren&&this.c?.findSuperstr(le)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=d;function D(J,le,$){return!J||!le||J===le||le.length>J.length?!1:(le.charAt(le.length-1)!==t.sep&&(le+=t.sep),$?(0,k.startsWithIgnoreCase)(J,le):J.indexOf(le)===0)}e.isParent=D;class L extends Error{constructor(le,$,W){super(le),this.fileOperationResult=$,this.options=W}}e.FileOperationError=L;class N extends L{constructor(le,$,W){super(le,2,W),this.stat=$}}e.NotModifiedSinceFileOperationError=N;var V;(function(J){J[J.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",J[J.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",J[J.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",J[J.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",J[J.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",J[J.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",J[J.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",J[J.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",J[J.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",J[J.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",J[J.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",J[J.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var oe;(function(J){J[J.FILE=0]="FILE",J[J.FOLDER=1]="FOLDER",J[J.ROOT_FOLDER=2]="ROOT_FOLDER"})(oe=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function X(J){if(!(typeof J.size!="number"||typeof J.mtime!="number"))return J.mtime.toString(29)+J.size.toString(31)}e.etag=X;async function Y(J,le){if(!le.hasProvider(A.URI.from({scheme:J.scheme})))return new Promise($=>{const W=le.onDidChangeFileSystemProviderRegistrations(T=>{T.scheme===J.scheme&&T.added&&(W.dispose(),$())})})}e.whenProviderRegistered=Y,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(le){return(0,R.isNumber)(le)||(le=0),le<se.KB?(0,P.localize)(1,null,le.toFixed(0)):le<se.MB?(0,P.localize)(2,null,(le/se.KB).toFixed(2)):le<se.GB?(0,P.localize)(3,null,(le/se.MB).toFixed(2)):le<se.TB?(0,P.localize)(4,null,(le/se.GB).toFixed(2)):(0,P.localize)(5,null,(le/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var re;(function(J){J[J.IA32=0]="IA32",J[J.OTHER=1]="OTHER"})(re=e.Arch||(e.Arch={}));function fe(J){return{maxFileSize:J===0?300*se.MB:16*se.GB,maxHeapSize:J===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=fe}),define(ie[196],ne([0,1,17,45,15,3,2,59,7,29,16]),function(G,e,E,t,k,R,A,P,w,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class S extends A.Disposable{constructor(u,f){super(),this.a=u,this.b=f,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.h=(0,g.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,f){const{buffer:p}=await this.a.call("readFile",[u,f]);return p}readFileStream(u,f,p){const h=(0,P.newWriteableStream)(v=>E.VSBuffer.concat(v.map(C=>E.VSBuffer.wrap(C))).buffer),l=this.a.listen("readFileStream",[u,f])(v=>{if(v instanceof E.VSBuffer)h.write(v.buffer);else{if(v==="end")h.end();else{let C=v;C instanceof Error||(C=(0,b.createFileSystemProviderError)((0,t.toErrorMessage)(C),b.FileSystemProviderErrorCode.Unknown)),h.error(C),h.end()}l.dispose()}});return p.onCancellationRequested(()=>{h.error((0,k.canceled)()),h.end(),l.dispose()}),h}writeFile(u,f,p){return this.a.call("writeFile",[u,E.VSBuffer.wrap(f),p])}open(u,f){return this.a.call("open",[u,f])}close(u){return this.a.call("close",[u])}async read(u,f,p,h,l){const[v,C]=await this.a.call("read",[u,f,l]);return p.set(v.buffer.slice(0,C),h),C}write(u,f,p,h,l){return this.a.call("write",[u,f,E.VSBuffer.wrap(p),h,l])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,f){return this.a.call("delete",[u,f])}rename(u,f,p){return this.a.call("rename",[u,f,p])}copy(u,f,p){return this.a.call("copy",[u,f,p])}cloneFile(u,f){return this.a.call("cloneFile",[u,f])}i(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const f=u;this.f.fire(f.map(p=>({resource:w.URI.revive(p.resource),type:p.type})))}else{const f=u;this.g.fire(f)}}))}watch(u,f){const p=(0,g.generateUuid)();return this.a.call("watch",[this.h,p,u,f]),(0,A.toDisposable)(()=>this.a.call("unwatch",[this.h,p]))}}e.DiskFileSystemProviderClient=S}),define(ie[108],ne([0,1,17,15,160,16]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(b,S,y,u,f,p){let h;try{await P(b,S,y,u,f,p)}catch(l){h=l}finally{h&&f.errorTransformer&&(h=f.errorTransformer(h)),typeof h<"u"&&y.error(h),y.end()}}e.readFileIntoStream=A;async function P(b,S,y,u,f,p){w(p);const h=await b.open(S,{create:!1});try{w(p);let l=0,v=0,C=f&&typeof f.length=="number"?f.length:void 0,I=E.VSBuffer.alloc(Math.min(f.bufferSize,typeof C=="number"?C:f.bufferSize)),m=f&&typeof f.position=="number"?f.position:0,i=0;do v=await b.read(h,m,I.buffer,i,I.byteLength-i),m+=v,i+=v,l+=v,typeof C=="number"&&(C-=v),i===I.byteLength&&(await y.write(u(I)),I=E.VSBuffer.alloc(Math.min(f.bufferSize,typeof C=="number"?C:f.bufferSize)),i=0);while(v>0&&(typeof C!="number"||C>0)&&w(p)&&g(l,f));if(i>0){let n=i;typeof C=="number"&&(n=Math.min(i,C)),y.write(u(I.slice(0,n)))}}catch(l){throw(0,R.ensureFileSystemProviderError)(l)}finally{await b.close(h)}}function w(b){if(b.isCancellationRequested)throw(0,t.canceled)();return!0}function g(b,S){if(S?.limits){if(typeof S.limits.memory=="number"&&b>S.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&b>S.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ie[72],ne([0,1,99,2,9,4,7,16]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function w(l){return l.recursive===!0}e.isRecursiveWatchRequest=w;class g extends t.Disposable{constructor(v,C,I,m){super(),this.h=v,this.i=C,this.j=I,this.k=m,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const v=new t.DisposableStore;this.c.value=v,this.b=this.l(v),this.b.setVerboseLogging(this.j),v.add(this.b.onDidChangeFile(C=>this.h(C))),v.add(this.b.onDidLogMessage(C=>this.i(C))),v.add(this.b.onDidError(C=>this.n(C)))}n(v){this.k.restartOnError?this.g<g.a&&this.f?(this.r(`restarting watcher after error: ${v}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${v}`):this.r(v)}p(v){this.g++,this.m(),this.watch(v)}async watch(v){this.f=v,await this.b?.watch(v)}async setVerboseLogging(v){this.j=v,await this.b?.setVerboseLogging(v)}r(v){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${v}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=g,g.a=5;class b extends g{constructor(v,C,I){super(v,C,I,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class S extends g{constructor(v,C,I){super(v,C,I,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=S;function y(l){return l.map(v=>({type:v.type,resource:A.URI.file(v.path)}))}e.toFileChanges=y;function u(l){const v=new h;for(const C of l)v.processEvent(C);return v.coalesce()}e.coalesceEvents=u;function f(l,v){return typeof v=="string"&&!v.startsWith(E.GLOBSTAR)&&!(0,k.isAbsolute)(v)?{base:l,pattern:v}:v}e.normalizeWatcherPattern=f;function p(l,v){const C=[];for(const I of v)C.push((0,E.parse)(f(l,I)));return C}e.parseWatcherPatterns=p;class h{constructor(){this.a=new Set,this.b=new Map}c(v){return R.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const C=this.b.get(this.c(v));let I=!1;if(C){const m=C.type,i=v.type;C.path!==v.path&&(v.type===2||v.type===1)?I=!0:m===1&&i===2?(this.b.delete(this.c(v)),this.a.delete(C)):m===2&&i===1?C.type=0:m===1&&i===0||(C.type=i)}else I=!0;I&&(this.a.add(v),this.b.set(this.c(v),v))}coalesce(){const v=[],C=[];return Array.from(this.a).filter(I=>I.type!==2?(v.push(I),!1):!0).sort((I,m)=>I.path.length-m.path.length).filter(I=>C.some(m=>(0,P.isParent)(I.path,m,!R.isLinux))?!1:(C.push(I.path),!0)).concat(v)}}}),define(ie[197],ne([0,1,40,8,22,30,2,76,9,4,100,23,72]),function(G,e,E,t,k,R,A,P,w,g,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends A.Disposable{constructor(h,l,v,C){super(),this.k=h,this.l=l,this.m=v,this.n=C,this.c=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},I=>this.l(I)),this.f=this.B(new t.ThrottledDelayer(u.b)),this.g=[],this.h=(0,y.parseWatcherPatterns)(this.k.path,this.k.excludes),this.i=this.k.includes?(0,y.parseWatcherPatterns)(this.k.path,this.k.includes):void 0,this.j=new k.CancellationTokenSource,this.ready=this.r()}async r(){try{const h=await this.s(this.k);if(this.j.token.isCancellationRequested)return;const l=await S.Promises.stat(h);this.B(await this.t(h,l.isDirectory()))}catch(h){h.code!=="ENOENT"?this.w(h):this.z(h)}}async s(h){let l=h.path;try{l=await S.Promises.realpath(h.path),h.path===l&&(l=await(0,b.realcase)(h.path)??h.path),h.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${l})`)}catch{}return l}async t(h,l){if(g.isMacintosh&&(0,R.isEqualOrParent)(h,"/Volumes/",!0))return this.w(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const v=new k.CancellationTokenSource(this.j.token),C=new A.DisposableStore;try{const I=(0,w.basename)(h),m=(0,E.watch)(h);C.add((0,A.toDisposable)(()=>{m.removeAllListeners(),m.close()})),this.z(`Started watching: '${h}'`);const i=new Set;if(l)try{for(const r of await S.Promises.readdir(h))i.add(r)}catch(r){this.w(r)}const n=new Map;C.add((0,A.toDisposable)(()=>{for(const[,r]of n)r.dispose();n.clear()})),m.on("error",(r,a)=>{this.w(`Failed to watch ${h} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),m.on("change",(r,a)=>{if(v.token.isCancellationRequested)return;this.z(`[raw] ["${r}"] ${a}`);let s="";if(a&&(s=a.toString(),g.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||r!=="change"&&r!=="rename"))if(l)if(r==="rename"){n.get(s)?.dispose();const c=setTimeout(async()=>{if(n.delete(s),s===I&&!await S.Promises.exists(h)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,w.join)(h,s));if(v.token.isCancellationRequested)return;let d;o?i.has(s)?d=0:(d=1,i.add(s)):(i.delete(s),d=2),this.u({path:(0,w.join)(this.k.path,s),type:d})},u.a);n.set(s,(0,A.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(s)?c=0:(c=1,i.add(s)),this.u({path:(0,w.join)(this.k.path,s),type:c})}else if(r==="rename"||s!==I){const c=setTimeout(async()=>{const o=await S.Promises.exists(h);v.token.isCancellationRequested||(o?(this.u({path:this.k.path,type:0},!0),C.add(await this.t(h,!1))):(await this.u({path:this.k.path,type:2},!0),this.dispose()))},u.a);C.clear(),C.add((0,A.toDisposable)(()=>clearTimeout(c)))}else this.u({path:this.k.path,type:0},!0)})}catch(I){await S.Promises.exists(h)&&!v.token.isCancellationRequested&&this.w(`Failed to watch ${h} for changes using fs.watch() (${I.toString()})`)}return(0,A.toDisposable)(()=>{v.dispose(!0),C.dispose()})}async u(h,l=!1){if(!this.j.token.isCancellationRequested){this.n&&this.z(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`),!l&&this.h.some(v=>v(h.path))?this.n&&this.z(` >> ignored (excluded) ${h.path}`):!l&&this.i&&this.i.length>0&&!this.i.some(v=>v(h.path))?this.n&&this.z(` >> ignored (not included) ${h.path}`):this.g.push(h);try{await this.f.trigger(async()=>{const v=this.g;this.g=[];const C=(0,y.coalesceEvents)(v);if(C.length>0){if(this.n)for(const m of C)this.z(`>> normalized ${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`);this.c.work(C)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${C[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${C.length}, most recent change: ${C[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async v(h){if(g.isLinux)return S.Promises.exists(h);try{const l=(0,w.basename)(h);return(await S.Promises.readdir((0,w.dirname)(h))).some(C=>C===l)}catch(l){return this.z(l),!1}}setVerboseLogging(h){this.n=h}w(h){this.j.token.isCancellationRequested||this.m?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}y(h){this.j.token.isCancellationRequested||this.m?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}z(h){!this.j.token.isCancellationRequested&&this.n&&this.m?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.z(`stopping file watcher on ${this.k.path}`),this.j.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u,u.a=100,u.b=50;async function f(p,h,l,v,C=512){const I=await S.Promises.open(p,"r"),m=Buffer.allocUnsafe(C),i=new k.CancellationTokenSource(v);let n,r=!1;const a={path:p,excludes:[],recursive:!1},s=new u(a,c=>{(async()=>{for(const{type:o}of c)if(o===0){if(r)return;r=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:d}=await S.Promises.read(I,m,0,C,null);if(!d||i.token.isCancellationRequested)break;h(m.slice(0,d))}}catch(d){n=new Error(d),i.dispose(!0)}finally{r=!1}}})()});return await s.ready,l(),new Promise((c,o)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await S.Promises.close(I)}catch(d){n=new Error(d)}n?o(n):c()})})}e.watchFileContents=f}),define(ie[198],ne([0,1,3,99,2,4,197]),function(G,e,E,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(g){const b=this.i(g),S=b.filter(u=>{const f=this.c.get(u.path);return f?!(0,t.patternsEquals)(f.request.excludes,u.excludes)||!(0,t.patternsEquals)(f.request.includes,u.includes):!0}),y=Array.from(this.c.values()).filter(({request:u})=>!b.find(f=>f.path===u.path&&(0,t.patternsEquals)(f.excludes,u.excludes)&&(0,t.patternsEquals)(f.includes,u.includes))).map(({request:u})=>u.path);S.length&&this.j(`Request to start watching: ${S.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),y.length&&this.j(`Request to stop watching: ${y.join(",")}`);for(const u of y)this.h(u);for(const u of S)this.g(u)}g(g){const b=new A.NodeJSFileWatcherLibrary(g,y=>this.a.fire(y),y=>this.b.fire(y),this.f),S={request:g,instance:b};this.c.set(g.path,S)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const b=this.c.get(g);b&&(this.c.delete(g),b.instance.dispose())}i(g){const b=new Map;for(const S of g){const y=R.isLinux?S.path:S.path.toLowerCase();b.set(y,S)}return Array.from(b.values())}async setVerboseLogging(g){this.f=g;for(const[,b]of this.c)b.instance.setVerboseLogging(g)}j(g){this.f&&this.b.fire({type:"trace",message:this.k(g)})}k(g,b){return b?`[File Watcher (node.js)] ${g} (path: ${b.request.path})`:`[File Watcher (node.js)] ${g}`}}e.NodeJSWatcher=P}),define(ie[199],ne([0,1,72,198]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends E.AbstractNonRecursiveWatcherClient{constructor(A,P,w){super(A,P,w),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ie[200],ne([0,1,14,47,146,72]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends R.AbstractUniversalWatcherClient{constructor(w,g,b){super(w,g,b),this.m()}l(w){const g=w.add(new k.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(g.onDidProcessExit(({code:b,signal:S})=>this.n(`terminated by itself with code ${b}, signal: ${S}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(g.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ie[85],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...k){this.a=new Map;for(const[R,A]of k)this.set(R,A)}set(k,R){const A=this.a.get(k);return this.a.set(k,R),A}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=E}),define(ie[201],ne([0,1,8,15,2,70,191,5,85,96]),function(G,e,E,t,k,R,A,P,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class S extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class y{constructor(h=new w.ServiceCollection,l=!1,v,C=b){this.f=h,this.g=l,this.h=v,this.i=C,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=C?v?._globalGraph??new A.Graph(I=>I):void 0}createChild(h){return new y(h,this.g,this,this.i)}invokeFunction(h,...l){const v=f.traceInvocation(this.i,h);let C=!1;try{return h({get:m=>{if(C)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(m,v);if(!i)throw new Error(`[invokeFunction] unknown service '${m}'`);return i}},...l)}finally{C=!0,v.stop()}}createInstance(h,...l){let v,C;return h instanceof R.SyncDescriptor?(v=f.traceCreation(this.i,h.ctor),C=this.j(h.ctor,h.staticArguments.concat(l),v)):(v=f.traceCreation(this.i,h),C=this.j(h,l,v)),v.stop(),C}j(h,l=[],v){const C=P._util.getServiceDependencies(h).sort((i,n)=>i.index-n.index),I=[];for(const i of C){const n=this.m(i.id,v);n||this.u(`[createInstance] ${h.name} depends on UNKNOWN service ${i.id}.`,!1),I.push(n)}const m=C.length>0?C[0].index:l.length;if(l.length!==m){console.trace(`[createInstance] First service dependency of ${h.name} at position ${m+1} conflicts with ${l.length} static arguments`);const i=m-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,m)}return Reflect.construct(h,l.concat(I))}k(h,l){if(this.f.get(h)instanceof R.SyncDescriptor)this.f.set(h,l);else if(this.h)this.h.k(h,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(h){const l=this.f.get(h);return!l&&this.h?this.h.l(h):l}m(h,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const v=this.l(h);return v instanceof R.SyncDescriptor?this.q(h,v,l.branch(h,!0)):(l.branch(h,!1),v)}q(h,l,v){if(this.o.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.o.add(h);try{return this.r(h,l,v)}finally{this.o.delete(h)}}r(h,l,v){const C=new A.Graph(i=>i.id.toString());let I=0;const m=[{id:h,desc:l,_trace:v}];for(;m.length;){const i=m.pop();if(C.lookupOrInsertNode(i),I++>1e3)throw new S(C);for(const n of P._util.getServiceDependencies(i.desc.ctor)){const r=this.l(n.id);if(r||this.u(`[createInstance] ${h} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),r instanceof R.SyncDescriptor){const a={id:n.id,desc:r,_trace:i._trace.branch(n.id,!0)};C.insertEdge(i,a),m.push(a)}}}for(;;){const i=C.roots();if(i.length===0){if(!C.isEmpty())throw new S(C);break}for(const{data:n}of i){if(this.l(n.id)instanceof R.SyncDescriptor){const a=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,a)}C.removeNode(n)}}return this.l(h)}s(h,l,v=[],C,I){if(this.f.get(h)instanceof R.SyncDescriptor)return this.t(h,l,v,C,I);if(this.h)return this.h.s(h,l,v,C,I);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(h,l,v=[],C,I){if(C){const m=new y(void 0,this.g,this,this.i);m.c=String(h);const i=new Map,n=new E.IdleValue(()=>{const r=m.j(l,v,I);for(const[a,s]of i){const c=r[a];if(typeof c=="function")for(const o of s)c.apply(r,o)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,a){if(!n.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let o=i.get(a);return o||(o=new g.LinkedList,i.set(a,o)),(D,L,N)=>{const V=o.push([D,L,N]);return(0,k.toDisposable)(V)}}if(a in r)return r[a];const s=n.value;let c=s[a];return typeof c!="function"||(c=c.bind(s),r[a]=c),c},set(r,a,s){return n.value[a]=s,!0},getPrototypeOf(r){return l.prototype}})}else return this.j(l,v,I)}u(h,l){if(l&&console.warn(h),this.g)throw new Error(h)}}e.InstantiationService=y;var u;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(u||(u={}));class f{static traceInvocation(h,l){return h?new f(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(h,l){return h?new f(1,l.name):f.c}constructor(h,l){this.type=h,this.name=l,this.g=Date.now(),this.h=[]}branch(h,l){const v=new f(3,h.toString());return this.h.push([h,l,v]),v}stop(){const h=Date.now()-this.g;f.f+=h;let l=!1;function v(I,m){const i=[],n=new Array(I+1).join("	");for(const[r,a,s]of m.h)if(a&&s){l=!0,i.push(`${n}CREATES -> ${r}`);const c=v(I+1,s);c&&i.push(c)}else i.push(`${n}uses -> ${r}`);return i.join(`
`)}const C=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(h>2||l)&&f.all.add(C.join(`
`))}}e.Trace=f,f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0}),define(ie[6],ne([0,1,45,3,2,39,4,7,5]),function(G,e,E,t,k,R,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function g(){return new Date().toISOString()}var b;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function S(c,o,d){switch(o){case b.Trace:c.trace(d);break;case b.Debug:c.debug(d);break;case b.Info:c.info(d);break;case b.Warning:c.warn(d);break;case b.Error:c.error(d);break;case b.Off:break;default:throw new Error(`Invalid log level ${o}`)}}e.log=S;function y(c){let o="";for(let d=0;d<c.length;d++){let D=c[d];if(typeof D=="object")try{D=JSON.stringify(D)}catch{}o+=(d>0?" ":"")+D}return o}e.format=y;class u extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}f(o){return this.b!==b.Off&&this.b<=o}}e.AbstractLogger=u;class f extends u{constructor(o){super(),this.h=o}f(o){return this.h||super.f(o)}trace(o,...d){this.f(b.Trace)&&this.g(b.Trace,y([o,...d]))}debug(o,...d){this.f(b.Debug)&&this.g(b.Debug,y([o,...d]))}info(o,...d){this.f(b.Info)&&this.g(b.Info,y([o,...d]))}warn(o,...d){this.f(b.Warning)&&this.g(b.Warning,y([o,...d]))}error(o,...d){if(this.f(b.Error))if(o instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=o.stack,this.g(b.Error,y(D))}else this.g(b.Error,y([o,...d]))}flush(){}}e.AbstractMessageLogger=f;class p extends u{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.g=!A.isWindows}trace(o,...d){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,o,...d):console.log(`[main ${g()}]`,o,...d))}debug(o,...d){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,o,...d):console.log(`[main ${g()}]`,o,...d))}info(o,...d){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,o,...d):console.log(`[main ${g()}]`,o,...d))}warn(o,...d){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,o,...d):console.warn(`[main ${g()}]`,o,...d))}error(o,...d){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,o,...d):console.error(`[main ${g()}]`,o,...d))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class h extends u{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...d){this.f(b.Trace)&&console.log("%cTRACE","color: #888",o,...d)}debug(o,...d){this.f(b.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",o,...d)}info(o,...d){this.f(b.Info)&&console.log("%c INFO","color: #33f",o,...d)}warn(o,...d){this.f(b.Warning)&&console.log("%c WARN","color: #993",o,...d)}error(o,...d){this.f(b.Error)&&console.log("%c  ERR","color: #f33",o,...d)}dispose(){}flush(){}}e.ConsoleLogger=h;class l extends u{constructor(o,d=e.DEFAULT_LOG_LEVEL){super(),this.g=o,this.setLevel(d)}trace(o,...d){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(o),...d])}debug(o,...d){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(o),...d])}info(o,...d){this.f(b.Info)&&this.g.log(b.Info,[this.h(o),...d])}warn(o,...d){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(o),...d])}error(o,...d){this.f(b.Error)&&this.g.log(b.Error,[this.h(o),...d])}h(o){return typeof o=="string"?o:(0,E.toErrorMessage)(o,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class v extends u{constructor(o){super(),this.g=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const d of this.g)d.setLevel(o);super.setLevel(o)}trace(o,...d){for(const D of this.g)D.trace(o,...d)}debug(o,...d){for(const D of this.g)D.debug(o,...d)}info(o,...d){for(const D of this.g)D.info(o,...d)}warn(o,...d){for(const D of this.g)D.warn(o,...d)}error(o,...d){for(const D of this.g)D.error(o,...d)}flush(){for(const o of this.g)o.flush()}dispose(){for(const o of this.g)o.dispose()}}e.MultiplexLogService=v;class C extends k.Disposable{constructor(o){super(),this.b=o,this.B(o)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(o){this.b.setLevel(o)}getLevel(){return this.b.getLevel()}trace(o,...d){this.b.trace(o,...d)}debug(o,...d){this.b.debug(o,...d)}info(o,...d){this.b.info(o,...d)}warn(o,...d){this.b.warn(o,...d)}error(o,...d){this.b.error(o,...d)}flush(){this.b.flush()}}e.LogService=C;class I extends k.Disposable{constructor(o,d){super(),this.c=o,this.b=new R.ResourceMap,this.B(d(D=>this.setLevel(D)))}getLoggers(){return[...this.b.values()].map(({logger:o})=>o)}getLogger(o){return this.b.get(o)?.logger}createLogger(o,d,D){let L=this.b.get(o)?.logger;return L||(D=d?.always?b.Trace:D,L=this.f(o,D??this.c,d),this.b.set(o,{logger:L,logLevel:D})),L}setLevel(o,d){const D=P.URI.isUri(o)?o:void 0,L=D?d:o;if(D){const N=this.b.get(D);N&&N.logLevel!==L&&(N.logLevel=L,N.logger.setLevel(L))}else this.c=L,this.b.forEach(({logLevel:N,logger:V})=>{N===void 0&&V.setLevel(this.c)})}getLogLevel(o){return this.b.get(o)?.logLevel}dispose(){this.b.forEach(({logger:o})=>o.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=I;class m{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return b.Info}trace(o,...d){}debug(o,...d){}info(o,...d){}warn(o,...d){}error(o,...d){}critical(o,...d){}dispose(){}flush(){}}e.NullLogger=m;class i extends m{}e.NullLogService=i;class n extends I{constructor(){super(b.Info,t.Event.None)}f(o,d,D){return new m}}e.NullLoggerService=n;function r(c){if(c.verbose)return b.Trace;if(typeof c.logLevel=="string"){const o=s(c.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function a(c){switch(c){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=a;function s(c){switch(c){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=s});var ee=this&&this.__param||function(G,e){return function(E,t){e(E,t,G)}};define(ie[202],ne([0,1,71,3,2,6,4,8]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let w=class Et extends k.Disposable{constructor(b){super(),this.g=b,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(b,S){this.g.trace("Getting password from keytar:",b,S);let y;try{y=await this.h()}catch{return null}const u=await(0,P.retry)(()=>y.getPassword(b,S),50,3);if(!u)return this.g.trace("Did not get a password from keytar for account:",S),u;let f,p;try{const h=JSON.parse(u);f=h.content,p=h.hasNextChunk}catch{}if(!f||!p)return this.g.trace("Got password from keytar for account:",S),u;try{let h=1;for(;p;){const l=await(0,P.retry)(()=>y.getPassword(b,`${S}-${h}`),50,3),v=JSON.parse(l);f+=v.content,p=v.hasNextChunk,h++}return this.g.trace(`Got ${h}-chunked password from keytar for account:`,S),f}catch(h){return this.g.error(h),u}}async setPassword(b,S,y){this.g.trace("Setting password using keytar:",b,S);let u;try{u=await this.h()}catch(f){throw this.i?.(f),f}if(A.isWindows&&y.length>Et.a){let f=0,p=0,h=!0;for(;h;){const l=y.substring(f,f+Et.b);f+=Et.b,h=y.length-f>0;const v={content:l,hasNextChunk:h};await(0,P.retry)(()=>u.setPassword(b,p?`${S}-${p}`:S,JSON.stringify(v)),50,3),p++}this.g.trace(`Got${p?` ${p}-chunked`:""} password from keytar for account:`,S)}else await(0,P.retry)(()=>u.setPassword(b,S,y),50,3),this.g.trace("Got password from keytar for account:",S);this.c.fire({service:b,account:S})}async deletePassword(b,S){this.g.trace("Deleting password using keytar:",b,S);let y;try{y=await this.h()}catch(l){throw this.i?.(l),l}const u=await y.getPassword(b,S);if(!u)return this.g.trace("Did not get a password to delete from keytar for account:",S),!1;let f,p;try{const l=JSON.parse(u);f=l.content,p=l.hasNextChunk}catch{}let h=0;if(f&&p)try{for(h++;p;){const l=`${S}-${h}`,v=await y.getPassword(b,l);await y.deletePassword(b,l),p=JSON.parse(v).hasNextChunk,h++}}catch(l){this.g.error(l)}return await y.deletePassword(b,S)?(this.c.fire({service:b,account:S}),this.g.trace(`Deleted${h?` ${h}-chunked`:""} password from keytar for account:`,S),!0):(this.g.trace(`Keytar failed to delete${h?` ${h}-chunked`:""} password for account:`,S),!1)}async findPassword(b){let S;try{S=await this.h()}catch{return null}return await S.findPassword(b)}async findCredentials(b){let S;try{S=await this.h()}catch{return[]}return await S.findCredentials(b)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};w.a=2500,w.b=w.a-100,w=pe([ee(0,R.ILogService)],w),e.BaseCredentialsMainService=w}),define(ie[203],ne([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(R,A){this.a=R,this.b=A}c(){return new Promise((R,A)=>G(["vscode-encrypt"],R,A))}async encrypt(R){let A;try{A=await this.c()}catch{return R}try{return A.encrypt(this.a,R)}catch(P){return this.b.error(P),R}}async decrypt(R){let A;try{A=await this.c()}catch{return R}try{return A.decrypt(this.a,R)}catch(P){return this.b.error(P),R}}};t=pe([ee(1,E.ILogService)],t),e.EncryptionMainService=t}),define(ie[204],ne([0,1,24,8,15,3,2,9,72,6]),function(G,e,E,t,k,R,A,P,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends A.Disposable{constructor(y,u){super(),this.a=y,this.b=u,this.c=this.B(new R.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(y,u){return u.recursive||this.b?.watcher?.forceUniversal?this.l(y,u):this.u(y,u)}l(y,u){const f={path:this.C(y),excludes:u.excludes,includes:u.includes,recursive:u.recursive},p=(0,E.insert)(this.j,f);return this.m(),(0,A.toDisposable)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(y=>(0,k.onUnexpectedError)(y))}n(){this.h||(this.h=this.B(this.p(u=>this.c.fire((0,w.toFileChanges)(u)),u=>this.z(u),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const u of this.j)(0,w.isRecursiveWatchRequest)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const u of this.j)(0,w.isRecursiveWatchRequest)(u)&&y.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(y,u){const f={path:this.C(y),excludes:u.excludes,includes:u.includes,recursive:!1},p=(0,E.insert)(this.s,f);return this.v(),(0,A.toDisposable)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(y=>(0,k.onUnexpectedError)(y))}w(){return this.r||(this.r=this.B(this.y(y=>this.c.fire((0,w.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.r.watch(this.s)}z(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}C(y){return(0,P.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ie[205],ne([0,1,24,8,17,22,3,68,67,2,60,14,73,20,59,158,16,108,6]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class extends g.Disposable{constructor(m){super(),this.b=m,this.a=256*1024,this.c=this.B(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new A.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new A.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new A.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new t.ResourceQueue)}registerProvider(m,i){if(this.h.has(m))throw new Error(`A filesystem provider for the scheme '${m}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${m}`);const n=new g.DisposableStore;return this.h.set(m,i),this.c.fire({added:!0,scheme:m,provider:i}),n.add(i.onDidChangeFile(r=>this.Q.fire(new h.FileChangesEvent(r,!this.N(i))))),typeof i.onDidWatchError=="function"&&n.add(i.onDidWatchError(r=>this.R.fire(new Error(r)))),n.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:m}))),(0,g.toDisposable)(()=>{this.c.fire({added:!1,scheme:m,provider:i}),this.h.delete(m),(0,g.dispose)(n)})}getProvider(m){return this.h.get(m)}async activateProvider(m){const i=[];this.f.fire({scheme:m,join(n){i.push(n)}}),!this.h.has(m)&&await t.Promises.settled(i)}async canHandleResource(m){return await this.activateProvider(m.scheme),this.hasProvider(m)}hasProvider(m){return this.h.has(m.scheme)}hasCapability(m,i){const n=this.h.get(m.scheme);return!!(n&&n.capabilities&i)}listCapabilities(){return w.Iterable.map(this.h,([m,i])=>({scheme:m,capabilities:i.capabilities}))}async j(m){if(!(0,u.isAbsolutePath)(m))throw new h.FileOperationError((0,p.localize)(0,null,this.mb(m)),8);await this.activateProvider(m.scheme);const i=this.h.get(m.scheme);if(!i){const n=new Error;throw n.name="ENOPRO",n.message=(0,p.localize)(1,null,m.toString()),n}return i}async k(m){const i=await this.j(m);if((0,h.hasOpenReadWriteCloseCapability)(i)||(0,h.hasReadWriteCapability)(i)||(0,h.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${m.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(m){const i=await this.j(m);if((0,h.hasOpenReadWriteCloseCapability)(i)||(0,h.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${m.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(m,i){try{return await this.n(m,i)}catch(n){throw(0,h.toFileSystemProviderErrorCode)(n)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,p.localize)(2,null,this.mb(m)),1):(0,h.ensureFileSystemProviderError)(n)}}async n(m,i){const n=await this.j(m),r=this.N(n),a=i?.resolveTo,s=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,o=await n.stat(m);let d;return this.p(n,m,o,void 0,!!c,(D,L)=>(d||(d=b.TernarySearchTree.forUris(()=>!r),d.set(m,!0),a&&d.fill(!0,a)),d.get(D.resource)||d.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?L===1:!1))}async p(m,i,n,r,a,s){const{providerExtUri:c}=this.M(m),o={resource:i,name:c.basename(i),isFile:(n.type&h.FileType.File)!==0,isDirectory:(n.type&h.FileType.Directory)!==0,isSymbolicLink:(n.type&h.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&h.FilePermission.Readonly)||Boolean(m.capabilities&2048),etag:(0,h.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(o.isDirectory&&s(o,r)){try{const d=await m.readdir(i),D=await t.Promises.settled(d.map(async([L,N])=>{try{const V=c.joinPath(i,L),oe=a?await m.stat(V):{type:N};return await this.p(m,V,oe,d.length,a,s)}catch(V){return this.b.trace(V),null}}));o.children=(0,E.coalesce)(D)}catch(d){this.b.trace(d),o.children=[]}return o}return o}async resolveAll(m){return t.Promises.settled(m.map(async i=>{try{return{stat:await this.n(i.resource,i.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(m){const i=await this.j(m),n=await i.stat(m);return this.p(i,m,n,void 0,!0,()=>!1)}async exists(m){const i=await this.j(m);try{return!!await i.stat(m)}catch{return!1}}async canCreateFile(m,i){try{await this.r(m,i)}catch(n){return n}return!0}async r(m,i){if(!i?.overwrite&&await this.exists(m))throw new h.FileOperationError((0,p.localize)(3,null,this.mb(m)),3,i)}async createFile(m,i=k.VSBuffer.fromString(""),n){await this.r(m,n);const r=await this.writeFile(m,i);return this.m.fire(new h.FileOperationEvent(m,0,r)),r}async writeFile(m,i,n){const r=this.kb(await this.l(m),m),{providerExtUri:a}=this.M(r);try{await this.s(r,m,n)||await this.O(r,a.dirname(m));let c;if((0,h.hasReadWriteCapability)(r)&&!(i instanceof k.VSBuffer))if((0,f.isReadableStream)(i)){const o=await(0,f.peekStream)(i,3);o.ended?c=k.VSBuffer.concat(o.buffer):c=o}else c=(0,f.peekReadable)(i,o=>k.VSBuffer.concat(o),3);else c=i;!(0,h.hasOpenReadWriteCloseCapability)(r)||(0,h.hasReadWriteCapability)(r)&&c instanceof k.VSBuffer?await this.bb(r,m,n,c):await this.X(r,m,n,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this.m.fire(new h.FileOperationEvent(m,4))}catch(s){throw new h.FileOperationError((0,p.localize)(4,null,this.mb(m),(0,h.ensureFileSystemProviderError)(s).toString()),(0,h.toFileOperationResult)(s),n)}return this.resolve(m,{resolveMetadata:!0})}async s(m,i,n){if(!!n?.unlock&&!(m.capabilities&8192))throw new Error((0,p.localize)(5,null,this.mb(i)));let a;try{a=await m.stat(i)}catch{return}if((a.type&h.FileType.Directory)!==0)throw new h.FileOperationError((0,p.localize)(6,null,this.mb(i)),0,n);if(this.lb(i,a),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==h.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&n.mtime<a.mtime&&n.etag!==(0,h.etag)({mtime:n.mtime,size:a.size}))throw new h.FileOperationError((0,p.localize)(7,null),3,n);return a}async readFile(m,i,n){const r=await this.k(m);return i?.atomic?this.t(r,m,i,n):this.u(r,m,i,n)}async t(m,i,n,r){return new Promise((a,s)=>{this.W.queueFor(i,this.M(m).providerExtUri).queue(async()=>{try{const c=await this.u(m,i,n,r);a(c)}catch(c){s(c)}})})}async u(m,i,n,r){const a=await this.v(m,i,{...n,preferUnbuffered:!0},r);return{...a,value:await(0,k.streamToBuffer)(a.value)}}async readFileStream(m,i,n){const r=await this.k(m);return this.v(r,m,i,n)}async v(m,i,n,r){const a=new R.CancellationTokenSource(r),s=this.D(i,n).then(o=>o,o=>{throw a.cancel(),o});let c;try{return typeof n?.etag=="string"&&n.etag!==h.ETAG_DISABLED&&await s,n?.atomic&&(0,h.hasFileAtomicReadCapability)(m)||!((0,h.hasOpenReadWriteCloseCapability)(m)||(0,h.hasFileReadStreamCapability)(m))||(0,h.hasReadWriteCapability)(m)&&n?.preferUnbuffered?c=this.C(m,i,n):(0,h.hasFileReadStreamCapability)(m)?c=this.w(m,i,a.token,n):c=this.z(m,i,a.token,n),{...await s,value:c}}catch(o){c&&await(0,f.consumeStream)(c);const d=(0,p.localize)(8,null,this.mb(i),(0,h.ensureFileSystemProviderError)(o).toString());throw o instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(d,o.stat,n):new h.FileOperationError(d,(0,h.toFileOperationResult)(o),n)}}w(m,i,n,r=Object.create(null)){const a=m.readFileStream(i,r,n);return(0,f.transform)(a,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new h.FileOperationError((0,p.localize)(9,null,this.mb(i),(0,h.ensureFileSystemProviderError)(s).toString()),(0,h.toFileOperationResult)(s),r)},s=>k.VSBuffer.concat(s))}z(m,i,n,r=Object.create(null)){const a=(0,k.newWriteableBufferStream)();return(0,l.readFileIntoStream)(m,i,a,s=>s,{...r,bufferSize:this.a,errorTransformer:s=>new h.FileOperationError((0,p.localize)(10,null,this.mb(i),(0,h.ensureFileSystemProviderError)(s).toString()),(0,h.toFileOperationResult)(s),r)},n),a}C(m,i,n){const r=(0,f.newWriteableStream)(a=>k.VSBuffer.concat(a));return(async()=>{try{let a;n?.atomic&&(0,h.hasFileAtomicReadCapability)(m)?a=await m.readFile(i,{atomic:!0}):a=await m.readFile(i),typeof n?.position=="number"&&(a=a.slice(n.position)),typeof n?.length=="number"&&(a=a.slice(0,n.length)),this.F(i,a.byteLength,n),r.end(k.VSBuffer.wrap(a))}catch(a){r.error(a),r.end()}})(),r}async D(m,i){const n=await this.resolve(m,{resolveMetadata:!0});if(n.isDirectory)throw new h.FileOperationError((0,p.localize)(11,null,this.mb(m)),0,i);if(typeof i?.etag=="string"&&i.etag!==h.ETAG_DISABLED&&i.etag===n.etag)throw new h.NotModifiedSinceFileOperationError((0,p.localize)(12,null),n,i);return this.F(m,n.size,i),n}F(m,i,n){if(n?.limits){let r;if(typeof n.limits.memory=="number"&&i>n.limits.memory&&(r=9),typeof n.limits.size=="number"&&i>n.limits.size&&(r=7),typeof r=="number")throw new h.FileOperationError((0,p.localize)(13,null,this.mb(m)),r)}}async canMove(m,i,n){return this.G(m,i,"move",n)}async canCopy(m,i,n){return this.G(m,i,"copy",n)}async G(m,i,n,r){if(m.toString()!==i.toString())try{const a=n==="move"?this.kb(await this.l(m),m):await this.k(m),s=this.kb(await this.l(i),i);await this.L(a,m,s,i,n,r)}catch(a){return a}return!0}async move(m,i,n){const r=this.kb(await this.l(m),m),a=this.kb(await this.l(i),i),s=await this.H(r,m,a,i,"move",!!n),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(m,s==="move"?2:3,c)),c}async copy(m,i,n){const r=await this.k(m),a=this.kb(await this.l(i),i),s=await this.H(r,m,a,i,"copy",!!n),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(m,s==="copy"?3:2,c)),c}async H(m,i,n,r,a,s){if(i.toString()===r.toString())return a;const{exists:c,isSameResourceWithDifferentPathCase:o}=await this.L(m,i,n,r,a,s);if(c&&!o&&s&&await this.del(r,{recursive:!0}),await this.O(n,this.M(n).providerExtUri.dirname(r)),a==="copy"){if(m===n&&(0,h.hasFileFolderCopyCapability)(m))await m.copy(i,r,{overwrite:s});else{const d=await this.resolve(i);d.isDirectory?await this.J(m,d,n,r):await this.I(m,i,n,r)}return a}else return m===n?(await m.rename(i,r,{overwrite:s}),a):(await this.H(m,i,n,r,"copy",s),await this.del(i,{recursive:!0}),"copy")}async I(m,i,n,r){if((0,h.hasOpenReadWriteCloseCapability)(m)&&(0,h.hasOpenReadWriteCloseCapability)(n))return this.db(m,i,n,r);if((0,h.hasOpenReadWriteCloseCapability)(m)&&(0,h.hasReadWriteCapability)(n))return this.jb(m,i,n,r);if((0,h.hasReadWriteCapability)(m)&&(0,h.hasOpenReadWriteCloseCapability)(n))return this.hb(m,i,n,r);if((0,h.hasReadWriteCapability)(m)&&(0,h.hasReadWriteCapability)(n))return this.fb(m,i,n,r)}async J(m,i,n,r){await n.mkdir(r),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async a=>{const s=this.M(n).providerExtUri.joinPath(r,a.name);return a.isDirectory?this.J(m,await this.resolve(a.resource),n,s):this.I(m,a.resource,n,s)}))}async L(m,i,n,r,a,s){let c=!1;if(m===n){const{providerExtUri:d,isPathCaseSensitive:D}=this.M(m);if(D||(c=d.isEqual(i,r)),c&&a==="copy")throw new Error((0,p.localize)(14,null,this.mb(i),this.mb(r)));if(!c&&d.isEqualOrParent(r,i))throw new Error((0,p.localize)(15,null,this.mb(i),this.mb(r)))}const o=await this.exists(r);if(o&&!c){if(!s)throw new h.FileOperationError((0,p.localize)(16,null,this.mb(i),this.mb(r)),4);if(m===n){const{providerExtUri:d}=this.M(m);if(d.isEqualOrParent(i,r))throw new Error((0,p.localize)(17,null,this.mb(i),this.mb(r)))}}return{exists:o,isSameResourceWithDifferentPathCase:c}}M(m){const i=this.N(m);return{providerExtUri:i?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:i}}N(m){return!!(m.capabilities&1024)}async createFolder(m){const i=this.kb(await this.j(m),m);await this.O(i,m);const n=await this.resolve(m,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(m,0,n)),n}async O(m,i){const n=[],{providerExtUri:r}=this.M(m);for(;!r.isEqual(i,r.dirname(i));)try{if(((await m.stat(i)).type&h.FileType.Directory)===0)throw new Error((0,p.localize)(18,null,this.mb(i)));break}catch(a){if((0,h.toFileSystemProviderErrorCode)(a)!==h.FileSystemProviderErrorCode.FileNotFound)throw a;n.push(r.basename(i)),i=r.dirname(i)}for(let a=n.length-1;a>=0;a--){i=r.joinPath(i,n[a]);try{await m.mkdir(i)}catch(s){if((0,h.toFileSystemProviderErrorCode)(s)!==h.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(m,i){try{await this.P(m,i)}catch(n){return n}return!0}async P(m,i){const n=this.kb(await this.j(m),m);if(!!i?.useTrash&&!(n.capabilities&4096))throw new Error((0,p.localize)(19,null,this.mb(m)));let a;try{a=await n.stat(m)}catch{}if(a)this.lb(m,a);else throw new h.FileOperationError((0,p.localize)(20,null,this.mb(m)),1);if(!!!i?.recursive){const c=await this.resolve(m);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,p.localize)(21,null,this.mb(m)))}return n}async del(m,i){const n=await this.P(m,i),r=!!i?.useTrash,a=!!i?.recursive;await n.delete(m,{recursive:a,useTrash:r}),this.m.fire(new h.FileOperationEvent(m,1))}async cloneFile(m,i){const n=await this.j(m),r=this.kb(await this.l(i),i);if(n===r&&this.M(n).providerExtUri.isEqual(m,i))return;if(n===r&&(0,h.hasFileCloneCapability)(n))return n.cloneFile(m,i);await this.O(r,this.M(r).providerExtUri.dirname(i));const a=this.W.queueFor(m,this.M(n).providerExtUri);return n===r&&(0,h.hasFileFolderCopyCapability)(n)?a.queue(()=>n.copy(m,i,{overwrite:!0})):a.queue(()=>this.I(n,m,r,i))}watch(m,i={recursive:!1,excludes:[]}){const n=new g.DisposableStore;let r=!1,a=()=>{r=!0};return n.add((0,g.toDisposable)(()=>a())),(async()=>{try{const s=await this.U(m,i);r?(0,g.dispose)(s):a=()=>(0,g.dispose)(s)}catch(s){this.b.error(s)}})(),n}async U(m,i){const n=await this.j(m),r=(0,P.hash)([this.M(n).providerExtUri.getComparisonKey(m),i]);let a=this.S.get(r);return a||(a={count:0,disposable:n.watch(m,i)},this.S.set(r,a)),a.count+=1,(0,g.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,g.dispose)(a.disposable),this.S.delete(r)))})}dispose(){super.dispose();for(const[,m]of this.S)(0,g.dispose)(m.disposable);this.S.clear()}async X(m,i,n,r){return this.W.queueFor(i,this.M(m).providerExtUri).queue(async()=>{const a=await m.open(i,{create:!0,unlock:n?.unlock??!1});try{(0,f.isReadableStream)(r)||(0,f.isReadableBufferedStream)(r)?await this.Y(m,a,r):await this.Z(m,a,r)}catch(s){throw(0,h.ensureFileSystemProviderError)(s)}finally{await m.close(a)}})}async Y(m,i,n){let r=0,a;if((0,f.isReadableBufferedStream)(n)){if(n.buffer.length>0){const s=k.VSBuffer.concat(n.buffer);await this.ab(m,i,s,s.byteLength,r,0),r+=s.byteLength}if(n.ended)return;a=n.stream}else a=n;return new Promise((s,c)=>{(0,f.listenStream)(a,{onData:async o=>{a.pause();try{await this.ab(m,i,o,o.byteLength,r,0)}catch(d){return c(d)}r+=o.byteLength,setTimeout(()=>a.resume())},onError:o=>c(o),onEnd:()=>s()})})}async Z(m,i,n){let r=0,a;for(;(a=n.read())!==null;)await this.ab(m,i,a,a.byteLength,r,0),r+=a.byteLength}async ab(m,i,n,r,a,s){let c=0;for(;c<r;)c+=await m.write(i,a+c,n.buffer,s+c,r-c)}async bb(m,i,n,r){return this.W.queueFor(i,this.M(m).providerExtUri).queue(()=>this.cb(m,i,n,r))}async cb(m,i,n,r){let a;r instanceof k.VSBuffer?a=r:(0,f.isReadableStream)(r)?a=await(0,k.streamToBuffer)(r):(0,f.isReadableBufferedStream)(r)?a=await(0,k.bufferedStreamToBuffer)(r):a=(0,k.readableToBuffer)(r),await m.writeFile(i,a.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async db(m,i,n,r){return this.W.queueFor(r,this.M(n).providerExtUri).queue(()=>this.eb(m,i,n,r))}async eb(m,i,n,r){let a,s;try{a=await m.open(i,{create:!1}),s=await n.open(r,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.a);let o=0,d=0,D=0;do D=await m.read(a,o,c.buffer,d,c.byteLength-d),await this.ab(n,s,c,D,o,d),o+=D,d+=D,d===c.byteLength&&(d=0);while(D>0)}catch(c){throw(0,h.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof a=="number"?m.close(a):Promise.resolve(),typeof s=="number"?n.close(s):Promise.resolve()])}}async fb(m,i,n,r){return this.W.queueFor(r,this.M(n).providerExtUri).queue(()=>this.gb(m,i,n,r))}async gb(m,i,n,r){return n.writeFile(r,await m.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async hb(m,i,n,r){return this.W.queueFor(r,this.M(n).providerExtUri).queue(()=>this.ib(m,i,n,r))}async ib(m,i,n,r){const a=await n.open(r,{create:!0,unlock:!1});try{const s=await m.readFile(i);await this.ab(n,a,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,h.ensureFileSystemProviderError)(s)}finally{await n.close(a)}}async jb(m,i,n,r){const a=await(0,k.streamToBuffer)(this.z(m,i,R.CancellationToken.None));await this.bb(n,r,void 0,a)}kb(m,i){if(m.capabilities&2048)throw new h.FileOperationError((0,p.localize)(22,null,this.mb(i)),6);return m}lb(m,i){if((i.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,p.localize)(23,null,this.mb(m)),6)}mb(m){return m.scheme===S.Schemas.file?m.fsPath:m.toString(!0)}};C=pe([ee(0,v.ILogService)],C),e.FileService=C}),define(ie[86],ne([0,1,40,281,8,39,17,3,30,2,9,4,20,59,23,162,16,108,204,45,200,199]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v,C,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(E)}catch(n){console.error(`Error enabling graceful-fs: ${(0,C.toErrorMessage)(n)}`)}})();class i extends v.AbstractDiskFileSystemProvider{constructor(r,a){super(r,a),this.onDidChangeCapabilities=P.Event.None,this.H=new R.ResourceMap(s=>y.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,S.isLinux&&(this.F|=1024)),this.F}async stat(r){try{const{stat:a,symbolicLink:s}=await f.SymlinkSupport.stat(this.C(r));return{type:this.G(a,s),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.Y(a)}}async readdir(r){try{const a=await f.Promises.readdir(this.C(r),{withFileTypes:!0}),s=[];return await Promise.all(a.map(async c=>{try{let o;c.isSymbolicLink()?o=(await this.stat((0,y.joinPath)(r,c.name))).type:o=this.G(c),s.push([c.name,o])}catch(o){this.a.trace(o)}})),s}catch(a){throw this.Y(a)}}G(r,a){let s;return a?.dangling?s=h.FileType.Unknown:r.isFile()?s=h.FileType.File:r.isDirectory()?s=h.FileType.Directory:s=h.FileType.Unknown,a&&(s|=h.FileType.SymbolicLink),s}async I(r){const a=this.C(r);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let s;for(;s=this.H.get(r);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await s.wait();const c=new k.Barrier;return this.H.set(r,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,g.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.H.get(r)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.H.delete(r)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),c.open()})}async readFile(r,a){let s;try{a?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(r)})`),s=await this.I(r));const c=this.C(r);return await f.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{s?.dispose()}}J(r){i.D&&this.a.trace(r)}readFileStream(r,a,s){const c=(0,u.newWriteableStream)(o=>A.VSBuffer.concat(o.map(d=>A.VSBuffer.wrap(d))).buffer);return(0,l.readFileIntoStream)(this,r,c,o=>o.buffer,{...a,bufferSize:256*1024},s),c}async writeFile(r,a,s){let c;try{const o=this.C(r);if(!s.create||!s.overwrite){if(await f.Promises.exists(o)){if(!s.overwrite)throw(0,h.createFileSystemProviderError)((0,p.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,h.createFileSystemProviderError)((0,p.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(r,{create:!0,unlock:s.unlock}),await this.write(c,0,a,0,a.byteLength)}catch(o){throw await this.Z(r,o)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(r){i.O=r}async open(r,a){const s=this.C(r);let c;(0,h.isFileOpenForWriteOptions)(a)&&(c=await this.I(r));let o;try{if((0,h.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:D}=await f.SymlinkSupport.stat(s);D.mode&128||await f.Promises.chmod(s,D.mode|128)}catch(D){this.a.trace(D)}let d;if((0,h.isFileOpenForWriteOptions)(a)){if(S.isWindows)try{await f.Promises.truncate(s,0),d="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}d||(d="w")}else d="r";o=await f.Promises.open(s,d)}catch(d){throw c?.dispose(),(0,h.isFileOpenForWriteOptions)(a)?await this.Z(r,d):this.Y(d)}if(this.L.set(o,0),(0,h.isFileOpenForWriteOptions)(a)&&this.N.set(o,r),c){const d=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${s})`),this.M.set(o,c),d&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${s})`),d.dispose())}return o}async close(r){const a=this.M.get(r);try{if(this.L.delete(r),this.N.delete(r)&&i.O)try{await f.Promises.fdatasync(r)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await f.Promises.close(r)}catch(s){throw this.Y(s)}finally{a&&(this.M.get(r)===a&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.M.delete(r)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),a.dispose())}}async read(r,a,s,c,o){const d=this.P(r,a);let D=null;try{D=(await f.Promises.read(r,s,c,o,d)).bytesRead}catch(L){throw this.Y(L)}finally{this.Q(r,d,D)}return D}P(r,a){return a===this.L.get(r)?null:a}Q(r,a,s){const c=this.L.get(r);typeof c=="number"&&(typeof a=="number"||(typeof s=="number"?this.L.set(r,c+s):this.L.delete(r)))}async write(r,a,s,c,o){return(0,k.retry)(()=>this.R(r,a,s,c,o),100,3)}async R(r,a,s,c,o){const d=this.P(r,a);let D=null;try{D=(await f.Promises.write(r,s,c,o,d)).bytesWritten}catch(L){throw await this.Z(this.N.get(r),L)}finally{this.Q(r,d,D)}return D}async mkdir(r){try{await f.Promises.mkdir(this.C(r))}catch(a){throw this.Y(a)}}async delete(r,a){try{const s=this.C(r);a.recursive?await f.Promises.rm(s,f.RimRafMode.MOVE):await f.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(r,a,s){const c=this.C(r),o=this.C(a);if(c!==o)try{await this.S(r,a,"move",s.overwrite),await f.Promises.move(c,o)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,p.localize)(2,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(o)),d.toString()))),this.Y(d)}}async copy(r,a,s){const c=this.C(r),o=this.C(a);if(c!==o)try{await this.S(r,a,"copy",s.overwrite),await f.Promises.copy(c,o,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,p.localize)(3,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(o)),d.toString()))),this.Y(d)}}async S(r,a,s,c){const o=this.C(r),d=this.C(a);let D=!1;if(!!(this.capabilities&1024)||(D=(0,w.isEqual)(o,d,!0)),D&&s==="copy")throw(0,h.createFileSystemProviderError)((0,p.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!D&&await f.Promises.exists(d)){if(!c)throw(0,h.createFileSystemProviderError)((0,p.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(r,a){return this.U(r,a,!1)}async U(r,a,s){const c=this.C(r),o=this.C(a),d=!!(this.capabilities&1024);if((0,w.isEqual)(c,o,!d))return;const D=new g.DisposableStore;try{const[L,N]=await Promise.all([this.I(r),this.I(a)]);D.add(L),D.add(N),s&&await f.Promises.mkdir((0,b.dirname)(o),{recursive:!0}),await f.Promises.copyFile(c,o)}catch(L){if(L.code==="ENOENT"&&!s)return this.U(r,a,!0);throw this.Y(L)}finally{D.dispose()}}p(r,a,s){return new I.UniversalWatcherClient(c=>r(c),c=>a(c),s)}y(r,a,s){return new m.NodeJSWatcherClient(c=>r(c),c=>a(c),s)}Y(r){if(r instanceof h.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=h.FileSystemProviderErrorCode.NoPermissions;break;default:a=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(r,a)}async Z(r,a){let s=this.Y(a);if(r&&s.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await f.SymlinkSupport.stat(this.C(r));c.mode&128||(s=(0,h.createFileSystemProviderError)(a,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return s}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(ie[206],ne([0,1,3,86,2,17,59,22]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class w extends k.Disposable{constructor(S,y){super(),this.a=S,this.b=y,this.w=new Map,this.y=new Map}call(S,y,u){const f=this.c(S);switch(y){case"stat":return this.g(f,u[0]);case"readdir":return this.h(f,u[0]);case"open":return this.l(f,u[0],u[1]);case"close":return this.m(u[0]);case"read":return this.n(u[0],u[1],u[2]);case"readFile":return this.i(f,u[0],u[1]);case"write":return this.p(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.k(f,u[0],u[1],u[2]);case"rename":return this.t(f,u[0],u[1],u[2]);case"copy":return this.u(f,u[0],u[1],u[2]);case"cloneFile":return this.v(f,u[0],u[1]);case"mkdir":return this.r(f,u[0]);case"delete":return this.s(f,u[0],u[1]);case"watch":return this.C(f,u[0],u[1],u[2],u[3]);case"unwatch":return this.D(u[0],u[1])}throw new Error(`IPC Command ${y} not found`)}listen(S,y,u){const f=this.c(S);switch(y){case"fileChange":return this.z(f,u[0]);case"readFileStream":return this.j(f,u[0],u[1])}throw new Error(`Unknown event ${y}`)}g(S,y){const u=this.f(S,y,!0);return this.a.stat(u)}h(S,y){const u=this.f(S,y);return this.a.readdir(u)}async i(S,y,u){const f=this.f(S,y,!0),p=await this.a.readFile(f,u);return R.VSBuffer.wrap(p)}j(S,y,u){const f=this.f(S,y,!0),p=new P.CancellationTokenSource,h=new E.Emitter({onDidRemoveLastListener:()=>{p.cancel()}}),l=this.a.readFileStream(f,u,p.token);return(0,A.listenStream)(l,{onData:v=>h.fire(R.VSBuffer.wrap(v)),onError:v=>h.fire(v),onEnd:()=>{h.fire("end"),h.dispose(),p.dispose()}}),h.event}k(S,y,u,f){const p=this.f(S,y);return this.a.writeFile(p,u.buffer,f)}l(S,y,u){const f=this.f(S,y,!0);return this.a.open(f,u)}m(S){return this.a.close(S)}async n(S,y,u){const f=R.VSBuffer.alloc(u),p=0,h=await this.a.read(S,y,f.buffer,p,u);return[f,h]}p(S,y,u,f,p){return this.a.write(S,y,u.buffer,f,p)}r(S,y){const u=this.f(S,y);return this.a.mkdir(u)}s(S,y,u){const f=this.f(S,y);return this.a.delete(f,u)}t(S,y,u,f){const p=this.f(S,y),h=this.f(S,u);return this.a.rename(p,h,f)}u(S,y,u,f){const p=this.f(S,y),h=this.f(S,u);return this.a.copy(p,h,f)}v(S,y,u){const f=this.f(S,y),p=this.f(S,u);return this.a.cloneFile(f,p)}z(S,y){const u=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(y,this.F(S,u))},onDidRemoveLastListener:()=>{(0,k.dispose)(this.w.get(y)),this.w.delete(y)}});return u.event}async C(S,y,u,f,p){const h=this.w.get(y);if(h){const l=this.f(S,f),v=h.watch(u,l,p);this.y.set(y+u,v)}}async D(S,y){const u=S+y,f=this.y.get(u);f&&((0,k.dispose)(f),this.y.delete(u))}dispose(){super.dispose();for(const[,S]of this.y)S.dispose();this.y.clear();for(const[,S]of this.w)S.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=w;class g extends k.Disposable{constructor(S,y,u,f){super(),this.c=S,this.f=u,this.g=f,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(y)}h(S){const y=this.B(new E.Emitter);this.B(y.event(u=>{S.fire(u.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type})))})),this.B(this.b.onDidChangeFile(u=>y.fire(u))),this.B(this.b.onDidWatchError(u=>S.fire(u)))}i(S){}j(S){}watch(S,y,u){const f=this.j(this.g);return Array.isArray(f)&&(u.excludes=[...u.excludes,...f]),this.a.set(S,this.b.watch(y,u)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.a.get(S)),this.a.delete(S)})}dispose(){super.dispose();for(const[,S]of this.a)S.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=g}),define(ie[207],ne([0,1,13,161,4,7,16,9,206,140]),function(G,e,E,t,k,R,A,P,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class b extends w.AbstractDiskFileSystemProviderChannel{constructor(u,f,p){super(u,f),this.G=p}c(u){return g.DefaultURITransformer}f(u,f){return R.URI.revive(f)}async s(u,f,p){if(!p.useTrash)return super.s(u,f,p);const h=this.f(u,f),l=(0,P.normalize)(h.fsPath);try{await E.shell.trashItem(l)}catch{throw(0,A.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,P.basename)(l)):(0,t.localize)(1,null,(0,P.basename)(l)),A.FileSystemProviderErrorCode.Unknown)}}F(u,f){return new S(u,f,this.b,this.G)}}e.DiskFileSystemProviderChannel=b;class S extends w.AbstractSessionFileWatcher{watch(u,f,p){if(p.recursive)throw(0,A.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(u,f,p)}}}),define(ie[208],ne([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;class t extends E.AbstractMessageLogger{constructor(R=E.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(A=>{this.l?.setLevel(A)}))}set logger(R){this.l=R;for(const{level:A,message:P}of this.k)(0,E.log)(R,A,P);this.k=[]}g(R,A){this.l?(0,E.log)(this.l,R,A):this.getLevel()<=R&&this.k.push({level:R,message:A})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogService=t}),define(ie[209],ne([0,1,3,7,6]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(y,u){this.a=y,this.b=u,this.onDidChangeLogLevel=E.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,u){switch(u){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${u}`)}async call(y,u,f){switch(u){case"setLevel":return f[1]?this.b.setLevel(t.URI.revive(f[1]),f[0]):this.a.setLevel(f[0])}throw new Error(`Call not found: ${u}`)}}e.LogLevelChannel=R;class A{constructor(y){this.a=y}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(y,u){A.setLevel(this.a,y,u)}static setLevel(y,u,f){return y.call("setLevel",[u,f])}}e.LogLevelChannelClient=A;class P{constructor(y){this.b=y,this.a=new Map}listen(y,u){throw new Error(`Event not found: ${u}`)}async call(y,u,f){switch(u){case"createLogger":this.c(t.URI.revive(f[0]),f[1]);return;case"log":return this.e(t.URI.revive(f[0]),f[1]);case"consoleLog":return this.d(f[0],f[1])}throw new Error(`Call not found: ${u}`)}c(y,u){this.a.set(y.toString(),this.b.createLogger(y,u))}d(y,u){let f=console.log;switch(y){case k.LogLevel.Error:f=console.error;break;case k.LogLevel.Warning:f=console.warn;break;case k.LogLevel.Info:f=console.info;break}f.call(console,...u)}e(y,u){const f=this.a.get(y.toString());if(!f)throw new Error("Create the logger before logging");for(const[p,h]of u)(0,k.log)(f,p,h)}}e.LoggerChannel=P;class w extends k.AbstractLoggerService{constructor(y,u,f){super(y,u),this.g=f}createConsoleMainLogger(){return new k.AdapterLogger({log:(y,u)=>{this.g.call("consoleLog",[y,u])}})}f(y,u,f){return new g(this.g,y,u,f)}}e.LoggerChannelClient=w;class g extends k.AbstractMessageLogger{constructor(y,u,f,p){super(p?.always),this.m=y,this.n=u,this.k=!1,this.l=[],this.setLevel(f),this.m.call("createLogger",[u,p]).then(()=>{this.r(this.l),this.k=!0})}g(y,u){const f=[[y,u]];this.k?this.r(f):this.l.push(...f)}r(y){this.m.call("log",[this.n,y])}}class b extends k.LogService{constructor(y,u){super(u),this.c=y,this.B(y.onDidChangeLogLevel(f=>u.setLevel(f)))}setLevel(y){super.setLevel(y),this.c.setLevel(y)}}e.FollowerLogService=b}),define(ie[210],ne([0,1,16,6]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(k||(k={}));async function R(g,b,S,y,u){try{const f=await new Promise((h,l)=>{G(["spdlog"],h,l)});f.setFlushOn(k.Trace);const p=await f.createAsyncRotatingLogger(g,b,S,y);return u?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(f){console.error(f)}return null}function A(g,b,S){switch(b){case t.LogLevel.Trace:g.trace(S);break;case t.LogLevel.Debug:g.debug(S);break;case t.LogLevel.Info:g.info(S);break;case t.LogLevel.Warning:g.warn(S);break;case t.LogLevel.Error:g.error(S);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function P(g,b){switch(b){case t.LogLevel.Trace:g.setLevel(k.Trace);break;case t.LogLevel.Debug:g.setLevel(k.Debug);break;case t.LogLevel.Info:g.setLevel(k.Info);break;case t.LogLevel.Warning:g.setLevel(k.Warning);break;case t.LogLevel.Error:g.setLevel(k.Error);break;case t.LogLevel.Off:g.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class w extends t.AbstractMessageLogger{constructor(b,S,y,u,f){super(),this.k=[],this.setLevel(f),this.l=this.n(b,S,y,u),this.B(this.onDidChangeLogLevel(p=>{this.m&&P(this.m,p)}))}async n(b,S,y,u){const f=y?6:1,p=30/f*E.ByteSize.MB,h=await R(b,S,p,f,u);if(h){this.m=h,P(this.m,this.getLevel());for(const{level:l,message:v}of this.k)A(this.m,l,v);this.k=[]}}g(b,S){this.m?A(this.m,b,S):this.getLevel()<=b&&this.k.push({level:b,message:S})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=w}),define(ie[211],ne([0,1,29,6,210]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let R=class extends t.AbstractLoggerService{constructor(P){super(P.getLevel(),P.onDidChangeLogLevel)}f(P,w,g){return new k.SpdLogLogger(g?.name||(0,E.generateUuid)(),P.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,w)}};R=pe([ee(0,t.ILogService)],R),e.LoggerService=R}),define(ie[212],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(A){return A.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function t(A){return A.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(A){return A.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(A){return!E(A)&&!t(A)&&!k(A)}e.isMenubarMenuItemAction=R}),define(ie[37],ne([0,1,3,67,2,5]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class A extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const b=Object.keys(this.f).length;return this.f={...g,...this.f},b!==Object.keys(this.f).length&&await this.i(g),t.Iterable.reduce(this.g.entries(),(S,[y,u])=>({...S,[y]:u}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(g,[b,S])=>({...g,[b]:{definition:S,value:this.g.get(b)}}),{})}}e.AbstractPolicyService=A;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ie[213],ne([0,1,8,3,67,11,16,6,37]),function(G,e,E,t,k,R,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function g(S,y){const u=[];for(const f of new Set(k.Iterable.concat(S.keys(),y.keys())))S.get(f)!==y.get(f)&&u.push(f);return u}let b=class extends w.AbstractPolicyService{constructor(y,u,f){super(),this.j=y,this.k=u,this.l=f,this.c=this.B(new E.ThrottledDelayer(500));const p=t.Event.filter(u.onDidFilesChange,h=>h.affects(y));this.B(u.watch(y)),this.B(p(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const y=new Map;try{const u=await this.k.readFile(this.j),f=JSON.parse(u.value.toString());if(!(0,R.isObject)(f))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(f))this.f[p]&&y.set(p,f[p])}catch(u){u.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",u)}return y}async p(){const y=await this.n(),u=g(this.g,y);this.g=y,u.length>0&&this.h.fire(u)}};b=pe([ee(1,A.IFileService),ee(2,P.ILogService)],b),e.FilePolicyService=b}),define(ie[214],ne([0,1,3,2,37]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(w){this.b=w,this.a=new t.DisposableStore}listen(w,g){switch(g){case"onDidChange":return E.Event.map(this.b.onDidChange,b=>b.reduce((S,y)=>({...S,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(w,g,b){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.PolicyChannel=R;class A extends k.AbstractPolicyService{constructor(w,g){super(),this.a=g;for(const b in w){const{definition:S,value:y}=w[b];this.f[b]=S,y!==void 0&&this.g.set(b,y)}this.a.listen("onDidChange")(b=>{for(const S in b){const y=b[S];y===null?this.g.delete(S):this.g.set(S,y)}this.h.fire(Object.keys(b))})}async i(w){const g=await this.a.call("updatePolicyDefinitions",w);for(const b in g)this.g.set(b,g[b])}}e.PolicyChannelClient=A}),define(ie[63],ne([0,1,4,33]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const R=E.globals.vscode.context.configuration();if(R)k=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(k=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(k,{version:R.version})}}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(ie[19],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ie[215],ne([0,1,77,6,19]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(P,w){this.b=P,this.c=w,this.a=new Map}async isExtensionUrlTrusted(P,w){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const g=/^(.*)#([^#]+)$/.exec(w);if(!g)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,b,S]=g;let y=this.a.get(P);if(!y){if(y=this.b.trustedExtensionUrlPublicKeys[P],!y||y.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.a.set(P,[...y])}const u=Buffer.from(decodeURIComponent(S),"base64");if(u.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const f=u.slice(0,6),p=u.readUIntBE(0,6),h=Date.now()-p;if(h<0||h>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const l=u.slice(6),v=E.createVerify("SHA256");v.write(f),v.write(Buffer.from(b)),v.end();for(let C=0;C<y.length;C++){let I=y[C];if(I!==null){if(typeof I=="string")try{I=E.createPublicKey({key:Buffer.from(I,"base64"),format:"der",type:"spki"}),y[C]=I}catch(m){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${C+1} for ${P}:`,m),y[C]=null;continue}if(v.verify(I,l))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};R=pe([ee(0,k.IProductService),ee(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(ie[216],ne([0,1,8,6]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let k=class{constructor(A,P,w){this.a=A,this.b=P,this.c=w}async inspect(A){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.timeout)(A);const w=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),w.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};k=pe([ee(2,t.ILogService)],k),e.WindowProfiler=k}),define(ie[64],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(ie[48],ne([0,1,122,11]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(A,P){E.ok(t.isString(A)),E.ok(t.isObject(P)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,P)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.Registry=new k}),define(ie[217],ne([0,1,3,48]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,g){this.a[k(w)]=g,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const A=new R;t.Registry.add(e.Extensions.JSONContribution,A)}),define(ie[65],ne([0,1,24,3,11,149,18,217,48]),function(G,e,E,t,k,R,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(g=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=w.Registry.as(P.Extensions.JSONContribution);class y{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(i,n=!0){this.registerConfigurations([i],n)}registerConfigurations(i,n=!0){const r=this.k(i,n);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const n=this.l(i);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:i,remove:n}){const r=[];r.push(...this.l(n)),r.push(...this.k(i,!1)),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,E.distinct)(r)})}registerDefaultConfigurations(i){const n=[],r=[];for(const{overrides:a,source:s}of i)for(const c in a)if(n.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const o=this.a.get(c),d=o?.valuesSources??new Map;if(s)for(const V of Object.keys(a[c]))d.set(V,s);const D={...o?.value||{},...a[c]};this.a.set(c,{source:s,value:D,valuesSources:d});const L=(0,A.getLanguageTagSettingPlainKey)(c),N={type:"object",default:D,description:R.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:k.isString(s)?void 0:s,defaultValueSource:s};r.push(...p(c)),this.d[c]=N,this.b.properties[c]=N}else{this.a.set(c,{value:a[c],source:s});const o=this.d[c];o&&(this.s(c,o),this.o(c,o))}this.registerOverrideIdentifiers(r),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const n=[];for(const{overrides:r,source:a}of i)for(const s in r){const c=this.a.get(s),o=k.isString(a)?a:a?.id,d=k.isString(c?.source)?c?.source:c?.source?.id;if(o===d)if(n.push(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const D=this.d[s];D&&(this.s(s,D),this.o(s,D))}}this.q(),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){for(const n of i)this.h.add(n);this.q()}k(i,n){const r=[];return i.forEach(a=>{r.push(...this.m(a,n,a.extensionInfo,a.restrictedProperties)),this.c.push(a),this.n(a)}),r}l(i){const n=[],r=a=>{if(a.properties)for(const s in a.properties){n.push(s);const c=this.d[s];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[s],this.p(s,a.properties[s])}a.allOf?.forEach(s=>r(s))};for(const a of i){r(a);const s=this.c.indexOf(a);s!==-1&&this.c.splice(s,1)}return n}m(i,n=!0,r,a,s=3){s=k.isUndefinedOrNull(i.scope)?s:i.scope;const c=[],o=i.properties;if(o)for(const D in o){const L=o[D];if(n&&C(D,L)){delete o[D];continue}if(L.source=r,L.defaultDefaultValue=o[D].default,this.s(D,L),e.OVERRIDE_PROPERTY_REGEX.test(D)?L.scope=void 0:(L.scope=k.isUndefinedOrNull(L.scope)?s:L.scope,L.restricted=k.isUndefinedOrNull(L.restricted)?!!a?.includes(D):L.restricted),o[D].hasOwnProperty("included")&&!o[D].included){this.f[D]=o[D],delete o[D];continue}else this.d[D]=o[D],o[D].policy?.name&&this.e.set(o[D].policy.name,D);!o[D].deprecationMessage&&o[D].markdownDeprecationMessage&&(o[D].deprecationMessage=o[D].markdownDeprecationMessage),c.push(D)}const d=i.allOf;if(d)for(const D of d)c.push(...this.m(D,n,r,a,s));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(i){const n=r=>{const a=r.properties;if(a)for(const c in a)this.o(c,a[c]);r.allOf?.forEach(n)};n(i)}o(i,n){switch(e.allSettings.properties[i]=n,n.scope){case 1:e.applicationSettings.properties[i]=n;break;case 2:e.machineSettings.properties[i]=n;break;case 6:e.machineOverridableSettings.properties[i]=n;break;case 3:e.windowSettings.properties[i]=n;break;case 4:e.resourceSettings.properties[i]=n;break;case 5:e.resourceSettings.properties[i]=n,this.g.properties[i]=n;break}}p(i,n){switch(delete e.allSettings.properties[i],n.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}q(){for(const i of this.h.values()){const n=`[${i}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(n,r),e.allSettings.properties[n]=r,e.applicationSettings.properties[n]=r,e.machineSettings.properties[n]=r,e.machineOverridableSettings.properties[n]=r,e.windowSettings.properties[n]=r,e.resourceSettings.properties[n]=r}this.i.fire()}r(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}s(i,n){const r=this.a.get(i);let a=r?.value,s=r?.source;k.isUndefined(a)&&(a=n.defaultDefaultValue,s=void 0),k.isUndefined(a)&&(a=l(n.type)),n.default=a,n.defaultValueSource=s}}const u="\\[([^\\]]+)\\]",f=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(m){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let n=f.exec(m);for(;n?.length;){const r=n[1].trim();r&&i.push(r),n=f.exec(m)}}return(0,E.distinct)(i)}e.overrideIdentifiersFromKey=p;function h(m){return m.reduce((i,n)=>`${i}[${n}]`,"")}e.keyFromOverrideIdentifiers=h;function l(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const v=new y;w.Registry.add(e.Extensions.Configuration,v);function C(m,i){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?R.localize(7,null,m):v.getConfigurationProperties()[m]!==void 0?R.localize(8,null,m):i.policy?.name&&v.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,m,i.policy?.name,v.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=C;function I(){const m=[],i=v.getConfigurationProperties();for(const n of Object.keys(i))m.push([n,i[n].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=I}),define(ie[109],ne([0,1,24,3,43,2,39,44,11,7,18,65,48]),function(G,e,E,t,k,R,A,P,w,g,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class u{constructor(n={},r=[],a=[],s){this.c=n,this.d=r,this.f=a,this.raw=s,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(r=>{if(r instanceof u)return r;const a=new f("");return a.parseRaw(r),a.configurationModel});this.g=n.reduce((r,a)=>a===r?a:r.merge(a),n[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(n){return n?(0,b.getConfigurationValue)(this.contents,n):this.contents}inspect(n,r){const a=this.rawConfiguration.getValue(n),s=r?this.rawConfiguration.getOverrideValue(n,r):void 0,c=r?this.rawConfiguration.override(r).getValue(n):a;return{value:a,override:s,merged:c}}getOverrideValue(n,r){const a=this.l(r);return a?n?(0,b.getConfigurationValue)(a,n):a:void 0}getKeysForOverrideIdentifier(n){const r=[];for(const a of this.overrides)a.identifiers.includes(n)&&r.push(...a.keys);return E.distinct(r)}getAllOverrideIdentifiers(){const n=[];for(const r of this.overrides)n.push(...r.identifiers);return E.distinct(n)}override(n){let r=this.b.get(n);return r||(r=this.h(n),this.b.set(n,r)),r}merge(...n){const r=P.deepClone(this.contents),a=P.deepClone(this.overrides),s=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const o of n)if(c.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.j(r,o.contents);for(const d of o.overrides){const[D]=a.filter(L=>E.equals(L.identifiers,d.identifiers));D?(this.j(D.contents,d.contents),D.keys.push(...d.keys),D.keys=E.distinct(D.keys)):a.push(P.deepClone(d))}for(const d of o.keys)s.indexOf(d)===-1&&s.push(d)}return new u(r,s,a,c.every(o=>o instanceof u)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new u(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}h(n){const r=this.l(n);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const a={};for(const s of E.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[s];const o=r[s];o&&(typeof c=="object"&&typeof o=="object"?(c=P.deepClone(c),this.j(c,o)):c=o),a[s]=c}return new u(a,this.keys,this.overrides)}j(n,r){for(const a of Object.keys(r)){if(a in n&&w.isObject(n[a])&&w.isObject(r[a])){this.j(n[a],r[a]);continue}n[a]=P.deepClone(r[a])}}k(n){return this.a&&!Object.isFrozen(n)?P.deepFreeze(n):n}l(n){let r=null,a=null;const s=c=>{c&&(a?this.j(a,c):a=P.deepClone(c))};for(const c of this.overrides)E.equals(c.identifiers,[n])?r=c.contents:c.identifiers.includes(n)&&s(c.contents);return s(r),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,r){this.m(n),(0,b.addToValueTree)(this.contents,n,r,a=>{throw new Error(a)})}removeValue(n){this.n(n)&&(0,b.removeFromValueTree)(this.contents,n)}m(n){let r=this.keys.length;for(let a=0;a<r;a++)n.indexOf(this.keys[a])===0&&(r=a);this.keys.splice(r,1,n)}n(n){const r=this.keys.indexOf(n);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=u;class f{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new u}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,r){if(!w.isUndefinedOrNull(n)){const a=this.g(n);this.parseRaw(a,r)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,r){this.a=n;const{contents:a,keys:s,overrides:c,restricted:o,hasExcludedProperties:d}=this.h(n,r);this.b=new u(a,s,c,d?[n]:void 0),this.c=o||[]}g(n){let r={},a=null,s=[];const c=[],o=[];function d(L){Array.isArray(s)?s.push(L):a!==null&&(s[a]=L)}const D={onObjectBegin:()=>{const L={};d(L),c.push(s),s=L,a=null},onObjectProperty:L=>{a=L},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const L=[];d(L),c.push(s),s=L,a=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:d,onError:(L,N,V)=>{o.push({error:L,offset:N,length:V})}};if(n)try{k.visit(n,D),r=s[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return r}h(n,r){const a=y.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),s=this.j(n,a,!0,r);n=s.raw;const c=(0,b.toValuesTree)(n,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),o=Object.keys(n),d=this.l(n,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:c,keys:o,overrides:d,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}j(n,r,a,s){let c=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:c};const o={},d=[];for(const D in n)if(S.OVERRIDE_PROPERTY_REGEX.test(D)&&a){const L=this.j(n[D],r,!1,s);o[D]=L.raw,c=c||L.hasExcludedProperties,d.push(...L.restricted)}else{const L=r[D],N=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&d.push(D),(N===void 0||s.scopes===void 0||s.scopes.includes(N))&&!(s.skipRestricted&&L?.restricted)?o[D]=n[D]:c=!0}return{raw:o,restricted:d,hasExcludedProperties:c}}l(n,r){const a=[];for(const s of Object.keys(n))if(S.OVERRIDE_PROPERTY_REGEX.test(s)){const c={};for(const o in n[s])c[o]=n[s][o];a.push({identifiers:(0,S.overrideIdentifiersFromKey)(s),keys:Object.keys(c),contents:(0,b.toValuesTree)(c,r)})}return a}}e.ConfigurationModelParser=f;class p extends R.Disposable{constructor(n,r,a,s){super(),this.f=n,this.g=r,this.h=s,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&a.isEqual(c.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new u}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=p;class h{constructor(n,r,a,s,c,o,d,D,L,N,V,oe,X){this.a=n,this.b=r,this.value=a,this.overrideIdentifiers=s,this.c=c,this.d=o,this.f=d,this.g=D,this.h=L,this.j=N,this.k=V,this.l=oe,this.m=X}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(n,r,a,s,c=new u,o=new u,d=new A.ResourceMap,D=new u,L=new A.ResourceMap,N=!0){this.c=n,this.d=r,this.f=a,this.g=s,this.h=c,this.j=o,this.l=d,this.m=D,this.n=L,this.p=N,this.a=null,this.b=new A.ResourceMap,this.q=null}getValue(n,r,a){return this.s(n,r,a).getValue(n)}updateValue(n,r,a={}){let s;a.resource?(s=this.n.get(a.resource),s||(s=new u,this.n.set(a.resource,s))):s=this.m,r===void 0?s.removeValue(n):s.setValue(n,r),a.resource||(this.a=null)}inspect(n,r,a){const s=this.s(n,r,a),c=this.w(r.resource,a),o=r.resource?this.n.get(r.resource)||this.m:this.m,d=new Set;for(const D of s.overrides)for(const L of D.identifiers)s.getOverrideValue(n,L)!==void 0&&d.add(L);return new h(n,r,s.getValue(n),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),a?this.j.freeze():void 0,c?c.freeze():void 0,o.inspect(n,r.overrideIdentifier))}keys(n){const r=this.w(void 0,n);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.j=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,r){this.l.set(n,r),this.b.delete(n)}deleteFolderConfiguration(n){this.r.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,r){const a=[];if(!r){const{added:s,updated:c,removed:o}=I(this.c,n);r=[...s,...c,...o]}for(const s of r)for(const c of(0,S.overrideIdentifiersFromKey)(s)){const o=this.c.getKeysForOverrideIdentifier(c),d=n.getKeysForOverrideIdentifier(c),D=[...d.filter(L=>o.indexOf(L)===-1),...o.filter(L=>d.indexOf(L)===-1),...o.filter(L=>!P.equals(this.c.override(c).getValue(L),n.override(c).getValue(L)))];a.push([c,D])}return this.updateDefaultConfiguration(n),{keys:r,overrides:a}}compareAndUpdatePolicyConfiguration(n){const{added:r,updated:a,removed:s}=I(this.d,n),c=[...r,...a,...s];return c.length&&this.updatePolicyConfiguration(n),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:r,updated:a,removed:s,overrides:c}=I(this.applicationConfiguration,n),o=[...r,...a,...s];return o.length&&this.updateApplicationConfiguration(n),{keys:o,overrides:c}}compareAndUpdateLocalUserConfiguration(n){const{added:r,updated:a,removed:s,overrides:c}=I(this.localUserConfiguration,n),o=[...r,...a,...s];return o.length&&this.updateLocalUserConfiguration(n),{keys:o,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:r,updated:a,removed:s,overrides:c}=I(this.remoteUserConfiguration,n),o=[...r,...a,...s];return o.length&&this.updateRemoteUserConfiguration(n),{keys:o,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:r,updated:a,removed:s,overrides:c}=I(this.workspaceConfiguration,n),o=[...r,...a,...s];return o.length&&this.updateWorkspaceConfiguration(n),{keys:o,overrides:c}}compareAndUpdateFolderConfiguration(n,r){const a=this.r.get(n),{added:s,updated:c,removed:o,overrides:d}=I(a,r),D=[...s,...c,...o];return(D.length||!a)&&this.updateFolderConfiguration(n,r),{keys:D,overrides:d}}compareAndDeleteFolderConfiguration(n){const r=this.r.get(n);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:a,updated:s,removed:c,overrides:o}=I(r,void 0);return{keys:[...a,...s,...c],overrides:o}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(n,r,a){let s=this.t(r,a);return r.overrideIdentifier&&(s=s.override(r.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(s=s.merge(this.d)),s}t({resource:n},r){let a=this.u();if(r&&n){const s=r.getFolder(n);s&&(a=this.v(s.uri)||a);const c=this.n.get(n);c&&(a=a.merge(c))}return a}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(n){let r=this.b.get(n);if(!r){const a=this.u(),s=this.l.get(n);s?(r=a.merge(s),this.p&&(r=r.freeze()),this.b.set(n,r)):r=a}return r}w(n,r){if(r&&n){const a=r.getFolder(n);if(a)return this.l.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((n,r)=>{const{contents:a,overrides:s,keys:c}=this.l.get(r);return n.push([r,{contents:a,overrides:s,keys:c}]),n},[])}}allKeys(){const n=new Set;return this.c.freeze().keys.forEach(r=>n.add(r)),this.userConfiguration.freeze().keys.forEach(r=>n.add(r)),this.j.freeze().keys.forEach(r=>n.add(r)),this.l.forEach(r=>r.freeze().keys.forEach(a=>n.add(a))),[...n.values()]}x(){const n=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r)),this.j.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r)),this.l.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(a=>n.add(a))),[...n.values()]}y(n){const r=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(a=>r.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(a=>r.add(a)),this.j.getKeysForOverrideIdentifier(n).forEach(a=>r.add(a)),this.l.forEach(a=>a.getKeysForOverrideIdentifier(n).forEach(s=>r.add(s))),[...r.values()]}static parse(n){const r=this.z(n.defaults),a=this.z(n.policy),s=this.z(n.application),c=this.z(n.user),o=this.z(n.workspace),d=n.folders.reduce((D,L)=>(D.set(g.URI.revive(L[0]),this.z(L[1])),D),new A.ResourceMap);return new l(r,a,s,c,new u,o,d,new u,new A.ResourceMap,!1)}static z(n){return new u(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=l;function v(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const n=new Set,r=new Map;for(const s of i)s.keys.forEach(c=>n.add(c)),s.overrides.forEach(([c,o])=>{const d=(0,A.getOrSet)(r,c,new Set);o.forEach(D=>d.add(D))});const a=[];return r.forEach((s,c)=>a.push([c,[...s.values()]])),{keys:[...n.values()],overrides:a}}e.mergeChanges=v;class C{constructor(n,r,a,s){this.change=n,this.b=r,this.c=a,this.d=s,this.f=void 0;const c=new Set;n.keys.forEach(d=>c.add(d)),n.overrides.forEach(([,d])=>d.forEach(D=>c.add(D))),this.affectedKeys=[...c.values()];const o=new u;this.affectedKeys.forEach(d=>o.setValue(d,{})),this.a=o.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=l.parse(this.b.data)),this.f}affectsConfiguration(n,r){if(this.g(this.a,n)){if(r){const a=this.previousConfiguration?this.previousConfiguration.getValue(n,r,this.b?.workspace):void 0,s=this.c.getValue(n,r,this.d);return!P.equals(a,s)}return!0}return!1}g(n,r){let a=(0,b.toValuesTree)({[r]:!0},()=>{}),s;for(;typeof a=="object"&&(s=Object.keys(a)[0]);){if(n=n[s],!n)return!1;a=a[s]}return!0}}e.ConfigurationChangeEvent=C;function I(i,n){const{added:r,removed:a,updated:s}=m(n?.rawConfiguration,i?.rawConfiguration),c=[],o=i?.getAllOverrideIdentifiers()||[],d=n?.getAllOverrideIdentifiers()||[];if(n){const D=d.filter(L=>!o.includes(L));for(const L of D)c.push([L,n.getKeysForOverrideIdentifier(L)])}if(i){const D=o.filter(L=>!d.includes(L));for(const L of D)c.push([L,i.getKeysForOverrideIdentifier(L)])}if(n&&i){for(const D of o)if(d.includes(D)){const L=m({contents:i.getOverrideValue(void 0,D)||{},keys:i.getKeysForOverrideIdentifier(D)},{contents:n.getOverrideValue(void 0,D)||{},keys:n.getKeysForOverrideIdentifier(D)});c.push([D,[...L.added,...L.removed,...L.updated]])}}return{added:r,removed:a,updated:s,overrides:c}}function m(i,n){const r=i?n?i.keys.filter(c=>n.keys.indexOf(c)===-1):[...i.keys]:[],a=n?i?n.keys.filter(c=>i.keys.indexOf(c)===-1):[...n.keys]:[],s=[];if(i&&n){for(const c of n.keys)if(i.keys.indexOf(c)!==-1){const o=(0,b.getConfigurationValue)(n.contents,c),d=(0,b.getConfigurationValue)(i.contents,c);P.equals(o,d)||s.push(c)}}return{added:r,removed:a,updated:s}}}),define(ie[218],ne([0,1,24,3,2,44,11,18,109,65,6,37,48]),function(G,e,E,t,k,R,A,P,w,g,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class u extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new f(this.f())),this.b}async initialize(){return this.b=void 0,this.B(y.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:C})=>this.c(v,C))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(v,C){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:v})}f(){return{}}}e.DefaultConfiguration=u;class f extends w.ConfigurationModel{constructor(v={}){const C=y.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),I=Object.keys(C),m=Object.create(null),i=[];for(const n in C){const r=v[n],a=r!==void 0?r:C[n].default;(0,P.addToValueTree)(m,n,a,s=>console.error(`Conflict in default settings: ${s}`))}for(const n of Object.keys(m))g.OVERRIDE_PROPERTY_REGEX.test(n)&&i.push({identifiers:(0,g.overrideIdentifiersFromKey)(n),keys:Object.keys(m[n]),contents:(0,P.toValuesTree)(m[n],r=>console.error(`Conflict in default settings file: ${r}`))});super(m,I,i)}}e.DefaultConfigurationModel=f;class p{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=p;let h=class extends k.Disposable{get configurationModel(){return this.b}constructor(v,C,I){super(),this.c=v,this.f=C,this.g=I,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new w.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.i(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.j(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const C={},I=[],m=y.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const i of v){const n=m[i];if(!n){I.push(i);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.g.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}I.push(i),C[n.policy.name]={type:n.type}}}return(0,A.isEmptyObject)(C)||await this.f.updatePolicyDefinitions(C),I}i(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const C=y.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),I=(0,E.coalesce)(v.map(m=>C.get(m)));this.j(I,!0)}j(v,C){this.g.trace("PolicyConfiguration#update",v);const I=y.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),m=[],i=this.b.isEmpty();for(const n of v){const r=I[n]?.policy?.name;if(r){const a=this.f.getPolicyValue(r);(i?a!==void 0:!(0,R.equals)(this.b.getValue(n),a))&&m.push([n,a])}else this.b.getValue(n)!==void 0&&m.push([n,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const n=this.b;this.b=new w.ConfigurationModel;for(const r of n.keys)this.b.setValue(r,n.getValue(r));for(const[r,a]of m)a===void 0?this.b.removeValue(r):this.b.setValue(r,a);C&&this.a.fire(this.b)}}};h=pe([ee(1,S.IPolicyService),ee(2,b.ILogService)],h),e.PolicyConfiguration=h}),define(ie[219],ne([0,1,8,3,2,20,18,109,218,37]),function(G,e,E,t,k,R,A,P,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends k.Disposable{constructor(y,u,f,p){super(),this.i=y,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.DefaultConfiguration),this.c=f instanceof g.NullPolicyService?new w.NullPolicyConfiguration:this.B(new w.PolicyConfiguration(this.b,f,p)),this.f=this.B(new P.UserSettings(this.i,void 0,R.extUriBiasedIgnorePathCase,u)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:h,properties:l})=>this.k(h,l))),this.B(this.c.onDidChangeConfiguration(h=>this.l(h))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,u,f]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(y,u,new P.ConfigurationModel,f)}getConfigurationData(){return this.a.toData()}getValue(y,u){const f=typeof y=="string"?y:void 0,p=(0,A.isConfigurationOverrides)(y)?y:(0,A.isConfigurationOverrides)(u)?u:{};return this.a.getValue(f,p,void 0)}updateValue(y,u,f,p){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.j(y)}j(y){const u=this.a.toData(),f=this.a.compareAndUpdateLocalUserConfiguration(y);this.m(f,u,2)}k(y,u){const f=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(y,u);this.m(p,f,7)}l(y){const u=this.a.toData(),f=this.a.compareAndUpdatePolicyConfiguration(y);this.m(f,u,7)}m(y,u,f){const p=new P.ConfigurationChangeEvent(y,{data:u},this.a);p.source=f,p.sourceConfig=this.n(f),this.h.fire(p)}n(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ie[220],ne([0,1,15,5]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends E.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof R&&P._code===k.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof R&&P._code===k.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof R&&P._code===k.NoResolverFound}static isHandled(P){return P instanceof R&&P.isHandled}constructor(P,w=k.Unknown,g){super(P),this._message=P,this._code=w,this._detail=g,this.isHandled=w===k.NotAvailable&&g===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(ie[54],ne([0,1,14]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(g){return g.scheme===E.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=t;function k(g){if(!g)return;const b=g.indexOf("+");return b<0?g:g.substr(0,b)}e.getRemoteName=k;function R(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.getRemoteServerRootPath=R;function A(g){const{host:b,port:S}=w(g);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:S}}e.parseAuthorityWithPort=A;function P(g,b){let{host:S,port:y}=w(g);return typeof y>"u"&&(y=b),{host:S,port:y}}e.parseAuthorityWithOptionalPort=P;function w(g){const b=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const S=g.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const y=g.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:g,port:void 0}}}),define(ie[87],ne([0,1,26,5,54]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=R;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var w;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class g{constructor(p){this.value=p,this.c=p.toLowerCase()}static equals(p,h){if(typeof p>"u"||p===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){const l=typeof p=="string"?p:p.value,v=typeof h=="string"?h:h.value;return E.equalsIgnoreCase(l,v)}return p.c===h.c}static toKey(p){return typeof p=="string"?p.toLowerCase():p.c}}e.ExtensionIdentifier=g;function b(f){return S(f)}e.isApplicationScopedExtension=b;function S(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function y(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function u(f,p){if(p){const h=`onResolveRemoteAuthority:${(0,k.getRemoteName)(p)}`;return f.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=u,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ie[110],ne([0,1,26,192,87,4,7,15,33]),function(G,e,E,t,k,R,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function g(n,r){return n.uuid&&r.uuid?n.uuid===r.uuid:n.id===r.id?!0:(0,E.compareIgnoreCase)(n.id,r.id)===0}e.areSameExtensions=g;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{static create(r){const a=r.manifest?r.manifest.version:r.version,s=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new S(r.identifier,a,s)}static parse(r){const a=b.exec(r);return a&&a[1]&&a[2]?new S({id:a[1]},a[2],a[4]||void 0):null}constructor(r,a,s="undefined"){this.version=a,this.targetPlatform=s,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof S?g(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=S;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function u(n){const r=y.exec(n);return r&&r[1]?[p(r[1]),r[2]]:[p(n),void 0]}e.getIdAndVersion=u;function f(n,r){return`${n}.${r}`}e.getExtensionId=f;function p(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=p;function h(n,r){return p(f(n,r))}e.getGalleryExtensionId=h;function l(n,r){const a=[],s=c=>{for(const o of a)if(o.some(d=>g(r(d),r(c))))return o;return null};for(const c of n){const o=s(c);o?o.push(c):a.push([c])}return a}e.groupByExtension=l;function v(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function C(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function I(n,r){const a=[],s=r.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const c=s.shift();if(c&&a.every(o=>!g(o.identifier,{id:c}))){const o=n.filter(d=>g(d.identifier,{id:c}));o.length===1&&(a.push(o[0]),s.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=I;async function m(n,r){if(!R.isLinux)return!1;let a;try{a=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){r.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=m;async function i(n,r){const a=await m(n,r),s=(0,t.getTargetPlatform)(a?"alpine":R.platform,w.arch);return r.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=i}),define(ie[221],ne([0,1,8,17,22,15,3,2,29,102,220,54]),function(G,e,E,t,k,R,A,P,w,g,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var u;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(u=e.ConnectionType||(e.ConnectionType={}));function f(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function p(q){const j=new k.CancellationTokenSource;return setTimeout(()=>j.cancel(),q),j.token}function h(q,j){if(q.isCancellationRequested||j.isCancellationRequested)return k.CancellationToken.Cancelled;const M=new k.CancellationTokenSource;return q.onCancellationRequested(()=>M.cancel()),j.onCancellationRequested(()=>M.cancel()),M.token}class l{get didTimeout(){return this.c==="timedout"}constructor(j){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((M,O)=>{this.f=M,this.g=O}),j.isCancellationRequested?this.h():this.d.add(j.onCancellationRequested(()=>this.h()))}registerDisposable(j){this.c==="pending"?this.d.add(j):j.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(j))}reject(j){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(j))}}function v(q,j){const M=new l(j);return M.registerDisposable(q.onControlMessage(O=>{const F=JSON.parse(O.toString()),U=$(F);U?M.reject(U):M.resolve(F)})),M.promise}function C(q,j,M,O,F,U,H,x){const B=new l(x);return j.connect(M,O,F,U,H,(_,Z)=>{B.didTimeout?(_&&q.error(_),Z?.dispose()):_||!Z?B.reject(_):B.resolve(Z)}),B.promise}function I(q,j){const M=new l(j);return q.then(O=>{M.didTimeout||M.resolve(O)},O=>{M.didTimeout||M.reject(O)}),M.promise}async function m(q,j,M,O){const F=z(q,j);q.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let U;try{U=await C(q.logService,q.socketFactory,q.host,q.port,(0,S.getRemoteServerRootPath)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,`renderer-${f(j)}-${q.reconnectionToken}`,O)}catch(Z){throw q.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),q.logService.error(Z),Z}q.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let H,x;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(U,null),H=q.reconnectionProtocol,x=!1):(H=new g.PersistentProtocol(U,null),x=!0),q.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const B=await I(q.signService.createNewMessage((0,w.generateUuid)()),O),_={type:"auth",auth:q.connectionToken||"00000000000000000000",data:B.data};H.sendControl(t.VSBuffer.fromString(JSON.stringify(_)));try{const Z=await v(H,h(O,p(1e4)));if(Z.type!=="sign"||typeof Z.data!="string"){const Oe=new Error("Unexpected handshake message");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}if(q.logService.trace(`${F} 4/6. received SignRequest control message.`),!await I(q.signService.validate(B,Z.signedData),O)){const Oe=new Error("Refused to connect to unsupported server");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}const ge=await I(q.signService.sign(Z.data),O),ke={type:"connectionType",commit:q.commit,signedData:ge,desiredConnectionType:j};return M&&(ke.args=M),q.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(t.VSBuffer.fromString(JSON.stringify(ke))),{protocol:H,ownsProtocol:x}}catch(Z){throw Z&&Z.code==="ETIMEDOUT"&&(q.logService.error(`${F} the handshake timed out. Error:`),q.logService.error(Z)),Z&&Z.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${F} received error control message when negotiating connection. Error:`),q.logService.error(Z)),x&&le(H),Z}}async function i(q,j,M,O){const F=Date.now(),U=z(q,j),{protocol:H,ownsProtocol:x}=await m(q,j,M,O),B=new l(O);return B.registerDisposable(H.onControlMessage(_=>{const Z=JSON.parse(_.toString()),ae=$(Z);ae?(q.logService.error(`${U} received error control message when negotiating connection. Error:`),q.logService.error(ae),x&&le(H),B.reject(ae)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${Q(F)}!`),B.resolve({protocol:H,firstMessage:Z}))})),B.promise}async function n(q,j){const{protocol:M}=await i(q,1,void 0,j);return{protocol:M}}async function r(q,j,M){const{protocol:O,firstMessage:F}=await i(q,2,j,M),U=F&&F.debugPort;return{protocol:O,debugPort:U}}async function a(q,j,M){const O=Date.now(),F=z(q,3),{protocol:U}=await m(q,3,j,M);return q.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${Q(O)}!`),U}async function s(q,j,M){const{host:O,port:F,connectionToken:U}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,host:O,port:F,connectionToken:U,reconnectionToken:j,reconnectionProtocol:M,socketFactory:q.socketFactory,signService:q.signService,logService:q.logService}}async function c(q,j,M){return d(q,async O=>{const{protocol:F}=await n(O,k.CancellationToken.None);return new fe(q,j,M,O.reconnectionToken,F)})}e.connectRemoteAgentManagement=c;async function o(q,j){return d(q,async M=>{const{protocol:O,debugPort:F}=await r(M,j,k.CancellationToken.None);return new J(q,j,M.reconnectionToken,O,F)})}e.connectRemoteAgentExtensionHost=o;async function d(q,j){for(let O=1;;O++)try{const F=(0,w.generateUuid)(),U=await s(q,F,null);return await j(U)}catch(F){if(O<5)q.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(F);else throw q.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(F),re.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(F)),F}}async function D(q,j,M){const O=await s(q,(0,w.generateUuid)(),null);return await a(O,{host:j,port:M},k.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function L(q){return(0,E.createCancelablePromise)(j=>new Promise((M,O)=>{const F=setTimeout(M,q*1e3);j.onCancellationRequested(()=>{clearTimeout(F),M()})}))}var N;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(N=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class V{constructor(j,M){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.type=0}}e.ConnectionLostEvent=V;class oe{constructor(j,M,O,F){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.durationSeconds=O,this.c=F,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=oe;class X{constructor(j,M,O){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=X;class Y{constructor(j,M,O){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.attempt=O,this.type=4}}e.ConnectionGainEvent=Y;class se{constructor(j,M,O,F){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.attempt=O,this.handled=F,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class re extends P.Disposable{static triggerPermanentFailure(j,M,O){this._permanentFailure=!0,this.f=j,this.g=M,this.h=O,this.i.forEach(F=>F.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(j=>j.r())}static debugPauseSocketWriting(){this.i.forEach(j=>j.v())}get k(){return this.c||re._permanentFailure}constructor(j,M,O,F,U){super(),this.m=j,this.n=M,this.reconnectionToken=O,this.protocol=F,this.p=U,this.j=this.B(new A.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new Y(this.reconnectionToken,0,0)),this.B(F.onSocketClose(H=>{const x=T(this.m,this.reconnectionToken,!0);H?H.type===0?(this.n.logService.info(`${x} received socket close event (hadError: ${H.hadError}).`),H.error&&this.n.logService.error(H.error)):(this.n.logService.info(`${x} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this.n.logService.error(H.event)):this.n.logService.info(`${x} received socket close event.`),this.r()})),this.B(F.onSocketTimeout(H=>{const x=T(this.m,this.reconnectionToken,!0);this.n.logService.info(`${x} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this.r()})),re.i.push(this),this.B((0,P.toDisposable)(()=>{const H=re.i.indexOf(this);H>=0&&re.i.splice(H,1)})),this.k&&this.u(re.f,re.g,re.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const j=T(this.m,this.reconnectionToken,!0);this.n.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const F=O<M.length?M[O]:M[M.length-1];try{if(F>0){const H=L(F);this.j.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,H)),this.n.logService.info(`${j} waiting for ${F} seconds before reconnecting...`);try{await H}catch{}}if(this.k){this.n.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this.n.logService.info(`${j} resolving connection...`);const U=await s(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${j} connecting to ${U.host}:${U.port}...`),await this.w(U,p(y)),this.n.logService.info(`${j} reconnected!`),this.j.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(U),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this.n.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(U),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(U)){this.n.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this.n.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(U);continue}if((0,R.isCancellationError)(U)){this.n.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(U);continue}if(U instanceof b.RemoteAuthorityResolverError){this.n.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(U),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,b.RemoteAuthorityResolverError.isHandled(U));break}this.n.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(U),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this.k)}t(j,M,O){this.p?re.triggerPermanentFailure(j,M,O):this.u(j,M,O)}u(j,M,O){this.j.fire(new se(this.reconnectionToken,j,M,O)),le(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=re,re._permanentFailure=!1,re.f=0,re.g=0,re.h=!1,re.i=[];class fe extends re{constructor(j,M,O,F,U){super(1,j,F,U,!0),this.client=this.B(new g.Client(U,{remoteAuthority:M,clientId:O},j.ipcLogger))}async w(j,M){await n(j,M)}}e.ManagementPersistentConnection=fe;class J extends re{constructor(j,M,O,F,U){super(2,j,O,F,!1),this.y=M,this.debugPort=U}async w(j,M){await r(j,this.y,M)}}e.ExtensionHostPersistentConnection=J;function le(q){try{q.acceptDisconnect();const j=q.getSocket();q.dispose(),j.dispose()}catch(j){(0,R.onUnexpectedError)(j)}}function $(q){if(q&&q.type==="error"){const j=new Error(`Connection error: ${q.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function W(q,j){for(;q.length<j;)q+=" ";return q}function T(q,j,M){return`[remote-connection][${W(f(q),13)}][${j.substr(0,5)}\u2026][${M?"reconnect":"initial"}]`}function z(q,j){return`${T(j,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.host}:${q.port}]`}function Q(q){return`${Date.now()-q} ms`}}),define(ie[222],ne([0,1,78,83]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,A,P,w,g){const b=y=>g(y,void 0),S=E.createConnection({host:k,port:R},()=>{S.removeListener("error",b);const y=Buffer.alloc(16);for(let h=0;h<16;h++)y[h]=Math.round(Math.random()*256);const u=y.toString("base64"),f=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${A}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${u}`];S.write(f.join(`\r
`)+`\r
\r
`);const p=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",p),g(void 0,new t.NodeSocket(S,w)))};S.on("data",p)});S.setNoDelay(!0),S.once("error",b)}}}),define(ie[223],ne([0,1,25,46,40,182]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let A;async function P(u=!1){return(A===void 0||u)&&(A=w()),A}e.hasWSLFeatureInstalled=P;async function w(){const u=g();if(u===void 0)return!1;if(u>=22e3){const f=S();if(f)return new Promise(p=>{t.execFile(f,["--status"],h=>p(!h))})}else{const f=y();if(f)try{if((await k.promises.stat(f)).isFile())return!0}catch{}}return!1}function g(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(u)return parseInt(u[3])}function b(u){const f=process.env.SystemRoot;if(f){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(f,p?"Sysnative":"System32",u)}}function S(){return b("wsl.exe")}function y(){return b("lxss\\LxssManager.dll")}}),define(ie[55],ne([0,1,17,166,65,5,48]),function(G,e,E,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function P(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=P;function w(p){return p.res.statusCode===204}async function g(p){return w(p)?null:(await(0,E.streamToBuffer)(p.stream)).toString()}e.asText=g;async function b(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);return g(p)}e.asTextOrError=b;async function S(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);if(w(p))return null;const l=(await(0,E.streamToBuffer)(p.stream)).toString();try{return JSON.parse(l)}catch(v){throw v.message+=`:
`+l,v}}e.asJson=S;function y(p){f(p)}e.updateProxyConfigurationsScope=y;let u;function f(p){const h=A.Registry.as(k.Extensions.Configuration),l=u;u={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[u],remove:l?[l]:[]})}f(2)}),define(ie[224],ne([0,1,17,22]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(P){this.a=P}listen(P,w){throw new Error("Invalid listen")}call(P,w,g,b=t.CancellationToken.None){switch(w){case"request":return this.a.request(g[0],b).then(async({res:S,stream:y})=>{const u=await(0,E.streamToBuffer)(y);return[{statusCode:S.statusCode,headers:S.headers},u]});case"resolveProxy":return this.a.resolveProxy(g[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(P){this.a=P}async request(P,w){const[g,b]=await this.a.call("request",[P],w);return{res:g,stream:(0,E.bufferToStream)(b)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=R}),define(ie[225],ne([0,1,226,11]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(A,P){return A.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:A.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function R(A,P,w={}){const g=(0,E.parse)(A),b=w.proxyUrl||k(g,P);if(!b)return null;const S=(0,E.parse)(b);if(!/^https?:$/.test(S.protocol||""))return null;const y={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,t.isBoolean)(w.strictSSL)?w.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((u,f)=>{G(["http-proxy-agent"],u,f)}))(y):new(await new Promise((u,f)=>{G(["https-proxy-agent"],u,f)}))(y)}e.getProxyAgent=R}),define(ie[111],ne([0,1,46,9,167,22,45,15,4,29,143,61,8]),function(G,e,E,t,k,R,A,P,w,g,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const u=1e4;let f;async function p(l,v,C){return v["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(C)&&!v["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(C)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=y.Promises.withAsyncBody(async(I,m)=>{const i=new R.CancellationTokenSource,n=setTimeout(()=>{i.dispose(!0),m(new Error((0,k.localize)(0,null)))},u);try{I(await h(l,i.token))}catch(r){!(0,P.isCancellationError)(r)&&!i.token.isCancellationRequested?m(new Error((0,k.localize)(1,null,(0,A.toErrorMessage)(r)))):I({})}finally{clearTimeout(n),i.dispose()}})),f)}e.getResolvedShellEnv=p;async function h(l,v){const C=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",C);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",I);const m=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(m+"({.*})"+m),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",n);const r=await(0,b.getSystemShell)(w.OS,n);return l.trace("getUnixShellEnvironment#shell",r),new Promise((a,s)=>{if(v.isCancellationRequested)return s((0,P.canceled)());const c=(0,t.basename)(r);let o,d;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(o=`& '${process.execPath}' ${D} -p '''${m}'' + JSON.stringify(process.env) + ''${m}'''`,d=["-Login","-Command"]):(o=`'${process.execPath}' ${D} -p '"${m}" + JSON.stringify(process.env) + "${m}"'`,c==="tcsh"?d=["-ic"]:d=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),o);const L=(0,E.spawn)(r,[...d,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});v.onCancellationRequested(()=>(L.kill(),s((0,P.canceled)()))),L.on("error",oe=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(oe)),s(oe)});const N=[];L.stdout.on("data",oe=>N.push(oe));const V=[];L.stderr.on("data",oe=>V.push(oe)),L.on("close",(oe,X)=>{const Y=Buffer.concat(N).toString("utf8");l.trace("getUnixShellEnvironment#raw",Y);const se=Buffer.concat(V).toString("utf8");if(se.trim()&&l.trace("getUnixShellEnvironment#stderr",se),oe||X)return s(new Error((0,k.localize)(2,null,oe,X)));const re=i.exec(Y),fe=re?re[1]:"{}";try{const J=JSON.parse(fe);C?J.ELECTRON_RUN_AS_NODE=C:delete J.ELECTRON_RUN_AS_NODE,I?J.ELECTRON_NO_ATTACH_CONSOLE=I:delete J.ELECTRON_NO_ATTACH_CONSOLE,delete J.VSCODE_RESOLVING_ENVIRONMENT,delete J.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",J),a(J)}catch(J){l.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(J)),s(J)}})})}}),define(ie[88],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(ie[227],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.b=new Map}c(){return new Promise((k,R)=>G(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.c(),A=new R.validator;if(A){const P=String(E.a++);return this.b.set(P,A),{id:P,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const A=this.b.get(k.id);if(!A)return!1;this.b.delete(k.id);try{return A.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.c(),A=new R.signer;if(A)return A.sign(k)}catch{}return k}}e.SignService=E,E.a=1}),define(ie[36],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,E.createDecorator)("stateMainService")}),define(ie[21],ne([0,1,13,41,8,3,2,4,33,11,5,6,36,27]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,b.createDecorator)("lifecycleMainService");var f;(function(l){l[l.QUIT=1]="QUIT",l[l.KILL=2]="KILL"})(f=e.ShutdownReason||(e.ShutdownReason={}));var p;(function(l){l[l.Starting=1]="Starting",l[l.Ready=2]="Ready",l[l.AfterWindowOpen=3]="AfterWindowOpen",l[l.Eventually=4]="Eventually"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let h=class It extends A.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(v,C,I){super(),this.v=v,this.w=C,this.y=I,this.c=this.B(new R.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new R.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(It.b),this.j&&this.w.removeItem(It.b)}C(){const v=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.isMacintosh&&this.n===0&&this.D(1))};E.app.addListener("before-quit",v);const C=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!P.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",C),E.app.once("will-quit",I=>{this.L("Lifecycle#app.on(will-quit)"),I.preventDefault(),this.D(1).finally(()=>{this.H(!1),E.app.removeListener("before-quit",v),E.app.removeListener("window-all-closed",C),E.app.quit()})})}D(v){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const C=[];return this.f.fire({reason:v,join(I){C.push(I)}}),this.s=(async()=>{try{await k.Promises.settled(C)}catch(I){this.v.error(I)}try{await this.w.close()}catch(I){this.v.error(I)}})(),this.s}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===v)return;this.L(`lifecycle (main): phase changed (value: ${v})`),this.k=v;const C=this.u.get(this.k);C&&(C.open(),this.u.delete(this.k))}async when(v){if(v<=this.k)return;let C=this.u.get(v);C||(C=new k.Barrier,this.u.set(v,C)),await C.wait()}registerWindow(v){const C=new A.DisposableStore;this.n++,C.add(v.onWillLoad(m=>this.g.fire({window:v,workspace:m.workspace,reason:m.reason})));const I=(0,g.assertIsDefined)(v.win);I.on("close",m=>{const i=v.id;if(this.l.has(i)){this.l.delete(i);return}this.L(`Lifecycle#window.on('close') - window ID ${v.id}`),m.preventDefault(),this.unload(v,1).then(n=>{if(n){this.l.delete(i);return}this.l.add(i),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this.h.fire(v),v.close()})}),I.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.n--,C.dispose(),this.n===0&&(!P.isMacintosh||this.i)&&this.D(1)})}async reload(v,C){await this.unload(v,3)||v.reload(C)}unload(v,C){const I=this.t.get(v.id);if(I)return I;const m=this.F(v,C).finally(()=>{this.t.delete(v.id)});return this.t.set(v.id,m),m}async F(v,C){if(!v.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${v.id}`);const I=this.i?2:C,m=await this.I(v,I);return m?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.G(m)):(await this.J(v,I),!1)}G(v){return v?(this.H(!0),this.i=!1,!0):!1}H(v){this.r&&(this.r(v),this.r=void 0,this.p=void 0)}I(v,C){return new Promise(I=>{const m=this.m++,i=`vscode:ok${m}`,n=`vscode:cancel${m}`;t.validatedIpcMain.once(i,()=>{I(!1)}),t.validatedIpcMain.once(n,()=>{I(!0)}),v.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:n,reason:C})})}J(v,C){return new Promise(I=>{const i=`vscode:reply${this.m++}`;t.validatedIpcMain.once(i,()=>I()),v.send("vscode:onWillUnload",{replyChannel:i,reason:C})})}quit(v){return this.L(`Lifecycle#quit() - begin (willRestart: ${v})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(v&&this.w.setItem(It.b,!0),this.p=new Promise(C=>{this.r=C,this.L("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}L(v){this.y.args["enable-smoke-test-driver"]?this.v.info(v):this.v.trace(v)}async relaunch(v){this.L("Lifecycle#relaunch()");const C=process.argv.slice(1);if(v?.addArgs&&C.push(...v.addArgs),v?.removeArgs)for(const i of v.removeArgs){const n=C.indexOf(i);n>=0&&C.splice(n,1)}const I=()=>{try{if(P.isWindows){const i=(0,w.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.v.error(i)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:C})};E.app.once("quit",I),await this.quit(!0)&&E.app.removeListener("quit",I)}async kill(v){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const C of E.BrowserWindow.getAllWindows())if(C&&!C.isDestroyed()){let I;C.webContents&&!C.webContents.isDestroyed()?I=new Promise(m=>C.once("closed",m)):I=Promise.resolve(),C.destroy(),await I}})()]),E.app.exit(v)}};h.b="lifecycle.quitAndRestart",h=pe([ee(0,S.ILogService),ee(1,y.IStateMainService),ee(2,u.IEnvironmentMainService)],h),e.LifecycleMainService=h}),define(ie[228],ne([0,1,4,3,2,5,21]),function(G,e,E,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let P=class extends k.Disposable{constructor(b){super(),this.a=this.B(new t.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise((S,y)=>{G(["native-keymap"],S,y)});this.c=w(b),E.isCI||b.onDidChangeKeyboardLayout(()=>{this.c=w(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};P=pe([ee(0,A.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function w(g){const b=g.getKeyMap(),S=g.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:S}}}),define(ie[229],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(ie[230],ne([0,1,8,17,11,35,16,6]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class w{constructor(S,y,u){this.f=S,this.g=y,this.h=u,this.a=Object.create(null),this.b="",this.c=new E.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(S){S.fileOperationResult!==1&&this.g.error(S)}}getItem(S,y){const u=this.a[S];return(0,k.isUndefinedOrNull)(u)?y:u}setItem(S,y){this.setItems([{key:S,data:y}])}setItems(S){let y=!1;for(const{key:u,data:f}of S)this.a[u]!==f&&((0,k.isUndefinedOrNull)(f)?(0,k.isUndefined)(this.a[u])||(this.a[u]=void 0,y=!0):(this.a[u]=f,y=!0));y&&this.j()}removeItem(S){(0,k.isUndefined)(this.a[S])||(this.a[S]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const S=JSON.stringify(this.a,null,4);if(S!==this.b)try{await this.h.writeFile(this.f,t.VSBuffer.fromString(S)),this.b=S}catch(y){this.g.error(y)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=w;let g=class{constructor(S,y,u){this.a=new w(S.stateResource,y,u)}async init(){await this.a.init()}getItem(S,y){return this.a.getItem(S,y)}};g=pe([ee(0,R.IEnvironmentService),ee(1,P.ILogService),ee(2,A.IFileService)],g),e.StateService=g}),define(ie[231],ne([0,1,230]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends E.StateService{setItem(R,A){this.a.setItem(R,A)}setItems(R){this.a.setItems(R)}removeItem(R){this.a.removeItem(R)}close(){return this.a.close()}}e.StateMainService=t}),define(ie[89],ne([0,1,4,33,7,29]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(g){if(E.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function P(g,b,S,y,u,f,p,h,l,v){const C=Object.create(null);C["common.machineId"]=p,C.sessionID=(0,R.generateUuid)()+Date.now(),C.commitHash=u,C.version=f,C["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),C["common.platform"]=(0,E.PlatformToString)(E.platform),C["common.nodePlatform"]=t.platform,C["common.nodeArch"]=y,C["common.product"]=v||"desktop",h&&(C["common.msftInternal"]=h);let I=0;const m=Date.now();Object.defineProperties(C,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>I++,enumerable:!0}}),E.isLinuxSnap&&(C["common.snap"]="true");const i=A(S);i&&(C["common.platformDetail"]=i);try{const n=await g.readFile(k.URI.file(l));C["common.source"]=n.value.toString().slice(0,30)}catch{}return C}e.resolveCommonProperties=P;function w(g){const b=t.env.USERDNSDOMAIN;if(!b)return!1;const S=b.toLowerCase();return g.some(y=>S===y)}e.verifyMicrosoftInternalDomain=w}),define(ie[31],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ie[232],ne([0,1,25,8,43,14,9,4,7,81,23,101,84,16,19,31]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const h=new Map;async function l(i,n){const r=`${i}::${n.join(":")}`,a=h.get(r);if(a)return a;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,o=new Map,d=2e4;function D(N,V,oe,X){const Y=V.substring(N.length+1);return t.Promises.withAsyncBody(async se=>{let re;try{re=await b.Promises.readdir(V,{withFileTypes:!0})}catch{se();return}if(X.count>=d){X.count+=re.length,X.maxReached=!0,se();return}let fe=re.length;if(fe===0){se();return}let J=re;X.count+re.length>d&&(X.maxReached=!0,fe=d-X.count,J=re.slice(0,fe)),X.count+=re.length;for(const le of J)if(le.isDirectory()){if(oe.includes(le.name)||await D(N,(0,A.join)(V,le.name),oe,X),--fe===0){se();return}}else{const $=le.name.lastIndexOf(".");if($>=0){const W=le.name.substring($+1);W&&c.set(W,(c.get(W)??0)+1)}for(const W of s)W.relativePathPattern?.test(Y)!==!1&&W.filePattern.test(le.name)&&o.set(W.tag,(o.get(W.tag)??0)+1);if(--fe===0){se();return}}})}const L=t.Promises.withAsyncBody(async N=>{const V={count:0,maxReached:!1};await D(i,i,n,V);const oe=await I(i);N({configFiles:v(o),fileTypes:v(c),fileCount:V.count,maxFilesReached:V.maxReached,launchConfigFiles:oe})});return h.set(r,L),L}e.collectWorkspaceStats=l;function v(i){return Array.from(i.entries(),([n,r])=>({name:n,count:r})).sort((n,r)=>r.count-n.count)}function C(){const i={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.virtualMachineHint.value()*100)}%`},n=E.cpus();return n&&n.length>0&&(i.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),i}e.getMachineInfo=C;async function I(i){try{const n=new Map,r=(0,A.join)(i,".vscode","launch.json"),a=await b.Promises.readFile(r),s=[],c=(0,k.parse)(a.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,k.getNodeType)(c)==="object"&&c.configurations)for(const o of c.configurations){const d=o.type;d&&(n.has(d)?n.set(d,n.get(d)+1):n.set(d,1))}return v(n)}catch{return[]}}e.collectLaunchConfigs=I;let m=class{constructor(n,r){this.c=n,this.d=r}f(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}g(n){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const a=E.cpus();return a&&a.length>0&&r.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),r.push(`Memory (System):  ${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||r.push(`Load (avg):       ${E.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(g.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,S.listProcesses)(n.mainPID),this.k(n)]).then(async a=>{let[s,c]=a,o=this.m(n,s);return r.forEach(d=>{if((0,y.isRemoteDiagnosticError)(d))o+=`
${d.errorMessage}`,c+=`
${d.errorMessage}`;else if(o+=`

Remote: ${d.hostName}`,d.processes&&(o+=`
${this.m(n,d.processes)}`),d.workspaceMetadata){c+=`
|  Remote: ${d.hostName}`;for(const D of Object.keys(d.workspaceMetadata)){const L=d.workspaceMetadata[D];let N=`${L.fileCount} files`;L.maxFilesReached&&(N=`more than ${N}`),c+=`|    Folder (${D}): ${N}`,c+=this.h(L)}}}),{processInfo:o,workspaceInfo:c}})}async getSystemInfo(n,r){const{memory:a,vmHint:s,os:c,cpus:o}=C(),d={os:c,memory:a,cpus:o,vmHint:s,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return P.isWindows||(d.load=`${E.loadavg().map(D=>Math.round(D)).join(", ")}`),P.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(n,r){const a=[];return(0,S.listProcesses)(n.mainPID).then(async s=>(a.push(""),a.push(this.g(n)),a.push(""),a.push(this.m(n,s)),n.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.k(n))),r.forEach(c=>{if((0,y.isRemoteDiagnosticError)(c))a.push(`
${c.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${c.hostName}`),a.push(this.f(c.machineInfo)),c.processes&&a.push(this.m(n,c.processes)),c.workspaceMetadata)for(const o of Object.keys(c.workspaceMetadata)){const d=c.workspaceMetadata[o];let D=`${d.fileCount} files`;d.maxFilesReached&&(D=`more than ${D}`),a.push(`Folder (${o}): ${D}`),a.push(this.h(d))}}),a.push(""),a.push(""),a.join(`
`)))}h(n){const r=[];let s=0;const c=(L,N)=>{const V=` ${L}(${N})`;s+V.length>60?(r.push(o),o="|                 ",s=o.length):s+=V.length,o+=V};let o="|      File types:";const d=10,D=n.fileTypes.length>d?d:n.fileTypes.length;for(let L=0;L<D;L++){const N=n.fileTypes[L];c(N.name,N.count)}if(r.push(o),n.configFiles.length>=0&&(o="|      Conf files:",s=0,n.configFiles.forEach(L=>{c(L.name,L.count)}),r.push(o)),n.launchConfigFiles.length>0){let L="|      Launch Configs:";n.launchConfigFiles.forEach(N=>{L+=N.count>1?` ${N.name}(${N.count})`:` ${N.name}`}),r.push(L)}return r.join(`
`)}j(n){const r=Math.max(...Object.keys(n).map(a=>a.length));return Object.keys(n).map(a=>`${a}:  ${" ".repeat(r-a.length)}  ${n[a]}`).join(`
                  `)}k(n){const r=[],a=[];return n.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(c=>{const o=w.URI.revive(c);if(o.scheme===R.Schemas.file){const d=o.fsPath;a.push(l(d,["node_modules",".git"]).then(D=>{let L=`${D.fileCount} files`;D.maxFilesReached&&(L=`more than ${L}`),r.push(`|    Folder (${(0,A.basename)(d)}): ${L}`),r.push(this.h(D))}).catch(D=>{r.push(`|      Error: Unable to collect workspace stats for folder ${d} (${D.toString()})`)}))}else r.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(n,r){const a=new Map;n.windows.forEach(c=>a.set(c.pid,c.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.n(n.mainPID,a,s,r,0),s.join(`
`)}n(n,r,a,s,c){const o=c===0;let d;o?d=s.pid===n?`${this.d.applicationName} main`:"remote agent":(d=`${"  ".repeat(c)} ${s.name}`,s.name==="window"&&(d=`${d} (${r.get(s.pid)})`));const D=process.platform==="win32"?s.mem:E.totalmem()*(s.mem/100);a.push(`${s.load.toFixed(0).padStart(5," ")}	${(D/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(s.children)&&s.children.forEach(L=>this.n(n,r,a,L,c+1))}async getWorkspaceFileExtensions(n){const r=new Set;for(const{uri:a}of n.folders){const s=w.URI.revive(a);if(s.scheme!==R.Schemas.file)continue;const c=s.fsPath;try{(await l(c,["node_modules",".git"])).fileTypes.forEach(d=>r.add(d.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const a=w.URI.revive(r);if(a.scheme!==R.Schemas.file)continue;const s=a.fsPath;try{const c=await l(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),c.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:o.name,count:o.count})}),c.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:o.name,count:o.count})}),c.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};m=pe([ee(0,p.ITelemetryService),ee(1,f.IProductService)],m),e.DiagnosticsService=m}),define(ie[233],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(R){this.b=R}listen(R,A){throw new Error(`Event not found: ${A}`)}call(R,A,{eventName:P,data:w}){return this.b.forEach(g=>g.log(P,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class t{constructor(R){this.b=R}log(R,A){return this.b.call("log",{eventName:R,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ie[56],ne([0,1,44,11,18,54,89,31]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class w{constructor(c){this.value=c}}e.TrustedTelemetryValue=w;class g{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,o){return Promise.resolve(void 0)}publicLog2(c,o){return this.publicLog(c,o)}publicLogError(c,o){return Promise.resolve(void 0)}publicLogError2(c,o){return this.publicLogError(c,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=g,e.NullTelemetryService=new g;class b{async publicLog(c,o,d){}async publicLogError(c,o,d){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(s,c){return c.onDidChangeConfiguration(o=>{o.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(o.source),configurationKeys:C(o.sourceConfig)})})}e.configurationTelemetry=S;function y(s,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!s.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=y;function u(s,c){return!(c.isBuilt||c.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=u;function f(s){const c=s.getValue(P.TELEMETRY_SETTING_ID),o=s.getValue("telemetry.enableCrashReporter");if(s.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function p(s){const c={},o={},d={};v(s,d);for(let D in d){D=D.length>150?D.substr(D.length-149):D;const L=d[D];typeof L=="number"?o[D]=L:typeof L=="boolean"?o[D]=L?1:0:typeof L=="string"?(L.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${L.length}`),c[D]=L.substring(0,8191)):typeof L<"u"&&L!==null&&(c[D]=L)}return{properties:c,measurements:o}}e.validateTelemetryData=p;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function l(s){if(!s)return"none";const c=(0,R.getRemoteName)(s);return h.has(c)?c:"other"}e.cleanRemoteAuthority=l;function v(s,c,o=0,d){if(!!s)for(const D of Object.getOwnPropertyNames(s)){const L=s[D],N=d?d+D:D;Array.isArray(L)?c[N]=(0,E.safeStringify)(L):L instanceof Date?c[N]=L.toISOString():(0,t.isObject)(L)?o<2?v(L,c,o+1,N+"."):c[N]=(0,E.safeStringify)(L):c[N]=L}}function C(s){if(!s)return[];const c=[];return I(c,"",s),c}function I(s,c,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(d=>I(s,c?`${c}.${d}`:d,o[d])):s.push(c)}function m(s,c){const o=s.msftInternalDomains||[],d=c.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(o)||d}e.isInternalTelemetry=m;function i(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=i;function n(s,c){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let o=s;const d=[];for(const V of c)for(;;){const oe=V.exec(s);if(!oe)break;d.push([oe.index,V.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,L=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(o="";;){const V=L.exec(s);if(!V)break;const oe=d.some(([X,Y])=>V.index<Y&&X<L.lastIndex);!D.test(V[0])&&!oe&&(o+=s.substring(N,V.index)+"<REDACTED: user-file-path>",N=L.lastIndex)}return N<s.length&&(o+=s.substr(N)),o}function r(s){if(!s)return s;const c=s.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of o)if(d.regex.test(c))return`<REDACTED: ${d.label}>`;return s}function a(s,c){return(0,E.cloneAndChange)(s,o=>{if(o instanceof w)return o.value;if(typeof o=="string"){let d=o.replaceAll("%20"," ");d=n(d,c);for(const D of c)d=d.replace(D,"");return d=r(d),d}})}e.cleanData=a}),define(ie[234],ne([0,1,189,56]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,A,P,w,g,b,S){const y={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${A.nameShort})`};if((0,t.supportsTelemetry)(A,P)&&(0,t.getTelemetryLevel)(w)===3){const u=await(0,E.getServiceMachineId)(P,g,b),{machineId:f}=await S.getTelemetryInfo();y["X-Market-User-Id"]=u,y["VSCode-SessionId"]=f||u}return y}e.resolveMarketplaceHeaders=k}),define(ie[235],ne([0,1,15,44,56]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",A="https://mobile.events.data.microsoft.com/ping";async function P(g,b,S){const y=await new Promise((l,v)=>{G(["@microsoft/1ds-core-js"],l,v)}),u=await new Promise((l,v)=>{G(["@microsoft/1ds-post-js"],l,v)}),f=new y.AppInsightsCore,p=new u.PostChannel,h={instrumentationKey:g,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(S){h.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:S};h.extensionConfig[p.identifier]=l}return f.initialize(h,[]),f.addTelemetryInitializer(l=>{b&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),f}class w{constructor(b,S,y,u,f){this.e=b,this.f=S,this.g=y,this.h=f,this.c=R,this.d=A,this.g||(this.g={}),typeof u=="function"?this.a=u():this.a=u,this.b=null}i(b){if(!!this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(S=>{b(S)},S=>{(0,E.onUnexpectedError)(S),console.error(S)})}}log(b,S){if(!this.a)return;S=(0,t.mixin)(S,this.g),S=(0,k.validateTelemetryData)(S);const y=this.f+"/"+b;try{this.i(u=>{u.pluginVersionString=S?.properties.version??"Unknown",u.track({name:y,baseData:{name:y,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(S=>{S.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=w}),define(ie[112],ne([0,1,2,44,4,26,168,18,65,63,19,48,31,56]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(l,v,C){this.k=v,this.l=C,this.d={},this.i=new E.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const I of this.f)this.j.push(new RegExp((0,R.escapeRegExpCharacters)(I),"gi")),I.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.escapeRegExpCharacters)(I.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(l,v){this.d[l]=v}m(){let l=(0,u.getTelemetryLevel)(this.k);const v=this.l.enabledTelemetryLevels;if(v){this.h=this.sendErrorTelemetry?v.error:!1;const C=v.usage?3:v.error?2:0;l=Math.min(l,C)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,v=l.sessionID,C=l["common.machineId"],I=l["common.firstSessionDate"],m=l["common.msftInternal"];return{sessionId:v,machineId:C,firstSessionDate:I,msftInternal:m}}dispose(){this.i.dispose()}n(l,v,C){return this.g<v?Promise.resolve(void 0):this.c.then(I=>{C=(0,t.mixin)(C,this.d),C=(0,u.cleanData)(C,this.j),C=(0,t.mixin)(C,I),this.b.forEach(m=>m.log(l,C))},I=>{console.error(I)})}publicLog(l,v){return this.n(l,3,v)}publicLog2(l,v){return this.publicLog(l,v)}publicLogError(l,v){return this.h?this.n(l,2,v):Promise.resolve(void 0)}publicLogError2(l,v){return this.publicLogError(l,v)}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=pe([ee(1,P.IConfigurationService),ee(2,b.IProductService)],f),e.TelemetryService=f;function p(){const h=(0,A.localize)(0,null,g.default.nameLong),l=g.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=k.isWeb?"":(0,A.localize)(3,null),C=(0,A.localize)(4,null),I=(0,A.localize)(5,null),m=(0,A.localize)(6,null),i=(0,A.localize)(7,null),n=`
|       | ${C} | ${I} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,A.localize)(8,null);return`
${h} ${l} ${v}

&nbsp;

${i}
${n}

&nbsp;

${r}
`}S.Registry.as(w.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(w.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,A.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,A.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[236],ne([0,1,282,235]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends t.AbstractOneDataSystemAppender{constructor(A,P,w,g){const b={sendPOST:(S,y)=>{const u={method:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data)}};try{const f=E.request(S.urlString,u,p=>{p.on("data",function(h){y(p.statusCode??200,p.headers,h.toString())}),p.on("error",function(h){y(0,{})})});f.write(S.data),f.end()}catch{y(0,{})}}};super(A,P,w,g,b)}}e.OneDataSystemAppender=k}),define(ie[237],ne([0,1,4,81,31]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function R(A){let P=A.getItem(k.machineIdKey);return(typeof P!="string"||E.isMacintosh&&P==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(P=await(0,t.getMachineId)()),P}e.resolveMachineId=R}),define(ie[113],ne([0,1,31,237]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function k(R){const A=await(0,t.resolveMachineId)(R);return R.setItem(E.machineIdKey,A),A}e.resolveMachineId=k}),define(ie[238],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var E;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(E=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===E.HIGH_CONTRAST_DARK||R===E.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===E.DARK||R===E.HIGH_CONTRAST_DARK}e.isDark=k}),define(ie[239],ne([0,1,120,3,2,5,48,238]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var w;(function(h){function l(v){return v&&typeof v=="object"&&typeof v.id=="string"}h.isThemeColor=l})(w=e.ThemeColor||(e.ThemeColor={}));function g(h){return{id:h}}e.themeColorFromId=g;var b;(function(h){function l(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||w.isThemeColor(a.color))}h.isThemeIcon=l;const v=new RegExp(`^\\$\\((${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?)\\)$`);function C(a){const s=v.exec(a);if(!s)return;const[,c]=s;return{id:c}}h.fromString=C;function I(a){return{id:a}}h.fromId=I;function m(a,s){let c=a.id;const o=c.lastIndexOf("~");return o!==-1&&(c=c.substring(0,o)),s&&(c=`${c}~${s}`),{id:c}}h.modify=m;function i(a){const s=a.id.lastIndexOf("~");if(s!==-1)return a.id.substring(s+1)}h.getModifier=i;function n(a,s){return a.id===s.id&&a.color?.id===s.color?.id}h.isEqual=n;function r(a,s){return{id:a.id,color:s?g(s):void 0}}h.asThemeIcon=r,h.asClassNameArray=E.CSSIcon.asClassNameArray,h.asClassName=E.CSSIcon.asClassName,h.asCSSSelector=E.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=E.Codicon.file,e.FolderThemeIcon=E.Codicon.folder;function S(h){switch(h){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class y{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,k.toDisposable)(()=>{const v=this.a.indexOf(l);this.a.splice(v,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const u=new y;A.Registry.add(e.Extensions.ThemingContribution,u);function f(h){return u.onColorThemeChange(h)}e.registerThemingParticipant=f;class p extends k.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(v=>this.n(v)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,v){let C=this.h.getColor(l);return C&&v&&(C=v(C,this.h)),C?C.toString():null}}e.Themable=p}),define(ie[66],ne([0,1,13,3,2,4,18,5,36]),function(G,e,E,t,k,R,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const g="#FFFFFF",b="#1E1E1E",S="#000000",y="#FFFFFF",u="theme",f="themeBackground",p="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let h=class extends k.Disposable{constructor(v,C){super(),this.b=v,this.c=C,this.a=this.B(new t.Emitter),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return v.dark?S:y;let C=this.b.getItem(f,null);if(!C)switch(this.b.getItem(u,"vs-dark").split(" ")[0]){case"vs":C=g;break;case"hc-black":C=S;break;case"hc-light":C=y;break;default:C=b}return R.isMacintosh&&C.toUpperCase()===b&&(C="#171717"),C}saveWindowSplash(v,C){this.b.setItems([{key:u,data:C.baseTheme},{key:f,data:C.colorInfo.background},{key:p,data:C}]),typeof v=="number"&&this.f(v,C)}f(v,C){for(const I of E.BrowserWindow.getAllWindows())if(I.id===v){I.setBackgroundColor(C.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(p)}};h=pe([ee(0,w.IStateMainService),ee(1,A.IConfigurationService)],h),e.ThemeMainService=h}),define(ie[114],ne([0,1,3,18,5,6]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var A;(function(p){p.Http="http",p.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function g(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=S;function y(p,h,l,v){if(l===1)return!1;if(l===2&&S(h)){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(C?.length===4&&parseInt(C[1])>=18)return!1}return p<1024}e.isPortPrivileged=y;class u{constructor(h,l,v){this.remoteAddress=h,this.localAddress=l,this.b=v,this.a=new E.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=u;let f=class{constructor(h,l){this.i=h,this.j=l,this.a=new E.Emitter,this.onTunnelOpened=this.a.event,this.b=new E.Emitter,this.onTunnelClosed=this.b.event,this.c=new E.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const h=this.j.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.e=h,h?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.f=h.elevation,this.g=h.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const h=[],l=Array.from(this.d.values());for(const v of l){const C=Array.from(v.values());for(const I of C){const m=await I.value;m&&h.push(m)}}return h}async dispose(){for(const h of this.d.values()){for(const{value:l}of h.values())await l.then(v=>v?.dispose());h.clear()}this.d.clear()}setEnvironmentTunnel(h,l,v,C,I){this.o(h,l,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:l,localAddress:v,privacy:C,protocol:I,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,l){(S(h)||b(h))&&(h=e.LOCALHOST_ADDRESSES[0]);const v=this.q(h,l);if(v)return++v.refcount,v.value}openTunnel(h,l,v,C,I=!1,m,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${v} on local port ${C}.`),!h)return;if(l||(l="localhost"),this.e&&this.h.has(v)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.r(h,l,v,C,I,m,i);return n?n.then(r=>{if(!r){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,v);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(r);return(r.tunnelRemoteHost!==l||r.tunnelRemotePort!==v)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}m(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const l=this.d.get(h.tunnelRemoteHost);if(l){const v=l.get(h.tunnelRemotePort);v&&(v.refcount--,await this.n(h.tunnelRemoteHost,h.tunnelRemotePort,v))}}}}async n(h,l,v){if(v.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${l}.`);const C=v.value.then(async I=>{I&&(await I.dispose(!0),this.b.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this.d.has(h)&&this.d.get(h).delete(l),C}}async closeTunnel(h,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${l} `);const v=this.d.get(h);if(v&&v.has(l)){const C=v.get(l);C.refcount=0,await this.n(h,l,C)}}o(h,l,v){this.d.has(h)||this.d.set(h,new Map),this.d.get(h).set(l,{refcount:1,value:v})}async p(h,l){const v=this.d.get(h);v&&(await v.get(l)||v.delete(l),v.size===0&&this.d.delete(h))}q(h,l){const v=[h];b(h)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):S(h)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const C=v.map(I=>this.d.get(I));for(const I of C){const m=I?.get(l);if(m)return m}}canTunnel(h){return!!g(h)}s(h,l,v,C,I,m,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${v} on local port ${C}.`);const n=v;this.h.add(n);const r=C===void 0?v:C,a={elevationRequired:I?this.isPortPrivileged(r):!1},s={remoteAddress:{host:l,port:v},localAddressPort:C,privacy:m,public:m?m!==P.Private:void 0,protocol:i},c=h.forwardPort(s,a);return c?(this.o(l,v,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(n)})):this.h.delete(n),c}};f=pe([ee(0,R.ILogService),ee(1,t.IConfigurationService)],f),e.AbstractTunnelService=f}),define(ie[240],ne([0,1,78,25,97,222,8,2,18,6,19,221,114,88,4]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(I,m,i,n,r){let a;for(let s=3;s&&(a?.dispose(),a=await new h(I,m,i,n,r).waitForReady(),!(r&&k.BROWSER_RESTRICTED_PORTS[r]||!k.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));s--);return a}class h extends P.Disposable{constructor(m,i,n,r,a){super(),this.j=i,this.k=a,this.privacy=y.TunnelPrivacyId.Private,this.i=new Map,this.a=m,this.b=E.createServer(),this.c=new A.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=r,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const m=this.k??this.tunnelRemotePort,i=(0,y.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let n=await(0,k.findFreePortFaster)(m,2,1e3,i),r=null;return this.b.listen(n,this.j),await this.c.wait(),r=this.b.address(),r||(n=0,this.b.listen(n,this.j),await this.c.wait(),r=this.b.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async l(m){m.pause();const i=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,S.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),r=n.getSocket().socket,a=n.readEntireBuffer();n.dispose(),a.byteLength>0&&m.write(a.buffer),m.on("end",()=>{m.localAddress&&this.i.delete(m.localAddress),r.end()}),m.on("close",()=>r.end()),m.on("error",()=>{m.localAddress&&this.i.delete(m.localAddress),r.destroy()}),r.on("end",()=>m.end()),r.on("close",()=>m.end()),r.on("error",()=>{m.destroy()}),m.pipe(r),r.pipe(m),m.localAddress&&this.i.set(m.localAddress,()=>{m.end(),r.end()})}}let l=class extends y.AbstractTunnelService{constructor(m,i,n,r,a){super(i,a),this.t=m,this.u=n,this.v=r}isPortPrivileged(m){return(0,y.isPortPrivileged)(m,this.k,f.OS,t.release())}r(m,i,n,r,a,s,c){const o=this.q(i,n);if(o)return++o.refcount,o.value;if(this.e)return this.s(this.e,i,n,r,a,s,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${n} on local port ${r}.`);const d={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:m,signService:this.u,logService:this.i,ipcLogger:null},D=p(d,this.k,i,n,r);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,n,D),D}}};l=pe([ee(1,g.ILogService),ee(2,u.ISignService),ee(3,b.IProductService),ee(4,w.IConfigurationService)],l),e.BaseTunnelService=l;let v=class extends l{constructor(m,i,n,r){super(R.nodeSocketFactory,m,i,n,r)}};v=pe([ee(0,g.ILogService),ee(1,u.ISignService),ee(2,b.IProductService),ee(3,w.IConfigurationService)],v),e.TunnelService=v;let C=class extends P.Disposable{constructor(m,i,n,r){super(),this.b=m,this.c=i,this.f=n,this.g=r,this.a=new Map}async openTunnel(m,i,n,r,a,s,c,o){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${r} on local port ${a}.`),!this.a.has(m)){const d=new v(this.b,this.f,this.c,this.g);this.B(d),this.a.set(m,d),d.onTunnelClosed(async()=>{(await d.tunnels).length===0&&(d.dispose(),this.a.delete(m))})}return this.a.get(m).openTunnel(i,n,r,a,s,c,o)}};C=pe([ee(0,g.ILogService),ee(1,b.IProductService),ee(2,u.ISignService),ee(3,w.IConfigurationService)],C),e.SharedTunnelsService=C}),define(ie[49],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,A)=>({type:"idle",updateType:R,error:A}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(ie[241],ne([0,1,4,169,65,48]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ie[242],ne([0,1,3,49]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(P){this.a=P}listen(P,w){switch(w){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${w}`)}call(P,w,g){switch(w){case"checkForUpdates":return this.a.checkForUpdates(g);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(g)}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=k;class R{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new E.Emitter,this.onStateChange=this.a.event,this.b=t.State.Uninitialized,this.c.listen("onStateChange")(w=>this.state=w),this.c.call("_getInitialState").then(w=>this.state=w)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=R}),define(ie[90],ne([0,1,8,22,3,18,27,21,6,19,55,49]),function(G,e,E,t,k,R,A,P,w,g,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(f,p,h){return`${h.updateUrl}/api/update/${f}/${p}/${h.commit}`}e.createUpdateURL=y;let u=class{get state(){return this.b}d(p){this.j.info("update#setState",p.type),this.b=p,this.c.fire(p)}constructor(p,h,l,v,C,I){this.f=p,this.g=h,this.h=l,this.i=v,this.j=C,this.k=I,this.b=S.State.Uninitialized,this.c=new k.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.l(),h=this.m(p);if(!h){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(h),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(S.State.Idle(this.q())),p==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,l=>this.j.error(l))}l(){return(0,R.getMigratedSettingValue)(this.g,"update.mode","update.channel")}m(p){return p==="none"?void 0:this.k.quality}n(p=60*60*1e3){return(0,E.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(p){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(p)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(p){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){return this.a?await this.l()==="none"?!1:(await this.i.request({url:this.a},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(p){}q(){return 1}r(){}};u=pe([ee(0,P.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,A.IEnvironmentMainService),ee(3,b.IRequestService),ee(4,w.ILogService),ee(5,g.IProductService)],u),e.AbstractUpdateService=u}),define(ie[243],ne([0,1,13,53,3,2,18,27,21,6,19,55,31,49,90]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let p=class extends f.AbstractUpdateService{get v(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"error",(l,v)=>v)}get w(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(l,v,C)=>({url:v,version:C,productVersion:C}))}get y(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(l,v,C,I)=>({releaseNotes:v,version:C,productVersion:C,date:I}))}constructor(l,v,C,I,m,i,n){super(l,v,I,m,i,n),this.z=C,this.u=new R.DisposableStore}async initialize(){await super.initialize(),this.v(this.A,this,this.u),this.x(this.D,this,this.u),this.y(this.E,this,this.u),this.w(this.F,this,this.u)}A(l){this.j.error("UpdateService error:",l);const C=(this.state.type==="checking for updates"?this.state.explicit:!0)?l:void 0;this.d(u.State.Idle(1,C))}s(l){let v;this.k.darwinUniversalAssetId?v=this.k.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const C=(0,f.createUpdateURL)(v,l,this.k);try{E.autoUpdater.setFeedURL({url:C})}catch(I){this.j.error("Failed to set update feed URL",I);return}return C}t(l){this.d(u.State.CheckingForUpdates(l)),E.autoUpdater.checkForUpdates()}D(l){this.state.type==="checking for updates"&&this.d(u.State.Downloading(l))}E(l){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:l.version}),this.d(u.State.Ready(l)))}F(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(u.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};pe([t.memoize],p.prototype,"v",null),pe([t.memoize],p.prototype,"w",null),pe([t.memoize],p.prototype,"x",null),pe([t.memoize],p.prototype,"y",null),p=pe([ee(0,w.ILifecycleMainService),ee(1,A.IConfigurationService),ee(2,y.ITelemetryService),ee(3,P.IEnvironmentMainService),ee(4,S.IRequestService),ee(5,g.ILogService),ee(6,b.IProductService)],p),e.DarwinUpdateService=p}),define(ie[244],ne([0,1,46,40,8,3,9,27,21,6,31,49]),function(G,e,E,t,k,R,A,P,w,g,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{get state(){return this.a}d(p){this.g.info("update#setState",p.type),this.a=p,this.b.fire(p)}constructor(p,h,l){if(this.f=p,this.g=l,this.a=S.State.Uninitialized,this.b=new R.Emitter,this.onStateChange=this.b.event,h.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(S.State.Idle(this.k())),this.h(30*1e3).then(void 0,v=>this.g.error(v))}h(p=60*60*1e3){return(0,k.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(p){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(p)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(p){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(p){}};y=pe([ee(0,w.ILifecycleMainService),ee(1,P.IEnvironmentMainService),ee(2,g.ILogService)],y);let u=class extends y{constructor(p,h,l,v,C,I){super(l,v,C),this.o=p,this.p=h,this.q=I;const m=(0,t.watch)(A.dirname(this.o)),i=R.Event.fromNodeEventEmitter(m,"change",(s,c)=>c),n=R.Event.filter(i,s=>s==="current"),a=R.Event.debounce(n,(s,c)=>c,2e3)(()=>this.checkForUpdates(!1));l.onWillShutdown(()=>{a.dispose(),m.close()})}m(){this.d(S.State.CheckingForUpdates(!1)),this.u().then(p=>{p?this.d(S.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(S.State.Idle(2)))},p=>{this.g.error(p),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(S.State.Idle(2,p.message||p))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+A.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const p=await new Promise((l,v)=>(0,t.realpath)(`${A.dirname(this.o)}/current`,(C,I)=>C?v(C):l(I))),h=A.basename(p);return this.p!==h}isLatestVersion(){return this.u().then(void 0,p=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};u=pe([ee(2,w.ILifecycleMainService),ee(3,P.IEnvironmentMainService),ee(4,g.ILogService),ee(5,b.ITelemetryService)],u),e.SnapUpdateService=u}),define(ie[42],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ie[245],ne([0,1,42,190,16,20,126,3,2]),function(G,e,E,t,k,R,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class g{constructor(y){this.uri=y,this.time=g._clock++}touch(){return this.time=g._clock++,this}}g._clock=0;let b=class{constructor(y){this.g=y,this.c=new w.DisposableStore,this.f=2**16;const u=new Map,f=p=>{let h=u.get(p.scheme);return h===void 0&&(h=y.hasProvider(p)&&!this.g.hasCapability(p,1024),u.set(p.scheme,h)),h};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(p=>{u.delete(p.scheme)})),this.extUri=new R.ExtUri(f),this.d=new A.SkipList((p,h)=>this.extUri.compare(p,h,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,R.normalizePath)(y));const u=this.d.get(y);return u?u.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new g(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((f,p)=>f[1].touch<p[1].touch?1:f[1].touch>p[1].touch?-1:0);g._clock=0,this.d.clear();const u=this.f*.5;for(let f=0;f<u;f++)this.d.set(y[f][0],y[f][1].touch())}};b=pe([ee(0,k.IFileService)],b),e.UriIdentityService=b,(0,t.registerSingleton)(E.IUriIdentityService,b,1)}),define(ie[115],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(ie[246],ne([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(P){this.a=P}listen(P,w){throw new Error(`Event not found: ${w}`)}call(P,w,g){switch(w){case"handleURL":return this.a.handleURL(E.URI.revive(g[0]),g[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=t;class k{constructor(P){this.a=P}handleURL(P,w){return this.a.call("handleURL",[P.toJSON(),w])}}e.URLHandlerChannelClient=k;class R{constructor(P){this.a=P}async routeCall(P,w,g,b){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(g){const S=E.URI.revive(g);if(S&&S.query){const y=/\bwindowId=(\d+)/.exec(S.query);if(y){const u=y[1],f=new RegExp(`window:${u}`),p=P.connections.find(h=>f.test(h.ctx));if(p)return p}}}return this.a.routeCall(P,w,g,b)}routeEvent(P,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=R}),define(ie[247],ne([0,1,8,2,7,19]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class A extends t.Disposable{constructor(){super(...arguments),this.a=new Set}open(g,b){const S=[...this.a.values()];return(0,E.first)(S.map(y=>()=>y.handleURL(g,b)),void 0,!1).then(y=>y||!1)}registerHandler(g){return this.a.add(g),(0,t.toDisposable)(()=>this.a.delete(g))}}e.AbstractURLService=A;let P=class extends A{constructor(g){super(),this.b=g}create(g){let{authority:b,path:S,query:y,fragment:u}=g||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&S&&S.indexOf("/")!==0&&(S=`/${S}`),k.URI.from({scheme:this.b.urlProtocol,authority:b,path:S,query:y,fragment:u})}};P=pe([ee(0,R.IProductService)],P),e.NativeURLService=P}),define(ie[248],ne([0,1,13,8,3,2,4,7]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(b){try{return P.URI.parse(b)}catch{return null}}class g{constructor(S,y,u,f,p){if(this.f=y,this.a=[],this.b=0,this.c=R.Disposable.None,this.d=new R.DisposableStore,this.a=S,A.isWindows){const v=f.isBuilt?[]:[`"${f.appRoot}"`];v.push("--open-url","--"),E.app.setAsDefaultProtocolClient(p.urlProtocol,process.execPath,v)}const h=k.Event.map(k.Event.fromNodeEventEmitter(E.app,"open-url",(v,C)=>({event:v,url:C})),({event:v,url:C})=>(v.preventDefault(),C));this.d.add(h(v=>{const C=w(v);!C||this.f.open(C,{originalUrl:v})})),u.getWindows().filter(v=>v.isReady).length>0?this.g():k.Event.once(u.onDidSignalReadyWindow)(this.g,this,this.d)}async g(){if(this.b++>10)return;const S=[];for(const y of this.a)await this.f.open(y.uri,{originalUrl:y.url})||S.push(y);S.length!==0&&(this.a=S,this.c=(0,t.disposableTimeout)(()=>this.g(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=g}),define(ie[249],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(ie[250],ne([0,1,13,2,14,7]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class A extends t.Disposable{constructor(){super();const w=this.b.bind(this);E.protocol.registerFileProtocol(k.Schemas.vscodeWebview,w)}b(w,g){try{const b=R.URI.parse(w.url),S=A.a.get(b.path);if(typeof S=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${S}`,u=k.FileAccess.asFileUri(y);return g({path:decodeURIComponent(u.fsPath),headers:{...k.COI.getHeadersFromQuery(w.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return g({error:-10})}catch{}return g({error:-2})}}e.WebviewProtocolProvider=A,A.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ie[74],ne([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(b){return!!b.workspaceUri}e.isWorkspaceToOpen=t;function k(b){return!!b.folderUri}e.isFolderToOpen=k;function R(b){return!!b.fileUri}e.isFileToOpen=R;function A(b){const S=P(b),y=b.getValue("window.menuBarVisibility");return y==="default"||S==="native"&&y==="compact"||E.isMacintosh&&E.isNative?"classic":y}e.getMenuBarVisibility=A;function P(b){if(E.isWeb)return"custom";const S=b.getValue("window");if(S){if(E.isMacintosh&&S.nativeTabs===!0||E.isMacintosh&&S.nativeFullScreen===!1)return"native";const f=S.titleBarStyle;if(f==="native"||f==="custom")return f}return E.isLinux?"native":"custom"}e.getTitleBarStyle=P;function w(b){if(!E.isWindows||E.isWeb||P(b)==="native")return!1;const S=b.getValue("window.experimental.windowControlsOverlay.enabled");return typeof S=="boolean"?S:!0}e.useWindowControlsOverlay=w;function g(b=0){return Math.pow(1.2,b)}e.zoomLevelToZoomFactor=g}),define(ie[116],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(E=e.LoadReason||(e.LoadReason={}));var t;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=k;var R;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var A;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(A=e.WindowError||(e.WindowError={}))}),define(ie[32],ne([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(ie[251],ne([0,1,13,22,3,68,2,29,71,106,6,19,32]),function(G,e,E,t,k,R,A,P,w,g,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var u;(function(p){p[p.Initial=1]="Initial",p[p.StoredCredentialsUsed=2]="StoredCredentialsUsed",p[p.LoginDialogShown=3]="LoginDialogShown"})(u||(u={}));let f=class extends A.Disposable{constructor(h,l,v,C,I){super(),this.g=h,this.h=l,this.i=v,this.j=C,this.k=I,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=u.Initial,this.f=void 0,this.l()}l(){const h=k.Event.fromNodeEventEmitter(E.app,"login",(l,v,C,I,m)=>({event:l,webContents:v,req:C,authInfo:I,callback:m}));this.B(h(this.m,this))}async m({event:h,authInfo:l,req:v,callback:C}){if(!l.isProxy)return;if(!this.b&&this.c===u.LoginDialogShown&&v.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}h.preventDefault();let I;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),I=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(l);try{I=await this.b}finally{this.b=void 0}}C(I?.username,I?.password)}async n(h){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const l=await this.p(h);if(l)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),l;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(h){this.g.trace("auth#doResolveProxyCredentials - enter",h);const l=String((0,R.hash)({scheme:h.scheme,host:h.host,port:h.port}));let v,C;try{const n=await this.i.getPassword(this.a,l);if(n){const r=JSON.parse(await this.j.decrypt(n));v=r.username,C=r.password}}catch(n){this.g.error(n)}if(this.c!==u.StoredCredentialsUsed&&typeof v=="string"&&typeof C=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=u.StoredCredentialsUsed,{username:v,password:C};const I=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!I){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${I.id} to handle proxy login`);const m={authInfo:h,username:this.f?.username??v,password:this.f?.password??C,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};I.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,m),this.c=u.LoginDialogShown;const i=await new Promise(n=>{const r=async(a,s,c)=>{if(s===m.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${I.id}`),I.win?.webContents.off("ipc-message",r),c){const o={username:c.username,password:c.password};try{if(c.remember){const d=await this.j.encrypt(JSON.stringify(o));await this.i.setPassword(this.a,l,d)}else await this.i.deletePassword(this.a,l)}catch(d){this.g.error(d)}n({username:o.username,password:o.password})}else n(void 0)};I.win?.webContents.on("ipc-message",r)});return this.f=i,i}};f=pe([ee(0,b.ILogService),ee(1,y.IWindowsMainService),ee(2,w.ICredentialsMainService),ee(3,g.IEncryptionMainService),ee(4,S.IProductService)],f),e.ProxyAuthHandler=f}),define(ie[252],ne([0,1,71,6,35,19,32,202]),function(G,e,E,t,k,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let w=class extends P.BaseCredentialsMainService{constructor(b,S,y,u){super(b),this.j=S,this.k=y,this.l=u,this.i=f=>{this.l.sendToFocused("vscode:showCredentialsError",f.message??f)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;const b=await new Promise((S,y)=>{G(["keytar"],S,y)});return await b.findCredentials("test-keytar-loads"),this.f=b,this.f}};w=pe([ee(0,t.ILogService),ee(1,k.INativeEnvironmentService),ee(2,R.IProductService),ee(3,A.IWindowsMainService)],w),e.CredentialsNativeMainService=w}),define(ie[253],ne([0,1,15,2,3,6,21,80,46,283,8,14,44,4,33,13,32]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const l=p.utilityProcess,v=typeof l<"u";let C=class Nt{constructor(n,r,a){this.d=n,this.f=a,this.c=!1,this.b=new Map,r.onWillShutdown(s=>{this.c=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}g(n){const r=this.b.get(n);if(!r)throw new Error("Unknown extension host!");return r}onDynamicStdout(n){return this.g(n).onStdout}onDynamicStderr(n){return this.g(n).onStderr}onDynamicMessage(n){return this.g(n).onMessage}onDynamicError(n){return this.g(n).onError}onDynamicExit(n){return this.g(n).onExit}async canUseUtilityProcess(){return v}async createExtensionHost(n){if(this.c)throw(0,E.canceled)();const r=String(++Nt.a);let a;if(n){if(!v)throw new Error("Cannot use UtilityProcess!");a=new m(r,this.d,this.f)}else a=new I(r,this.d);return this.b.set(r,a),a.onExit(({pid:s,code:c,signal:o})=>{this.d.info(`Extension host with pid ${s} exited with code: ${c}, signal: ${o}.`),setTimeout(()=>{a.dispose(),this.b.delete(r)})}),{id:r}}async start(n,r){if(this.c)throw(0,E.canceled)();return this.g(n).start(r)}async enableInspectPort(n){if(this.c)throw(0,E.canceled)();const r=this.b.get(n);return r?r.enableInspectPort():!1}async kill(n){if(this.c)throw(0,E.canceled)();const r=this.b.get(n);!r||r.kill()}async _killAllNow(){for(const[,n]of this.b)n.kill()}async _waitForAllExit(n){const r=[];for(const[,a]of this.b)r.push(a.waitForExit(n));return b.Promises.settled(r).then(()=>{})}};C.a=0,C=pe([ee(0,R.ILogService),ee(1,A.ILifecycleMainService),ee(2,h.IWindowsMainService)],C),e.ExtensionHostStarter=C;let I=class extends t.Disposable{constructor(n,r){super(),this.id=n,this.c=r,this._onStdout=this.B(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new k.Emitter),this.onError=this._onError.event,this._onExit=this.B(new k.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(n){u.isCI&&this.c.info("Calling fork to start extension host...");const r=P.StopWatch.create(!1);this.a=(0,w.fork)(S.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,f.cwd)()},n));const a=r.elapsed(),s=this.a.pid;this.c.info(`Starting extension host with pid ${s} (fork() took ${a} ms).`);const c=new g.StringDecoder("utf-8");this.a.stdout?.on("data",d=>{const D=typeof d=="string"?d:c.write(d);this._onStdout.fire(D)});const o=new g.StringDecoder("utf-8");this.a.stderr?.on("data",d=>{const D=typeof d=="string"?d:o.write(d);this._onStderr.fire(D)}),this.a.on("message",d=>{this._onMessage.fire(d)}),this.a.on("error",d=>{this._onError.fire({error:(0,E.transformErrorForSerialization)(d)})}),this.a.on("exit",(d,D)=>{this.b=!0,this._onExit.fire({pid:s,code:d,signal:D})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):u.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(n){if(!this.a)return;const r=this.a.pid;this.c.info(`Waiting for extension host with pid ${r} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,b.timeout)(n)]),this.b||(this.c.info(`Extension host with pid ${r} did not exit within ${n}ms.`),this.a.kill())}};I=pe([ee(1,R.ILogService)],I);let m=class extends t.Disposable{constructor(n,r,a){super(),this.id=n,this.c=r,this.f=a,this.onError=k.Event.None,this._onStdout=this.B(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this.B(new k.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(n){const r=this.f.getWindowById(n.responseWindowId);if(!r){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const a=r.win;if(!a||a.isDestroyed()||a.webContents.isDestroyed()){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,c=S.FileAccess.asFileUri("bootstrap-fork.js").fsPath,o=["--type=extensionHost","--skipWorkspaceStorageLock"],d=n.execArgv||[],D={...n.env},L=!0,N="pipe";for(const re of Object.keys(D))D[re]=String(D[re]);this.c.info(`UtilityProcess<${this.id}>: Creating new...`),this.a=l.fork(c,o,{serviceName:s,env:D,execArgv:d,allowLoadingUnsignedLibraries:L,stdio:N});const V=new g.StringDecoder("utf-8");this.a.stdout?.on("data",re=>{const fe=typeof re=="string"?re:V.write(re);this._onStdout.fire(fe)});const oe=new g.StringDecoder("utf-8");this.a.stderr?.on("data",re=>{const fe=typeof re=="string"?re:oe.write(re);this._onStderr.fire(fe)}),this.a.on("message",re=>{this._onMessage.fire(re)}),this.B(k.Event.fromNodeEventEmitter(this.a,"spawn")(()=>{this.c.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const X=k.Event.fromNodeEventEmitter(this.a,"exit",re=>re);this.B(X(re=>{this.c.info(`UtilityProcess<${this.id}>: received exit event with code ${re}.`),this.b=!0,this._onExit.fire({pid:this.a.pid,code:re,signal:""})}));const{port1:Y,port2:se}=new p.MessageChannelMain;this.a.postMessage("null",[se]),a.webContents.postMessage(n.responseChannel,n.responseNonce,[Y])}enableInspectPort(){return this.a?(this.c.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):!1):!1}kill(){!this.a||(this.c.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(n){if(!this.a)return;const r=this.a.pid;this.c.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${r} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,b.timeout)(n)]),this.b||(this.c.info(`UtilityProcess<${this.id}>: Extension host with pid ${r} did not exit within ${n}ms, will kill it now.`),this.a.kill())}};m=pe([ee(1,R.ILogService),ee(2,h.IWindowsMainService)],m)}),define(ie[254],ne([0,1,13,24,4,7,23,18,61,5,6,115,32]),function(G,e,E,t,k,R,A,P,w,g,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,g.createDecorator)(e.ID);let u=class{constructor(p,h,l,v){this.a=p,this.b=h,this.c=l,this.d=v}async start(p,h){this.a.trace("Received data from other instance: ",p,h),k.isMacintosh&&E.app.focus({steal:!0});const l=this.e(p);if(l.length){let v=Promise.resolve();if(this.b.getWindowCount()===0){const C=(0,t.firstOrDefault)(await this.b.openEmptyWindow({context:4}));C&&(v=C.ready())}v.then(()=>{for(const{uri:C,url:I}of l)this.c.open(C,{originalUrl:I})})}else return this.f(p,h)}e(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,t.coalesce)(p._urls.map(h=>{try{return{uri:R.URI.parse(h),url:h}}catch{return null}})):[]}async f(p,h){const l=(0,w.isLaunchedFromCli)(h)?0:4;let v=[];const C=p.wait&&p.waitMarkerFilePath?R.URI.file(p.waitMarkerFilePath):void 0,I=p.remote||void 0,m={context:l,cli:p,userEnv:h,waitMarkerFileURI:C,remoteAuthority:I,forceProfile:p.profile,forceTempProfile:p["profile-temp"]};if(p.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,m);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let i=!1;if(p["new-window"]||p["unity-launch"]||m.forceProfile||m.forceTempProfile)i=!0;else if(p["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!k.isMacintosh}if(i)v=await this.b.open({...m,forceNewWindow:!0,forceEmpty:!0});else{const n=this.b.getLastActiveWindow();n?(this.b.openExistingWindow(n,m),v=[n]):v=await this.b.open({...m,forceEmpty:!0})}}else v=await this.b.open({...m,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(C&&v.length===1&&v[0])return Promise.race([v[0].whenClosedOrLoaded,(0,A.whenDeleted)(C.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};u=pe([ee(0,b.ILogService),ee(1,y.IWindowsMainService),ee(2,S.IURLService),ee(3,P.IConfigurationService)],u),e.LaunchMainService=u}),define(ie[255],ne([0,1,13,3,2,250,32]),function(G,e,E,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends k.Disposable{constructor(g){super(),this.b=g,this.a=this.B(new t.Emitter),this.onFoundInFrame=this.a.event,this.B(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(g,b){let S;if(typeof g.windowId=="number"){const{windowId:y}=g,u=this.b.getWindowById(y);if(!u?.win)throw new Error(`Invalid windowId: ${y}`);S=u.win.webContents}else{const{webContentsId:y}=g;if(S=E.webContents.fromId(y),!S)throw new Error(`Invalid webContentsId: ${y}`)}S.isDestroyed()||S.setIgnoreMenuShortcuts(b)}async findInFrame(g,b,S,y){const f=this.c(g,b);if(typeof f.findInFrame=="function"){f.findInFrame(S,{findNext:y.findNext,forward:y.forward});const p=(h,l)=>{l.finalUpdate&&(this.a.fire(l),f.removeListener("found-in-frame",p))};f.on("found-in-frame",p)}}async stopFindInFrame(g,b,S){const u=this.c(g,b);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(S.keepSelection?"keepSelection":"clearSelection")}c(g,b){const S=this.b.getWindowById(g.windowId);if(!S?.win)throw new Error(`Invalid windowId: ${g}`);const y=S.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===b);if(!y)throw new Error(`Unknown frame: ${b}`);return y}};P=pe([ee(0,A.IWindowsMainService)],P),e.WebviewMainService=P}),define(ie[256],ne([0,1,8,3,2]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:w,getActiveWindowId:g}){super(),this.a=this.B(new k.DisposableStore),t.Event.latch(t.Event.any(P,w))(this.f,this,this.a),this.b=(0,E.createCancelablePromise)(()=>g()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=R}),define(ie[28],ne([0,1,173,9,60,20,7,5,14]),function(G,e,E,t,k,R,A,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function g(n){const r=n;return typeof r?.id=="string"&&A.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=g,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function b(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,t.basename)(n)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const a=n;if(a.configuration)return{id:a.id,configPath:a.configuration};if(a.folders.length===1)return{id:a.id,uri:a.folders[0].uri}}e.toWorkspaceIdentifier=b;function S(n){const r=n;return typeof r?.id=="string"&&A.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=S;function y(n){const r=n;if(r?.uri)return{id:r.id,uri:A.URI.revive(r.uri)};const a=n;if(a?.configPath)return{id:a.id,configPath:A.URI.revive(a.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=y;var u;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(u=e.WorkbenchState||(e.WorkbenchState={}));function f(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=f;function p(n){const r=n;return!!(r&&typeof r=="object"&&A.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=p;class h{constructor(r,a,s,c,o){this.h=r,this.j=s,this.k=c,this.l=o,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class l{constructor(r,a){this.raw=a,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,R.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function v(n){return new l({uri:n,index:0,name:(0,R.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function C(n,r){return R.extUriBiasedIgnorePathCase.isEqualOrParent(n,r.untitledWorkspacesHome)}e.isUntitledWorkspace=C;function I(n){let r;return A.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=I;function m(n,r){return!C(n,r)&&!I(n)}e.isSavedWorkspace=m;function i(n){return(typeof n=="string"?(0,t.extname)(n):(0,R.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ie[57],ne([0,1,13,8,68,34,2,76,4,11,23,150,5,6,28]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let p=class{constructor(l){this.d=l,this.a=new Map,this.b=new Map,this.c=new t.Queue}pickFileFolder(l,v){return this.e({...l,pickFolders:!0,pickFiles:!0,title:(0,S.localize)(0,null)},v)}pickFolder(l,v){return this.e({...l,pickFolders:!0,title:(0,S.localize)(1,null)},v)}pickFile(l,v){return this.e({...l,pickFiles:!0,title:(0,S.localize)(2,null)},v)}pickWorkspace(l,v){const C=(0,S.localize)(3,null),I=(0,R.mnemonicButtonLabel)((0,S.localize)(4,null)),m=f.WORKSPACE_FILTER;return this.e({...l,pickFiles:!0,title:C,filters:m,buttonLabel:I},v)}async e(l,v){const C={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters,defaultPath:l.defaultPath};(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&(C.properties=void 0,l.pickFiles&&l.pickFolders&&(C.properties=["multiSelections","openDirectory","openFile","createDirectory"])),C.properties||(C.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&C.properties.push("treatPackageAsDirectory");const I=await this.showOpenDialog(C,(0,g.withNullAsUndefined)(v||E.BrowserWindow.getFocusedWindow()));if(I&&I.filePaths&&I.filePaths.length>0)return I.filePaths}f(l){if(l){let v=this.b.get(l.id);return v||(v=new t.Queue,this.b.set(l.id,v)),v}else return this.c}showMessageBox(l,v){return this.f(v).queue(async()=>v?E.dialog.showMessageBox(v,l):E.dialog.showMessageBox(l))}async showSaveDialog(l,v){const C=this.i(l,v);if(!C)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(v).queue(async()=>{let I;return v?I=await E.dialog.showSaveDialog(v,l):I=await E.dialog.showSaveDialog(l),I.filePath=this.g(I.filePath),I})}finally{(0,A.dispose)(C)}}g(l){return l&&w.isMacintosh&&(l=(0,P.normalizeNFC)(l)),l}h(l){return l.map(v=>this.g(v))}async showOpenDialog(l,v){l.defaultPath&&(await b.Promises.exists(l.defaultPath)||(l.defaultPath=void 0));const C=this.i(l,v);if(!C)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(v).queue(async()=>{let I;return v?I=await E.dialog.showOpenDialog(v,l):I=await E.dialog.showOpenDialog(l),I.filePaths=this.h(I.filePaths),I})}finally{(0,A.dispose)(C)}}i(l,v){if(!v)return A.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",l);let C=this.a.get(v.id);C||(C=new Set,this.a.set(v.id,C));const I=(0,k.hash)(l);if(!C.has(I))return this.d.trace("[DialogMainService]: new file dialog lock created",l),C.add(I),(0,A.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",l),C?.delete(I),C?.size===0&&this.a.delete(v.id)})}};p=pe([ee(0,u.ILogService)],p),e.DialogMainService=p}),define(ie[257],ne([0,1,3,2,69,28]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class A extends t.Disposable{constructor(w,g){super(),this.f=w,this.g=g,this.b=this.B(new E.Emitter),this.c=new Map,this.h(g.applicationStorage,this.b)}h(w,g){this.B(E.Event.debounce(w.onDidChangeStorage,(b,S)=>(b?b.push(S):b=[S],b),A.a)(b=>{b.length&&g.fire(this.i(b,w))}))}i(w,g){const b=new Map,S=new Set;return w.forEach(y=>{const u=g.get(y.key);typeof u=="string"?b.set(y.key,u):S.add(y.key)}),{changed:Array.from(b.entries()),deleted:Array.from(S.values())}}listen(w,g,b){switch(g){case"onDidChangeStorage":{const S=b.profile?(0,k.revive)(b.profile):void 0;if(!S)return this.b.event;let y=this.c.get(S.id);return y||(y=this.B(new E.Emitter),this.h(this.g.profileStorage(S),y),this.c.set(S.id,y)),y.event}}throw new Error(`Event not found: ${g}`)}async call(w,g,b){const S=b.profile?(0,k.revive)(b.profile):void 0,y=(0,R.reviveIdentifier)(b.workspace),u=await this.j(S,y);switch(g){case"getItems":return Array.from(u.items.entries());case"updateItems":{const f=b;if(f.insert)for(const[p,h]of f.insert)u.set(p,h);f.delete?.forEach(p=>u.delete(p));break}case"isUsed":{const f=b.payload;if(typeof f=="string")return this.g.isUsed(f)}default:throw new Error(`Call not found: ${g}`)}}async j(w,g){let b;g?b=this.g.workspaceStorage(g):w?b=this.g.profileStorage(w):b=this.g.applicationStorage;try{await b.init()}catch(S){this.f.error(`StorageIPC#init: Unable to init ${g?"workspace":w?"profile":"application"} storage due to ${S}`)}return b}}e.StorageDatabaseChannel=A,A.a=100}),define(ie[38],ne([0,1,68,3,2,20,7,170,35,16,5,6,28,39,42,8,29,26,11]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function C(r){const a=r;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&A.URI.isUri(a.location)&&A.URI.isUri(a.globalStorageHome)&&A.URI.isUri(a.settingsResource)&&A.URI.isUri(a.keybindingsResource)&&A.URI.isUri(a.tasksResource)&&A.URI.isUri(a.snippetsHome)&&A.URI.isUri(a.extensionsResource))}e.isUserDataProfile=C,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function I(r,a){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:A.URI.revive(r.location).with({scheme:a}),globalStorageHome:A.URI.revive(r.globalStorageHome).with({scheme:a}),settingsResource:A.URI.revive(r.settingsResource).with({scheme:a}),keybindingsResource:A.URI.revive(r.keybindingsResource).with({scheme:a}),tasksResource:A.URI.revive(r.tasksResource).with({scheme:a}),snippetsHome:A.URI.revive(r.snippetsHome).with({scheme:a}),extensionsResource:A.URI.revive(r.extensionsResource)?.with({scheme:a}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=I;function m(r,a,s,c){return{id:r,name:a,location:s,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,R.joinPath)(s,"globalStorage"),settingsResource:(0,R.joinPath)(s,"settings.json"),keybindingsResource:(0,R.joinPath)(s,"keybindings.json"),tasksResource:(0,R.joinPath)(s,"tasks.json"),snippetsHome:(0,R.joinPath)(s,"snippets"),extensionsResource:(0,R.joinPath)(s,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=m;let i=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(a,s,c,o){super(),this.m=a,this.n=s,this.r=c,this.s=o,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new u.ResourceMap},this.profilesHome=(0,R.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(a){this.f!==a&&(this.t=void 0,this.f=a)}isEnabled(){return this.f}get u(){if(!this.t){const a=[];if(this.f)for(const d of this.H()){if(!d.name||!(0,v.isString)(d.name)||!d.location){this.s.warn("Skipping the invalid stored profile",d.location||d.name);continue}a.push(m((0,R.basename)(d.location),d.name,d.location,{shortName:d.shortName,useDefaultFlags:d.useDefaultFlags}))}let s;const c=new u.ResourceMap,o=m((0,E.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(a.unshift({...o,extensionsResource:this.M()??o.extensionsResource,isDefault:!0}),a.length){const d=this.J();if(d.workspaces)for(const[D,L]of Object.entries(d.workspaces)){const N=A.URI.parse(D),V=A.URI.parse(L),oe=a.find(X=>this.r.extUri.isEqual(X.location,V));oe&&c.set(N,oe)}if(d.emptyWindow){const D=A.URI.parse(d.emptyWindow);s=a.find(L=>this.r.extUri.isEqual(L.location,D))}}this.t={profiles:a,workspaces:c,emptyWindow:s}}return this.t}async createTransientProfile(a){const s="Temp",c=new RegExp(`${(0,l.escapeRegExpCharacters)(s)}\\s(\\d+)`);let o=0;for(const D of this.profiles){const L=c.exec(D.name),N=L?parseInt(L[1]):0;o=N>o?N:o}const d=`${s} ${o+1}`;return this.createProfile((0,E.hash)((0,h.generateUuid)()).toString(16),d,{transient:!0},a)}async createNamedProfile(a,s,c){return this.createProfile((0,E.hash)((0,h.generateUuid)()).toString(16),a,s,c)}async createProfile(a,s,c,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const d=await this.v(a,s,c);return o&&await this.setProfileForWorkspace(o,d),d}async v(a,s,c){if(!(0,v.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.k.get(s);return o||(o=(async()=>{try{const d=this.profiles.find(N=>N.name===s||N.id===a);if(d)return d;const D=m(a,s,(0,R.joinPath)(this.profilesHome,a),c);await this.n.createFolder(D.location);const L=[];return this.h.fire({profile:D,join(N){L.push(N)}}),await p.Promises.settled(L),this.C([D],[],[]),D}finally{this.k.delete(s)}})(),this.k.set(s,o)),o}async updateProfile(a,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(o=>o.id===a.id);if(!c)throw new Error(`Profile '${a.name}' does not exist`);return c=m(c.id,s.name??c.name,c.location,{shortName:s.shortName??c.shortName,transient:s.transient??c.isTransient,useDefaultFlags:s.useDefaultFlags??c.useDefaultFlags}),this.C([],[],[c]),c}async removeProfile(a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(a.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(o=>o.id===a.id);if(!s)throw new Error(`Profile '${a.name}' does not exist`);const c=[];this.i.fire({profile:s,join(o){c.push(o)}});try{await Promise.allSettled(c)}catch(o){this.s.error(o)}s.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const o of[...this.u.workspaces.keys()])s.id===this.u.workspaces.get(o)?.id&&this.u.workspaces.delete(o);this.G(),this.C([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(o){this.s.error(o)}}getOrSetProfileForWorkspace(a,s=this.defaultProfile){if(!this.f)return this.defaultProfile;let c=this.w(a);return c||(c=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(a,c)),c}async setProfileForWorkspace(a,s){this.setProfileForWorkspaceSync(a,s)}setProfileForWorkspaceSync(a,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(o=>o.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);this.F(a,c)}unsetWorkspace(a,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(a,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const a=await this.n.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(s=>s.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.l.profiles.filter(s=>!this.z(s));await Promise.allSettled(a.map(s=>this.removeProfile(s)))}w(a){const s=this.y(a);return A.URI.isUri(s)?this.l.workspaces.get(s)??this.u.workspaces.get(s):this.l.emptyWindow??this.u.emptyWindow}y(a){return(0,y.isSingleFolderWorkspaceIdentifier)(a)?a.uri:(0,y.isWorkspaceIdentifier)(a)?a.configPath:"empty-window"}z(a){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,a.location)||[...this.l.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,a.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,a.location)||[...this.u.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,a.location)))}C(a,s,c){const o=[...this.profiles,...a],d=[];this.l.profiles=[];for(let D of o)D.isDefault||s.some(L=>D.id===L.id)||(D=c.find(L=>D.id===L.id)??D,D.isTransient?this.l.profiles.push(D):d.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.I(d),this.t=void 0,this.D(a,s,c)}D(a,s,c){this.g.fire({added:a,removed:s,updated:c,all:this.profiles})}F(a,s,c){c=s?.isTransient?!0:c,c||this.F(a,void 0,!0);const o=this.y(a),d=c?this.l:this.u;A.URI.isUri(o)?(d.workspaces.delete(o),s&&d.workspaces.set(o,s)):d.emptyWindow=s,c||this.G()}G(){const a={};for(const[c,o]of this.u.workspaces.entries())a[c.toString()]=o.location.toString();const s=this.u.emptyWindow?.location.toString();this.L({workspaces:a,emptyWindow:s}),this.t=void 0}H(){return[]}I(a){throw new Error("not implemented")}J(){return{}}L(a){throw new Error("not implemented")}M(){}};i.b="userDataProfiles",i.c="profileAssociations",i=pe([ee(0,w.IEnvironmentService),ee(1,g.IFileService),ee(2,f.IUriIdentityService),ee(3,S.ILogService)],i),e.UserDataProfilesService=i;class n extends i{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(a){this.a=a}J(){return this.P}L(a){this.P=a}}e.InMemoryUserDataProfilesService=n}),define(ie[91],ne([0,1,8,17,2,3,39,7,110,87,16,5,6,38,42,11,14]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let l=class extends k.Disposable{constructor(m,i,n,r){super(),this.h=m,this.i=i,this.j=n,this.k=r,this.a=this.B(new R.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new R.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new R.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new R.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new A.ResourceMap}scanProfileExtensions(m){return this.l(m)}async addExtensionsToProfile(m,i){const n=[],r=[];try{return await this.l(i,a=>{const s=[];for(const c of a)m.some(([o])=>(0,w.areSameExtensions)(o.identifier,c.identifier)&&o.manifest.version!==c.version)?n.push(c):s.push(c);for(const[c,o]of m)if(!s.some(d=>(0,w.areSameExtensions)(d.identifier,c.identifier)&&d.version===c.manifest.version)){const d={identifier:c.identifier,version:c.manifest.version,location:c.location,metadata:o};r.push(d),s.push(d)}return r.length&&this.a.fire({extensions:r,profileLocation:i}),n.length&&this.c.fire({extensions:n,profileLocation:i}),s}),r.length&&this.b.fire({extensions:r,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),r}catch(a){throw r.length&&this.b.fire({extensions:r,error:a,profileLocation:i}),n.length&&this.f.fire({extensions:n,error:a,profileLocation:i}),a}}async removeExtensionFromProfile(m,i){const n=[];this.c.fire({extensions:n,profileLocation:i});try{await this.l(i,r=>{const a=[];for(const s of r)(0,w.areSameExtensions)(s.identifier,m.identifier)?n.push(s):a.push(s);return n.length&&this.c.fire({extensions:n,profileLocation:i}),a}),n.length&&this.f.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.f.fire({extensions:n,error:r,profileLocation:i}),r}}async l(m,i){return this.s(m).queue(async()=>{let n=[],r;try{const a=await this.h.readFile(m);r=JSON.parse(a.value.toString())}catch(a){if((0,b.toFileOperationResult)(a)!==1)throw a;this.j.extUri.isEqual(m,this.i.defaultProfile.extensionsResource)&&(r=await this.r())}if(r){if(!Array.isArray(r))throw new Error(`Invalid extensions content in ${m.toString()}`);let a=!1;for(const s of r){if(!v(s))throw new Error(`Invalid extensions content in ${m.toString()}`);let c;if((0,p.isString)(s.location))c=this.n(m,s.location);else{c=P.URI.revive(s.location);const o=this.m(m,c);o&&(a=!0,s.location=o)}n.push({identifier:s.identifier,location:c,version:s.version,metadata:s.metadata})}a&&await this.h.writeFile(m,t.VSBuffer.fromString(JSON.stringify(r)))}if(i){n=i(n);const a=n.map(s=>({identifier:s.identifier,version:s.version,location:this.m(m,s.location)??s.location.toJSON(),metadata:s.metadata}));await this.h.writeFile(m,t.VSBuffer.fromString(JSON.stringify(a)))}return n})}m(m,i){const n=this.j.extUri.dirname(m).with({scheme:h.Schemas.file});if(this.j.extUri.isEqualOrParent(i,n))return this.j.extUri.relativePath(n,i)}n(m,i){return this.j.extUri.joinPath(this.j.extUri.dirname(m),i).with({scheme:h.Schemas.file})}async r(){return this.p||(this.p=(async()=>{const m=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let i;try{i=(await this.h.readFile(m)).value.toString()}catch(r){if((0,b.toFileOperationResult)(r)===1)return;throw r}this.k.info("Migrating extensions from old default profile location",m.toString());let n;try{const r=JSON.parse(i);Array.isArray(r)&&r.every(a=>v(a))?n=r:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",r)}catch(r){this.k.error(r)}if(n)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,t.VSBuffer.fromString(JSON.stringify(n)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",m.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(r){if((0,b.toFileOperationResult)(r)===3)this.k.info("Migration from old default profile location to new location is done by another window",m.toString(),this.i.defaultProfile.extensionsResource.toString());else throw r}try{await this.h.del(m)}catch(r){(0,b.toFileOperationResult)(r)!==1&&this.k.error(r)}return n})()),this.p}s(m){let i=this.g.get(m);return i||(i=new E.Queue,this.g.set(m,i)),i}};l=pe([ee(0,b.IFileService),ee(1,u.IUserDataProfilesService),ee(2,f.IUriIdentityService),ee(3,y.ILogService)],l),e.ExtensionsProfileScannerService=l;function v(I){return(0,p.isObject)(I)&&(0,g.isIExtensionIdentifier)(I.identifier)&&(C(I.location)||(0,p.isString)(I.location))&&I.version&&(0,p.isString)(I.version)}function C(I){return I?(0,p.isString)(I.path)&&(0,p.isString)(I.scheme):!1}}),define(ie[117],ne([0,1,24,8,44,17,15,43,136,2,14,9,4,20,188,98,11,7,155,35,110,87,187,16,5,6,19,3,69,91,38,42,185,186]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v,C,I,m,i,n,r,a,s,c,o,d,D,L,N,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var oe;(function(le){function $(W,T){if(W===T)return!0;const z=Object.keys(W),Q=new Set;for(const q of Object.keys(T))Q.add(q);if(z.length!==Q.size)return!1;for(const q of z){if(W[q]!==T[q])return!1;Q.delete(q)}return Q.size===0}le.equals=$})(oe=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,r.createDecorator)("IExtensionsScannerService");let X=class extends g.Disposable{constructor($,W,T,z,Q,q,j,M,O,F,U,H){super(),this.systemExtensionsLocation=$,this.userExtensionsLocation=W,this.l=T,this.m=z,this.n=Q,this.p=q,this.r=j,this.s=M,this.t=O,this.u=F,this.v=U,this.w=H,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,u.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(re,(0,u.joinPath)(this.m,m.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(re,(0,u.joinPath)(this.m,m.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(se,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,I.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions($,W,T){const[z,Q]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(W)]),q=T?await this.scanExtensionsUnderDevelopment($,[...z,...Q]):[];return this.D(z,Q,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const W=[];W.push(this.F(!!$.useCache,$.language)),W.push(this.G($.language,!!$.checkControlFile));const[T,z]=await Promise.all(W);return this.C([...T,...z],0,$,!1)}async scanUserExtensions($){const W=$.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",W);const T=await this.I(W,!!$.profileLocation,1,!$.includeUninstalled,$.language);let Q=await($.useCache&&!T.devMode&&T.excludeObsolete?this.j:this.k).scanExtensions(T);return Q=await this.C(Q,1,$,!0),this.s.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment($,W){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const T=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(z=>z.scheme===b.Schemas.file).map(async z=>{const Q=await this.I(z,!1,1,!0,$.language,!1);return(await this.k.scanOneOrMultipleExtensions(Q)).map(j=>(j.type=W.find(M=>(0,I.areSameExtensions)(M.identifier,j.identifier))?.type??j.type,this.k.validate(j,Q)))}))).flat();return this.C(T,"development",$,!0)}return[]}async scanExistingExtension($,W,T){const z=await this.I($,!1,W,!0,T.language),Q=await this.k.scanExtension(z);return!Q||!T.includeInvalid&&!Q.isValid?null:Q}async scanOneOrMultipleExtensions($,W,T){const z=await this.I($,!1,W,!0,T.language),Q=await this.k.scanOneOrMultipleExtensions(z);return this.C(Q,W,T,!0)}async scanMetadata($){const W=(0,u.joinPath)($,"package.json"),T=(await this.r.readFile(W)).value.toString();return JSON.parse(T).__metadata}async updateMetadata($,W){const T=(0,u.joinPath)($,"package.json"),z=(await this.r.readFile(T)).value.toString(),Q=JSON.parse(z);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,Q.__metadata={...Q.__metadata,...W},await this.r.writeFile((0,u.joinPath)($,"package.json"),R.VSBuffer.fromString(JSON.stringify(Q,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const $=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists($))return;let W=(await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource)).length>0;W||(W=await this.r.exists(this.n.defaultProfile.extensionsResource));const T=this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json");let z=(await this.p.scanProfileExtensions(T)).length>0;if(z||(z=await this.r.exists(T)),!W&&!z){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Q=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(Q.map(q=>[q,q.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile($,R.VSBuffer.fromString(""))}catch(Q){(0,n.toFileOperationResult)(Q)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.getErrorMessage)(Q))}}catch($){throw this.s.error($),$}})()),this.z}async C($,W,T,z){return T.includeAllVersions||($=this.D(W===0?$:void 0,W===1?$:void 0,W==="development"?$:void 0,await this.getTargetPlatform(),z)),T.includeInvalid||($=$.filter(Q=>Q.isValid)),$.sort((Q,q)=>{const j=S.basename(Q.location.fsPath),M=S.basename(q.location.fsPath);return j<M?-1:j>M?1:0})}D($,W,T,z,Q){const q=(M,O,F)=>{if(M.isValid&&!O.isValid)return!1;if(M.isValid===O.isValid){if(Q&&f.gt(M.manifest.version,O.manifest.version))return this.s.debug(`Skipping extension ${O.location.path} with lower version ${O.manifest.version} in favour of ${M.location.path} with version ${M.manifest.version}`),!1;if(f.eq(M.manifest.version,O.manifest.version)){if(M.type===0)return this.s.debug(`Skipping extension ${O.location.path} in favour of system extension ${M.location.path} with same version`),!1;if(M.targetPlatform===z)return this.s.debug(`Skipping extension ${O.location.path} from different target platform ${O.targetPlatform}`),!1}}return F?this.s.warn(`Overwriting user extension ${M.location.path} with ${O.location.path}.`):this.s.debug(`Overwriting user extension ${M.location.path} with ${O.location.path}.`),!0},j=new Map;return $?.forEach(M=>{const O=m.ExtensionIdentifier.toKey(M.identifier.id),F=j.get(O);(!F||q(F,M,!1))&&j.set(O,M)}),W?.forEach(M=>{const O=m.ExtensionIdentifier.toKey(M.identifier.id),F=j.get(O);if(!F&&$&&M.type===0){this.s.debug(`Skipping obsolete system extension ${M.location.path}.`);return}(!F||q(F,M,!1))&&j.set(O,M)}),T?.forEach(M=>{const O=m.ExtensionIdentifier.toKey(M.identifier.id),F=j.get(O);(!F||q(F,M,!0))&&j.set(O,M),j.set(O,M)}),[...j.values()]}async F($,W){this.s.trace("Started scanning system extensions");const T=await this.I(this.systemExtensionsLocation,!1,0,!0,W),Q=await($&&!T.devMode?this.i:this.k).scanExtensions(T);return this.s.trace("Scanned system extensions:",Q.length),Q}async G($,W){const T=this.t.isBuilt?[]:this.u.builtInExtensions;if(!T?.length)return[];this.s.trace("Started scanning dev system extensions");const z=W?await this.H():{},Q=[],q=l.URI.file(S.normalize(S.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const M of T){const O=z[M.name]||"marketplace";switch(O){case"disabled":break;case"marketplace":Q.push((0,u.joinPath)(q,M.name));break;default:Q.push(l.URI.file(O));break}}const j=await Promise.all(Q.map(async M=>this.k.scanExtension(await this.I(M,!1,0,!0,$))));return this.s.trace("Scanned dev system extensions:",j.length),(0,E.coalesce)(j)}async H(){try{const $=await this.r.readFile(this.l);return JSON.parse($.value.toString())}catch{return{}}}async I($,W,T,z,Q,q=!0){const j=await this.f(Q??y.language),M=await this.J($),O=W&&!this.v.extUri.isEqual($,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,F=O?await this.J(O):void 0;return new Y($,M,O,F,W,T,z,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Q,j)}async J($){try{const W=await this.r.stat($);if(typeof W.mtime=="number")return W.mtime}catch{}}};X=pe([ee(4,D.IUserDataProfilesService),ee(5,d.IExtensionsProfileScannerService),ee(6,n.IFileService),ee(7,a.ILogService),ee(8,C.IEnvironmentService),ee(9,s.IProductService),ee(10,L.IUriIdentityService),ee(11,r.IInstantiationService)],X),e.AbstractExtensionsScannerService=X;class Y{constructor($,W,T,z,Q,q,j,M,O,F,U,H,x,B){this.location=$,this.mtime=W,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=z,this.profile=Q,this.type=q,this.excludeObsolete=j,this.validate=M,this.productVersion=O,this.productDate=F,this.productCommit=U,this.devMode=H,this.language=x,this.translations=B}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,W){return(0,u.isEqual)($.location,W.location)&&$.mtime===W.mtime&&(0,u.isEqual)($.applicationExtensionslocation,W.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&$.profile===W.profile&&$.type===W.type&&$.excludeObsolete===W.excludeObsolete&&$.validate===W.validate&&$.productVersion===W.productVersion&&$.productDate===W.productDate&&$.productCommit===W.productCommit&&$.devMode===W.devMode&&$.language===W.language&&oe.equals($.translations,W.translations)}}let se=class extends g.Disposable{constructor($,W,T,z,Q){super(),this.f=$,this.g=W,this.h=T,this.i=z,this.j=Q}async scanExtensions($){const W=$.profile?await this.l($):await this.k($);let T={};if($.excludeObsolete&&$.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();T=JSON.parse(z)}catch{}return(0,h.isEmptyObject)(T)?W:W.filter(z=>!T[I.ExtensionKey.create(z).toString()])}async k($){const W=await this.i.resolve($.location);if(!W.children?.length)return[];const T=await Promise.all(W.children.map(async z=>{if(!z.isDirectory||$.type===1&&(0,u.basename)(z.resource).indexOf(".")===0)return null;const Q=new Y(z.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(Q)}));return(0,E.coalesce)(T).sort((z,Q)=>z.location.path<Q.location.path?-1:1)}async l($){let W=await this.m($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.h.extUri.isEqual($.location,$.applicationExtensionslocation)){W=W.filter(z=>!z.metadata?.isApplicationScoped);const T=await this.m($.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,$);W.push(...T)}return W}async m($,W,T){const z=await this.g.scanProfileExtensions($);if(!z.length)return[];const Q=await Promise.all(z.map(async q=>{if(W(q)){const j=new Y(q.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(j,q.metadata)}return null}));return(0,E.coalesce)(Q)}async scanOneOrMultipleExtensions($){try{if(await this.i.exists((0,u.joinPath)($.location,"package.json"))){const W=await this.scanExtension($);return W?[W]:[]}else return await this.scanExtensions($)}catch(W){return this.j.error(`Error scanning extensions at ${$.location.path}:`,(0,A.getErrorMessage)(W)),[]}}async scanExtension($,W){try{let T=await this.scanExtensionManifest($.location);if(T){T.publisher||(T.publisher=m.UNDEFINED_PUBLISHER),W=W??T.__metadata,delete T.__metadata;const z=(0,I.getGalleryExtensionId)(T.publisher,T.name),Q=W?.id?{id:z,uuid:W.id}:{id:z},q=W?.isSystem?0:$.type,j=q===0||!!W?.isBuiltin;V.ImplicitActivationEvents.updateManifest(T),T=await this.n($.location,T,Y.createNlsConfiguration($));const M={type:q,identifier:Q,manifest:T,location:$.location,isBuiltin:j,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return $.validate?this.validate(M,$):M}}catch(T){$.type!==0&&this.j.error(T)}return null}validate($,W){let T=!0;const z=(0,i.validateExtensionManifest)(W.productVersion,W.productDate,W.location,$.manifest,$.isBuiltin);for(const[Q,q]of z)Q===p.default.Error&&(T=!1,this.j.error(this.t(W.location,q)));return $.isValid=T,$.validations=z,$}async scanExtensionManifest($){const W=(0,u.joinPath)($,"package.json");let T;try{T=(await this.i.readFile(W)).value.toString()}catch(Q){return(0,n.toFileOperationResult)(Q)!==1&&this.j.error(this.t($,(0,v.localize)(0,null,W.path,Q.message))),null}let z;try{z=JSON.parse(T)}catch{const q=[];(0,P.parse)(T,q);for(const j of q)this.j.error(this.t($,(0,v.localize)(1,null,W.path,j.offset,j.length,(0,w.getParseErrorMessage)(j.error))));return null}return(0,P.getNodeType)(z)!=="object"?(this.j.error(this.t($,(0,v.localize)(2,null,W.path))),null):z}async n($,W,T){const z=await this.p($,W,T);if(z)try{const Q=[],q=await this.r(z.default,Q);if(Q.length>0)return Q.forEach(M=>{this.j.error(this.t($,(0,v.localize)(3,null,z.default?.path,(0,w.getParseErrorMessage)(M.error))))}),W;if((0,P.getNodeType)(z)!=="object")return this.j.error(this.t($,(0,v.localize)(4,null,z.default?.path))),W;const j=z.values||Object.create(null);return(0,N.localizeManifest)(W,j,q)}catch{}return W}async p($,W,T){const z=(0,u.joinPath)($,"package.nls.json"),Q=(O,F)=>{F.forEach(U=>{this.j.error(this.t($,(0,v.localize)(5,null,O?.path,(0,w.getParseErrorMessage)(U.error))))})},q=O=>{this.j.error(this.t($,(0,v.localize)(6,null,O?.path)))},j=`${W.publisher}.${W.name}`,M=T.translations[j];if(M)try{const O=l.URI.file(M),F=(await this.i.readFile(O)).value.toString(),U=[],H=(0,P.parse)(F,U);return U.length>0?(Q(O,U),{values:void 0,default:z}):(0,P.getNodeType)(H)!=="object"?(q(O),{values:void 0,default:z}):{values:H.contents?H.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let F;try{F=await this.s($,T)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const U=(await this.i.readFile(F.localized)).value.toString(),H=[],x=(0,P.parse)(U,H);return H.length>0?(Q(F.localized,H),{values:void 0,default:F.original}):(0,P.getNodeType)(x)!=="object"?(q(F.localized),{values:void 0,default:F.original}):{values:x,default:F.original}}catch{return{values:void 0,default:F.original}}}}async r($,W){if($)try{const T=(await this.i.readFile($)).value.toString();return(0,P.parse)(T,W)}catch{}}s($,W){return new Promise((T,z)=>{const Q=q=>{const j=(0,u.joinPath)($,`package.nls.${q}.json`);this.i.exists(j).then(M=>{M&&T({localized:j,original:(0,u.joinPath)($,"package.nls.json")});const O=q.lastIndexOf("-");O===-1?T({localized:(0,u.joinPath)($,"package.nls.json"),original:null}):(q=q.substring(0,O),Q(q))})};if(W.devMode||W.pseudo||!W.language)return T({localized:(0,u.joinPath)($,"package.nls.json"),original:null});Q(W.language)})}t($,W){return`[${$.path}]: ${W}`}};se=pe([ee(1,d.IExtensionsProfileScannerService),ee(2,L.IUriIdentityService),ee(3,n.IFileService),ee(4,a.ILogService)],se);let re=class extends se{constructor($,W,T,z,Q,q){super(W,T,z,Q,q),this.y=$,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions($){const W=await this.z();if(this.u=$,W&&W.input&&Y.equals(W.input,this.u))return this.v.trigger(()=>this.D()),W.result.map(z=>(z.location=l.URI.revive(z.location),z));const T=await super.scanExtensions($);return await this.C({input:$,result:T}),T}async z(){try{const $=await this.i.readFile(this.y),W=JSON.parse($.value.toString());return{result:W.result,input:(0,o.revive)(W.input)}}catch($){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,A.getErrorMessage)($))}return null}async C($){try{await this.i.writeFile(this.y,R.VSBuffer.fromString(JSON.stringify($)))}catch(W){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,A.getErrorMessage)(W))}}async D(){if(!this.u)return;const $=await this.z();if(!$)return;const W=$.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(T,W))try{await this.i.del(this.y),this.w.fire()}catch(z){this.j.error(z)}}};re=pe([ee(2,d.IExtensionsProfileScannerService),ee(3,L.IUriIdentityService),ee(4,n.IFileService),ee(5,a.ILogService)],re);function fe(le,$){const W=(0,I.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:W,identifier:new m.ExtensionIdentifier(W),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:$,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}e.toExtensionDescription=fe;class J extends X{constructor($,W,T,z,Q,q,j,M,O,F,U,H){super($,W,(0,u.joinPath)(T,".vscode-oss-dev","extensions","control.json"),(0,u.joinPath)(z,m.MANIFEST_CACHE_FOLDER),Q,q,j,M,O,F,U,H),this.L=(async()=>{if(y.translationsConfigFile)try{const x=await this.r.readFile(l.URI.file(y.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f($){return this.L}}e.NativeExtensionsScannerService=J}),define(ie[258],ne([0,1,7,35,91,117,16,5,6,19,42,38]),function(G,e,E,t,k,R,A,P,w,g,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends R.NativeExtensionsScannerService{constructor(f,p,h,l,v,C,I,m){super(E.URI.file(v.builtinExtensionsPath),E.URI.file(v.extensionsPath),v.userHome,E.URI.file(v.userDataPath),f,p,h,l,v,C,I,m)}};y=pe([ee(0,S.IUserDataProfilesService),ee(1,k.IExtensionsProfileScannerService),ee(2,A.IFileService),ee(3,w.ILogService),ee(4,t.INativeEnvironmentService),ee(5,g.IProductService),ee(6,b.IUriIdentityService),ee(7,P.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(ie[259],ne([0,1,13,2,14,9,4,60,7,29,41,35,6,38]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let f=class extends t.Disposable{constructor(h,l,v){super(),this.c=h,this.f=v,this.a=P.TernarySearchTree.forPaths(!A.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(h.appRoot),this.addValidFileRoot(h.extensionsPath),this.addValidFileRoot(l.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(h.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:h}=E.session;h.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(l,v)=>this.i(l,v)),h.protocol.interceptFileProtocol(k.Schemas.file,(l,v)=>this.h(l,v)),this.B((0,t.toDisposable)(()=>{h.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),h.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(h){const l=(0,R.normalize)(h);return this.a.get(l)?t.Disposable.None:(this.a.set(l,!0),(0,t.toDisposable)(()=>this.a.delete(l)))}h(h,l){const v=w.URI.parse(h.url);return this.f.error(`Refused to load resource ${v.fsPath} from ${k.Schemas.file}: protocol (original URL: ${h.url})`),l({error:-3})}i(h,l){const v=this.j(h);let C;return this.c.crossOriginIsolated&&((0,R.basename)(v)==="workbench.html"||(0,R.basename)(v)==="workbench-dev.html"?C=k.COI.CoopAndCoep:C=k.COI.getHeadersFromQuery(h.url)),this.a.findSubstr(v)?l({path:v,headers:C}):this.b.has((0,R.extname)(v).toLowerCase())?l({path:v}):(this.f.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${v} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${h.url})`),l({error:-3}))}j(h){const l=w.URI.parse(h.url),v=k.FileAccess.uriToFileUri(l);return(0,R.normalize)(v.fsPath)}createIPCObjectUrl(){let h;const l=w.URI.from({scheme:"vscode",path:(0,g.generateUuid)()}),v=l.toString(),C=async()=>h;return b.validatedIpcMain.handle(v,C),this.f.trace(`IPC Object URL: Registered new channel ${v}.`),{resource:l,update:I=>h=I,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${v}.`),b.validatedIpcMain.removeHandler(v)}}}};f=pe([ee(0,S.INativeEnvironmentService),ee(1,u.IUserDataProfilesService),ee(2,y.ILogService)],f),e.ProtocolMainService=f}),define(ie[260],ne([0,1,13,41,8,3,2,14,11,103,27,21,6,63,64,66,45,38,37]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let C=class extends A.Disposable{constructor(m,i,n,r,a,s,c,o,d){super(),this.g=m,this.h=i,this.i=n,this.j=r,this.k=a,this.l=s,this.m=c,this.n=o,this.p=d,this.a=new k.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new R.Emitter),this.onDidError=R.Event.buffer(this.f.event),this.w=void 0,this.y=void 0,this.r()}r(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(m,i)=>this.s(m,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(m,i)=>this.t(m,i)),this.B(this.k.onWillShutdown(()=>this.u()))}async s(m,i){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const n=await this.connect();if(m.sender.isDestroyed())return n.close();m.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[n])}t(m,i){this.l.trace("SharedProcess: onWorkerConnection",i);const n=new A.DisposableStore,r=s=>{!this.F()||(this.l.trace(`SharedProcess: disposing worker (reason: '${s}')`,i),n.dispose(),this.v("vscode:electron-main->shared-process=disposeWorker",i))},a=E.BrowserWindow.fromId(i.reply.windowId);if(!a||a.isDestroyed()||a.webContents.isDestroyed()||!i.reply.channel){r("unavailable");return}n.add(R.Event.filter(this.k.onWillLoadWindow,s=>s.window.win===a)(()=>r("load"))),n.add(R.Event.fromNodeEventEmitter(a,"closed")(()=>r("closed"))),a.webContents.postMessage(i.reply.channel,i.reply.nonce,m.ports)}u(){const m=this.b;!m||(this.v("vscode:electron-main->shared-process=exit"),this.c&&(m.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{m.close()}catch{}this.b=void 0},0))}v(m,...i){if(!this.F()){this.l.warn(`Sending IPC message to channel '${m}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(m,...i)}catch(n){this.l.warn(`Error sending IPC message to channel '${m}' of shared process: ${(0,h.toErrorMessage)(n)}`)}}whenReady(){return this.w||(this.w=new Promise(m=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),m()}))),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C(),this.D(),await new Promise(m=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),m()}))})()),this.y}C(){const m=this.B(this.p.createIPCObjectUrl());this.b=new E.BrowserWindow({show:!1,backgroundColor:this.n.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${m.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),m.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),product:u.default,policiesData:this.m.serialize()}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}D(){!this.b||(this.c=m=>{this.l.trace("SharedProcess#close prevented"),m.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(m,i)=>this.f.fire({type:2,details:i})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(m,i,n)=>this.f.fire({type:3,details:{reason:n,exitCode:i}})))}async connect(){await this.z;const m=(0,w.assertIsDefined)(this.b);return(0,g.connect)(m)}async toggle(){await this.z,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}F(){const m=this.b;return m?!m.isDestroyed()&&!m.webContents.isDestroyed():!1}};C=pe([ee(2,b.IEnvironmentMainService),ee(3,l.IUserDataProfilesService),ee(4,S.ILifecycleMainService),ee(5,y.ILogService),ee(6,v.IPolicyService),ee(7,p.IThemeMainService),ee(8,f.IProtocolMainService)],C),e.SharedProcess=C}),define(ie[92],ne([0,1,8,3,2,73,11,104,5,38]),function(G,e,E,t,k,R,A,P,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,w.createDecorator)("storageService");var b;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var y;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));function u(v){const C=v.get(e.TARGET_KEY);if(C)try{return JSON.parse(C)}catch{}return Object.create(null)}e.loadKeyTargets=u;class f extends k.Disposable{constructor(C={flushInterval:f.a}){super(),this.j=C,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.J()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(C,I){if(I===e.TARGET_KEY){switch(C){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:C})}else this.b.fire({scope:C,key:I,target:this.F(C)[I]})}r(C){this.f.fire({reason:C})}get(C,I,m){return this.L(I)?.get(C,m)}getBoolean(C,I,m){return this.L(I)?.getBoolean(C,m)}getNumber(C,I,m){return this.L(I)?.getNumber(C,m)}store(C,I,m,i){if((0,A.isUndefinedOrNull)(I)){this.remove(C,m);return}this.t(()=>{this.u(C,m,i),this.L(m)?.set(C,I)})}remove(C,I){this.t(()=>{this.u(C,I,void 0),this.L(I)?.delete(C)})}t(C){this.b.pause(),this.c.pause();try{C()}finally{this.b.resume(),this.c.resume()}}keys(C,I){const m=[],i=this.F(C);for(const n of Object.keys(i))i[n]===I&&m.push(n);return m}u(C,I,m){const i=this.F(I);typeof m=="number"?i[C]!==m&&(i[C]=m,this.L(I)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[C]=="number"&&(delete i[C],this.L(I)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(C){switch(C){case-1:return this.D;case 0:return this.z;default:return this.w}}G(C){const I=this.L(C);return I?u(I):Object.create(null)}isNew(C){return this.getBoolean(e.IS_NEW_KEY,C)===!0}async flush(C=b.NONE){this.f.fire({reason:C});const I=this.L(-1),m=this.L(0),i=this.L(1);switch(C){case b.NONE:await E.Promises.settled([I?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await E.Promises.settled([I?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const C=this.L(-1)?.items??new Map,I=this.L(0)?.items??new Map,m=this.L(1)?.items??new Map;return l(C,I,m,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(C,I){return this.r(b.NONE),(0,g.isUserDataProfile)(C)?this.N(C,I):this.O(C,I)}H(C,I){return!(C.id===I.id||p(I)&&p(C))}I(C,I,m,i){this.t(()=>{if(i)for(const[n,r]of C)I.set(n,r);else{const n=new Set;for(const[r,a]of C)n.add(r),I.get(r)!==a&&this.n(m,r);for(const[r]of I.items)n.has(r)||this.n(m,r)}})}}e.AbstractStorageService=f,f.a=60*1e3;function p(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class h extends f{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(C=>this.n(1,C))),this.B(this.P.onDidChangeStorage(C=>this.n(0,C))),this.B(this.p.onDidChangeStorage(C=>this.n(-1,C)))}L(C){switch(C){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(C){switch(C){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(C){return!1}}e.InMemoryStorageService=h;async function l(v,C,I,m,i,n){const r=V=>{try{return JSON.parse(V)}catch{return V}},a=new Map,s=new Map;v.forEach((V,oe)=>{a.set(oe,V),s.set(oe,r(V))});const c=new Map,o=new Map;C.forEach((V,oe)=>{c.set(oe,V),o.set(oe,r(V))});const d=new Map,D=new Map;I.forEach((V,oe)=>{d.set(oe,V),D.set(oe,r(V))}),console.group(m!==i?`Storage: Application (path: ${m})`:`Storage: Application & Profile (path: ${m}, default profile)`);const L=[];if(a.forEach((V,oe)=>{L.push({key:oe,value:V})}),console.table(L),console.groupEnd(),console.log(s),m!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const V=[];c.forEach((oe,X)=>{V.push({key:X,value:oe})}),console.table(V),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${n})`);const N=[];d.forEach((V,oe)=>{N.push({key:oe,value:V})}),console.table(N),console.groupEnd(),console.log(D)}e.logStorage=l}),define(ie[261],ne([0,1,24,8,3,2,9,80,7,23,104,147,6,92,31,28]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class h extends R.Disposable{get storage(){return this.f}constructor(n,r){super(),this.j=n,this.k=r,this.b=this.B(new k.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new k.Emitter),this.onDidCloseStorage=this.c.event,this.f=new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new t.DeferredPromise,this.whenInit=this.h.p,this.i=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===b.StorageState.None)try{const n=await this.n();this.f.dispose(),this.f=n,this.B(n.onDidChangeStorage(a=>this.b.fire({key:a}))),await this.m(n);const r=n.getBoolean(u.IS_NEW_KEY);r===void 0?n.set(u.IS_NEW_KEY,!0):r&&n.set(u.IS_NEW_KEY,!1)}catch(n){this.j.error(`[storage main] initialize(): Unable to init storage due to ${n}`)}finally{this.i=b.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===y.LogLevel.Trace?n=>this.j.trace(n):void 0,logError:n=>this.j.error(n)}}m(n){return n.init()}get items(){return this.f.items}get(n,r){return this.f.get(n,r)}set(n,r){return this.f.set(n,r)}delete(n){return this.f.delete(n)}async close(){const n=new P.StopWatch(!1);await this.s(),n.stop(),n.elapsed()>h.a&&await this.r(n),this.c.fire()}async r(n){if(!!this.path)try{const r=(0,E.top)(Array.from(this.f.items.entries()).map(([s,c])=>({key:s,length:c.length})),(s,c)=>c.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),a=(await this.k.stat(w.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${n.elapsed()}ms, DB size: ${a}b, Large Keys: ${r}`)}catch(r){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",r)}}async s(){this.g&&await this.g,this.i=b.StorageState.Closed,await this.f.close()}}h.a=2e3;class l extends h{get path(){if(!this.v.useInMemoryStorage)return(0,A.join)(this.u.globalStorageHome.fsPath,l.t)}constructor(n,r,a,s){super(a,s),this.u=n,this.v=r}async n(){return new b.Storage(new S.SQLiteStorageDatabase(this.path??S.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}l.t="state.vscdb";class v extends l{constructor(n,r,a,s){super(n,r,a,s)}}e.ProfileStorageMain=v;class C extends l{constructor(n,r,a,s){super(r.defaultProfile,n,a,s)}async m(n){await super.m(n),this.z(n)}z(n){n.get(f.firstSessionDateStorageKey,void 0)===void 0&&n.set(f.firstSessionDateStorageKey,new Date().toUTCString());const a=n.get(f.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();n.set(f.lastSessionDateStorageKey,typeof a>"u"?null:a),n.set(f.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=C;class I extends h{get path(){if(!this.w.useInMemoryStorage)return(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id,I.t)}constructor(n,r,a,s,c){super(a,c),this.v=n,this.w=r,this.y=s}async n(){const{storageFilePath:n,wasCreated:r}=await this.C();return new b.Storage(new S.SQLiteStorageDatabase(n,{logging:this.l()}),{hint:this.w.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:r?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:S.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const n=(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id),r=(0,A.join)(n,I.t);return await g.Promises.exists(n)?{storageFilePath:r,wasCreated:!1}:(await g.Promises.mkdir(n,{recursive:!0}),this.D(n),{storageFilePath:r,wasCreated:!0})}async D(n){let r;if((0,p.isSingleFolderWorkspaceIdentifier)(this.v)?r={folder:this.v.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.v)&&(r={workspace:this.v.configPath.toString()}),r)try{const a=(0,A.join)(n,I.u);await g.Promises.exists(a)||await g.Promises.writeFile(a,JSON.stringify(r,void 0,2))}catch(a){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${a}`)}}}e.WorkspaceStorageMain=I,I.t="state.vscdb",I.u="workspace.json";class m extends h{get path(){}async n(){return new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=m}),define(ie[262],ne([0,1,3,2,92]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(P,w,g){super(),this.b=P,this.c=w,this.f=g;const b=this.B(new t.MutableDisposable);this.a=this.B(new E.Emitter({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new t.DisposableStore;return P.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(w,g)=>(w?w.push(g.key):w=[g.key],w),100)(w=>this.h(w))),P.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(w,g)=>{w||(w=new Map);let b=w.get(g.profile.id);return b||w.set(g.profile.id,b={profile:g.profile,keys:[],storage:g.storage}),b.keys.push(g.key),w},100)(w=>this.i(w))),P}h(P){const w=P.includes(k.TARGET_KEY)?[this.c.defaultProfile]:[],g=[];if(P=P.filter(b=>b!==k.TARGET_KEY),P.length){const b=(0,k.loadKeyTargets)(this.b.applicationStorage.storage);g.push({profile:this.c.defaultProfile,changes:P.map(S=>({key:S,scope:0,target:b[S]}))})}this.j(w,g)}i(P){const w=[],g=new Map;for(const[b,S]of P.entries()){S.keys.includes(k.TARGET_KEY)&&w.push(S.profile);const y=S.keys.filter(u=>u!==k.TARGET_KEY);if(y.length){const u=(0,k.loadKeyTargets)(S.storage.storage);g.set(b,{profile:S.profile,changes:y.map(f=>({key:f,scope:0,target:u[f]}))})}}this.j(w,[...g.values()])}j(P,w){(P.length||w.length)&&this.a.fire({valueChanges:w,targetChanges:P})}listen(P,w,g){switch(w){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${w}`)}async call(P,w){throw new Error(`Call not found: ${w}`)}}e.ProfileStorageChangesListenerChannel=R}),define(ie[263],ne([0,1,69,7,35,16,6,229,42,38]),function(G,e,E,t,k,R,A,P,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let b=class extends g.UserDataProfilesService{constructor(u,f,p,h){super(f,p,u,h),this.a=f}M(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};b=pe([ee(0,w.IUriIdentityService),ee(1,k.INativeEnvironmentService),ee(2,R.IFileService),ee(3,A.ILogService)],b),e.ServerUserDataProfilesService=b;let S=class Lt extends b{constructor(u,f,p,h,l){super(f,p,h,l),this.O=u}H(){return(0,E.revive)(this.O.getItem(Lt.b,[]))}J(){return(0,E.revive)(this.O.getItem(Lt.c,{}))}M(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};S=pe([ee(0,P.IStateService),ee(1,w.IUriIdentityService),ee(2,k.INativeEnvironmentService),ee(3,R.IFileService),ee(4,A.ILogService)],S),e.UserDataProfilesService=S}),define(ie[51],ne([0,1,7,35,16,5,6,36,42,38,263]),function(G,e,E,t,k,R,A,P,w,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(g.IUserDataProfilesService);let S=class dt extends b.UserDataProfilesService{constructor(u,f,p,h,l){super(u,f,p,h,l),this.S=u}setEnablement(u){super.setEnablement(u),this.f||(this.I([]),this.L({}))}I(u){u.length?this.S.setItem(dt.b,u):this.S.removeItem(dt.b)}L(u){u.emptyWindow||u.workspaces?this.S.setItem(dt.c,u):this.S.removeItem(dt.c)}J(){const u="workspaceAndProfileInfo",f=this.S.getItem(u,void 0);if(f){this.S.removeItem(u);const p=f.reduce((h,{workspace:l,profile:v})=>(h[E.URI.revive(l).toString()]=E.URI.revive(v).toString(),h),{});this.S.setItem(dt.c,{workspaces:p})}return super.J()}};S=pe([ee(0,P.IStateMainService),ee(1,w.IUriIdentityService),ee(2,t.INativeEnvironmentService),ee(3,k.IFileService),ee(4,A.ILogService)],S),e.UserDataProfilesMainService=S}),define(ie[93],ne([0,1,7,50,3,2,35,16,5,21,6,92,261,38,51,42]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,w.createDecorator)("storageMainService");let h=class extends R.Disposable{constructor(C,I,m,i,n,r){super(),this.c=C,this.f=I,this.g=m,this.h=i,this.i=n,this.j=r,this.a=void 0,this.b=this.B(new k.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(C=>{C.window.profile&&this.profileStorage(C.window.profile).init(),C.workspace&&this.workspaceStorage(C.workspace).init()})),this.B(this.h.onWillShutdown(C=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=C.reason,C.join(this.applicationStorage.close());for(const[,I]of this.n)C.join(I.close());for(const[,I]of this.r)C.join(I.close())})),this.B(this.g.onWillCreateProfile(C=>{C.join((async()=>{await this.i.exists(C.profile.globalStorageHome)||await this.i.createFolder(C.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(C=>{const I=this.n.get(C.profile.id);I&&C.join(I.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const C=new y.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,t.once)(C.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),C}profileStorage(C){if((0,S.isProfileUsingDefaultStorage)(C))return this.applicationStorage;let I=this.n.get(C.id);if(!I){this.c.trace(`StorageMainService: creating profile storage (${C.name})`),I=this.p(C),this.n.set(C.id,I);const m=this.B(I.onDidChangeStorage(i=>this.b.fire({...i,storage:I,profile:C})));(0,t.once)(I.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${C.name})`),this.n.delete(C.id),m.dispose()})}return I}p(C){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.ProfileStorageMain(C,this.k(),this.c,this.i)}workspaceStorage(C){let I=this.r.get(C.id);return I||(this.c.trace(`StorageMainService: creating workspace storage (${C.id})`),I=this.s(C),this.r.set(C.id,I),(0,t.once)(I.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${C.id})`),this.r.delete(C.id)})),I}s(C){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.WorkspaceStorageMain(C,this.k(),this.c,this.f,this.i)}isUsed(C){const I=E.URI.file(C);for(const m of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!m.path&&this.j.extUri.isEqualOrParent(E.URI.file(m.path),I))return!0;return!1}};h=pe([ee(0,b.ILogService),ee(1,A.IEnvironmentService),ee(2,f.IUserDataProfilesMainService),ee(3,g.ILifecycleMainService),ee(4,P.IFileService),ee(5,p.IUriIdentityService)],h),e.StorageMainService=h,e.IApplicationStorageMainService=(0,w.createDecorator)("applicationStorageMainService");let l=class extends S.AbstractStorageService{constructor(C,I){super(),this.p=C,this.s=I,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(C){if(C===-1)return this.s.applicationStorage.storage}M(C){if(C===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};l=pe([ee(0,u.IUserDataProfilesService),ee(1,e.IStorageMainService)],l),e.ApplicationStorageMainService=l}),define(ie[264],ne([0,1,2,21,51]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends E.Disposable{constructor(P,w){super(),this.a=w,this.B(P.onWillLoadWindow(g=>{g.reason===2&&this.b(g.window.openedWorkspace??"empty-window")})),this.B(P.onBeforeCloseWindow(g=>this.b(g.openedWorkspace??"empty-window")))}async b(P){this.a.getOrSetProfileForWorkspace(P).isTransient&&(this.a.unsetWorkspace(P,!0),await this.a.cleanUpTransientProfiles())}};R=pe([ee(0,t.ILifecycleMainService),ee(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(ie[118],ne([0,1,20,7,28]),function(G,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(w,g,b){for(const y of w){const u=y.openedWorkspace;if((0,k.isWorkspaceIdentifier)(u)){const f=await b(u);if(f){if(f.folders.some(p=>E.extUriBiasedIgnorePathCase.isEqualOrParent(g,p.uri)))return y}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(g,u.configPath))return y}}const S=w.filter(y=>(0,k.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(g,y.openedWorkspace.uri));if(S.length)return S.sort((y,u)=>-(y.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function A(w,g){for(const b of w)if((0,k.isWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,g)||(0,k.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,g))return b}e.findWindowOnWorkspaceOrFolder=A;function P(w,g){const b=S=>g.some(y=>E.extUriBiasedIgnorePathCase.isEqual(t.URI.file(y),t.URI.file(S)));for(const S of w)if(S.config?.extensionDevelopmentPath?.some(y=>b(y)))return S}e.findWindowOnExtensionDevelopmentPath=P}),define(ie[265],ne([0,1,13,2,4,20,7,18,21,6,36,32,116,28]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let f=class Ot extends t.Disposable{get state(){return this.b}constructor(I,m,i,n,r){super(),this.g=I,this.h=m,this.i=i,this.j=n,this.k=r,this.b=p(this.h.getItem(Ot.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(I=>this.p(I)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(I=>{I.newCount-I.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(I=>this.p(I))}m(){this.f=!0,this.n()}n(){const I=new Set,m={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!m.lastActiveWindow){let r=this.g.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.g.getWindows().find(a=>!a.isExtensionDevelopmentHost)),r&&(m.lastActiveWindow=this.r(r),m.lastActiveWindow.uiState.mode===3&&I.add(m.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);i&&(m.lastPluginDevelopmentHostWindow=this.r(i),m.lastPluginDevelopmentHostWindow.uiState.mode===3&&(I.has(m.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!i.win?.isSimpleFullScreen()&&(m.lastPluginDevelopmentHostWindow.uiState.mode=1):I.add(m.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(m.openedWindows=this.g.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>{const a=this.r(r);return a.uiState.mode===3&&(I.has(a.uiState.display)?k.isMacintosh&&a.windowId!==m.lastActiveWindow?.windowId&&!r.win?.isSimpleFullScreen()&&(a.uiState.mode=1):I.add(a.uiState.display)),a}));const n=l(m);this.h.setItem(Ot.a,n),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",n)}p(I){if(this.i.quitRequested)return;const m=this.r(I);I.isExtensionDevelopmentHost&&!I.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=m:!I.isExtensionDevelopmentHost&&I.openedWorkspace&&this.b.openedWindows.forEach(i=>{const n=(0,u.isWorkspaceIdentifier)(I.openedWorkspace)&&i.workspace?.id===I.openedWorkspace.id,r=(0,u.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&i.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(i.folderUri,I.openedWorkspace.uri);(n||r)&&(i.uiState=m.uiState)}),this.g.getWindowCount()===1&&(this.c=m)}r(I){return{windowId:I.id,workspace:(0,u.isWorkspaceIdentifier)(I.openedWorkspace)?I.openedWorkspace:void 0,folderUri:(0,u.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)?I.openedWorkspace.uri:void 0,backupPath:I.backupPath,remoteAuthority:I.remoteAuthority,uiState:I.serializeWindowState()}}getNewWindowState(I){const m=this.s(I),i=this.k.getValue("window");if(m.mode===3){let n;m.hasDefaultState?n=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):n=!!(this.i.wasRestarted||i?.restoreFullscreen),n||(m.mode=1)}return m}s(I){const m=this.g.getLastActiveWindow();if(!I.extensionTestsPath){if(!!I.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=I.workspace;if((0,u.isWorkspaceIdentifier)(c)){const d=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===c.id).map(D=>D.uiState);if(d.length)return d[0]}if((0,u.isSingleFolderWorkspaceIdentifier)(c)){const d=this.state.openedWindows.filter(D=>D.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(D.folderUri,c.uri)).map(D=>D.uiState);if(d.length)return d[0]}else if(I.backupPath){const d=this.state.openedWindows.filter(D=>D.backupPath===I.backupPath).map(D=>D.uiState);if(d.length)return d[0]}const o=this.c||this.state.lastActiveWindow;if(!m&&o)return o.uiState}let i;const n=E.screen.getAllDisplays();if(n.length===1)i=n[0];else{if(k.isMacintosh){const c=E.screen.getCursorScreenPoint();i=E.screen.getDisplayNearestPoint(c)}!i&&m&&(i=E.screen.getDisplayMatching(m.getBounds())),i||(i=E.screen.getPrimaryDisplay()||n[0])}let r=(0,y.defaultWindowState)();r.x=Math.round(i.bounds.x+i.bounds.width/2-r.width/2),r.y=Math.round(i.bounds.y+i.bounds.height/2-r.height/2);const a=this.k.getValue("window");let s=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")r.mode=0,s=!1;else if(a.newWindowDimensions==="fullscreen")r.mode=3,s=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&m){const c=m.serializeWindowState();c.mode===3?r.mode=3:r=c,s=r.mode!==3&&a.newWindowDimensions==="offset"}}return s&&(r=this.t(r)),r.hasDefaultState=!0,r}t(I){if(this.g.getWindows().length===0)return I;I.x=typeof I.x=="number"?I.x:0,I.y=typeof I.y=="number"?I.y:0;const m=this.g.getWindows().map(i=>i.getBounds());for(;m.some(i=>i.x===I.x||i.y===I.y);)I.x+=30,I.y+=30;return I}};f.a="windowsState",f=pe([ee(0,S.IWindowsMainService),ee(1,b.IStateMainService),ee(2,w.ILifecycleMainService),ee(3,g.ILogService),ee(4,P.IConfigurationService)],f),e.WindowsStateHandler=f;function p(C){const I={openedWindows:[]},m=C||{openedWindows:[]};return m.lastActiveWindow&&(I.lastActiveWindow=h(m.lastActiveWindow)),m.lastPluginDevelopmentHostWindow&&(I.lastPluginDevelopmentHostWindow=h(m.lastPluginDevelopmentHostWindow)),Array.isArray(m.openedWindows)&&(I.openedWindows=m.openedWindows.map(i=>h(i))),I}e.restoreWindowsState=p;function h(C){const I={uiState:C.uiState};return C.backupPath&&(I.backupPath=C.backupPath),C.remoteAuthority&&(I.remoteAuthority=C.remoteAuthority),C.folder&&(I.folderUri=A.URI.parse(C.folder)),C.workspaceIdentifier&&(I.workspace={id:C.workspaceIdentifier.id,configPath:A.URI.parse(C.workspaceIdentifier.configURIPath)}),I}function l(C){return{lastActiveWindow:C.lastActiveWindow&&v(C.lastActiveWindow),lastPluginDevelopmentHostWindow:C.lastPluginDevelopmentHostWindow&&v(C.lastPluginDevelopmentHostWindow),openedWindows:C.openedWindows.map(I=>v(I))}}e.getWindowsStateStoreData=l;function v(C){return{workspaceIdentifier:C.workspace&&{id:C.workspace.id,configURIPath:C.workspace.configPath.toString()},folder:C.folderUri&&C.folderUri.toString(),backupPath:C.backupPath,remoteAuthority:C.remoteAuthority,uiState:C.uiState}}}),define(ie[94],ne([0,1,30,43,124,34,14,9,4,20,7,5,54,28]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,S.createDecorator)("workspacesService");function f(D){return D.hasOwnProperty("workspace")}e.isRecentWorkspace=f;function p(D){return D.hasOwnProperty("folderUri")}e.isRecentFolder=p;function h(D){return D.hasOwnProperty("fileUri")}e.isRecentFile=h;function l(D){return v(D)||C(D)}e.isStoredWorkspaceFolder=l;function v(D){const L=D;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function C(D){const L=D;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function I(D,L,N,V,oe){if(D.scheme!==V.scheme)return{name:N,uri:D.toString(!0)};let X=L?void 0:oe.relativePath(V,D);if(X!==void 0)X.length===0?X=".":w.isWindows&&(X=m(X));else if(D.scheme===A.Schemas.file)X=D.fsPath,w.isWindows&&(X=m(X));else if(oe.isEqualAuthority(D.authority,V.authority))X=D.path;else return{name:N,uri:D.toString(!0)};return{name:N,path:X}}e.getStoredWorkspaceFolder=I;function m(D){return D=(0,R.normalizeDriveLetter)(D),(0,E.isUNC)(D)||(D=(0,E.toSlashes)(D)),D}function i(D,L,N){const V=[],oe=new Set,X=N.dirname(L);for(const Y of D){let se;if(v(Y))Y.path&&(se=N.resolvePath(X,Y.path));else if(C(Y))try{se=b.URI.parse(Y.uri),se.path[0]!==P.posix.sep&&(se=se.with({path:P.posix.sep+se.path}))}catch(re){console.warn(re)}if(se){const re=N.getComparisonKey(se);if(!oe.has(re)){oe.add(re);const fe=Y.name||N.basenameOrAuthority(se);V.push(new u.WorkspaceFolder({uri:se,name:fe,index:V.length},Y))}}}return V}e.toWorkspaceFolders=i;function n(D,L,N,V,oe){const X=r(L,D),Y=oe.dirname(L),se=oe.dirname(V),re=[];for(const $ of X.folders){const W=v($)?oe.resolvePath(Y,$.path):b.URI.parse($.uri);let T;N?T=!1:T=!v($)||(0,P.isAbsolute)($.path),re.push(I(W,T,$.name,se,oe))}const fe={insertSpaces:!1,tabSize:4,eol:w.isLinux||w.isMacintosh?`
`:`\r
`},J=k.setProperty(D,["folders"],re,fe);let le=k.applyEdits(D,J);return(0,g.isEqualAuthority)(X.remoteAuthority,(0,y.getRemoteAuthority)(V))&&(le=k.applyEdits(le,k.removeProperty(le,["remoteAuthority"],fe))),le}e.rewriteWorkspaceFileForNewLocation=n;function r(D,L){const N=t.parse(L);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(V=>l(V));else throw new Error(`${D} looks like an invalid workspace file.`);return N}function a(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function s(D){return typeof D.folderUri=="string"}function c(D){return typeof D.fileUri=="string"}function o(D,L){const N={workspaces:[],files:[]};if(D){const V=function(X,Y){for(let se=0;se<X.length;se++)try{Y(X[se],se)}catch(re){L.warn(`Error restoring recent entry ${JSON.stringify(X[se])}: ${re.toString()}. Skip entry.`)}},oe=D;Array.isArray(oe.entries)&&V(oe.entries,X=>{const Y=X.label,se=X.remoteAuthority;a(X)?N.workspaces.push({label:Y,remoteAuthority:se,workspace:{id:X.workspace.id,configPath:b.URI.parse(X.workspace.configPath)}}):s(X)?N.workspaces.push({label:Y,remoteAuthority:se,folderUri:b.URI.parse(X.folderUri)}):c(X)&&N.files.push({label:Y,remoteAuthority:se,fileUri:b.URI.parse(X.fileUri)})})}return N}e.restoreRecentlyOpened=o;function d(D){const L={entries:[]};for(const N of D.workspaces)p(N)?L.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):L.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of D.files)L.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return L}e.toStoreData=d}),define(ie[95],ne([0,1,77,14,4,20]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function A(g){function b(){let S=g.scheme===t.Schemas.file?(0,R.originalFSPath)(g):g.toString();return k.isLinux||(S=S.toLowerCase()),(0,E.createHash)("md5").update(S).digest("hex")}return{id:b(),configPath:g}}e.getWorkspaceIdentifier=A;function P(g,b){function S(){if(g.scheme!==t.Schemas.file)return(0,E.createHash)("md5").update(g.toString()).digest("hex");if(!b)return;let u;return k.isLinux?u=b.ino:k.isMacintosh?u=b.birthtime.getTime():k.isWindows&&(typeof b.birthtimeMs=="number"?u=Math.floor(b.birthtimeMs):u=b.birthtime.getTime()),(0,E.createHash)("md5").update(g.fsPath).update(u?String(u):"").digest("hex")}const y=S();if(typeof y=="string")return{id:y,uri:g}}e.getSingleFolderWorkspaceIdentifier=P;function w(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=w}),define(ie[266],ne([0,1,77,30,14,9,4,20,23,177,18,27,36,16,6,176,28,95]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class Tt{constructor(I,m,i,n){this.j=I,this.k=m,this.l=i,this.m=n,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.extUriBiasedIgnorePathCase,this.i={isEqual:(r,a)=>(0,t.isEqual)(r,a,!A.isLinux)}}async initialize(){const I=this.m.getItem(Tt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(I.emptyWindows),this.d=await this.u((0,g.deserializeWorkspaceInfos)(I)),this.e=await this.v((0,g.deserializeFolderInfos)(I)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==u.HotExitConfiguration.OFF}q(){return this.s()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(I,m){this.d.some(n=>I.workspace.id===n.workspace.id)||(this.d.push(I),this.C());const i=(0,R.join)(this.c,I.workspace.id);return m?this.t(i,m).then(()=>i):i}async t(I,m){if(await w.Promises.exists(I)&&await this.z(I),await w.Promises.exists(m))try{await w.Promises.rename(m,I)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(I){return this.e.some(m=>this.h.isEqual(I.folderUri,m.folderUri))||(this.e.push(I),this.C()),(0,R.join)(this.c,this.D(I))}registerEmptyWindowBackup(I){return this.g.some(m=>!!m.backupFolder&&this.i.isEqual(m.backupFolder,I.backupFolder))||(this.g.push(I),this.C()),(0,R.join)(this.c,I.backupFolder)}async u(I){if(!Array.isArray(I))return[];const m=new Set,i=[];for(const n of I){const r=n.workspace;if(!(0,h.isWorkspaceIdentifier)(r))return[];if(!m.has(r.id)){m.add(r.id);const a=(0,R.join)(this.c,r.id);await this.B(a)?r.configPath.scheme!==k.Schemas.file||await w.Promises.exists(r.configPath.fsPath)?i.push(n):await this.z(a):await this.x(a)}}return i}async v(I){if(!Array.isArray(I))return[];const m=[],i=new Set;for(const n of I){const r=n.folderUri,a=this.h.getComparisonKey(r);if(!i.has(a)){i.add(a);const s=(0,R.join)(this.c,this.D(n));await this.B(s)?r.scheme!==k.Schemas.file||await w.Promises.exists(r.fsPath)?m.push(n):await this.z(s):await this.x(s)}}return m}async w(I){if(!Array.isArray(I))return[];const m=[],i=new Set;for(const n of I){const r=n.backupFolder;if(typeof r!="string")return[];if(!i.has(r)){i.add(r);const a=(0,R.join)(this.c,r);await this.B(a)?m.push(n):await this.x(a)}}return m}async x(I){try{await w.Promises.rm(I,w.RimRafMode.MOVE)}catch(m){this.l.error(`Backup: Could not delete stale backup: ${m.toString()}`)}}y(){let I=(0,l.createEmptyWorkspaceIdentifier)();for(;this.g.some(m=>!!m.backupFolder&&this.i.isEqual(m.backupFolder,I.id));)I=(0,l.createEmptyWorkspaceIdentifier)();return{backupFolder:I.id}}async z(I){const m=this.y(),i=(0,R.join)(this.c,m.backupFolder);try{await w.Promises.rename(I,i)}catch(n){return this.l.error(`Backup: Could not rename backup folder: ${n.toString()}`),!1}return this.g.push(m),!0}async getDirtyWorkspaces(){const I=[];for(const m of this.d)await this.A(m)&&I.push(m);for(const m of this.e)await this.A(m)&&I.push(m);return I}A(I){let m;return(0,g.isEmptyWindowBackupInfo)(I)?m=(0,R.join)(this.c,I.backupFolder):(0,p.isFolderBackupInfo)(I)?m=(0,R.join)(this.c,this.D(I)):m=(0,R.join)(this.c,I.workspace.id),this.B(m)}async B(I){try{const m=await w.Promises.readdir(I);for(const i of m)try{if((await w.Promises.readdir((0,R.join)(I,i))).length>0)return!0}catch{}}catch{}return!1}C(){const I={workspaces:this.d.map(({workspace:m,remoteAuthority:i})=>{const n={id:m.id,configURIPath:m.configPath.toString()};return i&&(n.remoteAuthority=i),n}),folders:this.e.map(({folderUri:m,remoteAuthority:i})=>{const n={folderUri:m.toString()};return i&&(n.remoteAuthority=i),n}),emptyWindows:this.g.map(({backupFolder:m,remoteAuthority:i})=>{const n={backupFolder:m};return i&&(n.remoteAuthority=i),n})};this.m.setItem(Tt.a,I)}D(I){const m=I.folderUri;let i;return m.scheme===k.Schemas.file?i=A.isLinux?m.fsPath:m.fsPath.toLowerCase():i=m.toString().toLowerCase(),(0,E.createHash)("md5").update(i).digest("hex")}};v.a="backupWorkspaces",v=pe([ee(0,S.IEnvironmentMainService),ee(1,b.IConfigurationService),ee(2,f.ILogService),ee(3,y.IStateMainService)],v),e.BackupMainService=v}),define(ie[52],ne([0,1,13,3,43,34,2,14,9,20,11,23,175,62,57,27,5,6,19,51,118,28,94,95]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v,C,I,m,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,h.createDecorator)("workspacesManagementMainService");let r=class extends A.Disposable{constructor(s,c,o,d,D,L){super(),this.g=s,this.h=c,this.i=o,this.j=d,this.k=D,this.l=L,this.a=this.B(new t.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new t.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const s=(await S.Promises.readdir(this.c.fsPath)).map(c=>(0,g.joinPath)(this.c,c,m.UNTITLED_WORKSPACE_NAME));for(const c of s){const o=(0,n.getWorkspaceIdentifier)(c),d=await this.resolveLocalWorkspace(c);d?this.f.push({workspace:o,remoteAuthority:d.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(s){s.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${s}).`)}}resolveLocalWorkspace(s){return this.m(s,c=>S.Promises.readFile(c,"utf8"))}m(s,c){if(!!this.n(s)&&s.scheme===P.Schemas.file)try{const o=c(s.fsPath);return o instanceof Promise?o.then(d=>this.p(s,d),d=>{}):this.p(s,o)}catch{return}}n(s){return(0,m.isUntitledWorkspace)(s,this.g)||(0,m.hasWorkspaceFileExtension)(s)}p(s,c){try{const o=this.r(s,c),d=(0,n.getWorkspaceIdentifier)(s);return{id:d.id,configPath:d.configPath,folders:(0,i.toWorkspaceFolders)(o.folders,d.configPath,g.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}r(s,c){const o=(0,k.parse)(c);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(d=>(0,i.isStoredWorkspaceFolder)(d));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(s,c){const{workspace:o,storedWorkspace:d}=this.s(s,c),D=o.configPath.fsPath;return await S.Promises.mkdir((0,w.dirname)(D),{recursive:!0}),await S.Promises.writeFile(D,JSON.stringify(d,null,"	")),this.f.push({workspace:o,remoteAuthority:c}),o}s(s=[],c){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),d=(0,g.joinPath)(this.c,o),D=(0,g.joinPath)(d,m.UNTITLED_WORKSPACE_NAME),L=[];for(const N of s)L.push((0,i.getStoredWorkspaceFolder)(N.uri,!0,N.name,d,g.extUriBiasedIgnorePathCase));return{workspace:(0,n.getWorkspaceIdentifier)(D),storedWorkspace:{folders:L,remoteAuthority:c}}}async getWorkspaceIdentifier(s){return(0,n.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,m.isUntitledWorkspace)(s.configPath,this.g)}async deleteUntitledWorkspace(s){!this.isUntitledWorkspace(s)||(await this.t(s),this.i.isEnabled()&&this.i.unsetWorkspace(s),this.a.fire(s))}async t(s){const c=(0,g.originalFSPath)(s.configPath);try{await S.Promises.rm((0,w.dirname)(c));const o=(0,w.join)(this.g.workspaceStorageHome.fsPath,s.id);await S.Promises.exists(o)&&await S.Promises.writeFile((0,w.join)(o,"obsolete"),""),this.f=this.f.filter(d=>d.workspace.id!==s.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${c} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(s,c,o){if(!s||!s.win||!s.isReady||!await this.u(s,c,o))return;const D=await this.v(s,(0,n.getWorkspaceIdentifier)(o));if(!!D)return this.b.fire({window:s,workspace:D.workspace}),D}async u(s,c,o){if(!o)return!0;if((0,m.isWorkspaceIdentifier)(s.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,o))return!1;if((0,I.findWindowOnWorkspaceOrFolder)(c,o)){const d={title:this.l.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,y.localize)(0,null))],message:(0,y.localize)(1,null,(0,g.basename)(o)),detail:(0,y.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(d,(0,b.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1}return!0}async v(s,c){if(!s.config)return;s.focus();let o;return s.config.extensionDevelopmentPath||(s.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority},s.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority})),(0,m.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=c,s.config.backupPath=o,{workspace:c,backupPath:o}}};r=pe([ee(0,p.IEnvironmentMainService),ee(1,l.ILogService),ee(2,C.IUserDataProfilesMainService),ee(3,u.IBackupMainService),ee(4,f.IDialogMainService),ee(5,v.IProductService)],r),e.WorkspacesManagementMainService=r}),define(ie[119],ne([0,1,13,41,22,5,32,28,52,11,6]),function(G,e,E,t,k,R,A,P,w,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let S=class{constructor(u,f,p){this.a=u,this.b=f,this.c=p}async getRemoteDiagnostics(u){const f=this.a.getWindows();return(await Promise.all(f.map(async h=>{const l=h.remoteAuthority;if(!l)return;const v=`vscode:getDiagnosticInfoResponse${h.id}`,C={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?await this.f(h):void 0};return new Promise(I=>{h.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:v,args:C}),t.validatedIpcMain.once(v,(m,i)=>{i||I({hostName:l,errorMessage:`Unable to resolve connection to '${l}'.`}),I(i)}),setTimeout(()=>{I({hostName:l,errorMessage:`Connection to '${l}' could not be established`})},5e3)})}))).filter(h=>!!h)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const u=[];for(const f of E.BrowserWindow.getAllWindows()){const p=this.a.getWindowById(f.id);p?u.push(await this.d(p)):u.push(this.e(f))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(u){const f=await this.f(u),p=(0,g.assertIsDefined)(u.win);return this.e(p,f,u.remoteAuthority)}e(u,f=[],p){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:f,remoteAuthority:p}}async f(u){const f=[],p=u.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(p))f.push(p.uri);else if((0,P.isWorkspaceIdentifier)(p)){const h=await this.b.resolveLocalWorkspace(p.configPath);h&&h.folders.forEach(v=>{f.push(v.uri)})}return f}};S=pe([ee(0,A.IWindowsMainService),ee(1,w.IWorkspacesManagementMainService),ee(2,b.ILogService)],S),e.DiagnosticsMainService=S}),define(ie[58],ne([0,1,46,13,25,141,53,3,34,2,14,9,4,7,100,81,23,97,165,57,27,5,21,6,19,66,32,28,52,17,223,216,36]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v,C,I,m,i,n,r,a,s,c,o,d,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,m.createDecorator)("nativeHostMainService");let V=class extends g.Disposable{constructor(X,Y,se,re,fe,J,le,$,W,T){super(),this.a=X,this.b=Y,this.c=se,this.f=re,this.g=fe,this.h=J,this.i=le,this.j=$,this.k=W,this.l=T,this.onDidOpenWindow=P.Event.map(this.b.onDidOpenWindow,z=>z.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:z,x:Q,y:q})=>({windowId:z.id,x:Q,y:q})),({windowId:z})=>!!this.b.getWindowById(z)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),z=>!!z),z=>z.id),P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new P.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(z,Q,q)=>q),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),P.Event.fromNodeEventEmitter(t.screen,"display-added"),P.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(Y=>({id:Y.id,workspace:Y.openedWorkspace??(0,c.toWorkspaceIdentifier)(Y.backupPath,Y.isExtensionDevelopmentHost),title:Y.win?.getTitle()??"",filename:Y.getRepresentedFilename(),dirty:Y.isDocumentEdited()}))}async getWindowCount(X){return this.b.getWindowCount()}async getActiveWindowId(X){const Y=t.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(Y)return Y.id}openWindow(X,Y,se){return Array.isArray(Y)?this.n(X,Y,se):this.p(X,Y)}async n(X,Y,se=Object.create(null)){Y.length>0&&await this.b.open({context:5,contextWindowId:X,urisToOpen:Y,cli:this.g.args,forceNewWindow:se.forceNewWindow,forceReuseWindow:se.forceReuseWindow,preferNewWindow:se.preferNewWindow,diffMode:se.diffMode,mergeMode:se.mergeMode,addMode:se.addMode,gotoLineMode:se.gotoLineMode,noRecentEntry:se.noRecentEntry,waitMarkerFileURI:se.waitMarkerFileURI,remoteAuthority:se.remoteAuthority||void 0})}async p(X,Y){await this.b.openEmptyWindow({context:5,contextWindowId:X},Y)}async toggleFullScreen(X){this.w(X)?.toggleFullScreen()}async handleTitleDoubleClick(X){this.w(X)?.handleTitleDoubleClick()}async isMaximized(X){const Y=this.w(X);return Y?.win?Y.win.isMaximized():!1}async maximizeWindow(X){const Y=this.w(X);Y?.win&&Y.win.maximize()}async unmaximizeWindow(X){const Y=this.w(X);Y?.win&&Y.win.unmaximize()}async minimizeWindow(X){const Y=this.w(X);Y?.win&&Y.win.minimize()}async updateWindowControls(X,Y){const se=this.w(X);se&&se.updateWindowControls(Y)}async focusWindow(X,Y){Y&&typeof Y.windowId=="number"&&(X=Y.windowId),this.w(X)?.focus({force:Y?.force??!1})}async setMinimumSize(X,Y,se){const re=this.w(X);if(re?.win){const[fe,J]=re.win.getSize(),[le,$]=re.win.getMinimumSize(),[W,T]=[Y??le,se??$],[z,Q]=[Math.max(fe,W),Math.max(J,T)];(le!==W||$!==T)&&re.win.setMinimumSize(W,T),(fe!==z||J!==Q)&&re.win.setSize(z,Q)}}async saveWindowSplash(X,Y){this.j.saveWindowSplash(X,Y)}async installShellCommand(X){const{source:Y,target:se}=await this.r();try{const{symbolicLink:re}=await h.SymlinkSupport.stat(Y);if(re&&!re.dangling){const fe=await(0,f.realpath)(Y);if(se===fe)return}await h.Promises.unlink(Y)}catch(re){if(re.code!=="ENOENT")throw re}try{await h.Promises.symlink(se,Y)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:fe}=await this.showMessageBox(X,{title:this.i.nameLong,type:"info",message:(0,v.localize)(0,null,this.i.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,w.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(fe===0)try{const J=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${se}' '${Y}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(J)}catch{throw new Error((0,v.localize)(3,null,Y))}}}async uninstallShellCommand(X){const{source:Y}=await this.r();try{await h.Promises.unlink(Y)}catch(se){switch(se.code){case"EACCES":{const{response:re}=await this.showMessageBox(X,{title:this.i.nameLong,type:"info",message:(0,v.localize)(4,null,this.i.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,w.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const fe=`osascript -e "do shell script \\"rm '${Y}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(fe)}catch{throw new Error((0,v.localize)(7,null,Y))}break}case"ENOENT":break;default:throw se}}}async r(){const X=(0,S.resolve)(this.g.appRoot,"bin","code"),Y=`/usr/local/bin/${this.i.applicationName}`;if(!await h.Promises.exists(X))throw new Error((0,v.localize)(8,null,X));return{source:Y,target:X}}async showMessageBox(X,Y){return this.c.showMessageBox(Y,this.s(X))}async showSaveDialog(X,Y){return this.c.showSaveDialog(Y,this.s(X))}async showOpenDialog(X,Y){return this.c.showOpenDialog(Y,this.s(X))}s(X){const Y=this.w(X);if(Y?.win)return Y.win}async pickFileFolderAndOpen(X,Y){const se=await this.c.pickFileFolder(Y);se&&await this.t(await Promise.all(se.map(async re=>await h.SymlinkSupport.existsDirectory(re)?{folderUri:u.URI.file(re)}:{fileUri:u.URI.file(re)})),Y,X)}async pickFolderAndOpen(X,Y){const se=await this.c.pickFolder(Y);se&&await this.t(se.map(re=>({folderUri:u.URI.file(re)})),Y,X)}async pickFileAndOpen(X,Y){const se=await this.c.pickFile(Y);se&&await this.t(se.map(re=>({fileUri:u.URI.file(re)})),Y,X)}async pickWorkspaceAndOpen(X,Y){const se=await this.c.pickWorkspace(Y);se&&await this.t(se.map(re=>({workspaceUri:u.URI.file(re)})),Y,X)}async t(X,Y,se){await this.b.open({context:3,contextWindowId:se,cli:this.g.args,urisToOpen:X,forceNewWindow:Y.forceNewWindow})}async showItemInFolder(X,Y){t.shell.showItemInFolder(Y)}async setRepresentedFilename(X,Y){this.w(X)?.setRepresentedFilename(Y)}async setDocumentEdited(X,Y){this.w(X)?.setDocumentEdited(Y)}async openExternal(X,Y){return y.isLinuxSnap?this.u(Y):t.shell.openExternal(Y),!0}u(X){const Y=process.env.GDK_PIXBUF_MODULE_FILE,se=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(X),process.env.GDK_PIXBUF_MODULE_FILE=Y,process.env.GDK_PIXBUF_MODULEDIR=se}moveItemToTrash(X,Y){return t.shell.trashItem(Y)}async isAdmin(){let X;return y.isWindows?X=(await new Promise((Y,se)=>{G(["native-is-elevated"],Y,se)}))():X=process.getuid()===0,X}async writeElevated(X,Y,se,re){const fe=await new Promise((J,le)=>{G(["@vscode/sudo-prompt"],J,le)});return new Promise((J,le)=>{const $=[`"${this.v}"`];re?.unlock&&$.push("--file-chmod"),$.push("--file-write",`"${Y.fsPath}"`,`"${se.fsPath}"`);const W={name:this.i.nameLong.replace("-",""),icns:y.isMacintosh&&this.g.isBuilt?(0,S.join)((0,S.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};fe.exec($.join(" "),W,(T,z,Q)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),Q&&this.h.trace(`[sudo-prompt] received stderr: ${Q}`),T?le(T):J(void 0)})})}get v(){return y.isWindows?this.g.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,S.join)(this.g.appRoot,"scripts","code-cli.bat"):y.isLinux?this.g.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,S.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,S.join)(this.g.appRoot,"bin","code"):(0,S.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return p.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return y.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(X,Y,se){process.kill(Y,se)}async readClipboardText(X,Y){return t.clipboard.readText(Y)}async writeClipboardText(X,Y,se){return t.clipboard.writeText(Y,se)}async readClipboardFindText(X){return t.clipboard.readFindText()}async writeClipboardFindText(X,Y){return t.clipboard.writeFindText(Y)}async writeClipboardBuffer(X,Y,se,re){return t.clipboard.writeBuffer(Y,Buffer.from(se.buffer),re)}async readClipboardBuffer(X,Y){return d.VSBuffer.wrap(t.clipboard.readBuffer(Y))}async hasClipboard(X,Y,se){return t.clipboard.has(Y,se)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(X,Y){this.w(X)?.updateTouchBar(Y)}async notifyReady(X){this.w(X)?.setReady()}async relaunch(X,Y){return this.f.relaunch(Y)}async reload(X,Y){const se=this.w(X);if(se){if((0,c.isWorkspaceIdentifier)(se.openedWorkspace)){const re=se.openedWorkspace.configPath;if(re.scheme===b.Schemas.file&&(await this.l.resolveLocalWorkspace(re))?.transient)return this.openWindow(se.id,{forceReuseWindow:!0})}return this.f.reload(se,Y?.disableExtensions!==void 0?{_:[],"disable-extensions":Y.disableExtensions}:void 0)}}async closeWindow(X){this.closeWindowById(X,X)}async closeWindowById(X,Y){const se=this.w(Y);if(se?.win)return se.win.close()}async quit(X){const Y=this.b.getLastActiveWindow();Y?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&Y.win?Y.win.close():this.f.quit()}async exit(X,Y){await this.f.kill(Y)}async resolveProxy(X,Y){const re=this.w(X)?.win?.webContents?.session;if(re)return re.resolveProxy(Y)}findFreePort(X,Y,se,re,fe=1){return(0,l.findFreePort)(Y,se,re,fe)}async openDevTools(X,Y){const se=this.w(X);se?.win&&se.win.webContents.openDevTools(Y)}async toggleDevTools(X){const Y=this.w(X);Y?.win&&Y.win.webContents.toggleDevTools()}async sendInputEvent(X,Y){const se=this.w(X);se?.win&&(Y.type==="mouseDown"||Y.type==="mouseUp")&&se.win.webContents.sendInputEvent(Y)}async enableSandbox(X,Y){Y?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(X,Y,se){const re=this.w(X);if(!re||!re.win)throw new Error;return await new L.WindowProfiler(re.win,Y,this.h).inspect(se)}async windowsGetStringRegKey(X,Y,se,re){if(!y.isWindows)return;const fe=await new Promise((J,le)=>{G(["@vscode/windows-registry"],J,le)});try{return fe.GetStringRegKey(Y,se,re)}catch{return}}w(X){if(typeof X=="number")return this.b.getWindowById(X)}};pe([A.memoize],V.prototype,"v",null),V=pe([ee(1,s.IWindowsMainService),ee(2,C.IDialogMainService),ee(3,i.ILifecycleMainService),ee(4,I.IEnvironmentMainService),ee(5,n.ILogService),ee(6,r.IProductService),ee(7,a.IThemeMainService),ee(8,N.IStateMainService),ee(9,o.IWorkspacesManagementMainService)],V),e.NativeHostMainService=V}),define(ie[267],ne([0,1,13,41,25,34,2,14,4,101,163,84,119,57,27,5,6,58,63,19,64,74,30,11]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v,C,I,m,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");let r=class jt{constructor(s,c,o,d,D,L,N,V,oe){this.g=s,this.h=c,this.i=o,this.j=d,this.k=D,this.l=L,this.m=N,this.n=V,this.o=oe,this.b=null,this.c=null,this.d=null,this.f=null,this.p()}p(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[c,o]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),d=await this.j.getSystemInfo(c,o);this.q(s,"vscode:issueSystemInfoResponse",d)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const c=[];try{c.push({name:(0,b.localize)(0,null),rootProcess:await(0,g.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(d=>{(0,S.isRemoteDiagnosticError)(d)?c.push({name:d.hostName,rootProcess:d}):d.processes&&c.push({name:d.hostName,rootProcess:d.processes})})}catch(o){this.i.error(`Listing processes failed: ${o}`)}this.q(s,"vscode:listProcessesResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const c={title:this.o.nameLong,message:(0,b.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,b.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const o=await this.l.showMessageBox(c,this.b);this.q(s,"vscode:issueReporterClipboardResponse",o.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const c=await this.u();this.q(s,"vscode:issuePerformanceInfoResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.o.nameLong,message:(0,b.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,b.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(s,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,c)=>{const{id:o,from:d,args:D}=c;let L;switch(d){case"issueReporter":L=this.c;break;case"processExplorer":L=this.f;break;default:throw new Error(`Unexpected command source: ${d}`)}L?.webContents.send("vscode:runAction",{id:o,from:d,args:D})}),t.validatedIpcMain.on("vscode:openExternal",(s,c)=>{this.m.openExternal(void 0,c)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.b?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.d?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const c=await this.k.getMainDiagnostics();this.q(s,"vscode:windowsInfoResponse",c.windows)})}q(s,c,...o){s.sender.isDestroyed()||s.sender.send(c,...o)}async openReporter(s){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const c=new A.DisposableStore,o=c.add(this.n.createIPCObjectUrl()),d=this.t(this.c,700,800);this.b=this.s(d,o,{backgroundColor:s.styles.backgroundColor,title:(0,b.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:s,disableExtensions:!!this.h.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:v.default}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,c.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,c.dispose())})}this.b&&this.r(this.b)}async openProcessExplorer(s){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const c=new A.DisposableStore,o=c.add(this.n.createIPCObjectUrl()),d=this.t(this.f,800,500);this.d=this.s(d,o,{backgroundColor:s.styles.backgroundColor,title:(0,b.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),o.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:s,product:v.default}),this.d.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,c.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,c.dispose())})}this.d&&this.r(this.d)}r(s){s.isMinimized()&&s.restore(),s.focus()}s(s,c,o,d){const D=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:o.title,backgroundColor:o.backgroundColor||jt.a,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,`--vscode-window-kind=${d}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,m.zoomLevelToZoomFactor)(o.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return D.setMenuBarVisibility(!1),D}async getSystemStatus(){const[s,c]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(s,c)}t(s,c,o){let d;const D=E.screen.getAllDisplays();if(D.length===1)d=D[0];else{if(w.isMacintosh){const V=E.screen.getCursorScreenPoint();d=E.screen.getDisplayNearestPoint(V)}!d&&s&&(d=E.screen.getDisplayMatching(s.getBounds())),d||(d=E.screen.getPrimaryDisplay()||D[0])}const L={width:c,height:o},N=d.bounds;return L.x=N.x+N.width/2-L.width/2,L.y=N.y+N.height/2-L.height/2,N.width>0&&N.height>0&&(L.x<N.x&&(L.x=N.x),L.y<N.y&&(L.y=N.y),L.x>N.x+N.width&&(L.x=N.x),L.y>N.y+N.height&&(L.y=N.y),L.width>N.width&&(L.width=N.width),L.height>N.height&&(L.height=N.height)),L}async u(){try{const[s,c]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(s,c)}catch(s){throw this.i.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.h.args.trace)return;const s=await E.contentTracing.stopRecording(`${(0,i.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,b.localize)(9,null),detail:(0,b.localize)(10,null,s),buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(11,null))],defaultId:0,noLink:!0},(0,n.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,s)}};r.a="#1E1E1E",r=pe([ee(1,f.IEnvironmentMainService),ee(2,h.ILogService),ee(3,S.IDiagnosticsService),ee(4,y.IDiagnosticsMainService),ee(5,u.IDialogMainService),ee(6,l.INativeHostMainService),ee(7,I.IProtocolMainService),ee(8,C.IProductService)],r),e.IssueMainService=r}),define(ie[268],ne([0,1,22,18,27,21,6,58,19,55,31,49,90]),function(G,e,E,t,k,R,A,P,w,g,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let u=class extends y.AbstractUpdateService{constructor(p,h,l,v,C,I,m,i){super(p,h,v,C,I,i),this.e=l,this.u=m}s(p){return(0,y.createUpdateURL)(`linux-${process.arch}`,p,this.k)}t(p){!this.a||(this.d(S.State.CheckingForUpdates(p)),this.i.request({url:this.a},E.CancellationToken.None).then(g.asJson).then(h=>{!h||!h.url||!h.version||!h.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!p}),this.d(S.State.Idle(1))):this.d(S.State.AvailableForDownload(h))}).then(void 0,h=>{this.j.error(h),this.e.publicLog2("update:notAvailable",{explicit:!!p});const l=p?h.message||h:void 0;this.d(S.State.Idle(1,l))}))}async o(p){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):p.update.url&&this.u.openExternal(void 0,p.update.url),this.d(S.State.Idle(1))}};u=pe([ee(0,R.ILifecycleMainService),ee(1,t.IConfigurationService),ee(2,b.ITelemetryService),ee(3,k.IEnvironmentMainService),ee(4,g.IRequestService),ee(5,A.ILogService),ee(6,P.INativeHostMainService),ee(7,w.IProductService)],u),e.LinuxUpdateService=u}),define(ie[269],ne([0,1,46,40,25,8,22,53,9,7,127,23,18,27,16,21,6,58,19,55,31,49,90]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v,C,I,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function n(c,o=1e3){for(;!c();)await(0,R.timeout)(o)}let r;function a(){return typeof r>"u"&&(r=t.existsSync(w.join(w.dirname(process.execPath),"unins000.exe"))?0:1),r}let s=class extends i.AbstractUpdateService{get cachePath(){const o=w.join((0,k.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return S.Promises.mkdir(o,{recursive:!0}).then(()=>o)}constructor(o,d,D,L,N,V,oe,X,Y){super(o,d,L,N,V,Y),this.u=D,this.v=oe,this.w=X}async initialize(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}s(o){let d="win32";return process.arch!=="ia32"&&(d+=`-${process.arch}`),a()===1?d+="-archive":this.k.target==="user"&&(d+="-user"),(0,i.createUpdateURL)(d,o,this.k)}t(o){!this.a||(this.d(m.State.CheckingForUpdates(o)),this.i.request({url:this.a},A.CancellationToken.None).then(C.asJson).then(d=>{const D=a();return!d||!d.url||!d.version||!d.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!o}),this.d(m.State.Idle(D)),Promise.resolve(null)):D===1?(this.d(m.State.AvailableForDownload(d)),Promise.resolve(null)):(this.d(m.State.Downloading(d)),this.B(d.version).then(()=>this.A(d.version).then(L=>S.Promises.exists(L).then(N=>{if(N)return Promise.resolve(L);const V=d.url,oe=d.hash,X=`${L}.tmp`;return this.i.request({url:V},A.CancellationToken.None).then(Y=>this.v.writeFile(g.URI.file(X),Y.stream)).then(oe?()=>(0,b.checksum)(X,d.hash):()=>{}).then(()=>S.Promises.rename(X,L)).then(()=>L)})).then(L=>{const N=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:L},N&&d.supportsFastUpdate?this.k.target==="user"?this.p():this.d(m.State.Downloaded(d)):this.d(m.State.Ready(d))})))}).then(void 0,d=>{this.j.error(d),this.u.publicLog2("update:notAvailable",{explicit:!!o});const D=o?d.message||d:void 0;this.d(m.State.Idle(a(),D))}))}async o(o){o.update.url&&this.w.openExternal(void 0,o.update.url),this.d(m.State.Idle(a()))}async A(o){const d=await this.cachePath;return w.join(d,`CodeSetup-${this.k.quality}-${o}.exe`)}async B(o=null){const d=o?V=>!new RegExp(`${this.k.quality}-${o}\\.exe$`).test(V):()=>!0,D=await this.cachePath,N=(await S.Promises.readdir(D)).filter(d).map(async V=>{try{await S.Promises.unlink(w.join(D,V))}catch{}});await Promise.all(N)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const o=this.state.update;this.d(m.State.Updating(o));const d=await this.cachePath;this.e.updateFilePath=w.join(d,`CodeSetup-${this.k.quality}-${o.version}.flag`),await S.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(m.State.Idle(a()))});const L=`${this.k.win32MutexName}-ready`,N=await new Promise((V,oe)=>{G(["windows-mutex"],V,oe)});n(()=>N.isActive(L)).then(()=>this.d(m.State.Ready(o)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?t.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return a()}async _applySpecificUpdate(o){if(this.state.type!=="idle")return;const d=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!d};this.d(m.State.Downloading(D)),this.e={packagePath:o},d?this.k.target==="user"?this.p():this.d(m.State.Downloaded(D)):this.d(m.State.Ready(D))}};pe([P.memoize],s.prototype,"cachePath",null),s=pe([ee(0,p.ILifecycleMainService),ee(1,y.IConfigurationService),ee(2,I.ITelemetryService),ee(3,u.IEnvironmentMainService),ee(4,C.IRequestService),ee(5,h.ILogService),ee(6,f.IFileService),ee(7,l.INativeHostMainService),ee(8,v.IProductService)],s),e.Win32UpdateService=s}),define(ie[270],ne([0,1,13,8,22,45,3,34,2,14,9,73,4,7,171,62,18,57,27,61,16,21,6,19,64,234,93,31,239,66,74,32,28,52,116,121,37,36,51,58,236,112,56,89,25,113]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v,C,I,m,i,n,r,a,s,c,o,d,D,L,N,V,oe,X,Y,se,re,fe,J,le,$,W,T,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(j){j[j.NONE=0]="NONE",j[j.NAVIGATING=1]="NAVIGATING",j[j.READY=2]="READY"})(Q||(Q={}));let q=class gt extends w.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const M=this.O.profiles.find(O=>O.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&M?M:this.O.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",M??this.O.defaultProfile)}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(M,O,F,U,H,x,B,_,Z,ae,ge,ke,Oe,De,Le,ve,we,ye,Me,te){super(),this.L=O,this.M=F,this.N=U,this.O=H,this.P=x,this.Q=B,this.R=_,this.S=Z,this.U=ae,this.W=ge,this.X=ke,this.Y=Oe,this.Z=De,this.ab=Le,this.bb=ve,this.db=we,this.eb=ye,this.fb=Me,this.gb=te,this.c=this.B(new A.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new A.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new A.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new A.Emitter),this.onDidClose=this.h.event,this.j=this.B(new A.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.db.createIPCObjectUrl()),this.J=!1,this.hb=0;{const[he,de]=this.sb(M.state);this.r=he,this.L.trace("window#ctor: using window state",he);const be=this.r.mode===0||this.r.mode===3;typeof gt.b>"u"&&(gt.b=this.fb.getItem("window.experimental.useSandbox",!1));const Pe=this.S.getValue("window");let We=!1;typeof Pe?.experimental?.useSandbox=="boolean"?We=Pe.experimental.useSandbox:this.bb.quality==="stable"&&gt.b?We=!0:We=typeof this.bb.quality=="string"&&this.bb.quality!=="stable";const Te={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.U.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!be,title:this.bb.nameLong,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(Pe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...We?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};y.isLinux?Te.icon=(0,b.join)(this.M.appRoot,"resources/linux/code.png"):y.isWindows&&!this.M.isBuilt&&(Te.icon=(0,b.join)(this.M.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.zb()&&(Te.fullscreenable=!1),y.isMacintosh&&(Te.acceptFirstMouse=!0,Pe?.clickThroughInactive===!1&&(Te.acceptFirstMouse=!1));const qe=y.isMacintosh&&Pe?.nativeTabs===!0;qe&&(Te.tabbingIdentifier=this.bb.nameShort);const Ue=(0,D.getTitleBarStyle)(this.S)==="custom";if(Ue&&(Te.titleBarStyle="hidden",y.isMacintosh||(Te.frame=!1),(0,D.useWindowControlsOverlay)(this.S))){const je=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Xe=X.Color.fromHex(je).isDarker()?"#FFFFFF":"#000000";Te.titleBarOverlay={height:29,color:je,symbolColor:Xe},this.z=!0}if((0,S.mark)("code/willCreateCodeBrowserWindow"),this.l=new E.BrowserWindow(Te),(0,S.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,y.isMacintosh&&Ue&&this.l.setSheetOffset(22),Ue&&(y.isWindows&&(0,D.useWindowControlsOverlay)(this.S)||y.isMacintosh)){const je=this.fb.getItem(gt.a);je&&this.updateWindowControls({height:je})}y.isWindows&&Ue&&this.l.hookWindowMessage(278,()=>{const[Xe,$e]=this.l.getPosition(),Ke=E.screen.getCursorScreenPoint(),K=Ke.x-Xe,ce=Ke.y-$e;return(()=>!(K>30&&ce>=0&&ce<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:K,y:ce})),0}),(y.isMacintosh||y.isWindows)&&de&&(!qe||E.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(je=>typeof je=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),be&&((0,S.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.vb(!0),this.l.show(),(0,S.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.M.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.pb(),this.Db(),this.ib()}setRepresentedFilename(M){y.isMacintosh?this.l.setRepresentedFilename(M):this.v=M}getRepresentedFilename(){return y.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(M){y.isMacintosh&&this.l.setDocumentEdited(M),this.w=M}isDocumentEdited(){return y.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(M){y.isMacintosh&&M?.force&&E.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.hb=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(M=>{if(this.isReady)return M(this);this.C.push(M)})}get isReady(){return this.hb===2}get whenClosedOrLoaded(){return new Promise(M=>{function O(){F.dispose(),U.dispose(),M()}const F=this.onDidClose(()=>O()),U=this.onWillLoad(()=>O())})}ib(){this.l.on("unresponsive",()=>this.lb(1)),this.l.webContents.on("render-process-gone",(O,F)=>this.lb(2,F)),this.l.webContents.on("did-fail-load",(O,F,U)=>this.lb(3,{reason:U,exitCode:F})),this.l.webContents.on("will-prevent-unload",O=>{O.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",O=>{this.n&&(this.n.maximized=!0),E.app.emit("browser-window-maximize",O,this.l)}),this.l.on("unmaximize",O=>{this.n&&(this.n.maximized=!1),E.app.emit("browser-window-unmaximize",O,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.S.onDidChangeConfiguration(O=>this.pb(O))),this.B(this.W.onDidDeleteUntitledWorkspace(O=>this.ob(O)));const M=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:M},async(O,F)=>{const U=await this.kb();F({cancel:!1,requestHeaders:Object.assign(O.requestHeaders,U)})})}kb(){return this.jb||(this.jb=(0,a.resolveMarketplaceHeaders)(this.bb.version,this.bb,this.M,this.S,this.P,this.Q,this.Y)),this.jb}async lb(M,O){switch(M){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:M,reason:O?.reason,code:O?.exitCode}),M){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.ab.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.ab.quit();return}if(M===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const F=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,f.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,f.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,f.localize)(2,null))],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.n?.workspace?(0,f.localize)(5,null):void 0},this.l);if(F.response!==1){const U=F.response===0;await this.nb(U,F.checkboxChecked)}}else if(M===2)if(y.isWindows&&O?.reason==="launch-failed"&&O.exitCode===18&&await this.gb.isAdmin(void 0))await this.mb(O);else{let F;O?F=(0,f.localize)(7,null,O.reason,O.exitCode??"<unknown>"):F=(0,f.localize)(6,null);const U=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,f.localize)(8,null)),(0,P.mnemonicButtonLabel)((0,f.localize)(9,null))],message:F,detail:(0,f.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this.n?.workspace?(0,f.localize)(11,null):void 0},this.l),H=U.response===0;await this.nb(H,U.checkboxChecked)}break}}async mb(M){const O=[],F=(0,$.isInternalTelemetry)(this.bb,this.S);if((0,$.supportsTelemetry)(this.bb,this.M)){this.bb.aiConfig&&this.bb.aiConfig.ariaKey&&O.push(new J.OneDataSystemAppender(F,"monacoworkbench",null,this.bb.aiConfig.ariaKey));const{installSourcePath:U}=this.M,H=await(0,z.resolveMachineId)(this.fb),x={appenders:O,sendErrorTelemetry:!1,commonProperties:(0,W.resolveCommonProperties)(this.P,(0,T.release)(),(0,T.hostname)(),process.arch,this.bb.commit,this.bb.version,H,F,U),piiPaths:(0,$.getPiiPathsFromEnvironment)(this.M)};await new le.TelemetryService(x,this.S,this.bb).publicLog2("windowadminerror",{reason:M.reason,code:M.exitCode})}await this.Z.showMessageBox({title:this.bb.nameLong,type:"error",buttons:[(0,P.mnemonicButtonLabel)((0,f.localize)(12,null))],message:(0,f.localize)(13,null),detail:(0,f.localize)(14,null,this.bb.nameLong),noLink:!0,defaultId:0},this.l),await Promise.all(O.map(U=>U.flush())),await this.nb(!1,!1)}async nb(M,O){const F=this.n?.workspace;if(O&&F)try{const U=this.R.workspaceStorage(F);await U.init(),U.delete("memento/workbench.parts.editor"),await U.close()}catch(U){this.L.error(U)}if(this.j.fire(),this.l?.destroy(),M&&this.n){let U,H;(0,N.isSingleFolderWorkspaceIdentifier)(F)?U={folderUri:F.uri}:(0,N.isWorkspaceIdentifier)(F)?U={workspaceUri:F.configPath}:H=!0;const[x]=await this.eb.open({context:5,userEnv:this.n.userEnv,cli:{...this.M.args,_:[]},urisToOpen:U?[U]:void 0,forceEmpty:H,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});x.focus()}}ob(M){this.n?.workspace?.id===M.id&&(this.n.workspace=void 0)}pb(M){const O=this.Ab();O!==this.s&&(this.s=O,this.Bb(O));let F=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;F?.endsWith("/")&&(F=F.substr(0,F.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((F||"").indexOf("@")===-1&&(F!==this.F||U!==this.G)){this.F=F,this.G=U;const H=F||"",x=U?`${U},<local>`:"<local>";this.L.trace(`Setting proxy to '${H}', bypassing '${x}'`),this.l.webContents.session.setProxy({proxyRules:H,proxyBypassRules:x,pacScript:""})}}addTabbedWindow(M){y.isMacintosh&&M.win&&this.l.addTabbedWindow(M.win)}load(M,O=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!O.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),O.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.bb.nameLong)),this.qb(M,O),this.hb===0?this.n=M:this.I=M,this.hb=1,this.l.loadURL(g.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const F=this.J;this.J=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new t.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:M.workspace,reason:O.isReload?3:F?2:1})}qb(M,O){const F=(this.n??this.I)?.userEnv;if(F){const U=(0,C.isLaunchedFromCli)(F)&&!(0,C.isLaunchedFromCli)(M.userEnv),H=this.isExtensionDevelopmentHost;(U||H)&&(M.userEnv={...F,...M.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(M.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),O.disableExtensions!==void 0&&(M["disable-extensions"]=O.disableExtensions),M.fullscreen=this.isFullScreen,M.maximized=this.l.isMaximized(),M.partsSplash=this.U.getWindowSplash(),(0,S.mark)("code/willOpenNewWindow"),M.perfMarks=(0,S.getMarks)(),this.H.update(M)}async reload(M){const O=Object.assign({},this.n);O.workspace=await this.rb(O),delete O.filesToOpenOrCreate,delete O.filesToDiff,delete O.filesToMerge,delete O.filesToWait,this.isExtensionDevelopmentHost&&M&&(O.verbose=M.verbose,O.debugId=M.debugId,O.extensionEnvironment=M.extensionEnvironment,O["inspect-extensions"]=M["inspect-extensions"],O["inspect-brk-extensions"]=M["inspect-brk-extensions"],O["extensions-dir"]=M["extensions-dir"]),O.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),O.isInitialStartup=!1,O.policiesData=this.N.serialize(),O.continueOn=this.M.continueOn,O.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile},O.logLevel=this.L.getLevel(),this.load(O,{isReload:!0,disableExtensions:M?.["disable-extensions"]})}async rb(M){if((0,N.isWorkspaceIdentifier)(M.workspace)){const O=M.workspace.configPath;if(O.scheme===g.Schemas.file&&!await this.P.exists(O))return}else if((0,N.isSingleFolderWorkspaceIdentifier)(M.workspace)){const O=M.workspace.uri;if(O.scheme===g.Schemas.file&&!await this.P.exists(O))return}return M.workspace}serializeWindowState(){if(!this.l)return(0,oe.defaultWindowState)();if(this.isFullScreen){let F;try{F=E.screen.getDisplayMatching(this.getBounds())}catch{}const U=(0,oe.defaultWindowState)();return{mode:3,display:F?F.id:void 0,width:this.r.width||U.width,height:this.r.height||U.height,x:this.r.x||0,y:this.r.y||0}}const M=Object.create(null);let O;if(!y.isMacintosh&&this.l.isMaximized()?O=0:O=1,O===0?M.mode=0:M.mode=1,O===1||O===0){let F;O===1?F=this.getBounds():F=this.l.getNormalBounds(),M.x=F.x,M.y=F.y,M.width=F.width,M.height=F.height}return M}updateWindowControls(M){if(M.height&&this.fb.setItem(gt.a,M.height),y.isWindows&&this.z)this.l.setTitleBarOverlay({color:M.backgroundColor?.trim()===""?void 0:M.backgroundColor,symbolColor:M.foregroundColor?.trim()===""?void 0:M.foregroundColor,height:M.height?M.height-1:void 0});else if(y.isMacintosh&&M.height!==void 0){const O=(M.height-15)/2;this.l.setTrafficLightPosition({x:O,y:O})}}sb(M){(0,S.mark)("code/willRestoreCodeWindowState");let O=!1;if(M)try{const F=E.screen.getAllDisplays();O=F.length>1,M=this.tb(M,F)}catch(F){this.L.warn(`Unexpected error validating window state: ${F}
${F.stack}`)}return(0,S.mark)("code/didRestoreCodeWindowState"),[M||(0,oe.defaultWindowState)(),O]}tb(M,O){if(this.L.trace(`window#validateWindowState: validating window state on ${O.length} display(s)`,M),typeof M.x!="number"||typeof M.y!="number"||typeof M.width!="number"||typeof M.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(M.width<=0||M.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(O.length===1){const H=this.ub(O[0]);if(H){let x=function(){!M||typeof M.x!="number"||typeof M.y!="number"||!H||(M.x<H.x&&(M.x=H.x),M.y<H.y&&(M.y=H.y))};this.L.trace("window#validateWindowState: 1 monitor working area",H),x(),M.width>H.width&&(M.width=H.width),M.height>H.height&&(M.height=H.height),M.x>H.x+H.width-128&&(M.x=H.x+H.width-M.width),M.y>H.y+H.height-128&&(M.y=H.y+H.height-M.height),x()}return M}if(M.display&&M.mode===3){const H=O.find(x=>x.id===M.display);if(H&&typeof H.bounds?.x=="number"&&typeof H.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const x=(0,oe.defaultWindowState)(3);return x.x=H.bounds.x,x.y=H.bounds.y,x}}let F,U;try{F=E.screen.getDisplayMatching({x:M.x,y:M.y,width:M.width,height:M.height}),U=this.ub(F)}catch{}if(F&&U&&M.x+M.width>U.x&&M.y+M.height>U.y&&M.x<U.x+U.width&&M.y<U.y+U.height)return this.L.trace("window#validateWindowState: multi-monitor working area",U),M}ub(M){if(M.workArea.width>0&&M.workArea.height>0)return M.workArea;if(M.bounds.width>0&&M.bounds.height>0)return M.bounds}getBounds(){const[M,O]=this.l.getPosition(),[F,U]=this.l.getSize();return{x:M,y:O,width:F,height:U}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(M){this.zb()?this.wb(M):this.yb(M),this.sendWhenReady(M?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.s&&this.Bb(this.s,!1)}get isFullScreen(){return y.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}wb(M){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.xb(M)}xb(M){y.isMacintosh&&(this.t=M,this.u=new t.DeferredPromise,Promise.race([this.u.p,(0,t.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(M)}yb(M){this.l.isFullScreen()&&this.xb(!1),this.l.setSimpleFullScreen(M),this.l.webContents.focus()}zb(){const M=this.S.getValue("window");return!M||typeof M.nativeFullScreen!="boolean"||M.nativeTabs?!0:M.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Ab(){let M=(0,D.getMenuBarVisibility)(this.S);return["visible","toggle","hidden"].indexOf(M)<0&&(M="classic"),M}Bb(M,O=!0){y.isMacintosh||(M==="toggle"&&O&&this.send("vscode:showInfoMessage",(0,f.localize)(15,null)),M==="hidden"?setTimeout(()=>{this.Cb(M)}):this.Cb(M))}Cb(M){const O=this.isFullScreen;switch(M){case"classic":this.l.setMenuBarVisibility(!O),this.l.autoHideMenuBar=O;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(y.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(M,O,...F){this.isReady?this.send(M,...F):this.ready().then(()=>{O.isCancellationRequested||this.send(M,...F)})}send(M,...O){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${M}' for window that is destroyed`);return}try{this.l.webContents.send(M,...O)}catch(F){this.L.warn(`Error sending IPC message to channel '${M}' of window ${this.k}: ${(0,R.toErrorMessage)(F)}`)}}}updateTouchBar(M){!y.isMacintosh||this.D.forEach((O,F)=>{const U=M[F];O.segments=this.Fb(U)})}Db(){if(!!y.isMacintosh){for(let M=0;M<10;M++){const O=this.Eb();this.D.push(O)}this.l.setTouchBar(new E.TouchBar({items:this.D}))}}Eb(M=[]){const O=this.Fb(M),F=new E.TouchBar.TouchBarSegmentedControl({segments:O,mode:"buttons",segmentStyle:"automatic",change:U=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:F.segments[U].id,from:"touchbar"})}});return F}Fb(M=[]){return M.map(F=>{let U;F.icon&&!o.ThemeIcon.isThemeIcon(F.icon)&&F.icon?.dark?.scheme===g.Schemas.file&&(U=E.nativeImage.createFromPath(u.URI.revive(F.icon.dark).fsPath),U.isEmpty()&&(U=void 0));let H;return typeof F.title=="string"?H=F.title:H=F.title.value,{id:F.id,label:U?void 0:H,icon:U}})}dispose(){super.dispose(),this.l=null}};q.a="windowControlHeight",q.b=void 0,q=pe([ee(1,i.ILogService),ee(2,v.IEnvironmentMainService),ee(3,Y.IPolicyService),ee(4,re.IUserDataProfilesMainService),ee(5,I.IFileService),ee(6,s.IApplicationStorageMainService),ee(7,s.IStorageMainService),ee(8,h.IConfigurationService),ee(9,d.IThemeMainService),ee(10,V.IWorkspacesManagementMainService),ee(11,p.IBackupMainService),ee(12,c.ITelemetryService),ee(13,l.IDialogMainService),ee(14,m.ILifecycleMainService),ee(15,n.IProductService),ee(16,r.IProtocolMainService),ee(17,L.IWindowsMainService),ee(18,se.IStateMainService),ee(19,fe.INativeHostMainService)],q),e.CodeWindow=q}),define(ie[75],ne([0,1,13,24,8,3,34,2,14,4,20,7,23,174,5,21,6,93,94,28,52,39]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v,C,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,f.createDecorator)("workspacesHistoryMainService");let i=class rt extends P.Disposable{constructor(r,a,s,c){super(),this.f=r,this.g=a,this.h=s,this.j=c,this.c=this.B(new R.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new k.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){let a=[],s=[];for(const o of r)if((0,v.isRecentWorkspace)(o))!this.g.isUntitledWorkspace(o.workspace)&&!this.r(a,o.workspace)&&a.push(o);else if((0,v.isRecentFolder)(o))this.s(a,o.folderUri)||a.push(o);else{const d=this.t(s,o.fileUri),D=o.fileUri.scheme===w.Schemas.file&&rt.y.indexOf((0,b.basename)(o.fileUri))>=0;!d&&!D&&(s.push(o),g.isWindows&&o.fileUri.scheme===w.Schemas.file&&E.app.addRecentDocument(o.fileUri.fsPath))}const c=await this.l({workspaces:a,files:s});a=c.workspaces,s=c.files,a.length>rt.a&&(a.length=rt.a),s.length>rt.a&&(s.length=rt.a),await this.n({workspaces:a,files:s}),this.c.fire(),g.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(r){const a=d=>{const D=this.p(d);for(const L of r)if(b.extUriBiasedIgnorePathCase.isEqual(L,D))return!1;return!0},s=await this.getRecentlyOpened(),c=s.workspaces.filter(a),o=s.files.filter(a);(c.length!==s.workspaces.length||o.length!==s.files.length)&&(await this.n({files:o,workspaces:c}),this.c.fire(),g.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(r){const a=new m.ResourceMap(o=>b.extUriBiasedIgnorePathCase.getComparisonKey(o));if(r?.workspaces)for(const o of r.workspaces)a.set(this.p(o),o);const s=new m.ResourceMap(o=>b.extUriBiasedIgnorePathCase.getComparisonKey(o));if(r?.files)for(const o of r.files)s.set(this.p(o),o);const c=await this.m();for(const o of c.workspaces){const d=a.get(this.p(o));d?d.label=d.label??o.label:a.set(this.p(o),o)}for(const o of c.files){const d=s.get(this.p(o));d?d.label=d.label??o.label:s.set(this.p(o),o)}return{workspaces:[...a.values()],files:[...s.values()]}}async m(){await this.j.whenReady;let r;const a=this.j.get(rt.b,-1);if(typeof a=="string")try{r=JSON.parse(a)}catch(s){this.f.error("Unexpected error parsing opened paths list",s)}return(0,v.restoreRecentlyOpened)(r,this.f)}async n(r){await this.j.whenReady,this.j.store(rt.b,JSON.stringify((0,v.toStoreData)(r)),-1,1)}p(r){return(0,v.isRecentFolder)(r)?r.folderUri:(0,v.isRecentFile)(r)?r.fileUri:r.workspace.configPath}r(r,a){return!!r.find(s=>(0,v.isRecentWorkspace)(s)&&s.workspace.id===a.id)}s(r,a){return!!r.find(s=>(0,v.isRecentFolder)(s)&&b.extUriBiasedIgnorePathCase.isEqual(s.folderUri,a))}t(r,a){return!!r.find(s=>b.extUriBiasedIgnorePathCase.isEqual(s.fileUri,a))}async C(){!g.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!g.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(0,null),description:(0,u.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const a=[];for(const o of E.app.getJumpListSettings().removedItems){const d=o.args;if(d){const D=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(d);D&&a.push(S.URI.parse(D[2]))}}await this.removeRecentlyOpened(a);let s=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.w).map(o=>{const d=(0,v.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:D,description:L}=this.F(d,o.label);let N;return S.URI.isUri(d)?N=`--folder-uri "${d.toString()}"`:(s=!0,N=`--file-uri "${d.configPath.toString()}"`),{type:"task",title:D.substr(0,255),description:L.substr(0,255),program:process.execPath,args:N,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&r.push({type:"custom",name:s?(0,u.localize)(2,null):(0,u.localize)(3,null),items:c})}r.push({type:"recent"});try{const a=E.app.setJumpList(r);a&&a!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${a}`)}catch(a){this.f.warn("updateWindowsJumpList#setJumpList",a)}}F(r,a){if(a)return{title:(0,A.splitName)(a).name,description:a};if(S.URI.isUri(r))return{title:(0,b.basename)(r),description:this.G(r)};if(this.g.isUntitledWorkspace(r))return{title:(0,u.localize)(4,null),description:""};let s=(0,b.basename)(r.configPath);return s.endsWith(C.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-C.WORKSPACE_EXTENSION.length-1)),{title:(0,u.localize)(5,null,s),description:this.G(r.configPath)}}G(r){return r.scheme==="file"?(0,A.normalizeDriveLetter)(r.fsPath):r.toString()}async H(){if(!g.isMacintosh)return;E.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),a=[];let s=0;for(let o=0;o<r.workspaces.length&&s<rt.u;o++){const d=this.p(r.workspaces[o]);if(d.scheme===w.Schemas.file){const D=(0,b.originalFSPath)(d);await y.Promises.exists(D)&&(a.push(D),s++)}}const c=[];for(let o=0;o<r.files.length&&s<rt.v;o++){const d=this.p(r.files[o]);if(d.scheme===w.Schemas.file){const D=(0,b.originalFSPath)(d);if(rt.y.includes((0,b.basename)(d))||a.includes(D))continue;await y.Promises.exists(D)&&(c.push(D),s++)}}c.reverse().forEach(o=>E.app.addRecentDocument(o)),a.reverse().forEach(o=>E.app.addRecentDocument(o))}};i.a=500,i.b="history.recentlyOpenedPathsList",i.u=7,i.v=10,i.w=7,i.y=["COMMIT_EDITMSG","MERGE_MSG"],i=pe([ee(0,h.ILogService),ee(1,I.IWorkspacesManagementMainService),ee(2,p.ILifecycleMainService),ee(3,l.IApplicationStorageMainService)],i),e.WorkspacesHistoryMainService=i}),define(ie[271],ne([0,1,13,8,22,34,4,7,164,18,27,21,6,212,58,19,36,31,49,74,32,75]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v,C,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let n=class Ft{constructor(s,c,o,d,D,L,N,V,oe,X,Y){this.n=s,this.o=c,this.p=o,this.q=d,this.r=D,this.s=L,this.t=N,this.u=V,this.v=oe,this.w=X,this.x=Y,this.m=Object.create(null),this.g=new t.RunOnceScheduler(()=>this.E(),0),this.h=new t.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.isMacintosh||(0,C.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const s=this.t.getItem(Ft.a);s&&(s.menus&&(this.k=s.menus),s.keybindings&&(this.l=s.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(L,N,V)=>this.p.openEmptyWindow({context:2,contextWindowId:N?.id}),this.m["workbench.action.newWindow"]=(L,N,V)=>this.p.openEmptyWindow({context:2,contextWindowId:N?.id}),this.m["workbench.action.files.openFileFolder"]=(L,N,V)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(V),telemetryExtraData:{from:i}}),this.m["workbench.action.files.openFolder"]=(L,N,V)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(V),telemetryExtraData:{from:i}}),this.m["workbench.action.openWorkspace"]=(L,N,V)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(V),telemetryExtraData:{from:i}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const s=this.x.twitterUrl;s&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(s,"openTwitterUrl"));const c=this.x.requestFeatureUrl;c&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(c,"openUserVoiceUrl"));const o=this.x.reportIssueUrl;o&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(o,"openReportIssues"));const d=this.x.licenseUrl;d&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.language){const L=d.indexOf("?")>0?"&":"?";this.Z(`${d}${L}lang=${A.language}`,"openLicenseUrl")}else this.Z(d,"openLicenseUrl")});const D=this.x.privacyStatementUrl;D&&d&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(D,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(s=>this.F(s)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const s=this.o.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get C(){if(!A.isMacintosh)return!1;const s=this.o.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,c){this.k=s.menus,this.l=s.keybindings,this.t.setItem(Ft.a,s),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(s){!A.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.d=s.newCount===0,this.D())}G(){!A.isMacintosh||(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const s=E.Menu.getApplicationMenu();if(s&&this.j.push(s),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(A.isMacintosh?new E.Menu:null);return}const c=new E.Menu;let o;if(A.isMacintosh){const D=new E.Menu;o=new E.MenuItem({label:this.x.nameShort,submenu:D}),this.I(D),c.append(o)}if(A.isMacintosh&&!this.c){this.c=!0;const D=new E.Menu;D.append(new E.MenuItem({label:this.bb(w.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(D)}if(this.K("File")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(1,null)),submenu:D});this.M(D,"File"),c.append(L)}if(this.K("Edit")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(2,null)),submenu:D});this.M(D,"Edit"),c.append(L)}if(this.K("Selection")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(3,null)),submenu:D});this.M(D,"Selection"),c.append(L)}if(this.K("View")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(4,null)),submenu:D});this.M(D,"View"),c.append(L)}if(this.K("Go")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(5,null)),submenu:D});this.M(D,"Go"),c.append(L)}if(this.K("Run")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(6,null)),submenu:D});this.M(D,"Run"),c.append(L)}if(this.K("Terminal")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(7,null)),submenu:D});this.M(D,"Terminal"),c.append(L)}let d;if(this.K("Window")){const D=new E.Menu;d=new E.MenuItem({label:this.bb(w.localize(8,null)),submenu:D,role:"window"}),this.S(D)}if(d&&c.append(d),this.K("Help")){const D=new E.Menu,L=new E.MenuItem({label:this.bb(w.localize(9,null)),submenu:D,role:"help"});this.M(D,"Help"),c.append(L)}c.items&&c.items.length>0?E.Menu.setApplicationMenu(c):E.Menu.setApplicationMenu(null),this.h.schedule()}I(s){const c=this.U(w.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),o=this.T();let d;if(this.K("Preferences")){const se=new E.Menu;this.M(se,"Preferences"),d=new E.MenuItem({label:this.bb(w.localize(11,null)),submenu:se})}const D=new E.Menu,L=new E.MenuItem({label:w.localize(12,null),role:"services",submenu:D}),N=new E.MenuItem({label:w.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),V=new E.MenuItem({label:w.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),oe=new E.MenuItem({label:w.localize(15,null),role:"unhide"}),X=new E.MenuItem(this.Y("workbench.action.quit",{label:w.localize(16,null,this.x.nameLong),click:async(se,re,fe)=>{const J=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!E.BrowserWindow.getFocusedWindow()||J?.isMinimized())&&await this.J(fe)&&this.w.quit(void 0)}})),Y=[c];Y.push(...o),d&&Y.push(r(),d),Y.push(r(),L,r(),N,V,oe,r(),X),Y.forEach(se=>s.append(se))}async J(s){if(this.p.getWindowCount()===0)return!0;const c=this.o.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.Q(s)){const o={title:this.x.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(w.localize(17,null)),(0,R.mnemonicButtonLabel)(w.localize(18,null))],message:w.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:d}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,o);return d===0}return!0}K(s){if(!A.isMacintosh&&(0,C.getTitleBarStyle)(this.o)==="custom")return!1;switch(s){case"File":case"Help":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[s];case"Window":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[s]}}L(s,c){c.forEach(o=>{if((0,u.isMenubarMenuItemSeparator)(o))s.append(r());else if((0,u.isMenubarMenuItemSubmenu)(o)){const d=new E.Menu,D=new E.MenuItem({label:this.bb(o.label),submenu:d});this.L(d,o.submenu.items),s.append(D)}else(0,u.isMenubarMenuItemRecentAction)(o)?s.append(this.O(o)):(0,u.isMenubarMenuItemAction)(o)&&(o.id==="workbench.action.showAboutDialog"&&this.N(s),A.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[o.id]?s.append(new E.MenuItem(this.Y(o.id,{label:this.bb(o.label),click:this.m[o.id]}))):s.append(this.U(o.label,o.id,!1,o.checked)):s.append(this.U(o.label,o.id,o.enabled!==!1,!!o.checked)):s.append(this.U(o.label,o.id,o.enabled!==!1,!!o.checked)))})}M(s,c){this.k&&this.k[c]&&this.L(s,this.k[c].items)}N(s){const c=this.T();c.length&&(c.forEach(o=>s.append(o)),s.append(r()))}O(s){const c=P.URI.revive(s.uri),o=s.id,d=o==="openRecentFile"?{fileUri:c}:o==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new E.MenuItem(this.Y(o,{label:s.label,click:async(D,L,N)=>{const V=this.P(N);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[d],forceNewWindow:V,gotoLineMode:!1,remoteAuthority:s.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([c])}},!1))}P(s){return!!(s&&(!A.isMacintosh&&(s.ctrlKey||s.shiftKey)||A.isMacintosh&&(s.metaKey||s.altKey)))}Q(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}R(s,c,o){const d={label:this.bb(s),role:o,enabled:!0};return new E.MenuItem(this.X(c,d))}S(s){const c=new E.MenuItem({label:w.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),o=new E.MenuItem({label:w.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),d=new E.MenuItem({label:w.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),D=this.U(w.localize(23,null),"workbench.action.switchWindow"),L=[];this.C&&(L.push(r()),L.push(this.U(w.localize(24,null),"workbench.action.newWindowTab")),L.push(this.R(w.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.R(w.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.R(w.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.R(w.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,o,r(),D,...L,r(),d].forEach(N=>s.append(N))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.bb(w.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:w.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.bb(w.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:w.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.bb(w.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:w.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.bb(w.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(s,c,o,d){const D=this.bb(s),L=typeof c=="function"?c:(Y,se,re)=>{const fe=Y?Y.userSettingsLabel:null;let J=c;Array.isArray(c)&&(J=this.P(re)?c[1]:c[0]),fe&&re.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:fe}):this.W({type:"commandId",commandId:J})},N=typeof o=="boolean"?o:this.p.getWindowCount()>0,V=typeof d=="boolean"?d:!1,oe={label:D,click:L,enabled:N};V&&(oe.type="checkbox",oe.checked=V);let X;return typeof c=="string"?X=c:Array.isArray(c)&&(X=c[0]),A.isMacintosh&&(X==="editor.action.clipboardCutAction"?oe.role="cut":X==="editor.action.clipboardCopyAction"?oe.role="copy":X==="editor.action.clipboardPasteAction"&&(oe.role="paste"),X==="undo"?oe.click=this.V(L,{inDevTools:Y=>Y.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):X==="redo"?oe.click=this.V(L,{inDevTools:Y=>Y.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):X==="editor.action.selectAll"&&(oe.click=this.V(L,{inDevTools:Y=>Y.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(X,oe))}V(s,c){return(o,d,D)=>{const L=E.BrowserWindow.getFocusedWindow();if(!L)return c.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return c.inDevTools(L.webContents.devToolsWebContents);s(o,d||L,D)}}W(s){let c=E.BrowserWindow.getFocusedWindow();if(!c){const d=this.p.getLastActiveWindow();d?.isMinimized()&&(c=d.win)}const o=c?this.p.getWindowById(c.id):void 0;if(o){if(this.v.trace("menubar#runActionInRenderer",s),A.isMacintosh&&!this.q.isBuilt&&!o.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const d={id:s.commandId,from:"menu"};o.sendWhenReady("vscode:runAction",k.CancellationToken.None,d)}else{const d={userSettingsLabel:s.userSettingsLabel};o.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,d)}}else this.v.trace("menubar#runActionInRenderer: no active window found",s)}X(s,c){const o=typeof s=="string"?this.l[s]:void 0;if(o?.label){if(o.isNative!==!1)c.accelerator=o.label,c.userSettingsLabel=o.userSettingsLabel;else if(typeof c.label=="string"){const d=c.label.indexOf("[");d>=0?c.label=`${c.label.substr(0,d)} [${o.label}]`:c.label=`${c.label} [${o.label}]`}}else c.accelerator=void 0;return c}Y(s,c,o=!c.accelerator){o&&(c=this.X(s,c));const d=c.click;return c.click=(D,L,N)=>{this.ab(s),d?.(D,L,N)},c}Z(s,c){this.w.openExternal(void 0,s),this.ab(c)}ab(s){this.r.publicLog2("workbenchActionExecuted",{id:s,from:i})}bb(s){return(0,R.mnemonicMenuLabel)(s,!this.B)}};n.a="lastKnownMenubarData",n=pe([ee(0,v.IUpdateService),ee(1,g.IConfigurationService),ee(2,I.IWindowsMainService),ee(3,b.IEnvironmentMainService),ee(4,l.ITelemetryService),ee(5,m.IWorkspacesHistoryMainService),ee(6,h.IStateMainService),ee(7,S.ILifecycleMainService),ee(8,y.ILogService),ee(9,f.INativeHostMainService),ee(10,p.IProductService)],n),e.Menubar=n;function r(){return new E.MenuItem({type:"separator"})}}),define(ie[272],ne([0,1,5,21,6,271]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let A=class{constructor(w,g,b){this.b=w,this.c=g,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.Menubar)}async updateMenubar(w,g){this.d.trace("menubarService#updateMenubar",w),(await this.a).updateMenu(g,w)}};A=pe([ee(0,E.IInstantiationService),ee(1,t.ILifecycleMainService),ee(2,k.ILogService)],A),e.MenubarMainService=A}),define(ie[273],ne([0,1,13,23,25,24,22,3,30,50,34,2,14,9,73,4,33,20,11,7,172,62,18,57,27,16,5,21,6,63,19,64,54,36,74,270,118,265,28,95,75,52,66,37,51]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v,C,I,m,i,n,r,a,s,c,o,d,D,L,N,V,oe,X,Y,se,re,fe,J,le,$,W,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(j){return(0,re.isWorkspaceIdentifier)(j?.workspace)}function Q(j){return(0,re.isSingleFolderWorkspaceIdentifier)(j?.workspace)}let q=class mt extends S.Disposable{constructor(M,O,F,U,H,x,B,_,Z,ae,ge,ke,Oe,De,Le,ve,we,ye){super(),this.k=M,this.l=O,this.m=F,this.n=U,this.r=H,this.s=x,this.t=B,this.u=_,this.v=Z,this.w=ae,this.z=ge,this.C=ke,this.D=Oe,this.F=De,this.G=Le,this.H=ve,this.I=we,this.J=ye,this.b=this.B(new P.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new P.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new P.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new P.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new P.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new se.WindowsStateHandler(this,this.n,this.u,this.m,this.w)),this.L()}L(){this.B(this.C.onDidEnterWorkspace(M=>this.c.fire(M.window))),this.B(this.onDidSignalReadyWindow(M=>{if(M.config?.extensionDevelopmentPath||M.config?.extensionTestsPath){const O=new S.DisposableStore;if(O.add(P.Event.any(M.onDidClose,M.onDidDestroy)(()=>O.dispose())),M.config.extensionDevelopmentPath)for(const F of M.config.extensionDevelopmentPath)O.add(this.I.addValidFileRoot(F));M.config.extensionTestsPath&&O.add(this.I.addValidFileRoot(M.config.extensionTestsPath))}}))}openEmptyWindow(M,O){const F=this.s.args,U=O?.remoteAuthority||void 0,H=!0,x=O?.forceReuseWindow,B=!x;return this.open({...M,cli:F,forceEmpty:H,forceNewWindow:B,forceReuseWindow:x,remoteAuthority:U})}openExistingWindow(M,O){M.focus(),this.M(O,[M])}async open(M){this.m.trace("windowsManager#open"),M.addMode&&(M.initialStartup||!this.getLastActiveWindow())&&(M.addMode=!1);const O=[],F=[],U=[],H=[],x=[];let B,_=0;const Z=await this.S(M);this.m.trace("windowsManager#open pathsToOpen",Z);for(const De of Z)Q(De)?M.addMode?O.push(De):F.push(De):z(De)?U.push(De):De.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),B.filesToOpenOrCreate.push(De)):De.backupPath?x.push({backupFolder:(0,u.basename)(De.backupPath),remoteAuthority:De.remoteAuthority}):_++;M.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),M.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&M.waitMarkerFileURI&&(B.filesToWait={paths:(0,R.coalesce)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:M.waitMarkerFileURI}),M.initialStartup?(H.push(...this.C.getUntitledWorkspaces()),U.push(...H),x.push(...this.v.getEmptyWindowBackups())):x.length=0;const{windows:ae,filesOpenedInWindow:ge}=await this.N(M,U,F,x,_,B,O);if(this.m.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${U.length}, foldersToOpen: ${F.length}, emptyToRestore: ${x.length}, emptyToOpen: ${_})`),ae.length>1)if(ge)ge.focus();else{const De=this.j.state.lastActiveWindow&&!M.forceEmpty&&!M.cli._.length&&!M.cli["file-uri"]&&!M.cli["folder-uri"]&&!(M.urisToOpen&&M.urisToOpen.length);let Le=!0,ve=!0;if(De){const we=ae.filter(ye=>this.j.state.lastActiveWindow&&ye.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Le=!1,ve=!1)}if(Le)for(let we=ae.length-1;we>=0;we--){const ye=ae[we];if(!(ye.openedWorkspace&&H.some(Me=>ye.openedWorkspace&&Me.workspace.id===ye.openedWorkspace.id)||ye.backupPath&&x.some(Me=>ye.backupPath&&Me.backupFolder===(0,u.basename)(ye.backupPath)))){ye.focus(),ve=!1;break}}ve&&ae[ae.length-1].focus()}const ke=B&&B.filesToDiff.length>0,Oe=B&&B.filesToMerge.length>0;if(!ae.some(De=>De.isExtensionDevelopmentHost)&&!ke&&!Oe&&!M.noRecentEntry){const De=[];for(const Le of Z)z(Le)&&!Le.transient?De.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):Q(Le)?De.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&De.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.z.addRecentlyOpened(De)}return this.M(M,ae),ae}M(M,O){const F=M.waitMarkerFileURI;M.context===0&&F&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.G.del(F)}catch{}})()}async N(M,O,F,U,H,x,B){const _=[];let Z;function ae(we,ye){_.push(we),ye&&(Z=we,x=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:ke}=this.fb(M);if(!M.initialStartup&&B.length>0){const we=B[0].remoteAuthority,ye=this.kb(we);ye&&ae(this.P(ye,B.map(Me=>Me.workspace.uri)))}const Oe=F.length+O.length+U.length;if(x&&Oe===0){const we=x.filesToOpenOrCreate[0]||x.filesToDiff[0]||x.filesToMerge[3],ye=this.getWindows().filter(te=>x&&(0,l.isEqualAuthority)(te.remoteAuthority,x.remoteAuthority));let Me;we?.fileUri&&!ke&&((M.context===4||M.context===0||M.context===1)&&(Me=await(0,Y.findWindowOnFile)(ye,we.fileUri,async te=>te.configPath.scheme===y.Schemas.file?this.C.resolveLocalWorkspace(te.configPath):void 0)),Me||(Me=this.lb(ye))),Me?(0,re.isWorkspaceIdentifier)(Me.openedWorkspace)?O.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(Me.openedWorkspace)?F.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):ae(this.O(M,Me,x),!0):ae(await this.gb({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,filesToOpen:x,forceNewWindow:!0,remoteAuthority:x.remoteAuthority,forceNewTabbedWindow:M.forceNewTabbedWindow,forceProfile:M.forceProfile,forceTempProfile:M.forceTempProfile}),!0)}const De=(0,R.distinct)(O,we=>we.workspace.id);if(De.length>0){const we=(0,R.coalesce)(De.map(ye=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.configPath)));if(we.length>0){const ye=we[0],Me=(0,l.isEqualAuthority)(x?.remoteAuthority,ye.remoteAuthority)?x:void 0;ae(this.O(M,ye,Me),!!Me),ge=!0}for(const ye of De){if(we.some(he=>he.openedWorkspace&&he.openedWorkspace.id===ye.workspace.id))continue;const Me=ye.remoteAuthority,te=(0,l.isEqualAuthority)(x?.remoteAuthority,Me)?x:void 0;ae(await this.R(M,ye,ge,te),!!te),ge=!0}}const Le=(0,R.distinct)(F,we=>l.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Le.length>0){const we=(0,R.coalesce)(Le.map(ye=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.uri)));if(we.length>0){const ye=we[0],Me=(0,l.isEqualAuthority)(x?.remoteAuthority,ye.remoteAuthority)?x:void 0;ae(this.O(M,ye,Me),!!Me),ge=!0}for(const ye of Le){if(we.some(he=>(0,re.isSingleFolderWorkspaceIdentifier)(he.openedWorkspace)&&l.extUriBiasedIgnorePathCase.isEqual(he.openedWorkspace.uri,ye.workspace.uri)))continue;const Me=ye.remoteAuthority,te=(0,l.isEqualAuthority)(x?.remoteAuthority,Me)?x:void 0;ae(await this.R(M,ye,ge,te),!!te),ge=!0}}const ve=(0,R.distinct)(U,we=>we.backupFolder);if(ve.length>0)for(const we of ve){const ye=we.remoteAuthority,Me=(0,l.isEqualAuthority)(x?.remoteAuthority,ye)?x:void 0;ae(await this.Q(M,!0,ye,Me,we),!!Me),ge=!0}if(_.length===0||x){x&&!H&&H++;const we=x?x.remoteAuthority:M.remoteAuthority;for(let ye=0;ye<H;ye++)ae(await this.Q(M,ge,we,x),!!x),ge=!0}return{windows:(0,R.distinct)(_),filesOpenedInWindow:Z}}O(M,O,F){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),O.focus();const U={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToMerge:F?.filesToMerge,filesToWait:F?.filesToWait,termProgram:M?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",A.CancellationToken.None,U),O}P(M,O){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),M.focus();const F={foldersToAdd:O};return M.sendWhenReady("vscode:addFolders",A.CancellationToken.None,F),M}Q(M,O,F,U,H){this.m.trace("windowsManager#doOpenEmpty",{restore:!!H,remoteAuthority:F,filesToOpen:U,forceNewWindow:O});let x;return!O&&typeof M.contextWindowId=="number"&&(x=this.getWindowById(M.contextWindowId)),this.gb({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:F,forceNewWindow:O,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:U,windowToUse:x,emptyWindowBackupInfo:H,forceProfile:M.forceProfile,forceTempProfile:M.forceTempProfile})}R(M,O,F,U,H){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:U}),!F&&!H&&typeof M.contextWindowId=="number"&&(H=this.getWindowById(M.contextWindowId)),this.gb({workspace:O.workspace,userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:U,windowToUse:H,forceProfile:M.forceProfile,forceTempProfile:M.forceTempProfile})}async S(M){let O,F=!1,U=!1;if(M.urisToOpen&&M.urisToOpen.length>0?(O=await this.U(M),F=!0):M.forceEmpty?O=[Object.create(null)]:M.cli._.length||M.cli["folder-uri"]||M.cli["file-uri"]?(O=await this.W(M.cli),O.length===0&&O.push(Object.create(null)),F=!0):(O=await this.Y(),O.length===0&&O.push(Object.create(null)),U=!0),!M.addMode&&F){const H=O.filter(x=>Q(x));if(H.length>1){const x=H[0].remoteAuthority;if(H.every(B=>(0,l.isEqualAuthority)(B.remoteAuthority,x))){const B=await this.C.createUntitledWorkspace(H.map(_=>({uri:_.workspace.uri})));O.push({workspace:B,remoteAuthority:x}),O=O.filter(_=>!Q(_))}}}if(M.initialStartup&&!U&&this.w.getValue("window")?.restoreWindows==="preserve"){const H=await this.Y();O.unshift(...H.filter(x=>z(x)||Q(x)||x.backupPath))}return O}async U(M){const O={gotoLineMode:M.gotoLineMode,remoteAuthority:M.remoteAuthority},F=await Promise.all((0,R.coalesce)(M.urisToOpen||[]).map(async U=>{const H=await this.ab(U,O);if(H)return H.label=U.label,H;const x=this.cb(U),B={title:this.H.nameLong,type:"info",buttons:[(0,b.mnemonicButtonLabel)((0,I.localize)(0,null))],defaultId:0,message:x.scheme===y.Schemas.file?(0,I.localize)(1,null):(0,I.localize)(2,null),detail:x.scheme===y.Schemas.file?(0,I.localize)(3,null,(0,b.getPathLabel)(x,{os:p.OS,tildify:this.s})):(0,I.localize)(4,null,x.toString(!0)),noLink:!0};this.F.showMessageBox(B,(0,v.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(F)}async W(M){const O=[],F={ignoreFileNotFound:!0,gotoLineMode:M.goto,remoteAuthority:M.remote||void 0,forceOpenWorkspaceAsFile:M.diff&&M._.length===2||M.merge&&M._.length===4},U=M["folder-uri"];if(U){const B=await Promise.all(U.map(_=>{const Z=this.X(_);if(!!Z)return this.ab({folderUri:Z},F)}));O.push(...(0,R.coalesce)(B))}const H=M["file-uri"];if(H){const B=await Promise.all(H.map(_=>{const Z=this.X(_);if(!!Z)return this.ab((0,re.hasWorkspaceFileExtension)(_)?{workspaceUri:Z}:{fileUri:Z},F)}));O.push(...(0,R.coalesce)(B))}const x=await Promise.all(M._.map(B=>F.remoteAuthority?this.eb(B,F):this.db(B,F)));return O.push(...(0,R.coalesce)(x)),O}X(M){try{const O=C.URI.parse(M);if(!O.scheme){this.m.error(`Invalid URI input string, scheme missing: ${M}`);return}return O}catch(O){this.m.error(`Invalid URI input string: ${M}, ${O.message}`)}}async Y(){const M=this.Z();switch(M){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];M!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const F=await Promise.all(O.map(async U=>{if(U.workspace){const H=await this.ab({workspaceUri:U.workspace.configPath},{remoteAuthority:U.remoteAuthority,rejectTransientWorkspaces:!0});if(z(H))return H}else if(U.folderUri){const H=await this.ab({folderUri:U.folderUri},{remoteAuthority:U.remoteAuthority});if(Q(H))return H}else if(M!=="folders"&&U.backupPath)return{backupPath:U.backupPath,remoteAuthority:U.remoteAuthority}}));return(0,R.coalesce)(F)}}}Z(){let M;return this.u.wasRestarted?M="all":(M=this.w.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(M)||(M="all")),M}async ab(M,O=Object.create(null)){const F=this.cb(M);return F.scheme===y.Schemas.file?((0,oe.isFileToOpen)(M)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.db(F.fsPath,O)):this.bb(M,O)}bb(M,O){let F=this.cb(M);const U=(0,N.getRemoteAuthority)(F)||O.remoteAuthority;if(F=(0,l.removeTrailingPathSeparator)((0,l.normalizePath)(F)),(0,oe.isFileToOpen)(M)){if(O.gotoLineMode){const{path:H,line:x,column:B}=(0,w.parseLineAndColumnAware)(F.path);return{fileUri:F.with({path:H}),options:{selection:x?{startLineNumber:x,startColumn:B||1}:void 0},remoteAuthority:U}}return{fileUri:F,remoteAuthority:U}}else if((0,oe.isWorkspaceToOpen)(M))return{workspace:(0,fe.getWorkspaceIdentifier)(F),remoteAuthority:U};return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(F),remoteAuthority:U}}cb(M){return(0,oe.isWorkspaceToOpen)(M)?M.workspaceUri:(0,oe.isFolderToOpen)(M)?M.folderUri:M.fileUri}async db(M,O){let F,U;O.gotoLineMode&&({path:M,line:F,column:U}=(0,w.parseLineAndColumnAware)(M)),M=(0,w.sanitizeFilePath)((0,u.normalize)(M),(0,h.cwd)());try{const H=await t.Promises.stat(M);if(H.isFile()){if(!O.forceOpenWorkspaceAsFile){const x=await this.C.resolveLocalWorkspace(C.URI.file(M));if(x)return x.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:x.id,configPath:x.configPath},type:a.FileType.File,exists:!0,remoteAuthority:x.remoteAuthority,transient:x.transient}}return{fileUri:C.URI.file(M),type:a.FileType.File,exists:!0,options:{selection:F?{startLineNumber:F,startColumn:U||1}:void 0}}}else{if(H.isDirectory())return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(C.URI.file(M),H),type:a.FileType.Directory,exists:!0};if(!p.isWindows&&M==="/dev/null")return{fileUri:C.URI.file(M),type:a.FileType.File,exists:!0}}}catch{const x=C.URI.file(M);if(this.z.removeRecentlyOpened([x]),O.ignoreFileNotFound)return{fileUri:x,type:a.FileType.File,exists:!1}}}eb(M,O){const F=M.charCodeAt(0),U=O.remoteAuthority;let H,x;O.gotoLineMode&&({path:M,line:H,column:x}=(0,w.parseLineAndColumnAware)(M)),F!==47&&((0,w.isWindowsDriveLetter)(F)&&M.charCodeAt(M.charCodeAt(1))===58&&(M=(0,w.toSlashes)(M)),M=`/${M}`);const B=C.URI.from({scheme:y.Schemas.vscodeRemote,authority:U,path:M});if(M.charCodeAt(M.length-1)!==47){if((0,re.hasWorkspaceFileExtension)(M))return O.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:H?{startLineNumber:H,startColumn:x||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,fe.getWorkspaceIdentifier)(B),remoteAuthority:U};if(O.gotoLineMode||u.posix.basename(M).indexOf(".")!==-1)return{fileUri:B,options:{selection:H?{startLineNumber:H,startColumn:x||1}:void 0},remoteAuthority:U}}return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:U}}fb(M){const O=this.w.getValue("window"),F=O?.openFoldersInNewWindow||"default",U=O?.openFilesInNewWindow||"off";let H=(M.preferNewWindow||M.forceNewWindow)&&!M.forceReuseWindow;!M.forceNewWindow&&!M.forceReuseWindow&&(F==="on"||F==="off")&&(H=F==="on");let x=!1;return M.forceNewWindow||M.forceReuseWindow?x=!!M.forceNewWindow&&!M.forceReuseWindow:(p.isMacintosh?M.context===1&&(x=!0):M.context!==3&&M.context!==2&&!(M.userEnv&&M.userEnv.TERM_PROGRAM==="vscode")&&(x=!0),!M.cli.extensionDevelopmentPath&&(U==="on"||U==="off")&&(x=U==="on")),{openFolderInNewWindow:!!H,openFilesInNewWindow:x}}async openExtensionDevelopmentHostWindow(M,O){const F=(0,Y.findWindowOnExtensionDevelopmentPath)(this.getWindows(),M);if(F)return this.u.reload(F,O.cli),F.focus(),[F];let U=O.cli["folder-uri"]||[],H=O.cli["file-uri"]||[],x=O.cli._;if(!x.length&&!U.length&&!H.length&&!O.cli.extensionTestsPath){const Z=this.j.state.lastPluginDevelopmentHostWindow,ae=Z?.workspace??Z?.folderUri;ae&&(C.URI.isUri(ae)?ae.scheme===y.Schemas.file?x=[ae.fsPath]:U=[ae.toString()]:ae.configPath.scheme===y.Schemas.file?x=[(0,l.originalFSPath)(ae.configPath)]:H=[ae.configPath.toString()])}let B=O.remoteAuthority;for(const Z of M)if(Z.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ae=C.URI.parse(Z),ge=(0,N.getRemoteAuthority)(ae);ge&&(B?(0,l.isEqualAuthority)(ge,B)||this.m.error("more than one extension development path authority"):B=ge)}x=x.filter(Z=>{const ae=C.URI.file(Z);return(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:(0,l.isEqualAuthority)((0,N.getRemoteAuthority)(ae),B)}),U=U.filter(Z=>{const ae=this.X(Z);return ae&&!!(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,l.isEqualAuthority)((0,N.getRemoteAuthority)(ae),B):!1}),H=H.filter(Z=>{const ae=this.X(Z);return ae&&!!(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,l.isEqualAuthority)((0,N.getRemoteAuthority)(ae),B):!1}),O.cli._=x,O.cli["folder-uri"]=U,O.cli["file-uri"]=H;const _={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!x.length&&!U.length&&!H.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:B,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(_)}async gb(M){const O=this.w.getValue("window");let F;!M.forceNewWindow&&!M.forceNewTabbedWindow&&(F=M.windowToUse||this.getLastActiveWindow(),F&&F.focus());const U={...this.s.args,...M.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.s.appRoot,execPath:process.execPath,codeCachePath:this.s.codeCachePath,backupPath:M.emptyWindowBackupInfo?(0,u.join)(this.s.backupHome,M.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.t.profiles,profile:F?.isExtensionDevelopmentHost&&F?.profile?F.profile:await this.ib(M)},homeDir:this.s.userHome.fsPath,tmpDir:this.s.tmpDir.fsPath,userDataDir:this.s.userDataPath,remoteAuthority:M.remoteAuthority,workspace:M.workspace,userEnv:{...this.l,...M.userEnv},filesToOpenOrCreate:M.filesToOpen?.filesToOpenOrCreate,filesToDiff:M.filesToOpen?.filesToDiff,filesToMerge:M.filesToOpen?.filesToMerge,filesToWait:M.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),logsPath:this.s.logsPath,product:d.default,isInitialStartup:M.initialStartup,perfMarks:(0,f.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.r.serialize(),continueOn:this.s.continueOn};if(F){const H=F.config;!U.extensionDevelopmentPath&&H?.extensionDevelopmentPath&&(U.extensionDevelopmentPath=H.extensionDevelopmentPath,U.extensionDevelopmentKind=H.extensionDevelopmentKind,U["enable-proposed-api"]=H["enable-proposed-api"],U.verbose=H.verbose,U["inspect-extensions"]=H["inspect-extensions"],U["inspect-brk-extensions"]=H["inspect-brk-extensions"],U.debugId=H.debugId,U.extensionEnvironment=H.extensionEnvironment,U["extensions-dir"]=H["extensions-dir"],U["disable-extensions"]=H["disable-extensions"])}else{const H=this.j.getNewWindowState(U);(0,f.mark)("code/willCreateCodeWindow");const x=F=this.D.createInstance(X.CodeWindow,{state:H,extensionDevelopmentPath:U.extensionDevelopmentPath,isExtensionTestHost:!!U.extensionTestsPath});(0,f.mark)("code/didCreateCodeWindow"),M.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(x),mt.a.push(x),this.b.fire(x),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,g.once)(x.onDidSignalReady)(()=>this.c.fire(x)),(0,g.once)(x.onDidClose)(()=>this.jb(x)),(0,g.once)(x.onDidDestroy)(()=>this.f.fire(x)),x.onDidTriggerSystemContextMenu(({x:_,y:Z})=>this.h.fire({window:x,x:_,y:Z}));const B=(0,v.assertIsDefined)(x.win?.webContents);B.removeAllListeners("devtools-reload-page"),B.on("devtools-reload-page",()=>this.u.reload(x)),this.u.registerWindow(x)}return U.windowId=F.id,F.isReady?this.u.unload(F,4).then(H=>{H||this.hb(F,U,M)}):this.hb(F,U,M),F}hb(M,O,F){O.extensionDevelopmentPath||((0,re.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.v.registerEmptyWindowBackup({backupFolder:F.emptyWindowBackupInfo?.backupFolder??(0,fe.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),M.load(O)}async ib(M){let O;return this.t.isEnabled()&&(M.forceProfile?O=this.t.profiles.find(F=>F.name===M.forceProfile)??await this.t.createNamedProfile(M.forceProfile):M.forceTempProfile&&(O=await this.t.createTransientProfile())),O?M.cli?.extensionDevelopmentPath||this.t.setProfileForWorkspaceSync(M.workspace??"empty-window",O):O=this.t.getOrSetProfileForWorkspace(M.workspace??"empty-window",(M.windowToUse??this.getLastActiveWindow())?.profile??this.t.defaultProfile),O}jb(M){const O=mt.a.indexOf(M);mt.a.splice(O,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const M=E.BrowserWindow.getFocusedWindow();if(M)return this.getWindowById(M.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(M){return this.lb(this.getWindows().filter(O=>(0,l.isEqualAuthority)(O.remoteAuthority,M)))}lb(M){const O=Math.max.apply(Math,M.map(F=>F.lastFocusTime));return M.find(F=>F.lastFocusTime===O)}sendToFocused(M,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(M,A.CancellationToken.None,...O)}sendToAll(M,O,F){for(const U of this.getWindows())F&&F.indexOf(U.id)>=0||U.sendWhenReady(M,A.CancellationToken.None,O)}getWindows(){return mt.a}getWindowCount(){return mt.a.length}getWindowById(M){const O=this.getWindows().filter(F=>F.id===M);return(0,R.firstOrDefault)(O)}getWindowByWebContents(M){const O=E.BrowserWindow.fromWebContents(M);if(!!O)return this.getWindowById(O.id)}};q.a=[],q=pe([ee(2,o.ILogService),ee(3,V.IStateMainService),ee(4,W.IPolicyService),ee(5,r.IEnvironmentMainService),ee(6,T.IUserDataProfilesMainService),ee(7,c.ILifecycleMainService),ee(8,m.IBackupMainService),ee(9,i.IConfigurationService),ee(10,J.IWorkspacesHistoryMainService),ee(11,le.IWorkspacesManagementMainService),ee(12,s.IInstantiationService),ee(13,n.IDialogMainService),ee(14,a.IFileService),ee(15,D.IProductService),ee(16,L.IProtocolMainService),ee(17,$.IThemeMainService)],q),e.WindowsMainService=q}),define(ie[274],ne([0,1,62,32,75,52]),function(G,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let A=class{constructor(w,g,b,S){this.a=w,this.b=g,this.c=b,this.d=S,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(w,g){const b=this.b.getWindowById(w);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),g)}createUntitledWorkspace(w,g,b){return this.a.createUntitledWorkspace(g,b)}deleteUntitledWorkspace(w,g){return this.a.deleteUntitledWorkspace(g)}getWorkspaceIdentifier(w,g){return this.a.getWorkspaceIdentifier(g)}getRecentlyOpened(w){return this.c.getRecentlyOpened()}addRecentlyOpened(w,g){return this.c.addRecentlyOpened(g)}removeRecentlyOpened(w,g){return this.c.removeRecentlyOpened(g)}clearRecentlyOpened(w){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};A=pe([ee(0,R.IWorkspacesManagementMainService),ee(1,t.IWindowsMainService),ee(2,k.IWorkspacesHistoryMainService),ee(3,E.IBackupMainService)],A),e.WorkspacesMainService=A}),define(ie[275],ne([0,1,13,41,25,17,45,15,30,50,43,34,2,14,9,4,11,7,29,131,47,145,103,251,148,62,266,18,71,180,84,119,57,106,203,27,61,111,193,215,194,253,107,195,196,16,207,86,70,5,85,267,228,254,21,6,209,272,58,19,54,260,88,36,257,93,89,31,233,112,56,49,242,243,268,244,269,115,246,247,248,249,255,32,273,256,28,94,75,274,52,252,37,214,51,224,55,91,117,258,264,262,8,113]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v,C,I,m,i,n,r,a,s,c,o,d,D,L,N,V,oe,X,Y,se,re,fe,J,le,$,W,T,z,Q,q,j,M,O,F,U,H,x,B,_,Z,ae,ge,ke,Oe,De,Le,ve,we,ye,Me,te,he,de,be,Pe,We,Te,qe,Ue,je,Xe,$e,Ke,K,ce,ue,me,Se,Ae,Be,it,xe,He,tt,nt,lt,at,Bt,$t,Wt,zt,qt,Ht,Vt,Pt,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends y.Disposable{constructor(Ee,Ce,Re,Ie,Fe,ze,_e,et,Ne,Ge,Je){super(),this.c=Ee,this.f=Ce,this.g=Re,this.h=Ie,this.i=Fe,this.j=ze,this.k=_e,this.l=et,this.m=Ne,this.n=Ge,this.p=Je,this.r(),this.s()}r(){const Ee=Ne=>Ne?.startsWith(`${u.Schemas.vscodeWebview}://`),Ce=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?Je(Ce.has(Ge)):Je(!1)),E.session.defaultSession.setPermissionCheckHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?Ce.has(Ge):!1);const Re=new Set([u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemoteResource,"devtools"]),Ie=Ne=>{for(let Ge=Ne;Ge;Ge=Ge.parent)if(Ge.url.startsWith(`${u.Schemas.vscodeWebview}://`))return!0;return!1},Fe=Ne=>Ne.resourceType==="xhr"||Ie(Ne.frame),ze=Ne=>{const Ge=Ne.frame;if(!Ge||!this.a)return!1;const Je=E.BrowserWindow.getAllWindows();for(const Ze of Je)if(Ge.processId===Ze.webContents.mainFrame.processId)return!0;return!1},_e=(Ne,Ge)=>{if(Ne.path!=="/index.html")return!0;const Je=Ge.frame;if(!Je||!this.a)return!1;for(const Ze of this.a.getWindows())if(Ze.win&&Je.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Ne,Ge)=>{const Je=l.URI.parse(Ne.url);return Je.scheme===u.Schemas.vscodeWebview&&!_e(Je,Ne)?(this.h.error("Blocked vscode-webview request",Ne.url),Ge({cancel:!0})):Je.scheme===u.Schemas.vscodeFileResource&&!ze(Ne)?(this.h.error("Blocked vscode-file request",Ne.url),Ge({cancel:!0})):Je.path.endsWith(".svg")&&!Re.has(Je.scheme)?Ge({cancel:!Fe(Ne)}):Ge({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Ne,Ge)=>{const Je=Ne.responseHeaders,Ze=Je["content-type"]||Je["Content-Type"];if(Ze&&Array.isArray(Ze)){const st=l.URI.parse(Ne.url);if(st.path.endsWith(".svg")&&Re.has(st.scheme))return Je["Content-Type"]=["image/svg+xml"],Ge({cancel:!1,responseHeaders:Je});if(!st.path.endsWith(u.Schemas.vscodeRemoteResource)&&Ze.some(ct=>ct.toLowerCase().includes("image/svg")))return Ge({cancel:!Fe(Ne)})}return Ge({cancel:!1})});const et=E.session.defaultSession;typeof et.setCodeCachePath=="function"&&this.i.codeCachePath&&et.setCodeCachePath((0,f.join)(this.i.codeCachePath,"chrome"))}s(){(0,P.setUnexpectedErrorHandler)(Re=>this.u(Re)),process.on("uncaughtException",Re=>(0,P.onUnexpectedError)(Re)),process.on("unhandledRejection",Re=>(0,P.onUnexpectedError)(Re)),this.j.onWillShutdown(()=>this.dispose()),(0,C.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(Re,Ie)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),E.app.on("activate",async(Re,Ie)=>{this.h.trace("app#activate"),Ie||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(Re,Ie)=>{Ie.on("will-navigate",Fe=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),Ie.setWindowOpenHandler(({url:Fe})=>(this.b?.openExternal(void 0,Fe),{action:"deny"}))});let Ee=[],Ce;E.app.on("open-file",(Re,Ie)=>{this.h.trace("app#open-file: ",Ie),Re.preventDefault(),Ee.push((0,Ae.hasWorkspaceFileExtension)(Ie)?{workspaceUri:l.URI.file(Ie)}:{fileUri:l.URI.file(Ie)}),Ce!==void 0&&(clearTimeout(Ce),Ce=void 0),Ce=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],Ce=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Re=>{const Ie=this.a?.getWindowByWebContents(Re.sender);let Fe,ze;return Ie?.config?(Fe=Ie.config,ze={...process.env,...Ie.config.userEnv}):(Fe=this.i.args,ze=process.env),this.J(Fe,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Re,Ie,Fe)=>{const ze=this.t([Ie]);if(!ze||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(ze,R.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Re,...Ie)=>{const Fe=this.t(Ie);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Re=>Re.sender.reload())}t(Ee){let Ce;for(const Re of Ee)typeof Re=="string"&&(typeof Ce!="string"?Ce=Re:Ce=(0,f.join)(Ce,Re));if(!(typeof Ce!="string"||!(0,f.isAbsolute)(Ce)||!(0,w.isEqualOrParent)(Ce,this.i.cachedLanguagesPath,!p.isLinux)))return l.URI.file(Ce)}u(Ee){if(Ee){const Ce={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ce))}this.h.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.h.error(Ee.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Ee=this.n.win32AppUserModelId;p.isWindows&&Ee&&E.app.setAppUserModelId(Ee);try{p.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const Ce=new m.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&Ce.dispose()}),this.h.trace("Resolving machine identifier...");const Re=await(0,Gt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${Re}`);const{sharedProcess:Ie,sharedProcessReady:Fe,sharedProcessClient:ze}=this.w(Re),_e=await this.y(Re,Ie,Fe);this.v(_e),_e.invokeFunction(Ne=>this.z(Ne,Ce,ze)),await _e.invokeFunction(Ne=>this.C(Ne,Ce)),_e.invokeFunction(Ne=>this.G(Ne,Ie)),this.B(new Pt.RunOnceScheduler(()=>{this.B((0,Pt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Ee){this.B(Ee.createInstance(n.ProxyAuthHandler)),this.B(Ee.createInstance(Ht.UserDataTransientProfilesHandler))}w(Ee){const Ce=this.B(this.g.createInstance(Oe.SharedProcess,Ee,this.f)),Re=(async()=>{this.h.trace("Main->SharedProcess#connect");const Fe=await Ce.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new i.Client(Fe,"main")})(),Ie=(async()=>(await Ce.whenReady(),Re))();return{sharedProcess:Ce,sharedProcessReady:Ie,sharedProcessClient:Re}}async y(Ee,Ce,Re){const Ie=new O.ServiceCollection;switch(process.platform){case"win32":Ie.set(be.IUpdateService,new j.SyncDescriptor(Ue.Win32UpdateService));break;case"linux":p.isLinuxSnap?Ie.set(be.IUpdateService,new j.SyncDescriptor(qe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(be.IUpdateService,new j.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Ie.set(be.IUpdateService,new j.SyncDescriptor(We.DarwinUpdateService));break}Ie.set(ue.IWindowsMainService,new j.SyncDescriptor(me.WindowsMainService,[Ee,this.f],!1));const Fe=new N.DialogMainService(this.h);Ie.set(N.IDialogMainService,Fe),Ie.set(H.ILaunchMainService,new j.SyncDescriptor(H.LaunchMainService,void 0,!1)),Ie.set(L.IDiagnosticsMainService,new j.SyncDescriptor(L.DiagnosticsMainService,void 0,!1)),Ie.set(D.IDiagnosticsService,I.ProxyChannel.toService((0,I.getDelayedChannel)(Re.then(et=>et.getChannel("diagnostics"))))),Ie.set(F.IIssueMainService,new j.SyncDescriptor(F.IssueMainService,[this.f])),Ie.set(V.IEncryptionMainService,new j.SyncDescriptor(oe.EncryptionMainService,[Ee])),Ie.set(U.IKeyboardLayoutMainService,new j.SyncDescriptor(U.KeyboardLayoutMainService)),Ie.set(ae.INativeHostMainService,new j.SyncDescriptor(ae.NativeHostMainService,[Ce],!1)),Ie.set(o.ICredentialsMainService,new j.SyncDescriptor(tt.CredentialsNativeMainService)),Ie.set(K.IWebviewManagerService,new j.SyncDescriptor(ce.WebviewMainService)),Ie.set(Z.IMenubarMainService,new j.SyncDescriptor(Z.MenubarMainService)),Ie.set(re.IExtensionUrlTrustService,new j.SyncDescriptor(fe.ExtensionUrlTrustService)),Ie.set(J.IExtensionHostStarter,new j.SyncDescriptor(le.ExtensionHostStarter)),Ie.set(we.IStorageMainService,new j.SyncDescriptor(we.StorageMainService)),Ie.set(we.IApplicationStorageMainService,new j.SyncDescriptor(we.ApplicationStorageMainService)),p.isWindows?Ie.set($.IExternalTerminalMainService,new j.SyncDescriptor(W.WindowsExternalTerminalService)):p.isMacintosh?Ie.set($.IExternalTerminalMainService,new j.SyncDescriptor(W.MacExternalTerminalService)):p.isLinux&&Ie.set($.IExternalTerminalMainService,new j.SyncDescriptor(W.LinuxExternalTerminalService));const ze=new s.BackupMainService(this.i,this.k,this.h,this.l);Ie.set(a.IBackupMainService,ze);const _e=new He.WorkspacesManagementMainService(this.i,this.h,this.p,ze,Fe,this.n);if(Ie.set(He.IWorkspacesManagementMainService,_e),Ie.set(Be.IWorkspacesService,new j.SyncDescriptor(xe.WorkspacesMainService,void 0,!1)),Ie.set(it.IWorkspacesHistoryMainService,new j.SyncDescriptor(it.WorkspacesHistoryMainService,void 0,!1)),Ie.set(je.IURLService,new j.SyncDescriptor($e.NativeURLService,void 0,!1)),(0,de.supportsTelemetry)(this.n,this.i)){const et=(0,de.isInternalTelemetry)(this.n,this.k),Ne=(0,I.getDelayedChannel)(Re.then(ct=>ct.getChannel("telemetryAppender"))),Ge=new te.TelemetryAppenderClient(Ne),Je=(0,ye.resolveCommonProperties)(this.m,(0,k.release)(),(0,k.hostname)(),process.arch,this.n.commit,this.n.version,Ee,et,this.i.installSourcePath),Ze=(0,de.getPiiPathsFromEnvironment)(this.i),st={appenders:[Ge],commonProperties:Je,piiPaths:Ze,sendErrorTelemetry:!0};Ie.set(Me.ITelemetryService,new j.SyncDescriptor(he.TelemetryService,[st],!1))}else Ie.set(Me.ITelemetryService,de.NullTelemetryService);return Ie.set(Wt.IExtensionsProfileScannerService,new j.SyncDescriptor(Wt.ExtensionsProfileScannerService,void 0,!0)),Ie.set(zt.IExtensionsScannerService,new j.SyncDescriptor(qt.ExtensionsScannerService,void 0,!0)),await Pt.Promises.settled([ze.initialize(),_e.initialize()]),this.g.createChild(Ie)}z(Ee,Ce,Re){const Ie=I.ProxyChannel.fromService(Ee.get(H.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Ie);const Fe=I.ProxyChannel.fromService(Ee.get(L.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Fe);const ze=new lt.PolicyChannel(Ee.get(nt.IPolicyService));Ce.registerChannel("policy",ze),Re.then(Ye=>Ye.registerChannel("policy",ze));const _e=this.m.getProvider(u.Schemas.file);(0,h.assertType)(_e instanceof q.DiskFileSystemProvider);const et=new Q.DiskFileSystemProviderChannel(_e,this.h,this.i);Ce.registerChannel(T.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et),Re.then(Ye=>Ye.registerChannel(T.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et));const Ne=I.ProxyChannel.fromService(Ee.get(at.IUserDataProfilesMainService));Ce.registerChannel("userDataProfiles",Ne),Re.then(Ye=>Ye.registerChannel("userDataProfiles",Ne));const Ge=new Bt.RequestChannel(Ee.get($t.IRequestService));Re.then(Ye=>Ye.registerChannel("request",Ge));const Je=new Pe.UpdateChannel(Ee.get(be.IUpdateService));Ce.registerChannel("update",Je);const Ze=I.ProxyChannel.fromService(Ee.get(F.IIssueMainService));Ce.registerChannel("issue",Ze);const st=I.ProxyChannel.fromService(Ee.get(V.IEncryptionMainService));Ce.registerChannel("encryption",st);const ct=I.ProxyChannel.fromService(Ee.get(o.ICredentialsMainService));Ce.registerChannel("credentials",ct);const kt=I.ProxyChannel.fromService(Ee.get(De.ISignService));Ce.registerChannel("sign",kt);const Qe=I.ProxyChannel.fromService(Ee.get(U.IKeyboardLayoutMainService));Ce.registerChannel("keyboardLayout",Qe),this.b=Ee.get(ae.INativeHostMainService);const wt=I.ProxyChannel.fromService(this.b);Ce.registerChannel("nativeHost",wt),Re.then(Ye=>Ye.registerChannel("nativeHost",wt));const pt=I.ProxyChannel.fromService(Ee.get(Be.IWorkspacesService));Ce.registerChannel("workspaces",pt);const yt=I.ProxyChannel.fromService(Ee.get(Z.IMenubarMainService));Ce.registerChannel("menubar",yt);const Dt=I.ProxyChannel.fromService(Ee.get(je.IURLService));Ce.registerChannel("url",Dt);const Mt=I.ProxyChannel.fromService(Ee.get(re.IExtensionUrlTrustService));Ce.registerChannel("extensionUrlTrust",Mt);const vt=I.ProxyChannel.fromService(Ee.get(K.IWebviewManagerService));Ce.registerChannel("webview",vt);const ut=this.B(new ve.StorageDatabaseChannel(this.h,Ee.get(we.IStorageMainService)));Ce.registerChannel("storage",ut),Re.then(Ye=>Ye.registerChannel("storage",ut));const St=this.B(new Vt.ProfileStorageChangesListenerChannel(Ee.get(we.IStorageMainService),Ee.get(at.IUserDataProfilesMainService),this.h));Re.then(Ye=>Ye.registerChannel("profileStorageListener",St));const bt=I.ProxyChannel.fromService(Ee.get($.IExternalTerminalMainService));Ce.registerChannel("externalTerminal",bt);const ht=new _.LogLevelChannel(Ee.get(B.ILogService),Ee.get(B.ILoggerService));Ce.registerChannel("logLevel",ht),Re.then(Ye=>Ye.registerChannel("logLevel",ht));const Ve=new _.LoggerChannel(Ee.get(B.ILoggerService));Ce.registerChannel("logger",Ve),Re.then(Ye=>Ye.registerChannel("logger",Ve));const ot=new d.ElectronExtensionHostDebugBroadcastChannel(Ee.get(ue.IWindowsMainService));Ce.registerChannel("extensionhostdebugservice",ot);const ft=I.ProxyChannel.fromService(Ee.get(J.IExtensionHostStarter));Ce.registerChannel(J.ipcExtensionHostStarterChannelName,ft)}async C(Ee,Ce){const Re=this.a=Ee.get(ue.IWindowsMainService),Ie=Ee.get(je.IURLService),Fe=Ee.get(ae.INativeHostMainService);this.j.phase=2;const ze=[],_e=[...this.i.args["open-url"]?this.i.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ve=>{try{return{uri:l.URI.parse(Ve),url:Ve}}catch{return}}).filter(Ve=>{if(!Ve||this.D(Ve.uri))return!1;const ot=this.F(Ve.uri);return ot?(ze.push(ot),!1):!0}),et=this,Ne=this.i,Ge=this.n,Je=this.h;Ie.registerHandler({async handleURL(Ve,ot){if(Je.trace("app#handleURL: ",Ve.toString(!0),ot),Ve.scheme===Ge.urlProtocol&&Ve.path==="workspace"&&(Ve=Ve.with({authority:"file",path:l.URI.parse(Ve.query).path,query:""})),et.D(Ve))return!0;let ft=!1;const Ye=new URLSearchParams(Ve.query);Ye.get("windowId")==="_blank"&&(Ye.delete("windowId"),Ve=Ve.with({query:Ye.toString()}),ft=!0),ft||=p.isMacintosh&&Re.getWindowCount()===0;const Ut=Ye.get("continueOn");Ut!==null&&(Ne.continueOn=Ut??void 0,Ye.delete("continueOn"),Ve=Ve.with({query:Ye.toString()}));const Rt=et.F(Ve);if(Je.trace("app#handleURL: windowOpenableFromProtocolLink = ",Rt),Rt){const[At]=await Re.open({context:5,cli:{...Ne.args},urisToOpen:[Rt],forceNewWindow:ft,gotoLineMode:!0});return At.focus(),!0}if(ft){const[At]=await Re.open({context:5,cli:{...Ne.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ke.getRemoteAuthority)(Ve)});return await At.ready(),Ie.open(Ve,ot)}return!1}});const Ze=this.B(new Se.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),st=new I.StaticRouter(Ve=>Ze.getActiveClientId().then(ot=>Ve===ot)),ct=new Xe.URLHandlerRouter(st),kt=Ce.getChannel("urlHandler",ct);Ie.registerHandler(new Xe.URLHandlerChannelClient(kt)),this.B(new Ke.ElectronURLListener(_e,Ie,Re,this.i,this.n));const Qe=this.i.args,wt=global.macOpenFiles,pt=(0,Y.isLaunchedFromCli)(process.env)?0:4,yt=Qe._.length,Dt=!!Qe["folder-uri"],Mt=!!Qe["file-uri"],vt=Qe["skip-add-to-recently-opened"]===!0,ut=Qe.wait&&Qe.waitMarkerFilePath?l.URI.file(Qe.waitMarkerFilePath):void 0,St=Qe.remote||void 0,bt=Qe.profile,ht=Qe["profile-temp"];if(ze.length>0)return Re.open({context:pt,cli:Qe,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});if(!yt&&!Dt&&!Mt){if(Qe["new-window"]||bt||ht)return Re.open({context:pt,cli:Qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:vt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:St,forceProfile:bt,forceTempProfile:ht});if(wt.length)return Re.open({context:1,cli:Qe,urisToOpen:wt.map(Ve=>(0,Ae.hasWorkspaceFileExtension)(Ve)?{workspaceUri:l.URI.file(Ve)}:{fileUri:l.URI.file(Ve)}),noRecentEntry:vt,waitMarkerFileURI:ut,initialStartup:!0})}return Re.open({context:pt,cli:Qe,forceNewWindow:Qe["new-window"]||!yt&&Qe["unity-launch"],diffMode:Qe.diff,mergeMode:Qe.merge,noRecentEntry:vt,waitMarkerFileURI:ut,gotoLineMode:Qe.goto,initialStartup:!0,remoteAuthority:St,forceProfile:bt,forceTempProfile:ht})}D(Ee){return!!(Ee.authority===u.Schemas.file&&p.isWindows&&E.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,S.mnemonicButtonLabel)((0,r.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,r.localize)(1,null))],defaultId:0,cancelId:1,message:(0,r.localize)(2,null,(0,S.getPathLabel)(Ee,{os:p.OS,tildify:this.i}),this.n.nameShort),detail:(0,r.localize)(3,null),noLink:!0})===1)}F(Ee){if(!!Ee.path){if(Ee.authority===u.Schemas.file){const Ce=l.URI.file(Ee.fsPath);return(0,Ae.hasWorkspaceFileExtension)(Ce)?{workspaceUri:Ce}:{fileUri:Ce}}else if(Ee.authority===u.Schemas.vscodeRemote){const Ce=Ee.path.indexOf(f.posix.sep,1);if(Ce!==-1){const Re=Ee.path.substring(1,Ce),Ie=Ee.path.substring(Ce),Fe=l.URI.from({scheme:u.Schemas.vscodeRemote,authority:Re,path:Ie,query:Ee.query,fragment:Ee.fragment});return(0,Ae.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Fe}:/:[\d]+$/.test(Ie)?{fileUri:Fe}:{folderUri:Fe}}}}}G(Ee,Ce){const Re=Ee.get(Me.ITelemetryService),Ie=Ee.get(be.IUpdateService);this.j.phase=3,this.I(Re,Ce),this.H(),E.protocol.registerHttpProtocol(u.Schemas.vscodeRemoteResource,(Fe,ze)=>{ze({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(Ie instanceof Ue.Win32UpdateService||Ie instanceof Te.LinuxUpdateService||Ie instanceof We.DarwinUpdateService)&&Ie.initialize(),this.J(this.i.args,process.env,!0),this.L()}async H(){const Ee=this.n.win32MutexName;if(p.isWindows&&Ee)try{const Ce=await new Promise((Ie,Fe)=>{G(["windows-mutex"],Ie,Fe)}),Re=new Ce.Mutex(Ee);(0,g.once)(this.j.onWillShutdown)(()=>Re.release())}catch(Ce){this.h.error(Ce)}}I(Ee,Ce){let Re=!1;(0,g.once)(this.j.onWillShutdown)(()=>Re=!0),this.B(Ce.onDidError(({type:Ie,details:Fe})=>{let ze;switch(Ie){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error(ze)),Ee.publicLog2("sharedprocesserror",{type:Ie,reason:Fe?.reason,code:Fe?.exitCode,visible:Ce.isVisible(),shuttingdown:Re})}))}async J(Ee,Ce,Re){try{return await(0,se.getResolvedShellEnv)(this.h,Ee,Ce)}catch(Ie){const Fe=(0,A.toErrorMessage)(Ie);Re?this.a?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.h.error(Fe)}return{}}async L(){try{const Ce=(await this.m.readFile(this.i.argvResource)).value.toString(),Re=JSON.parse((0,b.stripComments)(Ce)),Fe=(0,de.getTelemetryLevel)(this.k)>=1;if(Re["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.generateUuid)()}"`,"}"],_e=Ce.substring(0,Ce.length-2).concat(`,
`,ze.join(`
`));await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(_e))}else{const ze=Ce.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);ze!==Ce&&await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(ze))}}catch(Ee){this.h.error(Ee)}}};Ct=pe([ee(2,M.IInstantiationService),ee(3,B.ILogService),ee(4,X.IEnvironmentMainService),ee(5,x.ILifecycleMainService),ee(6,c.IConfigurationService),ee(7,Le.IStateMainService),ee(8,z.IFileService),ee(9,ge.IProductService),ee(10,at.IUserDataProfilesMainService)],Ct),e.CodeApplication=Ct}),define(ie[276],ne([0,1,37,8,284,2,6]),function(G,e,E,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends E.AbstractPolicyService{constructor(g,b){super(),this.j=g,this.k=b,this.a=new t.Throttler,this.b=this.B(new R.MutableDisposable)}async i(g){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(g).length} policy definitions`),await this.a.queue(()=>new Promise((b,S)=>{try{this.b.value=(0,k.createWatcher)(this.k,g,y=>{this.m(y),b()})}catch(y){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),S(y)}}))}m(g){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(g)}`);for(const b in g){const S=g[b];S===void 0?this.g.delete(b):this.g.set(b,S)}this.h.fire(Object.keys(g))}};P=pe([ee(0,A.ILogService)],P),e.NativePolicyService=P}),define(ie[277],ne([0,1,226,8,17,15,2,11,18,35,111,6,225,285]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let f=class extends A.Disposable{constructor(h,l,v){super(),this.h=l,this.i=v,this.j(h.getValue()),this.B(h.onDidChangeConfiguration(()=>this.j(h.getValue()),this))}j(h){this.a=h.http&&h.http.proxy,this.b=!!(h.http&&h.http.proxyStrictSSL),this.f=h.http&&h.http.proxyAuthorization}async request(h,l){this.i.trace("RequestService#request (node) - begin",h.url);const{a:v,b:C}=this;let I;try{I=await(0,b.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(n){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",n))}const m={...process.env,...I},i=h.agent?h.agent:await(0,y.getProxyAgent)(h.url||"",m,{proxyUrl:v,strictSSL:C});h.agent=i,h.strictSSL=C,this.f&&(h.headers={...h.headers||{},"Proxy-Authorization":this.f});try{const n=await this.l(h,l);return this.i.trace("RequestService#request (node) - success",h.url),n}catch(n){throw this.i.trace("RequestService#request (node) - error",h.url,n),n}}async k(h){return((0,E.parse)(h.url).protocol==="https:"?await new Promise((C,I)=>{G(["https"],C,I)}):await new Promise((C,I)=>{G(["http"],C,I)})).request}l(h,l){return t.Promises.withAsyncBody(async(v,C)=>{const I=(0,E.parse)(h.url),m=h.getRawRequest?h.getRawRequest(h):await this.k(h),i={hostname:I.hostname,port:I.port?parseInt(I.port):I.protocol==="https:"?443:80,protocol:I.protocol,path:I.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,P.isBoolean)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(i.auth=h.user+":"+h.password);const n=m(i,r=>{const a=(0,P.isNumber)(h.followRedirects)?h.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&a>0&&r.headers.location)this.l({...h,url:r.headers.location,followRedirects:a-1},l).then(v,C);else{let s=r;!h.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(s=r.pipe((0,u.createGunzip)())),v({res:r,stream:(0,k.streamToBufferReadableStream)(s)})}});n.on("error",C),h.timeout&&n.setTimeout(h.timeout),h.isChromiumNetwork&&n.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&n.write(h.data),n.end(),l.onCancellationRequested(()=>{n.abort(),C(new R.CancellationError)})})}async resolveProxy(h){}};f=pe([ee(0,w.IConfigurationService),ee(1,g.INativeEnvironmentService),ee(2,S.ILogService)],f),e.RequestService=f}),define(ie[278],ne([0,1,13,277]),function(G,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(A){return E.net.request}class R extends t.RequestService{request(P,w){return super.request({...P||{},getRawRequest:k,isChromiumNetwork:!0},w)}}e.RequestMainService=R}),define(ie[286],ne([0,1,13,40,7,24,8,45,15,30,50,34,14,9,73,4,33,26,23,47,83,275,10,18,219,232,27,61,184,16,205,86,70,201,85,21,208,6,211,63,19,64,259,114,240,55,278,88,227,36,231,56,66,51,37,276,213,2,42,245,38,241]),function(G,e,E,t,k,R,A,P,w,g,b,S,y,u,f,p,h,l,v,C,I,m,i,n,r,a,s,c,o,d,D,L,N,V,oe,X,Y,se,re,fe,J,le,$,W,T,z,Q,q,j,M,O,F,U,H,x,B,_,Z,ae,ge,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Oe{main(){try{this.a()}catch(ve){console.error(ve.message),E.app.exit(1)}}async a(){(0,w.setUnexpectedErrorHandler)(Pe=>console.error(Pe));const[ve,we,ye,Me,te,he,de,be]=this.b();try{try{await this.d(ye,be,Me,te,de)}catch(Pe){throw this.f(ye,de.nameLong,Pe),Pe}await ve.invokeFunction(async Pe=>{const We=Pe.get(se.ILogService),Te=Pe.get(X.ILifecycleMainService),qe=Pe.get(d.IFileService),Ue=Pe.get(se.ILoggerService),je=await this.e(We,ye,Te,ve,de,!0);return v.Promises.writeFile(ye.mainLockfile,String(process.pid)).catch(Xe=>{We.warn(`Error writing main lockfile: ${Xe.stack}`)}),he.logger=Ue.createLogger(k.URI.file((0,u.join)(ye.logsPath,"main.log")),{name:"main"}),(0,b.once)(Te.onWillShutdown)(Xe=>{qe.dispose(),Me.dispose(),Xe.join(v.Promises.unlink(ye.mainLockfile).catch(()=>{}))}),ve.createInstance(m.CodeApplication,je,we).startup()})}catch(Pe){ve.invokeFunction(this.i,Pe)}}b(){const ve=new oe.ServiceCollection,we=new Z.DisposableStore;process.once("exit",()=>we.dispose());const ye={_serviceBrand:void 0,...fe.default};ve.set(J.IProductService,ye);const Me=new s.EnvironmentMainService(this.j(),ye),te=this.c(Me);ve.set(s.IEnvironmentMainService,Me);const he=new Y.BufferLogService,de=we.add(new se.MultiplexLogService([new se.ConsoleMainLogger((0,se.getLogLevel)(Me)),he]));ve.set(se.ILogService,de);const be=new D.FileService(de);ve.set(d.IFileService,be);const Pe=new L.DiskFileSystemProvider(de);be.registerProvider(y.Schemas.file,Pe);const We=new ge.UriIdentityService(be);ve.set(ae.IUriIdentityService,We),ve.set(se.ILoggerService,new re.LoggerService(de));const Te=new O.StateMainService(Me,de,be);ve.set(M.IStateMainService,Te);const qe=new H.UserDataProfilesMainService(Te,We,Me,be,de);ve.set(H.IUserDataProfilesMainService,qe);const Ue=p.isWindows&&ye.win32RegValueName?we.add(new B.NativePolicyService(de,ye.win32RegValueName)):Me.policyFile?we.add(new _.FilePolicyService(Me.policyFile,be,de)):new x.NullPolicyService;ve.set(x.IPolicyService,Ue);const je=new r.ConfigurationService(qe.defaultProfile.settingsResource,be,Ue,de);return ve.set(n.IConfigurationService,je),ve.set(X.ILifecycleMainService,new N.SyncDescriptor(X.LifecycleMainService,void 0,!1)),ve.set(z.IRequestService,new N.SyncDescriptor(Q.RequestMainService,void 0,!0)),ve.set(U.IThemeMainService,new N.SyncDescriptor(U.ThemeMainService)),ve.set(q.ISignService,new N.SyncDescriptor(j.SignService,void 0,!1)),ve.set(W.ITunnelService,new N.SyncDescriptor(T.TunnelService)),ve.set(le.IProtocolMainService,new $.ProtocolMainService(Me,qe,de)),[new V.InstantiationService(ve,!0),te,Me,je,Te,he,ye,qe]}c(ve){const we={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ye=>{const Me=process.env[ye];typeof Me=="string"&&(we[ye]=Me)}),Object.assign(process.env,we),we}async d(ve,we,ye,Me,te){await A.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsPath,we.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(he=>he?v.Promises.mkdir(he,{recursive:!0}):void 0)),Me.init(),ye.initialize()]),we.setEnablement(te.quality!=="stable"||ye.getValue(ke.PROFILES_ENABLEMENT_CONFIG))}async e(ve,we,ye,Me,te,he){let de;try{(0,f.mark)("code/willStartMainServer"),de=await(0,I.serve)(we.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),(0,b.once)(ye.onWillShutdown)(()=>de.dispose())}catch(be){if(be.code!=="EADDRINUSE")throw this.f(we,te.nameLong,be),be;let Pe;try{Pe=await(0,I.connect)(we.mainIPCHandle,"main")}catch(Ue){if(!he||p.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.g((0,i.localize)(0,null,te.nameShort),(0,i.localize)(1,null),te.nameLong),Ue;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(je){throw ve.warn("Could not delete obsolete instance handle",je),je}return this.e(ve,we,ye,Me,te,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const Ue=`Running extension tests from the command line is currently only supported if no other instance of ${te.nameShort} is running.`;throw ve.error(Ue),Pe.dispose(),new Error(Ue)}let We;!we.args.wait&&!we.args.status&&(We=setTimeout(()=>{this.g((0,i.localize)(2,null,te.nameShort),(0,i.localize)(3,null),te.nameLong)},1e4));const Te=C.ProxyChannel.toService(Pe.getChannel("launch"),{disableMarshalling:!0}),qe=C.ProxyChannel.toService(Pe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return Me.invokeFunction(async()=>{const Ue=new a.DiagnosticsService(F.NullTelemetryService,te),je=await qe.getMainDiagnostics(),Xe=await qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),$e=await Ue.getDiagnostics(je,Xe);throw console.log($e),new w.ExpectedError});throw p.isWindows&&await this.h(Te,ve),ve.trace("Sending env to running instance..."),await Te.start(we.args,process.env),Pe.dispose(),We&&clearTimeout(We),new w.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw ve.warn(`Warning: The --status argument can only be used if ${te.nameShort} is already running. Please run it again after {0} has started.`),new w.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}f(ve,we,ye){if(ye.code==="EACCES"||ye.code==="EPERM"){const Me=(0,R.coalesce)([ve.userDataPath,ve.extensionsPath,I.XDG_RUNTIME_DIR]).map(te=>(0,S.getPathLabel)(k.URI.file(te),{os:p.OS,tildify:ve}));this.g((0,i.localize)(4,null),(0,i.localize)(5,null,(0,P.toErrorMessage)(ye),Me.join(`
`)),we)}}g(ve,we,ye){E.dialog.showMessageBoxSync({title:ye,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,i.localize)(6,null))],message:ve,detail:we,defaultId:0,noLink:!0})}async h(ve,we){if(p.isWindows){const ye=await ve.getMainProcessId();we.trace("Sending some foreground love to the running instance:",ye);try{(await new Promise((Me,te)=>{G(["windows-foreground-love"],Me,te)})).allowSetForegroundWindow(ye)}catch(Me){we.error(Me)}}}i(ve,we){const ye=ve.get(se.ILogService),Me=ve.get(X.ILifecycleMainService);let te=0;we&&(we.isExpected?we.message&&ye.trace(we.message):(te=1,we.stack?ye.error(we.stack):ye.error(`Startup error: ${we.toString()}`))),Me.kill(te)}j(){const ve=this.k((0,c.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const we=(0,o.createWaitMarkerFileSync)(ve.verbose);we&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",we),ve.waitMarkerFilePath=we)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const we=this.l(ve._,ve.goto);ve._=we}return ve}l(ve,we){const ye=(0,h.cwd)(),Me=ve.map(de=>{let be=String(de),Pe;we&&(Pe=(0,g.parseLineAndColumnAware)(be),be=Pe.path),be&&(be=this.m(ye,be));const We=(0,g.sanitizeFilePath)(be,ye),Te=(0,u.basename)(We);return Te&&!(0,g.isValidBasename)(Te)?null:we&&Pe?(Pe.path=We,this.n(Pe)):We}),te=p.isWindows||p.isMacintosh,he=(0,R.distinct)(Me,de=>de&&te?de.toLowerCase():de||"");return(0,R.coalesce)(he)}m(ve,we){return p.isWindows&&(we=(0,l.rtrim)(we,'"')),we=(0,l.trim)((0,l.trim)(we," "),"	"),p.isWindows&&(we=(0,u.resolve)(ve,we),we=(0,l.rtrim)(we,".")),we}n(ve){const we=[ve.path];return typeof ve.line=="number"&&we.push(String(ve.line)),typeof ve.column=="number"&&we.push(String(ve.column)),we.join(":")}}new Oe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/44531ffc7b7477dbe82750040d8ed69bae2bb140/core/vs/code/electron-main/main.js.map
