/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/async","vs/base/common/event","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/userDataProfile/common/userDataProfile","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","vs/platform/telemetry/common/telemetry","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(W){for(var e=[],L=0,R=W.length;L<R;L++)e[L]=Z[W[L]];return e};define(Z[49],Q([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(N){return(b,d,u)=>{let y=null,p=null;if(typeof u.value=="function"?(y="value",p=u.value):typeof u.get=="function"&&(y="get",p=u.get),!p)throw new Error("not supported");u[y]=N(p,d)}}function R(N,b,d){let u=null,y=null;if(typeof d.value=="function"?(u="value",y=d.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(u="get",y=d.get),!y)throw new Error("not supported");const p=`$memoize$${b}`;d[u]=function(...m){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,m)}),this[p]}}e.memoize=R;function k(N,b,d){return L((u,y)=>{const p=`$debounce$${y}`,m=`$debounce$result$${y}`;return function(...S){this[m]||(this[m]=d?d():void 0),clearTimeout(this[p]),b&&(this[m]=b(this[m],...S),S=[this[m]]),this[p]=setTimeout(()=>{u.apply(this,S),this[m]=d?d():void 0},N)}})}e.debounce=k;function T(N,b,d){return L((u,y)=>{const p=`$throttle$timer$${y}`,m=`$throttle$result$${y}`,S=`$throttle$lastRun$${y}`,v=`$throttle$pending$${y}`;return function(...O){if(this[m]||(this[m]=d?d():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...O)),this[v])return;const w=this[S]+N;w<=Date.now()?(this[S]=Date.now(),u.apply(this,[this[m]]),this[m]=d?d():void 0):(this[v]=!0,this[p]=setTimeout(()=>{this[v]=!1,this[S]=Date.now(),u.apply(this,[this[m]]),this[m]=d?d():void 0},w-Date.now()))}})}e.throttle=T}),define(Z[70],Q([0,1,10]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(d,u){if(!d)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=R;function k(d,u="Unreachable"){throw new Error(u)}e.assertNever=k;function T(d){if(!d)throw new L.BugIndicatingError("Assertion Failed")}e.assert=T;function N(d){if(!d()){debugger;d(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function b(d,u){let y=0;for(;y<d.length-1;){const p=d[y],m=d[y+1];if(!u(p,m))return!1;y++}return!0}e.checkAdjacentItems=b}),define(Z[50],Q([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function N(t,n=!1){let i=0;const r=t.length;let s="",l=0,a=16,f=0;function D(ee){let pe=0,le=0;for(;pe<ee;){const ae=t.charCodeAt(i);if(ae>=48&&ae<=57)le=le*16+ae-48;else if(ae>=65&&ae<=70)le=le*16+ae-65+10;else if(ae>=97&&ae<=102)le=le*16+ae-97+10;else break;i++,pe++}return pe<ee&&(le=-1),le}function C(ee){i=ee,s="",l=0,a=16,f=0}function x(){const ee=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&u(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&u(t.charCodeAt(i)))for(i++;i<t.length&&u(t.charCodeAt(i));)i++;else return f=3,t.substring(ee,i);let pe=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&u(t.charCodeAt(i))){for(i++;i<t.length&&u(t.charCodeAt(i));)i++;pe=i}else f=3;return t.substring(ee,pe)}function Y(){let ee="",pe=i;for(;;){if(i>=r){ee+=t.substring(pe,i),f=2;break}const le=t.charCodeAt(i);if(le===34){ee+=t.substring(pe,i),i++;break}if(le===92){if(ee+=t.substring(pe,i),i++,i>=r){f=2;break}switch(t.charCodeAt(i++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:{const he=D(4);he>=0?ee+=String.fromCharCode(he):f=4;break}default:f=5}pe=i;continue}if(le>=0&&le<=31)if(d(le)){ee+=t.substring(pe,i),f=2;break}else f=6;i++}return ee}function X(){if(s="",f=0,l=i,i>=r)return l=r,a=17;let ee=t.charCodeAt(i);if(b(ee)){do i++,s+=String.fromCharCode(ee),ee=t.charCodeAt(i);while(b(ee));return a=15}if(d(ee))return i++,s+=String.fromCharCode(ee),ee===13&&t.charCodeAt(i)===10&&(i++,s+=`
`),a=14;switch(ee){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,s=Y(),a=10;case 47:{const pe=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!d(t.charCodeAt(i));)i++;return s=t.substring(pe,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const le=r-1;let ae=!1;for(;i<le;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ae=!0;break}i++}return ae||(i++,f=1),s=t.substring(pe,i),a=13}return s+=String.fromCharCode(ee),i++,a=16}case 45:if(s+=String.fromCharCode(ee),i++,i===r||!u(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=x(),a=11;default:for(;i<r&&ie(ee);)i++,ee=t.charCodeAt(i);if(l!==i){switch(s=t.substring(l,i),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(ee),i++,a=16}}function ie(ee){if(b(ee)||d(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ee;do ee=X();while(ee>=12&&ee<=15);return ee}return{setPosition:C,getPosition:()=>i,scan:n?re:X,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>f}}e.createScanner=N;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var y;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(y||(y={}));function p(t,n){const i=[],r=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function f(D,C,x,Y){l.value=D,l.offset=C,l.length=x,l.type=Y,l.colonOffset=void 0,s=l}try{E(t,{onObjectBegin:(D,C)=>{if(n<=D)throw r;s=void 0,a=n>D,i.push("")},onObjectProperty:(D,C,x)=>{if(n<C||(f(D,C,x,"property"),i[i.length-1]=D,n<=C+x))throw r},onObjectEnd:(D,C)=>{if(n<=D)throw r;s=void 0,i.pop()},onArrayBegin:(D,C)=>{if(n<=D)throw r;s=void 0,i.push(0)},onArrayEnd:(D,C)=>{if(n<=D)throw r;s=void 0,i.pop()},onLiteralValue:(D,C,x)=>{if(n<C||(f(D,C,x,o(D)),n<=C+x))throw r},onSeparator:(D,C,x)=>{if(n<=C)throw r;if(D===":"&&s&&s.type==="property")s.colonOffset=C,a=!1,s=void 0;else if(D===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(a=!0,i[i.length-1]=""),s=void 0}}})}catch(D){if(D!==r)throw D}return{path:i,previousNode:s,isAtPropertyKey:a,matches:D=>{let C=0;for(let x=0;C<D.length&&x<i.length;x++)if(D[C]===i[x]||D[C]==="*")C++;else if(D[C]!=="**")return!1;return C===D.length}}}e.getLocation=p;function m(t,n=[],i=T.DEFAULT){let r=null,s=[];const l=[];function a(D){Array.isArray(s)?s.push(D):r!==null&&(s[r]=D)}return E(t,{onObjectBegin:()=>{const D={};a(D),l.push(s),s=D,r=null},onObjectProperty:D=>{r=D},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const D=[];a(D),l.push(s),s=D,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:a,onError:(D,C,x)=>{n.push({error:D,offset:C,length:x})}},i),s[0]}e.parse=m;function S(t,n=[],i=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(D){r.type==="property"&&(r.length=D-r.offset,r=r.parent)}function l(D){return r.children.push(D),D}E(t,{onObjectBegin:D=>{r=l({type:"object",offset:D,length:-1,parent:r,children:[]})},onObjectProperty:(D,C,x)=>{r=l({type:"property",offset:C,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:D,offset:C,length:x,parent:r})},onObjectEnd:(D,C)=>{r.length=D+C-r.offset,r=r.parent,s(D+C)},onArrayBegin:(D,C)=>{r=l({type:"array",offset:D,length:-1,parent:r,children:[]})},onArrayEnd:(D,C)=>{r.length=D+C-r.offset,r=r.parent,s(D+C)},onLiteralValue:(D,C,x)=>{l({type:o(D),offset:C,length:x,parent:r,value:D}),s(C+x)},onSeparator:(D,C,x)=>{r.type==="property"&&(D===":"?r.colonOffset=C:D===","&&s(C))},onError:(D,C,x)=>{n.push({error:D,offset:C,length:x})}},i);const f=r.children[0];return f&&delete f.parent,f}e.parseTree=S;function v(t,n){if(!t)return;let i=t;for(const r of n)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===r){i=l.children[1],s=!0;break}if(!s)return}else{const s=r;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=v;function O(t){if(!t.parent||!t.parent.children)return[];const n=O(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;n.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&n.push(i)}return n}e.getNodePath=O;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":{const n=Object.create(null);for(const i of t.children){const r=i.children[1];r&&(n[i.children[0].value]=w(r))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=w;function c(t,n,i=!1){return n>=t.offset&&n<t.offset+t.length||i&&n===t.offset+t.length}e.contains=c;function g(t,n,i=!1){if(c(t,n,i)){const r=t.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=n;s++){const l=g(r[s],n,i);if(l)return l}return t}}e.findNodeAtOffset=g;function E(t,n,i=T.DEFAULT){const r=N(t,!1);function s(q){return q?()=>q(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(q){return q?K=>q(K,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=s(n.onObjectBegin),f=l(n.onObjectProperty),D=s(n.onObjectEnd),C=s(n.onArrayBegin),x=s(n.onArrayEnd),Y=l(n.onLiteralValue),X=l(n.onSeparator),ie=s(n.onComment),re=l(n.onError),ee=i&&i.disallowComments,pe=i&&i.allowTrailingComma;function le(){for(;;){const q=r.scan();switch(r.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:ee||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(q){case 12:case 13:ee?ae(10):ie();break;case 16:ae(1);break;case 15:case 14:break;default:return q}}}function ae(q,K=[],I=[]){if(re(q),K.length+I.length>0){let P=r.getToken();for(;P!==17;){if(K.indexOf(P)!==-1){le();break}else if(I.indexOf(P)!==-1)break;P=le()}}}function he(q){const K=r.getTokenValue();return q?Y(K):f(K),le(),!0}function B(){switch(r.getToken()){case 11:{let q=0;try{q=JSON.parse(r.getTokenValue()),typeof q!="number"&&(ae(2),q=0)}catch{ae(2)}Y(q);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return le(),!0}function j(){return r.getToken()!==10?(ae(3,[],[2,5]),!1):(he(!1),r.getToken()===6?(X(":"),le(),$()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function A(){a(),le();let q=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(q||ae(4,[],[]),X(","),le(),r.getToken()===2&&pe)break}else q&&ae(6,[],[]);j()||ae(4,[],[2,5]),q=!0}return D(),r.getToken()!==2?ae(7,[2],[]):le(),!0}function z(){C(),le();let q=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(q||ae(4,[],[]),X(","),le(),r.getToken()===4&&pe)break}else q&&ae(6,[],[]);$()||ae(4,[],[4,5]),q=!0}return x(),r.getToken()!==4?ae(8,[4],[]):le(),!0}function $(){switch(r.getToken()){case 3:return z();case 1:return A();case 10:return he(!0);default:return B()}}return le(),r.getToken()===17?i.allowEmptyContent?!0:(ae(4,[],[]),!1):$()?(r.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.visit=E;function h(t,n){const i=N(t),r=[];let s,l=0,a;do switch(a=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:l!==a&&r.push(t.substring(l,a)),n!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,n)),l=i.getPosition();break}while(s!==17);return r.join("")}e.stripComments=h;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),function(){function W(k){const T=[];typeof k=="number"&&T.push("code/timeOrigin",k);function N(d){T.push(d,Date.now())}function b(){const d=[];for(let u=0;u<T.length;u+=2)d.push({name:T[u],startTime:T[u+1]});return d}return{mark:N,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?W():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const N of performance.getEntriesByType("mark"))T.push({name:N.name,startTime:Math.round(k+N.startTime)});return T}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return W(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),W()}function L(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=L(R))}(),function(W,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var R in L)(typeof exports=="object"?exports:W)[R]=L[R]}}(typeof self<"u"?self:this,function(){return function(W){var e={};function L(R){if(e[R])return e[R].exports;var k=e[R]={i:R,l:!1,exports:{}};return W[R].call(k.exports,k,k.exports,L),k.l=!0,k.exports}return L.m=W,L.c=e,L.d=function(R,k,T){L.o(R,k)||Object.defineProperty(R,k,{enumerable:!0,get:T})},L.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},L.t=function(R,k){if(1&k&&(R=L(R)),8&k||4&k&&typeof R=="object"&&R&&R.__esModule)return R;var T=Object.create(null);if(L.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:R}),2&k&&typeof R!="string")for(var N in R)L.d(T,N,function(b){return R[b]}.bind(null,N));return T},L.n=function(R){var k=R&&R.__esModule?function(){return R.default}:function(){return R};return L.d(k,"a",k),k},L.o=function(R,k){return Object.prototype.hasOwnProperty.call(R,k)},L.p="",L(L.s=0)}([function(W,e,L){(function(R){var k;e=W.exports=I,k=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],d=e.src=[],u=0,y=u++;d[y]="0|[1-9]\\d*";var p=u++;d[p]="[0-9]+";var m=u++;d[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=u++;d[S]="("+d[y]+")\\.("+d[y]+")\\.("+d[y]+")";var v=u++;d[v]="("+d[p]+")\\.("+d[p]+")\\.("+d[p]+")";var O=u++;d[O]="(?:"+d[y]+"|"+d[m]+")";var w=u++;d[w]="(?:"+d[p]+"|"+d[m]+")";var c=u++;d[c]="(?:-("+d[O]+"(?:\\."+d[O]+")*))";var g=u++;d[g]="(?:-?("+d[w]+"(?:\\."+d[w]+")*))";var E=u++;d[E]="[0-9A-Za-z-]+";var h=u++;d[h]="(?:\\+("+d[E]+"(?:\\."+d[E]+")*))";var o=u++,t="v?"+d[S]+d[c]+"?"+d[h]+"?";d[o]="^"+t+"$";var n="[v=\\s]*"+d[v]+d[g]+"?"+d[h]+"?",i=u++;d[i]="^"+n+"$";var r=u++;d[r]="((?:<|>)?=?)";var s=u++;d[s]=d[p]+"|x|X|\\*";var l=u++;d[l]=d[y]+"|x|X|\\*";var a=u++;d[a]="[v=\\s]*("+d[l]+")(?:\\.("+d[l]+")(?:\\.("+d[l]+")(?:"+d[c]+")?"+d[h]+"?)?)?";var f=u++;d[f]="[v=\\s]*("+d[s]+")(?:\\.("+d[s]+")(?:\\.("+d[s]+")(?:"+d[g]+")?"+d[h]+"?)?)?";var D=u++;d[D]="^"+d[r]+"\\s*"+d[a]+"$";var C=u++;d[C]="^"+d[r]+"\\s*"+d[f]+"$";var x=u++;d[x]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=u++;d[Y]="(?:~>?)";var X=u++;d[X]="(\\s*)"+d[Y]+"\\s+",b[X]=new RegExp(d[X],"g");var ie=u++;d[ie]="^"+d[Y]+d[a]+"$";var re=u++;d[re]="^"+d[Y]+d[f]+"$";var ee=u++;d[ee]="(?:\\^)";var pe=u++;d[pe]="(\\s*)"+d[ee]+"\\s+",b[pe]=new RegExp(d[pe],"g");var le=u++;d[le]="^"+d[ee]+d[a]+"$";var ae=u++;d[ae]="^"+d[ee]+d[f]+"$";var he=u++;d[he]="^"+d[r]+"\\s*("+n+")$|^$";var B=u++;d[B]="^"+d[r]+"\\s*("+t+")$|^$";var j=u++;d[j]="(\\s*)"+d[r]+"\\s*("+n+"|"+d[a]+")",b[j]=new RegExp(d[j],"g");var A=u++;d[A]="^\\s*("+d[a]+")\\s+-\\s+("+d[a]+")\\s*$";var z=u++;d[z]="^\\s*("+d[f]+")\\s+-\\s+("+d[f]+")\\s*$";var $=u++;d[$]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)k(q,d[q]),b[q]||(b[q]=new RegExp(d[q]));function K(U,H){if(U instanceof I)return U;if(typeof U!="string"||U.length>T||!(H?b[i]:b[o]).test(U))return null;try{return new I(U,H)}catch{return null}}function I(U,H){if(U instanceof I){if(U.loose===H)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof I))return new I(U,H);k("SemVer",U,H),this.loose=H;var J=U.trim().match(H?b[i]:b[o]);if(!J)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var ve=+de;if(ve>=0&&ve<N)return ve}return de}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=K,e.valid=function(U,H){var J=K(U,H);return J?J.version:null},e.clean=function(U,H){var J=K(U.trim().replace(/^[=v]+/,""),H);return J?J.version:null},e.SemVer=I,I.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},I.prototype.toString=function(){return this.version},I.prototype.compare=function(U){return k("SemVer.compare",this.version,this.loose,U),U instanceof I||(U=new I(U,this.loose)),this.compareMain(U)||this.comparePre(U)},I.prototype.compareMain=function(U){return U instanceof I||(U=new I(U,this.loose)),M(this.major,U.major)||M(this.minor,U.minor)||M(this.patch,U.patch)},I.prototype.comparePre=function(U){if(U instanceof I||(U=new I(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var H=0;do{var J=this.prerelease[H],de=U.prerelease[H];if(k("prerelease compare",H,J,de),J===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(J===void 0)return-1;if(J!==de)return M(J,de)}while(++H)},I.prototype.inc=function(U,H){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,H,J,de){typeof J=="string"&&(de=J,J=void 0);try{return new I(U,J).inc(H,de).version}catch{return null}},e.diff=function(U,H){if(te(U,H))return null;var J=K(U),de=K(H);if(J.prerelease.length||de.prerelease.length){for(var ve in J)if((ve==="major"||ve==="minor"||ve==="patch")&&J[ve]!==de[ve])return"pre"+ve;return"prerelease"}for(var ve in J)if((ve==="major"||ve==="minor"||ve==="patch")&&J[ve]!==de[ve])return ve},e.compareIdentifiers=M;var P=/^[0-9]+$/;function M(U,H){var J=P.test(U),de=P.test(H);return J&&de&&(U=+U,H=+H),J&&!de?-1:de&&!J?1:U<H?-1:U>H?1:0}function F(U,H,J){return new I(U,J).compare(new I(H,J))}function V(U,H,J){return F(U,H,J)>0}function G(U,H,J){return F(U,H,J)<0}function te(U,H,J){return F(U,H,J)===0}function ne(U,H,J){return F(U,H,J)!==0}function ge(U,H,J){return F(U,H,J)>=0}function ye(U,H,J){return F(U,H,J)<=0}function ue(U,H,J,de){var ve;switch(H){case"===":typeof U=="object"&&(U=U.version),typeof J=="object"&&(J=J.version),ve=U===J;break;case"!==":typeof U=="object"&&(U=U.version),typeof J=="object"&&(J=J.version),ve=U!==J;break;case"":case"=":case"==":ve=te(U,J,de);break;case"!=":ve=ne(U,J,de);break;case">":ve=V(U,J,de);break;case">=":ve=ge(U,J,de);break;case"<":ve=G(U,J,de);break;case"<=":ve=ye(U,J,de);break;default:throw new TypeError("Invalid operator: "+H)}return ve}function ce(U,H){if(U instanceof ce){if(U.loose===H)return U;U=U.value}if(!(this instanceof ce))return new ce(U,H);k("comparator",U,H),this.loose=H,this.parse(U),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(U,H){return M(H,U)},e.major=function(U,H){return new I(U,H).major},e.minor=function(U,H){return new I(U,H).minor},e.patch=function(U,H){return new I(U,H).patch},e.compare=F,e.compareLoose=function(U,H){return F(U,H,!0)},e.rcompare=function(U,H,J){return F(H,U,J)},e.sort=function(U,H){return U.sort(function(J,de){return e.compare(J,de,H)})},e.rsort=function(U,H){return U.sort(function(J,de){return e.rcompare(J,de,H)})},e.gt=V,e.lt=G,e.eq=te,e.neq=ne,e.gte=ge,e.lte=ye,e.cmp=ue,e.Comparator=ce;var oe={};function se(U,H){if(U instanceof se)return U.loose===H?U:new se(U.raw,H);if(U instanceof ce)return new se(U.value,H);if(!(this instanceof se))return new se(U,H);if(this.loose=H,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function fe(U){return!U||U.toLowerCase()==="x"||U==="*"}function Te(U,H,J,de,ve,Re,Se,Le,Pe,Oe,je,Ie,Ne){return((H=fe(J)?"":fe(de)?">="+J+".0.0":fe(ve)?">="+J+"."+de+".0":">="+H)+" "+(Le=fe(Pe)?"":fe(Oe)?"<"+(+Pe+1)+".0.0":fe(je)?"<"+Pe+"."+(+Oe+1)+".0":Ie?"<="+Pe+"."+Oe+"."+je+"-"+Ie:"<="+Le)).trim()}function Fe(U,H){for(var J=0;J<U.length;J++)if(!U[J].test(H))return!1;if(H.prerelease.length){for(J=0;J<U.length;J++)if(k(U[J].semver),U[J].semver!==oe&&U[J].semver.prerelease.length>0){var de=U[J].semver;if(de.major===H.major&&de.minor===H.minor&&de.patch===H.patch)return!0}return!1}return!0}function De(U,H,J){try{H=new se(H,J)}catch{return!1}return H.test(U)}function Me(U,H,J,de){var ve,Re,Se,Le,Pe;switch(U=new I(U,de),H=new se(H,de),J){case">":ve=V,Re=ye,Se=G,Le=">",Pe=">=";break;case"<":ve=G,Re=ge,Se=V,Le="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(De(U,H,de))return!1;for(var Oe=0;Oe<H.set.length;++Oe){var je=H.set[Oe],Ie=null,Ne=null;if(je.forEach(function(Ce){Ce.semver===oe&&(Ce=new ce(">=0.0.0")),Ie=Ie||Ce,Ne=Ne||Ce,ve(Ce.semver,Ie.semver,de)?Ie=Ce:Se(Ce.semver,Ne.semver,de)&&(Ne=Ce)}),Ie.operator===Le||Ie.operator===Pe||(!Ne.operator||Ne.operator===Le)&&Re(U,Ne.semver)||Ne.operator===Pe&&Se(U,Ne.semver))return!1}return!0}ce.prototype.parse=function(U){var H=this.loose?b[he]:b[B],J=U.match(H);if(!J)throw new TypeError("Invalid comparator: "+U);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new I(J[2],this.loose):this.semver=oe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(U){return k("Comparator.test",U,this.loose),this.semver===oe||(typeof U=="string"&&(U=new I(U,this.loose)),ue(U,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(U,H){if(!(U instanceof ce))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new se(U.value,H),De(this.value,J,H);if(U.operator==="")return J=new se(this.value,H),De(U.semver,J,H);var de=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),Re=this.semver.version===U.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Le=ue(this.semver,"<",U.semver,H)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),Pe=ue(this.semver,">",U.semver,H)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return de||ve||Re&&Se||Le||Pe},e.Range=se,se.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},se.prototype.toString=function(){return this.range},se.prototype.parseRange=function(U){var H=this.loose;U=U.trim(),k("range",U,H);var J=H?b[z]:b[A];U=U.replace(J,Te),k("hyphen replace",U),U=U.replace(b[j],"$1$2$3"),k("comparator trim",U,b[j]),U=(U=(U=U.replace(b[X],"$1~")).replace(b[pe],"$1^")).split(/\s+/).join(" ");var de=H?b[he]:b[B],ve=U.split(" ").map(function(Re){return function(Se,Le){return k("comp",Se),Se=function(Pe,Oe){return Pe.trim().split(/\s+/).map(function(je){return function(Ie,Ne){k("caret",Ie,Ne);var Ce=Ne?b[ae]:b[le];return Ie.replace(Ce,function(Ue,we,Ee,be,ke){var Ae;return k("caret",Ie,Ue,we,Ee,be,ke),fe(we)?Ae="":fe(Ee)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":fe(be)?Ae=we==="0"?">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+".0 <"+(+we+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+ke+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+ke+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+ke+" <"+(+we+1)+".0.0"):(k("no pr"),Ae=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+" <"+(+we+1)+".0.0"),k("caret return",Ae),Ae})}(je,Oe)}).join(" ")}(Se,Le),k("caret",Se),Se=function(Pe,Oe){return Pe.trim().split(/\s+/).map(function(je){return function(Ie,Ne){var Ce=Ne?b[re]:b[ie];return Ie.replace(Ce,function(Ue,we,Ee,be,ke){var Ae;return k("tilde",Ie,Ue,we,Ee,be,ke),fe(we)?Ae="":fe(Ee)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":fe(be)?Ae=">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=">="+we+"."+Ee+"."+be+ke+" <"+we+"."+(+Ee+1)+".0"):Ae=">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0",k("tilde return",Ae),Ae})}(je,Oe)}).join(" ")}(Se,Le),k("tildes",Se),Se=function(Pe,Oe){return k("replaceXRanges",Pe,Oe),Pe.split(/\s+/).map(function(je){return function(Ie,Ne){Ie=Ie.trim();var Ce=Ne?b[C]:b[D];return Ie.replace(Ce,function(Ue,we,Ee,be,ke,Ae){k("xRange",Ie,Ue,we,Ee,be,ke,Ae);var We=fe(Ee),ze=We||fe(be),Be=ze||fe(ke);return we==="="&&Be&&(we=""),We?Ue=we===">"||we==="<"?"<0.0.0":"*":we&&Be?(ze&&(be=0),Be&&(ke=0),we===">"?(we=">=",ze?(Ee=+Ee+1,be=0,ke=0):Be&&(be=+be+1,ke=0)):we==="<="&&(we="<",ze?Ee=+Ee+1:be=+be+1),Ue=we+Ee+"."+be+"."+ke):ze?Ue=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Be&&(Ue=">="+Ee+"."+be+".0 <"+Ee+"."+(+be+1)+".0"),k("xRange return",Ue),Ue})}(je,Oe)}).join(" ")}(Se,Le),k("xrange",Se),Se=function(Pe,Oe){return k("replaceStars",Pe,Oe),Pe.trim().replace(b[$],"")}(Se,Le),k("stars",Se),Se}(Re,H)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Re){return!!Re.match(de)})),ve=ve.map(function(Re){return new ce(Re,H)})},se.prototype.intersects=function(U,H){if(!(U instanceof se))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(de){return U.set.some(function(ve){return ve.every(function(Re){return de.intersects(Re,H)})})})})},e.toComparators=function(U,H){return new se(U,H).set.map(function(J){return J.map(function(de){return de.value}).join(" ").trim().split(" ")})},se.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new I(U,this.loose));for(var H=0;H<this.set.length;H++)if(Fe(this.set[H],U))return!0;return!1},e.satisfies=De,e.maxSatisfying=function(U,H,J){var de=null,ve=null;try{var Re=new se(H,J)}catch{return null}return U.forEach(function(Se){Re.test(Se)&&(de&&ve.compare(Se)!==-1||(ve=new I(de=Se,J)))}),de},e.minSatisfying=function(U,H,J){var de=null,ve=null;try{var Re=new se(H,J)}catch{return null}return U.forEach(function(Se){Re.test(Se)&&(de&&ve.compare(Se)!==1||(ve=new I(de=Se,J)))}),de},e.validRange=function(U,H){try{return new se(U,H).range||"*"}catch{return null}},e.ltr=function(U,H,J){return Me(U,H,"<",J)},e.gtr=function(U,H,J){return Me(U,H,">",J)},e.outside=Me,e.prerelease=function(U,H){var J=K(U,H);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(U,H,J){return U=new se(U,J),H=new se(H,J),U.intersects(H)},e.coerce=function(U){if(U instanceof I)return U;if(typeof U!="string")return null;var H=U.match(b[x]);return H==null?null:K((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,L(1))},function(W,e){var L,R,k=W.exports={};function T(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function b(w){if(L===setTimeout)return setTimeout(w,0);if((L===T||!L)&&setTimeout)return L=setTimeout,setTimeout(w,0);try{return L(w,0)}catch{try{return L.call(null,w,0)}catch{return L.call(this,w,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:T}catch{L=T}try{R=typeof clearTimeout=="function"?clearTimeout:N}catch{R=N}})();var d,u=[],y=!1,p=-1;function m(){y&&d&&(y=!1,d.length?u=d.concat(u):p=-1,u.length&&S())}function S(){if(!y){var w=b(m);y=!0;for(var c=u.length;c;){for(d=u,u=[];++p<c;)d&&d[p].run();p=-1,c=u.length}d=null,y=!1,function(g){if(R===clearTimeout)return clearTimeout(g);if((R===N||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(g);try{R(g)}catch{try{return R.call(null,g)}catch{return R.call(this,g)}}}(w)}}function v(w,c){this.fun=w,this.array=c}function O(){}k.nextTick=function(w){var c=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)c[g-1]=arguments[g];u.push(new v(w,c)),u.length!==1||y||b(S)},v.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=O,k.addListener=O,k.once=O,k.off=O,k.removeListener=O,k.removeAllListeners=O,k.emit=O,k.prependListener=O,k.prependOnceListener=O,k.listeners=function(w){return[]},k.binding=function(w){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(w){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Z[71],Q([0,1]),function(W,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class R{constructor(b,d,u){this.level=b,this.key=d,this.value=u,this.forward=[]}}const k=void 0;class T{constructor(b,d=2**16){this.comparator=b,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new R(this.c,k,k)}get size(){return this.f}clear(){this.e=new R(this.c,k,k)}has(b){return Boolean(T.g(this,b,this.comparator))}get(b){return T.g(this,b,this.comparator)?.value}set(b,d){return T.h(this,b,d,this.comparator)&&(this.f+=1),this}delete(b){const d=T.k(this,b,this.comparator);return d&&(this.f-=1),d}forEach(b,d){let u=this.e.forward[0];for(;u;)b.call(d,u.value,u.key,this),u=u.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",d=this.e.forward[0];for(;d;)b+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return b}static g(b,d,u){let y=b.e;for(let p=b.d-1;p>=0;p--)for(;y.forward[p]&&u(y.forward[p].key,d)<0;)y=y.forward[p];if(y=y.forward[0],y&&u(y.key,d)===0)return y}static h(b,d,u,y){const p=[];let m=b.e;for(let S=b.d-1;S>=0;S--){for(;m.forward[S]&&y(m.forward[S].key,d)<0;)m=m.forward[S];p[S]=m}if(m=m.forward[0],m&&y(m.key,d)===0)return m.value=u,!1;{const S=T.j(b);if(S>b.d){for(let v=b.d;v<S;v++)p[v]=b.e;b.d=S}m=new R(S,d,u);for(let v=0;v<S;v++)m.forward[v]=p[v].forward[v],p[v].forward[v]=m;return!0}}static j(b,d=.5){let u=1;for(;Math.random()<d&&u<b.c;)u+=1;return u}static k(b,d,u){const y=[];let p=b.e;for(let m=b.d-1;m>=0;m--){for(;p.forward[m]&&u(p.forward[m].key,d)<0;)p=p.forward[m];y[m]=p}if(p=p.forward[0],!p||u(p.key,d)!==0)return!1;for(let m=0;m<b.d&&y[m].forward[m]===p;m++)y[m].forward[m]=p.forward[m];for(;b.d>0&&b.e.forward[b.d-1]===k;)b.d-=1;return!0}}e.SkipList=T}),define(Z[43],Q([0,1,10,2]),function(W,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(h){const o=h;return o?typeof o.read=="function":!1}e.isReadable=k;function T(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=T;function N(h){const o=h;return o?T(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=N;function b(h,o){return new d(h,o)}e.newWriteableStream=b;class d{constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,L.onUnexpectedError)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let n;switch(o){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const i=n.indexOf(t);i>=0&&n.splice(i,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(h,o){const t=[];let n;for(;(n=h.read())!==null;)t.push(n);return o(t)}e.consumeReadable=u;function y(h,o,t){const n=[];let i;for(;(i=h.read())!==null&&n.length<t;)n.push(i);return i===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return h.read()}}}e.peekReadable=y;function p(h,o){return new Promise((t,n)=>{const i=[];m(h,{onData:r=>{o&&i.push(r)},onError:r=>{o?n(r):t(void 0)},onEnd:()=>{t(o?o(i):void 0)}})})}e.consumeStream=p;function m(h,o){let t=!1;return h.on("error",n=>{t||o.onError(n)}),h.on("end",()=>{t||o.onEnd()}),h.on("data",n=>{t||o.onData(n)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=m;function S(h,o){return new Promise((t,n)=>{const i=new R.DisposableStore,r=[],s=f=>{if(r.push(f),r.length>o)return i.dispose(),h.pause(),t({stream:h,buffer:r,ended:!1})},l=f=>n(f),a=()=>t({stream:h,buffer:r,ended:!0});i.add((0,R.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),i.add((0,R.toDisposable)(()=>h.removeListener("end",a))),h.on("end",a),i.add((0,R.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=S;function v(h,o){const t=b(o);return t.end(h),t}e.toStream=v;function O(){const h=b(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=O;function w(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}e.toReadable=w;function c(h,o,t){const n=b(t);return m(h,{onData:i=>n.write(o.data(i)),onError:i=>n.error(o.error?o.error(i):i),onEnd:()=>n.end()}),n}e.transform=c;function g(h,o,t){let n=!1;return{read:()=>{const i=o.read();return n?i:(n=!0,i!==null?t([h,i]):h)}}}e.prefixedReadable=g;function E(h,o,t){let n=!1;const i=b(t);return m(o,{onData:r=>n?i.write(r):(n=!0,i.write(t([h,r]))),onError:r=>i.error(r),onEnd:()=>{n||(n=!0,i.write(h)),i.end()}}),i}e.prefixedStream=E}),define(Z[15],Q([0,1,43]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let k,T;class N{static alloc(f){return R?new N(Buffer.allocUnsafe(f)):new N(new Uint8Array(f))}static wrap(f){return R&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new N(f)}static fromString(f,D){return!(D?.dontUseNodeBuffer||!1)&&R?new N(Buffer.from(f)):(k||(k=new TextEncoder),new N(k.encode(f)))}static fromByteArray(f){const D=N.alloc(f.length);for(let C=0,x=f.length;C<x;C++)D.buffer[C]=f[C];return D}static concat(f,D){if(typeof D>"u"){D=0;for(let Y=0,X=f.length;Y<X;Y++)D+=f[Y].byteLength}const C=N.alloc(D);let x=0;for(let Y=0,X=f.length;Y<X;Y++){const ie=f[Y];C.set(ie,x),x+=ie.byteLength}return C}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=N.alloc(this.byteLength);return f.set(this),f}toString(){return R?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(f,D){return new N(this.buffer.subarray(f,D))}set(f,D){if(f instanceof N)this.buffer.set(f.buffer,D);else if(f instanceof Uint8Array)this.buffer.set(f,D);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),D);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return u(this.buffer,f)}writeUInt32BE(f,D){y(this.buffer,f,D)}readUInt32LE(f){return p(this.buffer,f)}writeUInt32LE(f,D){m(this.buffer,f,D)}readUInt8(f){return S(this.buffer,f)}writeUInt8(f,D){v(this.buffer,f,D)}}e.VSBuffer=N;function b(a,f){return a[f+0]<<0>>>0|a[f+1]<<8>>>0}e.readUInt16LE=b;function d(a,f,D){a[D+0]=f&255,f=f>>>8,a[D+1]=f&255}e.writeUInt16LE=d;function u(a,f){return a[f]*2**24+a[f+1]*2**16+a[f+2]*2**8+a[f+3]}e.readUInt32BE=u;function y(a,f,D){a[D+3]=f,f=f>>>8,a[D+2]=f,f=f>>>8,a[D+1]=f,f=f>>>8,a[D]=f}e.writeUInt32BE=y;function p(a,f){return a[f+0]<<0>>>0|a[f+1]<<8>>>0|a[f+2]<<16>>>0|a[f+3]<<24>>>0}e.readUInt32LE=p;function m(a,f,D){a[D+0]=f&255,f=f>>>8,a[D+1]=f&255,f=f>>>8,a[D+2]=f&255,f=f>>>8,a[D+3]=f&255}e.writeUInt32LE=m;function S(a,f){return a[f]}e.readUInt8=S;function v(a,f,D){a[D]=f}e.writeUInt8=v;function O(a){return L.consumeReadable(a,f=>N.concat(f))}e.readableToBuffer=O;function w(a){return L.toReadable(a)}e.bufferToReadable=w;function c(a){return L.consumeStream(a,f=>N.concat(f))}e.streamToBuffer=c;async function g(a){return a.ended?N.concat(a.buffer):N.concat([...a.buffer,await c(a.stream)])}e.bufferedStreamToBuffer=g;function E(a){return L.toStream(a,f=>N.concat(f))}e.bufferToStream=E;function h(a){return L.transform(a,{data:f=>typeof f=="string"?N.fromString(f):N.wrap(f)},f=>N.concat(f))}e.streamToBufferReadableStream=h;function o(a){return L.newWriteableStream(f=>N.concat(f),a)}e.newWriteableBufferStream=o;function t(a,f){return L.prefixedReadable(a,f,D=>N.concat(D))}e.prefixedBufferReadable=t;function n(a,f){return L.prefixedStream(a,f,D=>N.concat(D))}e.prefixedBufferStream=n;function i(a){let f=0,D=0,C=0;const x=new Uint8Array(Math.floor(a.length/4*3)),Y=ie=>{switch(D){case 3:x[C++]=f|ie,D=0;break;case 2:x[C++]=f|ie>>>2,f=ie<<6,D=3;break;case 1:x[C++]=f|ie>>>4,f=ie<<4,D=2;break;default:f=ie<<2,D=1}};for(let ie=0;ie<a.length;ie++){const re=a.charCodeAt(ie);if(re>=65&&re<=90)Y(re-65);else if(re>=97&&re<=122)Y(re-97+26);else if(re>=48&&re<=57)Y(re-48+52);else if(re===43||re===45)Y(62);else if(re===47||re===95)Y(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${a[ie]}`)}}const X=C;for(;D>0;)Y(0);return N.wrap(x).slice(0,X)}e.decodeBase64=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:a},f=!0,D=!1){const C=D?s:r;let x="";const Y=a.byteLength%3;let X=0;for(;X<a.byteLength-Y;X+=3){const ie=a[X+0],re=a[X+1],ee=a[X+2];x+=C[ie>>>2],x+=C[(ie<<4|re>>>4)&63],x+=C[(re<<2|ee>>>6)&63],x+=C[ee&63]}if(Y===1){const ie=a[X+0];x+=C[ie>>>2],x+=C[ie<<4&63],f&&(x+="==")}else if(Y===2){const ie=a[X+0],re=a[X+1];x+=C[ie>>>2],x+=C[(ie<<4|re>>>4)&63],x+=C[re<<2&63],f&&(x+="=")}return x}e.encodeBase64=l}),define(Z[29],Q([0,1,3]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const g=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([E,h])=>{g[E]=h&&typeof h=="object"?R(h):h}),g}e.deepClone=R;function k(c){if(!c||typeof c!="object")return c;const g=[c];for(;g.length>0;){const E=g.shift();Object.freeze(E);for(const h in E)if(T.call(E,h)){const o=E[h];typeof o=="object"&&!Object.isFrozen(o)&&!(0,L.isTypedArray)(o)&&g.push(o)}}return c}e.deepFreeze=k;const T=Object.prototype.hasOwnProperty;function N(c,g){return b(c,g,new Set)}e.cloneAndChange=N;function b(c,g,E){if((0,L.isUndefinedOrNull)(c))return c;const h=g(c);if(typeof h<"u")return h;if(Array.isArray(c)){const o=[];for(const t of c)o.push(b(t,g,E));return o}if((0,L.isObject)(c)){if(E.has(c))throw new Error("Cannot clone recursive data-structure");E.add(c);const o={};for(const t in c)T.call(c,t)&&(o[t]=b(c[t],g,E));return E.delete(c),o}return c}function d(c,g,E=!0){return(0,L.isObject)(c)?((0,L.isObject)(g)&&Object.keys(g).forEach(h=>{h in c?E&&((0,L.isObject)(c[h])&&(0,L.isObject)(g[h])?d(c[h],g[h],E):c[h]=g[h]):c[h]=g[h]}),c):g}e.mixin=d;function u(c,g){if(c===g)return!0;if(c==null||g===null||g===void 0||typeof c!=typeof g||typeof c!="object"||Array.isArray(c)!==Array.isArray(g))return!1;let E,h;if(Array.isArray(c)){if(c.length!==g.length)return!1;for(E=0;E<c.length;E++)if(!u(c[E],g[E]))return!1}else{const o=[];for(h in c)o.push(h);o.sort();const t=[];for(h in g)t.push(h);if(t.sort(),!u(o,t))return!1;for(E=0;E<o.length;E++)if(!u(c[o[E]],g[o[E]]))return!1}return!0}e.equals=u;function y(c){const g=new Set;return JSON.stringify(c,(E,h)=>{if((0,L.isObject)(h)||Array.isArray(h)){if(g.has(h))return"[Circular]";g.add(h)}return h})}e.safeStringify=y;function p(c,g){const E=Object.create(null);return!c||!g||Object.keys(g).forEach(o=>{const t=c[o],n=g[o];u(t,n)||(E[o]=n)}),E}e.distinct=p;function m(c,g){const E=g.toLowerCase(),h=Object.keys(c).find(o=>o.toLowerCase()===E);return h?c[h]:c[g]}e.getCaseInsensitive=m;function S(c,g){const E=Object.create(null);for(const[h,o]of Object.entries(c))g(h,o)&&(E[h]=o);return E}e.filter=S;function v(c){let g=[],E=Object.getPrototypeOf(c);for(;Object.prototype!==E;)g=g.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return g}e.getAllPropertyNames=v;function O(c){const g=[];for(const E of v(c))typeof c[E]=="function"&&g.push(E);return g}e.getAllMethodNames=O;function w(c,g){const E=o=>function(){const t=Array.prototype.slice.call(arguments,0);return g(o,t)},h={};for(const o of c)h[o]=E(o);return h}e.createProxyObject=w}),define(Z[30],Q([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(k){return L.test(k)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(b){for(let d=0;d<b.length;d++)b[d]=Math.floor(Math.random()*256);return b};const T=new Uint8Array(16),N=[];for(let b=0;b<256;b++)N.push(b.toString(16).padStart(2,"0"));return function(){k(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let d=0,u="";return u+=N[T[d++]],u+=N[T[d++]],u+=N[T[d++]],u+=N[T[d++]],u+="-",u+=N[T[d++]],u+=N[T[d++]],u+="-",u+=N[T[d++]],u+=N[T[d++]],u+="-",u+=N[T[d++]],u+=N[T[d++]],u+="-",u+=N[T[d++]],u+=N[T[d++]],u+=N[T[d++]],u+=N[T[d++]],u+=N[T[d++]],u+=N[T[d++]],u}}()}),define(Z[72],Q([0,1,33]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(N){const b=N.replace(/\-/g,":").toLowerCase();return!R.has(b)}function T(){const N=(0,L.networkInterfaces)();for(const b in N){const d=N[b];if(d){for(const{mac:u}of d)if(k(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(Z[73],Q([6,7]),function(W,e){return W.create("vs/base/common/date",e)}),define(Z[74],Q([0,1,73]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,k=R*60,T=k*24,N=T*7,b=T*30,d=T*365;function u(p,m,S){typeof p!="number"&&(p=p.getTime());const v=Math.round((new Date().getTime()-p)/1e3);if(v<-30)return(0,L.localize)(0,null,u(new Date().getTime()+v*1e3,!1));if(v<30)return(0,L.localize)(1,null);let O;return v<R?(O=v,m?O===1?S?(0,L.localize)(2,null,O):(0,L.localize)(3,null,O):S?(0,L.localize)(4,null,O):(0,L.localize)(5,null,O):O===1?S?(0,L.localize)(6,null,O):(0,L.localize)(7,null,O):S?(0,L.localize)(8,null,O):(0,L.localize)(9,null,O)):v<k?(O=Math.floor(v/R),m?O===1?S?(0,L.localize)(10,null,O):(0,L.localize)(11,null,O):S?(0,L.localize)(12,null,O):(0,L.localize)(13,null,O):O===1?S?(0,L.localize)(14,null,O):(0,L.localize)(15,null,O):S?(0,L.localize)(16,null,O):(0,L.localize)(17,null,O)):v<T?(O=Math.floor(v/k),m?O===1?S?(0,L.localize)(18,null,O):(0,L.localize)(19,null,O):S?(0,L.localize)(20,null,O):(0,L.localize)(21,null,O):O===1?S?(0,L.localize)(22,null,O):(0,L.localize)(23,null,O):S?(0,L.localize)(24,null,O):(0,L.localize)(25,null,O)):v<N?(O=Math.floor(v/T),m?O===1?(0,L.localize)(26,null,O):(0,L.localize)(27,null,O):O===1?(0,L.localize)(28,null,O):(0,L.localize)(29,null,O)):v<b?(O=Math.floor(v/N),m?O===1?S?(0,L.localize)(30,null,O):(0,L.localize)(31,null,O):S?(0,L.localize)(32,null,O):(0,L.localize)(33,null,O):O===1?S?(0,L.localize)(34,null,O):(0,L.localize)(35,null,O):S?(0,L.localize)(36,null,O):(0,L.localize)(37,null,O)):v<d?(O=Math.floor(v/b),m?O===1?S?(0,L.localize)(38,null,O):(0,L.localize)(39,null,O):S?(0,L.localize)(40,null,O):(0,L.localize)(41,null,O):O===1?S?(0,L.localize)(42,null,O):(0,L.localize)(43,null,O):S?(0,L.localize)(44,null,O):(0,L.localize)(45,null,O)):(O=Math.floor(v/d),m?O===1?S?(0,L.localize)(46,null,O):(0,L.localize)(47,null,O):S?(0,L.localize)(48,null,O):(0,L.localize)(49,null,O):O===1?S?(0,L.localize)(50,null,O):(0,L.localize)(51,null,O):S?(0,L.localize)(52,null,O):(0,L.localize)(53,null,O))}e.fromNow=u;function y(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(Z[75],Q([6,7]),function(W,e){return W.create("vs/base/common/errorMessage",e)}),define(Z[34],Q([0,1,19,3,75]),function(W,e,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(p,m){return m&&(p.stack||p.stacktrace)?k.localize(0,null,b(p),N(p.stack)||N(p.stacktrace)):b(p)}function N(p){return Array.isArray(p)?p.join(`
`):p}function b(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?k.localize(1,null,p.message):p.message||k.localize(2,null)}function d(p=null,m=!1){if(!p)return k.localize(3,null);if(Array.isArray(p)){const S=L.coalesce(p),v=d(S[0],m);return S.length>1?k.localize(4,null,v,S.length):v}if(R.isString(p))return p;if(p.detail){const S=p.detail;if(S.error)return T(S.error,m);if(S.exception)return T(S.exception,m)}return p.stack?T(p,m):p.message?p.message:k.localize(5,null)}e.toErrorMessage=d;function u(p){const m=p;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=u;function y(p,m){let S;return typeof p=="string"?S=new Error(p):S=p,S.actions=m,S}e.createErrorWithActions=y}),define(Z[76],Q([6,7]),function(W,e){return W.create("vs/base/common/jsonErrorMessages",e)}),define(Z[77],Q([0,1,76]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function R(k){switch(k){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=R}),define(Z[51],Q([0,1,12]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var k;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(b,...d){const u=d.reduce((m,S)=>(m[S]=!0,m),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!u[m]).forEach(m=>{for(let S=0;S<y.length;S++)if(m.search(y[S])!==-1){delete b[m];break}})}e.sanitizeProcessEnvironment=T;function N(b){!b||(delete b.DEBUG,L.isMacintosh&&delete b.DYLD_LIBRARY_PATH,L.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(Z[52],Q([0,1,31]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(c){return k(c,0)}e.hash=R;function k(c,g){switch(typeof c){case"object":return c===null?T(349,g):Array.isArray(c)?d(c,g):u(c,g);case"string":return b(c,g);case"boolean":return N(c,g);case"number":return T(c,g);case"undefined":return T(937,g);default:return T(617,g)}}e.doHash=k;function T(c,g){return(g<<5)-g+c|0}e.numberHash=T;function N(c,g){return T(c?433:863,g)}function b(c,g){g=T(149417,g);for(let E=0,h=c.length;E<h;E++)g=T(c.charCodeAt(E),g);return g}e.stringHash=b;function d(c,g){return g=T(104579,g),c.reduce((E,h)=>k(h,E),g)}function u(c,g){return g=T(181387,g),Object.keys(c).sort().reduce((E,h)=>(E=b(h,E),k(c[h],E)),g)}class y{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=k(g,this.g),this.g}}e.Hasher=y;var p;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function m(c,g,E=32){const h=E-g,o=~((1<<h)-1);return(c<<g|(o&c)>>>h)>>>0}function S(c,g=0,E=c.byteLength,h=0){for(let o=0;o<E;o++)c[g+o]=h}function v(c,g,E="0"){for(;c.length<g;)c=E+c;return c}function O(c,g=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(E=>E.toString(16).padStart(2,"0")).join(""):v((c>>>0).toString(16),g/4)}e.toHexString=O;class w{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const E=g.length;if(E===0)return;const h=this.p;let o=this.r,t=this.u,n,i;for(t!==0?(n=t,i=-1,t=0):(n=g.charCodeAt(0),i=0);;){let r=n;if(L.isHighSurrogate(n))if(i+1<E){const s=g.charCodeAt(i+1);L.isLowSurrogate(s)?(i++,r=L.computeCodePoint(n,s)):r=65533}else{t=n;break}else L.isLowSurrogate(n)&&(r=65533);if(o=this.w(h,o,r),i++,i<E)n=g.charCodeAt(i);else break}this.r=o,this.u=t}w(g,E,h){return h<128?g[E++]=h:h<2048?(g[E++]=192|(h&1984)>>>6,g[E++]=128|(h&63)>>>0):h<65536?(g[E++]=224|(h&61440)>>>12,g[E++]=128|(h&4032)>>>6,g[E++]=128|(h&63)>>>0):(g[E++]=240|(h&1835008)>>>18,g[E++]=128|(h&258048)>>>12,g[E++]=128|(h&4032)>>>6,g[E++]=128|(h&63)>>>0),E>=64&&(this.y(),E-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),O(this.h)+O(this.l)+O(this.m)+O(this.n)+O(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=w.g,E=this.q;for(let a=0;a<64;a+=4)g.setUint32(a,E.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,m(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let h=this.h,o=this.l,t=this.m,n=this.n,i=this.o,r,s,l;for(let a=0;a<80;a++)a<20?(r=o&t|~o&n,s=1518500249):a<40?(r=o^t^n,s=1859775393):a<60?(r=o&t|o&n|t&n,s=2400959708):(r=o^t^n,s=3395469782),l=m(h,5)+r+i+s+g.getUint32(a*4,!1)&4294967295,i=n,n=t,t=m(o,30),o=h,h=l;this.h=this.h+h&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=w,w.g=new DataView(new ArrayBuffer(320))}),define(Z[53],Q([0,1,31]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const T="error",N="warning",b="warn",d="info",u="ignore";function y(m){return m?L.equalsIgnoreCase(T,m)?k.Error:L.equalsIgnoreCase(N,m)||L.equalsIgnoreCase(b,m)?k.Warning:L.equalsIgnoreCase(d,m)?k.Info:k.Ignore:k.Ignore}k.fromValue=y;function p(m){switch(m){case k.Error:return T;case k.Warning:return N;case k.Info:return d;default:return u}}k.toString=p}(R||(R={})),e.default=R}),define(Z[78],Q([0,1,11]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(u){const y=u;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=R;function k(u){const y=[];let p;try{const m=JSON.parse(u.arguments),S=m[m.length-1];S&&S.__$stack&&(m.pop(),p=S.__$stack),y.push(...m)}catch{y.push("Unable to log remote console arguments",u.arguments)}return{args:y,stack:p}}e.parse=k;function T(u){if(typeof u!="string")return T(k(u).stack);const y=u;if(y){const p=N(y),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(m&&m.length===4)return{uri:L.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=T;function N(u){if(!u)return u;const y=u.indexOf(`
`);return y===-1?u:u.substring(0,y)}function b(u,y){const{args:p,stack:m}=k(u),S=typeof p[0]=="string"&&p.length===1;let v=N(m);v&&(v=`(${v.trim()})`);let O=[];if(typeof p[0]=="string"?v&&S?O=[`%c[${y}] %c${p[0]} %c${v}`,d("blue"),d(""),d("grey")]:O=[`%c[${y}] %c${p[0]}`,d("blue"),d(""),...p.slice(1)]:O=[`%c[${y}]%`,d("blue"),...p],v&&!S&&O.push(v),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,O)}e.log=b;function d(u){return`color: ${u}`}}),define(Z[44],Q([0,1,15,31,11]),function(W,e,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(u){return JSON.stringify(u,b)}e.stringify=T;function N(u){let y=JSON.parse(u);return y=d(y),y}e.parse=N;function b(u,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,R.regExpFlags)(y)}:y}function d(u,y=0){if(!u||y>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return k.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof L.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let p=0;p<u.length;++p)u[p]=d(u[p],y+1);else for(const p in u)Object.hasOwnProperty.call(u,p)&&(u[p]=d(u[p],y+1))}return u}e.revive=d}),define(Z[79],Q([0,1,33,10,54,30,72]),function(W,e,L,R,k,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(y){return this.a||(this.a=k.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,p=0;const m=(0,L.networkInterfaces)();for(const S in m){const v=m[S];if(v)for(const{mac:O,internal:w}of v)w||(p+=1,this.c(O.toUpperCase())&&(y+=1))}this.b=p>0?y/p:0}return this.b}};let b;async function d(){return b||(b=(async()=>await u()||T.generateUuid())()),b}e.getMachineId=d;async function u(){try{const y=await new Promise((m,S)=>{W(["crypto"],m,S)}),p=(0,N.getMac)();return y.createHash("sha256").update(p,"utf8").digest("hex")}catch(y){R.onUnexpectedError(y);return}}}),define(Z[80],Q([0,1,33,14,20]),function(W,e,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,N=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var d;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(d||(d={}));let u;switch(process.arch){case"ia32":case"x32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class p{constructor(o,t,n){this.exePath=o,this.displayName=t,this.a=n}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:h=!1}={}){return h?u===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:h=!1,findPreview:o=!1}={}){const t=m({useAlternateBitness:h});if(!t)return null;const n=R.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(n))return null;let i=-1,r=null;for(const a of await k.Promises.readdir(n)){let f=-1;if(o){const C=a.indexOf("-");if(C<0)continue;const x=a.substring(0,C);if(!T.test(x)||a.substring(C+1)!=="preview")continue;f=parseInt(x,10)}else{if(!T.test(a))continue;f=parseInt(a,10)}if(f<=i)continue;const D=R.join(n,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(D)||(r=D,i=f)}if(!r)return null;const s=t.includes("x86")?" (x86)":"",l=o?" Preview":"";return new p(r,`PowerShell${l}${s}`,!0)}async function v({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const o=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=h?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(o))if(t.test(i)){const r=R.join(o,i,"pwsh.exe");return new p(r,n)}return null}function O(){const h=R.join(L.homedir(),".dotnet","tools","pwsh.exe");return new p(h,".NET Core PowerShell Global Tool")}function w(){const h=R.join(process.env.windir,u===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(h,"Windows PowerShell",!0)}async function*c(){let h=await S();h&&(yield h),h=await S({useAlternateBitness:!0}),h&&(yield h),h=await v(),h&&(yield h),h=O(),h&&(yield h),h=await S({findPreview:!0}),h&&(yield h),h=await v({findPreview:!0}),h&&(yield h),h=await S({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=w(),h&&(yield h)}async function*g(){for await(const h of c())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=g;async function E(){for await(const h of g())return h;return null}e.getFirstAvailablePowerShellInstallation=E}),define(Z[55],Q([0,1,14,12,35,51,3,20]),function(W,e,L,R,k,T,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function d(p=k.env){return p.comspec||"cmd.exe"}e.getWindowsShell=d;function u(p){let m=[],S=!1;const v=function(O){if(S){m.push(O);return}(!p.send(O,c=>{if(c&&console.error(c),S=!1,m.length>0){const g=m.slice(0);m=[],g.forEach(E=>v(E))}})||R.isWindows)&&(S=!0)};return{send:v}}e.createQueuedSender=u;var y;(function(p){async function m(S,v,O){if(L.isAbsolute(S))return S;if(v===void 0&&(v=k.cwd()),L.dirname(S)!=="."||(O===void 0&&N.isString(k.env.PATH)&&(O=k.env.PATH.split(L.delimiter)),O===void 0||O.length===0))return L.join(v,S);async function c(g){if(await b.Promises.exists(g)){let E;try{E=await b.Promises.stat(g)}catch(h){h.message.startsWith("EACCES")&&(E=await b.Promises.lstat(g))}return E?!E.isDirectory():!1}return!1}for(const g of O){let E;if(L.isAbsolute(g)?E=L.join(g,S):E=L.join(v,g,S),await c(E))return E;let h=E+".com";if(await c(h)||(h=E+".exe",await c(h)))return h}return L.join(v,S)}p.findExecutable=m})(y=e.win32||(e.win32={}))}),define(Z[81],Q([0,1,33,12,80,55]),function(W,e,L,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function N(p,m){return p===1?R.isWindows?y():T.getWindowsShell(m):d(p,m)}e.getSystemShell=N;let b=null;function d(p,m){if(R.isLinux&&p===2||R.isMacintosh&&p===3)return"/bin/bash";if(!b){let S;if(R.isWindows)S="/bin/bash";else{if(S=m.SHELL,!S)try{S=(0,L.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}b=S}return b}let u=null;async function y(){return u||(u=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),u}});var me=this&&this.__decorate||function(W,e,L,R){var k=arguments.length,T=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,L):R,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(W,e,L,R);else for(var b=W.length-1;b>=0;b--)(N=W[b])&&(T=(k<3?N(T):k>3?N(e,L,T):N(e,L))||T);return k>3&&T&&Object.defineProperty(e,L,T),T};define(Z[56],Q([0,1,19,4,15,22,49,10,5,2,44,31,3]),function(W,e,L,R,k,T,N,b,d,u,y,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var S;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(S||(S={}));function v(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var O;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(O||(O={}));function w(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(c||(c={}));function g(j){let A=0;for(let z=0;;z+=7){const $=j.read(1);if(A|=($.buffer[0]&127)<<z,!($.buffer[0]&128))return A}}const E=i(0);function h(j,A){if(A===0){j.write(E);return}let z=0;for(let q=A;q!==0;q=q>>>7)z++;const $=k.VSBuffer.alloc(z);for(let q=0;A!==0;q++)$.buffer[q]=A&127,A=A>>>7,A>0&&($.buffer[q]|=128);j.write($)}class o{constructor(A){this.b=A,this.a=0}read(A){const z=this.b.slice(this.a,this.a+A);return this.a+=z.byteLength,z}}e.BufferReader=o;class t{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(A){this.a.push(A)}}e.BufferWriter=t;var n;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(n||(n={}));function i(j){const A=k.VSBuffer.alloc(1);return A.writeUInt8(j,0),A}const r={Undefined:i(n.Undefined),String:i(n.String),Buffer:i(n.Buffer),VSBuffer:i(n.VSBuffer),Array:i(n.Array),Object:i(n.Object),Uint:i(n.Int)},s=typeof Buffer<"u";function l(j,A){if(typeof A>"u")j.write(r.Undefined);else if(typeof A=="string"){const z=k.VSBuffer.fromString(A);j.write(r.String),h(j,z.byteLength),j.write(z)}else if(s&&Buffer.isBuffer(A)){const z=k.VSBuffer.wrap(A);j.write(r.Buffer),h(j,z.byteLength),j.write(z)}else if(A instanceof k.VSBuffer)j.write(r.VSBuffer),h(j,A.byteLength),j.write(A);else if(Array.isArray(A)){j.write(r.Array),h(j,A.length);for(const z of A)l(j,z)}else if(typeof A=="number"&&(A|0)===A)j.write(r.Uint),h(j,A);else{const z=k.VSBuffer.fromString(JSON.stringify(A));j.write(r.Object),h(j,z.byteLength),j.write(z)}}e.serialize=l;function a(j){switch(j.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return j.read(g(j)).toString();case n.Buffer:return j.read(g(j)).buffer;case n.VSBuffer:return j.read(g(j));case n.Array:{const z=g(j),$=[];for(let q=0;q<z;q++)$.push(a(j));return $}case n.Object:return JSON.parse(j.read(g(j)).toString());case n.Int:return g(j)}}e.deserialize=a;class f{constructor(A,z,$=null,q=1e3){this.h=A,this.j=z,this.k=$,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(A,z){this.b.set(A,z),setTimeout(()=>this.w(A),0)}m(A){switch(A.type){case 200:{const z=this.o([A.type]);this.k?.logOutgoing(z,0,1,w(A.type));return}case 201:case 202:case 204:case 203:{const z=this.o([A.type,A.id],A.data);this.k?.logOutgoing(z,A.id,1,w(A.type),A.data);return}}}o(A,z=void 0){const $=new t;return l($,A),l($,z),this.p($.buffer)}p(A){try{return this.h.send(A),A.byteLength}catch{return 0}}q(A){const z=new o(A),$=a(z),q=a(z),K=$[0];switch(K){case 100:return this.k?.logIncoming(A.byteLength,$[1],1,`${v(K)}: ${$[2]}.${$[3]}`,q),this.s({type:K,id:$[1],channelName:$[2],name:$[3],arg:q});case 102:return this.k?.logIncoming(A.byteLength,$[1],1,`${v(K)}: ${$[2]}.${$[3]}`,q),this.t({type:K,id:$[1],channelName:$[2],name:$[3],arg:q});case 101:return this.k?.logIncoming(A.byteLength,$[1],1,`${v(K)}`),this.u({type:K,id:$[1]});case 103:return this.k?.logIncoming(A.byteLength,$[1],1,`${v(K)}`),this.u({type:K,id:$[1]})}}s(A){const z=this.b.get(A.channelName);if(!z){this.v(A);return}const $=new T.CancellationTokenSource;let q;try{q=z.call(this.j,A.name,A.arg,$.token)}catch(P){q=Promise.reject(P)}const K=A.id;q.then(P=>{this.m({id:K,data:P,type:201}),this.d.delete(A.id)},P=>{P instanceof Error?this.m({id:K,data:{message:P.message,name:P.name,stack:P.stack?P.stack.split?P.stack.split(`
`):P.stack:void 0},type:202}):this.m({id:K,data:P,type:203}),this.d.delete(A.id)});const I=(0,u.toDisposable)(()=>$.cancel());this.d.set(A.id,I)}t(A){const z=this.b.get(A.channelName);if(!z){this.v(A);return}const $=A.id,K=z.listen(this.j,A.name,A.arg)(I=>this.m({id:$,data:I,type:204}));this.d.set(A.id,K)}u(A){const z=this.d.get(A.id);z&&(z.dispose(),this.d.delete(A.id))}v(A){let z=this.g.get(A.channelName);z||(z=[],this.g.set(A.channelName,z));const $=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.m({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:A,timeoutTimer:$})}w(A){const z=this.g.get(A);if(z){for(const $ of z)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.s($.request);break;case 102:this.t($.request);break}this.g.delete(A)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=f;var D;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class C{constructor(A,z=null){this.l=A,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage($=>this.s($)),this.j=z}getChannel(A){const z=this;return{call($,q,K){return z.a?Promise.reject(new b.CancellationError):z.m(A,$,q,K)},listen($,q){return z.a?d.Event.None:z.o(A,$,q)}}}m(A,z,$,q=T.CancellationToken.None){const K=this.g++,P={id:K,type:100,channelName:A,name:z,arg:$};if(q.isCancellationRequested)return Promise.reject(new b.CancellationError);let M;return new Promise((V,G)=>{if(q.isCancellationRequested)return G(new b.CancellationError);const te=()=>{const ue=ce=>{switch(ce.type){case 201:this.f.delete(K),V(ce.data);break;case 202:{this.f.delete(K);const oe=new Error(ce.data.message);oe.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,oe.name=ce.data.name,G(oe);break}case 203:this.f.delete(K),G(ce.data);break}};this.f.set(K,ue),this.p(P)};let ne=null;this.b===c.Idle?te():(ne=(0,R.createCancelablePromise)(ue=>this.u()),ne.then(()=>{ne=null,te()}));const ge=()=>{ne?(ne.cancel(),ne=null):this.p({id:K,type:101}),G(new b.CancellationError)},ye=q.onCancellationRequested(ge);M=(0,u.combinedDisposable)((0,u.toDisposable)(ge),ye),this.d.add(M)}).finally(()=>{this.d.delete(M)})}o(A,z,$){const q=this.g++,I={id:q,type:102,channelName:A,name:z,arg:$};let P=null;const M=new d.Emitter({onWillAddFirstListener:()=>{P=(0,R.createCancelablePromise)(V=>this.u()),P.then(()=>{P=null,this.d.add(M),this.p(I)})},onDidRemoveLastListener:()=>{P?(P.cancel(),P=null):(this.d.delete(M),this.p({id:q,type:103}))}}),F=V=>M.fire(V.data);return this.f.set(q,F),M.event}p(A){switch(A.type){case 100:case 102:{const z=this.q([A.type,A.id,A.channelName,A.name],A.arg);this.j?.logOutgoing(z,A.id,0,`${v(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const z=this.q([A.type,A.id]);this.j?.logOutgoing(z,A.id,0,v(A.type));return}}}q(A,z=void 0){const $=new t;return l($,A),l($,z),this.r($.buffer)}r(A){try{return this.l.send(A),A.byteLength}catch{return 0}}s(A){const z=new o(A),$=a(z),q=a(z),K=$[0];switch(K){case 200:return this.j?.logIncoming(A.byteLength,0,0,w(K)),this.t({type:$[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(A.byteLength,$[1],0,w(K),q),this.t({type:$[0],id:$[1],data:q})}}t(A){if(A.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(A.id)?.(A)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.dispose)(this.d.values()),this.d.clear()}}me([N.memoize],C.prototype,"onDidInitializePromise",null),e.ChannelClient=C;class x{get connections(){const A=[];return this.f.forEach(z=>A.push(z)),A}constructor(A){this.a=new Map,this.f=new Set,this.g=new d.Emitter,this.onDidAddConnection=this.g.event,this.h=new d.Emitter,this.onDidRemoveConnection=this.h.event,A(({protocol:z,onDidClientDisconnect:$})=>{d.Event.once(z.onMessage)(K=>{const I=new o(K),P=a(I),M=new f(z,P),F=new C(z);this.a.forEach((G,te)=>M.registerChannel(te,G));const V={channelServer:M,channelClient:F,ctx:P};this.f.add(V),this.g.fire(V),$(()=>{M.dispose(),F.dispose(),this.f.delete(V),this.h.fire(V)})})})}getChannel(A,z){const $=this;return{call(q,K,I){let P;if((0,m.isFunction)(z)){const F=(0,L.getRandomElement)($.connections.filter(z));P=F?Promise.resolve(F):d.Event.toPromise(d.Event.filter($.onDidAddConnection,z))}else P=z.routeCall($,q,K);const M=P.then(F=>F.channelClient.getChannel(A));return X(M).call(q,K,I)},listen(q,K){if((0,m.isFunction)(z))return $.j(A,z,q,K);const I=z.routeEvent($,q,K).then(P=>P.channelClient.getChannel(A));return X(I).listen(q,K)}}}j(A,z,$,q){const K=this;let I=new u.DisposableStore;const P=new d.Emitter({onWillAddFirstListener:()=>{I=new u.DisposableStore;const M=new d.EventMultiplexer,F=new Map,V=te=>{const ge=te.channelClient.getChannel(A).listen($,q),ye=M.add(ge);F.set(te,ye)},G=te=>{const ne=F.get(te);!ne||(ne.dispose(),F.delete(te))};K.connections.filter(z).forEach(V),d.Event.filter(K.onDidAddConnection,z)(V,void 0,I),K.onDidRemoveConnection(G,void 0,I),M.event(P.fire,P,I),I.add(M)},onDidRemoveLastListener:()=>{I.dispose()}});return P.event}registerChannel(A,z){this.a.set(A,z),this.f.forEach($=>{$.channelServer.registerChannel(A,z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=x;class Y{constructor(A,z,$=null){const q=new t;l(q,z),A.send(q.buffer),this.a=new C(A,$),this.d=new f(A,z,$)}getChannel(A){return this.a.getChannel(A)}registerChannel(A,z){this.d.registerChannel(A,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=Y;function X(j){return{call(A,z,$){return j.then(q=>q.call(A,z,$))},listen(A,z){const $=new d.Relay;return j.then(q=>$.input=q.listen(A,z)),$.event}}}e.getDelayedChannel=X;function ie(j){let A=!1;return{call(z,$,q){return A?j.call(z,$,q):(0,R.timeout)(0).then(()=>A=!0).then(()=>j.call(z,$,q))},listen(z,$){if(A)return j.listen(z,$);const q=new d.Relay;return(0,R.timeout)(0).then(()=>A=!0).then(()=>q.input=j.listen(z,$)),q.event}}}e.getNextTickChannel=ie;class re{constructor(A){this.a=A}routeCall(A){return this.b(A)}routeEvent(A){return this.b(A)}async b(A){for(const z of A.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await d.Event.toPromise(A.onDidAddConnection),await this.b(A)}}e.StaticRouter=re;var ee;(function(j){function A(K,I){const P=K,M=I&&I.disableMarshalling,F=new Map;for(const V in P)$(V)&&F.set(V,d.Event.buffer(P[V],!0));return new class{listen(V,G,te){const ne=F.get(G);if(ne)return ne;if(q(G)){const ge=P[G];if(typeof ge=="function")return ge.call(P,te)}throw new Error(`Event not found: ${G}`)}call(V,G,te){const ne=P[G];if(typeof ne=="function"){if(!M&&Array.isArray(te))for(let ge=0;ge<te.length;ge++)te[ge]=(0,y.revive)(te[ge]);return ne.apply(P,te)}throw new Error(`Method not found: ${G}`)}}}j.fromService=A;function z(K,I){const P=I&&I.disableMarshalling;return new Proxy({},{get(M,F){if(typeof F=="string")return I?.properties?.has(F)?I.properties.get(F):q(F)?function(V){return K.listen(F,V)}:$(F)?K.listen(F):async function(...V){let G;I&&!(0,m.isUndefinedOrNull)(I.context)?G=[I.context,...V]:G=V;const te=await K.call(F,G);return P?te:(0,y.revive)(te)};throw new Error(`Property not found: ${String(F)}`)}})}j.toService=z;function $(K){return K[0]==="o"&&K[1]==="n"&&p.isUpperAsciiLetter(K.charCodeAt(2))}function q(K){return/^onDynamic/.test(K)&&p.isUpperAsciiLetter(K.charCodeAt(9))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const pe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const A=j.toString();if(A!=="[object Object]")return A}return j}function ae(j){return Array.isArray(j)?j.map(le):le(j)}function he(j,A,z,$,q,K,I){I=ae(I);const P=pe[q],M=P[$%P.length];let F=[`%c[${j}]%c[${String(A).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String($).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(K)?(F=F.concat(I),F.push(")")):F.push(I),console.log.apply(console,F)}class B{constructor(A,z){this.d=A,this.f=z,this.a=0,this.b=0}logOutgoing(A,z,$,q,K){this.b+=A,he(this.d,this.b,A,z,$,q,K)}logIncoming(A,z,$,q,K){this.a+=A,he(this.f,this.a,A,z,$,q,K)}}e.IPCLogger=B}),define(Z[82],Q([0,1,57,4,15,22,78,10,5,2,29,55,51,56]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class v extends S.ChannelServer{constructor(c){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",g=>k.VSBuffer.wrap(Buffer.from(g,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.Server=v;class O{constructor(c,g){this.i=c,this.j=g,this.c=new Set,this.g=new Map,this.h=new d.Emitter,this.onDidProcessExit=this.h.event;const E=g&&g.timeout?g.timeout:6e4;this.b=new R.Delayer(E),this.d=null,this.f=null}getChannel(c){const g=this;return{call(E,h,o){return g.k(c,E,h,o)},listen(E,h){return g.l(c,E,h)}}}k(c,g,E,h=T.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(b.canceled());this.b.cancel();const o=this.n(c),t=(0,R.createCancelablePromise)(r=>o.call(g,E,r)),n=h.onCancellationRequested(()=>t.cancel()),i=(0,u.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{n.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,g,E){if(!this.b)return d.Event.None;this.b.cancel();let h;const o=new d.Emitter({onWillAddFirstListener:()=>{h=this.n(c).listen(g,E)(o.fire,o),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,m.removeDangerousEnvVariables)(g.env),this.d=(0,L.fork)(this.i,c,g);const E=new d.Emitter;d.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,N.isRemoteConsoleLog)(s)){(0,N.log)(s,`IPC Library: ${this.j.serverName}`);return}E.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const o=this.j.useQueue?(0,p.createQueuedSender)(this.d):this.d,t=s=>this.d&&this.d.connected&&o.send(s.buffer.toString("base64")),n=E.event,i={send:t,onMessage:n};this.f=new S.ChannelClient(i);const r=()=>this.o();process.once("exit",r),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,l)=>{process.removeListener("exit",r),this.c.forEach(a=>(0,u.dispose)(a)),this.c.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:l})})}return this.f}n(c){let g=this.g.get(c);return g||(g=this.m.getChannel(c),this.g.set(c,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=O}),define(Z[83],Q([0,1,4,5,2,3]),function(W,e,L,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N=e.StorageHint||(e.StorageHint={}));function b(p){const m=p;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var d;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(d=e.StorageState||(e.StorageState={}));class u extends k.Disposable{constructor(m,S=Object.create(null)){super(),this.m=m,this.n=S,this.b=this.B(new R.Emitter),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=new L.ThrottledDelayer(u.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(m=>this.r(m)))}r(m){m.changed?.forEach((S,v)=>this.s(v,S)),m.deleted?.forEach(S=>this.s(S,void 0))}s(m,S){if(this.c===d.Closed)return;let v=!1;(0,T.isUndefinedOrNull)(S)?v=this.f.delete(m):this.f.get(m)!==S&&(this.f.set(m,S),v=!0),v&&this.b.fire(m)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(m,S){const v=this.f.get(m);return(0,T.isUndefinedOrNull)(v)?S:v}getBoolean(m,S){const v=this.get(m);return(0,T.isUndefinedOrNull)(v)?S:v==="true"}getNumber(m,S){const v=this.get(m);return(0,T.isUndefinedOrNull)(v)?S:parseInt(v,10)}async set(m,S){if(this.c===d.Closed)return;if((0,T.isUndefinedOrNull)(S))return this.delete(m);const v=String(S);if(this.f.get(m)!==v)return this.f.set(m,v),this.j.set(m,v),this.h.delete(m),this.b.fire(m),this.w()}async delete(m){if(!(this.c===d.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire(m),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=d.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(m).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(m){if(!!this.u)return this.w(m)}async w(m){return this.g.trigger(()=>this.v(),m)}async whenFlushed(){if(!!this.u)return new Promise(m=>this.l.push(m))}isInMemory(){return this.n.hint===N.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=u,u.a=100;class y{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((S,v)=>this.a.set(v,S)),m.delete?.forEach(S=>this.a.delete(S))}async close(){}}e.InMemoryStorageDatabase=y}),define(Z[84],Q([6,7]),function(W,e){return W.create("vs/base/node/zip",e)}),define(Z[85],Q([6,7]),function(W,e){return W.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[86],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[87],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[88],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Z[89],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[90],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[91],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[92],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[93],Q([6,7]),function(W,e){return W.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[94],Q([6,7]),function(W,e){return W.create("vs/platform/files/common/fileService",e)}),define(Z[95],Q([6,7]),function(W,e){return W.create("vs/platform/files/common/io",e)}),define(Z[96],Q([6,7]),function(W,e){return W.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[97],Q([6,7]),function(W,e){return W.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Z[98],Q([6,7]),function(W,e){return W.create("vs/platform/request/common/request",e)}),define(Z[99],Q([6,7]),function(W,e){return W.create("vs/platform/shell/node/shellEnv",e)}),define(Z[100],Q([6,7]),function(W,e){return W.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[101],Q([6,7]),function(W,e){return W.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[102],Q([6,7]),function(W,e){return W.create("vs/platform/workspace/common/workspace",e)}),define(Z[103],Q([0,1,74,49,16,14,35,17,11]),function(W,e,L,R,k,T,N,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,T.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return d.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(d.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=N.env.VSCODE_PORTABLE;return v?d.URI.file((0,T.join)(v,"argv.json")):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,T.resolve)(v):(0,T.normalize)((0,T.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?d.URI.file((0,T.resolve)(v)):d.URI.file((0,T.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,T.resolve)(v);const O=N.env.VSCODE_EXTENSIONS;if(O)return O;const w=N.env.VSCODE_PORTABLE;return w?(0,T.join)(w,"extensions"):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(O=>/^[^:/?#]+?:\/\//.test(O)?d.URI.parse(O):d.URI.file((0,T.normalize)(O)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?d.URI.parse(v):d.URI.file((0,T.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const O of this.args.log||[]){const w=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(O);w&&w[1]&&w[2]&&v.push([w[1],w[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,b.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return d.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=N.env.VSCODE_PORTABLE;return v?d.URI.file((0,T.join)(v,"policy.json")):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this.a}constructor(v,O,w){this.a=v,this.b=O,this.c=w,this.editSessionId=this.args.editSessionId}}me([R.memoize],u.prototype,"appRoot",null),me([R.memoize],u.prototype,"userHome",null),me([R.memoize],u.prototype,"userDataPath",null),me([R.memoize],u.prototype,"appSettingsHome",null),me([R.memoize],u.prototype,"tmpDir",null),me([R.memoize],u.prototype,"cacheHome",null),me([R.memoize],u.prototype,"stateResource",null),me([R.memoize],u.prototype,"userRoamingDataHome",null),me([R.memoize],u.prototype,"userDataSyncHome",null),me([R.memoize],u.prototype,"userDataSyncLogResource",null),me([R.memoize],u.prototype,"editSessionsLogResource",null),me([R.memoize],u.prototype,"sync",null),me([R.memoize],u.prototype,"machineSettingsResource",null),me([R.memoize],u.prototype,"workspaceStorageHome",null),me([R.memoize],u.prototype,"localHistoryHome",null),me([R.memoize],u.prototype,"keyboardLayoutResource",null),me([R.memoize],u.prototype,"argvResource",null),me([R.memoize],u.prototype,"isExtensionDevelopment",null),me([R.memoize],u.prototype,"untitledWorkspacesHome",null),me([R.memoize],u.prototype,"installSourcePath",null),me([R.memoize],u.prototype,"builtinExtensionsPath",null),me([R.memoize],u.prototype,"extensionsPath",null),me([R.memoize],u.prototype,"extensionDevelopmentLocationURI",null),me([R.memoize],u.prototype,"extensionDevelopmentKind",null),me([R.memoize],u.prototype,"extensionTestsLocationURI",null),me([R.memoize],u.prototype,"debugExtensionHost",null),me([R.memoize],u.prototype,"logLevel",null),me([R.memoize],u.prototype,"extensionLogLevel",null),me([R.memoize],u.prototype,"serviceMachineIdResource",null),me([R.memoize],u.prototype,"telemetryLogResource",null),me([R.memoize],u.prototype,"disableWorkspaceTrust",null),me([R.memoize],u.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=u;function y(S,v){return m(S["inspect-extensions"],S["inspect-brk-extensions"],5870,v,S.debugId,S.extensionEnvironment)}e.parseExtensionHostPort=y;function p(S,v){return m(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,v,S.extensionEnvironment)}e.parsePtyHostPort=p;function m(S,v,O,w,c,g){const h=Number(v||S)||(w?null:O),o=h?Boolean(!!v):!1;let t;if(g)try{t=JSON.parse(g)}catch{}return{port:h,break:o,debugId:c,env:t}}}),function(){"use strict";function W(e,L,R){function k(N,b){const d=T(N,b),u=[d];return e.isAbsolute(d)||u.unshift(R),e.resolve(...u)}function T(N,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,b);const y=N["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(p,"AppData","Roaming")}break;case"darwin":u=e.join(L.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,b)}return{getUserDataPath:k}}if(typeof define=="function")define(Z[104],Q([154,33,35]),function(e,L,R){return W(e,L,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=W(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[105],Q([0,1,33,103,104]),function(W,e,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends R.AbstractNativeEnvironmentService{constructor(b,d){super(b,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,k.getUserDataPath)(b,d.nameShort)},d)}}e.NativeEnvironmentService=T}),define(Z[106],Q([0,1,3,89]),function(W,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(N,b,d){try{T(N,b,d)}catch(u){console.error(u?.message??u)}return N}e.localizeManifest=k;function T(N,b,d){const u=(y,p,m)=>{const S=y[p];if((0,L.isString)(S)){const v=S,O=v.length;if(O>1&&v[0]==="%"&&v[O-1]==="%"){const w=v.substr(1,O-2);let c=b[w];c===void 0&&d&&(c=d[w]);const g=typeof c=="string"?c:c?.message,E=d?.[w],h=typeof E=="string"?E:E?.message;if(!g){h||console.warn(`[${N.name}]: ${(0,R.localize)(0,null,w)}`);return}if(m&&(p==="title"||p==="category")&&h&&h!==g){const o={value:g,original:h};y[p]=o}else y[p]=g}}else if((0,L.isObject)(S))for(const v in S)S.hasOwnProperty(v)&&(v==="commands"?u(S,v,!0):u(S,v,m));else if(Array.isArray(S))for(let v=0;v<S.length;v++)u(S,v,m)};for(const y in N)N.hasOwnProperty(y)&&u(N,y)}}),define(Z[107],Q([0,1,10]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class R{constructor(){this.a=new Map}register(T,N){this.a.set(T,N)}updateManifest(T){if(!(typeof T.main>"u"&&typeof T.browser>"u")&&(T.activationEvents===void 0&&Object.assign(T,{activationEvents:[]}),!(!Array.isArray(T.activationEvents)||!T.contributes)))for(const N in T.contributes){const b=this.a.get(N);if(!b)continue;const d=T.contributes[N],u=Array.isArray(d)?d:[d];try{b(u,T.activationEvents)}catch(y){(0,L.onUnexpectedError)(y)}}}}e.ImplicitActivationEventsImpl=R,e.ImplicitActivationEvents=new R}),define(Z[45],Q([0,1,17,53,93,39]),function(W,e,L,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function d(c){return c=c.trim(),c==="*"||N.test(c)}e.isValidVersionStr=d;function u(c){if(!d(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=c.match(N);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=u;function y(c){if(!c)return null;const g=c.majorBase,E=c.majorMustEqual,h=c.minorBase;let o=c.minorMustEqual;const t=c.patchBase;let n=c.patchMustEqual;c.hasCaret&&(g===0||(o=!1),n=!1);let i=0;if(c.preRelease){const r=b.exec(c.preRelease);if(r){const[,s,l,a]=r;i=Date.UTC(Number(s),Number(l)-1,Number(a))}}return{majorBase:g,majorMustEqual:E,minorBase:h,minorMustEqual:o,patchBase:t,patchMustEqual:n,isMinimum:c.hasGreaterEquals,notBefore:i}}e.normalizeVersion=y;function p(c,g,E){let h;typeof c=="string"?h=y(u(c)):h=c;let o;g instanceof Date?o=g.getTime():typeof g=="string"&&(o=new Date(g).getTime());let t;if(typeof E=="string"?t=y(u(E)):t=E,!h||!t)return!1;const n=h.majorBase,i=h.minorBase,r=h.patchBase;let s=t.majorBase,l=t.minorBase,a=t.patchBase;const f=t.notBefore;let D=t.majorMustEqual,C=t.minorMustEqual,x=t.patchMustEqual;return t.isMinimum?n>s?!0:n<s?!1:i>l?!0:i<l||o&&o<f?!1:r>=a:(n===1&&s===0&&(!D||!C||!x)&&(s=1,l=0,a=0,D=!0,C=!1,x=!1),n<s?!1:n>s?!D:i<l?!1:i>l?!C:r<a?!1:r>a?!x:!(o&&o<f))}e.isValidVersion=p;function m(c,g,E,h,o){const t=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return t.push([R.default.Error,k.localize(0,null)]),t;if(typeof h.name!="string")return t.push([R.default.Error,k.localize(1,null,"name")]),t;if(typeof h.version!="string")return t.push([R.default.Error,k.localize(2,null,"version")]),t;if(!h.engines)return t.push([R.default.Error,k.localize(3,null,"engines")]),t;if(typeof h.engines.vscode!="string")return t.push([R.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof h.extensionDependencies<"u"&&!w(h.extensionDependencies))return t.push([R.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof h.activationEvents<"u"){if(!w(h.activationEvents))return t.push([R.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof h.main>"u"&&typeof h.browser>"u")return t.push([R.default.Error,k.localize(7,null,"activationEvents","main")]),t}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&t.push([R.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return t.push([R.default.Error,k.localize(9,null,"main")]),t;{const r=(0,L.joinPath)(E,h.main);(0,L.isEqualOrParent)(r,E)||t.push([R.default.Warning,k.localize(10,null,r.path,E.path)])}if(typeof h.activationEvents>"u")return t.push([R.default.Error,k.localize(11,null,"activationEvents","main")]),t}if(typeof h.browser<"u"){if(typeof h.browser!="string")return t.push([R.default.Error,k.localize(12,null,"browser")]),t;{const r=(0,L.joinPath)(E,h.browser);(0,L.isEqualOrParent)(r,E)||t.push([R.default.Warning,k.localize(13,null,r.path,E.path)])}if(typeof h.activationEvents>"u")return t.push([R.default.Error,k.localize(14,null,"activationEvents","browser")]),t}if(!T.valid(h.version))return t.push([R.default.Error,k.localize(15,null)]),t;const n=[];if(!S(c,g,h,o,n))for(const r of n)t.push([R.default.Error,r]);return t}e.validateExtensionManifest=m;function S(c,g,E,h,o){return h||typeof E.main>"u"&&typeof E.browser>"u"?!0:O(c,g,E.engines.vscode,o)}e.isValidExtensionVersion=S;function v(c,g,E){return c==="*"||O(g,E,c)}e.isEngineValid=v;function O(c,g,E,h=[]){const o=y(u(E));if(!o)return h.push(k.localize(16,null,E)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return h.push(k.localize(17,null,E)),!1}else if(!o.majorMustEqual)return h.push(k.localize(18,null,E)),!1;return p(c,g,o)?!0:(h.push(k.localize(19,null,c,E)),!1)}function w(c){if(!Array.isArray(c))return!1;for(let g=0,E=c.length;g<E;g++)if(typeof c[g]!="string")return!1;return!0}}),define(Z[108],Q([0,1,15,30]),function(W,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(T,N,b){let d=b&&b.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const y=(await N.readFile(T.serviceMachineIdResource)).value.toString();d=(0,R.isUUID)(y)?y:null}catch{d=null}if(!d){d=(0,R.generateUuid)();try{await N.writeFile(T.serviceMachineIdResource,L.VSBuffer.fromString(d))}catch{}}return b?.store("storage.serviceMachineId",d,-1,1),d}e.getServiceMachineId=k}),define(Z[46],Q([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(k,T=[],N=!1){this.ctor=k,this.staticArguments=T,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=L}),define(Z[109],Q([0,1,46]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var k;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function T(b,d,u){d instanceof L.SyncDescriptor||(d=new L.SyncDescriptor(d,[],Boolean(u))),R.push([b,d])}e.registerSingleton=T;function N(){return R}e.getSingletonServiceDescriptors=N}),define(Z[110],Q([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(T,N){this.key=T,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class R{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const N of this.a.values())N.outgoing.size===0&&T.push(N);return T}insertEdge(T,N){const b=this.lookupOrInsertNode(T),d=this.lookupOrInsertNode(N);b.outgoing.set(d.key,d),d.incoming.set(b.key,b)}removeNode(T){const N=this.b(T);this.a.delete(N);for(const b of this.a.values())b.outgoing.delete(N),b.incoming.delete(N)}lookupOrInsertNode(T){const N=this.b(T);let b=this.a.get(N);return b||(b=new L(N,T),this.a.set(N,b)),b}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[N,b]of this.a)T.push(`${N}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,N]of this.a){const b=new Set([T]),d=this.c(N,b);if(d)return d}}c(T,N){for(const[b,d]of T.outgoing){if(N.has(b))return[...N,b].join(" -> ");N.add(b);const u=this.c(d,N);if(u)return u;N.delete(b)}}}e.Graph=R}),define(Z[21],Q([0,1,3,11,8]),function(W,e,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function T(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof R.URI)}e.isConfigurationOverrides=T;function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=N;var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=d;function u(c,g){const E=Object.create(null);for(const h in c)y(E,h,c[h],g);return E}e.toValuesTree=u;function y(c,g,E,h){const o=g.split("."),t=o.pop();let n=c;for(let i=0;i<o.length;i++){const r=o[i];let s=n[r];switch(typeof s){case"undefined":s=n[r]=Object.create(null);break;case"object":break;default:h(`Ignoring ${g} as ${o.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[t]=E}catch{h(`Ignoring ${g} as ${o.join(".")} is ${JSON.stringify(n)}`)}else h(`Ignoring ${g} as ${o.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=y;function p(c,g){const E=g.split(".");m(c,E)}e.removeFromValueTree=p;function m(c,g){const E=g.shift();if(g.length===0){delete c[E];return}if(Object.keys(c).indexOf(E)!==-1){const h=c[E];typeof h=="object"&&!Array.isArray(h)&&(m(h,g),Object.keys(h).length===0&&delete c[E])}}function S(c,g,E){function h(n,i){let r=n;for(const s of i){if(typeof r!="object"||r===null)return;r=r[s]}return r}const o=g.split("."),t=h(c,o);return typeof t>"u"?E:t}e.getConfigurationValue=S;function v(c,g,E){Object.keys(g).forEach(h=>{h!=="__proto__"&&(h in c?L.isObject(c[h])&&L.isObject(g[h])?v(c[h],g[h],E):E&&(c[h]=g[h]):c[h]=g[h])})}e.merge=v;function O(c,g,E){const h=c.inspect(g),o=c.inspect(E);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof o.userValue<"u"||typeof o.workspaceValue<"u"||typeof o.workspaceFolderValue<"u"?o.value:h.defaultValue}e.getMigratedSettingValue=O;function w(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(Z[58],Q([0,1,8]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(Z[18],Q([0,1,8]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[23],Q([0,1,87,8]),function(W,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function T(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function N(c,g){switch(c){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function b(c,g){return g==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function d(c,g,E){return b(g,E)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===E?!0:u(E).includes(c)}e.isTargetPlatformCompatible=d;function u(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function y(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=y;var p;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var m;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var S;(function(c){c.Install="install",c.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var v;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var O;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal",c.Signature="Signature"})(O=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(g,E){super(g),this.code=E,this.name=E}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Z[59],Q([0,1,8]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((T,N)=>W(["node-vsce-sign"],async b=>T(b),N))),this.a}async verify(T,N){let b;try{b=await this.b()}catch{return!1}return b.verify(T,N)}}e.ExtensionSignatureVerificationService=R}),define(Z[60],Q([0,1,15,10,95,13]),function(W,e,L,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(y,p,m,S,v,O){let w;try{await b(y,p,m,S,v,O)}catch(c){w=c}finally{w&&v.errorTransformer&&(w=v.errorTransformer(w)),typeof w<"u"&&m.error(w),m.end()}}e.readFileIntoStream=N;async function b(y,p,m,S,v,O){d(O);const w=await y.open(p,{create:!1});try{d(O);let c=0,g=0,E=v&&typeof v.length=="number"?v.length:void 0,h=L.VSBuffer.alloc(Math.min(v.bufferSize,typeof E=="number"?E:v.bufferSize)),o=v&&typeof v.position=="number"?v.position:0,t=0;do g=await y.read(w,o,h.buffer,t,h.byteLength-t),o+=g,t+=g,c+=g,typeof E=="number"&&(E-=g),t===h.byteLength&&(await m.write(S(h)),h=L.VSBuffer.alloc(Math.min(v.bufferSize,typeof E=="number"?E:v.bufferSize)),t=0);while(g>0&&(typeof E!="number"||E>0)&&d(O)&&u(c,v));if(t>0){let n=t;typeof E=="number"&&(n=Math.min(t,E)),m.write(S(h.slice(0,n)))}}catch(c){throw(0,T.ensureFileSystemProviderError)(c)}finally{await y.close(w)}}function d(y){if(y.isCancellationRequested)throw(0,R.canceled)();return!0}function u(y,p){if(p?.limits){if(typeof p.limits.memory=="number"&&y>p.limits.memory)throw(0,T.createFileSystemProviderError)((0,k.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof p.limits.size=="number"&&y>p.limits.size)throw(0,T.createFileSystemProviderError)((0,k.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[111],Q([0,1,5,155,2,12,156]),function(W,e,L,R,k,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new L.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(u){const y=this.i(u),p=y.filter(S=>{const v=this.c.get(S.path);return v?!(0,R.patternsEquals)(v.request.excludes,S.excludes)||!(0,R.patternsEquals)(v.request.includes,S.includes):!0}),m=Array.from(this.c.values()).filter(({request:S})=>!y.find(v=>v.path===S.path&&(0,R.patternsEquals)(v.excludes,S.excludes)&&(0,R.patternsEquals)(v.includes,S.includes))).map(({request:S})=>S.path);p.length&&this.j(`Request to start watching: ${p.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const S of m)this.h(S);for(const S of p)this.g(S)}g(u){const y=new N.NodeJSFileWatcherLibrary(u,m=>this.a.fire(m),m=>this.b.fire(m),this.f),p={request:u,instance:y};this.c.set(u.path,p)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const y=this.c.get(u);y&&(this.c.delete(u),y.instance.dispose())}i(u){const y=new Map;for(const p of u){const m=T.isLinux?p.path:p.path.toLowerCase();y.set(m,p)}return Array.from(y.values())}async setVerboseLogging(u){this.f=u;for(const[,y]of this.c)y.instance.setVerboseLogging(u)}j(u){this.f&&this.b.fire({type:"trace",message:this.k(u)})}k(u,y){return y?`[File Watcher (node.js)] ${u} (path: ${y.request.path})`:`[File Watcher (node.js)] ${u}`}}e.NodeJSWatcher=b}),define(Z[112],Q([0,1,61,111]),function(W,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends L.AbstractNonRecursiveWatcherClient{constructor(N,b,d){super(N,b,d),this.m()}l(){return new R.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Z[113],Q([0,1,16,56,82,61]),function(W,e,L,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends T.AbstractUniversalWatcherClient{constructor(d,u,y){super(d,u,y),this.m()}l(d){const u=d.add(new k.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(u.onDidProcessExit(({code:y,signal:p})=>this.n(`terminated by itself with code ${y}, signal: ${p}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(u.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(Z[62],Q([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...k){this.a=new Map;for(const[T,N]of k)this.set(T,N)}set(k,T){const N=this.a.get(k);return this.a.set(k,T),N}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=L}),define(Z[114],Q([0,1,4,10,2,46,110,8,62,157]),function(W,e,L,R,k,T,N,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class p extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class m{constructor(w=new d.ServiceCollection,c=!1,g,E=y){this.f=w,this.g=c,this.h=g,this.i=E,this.o=new Set,this.f.set(b.IInstantiationService,this),this._globalGraph=E?g?._globalGraph??new N.Graph(h=>h):void 0}createChild(w){return new m(w,this.g,this,this.i)}invokeFunction(w,...c){const g=v.traceInvocation(this.i,w);let E=!1;try{return w({get:o=>{if(E)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(o,g);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...c)}finally{E=!0,g.stop()}}createInstance(w,...c){let g,E;return w instanceof T.SyncDescriptor?(g=v.traceCreation(this.i,w.ctor),E=this.j(w.ctor,w.staticArguments.concat(c),g)):(g=v.traceCreation(this.i,w),E=this.j(w,c,g)),g.stop(),E}j(w,c=[],g){const E=b._util.getServiceDependencies(w).sort((t,n)=>t.index-n.index),h=[];for(const t of E){const n=this.m(t.id,g);n||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${t.id}.`,!1),h.push(n)}const o=E.length>0?E[0].index:c.length;if(c.length!==o){console.trace(`[createInstance] First service dependency of ${w.name} at position ${o+1} conflicts with ${c.length} static arguments`);const t=o-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,o)}return Reflect.construct(w,c.concat(h))}k(w,c){if(this.f.get(w)instanceof T.SyncDescriptor)this.f.set(w,c);else if(this.h)this.h.k(w,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const c=this.f.get(w);return!c&&this.h?this.h.l(w):c}m(w,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const g=this.l(w);return g instanceof T.SyncDescriptor?this.q(w,g,c.branch(w,!0)):(c.branch(w,!1),g)}q(w,c,g){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,c,g)}finally{this.o.delete(w)}}r(w,c,g){const E=new N.Graph(t=>t.id.toString());let h=0;const o=[{id:w,desc:c,_trace:g}];for(;o.length;){const t=o.pop();if(E.lookupOrInsertNode(t),h++>1e3)throw new p(E);for(const n of b._util.getServiceDependencies(t.desc.ctor)){const i=this.l(n.id);if(i||this.u(`[createInstance] ${w} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),i instanceof T.SyncDescriptor){const r={id:n.id,desc:i,_trace:t._trace.branch(n.id,!0)};E.insertEdge(t,r),o.push(r)}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new p(E);break}for(const{data:n}of t){if(this.l(n.id)instanceof T.SyncDescriptor){const r=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,r)}E.removeNode(n)}}return this.l(w)}s(w,c,g=[],E,h){if(this.f.get(w)instanceof T.SyncDescriptor)return this.t(w,c,g,E,h);if(this.h)return this.h.s(w,c,g,E,h);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(w,c,g=[],E,h){if(E){const o=new m(void 0,this.g,this,this.i);o.c=String(w);const t=new Map,n=new L.IdleValue(()=>{const i=o.j(c,g,h);for(const[r,s]of t){const l=i[r];if(typeof l=="function")for(const a of s)l.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,r){if(!n.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=t.get(r);return a||(a=new u.LinkedList,t.set(r,a)),(D,C,x)=>{const Y=a.push([D,C,x]);return(0,k.toDisposable)(Y)}}if(r in i)return i[r];const s=n.value;let l=s[r];return typeof l!="function"||(l=l.bind(s),i[r]=l),l},set(i,r,s){return n.value[r]=s,!0},getPrototypeOf(i){return c.prototype}})}else return this.j(c,g,h)}u(w,c){if(c&&console.warn(w),this.g)throw new Error(w)}}e.InstantiationService=m;var S;(function(O){O[O.None=0]="None",O[O.Creation=1]="Creation",O[O.Invocation=2]="Invocation",O[O.Branch=3]="Branch"})(S||(S={}));class v{static traceInvocation(w,c){return w?new v(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(w,c){return w?new v(1,c.name):v.c}constructor(w,c){this.type=w,this.name=c,this.g=Date.now(),this.h=[]}branch(w,c){const g=new v(3,w.toString());return this.h.push([w,c,g]),g}stop(){const w=Date.now()-this.g;v.f+=w;let c=!1;function g(h,o){const t=[],n=new Array(h+1).join("	");for(const[i,r,s]of o.h)if(r&&s){c=!0,t.push(`${n}CREATES -> ${i}`);const l=g(h+1,s);l&&t.push(l)}else t.push(`${n}uses -> ${i}`);return t.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(w>2||c)&&v.all.add(E.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}},v.f=0});var _=this&&this.__param||function(W,e){return function(L,R){e(L,R,W)}};define(Z[63],Q([0,1,22,2,12,97,23,8]),function(W,e,L,R,k,T,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function d(y){return y.tags.find(p=>p.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=d,e.ILanguagePackService=(0,b.createDecorator)("languagePackService");let u=class extends R.Disposable{constructor(p){super(),this.c=p}async getAvailableLanguages(){const p=new L.CancellationTokenSource;setTimeout(()=>p.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},p.token)}catch{return[]}const v=m.firstPage.filter(O=>O.properties.localizedLanguages?.length&&O.tags.some(w=>w.startsWith("lp-"))).map(O=>{const w=O.properties.localizedLanguages?.[0],c=d(O);return{...this.f(c,w,O),extensionId:O.identifier.id,galleryExtension:O}});return v.push({...this.f("en","English"),extensionId:"default"}),v}f(p,m,S){const v=m??p;let O;if(v!==p&&(O=`(${p})`),p.toLowerCase()===k.language.toLowerCase()&&(O??="",O+=(0,T.localize)(0,null)),S?.installCount){O??="";const w=S.installCount;let c;w>1e6?c=`${Math.floor(w/1e5)/10}M`:w>1e3?c=`${Math.floor(w/1e3)}K`:c=String(w),O+=` $(cloud-download) ${c}`}return{id:p,label:v,description:O}}};u=me([_(0,N.IExtensionGalleryService)],u),e.LanguagePackBaseService=u}),define(Z[9],Q([0,1,34,5,2,36,12,11,8]),function(W,e,L,R,k,T,N,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,d.createDecorator)("logService"),e.ILoggerService=(0,d.createDecorator)("loggerService");function u(){return new Date().toISOString()}var y;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function p(l,a,f){switch(a){case y.Trace:l.trace(f);break;case y.Debug:l.debug(f);break;case y.Info:l.info(f);break;case y.Warning:l.warn(f);break;case y.Error:l.error(f);break;case y.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=p;function m(l){let a="";for(let f=0;f<l.length;f++){let D=l[f];if(typeof D=="object")try{D=JSON.stringify(D)}catch{}a+=(f>0?" ":"")+D}return a}e.format=m;class S extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==y.Off&&this.b<=a}}e.AbstractLogger=S;class v extends S{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...f){this.f(y.Trace)&&this.g(y.Trace,m([a,...f]))}debug(a,...f){this.f(y.Debug)&&this.g(y.Debug,m([a,...f]))}info(a,...f){this.f(y.Info)&&this.g(y.Info,m([a,...f]))}warn(a,...f){this.f(y.Warning)&&this.g(y.Warning,m([a,...f]))}error(a,...f){if(this.f(y.Error))if(a instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=a.stack,this.g(y.Error,m(D))}else this.g(y.Error,m([a,...f]))}flush(){}}e.AbstractMessageLogger=v;class O extends S{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.g=!N.isWindows}trace(a,...f){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...f):console.log(`[main ${u()}]`,a,...f))}debug(a,...f){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...f):console.log(`[main ${u()}]`,a,...f))}info(a,...f){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...f):console.log(`[main ${u()}]`,a,...f))}warn(a,...f){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,a,...f):console.warn(`[main ${u()}]`,a,...f))}error(a,...f){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,a,...f):console.error(`[main ${u()}]`,a,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=O;class w extends S{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...f){this.f(y.Trace)&&console.log("%cTRACE","color: #888",a,...f)}debug(a,...f){this.f(y.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",a,...f)}info(a,...f){this.f(y.Info)&&console.log("%c INFO","color: #33f",a,...f)}warn(a,...f){this.f(y.Warning)&&console.log("%c WARN","color: #993",a,...f)}error(a,...f){this.f(y.Error)&&console.log("%c  ERR","color: #f33",a,...f)}dispose(){}flush(){}}e.ConsoleLogger=w;class c extends S{constructor(a,f=e.DEFAULT_LOG_LEVEL){super(),this.g=a,this.setLevel(f)}trace(a,...f){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(a),...f])}debug(a,...f){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(a),...f])}info(a,...f){this.f(y.Info)&&this.g.log(y.Info,[this.h(a),...f])}warn(a,...f){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(a),...f])}error(a,...f){this.f(y.Error)&&this.g.log(y.Error,[this.h(a),...f])}h(a){return typeof a=="string"?a:(0,L.toErrorMessage)(a,this.f(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=c;class g extends S{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const f of this.g)f.setLevel(a);super.setLevel(a)}trace(a,...f){for(const D of this.g)D.trace(a,...f)}debug(a,...f){for(const D of this.g)D.debug(a,...f)}info(a,...f){for(const D of this.g)D.info(a,...f)}warn(a,...f){for(const D of this.g)D.warn(a,...f)}error(a,...f){for(const D of this.g)D.error(a,...f)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.MultiplexLogService=g;class E extends k.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...f){this.b.trace(a,...f)}debug(a,...f){this.b.debug(a,...f)}info(a,...f){this.b.info(a,...f)}warn(a,...f){this.b.warn(a,...f)}error(a,...f){this.b.error(a,...f)}flush(){this.b.flush()}}e.LogService=E;class h extends k.Disposable{constructor(a,f){super(),this.c=a,this.b=new T.ResourceMap,this.B(f(D=>this.setLevel(D)))}getLoggers(){return[...this.b.values()].map(({logger:a})=>a)}getLogger(a){return this.b.get(a)?.logger}createLogger(a,f,D){let C=this.b.get(a)?.logger;return C||(D=f?.always?y.Trace:D,C=this.f(a,D??this.c,f),this.b.set(a,{logger:C,logLevel:D})),C}setLevel(a,f){const D=b.URI.isUri(a)?a:void 0,C=D?f:a;if(D){const x=this.b.get(D);x&&x.logLevel!==C&&(x.logLevel=C,x.logger.setLevel(C))}else this.c=C,this.b.forEach(({logLevel:x,logger:Y})=>{x===void 0&&Y.setLevel(this.c)})}getLogLevel(a){return this.b.get(a)?.logLevel}dispose(){this.b.forEach(({logger:a})=>a.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=h;class o{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(a){}getLevel(){return y.Info}trace(a,...f){}debug(a,...f){}info(a,...f){}warn(a,...f){}error(a,...f){}critical(a,...f){}dispose(){}flush(){}}e.NullLogger=o;class t extends o{}e.NullLogService=t;class n extends h{constructor(){super(y.Info,R.Event.None)}f(a,f,D){return new o}}e.NullLoggerService=n;function i(l){if(l.verbose)return y.Trace;if(typeof l.logLevel=="string"){const a=s(l.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function r(l){switch(l){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=r;function s(l){switch(l){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=s}),define(Z[115],Q([0,1,19,4,10,5,2,14,61,9]),function(W,e,L,R,k,T,N,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends N.Disposable{constructor(m,S){super(),this.a=m,this.b=S,this.c=this.B(new T.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new T.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new R.ThrottledDelayer(0)),this.s=[],this.t=this.B(new R.ThrottledDelayer(0))}watch(m,S){return S.recursive||this.b?.watcher?.forceUniversal?this.l(m,S):this.u(m,S)}l(m,S){const v={path:this.C(m),excludes:S.excludes,includes:S.includes,recursive:S.recursive},O=(0,L.insert)(this.j,v);return this.m(),(0,N.toDisposable)(()=>{O(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,k.onUnexpectedError)(m))}n(){this.h||(this.h=this.B(this.p(S=>this.c.fire((0,d.toFileChanges)(S)),S=>this.z(S),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const S of this.j)(0,d.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const S of this.j)(0,d.isRecursiveWatchRequest)(S)&&m.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,S){const v={path:this.C(m),excludes:S.excludes,includes:S.includes,recursive:!1},O=(0,L.insert)(this.s,v);return this.v(),(0,N.toDisposable)(()=>{O(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,k.onUnexpectedError)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,d.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,b.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(Z[116],Q([0,1,19,4,15,22,5,52,64,2,54,16,117,17,43,94,13,60,9]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S,v,O,w,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class extends u.Disposable{constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new N.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new N.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new N.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new R.ResourceQueue)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${o}`);const n=new u.DisposableStore;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),n.add(t.onDidChangeFile(i=>this.Q.fire(new w.FileChangesEvent(i,!this.N(t))))),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(i=>this.R.fire(new Error(i)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,u.toDisposable)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,u.dispose)(n)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(n){t.push(n)}}),!this.h.has(o)&&await R.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const n=this.h.get(o.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return d.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,S.isAbsolutePath)(o))throw new w.FileOperationError((0,O.localize)(0,null,this.mb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const n=new Error;throw n.name="ENOPRO",n.message=(0,O.localize)(1,null,o.toString()),n}return t}async k(o){const t=await this.j(o);if((0,w.hasOpenReadWriteCloseCapability)(t)||(0,w.hasReadWriteCapability)(t)||(0,w.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(o){const t=await this.j(o);if((0,w.hasOpenReadWriteCloseCapability)(t)||(0,w.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.n(o,t)}catch(n){throw(0,w.toFileSystemProviderErrorCode)(n)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,O.localize)(2,null,this.mb(o)),1):(0,w.ensureFileSystemProviderError)(n)}}async n(o,t){const n=await this.j(o),i=this.N(n),r=t?.resolveTo,s=t?.resolveSingleChildDescendants,l=t?.resolveMetadata,a=await n.stat(o);let f;return this.p(n,o,a,void 0,!!l,(D,C)=>(f||(f=y.TernarySearchTree.forUris(()=>!i),f.set(o,!0),r&&f.fill(!0,r)),f.get(D.resource)||f.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?C===1:!1))}async p(o,t,n,i,r,s){const{providerExtUri:l}=this.M(o),a={resource:t,name:l.basename(t),isFile:(n.type&w.FileType.File)!==0,isDirectory:(n.type&w.FileType.Directory)!==0,isSymbolicLink:(n.type&w.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&w.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,w.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(a.isDirectory&&s(a,i)){try{const f=await o.readdir(t),D=await R.Promises.settled(f.map(async([C,x])=>{try{const Y=l.joinPath(t,C),X=r?await o.stat(Y):{type:x};return await this.p(o,Y,X,f.length,r,s)}catch(Y){return this.b.trace(Y),null}}));a.children=(0,L.coalesce)(D)}catch(f){this.b.trace(f),a.children=[]}return a}return a}async resolveAll(o){return R.Promises.settled(o.map(async t=>{try{return{stat:await this.n(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),n=await t.stat(o);return this.p(t,o,n,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.r(o,t)}catch(n){return n}return!0}async r(o,t){if(!t?.overwrite&&await this.exists(o))throw new w.FileOperationError((0,O.localize)(3,null,this.mb(o)),3,t)}async createFile(o,t=k.VSBuffer.fromString(""),n){await this.r(o,n);const i=await this.writeFile(o,t);return this.m.fire(new w.FileOperationEvent(o,0,i)),i}async writeFile(o,t,n){const i=this.kb(await this.l(o),o),{providerExtUri:r}=this.M(i);try{await this.s(i,o,n)||await this.O(i,r.dirname(o));let l;if((0,w.hasReadWriteCapability)(i)&&!(t instanceof k.VSBuffer))if((0,v.isReadableStream)(t)){const a=await(0,v.peekStream)(t,3);a.ended?l=k.VSBuffer.concat(a.buffer):l=a}else l=(0,v.peekReadable)(t,a=>k.VSBuffer.concat(a),3);else l=t;!(0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)&&l instanceof k.VSBuffer?await this.bb(i,o,n,l):await this.X(i,o,n,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l),this.m.fire(new w.FileOperationEvent(o,4))}catch(s){throw new w.FileOperationError((0,O.localize)(4,null,this.mb(o),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),n)}return this.resolve(o,{resolveMetadata:!0})}async s(o,t,n){if(!!n?.unlock&&!(o.capabilities&8192))throw new Error((0,O.localize)(5,null,this.mb(t)));let r;try{r=await o.stat(t)}catch{return}if((r.type&w.FileType.Directory)!==0)throw new w.FileOperationError((0,O.localize)(6,null,this.mb(t)),0,n);if(this.lb(t,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==w.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,w.etag)({mtime:n.mtime,size:r.size}))throw new w.FileOperationError((0,O.localize)(7,null),3,n);return r}async readFile(o,t,n){const i=await this.k(o);return t?.atomic?this.t(i,o,t,n):this.u(i,o,t,n)}async t(o,t,n,i){return new Promise((r,s)=>{this.W.queueFor(t,this.M(o).providerExtUri).queue(async()=>{try{const l=await this.u(o,t,n,i);r(l)}catch(l){s(l)}})})}async u(o,t,n,i){const r=await this.v(o,t,{...n,preferUnbuffered:!0},i);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(o,t,n){const i=await this.k(o);return this.v(i,o,t,n)}async v(o,t,n,i){const r=new T.CancellationTokenSource(i),s=this.D(t,n).then(a=>a,a=>{throw r.cancel(),a});let l;try{return typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&await s,n?.atomic&&(0,w.hasFileAtomicReadCapability)(o)||!((0,w.hasOpenReadWriteCloseCapability)(o)||(0,w.hasFileReadStreamCapability)(o))||(0,w.hasReadWriteCapability)(o)&&n?.preferUnbuffered?l=this.C(o,t,n):(0,w.hasFileReadStreamCapability)(o)?l=this.w(o,t,r.token,n):l=this.z(o,t,r.token,n),{...await s,value:l}}catch(a){l&&await(0,v.consumeStream)(l);const f=(0,O.localize)(8,null,this.mb(t),(0,w.ensureFileSystemProviderError)(a).toString());throw a instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(f,a.stat,n):new w.FileOperationError(f,(0,w.toFileOperationResult)(a),n)}}w(o,t,n,i=Object.create(null)){const r=o.readFileStream(t,i,n);return(0,v.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new w.FileOperationError((0,O.localize)(9,null,this.mb(t),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),i)},s=>k.VSBuffer.concat(s))}z(o,t,n,i=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,c.readFileIntoStream)(o,t,r,s=>s,{...i,bufferSize:this.a,errorTransformer:s=>new w.FileOperationError((0,O.localize)(10,null,this.mb(t),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),i)},n),r}C(o,t,n){const i=(0,v.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,w.hasFileAtomicReadCapability)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.F(t,r.byteLength,n),i.end(k.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async D(o,t){const n=await this.resolve(o,{resolveMetadata:!0});if(n.isDirectory)throw new w.FileOperationError((0,O.localize)(11,null,this.mb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==w.ETAG_DISABLED&&t.etag===n.etag)throw new w.NotModifiedSinceFileOperationError((0,O.localize)(12,null),n,t);return this.F(o,n.size,t),n}F(o,t,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&t>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&t>n.limits.size&&(i=7),typeof i=="number")throw new w.FileOperationError((0,O.localize)(13,null,this.mb(o)),i)}}async canMove(o,t,n){return this.G(o,t,"move",n)}async canCopy(o,t,n){return this.G(o,t,"copy",n)}async G(o,t,n,i){if(o.toString()!==t.toString())try{const r=n==="move"?this.kb(await this.l(o),o):await this.k(o),s=this.kb(await this.l(t),t);await this.L(r,o,s,t,n,i)}catch(r){return r}return!0}async move(o,t,n){const i=this.kb(await this.l(o),o),r=this.kb(await this.l(t),t),s=await this.H(i,o,r,t,"move",!!n),l=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new w.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,t,n){const i=await this.k(o),r=this.kb(await this.l(t),t),s=await this.H(i,o,r,t,"copy",!!n),l=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new w.FileOperationEvent(o,s==="copy"?3:2,l)),l}async H(o,t,n,i,r,s){if(t.toString()===i.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:a}=await this.L(o,t,n,i,r,s);if(l&&!a&&s&&await this.del(i,{recursive:!0}),await this.O(n,this.M(n).providerExtUri.dirname(i)),r==="copy"){if(o===n&&(0,w.hasFileFolderCopyCapability)(o))await o.copy(t,i,{overwrite:s});else{const f=await this.resolve(t);f.isDirectory?await this.J(o,f,n,i):await this.I(o,t,n,i)}return r}else return o===n?(await o.rename(t,i,{overwrite:s}),r):(await this.H(o,t,n,i,"copy",s),await this.del(t,{recursive:!0}),"copy")}async I(o,t,n,i){if((0,w.hasOpenReadWriteCloseCapability)(o)&&(0,w.hasOpenReadWriteCloseCapability)(n))return this.db(o,t,n,i);if((0,w.hasOpenReadWriteCloseCapability)(o)&&(0,w.hasReadWriteCapability)(n))return this.jb(o,t,n,i);if((0,w.hasReadWriteCapability)(o)&&(0,w.hasOpenReadWriteCloseCapability)(n))return this.hb(o,t,n,i);if((0,w.hasReadWriteCapability)(o)&&(0,w.hasReadWriteCapability)(n))return this.fb(o,t,n,i)}async J(o,t,n,i){await n.mkdir(i),Array.isArray(t.children)&&await R.Promises.settled(t.children.map(async r=>{const s=this.M(n).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.J(o,await this.resolve(r.resource),n,s):this.I(o,r.resource,n,s)}))}async L(o,t,n,i,r,s){let l=!1;if(o===n){const{providerExtUri:f,isPathCaseSensitive:D}=this.M(o);if(D||(l=f.isEqual(t,i)),l&&r==="copy")throw new Error((0,O.localize)(14,null,this.mb(t),this.mb(i)));if(!l&&f.isEqualOrParent(i,t))throw new Error((0,O.localize)(15,null,this.mb(t),this.mb(i)))}const a=await this.exists(i);if(a&&!l){if(!s)throw new w.FileOperationError((0,O.localize)(16,null,this.mb(t),this.mb(i)),4);if(o===n){const{providerExtUri:f}=this.M(o);if(f.isEqualOrParent(t,i))throw new Error((0,O.localize)(17,null,this.mb(t),this.mb(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:l}}M(o){const t=this.N(o);return{providerExtUri:t?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:t}}N(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.kb(await this.j(o),o);await this.O(t,o);const n=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new w.FileOperationEvent(o,0,n)),n}async O(o,t){const n=[],{providerExtUri:i}=this.M(o);for(;!i.isEqual(t,i.dirname(t));)try{if(((await o.stat(t)).type&w.FileType.Directory)===0)throw new Error((0,O.localize)(18,null,this.mb(t)));break}catch(r){if((0,w.toFileSystemProviderErrorCode)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(i.basename(t)),t=i.dirname(t)}for(let r=n.length-1;r>=0;r--){t=i.joinPath(t,n[r]);try{await o.mkdir(t)}catch(s){if((0,w.toFileSystemProviderErrorCode)(s)!==w.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,t){try{await this.P(o,t)}catch(n){return n}return!0}async P(o,t){const n=this.kb(await this.j(o),o);if(!!t?.useTrash&&!(n.capabilities&4096))throw new Error((0,O.localize)(19,null,this.mb(o)));let r;try{r=await n.stat(o)}catch{}if(r)this.lb(o,r);else throw new w.FileOperationError((0,O.localize)(20,null,this.mb(o)),1);if(!!!t?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,O.localize)(21,null,this.mb(o)))}return n}async del(o,t){const n=await this.P(o,t),i=!!t?.useTrash,r=!!t?.recursive;await n.delete(o,{recursive:r,useTrash:i}),this.m.fire(new w.FileOperationEvent(o,1))}async cloneFile(o,t){const n=await this.j(o),i=this.kb(await this.l(t),t);if(n===i&&this.M(n).providerExtUri.isEqual(o,t))return;if(n===i&&(0,w.hasFileCloneCapability)(n))return n.cloneFile(o,t);await this.O(i,this.M(i).providerExtUri.dirname(t));const r=this.W.queueFor(o,this.M(n).providerExtUri);return n===i&&(0,w.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(o,t,{overwrite:!0})):r.queue(()=>this.I(n,o,i,t))}watch(o,t={recursive:!1,excludes:[]}){const n=new u.DisposableStore;let i=!1,r=()=>{i=!0};return n.add((0,u.toDisposable)(()=>r())),(async()=>{try{const s=await this.U(o,t);i?(0,u.dispose)(s):r=()=>(0,u.dispose)(s)}catch(s){this.b.error(s)}})(),n}async U(o,t){const n=await this.j(o),i=(0,b.hash)([this.M(n).providerExtUri.getComparisonKey(o),t]);let r=this.S.get(i);return r||(r={count:0,disposable:n.watch(o,t)},this.S.set(i,r)),r.count+=1,(0,u.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,u.dispose)(r.disposable),this.S.delete(i)))})}dispose(){super.dispose();for(const[,o]of this.S)(0,u.dispose)(o.disposable);this.S.clear()}async X(o,t,n,i){return this.W.queueFor(t,this.M(o).providerExtUri).queue(async()=>{const r=await o.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,v.isReadableStream)(i)||(0,v.isReadableBufferedStream)(i)?await this.Y(o,r,i):await this.Z(o,r,i)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await o.close(r)}})}async Y(o,t,n){let i=0,r;if((0,v.isReadableBufferedStream)(n)){if(n.buffer.length>0){const s=k.VSBuffer.concat(n.buffer);await this.ab(o,t,s,s.byteLength,i,0),i+=s.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((s,l)=>{(0,v.listenStream)(r,{onData:async a=>{r.pause();try{await this.ab(o,t,a,a.byteLength,i,0)}catch(f){return l(f)}i+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>l(a),onEnd:()=>s()})})}async Z(o,t,n){let i=0,r;for(;(r=n.read())!==null;)await this.ab(o,t,r,r.byteLength,i,0),i+=r.byteLength}async ab(o,t,n,i,r,s){let l=0;for(;l<i;)l+=await o.write(t,r+l,n.buffer,s+l,i-l)}async bb(o,t,n,i){return this.W.queueFor(t,this.M(o).providerExtUri).queue(()=>this.cb(o,t,n,i))}async cb(o,t,n,i){let r;i instanceof k.VSBuffer?r=i:(0,v.isReadableStream)(i)?r=await(0,k.streamToBuffer)(i):(0,v.isReadableBufferedStream)(i)?r=await(0,k.bufferedStreamToBuffer)(i):r=(0,k.readableToBuffer)(i),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async db(o,t,n,i){return this.W.queueFor(i,this.M(n).providerExtUri).queue(()=>this.eb(o,t,n,i))}async eb(o,t,n,i){let r,s;try{r=await o.open(t,{create:!1}),s=await n.open(i,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.a);let a=0,f=0,D=0;do D=await o.read(r,a,l.buffer,f,l.byteLength-f),await this.ab(n,s,l,D,a,f),a+=D,f+=D,f===l.byteLength&&(f=0);while(D>0)}catch(l){throw(0,w.ensureFileSystemProviderError)(l)}finally{await R.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof s=="number"?n.close(s):Promise.resolve()])}}async fb(o,t,n,i){return this.W.queueFor(i,this.M(n).providerExtUri).queue(()=>this.gb(o,t,n,i))}async gb(o,t,n,i){return n.writeFile(i,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async hb(o,t,n,i){return this.W.queueFor(i,this.M(n).providerExtUri).queue(()=>this.ib(o,t,n,i))}async ib(o,t,n,i){const r=await n.open(i,{create:!0,unlock:!1});try{const s=await o.readFile(t);await this.ab(n,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await n.close(r)}}async jb(o,t,n,i){const r=await(0,k.streamToBuffer)(this.z(o,t,T.CancellationToken.None));await this.bb(n,i,void 0,r)}kb(o,t){if(o.capabilities&2048)throw new w.FileOperationError((0,O.localize)(22,null,this.mb(t)),6);return o}lb(o,t){if((t.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,O.localize)(23,null,this.mb(o)),6)}mb(o){return o.scheme===p.Schemas.file?o.fsPath:o.toString(!0)}};E=me([_(0,g.ILogService)],E),e.FileService=E}),define(Z[118],Q([0,1,119,158,4,36,15,5,159,2,14,12,17,43,20,96,13,60,115,34,113,112]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S,v,O,w,c,g,E,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(L)}catch(n){console.error(`Error enabling graceful-fs: ${(0,E.toErrorMessage)(n)}`)}})();class t extends g.AbstractDiskFileSystemProvider{constructor(i,r){super(i,r),this.onDidChangeCapabilities=b.Event.None,this.H=new T.ResourceMap(s=>m.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,p.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:r,symbolicLink:s}=await v.SymlinkSupport.stat(this.C(i));return{type:this.G(r,s),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.Y(r)}}async readdir(i){try{const r=await v.Promises.readdir(this.C(i),{withFileTypes:!0}),s=[];return await Promise.all(r.map(async l=>{try{let a;l.isSymbolicLink()?a=(await this.stat((0,m.joinPath)(i,l.name))).type:a=this.G(l),s.push([l.name,a])}catch(a){this.a.trace(a)}})),s}catch(r){throw this.Y(r)}}G(i,r){let s;return r?.dangling?s=w.FileType.Unknown:i.isFile()?s=w.FileType.File:i.isDirectory()?s=w.FileType.Directory:s=w.FileType.Unknown,r&&(s|=w.FileType.SymbolicLink),s}async I(i){const r=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let s;for(;s=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await s.wait();const l=new k.Barrier;return this.H.set(i,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,u.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.H.get(i)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),l.open()})}async readFile(i,r){let s;try{r?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),s=await this.I(i));const l=this.C(i);return await v.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{s?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,r,s){const l=(0,S.newWriteableStream)(a=>N.VSBuffer.concat(a.map(f=>N.VSBuffer.wrap(f))).buffer);return(0,c.readFileIntoStream)(this,i,l,a=>a.buffer,{...r,bufferSize:256*1024},s),l}async writeFile(i,r,s){let l;try{const a=this.C(i);if(!s.create||!s.overwrite){if(await v.Promises.exists(a)){if(!s.overwrite)throw(0,w.createFileSystemProviderError)((0,O.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,w.createFileSystemProviderError)((0,O.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(l,0,r,0,r.byteLength)}catch(a){throw await this.Z(i,a)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){t.O=i}async open(i,r){const s=this.C(i);let l;(0,w.isFileOpenForWriteOptions)(r)&&(l=await this.I(i));let a;try{if((0,w.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:D}=await v.SymlinkSupport.stat(s);D.mode&128||await v.Promises.chmod(s,D.mode|128)}catch(D){this.a.trace(D)}let f;if((0,w.isFileOpenForWriteOptions)(r)){if(p.isWindows)try{await v.Promises.truncate(s,0),f="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}f||(f="w")}else f="r";a=await v.Promises.open(s,f)}catch(f){throw l?.dispose(),(0,w.isFileOpenForWriteOptions)(r)?await this.Z(i,f):this.Y(f)}if(this.L.set(a,0),(0,w.isFileOpenForWriteOptions)(r)&&this.N.set(a,i),l){const f=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.M.set(a,l),f&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),f.dispose())}return a}async close(i){const r=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await v.Promises.fdatasync(i)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await v.Promises.close(i)}catch(s){throw this.Y(s)}finally{r&&(this.M.get(i)===r&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,s,l,a){const f=this.P(i,r);let D=null;try{D=(await v.Promises.read(i,s,l,a,f)).bytesRead}catch(C){throw this.Y(C)}finally{this.Q(i,f,D)}return D}P(i,r){return r===this.L.get(i)?null:r}Q(i,r,s){const l=this.L.get(i);typeof l=="number"&&(typeof r=="number"||(typeof s=="number"?this.L.set(i,l+s):this.L.delete(i)))}async write(i,r,s,l,a){return(0,k.retry)(()=>this.R(i,r,s,l,a),100,3)}async R(i,r,s,l,a){const f=this.P(i,r);let D=null;try{D=(await v.Promises.write(i,s,l,a,f)).bytesWritten}catch(C){throw await this.Z(this.N.get(i),C)}finally{this.Q(i,f,D)}return D}async mkdir(i){try{await v.Promises.mkdir(this.C(i))}catch(r){throw this.Y(r)}}async delete(i,r){try{const s=this.C(i);r.recursive?await v.Promises.rm(s,v.RimRafMode.MOVE):await v.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(i,r,s){const l=this.C(i),a=this.C(r);if(l!==a)try{await this.S(i,r,"move",s.overwrite),await v.Promises.move(l,a)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,O.localize)(2,null,(0,y.basename)(l),(0,y.basename)((0,y.dirname)(a)),f.toString()))),this.Y(f)}}async copy(i,r,s){const l=this.C(i),a=this.C(r);if(l!==a)try{await this.S(i,r,"copy",s.overwrite),await v.Promises.copy(l,a,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,O.localize)(3,null,(0,y.basename)(l),(0,y.basename)((0,y.dirname)(a)),f.toString()))),this.Y(f)}}async S(i,r,s,l){const a=this.C(i),f=this.C(r);let D=!1;if(!!(this.capabilities&1024)||(D=(0,d.isEqual)(a,f,!0)),D&&s==="copy")throw(0,w.createFileSystemProviderError)((0,O.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!D&&await v.Promises.exists(f)){if(!l)throw(0,w.createFileSystemProviderError)((0,O.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(i,r){return this.U(i,r,!1)}async U(i,r,s){const l=this.C(i),a=this.C(r),f=!!(this.capabilities&1024);if((0,d.isEqual)(l,a,!f))return;const D=new u.DisposableStore;try{const[C,x]=await Promise.all([this.I(i),this.I(r)]);D.add(C),D.add(x),s&&await v.Promises.mkdir((0,y.dirname)(a),{recursive:!0}),await v.Promises.copyFile(l,a)}catch(C){if(C.code==="ENOENT"&&!s)return this.U(i,r,!0);throw this.Y(C)}finally{D.dispose()}}p(i,r,s){return new h.UniversalWatcherClient(l=>i(l),l=>r(l),s)}y(i,r,s){return new o.NodeJSWatcherClient(l=>i(l),l=>r(l),s)}Y(i){if(i instanceof w.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=w.FileSystemProviderErrorCode.NoPermissions;break;default:r=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(i,r)}async Z(i,r){let s=this.Y(r);if(i&&s.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await v.SymlinkSupport.stat(this.C(i));l.mode&128||(s=(0,w.createFileSystemProviderError)(r,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return s}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(Z[120],Q([0,1,13,9]),function(W,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(k||(k={}));async function T(u,y,p,m,S){try{const v=await new Promise((w,c)=>{W(["spdlog"],w,c)});v.setFlushOn(k.Trace);const O=await v.createAsyncRotatingLogger(u,y,p,m);return S?O.clearFormatters():O.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),O}catch(v){console.error(v)}return null}function N(u,y,p){switch(y){case R.LogLevel.Trace:u.trace(p);break;case R.LogLevel.Debug:u.debug(p);break;case R.LogLevel.Info:u.info(p);break;case R.LogLevel.Warning:u.warn(p);break;case R.LogLevel.Error:u.error(p);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function b(u,y){switch(y){case R.LogLevel.Trace:u.setLevel(k.Trace);break;case R.LogLevel.Debug:u.setLevel(k.Debug);break;case R.LogLevel.Info:u.setLevel(k.Info);break;case R.LogLevel.Warning:u.setLevel(k.Warning);break;case R.LogLevel.Error:u.setLevel(k.Error);break;case R.LogLevel.Off:u.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class d extends R.AbstractMessageLogger{constructor(y,p,m,S,v){super(),this.k=[],this.setLevel(v),this.l=this.n(y,p,m,S),this.B(this.onDidChangeLogLevel(O=>{this.m&&b(this.m,O)}))}async n(y,p,m,S){const v=m?6:1,O=30/v*L.ByteSize.MB,w=await T(y,p,O,v,S);if(w){this.m=w,b(this.m,this.getLevel());for(const{level:c,message:g}of this.k)N(this.m,c,g);this.k=[]}}g(y,p){this.m?N(this.m,y,p):this.getLevel()<=y&&this.k.push({level:y,message:p})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=d}),define(Z[38],Q([0,1,5,64,2,8]),function(W,e,L,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class N extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const y=Object.keys(this.f).length;return this.f={...u,...this.f},y!==Object.keys(this.f).length&&await this.i(u),R.Iterable.reduce(this.g.entries(),(p,[m,S])=>({...p,[m]:S}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(u,[y,p])=>({...u,[y]:{definition:p,value:this.g.get(y)}}),{})}}e.AbstractPolicyService=N;class b{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(Z[121],Q([0,1,4,5,64,3,13,9,38]),function(W,e,L,R,k,T,N,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function u(p,m){const S=[];for(const v of new Set(k.Iterable.concat(p.keys(),m.keys())))p.get(v)!==m.get(v)&&S.push(v);return S}let y=class extends d.AbstractPolicyService{constructor(m,S,v){super(),this.j=m,this.k=S,this.l=v,this.c=this.B(new L.ThrottledDelayer(500));const O=R.Event.filter(S.onDidFilesChange,w=>w.affects(m));this.B(S.watch(m)),this.B(O(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const m=new Map;try{const S=await this.k.readFile(this.j),v=JSON.parse(S.value.toString());if(!(0,T.isObject)(v))throw new Error("Policy file isn't a JSON object");for(const O of Object.keys(v))this.f[O]&&m.set(O,v[O])}catch(S){S.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",S)}return m}async p(){const m=await this.n(),S=u(this.g,m);this.g=m,S.length>0&&this.h.fire(S)}};y=me([_(1,N.IFileService),_(2,b.ILogService)],y),e.FilePolicyService=y}),define(Z[26],Q([0,1,8]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[37],Q([0,1,70,3]),function(W,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(N,b){L.ok(R.isString(N)),L.ok(R.isObject(b)),L.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,b)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new k}),define(Z[122],Q([0,1,5,37]),function(W,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class T{constructor(){this.b=new L.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,u){this.a[k(d)]=u,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const N=new T;R.Registry.add(e.Extensions.JSONContribution,N)}),define(Z[40],Q([0,1,19,5,3,85,21,122,37]),function(W,e,L,R,k,T,N,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var u;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(u=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const p=d.Registry.as(b.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const i=this.k(t,n);p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const n=this.l(t);p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const i=[];i.push(...this.l(n)),i.push(...this.k(t,!1)),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,L.distinct)(i)})}registerDefaultConfigurations(t){const n=[],i=[];for(const{overrides:r,source:s}of t)for(const l in r)if(n.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const a=this.a.get(l),f=a?.valuesSources??new Map;if(s)for(const Y of Object.keys(r[l]))f.set(Y,s);const D={...a?.value||{},...r[l]};this.a.set(l,{source:s,value:D,valuesSources:f});const C=(0,N.getLanguageTagSettingPlainKey)(l),x={type:"object",default:D,description:T.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:k.isString(s)?void 0:s,defaultValueSource:s};i.push(...O(l)),this.d[l]=x,this.b.properties[l]=x}else{this.a.set(l,{value:r[l],source:s});const a=this.d[l];a&&(this.s(l,a),this.o(l,a))}this.registerOverrideIdentifiers(i),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const n=[];for(const{overrides:i,source:r}of t)for(const s in i){const l=this.a.get(s),a=k.isString(r)?r:r?.id,f=k.isString(l?.source)?l?.source:l?.source?.id;if(a===f)if(n.push(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const D=this.d[s];D&&(this.s(s,D),this.o(s,D))}}this.q(),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){for(const n of t)this.h.add(n);this.q()}k(t,n){const i=[];return t.forEach(r=>{i.push(...this.m(r,n,r.extensionInfo,r.restrictedProperties)),this.c.push(r),this.n(r)}),i}l(t){const n=[],i=r=>{if(r.properties)for(const s in r.properties){n.push(s);const l=this.d[s];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[s],this.p(s,r.properties[s])}r.allOf?.forEach(s=>i(s))};for(const r of t){i(r);const s=this.c.indexOf(r);s!==-1&&this.c.splice(s,1)}return n}m(t,n=!0,i,r,s=3){s=k.isUndefinedOrNull(t.scope)?s:t.scope;const l=[],a=t.properties;if(a)for(const D in a){const C=a[D];if(n&&E(D,C)){delete a[D];continue}if(C.source=i,C.defaultDefaultValue=a[D].default,this.s(D,C),e.OVERRIDE_PROPERTY_REGEX.test(D)?C.scope=void 0:(C.scope=k.isUndefinedOrNull(C.scope)?s:C.scope,C.restricted=k.isUndefinedOrNull(C.restricted)?!!r?.includes(D):C.restricted),a[D].hasOwnProperty("included")&&!a[D].included){this.f[D]=a[D],delete a[D];continue}else this.d[D]=a[D],a[D].policy?.name&&this.e.set(a[D].policy.name,D);!a[D].deprecationMessage&&a[D].markdownDeprecationMessage&&(a[D].deprecationMessage=a[D].markdownDeprecationMessage),l.push(D)}const f=t.allOf;if(f)for(const D of f)l.push(...this.m(D,n,i,r,s));return l}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(t){const n=i=>{const r=i.properties;if(r)for(const l in r)this.o(l,r[l]);i.allOf?.forEach(n)};n(t)}o(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.g.properties[t]=n;break}}p(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}q(){for(const t of this.h.values()){const n=`[${t}]`,i={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(n,i),e.allSettings.properties[n]=i,e.applicationSettings.properties[n]=i,e.machineSettings.properties[n]=i,e.machineOverridableSettings.properties[n]=i,e.windowSettings.properties[n]=i,e.resourceSettings.properties[n]=i}this.i.fire()}r(){const t={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}s(t,n){const i=this.a.get(t);let r=i?.value,s=i?.source;k.isUndefined(r)&&(r=n.defaultDefaultValue,s=void 0),k.isUndefined(r)&&(r=c(n.type)),n.default=r,n.defaultValueSource=s}}const S="\\[([^\\]]+)\\]",v=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function O(o){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(o)){let n=v.exec(o);for(;n?.length;){const i=n[1].trim();i&&t.push(i),n=v.exec(o)}}return(0,L.distinct)(t)}e.overrideIdentifiersFromKey=O;function w(o){return o.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=w;function c(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const g=new m;d.Registry.add(e.Extensions.Configuration,g);function E(o,t){return o.trim()?e.OVERRIDE_PROPERTY_REGEX.test(o)?T.localize(7,null,o):g.getConfigurationProperties()[o]!==void 0?T.localize(8,null,o):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?T.localize(9,null,o,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:T.localize(6,null)}e.validateProperty=E;function h(){const o=[],t=g.getConfigurationProperties();for(const n of Object.keys(t))o.push([n,t[n].scope]);return o.push(["launch",4]),o.push(["task",4]),o}e.getScopes=h}),define(Z[65],Q([0,1,19,5,50,2,36,29,3,11,21,40,37]),function(W,e,L,R,k,T,N,b,d,u,y,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class S{constructor(n={},i=[],r=[],s){this.c=n,this.d=i,this.f=r,this.raw=s,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof S)return i;const r=new v("");return r.parseRaw(i),r.configurationModel});this.g=n.reduce((i,r)=>r===i?r:i.merge(r),n[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(n){return n?(0,y.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const r=this.rawConfiguration.getValue(n),s=i?this.rawConfiguration.getOverrideValue(n,i):void 0,l=i?this.rawConfiguration.override(i).getValue(n):r;return{value:r,override:s,merged:l}}getOverrideValue(n,i){const r=this.l(i);return r?n?(0,y.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const r of this.overrides)r.identifiers.includes(n)&&i.push(...r.keys);return L.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return L.distinct(n)}override(n){let i=this.b.get(n);return i||(i=this.h(n),this.b.set(n,i)),i}merge(...n){const i=b.deepClone(this.contents),r=b.deepClone(this.overrides),s=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const a of n)if(l.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.j(i,a.contents);for(const f of a.overrides){const[D]=r.filter(C=>L.equals(C.identifiers,f.identifiers));D?(this.j(D.contents,f.contents),D.keys.push(...f.keys),D.keys=L.distinct(D.keys)):r.push(b.deepClone(f))}for(const f of a.keys)s.indexOf(f)===-1&&s.push(f)}return new S(i,s,r,l.every(a=>a instanceof S)?void 0:l)}freeze(){return this.a=!0,this}clone(){return new S(b.deepClone(this.contents),[...this.keys],b.deepClone(this.overrides))}h(n){const i=this.l(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const s of L.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[s];const a=i[s];a&&(typeof l=="object"&&typeof a=="object"?(l=b.deepClone(l),this.j(l,a)):l=a),r[s]=l}return new S(r,this.keys,this.overrides)}j(n,i){for(const r of Object.keys(i)){if(r in n&&d.isObject(n[r])&&d.isObject(i[r])){this.j(n[r],i[r]);continue}n[r]=b.deepClone(i[r])}}k(n){return this.a&&!Object.isFrozen(n)?b.deepFreeze(n):n}l(n){let i=null,r=null;const s=l=>{l&&(r?this.j(r,l):r=b.deepClone(l))};for(const l of this.overrides)L.equals(l.identifiers,[n])?i=l.contents:l.identifiers.includes(n)&&s(l.contents);return s(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,i){this.m(n),(0,y.addToValueTree)(this.contents,n,i,r=>{throw new Error(r)})}removeValue(n){this.n(n)&&(0,y.removeFromValueTree)(this.contents,n)}m(n){let i=this.keys.length;for(let r=0;r<i;r++)n.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,n)}n(n){const i=this.keys.indexOf(n);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=S;class v{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!d.isUndefinedOrNull(n)){const r=this.g(n);this.parseRaw(r,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:r,keys:s,overrides:l,restricted:a,hasExcludedProperties:f}=this.h(n,i);this.b=new S(r,s,l,f?[n]:void 0),this.c=a||[]}g(n){let i={},r=null,s=[];const l=[],a=[];function f(C){Array.isArray(s)?s.push(C):r!==null&&(s[r]=C)}const D={onObjectBegin:()=>{const C={};f(C),l.push(s),s=C,r=null},onObjectProperty:C=>{r=C},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const C=[];f(C),l.push(s),s=C,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:f,onError:(C,x,Y)=>{a.push({error:C,offset:x,length:Y})}};if(n)try{k.visit(n,D),i=s[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return i}h(n,i){const r=m.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),s=this.j(n,r,!0,i);n=s.raw;const l=(0,y.toValuesTree)(n,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),a=Object.keys(n),f=this.l(n,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:l,keys:a,overrides:f,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}j(n,i,r,s){let l=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:l};const a={},f=[];for(const D in n)if(p.OVERRIDE_PROPERTY_REGEX.test(D)&&r){const C=this.j(n[D],i,!1,s);a[D]=C.raw,l=l||C.hasExcludedProperties,f.push(...C.restricted)}else{const C=i[D],x=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&f.push(D),(x===void 0||s.scopes===void 0||s.scopes.includes(x))&&!(s.skipRestricted&&C?.restricted)?a[D]=n[D]:l=!0}return{raw:a,restricted:f,hasExcludedProperties:l}}l(n,i){const r=[];for(const s of Object.keys(n))if(p.OVERRIDE_PROPERTY_REGEX.test(s)){const l={};for(const a in n[s])l[a]=n[s][a];r.push({identifiers:(0,p.overrideIdentifiersFromKey)(s),keys:Object.keys(l),contents:(0,y.toValuesTree)(l,i)})}return r}}e.ConfigurationModelParser=v;class O extends T.Disposable{constructor(n,i,r,s){super(),this.f=n,this.g=i,this.h=s,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&r.isEqual(l.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new S}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=O;class w{constructor(n,i,r,s,l,a,f,D,C,x,Y,X,ie){this.a=n,this.b=i,this.value=r,this.overrideIdentifiers=s,this.c=l,this.d=a,this.f=f,this.g=D,this.h=C,this.j=x,this.k=Y,this.l=X,this.m=ie}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class c{constructor(n,i,r,s,l=new S,a=new S,f=new N.ResourceMap,D=new S,C=new N.ResourceMap,x=!0){this.c=n,this.d=i,this.f=r,this.g=s,this.h=l,this.j=a,this.l=f,this.m=D,this.n=C,this.p=x,this.a=null,this.b=new N.ResourceMap,this.q=null}getValue(n,i,r){return this.s(n,i,r).getValue(n)}updateValue(n,i,r={}){let s;r.resource?(s=this.n.get(r.resource),s||(s=new S,this.n.set(r.resource,s))):s=this.m,i===void 0?s.removeValue(n):s.setValue(n,i),r.resource||(this.a=null)}inspect(n,i,r){const s=this.s(n,i,r),l=this.w(i.resource,r),a=i.resource?this.n.get(i.resource)||this.m:this.m,f=new Set;for(const D of s.overrides)for(const C of D.identifiers)s.getOverrideValue(n,C)!==void 0&&f.add(C);return new w(n,i,s.getValue(n),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this.j.freeze():void 0,l?l.freeze():void 0,a.inspect(n,i.overrideIdentifier))}keys(n){const i=this.w(void 0,n);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.j=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.l.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.r.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const r=[];if(!i){const{added:s,updated:l,removed:a}=h(this.c,n);i=[...s,...l,...a]}for(const s of i)for(const l of(0,p.overrideIdentifiersFromKey)(s)){const a=this.c.getKeysForOverrideIdentifier(l),f=n.getKeysForOverrideIdentifier(l),D=[...f.filter(C=>a.indexOf(C)===-1),...a.filter(C=>f.indexOf(C)===-1),...a.filter(C=>!b.equals(this.c.override(l).getValue(C),n.override(l).getValue(C)))];r.push([l,D])}return this.updateDefaultConfiguration(n),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:r,removed:s}=h(this.d,n),l=[...i,...r,...s];return l.length&&this.updatePolicyConfiguration(n),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:r,removed:s,overrides:l}=h(this.applicationConfiguration,n),a=[...i,...r,...s];return a.length&&this.updateApplicationConfiguration(n),{keys:a,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:r,removed:s,overrides:l}=h(this.localUserConfiguration,n),a=[...i,...r,...s];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:r,removed:s,overrides:l}=h(this.remoteUserConfiguration,n),a=[...i,...r,...s];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:r,removed:s,overrides:l}=h(this.workspaceConfiguration,n),a=[...i,...r,...s];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:l}}compareAndUpdateFolderConfiguration(n,i){const r=this.r.get(n),{added:s,updated:l,removed:a,overrides:f}=h(r,i),D=[...s,...l,...a];return(D.length||!r)&&this.updateFolderConfiguration(n,i),{keys:D,overrides:f}}compareAndDeleteFolderConfiguration(n){const i=this.r.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:s,removed:l,overrides:a}=h(i,void 0);return{keys:[...r,...s,...l],overrides:a}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(n,i,r){let s=this.t(i,r);return i.overrideIdentifier&&(s=s.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(s=s.merge(this.d)),s}t({resource:n},i){let r=this.u();if(i&&n){const s=i.getFolder(n);s&&(r=this.v(s.uri)||r);const l=this.n.get(n);l&&(r=r.merge(l))}return r}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(n){let i=this.b.get(n);if(!i){const r=this.u(),s=this.l.get(n);s?(i=r.merge(s),this.p&&(i=i.freeze()),this.b.set(n,i)):i=r}return i}w(n,i){if(i&&n){const r=i.getFolder(n);if(r)return this.l.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((n,i)=>{const{contents:r,overrides:s,keys:l}=this.l.get(i);return n.push([i,{contents:r,overrides:s,keys:l}]),n},[])}}allKeys(){const n=new Set;return this.c.freeze().keys.forEach(i=>n.add(i)),this.userConfiguration.freeze().keys.forEach(i=>n.add(i)),this.j.freeze().keys.forEach(i=>n.add(i)),this.l.forEach(i=>i.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}x(){const n=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.l.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}y(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.j.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.l.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(s=>i.add(s))),[...i.values()]}static parse(n){const i=this.z(n.defaults),r=this.z(n.policy),s=this.z(n.application),l=this.z(n.user),a=this.z(n.workspace),f=n.folders.reduce((D,C)=>(D.set(u.URI.revive(C[0]),this.z(C[1])),D),new N.ResourceMap);return new c(i,r,s,l,new S,a,f,new S,new N.ResourceMap,!1)}static z(n){return new S(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=c;function g(...t){if(t.length===0)return{keys:[],overrides:[]};if(t.length===1)return t[0];const n=new Set,i=new Map;for(const s of t)s.keys.forEach(l=>n.add(l)),s.overrides.forEach(([l,a])=>{const f=(0,N.getOrSet)(i,l,new Set);a.forEach(D=>f.add(D))});const r=[];return i.forEach((s,l)=>r.push([l,[...s.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=g;class E{constructor(n,i,r,s){this.change=n,this.b=i,this.c=r,this.d=s,this.f=void 0;const l=new Set;n.keys.forEach(f=>l.add(f)),n.overrides.forEach(([,f])=>f.forEach(D=>l.add(D))),this.affectedKeys=[...l.values()];const a=new S;this.affectedKeys.forEach(f=>a.setValue(f,{})),this.a=a.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=c.parse(this.b.data)),this.f}affectsConfiguration(n,i){if(this.g(this.a,n)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.b?.workspace):void 0,s=this.c.getValue(n,i,this.d);return!b.equals(r,s)}return!0}return!1}g(n,i){let r=(0,y.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(n=n[s],!n)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=E;function h(t,n){const{added:i,removed:r,updated:s}=o(n?.rawConfiguration,t?.rawConfiguration),l=[],a=t?.getAllOverrideIdentifiers()||[],f=n?.getAllOverrideIdentifiers()||[];if(n){const D=f.filter(C=>!a.includes(C));for(const C of D)l.push([C,n.getKeysForOverrideIdentifier(C)])}if(t){const D=a.filter(C=>!f.includes(C));for(const C of D)l.push([C,t.getKeysForOverrideIdentifier(C)])}if(n&&t){for(const D of a)if(f.includes(D)){const C=o({contents:t.getOverrideValue(void 0,D)||{},keys:t.getKeysForOverrideIdentifier(D)},{contents:n.getOverrideValue(void 0,D)||{},keys:n.getKeysForOverrideIdentifier(D)});l.push([D,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:r,updated:s,overrides:l}}function o(t,n){const i=t?n?t.keys.filter(l=>n.keys.indexOf(l)===-1):[...t.keys]:[],r=n?t?n.keys.filter(l=>t.keys.indexOf(l)===-1):[...n.keys]:[],s=[];if(t&&n){for(const l of n.keys)if(t.keys.indexOf(l)!==-1){const a=(0,y.getConfigurationValue)(n.contents,l),f=(0,y.getConfigurationValue)(t.contents,l);b.equals(a,f)||s.push(l)}}return{added:i,removed:r,updated:s}}}),define(Z[123],Q([0,1,19,5,2,29,3,21,65,40,9,38,37]),function(W,e,L,R,k,T,N,b,d,u,y,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class S extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new v(this.f())),this.b}async initialize(){return this.b=void 0,this.B(m.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:E})=>this.c(g,E))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(g,E){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}}e.DefaultConfiguration=S;class v extends d.ConfigurationModel{constructor(g={}){const E=m.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(E),o=Object.create(null),t=[];for(const n in E){const i=g[n],r=i!==void 0?i:E[n].default;(0,b.addToValueTree)(o,n,r,s=>console.error(`Conflict in default settings: ${s}`))}for(const n of Object.keys(o))u.OVERRIDE_PROPERTY_REGEX.test(n)&&t.push({identifiers:(0,u.overrideIdentifiersFromKey)(n),keys:Object.keys(o[n]),contents:(0,b.toValuesTree)(o[n],i=>console.error(`Conflict in default settings file: ${i}`))});super(o,h,t)}}e.DefaultConfigurationModel=v;class O{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new d.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=O;let w=class extends k.Disposable{get configurationModel(){return this.b}constructor(g,E,h){super(),this.c=g,this.f=E,this.g=h,this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new d.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.i(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.j(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const E={},h=[],o=m.Registry.as(u.Extensions.Configuration).getConfigurationProperties();for(const t of g){const n=o[t];if(!n){h.push(t);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.g.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}h.push(t),E[n.policy.name]={type:n.type}}}return(0,N.isEmptyObject)(E)||await this.f.updatePolicyDefinitions(E),h}i(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const E=m.Registry.as(u.Extensions.Configuration).getPolicyConfigurations(),h=(0,L.coalesce)(g.map(o=>E.get(o)));this.j(h,!0)}j(g,E){this.g.trace("PolicyConfiguration#update",g);const h=m.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),o=[],t=this.b.isEmpty();for(const n of g){const i=h[n]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(t?r!==void 0:!(0,T.equals)(this.b.getValue(n),r))&&o.push([n,r])}else this.b.getValue(n)!==void 0&&o.push([n,void 0])}if(o.length){this.g.trace("PolicyConfiguration#changed",o);const n=this.b;this.b=new d.ConfigurationModel;for(const i of n.keys)this.b.setValue(i,n.getValue(i));for(const[i,r]of o)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);E&&this.a.fire(this.b)}}};w=me([_(1,p.IPolicyService),_(2,y.ILogService)],w),e.PolicyConfiguration=w}),define(Z[124],Q([0,1,4,5,2,17,21,65,123,38]),function(W,e,L,R,k,T,N,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends k.Disposable{constructor(m,S,v,O){super(),this.i=m,this.h=this.B(new R.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.DefaultConfiguration),this.c=v instanceof u.NullPolicyService?new d.NullPolicyConfiguration:this.B(new d.PolicyConfiguration(this.b,v,O)),this.f=this.B(new b.UserSettings(this.i,void 0,T.extUriBiasedIgnorePathCase,S)),this.a=new b.Configuration(this.b.configurationModel,this.c.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.g=this.B(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:c})=>this.k(w,c))),this.B(this.c.onDidChangeConfiguration(w=>this.l(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,S,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.Configuration(m,S,new b.ConfigurationModel,v)}getConfigurationData(){return this.a.toData()}getValue(m,S){const v=typeof m=="string"?m:void 0,O=(0,N.isConfigurationOverrides)(m)?m:(0,N.isConfigurationOverrides)(S)?S:{};return this.a.getValue(v,O,void 0)}updateValue(m,S,v,O){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const S=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(v,S,2)}k(m,S){const v=this.a.toData(),O=this.a.compareAndUpdateDefaultConfiguration(m,S);this.m(O,v,7)}l(m){const S=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(m);this.m(v,S,7)}m(m,S,v){const O=new b.ConfigurationChangeEvent(m,{data:S},this.a);O.source=v,O.sourceConfig=this.n(v),this.h.fire(O)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(Z[66],Q([0,1,16]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(u){return u.scheme===L.Schemas.vscodeRemote?u.authority:void 0}e.getRemoteAuthority=R;function k(u){if(!u)return;const y=u.indexOf("+");return y<0?u:u.substr(0,y)}e.getRemoteName=k;function T(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.getRemoteServerRootPath=T;function N(u){const{host:y,port:p}=d(u);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:y,port:p}}e.parseAuthorityWithPort=N;function b(u,y){let{host:p,port:m}=d(u);return typeof m>"u"&&(m=y),{host:p,port:m}}e.parseAuthorityWithOptionalPort=b;function d(u){const y=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const p=u.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const m=u.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:u,port:void 0}}}),define(Z[27],Q([0,1,31,8,66]),function(W,e,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=T;function N(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));var d;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(d=e.TargetPlatform||(e.TargetPlatform={}));class u{constructor(O){this.value=O,this.c=O.toLowerCase()}static equals(O,w){if(typeof O>"u"||O===null)return typeof w>"u"||w===null;if(typeof w>"u"||w===null)return!1;if(typeof O=="string"||typeof w=="string"){const c=typeof O=="string"?O:O.value,g=typeof w=="string"?w:w.value;return L.equalsIgnoreCase(c,g)}return O.c===w.c}static toKey(O){return typeof O=="string"?O.toLowerCase():O.c}}e.ExtensionIdentifier=u;function y(v){return p(v)}e.isApplicationScopedExtension=y;function p(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function m(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function S(v,O){if(O){const w=`onResolveRemoteAuthority:${(0,k.getRemoteName)(O)}`;return v.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=S,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[24],Q([0,1,31,23,27,12,11,10,35]),function(W,e,L,R,k,T,N,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function u(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,L.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=u;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const r=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,r,s)}static parse(i){const r=y.exec(i);return r&&r[1]&&r[2]?new p({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?u(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=p;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(n){const i=m.exec(n);return i&&i[1]?[O(i[1]),i[2]]:[O(n),void 0]}e.getIdAndVersion=S;function v(n,i){return`${n}.${i}`}e.getExtensionId=v;function O(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=O;function w(n,i){return O(v(n,i))}e.getGalleryExtensionId=w;function c(n,i){const r=[],s=l=>{for(const a of r)if(a.some(f=>u(i(f),i(l))))return a;return null};for(const l of n){const a=s(l);a?a.push(l):r.push([l])}return r}e.groupByExtension=c;function g(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function E(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function h(n,i){const r=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const l=s.shift();if(l&&r.every(a=>!u(a.identifier,{id:l}))){const a=n.filter(f=>u(f.identifier,{id:l}));a.length===1&&(r.push(a[0]),s.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=h;async function o(n,i){if(!T.isLinux)return!1;let r;try{r=(await n.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(l))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=o;async function t(n,i){const r=await o(n,i),s=(0,R.getTargetPlatform)(r?"alpine":T.platform,d.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=t}),define(Z[125],Q([0,1,22,10,16,17,39,11,88,23,24,27]),function(W,e,L,R,k,T,N,b,d,u,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const m=w=>(0,d.localize)(0,null,w),S=(0,d.localize)(1,null,"ms-dotnettools.csharp");function v(w,c){return c?`${w.publisher}.${w.name}@${w.version}`:`${w.publisher}.${w.name}`}let O=class{constructor(c,g){this.a=c,this.b=g}get d(){}async listExtensions(c,g,E,h=console){let o=await this.a.getInstalled(1,E);const t=p.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(g&&g!==""){if(t.indexOf(g.toLowerCase())<0){h.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}o=o.filter(i=>i.manifest.categories?i.manifest.categories.map(s=>s.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){h.log("Possible Categories: "),t.forEach(i=>{h.log(i)});return}this.d&&h.log((0,d.localize)(2,null,this.d)),o=o.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let n;for(const i of o)n!==i.identifier.id&&(n=i.identifier.id,h.log(v(i.manifest,c)))}async installExtensions(c,g,E,h,o=console){const t=[],n=[];c.length&&o.log(this.d?(0,d.localize)(3,null,this.d):(0,d.localize)(4,null));const i=await this.a.getInstalled(1,E.profileLocation),r=(f,D)=>{const C=i.find(x=>(0,y.areSameExtensions)(x.identifier,{id:f}));if(C){if(!h&&(!D||D==="prerelease"&&C.preRelease))return o.log((0,d.localize)(5,null,f,C.manifest.version,f)),!1;if(D&&C.manifest.version===D)return o.log((0,d.localize)(6,null,`${f}@${D}`)),!1}return!0},s=(f,D,C)=>{a.push({id:f,version:D!=="prerelease"?D:void 0,installOptions:{...E,isBuiltin:C,installPreReleaseVersion:D==="prerelease"||E.installPreReleaseVersion}})},l=[],a=[];for(const f of c)if(f instanceof b.URI)l.push(f);else{const[D,C]=(0,y.getIdAndVersion)(f);r(D,C)&&s(D,C,!1)}for(const f of g){const[D,C]=(0,y.getIdAndVersion)(f);r(D,C)&&s(D,C,!0)}if(l.length&&await Promise.all(l.map(async f=>{try{const D=await this.f(f,{...E,isBuiltin:!1},h,o);D&&n.push(D)}catch(D){o.error(D.message||D.stack||D),t.push(f.toString())}})),a.length){const f=await this.g(a);await Promise.all(a.map(async D=>{const C=f.get(D.id.toLowerCase());if(C)try{const x=await this.h(D,C,i,h,o);x&&n.push(x)}catch(x){o.error(x.message||x.stack||x),t.push(D.id)}else o.error(`${m(D.version?`${D.id}@${D.version}`:D.id)}
${S}`),t.push(D.id)}))}if(t.length)throw new Error((0,d.localize)(7,null,t.join(", ")))}async f(c,g,E,h){const o=await this.a.getManifest(c);if(!o)throw new Error("Invalid vsix");if(await this.k(o,E,g.profileLocation,h))try{return await this.a.install(c,g),h.log((0,d.localize)(8,null,(0,T.basename)(c))),o}catch(n){if((0,R.isCancellationError)(n))return h.log((0,d.localize)(9,null,(0,T.basename)(c))),null;throw n}return null}async g(c){const g=new Map,E=c.some(o=>o.installOptions.installPreReleaseVersion),h=await this.b.getExtensions(c.map(o=>({...o,preRelease:E})),L.CancellationToken.None);for(const o of h)g.set(o.identifier.id.toLowerCase(),o);return g}async h({id:c,version:g,installOptions:E},h,o,t,n){const i=await this.b.getManifest(h,L.CancellationToken.None);if(i&&!this.j(i,n))return null;const r=o.find(s=>(0,y.areSameExtensions)(s.identifier,h.identifier));if(r){if(h.version===r.manifest.version)return n.log((0,d.localize)(10,null,g?`${c}@${g}`:c)),null;n.log((0,d.localize)(11,null,c,h.version))}try{E.isBuiltin?n.log(g?(0,d.localize)(12,null,c,g):(0,d.localize)(13,null,c)):n.log(g?(0,d.localize)(14,null,c,g):(0,d.localize)(15,null,c));const s=await this.a.installFromGallery(h,{...E,installGivenVersion:!!g});return n.log((0,d.localize)(16,null,c,s.manifest.version)),i}catch(s){if((0,R.isCancellationError)(s))return n.log((0,d.localize)(17,null,c)),null;throw s}}j(c,g){return!0}async k(c,g,E,h){const o={id:(0,y.getGalleryExtensionId)(c.publisher,c.name)},n=(await this.a.getInstalled(1,E)).find(i=>(0,y.areSameExtensions)(o,i.identifier)&&(0,N.gt)(i.manifest.version,c.version));return n&&!g?(h.log((0,d.localize)(18,null,n.identifier.id,n.manifest.version,c.version)),!1):this.j(c,h)}async uninstallExtensions(c,g,E,h=console){const o=async n=>{if(n instanceof b.URI){const i=await this.a.getManifest(n);return v(i)}return n},t=[];for(const n of c){const i=await o(n),s=(await this.a.getInstalled(void 0,E)).filter(l=>(0,y.areSameExtensions)(l.identifier,{id:i}));if(!s.length)throw new Error(`${this.l(i)}
${S}`);if(s.some(l=>l.type===0)){h.log((0,d.localize)(19,null,i));return}if(!g&&s.some(l=>l.isBuiltin)){h.log((0,d.localize)(20,null,i));return}h.log((0,d.localize)(21,null,i));for(const l of s)await this.a.uninstall(l,{profileLocation:E}),t.push(l);this.d?h.log((0,d.localize)(22,null,i,this.d)):h.log((0,d.localize)(23,null,i))}}async locateExtension(c,g=console){const E=await this.a.getInstalled();c.forEach(h=>{E.forEach(o=>{if(o.identifier.id===h&&o.location.scheme===k.Schemas.file){g.log(o.location.fsPath);return}})})}l(c){return this.d?(0,d.localize)(24,null,c,this.d):(0,d.localize)(25,null,c)}};O=me([_(0,u.IExtensionManagementService),_(1,u.IExtensionGalleryService)],O),e.ExtensionManagementCLI=O}),define(Z[126],Q([0,1,4,10,2,16,12,17,39,3,30,20,21,18,23,24,59,13,9,26]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S,v,O,w,c,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let h=class Ve extends k.Disposable{constructor(t,n,i,r,s,l,a,f){super(),this.h=t,this.i=i,this.j=r,this.k=s,this.l=l,this.m=a,this.n=f,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.w()}async download(t,n){await this.g;const i=(0,b.joinPath)(this.extensionsDownloadDir,this.y(t));try{await this.u(t,i,s=>this.j.download(t,s,n))}catch(s){throw new v.ExtensionManagementError(s.message,v.ExtensionManagementErrorCode.Download)}let r=!1;if(await this.r(t)){const s=await this.t(t);try{r=await this.m.verify(i.fsPath,s.fsPath),this.n.info(`Verified extension: ${t.identifier.id}`,r)}catch(l){throw await this.delete(s),await this.delete(i),new v.ExtensionManagementError(l.code,v.ExtensionManagementErrorCode.Signature)}}return{location:i,verified:r}}async r(t){if(!t.isSigned||await this.h==="linux-armhf")return!1;const i=this.k.getValue("extensions.verifySignature");return(0,u.isBoolean)(i)?i:this.l.quality!=="stable"}async t(t){await this.g;const n=(0,b.joinPath)(this.extensionsDownloadDir,`${this.y(t)}${Ve.c}`);return await this.u(t,n,i=>this.j.downloadSignatureArchive(t,i)),n}async u(t,n,i){if(await this.i.exists(n))return;if(n.scheme!==T.Schemas.file){await i(n);return}const r=(0,b.joinPath)(this.extensionsDownloadDir,`.${(0,y.generateUuid)()}`);await this.i.exists(r)||await i(r);try{await this.v(r,n,Date.now()+2*60*1e3)}catch(s){try{await this.i.del(r)}catch{}if(s.code==="ENOTEMPTY")this.n.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.n.info(`Rename failed because of ${(0,R.getErrorMessage)(s)}. Deleted the file from downloaded location`,r.path),s}}async delete(t){await this.g,await this.i.del(t)}async v(t,n,i){try{await p.Promises.rename(t.fsPath,n.fsPath)}catch(r){if(N.isWindows&&r&&r.code==="EPERM"&&Date.now()<i)return this.n.info(`Failed renaming ${t} to ${n} with 'EPERM' error. Trying again...`),this.v(t,n,i);throw r}}async w(){try{if(!await this.i.exists(this.extensionsDownloadDir)){this.n.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.i.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],i=[],r=[];for(const a of t.children)if(a.name.endsWith(Ve.c))r.push(a.resource);else{const f=O.ExtensionKey.parse(a.name);f&&i.push([f,a])}const s=(0,O.groupByExtension)(i,([a])=>a),l=[];for(const a of s)a.sort((f,D)=>d.rcompare(f[0].version,D[0].version)),n.push(...a.slice(1).map(f=>f[1].resource)),l.push(a[0][1]);l.sort((a,f)=>a.mtime-f.mtime),n.push(...l.slice(0,Math.max(0,l.length-this.f)).map(a=>a.resource)),n.push(...r),await L.Promises.settled(n.map(a=>(this.n.trace("Deleting from cache",a.path),this.i.del(a))))}}catch(t){this.n.error(t)}}y(t){return this.f?O.ExtensionKey.create(t).toString().toLowerCase():(0,y.generateUuid)()}};h.c=".sigzip",h=me([_(1,S.INativeEnvironmentService),_(2,c.IFileService),_(3,v.IExtensionGalleryService),_(4,m.IConfigurationService),_(5,E.IProductService),_(6,w.IExtensionSignatureVerificationService),_(7,g.ILogService)],h),e.ExtensionsDownloader=h}),define(Z[127],Q([0,1,2,14,20,27]),function(W,e,L,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends L.Disposable{constructor(d,u){super(),this.b=d,this.a=(0,R.join)(this.b.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this.B(u.onDidInstallExtensions(y=>this.c(y))),this.B(u.onDidUninstallExtension(y=>this.f(y)))}c(d){d.some(u=>!!u.local)&&this.invalidate()}f(d){d.error||this.invalidate()}invalidate(){k.Promises.rm(this.a,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(Z[128],Q([0,1,5,2,36,24,27]),function(W,e,L,R,k,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class b extends R.Disposable{constructor(u,y,p,m,S,v,O){super(),this.f=u,this.g=y,this.h=p,this.i=m,this.j=S,this.k=v,this.l=O,this.a=this.B(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.DisposableMap),this.m().then(null,w=>O.error(w))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(u=>this.p(u.added,u.removed))),this.B(this.i.onAddExtensions(u=>this.r(u))),this.B(this.i.onDidAddExtensions(u=>this.s(u))),this.B(this.i.onRemoveExtensions(u=>this.t(u))),this.B(this.i.onDidRemoveExtensions(u=>this.u(u))),this.B(this.k.onDidFilesChange(u=>this.v(u)))}async p(u,y){try{await Promise.all(y.map(p=>(this.c.deleteAndDispose(p.id),this.z(p.extensionsResource)))),u.length&&await Promise.all(u.map(p=>(this.c.set(p.id,(0,R.combinedDisposable)(this.k.watch(this.j.extUri.dirname(p.extensionsResource)),this.k.watch(p.extensionsResource))),this.y(p.extensionsResource))))}catch(p){throw this.l.error(p),p}}async r(u){for(const y of u.extensions)this.D(this.G(y.identifier,y.version),u.profileLocation)}async s(u){for(const y of u.extensions){const p=this.G(y.identifier,y.version);u.error?this.F(p,u.profileLocation):this.D(p,u.profileLocation)}}async t(u){for(const y of u.extensions)this.F(this.G(y.identifier,y.version),u.profileLocation)}async u(u){let y=!1;for(const p of u.extensions){const m=this.G(p.identifier,p.version);u.error?this.D(m,u.profileLocation):(this.F(m,u.profileLocation),y=y||!this.b.has(m))}y&&await this.C()}v(u){for(const y of this.h.profiles)u.contains(y.extensionsResource,0,1)&&this.w(y.extensionsResource)}async w(u){const y=[],p=[],m=await this.i.scanProfileExtensions(u),S=new Set,v=new Set;for(const[O,w]of this.b)w.has(u)&&v.add(O);for(const O of m){const w=this.G(O.identifier,O.version);S.add(w),v.has(w)||(y.push(O.identifier),this.D(w,u))}for(const O of v)if(!S.has(O)){const w=this.H(O);w&&(p.push(w.identifier),this.F(O,u))}(y.length||p.length)&&this.a.fire({added:y.length?{extensions:y,profileLocation:u}:void 0,removed:p.length?{extensions:p,profileLocation:u}:void 0})}async y(u){const y=await this.i.scanProfileExtensions(u);for(const p of y)this.D(this.G(p.identifier,p.version),u)}async z(u){for(const y of[...this.b.keys()])this.F(y,u);await this.C()}async C(){const y=(await this.f.getAllUserInstalled()).filter(p=>p.installedTimestamp&&!this.b.has(this.G(p.identifier,p.manifest.version)));y.length&&await this.f.markAsUninstalled(...y)}D(u,y){let p=this.b.get(u);p||this.b.set(u,p=new k.ResourceSet(m=>this.j.extUri.getComparisonKey(m))),p.add(y)}F(u,y){const p=this.b.get(u);p&&p.delete(y),p?.size||this.b.delete(u)}G(u,y){return`${N.ExtensionIdentifier.toKey(u.id)}@${y}`}H(u){const[y,p]=(0,T.getIdAndVersion)(u);return p?{identifier:{id:y},version:p}:void 0}}e.ExtensionsWatcher=b}),define(Z[129],Q([0,1,160,19,4,2,16,14,20,18,23,24,9,63,12,11]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S,v,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let w=class extends S.LanguagePackBaseService{constructor(h,o,t,n){super(t),this.h=h,this.i=n,this.g=this.B(new c(o,n)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(h){const t=(await this.g.getLanguagePacks())[v.Language.value()];if(!t){this.i.warn(`No language pack found for ${v.Language.value()}`);return}const n=t.translations[h];return n?O.URI.file(n):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),o=Object.keys(h).map(t=>{const n=h[t];return{...this.f(t,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return o.push({...this.f("en","English"),extensionId:"default"}),o.sort((t,n)=>t.label.localeCompare(n.label)),o}async j(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",h.identifier.id),await this.update())}async k(h){const o=await this.g.getLanguagePacks();Object.keys(o).some(t=>o[t]&&o[t].extensions.some(n=>(0,p.areSameExtensions)(n.extensionIdentifier,h.identifier)))&&(this.i.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,o]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(o);return!(0,R.equals)(Object.keys(h),Object.keys(t))}};w=me([_(0,y.IExtensionManagementService),_(1,u.INativeEnvironmentService),_(2,y.IExtensionGalleryService),_(3,m.ILogService)],w),e.NativeLanguagePackService=w;let c=class extends T.Disposable{constructor(h,o){super(),this.i=o,this.c={},this.f=(0,b.join)(h.userDataPath,"languagepacks.json"),this.g=new k.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.m(o=>{Object.keys(o).forEach(t=>delete o[t]),this.j(o,...h)}).then(()=>this.c)}j(h,...o){for(const t of o)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(h,t);Object.keys(h).forEach(t=>this.l(h[t]))}k(h,o){const t=o.identifier,n=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const i of n)if(o.location.scheme===N.Schemas.file&&g(i)){let r=h[i.languageId];r||(r={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},h[i.languageId]=r);const s=r.extensions.filter(l=>(0,p.areSameExtensions)(l.extensionIdentifier,t))[0];s?s.version=o.manifest.version:r.extensions.push({extensionIdentifier:t,version:o.manifest.version});for(const l of i.translations)r.translations[l.id]=(0,b.join)(o.location.fsPath,l.path)}}l(h){if(h){const o=(0,L.createHash)("md5");for(const t of h.extensions)o.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);h.hash=o.digest("hex")}}m(h=()=>null){return this.g.queue(()=>{let o=null;return d.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(o=h(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),d.Promises.writeFile(this.f,n)}).then(()=>o,t=>this.i.error(t))})}};c=me([_(0,u.INativeEnvironmentService),_(1,m.ILogService)],c);function g(E){if(typeof E.languageId!="string"||!Array.isArray(E.translations)||E.translations.length===0)return!1;for(const h of E.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(E.languageName&&typeof E.languageName!="string"||E.localizedLanguageName&&typeof E.localizedLanguageName!="string")}}),define(Z[47],Q([0,1,15,98,40,8,37]),function(W,e,L,R,k,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function b(O){return O.res.statusCode&&O.res.statusCode>=200&&O.res.statusCode<300||O.res.statusCode===1223}e.isSuccess=b;function d(O){return O.res.statusCode===204}async function u(O){return d(O)?null:(await(0,L.streamToBuffer)(O.stream)).toString()}e.asText=u;async function y(O){if(!b(O))throw new Error("Server returned "+O.res.statusCode);return u(O)}e.asTextOrError=y;async function p(O){if(!b(O))throw new Error("Server returned "+O.res.statusCode);if(d(O))return null;const c=(await(0,L.streamToBuffer)(O.stream)).toString();try{return JSON.parse(c)}catch(g){throw g.message+=`:
`+c,g}}e.asJson=p;function m(O){v(O)}e.updateProxyConfigurationsScope=m;let S;function v(O){const w=N.Registry.as(k.Extensions.Configuration),c=S;S={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:O,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[S],remove:c?[c]:[]})}v(2)}),define(Z[130],Q([0,1,22,16,13,47]),function(W,e,L,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(d,u){this.a=d,this.b=u}async download(d,u,y=L.CancellationToken.None){if(d.scheme===R.Schemas.file||d.scheme===R.Schemas.vscodeRemote){await this.b.copy(d,u);return}const p={type:"GET",url:d.toString(!0)},m=await this.a.request(p,y);if(m.res.statusCode===200)await this.b.writeFile(u,m.stream);else{const S=await(0,T.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${S}`)}}};N=me([_(0,T.IRequestService),_(1,k.IFileService)],N),e.DownloadService=N}),define(Z[131],Q([0,1,132,3]),function(W,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(N,b){return N.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:N.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function T(N,b,d={}){const u=(0,L.parse)(N),y=d.proxyUrl||k(u,b);if(!y)return null;const p=(0,L.parse)(y);if(!/^https?:$/.test(p.protocol||""))return null;const m={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,R.isBoolean)(d.strictSSL)?d.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((S,v)=>{W(["http-proxy-agent"],S,v)}))(m):new(await new Promise((S,v)=>{W(["https-proxy-agent"],S,v)}))(m)}e.getProxyAgent=T}),define(Z[133],Q([0,1,57,14,99,22,34,10,12,30,81,161,4]),function(W,e,L,R,k,T,N,b,d,u,y,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let v;async function O(c,g,E){return g["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.isLaunchedFromCli)(E)&&!g["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.isLaunchedFromCli)(E)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=m.Promises.withAsyncBody(async(h,o)=>{const t=new T.CancellationTokenSource,n=setTimeout(()=>{t.dispose(!0),o(new Error((0,k.localize)(0,null)))},S);try{h(await w(c,t.token))}catch(i){!(0,b.isCancellationError)(i)&&!t.token.isCancellationRequested?o(new Error((0,k.localize)(1,null,(0,N.toErrorMessage)(i)))):h({})}finally{clearTimeout(n),t.dispose()}})),v)}e.getResolvedShellEnv=O;async function w(c,g){const E=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",E);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",h);const o=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(o+"({.*})"+o),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",n);const i=await(0,y.getSystemShell)(d.OS,n);return c.trace("getUnixShellEnvironment#shell",i),new Promise((r,s)=>{if(g.isCancellationRequested)return s((0,b.canceled)());const l=(0,R.basename)(i);let a,f;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(a=`& '${process.execPath}' ${D} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,f=["-Login","-Command"]):(a=`'${process.execPath}' ${D} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,l==="tcsh"?f=["-ic"]:f=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),a);const C=(0,L.spawn)(i,[...f,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});g.onCancellationRequested(()=>(C.kill(),s((0,b.canceled)()))),C.on("error",X=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(X)),s(X)});const x=[];C.stdout.on("data",X=>x.push(X));const Y=[];C.stderr.on("data",X=>Y.push(X)),C.on("close",(X,ie)=>{const re=Buffer.concat(x).toString("utf8");c.trace("getUnixShellEnvironment#raw",re);const ee=Buffer.concat(Y).toString("utf8");if(ee.trim()&&c.trace("getUnixShellEnvironment#stderr",ee),X||ie)return s(new Error((0,k.localize)(2,null,X,ie)));const pe=t.exec(re),le=pe?pe[1]:"{}";try{const ae=JSON.parse(le);E?ae.ELECTRON_RUN_AS_NODE=E:delete ae.ELECTRON_RUN_AS_NODE,h?ae.ELECTRON_NO_ATTACH_CONSOLE=h:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ae),r(ae)}catch(ae){c.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(ae)),s(ae)}})})}}),define(Z[67],Q([0,1,8]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,L.createDecorator)("stateService")}),define(Z[134],Q([0,1,4,15,3,18,13,9]),function(W,e,L,R,k,T,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class d{constructor(p,m,S){this.f=p,this.g=m,this.h=S,this.a=Object.create(null),this.b="",this.c=new L.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==1&&this.g.error(p)}}getItem(p,m){const S=this.a[p];return(0,k.isUndefinedOrNull)(S)?m:S}setItem(p,m){this.setItems([{key:p,data:m}])}setItems(p){let m=!1;for(const{key:S,data:v}of p)this.a[S]!==v&&((0,k.isUndefinedOrNull)(v)?(0,k.isUndefined)(this.a[S])||(this.a[S]=void 0,m=!0):(this.a[S]=v,m=!0));m&&this.j()}removeItem(p){(0,k.isUndefined)(this.a[p])||(this.a[p]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.h.writeFile(this.f,R.VSBuffer.fromString(p)),this.b=p}catch(m){this.g.error(m)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=d;let u=class{constructor(p,m,S){this.a=new d(p.stateResource,m,S)}async init(){await this.a.init()}getItem(p,m){return this.a.getItem(p,m)}};u=me([_(0,T.IEnvironmentService),_(1,b.ILogService),_(2,N.IFileService)],u),e.StateService=u}),define(Z[68],Q([0,1,12,35,11,30]),function(W,e,L,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(u){if(L.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}async function b(u,y,p,m,S,v,O,w,c,g){const E=Object.create(null);E["common.machineId"]=O,E.sessionID=(0,T.generateUuid)()+Date.now(),E.commitHash=S,E.version=v,E["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,L.PlatformToString)(L.platform),E["common.nodePlatform"]=R.platform,E["common.nodeArch"]=m,E["common.product"]=g||"desktop",w&&(E["common.msftInternal"]=w);let h=0;const o=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),L.isLinuxSnap&&(E["common.snap"]="true");const t=N(p);t&&(E["common.platformDetail"]=t);try{const n=await u.readFile(k.URI.file(c));E["common.source"]=n.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=b;function d(u){const y=R.env.USERDNSDOMAIN;if(!y)return!1;const p=y.toLowerCase();return u.some(m=>p===m)}e.verifyMicrosoftInternalDomain=d}),define(Z[32],Q([0,1,8]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[41],Q([0,1,29,3,21,66,68,32]),function(W,e,L,R,k,T,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class d{constructor(l){this.value=l}}e.TrustedTelemetryValue=d;class u{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(l,a){return Promise.resolve(void 0)}publicLog2(l,a){return this.publicLog(l,a)}publicLogError(l,a){return Promise.resolve(void 0)}publicLogError2(l,a){return this.publicLogError(l,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=u,e.NullTelemetryService=new u;class y{async publicLog(l,a,f){}async publicLogError(l,a,f){}}e.NullEndpointTelemetryService=y,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(s,l){return l.onDidChangeConfiguration(a=>{a.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(a.source),configurationKeys:E(a.sourceConfig)})})}e.configurationTelemetry=p;function m(s,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!s.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=m;function S(s,l){return!(l.isBuilt||l.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=S;function v(s){const l=s.getValue(b.TELEMETRY_SETTING_ID),a=s.getValue("telemetry.enableCrashReporter");if(s.getValue(b.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function O(s){const l={},a={},f={};g(s,f);for(let D in f){D=D.length>150?D.substr(D.length-149):D;const C=f[D];typeof C=="number"?a[D]=C:typeof C=="boolean"?a[D]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${C.length}`),l[D]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(l[D]=C)}return{properties:l,measurements:a}}e.validateTelemetryData=O;const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function c(s){if(!s)return"none";const l=(0,T.getRemoteName)(s);return w.has(l)?l:"other"}e.cleanRemoteAuthority=c;function g(s,l,a=0,f){if(!!s)for(const D of Object.getOwnPropertyNames(s)){const C=s[D],x=f?f+D:D;Array.isArray(C)?l[x]=(0,L.safeStringify)(C):C instanceof Date?l[x]=C.toISOString():(0,R.isObject)(C)?a<2?g(C,l,a+1,x+"."):l[x]=(0,L.safeStringify)(C):l[x]=C}}function E(s){if(!s)return[];const l=[];return h(l,"",s),l}function h(s,l,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(f=>h(s,l?`${l}.${f}`:f,a[f])):s.push(l)}function o(s,l){const a=s.msftInternalDomains||[],f=l.getValue("telemetry.internalTesting");return(0,N.verifyMicrosoftInternalDomain)(a)||f}e.isInternalTelemetry=o;function t(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=t;function n(s,l){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let a=s;const f=[];for(const Y of l)for(;;){const X=Y.exec(s);if(!X)break;f.push([X.index,Y.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let x=0;for(a="";;){const Y=C.exec(s);if(!Y)break;const X=f.some(([ie,re])=>Y.index<re&&ie<C.lastIndex);!D.test(Y[0])&&!X&&(a+=s.substring(x,Y.index)+"<REDACTED: user-file-path>",x=C.lastIndex)}return x<s.length&&(a+=s.substr(x)),a}function i(s){if(!s)return s;const l=s.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of a)if(f.regex.test(l))return`<REDACTED: ${f.label}>`;return s}function r(s,l){return(0,L.cloneAndChange)(s,a=>{if(a instanceof d)return a.value;if(typeof a=="string"){let f=a.replaceAll("%20"," ");f=n(f,l);for(const D of l)f=f.replace(D,"");return f=i(f),f}})}e.cleanData=r}),define(Z[135],Q([0,1,108,41]),function(W,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(T,N,b,d,u,y,p){const m={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${N.nameShort})`};if((0,R.supportsTelemetry)(N,b)&&(0,R.getTelemetryLevel)(d)===3){const S=await(0,L.getServiceMachineId)(b,u,y),{machineId:v}=await p.getTelemetryInfo();m["X-Market-User-Id"]=S,m["VSCode-SessionId"]=v||S}return m}e.resolveMarketplaceHeaders=k}),define(Z[136],Q([0,1,10,29,41]),function(W,e,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0",N="https://mobile.events.data.microsoft.com/ping";async function b(u,y,p){const m=await new Promise((c,g)=>{W(["@microsoft/1ds-core-js"],c,g)}),S=await new Promise((c,g)=>{W(["@microsoft/1ds-post-js"],c,g)}),v=new m.AppInsightsCore,O=new S.PostChannel,w={instrumentationKey:u,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[O]]};if(p){w.extensionConfig={};const c={alwaysUseXhrOverride:!0,httpXHROverride:p};w.extensionConfig[O.identifier]=c}return v.initialize(w,[]),v.addTelemetryInitializer(c=>{y&&(c.ext=c.ext??{},c.ext.utc=c.ext.utc??{},c.ext.utc.flags=8462029)}),v}class d{constructor(y,p,m,S,v){this.e=y,this.f=p,this.g=m,this.h=v,this.c=T,this.d=N,this.g||(this.g={}),typeof S=="function"?this.a=S():this.a=S,this.b=null}i(y){if(!!this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=b(this.a,this.e,this.h)),this.b.then(p=>{y(p)},p=>{(0,L.onUnexpectedError)(p),console.error(p)})}}log(y,p){if(!this.a)return;p=(0,R.mixin)(p,this.g),p=(0,k.validateTelemetryData)(p);const m=this.f+"/"+y;try{this.i(S=>{S.pluginVersionString=p?.properties.version??"Unknown",S.track({name:m,baseData:{name:m,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=d}),define(Z[137],Q([0,1,2,29,12,31,100,21,40,138,26,37,32,41]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(c,g,E){this.k=g,this.l=E,this.d={},this.i=new L.DisposableStore,this.j=[],this.b=c.appenders,this.c=c.commonProperties||Promise.resolve({}),this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,T.escapeRegExpCharacters)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,T.escapeRegExpCharacters)(h.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(c,g){this.d[c]=g}m(){let c=(0,S.getTelemetryLevel)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const E=g.usage?3:g.error?2:0;c=Math.min(c,E)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const c=await this.c,g=c.sessionID,E=c["common.machineId"],h=c["common.firstSessionDate"],o=c["common.msftInternal"];return{sessionId:g,machineId:E,firstSessionDate:h,msftInternal:o}}dispose(){this.i.dispose()}n(c,g,E){return this.g<g?Promise.resolve(void 0):this.c.then(h=>{E=(0,R.mixin)(E,this.d),E=(0,S.cleanData)(E,this.j),E=(0,R.mixin)(E,h),this.b.forEach(o=>o.log(c,E))},h=>{console.error(h)})}publicLog(c,g){return this.n(c,3,g)}publicLog2(c,g){return this.publicLog(c,g)}publicLogError(c,g){return this.h?this.n(c,2,g):Promise.resolve(void 0)}publicLogError2(c,g){return this.publicLogError(c,g)}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=me([_(1,b.IConfigurationService),_(2,y.IProductService)],v),e.TelemetryService=v;function O(){const w=(0,N.localize)(0,null,u.default.nameLong),c=u.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=k.isWeb?"":(0,N.localize)(3,null),E=(0,N.localize)(4,null),h=(0,N.localize)(5,null),o=(0,N.localize)(6,null),t=(0,N.localize)(7,null),n=`
|       | ${E} | ${h} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${w} ${c} ${g}

&nbsp;

${t}
${n}

&nbsp;

${i}
`}p.Registry.as(d.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:O(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(d.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,N.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,N.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[139],Q([0,1,162,136]),function(W,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends R.AbstractOneDataSystemAppender{constructor(N,b,d,u){const y={sendPOST:(p,m)=>{const S={method:"POST",headers:{...p.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(p.data)}};try{const v=L.request(p.urlString,S,O=>{O.on("data",function(w){m(O.statusCode??200,O.headers,w.toString())}),O.on("error",function(w){m(0,{})})});v.write(p.data),v.end()}catch{m(0,{})}}};super(N,b,d,u,y)}}e.OneDataSystemAppender=k}),define(Z[140],Q([0,1,14,20]),function(W,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(T,N){const b=Object.create(null),d=(y,p)=>{const m=JSON.parse(y);b[p]=m};if(N){const y=[],p=await R.Promises.readdir(N);for(const S of p)try{(await R.Promises.stat((0,L.join)(N,S))).isDirectory()&&y.push(S)}catch{}const m=[];for(const S of y)(await R.Promises.readdir((0,L.join)(N,S))).filter(O=>O==="telemetry.json").length===1&&m.push(S);for(const S of m){const v=(await R.Promises.readFile((0,L.join)(N,S,"telemetry.json"))).toString();d(v,S)}}let u=(await R.Promises.readFile((0,L.join)(T,"telemetry-core.json"))).toString();return d(u,"vscode-core"),u=(await R.Promises.readFile((0,L.join)(T,"telemetry-extensions.json"))).toString(),d(u,"vscode-extensions"),JSON.stringify(b,null,4)}e.buildTelemetryMessage=k}),define(Z[141],Q([0,1,12,79,32]),function(W,e,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function T(N){let b=N.getItem(k.machineIdKey);return(typeof b!="string"||L.isMacintosh&&b==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(b=await(0,R.getMachineId)()),b}e.resolveMachineId=T}),define(Z[28],Q([0,1,8]),function(W,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(Z[142],Q([0,1,28,109,13,17,71,5,2]),function(W,e,L,R,k,T,N,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class u{constructor(m){this.uri=m,this.time=u._clock++}touch(){return this.time=u._clock++,this}}u._clock=0;let y=class{constructor(m){this.g=m,this.c=new d.DisposableStore,this.f=2**16;const S=new Map,v=O=>{let w=S.get(O.scheme);return w===void 0&&(w=m.hasProvider(O)&&!this.g.hasCapability(O,1024),S.set(O.scheme,w)),w};this.c.add(b.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(O=>{S.delete(O.scheme)})),this.extUri=new T.ExtUri(v),this.d=new N.SkipList((O,w)=>this.extUri.compare(O,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,T.normalizePath)(m));const S=this.d.get(m);return S?S.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new u(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((v,O)=>v[1].touch<O[1].touch?1:v[1].touch>O[1].touch?-1:0);u._clock=0,this.d.clear();const S=this.f*.5;for(let v=0;v<S;v++)this.d.set(m[v][0],m[v][1].touch())}};y=me([_(0,k.IFileService)],y),e.UriIdentityService=y,(0,R.registerSingleton)(L.IUriIdentityService,y,1)}),define(Z[143],Q([0,1,102,14,54,17,11,8,16]),function(W,e,L,R,k,T,N,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function u(n){const i=n;return typeof i?.id=="string"&&N.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=u,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function y(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,R.basename)(n)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=n;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=y;function p(n){const i=n;return typeof i?.id=="string"&&N.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=p;function m(n){const i=n;if(i?.uri)return{id:i.id,uri:N.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=m;var S;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function v(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=v;function O(n){const i=n;return!!(i&&typeof i=="object"&&N.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=O;class w{constructor(i,r,s,l,a){this.h=i,this.j=s,this.k=l,this.l=a,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class c{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,T.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function g(n){return new c({uri:n,index:0,name:(0,T.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(n,i){return T.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function h(n){let i;return N.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=h;function o(n,i){return!E(n,i)&&!h(n)}e.isSavedWorkspace=o;function t(n){return(typeof n=="string"?(0,R.extname)(n):(0,T.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(Z[25],Q([0,1,52,5,2,17,11,101,18,13,8,9,143,36,28,4,30,31,3]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S,v,O,w,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function E(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&N.URI.isUri(r.location)&&N.URI.isUri(r.globalStorageHome)&&N.URI.isUri(r.settingsResource)&&N.URI.isUri(r.keybindingsResource)&&N.URI.isUri(r.tasksResource)&&N.URI.isUri(r.snippetsHome)&&N.URI.isUri(r.extensionsResource))}e.isUserDataProfile=E,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function h(i,r){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:N.URI.revive(i.location).with({scheme:r}),globalStorageHome:N.URI.revive(i.globalStorageHome).with({scheme:r}),settingsResource:N.URI.revive(i.settingsResource).with({scheme:r}),keybindingsResource:N.URI.revive(i.keybindingsResource).with({scheme:r}),tasksResource:N.URI.revive(i.tasksResource).with({scheme:r}),snippetsHome:N.URI.revive(i.snippetsHome).with({scheme:r}),extensionsResource:N.URI.revive(i.extensionsResource)?.with({scheme:r}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=h;function o(i,r,s,l){return{id:i,name:r,location:s,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,T.joinPath)(s,"globalStorage"),settingsResource:(0,T.joinPath)(s,"settings.json"),keybindingsResource:(0,T.joinPath)(s,"keybindings.json"),tasksResource:(0,T.joinPath)(s,"tasks.json"),snippetsHome:(0,T.joinPath)(s,"snippets"),extensionsResource:(0,T.joinPath)(s,"extensions.json"),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=o;let t=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(r,s,l,a){super(),this.m=r,this.n=s,this.r=l,this.s=a,this.f=!1,this.g=this.B(new R.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new R.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new R.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new R.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new S.ResourceMap},this.profilesHome=(0,T.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(r){this.f!==r&&(this.t=void 0,this.f=r)}isEnabled(){return this.f}get u(){if(!this.t){const r=[];if(this.f)for(const f of this.H()){if(!f.name||!(0,g.isString)(f.name)||!f.location){this.s.warn("Skipping the invalid stored profile",f.location||f.name);continue}r.push(o((0,T.basename)(f.location),f.name,f.location,{shortName:f.shortName,useDefaultFlags:f.useDefaultFlags}))}let s;const l=new S.ResourceMap,a=o((0,L.hash)(this.m.userRoamingDataHome.path).toString(16),(0,b.localize)(0,null),this.m.userRoamingDataHome);if(r.unshift({...a,extensionsResource:this.M()??a.extensionsResource,isDefault:!0}),r.length){const f=this.J();if(f.workspaces)for(const[D,C]of Object.entries(f.workspaces)){const x=N.URI.parse(D),Y=N.URI.parse(C),X=r.find(ie=>this.r.extUri.isEqual(ie.location,Y));X&&l.set(x,X)}if(f.emptyWindow){const D=N.URI.parse(f.emptyWindow);s=r.find(C=>this.r.extUri.isEqual(C.location,D))}}this.t={profiles:r,workspaces:l,emptyWindow:s}}return this.t}async createTransientProfile(r){const s="Temp",l=new RegExp(`${(0,c.escapeRegExpCharacters)(s)}\\s(\\d+)`);let a=0;for(const D of this.profiles){const C=l.exec(D.name),x=C?parseInt(C[1]):0;a=x>a?x:a}const f=`${s} ${a+1}`;return this.createProfile((0,L.hash)((0,w.generateUuid)()).toString(16),f,{transient:!0},r)}async createNamedProfile(r,s,l){return this.createProfile((0,L.hash)((0,w.generateUuid)()).toString(16),r,s,l)}async createProfile(r,s,l,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const f=await this.v(r,s,l);return a&&await this.setProfileForWorkspace(a,f),f}async v(r,s,l){if(!(0,g.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(s);return a||(a=(async()=>{try{const f=this.profiles.find(x=>x.name===s||x.id===r);if(f)return f;const D=o(r,s,(0,T.joinPath)(this.profilesHome,r),l);await this.n.createFolder(D.location);const C=[];return this.h.fire({profile:D,join(x){C.push(x)}}),await O.Promises.settled(C),this.C([D],[],[]),D}finally{this.k.delete(s)}})(),this.k.set(s,a)),a}async updateProfile(r,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let l=this.profiles.find(a=>a.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);return l=o(l.id,s.name??l.name,l.location,{shortName:s.shortName??l.shortName,transient:s.transient??l.isTransient,useDefaultFlags:s.useDefaultFlags??l.useDefaultFlags}),this.C([],[],[l]),l}async removeProfile(r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(a=>a.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);const l=[];this.i.fire({profile:s,join(a){l.push(a)}});try{await Promise.allSettled(l)}catch(a){this.s.error(a)}s.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const a of[...this.u.workspaces.keys()])s.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.G(),this.C([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(a){this.s.error(a)}}getOrSetProfileForWorkspace(r,s=this.defaultProfile){if(!this.f)return this.defaultProfile;let l=this.w(r);return l||(l=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(r,l)),l}async setProfileForWorkspace(r,s){this.setProfileForWorkspaceSync(r,s)}setProfileForWorkspaceSync(r,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const l=this.profiles.find(a=>a.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);this.F(r,l)}unsetWorkspace(r,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(r,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const r=await this.n.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(s=>s.isDirectory&&this.profiles.every(l=>!this.r.extUri.isEqual(l.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.l.profiles.filter(s=>!this.z(s));await Promise.allSettled(r.map(s=>this.removeProfile(s)))}w(r){const s=this.y(r);return N.URI.isUri(s)?this.l.workspaces.get(s)??this.u.workspaces.get(s):this.l.emptyWindow??this.u.emptyWindow}y(r){return(0,m.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,m.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}z(r){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,r.location)||[...this.l.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,r.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,r.location)||[...this.u.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,r.location)))}C(r,s,l){const a=[...this.profiles,...r],f=[];this.l.profiles=[];for(let D of a)D.isDefault||s.some(C=>D.id===C.id)||(D=l.find(C=>D.id===C.id)??D,D.isTransient?this.l.profiles.push(D):f.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.I(f),this.t=void 0,this.D(r,s,l)}D(r,s,l){this.g.fire({added:r,removed:s,updated:l,all:this.profiles})}F(r,s,l){l=s?.isTransient?!0:l,l||this.F(r,void 0,!0);const a=this.y(r),f=l?this.l:this.u;N.URI.isUri(a)?(f.workspaces.delete(a),s&&f.workspaces.set(a,s)):f.emptyWindow=s,l||this.G()}G(){const r={};for(const[l,a]of this.u.workspaces.entries())r[l.toString()]=a.location.toString();const s=this.u.emptyWindow?.location.toString();this.L({workspaces:r,emptyWindow:s}),this.t=void 0}H(){return[]}I(r){throw new Error("not implemented")}J(){return{}}L(r){throw new Error("not implemented")}M(){}};t.b="userDataProfiles",t.c="profileAssociations",t=me([_(0,d.IEnvironmentService),_(1,u.IFileService),_(2,v.IUriIdentityService),_(3,p.ILogService)],t),e.UserDataProfilesService=t;class n extends t{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(r){this.a=r}J(){return this.P}L(r){this.P=r}}e.InMemoryUserDataProfilesService=n}),define(Z[144],Q([0,1,19,4,22,10,5,2,12,11,86,23,24,27,9,26,32,25]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S,v,O,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends b.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,r,s,l,a){super(),this.t=i,this.u=r,this.v=s,this.w=l,this.y=a,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new N.Emitter),this.m=this.B(new N.Emitter),this.n=this.B(new N.Emitter),this.p=this.B(new N.Emitter),this.s=[],this.B((0,b.toDisposable)(()=>{this.j.forEach(({task:f})=>f.cancel()),this.k.forEach(f=>f.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(s=>(0,p.isTargetPlatformCompatible)(s,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{if(!this.t.isEnabled())throw new p.ExtensionManagementError(y.localize(0,null),p.ExtensionManagementErrorCode.Internal);const s=await this.G(i,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(s.manifest,s.extension,r)}catch(s){throw o(this.u,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(i),error:s}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(s),h(s)}}async uninstall(i,r={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,r)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,r,s){const l={...s,installOnlyNewlyAddedFromExtensionPack:u.URI.isUri(r)?s.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,S.isApplicationScopedExtension)(i)?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},a=X=>`${m.ExtensionKey.create(X).toString()}${l.profileLocation?`-${l.profileLocation.toString()}`:""}`;if(!u.URI.isUri(r)){const X=this.j.get(a(r));if(X){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:ie}=await X.task.waitUntilTaskIsFinished();return ie}}const f=[],D=[],C=[],x=this.Q(i,r,l);u.URI.isUri(r)||this.j.set(a(r),{task:x,waitingTasks:[]}),this.l.fire({identifier:x.identifier,source:r,profileLocation:l.profileLocation}),this.v.info("Installing extension:",x.identifier.id),f.push({task:x,manifest:i});let Y=!1;try{if(l.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",x.identifier.id);else try{const ie=await this.F(x.identifier,i,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation),re=await this.getInstalled(void 0,l.profileLocation);for(const{gallery:ee,manifest:pe}of(0,L.distinct)(ie,({gallery:le})=>le.identifier.id)){Y=Y||!!pe.extensionDependencies?.some(he=>(0,m.areSameExtensions)({id:he},x.identifier));const le=a(ee),ae=this.j.get(le);if(ae){if(this.C(x,ae.task)){const he=ae.task.identifier;this.v.info("Waiting for already requested installing extension",he.id,x.identifier.id),ae.waitingTasks.push(x),D.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,B=>B.some(j=>(0,m.areSameExtensions)(j.identifier,he)))).then(B=>{if(this.v.info("Finished waiting for already requested installing extension",he.id,x.identifier.id),!B.find(A=>(0,m.areSameExtensions)(A.identifier,he))?.local)throw new Error(`Extension ${he.id} is not installed`)}))}}else if(!re.some(({identifier:he})=>(0,m.areSameExtensions)(he,ee.identifier))){const he=this.Q(pe,ee,{...l,donotIncludePackAndDependencies:!0});this.j.set(le,{task:he,waitingTasks:[x]}),this.l.fire({identifier:he.identifier,source:ee,profileLocation:l.profileLocation}),this.v.info("Installing extension:",he.identifier.id,x.identifier.id),f.push({task:he,manifest:pe})}}}catch(ie){if(u.URI.isUri(x.source))(0,L.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",x.identifier.id,ie.message),(0,L.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",x.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",x.identifier.id),ie}const X=f.reduce((ie,{task:re,manifest:ee})=>(ie.set(re.identifier.id.toLowerCase(),{task:re,manifest:ee}),ie),new Map);for(;X.size;){let ie;const re=[...X.values()].filter(({manifest:ee})=>!ee.extensionDependencies?.some(pe=>X.has(pe.toLowerCase())));re.length?ie=X.size===1?re:re.filter(({task:ee})=>!(ee===x&&!Y)):(this.v.info("Found extensions with circular dependencies",re.map(({task:ee})=>ee.identifier.id)),ie=[...X.values()]),await this.D(ie.map(async({task:ee})=>{const pe=new Date().getTime();try{const{local:le}=await ee.run();if(await this.D(this.s.map(ae=>ae.postInstall(le,ee.source,l,k.CancellationToken.None))),!u.URI.isUri(ee.source)){const ae=ee.operation===3,he=ae?void 0:(new Date().getTime()-ee.source.lastUpdated)/1e3;if(o(this.u,ae?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(ee.source),wasVerified:ee.wasVerified,duration:new Date().getTime()-pe,durationSinceUpdate:he}),d.isWeb&&ee.operation!==3)try{await this.t.reportStatistic(le.manifest.publisher,le.manifest.name,le.manifest.version,"install")}catch{}}C.push({local:le,identifier:ee.identifier,operation:ee.operation,source:ee.source,context:l.context,profileLocation:l.profileLocation,applicationScoped:le.isApplicationScoped})}catch(le){throw u.URI.isUri(ee.source)||o(this.u,ee.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(ee.source),wasVerified:ee.wasVerified,duration:new Date().getTime()-pe,error:le}),this.v.error("Error while installing the extension:",ee.identifier.id),le}finally{X.delete(ee.identifier.id.toLowerCase())}}))}return D.length&&await this.D(D),C.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(C),C.filter(({identifier:ie})=>(0,m.areSameExtensions)(ie,x.identifier))[0].local}catch(X){if(f.forEach(({task:ie})=>ie.cancel()),C.length)try{const ie=await Promise.allSettled(C.map(({local:re})=>this.R(re,{versionOnly:!0,profileLocation:l.profileLocation}).run()));for(let re=0;re<ie.length;re++){const ee=ie[re],{identifier:pe}=C[re];ee.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",pe.id):this.v.warn("Rollback: Error while uninstalling extension",pe.id,(0,T.getErrorMessage)(ee.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,T.getErrorMessage)(ie),C.map(({identifier:re})=>re.id))}throw this.m.fire(f.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:l.context,profileLocation:l.profileLocation}))),X}finally{for(const{task:X}of f)X.source&&!u.URI.isUri(X.source)&&this.j.delete(a(X.source))}}C(i,r){for(const[,{task:s,waitingTasks:l}]of this.j.entries())if(s===i&&(l.includes(r)||l.some(a=>this.C(a,r)))||s===r&&l[0]&&!this.C(i,l[0]))return!1;return!0}async D(i){const r=[],s=[],l=await Promise.allSettled(i);for(const a of l)a.status==="fulfilled"?r.push(a.value):s.push(a.reason);if(s.length)throw E(s);return r}async F(i,r,s,l,a){if(!this.t.isEnabled())return[];const f=await this.getInstalled(void 0,a),D=[],C=[],x=async(Y,X)=>{D.push(Y);const ie=X.extensionDependencies||[],re=[...ie];if(X.extensionPack){const ee=s?f.find(pe=>(0,m.areSameExtensions)(pe.identifier,Y)):void 0;for(const pe of X.extensionPack)ee&&ee.manifest.extensionPack&&ee.manifest.extensionPack.some(le=>(0,m.areSameExtensions)({id:le},{id:pe}))||re.every(le=>!(0,m.areSameExtensions)({id:le},{id:pe}))&&re.push(pe)}if(re.length){const ee=re.filter(pe=>D.every(le=>!(0,m.areSameExtensions)(le,{id:pe})));if(ee.length){const pe=await this.t.getExtensions(ee.map(le=>({id:le,preRelease:l})),k.CancellationToken.None);for(const le of pe){if(D.find(B=>(0,m.areSameExtensions)(B,le.identifier)))continue;const ae=ie.some(B=>(0,m.areSameExtensions)({id:B},le.identifier));let he;try{he=await this.G(le,!1,l)}catch(B){if(B instanceof p.ExtensionManagementError&&B.code===p.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ae){this.v.info("Skipping the packed extension as it cannot be installed",le.identifier.id);continue}else throw B}C.push({gallery:he.extension,manifest:he.manifest}),await x(he.extension.identifier,he.manifest)}}}};return await x(i,r),C}async G(i,r,s){if((await this.getExtensionsControlManifest()).malicious.some(D=>(0,m.areSameExtensions)(i.identifier,D)))throw new p.ExtensionManagementError(y.localize(1,null,i.identifier.id),p.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const D=await this.getTargetPlatform();throw new p.ExtensionManagementError(y.localize(2,null,i.identifier.id,this.w.nameLong,(0,p.TargetPlatformToString)(D)),p.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.H(i,r,s);if(a){if(s&&!r&&i.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new p.ExtensionManagementError(y.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),p.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],k.CancellationToken.None))[0]?new p.ExtensionManagementError(y.localize(4,null,i.identifier.id),p.ExtensionManagementErrorCode.ReleaseVersionNotFound):new p.ExtensionManagementError(y.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),p.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",a.identifier.id);const f=await this.t.getManifest(a,k.CancellationToken.None);if(f===null)throw new p.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,p.ExtensionManagementErrorCode.Invalid);if(f.version!==a.version)throw new p.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,p.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:f}}async H(i,r,s){const l=await this.getTargetPlatform();let a=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==s&&(a=(await this.t.getExtensions([{...i.identifier,preRelease:s}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null),!a&&await this.t.isExtensionCompatible(i,s,l)&&(a=i),a||(r?a=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null:a=await this.t.getCompatibleExtension(i,s,l)),a}async I(i,r){const s={...r,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},l=Y=>`${Y.id.toLowerCase()}${s.versionOnly?`-${i.manifest.version}`:""}${s.profileLocation?`@${s.profileLocation.toString()}`:""}`,a=this.k.get(l(i.identifier));if(a)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),a.waitUntilTaskIsFinished();const f=Y=>{const X=this.R(Y,s);return this.k.set(l(X.extension.identifier),X),s.profileLocation?this.v.info("Uninstalling extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,s.profileLocation.toString()):this.v.info("Uninstalling extension:",`${Y.identifier.id}@${Y.manifest.version}`),this.n.fire({identifier:Y.identifier,profileLocation:s.profileLocation,applicationScoped:Y.isApplicationScoped}),X},D=(Y,X)=>{X?s.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,s.profileLocation.toString(),X.message):this.v.error("Failed to uninstall extension:",`${Y.identifier.id}@${Y.manifest.version}`,X.message):s.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${Y.identifier.id}@${Y.manifest.version}`,s.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${Y.identifier.id}@${Y.manifest.version}`),o(this.u,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(Y),error:X}),this.p.fire({identifier:Y.identifier,error:X?.code,profileLocation:s.profileLocation,applicationScoped:Y.isApplicationScoped})},C=[],x=[];try{C.push(f(i));const Y=await this.getInstalled(1,s.profileLocation);if(s.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const X=this.M(i,Y);for(const ie of X)this.k.has(l(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):C.push(f(ie))}s.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(C.map(X=>X.extension),Y,i),await this.D(C.map(async X=>{try{if(await X.run(),await this.D(this.s.map(ie=>ie.postUninstall(X.extension,s,k.CancellationToken.None))),X.extension.identifier.uuid)try{await this.t.reportStatistic(X.extension.manifest.publisher,X.extension.manifest.name,X.extension.manifest.version,"uninstall")}catch{}D(X.extension)}catch(ie){const re=ie instanceof p.ExtensionManagementError?ie:new p.ExtensionManagementError((0,T.getErrorMessage)(ie),p.ExtensionManagementErrorCode.Internal);throw D(X.extension,re),re}finally{x.push(X)}}))}catch(Y){const X=Y instanceof p.ExtensionManagementError?Y:new p.ExtensionManagementError((0,T.getErrorMessage)(Y),p.ExtensionManagementErrorCode.Internal);for(const ie of C){try{ie.cancel()}catch{}x.includes(ie)||D(ie.extension,X)}throw X}finally{for(const Y of C)this.k.delete(l(Y.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",Y.extension.identifier.id)}}J(i,r,s){for(const l of i){const a=this.N(l,r);if(a.length){const f=a.filter(D=>!i.some(C=>(0,m.areSameExtensions)(C.identifier,D.identifier)));if(f.length)throw new Error(this.L(l,f,s))}}}L(i,r,s){return s===i?r.length===1?y.localize(6,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(7,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(8,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?y.localize(9,null,s.manifest.displayName||s.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(10,null,s.manifest.displayName||s.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(11,null,s.manifest.displayName||s.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(i,r,s=[]){if(s.indexOf(i)!==-1)return[];s.push(i);const l=i.manifest.extensionPack?i.manifest.extensionPack:[];if(l.length){const a=r.filter(D=>!D.isBuiltin&&l.some(C=>(0,m.areSameExtensions)({id:C},D.identifier))),f=[];for(const D of a)f.push(...this.M(D,r,s));return[...a,...f]}return[]}N(i,r){return r.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(l=>(0,m.areSameExtensions)({id:l},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};g=me([_(0,p.IExtensionGalleryService),_(1,w.ITelemetryService),_(2,v.ILogService),_(3,O.IProductService),_(4,c.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function E(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,s)=>new Error(`${r.message}${r.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=E;function h(n){if(n instanceof p.ExtensionManagementError)return n;const i=new p.ExtensionManagementError(n.message,p.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}function o(n,i,{extensionData:r,wasVerified:s,duration:l,error:a,durationSinceUpdate:f}){let D,C;a&&(a instanceof p.ExtensionManagementError?(D=a.code,a.code===p.ExtensionManagementErrorCode.Signature&&(C=a.message)):D=p.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,wasVerified:s,success:!a,duration:l,errorcode:D,errorcodeDetail:C,durationSinceUpdate:f})}e.reportTelemetry=o;class t{constructor(){this.d=new R.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.createCancelablePromise)(i=>new Promise((r,s)=>{const l=i.onCancellationRequested(()=>{l.dispose(),s(new T.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=t}),define(Z[42],Q([0,1,4,15,2,5,36,11,24,27,13,8,9,25,28,3,16]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S,v,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,p.createDecorator)("IExtensionsProfileScannerService");let c=class extends k.Disposable{constructor(o,t,n,i){super(),this.h=o,this.i=t,this.j=n,this.k=i,this.a=this.B(new T.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new T.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new T.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new T.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new N.ResourceMap}scanProfileExtensions(o){return this.l(o)}async addExtensionsToProfile(o,t){const n=[],i=[];try{return await this.l(t,r=>{const s=[];for(const l of r)o.some(([a])=>(0,d.areSameExtensions)(a.identifier,l.identifier)&&a.manifest.version!==l.version)?n.push(l):s.push(l);for(const[l,a]of o)if(!s.some(f=>(0,d.areSameExtensions)(f.identifier,l.identifier)&&f.version===l.manifest.version)){const f={identifier:l.identifier,version:l.manifest.version,location:l.location,metadata:a};i.push(f),s.push(f)}return i.length&&this.a.fire({extensions:i,profileLocation:t}),n.length&&this.c.fire({extensions:n,profileLocation:t}),s}),i.length&&this.b.fire({extensions:i,profileLocation:t}),n.length&&this.f.fire({extensions:n,profileLocation:t}),i}catch(r){throw i.length&&this.b.fire({extensions:i,error:r,profileLocation:t}),n.length&&this.f.fire({extensions:n,error:r,profileLocation:t}),r}}async removeExtensionFromProfile(o,t){const n=[];this.c.fire({extensions:n,profileLocation:t});try{await this.l(t,i=>{const r=[];for(const s of i)(0,d.areSameExtensions)(s.identifier,o.identifier)?n.push(s):r.push(s);return n.length&&this.c.fire({extensions:n,profileLocation:t}),r}),n.length&&this.f.fire({extensions:n,profileLocation:t})}catch(i){throw n.length&&this.f.fire({extensions:n,error:i,profileLocation:t}),i}}async l(o,t){return this.s(o).queue(async()=>{let n=[],i;try{const r=await this.h.readFile(o);i=JSON.parse(r.value.toString())}catch(r){if((0,y.toFileOperationResult)(r)!==1)throw r;this.j.extUri.isEqual(o,this.i.defaultProfile.extensionsResource)&&(i=await this.r())}if(i){if(!Array.isArray(i))throw new Error(`Invalid extensions content in ${o.toString()}`);let r=!1;for(const s of i){if(!g(s))throw new Error(`Invalid extensions content in ${o.toString()}`);let l;if((0,O.isString)(s.location))l=this.n(o,s.location);else{l=b.URI.revive(s.location);const a=this.m(o,l);a&&(r=!0,s.location=a)}n.push({identifier:s.identifier,location:l,version:s.version,metadata:s.metadata})}r&&await this.h.writeFile(o,R.VSBuffer.fromString(JSON.stringify(i)))}if(t){n=t(n);const r=n.map(s=>({identifier:s.identifier,version:s.version,location:this.m(o,s.location)??s.location.toJSON(),metadata:s.metadata}));await this.h.writeFile(o,R.VSBuffer.fromString(JSON.stringify(r)))}return n})}m(o,t){const n=this.j.extUri.dirname(o).with({scheme:w.Schemas.file});if(this.j.extUri.isEqualOrParent(t,n))return this.j.extUri.relativePath(n,t)}n(o,t){return this.j.extUri.joinPath(this.j.extUri.dirname(o),t).with({scheme:w.Schemas.file})}async r(){return this.p||(this.p=(async()=>{const o=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let t;try{t=(await this.h.readFile(o)).value.toString()}catch(i){if((0,y.toFileOperationResult)(i)===1)return;throw i}this.k.info("Migrating extensions from old default profile location",o.toString());let n;try{const i=JSON.parse(t);Array.isArray(i)&&i.every(r=>g(r))?n=i:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",i)}catch(i){this.k.error(i)}if(n)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify(n)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",o.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(i){if((0,y.toFileOperationResult)(i)===3)this.k.info("Migration from old default profile location to new location is done by another window",o.toString(),this.i.defaultProfile.extensionsResource.toString());else throw i}try{await this.h.del(o)}catch(i){(0,y.toFileOperationResult)(i)!==1&&this.k.error(i)}return n})()),this.p}s(o){let t=this.g.get(o);return t||(t=new L.Queue,this.g.set(o,t)),t}};c=me([_(0,y.IFileService),_(1,S.IUserDataProfilesService),_(2,v.IUriIdentityService),_(3,m.ILogService)],c),e.ExtensionsProfileScannerService=c;function g(h){return(0,O.isObject)(h)&&(0,u.isIExtensionIdentifier)(h.identifier)&&(E(h.location)||(0,O.isString)(h.location))&&h.version&&(0,O.isString)(h.version)}function E(h){return h?(0,O.isString)(h.path)&&(0,O.isString)(h.scheme):!1}}),define(Z[48],Q([0,1,19,4,29,15,10,50,77,2,16,14,12,17,39,53,3,11,90,18,24,27,45,13,8,9,26,5,44,42,25,28,106,107]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S,v,O,w,c,g,E,h,o,t,n,i,r,s,l,a,f,D,C,x,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(he){function B(j,A){if(j===A)return!0;const z=Object.keys(j),$=new Set;for(const q of Object.keys(A))$.add(q);if(z.length!==$.size)return!1;for(const q of z){if(j[q]!==A[q])return!1;$.delete(q)}return $.size===0}he.equals=B})(X=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let ie=class extends u.Disposable{constructor(B,j,A,z,$,q,K,I,P,M,F,V){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=j,this.l=A,this.m=z,this.n=$,this.p=q,this.r=K,this.s=I,this.t=P,this.u=M,this.v=F,this.w=V,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,S.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(pe,(0,S.joinPath)(this.m,o.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(pe,(0,S.joinPath)(this.m,o.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ee,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,h.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(B,j,A){const[z,$]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(j)]),q=A?await this.scanExtensionsUnderDevelopment(B,[...z,...$]):[];return this.D(z,$,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const j=[];j.push(this.F(!!B.useCache,B.language)),j.push(this.G(B.language,!!B.checkControlFile));const[A,z]=await Promise.all(j);return this.C([...A,...z],0,B,!1)}async scanUserExtensions(B){const j=B.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const A=await this.I(j,!!B.profileLocation,1,!B.includeUninstalled,B.language);let $=await(B.useCache&&!A.devMode&&A.excludeObsolete?this.j:this.k).scanExtensions(A);return $=await this.C($,1,B,!0),this.s.trace("Scanned user extensions:",$.length),$}async scanExtensionsUnderDevelopment(B,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const A=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(z=>z.scheme===y.Schemas.file).map(async z=>{const $=await this.I(z,!1,1,!0,B.language,!1);return(await this.k.scanOneOrMultipleExtensions($)).map(K=>(K.type=j.find(I=>(0,h.areSameExtensions)(I.identifier,K.identifier))?.type??K.type,this.k.validate(K,$)))}))).flat();return this.C(A,"development",B,!0)}return[]}async scanExistingExtension(B,j,A){const z=await this.I(B,!1,j,!0,A.language),$=await this.k.scanExtension(z);return!$||!A.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(B,j,A){const z=await this.I(B,!1,j,!0,A.language),$=await this.k.scanOneOrMultipleExtensions(z);return this.C($,j,A,!0)}async scanMetadata(B){const j=(0,S.joinPath)(B,"package.json"),A=(await this.r.readFile(j)).value.toString();return JSON.parse(A).__metadata}async updateMetadata(B,j){const A=(0,S.joinPath)(B,"package.json"),z=(await this.r.readFile(A)).value.toString(),$=JSON.parse(z);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,$.__metadata={...$.__metadata,...j},await this.r.writeFile((0,S.joinPath)(B,"package.json"),T.VSBuffer.fromString(JSON.stringify($,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const B=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(B))return;let j=(await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource)).length>0;j||(j=await this.r.exists(this.n.defaultProfile.extensionsResource));const A=this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json");let z=(await this.p.scanProfileExtensions(A)).length>0;if(z||(z=await this.r.exists(A)),!j&&!z){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const $=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile($.map(q=>[q,q.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(B,T.VSBuffer.fromString(""))}catch($){(0,n.toFileOperationResult)($)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)($))}}catch(B){throw this.s.error(B),B}})()),this.z}async C(B,j,A,z){return A.includeAllVersions||(B=this.D(j===0?B:void 0,j===1?B:void 0,j==="development"?B:void 0,await this.getTargetPlatform(),z)),A.includeInvalid||(B=B.filter($=>$.isValid)),B.sort(($,q)=>{const K=p.basename($.location.fsPath),I=p.basename(q.location.fsPath);return K<I?-1:K>I?1:0})}D(B,j,A,z,$){const q=(I,P,M)=>{if(I.isValid&&!P.isValid)return!1;if(I.isValid===P.isValid){if($&&v.gt(I.manifest.version,P.manifest.version))return this.s.debug(`Skipping extension ${P.location.path} with lower version ${P.manifest.version} in favour of ${I.location.path} with version ${I.manifest.version}`),!1;if(v.eq(I.manifest.version,P.manifest.version)){if(I.type===0)return this.s.debug(`Skipping extension ${P.location.path} in favour of system extension ${I.location.path} with same version`),!1;if(I.targetPlatform===z)return this.s.debug(`Skipping extension ${P.location.path} from different target platform ${P.targetPlatform}`),!1}}return M?this.s.warn(`Overwriting user extension ${I.location.path} with ${P.location.path}.`):this.s.debug(`Overwriting user extension ${I.location.path} with ${P.location.path}.`),!0},K=new Map;return B?.forEach(I=>{const P=o.ExtensionIdentifier.toKey(I.identifier.id),M=K.get(P);(!M||q(M,I,!1))&&K.set(P,I)}),j?.forEach(I=>{const P=o.ExtensionIdentifier.toKey(I.identifier.id),M=K.get(P);if(!M&&B&&I.type===0){this.s.debug(`Skipping obsolete system extension ${I.location.path}.`);return}(!M||q(M,I,!1))&&K.set(P,I)}),A?.forEach(I=>{const P=o.ExtensionIdentifier.toKey(I.identifier.id),M=K.get(P);(!M||q(M,I,!0))&&K.set(P,I),K.set(P,I)}),[...K.values()]}async F(B,j){this.s.trace("Started scanning system extensions");const A=await this.I(this.systemExtensionsLocation,!1,0,!0,j),$=await(B&&!A.devMode?this.i:this.k).scanExtensions(A);return this.s.trace("Scanned system extensions:",$.length),$}async G(B,j){const A=this.t.isBuilt?[]:this.u.builtInExtensions;if(!A?.length)return[];this.s.trace("Started scanning dev system extensions");const z=j?await this.H():{},$=[],q=c.URI.file(p.normalize(p.join(y.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const I of A){const P=z[I.name]||"marketplace";switch(P){case"disabled":break;case"marketplace":$.push((0,S.joinPath)(q,I.name));break;default:$.push(c.URI.file(P));break}}const K=await Promise.all($.map(async I=>this.k.scanExtension(await this.I(I,!1,0,!0,B))));return this.s.trace("Scanned dev system extensions:",K.length),(0,L.coalesce)(K)}async H(){try{const B=await this.r.readFile(this.l);return JSON.parse(B.value.toString())}catch{return{}}}async I(B,j,A,z,$,q=!0){const K=await this.f($??m.language),I=await this.J(B),P=j&&!this.v.extUri.isEqual(B,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,M=P?await this.J(P):void 0;return new re(B,I,P,M,j,A,z,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,$,K)}async J(B){try{const j=await this.r.stat(B);if(typeof j.mtime=="number")return j.mtime}catch{}}};ie=me([_(4,D.IUserDataProfilesService),_(5,f.IExtensionsProfileScannerService),_(6,n.IFileService),_(7,r.ILogService),_(8,E.IEnvironmentService),_(9,s.IProductService),_(10,C.IUriIdentityService),_(11,i.IInstantiationService)],ie),e.AbstractExtensionsScannerService=ie;class re{constructor(B,j,A,z,$,q,K,I,P,M,F,V,G,te){this.location=B,this.mtime=j,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=z,this.profile=$,this.type=q,this.excludeObsolete=K,this.validate=I,this.productVersion=P,this.productDate=M,this.productCommit=F,this.devMode=V,this.language=G,this.translations=te}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,j){return(0,S.isEqual)(B.location,j.location)&&B.mtime===j.mtime&&(0,S.isEqual)(B.applicationExtensionslocation,j.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&B.profile===j.profile&&B.type===j.type&&B.excludeObsolete===j.excludeObsolete&&B.validate===j.validate&&B.productVersion===j.productVersion&&B.productDate===j.productDate&&B.productCommit===j.productCommit&&B.devMode===j.devMode&&B.language===j.language&&X.equals(B.translations,j.translations)}}let ee=class extends u.Disposable{constructor(B,j,A,z,$){super(),this.f=B,this.g=j,this.h=A,this.i=z,this.j=$}async scanExtensions(B){const j=B.profile?await this.l(B):await this.k(B);let A={};if(B.excludeObsolete&&B.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();A=JSON.parse(z)}catch{}return(0,w.isEmptyObject)(A)?j:j.filter(z=>!A[h.ExtensionKey.create(z).toString()])}async k(B){const j=await this.i.resolve(B.location);if(!j.children?.length)return[];const A=await Promise.all(j.children.map(async z=>{if(!z.isDirectory||B.type===1&&(0,S.basename)(z.resource).indexOf(".")===0)return null;const $=new re(z.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension($)}));return(0,L.coalesce)(A).sort((z,$)=>z.location.path<$.location.path?-1:1)}async l(B){let j=await this.m(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){j=j.filter(z=>!z.metadata?.isApplicationScoped);const A=await this.m(B.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,B);j.push(...A)}return j}async m(B,j,A){const z=await this.g.scanProfileExtensions(B);if(!z.length)return[];const $=await Promise.all(z.map(async q=>{if(j(q)){const K=new re(q.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(K,q.metadata)}return null}));return(0,L.coalesce)($)}async scanOneOrMultipleExtensions(B){try{if(await this.i.exists((0,S.joinPath)(B.location,"package.json"))){const j=await this.scanExtension(B);return j?[j]:[]}else return await this.scanExtensions(B)}catch(j){return this.j.error(`Error scanning extensions at ${B.location.path}:`,(0,N.getErrorMessage)(j)),[]}}async scanExtension(B,j){try{let A=await this.scanExtensionManifest(B.location);if(A){A.publisher||(A.publisher=o.UNDEFINED_PUBLISHER),j=j??A.__metadata,delete A.__metadata;const z=(0,h.getGalleryExtensionId)(A.publisher,A.name),$=j?.id?{id:z,uuid:j.id}:{id:z},q=j?.isSystem?0:B.type,K=q===0||!!j?.isBuiltin;Y.ImplicitActivationEvents.updateManifest(A),A=await this.n(B.location,A,re.createNlsConfiguration(B));const I={type:q,identifier:$,manifest:A,location:B.location,isBuiltin:K,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return B.validate?this.validate(I,B):I}}catch(A){B.type!==0&&this.j.error(A)}return null}validate(B,j){let A=!0;const z=(0,t.validateExtensionManifest)(j.productVersion,j.productDate,j.location,B.manifest,B.isBuiltin);for(const[$,q]of z)$===O.default.Error&&(A=!1,this.j.error(this.t(j.location,q)));return B.isValid=A,B.validations=z,B}async scanExtensionManifest(B){const j=(0,S.joinPath)(B,"package.json");let A;try{A=(await this.i.readFile(j)).value.toString()}catch($){return(0,n.toFileOperationResult)($)!==1&&this.j.error(this.t(B,(0,g.localize)(0,null,j.path,$.message))),null}let z;try{z=JSON.parse(A)}catch{const q=[];(0,b.parse)(A,q);for(const K of q)this.j.error(this.t(B,(0,g.localize)(1,null,j.path,K.offset,K.length,(0,d.getParseErrorMessage)(K.error))));return null}return(0,b.getNodeType)(z)!=="object"?(this.j.error(this.t(B,(0,g.localize)(2,null,j.path))),null):z}async n(B,j,A){const z=await this.p(B,j,A);if(z)try{const $=[],q=await this.r(z.default,$);if($.length>0)return $.forEach(I=>{this.j.error(this.t(B,(0,g.localize)(3,null,z.default?.path,(0,d.getParseErrorMessage)(I.error))))}),j;if((0,b.getNodeType)(z)!=="object")return this.j.error(this.t(B,(0,g.localize)(4,null,z.default?.path))),j;const K=z.values||Object.create(null);return(0,x.localizeManifest)(j,K,q)}catch{}return j}async p(B,j,A){const z=(0,S.joinPath)(B,"package.nls.json"),$=(P,M)=>{M.forEach(F=>{this.j.error(this.t(B,(0,g.localize)(5,null,P?.path,(0,d.getParseErrorMessage)(F.error))))})},q=P=>{this.j.error(this.t(B,(0,g.localize)(6,null,P?.path)))},K=`${j.publisher}.${j.name}`,I=A.translations[K];if(I)try{const P=c.URI.file(I),M=(await this.i.readFile(P)).value.toString(),F=[],V=(0,b.parse)(M,F);return F.length>0?($(P,F),{values:void 0,default:z}):(0,b.getNodeType)(V)!=="object"?(q(P),{values:void 0,default:z}):{values:V.contents?V.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let M;try{M=await this.s(B,A)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const F=(await this.i.readFile(M.localized)).value.toString(),V=[],G=(0,b.parse)(F,V);return V.length>0?($(M.localized,V),{values:void 0,default:M.original}):(0,b.getNodeType)(G)!=="object"?(q(M.localized),{values:void 0,default:M.original}):{values:G,default:M.original}}catch{return{values:void 0,default:M.original}}}}async r(B,j){if(B)try{const A=(await this.i.readFile(B)).value.toString();return(0,b.parse)(A,j)}catch{}}s(B,j){return new Promise((A,z)=>{const $=q=>{const K=(0,S.joinPath)(B,`package.nls.${q}.json`);this.i.exists(K).then(I=>{I&&A({localized:K,original:(0,S.joinPath)(B,"package.nls.json")});const P=q.lastIndexOf("-");P===-1?A({localized:(0,S.joinPath)(B,"package.nls.json"),original:null}):(q=q.substring(0,P),$(q))})};if(j.devMode||j.pseudo||!j.language)return A({localized:(0,S.joinPath)(B,"package.nls.json"),original:null});$(j.language)})}t(B,j){return`[${B.path}]: ${j}`}};ee=me([_(1,f.IExtensionsProfileScannerService),_(2,C.IUriIdentityService),_(3,n.IFileService),_(4,r.ILogService)],ee);let pe=class extends ee{constructor(B,j,A,z,$,q){super(j,A,z,$,q),this.y=B,this.v=this.B(new R.ThrottledDelayer(3e3)),this.w=this.B(new l.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(B){const j=await this.z();if(this.u=B,j&&j.input&&re.equals(j.input,this.u))return this.v.trigger(()=>this.D()),j.result.map(z=>(z.location=c.URI.revive(z.location),z));const A=await super.scanExtensions(B);return await this.C({input:B,result:A}),A}async z(){try{const B=await this.i.readFile(this.y),j=JSON.parse(B.value.toString());return{result:j.result,input:(0,a.revive)(j.input)}}catch(B){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,N.getErrorMessage)(B))}return null}async C(B){try{await this.i.writeFile(this.y,T.VSBuffer.fromString(JSON.stringify(B)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,N.getErrorMessage)(j))}}async D(){if(!this.u)return;const B=await this.z();if(!B)return;const j=B.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(A,j))try{await this.i.del(this.y),this.w.fire()}catch(z){this.j.error(z)}}};pe=me([_(2,f.IExtensionsProfileScannerService),_(3,C.IUriIdentityService),_(4,n.IFileService),_(5,r.ILogService)],pe);function le(he,B){const j=(0,h.getExtensionId)(he.manifest.publisher,he.manifest.name);return{id:j,identifier:new o.ExtensionIdentifier(j),isBuiltin:he.type===0,isUserBuiltin:he.type===1&&he.isBuiltin,isUnderDevelopment:B,extensionLocation:he.location,uuid:he.identifier.uuid,targetPlatform:he.targetPlatform,...he.manifest}}e.toExtensionDescription=le;class ae extends ie{constructor(B,j,A,z,$,q,K,I,P,M,F,V){super(B,j,(0,S.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,S.joinPath)(z,o.MANIFEST_CACHE_FOLDER),$,q,K,I,P,M,F,V),this.L=(async()=>{if(m.translationsConfigFile)try{const G=await this.r.readFile(c.URI.file(m.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(B){return this.L}}e.NativeExtensionsScannerService=ae}),define(Z[145],Q([0,1,57,4,34,5,2,16,14,20,9,25]),function(W,e,L,R,k,T,N,b,d,u,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends N.Disposable{constructor(v,O){super(),this.b=v,this.f=O,this.a=new R.Limiter(5)}async postUninstall(v){const O=this.g(v,"uninstall");return O&&(this.f.info(v.identifier.id,v.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(O.script,"uninstall",O.args,!0,v).then(()=>this.f.info(v.identifier.id,v.manifest.version,"Finished running post uninstall script"),w=>this.f.error(v.identifier.id,v.manifest.version,`Failed to run post uninstall script: ${w}`)))),u.Promises.rm(this.j(v)).then(void 0,w=>this.f.error("Error while removing extension storage path",w))}g(v,O){const w=`vscode:${O}`;if(v.location.scheme===b.Schemas.file&&v.manifest&&v.manifest.scripts&&typeof v.manifest.scripts[w]=="string"){const c=v.manifest.scripts[w].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(v.identifier.id,v.manifest.version,`${w} should be a node script`),null):{script:(0,d.join)(v.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(v,O,w,c,g){return new Promise((E,h)=>{const o=this.i(v,O,w,g);let t;const n=i=>{t&&(clearTimeout(t),t=null),i?h(i):E(void 0)};o.on("error",i=>{n((0,k.toErrorMessage)(i)||"Unknown")}),o.on("exit",(i,r)=>{n(i?`post-${O} process exited with code ${i}`:void 0)}),c&&(t=setTimeout(()=>{t=null,o.kill(),h("timed out")},5e3))})}i(v,O,w,c){const g={silent:!0,execArgv:void 0},E=(0,L.fork)(v,[`--type=extension-post-${O}`,...w],g);E.stdout.setEncoding("utf8"),E.stderr.setEncoding("utf8");const h=T.Event.fromNodeEventEmitter(E.stdout,"data"),o=T.Event.fromNodeEventEmitter(E.stderr,"data");h(i=>this.f.info(c.identifier.id,c.manifest.version,`post-${O}`,i)),o(i=>this.f.error(c.identifier.id,c.manifest.version,`post-${O}`,i));const t=T.Event.any(T.Event.map(h,i=>({data:`%c${i}`,format:[""]})),T.Event.map(o,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(t,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(c.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),E}j(v){return(0,d.join)(this.b.defaultProfile.globalStorageHome.fsPath,v.identifier.id.toLowerCase())}};m=me([_(0,p.IUserDataProfilesService),_(1,y.ILogService)],m),e.ExtensionsLifecycle=m}),define(Z[146],Q([0,1,11,18,42,48,13,8,9,26,28,25]),function(W,e,L,R,k,T,N,b,d,u,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends T.NativeExtensionsScannerService{constructor(v,O,w,c,g,E,h,o){super(L.URI.file(g.builtinExtensionsPath),L.URI.file(g.extensionsPath),g.userHome,L.URI.file(g.userDataPath),v,O,w,c,g,E,h,o)}};m=me([_(0,p.IUserDataProfilesService),_(1,k.IExtensionsProfileScannerService),_(2,N.IFileService),_(3,d.ILogService),_(4,R.INativeEnvironmentService),_(5,u.IProductService),_(6,y.IUriIdentityService),_(7,b.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(Z[147],Q([0,1,4,5,2,117,3,83,8,25]),function(W,e,L,R,k,T,N,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,d.createDecorator)("storageService");var y;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var p;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(p=e.StorageScope||(e.StorageScope={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function S(g){const E=g.get(e.TARGET_KEY);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}e.loadKeyTargets=S;class v extends k.Disposable{constructor(E={flushInterval:v.a}){super(),this.j=E,this.b=this.B(new R.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new R.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new L.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,L.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.J()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(E,h){if(h===e.TARGET_KEY){switch(E){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:E})}else this.b.fire({scope:E,key:h,target:this.F(E)[h]})}r(E){this.f.fire({reason:E})}get(E,h,o){return this.L(h)?.get(E,o)}getBoolean(E,h,o){return this.L(h)?.getBoolean(E,o)}getNumber(E,h,o){return this.L(h)?.getNumber(E,o)}store(E,h,o,t){if((0,N.isUndefinedOrNull)(h)){this.remove(E,o);return}this.t(()=>{this.u(E,o,t),this.L(o)?.set(E,h)})}remove(E,h){this.t(()=>{this.u(E,h,void 0),this.L(h)?.delete(E)})}t(E){this.b.pause(),this.c.pause();try{E()}finally{this.b.resume(),this.c.resume()}}keys(E,h){const o=[],t=this.F(E);for(const n of Object.keys(t))t[n]===h&&o.push(n);return o}u(E,h,o){const t=this.F(h);typeof o=="number"?t[E]!==o&&(t[E]=o,this.L(h)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[E]=="number"&&(delete t[E],this.L(h)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(E){switch(E){case-1:return this.D;case 0:return this.z;default:return this.w}}G(E){const h=this.L(E);return h?S(h):Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(E=y.NONE){this.f.fire({reason:E});const h=this.L(-1),o=this.L(0),t=this.L(1);switch(E){case y.NONE:await L.Promises.settled([h?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await L.Promises.settled([h?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const E=this.L(-1)?.items??new Map,h=this.L(0)?.items??new Map,o=this.L(1)?.items??new Map;return c(E,h,o,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(E,h){return this.r(y.NONE),(0,u.isUserDataProfile)(E)?this.N(E,h):this.O(E,h)}H(E,h){return!(E.id===h.id||O(h)&&O(E))}I(E,h,o,t){this.t(()=>{if(t)for(const[n,i]of E)h.set(n,i);else{const n=new Set;for(const[i,r]of E)n.add(i),h.get(i)!==r&&this.n(o,i);for(const[i]of h.items)n.has(i)||this.n(o,i)}})}}e.AbstractStorageService=v,v.a=60*1e3;function O(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=O;class w extends v{constructor(){super(),this.p=this.B(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(E=>this.n(1,E))),this.B(this.P.onDidChangeStorage(E=>this.n(0,E))),this.B(this.p.onDidChangeStorage(E=>this.n(-1,E)))}L(E){switch(E){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(E){switch(E){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(E){return!1}}e.InMemoryStorageService=w;async function c(g,E,h,o,t,n){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},r=new Map,s=new Map;g.forEach((Y,X)=>{r.set(X,Y),s.set(X,i(Y))});const l=new Map,a=new Map;E.forEach((Y,X)=>{l.set(X,Y),a.set(X,i(Y))});const f=new Map,D=new Map;h.forEach((Y,X)=>{f.set(X,Y),D.set(X,i(Y))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const C=[];if(r.forEach((Y,X)=>{C.push({key:X,value:Y})}),console.table(C),console.groupEnd(),console.log(s),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Y=[];l.forEach((X,ie)=>{Y.push({key:ie,value:X})}),console.table(Y),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${n})`);const x=[];f.forEach((Y,X)=>{x.push({key:X,value:Y})}),console.table(x),console.groupEnd(),console.log(D)}e.logStorage=c}),define(Z[148],Q([0,1,19,22,10,12,35,3,11,21,18,23,24,45,13,9,26,47,135,147,32]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S,v,O,w,c,g,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const o=T.isWeb?"web":(0,p.getTargetPlatform)(T.platform,N.arch);var t;(function(I){I[I.None=0]="None",I[I.IncludeVersions=1]="IncludeVersions",I[I.IncludeFiles=2]="IncludeFiles",I[I.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",I[I.IncludeSharedAccounts=8]="IncludeSharedAccounts",I[I.IncludeVersionProperties=16]="IncludeVersionProperties",I[I.ExcludeNonValidated=32]="ExcludeNonValidated",I[I.IncludeInstallationTargets=64]="IncludeInstallationTargets",I[I.IncludeAssetUri=128]="IncludeAssetUri",I[I.IncludeStatistics=256]="IncludeStatistics",I[I.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",I[I.Unpublished=4096]="Unpublished",I[I.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...I){return String(I.reduce((P,M)=>P|M,0))}var i;(function(I){I[I.Tag=1]="Tag",I[I.ExtensionId=4]="ExtensionId",I[I.Category=5]="Category",I[I.ExtensionName=7]="ExtensionName",I[I.Target=8]="Target",I[I.Featured=9]="Featured",I[I.SearchText=10]="SearchText",I[I.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class f{constructor(P=a){this.d=P}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(P,M=this.d.pageSize){return new f({...this.d,pageNumber:P,pageSize:M})}withFilter(P,...M){const F=[...this.d.criteria,...M.length?M.map(V=>({filterType:P,value:V})):[{filterType:P}]];return new f({...this.d,criteria:F})}withSortBy(P){return new f({...this.d,sortBy:P})}withSortOrder(P){return new f({...this.d,sortOrder:P})}withFlags(...P){return new f({...this.d,flags:P.reduce((M,F)=>M|F,0)})}withAssetTypes(...P){return new f({...this.d,assetTypes:P})}withSource(P){return new f({...this.d,source:P})}get raw(){const{criteria:P,pageNumber:M,pageSize:F,sortBy:V,sortOrder:G,flags:te,assetTypes:ne}=this.d;return{filters:[{criteria:P,pageNumber:M,pageSize:F,sortBy:V,sortOrder:G}],assetTypes:ne,flags:te}}get searchText(){const P=this.d.criteria.filter(M=>M.filterType===i.SearchText)[0];return P&&P.value?P.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(P=>String(P.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function D(I,P){const M=(I||[]).filter(F=>F.statisticName===P)[0];return M?M.value:0}function C(I){const P="Microsoft.VisualStudio.Code.Translation.";return I.files.filter(F=>F.assetType.indexOf(P)===0).reduce((F,V)=>{const G=X(I,V.assetType);return G&&F.push([V.assetType.substring(P.length),G]),F},[])}function x(I){if(I.properties){const P=I.properties.filter(V=>V.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=P.filter(V=>M.test(V.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return X(I,r.Repository)}function Y(I){return{uri:`${I.fallbackAssetUri}/${r.VSIX}?redirect=true${I.targetPlatform?`&targetPlatform=${I.targetPlatform}`:""}`,fallbackUri:`${I.fallbackAssetUri}/${r.VSIX}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`}}function X(I,P){return I.files.filter(F=>F.assetType===P)[0]?{uri:`${I.assetUri}/${P}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`,fallbackUri:`${I.fallbackAssetUri}/${P}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`}:null}function ie(I,P){const M=I.properties?I.properties.filter(V=>V.key===P):[],F=M.length>0&&M[0].value;return F?F.split(",").map(V=>(0,m.adoptToGalleryExtensionId)(V)):[]}function re(I){const P=I.properties?I.properties.filter(M=>M.key===s.Engine):[];return P.length>0&&P[0].value||""}function ee(I){const P=I.properties?I.properties.filter(M=>M.key===s.PreRelease):[];return P.length>0&&P[0].value==="true"}function pe(I){const P=I.properties?I.properties.filter(F=>F.key===s.LocalizedLanguages):[],M=P.length>0&&P[0].value||"";return M?M.split(","):[]}function le(I){return I.properties?.find(P=>P.key===s.SponsorLink)?.value}function ae(I){return I.indexOf("preview")!==-1}function he(I){return I.targetPlatform?(0,p.toTargetPlatform)(I.targetPlatform):"undefined"}function B(I){const P=(0,L.distinct)(I.versions.map(he)),M=!!I.tags?.includes(p.WEB_EXTENSION_TAG),F=P.indexOf("web");return M?F===-1&&P.push("web"):F!==-1&&P.splice(F,1),P}function j(I,P){const M=(0,p.getFallbackTargetPlarforms)(P);for(let F=0;F<I.length;F++){const V=I[F];if(V.version===I[F-1]?.version){let G=F;const te=he(V);if(te===P)for(;G>0&&I[G-1].version===V.version;)G--;else if(M.includes(te))for(;G>0&&I[G-1].version===V.version&&he(I[G-1])!==P;)G--;G!==F&&(I.splice(F,1),I.splice(G,0,V))}}return I}e.sortExtensionVersions=j;function A(I,P,M){I.telemetryData={index:P,querySource:M}}function z(I,P,M){const F=I.versions[0],V={manifest:X(P,r.Manifest),readme:X(P,r.Details),changelog:X(P,r.Changelog),license:X(P,r.License),repository:x(P),download:Y(P),icon:X(P,r.Icon),signature:X(P,r.Signature),coreTranslations:C(P)};return{identifier:{id:(0,m.getGalleryExtensionId)(I.publisher.publisherName,I.extensionName),uuid:I.extensionId},name:I.extensionName,version:P.version,displayName:I.displayName,publisherId:I.publisher.publisherId,publisher:I.publisher.publisherName,publisherDisplayName:I.publisher.displayName,publisherDomain:I.publisher.domain?{link:I.publisher.domain,verified:!!I.publisher.isDomainVerified}:void 0,publisherSponsorLink:le(F),description:I.shortDescription||"",installCount:D(I.statistics,"install"),rating:D(I.statistics,"averagerating"),ratingCount:D(I.statistics,"ratingcount"),categories:I.categories||[],tags:I.tags||[],releaseDate:Date.parse(I.releaseDate),lastUpdated:Date.parse(I.lastUpdated),allTargetPlatforms:M,assets:V,properties:{dependencies:ie(P,s.Dependency),extensionPack:ie(P,s.ExtensionPack),engine:re(P),localizedLanguages:pe(P),targetPlatform:he(P),isPreReleaseVersion:ee(P)},hasPreReleaseVersion:ee(F),hasReleaseVersion:!0,preview:ae(I.flags),isSigned:!!V.signature}}let $=class{constructor(P,M,F,V,G,te,ne,ge){this.k=M,this.l=F,this.n=V,this.o=G,this.q=te,this.u=ne,this.w=ge;const ye=ne.extensionsGallery,ue=ye?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=ue?ye.servicePPEUrl:ye?.serviceUrl,this.g=ue?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,g.resolveMarketplaceHeaders)(ne.version,ne,this.n,this.w,this.q,P,this.o)}x(P=""){return`${this.d}${P}`}isEnabled(){return!!this.d}async getExtensions(P,M,F){const V=R.CancellationToken.isCancellationToken(M)?{}:M,G=R.CancellationToken.isCancellationToken(M)?M:F,te=[],ne=[],ge=[],ye=[];let ue=!0;for(const se of P){se.uuid?ne.push(se.uuid):te.push(se.id);const fe=!!(se.version||se.preRelease);ge.push({id:se.id,uuid:se.uuid,includePreRelease:fe}),se.version&&ye.push({id:se.id,uuid:se.uuid,version:se.version}),ue=ue&&!!se.hasPreRelease&&!fe}if(!ne.length&&!te.length)return[];let ce=new f().withPage(1,P.length);ne.length&&(ce=ce.withFilter(i.ExtensionId,...ne)),te.length&&(ce=ce.withFilter(i.ExtensionName,...te)),(V.queryAllVersions||ue)&&(ce=ce.withFlags(ce.flags,t.IncludeVersions)),V.source&&(ce=ce.withSource(V.source));const{extensions:oe}=await this.z(ce,{targetPlatform:V.targetPlatform??o,includePreRelease:ge,versions:ye,compatible:!!V.compatible},G);return V.source&&oe.forEach((se,fe)=>A(se,fe,V.source)),oe}async getCompatibleExtension(P,M,F){if((0,p.isNotWebExtensionInWebTargetPlatform)(P.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(P,M,F))return P;const V=new f().withFlags(t.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,P.identifier.uuid),{extensions:G}=await this.z(V,{targetPlatform:F,compatible:!0,includePreRelease:M},R.CancellationToken.None);return G[0]||null}async isExtensionCompatible(P,M,F){if(!(0,p.isTargetPlatformCompatible)(P.properties.targetPlatform,P.allTargetPlatforms,F)||!M&&P.properties.isPreReleaseVersion)return!1;let V=P.properties.engine;if(!V){const G=await this.getManifest(P,R.CancellationToken.None);if(!G)throw new Error("Manifest was not found");V=G.engines.vscode}return(0,S.isEngineValid)(V,this.u.version,this.u.date)}async y(P,M,F,V,G){if(!(0,p.isTargetPlatformCompatible)(he(P),V,G)||M!=="any"&&ee(P)!==(M==="prerelease"))return!1;if(F)try{const te=await this.E(P);if(!(0,S.isEngineValid)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${P.version}.`,(0,k.getErrorMessage)(te)),!1}return!0}async query(P,M){let F=P.text||"";const V=P.pageSize??50;let G=new f().withPage(1,V);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ce,oe)=>(G=G.withFilter(i.Category,oe||ce),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ce,oe)=>(G=G.withFilter(i.Tag,oe||ce),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(i.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),G=G.withFilter(i.SearchText,F)),G=G.withSortBy(0)):P.ids?G=G.withFilter(i.ExtensionId,...P.ids):P.names?G=G.withFilter(i.ExtensionName,...P.names):G=G.withSortBy(4),typeof P.sortBy=="number"&&(G=G.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(G=G.withSortOrder(P.sortOrder)),P.source&&(G=G.withSource(P.source));const te=async(ue,ce)=>{const{extensions:oe,total:se}=await this.z(ue,{targetPlatform:o,compatible:!1,includePreRelease:!!P.includePreRelease},ce);return oe.forEach((fe,Te)=>A(fe,(ue.pageNumber-1)*ue.pageSize+Te,P.source)),{extensions:oe,total:se}},{extensions:ne,total:ge}=await te(G,M),ye=async(ue,ce)=>{if(ce.isCancellationRequested)throw new k.CancellationError;const{extensions:oe}=await te(G.withPage(ue+1),ce);return oe};return{firstPage:ne,total:ge,pageSize:G.pageSize,getPage:ye}}async z(P,M,F){const V=P.flags;!!(P.flags&t.IncludeLatestVersionOnly)&&!!(P.flags&t.IncludeVersions)&&(P=P.withFlags(P.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(P.flags&t.IncludeLatestVersionOnly)&&!(P.flags&t.IncludeVersions)&&(P=P.withFlags(P.flags,t.IncludeLatestVersionOnly)),M.versions?.length&&(P=P.withFlags(P.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),P=P.withFlags(P.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:G,total:te}=await this.B(P,F);if(!(P.flags&t.IncludeLatestVersionOnly)){const ue=[];for(const ce of G){const oe=await this.A(ce,M);oe&&ue.push(oe)}return{extensions:ue,total:te}}const ge=[],ye=new Map;for(let ue=0;ue<G.length;ue++){const ce=G[ue],oe={id:(0,m.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},se=(0,b.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Te=>(0,m.areSameExtensions)(Te,oe))?.includePreRelease;if(M.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(B(ce),M.targetPlatform))continue;const fe=await this.A(ce,M);!fe||fe.properties.isPreReleaseVersion&&(!se||!fe.hasReleaseVersion)||!fe.properties.isPreReleaseVersion&&fe.properties.targetPlatform!==M.targetPlatform&&fe.hasPreReleaseVersion?ye.set(ce.extensionId,ue):ge.push([ue,fe])}if(ye.size){const ue=new Date().getTime(),ce=new f().withFlags(V&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ye.size).withFilter(i.ExtensionId,...ye.keys()),{extensions:oe}=await this.z(ce,M,F);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:ye.size});for(const se of oe){const fe=ye.get(se.identifier.uuid);ge.push([fe,se])}}return{extensions:ge.sort((ue,ce)=>ue[0]-ce[0]).map(([,ue])=>ue),total:te}}async A(P,M){const F={id:(0,m.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},V=M.versions?.find(ge=>(0,m.areSameExtensions)(ge,F))?.version,G=(0,b.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(ge=>(0,m.areSameExtensions)(ge,F))?.includePreRelease,te=B(P),ne=j(P.versions,M.targetPlatform);if(M.compatible&&(0,p.isNotWebExtensionInWebTargetPlatform)(te,M.targetPlatform))return null;for(let ge=0;ge<ne.length;ge++){const ye=ne[ge];if(!(V&&ye.version!==V)){if(await this.y(ye,G?"any":"release",M.compatible,te,M.targetPlatform))return z(P,ye,te);if(V&&ye.version===V)return null}}return V||M.compatible?null:z(P,P.versions[0],te)}async B(P,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");P=P.withFlags(P.flags,t.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(t.Unpublished));const F=await this.j,V=JSON.stringify(P.raw),G={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)},te=new Date().getTime();let ne,ge,ye=0;try{if(ne=await this.k.request({type:"POST",url:this.g&&P.criteria.some(ce=>ce.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:V,headers:G},M),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:ye};const ue=await(0,c.asJson)(ne);if(ue){const ce=ue.results[0],oe=ce.extensions,se=ce.resultMetadata&&ce.resultMetadata.filter(fe=>fe.metadataType==="ResultCount")[0];return ye=se&&se.metadataItems.filter(fe=>fe.name==="TotalCount")[0].count||0,{galleryExtensions:oe,total:ye}}return{galleryExtensions:[],total:ye}}catch(ue){throw ge=ue,ue}finally{this.o.publicLog2("galleryService:query",{...P.telemetryData,requestBodySize:String(V.length),duration:new Date().getTime()-te,success:!!ne&&(0,c.isSuccess)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:ge?(0,k.isCancellationError)(ge)?"canceled":(0,k.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(P,M,F,V){if(!this.isEnabled())return;const G=T.isWeb?this.x(`/itemName/${P}.${M}/version/${F}/statType/${V==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${P}/extensions/${M}/${F}/stats?statType=${V}`),te=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:G,headers:ge},R.CancellationToken.None)}catch{}}async download(P,M,F){this.l.trace("ExtensionGalleryService#download",P.identifier.id);const V=(0,m.getGalleryExtensionTelemetryData)(P),G=new Date().getTime(),te=ue=>this.o.publicLog("galleryService:downloadVSIX",{...V,duration:ue}),ne=F===2?"install":F===3?"update":"",ge=ne?{uri:`${P.assets.download.uri}${d.URI.parse(P.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${P.assets.download.fallbackUri}${d.URI.parse(P.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:P.assets.download,ye=await this.D(ge);await this.q.writeFile(M,ye.stream),te(new Date().getTime()-G)}async downloadSignatureArchive(P,M){if(!P.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",P.identifier.id);const F=await this.D(P.assets.signature);await this.q.writeFile(M,F.stream)}async getReadme(P,M){if(P.assets.readme){const F=await this.D(P.assets.readme,{},M);return await(0,c.asTextOrError)(F)||""}return""}async getManifest(P,M){if(P.assets.manifest){const F=await this.D(P.assets.manifest,{},M),V=await(0,c.asTextOrError)(F);return V?JSON.parse(V):null}return null}async C(P,M){const F=X(P,r.Manifest);if(!F)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},G=await this.D(F,{headers:V});return await(0,c.asJson)(G)}async getCoreTranslation(P,M){const F=P.assets.coreTranslations.filter(V=>V[0]===M.toUpperCase())[0];if(F){const V=await this.D(F[1]),G=await(0,c.asTextOrError)(V);return G?JSON.parse(G):null}return null}async getChangelog(P,M){if(P.assets.changelog){const F=await this.D(P.assets.changelog,{},M);return await(0,c.asTextOrError)(F)||""}return""}async getAllCompatibleVersions(P,M,F){let V=new f().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);P.identifier.uuid?V=V.withFilter(i.ExtensionId,P.identifier.uuid):V=V.withFilter(i.ExtensionName,P.identifier.id);const{galleryExtensions:G}=await this.B(V,R.CancellationToken.None);if(!G.length)return[];const te=B(G[0]);if((0,p.isNotWebExtensionInWebTargetPlatform)(te,F))return[];const ne=[];await Promise.all(G[0].versions.map(async ue=>{try{await this.y(ue,M?"any":"release",!0,te,F)&&ne.push(ue)}catch{}}));const ge=[],ye=new Set;for(const ue of j(ne,F))ye.has(ue.version)||(ye.add(ue.version),ge.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:ee(ue)}));return ge}async D(P,M={},F=R.CancellationToken.None){const V=await this.j,G={type:"GET"},te={...V,...M.headers||{}};M={...M,...G,headers:te};const ne=P.uri,ge=P.fallbackUri,ye={...M,url:ne};try{const ue=await this.k.request(ye,F);if(ue.res.statusCode===200)return ue;const ce=await(0,c.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ce}`)}catch(ue){if((0,k.isCancellationError)(ue))throw ue;const ce=(0,k.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:ne,message:ce});const oe={...M,url:ge};return this.k.request(oe,F)}}async E(P){let M=re(P);if(!M){const F=await this.C(P,R.CancellationToken.None);if(!F)throw new Error("Manifest was not found");M=F.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const P=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(P.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,c.asJson)(P),F=[],V={};if(M){for(const G of M.malicious)F.push({id:G});if(M.migrateToPreRelease)for(const[G,te]of Object.entries(M.migrateToPreRelease))(!te.engine||(0,S.isEngineValid)(te.engine,this.u.version,this.u.date))&&(V[G.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[G,te]of Object.entries(M.deprecated))te&&(V[G.toLowerCase()]=(0,b.isBoolean)(te)?{}:te)}return{malicious:F,deprecated:V}}};$=me([_(1,c.IRequestService),_(2,O.ILogService),_(3,y.IEnvironmentService),_(4,h.ITelemetryService),_(5,v.IFileService),_(6,w.IProductService),_(7,u.IConfigurationService)],$);let q=class extends ${constructor(P,M,F,V,G,te,ne,ge){super(P,M,F,V,G,te,ne,ge)}};q=me([_(0,E.IStorageService),_(1,c.IRequestService),_(2,O.ILogService),_(3,y.IEnvironmentService),_(4,h.ITelemetryService),_(5,v.IFileService),_(6,w.IProductService),_(7,u.IConfigurationService)],q),e.ExtensionGalleryService=q;let K=class extends ${constructor(P,M,F,V,G,te,ne){super(void 0,P,M,F,V,G,te,ne)}};K=me([_(0,c.IRequestService),_(1,O.ILogService),_(2,y.IEnvironmentService),_(3,h.ITelemetryService),_(4,v.IFileService),_(5,w.IProductService),_(6,u.IConfigurationService)],K),e.ExtensionGalleryServiceWithNoStorageService=K}),define(Z[149],Q([0,1,44,11,18,13,9,67,28,25]),function(W,e,L,R,k,T,N,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let y=class extends u.UserDataProfilesService{constructor(S,v,O,w){super(v,O,S,w),this.a=v}M(){return this.r.extUri.joinPath(R.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y=me([_(0,d.IUriIdentityService),_(1,k.INativeEnvironmentService),_(2,T.IFileService),_(3,N.ILogService)],y),e.ServerUserDataProfilesService=y;let p=class $e extends y{constructor(S,v,O,w,c){super(v,O,w,c),this.O=S}H(){return(0,L.revive)(this.O.getItem($e.b,[]))}J(){return(0,L.revive)(this.O.getItem($e.c,{}))}M(){return this.r.extUri.joinPath(R.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p=me([_(0,b.IStateService),_(1,d.IUriIdentityService),_(2,k.INativeEnvironmentService),_(3,T.IFileService),_(4,N.ILogService)],p),e.UserDataProfilesService=p}),define(Z[150],Q([0,1,38,4,163,2,9]),function(W,e,L,R,k,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let b=class extends L.AbstractPolicyService{constructor(u,y){super(),this.j=u,this.k=y,this.a=new R.Throttler,this.b=this.B(new T.MutableDisposable)}async i(u){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`),await this.a.queue(()=>new Promise((y,p)=>{try{this.b.value=(0,k.createWatcher)(this.k,u,m=>{this.m(m),y()})}catch(m){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),p(m)}}))}m(u){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const y in u){const p=u[y];p===void 0?this.g.delete(y):this.g.set(y,p)}this.h.fire(Object.keys(u))}};b=me([_(0,N.ILogService)],b),e.NativePolicyService=b}),define(Z[69],Q([0,1,119,4,14,3,20,84,164,165]),function(W,e,L,R,k,T,N,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class y extends Error{constructor(t,n){let i=n.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=n}}e.ExtractError=y;function p(o){const t=o.externalFileAttributes>>16||33188;return[448,56,7].map(n=>t&n).reduce((n,i)=>n+i,t&61440)}function m(o){if(o instanceof y)return o;let t;return/end of central directory record signature not found/.test(o.message)&&(t="CorruptZip"),new y(t,o)}function S(o,t,n,i,r,s){const l=k.dirname(t),a=k.join(i,l);if(!a.startsWith(i))return Promise.reject(new Error(b.localize(0,null,t)));const f=k.join(i,t);let D;return s.onCancellationRequested(()=>{D?.destroy()}),Promise.resolve(N.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((C,x)=>{if(!s.isCancellationRequested)try{D=(0,L.createWriteStream)(f,{mode:n}),D.once("close",()=>C()),D.once("error",x),o.once("error",x),o.pipe(D)}catch(Y){x(Y)}}))}function v(o,t,n,i){let r=(0,R.createCancelablePromise)(()=>Promise.resolve()),s=0;return i.onCancellationRequested(()=>{r.cancel(),o.close()}),new Promise((l,a)=>{const f=new R.Sequencer,D=C=>{C.isCancellationRequested||(s++,o.readEntry())};o.once("error",a),o.once("close",()=>r.then(()=>{i.isCancellationRequested||o.entryCount===s?l():a(new y("Incomplete",new Error(b.localize(1,null,s,o.entryCount))))},a)),o.readEntry(),o.on("entry",C=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(C.fileName)){D(i);return}const x=C.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(x)){const ie=k.join(t,x);r=(0,R.createCancelablePromise)(re=>N.Promises.mkdir(ie,{recursive:!0}).then(()=>D(re)).then(void 0,a));return}const Y=w(o,C),X=p(C);r=(0,R.createCancelablePromise)(ie=>f.queue(()=>Y.then(re=>S(re,x,X,t,n,ie).then(()=>D(ie)))).then(null,a))})})}function O(o,t=!1){return new Promise((n,i)=>{(0,d.open)(o,t?{lazyEntries:!0}:void 0,(r,s)=>{r?i(m(r)):n((0,T.assertIsDefined)(s))})})}function w(o,t){return new Promise((n,i)=>{o.openReadStream(t,(r,s)=>{r?i(m(r)):n((0,T.assertIsDefined)(s))})})}function c(o,t){return new Promise((n,i)=>{const r=new u.ZipFile;t.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const s=(0,L.createWriteStream)(o);r.outputStream.pipe(s),r.outputStream.once("error",i),s.once("error",i),s.once("finish",()=>n(o))})}e.zip=c;function g(o,t,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let s=O(o,!0);return n.overwrite&&(s=s.then(l=>N.Promises.rm(t).then(()=>l))),s.then(l=>v(l,t,{sourcePathRegex:r},i))}e.extract=g;function E(o,t){return O(o).then(n=>new Promise((i,r)=>{n.on("entry",s=>{s.fileName===t&&w(n,s).then(l=>i(l),l=>r(l))}),n.once("close",()=>r(new Error(b.localize(2,null,t))))}))}function h(o,t){return E(o,t).then(n=>new Promise((i,r)=>{const s=[];n.once("error",r),n.on("data",l=>s.push(l)),n.on("end",()=>i(Buffer.concat(s)))}))}e.buffer=h}),define(Z[151],Q([0,1,69,92]),function(W,e,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(T){return(0,L.buffer)(T,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.getManifest=k}),define(Z[152],Q([0,1,4,22,34,10,5,2,36,16,14,12,17,39,3,11,30,20,69,91,58,18,144,23,24,42,48,126,145,151,127,128,27,45,13,8,9,26,32,28,25]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S,v,O,w,c,g,E,h,o,t,n,i,r,s,l,a,f,D,C,x,Y,X,ie,re,ee,pe,le,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ie.refineServiceDecorator)(n.IExtensionManagementService);let he=class extends t.AbstractExtensionManagementService{constructor(I,P,M,F,V,G,te,ne,ge,ye,ue,ce){super(I,P,M,ye,ce),this.Y=V,this.Z=G,this.ab=te,this.bb=ge,this.cb=ue,this.X=new Map,this.kb=new d.ResourceSet;const oe=this.B(ne.createInstance(a.ExtensionsLifecycle));this.S=this.B(ne.createInstance(B,fe=>oe.postUninstall(fe))),this.U=this.B(new D.ExtensionsManifestCache(F,this)),this.W=this.B(ne.createInstance(l.ExtensionsDownloader,this.getTargetPlatform()));const se=this.B(new C.ExtensionsWatcher(this,this.Y,ce,G,ue,ge,M));this.B(se.onDidChangeExtensionsByAnotherSource(fe=>this.jb(fe))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,i.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(I){this.v.trace("ExtensionManagementService#zip",I.identifier.id);const P=await this.ib(I),M=await(0,g.zip)((0,m.joinPath)(this.W.extensionsDownloadDir,(0,w.generateUuid)()).fsPath,P);return O.URI.file(M)}async unzip(I){return this.v.trace("ExtensionManagementService#unzip",I.toString()),(await this.install(I)).identifier}async getManifest(I){const{location:P,cleanup:M}=await this.eb(I),F=y.resolve(P.fsPath);try{return await(0,f.getManifest)(F)}finally{await M()}}getInstalled(I,P){return this.S.scanExtensions(I??null,P)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(I,P={}){this.v.trace("ExtensionManagementService#install",I.toString());const{location:M,cleanup:F}=await this.eb(I);try{const V=await(0,f.getManifest)(y.resolve(M.fsPath));if(V.engines&&V.engines.vscode&&!(0,Y.isEngineValid)(V.engines.vscode,this.w.version,this.w.date))throw new Error(E.localize(0,null,(0,i.getGalleryExtensionId)(V.publisher,V.name),this.w.version));return await this.z(V,M,P)}finally{await F()}}async installFromLocation(I,P){this.v.trace("ExtensionManagementService#installFromLocation",I.toString());const M=await this.S.scanUserExtensionAtLocation(I);if(!M)throw new Error(`Cannot find a valid extension from the location ${I.toString()}`);return await this.nb([M],P),this.v.info("Successfully installed extension",M.identifier.id,P.toString()),M}getMetadata(I){return this.Y.scanMetadata(I.location)}async updateMetadata(I,P){this.v.trace("ExtensionManagementService#updateMetadata",I.identifier.id);const M={...P};return P.isPreReleaseVersion&&(M.preRelease=!0),I=await this.S.updateMetadata(I,M),this.U.invalidate(),I}async updateExtensionScope(I,P){return this.v.trace("ExtensionManagementService#updateExtensionScope",I.identifier.id),I=await this.S.updateMetadata(I,{isMachineScoped:P}),this.U.invalidate(),I}async reinstallFromGallery(I){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",I.identifier.id),!this.t.isEnabled())throw new Error(E.localize(1,null));const P=await this.getTargetPlatform(),[M]=await this.t.getExtensions([{...I.identifier,preRelease:I.preRelease}],{targetPlatform:P,compatible:!0},R.CancellationToken.None);if(!M)throw new Error(E.localize(2,null));await this.S.setUninstalled(I);try{await this.S.removeUninstalledExtension(I)}catch(F){throw new Error(E.localize(3,null,(0,k.toErrorMessage)(F)))}await this.installFromGallery(M)}markAsUninstalled(...I){return this.S.setUninstalled(...I)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(I,P){const{location:M}=await this.W.download(I,P);return M}async eb(I){if(I.scheme===u.Schemas.file)return{location:I,async cleanup(){}};this.v.trace("Downloading extension from",I.toString());const P=(0,m.joinPath)(this.W.extensionsDownloadDir,(0,w.generateUuid)());return await this.ab.download(I,P),this.v.info("Downloaded extension to",P.toString()),{location:P,cleanup:async()=>{try{await this.bb.del(P)}catch(F){this.v.error(F)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(I,P,M){let F;if(O.URI.isUri(P))F=new z(I,P,M,this.t,this.S,this.v);else{const V=i.ExtensionKey.create(P).toString();F=this.X.get(V),F||(this.X.set(V,F=new A(I,P,M,this.W,this.S,this.v)),F.waitUntilTaskIsFinished().then(()=>this.X.delete(V)))}return new $(F,M.profileLocation,this.Z)}R(I,P){return new q(I,P.profileLocation,this.Z)}async ib(I){const P=async F=>{let V=await c.Promises.readdir(F);V=V.map(ne=>y.join(F,ne));const G=await Promise.all(V.map(ne=>c.Promises.stat(ne)));let te=Promise.resolve([]);return G.forEach((ne,ge)=>{const ye=V[ge];ne.isFile()&&(te=te.then(ue=>[...ue,ye])),ne.isDirectory()&&(te=te.then(ue=>P(ye).then(ce=>[...ue,...ce])))}),te};return(await P(I.location.fsPath)).map(F=>({path:`extension/${y.relative(I.location.fsPath,F)}`,localPath:F}))}async jb({added:I,removed:P}){if(P)for(const M of P.extensions)this.v.info("Extensions removed from another source",M.id,P.profileLocation.toString()),this.p.fire({identifier:M,profileLocation:P.profileLocation});if(I){const F=(await this.S.scanExtensions(1,I.profileLocation)).filter(V=>I.extensions.some(G=>(0,i.areSameExtensions)(G,V.identifier)));this.m.fire(F.map(V=>(this.v.info("Extensions added from another source",V.identifier.id,I.profileLocation.toString()),{identifier:V.identifier,local:V,profileLocation:I.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(P=>this.kb.add(P)));const I=await this.bb.resolve(this.Y.userExtensionsLocation);for(const P of I.children??[])P.isDirectory&&this.kb.add(P.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(P=>this.mb(P)))}async mb(I){const P=[];for(const M of I.rawAdded){if(this.kb.has(M)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(M),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(M,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(M).startsWith(".")||!(await this.bb.stat(M)).isDirectory)continue;const F=await this.S.scanUserExtensionAtLocation(M);F&&F.installedTimestamp===void 0&&(this.kb.add(M),P.push(F))}P.length&&(await this.nb(P,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",P.map(M=>M.identifier.id)))}async nb(I,P){await this.Z.addExtensionsToProfile(I.map(M=>[M,void 0]),P),this.m.fire(I.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:P})))}};he=me([_(0,n.IExtensionGalleryService),_(1,pe.ITelemetryService),_(2,re.ILogService),_(3,o.INativeEnvironmentService),_(4,s.IExtensionsScannerService),_(5,r.IExtensionsProfileScannerService),_(6,h.IDownloadService),_(7,ie.IInstantiationService),_(8,X.IFileService),_(9,ee.IProductService),_(10,le.IUriIdentityService),_(11,ae.IUserDataProfilesService)],he),e.ExtensionManagementService=he;let B=class extends b.Disposable{constructor(I,P,M,F){super(),this.j=I,this.k=P,this.l=M,this.m=F,this.h=this.B(new N.Emitter),this.onExtract=this.h.event,this.c=(0,m.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new L.Queue}async cleanUp(){await this.v()}async scanExtensions(I,P){await this.l.initializeDefaultProfileExtensions();const M={includeInvalid:!0,profileLocation:P};let F=[];return I===null||I===0?F.push(...await this.l.scanAllExtensions({includeInvalid:!0},M,!1)):I===1&&F.push(...await this.l.scanUserExtensions(M)),F=I!==null?F.filter(V=>V.type===I):F,Promise.all(F.map(V=>this.u(V)))}async scanAllUserExtensions(I){const P=await this.l.scanUserExtensions({includeAllVersions:!I,includeInvalid:!0});return Promise.all(P.map(M=>this.u(M)))}async scanUserExtensionAtLocation(I){try{const P=await this.l.scanExistingExtension(I,1,{includeInvalid:!0});if(P)return await this.u(P)}catch(P){this.m.error(P)}return null}async extractUserExtension(I,P,M,F){await this.l.initializeDefaultProfileExtensions();const V=I.toString(),G=y.join(this.l.userExtensionsLocation.fsPath,`.${(0,w.generateUuid)()}`),te=y.join(this.l.userExtensionsLocation.fsPath,V);try{await c.Promises.rm(te)}catch{throw new n.ExtensionManagementError(E.localize(4,null,te,I.id),n.ExtensionManagementErrorCode.Delete)}await this.p(I,P,G,F),await this.l.updateMetadata(O.URI.file(G),M);try{this.h.fire(O.URI.file(te)),await this.s(I,G,te,Date.now()+2*60*1e3),this.m.info("Renamed to",te)}catch(ne){try{await c.Promises.rm(G)}catch{}if(ne.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",I.id);else throw this.m.info(`Rename failed because of ${(0,T.getErrorMessage)(ne)}. Deleted from extracted location`,G),ne}return this.t(O.URI.file(te),1)}async updateMetadata(I,P){return await this.l.updateMetadata(I.location,P),this.t(I.location,I.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...I){const P=I.map(M=>i.ExtensionKey.create(M));await this.n(M=>P.forEach(F=>{M[F.toString()]=!0,this.m.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(I){await this.n(F=>delete F[I.toString()]);const M=(await this.scanAllUserExtensions(!0)).find(F=>i.ExtensionKey.create(F).equals(I))||null;return M?this.updateMetadata(M,{installedTimestamp:Date.now()}):null}async removeExtension(I,P){this.m.trace(`Deleting ${P} extension from disk`,I.identifier.id,I.location.fsPath),await c.Promises.rm(I.location.fsPath),this.m.info("Deleted from disk",I.identifier.id,I.location.fsPath)}async removeUninstalledExtension(I){await this.removeExtension(I,"uninstalled"),await this.n(P=>delete P[i.ExtensionKey.create(I).toString()])}async n(I){return this.g.queue(async()=>{let P;try{P=await c.Promises.readFile(this.c,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let M={};if(P)try{M=JSON.parse(P)}catch{}return I&&(I(M),Object.keys(M).length?await c.Promises.writeFile(this.c,JSON.stringify(M)):await c.Promises.rm(this.c)),M})}async p(I,P,M,F){this.m.trace(`Started extracting the extension from ${P} to ${M}`);try{await c.Promises.rm(M)}catch(V){throw new n.ExtensionManagementError(this.w(V).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(P,M,{sourcePath:"extension",overwrite:!0},F),this.m.info(`Extracted extension to ${M}:`,I.id)}catch(V){try{await c.Promises.rm(M)}catch{}let G=n.ExtensionManagementErrorCode.Extract;throw V instanceof g.ExtractError&&(V.type==="CorruptZip"?G=n.ExtensionManagementErrorCode.CorruptZip:V.type==="Incomplete"&&(G=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(V.message,G)}}async s(I,P,M,F){try{await c.Promises.rename(P,M)}catch(V){if(p.isWindows&&V&&V.code==="EPERM"&&Date.now()<F)return this.m.info(`Failed renaming ${P} to ${M} with 'EPERM' error. Trying again...`,I.id),this.s(I,P,M,F);throw new n.ExtensionManagementError(V.message||E.localize(5,null,P,M),V.code||n.ExtensionManagementErrorCode.Rename)}}async t(I,P){const M=await this.l.scanExistingExtension(I,P,{includeInvalid:!0});if(M)return this.u(M);throw new Error(E.localize(6,null,I.path))}async u(I){const P=await this.k.resolve(I.location);let M,F;return P.children&&(M=P.children.find(({name:V})=>/^readme(\.txt|\.md|)$/i.test(V))?.resource,F=P.children.find(({name:V})=>/^changelog(\.txt|\.md|)$/i.test(V))?.resource),{identifier:I.identifier,type:I.type,isBuiltin:I.isBuiltin||!!I.metadata?.isBuiltin,location:I.location,manifest:I.manifest,targetPlatform:I.targetPlatform,validations:I.validations,isValid:I.isValid,readmeUrl:M,changelogUrl:F,publisherDisplayName:I.metadata?.publisherDisplayName||null,publisherId:I.metadata?.publisherId||null,isApplicationScoped:!!I.metadata?.isApplicationScoped,isMachineScoped:!!I.metadata?.isMachineScoped,isPreReleaseVersion:!!I.metadata?.isPreReleaseVersion,preRelease:!!I.metadata?.preRelease,installedTimestamp:I.metadata?.installedTimestamp,updated:!!I.metadata?.updated}}async v(){const I=await this.getUninstalledExtensions(),P=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=new Set;for(const G of P)I[i.ExtensionKey.create(G).toString()]||M.add(G.identifier.id.toLowerCase());const F=(0,i.groupByExtension)(P,G=>G.identifier);await L.Promises.settled(F.map(async G=>{const te=G.sort((ne,ge)=>S.rcompare(ne.manifest.version,ge.manifest.version))[0];M.has(te.identifier.id.toLowerCase())||await this.j(await this.u(te))}));const V=P.filter(G=>G.metadata&&I[i.ExtensionKey.create(G).toString()]);await L.Promises.settled(V.map(G=>this.removeUninstalledExtension(G)))}w(I){const P=Array.isArray(I)?I:[I];return P.length===1?P[0]instanceof Error?P[0]:new Error(P[0]):P.reduce((M,F)=>new Error(`${M.message}${M.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}};B=me([_(1,X.IFileService),_(2,s.IExtensionsScannerService),_(3,re.ILogService)],B),e.ExtensionsScanner=B;class j extends t.AbstractExtensionTask{get operation(){return(0,v.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(I,P,M,F,V){super(),this.identifier=I,this.source=P,this.k=M,this.l=F,this.m=V,this.wasVerified=!1,this.j=2}async n(I,P){try{const M=await this.o(I.key);if(M)return this.l.updateMetadata(M,I.metadata)}catch{throw p.isMacintosh?new n.ExtensionManagementError(E.localize(7,null),n.ExtensionManagementErrorCode.Internal):new n.ExtensionManagementError(E.localize(8,null),n.ExtensionManagementErrorCode.Internal)}return this.q(I,P)}async o(I){if(!await this.p(I))return null;this.m.trace("Removing the extension from uninstalled list:",I.id);const M=await this.l.setInstalled(I);return this.m.info("Removed the extension from uninstalled list:",I.id),M}async p(I){return!!(await this.l.getUninstalledExtensions())[I.toString()]}async q({zipPath:I,key:P,metadata:M},F){const V=await this.l.extractUserExtension(P,I,M,F);return this.m.info("Extracting completed.",P.id),V}}class A extends j{constructor(I,P,M,F,V,G){super(P.identifier,P,M,V,G),this.s=I,this.t=P,this.u=F}async h(I){const M=(await this.l.scanExtensions(null,void 0)).find(te=>(0,i.areSameExtensions)(te.identifier,this.t.identifier));M&&(this.j=3);const F={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,x.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||M?.isMachineScoped,isBuiltin:this.k.isBuiltin||M?.isBuiltin,isSystem:M?.type===0?!0:void 0,updated:!!M,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,v.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:M?.preRelease)};if(M?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(M,F),metadata:F};const{location:V,verified:G}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!G,this.w(V.fsPath),{local:await this.n({zipPath:V.fsPath,key:i.ExtensionKey.create(this.t),metadata:F},I),metadata:F}}catch(te){try{await this.u.delete(V)}catch(ne){this.m.warn("Error while deleting the downloaded file",V.toString(),(0,T.getErrorMessage)(ne))}throw te}}async w(I){try{await(0,f.getManifest)(I)}catch(P){throw new n.ExtensionManagementError((0,t.joinErrors)(P).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=A;class z extends j{constructor(I,P,M,F,V,G){super({id:(0,i.getGalleryExtensionId)(I.publisher,I.name)},P,M,V,G),this.s=I,this.t=P,this.u=F}async h(I){const P=new i.ExtensionKey(this.identifier,this.s.version),F=(await this.l.scanExtensions(1,void 0)).find(te=>(0,i.areSameExtensions)(this.identifier,te.identifier)),V=await this.w(this.identifier.id,this.s.version,I);if(V.isApplicationScoped=(0,x.isApplicationScopedExtension)(this.s),V.isMachineScoped=this.k.isMachineScoped||F?.isMachineScoped,V.isBuiltin=this.k.isBuiltin||F?.isBuiltin,V.installedTimestamp=Date.now(),F)if(this.j=3,P.equals(new i.ExtensionKey(F.identifier,F.manifest.version)))try{await this.l.removeExtension(F,"existing")}catch{throw new Error(E.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&S.gt(F.manifest.version,this.s.version)&&await this.l.setUninstalled(F);else{const te=await this.o(P);if(te)try{await this.l.removeExtension(te,"existing")}catch{throw new Error(E.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:y.resolve(this.t.fsPath),key:P,metadata:V},I),metadata:V}}async w(I,P,M){try{let[F]=await this.u.getExtensions([{id:I,version:P}],M);if(F||([F]=await this.u.getExtensions([{id:I}],M)),F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class ${constructor(I,P,M){this.d=I,this.g=P,this.h=M,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const I=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[I.local,I.metadata]],this.g),I}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class q extends t.AbstractExtensionTask{constructor(I,P,M){super(),this.extension=I,this.j=P,this.k=M}async h(I){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Z[153],Q([0,1,132,4,15,10,2,3,21,18,133,9,131,166]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let v=class extends N.Disposable{constructor(w,c,g){super(),this.h=c,this.i=g,this.j(w.getValue()),this.B(w.onDidChangeConfiguration(()=>this.j(w.getValue()),this))}j(w){this.a=w.http&&w.http.proxy,this.b=!!(w.http&&w.http.proxyStrictSSL),this.f=w.http&&w.http.proxyAuthorization}async request(w,c){this.i.trace("RequestService#request (node) - begin",w.url);const{a:g,b:E}=this;let h;try{h=await(0,y.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(n){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",n))}const o={...process.env,...h},t=w.agent?w.agent:await(0,m.getProxyAgent)(w.url||"",o,{proxyUrl:g,strictSSL:E});w.agent=t,w.strictSSL=E,this.f&&(w.headers={...w.headers||{},"Proxy-Authorization":this.f});try{const n=await this.l(w,c);return this.i.trace("RequestService#request (node) - success",w.url),n}catch(n){throw this.i.trace("RequestService#request (node) - error",w.url,n),n}}async k(w){return((0,L.parse)(w.url).protocol==="https:"?await new Promise((E,h)=>{W(["https"],E,h)}):await new Promise((E,h)=>{W(["http"],E,h)})).request}l(w,c){return R.Promises.withAsyncBody(async(g,E)=>{const h=(0,L.parse)(w.url),o=w.getRawRequest?w.getRawRequest(w):await this.k(w),t={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,b.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(t.auth=w.user+":"+w.password);const n=o(t,i=>{const r=(0,b.isNumber)(w.followRedirects)?w.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this.l({...w,url:i.headers.location,followRedirects:r-1},c).then(g,E);else{let s=i;!w.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,S.createGunzip)())),g({res:i,stream:(0,k.streamToBufferReadableStream)(s)})}});n.on("error",E),w.timeout&&n.setTimeout(w.timeout),w.isChromiumNetwork&&n.removeHeader("Content-Length"),w.data&&typeof w.data=="string"&&n.write(w.data),n.end(),c.onCancellationRequested(()=>{n.abort(),E(new T.CancellationError)})})}async resolveProxy(w){}};v=me([_(0,d.IConfigurationService),_(1,u.INativeEnvironmentService),_(2,p.ILogService)],v),e.RequestService=v}),define(Z[167],Q([0,1,33,4,15,34,10,2,16,14,12,35,11,20,21,124,58,130,18,105,148,23,59,125,42,48,152,146,13,116,118,46,114,62,63,129,9,120,121,38,150,138,26,47,153,67,134,68,32,137,41,139,140,28,142,25,149,141]),function(W,e,L,R,k,T,N,b,d,u,y,p,m,S,v,O,w,c,g,E,h,o,t,n,i,r,s,l,a,f,D,C,x,Y,X,ie,re,ee,pe,le,ae,he,B,j,A,z,$,q,K,I,P,M,F,V,G,te,ne,ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ye extends b.Disposable{constructor(oe){super(),this.b=oe,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[oe,se]=await this.f();return oe.invokeFunction(async fe=>{const Te=fe.get(re.ILogService),Fe=fe.get(a.IFileService),De=fe.get(g.INativeEnvironmentService),Me=fe.get(te.IUserDataProfilesService);Te.info("CLI main",this.b),this.g(Te),await this.h(De,Fe,Me,oe),await Promise.all(se.map(U=>{(0,R.raceTimeout)(U.flush(),1e3)}))})}async f(){const oe=new Y.ServiceCollection,se={_serviceBrand:void 0,...he.default};oe.set(B.IProductService,se);const fe=new E.NativeEnvironmentService(this.b,se);oe.set(g.INativeEnvironmentService,fe),await Promise.all([fe.appSettingsHome.fsPath,fe.extensionsPath].map(Pe=>Pe?S.Promises.mkdir(Pe,{recursive:!0}):void 0));const Te=(0,re.getLogLevel)(fe),Fe=[];Fe.push(new ee.SpdLogLogger("cli",(0,u.join)(fe.logsPath,"cli.log"),!0,!1,Te)),Te===re.LogLevel.Trace&&Fe.push(new re.ConsoleLogger(Te));const De=this.B(new re.MultiplexLogService(Fe));oe.set(re.ILogService,De);const Me=this.B(new f.FileService(De));oe.set(a.IFileService,Me);const U=this.B(new D.DiskFileSystemProvider(De));Me.registerProvider(d.Schemas.file,U);const H=new $.StateService(fe,De,Me);oe.set(z.IStateService,H);const J=new G.UriIdentityService(Me);oe.set(V.IUriIdentityService,J);const de=new ne.UserDataProfilesService(H,J,fe,Me,De);oe.set(te.IUserDataProfilesService,de);const ve=y.isWindows&&se.win32RegValueName?this.B(new ae.NativePolicyService(De,se.win32RegValueName)):fe.policyFile?this.B(new pe.FilePolicyService(fe.policyFile,Me,De)):new le.NullPolicyService;oe.set(le.IPolicyService,ve);const Re=this.B(new O.ConfigurationService(de.defaultProfile.settingsResource,Me,ve,De));oe.set(v.IConfigurationService,Re),await Promise.all([H.init(),Re.initialize()]),de.setEnablement(se.quality!=="stable"||Re.getValue(te.PROFILES_ENABLEMENT_CONFIG)),oe.set(V.IUriIdentityService,new G.UriIdentityService(Me)),oe.set(j.IRequestService,new C.SyncDescriptor(A.RequestService,void 0,!0)),oe.set(w.IDownloadService,new C.SyncDescriptor(c.DownloadService,void 0,!0)),oe.set(i.IExtensionsProfileScannerService,new C.SyncDescriptor(i.ExtensionsProfileScannerService,void 0,!0)),oe.set(r.IExtensionsScannerService,new C.SyncDescriptor(l.ExtensionsScannerService,void 0,!0)),oe.set(t.IExtensionSignatureVerificationService,new C.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),oe.set(s.INativeServerExtensionManagementService,new C.SyncDescriptor(s.ExtensionManagementService,void 0,!0)),oe.set(o.IExtensionGalleryService,new C.SyncDescriptor(h.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),oe.set(X.ILanguagePackService,new C.SyncDescriptor(ie.NativeLanguagePackService,void 0,!1));const Se=[],Le=(0,P.isInternalTelemetry)(se,Re);if((0,P.supportsTelemetry)(se,fe)){se.aiConfig&&se.aiConfig.ariaKey&&Se.push(new M.OneDataSystemAppender(Le,"monacoworkbench",null,se.aiConfig.ariaKey));const{installSourcePath:Pe}=fe,Oe={appenders:Se,sendErrorTelemetry:!1,commonProperties:(async()=>{let je;try{je=await(0,ge.resolveMachineId)(H)}catch(Ie){Ie.code!=="ENOENT"&&De.error(Ie)}return(0,q.resolveCommonProperties)(Me,(0,L.release)(),(0,L.hostname)(),process.arch,se.commit,se.version,je,Le,Pe)})(),piiPaths:(0,P.getPiiPathsFromEnvironment)(fe)};oe.set(K.ITelemetryService,new C.SyncDescriptor(I.TelemetryService,[Oe],!1))}else oe.set(K.ITelemetryService,P.NullTelemetryService);return[new x.InstantiationService(oe),Se]}g(oe){(0,N.setUnexpectedErrorHandler)(se=>{const fe=(0,T.toErrorMessage)(se,!0);!fe||oe.error(`[uncaught exception in CLI]: ${fe}`)}),process.on("uncaughtException",se=>(0,N.onUnexpectedError)(se)),process.on("unhandledRejection",se=>(0,N.onUnexpectedError)(se))}async h(oe,se,fe,Te){const Fe=(oe.args.profile?fe.profiles.find(De=>De.name===oe.args.profile)??fe.defaultProfile:fe.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(oe,se,this.b["install-source"]);if(this.b["list-extensions"])return Te.createInstance(n.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Fe);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const De={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Fe};return Te.createInstance(n.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],De,!!this.b.force)}else{if(this.b["uninstall-extension"])return Te.createInstance(n.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Fe);if(this.b["locate-extension"])return Te.createInstance(n.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.buildTelemetryMessage)(oe.appRoot,oe.extensionsPath))}}i(oe){return oe.map(se=>/\.vsix$/i.test(se)?m.URI.file((0,u.isAbsolute)(se)?se:(0,u.join)((0,p.cwd)(),se)):se)}async j(oe,se,fe){await se.writeFile(m.URI.file(oe.installSourcePath),k.VSBuffer.fromString(fe.slice(0,30)))}}async function ue(ce){const oe=new ye(ce);try{await oe.run()}finally{oe.dispose()}}e.main=ue})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/44531ffc7b7477dbe82750040d8ed69bae2bb140/core/vs/code/node/cliProcessMain.js.map
