/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/platform/registry/common/platform","vs/base/common/stopwatch","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],ye=function(ne){for(var e=[],c=0,t=ne.length;c<t;c++)e[c]=Se[ne[c]];return e};define(Se[79],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function c(A){return A?A.replace(/\$\((.*?)\)/g,(C,T)=>` ${T} `).trim():""}e.getCodiconAriaLabel=c;class t{constructor(C,T,S){this.id=C,this.definition=T,this.description=S,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var I;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function T(L){if(L instanceof t)return["codicon","codicon-"+L.id];const P=C.exec(L.id);if(!P)return T(t.error);const[,E,D]=P,v=["codicon","codicon-"+E];return D&&v.push("codicon-modifier-"+D.substring(1)),v}A.asClassNameArray=T;function S(L){return T(L).join(" ")}A.asClassName=S;function y(L){return"."+T(L).join(".")}A.asCSSSelector=y})(I=e.CSSIcon||(e.CSSIcon={}))}),define(Se[80],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(C,T){const S=Object.create(null);for(const y of C){const L=T(y);let P=S[L];P||(P=S[L]=[]),P.push(y)}return S}e.groupBy=c;function t(C,T){const S=[],y=[];for(const L of C)T.has(L)||S.push(L);for(const L of T)C.has(L)||y.push(L);return{removed:S,added:y}}e.diffSets=t;function I(C,T){const S=[],y=[];for(const[L,P]of C)T.has(L)||S.push(P);for(const[L,P]of T)C.has(L)||y.push(P);return{removed:S,added:y}}e.diffMaps=I;class A{constructor(){this.a=new Map}add(T,S){let y=this.a.get(T);y||(y=new Set,this.a.set(T,y)),y.add(S)}delete(T,S){const y=this.a.get(T);!y||(y.delete(S),y.size===0&&this.a.delete(T))}forEach(T,S){const y=this.a.get(T);!y||y.forEach(S)}}e.SetMap=A}),define(Se[60],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function c(C){return(T,S,y)=>{let L=null,P=null;if(typeof y.value=="function"?(L="value",P=y.value):typeof y.get=="function"&&(L="get",P=y.get),!P)throw new Error("not supported");y[L]=C(P,S)}}function t(C,T,S){let y=null,L=null;if(typeof S.value=="function"?(y="value",L=S.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(y="get",L=S.get),!L)throw new Error("not supported");const P=`$memoize$${T}`;S[y]=function(...E){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,E)}),this[P]}}e.memoize=t;function I(C,T,S){return c((y,L)=>{const P=`$debounce$${L}`,E=`$debounce$result$${L}`;return function(...D){this[E]||(this[E]=S?S():void 0),clearTimeout(this[P]),T&&(this[E]=T(this[E],...D),D=[this[E]]),this[P]=setTimeout(()=>{y.apply(this,D),this[E]=S?S():void 0},C)}})}e.debounce=I;function A(C,T,S){return c((y,L)=>{const P=`$throttle$timer$${L}`,E=`$throttle$result$${L}`,D=`$throttle$lastRun$${L}`,v=`$throttle$pending$${L}`;return function(...d){if(this[E]||(this[E]=S?S():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),T&&(this[E]=T(this[E],...d)),this[v])return;const m=this[D]+C;m<=Date.now()?(this[D]=Date.now(),y.apply(this,[this[E]]),this[E]=S?S():void 0):(this[v]=!0,this[P]=setTimeout(()=>{this[v]=!1,this[D]=Date.now(),y.apply(this,[this[E]]),this[E]=S?S():void 0},m-Date.now()))}})}e.throttle=A}),define(Se[10],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?p.isErrorNoTelemetry(s)?new p(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(r=>{r(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.ErrorHandler=c,e.errorHandler=new c;function t(w){e.errorHandler.setUnexpectedErrorHandler(w)}e.setUnexpectedErrorHandler=t;function I(w){S(w)||e.errorHandler.onUnexpectedError(w)}e.onUnexpectedError=I;function A(w){S(w)||e.errorHandler.onUnexpectedExternalError(w)}e.onUnexpectedExternalError=A;function C(w){if(w instanceof Error){const{name:s,message:r}=w,l=w.stacktrace||w.stack;return{$isError:!0,name:s,message:r,stack:l,noTelemetry:p.isErrorNoTelemetry(w)}}return w}e.transformErrorForSerialization=C;const T="Canceled";function S(w){return w instanceof y?!0:w instanceof Error&&w.name===T&&w.message===T}e.isCancellationError=S;class y extends Error{constructor(){super(T),this.name=this.message}}e.CancellationError=y;function L(){const w=new Error(T);return w.name=w.message,w}e.canceled=L;function P(w){return w?new Error(`Illegal argument: ${w}`):new Error("Illegal argument")}e.illegalArgument=P;function E(w){return w?new Error(`Illegal state: ${w}`):new Error("Illegal state")}e.illegalState=E;function D(w){return w?new Error(`readonly property '${w} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=D;function v(w){const s=new Error(`${w} has been disposed`);return s.name="DISPOSED",s}e.disposed=v;function d(w){return w?w.message?w.message:w.stack?w.stack.split(`
`)[0]:String(w):"Error"}e.getErrorMessage=d;class m extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=m;class h extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=h;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class p extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof p)return s;const r=new p;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=p;class g extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(Se[17],ye([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(se,ue=0){return se[se.length-(1+ue)]}e.tail=t;function I(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}e.tail2=I;function A(se,ue,he=(ee,oe)=>ee===oe){if(se===ue)return!0;if(!se||!ue||se.length!==ue.length)return!1;for(let ee=0,oe=se.length;ee<oe;ee++)if(!he(se[ee],ue[ee]))return!1;return!0}e.equals=A;function C(se,ue){const he=se.length-1;ue<he&&(se[ue]=se[he]),se.pop()}e.removeFastWithoutKeepingOrder=C;function T(se,ue,he){return S(se.length,ee=>he(se[ee],ue))}e.binarySearch=T;function S(se,ue){let he=0,ee=se-1;for(;he<=ee;){const oe=(he+ee)/2|0,ie=ue(oe);if(ie<0)he=oe+1;else if(ie>0)ee=oe-1;else return oe}return-(he+1)}e.binarySearch2=S;function y(se,ue){let he=0,ee=se.length;if(ee===0)return 0;for(;he<ee;){const oe=Math.floor((he+ee)/2);ue(se[oe])?ee=oe:he=oe+1}return he}e.findFirstInSorted=y;function L(se,ue,he){if(se=se|0,se>=ue.length)throw new TypeError("invalid index");const ee=ue[Math.floor(ue.length*Math.random())],oe=[],ie=[],O=[];for(const H of ue){const K=he(H,ee);K<0?oe.push(H):K>0?ie.push(H):O.push(H)}return se<oe.length?L(se,oe,he):se<oe.length+O.length?O[0]:L(se-(oe.length+O.length),ie,he)}e.quickSelect=L;function P(se,ue){const he=[];let ee;for(const oe of se.slice(0).sort(ue))!ee||ue(ee[0],oe)!==0?(ee=[oe],he.push(ee)):ee.push(oe);return he}e.groupBy=P;function E(se,ue,he){const ee=[];function oe(H,K,Y){if(K===0&&Y.length===0)return;const de=ee[ee.length-1];de&&de.start+de.deleteCount===H?(de.deleteCount+=K,de.toInsert.push(...Y)):ee.push({start:H,deleteCount:K,toInsert:Y})}let ie=0,O=0;for(;;){if(ie===se.length){oe(ie,0,ue.slice(O));break}if(O===ue.length){oe(ie,se.length-ie,[]);break}const H=se[ie],K=ue[O],Y=he(H,K);Y===0?(ie+=1,O+=1):Y<0?(oe(ie,1,[]),ie+=1):Y>0&&(oe(ie,0,[K]),O+=1)}return ee}e.sortedDiff=E;function D(se,ue,he){const ee=E(se,ue,he),oe=[],ie=[];for(const O of ee)oe.push(...se.slice(O.start,O.start+O.deleteCount)),ie.push(...O.toInsert);return{removed:oe,added:ie}}e.delta=D;function v(se,ue,he){if(he===0)return[];const ee=se.slice(0,he).sort(ue);return m(se,ue,ee,he,se.length),ee}e.top=v;function d(se,ue,he,ee,oe){return he===0?Promise.resolve([]):new Promise((ie,O)=>{(async()=>{const H=se.length,K=se.slice(0,he).sort(ue);for(let Y=he,de=Math.min(he+ee,H);Y<H;Y=de,de=Math.min(de+ee,H)){if(Y>he&&await new Promise(be=>setTimeout(be)),oe&&oe.isCancellationRequested)throw new c.CancellationError;m(se,ue,K,Y,de)}return K})().then(ie,O)})}e.topAsync=d;function m(se,ue,he,ee,oe){for(const ie=he.length;ee<oe;ee++){const O=se[ee];if(ue(O,he[ie-1])<0){he.pop();const H=y(he,K=>ue(O,K)<0);he.splice(H,0,O)}}}function h(se){return se.filter(ue=>!!ue)}e.coalesce=h;function b(se){let ue=0;for(let he=0;he<se.length;he++)se[he]&&(se[ue]=se[he],ue+=1);se.length=ue}e.coalesceInPlace=b;function p(se,ue,he){se.splice(he,0,se.splice(ue,1)[0])}e.move=p;function g(se){return!Array.isArray(se)||se.length===0}e.isFalsyOrEmpty=g;function w(se){return Array.isArray(se)&&se.length>0}e.isNonEmptyArray=w;function s(se,ue=he=>he){const he=new Set;return se.filter(ee=>{const oe=ue(ee);return he.has(oe)?!1:(he.add(oe),!0)})}e.distinct=s;function r(se){const ue=new Set;return he=>{const ee=se(he);return ue.has(ee)?!1:(ue.add(ee),!0)}}e.uniqueFilter=r;function l(se,ue){const he=u(se,ue);if(he!==-1)return se[he]}e.findLast=l;function u(se,ue){for(let he=se.length-1;he>=0;he--){const ee=se[he];if(ue(ee))return he}return-1}e.lastIndex=u;function o(se,ue){return se.length>0?se[0]:ue}e.firstOrDefault=o;function a(se,ue){return se.length>0?se[se.length-1]:ue}e.lastOrDefault=a;function n(se,ue,he=(ee,oe)=>ee===oe){let ee=0;for(let oe=0,ie=Math.min(se.length,ue.length);oe<ie&&he(se[oe],ue[oe]);oe++)ee++;return ee}e.commonPrefixLength=n;function i(se){return[].concat(...se)}e.flatten=i;function f(se,ue){let he=typeof ue=="number"?se:0;typeof ue=="number"?he=se:(he=0,ue=se);const ee=[];if(he<=ue)for(let oe=he;oe<ue;oe++)ee.push(oe);else for(let oe=he;oe>ue;oe--)ee.push(oe);return ee}e.range=f;function k(se,ue,he){return se.reduce((ee,oe)=>(ee[ue(oe)]=he?he(oe):oe,ee),Object.create(null))}e.index=k;function R(se,ue){return se.push(ue),()=>B(se,ue)}e.insert=R;function B(se,ue){const he=se.indexOf(ue);if(he>-1)return se.splice(he,1),ue}e.remove=B;function X(se,ue,he){const ee=se.slice(0,ue),oe=se.slice(ue);return ee.concat(he,oe)}e.arrayInsert=X;function q(se,ue){let he;if(typeof ue=="number"){let ee=ue;he=()=>{const oe=Math.sin(ee++)*179426549;return oe-Math.floor(oe)}}else he=Math.random;for(let ee=se.length-1;ee>0;ee-=1){const oe=Math.floor(he()*(ee+1)),ie=se[ee];se[ee]=se[oe],se[oe]=ie}}e.shuffle=q;function N(se,ue){const he=se.indexOf(ue);he>-1&&(se.splice(he,1),se.unshift(ue))}e.pushToStart=N;function M(se,ue){const he=se.indexOf(ue);he>-1&&(se.splice(he,1),se.push(ue))}e.pushToEnd=M;function F(se,ue){for(const he of ue)se.push(he)}e.pushMany=F;function z(se,ue){return Array.isArray(se)?se.map(ue):ue(se)}e.mapArrayOrNot=z;function U(se){return Array.isArray(se)?se:[se]}e.asArray=U;function W(se){return se[Math.floor(Math.random()*se.length)]}e.getRandomElement=W;function x(se,ue){for(const he of se){const ee=ue(he);if(ee!==void 0)return ee}}e.mapFind=x;function V(se,ue,he){const ee=Q(se,ue),oe=se.length,ie=he.length;se.length=oe+ie;for(let O=oe-1;O>=ee;O--)se[O+ie]=se[O];for(let O=0;O<ie;O++)se[O+ee]=he[O]}e.insertInto=V;function _(se,ue,he,ee){const oe=Q(se,ue),ie=se.splice(oe,he);return V(se,oe,ee),ie}e.splice=_;function Q(se,ue){return ue<0?Math.max(ue+se.length,0):Math.min(ue,se.length)}var J;(function(se){function ue(oe){return oe<0}se.isLessThan=ue;function he(oe){return oe>0}se.isGreaterThan=he;function ee(oe){return oe===0}se.isNeitherLessOrGreaterThan=ee,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(J=e.CompareResult||(e.CompareResult={}));function te(se,ue){return(he,ee)=>ue(se(he),se(ee))}e.compareBy=te;function le(...se){return(ue,he)=>{for(const ee of se){const oe=ee(ue,he);if(!J.isNeitherLessOrGreaterThan(oe))return oe}return J.neitherLessOrGreaterThan}}e.tieBreakComparators=le;const Z=(se,ue)=>se-ue;e.numberComparator=Z;function ge(se,ue){if(se.length===0)return;let he=se[0];for(let ee=1;ee<se.length;ee++){const oe=se[ee];ue(oe,he)>0&&(he=oe)}return he}e.findMaxBy=ge;function ve(se,ue){if(se.length===0)return;let he=se[0];for(let ee=1;ee<se.length;ee++){const oe=se[ee];ue(oe,he)>=0&&(he=oe)}return he}e.findLastMaxBy=ve;function De(se,ue){return ge(se,(he,ee)=>-ue(he,ee))}e.findMinBy=De;class Re{constructor(ue){this.f=ue,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ue){let he=this.c;for(;he<this.f.length&&ue(this.f[he]);)he++;const ee=he===this.c?null:this.f.slice(this.c,he);return this.c=he,ee}takeFromEndWhile(ue){let he=this.d;for(;he>=0&&ue(this.f[he]);)he--;const ee=he===this.d?null:this.f.slice(he+1,this.d+1);return this.d=he,ee}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ue=this.f[this.c];return this.c++,ue}removeLast(){const ue=this.f[this.d];return this.d--,ue}takeCount(ue){const he=this.f.slice(this.c,this.c+ue);return this.c+=ue,he}}e.ArrayQueue=Re;class ze{constructor(ue){this.iterate=ue}forEach(ue){this.iterate(he=>(ue(he),!0))}toArray(){const ue=[];return this.iterate(he=>(ue.push(he),!0)),ue}filter(ue){return new ze(he=>this.iterate(ee=>ue(ee)?he(ee):!0))}map(ue){return new ze(he=>this.iterate(ee=>he(ue(ee))))}some(ue){let he=!1;return this.iterate(ee=>(he=ue(ee),!he)),he}findFirst(ue){let he;return this.iterate(ee=>ue(ee)?(he=ee,!1):!0),he}findLast(ue){let he;return this.iterate(ee=>(ue(ee)&&(he=ee),!0)),he}findLastMaxBy(ue){let he,ee=!0;return this.iterate(oe=>((ee||J.isGreaterThan(ue(oe,he)))&&(ee=!1,he=oe),!0)),he}}e.CallbackIterable=ze,ze.empty=new ze(se=>{})}),define(Se[49],ye([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(S,y){if(!S)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=t;function I(S,y="Unreachable"){throw new Error(y)}e.assertNever=I;function A(S){if(!S)throw new c.BugIndicatingError("Assertion Failed")}e.assert=A;function C(S){if(!S()){debugger;S(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function T(S,y){let L=0;for(;L<S.length-1;){const P=S[L],E=S[L+1];if(!y(P,E))return!1;L++}return!0}e.checkAdjacentItems=T}),define(Se[61],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(t){const I=this;let A=!1,C;return function(){return A||(A=!0,C=t.apply(I,arguments)),C}}e.once=c}),define(Se[99],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(Se[62],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(t){function I(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}t.is=I;const A=Object.freeze([]);function C(){return A}t.empty=C;function*T(g){yield g}t.single=T;function S(g){return I(g)?g:T(g)}t.wrap=S;function y(g){return g||A}t.from=y;function L(g){return!g||g[Symbol.iterator]().next().done===!0}t.isEmpty=L;function P(g){return g[Symbol.iterator]().next().value}t.first=P;function E(g,w){for(const s of g)if(w(s))return!0;return!1}t.some=E;function D(g,w){for(const s of g)if(w(s))return s}t.find=D;function*v(g,w){for(const s of g)w(s)&&(yield s)}t.filter=v;function*d(g,w){let s=0;for(const r of g)yield w(r,s++)}t.map=d;function*m(...g){for(const w of g)for(const s of w)yield s}t.concat=m;function h(g,w,s){let r=s;for(const l of g)r=w(r,l);return r}t.reduce=h;function*b(g,w,s=g.length){for(w<0&&(w+=g.length),s<0?s+=g.length:s>g.length&&(s=g.length);w<s;w++)yield g[w]}t.slice=b;function p(g,w=Number.POSITIVE_INFINITY){const s=[];if(w===0)return[s,g];const r=g[Symbol.iterator]();for(let l=0;l<w;l++){const u=r.next();if(u.done)return[s,t.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return r}}]}t.consume=p})(c=e.Iterable||(e.Iterable={}))}),define(Se[146],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function C(s,r=!1){let l=0;const u=s.length;let o="",a=0,n=16,i=0;function f(M){let F=0,z=0;for(;F<M;){const U=s.charCodeAt(l);if(U>=48&&U<=57)z=z*16+U-48;else if(U>=65&&U<=70)z=z*16+U-65+10;else if(U>=97&&U<=102)z=z*16+U-97+10;else break;l++,F++}return F<M&&(z=-1),z}function k(M){l=M,o="",a=0,n=16,i=0}function R(){const M=l;if(s.charCodeAt(l)===48)l++;else for(l++;l<s.length&&y(s.charCodeAt(l));)l++;if(l<s.length&&s.charCodeAt(l)===46)if(l++,l<s.length&&y(s.charCodeAt(l)))for(l++;l<s.length&&y(s.charCodeAt(l));)l++;else return i=3,s.substring(M,l);let F=l;if(l<s.length&&(s.charCodeAt(l)===69||s.charCodeAt(l)===101))if(l++,(l<s.length&&s.charCodeAt(l)===43||s.charCodeAt(l)===45)&&l++,l<s.length&&y(s.charCodeAt(l))){for(l++;l<s.length&&y(s.charCodeAt(l));)l++;F=l}else i=3;return s.substring(M,F)}function B(){let M="",F=l;for(;;){if(l>=u){M+=s.substring(F,l),i=2;break}const z=s.charCodeAt(l);if(z===34){M+=s.substring(F,l),l++;break}if(z===92){if(M+=s.substring(F,l),l++,l>=u){i=2;break}switch(s.charCodeAt(l++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const W=f(4);W>=0?M+=String.fromCharCode(W):i=4;break}default:i=5}F=l;continue}if(z>=0&&z<=31)if(S(z)){M+=s.substring(F,l),i=2;break}else i=6;l++}return M}function X(){if(o="",i=0,a=l,l>=u)return a=u,n=17;let M=s.charCodeAt(l);if(T(M)){do l++,o+=String.fromCharCode(M),M=s.charCodeAt(l);while(T(M));return n=15}if(S(M))return l++,o+=String.fromCharCode(M),M===13&&s.charCodeAt(l)===10&&(l++,o+=`
`),n=14;switch(M){case 123:return l++,n=1;case 125:return l++,n=2;case 91:return l++,n=3;case 93:return l++,n=4;case 58:return l++,n=6;case 44:return l++,n=5;case 34:return l++,o=B(),n=10;case 47:{const F=l-1;if(s.charCodeAt(l+1)===47){for(l+=2;l<u&&!S(s.charCodeAt(l));)l++;return o=s.substring(F,l),n=12}if(s.charCodeAt(l+1)===42){l+=2;const z=u-1;let U=!1;for(;l<z;){if(s.charCodeAt(l)===42&&s.charCodeAt(l+1)===47){l+=2,U=!0;break}l++}return U||(l++,i=1),o=s.substring(F,l),n=13}return o+=String.fromCharCode(M),l++,n=16}case 45:if(o+=String.fromCharCode(M),l++,l===u||!y(s.charCodeAt(l)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=R(),n=11;default:for(;l<u&&q(M);)l++,M=s.charCodeAt(l);if(a!==l){switch(o=s.substring(a,l),o){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return o+=String.fromCharCode(M),l++,n=16}}function q(M){if(T(M)||S(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let M;do M=X();while(M>=12&&M<=15);return M}return{setPosition:k,getPosition:()=>l,scan:r?N:X,getToken:()=>n,getTokenValue:()=>o,getTokenOffset:()=>a,getTokenLength:()=>l-a,getTokenError:()=>i}}e.createScanner=C;function T(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function y(s){return s>=48&&s<=57}var L;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(L||(L={}));function P(s,r){const l=[],u=new Object;let o;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function i(f,k,R,B){a.value=f,a.offset=k,a.length=R,a.type=B,a.colonOffset=void 0,o=a}try{p(s,{onObjectBegin:(f,k)=>{if(r<=f)throw u;o=void 0,n=r>f,l.push("")},onObjectProperty:(f,k,R)=>{if(r<k||(i(f,k,R,"property"),l[l.length-1]=f,r<=k+R))throw u},onObjectEnd:(f,k)=>{if(r<=f)throw u;o=void 0,l.pop()},onArrayBegin:(f,k)=>{if(r<=f)throw u;o=void 0,l.push(0)},onArrayEnd:(f,k)=>{if(r<=f)throw u;o=void 0,l.pop()},onLiteralValue:(f,k,R)=>{if(r<k||(i(f,k,R,w(f)),r<=k+R))throw u},onSeparator:(f,k,R)=>{if(r<=k)throw u;if(f===":"&&o&&o.type==="property")o.colonOffset=k,n=!1,o=void 0;else if(f===","){const B=l[l.length-1];typeof B=="number"?l[l.length-1]=B+1:(n=!0,l[l.length-1]=""),o=void 0}}})}catch(f){if(f!==u)throw f}return{path:l,previousNode:o,isAtPropertyKey:n,matches:f=>{let k=0;for(let R=0;k<f.length&&R<l.length;R++)if(f[k]===l[R]||f[k]==="*")k++;else if(f[k]!=="**")return!1;return k===f.length}}}e.getLocation=P;function E(s,r=[],l=A.DEFAULT){let u=null,o=[];const a=[];function n(f){Array.isArray(o)?o.push(f):u!==null&&(o[u]=f)}return p(s,{onObjectBegin:()=>{const f={};n(f),a.push(o),o=f,u=null},onObjectProperty:f=>{u=f},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const f=[];n(f),a.push(o),o=f,u=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:n,onError:(f,k,R)=>{r.push({error:f,offset:k,length:R})}},l),o[0]}e.parse=E;function D(s,r=[],l=A.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(f){u.type==="property"&&(u.length=f-u.offset,u=u.parent)}function a(f){return u.children.push(f),f}p(s,{onObjectBegin:f=>{u=a({type:"object",offset:f,length:-1,parent:u,children:[]})},onObjectProperty:(f,k,R)=>{u=a({type:"property",offset:k,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:f,offset:k,length:R,parent:u})},onObjectEnd:(f,k)=>{u.length=f+k-u.offset,u=u.parent,o(f+k)},onArrayBegin:(f,k)=>{u=a({type:"array",offset:f,length:-1,parent:u,children:[]})},onArrayEnd:(f,k)=>{u.length=f+k-u.offset,u=u.parent,o(f+k)},onLiteralValue:(f,k,R)=>{a({type:w(f),offset:k,length:R,parent:u,value:f}),o(k+R)},onSeparator:(f,k,R)=>{u.type==="property"&&(f===":"?u.colonOffset=k:f===","&&o(k))},onError:(f,k,R)=>{r.push({error:f,offset:k,length:R})}},l);const i=u.children[0];return i&&delete i.parent,i}e.parseTree=D;function v(s,r){if(!s)return;let l=s;for(const u of r)if(typeof u=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let o=!1;for(const a of l.children)if(Array.isArray(a.children)&&a.children[0].value===u){l=a.children[1],o=!0;break}if(!o)return}else{const o=u;if(l.type!=="array"||o<0||!Array.isArray(l.children)||o>=l.children.length)return;l=l.children[o]}return l}e.findNodeAtLocation=v;function d(s){if(!s.parent||!s.parent.children)return[];const r=d(s.parent);if(s.parent.type==="property"){const l=s.parent.children[0].value;r.push(l)}else if(s.parent.type==="array"){const l=s.parent.children.indexOf(s);l!==-1&&r.push(l)}return r}e.getNodePath=d;function m(s){switch(s.type){case"array":return s.children.map(m);case"object":{const r=Object.create(null);for(const l of s.children){const u=l.children[1];u&&(r[l.children[0].value]=m(u))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=m;function h(s,r,l=!1){return r>=s.offset&&r<s.offset+s.length||l&&r===s.offset+s.length}e.contains=h;function b(s,r,l=!1){if(h(s,r,l)){const u=s.children;if(Array.isArray(u))for(let o=0;o<u.length&&u[o].offset<=r;o++){const a=b(u[o],r,l);if(a)return a}return s}}e.findNodeAtOffset=b;function p(s,r,l=A.DEFAULT){const u=C(s,!1);function o(te){return te?()=>te(u.getTokenOffset(),u.getTokenLength()):()=>!0}function a(te){return te?le=>te(le,u.getTokenOffset(),u.getTokenLength()):()=>!0}const n=o(r.onObjectBegin),i=a(r.onObjectProperty),f=o(r.onObjectEnd),k=o(r.onArrayBegin),R=o(r.onArrayEnd),B=a(r.onLiteralValue),X=a(r.onSeparator),q=o(r.onComment),N=a(r.onError),M=l&&l.disallowComments,F=l&&l.allowTrailingComma;function z(){for(;;){const te=u.scan();switch(u.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:M||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(te){case 12:case 13:M?U(10):q();break;case 16:U(1);break;case 15:case 14:break;default:return te}}}function U(te,le=[],Z=[]){if(N(te),le.length+Z.length>0){let ge=u.getToken();for(;ge!==17;){if(le.indexOf(ge)!==-1){z();break}else if(Z.indexOf(ge)!==-1)break;ge=z()}}}function W(te){const le=u.getTokenValue();return te?B(le):i(le),z(),!0}function x(){switch(u.getToken()){case 11:{let te=0;try{te=JSON.parse(u.getTokenValue()),typeof te!="number"&&(U(2),te=0)}catch{U(2)}B(te);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return z(),!0}function V(){return u.getToken()!==10?(U(3,[],[2,5]),!1):(W(!1),u.getToken()===6?(X(":"),z(),J()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function _(){n(),z();let te=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(te||U(4,[],[]),X(","),z(),u.getToken()===2&&F)break}else te&&U(6,[],[]);V()||U(4,[],[2,5]),te=!0}return f(),u.getToken()!==2?U(7,[2],[]):z(),!0}function Q(){k(),z();let te=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(te||U(4,[],[]),X(","),z(),u.getToken()===4&&F)break}else te&&U(6,[],[]);J()||U(4,[],[4,5]),te=!0}return R(),u.getToken()!==4?U(8,[4],[]):z(),!0}function J(){switch(u.getToken()){case 3:return Q();case 1:return _();case 10:return W(!0);default:return x()}}return z(),u.getToken()===17?l.allowEmptyContent?!0:(U(4,[],[]),!1):J()?(u.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=p;function g(s,r){const l=C(s),u=[];let o,a=0,n;do switch(n=l.getPosition(),o=l.scan(),o){case 12:case 13:case 17:a!==n&&u.push(s.substring(a,n)),r!==void 0&&u.push(l.getTokenValue().replace(/[^\r\n]/g,r)),a=l.getPosition();break}while(o!==17);return u.join("")}e.stripComments=g;function w(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(Se[81],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(I){this.d=I,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(I){this.c=I}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(I){return new c(()=>I(this.getValue()))}}e.Lazy=c}),define(Se[6],ye([1,0,61,62]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let A=null;function C(a){A=a}if(e.setDisposableTracker=C,I){const a="__is_disposable_tracked__";C(new class{trackDisposable(n){const i=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[a]||console.log(i)},3e3)}setParent(n,i){if(n&&n!==b.None)try{n[a]=!0}catch{}}markAsDisposed(n){if(n&&n!==b.None)try{n[a]=!0}catch{}}markAsSingleton(n){}})}function T(a){return A?.trackDisposable(a),a}function S(a){A?.markAsDisposed(a)}function y(a,n){A?.setParent(a,n)}function L(a,n){if(!!A)for(const i of a)A.setParent(i,n)}function P(a){return A?.markAsSingleton(a),a}e.markAsSingleton=P;function E(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=E;function D(a){if(t.Iterable.is(a)){const n=[];for(const i of a)if(i)try{i.dispose()}catch(f){n.push(f)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=D;function v(a){for(const n of a)E(n)&&n.dispose();return[]}e.disposeIfDisposable=v;function d(...a){const n=m(()=>D(a));return L(a,n),n}e.combinedDisposable=d;function m(a){const n=T({dispose:(0,c.once)(()=>{S(n),a()})});return n}e.toDisposable=m;class h{constructor(){this.c=new Set,this.f=!1,T(this)}dispose(){this.f||(S(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{D(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return y(n,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this.q=new h,T(this),y(this.q,this)}dispose(){S(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class p{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&y(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&y(n,null),n}}e.MutableDisposable=p;class g{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=g;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(n){let i=n;return this.unset=()=>i=void 0,this.isset=()=>i!==void 0,this.dispose=()=>{i&&(i(),i=void 0,S(this))},this}}e.SafeDisposable=w;class s{constructor(){this.a=new Map}acquire(n,...i){let f=this.a.get(n);f||(f={counter:0,object:this.b(n,...i)},this.a.set(n,f));const{object:k}=f,R=(0,c.once)(()=>{--f.counter===0&&(this.c(n,f.object),this.a.delete(n))});return f.counter++,{object:k,dispose:R}}}e.ReferenceCollection=s;class r{constructor(n){this.a=n}async acquire(n,...i){const f=this.a.acquire(n,...i);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(k){throw f.dispose(),k}}}e.AsyncReferenceCollection=r;class l{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=l;function u(a){const n=new h;try{a(n)}finally{n.dispose()}}e.disposeOnReturn=u;class o{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{D(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,i,f=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),f||this.a.get(n)?.dispose(),this.a.set(n,i)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(Se[63],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(A){this.element=A,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class t{constructor(){this.a=c.Undefined,this.b=c.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===c.Undefined}clear(){let A=this.a;for(;A!==c.Undefined;){const C=A.next;A.prev=c.Undefined,A.next=c.Undefined,A=C}this.a=c.Undefined,this.b=c.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,C){const T=new c(A);if(this.a===c.Undefined)this.a=T,this.b=T;else if(C){const y=this.b;this.b=T,T.prev=y,y.next=T}else{const y=this.a;this.a=T,T.next=y,y.prev=T}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(T))}}shift(){if(this.a!==c.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==c.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==c.Undefined&&A.next!==c.Undefined){const C=A.prev;C.next=A.next,A.next.prev=C}else A.prev===c.Undefined&&A.next===c.Undefined?(this.a=c.Undefined,this.b=c.Undefined):A.next===c.Undefined?(this.b=this.b.prev,this.b.next=c.Undefined):A.prev===c.Undefined&&(this.a=this.a.next,this.a.prev=c.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==c.Undefined;)yield A.element,A=A.next}}e.LinkedList=t}),define(Se[28],ye([1,0]),function(ne,e){"use strict";var c,t,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(v,d,m){let h=v.get(d);return h===void 0&&(h=m,v.set(d,h)),h}e.getOrSet=A;function C(v){const d=[];return v.forEach((m,h)=>{d.push(`${h} => ${m}`)}),`Map(${v.size}) {${d.join(", ")}}`}e.mapToString=C;function T(v){const d=[];return v.forEach(m=>{d.push(m)}),`Set(${v.size}) {${d.join(", ")}}`}e.setToString=T;class S{constructor(d,m){this.uri=d,this.value=m}}class y{constructor(d,m){this[c]="ResourceMap",d instanceof y?(this.b=new Map(d.b),this.c=m??y.a):(this.b=new Map,this.c=d??y.a)}set(d,m){return this.b.set(this.c(d),new S(d,m)),this}get(d){return this.b.get(this.c(d))?.value}has(d){return this.b.has(this.c(d))}get size(){return this.b.size}clear(){this.b.clear()}delete(d){return this.b.delete(this.c(d))}forEach(d,m){typeof m<"u"&&(d=d.bind(m));for(const[h,b]of this.b)d(b.value,b.uri,this)}*values(){for(const d of this.b.values())yield d.value}*keys(){for(const d of this.b.values())yield d.uri}*entries(){for(const d of this.b.values())yield[d.uri,d.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.b)yield[d.uri,d.value]}}e.ResourceMap=y,y.a=v=>v.toString();class L{constructor(d,m){this[t]="ResourceSet",!d||typeof d=="function"?this.a=new y(d):(this.a=new y(m),d.forEach(this.add,this))}get size(){return this.a.size}add(d){return this.a.set(d,d),this}clear(){this.a.clear()}delete(d){return this.a.delete(d)}forEach(d,m){this.a.forEach((h,b)=>d.call(m,b,b,this))}has(d){return this.a.has(d)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var P;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class E{constructor(){this[I]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(d){return this.a.has(d)}get(d,m=0){const h=this.a.get(d);if(!!h)return m!==0&&this.j(h,m),h.value}set(d,m,h=0){let b=this.a.get(d);if(b)b.value=m,h!==0&&this.j(b,h);else{switch(b={key:d,value:m,next:void 0,previous:void 0},h){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(d,b),this.d++}return this}delete(d){return!!this.remove(d)}remove(d){const m=this.a.get(d);if(!!m)return this.a.delete(d),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const d=this.b;return this.a.delete(d.key),this.i(d),this.d--,d.value}forEach(d,m){const h=this.e;let b=this.b;for(;b;){if(m?d.bind(m)(b.value,b.key,this):d(b.value,b.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const d=this,m=this.e;let h=this.b;const b={[Symbol.iterator](){return b},next(){if(d.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:h.key,done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return b}values(){const d=this,m=this.e;let h=this.b;const b={[Symbol.iterator](){return b},next(){if(d.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:h.value,done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return b}entries(){const d=this,m=this.e;let h=this.b;const b={[Symbol.iterator](){return b},next(){if(d.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const p={value:[h.key,h.value],done:!1};return h=h.next,p}else return{value:void 0,done:!0}}};return b}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(d){if(d>=this.size)return;if(d===0){this.clear();return}let m=this.b,h=this.size;for(;m&&h>d;)this.a.delete(m.key),m=m.next,h--;this.b=m,this.d=h,m&&(m.previous=void 0),this.e++}g(d){if(!this.b&&!this.c)this.c=d;else if(this.b)d.next=this.b,this.b.previous=d;else throw new Error("Invalid list");this.b=d,this.e++}h(d){if(!this.b&&!this.c)this.b=d;else if(this.c)d.previous=this.c,this.c.next=d;else throw new Error("Invalid list");this.c=d,this.e++}i(d){if(d===this.b&&d===this.c)this.b=void 0,this.c=void 0;else if(d===this.b){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.b=d.next}else if(d===this.c){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.c=d.previous}else{const m=d.next,h=d.previous;if(!m||!h)throw new Error("Invalid list");m.previous=h,h.next=m}d.next=void 0,d.previous=void 0,this.e++}j(d,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(d===this.b)return;const h=d.next,b=d.previous;d===this.c?(b.next=void 0,this.c=b):(h.previous=b,b.next=h),d.previous=void 0,d.next=this.b,this.b.previous=d,this.b=d,this.e++}else if(m===2){if(d===this.c)return;const h=d.next,b=d.previous;d===this.b?(h.previous=void 0,this.b=h):(h.previous=b,b.next=h),d.next=void 0,d.previous=this.c,this.c.next=d,this.c=d,this.e++}}}toJSON(){const d=[];return this.forEach((m,h)=>{d.push([h,m])}),d}fromJSON(d){this.clear();for(const[m,h]of d)this.set(m,h)}}e.LinkedMap=E;class D extends E{constructor(d,m=1){super(),this.k=d,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(d){this.k=d,this.m()}get ratio(){return this.l}set ratio(d){this.l=Math.min(Math.max(0,d),1),this.m()}get(d,m=2){return super.get(d,m)}peek(d){return super.get(d,0)}set(d,m){return super.set(d,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=D}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Se[147],ye([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(se,ue){for(var he=0;he<ue.length;he++){var ee=ue[he];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(se,ee.key,ee)}}function c(se,ue,he){return ue&&e(se.prototype,ue),he&&e(se,he),Object.defineProperty(se,"prototype",{writable:!1}),se}function t(se,ue){if(!!se){if(typeof se=="string")return I(se,ue);var he=Object.prototype.toString.call(se).slice(8,-1);if(he==="Object"&&se.constructor&&(he=se.constructor.name),he==="Map"||he==="Set")return Array.from(se);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return I(se,ue)}}function I(se,ue){(ue==null||ue>se.length)&&(ue=se.length);for(var he=0,ee=new Array(ue);he<ue;he++)ee[he]=se[he];return ee}function A(se,ue){var he=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(he)return(he=he.call(se)).next.bind(he);if(Array.isArray(se)||(he=t(se))||ue&&se&&typeof se.length=="number"){he&&(se=he);var ee=0;return function(){return ee>=se.length?{done:!0}:{done:!1,value:se[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=C();function T(se){ne.defaults=se}var S=/[&<>"']/,y=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},D=function(ue){return E[ue]};function v(se,ue){if(ue){if(S.test(se))return se.replace(y,D)}else if(L.test(se))return se.replace(P,D);return se}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(se){return se.replace(d,function(ue,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var h=/(^|[^\[])\^/g;function b(se,ue){se=typeof se=="string"?se:se.source,ue=ue||"";var he={replace:function(oe,ie){return ie=ie.source||ie,ie=ie.replace(h,"$1"),se=se.replace(oe,ie),he},getRegex:function(){return new RegExp(se,ue)}};return he}var p=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(se,ue,he){if(se){var ee;try{ee=decodeURIComponent(m(he)).replace(p,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ue&&!g.test(he)&&(he=o(ue,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var s={},r=/^[^:]+:\/*[^/]*$/,l=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(se,ue){s[" "+se]||(r.test(se)?s[" "+se]=se+"/":s[" "+se]=f(se,"/",!0)),se=s[" "+se];var he=se.indexOf(":")===-1;return ue.substring(0,2)==="//"?he?ue:se.replace(l,"$1")+ue:ue.charAt(0)==="/"?he?ue:se.replace(u,"$1")+ue:se+ue}var a={exec:function(){}};function n(se){for(var ue=1,he,ee;ue<arguments.length;ue++){he=arguments[ue];for(ee in he)Object.prototype.hasOwnProperty.call(he,ee)&&(se[ee]=he[ee])}return se}function i(se,ue){var he=se.replace(/\|/g,function(ie,O,H){for(var K=!1,Y=O;--Y>=0&&H[Y]==="\\";)K=!K;return K?"|":" |"}),ee=he.split(/ \|/),oe=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ue)ee.splice(ue);else for(;ee.length<ue;)ee.push("");for(;oe<ee.length;oe++)ee[oe]=ee[oe].trim().replace(/\\\|/g,"|");return ee}function f(se,ue,he){var ee=se.length;if(ee===0)return"";for(var oe=0;oe<ee;){var ie=se.charAt(ee-oe-1);if(ie===ue&&!he)oe++;else if(ie!==ue&&he)oe++;else break}return se.slice(0,ee-oe)}function k(se,ue){if(se.indexOf(ue[1])===-1)return-1;for(var he=se.length,ee=0,oe=0;oe<he;oe++)if(se[oe]==="\\")oe++;else if(se[oe]===ue[0])ee++;else if(se[oe]===ue[1]&&(ee--,ee<0))return oe;return-1}function R(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function B(se,ue){if(ue<1)return"";for(var he="";ue>1;)ue&1&&(he+=se),ue>>=1,se+=se;return he+se}function X(se,ue,he,ee){var oe=ue.href,ie=ue.title?v(ue.title):null,O=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){ee.state.inLink=!0;var H={type:"link",raw:he,href:oe,title:ie,text:O,tokens:ee.inlineTokens(O)};return ee.state.inLink=!1,H}return{type:"image",raw:he,href:oe,title:ie,text:v(O)}}function q(se,ue){var he=se.match(/^(\s+)(?:```)/);if(he===null)return ue;var ee=he[1];return ue.split(`
`).map(function(oe){var ie=oe.match(/^\s+/);if(ie===null)return oe;var O=ie[0];return O.length>=ee.length?oe.slice(ee.length):oe}).join(`
`)}var N=function(){function se(he){this.options=he||ne.defaults}var ue=se.prototype;return ue.space=function(ee){var oe=this.rules.block.newline.exec(ee);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},ue.code=function(ee){var oe=this.rules.block.code.exec(ee);if(oe){var ie=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:f(ie,`
`)}}},ue.fences=function(ee){var oe=this.rules.block.fences.exec(ee);if(oe){var ie=oe[0],O=q(ie,oe[3]||"");return{type:"code",raw:ie,lang:oe[2]?oe[2].trim():oe[2],text:O}}},ue.heading=function(ee){var oe=this.rules.block.heading.exec(ee);if(oe){var ie=oe[2].trim();if(/#$/.test(ie)){var O=f(ie,"#");(this.options.pedantic||!O||/ $/.test(O))&&(ie=O.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:ie,tokens:this.lexer.inline(ie)}}},ue.hr=function(ee){var oe=this.rules.block.hr.exec(ee);if(oe)return{type:"hr",raw:oe[0]}},ue.blockquote=function(ee){var oe=this.rules.block.blockquote.exec(ee);if(oe){var ie=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},ue.list=function(ee){var oe=this.rules.block.list.exec(ee);if(oe){var ie,O,H,K,Y,de,be,Pe,pe,Ce,ke,je,Ge=oe[1].trim(),et=Ge.length>1,_e={type:"list",raw:"",ordered:et,start:et?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=et?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=et?Ge:"[*+-]");for(var nt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(je=!1,!(!(oe=nt.exec(ee))||this.rules.block.hr.test(ee)));){if(ie=oe[0],ee=ee.substring(ie.length),Pe=oe[2].split(`
`,1)[0],pe=ee.split(`
`,1)[0],this.options.pedantic?(K=2,ke=Pe.trimLeft()):(K=oe[2].search(/[^ ]/),K=K>4?1:K,ke=Pe.slice(K),K+=oe[1].length),de=!1,!Pe&&/^ *$/.test(pe)&&(ie+=pe+`
`,ee=ee.substring(pe.length+1),je=!0),!je)for(var st=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");ee&&(Ce=ee.split(`
`,1)[0],Pe=Ce,this.options.pedantic&&(Pe=Pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(Pe)||it.test(Pe)||st.test(Pe)||ht.test(ee)));){if(Pe.search(/[^ ]/)>=K||!Pe.trim())ke+=`
`+Pe.slice(K);else if(!de)ke+=`
`+Pe;else break;!de&&!Pe.trim()&&(de=!0),ie+=Ce+`
`,ee=ee.substring(Ce.length+1)}_e.loose||(be?_e.loose=!0:/\n *\n *$/.test(ie)&&(be=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(ke),O&&(H=O[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),_e.items.push({type:"list_item",raw:ie,task:!!O,checked:H,loose:!1,text:ke}),_e.raw+=ie}_e.items[_e.items.length-1].raw=ie.trimRight(),_e.items[_e.items.length-1].text=ke.trimRight(),_e.raw=_e.raw.trimRight();var ae=_e.items.length;for(Y=0;Y<ae;Y++){this.lexer.state.top=!1,_e.items[Y].tokens=this.lexer.blockTokens(_e.items[Y].text,[]);var $=_e.items[Y].tokens.filter(function(Ie){return Ie.type==="space"}),ce=$.every(function(Ie){for(var Le=Ie.raw.split(""),Be=0,xe=A(Le),Ze;!(Ze=xe()).done;){var mt=Ze.value;if(mt===`
`&&(Be+=1),Be>1)return!0}return!1});!_e.loose&&$.length&&ce&&(_e.loose=!0,_e.items[Y].loose=!0)}return _e}},ue.html=function(ee){var oe=this.rules.block.html.exec(ee);if(oe){var ie={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(oe[0]):v(oe[0]);ie.type="paragraph",ie.text=O,ie.tokens=this.lexer.inline(O)}return ie}},ue.def=function(ee){var oe=this.rules.block.def.exec(ee);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var ie=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:oe[0],href:oe[2],title:oe[3]}}},ue.table=function(ee){var oe=this.rules.block.table.exec(ee);if(oe){var ie={type:"table",header:i(oe[1]).map(function(be){return{text:be}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=oe[0];var O=ie.align.length,H,K,Y,de;for(H=0;H<O;H++)/^ *-+: *$/.test(ie.align[H])?ie.align[H]="right":/^ *:-+: *$/.test(ie.align[H])?ie.align[H]="center":/^ *:-+ *$/.test(ie.align[H])?ie.align[H]="left":ie.align[H]=null;for(O=ie.rows.length,H=0;H<O;H++)ie.rows[H]=i(ie.rows[H],ie.header.length).map(function(be){return{text:be}});for(O=ie.header.length,K=0;K<O;K++)ie.header[K].tokens=this.lexer.inline(ie.header[K].text);for(O=ie.rows.length,K=0;K<O;K++)for(de=ie.rows[K],Y=0;Y<de.length;Y++)de[Y].tokens=this.lexer.inline(de[Y].text);return ie}}},ue.lheading=function(ee){var oe=this.rules.block.lheading.exec(ee);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},ue.paragraph=function(ee){var oe=this.rules.block.paragraph.exec(ee);if(oe){var ie=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:ie,tokens:this.lexer.inline(ie)}}},ue.text=function(ee){var oe=this.rules.block.text.exec(ee);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},ue.escape=function(ee){var oe=this.rules.inline.escape.exec(ee);if(oe)return{type:"escape",raw:oe[0],text:v(oe[1])}},ue.tag=function(ee){var oe=this.rules.inline.tag.exec(ee);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):v(oe[0]):oe[0]}},ue.link=function(ee){var oe=this.rules.inline.link.exec(ee);if(oe){var ie=oe[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var O=f(ie.slice(0,-1),"\\");if((ie.length-O.length)%2===0)return}else{var H=k(oe[2],"()");if(H>-1){var K=oe[0].indexOf("!")===0?5:4,Y=K+oe[1].length+H;oe[2]=oe[2].substring(0,H),oe[0]=oe[0].substring(0,Y).trim(),oe[3]=""}}var de=oe[2],be="";if(this.options.pedantic){var Pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Pe&&(de=Pe[1],be=Pe[3])}else be=oe[3]?oe[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(ie)?de=de.slice(1):de=de.slice(1,-1)),X(oe,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:be&&be.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},ue.reflink=function(ee,oe){var ie;if((ie=this.rules.inline.reflink.exec(ee))||(ie=this.rules.inline.nolink.exec(ee))){var O=(ie[2]||ie[1]).replace(/\s+/g," ");if(O=oe[O.toLowerCase()],!O||!O.href){var H=ie[0].charAt(0);return{type:"text",raw:H,text:H}}return X(ie,O,ie[0],this.lexer)}},ue.emStrong=function(ee,oe,ie){ie===void 0&&(ie="");var O=this.rules.inline.emStrong.lDelim.exec(ee);if(!!O&&!(O[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=O[1]||O[2]||"";if(!H||H&&(ie===""||this.rules.inline.punctuation.exec(ie))){var K=O[0].length-1,Y,de,be=K,Pe=0,pe=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,oe=oe.slice(-1*ee.length+K);(O=pe.exec(oe))!=null;)if(Y=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!Y){if(de=Y.length,O[3]||O[4]){be+=de;continue}else if((O[5]||O[6])&&K%3&&!((K+de)%3)){Pe+=de;continue}if(be-=de,!(be>0)){if(de=Math.min(de,de+be+Pe),Math.min(K,de)%2){var Ce=ee.slice(1,K+O.index+de);return{type:"em",raw:ee.slice(0,K+O.index+de+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ke=ee.slice(2,K+O.index+de-1);return{type:"strong",raw:ee.slice(0,K+O.index+de+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},ue.codespan=function(ee){var oe=this.rules.inline.code.exec(ee);if(oe){var ie=oe[2].replace(/\n/g," "),O=/[^ ]/.test(ie),H=/^ /.test(ie)&&/ $/.test(ie);return O&&H&&(ie=ie.substring(1,ie.length-1)),ie=v(ie,!0),{type:"codespan",raw:oe[0],text:ie}}},ue.br=function(ee){var oe=this.rules.inline.br.exec(ee);if(oe)return{type:"br",raw:oe[0]}},ue.del=function(ee){var oe=this.rules.inline.del.exec(ee);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},ue.autolink=function(ee,oe){var ie=this.rules.inline.autolink.exec(ee);if(ie){var O,H;return ie[2]==="@"?(O=v(this.options.mangle?oe(ie[1]):ie[1]),H="mailto:"+O):(O=v(ie[1]),H=O),{type:"link",raw:ie[0],text:O,href:H,tokens:[{type:"text",raw:O,text:O}]}}},ue.url=function(ee,oe){var ie;if(ie=this.rules.inline.url.exec(ee)){var O,H;if(ie[2]==="@")O=v(this.options.mangle?oe(ie[0]):ie[0]),H="mailto:"+O;else{var K;do K=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(K!==ie[0]);O=v(ie[0]),ie[1]==="www."?H="http://"+O:H=O}return{type:"link",raw:ie[0],text:O,href:H,tokens:[{type:"text",raw:O,text:O}]}}},ue.inlineText=function(ee,oe){var ie=this.rules.inline.text.exec(ee);if(ie){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]):ie[0]:O=v(this.options.smartypants?oe(ie[0]):ie[0]),{type:"text",raw:ie[0],text:O}}},se}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=b(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=b(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=b(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=b(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=b(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=b(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=n({},M),M.gfm=n({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=b(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=b(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=n({},M.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:b(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=b(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=b(M._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=b(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=b(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=b(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=b(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=b(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=b(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=b(F.reflink).replace("label",F._label).replace("ref",M._label).getRegex(),F.nolink=b(F.nolink).replace("ref",M._label).getRegex(),F.reflinkSearch=b(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:b(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=b(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:b(F.br).replace("{2,}","*").getRegex(),text:b(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(se){var ue="",he,ee,oe=se.length;for(he=0;he<oe;he++)ee=se.charCodeAt(he),Math.random()>.5&&(ee="x"+ee.toString(16)),ue+="&#"+ee+";";return ue}var W=function(){function se(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||ne.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:M.normal,inline:F.normal};this.options.pedantic?(ee.block=M.pedantic,ee.inline=F.pedantic):this.options.gfm&&(ee.block=M.gfm,this.options.breaks?ee.inline=F.breaks:ee.inline=F.gfm),this.tokenizer.rules=ee}se.lex=function(ee,oe){var ie=new se(oe);return ie.lex(ee)},se.lexInline=function(ee,oe){var ie=new se(oe);return ie.inlineTokens(ee)};var ue=se.prototype;return ue.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},ue.blockTokens=function(ee,oe){var ie=this;oe===void 0&&(oe=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(be,Pe,pe){return Pe+"    ".repeat(pe.length)});for(var O,H,K,Y;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(be){return(O=be.call({lexer:ie},ee,oe))?(ee=ee.substring(O.raw.length),oe.push(O),!0):!1}))){if(O=this.tokenizer.space(ee)){ee=ee.substring(O.raw.length),O.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(O);continue}if(O=this.tokenizer.code(ee)){ee=ee.substring(O.raw.length),H=oe[oe.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+O.raw,H.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):oe.push(O);continue}if(O=this.tokenizer.fences(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.heading(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.hr(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.blockquote(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.list(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.html(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.def(ee)){ee=ee.substring(O.raw.length),H=oe[oe.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+O.raw,H.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.lheading(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(K=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var be=1/0,Pe=ee.slice(1),pe=void 0;ie.options.extensions.startBlock.forEach(function(Ce){pe=Ce.call({lexer:this},Pe),typeof pe=="number"&&pe>=0&&(be=Math.min(be,pe))}),be<1/0&&be>=0&&(K=ee.substring(0,be+1))}(),this.state.top&&(O=this.tokenizer.paragraph(K))){H=oe[oe.length-1],Y&&H.type==="paragraph"?(H.raw+=`
`+O.raw,H.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):oe.push(O),Y=K.length!==ee.length,ee=ee.substring(O.raw.length);continue}if(O=this.tokenizer.text(ee)){ee=ee.substring(O.raw.length),H=oe[oe.length-1],H&&H.type==="text"?(H.raw+=`
`+O.raw,H.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):oe.push(O);continue}if(ee){var de="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,oe},ue.inline=function(ee,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:ee,tokens:oe}),oe},ue.inlineTokens=function(ee,oe){var ie=this;oe===void 0&&(oe=[]);var O,H,K,Y=ee,de,be,Pe;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(Y))!=null;)pe.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(Y=Y.slice(0,de.index)+"["+B("a",de[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(Y))!=null;)Y=Y.slice(0,de.index)+"["+B("a",de[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(Y))!=null;)Y=Y.slice(0,de.index)+"++"+Y.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(be||(Pe=""),be=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(O=ke.call({lexer:ie},ee,oe))?(ee=ee.substring(O.raw.length),oe.push(O),!0):!1}))){if(O=this.tokenizer.escape(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.tag(ee)){ee=ee.substring(O.raw.length),H=oe[oe.length-1],H&&O.type==="text"&&H.type==="text"?(H.raw+=O.raw,H.text+=O.text):oe.push(O);continue}if(O=this.tokenizer.link(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(O.raw.length),H=oe[oe.length-1],H&&O.type==="text"&&H.type==="text"?(H.raw+=O.raw,H.text+=O.text):oe.push(O);continue}if(O=this.tokenizer.emStrong(ee,Y,Pe)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.codespan(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.br(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.del(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.autolink(ee,U)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(ee,U))){ee=ee.substring(O.raw.length),oe.push(O);continue}if(K=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,je=ee.slice(1),Ge=void 0;ie.options.extensions.startInline.forEach(function(et){Ge=et.call({lexer:this},je),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(K=ee.substring(0,ke+1))}(),O=this.tokenizer.inlineText(K,z)){ee=ee.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(Pe=O.raw.slice(-1)),be=!0,H=oe[oe.length-1],H&&H.type==="text"?(H.raw+=O.raw,H.text+=O.text):oe.push(O);continue}if(ee){var Ce="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return oe},c(se,null,[{key:"rules",get:function(){return{block:M,inline:F}}}]),se}(),x=function(){function se(he){this.options=he||ne.defaults}var ue=se.prototype;return ue.code=function(ee,oe,ie){var O=(oe||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(ee,O);H!=null&&H!==ee&&(ie=!0,ee=H)}return ee=ee.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+v(O,!0)+'">'+(ie?ee:v(ee,!0))+`</code></pre>
`:"<pre><code>"+(ie?ee:v(ee,!0))+`</code></pre>
`},ue.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ue.html=function(ee){return ee},ue.heading=function(ee,oe,ie,O){if(this.options.headerIds){var H=this.options.headerPrefix+O.slug(ie);return"<h"+oe+' id="'+H+'">'+ee+"</h"+oe+`>
`}return"<h"+oe+">"+ee+"</h"+oe+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(ee,oe,ie){var O=oe?"ol":"ul",H=oe&&ie!==1?' start="'+ie+'"':"";return"<"+O+H+`>
`+ee+"</"+O+`>
`},ue.listitem=function(ee){return"<li>"+ee+`</li>
`},ue.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(ee){return"<p>"+ee+`</p>
`},ue.table=function(ee,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+oe+`</table>
`},ue.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ue.tablecell=function(ee,oe){var ie=oe.header?"th":"td",O=oe.align?"<"+ie+' align="'+oe.align+'">':"<"+ie+">";return O+ee+("</"+ie+`>
`)},ue.strong=function(ee){return"<strong>"+ee+"</strong>"},ue.em=function(ee){return"<em>"+ee+"</em>"},ue.codespan=function(ee){return"<code>"+ee+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(ee){return"<del>"+ee+"</del>"},ue.link=function(ee,oe,ie){if(ee=w(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var O='<a href="'+v(ee)+'"';return oe&&(O+=' title="'+oe+'"'),O+=">"+ie+"</a>",O},ue.image=function(ee,oe,ie){if(ee=w(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var O='<img src="'+ee+'" alt="'+ie+'"';return oe&&(O+=' title="'+oe+'"'),O+=this.options.xhtml?"/>":">",O},ue.text=function(ee){return ee},se}(),V=function(){function se(){}var ue=se.prototype;return ue.strong=function(ee){return ee},ue.em=function(ee){return ee},ue.codespan=function(ee){return ee},ue.del=function(ee){return ee},ue.html=function(ee){return ee},ue.text=function(ee){return ee},ue.link=function(ee,oe,ie){return""+ie},ue.image=function(ee,oe,ie){return""+ie},ue.br=function(){return""},se}(),_=function(){function se(){this.seen={}}var ue=se.prototype;return ue.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(ee,oe){var ie=ee,O=0;if(this.seen.hasOwnProperty(ie)){O=this.seen[ee];do O++,ie=ee+"-"+O;while(this.seen.hasOwnProperty(ie))}return oe||(this.seen[ee]=O,this.seen[ie]=0),ie},ue.slug=function(ee,oe){oe===void 0&&(oe={});var ie=this.serialize(ee);return this.getNextSafeSlug(ie,oe.dryrun)},se}(),Q=function(){function se(he){this.options=he||ne.defaults,this.options.renderer=this.options.renderer||new x,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new _}se.parse=function(ee,oe){var ie=new se(oe);return ie.parse(ee)},se.parseInline=function(ee,oe){var ie=new se(oe);return ie.parseInline(ee)};var ue=se.prototype;return ue.parse=function(ee,oe){oe===void 0&&(oe=!0);var ie="",O,H,K,Y,de,be,Pe,pe,Ce,ke,je,Ge,et,_e,nt,st,ht,Fe,it,ae=ee.length;for(O=0;O<ae;O++){if(ke=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(it=this.options.extensions.renderers[ke.type].call({parser:this},ke),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ie+=it||"";continue}switch(ke.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,m(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(pe="",Pe="",Y=ke.header.length,H=0;H<Y;H++)Pe+=this.renderer.tablecell(this.parseInline(ke.header[H].tokens),{header:!0,align:ke.align[H]});for(pe+=this.renderer.tablerow(Pe),Ce="",Y=ke.rows.length,H=0;H<Y;H++){for(be=ke.rows[H],Pe="",de=be.length,K=0;K<de;K++)Pe+=this.renderer.tablecell(this.parseInline(be[K].tokens),{header:!1,align:ke.align[K]});Ce+=this.renderer.tablerow(Pe)}ie+=this.renderer.table(pe,Ce);continue}case"blockquote":{Ce=this.parse(ke.tokens),ie+=this.renderer.blockquote(Ce);continue}case"list":{for(je=ke.ordered,Ge=ke.start,et=ke.loose,Y=ke.items.length,Ce="",H=0;H<Y;H++)nt=ke.items[H],st=nt.checked,ht=nt.task,_e="",nt.task&&(Fe=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Fe+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Fe+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Fe}):_e+=Fe),_e+=this.parse(nt.tokens,et),Ce+=this.renderer.listitem(_e,ht,st);ie+=this.renderer.list(Ce,je,Ge);continue}case"html":{ie+=this.renderer.html(ke.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Ce=ke.tokens?this.parseInline(ke.tokens):ke.text;O+1<ae&&ee[O+1].type==="text";)ke=ee[++O],Ce+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ie+=oe?this.renderer.paragraph(Ce):Ce;continue}default:{var $='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error($);return}else throw new Error($)}}}return ie},ue.parseInline=function(ee,oe){oe=oe||this.renderer;var ie="",O,H,K,Y=ee.length;for(O=0;O<Y;O++){if(H=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(K=this.options.extensions.renderers[H.type].call({parser:this},H),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){ie+=K||"";continue}switch(H.type){case"escape":{ie+=oe.text(H.text);break}case"html":{ie+=oe.html(H.text);break}case"link":{ie+=oe.link(H.href,H.title,this.parseInline(H.tokens,oe));break}case"image":{ie+=oe.image(H.href,H.title,H.text);break}case"strong":{ie+=oe.strong(this.parseInline(H.tokens,oe));break}case"em":{ie+=oe.em(this.parseInline(H.tokens,oe));break}case"codespan":{ie+=oe.codespan(H.text);break}case"br":{ie+=oe.br();break}case"del":{ie+=oe.del(this.parseInline(H.tokens,oe));break}case"text":{ie+=oe.text(H.text);break}default:{var de='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return ie},se}();function J(se,ue,he){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof ue=="function"&&(he=ue,ue=null),ue=n({},J.defaults,ue||{}),R(ue),he){var ee=ue.highlight,oe;try{oe=W.lex(se,ue)}catch(Y){return he(Y)}var ie=function(de){var be;if(!de)try{ue.walkTokens&&J.walkTokens(oe,ue.walkTokens),be=Q.parse(oe,ue)}catch(Pe){de=Pe}return ue.highlight=ee,de?he(de):he(null,be)};if(!ee||ee.length<3||(delete ue.highlight,!oe.length))return ie();var O=0;J.walkTokens(oe,function(Y){Y.type==="code"&&(O++,setTimeout(function(){ee(Y.text,Y.lang,function(de,be){if(de)return ie(de);be!=null&&be!==Y.text&&(Y.text=be,Y.escaped=!0),O--,O===0&&ie()})},0))}),O===0&&ie();return}function H(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+v(Y.message+"",!0)+"</pre>";throw Y}try{var K=W.lex(se,ue);if(ue.walkTokens){if(ue.async)return Promise.all(J.walkTokens(K,ue.walkTokens)).then(function(){return Q.parse(K,ue)}).catch(H);J.walkTokens(K,ue.walkTokens)}return Q.parse(K,ue)}catch(Y){H(Y)}}J.options=J.setOptions=function(se){return n(J.defaults,se),T(J.defaults),J},J.getDefaults=C,J.defaults=ne.defaults,J.use=function(){for(var se=arguments.length,ue=new Array(se),he=0;he<se;he++)ue[he]=arguments[he];var ee=n.apply(void 0,[{}].concat(ue)),oe=J.defaults.extensions||{renderers:{},childTokens:{}},ie;ue.forEach(function(O){if(O.extensions&&(ie=!0,O.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var Y=oe.renderers?oe.renderers[K.name]:null;Y?oe.renderers[K.name]=function(){for(var de=arguments.length,be=new Array(de),Pe=0;Pe<de;Pe++)be[Pe]=arguments[Pe];var pe=K.renderer.apply(this,be);return pe===!1&&(pe=Y.apply(this,be)),pe}:oe.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[K.level]?oe[K.level].unshift(K.tokenizer):oe[K.level]=[K.tokenizer],K.start&&(K.level==="block"?oe.startBlock?oe.startBlock.push(K.start):oe.startBlock=[K.start]:K.level==="inline"&&(oe.startInline?oe.startInline.push(K.start):oe.startInline=[K.start]))}K.childTokens&&(oe.childTokens[K.name]=K.childTokens)})),O.renderer&&function(){var K=J.defaults.renderer||new x,Y=function(Pe){var pe=K[Pe];K[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),je=0;je<Ce;je++)ke[je]=arguments[je];var Ge=O.renderer[Pe].apply(K,ke);return Ge===!1&&(Ge=pe.apply(K,ke)),Ge}};for(var de in O.renderer)Y(de);ee.renderer=K}(),O.tokenizer&&function(){var K=J.defaults.tokenizer||new N,Y=function(Pe){var pe=K[Pe];K[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),je=0;je<Ce;je++)ke[je]=arguments[je];var Ge=O.tokenizer[Pe].apply(K,ke);return Ge===!1&&(Ge=pe.apply(K,ke)),Ge}};for(var de in O.tokenizer)Y(de);ee.tokenizer=K}(),O.walkTokens){var H=J.defaults.walkTokens;ee.walkTokens=function(K){var Y=[];return Y.push(O.walkTokens.call(this,K)),H&&(Y=Y.concat(H.call(this,K))),Y}}ie&&(ee.extensions=oe),J.setOptions(ee)})},J.walkTokens=function(se,ue){for(var he=[],ee=function(){var H=ie.value;switch(he=he.concat(ue.call(J,H)),H.type){case"table":{for(var K=A(H.header),Y;!(Y=K()).done;){var de=Y.value;he=he.concat(J.walkTokens(de.tokens,ue))}for(var be=A(H.rows),Pe;!(Pe=be()).done;)for(var pe=Pe.value,Ce=A(pe),ke;!(ke=Ce()).done;){var je=ke.value;he=he.concat(J.walkTokens(je.tokens,ue))}break}case"list":{he=he.concat(J.walkTokens(H.items,ue));break}default:J.defaults.extensions&&J.defaults.extensions.childTokens&&J.defaults.extensions.childTokens[H.type]?J.defaults.extensions.childTokens[H.type].forEach(function(Ge){he=he.concat(J.walkTokens(H[Ge],ue))}):H.tokens&&(he=he.concat(J.walkTokens(H.tokens,ue)))}},oe=A(se),ie;!(ie=oe()).done;)ee();return he},J.parseInline=function(se,ue){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");ue=n({},J.defaults,ue||{}),R(ue);try{var he=W.lexInline(se,ue);return ue.walkTokens&&J.walkTokens(he,ue.walkTokens),Q.parseInline(he,ue)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+v(ee.message+"",!0)+"</pre>";throw ee}},J.Parser=Q,J.parser=Q.parse,J.Renderer=x,J.TextRenderer=V,J.Lexer=W,J.lexer=W.lex,J.Tokenizer=N,J.Slugger=_,J.parse=J;var te=J.options,le=J.setOptions,Z=J.use,ge=J.walkTokens,ve=J.parseInline,De=J,Re=Q.parse,ze=W.lex;ne.Lexer=W,ne.Parser=Q,ne.Renderer=x,ne.Slugger=_,ne.TextRenderer=V,ne.Tokenizer=N,ne.getDefaults=C,ne.lexer=ze,ne.marked=J,ne.options=te,ne.parse=De,ne.parseInline=ve,ne.parser=Re,ne.setOptions=le,ne.use=Z,ne.walkTokens=ge,Object.defineProperty(ne,"__esModule",{value:!0})}),define(Se[82],ye([1,0,28]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new c.LRUCache(1e4);function I(y){return S(y,"NFC",t)}e.normalizeNFC=I;const A=new c.LRUCache(1e4);function C(y){return S(y,"NFD",A)}e.normalizeNFD=C;const T=/[^\u0000-\u0080]/;function S(y,L,P){if(!y)return y;const E=P.get(y);if(E)return E;let D;return T.test(y)?D=y.normalize(L):D=y,P.set(y,D),D}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(L){return C(L).replace(y,"")}}()}),define(Se[100],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(T,S,y){return Math.min(Math.max(T,S),y)}e.clamp=c;function t(T,S){return(S+T%S)%S}e.rot=t;class I{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=I;class A{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class C{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const y=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function ne(I){const A=[];typeof I=="number"&&A.push("code/timeOrigin",I);function C(S){A.push(S,Date.now())}function T(){const S=[];for(let y=0;y<A.length;y+=2)S.push({name:A[y],startTime:A[y+1]});return S}return{mark:C,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const C of performance.getEntriesByType("mark"))A.push({name:C.name,startTime:Math.round(I+C.startTime)});return A}};if(typeof process=="object"){const I=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function c(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=c(t))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var t in c)(typeof exports=="object"?exports:ne)[t]=c[t]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function c(t){if(e[t])return e[t].exports;var I=e[t]={i:t,l:!1,exports:{}};return ne[t].call(I.exports,I,I.exports,c),I.l=!0,I.exports}return c.m=ne,c.c=e,c.d=function(t,I,A){c.o(t,I)||Object.defineProperty(t,I,{enumerable:!0,get:A})},c.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},c.t=function(t,I){if(1&I&&(t=c(t)),8&I||4&I&&typeof t=="object"&&t&&t.__esModule)return t;var A=Object.create(null);if(c.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:t}),2&I&&typeof t!="string")for(var C in t)c.d(A,C,function(T){return t[T]}.bind(null,C));return A},c.n=function(t){var I=t&&t.__esModule?function(){return t.default}:function(){return t};return c.d(I,"a",I),I},c.o=function(t,I){return Object.prototype.hasOwnProperty.call(t,I)},c.p="",c(c.s=0)}([function(ne,e,c){(function(t){var I;e=ne.exports=Z,I=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var pe=Array.prototype.slice.call(arguments,0);pe.unshift("SEMVER"),console.log.apply(console,pe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],S=e.src=[],y=0,L=y++;S[L]="0|[1-9]\\d*";var P=y++;S[P]="[0-9]+";var E=y++;S[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=y++;S[D]="("+S[L]+")\\.("+S[L]+")\\.("+S[L]+")";var v=y++;S[v]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var d=y++;S[d]="(?:"+S[L]+"|"+S[E]+")";var m=y++;S[m]="(?:"+S[P]+"|"+S[E]+")";var h=y++;S[h]="(?:-("+S[d]+"(?:\\."+S[d]+")*))";var b=y++;S[b]="(?:-?("+S[m]+"(?:\\."+S[m]+")*))";var p=y++;S[p]="[0-9A-Za-z-]+";var g=y++;S[g]="(?:\\+("+S[p]+"(?:\\."+S[p]+")*))";var w=y++,s="v?"+S[D]+S[h]+"?"+S[g]+"?";S[w]="^"+s+"$";var r="[v=\\s]*"+S[v]+S[b]+"?"+S[g]+"?",l=y++;S[l]="^"+r+"$";var u=y++;S[u]="((?:<|>)?=?)";var o=y++;S[o]=S[P]+"|x|X|\\*";var a=y++;S[a]=S[L]+"|x|X|\\*";var n=y++;S[n]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[h]+")?"+S[g]+"?)?)?";var i=y++;S[i]="[v=\\s]*("+S[o]+")(?:\\.("+S[o]+")(?:\\.("+S[o]+")(?:"+S[b]+")?"+S[g]+"?)?)?";var f=y++;S[f]="^"+S[u]+"\\s*"+S[n]+"$";var k=y++;S[k]="^"+S[u]+"\\s*"+S[i]+"$";var R=y++;S[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=y++;S[B]="(?:~>?)";var X=y++;S[X]="(\\s*)"+S[B]+"\\s+",T[X]=new RegExp(S[X],"g");var q=y++;S[q]="^"+S[B]+S[n]+"$";var N=y++;S[N]="^"+S[B]+S[i]+"$";var M=y++;S[M]="(?:\\^)";var F=y++;S[F]="(\\s*)"+S[M]+"\\s+",T[F]=new RegExp(S[F],"g");var z=y++;S[z]="^"+S[M]+S[n]+"$";var U=y++;S[U]="^"+S[M]+S[i]+"$";var W=y++;S[W]="^"+S[u]+"\\s*("+r+")$|^$";var x=y++;S[x]="^"+S[u]+"\\s*("+s+")$|^$";var V=y++;S[V]="(\\s*)"+S[u]+"\\s*("+r+"|"+S[n]+")",T[V]=new RegExp(S[V],"g");var _=y++;S[_]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var Q=y++;S[Q]="^\\s*("+S[i]+")\\s+-\\s+("+S[i]+")\\s*$";var J=y++;S[J]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)I(te,S[te]),T[te]||(T[te]=new RegExp(S[te]));function le(pe,Ce){if(pe instanceof Z)return pe;if(typeof pe!="string"||pe.length>A||!(Ce?T[l]:T[w]).test(pe))return null;try{return new Z(pe,Ce)}catch{return null}}function Z(pe,Ce){if(pe instanceof Z){if(pe.loose===Ce)return pe;pe=pe.version}else if(typeof pe!="string")throw new TypeError("Invalid Version: "+pe);if(pe.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Z))return new Z(pe,Ce);I("SemVer",pe,Ce),this.loose=Ce;var ke=pe.trim().match(Ce?T[l]:T[w]);if(!ke)throw new TypeError("Invalid Version: "+pe);if(this.raw=pe,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Ge=+je;if(Ge>=0&&Ge<C)return Ge}return je}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=le,e.valid=function(pe,Ce){var ke=le(pe,Ce);return ke?ke.version:null},e.clean=function(pe,Ce){var ke=le(pe.trim().replace(/^[=v]+/,""),Ce);return ke?ke.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(pe){return I("SemVer.compare",this.version,this.loose,pe),pe instanceof Z||(pe=new Z(pe,this.loose)),this.compareMain(pe)||this.comparePre(pe)},Z.prototype.compareMain=function(pe){return pe instanceof Z||(pe=new Z(pe,this.loose)),ve(this.major,pe.major)||ve(this.minor,pe.minor)||ve(this.patch,pe.patch)},Z.prototype.comparePre=function(pe){if(pe instanceof Z||(pe=new Z(pe,this.loose)),this.prerelease.length&&!pe.prerelease.length)return-1;if(!this.prerelease.length&&pe.prerelease.length)return 1;if(!this.prerelease.length&&!pe.prerelease.length)return 0;var Ce=0;do{var ke=this.prerelease[Ce],je=pe.prerelease[Ce];if(I("prerelease compare",Ce,ke,je),ke===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ke===void 0)return-1;if(ke!==je)return ve(ke,je)}while(++Ce)},Z.prototype.inc=function(pe,Ce){switch(pe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+pe)}return this.format(),this.raw=this.version,this},e.inc=function(pe,Ce,ke,je){typeof ke=="string"&&(je=ke,ke=void 0);try{return new Z(pe,ke).inc(Ce,je).version}catch{return null}},e.diff=function(pe,Ce){if(se(pe,Ce))return null;var ke=le(pe),je=le(Ce);if(ke.prerelease.length||je.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return Ge},e.compareIdentifiers=ve;var ge=/^[0-9]+$/;function ve(pe,Ce){var ke=ge.test(pe),je=ge.test(Ce);return ke&&je&&(pe=+pe,Ce=+Ce),ke&&!je?-1:je&&!ke?1:pe<Ce?-1:pe>Ce?1:0}function De(pe,Ce,ke){return new Z(pe,ke).compare(new Z(Ce,ke))}function Re(pe,Ce,ke){return De(pe,Ce,ke)>0}function ze(pe,Ce,ke){return De(pe,Ce,ke)<0}function se(pe,Ce,ke){return De(pe,Ce,ke)===0}function ue(pe,Ce,ke){return De(pe,Ce,ke)!==0}function he(pe,Ce,ke){return De(pe,Ce,ke)>=0}function ee(pe,Ce,ke){return De(pe,Ce,ke)<=0}function oe(pe,Ce,ke,je){var Ge;switch(Ce){case"===":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe===ke;break;case"!==":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe!==ke;break;case"":case"=":case"==":Ge=se(pe,ke,je);break;case"!=":Ge=ue(pe,ke,je);break;case">":Ge=Re(pe,ke,je);break;case">=":Ge=he(pe,ke,je);break;case"<":Ge=ze(pe,ke,je);break;case"<=":Ge=ee(pe,ke,je);break;default:throw new TypeError("Invalid operator: "+Ce)}return Ge}function ie(pe,Ce){if(pe instanceof ie){if(pe.loose===Ce)return pe;pe=pe.value}if(!(this instanceof ie))return new ie(pe,Ce);I("comparator",pe,Ce),this.loose=Ce,this.parse(pe),this.semver===O?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(pe,Ce){return ve(Ce,pe)},e.major=function(pe,Ce){return new Z(pe,Ce).major},e.minor=function(pe,Ce){return new Z(pe,Ce).minor},e.patch=function(pe,Ce){return new Z(pe,Ce).patch},e.compare=De,e.compareLoose=function(pe,Ce){return De(pe,Ce,!0)},e.rcompare=function(pe,Ce,ke){return De(Ce,pe,ke)},e.sort=function(pe,Ce){return pe.sort(function(ke,je){return e.compare(ke,je,Ce)})},e.rsort=function(pe,Ce){return pe.sort(function(ke,je){return e.rcompare(ke,je,Ce)})},e.gt=Re,e.lt=ze,e.eq=se,e.neq=ue,e.gte=he,e.lte=ee,e.cmp=oe,e.Comparator=ie;var O={};function H(pe,Ce){if(pe instanceof H)return pe.loose===Ce?pe:new H(pe.raw,Ce);if(pe instanceof ie)return new H(pe.value,Ce);if(!(this instanceof H))return new H(pe,Ce);if(this.loose=Ce,this.raw=pe,this.set=pe.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+pe);this.format()}function K(pe){return!pe||pe.toLowerCase()==="x"||pe==="*"}function Y(pe,Ce,ke,je,Ge,et,_e,nt,st,ht,Fe,it,ae){return((Ce=K(ke)?"":K(je)?">="+ke+".0.0":K(Ge)?">="+ke+"."+je+".0":">="+Ce)+" "+(nt=K(st)?"":K(ht)?"<"+(+st+1)+".0.0":K(Fe)?"<"+st+"."+(+ht+1)+".0":it?"<="+st+"."+ht+"."+Fe+"-"+it:"<="+nt)).trim()}function de(pe,Ce){for(var ke=0;ke<pe.length;ke++)if(!pe[ke].test(Ce))return!1;if(Ce.prerelease.length){for(ke=0;ke<pe.length;ke++)if(I(pe[ke].semver),pe[ke].semver!==O&&pe[ke].semver.prerelease.length>0){var je=pe[ke].semver;if(je.major===Ce.major&&je.minor===Ce.minor&&je.patch===Ce.patch)return!0}return!1}return!0}function be(pe,Ce,ke){try{Ce=new H(Ce,ke)}catch{return!1}return Ce.test(pe)}function Pe(pe,Ce,ke,je){var Ge,et,_e,nt,st;switch(pe=new Z(pe,je),Ce=new H(Ce,je),ke){case">":Ge=Re,et=ee,_e=ze,nt=">",st=">=";break;case"<":Ge=ze,et=he,_e=Re,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(pe,Ce,je))return!1;for(var ht=0;ht<Ce.set.length;++ht){var Fe=Ce.set[ht],it=null,ae=null;if(Fe.forEach(function($){$.semver===O&&($=new ie(">=0.0.0")),it=it||$,ae=ae||$,Ge($.semver,it.semver,je)?it=$:_e($.semver,ae.semver,je)&&(ae=$)}),it.operator===nt||it.operator===st||(!ae.operator||ae.operator===nt)&&et(pe,ae.semver)||ae.operator===st&&_e(pe,ae.semver))return!1}return!0}ie.prototype.parse=function(pe){var Ce=this.loose?T[W]:T[x],ke=pe.match(Ce);if(!ke)throw new TypeError("Invalid comparator: "+pe);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new Z(ke[2],this.loose):this.semver=O},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(pe){return I("Comparator.test",pe,this.loose),this.semver===O||(typeof pe=="string"&&(pe=new Z(pe,this.loose)),oe(pe,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(pe,Ce){if(!(pe instanceof ie))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new H(pe.value,Ce),be(this.value,ke,Ce);if(pe.operator==="")return ke=new H(this.value,Ce),be(pe.semver,ke,Ce);var je=!(this.operator!==">="&&this.operator!==">"||pe.operator!==">="&&pe.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||pe.operator!=="<="&&pe.operator!=="<"),et=this.semver.version===pe.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||pe.operator!==">="&&pe.operator!=="<="),nt=oe(this.semver,"<",pe.semver,Ce)&&(this.operator===">="||this.operator===">")&&(pe.operator==="<="||pe.operator==="<"),st=oe(this.semver,">",pe.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(pe.operator===">="||pe.operator===">");return je||Ge||et&&_e||nt||st},e.Range=H,H.prototype.format=function(){return this.range=this.set.map(function(pe){return pe.join(" ").trim()}).join("||").trim(),this.range},H.prototype.toString=function(){return this.range},H.prototype.parseRange=function(pe){var Ce=this.loose;pe=pe.trim(),I("range",pe,Ce);var ke=Ce?T[Q]:T[_];pe=pe.replace(ke,Y),I("hyphen replace",pe),pe=pe.replace(T[V],"$1$2$3"),I("comparator trim",pe,T[V]),pe=(pe=(pe=pe.replace(T[X],"$1~")).replace(T[F],"$1^")).split(/\s+/).join(" ");var je=Ce?T[W]:T[x],Ge=pe.split(" ").map(function(et){return function(_e,nt){return I("comp",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Fe){return function(it,ae){I("caret",it,ae);var $=ae?T[U]:T[z];return it.replace($,function(ce,Ie,Le,Be,xe){var Ze;return I("caret",it,ce,Ie,Le,Be,xe),K(Ie)?Ze="":K(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":K(Be)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":xe?(I("replaceCaret pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+xe+" <"+(+Ie+1)+".0.0"):(I("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+" <"+(+Ie+1)+".0.0"),I("caret return",Ze),Ze})}(Fe,ht)}).join(" ")}(_e,nt),I("caret",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Fe){return function(it,ae){var $=ae?T[N]:T[q];return it.replace($,function(ce,Ie,Le,Be,xe){var Ze;return I("tilde",it,ce,Ie,Le,Be,xe),K(Ie)?Ze="":K(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":K(Be)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":xe?(I("replaceTilde pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0",I("tilde return",Ze),Ze})}(Fe,ht)}).join(" ")}(_e,nt),I("tildes",_e),_e=function(st,ht){return I("replaceXRanges",st,ht),st.split(/\s+/).map(function(Fe){return function(it,ae){it=it.trim();var $=ae?T[k]:T[f];return it.replace($,function(ce,Ie,Le,Be,xe,Ze){I("xRange",it,ce,Ie,Le,Be,xe,Ze);var mt=K(Le),ft=mt||K(Be),lt=ft||K(xe);return Ie==="="&&lt&&(Ie=""),mt?ce=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&lt?(ft&&(Be=0),lt&&(xe=0),Ie===">"?(Ie=">=",ft?(Le=+Le+1,Be=0,xe=0):lt&&(Be=+Be+1,xe=0)):Ie==="<="&&(Ie="<",ft?Le=+Le+1:Be=+Be+1),ce=Ie+Le+"."+Be+"."+xe):ft?ce=">="+Le+".0.0 <"+(+Le+1)+".0.0":lt&&(ce=">="+Le+"."+Be+".0 <"+Le+"."+(+Be+1)+".0"),I("xRange return",ce),ce})}(Fe,ht)}).join(" ")}(_e,nt),I("xrange",_e),_e=function(st,ht){return I("replaceStars",st,ht),st.trim().replace(T[J],"")}(_e,nt),I("stars",_e),_e}(et,Ce)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(et){return!!et.match(je)})),Ge=Ge.map(function(et){return new ie(et,Ce)})},H.prototype.intersects=function(pe,Ce){if(!(pe instanceof H))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(je){return pe.set.some(function(Ge){return Ge.every(function(et){return je.intersects(et,Ce)})})})})},e.toComparators=function(pe,Ce){return new H(pe,Ce).set.map(function(ke){return ke.map(function(je){return je.value}).join(" ").trim().split(" ")})},H.prototype.test=function(pe){if(!pe)return!1;typeof pe=="string"&&(pe=new Z(pe,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(de(this.set[Ce],pe))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(pe,Ce,ke){var je=null,Ge=null;try{var et=new H(Ce,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==-1||(Ge=new Z(je=_e,ke)))}),je},e.minSatisfying=function(pe,Ce,ke){var je=null,Ge=null;try{var et=new H(Ce,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==1||(Ge=new Z(je=_e,ke)))}),je},e.validRange=function(pe,Ce){try{return new H(pe,Ce).range||"*"}catch{return null}},e.ltr=function(pe,Ce,ke){return Pe(pe,Ce,"<",ke)},e.gtr=function(pe,Ce,ke){return Pe(pe,Ce,">",ke)},e.outside=Pe,e.prerelease=function(pe,Ce){var ke=le(pe,Ce);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(pe,Ce,ke){return pe=new H(pe,ke),Ce=new H(Ce,ke),pe.intersects(Ce)},e.coerce=function(pe){if(pe instanceof Z)return pe;if(typeof pe!="string")return null;var Ce=pe.match(T[R]);return Ce==null?null:le((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,c(1))},function(ne,e){var c,t,I=ne.exports={};function A(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function T(m){if(c===setTimeout)return setTimeout(m,0);if((c===A||!c)&&setTimeout)return c=setTimeout,setTimeout(m,0);try{return c(m,0)}catch{try{return c.call(null,m,0)}catch{return c.call(this,m,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:A}catch{c=A}try{t=typeof clearTimeout=="function"?clearTimeout:C}catch{t=C}})();var S,y=[],L=!1,P=-1;function E(){L&&S&&(L=!1,S.length?y=S.concat(y):P=-1,y.length&&D())}function D(){if(!L){var m=T(E);L=!0;for(var h=y.length;h;){for(S=y,y=[];++P<h;)S&&S[P].run();P=-1,h=y.length}S=null,L=!1,function(b){if(t===clearTimeout)return clearTimeout(b);if((t===C||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(b);try{t(b)}catch{try{return t.call(null,b)}catch{return t.call(this,b)}}}(m)}}function v(m,h){this.fun=m,this.array=h}function d(){}I.nextTick=function(m){var h=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)h[b-1]=arguments[b];y.push(new v(m,h)),y.length!==1||L||T(D)},v.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=d,I.addListener=d,I.once=d,I.off=d,I.removeListener=d,I.removeAllListeners=d,I.emit=d,I.prependListener=d,I.prependOnceListener=d,I.listeners=function(m){return[]},I.binding=function(m){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(m){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Se[101],ye([1,0,10,6]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(g){const w=g;return w?typeof w.read=="function":!1}e.isReadable=I;function A(g){const w=g;return w?[w.on,w.pause,w.resume,w.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=A;function C(g){const w=g;return w?A(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=C;function T(g,w){return new S(g,w)}e.newWriteableStream=T;class S{constructor(w,s){this.e=w,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(s=>s(w))}h(w){this.c.error.length===0?(0,c.onUnexpectedError)(w):this.c.error.slice(0).forEach(s=>s(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,s){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(w,s){if(this.a.destroyed)return;let r;switch(w){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const l=r.indexOf(s);l>=0&&r.splice(l,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(g,w){const s=[];let r;for(;(r=g.read())!==null;)s.push(r);return w(s)}e.consumeReadable=y;function L(g,w,s){const r=[];let l;for(;(l=g.read())!==null&&r.length<s;)r.push(l);return l===null&&r.length>0?w(r):{read:()=>{if(r.length>0)return r.shift();if(typeof l<"u"){const u=l;return l=void 0,u}return g.read()}}}e.peekReadable=L;function P(g,w){return new Promise((s,r)=>{const l=[];E(g,{onData:u=>{w&&l.push(u)},onError:u=>{w?r(u):s(void 0)},onEnd:()=>{s(w?w(l):void 0)}})})}e.consumeStream=P;function E(g,w){let s=!1;return g.on("error",r=>{s||w.onError(r)}),g.on("end",()=>{s||w.onEnd()}),g.on("data",r=>{s||w.onData(r)}),(0,t.toDisposable)(()=>s=!0)}e.listenStream=E;function D(g,w){return new Promise((s,r)=>{const l=new t.DisposableStore,u=[],o=i=>{if(u.push(i),u.length>w)return l.dispose(),g.pause(),s({stream:g,buffer:u,ended:!1})},a=i=>r(i),n=()=>s({stream:g,buffer:u,ended:!0});l.add((0,t.toDisposable)(()=>g.removeListener("error",a))),g.on("error",a),l.add((0,t.toDisposable)(()=>g.removeListener("end",n))),g.on("end",n),l.add((0,t.toDisposable)(()=>g.removeListener("data",o))),g.on("data",o)})}e.peekStream=D;function v(g,w){const s=T(w);return s.end(g),s}e.toStream=v;function d(){const g=T(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=d;function m(g){let w=!1;return{read:()=>w?null:(w=!0,g)}}e.toReadable=m;function h(g,w,s){const r=T(s);return E(g,{onData:l=>r.write(w.data(l)),onError:l=>r.error(w.error?w.error(l):l),onEnd:()=>r.end()}),r}e.transform=h;function b(g,w,s){let r=!1;return{read:()=>{const l=w.read();return r?l:(r=!0,l!==null?s([g,l]):g)}}}e.prefixedReadable=b;function p(g,w,s){let r=!1;const l=T(s);return E(w,{onData:u=>r?l.write(u):(r=!0,l.write(s([g,u]))),onError:u=>l.error(u),onEnd:()=>{r||(r=!0,l.write(g)),l.end()}}),l}e.prefixedStream=p}),define(Se[22],ye([1,0,101]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let I,A;class C{static alloc(i){return t?new C(Buffer.allocUnsafe(i)):new C(new Uint8Array(i))}static wrap(i){return t&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new C(i)}static fromString(i,f){return!(f?.dontUseNodeBuffer||!1)&&t?new C(Buffer.from(i)):(I||(I=new TextEncoder),new C(I.encode(i)))}static fromByteArray(i){const f=C.alloc(i.length);for(let k=0,R=i.length;k<R;k++)f.buffer[k]=i[k];return f}static concat(i,f){if(typeof f>"u"){f=0;for(let B=0,X=i.length;B<X;B++)f+=i[B].byteLength}const k=C.alloc(f);let R=0;for(let B=0,X=i.length;B<X;B++){const q=i[B];k.set(q,R),R+=q.byteLength}return k}constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}clone(){const i=C.alloc(this.byteLength);return i.set(this),i}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(i,f){return new C(this.buffer.subarray(i,f))}set(i,f){if(i instanceof C)this.buffer.set(i.buffer,f);else if(i instanceof Uint8Array)this.buffer.set(i,f);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),f);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(i){return y(this.buffer,i)}writeUInt32BE(i,f){L(this.buffer,i,f)}readUInt32LE(i){return P(this.buffer,i)}writeUInt32LE(i,f){E(this.buffer,i,f)}readUInt8(i){return D(this.buffer,i)}writeUInt8(i,f){v(this.buffer,i,f)}}e.VSBuffer=C;function T(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0}e.readUInt16LE=T;function S(n,i,f){n[f+0]=i&255,i=i>>>8,n[f+1]=i&255}e.writeUInt16LE=S;function y(n,i){return n[i]*2**24+n[i+1]*2**16+n[i+2]*2**8+n[i+3]}e.readUInt32BE=y;function L(n,i,f){n[f+3]=i,i=i>>>8,n[f+2]=i,i=i>>>8,n[f+1]=i,i=i>>>8,n[f]=i}e.writeUInt32BE=L;function P(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0|n[i+2]<<16>>>0|n[i+3]<<24>>>0}e.readUInt32LE=P;function E(n,i,f){n[f+0]=i&255,i=i>>>8,n[f+1]=i&255,i=i>>>8,n[f+2]=i&255,i=i>>>8,n[f+3]=i&255}e.writeUInt32LE=E;function D(n,i){return n[i]}e.readUInt8=D;function v(n,i,f){n[f]=i}e.writeUInt8=v;function d(n){return c.consumeReadable(n,i=>C.concat(i))}e.readableToBuffer=d;function m(n){return c.toReadable(n)}e.bufferToReadable=m;function h(n){return c.consumeStream(n,i=>C.concat(i))}e.streamToBuffer=h;async function b(n){return n.ended?C.concat(n.buffer):C.concat([...n.buffer,await h(n.stream)])}e.bufferedStreamToBuffer=b;function p(n){return c.toStream(n,i=>C.concat(i))}e.bufferToStream=p;function g(n){return c.transform(n,{data:i=>typeof i=="string"?C.fromString(i):C.wrap(i)},i=>C.concat(i))}e.streamToBufferReadableStream=g;function w(n){return c.newWriteableStream(i=>C.concat(i),n)}e.newWriteableBufferStream=w;function s(n,i){return c.prefixedReadable(n,i,f=>C.concat(f))}e.prefixedBufferReadable=s;function r(n,i){return c.prefixedStream(n,i,f=>C.concat(f))}e.prefixedBufferStream=r;function l(n){let i=0,f=0,k=0;const R=new Uint8Array(Math.floor(n.length/4*3)),B=q=>{switch(f){case 3:R[k++]=i|q,f=0;break;case 2:R[k++]=i|q>>>2,i=q<<6,f=3;break;case 1:R[k++]=i|q>>>4,i=q<<4,f=2;break;default:i=q<<2,f=1}};for(let q=0;q<n.length;q++){const N=n.charCodeAt(q);if(N>=65&&N<=90)B(N-65);else if(N>=97&&N<=122)B(N-97+26);else if(N>=48&&N<=57)B(N-48+52);else if(N===43||N===45)B(62);else if(N===47||N===95)B(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${n[q]}`)}}const X=k;for(;f>0;)B(0);return C.wrap(R).slice(0,X)}e.decodeBase64=l;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:n},i=!0,f=!1){const k=f?o:u;let R="";const B=n.byteLength%3;let X=0;for(;X<n.byteLength-B;X+=3){const q=n[X+0],N=n[X+1],M=n[X+2];R+=k[q>>>2],R+=k[(q<<4|N>>>4)&63],R+=k[(N<<2|M>>>6)&63],R+=k[M&63]}if(B===1){const q=n[X+0];R+=k[q>>>2],R+=k[q<<4&63],i&&(R+="==")}else if(B===2){const q=n[X+0],N=n[X+1];R+=k[q>>>2],R+=k[(q<<4|N>>>4)&63],R+=k[N<<2&63],i&&(R+="=")}return R}e.encodeBase64=a}),define(Se[11],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(r){return typeof r=="string"}e.isString=c;function t(r){return Array.isArray(r)&&r.every(l=>c(l))}e.isStringArray=t;function I(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=I;function A(r){const l=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof l}e.isTypedArray=A;function C(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=C;function T(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=T;function S(r){return r===!0||r===!1}e.isBoolean=S;function y(r){return typeof r>"u"}e.isUndefined=y;function L(r){return!P(r)}e.isDefined=L;function P(r){return y(r)||r===null}e.isUndefinedOrNull=P;function E(r,l){if(!r)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=E;function D(r){if(P(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=D;function v(...r){const l=[];for(let u=0;u<r.length;u++){const o=r[u];if(P(o))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);l.push(o)}return l}e.assertAllDefined=v;const d=Object.prototype.hasOwnProperty;function m(r){if(!I(r))return!1;for(const l in r)if(d.call(r,l))return!1;return!0}e.isEmptyObject=m;function h(r){return typeof r=="function"}e.isFunction=h;function b(...r){return r.length>0&&r.every(h)}e.areFunctions=b;function p(r,l){const u=Math.min(r.length,l.length);for(let o=0;o<u;o++)g(r[o],l[o])}e.validateConstraints=p;function g(r,l){if(c(l)){if(typeof r!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(h(l)){try{if(r instanceof l)return}catch{}if(!P(r)&&r.constructor===l||l.length===1&&l.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=g;function w(r){return r===null?void 0:r}e.withNullAsUndefined=w;function s(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=s}),define(Se[23],ye([1,0,11]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const b=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([p,g])=>{b[p]=g&&typeof g=="object"?t(g):g}),b}e.deepClone=t;function I(h){if(!h||typeof h!="object")return h;const b=[h];for(;b.length>0;){const p=b.shift();Object.freeze(p);for(const g in p)if(A.call(p,g)){const w=p[g];typeof w=="object"&&!Object.isFrozen(w)&&!(0,c.isTypedArray)(w)&&b.push(w)}}return h}e.deepFreeze=I;const A=Object.prototype.hasOwnProperty;function C(h,b){return T(h,b,new Set)}e.cloneAndChange=C;function T(h,b,p){if((0,c.isUndefinedOrNull)(h))return h;const g=b(h);if(typeof g<"u")return g;if(Array.isArray(h)){const w=[];for(const s of h)w.push(T(s,b,p));return w}if((0,c.isObject)(h)){if(p.has(h))throw new Error("Cannot clone recursive data-structure");p.add(h);const w={};for(const s in h)A.call(h,s)&&(w[s]=T(h[s],b,p));return p.delete(h),w}return h}function S(h,b,p=!0){return(0,c.isObject)(h)?((0,c.isObject)(b)&&Object.keys(b).forEach(g=>{g in h?p&&((0,c.isObject)(h[g])&&(0,c.isObject)(b[g])?S(h[g],b[g],p):h[g]=b[g]):h[g]=b[g]}),h):b}e.mixin=S;function y(h,b){if(h===b)return!0;if(h==null||b===null||b===void 0||typeof h!=typeof b||typeof h!="object"||Array.isArray(h)!==Array.isArray(b))return!1;let p,g;if(Array.isArray(h)){if(h.length!==b.length)return!1;for(p=0;p<h.length;p++)if(!y(h[p],b[p]))return!1}else{const w=[];for(g in h)w.push(g);w.sort();const s=[];for(g in b)s.push(g);if(s.sort(),!y(w,s))return!1;for(p=0;p<w.length;p++)if(!y(h[w[p]],b[w[p]]))return!1}return!0}e.equals=y;function L(h){const b=new Set;return JSON.stringify(h,(p,g)=>{if((0,c.isObject)(g)||Array.isArray(g)){if(b.has(g))return"[Circular]";b.add(g)}return g})}e.safeStringify=L;function P(h,b){const p=Object.create(null);return!h||!b||Object.keys(b).forEach(w=>{const s=h[w],r=b[w];y(s,r)||(p[w]=r)}),p}e.distinct=P;function E(h,b){const p=b.toLowerCase(),g=Object.keys(h).find(w=>w.toLowerCase()===p);return g?h[g]:h[b]}e.getCaseInsensitive=E;function D(h,b){const p=Object.create(null);for(const[g,w]of Object.entries(h))b(g,w)&&(p[g]=w);return p}e.filter=D;function v(h){let b=[],p=Object.getPrototypeOf(h);for(;Object.prototype!==p;)b=b.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return b}e.getAllPropertyNames=v;function d(h){const b=[];for(const p of v(h))typeof h[p]=="function"&&b.push(p);return b}e.getAllMethodNames=d;function m(h,b){const p=w=>function(){const s=Array.prototype.slice.call(arguments,0);return b(w,s)},g={};for(const w of h)g[w]=p(w);return g}e.createProxyObject=m}),define(Se[102],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c=e.Constants||(e.Constants={}));function t(A){return A<0?0:A>255?255:A|0}e.toUint8=t;function I(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=I}),define(Se[30],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(I){return c.test(I)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(T){for(let S=0;S<T.length;S++)T[S]=Math.floor(Math.random()*256);return T};const A=new Uint8Array(16),C=[];for(let T=0;T<256;T++)C.push(T.toString(16).padStart(2,"0"));return function(){I(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,y="";return y+=C[A[S++]],y+=C[A[S++]],y+=C[A[S++]],y+=C[A[S++]],y+="-",y+=C[A[S++]],y+=C[A[S++]],y+="-",y+=C[A[S++]],y+=C[A[S++]],y+="-",y+=C[A[S++]],y+=C[A[S++]],y+="-",y+=C[A[S++]],y+=C[A[S++]],y+=C[A[S++]],y+=C[A[S++]],y+=C[A[S++]],y+=C[A[S++]],y}}()}),define(Se[148],ye([1,0,17,30]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function I(T){return{id:(0,t.generateUuid)(),asString:async()=>T,asFile:()=>{},value:typeof T=="string"?T:void 0}}e.createStringDataTransferItem=I;function A(T,S,y){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:T,uri:S,data:y}),value:void 0}}e.createFileDataTransferItem=A;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,y){const L=this.a.get(S);L?L.push(y):this.a.set(this.b(S),[y])}replace(S,y){this.a.set(this.b(S),[y])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,y]of this.a.entries())for(const L of y)yield[S,L]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[y,L]of this.entries())S(L,y)}b(S){return S.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:T=>(0,c.distinct)(T.map(S=>S.toString())).join(`\r
`),split:T=>T.split(`\r
`),parse:T=>e.UriList.split(T).filter(S=>!S.startsWith("#"))})}),define(Se[103],ye([1,0,102]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(T){const S=(0,c.toUint8)(T);this.c=S,this.a=t.d(S),this.b=new Map}static d(T){const S=new Uint8Array(256);return S.fill(T),S}set(T,S){const y=(0,c.toUint8)(S);T>=0&&T<256?this.a[T]=y:this.b.set(T,y)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=t;var I;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(I||(I={}));class A{constructor(){this.a=new t(0)}add(T){this.a.set(T,1)}has(T){return this.a.get(T)===1}clear(){return this.a.clear()}}e.CharacterSet=A}),define(Se[50],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(I,A){this.lineNumber=I,this.column=A}with(I=this.lineNumber,A=this.column){return I===this.lineNumber&&A===this.column?this:new c(I,A)}delta(I=0,A=0){return this.with(this.lineNumber+I,this.column+A)}equals(I){return c.equals(this,I)}static equals(I,A){return!I&&!A?!0:!!I&&!!A&&I.lineNumber===A.lineNumber&&I.column===A.column}isBefore(I){return c.isBefore(this,I)}static isBefore(I,A){return I.lineNumber<A.lineNumber?!0:A.lineNumber<I.lineNumber?!1:I.column<A.column}isBeforeOrEqual(I){return c.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,A){return I.lineNumber<A.lineNumber?!0:A.lineNumber<I.lineNumber?!1:I.column<=A.column}static compare(I,A){const C=I.lineNumber|0,T=A.lineNumber|0;if(C===T){const S=I.column|0,y=A.column|0;return S-y}return C-T}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new c(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=c}),define(Se[35],ye([1,0,50]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(A,C,T,S){A>T||A===T&&C>S?(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=A,this.endColumn=C):(this.startLineNumber=A,this.startColumn=C,this.endLineNumber=T,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return t.containsPosition(this,A)}static containsPosition(A,C){return!(C.lineNumber<A.startLineNumber||C.lineNumber>A.endLineNumber||C.lineNumber===A.startLineNumber&&C.column<A.startColumn||C.lineNumber===A.endLineNumber&&C.column>A.endColumn)}static strictContainsPosition(A,C){return!(C.lineNumber<A.startLineNumber||C.lineNumber>A.endLineNumber||C.lineNumber===A.startLineNumber&&C.column<=A.startColumn||C.lineNumber===A.endLineNumber&&C.column>=A.endColumn)}containsRange(A){return t.containsRange(this,A)}static containsRange(A,C){return!(C.startLineNumber<A.startLineNumber||C.endLineNumber<A.startLineNumber||C.startLineNumber>A.endLineNumber||C.endLineNumber>A.endLineNumber||C.startLineNumber===A.startLineNumber&&C.startColumn<A.startColumn||C.endLineNumber===A.endLineNumber&&C.endColumn>A.endColumn)}strictContainsRange(A){return t.strictContainsRange(this,A)}static strictContainsRange(A,C){return!(C.startLineNumber<A.startLineNumber||C.endLineNumber<A.startLineNumber||C.startLineNumber>A.endLineNumber||C.endLineNumber>A.endLineNumber||C.startLineNumber===A.startLineNumber&&C.startColumn<=A.startColumn||C.endLineNumber===A.endLineNumber&&C.endColumn>=A.endColumn)}plusRange(A){return t.plusRange(this,A)}static plusRange(A,C){let T,S,y,L;return C.startLineNumber<A.startLineNumber?(T=C.startLineNumber,S=C.startColumn):C.startLineNumber===A.startLineNumber?(T=C.startLineNumber,S=Math.min(C.startColumn,A.startColumn)):(T=A.startLineNumber,S=A.startColumn),C.endLineNumber>A.endLineNumber?(y=C.endLineNumber,L=C.endColumn):C.endLineNumber===A.endLineNumber?(y=C.endLineNumber,L=Math.max(C.endColumn,A.endColumn)):(y=A.endLineNumber,L=A.endColumn),new t(T,S,y,L)}intersectRanges(A){return t.intersectRanges(this,A)}static intersectRanges(A,C){let T=A.startLineNumber,S=A.startColumn,y=A.endLineNumber,L=A.endColumn;const P=C.startLineNumber,E=C.startColumn,D=C.endLineNumber,v=C.endColumn;return T<P?(T=P,S=E):T===P&&(S=Math.max(S,E)),y>D?(y=D,L=v):y===D&&(L=Math.min(L,v)),T>y||T===y&&S>L?null:new t(T,S,y,L)}equalsRange(A){return t.equalsRange(this,A)}static equalsRange(A,C){return!A&&!C?!0:!!A&&!!C&&A.startLineNumber===C.startLineNumber&&A.startColumn===C.startColumn&&A.endLineNumber===C.endLineNumber&&A.endColumn===C.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(A){return new c.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(A){return new c.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,C){return new t(this.startLineNumber,this.startColumn,A,C)}setStartPosition(A,C){return new t(A,C,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(A){return new t(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return t.collapseToEnd(this)}static collapseToEnd(A){return new t(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new t(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,C=A){return new t(A.lineNumber,A.column,C.lineNumber,C.column)}static lift(A){return A?new t(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,C){return!(A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<C.startColumn||C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<A.startColumn)}static areIntersecting(A,C){return!(A.endLineNumber<C.startLineNumber||A.endLineNumber===C.startLineNumber&&A.endColumn<=C.startColumn||C.endLineNumber<A.startLineNumber||C.endLineNumber===A.startLineNumber&&C.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,C){if(A&&C){const y=A.startLineNumber|0,L=C.startLineNumber|0;if(y===L){const P=A.startColumn|0,E=C.startColumn|0;if(P===E){const D=A.endLineNumber|0,v=C.endLineNumber|0;if(D===v){const d=A.endColumn|0,m=C.endColumn|0;return d-m}return D-v}return P-E}return y-L}return(A?1:0)-(C?1:0)}static compareRangesUsingEnds(A,C){return A.endLineNumber===C.endLineNumber?A.endColumn===C.endColumn?A.startLineNumber===C.startLineNumber?A.startColumn-C.startColumn:A.startLineNumber-C.startLineNumber:A.endColumn-C.endColumn:A.endLineNumber-C.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=t}),define(Se[149],ye([1,0,50,35]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class A extends t.Range{constructor(T,S,y,L){super(T,S,y,L),this.selectionStartLineNumber=T,this.selectionStartColumn=S,this.positionLineNumber=y,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return A.selectionsEqual(this,T)}static selectionsEqual(T,S){return T.selectionStartLineNumber===S.selectionStartLineNumber&&T.selectionStartColumn===S.selectionStartColumn&&T.positionLineNumber===S.positionLineNumber&&T.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,S){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,T,S):new A(T,S,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,S){return this.getDirection()===0?new A(T,S,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,T,S)}static fromPositions(T,S=T){return new A(T.lineNumber,T.column,S.lineNumber,S.column)}static fromRange(T,S){return S===0?new A(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new A(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new A(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,S){if(T&&!S||!T&&S)return!1;if(!T&&!S)return!0;if(T.length!==S.length)return!1;for(let y=0,L=T.length;y<L;y++)if(!this.selectionsEqual(T[y],S[y]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,S,y,L,P){return P===0?new A(T,S,y,L):new A(y,L,T,S)}}e.Selection=A}),define(Se[150],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[151],ye([1,0,103]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends c.CharacterClassifier{constructor(T){super(0);for(let S=0,y=T.length;S<y;S++)this.set(T.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function A(C){const T={};return S=>(T.hasOwnProperty(S)||(T[S]=C(S)),T[S])}e.getMapForWordSeparators=A(C=>new I(C))}),define(Se[104],ye([1,0,62,6,63]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(P=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)P.indexOf(D)>=0||(E+="\\"+D);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=A();function C(P){let E=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)E=P;else{let D="g";P.ignoreCase&&(D+="i"),P.multiline&&(D+="m"),P.unicode&&(D+="u"),E=new RegExp(P.source,D)}return E.lastIndex=0,E}e.ensureValidWordDefinition=C;const T=new I.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(P){const E=T.unshift(P);return(0,t.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=S;function y(P,E,D,v,d){if(d||(d=c.Iterable.first(T)),D.length>d.maxLen){let g=P-d.maxLen/2;return g<0?g=0:v+=g,D=D.substring(g,P+d.maxLen/2),y(P,E,D,v,d)}const m=Date.now(),h=P-1-v;let b=-1,p=null;for(let g=1;!(Date.now()-m>=d.timeBudget);g++){const w=h-d.windowSize*g;E.lastIndex=Math.max(0,w);const s=L(E,D,h,b);if(!s&&p||(p=s,w<=0))break;b=w}if(p){const g={word:p[0],startColumn:v+1+p.index,endColumn:v+1+p.index+p[0].length};return E.lastIndex=0,g}return null}e.getWordAtText=y;function L(P,E,D,v){let d;for(;d=P.exec(E);){const m=d.index||0;if(m<=D&&P.lastIndex>=D)return d;if(v>0&&m>v)return null}return null}}),define(Se[152],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class t{constructor(T){if(this.e=null,this.f=!1,this.open=T.open,this.close=T.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(T.notIn))for(let S=0,y=T.notIn.length;S<y;S++)switch(T.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(T,S){if(T.getTokenCount()===0)return!0;const y=T.findTokenIndexAtOffset(S-2),L=T.getStandardTokenType(y);return this.isOK(L)}g(T,S){for(let y=T;y<=S;y++){const L=String.fromCharCode(y);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=t;class I{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of T)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=I;function A(C,T,S){C.has(T)?C.get(T).push(S):C.set(T,[S])}}),define(Se[153],ye([1,0,103]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(D){D[D.Invalid=0]="Invalid",D[D.Start=1]="Start",D[D.H=2]="H",D[D.HT=3]="HT",D[D.HTT=4]="HTT",D[D.HTTP=5]="HTTP",D[D.F=6]="F",D[D.FI=7]="FI",D[D.FIL=8]="FIL",D[D.BeforeColon=9]="BeforeColon",D[D.AfterColon=10]="AfterColon",D[D.AlmostThere=11]="AlmostThere",D[D.End=12]="End",D[D.Accept=13]="Accept",D[D.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(v,d,m){const h=new Uint8Array(v*d);for(let b=0,p=v*d;b<p;b++)h[b]=m;this.a=h,this.rows=v,this.cols=d}get(v,d){return this.a[v*this.cols+d]}set(v,d,m){this.a[v*this.cols+d]=m}}class A{constructor(v){let d=0,m=0;for(let b=0,p=v.length;b<p;b++){const[g,w,s]=v[b];w>d&&(d=w),g>m&&(m=g),s>m&&(m=s)}d++,m++;const h=new I(m,d,0);for(let b=0,p=v.length;b<p;b++){const[g,w,s]=v[b];h.set(g,w,s)}this.a=h,this.b=d}nextState(v,d){return d<0||d>=this.b?0:this.a.get(v,d)}}e.StateMachine=A;let C=null;function T(){return C===null&&(C=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var S;(function(D){D[D.None=0]="None",D[D.ForceTermination=1]="ForceTermination",D[D.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let y=null;function L(){if(y===null){y=new c.CharacterClassifier(0);const D=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<D.length;d++)y.set(D.charCodeAt(d),1);const v=".;:";for(let d=0;d<v.length;d++)y.set(v.charCodeAt(d),2)}return y}class P{static a(v,d,m,h,b){let p=b-1;do{const g=d.charCodeAt(p);if(v.get(g)!==2)break;p--}while(p>h);if(h>0){const g=d.charCodeAt(h-1),w=d.charCodeAt(p);(g===40&&w===41||g===91&&w===93||g===123&&w===125)&&p--}return{range:{startLineNumber:m,startColumn:h+1,endLineNumber:m,endColumn:p+2},url:d.substring(h,p+1)}}static computeLinks(v,d=T()){const m=L(),h=[];for(let b=1,p=v.getLineCount();b<=p;b++){const g=v.getLineContent(b),w=g.length;let s=0,r=0,l=0,u=1,o=!1,a=!1,n=!1,i=!1;for(;s<w;){let f=!1;const k=g.charCodeAt(s);if(u===13){let R;switch(k){case 40:o=!0,R=0;break;case 41:R=o?0:1;break;case 91:n=!0,a=!0,R=0;break;case 93:n=!1,R=a?0:1;break;case 123:i=!0,R=0;break;case 125:R=i?0:1;break;case 39:case 34:case 96:l===k?R=1:l===39||l===34||l===96?R=0:R=1;break;case 42:R=l===42?1:0;break;case 124:R=l===124?1:0;break;case 32:R=n?0:1;break;default:R=m.get(k)}R===1&&(h.push(P.a(m,g,b,r,s)),f=!0)}else if(u===12){let R;k===91?(a=!0,R=0):R=m.get(k),R===1?f=!0:u=13}else u=d.nextState(u,k),u===0&&(f=!0);f&&(u=1,o=!1,a=!1,i=!1,r=s+1,l=k),s++}u===13&&h.push(P.a(m,g,b,r,w))}return h}}e.LinkComputer=P;function E(D){return!D||typeof D.getLineCount!="function"||typeof D.getLineContent!="function"?[]:P.computeLinks(D)}e.computeLinks=E}),define(Se[105],ye([1,0,23]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(p){p[p.Both=0]="Both",p[p.Right=1]="Right",p[p.Left=2]="Left",p[p.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),g.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,g.indentSize|0),this.a=!1),this.insertSpaces=Boolean(g.insertSpaces),this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=Boolean(g.trimAutoWhitespace),this.bracketPairColorizationOptions=g.bracketPairColorizationOptions}equals(g){return this.tabSize===g.tabSize&&this.a===g.a&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,g.bracketPairColorizationOptions)}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class L{constructor(g,w){this._findMatchBrand=void 0,this.range=g,this.matches=w}}e.FindMatch=L;var P;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function E(p){return p&&typeof p.read=="function"}e.isITextSnapshot=E;var D;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None",p[p.LeftOfInjectedText=3]="LeftOfInjectedText",p[p.RightOfInjectedText=4]="RightOfInjectedText"})(D=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class d{constructor(g,w,s,r,l,u){this.identifier=g,this.range=w,this.text=s,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=l,this._isTracked=u}}e.ValidAnnotatedEditOperation=d;class m{constructor(g,w,s){this.regex=g,this.wordSeparators=w,this.simpleSearch=s}}e.SearchData=m;class h{constructor(g,w,s){this.reverseEdits=g,this.changes=w,this.trimAutoWhitespaceLineNumbers=s}}e.ApplyEditsResult=h;function b(p){return!p.isTooLargeForSyncing()&&!p.isForSimpleWidget}e.shouldSynchronizeModel=b}),define(Se[154],ye([1,0,17,102]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,y){S=(0,t.toUint32)(S);const L=this.a,P=this.b,E=y.length;return E===0?!1:(this.a=new Uint32Array(L.length+E),this.a.set(L.subarray(0,S),0),this.a.set(L.subarray(S),S+E),this.a.set(y,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(S,y){return S=(0,t.toUint32)(S),y=(0,t.toUint32)(y),this.a[S]===y?!1:(this.a[S]=y,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,y){S=(0,t.toUint32)(S),y=(0,t.toUint32)(y);const L=this.a,P=this.b;if(S>=L.length)return!1;const E=L.length-S;return y>=E&&(y=E),y===0?!1:(this.a=new Uint32Array(L.length-y),this.a.set(L.subarray(0,S),0),this.a.set(L.subarray(S+y),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),S>=this.a.length&&(S=this.a.length-1);for(let L=y;L<=S;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let y=0,L=this.a.length-1,P=0,E=0,D=0;for(;y<=L;)if(P=y+(L-y)/2|0,E=this.b[P],D=E-this.a[P],S<D)L=P-1;else if(S>=E)y=P+1;else break;return new C(P,S-D)}}e.PrefixSumComputer=I;class A{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const y=this.e[S],L=y>0?this.d[y-1]:0;return new C(y,S-L)}removeValues(S,y){this.a.splice(S,y),this.f(S)}insertValues(S,y){this.a=(0,c.arrayInsert)(this.a,S,y),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,y=this.a.length;S<y;S++){const L=this.a[S],P=S>0?this.d[S-1]:0;this.d[S]=P+L;for(let E=0;E<L;E++)this.e[P+E]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,y){this.a[S]!==y&&(this.a[S]=y,this.f(S))}}e.ConstantTimePrefixSumComputer=A;class C{constructor(S,y){this.index=S,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=y}}e.PrefixSumIndexOfResult=C}),define(Se[155],ye([19,20]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(Se[156],ye([1,0,155]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,A=I*24,C=A*7,T=A*30,S=A*365;function y(P,E,D){typeof P!="number"&&(P=P.getTime());const v=Math.round((new Date().getTime()-P)/1e3);if(v<-30)return(0,c.localize)(0,null,y(new Date().getTime()+v*1e3,!1));if(v<30)return(0,c.localize)(1,null);let d;return v<t?(d=v,E?d===1?D?(0,c.localize)(2,null,d):(0,c.localize)(3,null,d):D?(0,c.localize)(4,null,d):(0,c.localize)(5,null,d):d===1?D?(0,c.localize)(6,null,d):(0,c.localize)(7,null,d):D?(0,c.localize)(8,null,d):(0,c.localize)(9,null,d)):v<I?(d=Math.floor(v/t),E?d===1?D?(0,c.localize)(10,null,d):(0,c.localize)(11,null,d):D?(0,c.localize)(12,null,d):(0,c.localize)(13,null,d):d===1?D?(0,c.localize)(14,null,d):(0,c.localize)(15,null,d):D?(0,c.localize)(16,null,d):(0,c.localize)(17,null,d)):v<A?(d=Math.floor(v/I),E?d===1?D?(0,c.localize)(18,null,d):(0,c.localize)(19,null,d):D?(0,c.localize)(20,null,d):(0,c.localize)(21,null,d):d===1?D?(0,c.localize)(22,null,d):(0,c.localize)(23,null,d):D?(0,c.localize)(24,null,d):(0,c.localize)(25,null,d)):v<C?(d=Math.floor(v/A),E?d===1?(0,c.localize)(26,null,d):(0,c.localize)(27,null,d):d===1?(0,c.localize)(28,null,d):(0,c.localize)(29,null,d)):v<T?(d=Math.floor(v/C),E?d===1?D?(0,c.localize)(30,null,d):(0,c.localize)(31,null,d):D?(0,c.localize)(32,null,d):(0,c.localize)(33,null,d):d===1?D?(0,c.localize)(34,null,d):(0,c.localize)(35,null,d):D?(0,c.localize)(36,null,d):(0,c.localize)(37,null,d)):v<S?(d=Math.floor(v/T),E?d===1?D?(0,c.localize)(38,null,d):(0,c.localize)(39,null,d):D?(0,c.localize)(40,null,d):(0,c.localize)(41,null,d):d===1?D?(0,c.localize)(42,null,d):(0,c.localize)(43,null,d):D?(0,c.localize)(44,null,d):(0,c.localize)(45,null,d)):(d=Math.floor(v/S),E?d===1?D?(0,c.localize)(46,null,d):(0,c.localize)(47,null,d):D?(0,c.localize)(48,null,d):(0,c.localize)(49,null,d):d===1?D?(0,c.localize)(50,null,d):(0,c.localize)(51,null,d):D?(0,c.localize)(52,null,d):(0,c.localize)(53,null,d))}e.fromNow=y;function L(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(Se[157],ye([19,20]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(Se[51],ye([1,0,17,11,157]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(P,E){return E&&(P.stack||P.stacktrace)?I.localize(0,null,T(P),C(P.stack)||C(P.stacktrace)):T(P)}function C(P){return Array.isArray(P)?P.join(`
`):P}function T(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?I.localize(1,null,P.message):P.message||I.localize(2,null)}function S(P=null,E=!1){if(!P)return I.localize(3,null);if(Array.isArray(P)){const D=c.coalesce(P),v=S(D[0],E);return D.length>1?I.localize(4,null,v,D.length):v}if(t.isString(P))return P;if(P.detail){const D=P.detail;if(D.error)return A(D.error,E);if(D.exception)return A(D.exception,E)}return P.stack?A(P,E):P.message?P.message:I.localize(5,null)}e.toErrorMessage=S;function y(P){const E=P;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=y;function L(P,E){let D;return typeof P=="string"?D=new Error(P):D=P,D.actions=E,D}e.createErrorWithActions=L}),define(Se[158],ye([19,20]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(Se[12],ye([1,0,158]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,I=!1,A=!1,C=!1,T=!1,S=!1,y=!1,L=!1,P=!1,E=!1,D,v=e.LANGUAGE_DEFAULT,d,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const b=typeof h?.versions?.electron=="string",p=b&&h?.type==="renderer";if(typeof navigator=="object"&&!p)m=navigator.userAgent,t=m.indexOf("Windows")>=0,I=m.indexOf("Macintosh")>=0,L=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=m.indexOf("Linux")>=0,E=m?.indexOf("Mobi")>=0,S=!0,D=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,v=D;else if(typeof h=="object"){t=h.platform==="win32",I=h.platform==="darwin",A=h.platform==="linux",C=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,y=b,P=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,D=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const i=JSON.parse(n),f=i.availableLanguages["*"];D=i.locale,v=f||e.LANGUAGE_DEFAULT,d=i._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var g;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function w(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let s=0;I?s=1:t?s=3:A&&(s=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=A,e.isLinuxSnap=C,e.isNative=T,e.isElectron=y,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=E,e.isCI=P,e.platform=s,e.userAgent=m,e.language=v;var r;(function(n){function i(){return e.language}n.value=i;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=f;function k(){return e.language==="en"}n.isDefault=k})(r=e.Language||(e.Language={})),e.locale=D,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let k=0,R=n.length;k<R;k++){const B=n[k];if(B.id===f.data.vscodeScheduleAsyncWork){n.splice(k,1),B.callback();return}}});let i=0;return f=>{const k=++i;n.push({id:k,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:k},"*")}}return n=>setTimeout(n)})();var l;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||L?2:t?1:3;let u=!0,o=!1;function a(){if(!o){o=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,u=new Uint16Array(n.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Se[36],ye([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const I=c.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Se[9],ye([1,0,36]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,A=90,C=122,T=46,S=47,y=92,L=58,P=63;class E extends Error{constructor(r,l,u){let o;typeof l=="string"&&l.indexOf("not ")===0?(o="must not be",l=l.replace(/^not /,"")):o="must be";const a=r.indexOf(".")!==-1?"property":"argument";let n=`The "${r}" ${a} ${o} of type ${l}`;n+=`. Received type ${typeof u}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function D(s,r){if(s===null||typeof s!="object")throw new E(r,"Object",s)}function v(s,r){if(typeof s!="string")throw new E(r,"string",s)}const d=c.platform==="win32";function m(s){return s===S||s===y}function h(s){return s===S}function b(s){return s>=t&&s<=A||s>=I&&s<=C}function p(s,r,l,u){let o="",a=0,n=-1,i=0,f=0;for(let k=0;k<=s.length;++k){if(k<s.length)f=s.charCodeAt(k);else{if(u(f))break;f=S}if(u(f)){if(!(n===k-1||i===1))if(i===2){if(o.length<2||a!==2||o.charCodeAt(o.length-1)!==T||o.charCodeAt(o.length-2)!==T){if(o.length>2){const R=o.lastIndexOf(l);R===-1?(o="",a=0):(o=o.slice(0,R),a=o.length-1-o.lastIndexOf(l)),n=k,i=0;continue}else if(o.length!==0){o="",a=0,n=k,i=0;continue}}r&&(o+=o.length>0?`${l}..`:"..",a=2)}else o.length>0?o+=`${l}${s.slice(n+1,k)}`:o=s.slice(n+1,k),a=k-n-1;n=k,i=0}else f===T&&i!==-1?++i:i=-1}return o}function g(s,r){D(r,"pathObject");const l=r.dir||r.root,u=r.base||`${r.name||""}${r.ext||""}`;return l?l===r.root?`${l}${u}`:`${l}${s}${u}`:u}e.win32={resolve(...s){let r="",l="",u=!1;for(let o=s.length-1;o>=-1;o--){let a;if(o>=0){if(a=s[o],v(a,"path"),a.length===0)continue}else r.length===0?a=c.cwd():(a=c.env[`=${r}`]||c.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==r.toLowerCase()&&a.charCodeAt(2)===y)&&(a=`${r}\\`));const n=a.length;let i=0,f="",k=!1;const R=a.charCodeAt(0);if(n===1)m(R)&&(i=1,k=!0);else if(m(R))if(k=!0,m(a.charCodeAt(1))){let B=2,X=B;for(;B<n&&!m(a.charCodeAt(B));)B++;if(B<n&&B!==X){const q=a.slice(X,B);for(X=B;B<n&&m(a.charCodeAt(B));)B++;if(B<n&&B!==X){for(X=B;B<n&&!m(a.charCodeAt(B));)B++;(B===n||B!==X)&&(f=`\\\\${q}\\${a.slice(X,B)}`,i=B)}}}else i=1;else b(R)&&a.charCodeAt(1)===L&&(f=a.slice(0,2),i=2,n>2&&m(a.charCodeAt(2))&&(k=!0,i=3));if(f.length>0)if(r.length>0){if(f.toLowerCase()!==r.toLowerCase())continue}else r=f;if(u){if(r.length>0)break}else if(l=`${a.slice(i)}\\${l}`,u=k,k&&r.length>0)break}return l=p(l,!u,"\\",m),u?`${r}\\${l}`:`${r}${l}`||"."},normalize(s){v(s,"path");const r=s.length;if(r===0)return".";let l=0,u,o=!1;const a=s.charCodeAt(0);if(r===1)return h(a)?"\\":s;if(m(a))if(o=!0,m(s.charCodeAt(1))){let i=2,f=i;for(;i<r&&!m(s.charCodeAt(i));)i++;if(i<r&&i!==f){const k=s.slice(f,i);for(f=i;i<r&&m(s.charCodeAt(i));)i++;if(i<r&&i!==f){for(f=i;i<r&&!m(s.charCodeAt(i));)i++;if(i===r)return`\\\\${k}\\${s.slice(f)}\\`;i!==f&&(u=`\\\\${k}\\${s.slice(f,i)}`,l=i)}}}else l=1;else b(a)&&s.charCodeAt(1)===L&&(u=s.slice(0,2),l=2,r>2&&m(s.charCodeAt(2))&&(o=!0,l=3));let n=l<r?p(s.slice(l),!o,"\\",m):"";return n.length===0&&!o&&(n="."),n.length>0&&m(s.charCodeAt(r-1))&&(n+="\\"),u===void 0?o?`\\${n}`:n:o?`${u}\\${n}`:`${u}${n}`},isAbsolute(s){v(s,"path");const r=s.length;if(r===0)return!1;const l=s.charCodeAt(0);return m(l)||r>2&&b(l)&&s.charCodeAt(1)===L&&m(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let r,l;for(let a=0;a<s.length;++a){const n=s[a];v(n,"path"),n.length>0&&(r===void 0?r=l=n:r+=`\\${n}`)}if(r===void 0)return".";let u=!0,o=0;if(typeof l=="string"&&m(l.charCodeAt(0))){++o;const a=l.length;a>1&&m(l.charCodeAt(1))&&(++o,a>2&&(m(l.charCodeAt(2))?++o:u=!1))}if(u){for(;o<r.length&&m(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.win32.normalize(r)},relative(s,r){if(v(s,"from"),v(r,"to"),s===r)return"";const l=e.win32.resolve(s),u=e.win32.resolve(r);if(l===u||(s=l.toLowerCase(),r=u.toLowerCase(),s===r))return"";let o=0;for(;o<s.length&&s.charCodeAt(o)===y;)o++;let a=s.length;for(;a-1>o&&s.charCodeAt(a-1)===y;)a--;const n=a-o;let i=0;for(;i<r.length&&r.charCodeAt(i)===y;)i++;let f=r.length;for(;f-1>i&&r.charCodeAt(f-1)===y;)f--;const k=f-i,R=n<k?n:k;let B=-1,X=0;for(;X<R;X++){const N=s.charCodeAt(o+X);if(N!==r.charCodeAt(i+X))break;N===y&&(B=X)}if(X!==R){if(B===-1)return u}else{if(k>R){if(r.charCodeAt(i+X)===y)return u.slice(i+X+1);if(X===2)return u.slice(i+X)}n>R&&(s.charCodeAt(o+X)===y?B=X:X===2&&(B=3)),B===-1&&(B=0)}let q="";for(X=o+B+1;X<=a;++X)(X===a||s.charCodeAt(X)===y)&&(q+=q.length===0?"..":"\\..");return i+=B,q.length>0?`${q}${u.slice(i,f)}`:(u.charCodeAt(i)===y&&++i,u.slice(i,f))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const r=e.win32.resolve(s);if(r.length<=2)return s;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const l=r.charCodeAt(2);if(l!==P&&l!==T)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(b(r.charCodeAt(0))&&r.charCodeAt(1)===L&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return s},dirname(s){v(s,"path");const r=s.length;if(r===0)return".";let l=-1,u=0;const o=s.charCodeAt(0);if(r===1)return m(o)?s:".";if(m(o)){if(l=u=1,m(s.charCodeAt(1))){let i=2,f=i;for(;i<r&&!m(s.charCodeAt(i));)i++;if(i<r&&i!==f){for(f=i;i<r&&m(s.charCodeAt(i));)i++;if(i<r&&i!==f){for(f=i;i<r&&!m(s.charCodeAt(i));)i++;if(i===r)return s;i!==f&&(l=u=i+1)}}}}else b(o)&&s.charCodeAt(1)===L&&(l=r>2&&m(s.charCodeAt(2))?3:2,u=l);let a=-1,n=!0;for(let i=r-1;i>=u;--i)if(m(s.charCodeAt(i))){if(!n){a=i;break}}else n=!1;if(a===-1){if(l===-1)return".";a=l}return s.slice(0,a)},basename(s,r){r!==void 0&&v(r,"ext"),v(s,"path");let l=0,u=-1,o=!0,a;if(s.length>=2&&b(s.charCodeAt(0))&&s.charCodeAt(1)===L&&(l=2),r!==void 0&&r.length>0&&r.length<=s.length){if(r===s)return"";let n=r.length-1,i=-1;for(a=s.length-1;a>=l;--a){const f=s.charCodeAt(a);if(m(f)){if(!o){l=a+1;break}}else i===-1&&(o=!1,i=a+1),n>=0&&(f===r.charCodeAt(n)?--n===-1&&(u=a):(n=-1,u=i))}return l===u?u=i:u===-1&&(u=s.length),s.slice(l,u)}for(a=s.length-1;a>=l;--a)if(m(s.charCodeAt(a))){if(!o){l=a+1;break}}else u===-1&&(o=!1,u=a+1);return u===-1?"":s.slice(l,u)},extname(s){v(s,"path");let r=0,l=-1,u=0,o=-1,a=!0,n=0;s.length>=2&&s.charCodeAt(1)===L&&b(s.charCodeAt(0))&&(r=u=2);for(let i=s.length-1;i>=r;--i){const f=s.charCodeAt(i);if(m(f)){if(!a){u=i+1;break}continue}o===-1&&(a=!1,o=i+1),f===T?l===-1?l=i:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||o===-1||n===0||n===1&&l===o-1&&l===u+1?"":s.slice(l,o)},format:g.bind(null,"\\"),parse(s){v(s,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return r;const l=s.length;let u=0,o=s.charCodeAt(0);if(l===1)return m(o)?(r.root=r.dir=s,r):(r.base=r.name=s,r);if(m(o)){if(u=1,m(s.charCodeAt(1))){let B=2,X=B;for(;B<l&&!m(s.charCodeAt(B));)B++;if(B<l&&B!==X){for(X=B;B<l&&m(s.charCodeAt(B));)B++;if(B<l&&B!==X){for(X=B;B<l&&!m(s.charCodeAt(B));)B++;B===l?u=B:B!==X&&(u=B+1)}}}}else if(b(o)&&s.charCodeAt(1)===L){if(l<=2)return r.root=r.dir=s,r;if(u=2,m(s.charCodeAt(2))){if(l===3)return r.root=r.dir=s,r;u=3}}u>0&&(r.root=s.slice(0,u));let a=-1,n=u,i=-1,f=!0,k=s.length-1,R=0;for(;k>=u;--k){if(o=s.charCodeAt(k),m(o)){if(!f){n=k+1;break}continue}i===-1&&(f=!1,i=k+1),o===T?a===-1?a=k:R!==1&&(R=1):a!==-1&&(R=-1)}return i!==-1&&(a===-1||R===0||R===1&&a===i-1&&a===n+1?r.base=r.name=s.slice(n,i):(r.name=s.slice(n,a),r.base=s.slice(n,i),r.ext=s.slice(a,i))),n>0&&n!==u?r.dir=s.slice(0,n-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const w=(()=>{if(d){const s=/\\/g;return()=>{const r=c.cwd().replace(s,"/");return r.slice(r.indexOf("/"))}}return()=>c.cwd()})();e.posix={resolve(...s){let r="",l=!1;for(let u=s.length-1;u>=-1&&!l;u--){const o=u>=0?s[u]:w();v(o,"path"),o.length!==0&&(r=`${o}/${r}`,l=o.charCodeAt(0)===S)}return r=p(r,!l,"/",h),l?`/${r}`:r.length>0?r:"."},normalize(s){if(v(s,"path"),s.length===0)return".";const r=s.charCodeAt(0)===S,l=s.charCodeAt(s.length-1)===S;return s=p(s,!r,"/",h),s.length===0?r?"/":l?"./":".":(l&&(s+="/"),r?`/${s}`:s)},isAbsolute(s){return v(s,"path"),s.length>0&&s.charCodeAt(0)===S},join(...s){if(s.length===0)return".";let r;for(let l=0;l<s.length;++l){const u=s[l];v(u,"path"),u.length>0&&(r===void 0?r=u:r+=`/${u}`)}return r===void 0?".":e.posix.normalize(r)},relative(s,r){if(v(s,"from"),v(r,"to"),s===r||(s=e.posix.resolve(s),r=e.posix.resolve(r),s===r))return"";const l=1,u=s.length,o=u-l,a=1,n=r.length-a,i=o<n?o:n;let f=-1,k=0;for(;k<i;k++){const B=s.charCodeAt(l+k);if(B!==r.charCodeAt(a+k))break;B===S&&(f=k)}if(k===i)if(n>i){if(r.charCodeAt(a+k)===S)return r.slice(a+k+1);if(k===0)return r.slice(a+k)}else o>i&&(s.charCodeAt(l+k)===S?f=k:k===0&&(f=0));let R="";for(k=l+f+1;k<=u;++k)(k===u||s.charCodeAt(k)===S)&&(R+=R.length===0?"..":"/..");return`${R}${r.slice(a+f)}`},toNamespacedPath(s){return s},dirname(s){if(v(s,"path"),s.length===0)return".";const r=s.charCodeAt(0)===S;let l=-1,u=!0;for(let o=s.length-1;o>=1;--o)if(s.charCodeAt(o)===S){if(!u){l=o;break}}else u=!1;return l===-1?r?"/":".":r&&l===1?"//":s.slice(0,l)},basename(s,r){r!==void 0&&v(r,"ext"),v(s,"path");let l=0,u=-1,o=!0,a;if(r!==void 0&&r.length>0&&r.length<=s.length){if(r===s)return"";let n=r.length-1,i=-1;for(a=s.length-1;a>=0;--a){const f=s.charCodeAt(a);if(f===S){if(!o){l=a+1;break}}else i===-1&&(o=!1,i=a+1),n>=0&&(f===r.charCodeAt(n)?--n===-1&&(u=a):(n=-1,u=i))}return l===u?u=i:u===-1&&(u=s.length),s.slice(l,u)}for(a=s.length-1;a>=0;--a)if(s.charCodeAt(a)===S){if(!o){l=a+1;break}}else u===-1&&(o=!1,u=a+1);return u===-1?"":s.slice(l,u)},extname(s){v(s,"path");let r=-1,l=0,u=-1,o=!0,a=0;for(let n=s.length-1;n>=0;--n){const i=s.charCodeAt(n);if(i===S){if(!o){l=n+1;break}continue}u===-1&&(o=!1,u=n+1),i===T?r===-1?r=n:a!==1&&(a=1):r!==-1&&(a=-1)}return r===-1||u===-1||a===0||a===1&&r===u-1&&r===l+1?"":s.slice(r,u)},format:g.bind(null,"/"),parse(s){v(s,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return r;const l=s.charCodeAt(0)===S;let u;l?(r.root="/",u=1):u=0;let o=-1,a=0,n=-1,i=!0,f=s.length-1,k=0;for(;f>=u;--f){const R=s.charCodeAt(f);if(R===S){if(!i){a=f+1;break}continue}n===-1&&(i=!1,n=f+1),R===T?o===-1?o=f:k!==1&&(k=1):o!==-1&&(k=-1)}if(n!==-1){const R=a===0&&l?1:a;o===-1||k===0||k===1&&o===n-1&&o===a+1?r.base=r.name=s.slice(R,n):(r.name=s.slice(R,o),r.base=s.slice(R,n),r.ext=s.slice(o,n))}return a>0?r.dir=s.slice(0,a-1):l&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=d?e.win32.normalize:e.posix.normalize,e.isAbsolute=d?e.win32.isAbsolute:e.posix.isAbsolute,e.join=d?e.win32.join:e.posix.join,e.resolve=d?e.win32.resolve:e.posix.resolve,e.relative=d?e.win32.relative:e.posix.relative,e.dirname=d?e.win32.dirname:e.posix.dirname,e.basename=d?e.win32.basename:e.posix.basename,e.extname=d?e.win32.extname:e.posix.extname,e.format=d?e.win32.format:e.posix.format,e.parse=d?e.win32.parse:e.posix.parse,e.toNamespacedPath=d?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=d?e.win32.sep:e.posix.sep,e.delimiter=d?e.win32.delimiter:e.posix.delimiter}),define(Se[83],ye([1,0,9]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(L){const P=(0,c.extname)(L),E=t[P.toLowerCase()];return E!==void 0?E:C(L)}e.getMediaOrTextMime=A;function C(L){const P=(0,c.extname)(L);return I[P.toLowerCase()]}e.getMediaMime=C;function T(L){for(const P in I)if(I[P]===L)return P}e.getExtensionForMimeType=T;const S=/^(.+)\/(.+?)(;.+)?$/;function y(L,P){const E=S.exec(L);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:P?void 0:L}e.normalizeMimeType=y}),define(Se[106],ye([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var I;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(T,...S){const y=S.reduce((E,D)=>(E[D]=!0,E),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(E=>!y[E]).forEach(E=>{for(let D=0;D<L.length;D++)if(E.search(L[D])!==-1){delete T[E];break}})}e.sanitizeProcessEnvironment=A;function C(T){!T||(delete T.DEBUG,c.isMacintosh&&delete T.DYLD_LIBRARY_PATH,c.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(Se[44],ye([1,0,12]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=c.globals.performance&&typeof c.globals.performance.now=="function";class I{static create(C=!0){return new I(C)}constructor(C){this.a=t&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?c.globals.performance.now():Date.now()}}e.StopWatch=I}),define(Se[4],ye([1,0,10,61,6,63,44]),function(ne,e,c,t,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,S=!1;var y;(function(a){a.None=()=>I.Disposable.None;function n(De){if(S){const{onDidAddListener:Re}=De,ze=v.create();let se=0;De.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ze.print()),Re?.()}}}function i(De,Re){return F(De,()=>{},0,void 0,void 0,Re)}a.defer=i;function f(De){return(Re,ze=null,se)=>{let ue=!1,he;return he=De(ee=>{if(!ue)return he?he.dispose():ue=!0,Re.call(ze,ee)},null,se),ue&&he.dispose(),he}}a.once=f;function k(De,Re,ze){return M((se,ue=null,he)=>De(ee=>se.call(ue,Re(ee)),null,he),ze)}a.map=k;function R(De,Re,ze){return M((se,ue=null,he)=>De(ee=>{Re(ee),se.call(ue,ee)},null,he),ze)}a.forEach=R;function B(De,Re,ze){return M((se,ue=null,he)=>De(ee=>Re(ee)&&se.call(ue,ee),null,he),ze)}a.filter=B;function X(De){return De}a.signal=X;function q(...De){return(Re,ze=null,se)=>(0,I.combinedDisposable)(...De.map(ue=>ue(he=>Re.call(ze,he),null,se)))}a.any=q;function N(De,Re,ze,se){let ue=ze;return k(De,he=>(ue=Re(ue,he),ue),se)}a.reduce=N;function M(De,Re){let ze;const se={onWillAddFirstListener(){ze=De(ue.fire,ue)},onDidRemoveLastListener(){ze?.dispose()}};Re||n(se);const ue=new m(se);return Re?.add(ue),ue.event}function F(De,Re,ze=100,se=!1,ue,he){let ee,oe,ie,O=0;const H={leakWarningThreshold:ue,onWillAddFirstListener(){ee=De(Y=>{O++,oe=Re(oe,Y),se&&!ie&&(K.fire(oe),oe=void 0),clearTimeout(ie),ie=setTimeout(()=>{const de=oe;oe=void 0,ie=void 0,(!se||O>1)&&K.fire(de),O=0},ze)})},onDidRemoveLastListener(){ee.dispose()}};he||n(H);const K=new m(H);return he?.add(K),K.event}a.debounce=F;function z(De,Re=0,ze){return a.debounce(De,(se,ue)=>se?(se.push(ue),se):[ue],Re,void 0,void 0,ze)}a.accumulate=z;function U(De,Re=(se,ue)=>se===ue,ze){let se=!0,ue;return B(De,he=>{const ee=se||!Re(he,ue);return se=!1,ue=he,ee},ze)}a.latch=U;function W(De,Re,ze){return[a.filter(De,Re,ze),a.filter(De,se=>!Re(se),ze)]}a.split=W;function x(De,Re=!1,ze=[]){let se=ze.slice(),ue=De(oe=>{se?se.push(oe):ee.fire(oe)});const he=()=>{se?.forEach(oe=>ee.fire(oe)),se=null},ee=new m({onWillAddFirstListener(){ue||(ue=De(oe=>ee.fire(oe)))},onDidAddFirstListener(){se&&(Re?setTimeout(he):he())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return ee.event}a.buffer=x;class V{constructor(Re){this.event=Re,this.c=new I.DisposableStore}map(Re){return new V(k(this.event,Re,this.c))}forEach(Re){return new V(R(this.event,Re,this.c))}filter(Re){return new V(B(this.event,Re,this.c))}reduce(Re,ze){return new V(N(this.event,Re,ze,this.c))}latch(){return new V(U(this.event,void 0,this.c))}debounce(Re,ze=100,se=!1,ue){return new V(F(this.event,Re,ze,se,ue,this.c))}on(Re,ze,se){return this.event(Re,ze,se)}once(Re,ze,se){return f(this.event)(Re,ze,se)}dispose(){this.c.dispose()}}function _(De){return new V(De)}a.chain=_;function Q(De,Re,ze=se=>se){const se=(...oe)=>ee.fire(ze(...oe)),ue=()=>De.on(Re,se),he=()=>De.removeListener(Re,se),ee=new m({onWillAddFirstListener:ue,onDidRemoveLastListener:he});return ee.event}a.fromNodeEventEmitter=Q;function J(De,Re,ze=se=>se){const se=(...oe)=>ee.fire(ze(...oe)),ue=()=>De.addEventListener(Re,se),he=()=>De.removeEventListener(Re,se),ee=new m({onWillAddFirstListener:ue,onDidRemoveLastListener:he});return ee.event}a.fromDOMEventEmitter=J;function te(De){return new Promise(Re=>f(De)(Re))}a.toPromise=te;function le(De,Re){return Re(void 0),De(ze=>Re(ze))}a.runAndSubscribe=le;function Z(De,Re){let ze=null;function se(he){ze?.dispose(),ze=new I.DisposableStore,Re(he,ze)}se(void 0);const ue=De(he=>se(he));return(0,I.toDisposable)(()=>{ue.dispose(),ze?.dispose()})}a.runAndSubscribeWithStore=Z;class ge{constructor(Re,ze){this.obs=Re,this.c=0,this.d=!1;const se={onWillAddFirstListener:()=>{Re.addObserver(this)},onDidRemoveLastListener:()=>{Re.removeObserver(this)}};ze||n(se),this.emitter=new m(se),ze&&ze.add(this.emitter)}beginUpdate(Re){this.c++}handleChange(Re,ze){this.d=!0}endUpdate(Re){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function ve(De,Re){return new ge(De,Re).emitter.event}a.fromObservable=ve})(y=e.Event||(e.Event={}));class L{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${L.c++}`,L.all.add(this)}start(n){this.d=new C.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=L,L.all=new Set,L.c=0;let P=-1;function E(a){const n=P;return P=a,{dispose(){P=n}}}e.setGlobalLeakWarningThreshold=E;class D{constructor(n,i=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=i,this.d=0}dispose(){this.c?.clear()}check(n,i){const f=this.threshold;if(f<=0||i<f)return;this.c||(this.c=new Map);const k=this.c.get(n.value)||0;if(this.c.set(n.value,k+1),this.d-=1,this.d<=0){this.d=f*.5;let R,B=0;for(const[X,q]of this.c)(!R||B<q)&&(R=X,B=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${i} listeners already. MOST frequent listener (${B}):`),console.warn(R)}return()=>{const R=this.c.get(n.value)||0;this.c.set(n.value,R-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(n,i,f){this.callback=n,this.callbackThis=i,this.stack=f,this.subscription=new I.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class m{constructor(n){this.j=!1,this.d=n,this.f=P>0||this.d?.leakWarningThreshold?new D(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(T){const n=Array.from(this.q);queueMicrotask(()=>{for(const i of n)i.subscription.isset()&&(i.subscription.unset(),i.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,i,f)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),I.Disposable.None;const k=this.q.isEmpty();k&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let R,B;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(B=v.create(),R=this.f.check(B,this.q.size+1)),T&&(B=B??v.create());const X=new d(n,i,B),q=this.q.push(X);k&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,i);const N=X.subscription.set(()=>{R?.(),this.j||(q(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return f instanceof I.DisposableStore?f.add(N):Array.isArray(f)&&f.push(N),N}),this.l}fire(n){if(this.q){this.m||(this.m=new b);for(const i of this.q)this.m.push(this,i,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=m;class h{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(n,i,f){this.c.push(new p(n,i,f))}clear(n){const i=new A.LinkedList;for(const f of this.c)f.emitter!==n&&i.push(f);this.c=i}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(i){(0,c.onUnexpectedError)(i)}}}}e.EventDeliveryQueue=h;class b extends h{clear(n){this.c.clear()}}class p{constructor(n,i,f){this.emitter=n,this.listener=i,this.event=f}}class g extends m{async fireAsync(n,i,f){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const k of this.q)this.c.push([k,n]);for(;this.c.size>0&&!i.isCancellationRequested;){const[k,R]=this.c.shift(),B=[],X={...R,token:i,waitUntil:q=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");f&&(q=f(q,k.callback)),B.push(q)}};try{k.invoke(X)}catch(q){(0,c.onUnexpectedError)(q);continue}Object.freeze(B),await Promise.allSettled(B).then(q=>{for(const N of q)N.status==="rejected"&&(0,c.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=g;class w extends m{constructor(n){super(n),this.h=0,this.s=new A.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=w;class s extends w{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=s;class r extends m{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(i=>super.fire(i)),this.c=[]}))}}e.MicrotaskEmitter=r;class l{constructor(){this.d=!1,this.f=[],this.c=new m({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const i={event:n,listener:null};this.f.push(i),this.d&&this.j(i);const f=()=>{this.d&&this.k(i);const k=this.f.indexOf(i);this.f.splice(k,1)};return(0,I.toDisposable)((0,t.once)(f))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(i=>this.c.fire(i))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=l;class u{constructor(){this.c=[]}wrapEvent(n){return(i,f,k)=>n(R=>{const B=this.c[this.c.length-1];B?B.push(()=>i.call(f,R)):i.call(f,R)},void 0,k)}bufferEvents(n){const i=[];this.c.push(i);const f=n();return this.c.pop(),i.forEach(k=>k()),f}}e.EventBufferer=u;class o{constructor(){this.c=!1,this.d=y.None,this.f=I.Disposable.None,this.g=new m({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(Se[21],ye([1,0,4]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(T,S){const y=setTimeout(T.bind(S),0);return{dispose(){clearTimeout(y)}}});var I;(function(T){function S(y){return y===T.None||y===T.Cancelled||y instanceof A?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}T.isCancellationToken=S,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new c.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=I.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=I.None}}e.CancellationTokenSource=C}),define(Se[159],ye([1,0,21]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(T){this.b=T,this.a=null}get(){if(this.a)return this.a;const T=new c.CancellationTokenSource,S=this.b(T.token);return this.a={promise:S,dispose:()=>{this.a=null,T.cancel(),T.dispose()}},this.a}}e.Cache=t;class I{constructor(T){this.c=T,this.a=void 0,this.b=void 0}get(T){const S=JSON.stringify(T);return this.b!==S&&(this.b=S,this.a=this.c(T)),this.a}}e.LRUCachedFunction=I;class A{get cachedValues(){return this.a}constructor(T){this.b=T,this.a=new Map}get(T){if(this.a.has(T))return this.a.get(T);const S=this.b(T);return this.a.set(T,S),S}}e.CachedFunction=A}),define(Se[8],ye([1,0,159,81]),function(ne,e,c,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=A;const C=/{(\d+)}/g;function T($,...ce){return ce.length===0?$:$.replace(C,function(Ie,Le){const Be=parseInt(Le,10);return isNaN(Be)||Be<0||Be>=ce.length?Ie:ce[Be]})}e.format=T;const S=/{([^}]+)}/g;function y($,ce){return $.replace(S,(Ie,Le)=>ce[Le]??Ie)}e.format2=y;function L($){return $.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=L;function P($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function E($,ce){let Ie=0;const Le=ce.charCodeAt(0);for(let Be=$.length-1;Be>=0;Be--)$.charCodeAt(Be)===Le&&Ie++;return Ie}e.count=E;function D($,ce,Ie="\u2026"){return $.length<=ce?$:`${$.substr(0,ce)}${Ie}`}e.truncate=D;function v($,ce=" "){const Ie=d($,ce);return m(Ie,ce)}e.trim=v;function d($,ce){if(!$||!ce)return $;const Ie=ce.length;if(Ie===0||$.length===0)return $;let Le=0;for(;$.indexOf(ce,Le)===Le;)Le=Le+Ie;return $.substring(Le)}e.ltrim=d;function m($,ce){if(!$||!ce)return $;const Ie=ce.length,Le=$.length;if(Ie===0||Le===0)return $;let Be=Le,xe=-1;for(;xe=$.lastIndexOf(ce,Be-1),!(xe===-1||xe+Ie!==Be);){if(xe===0)return"";Be=xe}return $.substring(0,Be)}e.rtrim=m;function h($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function b($){return $.replace(/\*/g,"")}e.stripWildcards=b;function p($,ce,Ie={}){if(!$)throw new Error("Cannot create regex from empty string");ce||($=P($)),Ie.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=p;function g($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function w($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function s($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=s;function r($){return $.split(/\r\n|\r|\n/)}e.splitLines=r;function l($){for(let ce=0,Ie=$.length;ce<Ie;ce++){const Le=$.charCodeAt(ce);if(Le!==32&&Le!==9)return ce}return-1}e.firstNonWhitespaceIndex=l;function u($,ce=0,Ie=$.length){for(let Le=ce;Le<Ie;Le++){const Be=$.charCodeAt(Le);if(Be!==32&&Be!==9)return $.substring(ce,Le)}return $.substring(ce,Ie)}e.getLeadingWhitespace=u;function o($,ce=$.length-1){for(let Ie=ce;Ie>=0;Ie--){const Le=$.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=o;function a($,ce,Ie){const Le=[];let Be=0;for(const xe of $.matchAll(ce)){if(Le.push($.slice(Be,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Be=xe.index+xe[0].length,Le.push(Ie(xe[0],...xe.slice(1),xe.index,$,xe.groups))}return Le.push($.slice(Be)),Promise.all(Le).then(xe=>xe.join(""))}e.replaceAsync=a;function n($,ce){return $<ce?-1:$>ce?1:0}e.compare=n;function i($,ce,Ie=0,Le=$.length,Be=0,xe=ce.length){for(;Ie<Le&&Be<xe;Ie++,Be++){const ft=$.charCodeAt(Ie),lt=ce.charCodeAt(Be);if(ft<lt)return-1;if(ft>lt)return 1}const Ze=Le-Ie,mt=xe-Be;return Ze<mt?-1:Ze>mt?1:0}e.compareSubstring=i;function f($,ce){return k($,ce,0,$.length,0,ce.length)}e.compareIgnoreCase=f;function k($,ce,Ie=0,Le=$.length,Be=0,xe=ce.length){for(;Ie<Le&&Be<xe;Ie++,Be++){let ft=$.charCodeAt(Ie),lt=ce.charCodeAt(Be);if(ft===lt)continue;if(ft>=128||lt>=128)return i($.toLowerCase(),ce.toLowerCase(),Ie,Le,Be,xe);B(ft)&&(ft-=32),B(lt)&&(lt-=32);const ot=ft-lt;if(ot!==0)return ot}const Ze=Le-Ie,mt=xe-Be;return Ze<mt?-1:Ze>mt?1:0}e.compareSubstringIgnoreCase=k;function R($){return $>=48&&$<=57}e.isAsciiDigit=R;function B($){return $>=97&&$<=122}e.isLowerAsciiLetter=B;function X($){return $>=65&&$<=90}e.isUpperAsciiLetter=X;function q($,ce){return $.length===ce.length&&k($,ce)===0}e.equalsIgnoreCase=q;function N($,ce){const Ie=ce.length;return ce.length>$.length?!1:k($,ce,0,Ie)===0}e.startsWithIgnoreCase=N;function M($,ce){const Ie=Math.min($.length,ce.length);let Le;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Le)!==ce.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=M;function F($,ce){const Ie=Math.min($.length,ce.length);let Le;const Be=$.length-1,xe=ce.length-1;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Be-Le)!==ce.charCodeAt(xe-Le))return Le;return Ie}e.commonSuffixLength=F;function z($){return 55296<=$&&$<=56319}e.isHighSurrogate=z;function U($){return 56320<=$&&$<=57343}e.isLowSurrogate=U;function W($,ce){return($-55296<<10)+(ce-56320)+65536}e.computeCodePoint=W;function x($,ce,Ie){const Le=$.charCodeAt(Ie);if(z(Le)&&Ie+1<ce){const Be=$.charCodeAt(Ie+1);if(U(Be))return W(Le,Be)}return Le}e.getNextCodePoint=x;function V($,ce){const Ie=$.charCodeAt(ce-1);if(U(Ie)&&ce>1){const Le=$.charCodeAt(ce-2);if(z(Le))return W(Le,Ie)}return Ie}class _{get offset(){return this.e}constructor(ce,Ie=0){this.c=ce,this.d=ce.length,this.e=Ie}setOffset(ce){this.e=ce}prevCodePoint(){const ce=V(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=x(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=_;class Q{get offset(){return this.c.offset}constructor(ce,Ie=0){this.c=new _(ce,Ie)}nextGraphemeLength(){const ce=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ce.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const xe=Ie.offset,Ze=ce.getGraphemeBreakType(Ie.nextCodePoint());if(je(Be,Ze)){Ie.setOffset(xe);break}Be=Ze}return Ie.offset-Le}prevGraphemeLength(){const ce=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ce.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const xe=Ie.offset,Ze=ce.getGraphemeBreakType(Ie.prevCodePoint());if(je(Ze,Be)){Ie.setOffset(xe);break}Be=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Q;function J($,ce){return new Q($,ce).nextGraphemeLength()}e.nextCharLength=J;function te($,ce){return new Q($,ce).prevGraphemeLength()}e.prevCharLength=te;function le($,ce){ce>0&&U($.charCodeAt(ce))&&ce--;const Ie=ce+J($,ce);return[Ie-te($,Ie),Ie]}e.getCharContainingOffset=le;function Z($){const ce=new Q($);let Ie=0;for(;!ce.eol();)Ie++,ce.nextGraphemeLength();return Ie}e.charCount=Z;let ge;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function De($){return ge||(ge=ve()),ge.test($)}e.containsRTL=De;const Re=/^[\t\n\r\x20-\x7E]*$/;function ze($){return Re.test($)}e.isBasicASCII=ze,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=se;function ue($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=ue;function he($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=he;function ee($,ce){if($.length<ce)return $;const Ie=/\b/g;let Le=0;for(;Ie.test($)&&!($.length-Ie.lastIndex<ce);)Le=Ie.lastIndex,Ie.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=ee;const oe=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,O=/\x1b\[0?m/g;function H($){return $&&($=$.replace(oe,""),$=$.replace(ie,""),$=$.replace(O,"")),$}e.removeAnsiEscapeCodes=H,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function K($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=K;function Y($){return K($)?$.substr(1):$}e.stripUTF8BOM=Y;function de($,ce){if(!$||!ce||$.length<ce.length)return!1;const Ie=ce.length,Le=$.toLowerCase();let Be=0,xe=-1;for(;Be<Ie;){const Ze=Le.indexOf(ce[Be],xe+1);if(Ze<0)return!1;xe=Ze,Be++}return!0}e.fuzzyContains=de;function be($,ce=!1){return $?(ce&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=be;function Pe($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=Pe;function pe($,ce=1){if(ce===0)return"";let Ie=-1;do Ie=$.indexOf(`
`,Ie+1),ce--;while(ce>0&&Ie>=0);return Ie===-1?$:($[Ie-1]==="\r"&&Ie--,$.substr(0,Ie))}e.getNLines=pe;function Ce($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=Ce;function ke($){return et.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=ke;function je($,ce){return $===0?ce!==5&&ce!==7:$===2&&ce===3?!1:$===4||$===2||$===3||ce===4||ce===2||ce===3?!0:!($===8&&(ce===8||ce===9||ce===11||ce===12)||($===11||$===9)&&(ce===9||ce===10)||($===12||$===10)&&ce===10||ce===5||ce===13||ce===7||$===1||$===13&&ce===14||$===6&&ce===6)}var Ge;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=_e()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const Ie=this.d,Le=Ie.length/3;let Be=1;for(;Be<=Le;)if(ce<Ie[3*Be])Be=2*Be;else if(ce>Ie[3*Be+1])Be=2*Be+1;else return Ie[3*Be+2];return 0}}et.c=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt($,ce){if($===0)return 0;const Ie=st($,ce);if(Ie!==void 0)return Ie;const Le=new _(ce,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st($,ce){const Ie=new _(ce,$);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!he(Le))return;let Be=Ie.offset;return Be>0&&Ie.prevCodePoint()===8205&&(Be=Ie.offset),Be}function ht($){return 127995<=$&&$<=127999}var Fe;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class it{static getInstance(ce){return it.d.get(Array.from(ce))}static getLocales(){return it.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=it,I=it,it.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),it.d=new c.LRUCachedFunction($=>{function ce(lt){const ot=new Map;for(let rt=0;rt<lt.length;rt+=2)ot.set(lt[rt],lt[rt+1]);return ot}function Ie(lt,ot){const rt=new Map(lt);for(const[Tt,Pt]of ot)rt.set(Tt,Pt);return rt}function Le(lt,ot){if(!lt)return ot;const rt=new Map;for(const[Tt,Pt]of lt)ot.has(Tt)&&rt.set(Tt,Pt);return rt}const Be=I.c.getValue();let xe=$.filter(lt=>!lt.startsWith("_")&&lt in Be);xe.length===0&&(xe=["_default"]);let Ze;for(const lt of xe){const ot=ce(Be[lt]);Ze=Le(Ze,ot)}const mt=ce(Be._common),ft=Ie(mt,Ze);return new it(ft)}),it.e=new t.Lazy(()=>Object.keys(it.c.getValue()).filter($=>!$.startsWith("_")));class ae{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ae.c())),this.d}static isInvisibleCharacter(ce){return ae.e().has(ce)}static get codePoints(){return ae.e()}}e.InvisibleCharacters=ae,ae.d=void 0}),define(Se[32],ye([1,0,9,12,8,11]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(o){return o===47||o===92}e.isPathSeparator=C;function T(o){return o.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=T;function S(o){return o.indexOf("/")===-1&&(o=T(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=S;function y(o,a=c.posix.sep){if(!o)return"";const n=o.length,i=o.charCodeAt(0);if(C(i)){if(C(o.charCodeAt(1))&&!C(o.charCodeAt(2))){let k=3;const R=k;for(;k<n&&!C(o.charCodeAt(k));k++);if(R!==k&&!C(o.charCodeAt(k+1))){for(k+=1;k<n;k++)if(C(o.charCodeAt(k)))return o.slice(0,k+1).replace(/[\\/]/g,a)}}return a}else if(h(i)&&o.charCodeAt(1)===58)return C(o.charCodeAt(2))?o.slice(0,2)+a:o.slice(0,2);let f=o.indexOf("://");if(f!==-1){for(f+=3;f<n;f++)if(C(o.charCodeAt(f)))return o.slice(0,f+1)}return""}e.getRoot=y;function L(o){if(!t.isWindows||!o||o.length<5)return!1;let a=o.charCodeAt(0);if(a!==92||(a=o.charCodeAt(1),a!==92))return!1;let n=2;const i=n;for(;n<o.length&&(a=o.charCodeAt(n),a!==92);n++);return!(i===n||(a=o.charCodeAt(n+1),isNaN(a)||a===92))}e.isUNC=L;const P=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,D=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(o,a=t.isWindows){const n=a?P:E;return!(!o||o.length===0||/^\s+$/.test(o)||(n.lastIndex=0,n.test(o))||a&&D.test(o)||o==="."||o===".."||a&&o[o.length-1]==="."||a&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=v;function d(o,a,n){const i=o===a;return!n||i?i:!o||!a?!1:(0,I.equalsIgnoreCase)(o,a)}e.isEqual=d;function m(o,a,n,i=c.sep){if(o===a)return!0;if(!o||!a||a.length>o.length)return!1;if(n){if(!(0,I.startsWithIgnoreCase)(o,a))return!1;if(a.length===o.length)return!0;let k=a.length;return a.charAt(a.length-1)===i&&k--,o.charAt(k)===i}return a.charAt(a.length-1)!==i&&(a+=i),o.indexOf(a)===0}e.isEqualOrParent=m;function h(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=h;function b(o,a){return t.isWindows&&o.endsWith(":")&&(o+=c.sep),(0,c.isAbsolute)(o)||(o=(0,c.join)(a,o)),o=(0,c.normalize)(o),t.isWindows?(o=(0,I.rtrim)(o,c.sep),o.endsWith(":")&&(o+=c.sep)):(o=(0,I.rtrim)(o,c.sep),o||(o=c.sep)),o}e.sanitizeFilePath=b;function p(o){const a=(0,c.normalize)(o);return t.isWindows?o.length>3?!1:g(a)&&(o.length===2||a.charCodeAt(2)===92):a===c.posix.sep}e.isRootOrDriveLetter=p;function g(o,a=t.isWindows){return a?h(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function w(o){return g(o)?o[0]:void 0}e.getDriveLetter=w;function s(o,a,n){return a.length>o.length?-1:o===a?0:(n&&(o=o.toLowerCase(),a=a.toLowerCase()),o.indexOf(a))}e.indexOfPath=s;function r(o){const a=o.split(":");let n,i,f;for(const k of a){const R=Number(k);(0,A.isNumber)(R)?i===void 0?i=R:f===void 0&&(f=R):n=n?[n,k].join(":"):k}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:i!==void 0?i:void 0,column:f!==void 0?f:i!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(o,a,n=8){let i="";for(let k=0;k<n;k++)i+=l.charAt(Math.floor(Math.random()*l.length));let f;return a?f=`${a}-${i}`:f=i,o?(0,c.join)(o,f):f}e.randomPath=u}),define(Se[107],ye([1,0,28,8]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...ie){return function(O,H){for(let K=0,Y=ie.length;K<Y;K++){const de=ie[K](O,H);if(de)return de}return null}}e.or=I,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ie,O,H){if(!H||H.length<O.length)return null;let K;return ie?K=t.startsWithIgnoreCase(H,O):K=H.indexOf(O)===0,K?O.length>0?[{start:0,end:O.length}]:[]:null}function C(ie,O){const H=O.toLowerCase().indexOf(ie.toLowerCase());return H===-1?null:[{start:H,end:H+ie.length}]}e.matchesContiguousSubString=C;function T(ie,O){return S(ie.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=T;function S(ie,O,H,K){if(H===ie.length)return[];if(K===O.length)return null;if(ie[H]===O[K]){let Y=null;return(Y=S(ie,O,H+1,K+1))?h({start:K,end:K+1},Y):null}return S(ie,O,H,K+1)}function y(ie){return 97<=ie&&ie<=122}function L(ie){return 65<=ie&&ie<=90}e.isUpper=L;function P(ie){return 48<=ie&&ie<=57}function E(ie){return ie===32||ie===9||ie===10||ie===13}const D=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>D.add(ie.charCodeAt(0)));function v(ie){return E(ie)||D.has(ie)}function d(ie,O){return ie===O||v(ie)&&v(O)}function m(ie){return y(ie)||L(ie)||P(ie)}function h(ie,O){return O.length===0?O=[ie]:ie.end===O[0].start?O[0].start=ie.start:O.unshift(ie),O}function b(ie,O){for(let H=O;H<ie.length;H++){const K=ie.charCodeAt(H);if(L(K)||P(K)||H>0&&!m(ie.charCodeAt(H-1)))return H}return ie.length}function p(ie,O,H,K){if(H===ie.length)return[];if(K===O.length)return null;if(ie[H]!==O[K].toLowerCase())return null;{let Y=null,de=K+1;for(Y=p(ie,O,H+1,K+1);!Y&&(de=b(O,de))<O.length;)Y=p(ie,O,H+1,de),de++;return Y===null?null:h({start:K,end:K+1},Y)}}function g(ie){let O=0,H=0,K=0,Y=0,de=0;for(let ke=0;ke<ie.length;ke++)de=ie.charCodeAt(ke),L(de)&&O++,y(de)&&H++,m(de)&&K++,P(de)&&Y++;const be=O/ie.length,Pe=H/ie.length,pe=K/ie.length,Ce=Y/ie.length;return{upperPercent:be,lowerPercent:Pe,alphaPercent:pe,numericPercent:Ce}}function w(ie){const{upperPercent:O,lowerPercent:H}=ie;return H===0&&O>.6}function s(ie){const{upperPercent:O,lowerPercent:H,alphaPercent:K,numericPercent:Y}=ie;return H>.2&&O<.8&&K>.6&&Y<.2}function r(ie){let O=0,H=0,K=0,Y=0;for(let de=0;de<ie.length;de++)K=ie.charCodeAt(de),L(K)&&O++,y(K)&&H++,E(K)&&Y++;return(O===0||H===0)&&Y===0?ie.length<=30:O<=5}function l(ie,O){if(!O||(O=O.trim(),O.length===0)||!r(ie)||O.length>60)return null;const H=g(O);if(!s(H)){if(!w(H))return null;O=O.toLowerCase()}let K=null,Y=0;for(ie=ie.toLowerCase();Y<O.length&&(K=p(ie,O,0,Y))===null;)Y=b(O,Y+1);return K}e.matchesCamelCase=l;function u(ie,O,H=!1){if(!O||O.length===0)return null;let K=null,Y=0;for(ie=ie.toLowerCase(),O=O.toLowerCase();Y<O.length&&(K=o(ie,O,0,Y,H))===null;)Y=a(O,Y+1);return K}e.matchesWords=u;function o(ie,O,H,K,Y){if(H===ie.length)return[];if(K===O.length)return null;if(d(ie.charCodeAt(H),O.charCodeAt(K))){let de=null,be=K+1;if(de=o(ie,O,H+1,K+1,Y),!Y)for(;!de&&(be=a(O,be))<O.length;)de=o(ie,O,H+1,be,Y),be++;return de?ie.charCodeAt(H)!==O.charCodeAt(K)?de:h({start:K,end:K+1},de):null}else return null}function a(ie,O){for(let H=O;H<ie.length;H++)if(v(ie.charCodeAt(H))||H>0&&v(ie.charCodeAt(H-1)))return H;return ie.length}const n=I(e.matchesPrefix,l,C),i=I(e.matchesPrefix,l,T),f=new c.LRUCache(1e4);function k(ie,O,H=!1){if(typeof ie!="string"||typeof O!="string")return null;let K=f.get(ie);K||(K=new RegExp(t.convertSimple2RegExpPattern(ie),"i"),f.set(ie,K));const Y=K.exec(O);return Y?[{start:Y.index,end:Y.index+Y[0].length}]:H?i(ie,O):n(ie,O)}e.matchesFuzzy=k;function R(ie,O){const H=Re(ie,ie.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?X(H):null}e.matchesFuzzy2=R;function B(ie,O,H,K,Y,de){const be=Math.min(13,ie.length);for(;H<be;H++){const Pe=Re(ie,O,H,K,Y,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Pe)return Pe}return[0,de]}e.anyScore=B;function X(ie){if(typeof ie>"u")return[];const O=[],H=ie[1];for(let K=ie.length-1;K>1;K--){const Y=ie[K]+H,de=O[O.length-1];de&&de.end===Y?de.end=Y+1:O.push({start:Y,end:Y+1})}return O}e.createMatches=X;const q=128;function N(){const ie=[],O=[];for(let H=0;H<=q;H++)O[H]=0;for(let H=0;H<=q;H++)ie.push(O.slice(0));return ie}function M(ie){const O=[];for(let H=0;H<=ie;H++)O[H]=0;return O}const F=M(2*q),z=M(2*q),U=N(),W=N(),x=N(),V=!1;function _(ie,O,H,K,Y){function de(Pe,pe,Ce=" "){for(;Pe.length<pe;)Pe=Ce+Pe;return Pe}let be=` |   |${K.split("").map(Pe=>de(Pe,3)).join("|")}
`;for(let Pe=0;Pe<=H;Pe++)Pe===0?be+=" |":be+=`${O[Pe-1]}|`,be+=ie[Pe].slice(0,Y+1).map(pe=>de(pe.toString(),3)).join("|")+`
`;return be}function Q(ie,O,H,K){ie=ie.substr(O),H=H.substr(K),console.log(_(W,ie,ie.length,H,H.length)),console.log(_(x,ie,ie.length,H,H.length)),console.log(_(U,ie,ie.length,H,H.length))}function J(ie,O){if(O<0||O>=ie.length)return!1;const H=ie.codePointAt(O);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(H)}}function te(ie,O){if(O<0||O>=ie.length)return!1;switch(ie.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function le(ie,O,H){return O[ie]!==H[ie]}function Z(ie,O,H,K,Y,de,be=!1){for(;O<H&&Y<de;)ie[O]===K[Y]&&(be&&(F[O]=Y),O+=1),Y+=1;return O===H}e.isPatternInWord=Z;var ge;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var ve;(function(ie){ie.Default=[-100,0];function O(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}ie.isDefault=O})(ve=e.FuzzyScore||(e.FuzzyScore={}));class De{constructor(O,H){this.firstMatchCanBeWeak=O,this.boostFullMatch=H}}e.FuzzyScoreOptions=De,De.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(ie,O,H,K,Y,de,be=De.default){const Pe=ie.length>q?q:ie.length,pe=K.length>q?q:K.length;if(H>=Pe||de>=pe||Pe-H>pe-de||!Z(O,H,Pe,Y,de,pe,!0))return;ze(Pe,pe,H,de,O,Y);let Ce=1,ke=1,je=H,Ge=de;const et=[!1];for(Ce=1,je=H;je<Pe;Ce++,je++){const Fe=F[je],it=z[je],ae=je+1<Pe?z[je+1]:pe;for(ke=Fe-de+1,Ge=Fe;Ge<ae;ke++,Ge++){let $=Number.MIN_SAFE_INTEGER,ce=!1;Ge<=it&&($=se(ie,O,je,H,K,Y,Ge,pe,de,U[Ce-1][ke-1]===0,et));let Ie=0;$!==Number.MAX_SAFE_INTEGER&&(ce=!0,Ie=$+W[Ce-1][ke-1]);const Le=Ge>Fe,Be=Le?W[Ce][ke-1]+(U[Ce][ke-1]>0?-5:0):0,xe=Ge>Fe+1&&U[Ce][ke-1]>0,Ze=xe?W[Ce][ke-2]+(U[Ce][ke-2]>0?-5:0):0;if(xe&&(!Le||Ze>=Be)&&(!ce||Ze>=Ie))W[Ce][ke]=Ze,x[Ce][ke]=3,U[Ce][ke]=0;else if(Le&&(!ce||Be>=Ie))W[Ce][ke]=Be,x[Ce][ke]=2,U[Ce][ke]=0;else if(ce)W[Ce][ke]=Ie,x[Ce][ke]=1,U[Ce][ke]=U[Ce-1][ke-1]+1;else throw new Error("not possible")}}if(V&&Q(ie,H,K,de),!et[0]&&!be.firstMatchCanBeWeak)return;Ce--,ke--;const _e=[W[Ce][ke],de];let nt=0,st=0;for(;Ce>=1;){let Fe=ke;do{const it=x[Ce][Fe];if(it===3)Fe=Fe-2;else if(it===2)Fe=Fe-1;else break}while(Fe>=1);nt>1&&O[H+Ce-1]===Y[de+ke-1]&&!le(Fe+de-1,K,Y)&&nt+1>U[Ce][Fe]&&(Fe=ke),Fe===ke?nt++:nt=1,st||(st=Fe),Ce--,ke=Fe-1,_e.push(ke)}pe===Pe&&be.boostFullMatch&&(_e[0]+=2);const ht=st-Pe;return _e[0]-=ht,_e}e.fuzzyScore=Re;function ze(ie,O,H,K,Y,de){let be=ie-1,Pe=O-1;for(;be>=H&&Pe>=K;)Y[be]===de[Pe]&&(z[be]=Pe,be--),Pe--}function se(ie,O,H,K,Y,de,be,Pe,pe,Ce,ke){if(O[H]!==de[be])return Number.MIN_SAFE_INTEGER;let je=1,Ge=!1;return be===H-K?je=ie[H]===Y[be]?7:5:le(be,Y,de)&&(be===0||!le(be-1,Y,de))?(je=ie[H]===Y[be]?7:5,Ge=!0):J(de,be)&&(be===0||!J(de,be-1))?je=5:(J(de,be-1)||te(de,be-1))&&(je=5,Ge=!0),je>1&&H===K&&(ke[0]=!0),Ge||(Ge=le(be,Y,de)||J(de,be-1)||te(de,be-1)),H===K?be>pe&&(je-=Ge?3:5):Ce?je+=Ge?2:0:je+=Ge?0:1,be+1===Pe&&(je-=Ge?3:5),je}function ue(ie,O,H,K,Y,de,be){return ee(ie,O,H,K,Y,de,!0,be)}e.fuzzyScoreGracefulAggressive=ue;function he(ie,O,H,K,Y,de,be){return ee(ie,O,H,K,Y,de,!1,be)}e.fuzzyScoreGraceful=he;function ee(ie,O,H,K,Y,de,be,Pe){let pe=Re(ie,O,H,K,Y,de,Pe);if(pe&&!be)return pe;if(ie.length>=3){const Ce=Math.min(7,ie.length-1);for(let ke=H+1;ke<Ce;ke++){const je=oe(ie,ke);if(je){const Ge=Re(je,je.toLowerCase(),H,K,Y,de,Pe);Ge&&(Ge[0]-=3,(!pe||Ge[0]>pe[0])&&(pe=Ge))}}}return pe}function oe(ie,O){if(O+1>=ie.length)return;const H=ie[O],K=ie[O+1];if(H!==K)return ie.slice(0,O)+K+H+ie.slice(O+2)}}),define(Se[84],ye([1,0,8]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(h){return I(h,0)}e.hash=t;function I(h,b){switch(typeof h){case"object":return h===null?A(349,b):Array.isArray(h)?S(h,b):y(h,b);case"string":return T(h,b);case"boolean":return C(h,b);case"number":return A(h,b);case"undefined":return A(937,b);default:return A(617,b)}}e.doHash=I;function A(h,b){return(b<<5)-b+h|0}e.numberHash=A;function C(h,b){return A(h?433:863,b)}function T(h,b){b=A(149417,b);for(let p=0,g=h.length;p<g;p++)b=A(h.charCodeAt(p),b);return b}e.stringHash=T;function S(h,b){return b=A(104579,b),h.reduce((p,g)=>I(g,p),b)}function y(h,b){return b=A(181387,b),Object.keys(h).sort().reduce((p,g)=>(p=T(g,p),I(h[g],p)),b)}class L{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=I(b,this.g),this.g}}e.Hasher=L;var P;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function E(h,b,p=32){const g=p-b,w=~((1<<g)-1);return(h<<b|(w&h)>>>g)>>>0}function D(h,b=0,p=h.byteLength,g=0){for(let w=0;w<p;w++)h[b+w]=g}function v(h,b,p="0"){for(;h.length<b;)h=p+h;return h}function d(h,b=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(p=>p.toString(16).padStart(2,"0")).join(""):v((h>>>0).toString(16),b/4)}e.toHexString=d;class m{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const p=b.length;if(p===0)return;const g=this.p;let w=this.r,s=this.u,r,l;for(s!==0?(r=s,l=-1,s=0):(r=b.charCodeAt(0),l=0);;){let u=r;if(c.isHighSurrogate(r))if(l+1<p){const o=b.charCodeAt(l+1);c.isLowSurrogate(o)?(l++,u=c.computeCodePoint(r,o)):u=65533}else{s=r;break}else c.isLowSurrogate(r)&&(u=65533);if(w=this.w(g,w,u),l++,l<p)r=b.charCodeAt(l);else break}this.r=w,this.u=s}w(b,p,g){return g<128?b[p++]=g:g<2048?(b[p++]=192|(g&1984)>>>6,b[p++]=128|(g&63)>>>0):g<65536?(b[p++]=224|(g&61440)>>>12,b[p++]=128|(g&4032)>>>6,b[p++]=128|(g&63)>>>0):(b[p++]=240|(g&1835008)>>>18,b[p++]=128|(g&258048)>>>12,b[p++]=128|(g&4032)>>>6,b[p++]=128|(g&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,D(this.p,this.r),this.r>56&&(this.y(),D(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=m.g,p=this.q;for(let n=0;n<64;n+=4)b.setUint32(n,p.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)b.setUint32(n,E(b.getUint32(n-12,!1)^b.getUint32(n-32,!1)^b.getUint32(n-56,!1)^b.getUint32(n-64,!1),1),!1);let g=this.h,w=this.l,s=this.m,r=this.n,l=this.o,u,o,a;for(let n=0;n<80;n++)n<20?(u=w&s|~w&r,o=1518500249):n<40?(u=w^s^r,o=1859775393):n<60?(u=w&s|w&r|s&r,o=2400959708):(u=w^s^r,o=3395469782),a=E(g,5)+u+l+o+b.getUint32(n*4,!1)&4294967295,l=r,r=s,s=E(w,30),w=g,g=a;this.h=this.h+g&4294967295,this.l=this.l+w&4294967295,this.m=this.m+s&4294967295,this.n=this.n+r&4294967295,this.o=this.o+l&4294967295}}e.StringSHA1=m,m.g=new DataView(new ArrayBuffer(320))}),define(Se[160],ye([1,0,79,107,8]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",C=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${C.source}`,"g");function S(m){return m.replace(T,(h,b)=>b?h:`\\${h}`)}e.escapeIcons=S;const y=new RegExp(`\\\\${C.source}`,"g");function L(m){return m.replace(y,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=L;const P=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function E(m){return m.indexOf(A)===-1?m:m.replace(P,(h,b,p,g)=>p?h:b||g||"")}e.stripIcons=E;const D=new RegExp(`\\$\\(${c.CSSIcon.iconNameCharacter}+\\)`,"g");function v(m){D.lastIndex=0;let h="";const b=[];let p=0;for(;;){const g=D.lastIndex,w=D.exec(m),s=m.substring(g,w?.index);if(s.length>0){h+=s;for(let r=0;r<s.length;r++)b.push(p)}if(!w)break;p+=w[0].length}return{text:h,iconOffsets:b}}e.parseLabelWithIcons=v;function d(m,h,b=!1){const{text:p,iconOffsets:g}=h;if(!g||g.length===0)return(0,t.matchesFuzzy)(m,p,b);const w=(0,I.ltrim)(p," "),s=p.length-w.length,r=(0,t.matchesFuzzy)(m,w,b);if(r)for(const l of r){const u=g[l.start+s]+s;l.start+=u,l.end+=u}return r}e.matchesFuzzyIconAware=d}),define(Se[42],ye([1,0,8]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const A="error",C="warning",T="warn",S="info",y="ignore";function L(E){return E?c.equalsIgnoreCase(A,E)?I.Error:c.equalsIgnoreCase(C,E)||c.equalsIgnoreCase(T,E)?I.Warning:c.equalsIgnoreCase(S,E)?I.Info:I.Ignore:I.Ignore}I.fromValue=L;function P(E){switch(E){case I.Error:return A;case I.Warning:return C;case I.Info:return S;default:return y}}I.toString=P}(t||(t={})),e.default=t}),define(Se[64],ye([1,0,17,8]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class I{constructor(){this.b="",this.c=0}reset(D){return this.b=D,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(D){const v=D.charCodeAt(0),d=this.b.charCodeAt(this.c);return v-d}value(){return this.b[this.c]}}e.StringIterator=I;class A{constructor(D=!0){this.e=D}reset(D){return this.b=D,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let D=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(D)this.c++;else break;else D=!1;return this}cmp(D){return this.e?(0,t.compareSubstring)(D,this.b,0,D.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(D,this.b,0,D.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class C{constructor(D=!0,v=!0){this.f=D,this.g=v}reset(D){this.d=0,this.e=0,this.b=D,this.c=D.length;for(let v=D.length-1;v>=0;v--,this.c--){const d=this.b.charCodeAt(v);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let D=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(D)this.d++;else break;else D=!1}return this}cmp(D){return this.g?(0,t.compareSubstring)(D,this.b,0,D.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(D,this.b,0,D.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var T;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(T||(T={}));class S{constructor(D,v){this.f=D,this.g=v,this.d=[],this.e=0}reset(D){return this.c=D,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(D)),this.b.reset(D.path),this.b.value()&&this.d.push(3)),this.g(D)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(D){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(D,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(D,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(D);if(this.d[this.e]===4)return(0,t.compare)(D,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(D,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const D=this.right;return this.right=D.left,D.left=this,this.updateHeight(),D.updateHeight(),D}rotateRight(){const D=this.left;return this.left=D.right,D.right=this,this.updateHeight(),D.updateHeight(),D}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(L||(L={}));class P{static forUris(D=()=>!1,v=()=>!1){return new P(new S(D,v))}static forPaths(D=!1){return new P(new C(void 0,!D))}static forStrings(){return new P(new I)}static forConfigKeys(){return new P(new A)}constructor(D){this.b=D}clear(){this.c=void 0}fill(D,v){if(v){const d=v.slice(0);(0,c.shuffle)(d);for(const m of d)this.set(m,D)}else{const d=D.slice(0);(0,c.shuffle)(d);for(const m of d)this.set(m[0],m[1])}}set(D,v){const d=this.b.reset(D);let m;this.c||(this.c=new y,this.c.segment=d.value());const h=[];for(m=this.c;;){const p=d.cmp(m.segment);if(p>0)m.left||(m.left=new y,m.left.segment=d.value()),h.push([-1,m]),m=m.left;else if(p<0)m.right||(m.right=new y,m.right.segment=d.value()),h.push([1,m]),m=m.right;else if(d.hasNext())d.next(),m.mid||(m.mid=new y,m.mid.segment=d.value()),h.push([0,m]),m=m.mid;else break}const b=m.value;m.value=v,m.key=D;for(let p=h.length-1;p>=0;p--){const g=h[p][1];g.updateHeight();const w=g.balanceFactor();if(w<-1||w>1){const s=h[p][0],r=h[p+1][0];if(s===1&&r===1)h[p][1]=g.rotateLeft();else if(s===-1&&r===-1)h[p][1]=g.rotateRight();else if(s===1&&r===-1)g.right=h[p+1][1]=h[p+1][1].rotateRight(),h[p][1]=g.rotateLeft();else if(s===-1&&r===1)g.left=h[p+1][1]=h[p+1][1].rotateLeft(),h[p][1]=g.rotateRight();else throw new Error;if(p>0)switch(h[p-1][0]){case-1:h[p-1][1].left=h[p][1];break;case 1:h[p-1][1].right=h[p][1];break;case 0:h[p-1][1].mid=h[p][1];break}else this.c=h[0][1]}}return b}get(D){return this.d(D)?.value}d(D){const v=this.b.reset(D);let d=this.c;for(;d;){const m=v.cmp(d.segment);if(m>0)d=d.left;else if(m<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else break}return d}has(D){const v=this.d(D);return!(v?.value===void 0&&v?.mid===void 0)}delete(D){return this.e(D,!1)}deleteSuperstr(D){return this.e(D,!0)}e(D,v){const d=this.b.reset(D),m=[];let h=this.c;for(;h;){const b=d.cmp(h.segment);if(b>0)m.push([-1,h]),h=h.left;else if(b<0)m.push([1,h]),h=h.right;else if(d.hasNext())d.next(),m.push([0,h]),h=h.mid;else break}if(!!h){if(v?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const b=this.f(h.right);if(b.key){const{key:p,value:g,segment:w}=b;this.e(b.key,!1),h.key=p,h.value=g,h.segment=w}}else{const b=h.left??h.right;if(m.length>0){const[p,g]=m[m.length-1];switch(p){case-1:g.left=b;break;case 0:g.mid=b;break;case 1:g.right=b;break}}else this.c=b}for(let b=m.length-1;b>=0;b--){const p=m[b][1];p.updateHeight();const g=p.balanceFactor();if(g>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),m[b][1]=p.rotateLeft()):g<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),m[b][1]=p.rotateRight()),b>0)switch(m[b-1][0]){case-1:m[b-1][1].left=m[b][1];break;case 1:m[b-1][1].right=m[b][1];break;case 0:m[b-1][1].mid=m[b][1];break}else this.c=m[0][1]}}}f(D){for(;D.left;)D=D.left;return D}findSubstr(D){const v=this.b.reset(D);let d=this.c,m;for(;d;){const h=v.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(v.hasNext())v.next(),m=d.value||m,d=d.mid;else break}return d&&d.value||m}findSuperstr(D){const v=this.b.reset(D);let d=this.c;for(;d;){const m=v.cmp(d.segment);if(m>0)d=d.left;else if(m<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else return d.mid?this.g(d.mid):void 0}}forEach(D){for(const[v,d]of this)D(d,v)}*[Symbol.iterator](){yield*this.g(this.c)}g(D){const v=[];return this.h(D,v),v[Symbol.iterator]()}h(D,v){!D||(D.left&&this.h(D.left,v),D.value&&v.push([D.key,D.value]),D.mid&&this.h(D.mid,v),D.right&&this.h(D.right,v))}_isBalanced(){const D=v=>{if(!v)return!0;const d=v.balanceFactor();return d<-1||d>1?!1:D(v.left)&&D(v.right)};return D(this.c)}}e.TernarySearchTree=P}),define(Se[2],ye([1,0,9,12]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,A=/^\//,C=/^\/\//;function T(l,u){if(!l.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!I.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!A.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(l,u){return!l&&!u?"file":l}function y(l,u){switch(l){case"https":case"http":case"file":u?u[0]!==P&&(u=P+u):u=P;break}return u}const L="",P="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class D{static isUri(u){return u instanceof D?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,o,a,n,i,f=!1){typeof u=="object"?(this.scheme=u.scheme||L,this.authority=u.authority||L,this.path=u.path||L,this.query=u.query||L,this.fragment=u.fragment||L):(this.scheme=S(u,f),this.authority=o||L,this.path=y(this.scheme,a||L),this.query=n||L,this.fragment=i||L,T(this,f))}get fsPath(){return p(this,!1)}with(u){if(!u)return this;let{scheme:o,authority:a,path:n,query:i,fragment:f}=u;return o===void 0?o=this.scheme:o===null&&(o=L),a===void 0?a=this.authority:a===null&&(a=L),n===void 0?n=this.path:n===null&&(n=L),i===void 0?i=this.query:i===null&&(i=L),f===void 0?f=this.fragment:f===null&&(f=L),o===this.scheme&&a===this.authority&&n===this.path&&i===this.query&&f===this.fragment?this:new d(o,a,n,i,f)}static parse(u,o=!1){const a=E.exec(u);return a?new d(a[2]||L,r(a[4]||L),r(a[5]||L),r(a[7]||L),r(a[9]||L),o):new d(L,L,L,L,L)}static file(u){let o=L;if(t.isWindows&&(u=u.replace(/\\/g,P)),u[0]===P&&u[1]===P){const a=u.indexOf(P,2);a===-1?(o=u.substring(2),u=P):(o=u.substring(2,a),u=u.substring(a)||P)}return new d("file",o,u,L,L)}static from(u){const o=new d(u.scheme,u.authority,u.path,u.query,u.fragment);return T(o,!0),o}static joinPath(u,...o){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&u.scheme==="file"?a=D.file(c.win32.join(p(u,!0),...o)).path:a=c.posix.join(u.path,...o),u.with({path:a})}toString(u=!1){return g(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof D)return u;{const o=new d(u);return o._formatted=u.external,o._fsPath=u._sep===v?u.fsPath:null,o}}else return u}}e.URI=D;const v=t.isWindows?1:void 0;class d extends D{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(u=!1){return u?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=v),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(l,u,o){let a,n=-1;for(let i=0;i<l.length;i++){const f=l.charCodeAt(i);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||u&&f===47||o&&f===91||o&&f===93||o&&f===58)n!==-1&&(a+=encodeURIComponent(l.substring(n,i)),n=-1),a!==void 0&&(a+=l.charAt(i));else{a===void 0&&(a=l.substr(0,i));const k=m[f];k!==void 0?(n!==-1&&(a+=encodeURIComponent(l.substring(n,i)),n=-1),a+=k):n===-1&&(n=i)}}return n!==-1&&(a+=encodeURIComponent(l.substring(n))),a!==void 0?a:l}function b(l){let u;for(let o=0;o<l.length;o++){const a=l.charCodeAt(o);a===35||a===63?(u===void 0&&(u=l.substr(0,o)),u+=m[a]):u!==void 0&&(u+=l[o])}return u!==void 0?u:l}function p(l,u){let o;return l.authority&&l.path.length>1&&l.scheme==="file"?o=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?u?o=l.path.substr(1):o=l.path[1].toLowerCase()+l.path.substr(2):o=l.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=p;function g(l,u){const o=u?b:h;let a="",{scheme:n,authority:i,path:f,query:k,fragment:R}=l;if(n&&(a+=n,a+=":"),(i||n==="file")&&(a+=P,a+=P),i){let B=i.indexOf("@");if(B!==-1){const X=i.substr(0,B);i=i.substr(B+1),B=X.lastIndexOf(":"),B===-1?a+=o(X,!1,!1):(a+=o(X.substr(0,B),!1,!1),a+=":",a+=o(X.substr(B+1),!1,!0)),a+="@"}i=i.toLowerCase(),B=i.lastIndexOf(":"),B===-1?a+=o(i,!1,!0):(a+=o(i.substr(0,B),!1,!0),a+=i.substr(B))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const B=f.charCodeAt(1);B>=65&&B<=90&&(f=`/${String.fromCharCode(B+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const B=f.charCodeAt(0);B>=65&&B<=90&&(f=`${String.fromCharCode(B+32)}:${f.substr(2)}`)}a+=o(f,!0,!1)}return k&&(a+="?",a+=o(k,!1,!1)),R&&(a+="#",a+=u?R:h(R,!1,!1)),a}function w(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+w(l.substr(3)):l}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(l){return l.match(s)?l.replace(s,u=>w(u)):l}}),define(Se[85],ye([1,0,22,8,2]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(y){return JSON.stringify(y,T)}e.stringify=A;function C(y){let L=JSON.parse(y);return L=S(L),L}e.parse=C;function T(y,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,t.regExpFlags)(L)}:L}function S(y,L=0){if(!y||L>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return I.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 16:return new Date(y.source)}if(y instanceof c.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let P=0;P<y.length;++P)y[P]=S(y[P],L+1);else for(const P in y)Object.hasOwnProperty.call(y,P)&&(y[P]=S(y[P],L+1))}return y}e.revive=S}),define(Se[15],ye([1,0,12,2]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(y){this.d=y}setDelegate(y){this.e=y}setServerRootPath(y){this.f=`${y}/${I.vscodeRemoteResource}`}set(y,L,P){this.a[y]=L,this.b[y]=P}setConnectionToken(y,L){this.c[y]=L}getPreferredWebSchema(){return this.d}rewrite(y){if(this.e)return this.e(y);const L=y.authority;let P=this.a[L];P&&P.indexOf(":")!==-1&&P.indexOf("[")===-1&&(P=`[${P}]`);const E=this.b[L],D=this.c[L];let v=`path=${encodeURIComponent(y.path)}`;return typeof D=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(D)}`),t.URI.from({scheme:c.isWeb?this.d:I.vscodeRemoteResource,authority:`${P}:${E}`,path:this.f,query:v})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class C{asBrowserUri(y){const L=this.b(y,ne);return this.uriToBrowserUri(L)}uriToBrowserUri(y){return y.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===I.file&&(c.isNative||c.isWebWorker&&c.globals.origin===`${I.vscodeFileResource}://${C.a}`)?y.with({scheme:I.vscodeFileResource,authority:y.authority||C.a,query:null,fragment:null}):y}asFileUri(y){const L=this.b(y,ne);return this.uriToFileUri(L)}uriToFileUri(y){return y.scheme===I.vscodeFileResource?y.with({scheme:I.file,authority:y.authority!==C.a?y.authority:null,query:null,fragment:null}):y}b(y,L){return t.URI.isUri(y)?y:t.URI.parse(L.toUrl(y))}}C.a="vscode-app",e.FileAccess=new C;var T;(function(S){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(y.get("3"));const L="vscode-coi";function P(D){let v;typeof D=="string"?v=new URL(D).searchParams:D instanceof URL?v=D.searchParams:t.URI.isUri(D)&&(v=new URL(D.toString(!0)).searchParams);const d=v?.get(L);if(!!d)return y.get(d)}S.getHeadersFromQuery=P;function E(D,v,d){if(!globalThis.crossOriginIsolated)return;const m=v&&d?"3":d?"2":"1";D instanceof URLSearchParams?D.set(L,m):D[L]=m}S.addSearchParam=E})(T=e.COI||(e.COI={}))}),define(Se[24],ye([1,0,32,15,9,12,8,2]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(D){return(0,T.uriToFsPath)(D,!0)}e.originalFSPath=S;class y{constructor(v){this.a=v}compare(v,d,m=!1){return v===d?0:(0,C.compare)(this.getComparisonKey(v,m),this.getComparisonKey(d,m))}isEqual(v,d,m=!1){return v===d?!0:!v||!d?!1:this.getComparisonKey(v,m)===this.getComparisonKey(d,m)}getComparisonKey(v,d=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,d,m=!1){if(v.scheme===d.scheme){if(v.scheme===t.Schemas.file)return c.isEqualOrParent(S(v),S(d),this.a(v))&&v.query===d.query&&(m||v.fragment===d.fragment);if((0,e.isEqualAuthority)(v.authority,d.authority))return c.isEqualOrParent(v.path,d.path,this.a(v),"/")&&v.query===d.query&&(m||v.fragment===d.fragment)}return!1}joinPath(v,...d){return T.URI.joinPath(v,...d)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return I.posix.basename(v.path)}extname(v){return I.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let d;return v.scheme===t.Schemas.file?d=T.URI.file(I.dirname(S(v))).path:(d=I.posix.dirname(v.path),v.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),d="/")),v.with({path:d})}normalizePath(v){if(!v.path.length)return v;let d;return v.scheme===t.Schemas.file?d=T.URI.file(I.normalize(S(v))).path:d=I.posix.normalize(v.path),v.with({path:d})}relativePath(v,d){if(v.scheme!==d.scheme||!(0,e.isEqualAuthority)(v.authority,d.authority))return;if(v.scheme===t.Schemas.file){const b=I.relative(S(v),S(d));return A.isWindows?c.toSlashes(b):b}let m=v.path||"/";const h=d.path||"/";if(this.a(v)){let b=0;for(const p=Math.min(m.length,h.length);b<p&&!(m.charCodeAt(b)!==h.charCodeAt(b)&&m.charAt(b).toLowerCase()!==h.charAt(b).toLowerCase());b++);m=h.substr(0,b)+m.substr(b)}return I.posix.relative(m,h)}resolvePath(v,d){if(v.scheme===t.Schemas.file){const m=T.URI.file(I.resolve(S(v),d));return v.with({authority:m.authority,path:m.path})}return d=c.toPosixPath(d),v.with({path:I.posix.resolve(v.path,d)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,d){return v===d||v!==void 0&&d!==void 0&&(0,C.equalsIgnoreCase)(v,d)}hasTrailingPathSeparator(v,d=I.sep){if(v.scheme===t.Schemas.file){const m=S(v);return m.length>c.getRoot(m).length&&m[m.length-1]===d}else{const m=v.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,d=I.sep){return(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,d=I.sep){let m=!1;if(v.scheme===t.Schemas.file){const h=S(v);m=h!==void 0&&h.length===c.getRoot(h).length&&h[h.length-1]===d}else{d="/";const h=v.path;m=h.length===1&&h.charCodeAt(h.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path+"/"}):v}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(D=>D.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new y(D=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(D,v){const d=[];for(let m=0;m<D.length;m++){const h=v(D[m]);D.some((b,p)=>p===m?!1:(0,e.isEqualOrParent)(h,v(b)))||d.push(D[m])}return d}e.distinctParents=L;var P;(function(D){D.META_DATA_LABEL="label",D.META_DATA_DESCRIPTION="description",D.META_DATA_SIZE="size",D.META_DATA_MIME="mime";function v(d){const m=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(p=>{const[g,w]=p.split(":");g&&w&&m.set(g,w)});const b=d.path.substring(0,d.path.indexOf(";"));return b&&m.set(D.META_DATA_MIME,b),m}D.parseMetaData=v})(P=e.DataUri||(e.DataUri={}));function E(D,v,d){if(v){let m=D.path;return m&&m[0]!==I.posix.sep&&(m=I.posix.sep+m),D.with({scheme:d,authority:v,path:m})}return D.with({scheme:d})}e.toLocalResource=E}),define(Se[18],ye([1,0,21,10,4,6,24,12]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(le){return!!le&&typeof le.then=="function"}e.isThenable=S;function y(le){const Z=new c.CancellationTokenSource,ge=le(Z.token),ve=new Promise((De,Re)=>{const ze=Z.token.onCancellationRequested(()=>{ze.dispose(),Z.dispose(),Re(new t.CancellationError)});Promise.resolve(ge).then(se=>{ze.dispose(),Z.dispose(),De(se)},se=>{ze.dispose(),Z.dispose(),Re(se)})});return new class{cancel(){Z.cancel()}then(De,Re){return ve.then(De,Re)}catch(De){return this.then(void 0,De)}finally(De){return ve.finally(De)}}}e.createCancelablePromise=y;function L(le,Z,ge){return new Promise((ve,De)=>{const Re=Z.onCancellationRequested(()=>{Re.dispose(),ve(ge)});le.then(ve,De).finally(()=>Re.dispose())})}e.raceCancellation=L;function P(le,Z){return new Promise((ge,ve)=>{const De=Z.onCancellationRequested(()=>{De.dispose(),ve(new t.CancellationError)});le.then(ge,ve).finally(()=>De.dispose())})}e.raceCancellationError=P;async function E(le){let Z=-1;const ge=le.map((De,Re)=>De.then(ze=>(Z=Re,ze))),ve=await Promise.race(ge);return le.forEach((De,Re)=>{Re!==Z&&De.cancel()}),ve}e.raceCancellablePromises=E;function D(le,Z,ge){let ve;const De=setTimeout(()=>{ve?.(void 0),ge?.()},Z);return Promise.race([le.finally(()=>clearTimeout(De)),new Promise(Re=>ve=Re)])}e.raceTimeout=D;function v(le){return new Promise((Z,ge)=>{const ve=le();S(ve)?ve.then(Z,ge):Z(ve)})}e.asPromise=v;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(Z){if(this.a){if(this.d=Z,!this.b){const ge=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(ge,ge).then(ve)})}return new Promise((ge,ve)=>{this.b.then(ge,ve)})}return this.a=Z(),new Promise((ge,ve)=>{this.a.then(De=>{this.a=null,ge(De)},De=>{this.a=null,ve(De)})})}}e.Throttler=d;class m{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.Sequencer=m;class h{constructor(){this.a=new Map}queue(Z,ge){const De=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.a.get(Z)===De&&this.a.delete(Z)});return this.a.set(Z,De),De}}e.SequencerByKey=h;const b=(le,Z)=>{let ge=!0;const ve=setTimeout(()=>{ge=!1,Z()},le);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(ve),ge=!1}}},p=le=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,le())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,ge=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((De,Re)=>{this.d=De,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const De=this.g;return this.g=null,De()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=ge===e.MicrotaskDelay?p(ve):b(ge,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=g;class w{constructor(Z){this.a=new g(Z),this.b=new d}trigger(Z,ge){return this.a.trigger(()=>this.b.queue(Z),ge)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=w;class s{constructor(){this.a=!1,this.b=new Promise((Z,ge)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class r extends s{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function l(le,Z){return Z?new Promise((ge,ve)=>{const De=setTimeout(()=>{Re.dispose(),ge()},le),Re=Z.onCancellationRequested(()=>{clearTimeout(De),Re.dispose(),ve(new t.CancellationError)})}):y(ge=>l(le,ge))}e.timeout=l;function u(le,Z=0){const ge=setTimeout(le,Z);return(0,A.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=u;function o(le){const Z=[];let ge=0;const ve=le.length;function De(){return ge<ve?le[ge++]():null}function Re(ze){ze!=null&&Z.push(ze);const se=De();return se?se.then(Re):Promise.resolve(Z)}return Promise.resolve(null).then(Re)}e.sequence=o;function a(le,Z=ve=>!!ve,ge=null){let ve=0;const De=le.length,Re=()=>{if(ve>=De)return Promise.resolve(ge);const ze=le[ve++];return Promise.resolve(ze()).then(ue=>Z(ue)?Promise.resolve(ue):Re())};return Re()}e.first=a;function n(le,Z=ve=>!!ve,ge=null){if(le.length===0)return Promise.resolve(ge);let ve=le.length;const De=()=>{ve=-1;for(const Re of le)Re.cancel?.()};return new Promise((Re,ze)=>{for(const se of le)se.then(ue=>{--ve>=0&&Z(ue)?(De(),Re(ue)):ve===0&&Re(ge)}).catch(ue=>{--ve>=0&&(De(),ze(ue))})})}e.firstParallel=n;class i{constructor(Z){this.a=0,this.d=Z,this.f=[],this.b=0,this.g=new I.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(Z){return this.a++,new Promise((ge,ve)=>{this.f.push({factory:Z,c:ge,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Z=this.f.shift();this.b++;const ge=Z.factory();ge.then(Z.c,Z.e),ge.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=i;class f extends i{constructor(){super(1)}}e.Queue=f;class k{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const Z=new x;return this.b.add(Z),Z.p}d(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueFor(Z,ge=C.extUri){const ve=ge.getComparisonKey(Z);let De=this.a.get(ve);return De||(De=new f,I.Event.once(De.onDrained)(()=>{De?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,De)),De}f(){!this.d()||this.g()}g(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.g()}}e.ResourceQueue=k;class R{constructor(Z,ge){this.a=-1,typeof Z=="function"&&typeof ge=="number"&&this.setIfNotSet(Z,ge)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,ge){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},ge)}setIfNotSet(Z,ge){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},ge))}}e.TimeoutTimer=R;class B{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(Z,ge){this.cancel(),this.a=setInterval(()=>{Z()},ge)}}e.IntervalTimer=B;class X{constructor(Z,ge){this.b=-1,this.a=Z,this.d=ge,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=X;class q{constructor(Z,ge){ge%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.a=Z,this.b=ge,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=q;class N extends X{constructor(Z,ge){super(Z,ge),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=N;class M extends A.Disposable{constructor(Z,ge){super(),this.g=Z,this.h=ge,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...Z),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new X(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=le=>{(0,T.setTimeout0)(()=>{if(Z)return;const ge=Date.now()+15;le(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.runWhenIdle=(le,Z)=>{const ge=requestIdleCallback(le,typeof Z=="number"?{timeout:Z}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(ge))}}}}();class F{constructor(Z){this.d=!1,this.a=()=>{try{this.f=Z()}catch(ge){this.g=ge}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function z(le,Z,ge){let ve;for(let De=0;De<ge;De++)try{return await le()}catch(Re){ve=Re,await l(Z)}throw ve}e.retry=z;class U{hasPending(Z){return this.a?typeof Z=="number"?this.a.taskId===Z:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(Z,ge,ve){return this.a={taskId:Z,cancel:()=>ve?.(),promise:ge},ge.then(()=>this.d(Z),()=>this.d(Z)),ge}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}setNext(Z){if(this.b)this.b.run=Z;else{let ge,ve;const De=new Promise((Re,ze)=>{ge=Re,ve=ze});this.b={run:Z,promise:De,promiseResolve:ge,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=U;class W{constructor(Z,ge=()=>Date.now()){this.d=Z,this.f=ge,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.IntervalCounter=W;class x{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((Z,ge)=>{this.a=Z,this.b=ge})}complete(Z){return new Promise(ge=>{this.a(Z),this.f=!0,ge()})}error(Z){return new Promise(ge=>{this.b(Z),this.d=!0,ge()})}cancel(){new Promise(Z=>{this.b(new t.CancellationError),this.d=!0,Z()})}}e.DeferredPromise=x;var V;(function(le){async function Z(ve){let De;const Re=await Promise.all(ve.map(ze=>ze.then(se=>se,se=>{De||(De=se)})));if(typeof De<"u")throw De;return Re}le.settled=Z;function ge(ve){return new Promise(async(De,Re)=>{try{await ve(De,Re)}catch(ze){Re(ze)}})}le.withAsyncBody=ge})(V=e.Promises||(e.Promises={}));var _;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(_||(_={}));class Q{static fromArray(Z){return new Q(ge=>{ge.emitMany(Z)})}static fromPromise(Z){return new Q(async ge=>{ge.emitMany(await Z)})}static fromPromises(Z){return new Q(async ge=>{await Promise.all(Z.map(async ve=>ge.emitOne(await ve)))})}static merge(Z){return new Q(async ge=>{await Promise.all(Z.map(async ve=>{for await(const De of ve)ge.emitOne(De)}))})}constructor(Z){this.a=0,this.b=[],this.d=null,this.f=new I.Emitter,queueMicrotask(async()=>{const ge={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(Z(ge)),this.j()}catch(ve){this.k(ve)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(Z,ge){return new Q(async ve=>{for await(const De of Z)ve.emitOne(ge(De))})}map(Z){return Q.map(this,Z)}static filter(Z,ge){return new Q(async ve=>{for await(const De of Z)ge(De)&&ve.emitOne(De)})}filter(Z){return Q.filter(this,Z)}static coalesce(Z){return Q.filter(Z,ge=>!!ge)}coalesce(){return Q.coalesce(this)}static async toPromise(Z){const ge=[];for await(const ve of Z)ge.push(ve);return ge}toPromise(){return Q.toPromise(this)}g(Z){this.a===0&&(this.b.push(Z),this.f.fire())}h(Z){this.a===0&&(this.b=this.b.concat(Z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Z){this.a===0&&(this.a=2,this.d=Z,this.f.fire())}}e.AsyncIterableObject=Q,Q.EMPTY=Q.fromArray([]);class J extends Q{constructor(Z,ge){super(ge),this.l=Z}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=J;function te(le){const Z=new c.CancellationTokenSource,ge=le(Z.token);return new J(Z,async ve=>{const De=Z.token.onCancellationRequested(()=>{De.dispose(),Z.dispose(),ve.reject(new t.CancellationError)});try{for await(const Re of ge){if(Z.token.isCancellationRequested)return;ve.emitOne(Re)}De.dispose(),Z.dispose()}catch(Re){De.dispose(),Z.dispose(),ve.reject(Re)}})}e.createCancelableAsyncIterable=te}),define(Se[108],ye([1,0,18,9]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new c.IdleValue(()=>{const i=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:i,collatorIsNumeric:i.resolvedOptions().numeric}}),A=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(i,f,k=!1){const R=i||"",B=f||"",X=I.value.collator.compare(R,B);return I.value.collatorIsNumeric&&X===0&&R!==B?R<B?-1:1:X}e.compareFileNames=T;function S(i,f){const k=A.value.collator;return i=i||"",f=f||"",g(k,i,f)}e.compareFileNamesDefault=S;function y(i,f){const k=A.value.collator;return i=i||"",f=f||"",l(i,f)||g(k,i,f)}e.compareFileNamesUpper=y;function L(i,f){const k=A.value.collator;return i=i||"",f=f||"",r(i,f)||g(k,i,f)}e.compareFileNamesLower=L;function P(i,f){return i=i||"",f=f||"",i===f?0:i<f?-1:1}e.compareFileNamesUnicode=P;function E(i,f){const[k,R]=b(i),[B,X]=b(f);let q=I.value.collator.compare(R,X);if(q===0){if(I.value.collatorIsNumeric&&R!==X)return R<X?-1:1;if(q=I.value.collator.compare(k,B),I.value.collatorIsNumeric&&q===0&&k!==B)return k<B?-1:1}return q}e.compareFileExtensions=E;function D(i,f){i=i||"",f=f||"";const k=p(i),R=p(f),B=A.value.collator,X=C.value.collator;return g(X,k,R)||g(B,i,f)}e.compareFileExtensionsDefault=D;function v(i,f){i=i||"",f=f||"";const k=p(i),R=p(f),B=A.value.collator,X=C.value.collator;return g(X,k,R)||l(i,f)||g(B,i,f)}e.compareFileExtensionsUpper=v;function d(i,f){i=i||"",f=f||"";const k=p(i),R=p(f),B=A.value.collator,X=C.value.collator;return g(X,k,R)||r(i,f)||g(B,i,f)}e.compareFileExtensionsLower=d;function m(i,f){i=i||"",f=f||"";const k=p(i).toLowerCase(),R=p(f).toLowerCase();return k!==R?k<R?-1:1:i!==f?i<f?-1:1:0}e.compareFileExtensionsUnicode=m;const h=/^(.*?)(\.([^.]*))?$/;function b(i,f=!1){const k=i?h.exec(i):[];let R=[k&&k[1]||"",k&&k[3]||""];return f&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function p(i){const f=i?h.exec(i):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function g(i,f,k){const R=i.compare(f,k);return R!==0?R:f.length!==k.length?f.length<k.length?-1:1:0}function w(i){const f=i.charAt(0);return f.toLocaleUpperCase()!==f}function s(i){const f=i.charAt(0);return f.toLocaleLowerCase()!==f}function r(i,f){return w(i)&&s(f)?-1:s(i)&&w(f)?1:0}function l(i,f){return s(i)&&w(f)?-1:w(i)&&s(f)?1:0}function u(i,f,k=!1){return k||(i=i&&i.toLowerCase(),f=f&&f.toLowerCase()),i===f?0:i<f?-1:1}function o(i,f,k=!1){const R=i.split(t.sep),B=f.split(t.sep),X=R.length-1,q=B.length-1;let N,M;for(let F=0;;F++){if(N=X===F,M=q===F,N&&M)return T(R[F],B[F],k);if(N)return-1;if(M)return 1;const z=u(R[F],B[F],k);if(z!==0)return z}}e.comparePaths=o;function a(i,f,k){const R=i.toLowerCase(),B=f.toLowerCase(),X=n(i,f,k);if(X)return X;const q=R.endsWith(k),N=B.endsWith(k);if(q!==N)return q?-1:1;const M=T(R,B);return M!==0?M:R.localeCompare(B)}e.compareAnything=a;function n(i,f,k){const R=i.toLowerCase(),B=f.toLowerCase(),X=R.startsWith(k),q=B.startsWith(k);if(X!==q)return X?-1:1;if(X&&q){if(R.length<B.length)return-1;if(R.length>B.length)return 1}return 0}e.compareByPrefix=n}),define(Se[109],ye([1,0,108,107,84,9,12,8]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,y=[S,[]];function L(U,W,x,V){if(!U||!W)return y;const _=U.length,Q=W.length;if(_<Q)return y;const J=U.toLowerCase();return P(W,x,Q,U,J,_,V)}e.scoreFuzzy=L;function P(U,W,x,V,_,Q,J){const te=[],le=[];for(let De=0;De<x;De++){const Re=De*Q,ze=Re-Q,se=De>0,ue=U[De],he=W[De];for(let ee=0;ee<Q;ee++){const oe=ee>0,ie=Re+ee,O=ie-1,H=ze+ee-1,K=oe?te[O]:0,Y=se&&oe?te[H]:0,de=se&&oe?le[H]:0;let be;!Y&&se?be=0:be=E(ue,he,V,_,ee,de),be&&Y+be>=K&&(J||se||_.startsWith(W,ee))?(le[ie]=de+1,te[ie]=Y+be):(le[ie]=S,te[ie]=K)}}const Z=[];let ge=x-1,ve=Q-1;for(;ge>=0&&ve>=0;){const De=ge*Q+ve;le[De]===S||(Z.push(ve),ge--),ve--}return[te[x*Q-1],Z.reverse()]}function E(U,W,x,V,_,Q){let J=0;if(!D(W,V[_]))return J;if(J+=1,Q>0&&(J+=Q*5),U===x[_]&&(J+=1),_===0)J+=8;else{const te=v(x.charCodeAt(_-1));te?J+=te:(0,t.isUpper)(x.charCodeAt(_))&&Q===0&&(J+=2)}return J}function D(U,W){return U===W?!0:U==="/"||U==="\\"?W==="/"||W==="\\":!1}function v(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function m(U,W,x=0,V=0){const _=W;return _.values&&_.values.length>1?h(U,_.values,x,V):b(U,W,x,V)}e.scoreFuzzy2=m;function h(U,W,x,V){let _=0;const Q=[];for(const J of W){const[te,le]=b(U,J,x,V);if(typeof te!="number")return d;_+=te,Q.push(...le)}return[_,i(Q)]}function b(U,W,x,V){const _=(0,t.fuzzyScore)(W.original,W.originalLowercase,x,U,U.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?[_[0],(0,t.createMatches)(_)]:d}const p=Object.freeze({score:0}),g=1<<18,w=1<<17,s=1<<16;function r(U,W,x,V){const _=V.values?V.values:[V];return(0,I.hash)({[V.normalized]:{values:_.map(J=>({value:J.normalized,expectContiguousMatch:J.expectContiguousMatch})),label:U,description:W,allowNonContiguousMatches:x}})}function l(U,W,x,V,_){if(!U||!W.normalized)return p;const Q=V.getItemLabel(U);if(!Q)return p;const J=V.getItemDescription(U),te=r(Q,J,x,W),le=_[te];if(le)return le;const Z=u(Q,J,V.getItemPath(U),W,x);return _[te]=Z,Z}e.scoreItemFuzzy=l;function u(U,W,x,V,_){const Q=!x||!V.containsPathSeparator;return x&&(C.isLinux?V.pathNormalized===x:(0,T.equalsIgnoreCase)(V.pathNormalized,x))?{score:g,labelMatch:[{start:0,end:U.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:V.values&&V.values.length>1?o(U,W,x,V.values,Q,_):a(U,W,x,V,Q,_)}function o(U,W,x,V,_,Q){let J=0;const te=[],le=[];for(const Z of V){const{score:ge,labelMatch:ve,descriptionMatch:De}=a(U,W,x,Z,_,Q);if(ge===S)return p;J+=ge,ve&&te.push(...ve),De&&le.push(...De)}return{score:J,labelMatch:i(te),descriptionMatch:i(le)}}function a(U,W,x,V,_,Q){if(_||!W){const[J,te]=L(U,V.normalized,V.normalizedLowercase,Q&&!V.expectContiguousMatch);if(J){const le=(0,t.matchesPrefix)(V.normalized,U);let Z;return le?(Z=w,Z+=Math.round(V.normalized.length/U.length*100)):Z=s,{score:Z+J,labelMatch:le||n(te)}}}if(W){let J=W;x&&(J=`${W}${A.sep}`);const te=J.length,le=`${J}${U}`,[Z,ge]=L(le,V.normalized,V.normalizedLowercase,Q&&!V.expectContiguousMatch);if(Z){const ve=n(ge),De=[],Re=[];return ve.forEach(ze=>{ze.start<te&&ze.end>te?(De.push({start:0,end:ze.end-te}),Re.push({start:ze.start,end:te})):ze.start>=te?De.push({start:ze.start-te,end:ze.end-te}):Re.push(ze)}),{score:Z,labelMatch:De,descriptionMatch:Re}}}return p}function n(U){const W=[];if(!U)return W;let x;for(const V of U)x&&x.end===V?x.end+=1:(x={start:V,end:V+1},W.push(x));return W}function i(U){const W=U.sort((_,Q)=>_.start-Q.start),x=[];let V;for(const _ of W)!V||!f(V,_)?(V=_,x.push(_)):(V.start=Math.min(V.start,_.start),V.end=Math.max(V.end,_.end));return x}function f(U,W){return!(U.end<W.start||W.end<U.start)}function k(U,W,x,V,_,Q){const J=l(U,x,V,_,Q),te=l(W,x,V,_,Q),le=J.score,Z=te.score;if((le===g||Z===g)&&le!==Z)return le===g?-1:1;if(le>s||Z>s){if(le!==Z)return le>Z?-1:1;if(le<w&&Z<w){const ue=B(J.labelMatch,te.labelMatch);if(ue!==0)return ue}const ze=_.getItemLabel(U)||"",se=_.getItemLabel(W)||"";if(ze.length!==se.length)return ze.length-se.length}if(le!==Z)return le>Z?-1:1;const ge=Array.isArray(J.labelMatch)&&J.labelMatch.length>0,ve=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(ge&&!ve)return-1;if(ve&&!ge)return 1;const De=R(U,J,_),Re=R(W,te,_);return De&&Re&&De!==Re?Re>De?-1:1:X(U,W,x,_)}e.compareItemsByFuzzyScore=k;function R(U,W,x){let V=-1,_=-1;if(W.descriptionMatch&&W.descriptionMatch.length?V=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(V=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(_=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const Q=x.getItemDescription(U);Q&&(_+=Q.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(_=W.descriptionMatch[W.descriptionMatch.length-1].end);return _-V}function B(U,W){if(!U&&!W||(!U||!U.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!U||!U.length)return 1;const x=U[0].start,_=U[U.length-1].end-x,Q=W[0].start,te=W[W.length-1].end-Q;return _===te?0:te<_?1:-1}function X(U,W,x,V){const _=V.getItemLabel(U)||"",Q=V.getItemLabel(W)||"",J=V.getItemDescription(U),te=V.getItemDescription(W),le=_.length+(J?J.length:0),Z=Q.length+(te?te.length:0);if(le!==Z)return le-Z;const ge=V.getItemPath(U),ve=V.getItemPath(W);return ge&&ve&&ge.length!==ve.length?ge.length-ve.length:_!==Q?(0,c.compareAnything)(_,Q,x.normalized):J&&te&&J!==te?(0,c.compareAnything)(J,te,x.normalized):ge&&ve&&ge!==ve?(0,c.compareAnything)(ge,ve,x.normalized):0}function q(U){return U.startsWith('"')&&U.endsWith('"')}const N=" ";function M(U){typeof U!="string"&&(U="");const W=U.toLowerCase(),{pathNormalized:x,normalized:V,normalizedLowercase:_}=F(U),Q=x.indexOf(A.sep)>=0,J=q(U);let te;const le=U.split(N);if(le.length>1)for(const Z of le){const ge=q(Z),{pathNormalized:ve,normalized:De,normalizedLowercase:Re}=F(Z);De&&(te||(te=[]),te.push({original:Z,originalLowercase:Z.toLowerCase(),pathNormalized:ve,normalized:De,normalizedLowercase:Re,expectContiguousMatch:ge}))}return{original:U,originalLowercase:W,pathNormalized:x,normalized:V,normalizedLowercase:_,values:te,containsPathSeparator:Q,expectContiguousMatch:J}}e.prepareQuery=M;function F(U){let W;C.isWindows?W=U.replace(/\//g,A.sep):W=U.replace(/\\/g,A.sep);const x=(0,T.stripWildcards)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:x,normalizedLowercase:x.toLowerCase()}}function z(U){return Array.isArray(U)?M(U.map(W=>W.original).join(N)):M(U.original)}e.pieceToQuery=z}),define(Se[37],ye([1,0,17,18,32,28,9,12,8]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",P="[^/\\\\]",E=/\//g;function D(x,V){switch(x){case 0:return"";case 1:return`${P}*?`;default:return`(?:${L}|${P}+${L}${V?`|${L}${P}+`:""})*?`}}function v(x,V){if(!x)return[];const _=[];let Q=!1,J=!1,te="";for(const le of x){switch(le){case V:if(!Q&&!J){_.push(te),te="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":J=!0;break;case"]":J=!1;break}te+=le}return te&&_.push(te),_}e.splitGlobAware=v;function d(x){if(!x)return"";let V="";const _=v(x,e.GLOB_SPLIT);if(_.every(Q=>Q===e.GLOBSTAR))V=".*";else{let Q=!1;_.forEach((J,te)=>{if(J===e.GLOBSTAR){if(Q)return;V+=D(2,te===_.length-1)}else{let le=!1,Z="",ge=!1,ve="";for(const De of J){if(De!=="}"&&le){Z+=De;continue}if(ge&&(De!=="]"||!ve)){let Re;De==="-"?Re=De:(De==="^"||De==="!")&&!ve?Re="^":De===e.GLOB_SPLIT?Re="":Re=(0,S.escapeRegExpCharacters)(De),ve+=Re;continue}switch(De){case"{":le=!0;continue;case"[":ge=!0;continue;case"}":{V+=`(?:${v(Z,",").map(se=>d(se)).join("|")})`,le=!1,Z="";break}case"]":{V+="["+ve+"]",ge=!1,ve="";break}case"?":V+=P;continue;case"*":V+=D(1);continue;default:V+=(0,S.escapeRegExpCharacters)(De)}}te<_.length-1&&(_[te+1]!==e.GLOBSTAR||te+2<_.length)&&(V+=L)}Q=J===e.GLOBSTAR})}return V}const m=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new A.LRUCache(1e4),r=function(){return!1},l=function(){return null};function u(x,V){if(!x)return l;let _;typeof x!="string"?_=x.pattern:_=x,_=_.trim();const Q=`${_}_${!!V.trimForExclusions}`;let J=s.get(Q);if(J)return o(J,x);let te;return m.test(_)?J=n(_.substr(4),_):(te=h.exec(a(_,V)))?J=i(te[1],_):(V.trimForExclusions?p:b).test(_)?J=f(_,V):(te=g.exec(a(_,V)))?J=k(te[1].substr(1),_,!0):(te=w.exec(a(_,V)))?J=k(te[1],_,!1):J=R(_),s.set(Q,J),o(J,x)}function o(x,V){if(typeof V=="string")return x;const _=function(Q,J){return(0,I.isEqualOrParent)(Q,V.base,!T.isLinux)?x((0,S.ltrim)(Q.substr(V.base.length),C.sep),J):null};return _.allBasenames=x.allBasenames,_.allPaths=x.allPaths,_.basenames=x.basenames,_.patterns=x.patterns,_}function a(x,V){return V.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function n(x,V){return function(_,Q){return typeof _=="string"&&_.endsWith(x)?V:null}}function i(x,V){const _=`/${x}`,Q=`\\${x}`,J=function(le,Z){return typeof le!="string"?null:Z?Z===x?V:null:le===x||le.endsWith(_)||le.endsWith(Q)?V:null},te=[x];return J.basenames=te,J.patterns=[V],J.allBasenames=te,J}function f(x,V){const _=U(x.slice(1,-1).split(",").map(Z=>u(Z,V)).filter(Z=>Z!==l),x),Q=_.length;if(!Q)return l;if(Q===1)return _[0];const J=function(Z,ge){for(let ve=0,De=_.length;ve<De;ve++)if(_[ve](Z,ge))return x;return null},te=_.find(Z=>!!Z.allBasenames);te&&(J.allBasenames=te.allBasenames);const le=_.reduce((Z,ge)=>ge.allPaths?Z.concat(ge.allPaths):Z,[]);return le.length&&(J.allPaths=le),J}function k(x,V,_){const Q=C.sep===C.posix.sep,J=Q?x:x.replace(E,C.sep),te=C.sep+J,le=C.posix.sep+x;let Z;return _?Z=function(ge,ve){return typeof ge=="string"&&(ge===J||ge.endsWith(te)||!Q&&(ge===x||ge.endsWith(le)))?V:null}:Z=function(ge,ve){return typeof ge=="string"&&(ge===J||!Q&&ge===x)?V:null},Z.allPaths=[(_?"*/":"./")+x],Z}function R(x){try{const V=new RegExp(`^${d(x)}$`);return function(_){return V.lastIndex=0,typeof _=="string"&&V.test(_)?x:null}}catch{return l}}function B(x,V,_){return!x||typeof V!="string"?!1:X(x)(V,void 0,_)}e.match=B;function X(x,V={}){if(!x)return r;if(typeof x=="string"||q(x)){const _=u(x,V);if(_===l)return r;const Q=function(J,te){return!!_(J,te)};return _.allBasenames&&(Q.allBasenames=_.allBasenames),_.allPaths&&(Q.allPaths=_.allPaths),Q}return F(x,V)}e.parse=X;function q(x){const V=x;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=q;function N(x){return x.allBasenames||[]}e.getBasenameTerms=N;function M(x){return x.allPaths||[]}e.getPathTerms=M;function F(x,V){const _=U(Object.getOwnPropertyNames(x).map(Z=>z(Z,x[Z],V)).filter(Z=>Z!==l)),Q=_.length;if(!Q)return l;if(!_.some(Z=>!!Z.requiresSiblings)){if(Q===1)return _[0];const Z=function(De,Re){let ze;for(let se=0,ue=_.length;se<ue;se++){const he=_[se](De,Re);if(typeof he=="string")return he;(0,t.isThenable)(he)&&(ze||(ze=[]),ze.push(he))}return ze?(async()=>{for(const se of ze){const ue=await se;if(typeof ue=="string")return ue}return null})():null},ge=_.find(De=>!!De.allBasenames);ge&&(Z.allBasenames=ge.allBasenames);const ve=_.reduce((De,Re)=>Re.allPaths?De.concat(Re.allPaths):De,[]);return ve.length&&(Z.allPaths=ve),Z}const J=function(Z,ge,ve){let De,Re;for(let ze=0,se=_.length;ze<se;ze++){const ue=_[ze];ue.requiresSiblings&&ve&&(ge||(ge=(0,C.basename)(Z)),De||(De=ge.substr(0,ge.length-(0,C.extname)(Z).length)));const he=ue(Z,ge,De,ve);if(typeof he=="string")return he;(0,t.isThenable)(he)&&(Re||(Re=[]),Re.push(he))}return Re?(async()=>{for(const ze of Re){const se=await ze;if(typeof se=="string")return se}return null})():null},te=_.find(Z=>!!Z.allBasenames);te&&(J.allBasenames=te.allBasenames);const le=_.reduce((Z,ge)=>ge.allPaths?Z.concat(ge.allPaths):Z,[]);return le.length&&(J.allPaths=le),J}function z(x,V,_){if(V===!1)return l;const Q=u(x,_);if(Q===l)return l;if(typeof V=="boolean")return Q;if(V){const J=V.when;if(typeof J=="string"){const te=(le,Z,ge,ve)=>{if(!ve||!Q(le,Z))return null;const De=J.replace("$(basename)",()=>ge),Re=ve(De);return(0,t.isThenable)(Re)?Re.then(ze=>ze?x:null):Re?x:null};return te.requiresSiblings=!0,te}}return Q}function U(x,V){const _=x.filter(Z=>!!Z.basenames);if(_.length<2)return x;const Q=_.reduce((Z,ge)=>{const ve=ge.basenames;return ve?Z.concat(ve):Z},[]);let J;if(V){J=[];for(let Z=0,ge=Q.length;Z<ge;Z++)J.push(V)}else J=_.reduce((Z,ge)=>{const ve=ge.patterns;return ve?Z.concat(ve):Z},[]);const te=function(Z,ge){if(typeof Z!="string")return null;if(!ge){let De;for(De=Z.length;De>0;De--){const Re=Z.charCodeAt(De-1);if(Re===47||Re===92)break}ge=Z.substr(De)}const ve=Q.indexOf(ge);return ve!==-1?J[ve]:null};te.basenames=Q,te.patterns=J,te.allBasenames=Q;const le=x.filter(Z=>!Z.basenames);return le.push(te),le}function W(x,V){return(0,c.equals)(x,V,(_,Q)=>typeof _=="string"&&typeof Q=="string"?_===Q:typeof _!="string"&&typeof Q!="string"?_.base===Q.base&&_.pattern===Q.pattern:!1)}e.patternsEquals=W}),define(Se[110],ye([1,0,10,160,24,8,2]),function(ne,e,c,t,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(h="",b=!1){if(this.value=h,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof b=="boolean"?(this.isTrusted=b,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=b.isTrusted??void 0,this.supportThemeIcons=b.supportThemeIcons??!1,this.supportHtml=b.supportHtml??!1)}appendText(h,b=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(h):h).replace(/([ \t]+)/g,(p,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,b===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,b){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=b,this.value+="\n```\n",this}appendLink(h,b,p){return this.value+="[",this.value+=this.c(b,"]"),this.value+="](",this.value+=this.c(String(h),")"),p&&(this.value+=` "${this.c(this.c(p,'"'),")")}"`),this.value+=")",this}c(h,b){const p=new RegExp((0,A.escapeRegExpCharacters)(b),"g");return h.replace(p,(g,w)=>h.charAt(w-1)!=="\\"?`\\${g}`:g)}}e.MarkdownString=S;function y(m){return L(m)?!m.value:Array.isArray(m)?m.every(y):!0}e.isEmptyMarkdownString=y;function L(m){return m instanceof S?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function P(m,h){return m===h?!0:!m||!h?!1:m.value===h.value&&m.isTrusted===h.isTrusted&&m.supportThemeIcons===h.supportThemeIcons&&m.supportHtml===h.supportHtml&&(m.baseUri===h.baseUri||!!m.baseUri&&!!h.baseUri&&(0,I.isEqual)(C.URI.from(m.baseUri),C.URI.from(h.baseUri)))}e.markdownStringEqual=P;function E(m){return m.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function D(m){return m.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=D;function v(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=v;function d(m){const h=[],b=m.split("|").map(g=>g.trim());m=b[0];const p=b[1];if(p){const g=/height=(\d+)/.exec(p),w=/width=(\d+)/.exec(p),s=g?g[1]:"",r=w?w[1]:"",l=isFinite(parseInt(r)),u=isFinite(parseInt(s));l&&h.push(`width="${r}"`),u&&h.push(`height="${s}"`)}return{href:m,dimensions:h}}e.parseHrefAndDimensions=d}),define(Se[111],ye([1,0,17,32,9,12,24,8]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(l,u){const{os:o,tildify:a,relative:n}=u;if(n){const k=y(l,n,o);if(typeof k=="string")return k}let i=l.fsPath;if(o===1&&!A.isWindows?i=i.replace(/\//g,"\\"):o!==1&&A.isWindows&&(i=i.replace(/\\/g,"/")),o!==1&&a?.userHome){const k=a.userHome.fsPath;let R;l.scheme!==a.userHome.scheme&&l.path.startsWith(I.posix.sep)?R=a.userHome.with({path:l.path}).fsPath:R=l.fsPath,i=E(R,k,o)}return(o===1?I.win32:I.posix).normalize(L(i,o===1))}e.getPathLabel=S;function y(l,u,o){const a=o===1?I.win32:I.posix,n=o===3?C.extUri:C.extUriIgnorePathCase,i=u.getWorkspace(),f=(0,c.firstOrDefault)(i.folders);if(!f)return;l.scheme!==f.uri.scheme&&l.path.startsWith(I.posix.sep)&&(l=f.uri.with({path:l.path}));const k=u.getWorkspaceFolder(l);if(!k)return;let R;if(n.isEqual(k.uri,l)?R="":R=n.relativePath(k.uri,l)??"",R&&(R=a.normalize(R)),i.folders.length>1&&!u.noPrefix){const B=k.name?k.name:n.basenameOrAuthority(k.uri);R=R?`${B} \u2022 ${R}`:B}return R}function L(l,u=A.isWindows){return(0,t.hasDriveLetter)(l,u)?l.charAt(0).toUpperCase()+l.slice(1):l}e.normalizeDriveLetter=L;let P=Object.create(null);function E(l,u,o=A.OS){if(o===1||!l||!u)return l;let a=P.original===u?P.normalized:void 0;a||(a=u,A.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,T.rtrim)(a,I.posix.sep)}${I.posix.sep}`,P={original:u,normalized:a});let n=l;return A.isWindows&&(n=(0,t.toSlashes)(n)),(o===3?n.startsWith(a):(0,T.startsWithIgnoreCase)(n,a))?`~/${n.substr(a.length)}`:l}e.tildify=E;function D(l,u){return l.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=D;const v="\u2026",d="\\\\",m="~";function h(l,u=I.sep){const o=new Array(l.length);let a=!1;for(let n=0;n<l.length;n++){const i=l[n];if(i===""){o[n]=`.${u}`;continue}if(!i){o[n]=i;continue}a=!0;let f="",k=i;k.indexOf(d)===0?(f=k.substr(0,k.indexOf(d)+d.length),k=k.substr(k.indexOf(d)+d.length)):k.indexOf(u)===0?(f=k.substr(0,k.indexOf(u)+u.length),k=k.substr(k.indexOf(u)+u.length)):k.indexOf(m)===0&&(f=k.substr(0,k.indexOf(m)+m.length),k=k.substr(k.indexOf(m)+m.length));const R=k.split(u);for(let B=1;a&&B<=R.length;B++)for(let X=R.length-B;a&&X>=0;X--){a=!1;let q=R.slice(X,X+B).join(u);for(let N=0;!a&&N<l.length;N++)if(N!==n&&l[N]&&l[N].indexOf(q)>-1){const M=X+B===R.length,F=X>0&&l[N].indexOf(u)>-1?u+q:q,z=l[N].endsWith(F);a=!M||z}if(!a){let N="";(R[0].endsWith(":")||f!=="")&&(X===1&&(X=0,B++,q=R[0]+u+q),X>0&&(N=R[0]+u),N=f+N),X>0&&(N=N+v+u),N=N+q,X+B<R.length&&(N=N+u+v),o[n]=N}}a&&(o[n]=i)}return o}e.shorten=h;var b;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function p(l,u=Object.create(null)){const o=[];let a=!1,n="";for(const i of l)if(i==="$"||a&&i==="{")n&&o.push({value:n,type:b.TEXT}),n="",a=!0;else if(i==="}"&&a){const f=u[n];if(typeof f=="string")f.length&&o.push({value:f,type:b.VARIABLE});else if(f){const k=o[o.length-1];(!k||k.type!==b.SEPARATOR)&&o.push({value:f.label,type:b.SEPARATOR})}n="",a=!1}else n+=i;return n&&!a&&o.push({value:n,type:b.TEXT}),o.filter((i,f)=>{if(i.type===b.SEPARATOR){const k=o[f-1],R=o[f+1];return[k,R].every(B=>B&&(B.type===b.VARIABLE||B.type===b.TEXT)&&B.value.length>0)}return!0}).map(i=>i.value).join("")}e.template=p;function g(l,u){return A.isMacintosh||u?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):l.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function w(l,u){return A.isMacintosh||u?l.replace(/\(&&\w\)|&&/g,""):A.isWindows?l.replace(/&&|&/g,o=>o==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function s(l){return l.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(l){const u=l.indexOf("/")!==-1?I.posix:I.win32,o=u.basename(l),a=u.dirname(l);return o.length?{name:o,parentPath:a}:{name:a,parentPath:""}}e.splitName=r}),define(Se[112],ye([1,0,2]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(L){return L.toJSON()}class I{constructor(P){this.a=P}transformIncoming(P){const E=this.a.transformIncoming(P);return E===P?P:t(c.URI.from(E))}transformOutgoing(P){const E=this.a.transformOutgoing(P);return E===P?P:t(c.URI.from(E))}transformOutgoingURI(P){const E=this.a.transformOutgoing(P);return E===P?P:c.URI.from(E)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function A(L,P,E){if(!L||E>200)return null;if(typeof L=="object"){if(L instanceof c.URI)return P.transformOutgoing(L);for(const D in L)if(Object.hasOwnProperty.call(L,D)){const v=A(L[D],P,E+1);v!==null&&(L[D]=v)}}return null}function C(L,P){const E=A(L,P,0);return E===null?L:E}e.transformOutgoingURIs=C;function T(L,P,E,D){if(!L||D>200)return null;if(typeof L=="object"){if(L.$mid===1)return E?c.URI.revive(P.transformIncoming(L)):P.transformIncoming(L);for(const v in L)if(Object.hasOwnProperty.call(L,v)){const d=T(L[v],P,E,D+1);d!==null&&(L[v]=d)}}return null}function S(L,P){const E=T(L,P,!1,0);return E===null?L:E}e.transformIncomingURIs=S;function y(L,P){const E=T(L,P,!0,0);return E===null?L:E}e.transformAndReviveIncomingURIs=y}),define(Se[29],ye([1,0,65,86,309,18,32,82,9,12,24,2]),function(ne,e,c,t,I,A,C,T,S,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function D(F,z=E.UNLINK){if((0,C.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return z===E.UNLINK?d(F):v(F)}async function v(F){try{const z=(0,C.randomPath)((0,t.tmpdir)());try{await c.promises.rename(F,z)}catch(U){return U.code==="ENOENT"?void 0:d(F)}d(z).catch(U=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function d(F){return(0,I.promisify)(c.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function m(F){if((0,C.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function h(F,z){return g(await(z?b(F):(0,I.promisify)(c.readdir)(F)))}async function b(F){try{return await(0,I.promisify)(c.readdir)(F,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const z=[],U=await h(F);for(const W of U){let x=!1,V=!1,_=!1;try{const Q=await e.Promises.lstat((0,S.join)(F,W));x=Q.isFile(),V=Q.isDirectory(),_=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}z.push({name:W,isFile:()=>x,isDirectory:()=>V,isSymbolicLink:()=>_})}return z}function p(F){return g(c.readdirSync(F))}e.readdirSync=p;function g(F){return F.map(z=>typeof z=="string"?y.isMacintosh?(0,T.normalizeNFC)(z):z:(z.name=y.isMacintosh?(0,T.normalizeNFC)(z.name):z.name,z))}async function w(F){const z=await h(F),U=[];for(const W of z)await r.existsDirectory((0,S.join)(F,W))&&U.push(W);return U}function s(F,z=1e3){return new Promise(U=>{let W=!1;const x=setInterval(()=>{W||(W=!0,c.access(F,V=>{W=!1,V&&(clearInterval(x),U(void 0))}))},z)})}e.whenDeleted=s;var r;(function(F){async function z(x){let V;try{if(V=await e.Promises.lstat(x),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(y.isWindows&&_.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw Q}throw _}}F.stat=z;async function U(x){try{const{stat:V,symbolicLink:_}=await F.stat(x);return V.isFile()&&_?.dangling!==!0}catch{}return!1}F.existsFile=U;async function W(x){try{const{stat:V,symbolicLink:_}=await F.stat(x);return V.isDirectory()&&_?.dangling!==!0}catch{}return!1}F.existsDirectory=W})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const l=new A.ResourceQueue;function u(F,z,U){return l.queueFor(P.URI.file(F),L.extUriBiasedIgnorePathCase).queue(()=>{const W=f(U);return new Promise((x,V)=>n(F,z,W,_=>_?V(_):x()))})}let o=!0;function a(F){o=F}e.configureFlushOnWrite=a;function n(F,z,U,W){if(!o)return c.writeFile(F,z,{mode:U.mode,flag:U.flag},W);c.open(F,U.flag,U.mode,(x,V)=>{if(x)return W(x);c.writeFile(V,z,_=>{if(_)return c.close(V,()=>W(_));c.fdatasync(V,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),a(!1)),c.close(V,J=>W(J))))})})}function i(F,z,U){const W=f(U);if(!o)return c.writeFileSync(F,z,{mode:W.mode,flag:W.flag});const x=c.openSync(F,W.flag,W.mode);try{c.writeFileSync(x,z);try{c.fdatasyncSync(x)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),a(!1)}}finally{c.closeSync(x)}}e.writeFileSync=i;function f(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function k(F,z){if(F!==z)try{await e.Promises.rename(F,z)}catch(U){if(F.toLowerCase()!==z.toLowerCase()&&U.code==="EXDEV"||F.endsWith("."))await R(F,z,{preserveSymlinks:!1}),await D(F,E.MOVE);else throw U}}async function R(F,z,U){return X(F,z,{root:{source:F,target:z},options:U,handledSourcePaths:new Set})}const B=511;async function X(F,z,U){if(U.handledSourcePaths.has(F))return;U.handledSourcePaths.add(F);const{stat:W,symbolicLink:x}=await r.stat(F);if(x){if(U.options.preserveSymlinks)try{return await M(F,z,U)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(x.dangling)return}return W.isDirectory()?q(F,z,W.mode&B,U):N(F,z,W.mode&B)}async function q(F,z,U,W){await e.Promises.mkdir(z,{recursive:!0,mode:U});const x=await h(F);for(const V of x)await X((0,S.join)(F,V),(0,S.join)(z,V),W)}async function N(F,z,U){await e.Promises.copyFile(F,z),await e.Promises.chmod(z,U)}async function M(F,z,U){let W=await e.Promises.readlink(F);(0,C.isEqualOrParent)(W,U.root.source,!y.isLinux)&&(W=(0,S.join)(U.root.target,W.substr(U.root.source.length+1))),await e.Promises.symlink(W,z)}e.Promises=new class{get access(){return(0,I.promisify)(c.access)}get stat(){return(0,I.promisify)(c.stat)}get lstat(){return(0,I.promisify)(c.lstat)}get utimes(){return(0,I.promisify)(c.utimes)}get read(){return(F,z,U,W,x)=>new Promise((V,_)=>{c.read(F,z,U,W,x,(Q,J,te)=>Q?_(Q):V({bytesRead:J,buffer:te}))})}get readFile(){return(0,I.promisify)(c.readFile)}get write(){return(F,z,U,W,x)=>new Promise((V,_)=>{c.write(F,z,U,W,x,(Q,J,te)=>Q?_(Q):V({bytesWritten:J,buffer:te}))})}get appendFile(){return(0,I.promisify)(c.appendFile)}get fdatasync(){return(0,I.promisify)(c.fdatasync)}get truncate(){return(0,I.promisify)(c.truncate)}get rename(){return(0,I.promisify)(c.rename)}get copyFile(){return(0,I.promisify)(c.copyFile)}get open(){return(0,I.promisify)(c.open)}get close(){return(0,I.promisify)(c.close)}get symlink(){return(0,I.promisify)(c.symlink)}get readlink(){return(0,I.promisify)(c.readlink)}get chmod(){return(0,I.promisify)(c.chmod)}get mkdir(){return(0,I.promisify)(c.mkdir)}get unlink(){return(0,I.promisify)(c.unlink)}get rmdir(){return(0,I.promisify)(c.rmdir)}get realpath(){return(0,I.promisify)(c.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return w}get writeFile(){return u}get rm(){return D}get move(){return k}get copy(){return R}}}),define(Se[113],ye([1,0,65,9,12,8,29]),function(ne,e,c,t,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(E){if(I.isLinux)return E;const D=(0,t.dirname)(E);if(E===D)return E;const v=((0,t.basename)(E)||E).toLowerCase();try{const m=(0,C.readdirSync)(D).filter(h=>h.toLowerCase()===v);if(m.length===1){const h=T(D);if(h)return(0,t.join)(h,m[0])}else if(m.length>1){const h=m.indexOf(v);if(h>=0){const b=T(D);if(b)return(0,t.join)(b,m[h])}}}catch{}return null}e.realcaseSync=T;async function S(E){if(I.isLinux)return E;const D=(0,t.dirname)(E);if(E===D)return E;const v=((0,t.basename)(E)||E).toLowerCase();try{const m=(await C.Promises.readdir(D)).filter(h=>h.toLowerCase()===v);if(m.length===1){const h=await S(D);if(h)return(0,t.join)(h,m[0])}else if(m.length>1){const h=m.indexOf(v);if(h>=0){const b=await S(D);if(b)return(0,t.join)(b,m[h])}}}catch{}return null}e.realcase=S;async function y(E){try{return await C.Promises.realpath(E)}catch{const v=P(E);return await C.Promises.access(v,c.constants.R_OK),v}}e.realpath=y;function L(E){try{return c.realpathSync(E)}catch{const v=P(E);return c.accessSync(v,c.constants.R_OK),v}}e.realpathSync=L;function P(E){return(0,A.rtrim)((0,t.normalize)(E),t.sep)}}),define(Se[114],ye([1,0,9,12,36,106,11,29]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function S(P=I.env){return P.comspec||"cmd.exe"}e.getWindowsShell=S;function y(P){let E=[],D=!1;const v=function(d){if(D){E.push(d);return}(!P.send(d,h=>{if(h&&console.error(h),D=!1,E.length>0){const b=E.slice(0);E=[],b.forEach(p=>v(p))}})||t.isWindows)&&(D=!0)};return{send:v}}e.createQueuedSender=y;var L;(function(P){async function E(D,v,d){if(c.isAbsolute(D))return D;if(v===void 0&&(v=I.cwd()),c.dirname(D)!=="."||(d===void 0&&C.isString(I.env.PATH)&&(d=I.env.PATH.split(c.delimiter)),d===void 0||d.length===0))return c.join(v,D);async function h(b){if(await T.Promises.exists(b)){let p;try{p=await T.Promises.stat(b)}catch(g){g.message.startsWith("EACCES")&&(p=await T.Promises.lstat(b))}return p?!p.isDirectory():!1}return!1}for(const b of d){let p;if(c.isAbsolute(b)?p=c.join(b,D):p=c.join(v,b,D),await h(p))return p;let g=p+".com";if(await h(g)||(g=p+".exe",await h(g)))return g}return c.join(v,D)}P.findExecutable=E})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(ne,e,c,t){var I=arguments.length,A=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,c):t,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ne,e,c,t);else for(var T=ne.length-1;T>=0;T--)(C=ne[T])&&(A=(I<3?C(A):I>3?C(e,c,A):C(e,c))||A);return I>3&&A&&Object.defineProperty(e,c,A),A};define(Se[115],ye([1,0,17,18,22,21,60,10,4,6,85,8,11]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var D;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(D||(D={}));function v(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(d||(d={}));function m(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(h||(h={}));function b(V){let _=0;for(let Q=0;;Q+=7){const J=V.read(1);if(_|=(J.buffer[0]&127)<<Q,!(J.buffer[0]&128))return _}}const p=l(0);function g(V,_){if(_===0){V.write(p);return}let Q=0;for(let te=_;te!==0;te=te>>>7)Q++;const J=I.VSBuffer.alloc(Q);for(let te=0;_!==0;te++)J.buffer[te]=_&127,_=_>>>7,_>0&&(J.buffer[te]|=128);V.write(J)}class w{constructor(_){this.b=_,this.a=0}read(_){const Q=this.b.slice(this.a,this.a+_);return this.a+=Q.byteLength,Q}}e.BufferReader=w;class s{constructor(){this.a=[]}get buffer(){return I.VSBuffer.concat(this.a)}write(_){this.a.push(_)}}e.BufferWriter=s;var r;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(r||(r={}));function l(V){const _=I.VSBuffer.alloc(1);return _.writeUInt8(V,0),_}const u={Undefined:l(r.Undefined),String:l(r.String),Buffer:l(r.Buffer),VSBuffer:l(r.VSBuffer),Array:l(r.Array),Object:l(r.Object),Uint:l(r.Int)},o=typeof Buffer<"u";function a(V,_){if(typeof _>"u")V.write(u.Undefined);else if(typeof _=="string"){const Q=I.VSBuffer.fromString(_);V.write(u.String),g(V,Q.byteLength),V.write(Q)}else if(o&&Buffer.isBuffer(_)){const Q=I.VSBuffer.wrap(_);V.write(u.Buffer),g(V,Q.byteLength),V.write(Q)}else if(_ instanceof I.VSBuffer)V.write(u.VSBuffer),g(V,_.byteLength),V.write(_);else if(Array.isArray(_)){V.write(u.Array),g(V,_.length);for(const Q of _)a(V,Q)}else if(typeof _=="number"&&(_|0)===_)V.write(u.Uint),g(V,_);else{const Q=I.VSBuffer.fromString(JSON.stringify(_));V.write(u.Object),g(V,Q.byteLength),V.write(Q)}}e.serialize=a;function n(V){switch(V.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return V.read(b(V)).toString();case r.Buffer:return V.read(b(V)).buffer;case r.VSBuffer:return V.read(b(V));case r.Array:{const Q=b(V),J=[];for(let te=0;te<Q;te++)J.push(n(V));return J}case r.Object:return JSON.parse(V.read(b(V)).toString());case r.Int:return b(V)}}e.deserialize=n;class i{constructor(_,Q,J=null,te=1e3){this.h=_,this.j=Q,this.k=J,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(le=>this.q(le)),this.m({type:200})}registerChannel(_,Q){this.b.set(_,Q),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const Q=this.o([_.type]);this.k?.logOutgoing(Q,0,1,m(_.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([_.type,_.id],_.data);this.k?.logOutgoing(Q,_.id,1,m(_.type),_.data);return}}}o(_,Q=void 0){const J=new s;return a(J,_),a(J,Q),this.p(J.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const Q=new w(_),J=n(Q),te=n(Q),le=J[0];switch(le){case 100:return this.k?.logIncoming(_.byteLength,J[1],1,`${v(le)}: ${J[2]}.${J[3]}`,te),this.s({type:le,id:J[1],channelName:J[2],name:J[3],arg:te});case 102:return this.k?.logIncoming(_.byteLength,J[1],1,`${v(le)}: ${J[2]}.${J[3]}`,te),this.t({type:le,id:J[1],channelName:J[2],name:J[3],arg:te});case 101:return this.k?.logIncoming(_.byteLength,J[1],1,`${v(le)}`),this.u({type:le,id:J[1]});case 103:return this.k?.logIncoming(_.byteLength,J[1],1,`${v(le)}`),this.u({type:le,id:J[1]})}}s(_){const Q=this.b.get(_.channelName);if(!Q){this.v(_);return}const J=new A.CancellationTokenSource;let te;try{te=Q.call(this.j,_.name,_.arg,J.token)}catch(ge){te=Promise.reject(ge)}const le=_.id;te.then(ge=>{this.m({id:le,data:ge,type:201}),this.d.delete(_.id)},ge=>{ge instanceof Error?this.m({id:le,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split?ge.stack.split(`
`):ge.stack:void 0},type:202}):this.m({id:le,data:ge,type:203}),this.d.delete(_.id)});const Z=(0,y.toDisposable)(()=>J.cancel());this.d.set(_.id,Z)}t(_){const Q=this.b.get(_.channelName);if(!Q){this.v(_);return}const J=_.id,le=Q.listen(this.j,_.name,_.arg)(Z=>this.m({id:J,data:Z,type:204}));this.d.set(_.id,le)}u(_){const Q=this.d.get(_.id);Q&&(Q.dispose(),this.d.delete(_.id))}v(_){let Q=this.g.get(_.channelName);Q||(Q=[],this.g.set(_.channelName,Q));const J=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:_,timeoutTimer:J})}w(_){const Q=this.g.get(_);if(Q){for(const J of Q)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=i;var f;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class k{constructor(_,Q=null){this.l=_,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=Q}getChannel(_){const Q=this;return{call(J,te,le){return Q.a?Promise.reject(new T.CancellationError):Q.m(_,J,te,le)},listen(J,te){return Q.a?S.Event.None:Q.o(_,J,te)}}}m(_,Q,J,te=A.CancellationToken.None){const le=this.g++,ge={id:le,type:100,channelName:_,name:Q,arg:J};if(te.isCancellationRequested)return Promise.reject(new T.CancellationError);let ve;return new Promise((Re,ze)=>{if(te.isCancellationRequested)return ze(new T.CancellationError);const se=()=>{const oe=ie=>{switch(ie.type){case 201:this.f.delete(le),Re(ie.data);break;case 202:{this.f.delete(le);const O=new Error(ie.data.message);O.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,O.name=ie.data.name,ze(O);break}case 203:this.f.delete(le),ze(ie.data);break}};this.f.set(le,oe),this.p(ge)};let ue=null;this.b===h.Idle?se():(ue=(0,t.createCancelablePromise)(oe=>this.u()),ue.then(()=>{ue=null,se()}));const he=()=>{ue?(ue.cancel(),ue=null):this.p({id:le,type:101}),ze(new T.CancellationError)},ee=te.onCancellationRequested(he);ve=(0,y.combinedDisposable)((0,y.toDisposable)(he),ee),this.d.add(ve)}).finally(()=>{this.d.delete(ve)})}o(_,Q,J){const te=this.g++,Z={id:te,type:102,channelName:_,name:Q,arg:J};let ge=null;const ve=new S.Emitter({onWillAddFirstListener:()=>{ge=(0,t.createCancelablePromise)(Re=>this.u()),ge.then(()=>{ge=null,this.d.add(ve),this.p(Z)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.d.delete(ve),this.p({id:te,type:103}))}}),De=Re=>ve.fire(Re.data);return this.f.set(te,De),ve.event}p(_){switch(_.type){case 100:case 102:{const Q=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(Q,_.id,0,`${v(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const Q=this.q([_.type,_.id]);this.j?.logOutgoing(Q,_.id,0,v(_.type));return}}}q(_,Q=void 0){const J=new s;return a(J,_),a(J,Q),this.r(J.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const Q=new w(_),J=n(Q),te=n(Q),le=J[0];switch(le){case 200:return this.j?.logIncoming(_.byteLength,0,0,m(le)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,J[1],0,m(le),te),this.t({type:J[0],id:J[1],data:te})}}t(_){if(_.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.dispose)(this.d.values()),this.d.clear()}}qe([C.memoize],k.prototype,"onDidInitializePromise",null),e.ChannelClient=k;class R{get connections(){const _=[];return this.f.forEach(Q=>_.push(Q)),_}constructor(_){this.a=new Map,this.f=new Set,this.g=new S.Emitter,this.onDidAddConnection=this.g.event,this.h=new S.Emitter,this.onDidRemoveConnection=this.h.event,_(({protocol:Q,onDidClientDisconnect:J})=>{S.Event.once(Q.onMessage)(le=>{const Z=new w(le),ge=n(Z),ve=new i(Q,ge),De=new k(Q);this.a.forEach((ze,se)=>ve.registerChannel(se,ze));const Re={channelServer:ve,channelClient:De,ctx:ge};this.f.add(Re),this.g.fire(Re),J(()=>{ve.dispose(),De.dispose(),this.f.delete(Re),this.h.fire(Re)})})})}getChannel(_,Q){const J=this;return{call(te,le,Z){let ge;if((0,E.isFunction)(Q)){const De=(0,c.getRandomElement)(J.connections.filter(Q));ge=De?Promise.resolve(De):S.Event.toPromise(S.Event.filter(J.onDidAddConnection,Q))}else ge=Q.routeCall(J,te,le);const ve=ge.then(De=>De.channelClient.getChannel(_));return X(ve).call(te,le,Z)},listen(te,le){if((0,E.isFunction)(Q))return J.j(_,Q,te,le);const Z=Q.routeEvent(J,te,le).then(ge=>ge.channelClient.getChannel(_));return X(Z).listen(te,le)}}}j(_,Q,J,te){const le=this;let Z=new y.DisposableStore;const ge=new S.Emitter({onWillAddFirstListener:()=>{Z=new y.DisposableStore;const ve=new S.EventMultiplexer,De=new Map,Re=se=>{const he=se.channelClient.getChannel(_).listen(J,te),ee=ve.add(he);De.set(se,ee)},ze=se=>{const ue=De.get(se);!ue||(ue.dispose(),De.delete(se))};le.connections.filter(Q).forEach(Re),S.Event.filter(le.onDidAddConnection,Q)(Re,void 0,Z),le.onDidRemoveConnection(ze,void 0,Z),ve.event(ge.fire,ge,Z),Z.add(ve)},onDidRemoveLastListener:()=>{Z.dispose()}});return ge.event}registerChannel(_,Q){this.a.set(_,Q),this.f.forEach(J=>{J.channelServer.registerChannel(_,Q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=R;class B{constructor(_,Q,J=null){const te=new s;a(te,Q),_.send(te.buffer),this.a=new k(_,J),this.d=new i(_,Q,J)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,Q){this.d.registerChannel(_,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=B;function X(V){return{call(_,Q,J){return V.then(te=>te.call(_,Q,J))},listen(_,Q){const J=new S.Relay;return V.then(te=>J.input=te.listen(_,Q)),J.event}}}e.getDelayedChannel=X;function q(V){let _=!1;return{call(Q,J,te){return _?V.call(Q,J,te):(0,t.timeout)(0).then(()=>_=!0).then(()=>V.call(Q,J,te))},listen(Q,J){if(_)return V.listen(Q,J);const te=new S.Relay;return(0,t.timeout)(0).then(()=>_=!0).then(()=>te.input=V.listen(Q,J)),te.event}}}e.getNextTickChannel=q;class N{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const Q of _.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise(_.onDidAddConnection),await this.b(_)}}e.StaticRouter=N;var M;(function(V){function _(le,Z){const ge=le,ve=Z&&Z.disableMarshalling,De=new Map;for(const Re in ge)J(Re)&&De.set(Re,S.Event.buffer(ge[Re],!0));return new class{listen(Re,ze,se){const ue=De.get(ze);if(ue)return ue;if(te(ze)){const he=ge[ze];if(typeof he=="function")return he.call(ge,se)}throw new Error(`Event not found: ${ze}`)}call(Re,ze,se){const ue=ge[ze];if(typeof ue=="function"){if(!ve&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,L.revive)(se[he]);return ue.apply(ge,se)}throw new Error(`Method not found: ${ze}`)}}}V.fromService=_;function Q(le,Z){const ge=Z&&Z.disableMarshalling;return new Proxy({},{get(ve,De){if(typeof De=="string")return Z?.properties?.has(De)?Z.properties.get(De):te(De)?function(Re){return le.listen(De,Re)}:J(De)?le.listen(De):async function(...Re){let ze;Z&&!(0,E.isUndefinedOrNull)(Z.context)?ze=[Z.context,...Re]:ze=Re;const se=await le.call(De,ze);return ge?se:(0,L.revive)(se)};throw new Error(`Property not found: ${String(De)}`)}})}V.toService=Q;function J(le){return le[0]==="o"&&le[1]==="n"&&P.isUpperAsciiLetter(le.charCodeAt(2))}function te(le){return/^onDynamic/.test(le)&&P.isUpperAsciiLetter(le.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const _=V.toString();if(_!=="[object Object]")return _}return V}function U(V){return Array.isArray(V)?V.map(z):z(V)}function W(V,_,Q,J,te,le,Z){Z=U(Z);const ge=F[te],ve=ge[J%ge.length];let De=[`%c[${V}]%c[${String(_).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${ve}`];/\($/.test(le)?(De=De.concat(Z),De.push(")")):De.push(Z),console.log.apply(console,De)}class x{constructor(_,Q){this.d=_,this.f=Q,this.a=0,this.b=0}logOutgoing(_,Q,J,te,le){this.b+=_,W(this.d,this.b,_,Q,J,te,le)}logIncoming(_,Q,J,te,le){this.a+=_,W(this.f,this.a,_,Q,J,te,le)}}e.IPCLogger=x}),define(Se[116],ye([1,0,22,4,6,115]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(C=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var T;(function(u){u.enableDiagnostics=!1,u.records=[];const o=new WeakMap;let a=0;function n(f,k){if(!o.has(f)){const R=String(++a);o.set(f,R)}return o.get(f)}function i(f,k,R,B){if(!u.enableDiagnostics)return;const X=n(f,k);if(B instanceof c.VSBuffer||B instanceof Uint8Array||B instanceof ArrayBuffer||ArrayBuffer.isView(B)){const q=c.VSBuffer.alloc(B.byteLength);q.set(B),u.records.push({timestamp:Date.now(),id:X,label:k,type:R,buff:q})}else u.records.push({timestamp:Date.now(),id:X,label:k,type:R,data:B})}u.traceSocketEvent=i})(T=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function L(){return y||(y=c.VSBuffer.alloc(0)),y}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(o){this.a.push(o),this.b+=o.byteLength}read(o){return this.c(o,!0)}peek(o){return this.c(o,!1)}c(o,a){if(o===0)return L();if(o>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===o){const k=this.a[0];return a&&(this.a.shift(),this.b-=o),k}if(this.a[0].byteLength>o){const k=this.a[0].slice(0,o);return a&&(this.a[0]=this.a[0].slice(o),this.b-=o),k}const n=c.VSBuffer.alloc(o);let i=0,f=0;for(;o>0;){const k=this.a[f];if(k.byteLength>o){const R=k.slice(0,o);n.set(R,i),i+=o,a&&(this.a[f]=k.slice(o),this.b-=o),o-=o}else n.set(k,i),i+=k.byteLength,a?(this.a.shift(),this.b-=k.byteLength):f++,o-=k.byteLength}return n}}e.ChunkStream=P;var E;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(E||(E={}));function D(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(o,a,n,i){this.type=o,this.id=a,this.ack=n,this.data=i,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends I.Disposable{constructor(o){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=o,this.b=!1,this.c=new P,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(o);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:D(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const n=this.g.messageType,i=this.g.id,f=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new d(n,i,f,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(o){this.k=null,this.a=!1,this.b=!1,this.c=o,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(o){if(this.a)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=c.VSBuffer.alloc(13);a.writeUInt8(o.type,0),a.writeUInt32BE(o.id,1),a.writeUInt32BE(o.ack,5),a.writeUInt32BE(o.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:D(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",o.data),this.j(a,o.data)}g(o,a){const n=this.f===0;return this.d.push(o,a),this.f+=o.byteLength+a.byteLength,n}h(){const o=c.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,o}j(o,a){this.g(o,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const o=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this.c.write(o)}}class b extends I.Disposable{constructor(o){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=o,this.b=this.B(new h(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(o){this.b.write(new d(1,0,0,o))}}e.Protocol=b;class p extends A.IPCClient{static fromSocket(o,a){return new p(new b(o),a)}get onDidDispose(){return this.b.onDidDispose}constructor(o,a,n=null){super(o,a,n),this.b=o}dispose(){super.dispose();const o=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),o.end()}}e.Client=p;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(o){this.b?this.d.length>0?this.d.push(o):this.a.fire(o):this.d.push(o)}flushBuffer(){this.d=[]}}e.BufferedEmitter=g;class w{constructor(o){this.data=o,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let o=0,a=this.a;for(;a;)a=a.next,o++;return o}peek(){return this.a?this.a.data:null}toArray(){const o=[];let a=0,n=this.a;for(;n;)o[a++]=n.data,n=n.next;return o}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(o){const a=new w(o);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const o=Date.now();for(let a=0;a<r.a;a++)this.c[a]=o-1e3*a;setInterval(()=>{for(let a=r.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const o=Date.now(),a=(1+r.a)*1e3;let n=0;for(let i=0;i<r.a;i++)o-this.c[i]<=a&&n++;return 1-n/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;class l{get unacknowledgedCount(){return this.c-this.d}constructor(o,a=null,n=r.getInstance()){this.t=new g,this.onControlMessage=this.t.event,this.u=new g,this.onMessage=this.u.event,this.v=new g,this.onDidDispose=this.v.event,this.w=new g,this.onSocketClose=this.w.event,this.x=new g,this.onSocketTimeout=this.x.event,this.s=n,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=o,this.p=new h(this.o),this.r.push(this.p),this.q=new m(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(i=>this.y(i))),this.r.push(this.o.onClose(i=>this.w.fire(i))),a&&this.q.acceptChunk(a),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,I.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const o=new d(5,0,0,L());this.p.write(o),this.p.flush()}sendPause(){const o=new d(7,0,0,L());this.p.write(o)}sendResume(){const o=new d(8,0,0,L());this.p.write(o)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(o,a){this.a=!0,this.r=(0,I.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=o,this.p=new h(this.o),this.r.push(this.p),this.q=new m(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(n=>this.y(n))),this.r.push(this.o.onClose(n=>this.w.fire(n))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const o=new d(3,0,this.h,L());this.p.write(o);const a=this.b.toArray();for(let n=0,i=a.length;n<i;n++)this.p.write(a[n]);this.A()}acceptDisconnect(){this.v.fire()}y(o){if(o.ack>this.d){this.d=o.ack;do{const a=this.b.peek();if(a&&a.id<=o.ack)this.b.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this.g)if(o.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new d(6,0,0,L())))}else this.g=o.id,this.j=Date.now(),this.z(),this.u.fire(o.data);break}case 2:{this.t.fire(o.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const a=this.b.toArray();for(let n=0,i=a.length;n<i;n++)this.p.write(a[n]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(o){const a=++this.c;this.h=this.g;const n=new d(1,a,this.h,o);this.b.push(n),this.a||(this.p.write(n),this.A())}sendControl(o){const a=new d(2,0,0,o);this.p.write(a)}z(){if(this.g<=this.h||this.k)return;const o=Date.now()-this.j;if(o>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-o+5)}A(){if(this.c<=this.d||this.f||this.a)return;const o=this.b.peek(),a=Date.now()-o.writtenTime,n=Date.now()-this.q.lastReadTime,i=Date.now()-this.n;if(a>=2e4&&n>=2e4&&i>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:n});return}const f=Math.max(2e4-a,2e4-n,2e4-i,500);this.f=setTimeout(()=>{this.f=null,this.A()},f)}B(){if(this.g<=this.h)return;this.h=this.g;const o=new d(3,0,this.h,L());this.p.write(o)}C(){const o=new d(9,0,0,L());this.p.write(o)}}e.PersistentProtocol=l}),define(Se[117],ye([1,0,22,10,4,6,9,12,30,115,116]),function(ne,e,c,t,I,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class E{traceSocketEvent(n,i){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,i)}constructor(n,i=""){this.f=!0,this.debugLabel=i,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=f=>{if(this.traceSocketEvent("error",{code:f?.code,message:f?.message}),f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}},this.socket.on("error",this.a),this.b=f=>{this.traceSocketEvent("close",{hadError:f}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const i=f=>{this.traceSocketEvent("read",f),n(c.VSBuffer.wrap(f))};return this.socket.on("data",i),{dispose:()=>this.socket.off("data",i)}}onClose(n){const i=f=>{n({type:0,hadError:f,error:void 0})};return this.socket.on("close",i),{dispose:()=>this.socket.off("close",i)}}onEnd(n){const i=()=>{n()};return this.socket.on("end",i),{dispose:()=>this.socket.off("end",i)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,i=>{if(i){if(i.code==="EPIPE")return;(0,t.onUnexpectedError)(i)}})}catch(i){if(i.code==="EPIPE")return;(0,t.onUnexpectedError)(i)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,i)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const f=()=>{this.socket.off("close",f),this.socket.off("end",f),this.socket.off("error",f),this.socket.off("timeout",f),this.socket.off("drain",f),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",f),this.socket.on("end",f),this.socket.on("error",f),this.socket.on("timeout",f),this.socket.on("drain",f)})}}e.NodeSocket=E;var D;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var v;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(v||(v={}));class d extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,i){this.socket.traceSocketEvent(n,i)}constructor(n,i,f,k){super(),this.f=this.B(new I.Emitter),this.g=this.B(new I.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:i,inflateBytesLength:f?.byteLength||0,recordInflateBytes:k}),this.a=this.B(new m(this,i,f,k,this.f,(R,B)=>this.k(R,B))),this.B(this.a.onError(R=>{console.error(R),(0,t.onUnexpectedError)(R),this.g.fire({type:0,hadError:!0,error:R})})),this.b=new L.ChunkStream,this.B(this.socket.onData(R=>this.l(R))),this.B(this.socket.onClose(R=>this.g.fire(R)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,i){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let f=2;n.byteLength<126?f+=0:n.byteLength<2**16?f+=2:f+=8;const k=c.VSBuffer.alloc(f);if(i?k.writeUInt8(194,0):k.writeUInt8(130,0),n.byteLength<126)k.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){k.writeUInt8(126,1);let R=1;k.writeUInt8(n.byteLength>>>8&255,++R),k.writeUInt8(n.byteLength>>>0&255,++R)}else{k.writeUInt8(127,1);let R=1;k.writeUInt8(0,++R),k.writeUInt8(0,++R),k.writeUInt8(0,++R),k.writeUInt8(0,++R),k.writeUInt8(n.byteLength>>>24&255,++R),k.writeUInt8(n.byteLength>>>16&255,++R),k.writeUInt8(n.byteLength>>>8&255,++R),k.writeUInt8(n.byteLength>>>0&255,++R)}this.socket.write(c.VSBuffer.concat([k,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const i=this.b.peek(this.j.readLen),f=i.readUInt8(0),k=(f&128)>>>7,R=(f&64)>>>6,B=i.readUInt8(1),X=(B&128)>>>7,q=B&127;this.j.state=2,this.j.readLen=2+(X?4:0)+(q===126?2:0)+(q===127?8:0),this.j.fin=k,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(R)),this.j.firstFrameOfMessage=Boolean(k),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const i=this.b.read(this.j.readLen),f=i.readUInt8(1),k=(f&128)>>>7;let R=f&127,B=1;R===126?R=i.readUInt8(++B)*2**8+i.readUInt8(++B):R===127&&(R=i.readUInt8(++B)*0+i.readUInt8(++B)*0+i.readUInt8(++B)*0+i.readUInt8(++B)*0+i.readUInt8(++B)*2**24+i.readUInt8(++B)*2**16+i.readUInt8(++B)*2**8+i.readUInt8(++B));let X=0;k&&(X=i.readUInt8(++B)*2**24+i.readUInt8(++B)*2**16+i.readUInt8(++B)*2**8+i.readUInt8(++B)),this.j.state=3,this.j.readLen=R,this.j.mask=X,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const i=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",i),p(i,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",i),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(i,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await I.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class m extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:c.VSBuffer.alloc(0)}constructor(n,i,f,k,R,B){super(),this.k=n,this.l=R,this.m=B,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new I.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,i?(this.b=this.B(new h(this.k,k,f,{windowBits:15})),this.f=this.B(new b(this.k,{windowBits:15})),this.B(this.b.onError(X=>this.a.fire(X))),this.B(this.f.onError(X=>this.a.fire(X)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const i=await this.r(this.f,n);this.m(i,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,i){return new Promise((f,k)=>{n.write(i),n.flush(R=>f(R))})}acceptFrame(n,i,f){this.h.push({data:n,isCompressed:i,isLastFrameOfMessage:f}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const i=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(i)}else this.l.fire(n.data)}this.s=!1}}u(n,i,f){return new Promise((k,R)=>{n.write(i),f&&n.write(c.VSBuffer.fromByteArray([0,0,255,255])),n.flush(B=>k(B))})}}class h extends A.Disposable{get recordedInflateBytes(){return this.j?c.VSBuffer.concat(this.f):c.VSBuffer.alloc(0)}constructor(n,i,f,k){super(),this.h=n,this.j=i,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(k),this.b.on("error",R=>{this.h.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this.a.fire(R)}),this.b.on("data",R=>{this.h.traceSocketEvent("zlibInflateData",R),this.g.push(c.VSBuffer.wrap(R))}),f&&(this.h.traceSocketEvent("zlibInflateInitialWrite",f.buffer),this.b.write(f.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const i=c.VSBuffer.concat(this.g);this.g.length=0,n(i)})}}class b extends A.Disposable{constructor(n,i){super(),this.g=n,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",f=>{this.g.traceSocketEvent("zlibDeflateError",{message:f?.message,code:f?.code}),this.a.fire(f)}),this.b.on("data",f=>{this.g.traceSocketEvent("zlibDeflateData",f),this.f.push(c.VSBuffer.wrap(f))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let i=c.VSBuffer.concat(this.f);this.f.length=0,i=i.slice(0,i.byteLength-4),n(i)})}}function p(a,n){if(n===0)return;const i=a.byteLength>>>2;for(let q=0;q<i;q++){const N=a.readUInt32BE(q*4);a.writeUInt32BE(N^n,q*4)}const f=i*4,k=a.byteLength-f,R=n>>>24&255,B=n>>>16&255,X=n>>>8&255;k>=1&&a.writeUInt8(a.readUInt8(f)^R,f),k>=2&&a.writeUInt8(a.readUInt8(f+1)^B,f+1),k>=3&&a.writeUInt8(a.readUInt8(f+2)^X,f+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const g={[2]:107,[1]:103};function w(){const a=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):n=(0,C.join)(P().os.tmpdir(),`vscode-ipc-${a}.sock`),r(n),n}e.createRandomIPCHandle=w;function s(a,n,i){const f=P().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${f}-${i}-${n}-sock`;let k;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?k=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${f.substr(0,8)}-${i}-${n}.sock`):k=(0,C.join)(a,`${i}-${n}.sock`),r(k),k}e.createStaticIPCHandle=s;function r(a){const n=g[T.platform];typeof n=="number"&&a.length>=n&&console.warn(`WARNING: IPC handle "${a}" is longer than ${n} chars, try a shorter --user-data-dir`)}class l extends y.IPCServer{static b(n){const i=I.Event.fromNodeEventEmitter(n,"connection");return I.Event.map(i,f=>({protocol:new L.Protocol(new E(f,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(f,"close"))}))}constructor(n){super(l.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=l;function u(a){return new Promise((n,i)=>{const f=P().net.createServer();f.on("error",i),f.listen(a,()=>{f.removeListener("error",i),n(new l(f))})})}e.serve=u;function o(a,n){return new Promise((i,f)=>{const k=P().net.createConnection(a,()=>{k.removeListener("error",f),i(L.Client.fromSocket(new E(k,`ipc-client${n}`),n))});k.once("error",f)})}e.connect=o}),define(Se[161],ye([1,0,37,9]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(A,C,T,S,y,L){if(Array.isArray(A)){let P=0;for(const E of A){const D=I(E,C,T,S,y,L);if(D===10)return D;D>P&&(P=D)}return P}else{if(typeof A=="string")return S?A==="*"?5:A===T?10:0:0;if(A){const{language:P,pattern:E,scheme:D,hasAccessToAllModels:v,notebookType:d}=A;if(!S&&!v)return 0;d&&y&&(C=y);let m=0;if(D)if(D===C.scheme)m=10;else if(D==="*")m=5;else return 0;if(P)if(P===T)m=10;else if(P==="*")m=Math.max(m,5);else return 0;if(d)if(d===L)m=10;else if(d==="*"&&L!==void 0)m=Math.max(m,5);else return 0;if(E){let h;if(typeof E=="string"?h=E:h={...E,base:(0,t.normalize)(E.base)},h===C.fsPath||(0,c.match)(h,C.fsPath))m=10;else return 0}return m}else return 0}}e.score=I}),define(Se[162],ye([1,0,8,50,154]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(T,S,y,L){this.c=T,this.d=S,this.f=y,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(T){T.eol&&T.eol!==this.f&&(this.f=T.eol,this.h=null);const S=T.changes;for(const y of S)this.n(y.range),this.o(new t.Position(y.range.startLineNumber,y.range.startColumn),y.text);this.g=T.versionId,this.j=null}k(){if(!this.h){const T=this.f.length,S=this.d.length,y=new Uint32Array(S);for(let L=0;L<S;L++)y[L]=this.d[L].length+T;this.h=new I.PrefixSumComputer(y)}}l(T,S){this.d[T]=S,this.h&&this.h.setValue(T,this.d[T].length+this.f.length)}n(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.startLineNumber-1].substring(T.endColumn-1));return}this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.endLineNumber-1].substring(T.endColumn-1)),this.d.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.h&&this.h.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}o(T,S){if(S.length===0)return;const y=(0,c.splitLines)(S);if(y.length===1){this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+y[0]+this.d[T.lineNumber-1].substring(T.column-1));return}y[y.length-1]+=this.d[T.lineNumber-1].substring(T.column-1),this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+y[0]);const L=new Uint32Array(y.length-1);for(let P=1;P<y.length;P++)this.d.splice(T.lineNumber+P-1,0,y[P]),L[P-1]=y[P].length+this.f.length;this.h&&this.h.insertValues(T.lineNumber,L)}}e.MirrorTextModel=A}),define(Se[163],ye([1,0,8,151,50,35,105]),function(ne,e,c,t,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class S{constructor(b,p,g,w){this.searchString=b,this.isRegex=p,this.matchCase=g,this.wordSeparators=w}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=y(this.searchString):b=this.searchString.indexOf(`
`)>=0;let p=null;try{p=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!p)return null;let g=!this.isRegex&&!b;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new C.SearchData(p,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=S;function y(h){if(!h||h.length===0)return!1;for(let b=0,p=h.length;b<p;b++){const g=h.charCodeAt(b);if(g===10)return!0;if(g===92){if(b++,b>=p)break;const w=h.charCodeAt(b);if(w===110||w===114||w===87)return!0}}return!1}e.isMultilineRegexSource=y;function L(h,b,p){if(!p)return new C.FindMatch(h,null);const g=[];for(let w=0,s=b.length;w<s;w++)g[w]=b[w];return new C.FindMatch(h,g)}e.createFindMatch=L;class P{constructor(b){const p=[];let g=0;for(let w=0,s=b.length;w<s;w++)b.charCodeAt(w)===10&&(p[g++]=w);this.a=p}findLineFeedCountBeforeOffset(b){const p=this.a;let g=0,w=p.length-1;if(w===-1||b<=p[0])return 0;for(;g<w;){const s=g+((w-g)/2>>0);p[s]>=b?w=s-1:p[s+1]>=b?(g=s,w=s):g=s+1}return g+1}}class E{static findMatches(b,p,g,w,s){const r=p.parseSearchRequest();return r?r.regex.multiline?this.b(b,g,new m(r.wordSeparators,r.regex),w,s):this.c(b,g,r,w,s):[]}static a(b,p,g,w,s,r){let l,u=0;w?(u=w.findLineFeedCountBeforeOffset(s),l=p+s+u):l=p+s;let o;if(w){const f=w.findLineFeedCountBeforeOffset(s+r.length)-u;o=l+r.length+f}else o=l+r.length;const a=b.getPositionAt(l),n=b.getPositionAt(o);return new A.Range(a.lineNumber,a.column,n.lineNumber,n.column)}static b(b,p,g,w,s){const r=b.getOffsetAt(p.getStartPosition()),l=b.getValueInRange(p,1),u=b.getEOL()===`\r
`?new P(l):null,o=[];let a=0,n;for(g.reset(0);n=g.next(l);)if(o[a++]=L(this.a(b,r,l,u,n.index,n[0]),n,w),a>=s)return o;return o}static c(b,p,g,w,s){const r=[];let l=0;if(p.startLineNumber===p.endLineNumber){const o=b.getLineContent(p.startLineNumber).substring(p.startColumn-1,p.endColumn-1);return l=this.d(g,o,p.startLineNumber,p.startColumn-1,l,r,w,s),r}const u=b.getLineContent(p.startLineNumber).substring(p.startColumn-1);l=this.d(g,u,p.startLineNumber,p.startColumn-1,l,r,w,s);for(let o=p.startLineNumber+1;o<p.endLineNumber&&l<s;o++)l=this.d(g,b.getLineContent(o),o,0,l,r,w,s);if(l<s){const o=b.getLineContent(p.endLineNumber).substring(0,p.endColumn-1);l=this.d(g,o,p.endLineNumber,0,l,r,w,s)}return r}static d(b,p,g,w,s,r,l,u){const o=b.wordSeparators;if(!l&&b.simpleSearch){const i=b.simpleSearch,f=i.length,k=p.length;let R=-f;for(;(R=p.indexOf(i,R+f))!==-1;)if((!o||d(o,p,k,R,f))&&(r[s++]=new C.FindMatch(new A.Range(g,R+1+w,g,R+1+f+w),null),s>=u))return s;return s}const a=new m(b.wordSeparators,b.regex);let n;a.reset(0);do if(n=a.next(p),n&&(r[s++]=L(new A.Range(g,n.index+1+w,g,n.index+1+n[0].length+w),n,l),s>=u))return s;while(n);return s}static findNextMatch(b,p,g,w){const s=p.parseSearchRequest();if(!s)return null;const r=new m(s.wordSeparators,s.regex);return s.regex.multiline?this.e(b,g,r,w):this.f(b,g,r,w)}static e(b,p,g,w){const s=new I.Position(p.lineNumber,1),r=b.getOffsetAt(s),l=b.getLineCount(),u=b.getValueInRange(new A.Range(s.lineNumber,s.column,l,b.getLineMaxColumn(l)),1),o=b.getEOL()===`\r
`?new P(u):null;g.reset(p.column-1);const a=g.next(u);return a?L(this.a(b,r,u,o,a.index,a[0]),a,w):p.lineNumber!==1||p.column!==1?this.e(b,new I.Position(1,1),g,w):null}static f(b,p,g,w){const s=b.getLineCount(),r=p.lineNumber,l=b.getLineContent(r),u=this.g(g,l,r,p.column,w);if(u)return u;for(let o=1;o<=s;o++){const a=(r+o-1)%s,n=b.getLineContent(a+1),i=this.g(g,n,a+1,1,w);if(i)return i}return null}static g(b,p,g,w,s){b.reset(w-1);const r=b.next(p);return r?L(new A.Range(g,r.index+1,g,r.index+1+r[0].length),r,s):null}static findPreviousMatch(b,p,g,w){const s=p.parseSearchRequest();if(!s)return null;const r=new m(s.wordSeparators,s.regex);return s.regex.multiline?this.h(b,g,r,w):this.j(b,g,r,w)}static h(b,p,g,w){const s=this.b(b,new A.Range(1,1,p.lineNumber,p.column),g,w,10*T);if(s.length>0)return s[s.length-1];const r=b.getLineCount();return p.lineNumber!==r||p.column!==b.getLineMaxColumn(r)?this.h(b,new I.Position(r,b.getLineMaxColumn(r)),g,w):null}static j(b,p,g,w){const s=b.getLineCount(),r=p.lineNumber,l=b.getLineContent(r).substring(0,p.column-1),u=this.k(g,l,r,w);if(u)return u;for(let o=1;o<=s;o++){const a=(s+r-o-1)%s,n=b.getLineContent(a+1),i=this.k(g,n,a+1,w);if(i)return i}return null}static k(b,p,g,w){let s=null,r;for(b.reset(0);r=b.next(p);)s=L(new A.Range(g,r.index+1,g,r.index+1+r[0].length),r,w);return s}}e.TextModelSearch=E;function D(h,b,p,g,w){if(g===0)return!0;const s=b.charCodeAt(g-1);if(h.get(s)!==0||s===13||s===10)return!0;if(w>0){const r=b.charCodeAt(g);if(h.get(r)!==0)return!0}return!1}function v(h,b,p,g,w){if(g+w===p)return!0;const s=b.charCodeAt(g+w);if(h.get(s)!==0||s===13||s===10)return!0;if(w>0){const r=b.charCodeAt(g+w-1);if(h.get(r)!==0)return!0}return!1}function d(h,b,p,g,w){return D(h,b,p,g,w)&&v(h,b,p,g,w)}e.isValidMatch=d;class m{constructor(b,p){this._wordSeparators=b,this.a=p,this.b=-1,this.c=0}reset(b){this.a.lastIndex=b,this.b=-1,this.c=0}next(b){const p=b.length;let g;do{if(this.b+this.c===p||(g=this.a.exec(b),!g))return null;const w=g.index,s=g[0].length;if(w===this.b&&s===this.c){if(s===0){c.getNextCodePoint(b,p,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=w,this.c=s,!this._wordSeparators||d(this._wordSeparators,b,p,w,s))return g}while(g);return null}}e.Searcher=m}),define(Se[118],ye([1,0,22,12]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(I||(I={}));function A(P){for(let E=0,D=P.length;E<D;E+=4){const v=P[E+0],d=P[E+1],m=P[E+2],h=P[E+3];P[E+0]=h,P[E+1]=m,P[E+2]=d,P[E+3]=v}}function C(P){const E=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return t.isLittleEndian()||A(E),c.VSBuffer.wrap(E)}function T(P){const E=P.buffer;if(t.isLittleEndian()||A(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const D=new Uint8Array(E.byteLength);return D.set(E),new Uint32Array(D.buffer,D.byteOffset,D.length/4)}}function S(P){const E=new Uint32Array(y(P));let D=0;if(E[D++]=P.id,P.type==="full")E[D++]=1,E[D++]=P.data.length,E.set(P.data,D),D+=P.data.length;else{E[D++]=2,E[D++]=P.deltas.length;for(const v of P.deltas)E[D++]=v.start,E[D++]=v.deleteCount,v.data?(E[D++]=v.data.length,E.set(v.data,D),D+=v.data.length):E[D++]=0}return C(E)}e.encodeSemanticTokensDto=S;function y(P){let E=0;if(E+=1+1,P.type==="full")E+=1+P.data.length;else{E+=1,E+=(1+1+1)*P.deltas.length;for(const D of P.deltas)D.data&&(E+=D.data.length)}return E}function L(P){const E=T(P);let D=0;const v=E[D++];if(E[D++]===1){const b=E[D++],p=E.subarray(D,D+b);return D+=b,{id:v,type:"full",data:p}}const m=E[D++],h=[];for(let b=0;b<m;b++){const p=E[D++],g=E[D++],w=E[D++];let s;w>0&&(s=E.subarray(D,D+w),D+=w),h[b]={start:p,deleteCount:g,data:s}}return{id:v,type:"delta",deltas:h}}e.decodeSemanticTokensDto=L}),define(Se[164],ye([1,0,4,6]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this.a=new Map,this.b=new Map,this.c=new c.Emitter,this.onDidChange=this.c.event,this.d=null}fire(T){this.c.fire({changedLanguages:T,changedColorMap:!1})}register(T,S){return this.a.set(T,S),this.fire([T]),(0,t.toDisposable)(()=>{this.a.get(T)===S&&(this.a.delete(T),this.fire([T]))})}registerFactory(T,S){this.b.get(T)?.dispose();const y=new A(this,T,S);return this.b.set(T,y),(0,t.toDisposable)(()=>{const L=this.b.get(T);!L||L!==y||(this.b.delete(T),L.dispose())})}async getOrCreate(T){const S=this.get(T);if(S)return S;const y=this.b.get(T);return!y||y.isResolved?null:(await y.resolve(),this.get(T))}get(T){return this.a.get(T)||null}isResolved(T){if(this.get(T))return!0;const y=this.b.get(T);return!!(!y||y.isResolved)}setColorMap(T){this.d=T,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=I;class A extends t.Disposable{get isResolved(){return this.c}constructor(T,S,y){super(),this.f=T,this.g=S,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const T=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,T&&!this.a&&this.B(this.f.register(this.g,T))}}}),define(Se[66],ye([1,0,79,2,35,164]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(f,k,R){this._tokenBrand=void 0,this.offset=f,this.type=k,this.language=R}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class T{constructor(f,k){this._tokenizationResultBrand=void 0,this.tokens=f,this.endState=k}}e.TokenizationResult=T;class S{constructor(f,k){this._encodedTokenizationResultBrand=void 0,this.tokens=f,this.endState=k}}e.EncodedTokenizationResult=S;var y;(function(i){i[i.Method=0]="Method",i[i.Function=1]="Function",i[i.Constructor=2]="Constructor",i[i.Field=3]="Field",i[i.Variable=4]="Variable",i[i.Class=5]="Class",i[i.Struct=6]="Struct",i[i.Interface=7]="Interface",i[i.Module=8]="Module",i[i.Property=9]="Property",i[i.Event=10]="Event",i[i.Operator=11]="Operator",i[i.Unit=12]="Unit",i[i.Value=13]="Value",i[i.Constant=14]="Constant",i[i.Enum=15]="Enum",i[i.EnumMember=16]="EnumMember",i[i.Keyword=17]="Keyword",i[i.Text=18]="Text",i[i.Color=19]="Color",i[i.File=20]="File",i[i.Reference=21]="Reference",i[i.Customcolor=22]="Customcolor",i[i.Folder=23]="Folder",i[i.TypeParameter=24]="TypeParameter",i[i.User=25]="User",i[i.Issue=26]="Issue",i[i.Snippet=27]="Snippet"})(y=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(i){const f=new Map;f.set(0,c.Codicon.symbolMethod),f.set(1,c.Codicon.symbolFunction),f.set(2,c.Codicon.symbolConstructor),f.set(3,c.Codicon.symbolField),f.set(4,c.Codicon.symbolVariable),f.set(5,c.Codicon.symbolClass),f.set(6,c.Codicon.symbolStruct),f.set(7,c.Codicon.symbolInterface),f.set(8,c.Codicon.symbolModule),f.set(9,c.Codicon.symbolProperty),f.set(10,c.Codicon.symbolEvent),f.set(11,c.Codicon.symbolOperator),f.set(12,c.Codicon.symbolUnit),f.set(13,c.Codicon.symbolValue),f.set(15,c.Codicon.symbolEnum),f.set(14,c.Codicon.symbolConstant),f.set(15,c.Codicon.symbolEnum),f.set(16,c.Codicon.symbolEnumMember),f.set(17,c.Codicon.symbolKeyword),f.set(27,c.Codicon.symbolSnippet),f.set(18,c.Codicon.symbolText),f.set(19,c.Codicon.symbolColor),f.set(20,c.Codicon.symbolFile),f.set(21,c.Codicon.symbolReference),f.set(22,c.Codicon.symbolCustomColor),f.set(23,c.Codicon.symbolFolder),f.set(24,c.Codicon.symbolTypeParameter),f.set(25,c.Codicon.account),f.set(26,c.Codicon.issues);function k(X){let q=f.get(X);return q||(console.info("No codicon found for CompletionItemKind "+X),q=c.Codicon.symbolProperty),q}i.toIcon=k;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function B(X,q){let N=R.get(X);return typeof N>"u"&&!q&&(N=9),N}i.fromString=B})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(i){i[i.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(i){i[i.None=0]="None",i[i.KeepWhitespace=1]="KeepWhitespace",i[i.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var D;(function(i){i[i.Invoke=0]="Invoke",i[i.TriggerCharacter=1]="TriggerCharacter",i[i.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(i){i[i.Automatic=0]="Automatic",i[i.Explicit=1]="Explicit"})(v=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(i){i[i.Invoke=1]="Invoke",i[i.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(i){i[i.Invoke=1]="Invoke",i[i.TriggerCharacter=2]="TriggerCharacter",i[i.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(i){i[i.Text=0]="Text",i[i.Read=1]="Read",i[i.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function b(i){return i&&t.URI.isUri(i.uri)&&I.Range.isIRange(i.range)&&(I.Range.isIRange(i.originSelectionRange)||I.Range.isIRange(i.targetSelectionRange))}e.isLocationLink=b;var p;(function(i){i[i.File=0]="File",i[i.Module=1]="Module",i[i.Namespace=2]="Namespace",i[i.Package=3]="Package",i[i.Class=4]="Class",i[i.Method=5]="Method",i[i.Property=6]="Property",i[i.Field=7]="Field",i[i.Constructor=8]="Constructor",i[i.Enum=9]="Enum",i[i.Interface=10]="Interface",i[i.Function=11]="Function",i[i.Variable=12]="Variable",i[i.Constant=13]="Constant",i[i.String=14]="String",i[i.Number=15]="Number",i[i.Boolean=16]="Boolean",i[i.Array=17]="Array",i[i.Object=18]="Object",i[i.Key=19]="Key",i[i.Null=20]="Null",i[i.EnumMember=21]="EnumMember",i[i.Struct=22]="Struct",i[i.Event=23]="Event",i[i.Operator=24]="Operator",i[i.TypeParameter=25]="TypeParameter"})(p=e.SymbolKind||(e.SymbolKind={}));var g;(function(i){i[i.Deprecated=1]="Deprecated"})(g=e.SymbolTag||(e.SymbolTag={}));var w;(function(i){const f=new Map;f.set(0,c.Codicon.symbolFile),f.set(1,c.Codicon.symbolModule),f.set(2,c.Codicon.symbolNamespace),f.set(3,c.Codicon.symbolPackage),f.set(4,c.Codicon.symbolClass),f.set(5,c.Codicon.symbolMethod),f.set(6,c.Codicon.symbolProperty),f.set(7,c.Codicon.symbolField),f.set(8,c.Codicon.symbolConstructor),f.set(9,c.Codicon.symbolEnum),f.set(10,c.Codicon.symbolInterface),f.set(11,c.Codicon.symbolFunction),f.set(12,c.Codicon.symbolVariable),f.set(13,c.Codicon.symbolConstant),f.set(14,c.Codicon.symbolString),f.set(15,c.Codicon.symbolNumber),f.set(16,c.Codicon.symbolBoolean),f.set(17,c.Codicon.symbolArray),f.set(18,c.Codicon.symbolObject),f.set(19,c.Codicon.symbolKey),f.set(20,c.Codicon.symbolNull),f.set(21,c.Codicon.symbolEnumMember),f.set(22,c.Codicon.symbolStruct),f.set(23,c.Codicon.symbolEvent),f.set(24,c.Codicon.symbolOperator),f.set(25,c.Codicon.symbolTypeParameter);function k(R){let B=f.get(R);return B||(console.info("No codicon found for SymbolKind "+R),B=c.Codicon.symbolProperty),B}i.toIcon=k})(w=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(f){this.value=f}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var r;(function(i){function f(k){return!k||typeof k!="object"?!1:typeof k.id=="string"&&typeof k.title=="string"}i.is=f})(r=e.Command||(e.Command={}));var l;(function(i){i[i.Collapsed=0]="Collapsed",i[i.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(i){i[i.Unresolved=0]="Unresolved",i[i.Resolved=1]="Resolved"})(u=e.CommentThreadState||(e.CommentThreadState={}));var o;(function(i){i[i.Editing=0]="Editing",i[i.Preview=1]="Preview"})(o=e.CommentMode||(e.CommentMode={}));var a;(function(i){i[i.Type=1]="Type",i[i.Parameter=2]="Parameter"})(a=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new A.TokenizationRegistry;var n;(function(i){i[i.None=0]="None",i[i.Option=1]="Option",i[i.Default=2]="Default",i[i.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Se[165],ye([19,20]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(Se[119],ye([1,0,165,12,104,17,23,150]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor($){this.c=$}hasChanged($){return this.c[$]}}e.ConfigurationChangedEvent=y;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class P{constructor($,ce,Ie,Le){this.id=$,this.name=ce,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ce){return D($,ce)}compute($,ce,Ie){return Ie}}class E{constructor($,ce){this.newValue=$,this.didChange=ce}}e.ApplyUpdateResult=E;function D(ae,$){if(typeof ae!="object"||typeof $!="object"||!ae||!$)return new E($,ae!==$);if(Array.isArray(ae)||Array.isArray($)){const Ie=Array.isArray(ae)&&Array.isArray($)&&A.equals(ae,$);return new E($,!Ie)}let ce=!1;for(const Ie in $)if($.hasOwnProperty(Ie)){const Le=D(ae[Ie],$[Ie]);Le.didChange&&(ae[Ie]=Le.newValue,ce=!0)}return new E(ae,ce)}class v{constructor($){this.schema=void 0,this.id=$,this.name="_never_",this.defaultValue=void 0}applyUpdate($,ce){return D($,ce)}validate($){return this.defaultValue}}class d{constructor($,ce,Ie,Le){this.id=$,this.name=ce,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ce){return D($,ce)}validate($){return typeof $>"u"?this.defaultValue:$}compute($,ce,Ie){return Ie}}function m(ae,$){return typeof ae>"u"?$:ae==="false"?!1:Boolean(ae)}e.boolean=m;class h extends d{constructor($,ce,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super($,ce,Ie,Le)}validate($){return m($,this.defaultValue)}}function b(ae,$,ce,Ie){if(typeof ae>"u")return $;let Le=parseInt(ae,10);return isNaN(Le)?$:(Le=Math.max(ce,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=b;class p extends d{static clampedInt($,ce,Ie,Le){return b($,ce,Ie,Le)}constructor($,ce,Ie,Le,Be,xe=void 0){typeof xe<"u"&&(xe.type="integer",xe.default=Ie,xe.minimum=Le,xe.maximum=Be),super($,ce,Ie,xe),this.minimum=Le,this.maximum=Be}validate($){return p.clampedInt($,this.defaultValue,this.minimum,this.maximum)}}class g extends d{static clamp($,ce,Ie){return $<ce?ce:$>Ie?Ie:$}static float($,ce){if(typeof $=="number")return $;if(typeof $>"u")return ce;const Ie=parseFloat($);return isNaN(Ie)?ce:Ie}constructor($,ce,Ie,Le,Be){typeof Be<"u"&&(Be.type="number",Be.default=Ie),super($,ce,Ie,Be),this.validationFn=Le}validate($){return this.validationFn(g.float($,this.defaultValue))}}class w extends d{static string($,ce){return typeof $!="string"?ce:$}constructor($,ce,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super($,ce,Ie,Le)}validate($){return w.string($,this.defaultValue)}}function s(ae,$,ce){return typeof ae!="string"||ce.indexOf(ae)===-1?$:ae}e.stringSet=s;class r extends d{constructor($,ce,Ie,Le,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.enum=Le,Be.default=Ie),super($,ce,Ie,Be),this.c=Le}validate($){return s($,this.defaultValue,this.c)}}class l extends P{constructor($,ce,Ie,Le,Be,xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Be,Ze.default=Le),super($,ce,Ie,Ze),this.c=Be,this.d=xe}validate($){return typeof $!="string"?this.defaultValue:this.c.indexOf($)===-1?this.defaultValue:this.d($)}}function u(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate($){switch($){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute($,ce,Ie){return Ie===0?$.accessibilitySupport:Ie}}class a extends P{constructor(){const $={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",$,{"editor.comments.insertSpace":{type:"boolean",default:$.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:$.ignoreEmptyLines,description:c.localize(5,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{insertSpace:m(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function k(ae){switch(ae){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function R(ae){switch(ae){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class B extends v{constructor(){super(134)}compute($,ce,Ie){const Le=["monaco-editor"];return ce.get(35)&&Le.push(ce.get(35)),$.extraEditorClassName&&Le.push($.extraEditorClassName),ce.get(69)==="default"?Le.push("mouse-default"):ce.get(69)==="copy"&&Le.push("mouse-copy"),ce.get(104)&&Le.push("showUnused"),ce.get(132)&&Le.push("showDeprecated"),Le.join(" ")}}class X extends h{constructor(){super(33,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute($,ce,Ie){return Ie&&$.emptySelectionClipboard}}class q extends P{constructor(){const $={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(37,"find",$,{"editor.find.cursorMoveOnType":{type:"boolean",default:$.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:$.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:$.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:$.globalFindClipboard,description:c.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:$.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:$.loop,description:c.localize(18,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{cursorMoveOnType:m(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof $.seedSearchStringFromSelection=="boolean"?$.seedSearchStringFromSelection?"always":"never":s(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof $.autoFindInSelection=="boolean"?$.autoFindInSelection?"always":"never":s(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(ce.loop,this.defaultValue.loop)}}}class N extends P{constructor(){super(47,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?N.OFF:$==="true"?N.ON:$:Boolean($)?N.ON:N.OFF}}e.EditorFontLigatures=N,N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on';class M extends P{constructor(){super(50,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?M.OFF:$==="true"?M.TRANSLATE:$:Boolean($)?M.TRANSLATE:M.OFF}compute($,ce,Ie){return $.fontInfo.fontVariationSettings}}e.EditorFontVariations=M,M.OFF="normal",M.TRANSLATE="translate";class F extends v{constructor(){super(46)}compute($,ce,Ie){return $.fontInfo}}class z extends d{constructor(){super(48,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate($){const ce=g.float($,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(ce,6,100)}compute($,ce,Ie){return $.fontInfo.fontSize}}class U extends P{constructor(){super(49,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.d,maximum:U.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate($){return $==="normal"||$==="bold"?$:String(p.clampedInt($,e.EDITOR_FONT_DEFAULTS.fontWeight,U.d,U.e))}}U.c=["normal","bold","100","200","300","400","500","600","700","800","900"],U.d=1,U.e=1e3;class W extends P{constructor(){const $={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:$.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(54,"gotoLocation",$,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...ce},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...ce},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:$.alternativeDefinitionCommand,enum:Ie,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:$.alternativeTypeDefinitionCommand,enum:Ie,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:$.alternativeDeclarationCommand,enum:Ie,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:$.alternativeImplementationCommand,enum:Ie,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:$.alternativeReferenceCommand,enum:Ie,description:c.localize(41,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{multiple:s(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??s(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??s(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??s(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??s(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??s(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends P{constructor(){const $={enabled:!0,delay:300,sticky:!0,above:!0};super(56,"hover",$,{"editor.hover.enabled":{type:"boolean",default:$.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:$.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:$.sticky,description:c.localize(44,null)},"editor.hover.above":{type:"boolean",default:$.above,description:c.localize(45,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),delay:p.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:m(ce.sticky,this.defaultValue.sticky),above:m(ce.above,this.defaultValue.above)}}}var V;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class _ extends v{constructor(){super(137)}compute($,ce,Ie){return _.computeLayout(ce,{memory:$.memory,outerWidth:$.outerWidth,outerHeight:$.outerHeight,isDominatedByLongLines:$.isDominatedByLongLines,lineHeight:$.fontInfo.lineHeight,viewLineCount:$.viewLineCount,lineNumbersDigitCount:$.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:$.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:$.fontInfo.maxDigitWidth,pixelRatio:$.pixelRatio})}static computeContainedMinimapLineCount($){const ce=$.height/$.lineHeight,Ie=$.scrollBeyondLastLine?ce-1:0,Le=($.viewLineCount+Ie)/($.pixelRatio*$.height),Be=Math.floor($.viewLineCount/Le);return{typicalViewportLineCount:ce,extraLinesBeyondLastLine:Ie,desiredRatio:Le,minimapLineCount:Be}}static c($,ce){const Ie=$.outerWidth,Le=$.outerHeight,Be=$.pixelRatio;if(!$.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const xe=ce.stableMinimapLayoutInput,Ze=xe&&$.outerHeight===xe.outerHeight&&$.lineHeight===xe.lineHeight&&$.typicalHalfwidthCharacterWidth===xe.typicalHalfwidthCharacterWidth&&$.pixelRatio===xe.pixelRatio&&$.scrollBeyondLastLine===xe.scrollBeyondLastLine&&$.minimap.enabled===xe.minimap.enabled&&$.minimap.side===xe.minimap.side&&$.minimap.size===xe.minimap.size&&$.minimap.showSlider===xe.minimap.showSlider&&$.minimap.renderCharacters===xe.minimap.renderCharacters&&$.minimap.maxColumn===xe.minimap.maxColumn&&$.minimap.scale===xe.minimap.scale&&$.verticalScrollbarWidth===xe.verticalScrollbarWidth&&$.isViewportWrapping===xe.isViewportWrapping,mt=$.lineHeight,ft=$.typicalHalfwidthCharacterWidth,lt=$.scrollBeyondLastLine,ot=$.minimap.renderCharacters;let rt=Be>=2?Math.round($.minimap.scale*2):$.minimap.scale;const Tt=$.minimap.maxColumn,Pt=$.minimap.size,Ft=$.minimap.side,gt=$.verticalScrollbarWidth,It=$.viewLineCount,Bt=$.remainingWidth,Mt=$.isViewportWrapping,Xe=ot?2:3;let Rt=Math.floor(Be*Le);const Ut=Rt/Be;let Ht=!1,pt=!1,At=Xe*rt,Ae=rt/Be,Oe=1;if(Pt==="fill"||Pt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeyondLastLine:St,desiredRatio:yt,minimapLineCount:kt}=_.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:lt,height:Le,lineHeight:mt,pixelRatio:Be});if(It/kt>1)Ht=!0,pt=!0,rt=1,At=1,Ae=rt/Be;else{let Et=!1,bt=rt+1;if(Pt==="fit"){const jt=Math.ceil((It+St)*At);Mt&&Ze&&Bt<=ce.stableFitRemainingWidth?(Et=!0,bt=ce.stableFitMaxMinimapScale):Et=jt>Rt}if(Pt==="fill"||Et){Ht=!0;const jt=rt;At=Math.min(mt*Be,Math.max(1,Math.floor(1/yt))),Mt&&Ze&&Bt<=ce.stableFitRemainingWidth&&(bt=ce.stableFitMaxMinimapScale),rt=Math.min(bt,Math.max(1,Math.floor(At/Xe))),rt>jt&&(Oe=Math.min(2,rt/jt)),Ae=rt/Be/Oe,Rt=Math.ceil(Math.max(tt,It+St)*At),Mt?(ce.stableMinimapLayoutInput=$,ce.stableFitRemainingWidth=Bt,ce.stableFitMaxMinimapScale=rt):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const Ee=Math.floor(Tt*Ae),re=Math.min(Ee,Math.max(0,Math.floor((Bt-gt-2)*Ae/(ft+Ae)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor(Be*re);const $e=Ne/Be;Ne=Math.floor(Ne*Oe);const Qe=ot?1:2,Ve=Ft==="left"?0:Ie-re-gt;return{renderMinimap:Qe,minimapLeft:Ve,minimapWidth:re,minimapHeightIsEditorHeight:Ht,minimapIsSampling:pt,minimapScale:rt,minimapLineHeight:At,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:Rt,minimapCanvasOuterWidth:$e,minimapCanvasOuterHeight:Ut}}static computeLayout($,ce){const Ie=ce.outerWidth|0,Le=ce.outerHeight|0,Be=ce.lineHeight|0,xe=ce.lineNumbersDigitCount|0,Ze=ce.typicalHalfwidthCharacterWidth,mt=ce.maxDigitWidth,ft=ce.pixelRatio,lt=ce.viewLineCount,ot=$.get(129),rt=ot==="inherit"?$.get(128):ot,Tt=rt==="inherit"?$.get(124):rt,Pt=$.get(127),Ft=ce.isDominatedByLongLines,gt=$.get(53),It=$.get(63).renderType!==0,Bt=$.get(64),Mt=$.get(98),Xe=$.get(68),Rt=$.get(96),Ut=Rt.verticalScrollbarSize,Ht=Rt.verticalHasArrows,pt=Rt.arrowSize,At=Rt.horizontalScrollbarSize,Ae=$.get(39),Oe=$.get(103)!=="never";let Ee=$.get(61);Ae&&Oe&&(Ee+=16);let re=0;if(It){const Ct=Math.max(xe,Bt);re=Math.round(Ct*mt)}let Ne=0;gt&&(Ne=Be);let $e=0,Qe=$e+Ne,Ve=Qe+re,tt=Ve+Ee;const St=Ie-Ne-re-Ee;let yt=!1,kt=!1,vt=-1;rt==="inherit"&&Ft?(yt=!0,kt=!0):Tt==="on"||Tt==="bounded"?kt=!0:Tt==="wordWrapColumn"&&(vt=Pt);const Et=_.c({outerWidth:Ie,outerHeight:Le,lineHeight:Be,typicalHalfwidthCharacterWidth:Ze,pixelRatio:ft,scrollBeyondLastLine:Mt,minimap:Xe,verticalScrollbarWidth:Ut,viewLineCount:lt,remainingWidth:St,isViewportWrapping:kt},ce.memory||new L);Et.renderMinimap!==0&&Et.minimapLeft===0&&($e+=Et.minimapWidth,Qe+=Et.minimapWidth,Ve+=Et.minimapWidth,tt+=Et.minimapWidth);const bt=St-Et.minimapWidth,jt=Math.max(1,Math.floor((bt-Ut-2)/Ze)),on=Ht?pt:0;return kt&&(vt=Math.max(1,jt),Tt==="bounded"&&(vt=Math.min(vt,Pt))),{width:Ie,height:Le,glyphMarginLeft:$e,glyphMarginWidth:Ne,lineNumbersLeft:Qe,lineNumbersWidth:re,decorationsLeft:Ve,decorationsWidth:Ee,contentLeft:tt,contentWidth:bt,minimap:Et,viewportColumn:jt,isWordWrapMinified:yt,isViewportWrapping:kt,wrappingColumn:vt,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:At,overviewRuler:{top:on,width:Ut,height:Le-2*on,right:0}}}}e.EditorLayoutInfoComputer=_;class Q extends P{constructor(){super(131,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(46,null),c.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(48,null)}})}validate($){return s($,"simple",["simple","advanced"])}compute($,ce,Ie){return ce.get(2)===2?"advanced":Ie}}class J extends P{constructor(){const $={enabled:!0};super(60,"lightbulb",$,{"editor.lightbulb.enabled":{type:"boolean",default:$.enabled,description:c.localize(49,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:m($.enabled,this.defaultValue.enabled)}}}class te extends P{constructor(){const $={enabled:!1,maxLineCount:5};super(108,"stickyScroll",$,{"editor.stickyScroll.enabled":{type:"boolean",default:$.enabled,description:c.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:$.maxLineCount,minimum:1,maximum:10,description:c.localize(51,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),maxLineCount:p.clampedInt(ce.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class le extends P{constructor(){const $={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(133,"inlayHints",$,{"editor.inlayHints.enabled":{type:"string",default:$.enabled,description:c.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(53,null),c.localize(54,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(55,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:$.fontSize,markdownDescription:c.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:$.fontFamily,markdownDescription:c.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:$.padding,description:c.localize(59,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return typeof ce.enabled=="boolean"&&(ce.enabled=ce.enabled?"on":"off"),{enabled:s(ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:p.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(ce.fontFamily,this.defaultValue.fontFamily),padding:m(ce.padding,this.defaultValue.padding)}}}class Z extends P{constructor(){super(61,"lineDecorationsWidth",10)}validate($){return typeof $=="string"&&/^\d+(\.\d+)?ch$/.test($)?-parseFloat($.substring(0,$.length-2)):p.clampedInt($,this.defaultValue,0,1e3)}compute($,ce,Ie){return Ie<0?p.clampedInt(-Ie*$.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class ge extends g{constructor(){super(62,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,$=>g.clamp($,0,150),{markdownDescription:c.localize(60,null)})}compute($,ce,Ie){return $.fontInfo.lineHeight}}class ve extends P{constructor(){const $={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(68,"minimap",$,{"editor.minimap.enabled":{type:"boolean",default:$.enabled,description:c.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:$.autohide,description:c.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(63,null),c.localize(64,null),c.localize(65,null)],default:$.size,description:c.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:$.side,description:c.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:$.showSlider,description:c.localize(68,null)},"editor.minimap.scale":{type:"number",default:$.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:$.renderCharacters,description:c.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:$.maxColumn,description:c.localize(71,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),autohide:m(ce.autohide,this.defaultValue.autohide),size:s(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ce.side,this.defaultValue.side,["right","left"]),showSlider:s(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(ce.renderCharacters,this.defaultValue.renderCharacters),scale:p.clampedInt(ce.scale,1,1,3),maxColumn:p.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function De(ae){return ae==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Re extends P{constructor(){super(79,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(73,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{top:p.clampedInt(ce.top,0,0,1e3),bottom:p.clampedInt(ce.bottom,0,0,1e3)}}}class ze extends P{constructor(){const $={enabled:!0,cycle:!1};super(80,"parameterHints",$,{"editor.parameterHints.enabled":{type:"boolean",default:$.enabled,description:c.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:$.cycle,description:c.localize(75,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),cycle:m(ce.cycle,this.defaultValue.cycle)}}}class se extends v{constructor(){super(135)}compute($,ce,Ie){return $.pixelRatio}}class ue extends P{constructor(){const $={other:"on",comments:"off",strings:"off"},ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(76,null),c.localize(77,null),c.localize(78,null)]}];super(83,"quickSuggestions",$,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ce,default:$.strings,description:c.localize(79,null)},comments:{anyOf:ce,default:$.comments,description:c.localize(80,null)},other:{anyOf:ce,default:$.other,description:c.localize(81,null)}},default:$,markdownDescription:c.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=$}validate($){if(typeof $=="boolean"){const ft=$?"on":"off";return{comments:ft,strings:ft,other:ft}}if(!$||typeof $!="object")return this.defaultValue;const{other:ce,comments:Ie,strings:Le}=$,Be=["on","inline","off"];let xe,Ze,mt;return typeof ce=="boolean"?xe=ce?"on":"off":xe=s(ce,this.defaultValue.other,Be),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=s(Ie,this.defaultValue.comments,Be),typeof Le=="boolean"?mt=Le?"on":"off":mt=s(Le,this.defaultValue.strings,Be),{other:xe,comments:Ze,strings:mt}}}var he;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(he=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ee extends P{constructor(){super(63,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(83,null),c.localize(84,null),c.localize(85,null),c.localize(86,null)],default:"on",description:c.localize(87,null)})}validate($){let ce=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof $<"u"&&(typeof $=="function"?(ce=4,Ie=$):$==="interval"?ce=3:$==="relative"?ce=2:$==="on"?ce=1:ce=0),{renderType:ce,renderFn:Ie}}}function oe(ae){const $=ae.get(91);return $==="editable"?ae.get(85):$!=="on"}e.filterValidationDecorations=oe;class ie extends P{constructor(){const $=[],ce={type:"number",description:c.localize(88,null)};super(95,"rulers",$,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:c.localize(89,null),format:"color-hex"}}}]},default:$,description:c.localize(90,null)})}validate($){if(Array.isArray($)){const ce=[];for(const Ie of $)if(typeof Ie=="number")ce.push({column:p.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;ce.push({column:p.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ce.sort((Ie,Le)=>Ie.column-Le.column),ce}return this.defaultValue}}function O(ae,$){if(typeof ae!="string")return $;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends P{constructor(){const $={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(96,"scrollbar",$,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(91,null),c.localize(92,null),c.localize(93,null)],default:"auto",description:c.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(95,null),c.localize(96,null),c.localize(97,null)],default:"auto",description:c.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:$.verticalScrollbarSize,description:c.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:$.horizontalScrollbarSize,description:c.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:$.scrollByPage,description:c.localize(101,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$,Ie=p.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=p.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:p.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:O(ce.vertical,this.defaultValue.vertical),horizontal:O(ce.horizontal,this.defaultValue.horizontal),useShadows:m(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:p.clampedInt(ce.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:p.clampedInt(ce.verticalSliderSize,Le,0,1e3),scrollByPage:m(ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends P{constructor(){const $={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(118,"unicodeHighlight",$,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.nonBasicASCII,description:c.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:$.invisibleCharacters,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:$.ambiguousCharacters,description:c.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeComments,description:c.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeStrings,description:c.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:$.allowedCharacters,description:c.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:$.allowedLocales,description:c.localize(108,null)}})}applyUpdate($,ce){let Ie=!1;ce.allowedCharacters&&$&&(C.equals($.allowedCharacters,ce.allowedCharacters)||($={...$,allowedCharacters:ce.allowedCharacters},Ie=!0)),ce.allowedLocales&&$&&(C.equals($.allowedLocales,ce.allowedLocales)||($={...$,allowedLocales:ce.allowedLocales},Ie=!0));const Le=super.applyUpdate($,ce);return Ie?new E(Le.newValue,!0):Le}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{nonBasicASCII:Pe(ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Pe(ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Pe(ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c($.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c($.allowedLocales,this.defaultValue.allowedLocales)}}c($,ce){if(typeof $!="object"||!$)return ce;const Ie={};for(const[Le,Be]of Object.entries($))Be===!0&&(Ie[Le]=!0);return Ie}}class Y extends P{constructor(){const $={enabled:!0,mode:"subwordSmart"};super(58,"inlineSuggest",$,{"editor.inlineSuggest.enabled":{type:"boolean",default:$.enabled,description:c.localize(109,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),mode:s(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class de extends P{constructor(){const $={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",$,{"editor.bracketPairColorization.enabled":{type:"boolean",default:$.enabled,markdownDescription:c.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:$.independentColorPoolPerBracketType,description:c.localize(111,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class be extends P{constructor(){const $={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",$,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(112,null),c.localize(113,null),c.localize(114,null)],default:$.bracketPairs,description:c.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(116,null),c.localize(117,null),c.localize(118,null)],default:$.bracketPairsHorizontal,description:c.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:$.highlightActiveBracketPair,description:c.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:$.indentation,description:c.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(122,null),c.localize(123,null),c.localize(124,null)],default:$.highlightActiveIndentation,description:c.localize(125,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{bracketPairs:Pe(ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Pe(ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Pe(ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Pe(ae,$,ce){const Ie=ce.indexOf(ae);return Ie===-1?$:ce[Ie]}class pe extends P{constructor(){const $={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(111,"suggest",$,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(126,null),c.localize(127,null)],default:$.insertMode,description:c.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:$.filterGraceful,description:c.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:$.localityBonus,description:c.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:$.shareSuggestSelections,markdownDescription:c.localize(131,null)},"editor.suggest.selectQuickSuggestions":{type:"boolean",default:$.selectQuickSuggestions,markdownDescription:c.localize(132,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:$.snippetsPreventQuickSuggestions,description:c.localize(133,null)},"editor.suggest.showIcons":{type:"boolean",default:$.showIcons,description:c.localize(134,null)},"editor.suggest.showStatusBar":{type:"boolean",default:$.showStatusBar,description:c.localize(135,null)},"editor.suggest.preview":{type:"boolean",default:$.preview,description:c.localize(136,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:$.showInlineDetails,description:c.localize(137,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(138,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(139,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(140,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(141,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(142,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(143,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(144,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(145,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(146,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(147,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(148,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(166,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(167,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{insertMode:s(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:m(ce.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:m(ce.showIcons,this.defaultValue.showIcons),showStatusBar:m(ce.showStatusBar,this.defaultValue.showStatusBar),preview:m(ce.preview,this.defaultValue.preview),previewMode:s(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(ce.showMethods,this.defaultValue.showMethods),showFunctions:m(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:m(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(ce.showFields,this.defaultValue.showFields),showVariables:m(ce.showVariables,this.defaultValue.showVariables),showClasses:m(ce.showClasses,this.defaultValue.showClasses),showStructs:m(ce.showStructs,this.defaultValue.showStructs),showInterfaces:m(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:m(ce.showModules,this.defaultValue.showModules),showProperties:m(ce.showProperties,this.defaultValue.showProperties),showEvents:m(ce.showEvents,this.defaultValue.showEvents),showOperators:m(ce.showOperators,this.defaultValue.showOperators),showUnits:m(ce.showUnits,this.defaultValue.showUnits),showValues:m(ce.showValues,this.defaultValue.showValues),showConstants:m(ce.showConstants,this.defaultValue.showConstants),showEnums:m(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:m(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(ce.showKeywords,this.defaultValue.showKeywords),showWords:m(ce.showWords,this.defaultValue.showWords),showColors:m(ce.showColors,this.defaultValue.showColors),showFiles:m(ce.showFiles,this.defaultValue.showFiles),showReferences:m(ce.showReferences,this.defaultValue.showReferences),showFolders:m(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:m(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(ce.showSnippets,this.defaultValue.showSnippets),showUsers:m(ce.showUsers,this.defaultValue.showUsers),showIssues:m(ce.showIssues,this.defaultValue.showIssues)}}}class Ce extends P{constructor(){super(106,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(170,null),default:!0,type:"boolean"}})}validate($){return!$||typeof $!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m($.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ke extends v{constructor(){super(136)}compute($,ce,Ie){return ce.get(85)?!0:$.tabFocusMode}}var je;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(je=e.WrappingIndent||(e.WrappingIndent={}));class Ge extends P{constructor(){super(130,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(171,null),c.localize(172,null),c.localize(173,null),c.localize(174,null)],description:c.localize(175,null),default:"same"}})}validate($){switch($){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute($,ce,Ie){return ce.get(2)===2?0:Ie}}class et extends v{constructor(){super(138)}compute($,ce,Ie){const Le=ce.get(137);return{isDominatedByLongLines:$.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class _e extends P{constructor(){const $={enabled:!0};super(32,"dropIntoEditor",$,{"editor.dropIntoEditor.enabled":{type:"boolean",default:$.enabled,markdownDescription:c.localize(176,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:m($.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?st:t.isLinux?ht:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var it;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.autoClosingBrackets=5]="autoClosingBrackets",ae[ae.autoClosingDelete=6]="autoClosingDelete",ae[ae.autoClosingOvertype=7]="autoClosingOvertype",ae[ae.autoClosingQuotes=8]="autoClosingQuotes",ae[ae.autoIndent=9]="autoIndent",ae[ae.automaticLayout=10]="automaticLayout",ae[ae.autoSurround=11]="autoSurround",ae[ae.bracketPairColorization=12]="bracketPairColorization",ae[ae.guides=13]="guides",ae[ae.codeLens=14]="codeLens",ae[ae.codeLensFontFamily=15]="codeLensFontFamily",ae[ae.codeLensFontSize=16]="codeLensFontSize",ae[ae.colorDecorators=17]="colorDecorators",ae[ae.columnSelection=18]="columnSelection",ae[ae.comments=19]="comments",ae[ae.contextmenu=20]="contextmenu",ae[ae.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=22]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=24]="cursorStyle",ae[ae.cursorSurroundingLines=25]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=27]="cursorWidth",ae[ae.disableLayerHinting=28]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ae[ae.domReadOnly=30]="domReadOnly",ae[ae.dragAndDrop=31]="dragAndDrop",ae[ae.dropIntoEditor=32]="dropIntoEditor",ae[ae.emptySelectionClipboard=33]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=34]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=35]="extraEditorClassName",ae[ae.fastScrollSensitivity=36]="fastScrollSensitivity",ae[ae.find=37]="find",ae[ae.fixedOverflowWidgets=38]="fixedOverflowWidgets",ae[ae.folding=39]="folding",ae[ae.foldingStrategy=40]="foldingStrategy",ae[ae.foldingHighlight=41]="foldingHighlight",ae[ae.foldingImportsByDefault=42]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=43]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=44]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=45]="fontFamily",ae[ae.fontInfo=46]="fontInfo",ae[ae.fontLigatures=47]="fontLigatures",ae[ae.fontSize=48]="fontSize",ae[ae.fontWeight=49]="fontWeight",ae[ae.fontVariations=50]="fontVariations",ae[ae.formatOnPaste=51]="formatOnPaste",ae[ae.formatOnType=52]="formatOnType",ae[ae.glyphMargin=53]="glyphMargin",ae[ae.gotoLocation=54]="gotoLocation",ae[ae.hideCursorInOverviewRuler=55]="hideCursorInOverviewRuler",ae[ae.hover=56]="hover",ae[ae.inDiffEditor=57]="inDiffEditor",ae[ae.inlineSuggest=58]="inlineSuggest",ae[ae.letterSpacing=59]="letterSpacing",ae[ae.lightbulb=60]="lightbulb",ae[ae.lineDecorationsWidth=61]="lineDecorationsWidth",ae[ae.lineHeight=62]="lineHeight",ae[ae.lineNumbers=63]="lineNumbers",ae[ae.lineNumbersMinChars=64]="lineNumbersMinChars",ae[ae.linkedEditing=65]="linkedEditing",ae[ae.links=66]="links",ae[ae.matchBrackets=67]="matchBrackets",ae[ae.minimap=68]="minimap",ae[ae.mouseStyle=69]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=70]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=71]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=72]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=73]="multiCursorModifier",ae[ae.multiCursorPaste=74]="multiCursorPaste",ae[ae.multiCursorLimit=75]="multiCursorLimit",ae[ae.occurrencesHighlight=76]="occurrencesHighlight",ae[ae.overviewRulerBorder=77]="overviewRulerBorder",ae[ae.overviewRulerLanes=78]="overviewRulerLanes",ae[ae.padding=79]="padding",ae[ae.parameterHints=80]="parameterHints",ae[ae.peekWidgetDefaultFocus=81]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=82]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=83]="quickSuggestions",ae[ae.quickSuggestionsDelay=84]="quickSuggestionsDelay",ae[ae.readOnly=85]="readOnly",ae[ae.renameOnType=86]="renameOnType",ae[ae.renderControlCharacters=87]="renderControlCharacters",ae[ae.renderFinalNewline=88]="renderFinalNewline",ae[ae.renderLineHighlight=89]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=90]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=91]="renderValidationDecorations",ae[ae.renderWhitespace=92]="renderWhitespace",ae[ae.revealHorizontalRightPadding=93]="revealHorizontalRightPadding",ae[ae.roundedSelection=94]="roundedSelection",ae[ae.rulers=95]="rulers",ae[ae.scrollbar=96]="scrollbar",ae[ae.scrollBeyondLastColumn=97]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=98]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=99]="scrollPredominantAxis",ae[ae.selectionClipboard=100]="selectionClipboard",ae[ae.selectionHighlight=101]="selectionHighlight",ae[ae.selectOnLineNumbers=102]="selectOnLineNumbers",ae[ae.showFoldingControls=103]="showFoldingControls",ae[ae.showUnused=104]="showUnused",ae[ae.snippetSuggestions=105]="snippetSuggestions",ae[ae.smartSelect=106]="smartSelect",ae[ae.smoothScrolling=107]="smoothScrolling",ae[ae.stickyScroll=108]="stickyScroll",ae[ae.stickyTabStops=109]="stickyTabStops",ae[ae.stopRenderingLineAfter=110]="stopRenderingLineAfter",ae[ae.suggest=111]="suggest",ae[ae.suggestFontSize=112]="suggestFontSize",ae[ae.suggestLineHeight=113]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=114]="suggestOnTriggerCharacters",ae[ae.suggestSelection=115]="suggestSelection",ae[ae.tabCompletion=116]="tabCompletion",ae[ae.tabIndex=117]="tabIndex",ae[ae.unicodeHighlighting=118]="unicodeHighlighting",ae[ae.unusualLineTerminators=119]="unusualLineTerminators",ae[ae.useShadowDOM=120]="useShadowDOM",ae[ae.useTabStops=121]="useTabStops",ae[ae.wordBreak=122]="wordBreak",ae[ae.wordSeparators=123]="wordSeparators",ae[ae.wordWrap=124]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=125]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=126]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=127]="wordWrapColumn",ae[ae.wordWrapOverride1=128]="wordWrapOverride1",ae[ae.wordWrapOverride2=129]="wordWrapOverride2",ae[ae.wrappingIndent=130]="wrappingIndent",ae[ae.wrappingStrategy=131]="wrappingStrategy",ae[ae.showDeprecated=132]="showDeprecated",ae[ae.inlayHints=133]="inlayHints",ae[ae.editorClassName=134]="editorClassName",ae[ae.pixelRatio=135]="pixelRatio",ae[ae.tabFocusMode=136]="tabFocusMode",ae[ae.layoutInfo=137]="layoutInfo",ae[ae.wrappingInfo=138]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(177,null)})),acceptSuggestionOnEnter:Fe(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(178,null),""],markdownDescription:c.localize(179,null)})),accessibilitySupport:Fe(new o),accessibilityPageSize:Fe(new p(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(180,null),tags:["accessibility"]})),ariaLabel:Fe(new w(4,"ariaLabel",c.localize(181,null))),autoClosingBrackets:Fe(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(182,null),c.localize(183,null),""],description:c.localize(184,null)})),autoClosingDelete:Fe(new r(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(185,null),""],description:c.localize(186,null)})),autoClosingOvertype:Fe(new r(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(187,null),""],description:c.localize(188,null)})),autoClosingQuotes:Fe(new r(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(189,null),c.localize(190,null),""],description:c.localize(191,null)})),autoIndent:Fe(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[c.localize(192,null),c.localize(193,null),c.localize(194,null),c.localize(195,null),c.localize(196,null)],description:c.localize(197,null)})),automaticLayout:Fe(new h(10,"automaticLayout",!1)),autoSurround:Fe(new r(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(198,null),c.localize(199,null),c.localize(200,null),""],description:c.localize(201,null)})),bracketPairColorization:Fe(new de),bracketPairGuides:Fe(new be),stickyTabStops:Fe(new h(109,"stickyTabStops",!1,{description:c.localize(202,null)})),codeLens:Fe(new h(14,"codeLens",!0,{description:c.localize(203,null)})),codeLensFontFamily:Fe(new w(15,"codeLensFontFamily","",{description:c.localize(204,null)})),codeLensFontSize:Fe(new p(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(205,null)})),colorDecorators:Fe(new h(17,"colorDecorators",!0,{description:c.localize(206,null)})),columnSelection:Fe(new h(18,"columnSelection",!1,{description:c.localize(207,null)})),comments:Fe(new a),contextmenu:Fe(new h(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new h(21,"copyWithSyntaxHighlighting",!0,{description:c.localize(208,null)})),cursorBlinking:Fe(new l(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:c.localize(209,null)})),cursorSmoothCaretAnimation:Fe(new r(23,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(210,null),c.localize(211,null),c.localize(212,null)],description:c.localize(213,null)})),cursorStyle:Fe(new l(24,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:c.localize(214,null)})),cursorSurroundingLines:Fe(new p(25,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(215,null)})),cursorSurroundingLinesStyle:Fe(new r(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(216,null),c.localize(217,null)],description:c.localize(218,null)})),cursorWidth:Fe(new p(27,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(219,null)})),disableLayerHinting:Fe(new h(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new h(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new h(30,"domReadOnly",!1)),dragAndDrop:Fe(new h(31,"dragAndDrop",!0,{description:c.localize(220,null)})),emptySelectionClipboard:Fe(new X),dropIntoEditor:Fe(new _e),stickyScroll:Fe(new te),experimentalWhitespaceRendering:Fe(new r(34,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(221,null),c.localize(222,null),c.localize(223,null)],description:c.localize(224,null)})),extraEditorClassName:Fe(new w(35,"extraEditorClassName","")),fastScrollSensitivity:Fe(new g(36,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:c.localize(225,null)})),find:Fe(new q),fixedOverflowWidgets:Fe(new h(38,"fixedOverflowWidgets",!1)),folding:Fe(new h(39,"folding",!0,{description:c.localize(226,null)})),foldingStrategy:Fe(new r(40,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(227,null),c.localize(228,null)],description:c.localize(229,null)})),foldingHighlight:Fe(new h(41,"foldingHighlight",!0,{description:c.localize(230,null)})),foldingImportsByDefault:Fe(new h(42,"foldingImportsByDefault",!1,{description:c.localize(231,null)})),foldingMaximumRegions:Fe(new p(43,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(232,null)})),unfoldOnClickAfterEndOfLine:Fe(new h(44,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(233,null)})),fontFamily:Fe(new w(45,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(234,null)})),fontInfo:Fe(new F),fontLigatures2:Fe(new N),fontSize:Fe(new z),fontWeight:Fe(new U),fontVariations:Fe(new M),formatOnPaste:Fe(new h(51,"formatOnPaste",!1,{description:c.localize(235,null)})),formatOnType:Fe(new h(52,"formatOnType",!1,{description:c.localize(236,null)})),glyphMargin:Fe(new h(53,"glyphMargin",!0,{description:c.localize(237,null)})),gotoLocation:Fe(new W),hideCursorInOverviewRuler:Fe(new h(55,"hideCursorInOverviewRuler",!1,{description:c.localize(238,null)})),hover:Fe(new x),inDiffEditor:Fe(new h(57,"inDiffEditor",!1)),letterSpacing:Fe(new g(59,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>g.clamp(ae,-5,20),{description:c.localize(239,null)})),lightbulb:Fe(new J),lineDecorationsWidth:Fe(new Z),lineHeight:Fe(new ge),lineNumbers:Fe(new ee),lineNumbersMinChars:Fe(new p(64,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new h(65,"linkedEditing",!1,{description:c.localize(240,null)})),links:Fe(new h(66,"links",!0,{description:c.localize(241,null)})),matchBrackets:Fe(new r(67,"matchBrackets","always",["always","near","never"],{description:c.localize(242,null)})),minimap:Fe(new ve),mouseStyle:Fe(new r(69,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new g(70,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:c.localize(243,null)})),mouseWheelZoom:Fe(new h(71,"mouseWheelZoom",!1,{markdownDescription:c.localize(244,null)})),multiCursorMergeOverlapping:Fe(new h(72,"multiCursorMergeOverlapping",!0,{description:c.localize(245,null)})),multiCursorModifier:Fe(new l(73,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],De,{markdownEnumDescriptions:[c.localize(246,null),c.localize(247,null)],markdownDescription:c.localize(248,null)})),multiCursorPaste:Fe(new r(74,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(249,null),c.localize(250,null)],markdownDescription:c.localize(251,null)})),multiCursorLimit:Fe(new p(75,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(252,null)})),occurrencesHighlight:Fe(new h(76,"occurrencesHighlight",!0,{description:c.localize(253,null)})),overviewRulerBorder:Fe(new h(77,"overviewRulerBorder",!0,{description:c.localize(254,null)})),overviewRulerLanes:Fe(new p(78,"overviewRulerLanes",3,0,3)),padding:Fe(new Re),parameterHints:Fe(new ze),peekWidgetDefaultFocus:Fe(new r(81,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(255,null),c.localize(256,null)],description:c.localize(257,null)})),definitionLinkOpensInPeek:Fe(new h(82,"definitionLinkOpensInPeek",!1,{description:c.localize(258,null)})),quickSuggestions:Fe(new ue),quickSuggestionsDelay:Fe(new p(84,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(259,null)})),readOnly:Fe(new h(85,"readOnly",!1)),renameOnType:Fe(new h(86,"renameOnType",!1,{description:c.localize(260,null),markdownDeprecationMessage:c.localize(261,null)})),renderControlCharacters:Fe(new h(87,"renderControlCharacters",!0,{description:c.localize(262,null),restricted:!0})),renderFinalNewline:Fe(new r(88,"renderFinalNewline",t.isLinux?"dimmed":"on",["off","on","dimmed"],{description:c.localize(263,null)})),renderLineHighlight:Fe(new r(89,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(264,null)],description:c.localize(265,null)})),renderLineHighlightOnlyWhenFocus:Fe(new h(90,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(266,null)})),renderValidationDecorations:Fe(new r(91,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new r(92,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(267,null),c.localize(268,null),c.localize(269,null),""],description:c.localize(270,null)})),revealHorizontalRightPadding:Fe(new p(93,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new h(94,"roundedSelection",!0,{description:c.localize(271,null)})),rulers:Fe(new ie),scrollbar:Fe(new H),scrollBeyondLastColumn:Fe(new p(97,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(272,null)})),scrollBeyondLastLine:Fe(new h(98,"scrollBeyondLastLine",!0,{description:c.localize(273,null)})),scrollPredominantAxis:Fe(new h(99,"scrollPredominantAxis",!0,{description:c.localize(274,null)})),selectionClipboard:Fe(new h(100,"selectionClipboard",!0,{description:c.localize(275,null),included:t.isLinux})),selectionHighlight:Fe(new h(101,"selectionHighlight",!0,{description:c.localize(276,null)})),selectOnLineNumbers:Fe(new h(102,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new r(103,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(277,null),c.localize(278,null),c.localize(279,null)],description:c.localize(280,null)})),showUnused:Fe(new h(104,"showUnused",!0,{description:c.localize(281,null)})),showDeprecated:Fe(new h(132,"showDeprecated",!0,{description:c.localize(282,null)})),inlayHints:Fe(new le),snippetSuggestions:Fe(new r(105,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(283,null),c.localize(284,null),c.localize(285,null),c.localize(286,null)],description:c.localize(287,null)})),smartSelect:Fe(new Ce),smoothScrolling:Fe(new h(107,"smoothScrolling",!1,{description:c.localize(288,null)})),stopRenderingLineAfter:Fe(new p(110,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new pe),inlineSuggest:Fe(new Y),suggestFontSize:Fe(new p(112,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(289,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new p(113,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(290,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new h(114,"suggestOnTriggerCharacters",!0,{description:c.localize(291,null)})),suggestSelection:Fe(new r(115,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(292,null),c.localize(293,null),c.localize(294,null)],description:c.localize(295,null)})),tabCompletion:Fe(new r(116,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(296,null),c.localize(297,null),c.localize(298,null)],description:c.localize(299,null)})),tabIndex:Fe(new p(117,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new K),unusualLineTerminators:Fe(new r(119,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(300,null),c.localize(301,null),c.localize(302,null)],description:c.localize(303,null)})),useShadowDOM:Fe(new h(120,"useShadowDOM",!0)),useTabStops:Fe(new h(121,"useTabStops",!0,{description:c.localize(304,null)})),wordBreak:Fe(new r(122,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(305,null),c.localize(306,null)],description:c.localize(307,null)})),wordSeparators:Fe(new w(123,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:c.localize(308,null)})),wordWrap:Fe(new r(124,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(309,null),c.localize(310,null),c.localize(311,null),c.localize(312,null)],description:c.localize(313,null)})),wordWrapBreakAfterCharacters:Fe(new w(125,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new w(126,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new p(127,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(314,null)})),wordWrapOverride1:Fe(new r(128,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new r(129,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new B),pixelRatio:Fe(new se),tabFocusMode:Fe(new ke),layoutInfo:Fe(new _),wrappingInfo:Fe(new et),wrappingIndent:Fe(new Ge),wrappingStrategy:Fe(new Q)}}),define(Se[166],ye([19,20]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[167],ye([19,20]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[168],ye([19,20]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[169],ye([19,20]),function(ne,e){return ne.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[170],ye([19,20]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(Se[171],ye([19,20]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(Se[172],ye([19,20]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(Se[173],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[174],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[175],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[176],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[177],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[178],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[179],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[180],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[181],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Se[182],ye([19,20]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(Se[183],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[184],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[185],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[186],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[187],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[188],ye([19,20]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[189],ye([19,20]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[190],ye([19,20]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[191],ye([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(A,C){this.a.set(A,C)}updateManifest(A){if(!(typeof A.main>"u"&&typeof A.browser>"u")&&(A.activationEvents===void 0&&Object.assign(A,{activationEvents:[]}),!(!Array.isArray(A.activationEvents)||!A.contributes)))for(const C in A.contributes){const T=this.a.get(C);if(!T)continue;const S=A.contributes[C],y=Array.isArray(S)?S:[S];try{T(y,A.activationEvents)}catch(L){(0,c.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(Se[192],ye([1,0,24,42,168,310]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function S(h){return h=h.trim(),h==="*"||C.test(h)}e.isValidVersionStr=S;function y(h){if(!S(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=h.match(C);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=y;function L(h){if(!h)return null;const b=h.majorBase,p=h.majorMustEqual,g=h.minorBase;let w=h.minorMustEqual;const s=h.patchBase;let r=h.patchMustEqual;h.hasCaret&&(b===0||(w=!1),r=!1);let l=0;if(h.preRelease){const u=T.exec(h.preRelease);if(u){const[,o,a,n]=u;l=Date.UTC(Number(o),Number(a)-1,Number(n))}}return{majorBase:b,majorMustEqual:p,minorBase:g,minorMustEqual:w,patchBase:s,patchMustEqual:r,isMinimum:h.hasGreaterEquals,notBefore:l}}e.normalizeVersion=L;function P(h,b,p){let g;typeof h=="string"?g=L(y(h)):g=h;let w;b instanceof Date?w=b.getTime():typeof b=="string"&&(w=new Date(b).getTime());let s;if(typeof p=="string"?s=L(y(p)):s=p,!g||!s)return!1;const r=g.majorBase,l=g.minorBase,u=g.patchBase;let o=s.majorBase,a=s.minorBase,n=s.patchBase;const i=s.notBefore;let f=s.majorMustEqual,k=s.minorMustEqual,R=s.patchMustEqual;return s.isMinimum?r>o?!0:r<o?!1:l>a?!0:l<a||w&&w<i?!1:u>=n:(r===1&&o===0&&(!f||!k||!R)&&(o=1,a=0,n=0,f=!0,k=!1,R=!1),r<o?!1:r>o?!f:l<a?!1:l>a?!k:u<n?!1:u>n?!R:!(w&&w<i))}e.isValidVersion=P;function E(h,b,p,g,w){const s=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return s.push([t.default.Error,I.localize(0,null)]),s;if(typeof g.name!="string")return s.push([t.default.Error,I.localize(1,null,"name")]),s;if(typeof g.version!="string")return s.push([t.default.Error,I.localize(2,null,"version")]),s;if(!g.engines)return s.push([t.default.Error,I.localize(3,null,"engines")]),s;if(typeof g.engines.vscode!="string")return s.push([t.default.Error,I.localize(4,null,"engines.vscode")]),s;if(typeof g.extensionDependencies<"u"&&!m(g.extensionDependencies))return s.push([t.default.Error,I.localize(5,null,"extensionDependencies")]),s;if(typeof g.activationEvents<"u"){if(!m(g.activationEvents))return s.push([t.default.Error,I.localize(6,null,"activationEvents")]),s;if(typeof g.main>"u"&&typeof g.browser>"u")return s.push([t.default.Error,I.localize(7,null,"activationEvents","main")]),s}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&s.push([t.default.Warning,I.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return s.push([t.default.Error,I.localize(9,null,"main")]),s;{const u=(0,c.joinPath)(p,g.main);(0,c.isEqualOrParent)(u,p)||s.push([t.default.Warning,I.localize(10,null,u.path,p.path)])}if(typeof g.activationEvents>"u")return s.push([t.default.Error,I.localize(11,null,"activationEvents","main")]),s}if(typeof g.browser<"u"){if(typeof g.browser!="string")return s.push([t.default.Error,I.localize(12,null,"browser")]),s;{const u=(0,c.joinPath)(p,g.browser);(0,c.isEqualOrParent)(u,p)||s.push([t.default.Warning,I.localize(13,null,u.path,p.path)])}if(typeof g.activationEvents>"u")return s.push([t.default.Error,I.localize(14,null,"activationEvents","browser")]),s}if(!A.valid(g.version))return s.push([t.default.Error,I.localize(15,null)]),s;const r=[];if(!D(h,b,g,w,r))for(const u of r)s.push([t.default.Error,u]);return s}e.validateExtensionManifest=E;function D(h,b,p,g,w){return g||typeof p.main>"u"&&typeof p.browser>"u"?!0:d(h,b,p.engines.vscode,w)}e.isValidExtensionVersion=D;function v(h,b,p){return h==="*"||d(b,p,h)}e.isEngineValid=v;function d(h,b,p,g=[]){const w=L(y(p));if(!w)return g.push(I.localize(16,null,p)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return g.push(I.localize(17,null,p)),!1}else if(!w.majorMustEqual)return g.push(I.localize(18,null,p)),!1;return P(h,b,w)?!0:(g.push(I.localize(19,null,h,p)),!1)}function m(h){if(!Array.isArray(h))return!1;for(let b=0,p=h.length;b<p;b++)if(typeof h[b]!="string")return!1;return!0}}),define(Se[120],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(I,A=[],C=!1){this.ctor=I,this.staticArguments=A,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=c}),define(Se[87],ye([1,0,120]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var I;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(I=e.InstantiationType||(e.InstantiationType={}));function A(T,S,y){S instanceof c.SyncDescriptor||(S=new c.SyncDescriptor(S,[],Boolean(y))),t.push([T,S])}e.registerSingleton=A;function C(){return t}e.getSingletonServiceDescriptors=C}),define(Se[193],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(A,C){this.key=A,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class t{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const C of this.a.values())C.outgoing.size===0&&A.push(C);return A}insertEdge(A,C){const T=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(C);T.outgoing.set(S.key,S),S.incoming.set(T.key,T)}removeNode(A){const C=this.b(A);this.a.delete(C);for(const T of this.a.values())T.outgoing.delete(C),T.incoming.delete(C)}lookupOrInsertNode(A){const C=this.b(A);let T=this.a.get(C);return T||(T=new c(C,A),this.a.set(C,T)),T}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[C,T]of this.a)A.push(`${C}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,C]of this.a){const T=new Set([A]),S=this.c(C,T);if(S)return S}}c(A,C){for(const[T,S]of A.outgoing){if(C.has(T))return[...C,T].join(" -> ");C.add(T);const y=this.c(S,C);if(y)return y;C.delete(T)}}}e.Graph=t}),define(Se[3],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function T(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=T})(c=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(C,T,S){T[c.DI_TARGET]===T?T[c.DI_DEPENDENCIES].push({id:C,index:S}):(T[c.DI_DEPENDENCIES]=[{id:C,index:S}],T[c.DI_TARGET]=T)}function I(C){if(c.serviceIds.has(C))return c.serviceIds.get(C);const T=function(S,y,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(T,S,L)};return T.toString=()=>C,c.serviceIds.set(C,T),T}e.createDecorator=I;function A(C){return C}e.refineServiceDecorator=A}),define(Se[52],ye([1,0,11,2,3]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationOverrides=A;function C(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=C;var T;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function y(h,b){const p=Object.create(null);for(const g in h)L(p,g,h[g],b);return p}e.toValuesTree=y;function L(h,b,p,g){const w=b.split("."),s=w.pop();let r=h;for(let l=0;l<w.length;l++){const u=w[l];let o=r[u];switch(typeof o){case"undefined":o=r[u]=Object.create(null);break;case"object":break;default:g(`Ignoring ${b} as ${w.slice(0,l+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[s]=p}catch{g(`Ignoring ${b} as ${w.join(".")} is ${JSON.stringify(r)}`)}else g(`Ignoring ${b} as ${w.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=L;function P(h,b){const p=b.split(".");E(h,p)}e.removeFromValueTree=P;function E(h,b){const p=b.shift();if(b.length===0){delete h[p];return}if(Object.keys(h).indexOf(p)!==-1){const g=h[p];typeof g=="object"&&!Array.isArray(g)&&(E(g,b),Object.keys(g).length===0&&delete h[p])}}function D(h,b,p){function g(r,l){let u=r;for(const o of l){if(typeof u!="object"||u===null)return;u=u[o]}return u}const w=b.split("."),s=g(h,w);return typeof s>"u"?p:s}e.getConfigurationValue=D;function v(h,b,p){Object.keys(b).forEach(g=>{g!=="__proto__"&&(g in h?c.isObject(h[g])&&c.isObject(b[g])?v(h[g],b[g],p):p&&(h[g]=b[g]):h[g]=b[g])})}e.merge=v;function d(h,b,p){const g=h.inspect(b),w=h.inspect(p);return typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:g.defaultValue}e.getMigratedSettingValue=d;function m(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(Se[53],ye([1,0,12,8,3]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",c.isMacintosh),A.set("isLinux",c.isLinux),A.set("isWindows",c.isWindows),A.set("isWeb",c.isWeb),A.set("isMacNative",c.isMacintosh&&!c.isWeb),A.set("isEdge",c.isEdge),A.set("isFirefox",c.isFirefox),A.set("isChrome",c.isChrome),A.set("isSafari",c.isSafari);const C=Object.prototype.hasOwnProperty;var T;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(T=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return P.INSTANCE}static true(){return E.INSTANCE}static has(N){return D.create(N)}static equals(N,M){return v.create(N,M)}static notEquals(N,M){return h.create(N,M)}static regex(N,M){return l.create(N,M)}static in(N,M){return d.create(N,M)}static notIn(N,M){return m.create(N,M)}static not(N){return b.create(N)}static and(...N){return a.create(N,null,!0)}static or(...N){return n.create(N,null,!0)}static greater(N,M){return g.create(N,M)}static greaterEquals(N,M){return w.create(N,M)}static smaller(N,M){return s.create(N,M)}static smallerEquals(N,M){return r.create(N,M)}static deserialize(N,M=!1){if(!!N)return this.c(N,M)}static c(N,M){const F=N.split("||");return n.create(F.map(z=>this.d(z,M)),null,!0)}static d(N,M){const F=N.split("&&");return a.create(F.map(z=>this.f(z,M)),null,!0)}static f(N,M){if(N=N.trim(),N.indexOf("!=")>=0){const F=N.split("!=");return h.create(F[0].trim(),this.g(F[1],M))}if(N.indexOf("==")>=0){const F=N.split("==");return v.create(F[0].trim(),this.g(F[1],M))}if(N.indexOf("=~")>=0){const F=N.split("=~");return l.create(F[0].trim(),this.h(F[1],M))}if(N.indexOf(" not in ")>=0){const F=N.split(" not in ");return m.create(F[0].trim(),this.g(F[1],M))}if(N.indexOf(" in ")>=0){const F=N.split(" in ");return d.create(F[0].trim(),this.g(F[1],M))}if(/^[^<=>]+>=[^<=>]+$/.test(N)){const F=N.split(">=");return w.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(N)){const F=N.split(">");return g.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(N)){const F=N.split("<=");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(N)){const F=N.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(N)?b.create(N.substr(1).trim()):D.create(N)}static g(N,M){if(N=N.trim(),N==="true")return!0;if(N==="false")return!1;const F=/^'([^']*)'$/.exec(N);return F?F[1].trim():N}static h(N,M){if((0,t.isFalsyOrWhitespace)(N)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=N.indexOf("/"),z=N.lastIndexOf("/");if(F===z||F<0){if(M)throw new Error(`bad regexp-value '${N}', missing /-enclosure`);return console.warn(`bad regexp-value '${N}', missing /-enclosure`),null}const U=N.slice(F+1,z),W=N[z+1]==="i"?"i":"";try{return new RegExp(U,W)}catch(x){if(M)throw new Error(`bad regexp-value '${N}', parse error: ${x}`);return console.warn(`bad regexp-value '${N}', parse error: ${x}`),null}}}e.ContextKeyExpr=S;function y(q,N){const M=q?q.substituteConstants():void 0,F=N?N.substituteConstants():void 0;return!M&&!F?!0:!M||!F?!1:M.equals(F)}e.expressionsAreEqualWithConstantSubstitution=y;function L(q,N){return q.cmp(N)}class P{constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class E{constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class D{static create(N,M=null){const F=A.get(N);return typeof F=="boolean"?F?E.INSTANCE:P.INSTANCE:new D(N,M)}constructor(N,M){this.key=N,this.c=M,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:f(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=A.get(this.key);return typeof N=="boolean"?N?E.INSTANCE:P.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=b.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=D;class v{static create(N,M,F=null){if(typeof M=="boolean")return M?D.create(N,F):b.create(N,F);const z=A.get(N);return typeof z=="boolean"?M===(z?"true":"false")?E.INSTANCE:P.INSTANCE:new v(N,M,F)}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:k(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=A.get(this.c);if(typeof N=="boolean"){const M=N?"true":"false";return this.d===M?E.INSTANCE:P.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=v;class d{static create(N,M){return new d(N,M)}constructor(N,M){this.d=N,this.f=M,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:k(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const M=N.getValue(this.f),F=N.getValue(this.d);return Array.isArray(M)?M.includes(F):typeof F=="string"&&typeof M=="object"&&M!==null?C.call(M,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=d;class m{static create(N,M){return new m(N,M)}constructor(N,M){this.d=N,this.f=M,this.type=11,this.c=d.create(N,M)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=m;class h{static create(N,M,F=null){if(typeof M=="boolean")return M?b.create(N,F):D.create(N,F);const z=A.get(N);return typeof z=="boolean"?M===(z?"true":"false")?P.INSTANCE:E.INSTANCE:new h(N,M,F)}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:k(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=A.get(this.c);if(typeof N=="boolean"){const M=N?"true":"false";return this.d===M?P.INSTANCE:E.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=h;class b{static create(N,M=null){const F=A.get(N);return typeof F=="boolean"?F?P.INSTANCE:E.INSTANCE:new b(N,M)}constructor(N,M){this.c=N,this.d=M,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:f(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=A.get(this.c);return typeof N=="boolean"?N?P.INSTANCE:E.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.ContextKeyNotExpr=b;function p(q,N){if(typeof q=="string"){const M=parseFloat(q);isNaN(M)||(q=M)}return typeof q=="string"||typeof q=="number"?N(q):P.INSTANCE}class g{static create(N,M,F=null){return p(M,z=>new g(N,z,F))}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:k(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=g;class w{static create(N,M,F=null){return p(M,z=>new w(N,z,F))}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:k(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=w;class s{static create(N,M,F=null){return p(M,z=>new s(N,z,F))}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:k(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=s;class r{static create(N,M,F=null){return p(M,z=>new r(N,z,F))}constructor(N,M,F){this.c=N,this.d=M,this.f=F,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:k(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class l{static create(N,M){return new l(N,M)}constructor(N,M){this.d=N,this.f=M,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const M=this.f?this.f.source:"",F=N.f?N.f.source:"";return M<F?-1:M>F?1:0}equals(N){if(N.type===this.type){const M=this.f?this.f.source:"",F=N.f?N.f.source:"";return this.d===N.d&&M===F}return!1}substituteConstants(){return this}evaluate(N){const M=N.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=u.create(this)),this.c}}e.ContextKeyRegexExpr=l;class u{static create(N){return new u(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(N){return new u(this.c.map(N))}negate(){return this.c}}e.ContextKeyNotRegexExpr=u;function o(q){let N=null;for(let M=0,F=q.length;M<F;M++){const z=q[M].substituteConstants();if(q[M]!==z&&N===null){N=[];for(let U=0;U<M;U++)N[U]=q[U]}N!==null&&(N[M]=z)}return N===null?q:N}class a{static create(N,M,F){return a.d(N,M,F)}constructor(N,M){this.expr=N,this.c=M,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const z=L(this.expr[M],N.expr[M]);if(z!==0)return z}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(N.expr[M]))return!1;return!0}return!1}substituteConstants(){const N=o(this.expr);return N===this.expr?this:a.create(N,this.c,!1)}evaluate(N){for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].evaluate(N))return!1;return!0}static d(N,M,F){const z=[];let U=!1;for(const W of N)if(!!W){if(W.type===1){U=!0;continue}if(W.type===0)return P.INSTANCE;if(W.type===6){z.push(...W.expr);continue}z.push(W)}if(z.length===0&&U)return E.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(L);for(let W=1;W<z.length;W++)z[W-1].equals(z[W])&&(z.splice(W,1),W--);if(z.length===1)return z[0];for(;z.length>1;){const W=z[z.length-1];if(W.type!==9)break;z.pop();const x=z.pop(),V=z.length===0,_=n.create(W.expr.map(Q=>a.create([Q,x],null,F)),null,V);_&&(z.push(_),z.sort(L))}if(z.length===1)return z[0];if(F){for(let W=0;W<z.length;W++)for(let x=W+1;x<z.length;x++)if(z[W].negate().equals(z[x]))return P.INSTANCE;if(z.length===1)return z[0]}return new a(z,M)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const M of this.expr)N.push(...M.keys());return N}map(N){return new a(this.expr.map(M=>M.map(N)),null)}negate(){if(!this.c){const N=[];for(const M of this.expr)N.push(M.negate());this.c=n.create(N,this,!0)}return this.c}}class n{static create(N,M,F){return n.d(N,M,F)}constructor(N,M){this.expr=N,this.c=M,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let M=0,F=this.expr.length;M<F;M++){const z=L(this.expr[M],N.expr[M]);if(z!==0)return z}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let M=0,F=this.expr.length;M<F;M++)if(!this.expr[M].equals(N.expr[M]))return!1;return!0}return!1}substituteConstants(){const N=o(this.expr);return N===this.expr?this:n.create(N,this.c,!1)}evaluate(N){for(let M=0,F=this.expr.length;M<F;M++)if(this.expr[M].evaluate(N))return!0;return!1}static d(N,M,F){let z=[],U=!1;if(N){for(let W=0,x=N.length;W<x;W++){const V=N[W];if(!!V){if(V.type===0){U=!0;continue}if(V.type===1)return E.INSTANCE;if(V.type===9){z=z.concat(V.expr);continue}z.push(V)}}if(z.length===0&&U)return P.INSTANCE;z.sort(L)}if(z.length!==0){if(z.length===1)return z[0];for(let W=1;W<z.length;W++)z[W-1].equals(z[W])&&(z.splice(W,1),W--);if(z.length===1)return z[0];if(F){for(let W=0;W<z.length;W++)for(let x=W+1;x<z.length;x++)if(z[W].negate().equals(z[x]))return E.INSTANCE;if(z.length===1)return z[0]}return new n(z,M)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const M of this.expr)N.push(...M.keys());return N}map(N){return new n(this.expr.map(M=>M.map(N)),null)}negate(){if(!this.c){const N=[];for(const M of this.expr)N.push(M.negate());for(;N.length>1;){const M=N.shift(),F=N.shift(),z=[];for(const U of X(M))for(const W of X(F))z.push(a.create([U,W],null,!1));N.unshift(n.create(z,null,!1))}this.c=n.create(N,this,!0)}return this.c}}class i extends D{static all(){return i.d.values()}constructor(N,M,F){super(N,null),this.f=M,typeof F=="object"?i.d.push({...F,key:N}):F!==!0&&i.d.push({key:N,description:F,type:M!=null?typeof M:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return v.create(this.key,N)}notEqualsTo(N){return h.create(this.key,N)}}e.RawContextKey=i,i.d=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService");function f(q,N){return q<N?-1:q>N?1:0}function k(q,N,M,F){return q<M?-1:q>M?1:N<F?-1:N>F?1:0}function R(q,N){if(q.type===0||N.type===1)return!0;if(q.type===9)return N.type===9?B(q.expr,N.expr):!1;if(N.type===9){for(const M of N.expr)if(R(q,M))return!0;return!1}if(q.type===6){if(N.type===6)return B(N.expr,q.expr);for(const M of q.expr)if(R(M,N))return!0;return!1}return q.equals(N)}e.implies=R;function B(q,N){let M=0,F=0;for(;M<q.length&&F<N.length;){const z=q[M].cmp(N[F]);if(z<0)return!1;z===0&&M++,F++}return M===q.length}function X(q){return q.type===9?q.expr:[q]}}),define(Se[194],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(Se[121],ye([1,0,167,3]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function I(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function A(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function C(h,b){switch(h){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function T(h,b){return b==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function S(h,b,p){return T(b,p)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===p?!0:y(p).includes(h)}e.isTargetPlatformCompatible=S;function y(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=y;function L(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=L;var P;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var E;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var D;(function(h){h.Install="install",h.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var v;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var d;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class m extends Error{constructor(b,p){super(b),this.code=p,this.name=p}}e.ExtensionManagementError=m,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,c.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Se[195],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(Se[196],ye([1,0,45,15,9,12,106,29,114,169,195]),function(ne,e,c,t,I,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=y.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:D.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class D extends E{openTerminal(g,w){return this.spawnTerminal(c,g,S.getWindowsShell(),w)}spawnTerminal(g,w,s,r){const l=w.windowsExec||D.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const u=I.basename(l).toLowerCase();if(u==="cmder"||u==="cmder.exe")return g.spawn(l,r?[r]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return l.indexOf(" ")>=0&&o.push('""'),o.push(l),(u==="wt"||u==="wt.exe")&&o.push("-d ."),new Promise((a,n)=>{const i=m(process),f=g.spawn(s,o,{cwd:r,env:i});f.on("error",n),f.on("exit",()=>a())})}runInTerminal(g,w,s,r,l){const u="windowsExec"in l&&l.windowsExec?l.windowsExec:D.getDefaultTerminalWindows();return new Promise((o,a)=>{const n=`"${w} - ${P}"`,i=`""${s.join('" "')}" & pause"`,f=["/c","start",n,"/wait",u,"/c",i],k=Object.assign({},m(process),r);Object.keys(k).filter(X=>k[X]===null).forEach(X=>delete k[X]);const R={cwd:w,env:k,windowsVerbatimArguments:!0};c.spawn(D.b,f,R).on("error",X=>{a(h(X))}),o(void 0)})}static getDefaultTerminalWindows(){if(!D.d){const g=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");D.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${g?"Sysnative":"System32"}\\cmd.exe`}return D.d}}e.WindowsExternalTerminalService=D,D.b="cmd.exe";class v extends E{openTerminal(g,w){return this.spawnTerminal(c,g,w)}runInTerminal(g,w,s,r,l){const u=l.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((o,a)=>{if(u===L.DEFAULT_TERMINAL_OSX||u==="iTerm.app"){const n=u===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",f=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",g||P,"-w",w];for(const B of s)f.push("-a"),f.push(B);if(r){const B=Object.assign({},m(process),r);for(const X in B){const q=B[X];q===null?(f.push("-u"),f.push(X)):(f.push("-e"),f.push(`${X}=${q}`))}}let k="";const R=c.spawn(v.b,f);R.on("error",B=>{a(h(B))}),R.stderr.on("data",B=>{k+=B.toString()}),R.on("exit",B=>{if(B===0)o(void 0);else if(k){const X=k.split(`
`,1);a(new Error(X[0]))}else a(new Error(y.localize(1,null,n,B)))})}else a(new Error(y.localize(2,null,u)))})}spawnTerminal(g,w,s){const r=w.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((l,u)=>{const o=["-a",r];s&&o.push(s);const a=m(process),n=g.spawn("/usr/bin/open",o,{cwd:s,env:a});n.on("error",u),n.on("exit",()=>l())})}}e.MacExternalTerminalService=v,v.b="/usr/bin/osascript";class d extends E{openTerminal(g,w){return this.spawnTerminal(c,g,w)}runInTerminal(g,w,s,r,l){const u=l.linuxExec?Promise.resolve(l.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((o,a)=>{const n=[];u.then(i=>{i.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const f=`${b(s)}; echo; read -p "${d.b}" -n1;`;n.push(`''${f}''`);const k=Object.assign({},m(process),r);Object.keys(k).filter(q=>k[q]===null).forEach(q=>delete k[q]);const R={cwd:w,env:k};let B="";const X=c.spawn(i,n,R);X.on("error",q=>{a(h(q))}),X.stderr.on("data",q=>{B+=q.toString()}),X.on("exit",q=>{if(q===0)o(void 0);else if(B){const N=B.split(`
`,1);a(new Error(N[0]))}else a(new Error(y.localize(4,null,i,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!d.d)if(!A.isLinux)d.d=Promise.resolve("xterm");else{const g=await T.Promises.exists("/etc/debian_version");d.d=new Promise(w=>{g?w("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?w("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?w("konsole"):process.env.COLORTERM?w(process.env.COLORTERM):process.env.TERM?w(process.env.TERM):w("xterm")})}return d.d}spawnTerminal(g,w,s){const r=w.linuxExec?Promise.resolve(w.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((l,u)=>{r.then(o=>{const a=m(process),n=g.spawn(o,[],{cwd:s,env:a});n.on("error",u),n.on("exit",()=>l())})})}}e.LinuxExternalTerminalService=d,d.b=y.localize(3,null);function m(p){const g={...p.env};return(0,C.sanitizeProcessEnvironment)(g),g}function h(p){return"errno"in p&&p.errno==="ENOENT"&&"path"in p&&typeof p.path=="string"?new Error(y.localize(5,null,p.path)):p}function b(p){let g="";for(const w of p)w.indexOf(" ")>=0?g+='"'+w+'"':g+=w,g+=" ";return g}}),define(Se[38],ye([1,0,64,9,8,11,2,170,3]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function y(U){return U.create===!0}e.isFileOpenForWriteOptions=y;var L;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var P;(function(U){U[U.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var E;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function D(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=D;function v(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=v;function d(U){return!!(U.capabilities&32768)}e.hasFileCloneCapability=d;function m(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function h(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=h;function b(U){return D(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var p;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(W,x){super(W),this.code=x}}e.FileSystemProviderError=g;function w(U,W){const x=new g(U.toString(),W);return r(x,W),x}e.createFileSystemProviderError=w;function s(U){return U||w((0,T.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=s;function r(U,W){return U.name=W?`${W} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=r;function l(U){if(!U)return p.Unknown;if(U instanceof g)return U.code;const W=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!W)return p.Unknown;switch(W[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=l;function u(U){if(U instanceof k)return U.fileOperationResult;switch(l(U)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var o;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class a{constructor(W,x,V){this.resource=W,this.operation=x,this.target=V}isOperation(W){return this.operation===W}}e.FileOperationEvent=a;var n;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class i{constructor(W,x){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=W;const V=new Map;for(const _ of W){const Q=V.get(_.type);switch(Q?Q.push([_.resource,_]):V.set(_.type,[[_.resource,_]]),_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}}for(const[_,Q]of V)switch(_){case 1:this.a=c.TernarySearchTree.forUris(()=>x),this.a.fill(Q);break;case 0:this.b=c.TernarySearchTree.forUris(()=>x),this.b.fill(Q);break;case 2:this.c=c.TernarySearchTree.forUris(()=>x),this.c.fill(Q);break}}contains(W,...x){return this.d(W,{includeChildren:!1},...x)}affects(W,...x){return this.d(W,{includeChildren:!0},...x)}d(W,x,...V){if(!W)return!1;const _=V.length>0;return!!((!_||V.includes(1))&&(this.a?.get(W)||x.includeChildren&&this.a?.findSuperstr(W))||(!_||V.includes(0))&&(this.b?.get(W)||x.includeChildren&&this.b?.findSuperstr(W))||(!_||V.includes(2))&&(this.c?.findSubstr(W)||x.includeChildren&&this.c?.findSuperstr(W)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=i;function f(U,W,x){return!U||!W||U===W||W.length>U.length?!1:(W.charAt(W.length-1)!==t.sep&&(W+=t.sep),x?(0,I.startsWithIgnoreCase)(U,W):U.indexOf(W)===0)}e.isParent=f;class k extends Error{constructor(W,x,V){super(W),this.fileOperationResult=x,this.options=V}}e.FileOperationError=k;class R extends k{constructor(W,x,V){super(W,2,V),this.stat=x}}e.NotModifiedSinceFileOperationError=R;var B;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(B=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var X;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(X=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function q(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=q;async function N(U,W){if(!W.hasProvider(C.URI.from({scheme:U.scheme})))return new Promise(x=>{const V=W.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===U.scheme&&_.added&&(V.dispose(),x())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(W){return(0,A.isNumber)(W)||(W=0),W<M.KB?(0,T.localize)(1,null,W.toFixed(0)):W<M.MB?(0,T.localize)(2,null,(W/M.KB).toFixed(2)):W<M.GB?(0,T.localize)(3,null,(W/M.MB).toFixed(2)):W<M.TB?(0,T.localize)(4,null,(W/M.GB).toFixed(2)):(0,T.localize)(5,null,(W/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var F;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function z(U){return{maxFileSize:U===0?300*M.MB:16*M.GB,maxHeapSize:U===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=z}),define(Se[88],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...I){this.a=new Map;for(const[A,C]of I)this.set(A,C)}set(I,A){const C=this.a.get(I);return this.a.set(I,A),C}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.ServiceCollection=c}),define(Se[197],ye([1,0,18,10,6,120,193,3,88,63]),function(ne,e,c,t,I,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class P extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class E{constructor(m=new S.ServiceCollection,h=!1,b,p=L){this.f=m,this.g=h,this.h=b,this.i=p,this.o=new Set,this.f.set(T.IInstantiationService,this),this._globalGraph=p?b?._globalGraph??new C.Graph(g=>g):void 0}createChild(m){return new E(m,this.g,this,this.i)}invokeFunction(m,...h){const b=v.traceInvocation(this.i,m);let p=!1;try{return m({get:w=>{if(p)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const s=this.m(w,b);if(!s)throw new Error(`[invokeFunction] unknown service '${w}'`);return s}},...h)}finally{p=!0,b.stop()}}createInstance(m,...h){let b,p;return m instanceof A.SyncDescriptor?(b=v.traceCreation(this.i,m.ctor),p=this.j(m.ctor,m.staticArguments.concat(h),b)):(b=v.traceCreation(this.i,m),p=this.j(m,h,b)),b.stop(),p}j(m,h=[],b){const p=T._util.getServiceDependencies(m).sort((s,r)=>s.index-r.index),g=[];for(const s of p){const r=this.m(s.id,b);r||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${s.id}.`,!1),g.push(r)}const w=p.length>0?p[0].index:h.length;if(h.length!==w){console.trace(`[createInstance] First service dependency of ${m.name} at position ${w+1} conflicts with ${h.length} static arguments`);const s=w-h.length;s>0?h=h.concat(new Array(s)):h=h.slice(0,w)}return Reflect.construct(m,h.concat(g))}k(m,h){if(this.f.get(m)instanceof A.SyncDescriptor)this.f.set(m,h);else if(this.h)this.h.k(m,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const h=this.f.get(m);return!h&&this.h?this.h.l(m):h}m(m,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const b=this.l(m);return b instanceof A.SyncDescriptor?this.q(m,b,h.branch(m,!0)):(h.branch(m,!1),b)}q(m,h,b){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,h,b)}finally{this.o.delete(m)}}r(m,h,b){const p=new C.Graph(s=>s.id.toString());let g=0;const w=[{id:m,desc:h,_trace:b}];for(;w.length;){const s=w.pop();if(p.lookupOrInsertNode(s),g++>1e3)throw new P(p);for(const r of T._util.getServiceDependencies(s.desc.ctor)){const l=this.l(r.id);if(l||this.u(`[createInstance] ${m} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(r.id)),l instanceof A.SyncDescriptor){const u={id:r.id,desc:l,_trace:s._trace.branch(r.id,!0)};p.insertEdge(s,u),w.push(u)}}}for(;;){const s=p.roots();if(s.length===0){if(!p.isEmpty())throw new P(p);break}for(const{data:r}of s){if(this.l(r.id)instanceof A.SyncDescriptor){const u=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,u)}p.removeNode(r)}}return this.l(m)}s(m,h,b=[],p,g){if(this.f.get(m)instanceof A.SyncDescriptor)return this.t(m,h,b,p,g);if(this.h)return this.h.s(m,h,b,p,g);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(m,h,b=[],p,g){if(p){const w=new E(void 0,this.g,this,this.i);w.c=String(m);const s=new Map,r=new c.IdleValue(()=>{const l=w.j(h,b,g);for(const[u,o]of s){const a=l[u];if(typeof a=="function")for(const n of o)a.apply(l,n)}return s.clear(),l});return new Proxy(Object.create(null),{get(l,u){if(!r.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let n=s.get(u);return n||(n=new y.LinkedList,s.set(u,n)),(f,k,R)=>{const B=n.push([f,k,R]);return(0,I.toDisposable)(B)}}if(u in l)return l[u];const o=r.value;let a=o[u];return typeof a!="function"||(a=a.bind(o),l[u]=a),a},set(l,u,o){return r.value[u]=o,!0},getPrototypeOf(l){return h.prototype}})}else return this.j(h,b,g)}u(m,h){if(h&&console.warn(m),this.g)throw new Error(m)}}e.InstantiationService=E;var D;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(D||(D={}));class v{static traceInvocation(m,h){return m?new v(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(m,h){return m?new v(1,h.name):v.c}constructor(m,h){this.type=m,this.name=h,this.g=Date.now(),this.h=[]}branch(m,h){const b=new v(3,m.toString());return this.h.push([m,h,b]),b}stop(){const m=Date.now()-this.g;v.f+=m;let h=!1;function b(g,w){const s=[],r=new Array(g+1).join("	");for(const[l,u,o]of w.h)if(u&&o){h=!0,s.push(`${r}CREATES -> ${l}`);const a=b(g+1,o);a&&s.push(a)}else s.push(`${r}uses -> ${l}`);return s.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(m>2||h)&&v.all.add(p.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}},v.f=0}),define(Se[13],ye([1,0,51,4,6,28,12,2,3]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function y(){return new Date().toISOString()}var L;(function(a){a[a.Off=0]="Off",a[a.Trace=1]="Trace",a[a.Debug=2]="Debug",a[a.Info=3]="Info",a[a.Warning=4]="Warning",a[a.Error=5]="Error"})(L=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=L.Info;function P(a,n,i){switch(n){case L.Trace:a.trace(i);break;case L.Debug:a.debug(i);break;case L.Info:a.info(i);break;case L.Warning:a.warn(i);break;case L.Error:a.error(i);break;case L.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=P;function E(a){let n="";for(let i=0;i<a.length;i++){let f=a[i];if(typeof f=="object")try{f=JSON.stringify(f)}catch{}n+=(i>0?" ":"")+f}return n}e.format=E;class D extends I.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==L.Off&&this.b<=n}}e.AbstractLogger=D;class v extends D{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...i){this.f(L.Trace)&&this.g(L.Trace,E([n,...i]))}debug(n,...i){this.f(L.Debug)&&this.g(L.Debug,E([n,...i]))}info(n,...i){this.f(L.Info)&&this.g(L.Info,E([n,...i]))}warn(n,...i){this.f(L.Warning)&&this.g(L.Warning,E([n,...i]))}error(n,...i){if(this.f(L.Error))if(n instanceof Error){const f=Array.prototype.slice.call(arguments);f[0]=n.stack,this.g(L.Error,E(f))}else this.g(L.Error,E([n,...i]))}flush(){}}e.AbstractMessageLogger=v;class d extends D{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!C.isWindows}trace(n,...i){this.f(L.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,n,...i):console.log(`[main ${y()}]`,n,...i))}debug(n,...i){this.f(L.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,n,...i):console.log(`[main ${y()}]`,n,...i))}info(n,...i){this.f(L.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,n,...i):console.log(`[main ${y()}]`,n,...i))}warn(n,...i){this.f(L.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,n,...i):console.warn(`[main ${y()}]`,n,...i))}error(n,...i){this.f(L.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,n,...i):console.error(`[main ${y()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class m extends D{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...i){this.f(L.Trace)&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.f(L.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.f(L.Info)&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.f(L.Warning)&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.f(L.Error)&&console.log("%c  ERR","color: #f33",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=m;class h extends D{constructor(n,i=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(i)}trace(n,...i){this.f(L.Trace)&&this.g.log(L.Trace,[this.h(n),...i])}debug(n,...i){this.f(L.Debug)&&this.g.log(L.Debug,[this.h(n),...i])}info(n,...i){this.f(L.Info)&&this.g.log(L.Info,[this.h(n),...i])}warn(n,...i){this.f(L.Warning)&&this.g.log(L.Warning,[this.h(n),...i])}error(n,...i){this.f(L.Error)&&this.g.log(L.Error,[this.h(n),...i])}h(n){return typeof n=="string"?n:(0,c.toErrorMessage)(n,this.f(L.Trace))}dispose(){}flush(){}}e.AdapterLogger=h;class b extends D{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.g)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const f of this.g)f.trace(n,...i)}debug(n,...i){for(const f of this.g)f.debug(n,...i)}info(n,...i){for(const f of this.g)f.info(n,...i)}warn(n,...i){for(const f of this.g)f.warn(n,...i)}error(n,...i){for(const f of this.g)f.error(n,...i)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=b;class p extends I.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...i){this.b.trace(n,...i)}debug(n,...i){this.b.debug(n,...i)}info(n,...i){this.b.info(n,...i)}warn(n,...i){this.b.warn(n,...i)}error(n,...i){this.b.error(n,...i)}flush(){this.b.flush()}}e.LogService=p;class g extends I.Disposable{constructor(n,i){super(),this.c=n,this.b=new A.ResourceMap,this.B(i(f=>this.setLevel(f)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,i,f){let k=this.b.get(n)?.logger;return k||(f=i?.always?L.Trace:f,k=this.f(n,f??this.c,i),this.b.set(n,{logger:k,logLevel:f})),k}setLevel(n,i){const f=T.URI.isUri(n)?n:void 0,k=f?i:n;if(f){const R=this.b.get(f);R&&R.logLevel!==k&&(R.logLevel=k,R.logger.setLevel(k))}else this.c=k,this.b.forEach(({logLevel:R,logger:B})=>{R===void 0&&B.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=g;class w{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return L.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogger=w;class s extends w{}e.NullLogService=s;class r extends g{constructor(){super(L.Info,t.Event.None)}f(n,i,f){return new w}}e.NullLoggerService=r;function l(a){if(a.verbose)return L.Trace;if(typeof a.logLevel=="string"){const n=o(a.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function u(a){switch(a){case L.Trace:return"trace";case L.Debug:return"debug";case L.Info:return"info";case L.Warning:return"warn";case L.Error:return"error";case L.Off:return"off"}}e.LogLevelToString=u;function o(a){switch(a){case"trace":return L.Trace;case"debug":return L.Debug;case"info":return L.Info;case"warn":return L.Warning;case"error":return L.Error;case"critical":return L.Error;case"off":return L.Off}}e.parseLogLevel=o}),define(Se[198],ye([1,0,38,13]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var I;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(I||(I={}));async function A(y,L,P,E,D){try{const v=await new Promise((m,h)=>{ne(["spdlog"],m,h)});v.setFlushOn(I.Trace);const d=await v.createAsyncRotatingLogger(y,L,P,E);return D?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(v){console.error(v)}return null}function C(y,L,P){switch(L){case t.LogLevel.Trace:y.trace(P);break;case t.LogLevel.Debug:y.debug(P);break;case t.LogLevel.Info:y.info(P);break;case t.LogLevel.Warning:y.warn(P);break;case t.LogLevel.Error:y.error(P);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function T(y,L){switch(L){case t.LogLevel.Trace:y.setLevel(I.Trace);break;case t.LogLevel.Debug:y.setLevel(I.Debug);break;case t.LogLevel.Info:y.setLevel(I.Info);break;case t.LogLevel.Warning:y.setLevel(I.Warning);break;case t.LogLevel.Error:y.setLevel(I.Error);break;case t.LogLevel.Off:y.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class S extends t.AbstractMessageLogger{constructor(L,P,E,D,v){super(),this.k=[],this.setLevel(v),this.l=this.n(L,P,E,D),this.B(this.onDidChangeLogLevel(d=>{this.m&&T(this.m,d)}))}async n(L,P,E,D){const v=E?6:1,d=30/v*c.ByteSize.MB,m=await A(L,P,d,v,D);if(m){this.m=m,T(this.m,this.getLevel());for(const{level:h,message:b}of this.k)C(this.m,h,b);this.k=[]}}g(L,P){this.m?C(this.m,L,P):this.getLevel()<=L&&this.k.push({level:L,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=S}),define(Se[122],ye([1,0,42,171,3]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function y(v,d){return d-v}S.compare=y;const L=Object.create(null);L[S.Error]=(0,t.localize)(0,null),L[S.Warning]=(0,t.localize)(1,null),L[S.Info]=(0,t.localize)(2,null);function P(v){return L[v]||""}S.toString=P;function E(v){switch(v){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=E;function D(v){switch(v){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=D}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(S){const y="";function L(E){return P(E,!0)}S.makeKey=L;function P(E,D){const v=[y];return E.source?v.push(E.source.replace("\xA6","\\\xA6")):v.push(y),E.code?typeof E.code=="string"?v.push(E.code.replace("\xA6","\\\xA6")):v.push(E.code.value.replace("\xA6","\\\xA6")):v.push(y),E.severity!==void 0&&E.severity!==null?v.push(C.toString(E.severity)):v.push(y),E.message&&D?v.push(E.message.replace("\xA6","\\\xA6")):v.push(y),E.startLineNumber!==void 0&&E.startLineNumber!==null?v.push(E.startLineNumber.toString()):v.push(y),E.startColumn!==void 0&&E.startColumn!==null?v.push(E.startColumn.toString()):v.push(y),E.endLineNumber!==void 0&&E.endLineNumber!==null?v.push(E.endLineNumber.toString()):v.push(y),E.endColumn!==void 0&&E.endColumn!==null?v.push(E.endColumn.toString()):v.push(y),v.push(y),v.join("\xA6")}S.makeKeyOptionalMessage=P})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(Se[199],ye([1,0,4,42,3]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(y){y[y.OFF=0]="OFF",y[y.SILENT=1]="SILENT",y[y.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=T;class S{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=S}),define(Se[123],ye([1,0,8,2,3]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,I.createDecorator)("openerService");function A(y,L){return t.URI.isUri(y)?(0,c.equalsIgnoreCase)(y.scheme,L):(0,c.startsWithIgnoreCase)(y,L+":")}e.matchesScheme=A;function C(y,...L){return L.some(P=>A(y,P))}e.matchesSomeScheme=C;function T(y,L){return y.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=T;function S(y){let L;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(y.fragment);return P&&(L={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},y=y.with({fragment:""})),{selection:L,uri:y}}e.extractSelection=S}),define(Se[200],ye([1,0,12,36]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.context<"u"){const A=c.globals.vscode.context.configuration();if(A)I=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(I=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`,serverDataFolderName:I.serverDataFolderName?`${I.serverDataFolderName}-dev`:void 0}),!I.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(I,{version:A.version})}}else I={},Object.keys(I).length===0&&Object.assign(I,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=I}),define(Se[201],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var He=this&&this.__param||function(ne,e){return function(c,t){e(c,t,ne)}};define(Se[124],ye([1,0,18,21,6,3]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var C;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}e.Progress=T,T.None=Object.freeze({report(){}});let S=class extends I.Disposable{constructor(P,E){super(),this.a=new c.DeferredPromise,E.withProgress(P,D=>(this.b=D,this.c&&D.report(this.c),this.a.p)),this.B((0,I.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};S=qe([He(1,e.IProgressService)],S),e.UnmanagedProgress=S;class y extends I.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new I.DisposableStore)}start(P){this.stop();const E=++this.a,D=new t.CancellationTokenSource;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,I.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,I.toDisposable)(()=>D.cancel())),this.b.add((0,I.toDisposable)(()=>this.c?this.c.done():void 0)),{id:E,token:D.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=y,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Se[43],ye([1,0,49,11]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.a=new Map}add(C,T){c.ok(t.isString(C)),c.ok(t.isObject(T)),c.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,T)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new I}),define(Se[125],ye([1,0,4,43]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class A{constructor(){this.b=new c.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,y){this.a[I(S)]=y,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const C=new A;t.Registry.add(e.Extensions.JSONContribution,C)}),define(Se[126],ye([1,0,17,4,11,166,52,125,43]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=S.Registry.as(T.Extensions.JSONContribution);class E{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const l=this.k(s,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:l})}deregisterConfigurations(s){const r=this.l(s);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:s,remove:r}){const l=[];l.push(...this.l(r)),l.push(...this.k(s,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,c.distinct)(l)})}registerDefaultConfigurations(s){const r=[],l=[];for(const{overrides:u,source:o}of s)for(const a in u)if(r.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const n=this.a.get(a),i=n?.valuesSources??new Map;if(o)for(const B of Object.keys(u[a]))i.set(B,o);const f={...n?.value||{},...u[a]};this.a.set(a,{source:o,value:f,valuesSources:i});const k=(0,C.getLanguageTagSettingPlainKey)(a),R={type:"object",default:f,description:A.localize(1,null,k),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:I.isString(o)?void 0:o,defaultValueSource:o};l.push(...d(a)),this.d[a]=R,this.b.properties[a]=R}else{this.a.set(a,{value:u[a],source:o});const n=this.d[a];n&&(this.s(a,n),this.o(a,n))}this.registerOverrideIdentifiers(l),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const r=[];for(const{overrides:l,source:u}of s)for(const o in l){const a=this.a.get(o),n=I.isString(u)?u:u?.id,i=I.isString(a?.source)?a?.source:a?.source?.id;if(n===i)if(r.push(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const f=this.d[o];f&&(this.s(o,f),this.o(o,f))}}this.q(),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){for(const r of s)this.h.add(r);this.q()}k(s,r){const l=[];return s.forEach(u=>{l.push(...this.m(u,r,u.extensionInfo,u.restrictedProperties)),this.c.push(u),this.n(u)}),l}l(s){const r=[],l=u=>{if(u.properties)for(const o in u.properties){r.push(o);const a=this.d[o];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[o],this.p(o,u.properties[o])}u.allOf?.forEach(o=>l(o))};for(const u of s){l(u);const o=this.c.indexOf(u);o!==-1&&this.c.splice(o,1)}return r}m(s,r=!0,l,u,o=3){o=I.isUndefinedOrNull(s.scope)?o:s.scope;const a=[],n=s.properties;if(n)for(const f in n){const k=n[f];if(r&&p(f,k)){delete n[f];continue}if(k.source=l,k.defaultDefaultValue=n[f].default,this.s(f,k),e.OVERRIDE_PROPERTY_REGEX.test(f)?k.scope=void 0:(k.scope=I.isUndefinedOrNull(k.scope)?o:k.scope,k.restricted=I.isUndefinedOrNull(k.restricted)?!!u?.includes(f):k.restricted),n[f].hasOwnProperty("included")&&!n[f].included){this.f[f]=n[f],delete n[f];continue}else this.d[f]=n[f],n[f].policy?.name&&this.e.set(n[f].policy.name,f);!n[f].deprecationMessage&&n[f].markdownDeprecationMessage&&(n[f].deprecationMessage=n[f].markdownDeprecationMessage),a.push(f)}const i=s.allOf;if(i)for(const f of i)a.push(...this.m(f,r,l,u,o));return a}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(s){const r=l=>{const u=l.properties;if(u)for(const a in u)this.o(a,u[a]);l.allOf?.forEach(r)};r(s)}o(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.g.properties[s]=r;break}}p(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.g.properties[s];break}}q(){for(const s of this.h.values()){const r=`[${s}]`,l={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(r,l),e.allSettings.properties[r]=l,e.applicationSettings.properties[r]=l,e.machineSettings.properties[r]=l,e.machineOverridableSettings.properties[r]=l,e.windowSettings.properties[r]=l,e.resourceSettings.properties[r]=l}this.i.fire()}r(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this.i.fire()}s(s,r){const l=this.a.get(s);let u=l?.value,o=l?.source;I.isUndefined(u)&&(u=r.defaultDefaultValue,o=void 0),I.isUndefined(u)&&(u=h(r.type)),r.default=u,r.defaultValueSource=o}}const D="\\[([^\\]]+)\\]",v=new RegExp(D,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${D})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(w){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let r=v.exec(w);for(;r?.length;){const l=r[1].trim();l&&s.push(l),r=v.exec(w)}}return(0,c.distinct)(s)}e.overrideIdentifiersFromKey=d;function m(w){return w.reduce((s,r)=>`${s}[${r}]`,"")}e.keyFromOverrideIdentifiers=m;function h(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const b=new E;S.Registry.add(e.Extensions.Configuration,b);function p(w,s){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?A.localize(7,null,w):b.getConfigurationProperties()[w]!==void 0?A.localize(8,null,w):s.policy?.name&&b.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,w,s.policy?.name,b.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.validateProperty=p;function g(){const w=[],s=b.getConfigurationProperties();for(const r of Object.keys(s))w.push([r,s[r].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=g}),define(Se[202],ye([1,0,17,4,146,6,28,23,11,2,52,126,43]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class D{constructor(r={},l=[],u=[],o){this.c=r,this.d=l,this.f=u,this.raw=o,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(l=>{if(l instanceof D)return l;const u=new v("");return u.parseRaw(l),u.configurationModel});this.g=r.reduce((l,u)=>u===l?u:l.merge(u),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,L.getConfigurationValue)(this.contents,r):this.contents}inspect(r,l){const u=this.rawConfiguration.getValue(r),o=l?this.rawConfiguration.getOverrideValue(r,l):void 0,a=l?this.rawConfiguration.override(l).getValue(r):u;return{value:u,override:o,merged:a}}getOverrideValue(r,l){const u=this.l(l);return u?r?(0,L.getConfigurationValue)(u,r):u:void 0}getKeysForOverrideIdentifier(r){const l=[];for(const u of this.overrides)u.identifiers.includes(r)&&l.push(...u.keys);return c.distinct(l)}getAllOverrideIdentifiers(){const r=[];for(const l of this.overrides)r.push(...l.identifiers);return c.distinct(r)}override(r){let l=this.b.get(r);return l||(l=this.h(r),this.b.set(r,l)),l}merge(...r){const l=T.deepClone(this.contents),u=T.deepClone(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const n of r)if(a.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(l,n.contents);for(const i of n.overrides){const[f]=u.filter(k=>c.equals(k.identifiers,i.identifiers));f?(this.j(f.contents,i.contents),f.keys.push(...i.keys),f.keys=c.distinct(f.keys)):u.push(T.deepClone(i))}for(const i of n.keys)o.indexOf(i)===-1&&o.push(i)}return new D(l,o,u,a.every(n=>n instanceof D)?void 0:a)}freeze(){return this.a=!0,this}clone(){return new D(T.deepClone(this.contents),[...this.keys],T.deepClone(this.overrides))}h(r){const l=this.l(r);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const u={};for(const o of c.distinct([...Object.keys(this.contents),...Object.keys(l)])){let a=this.contents[o];const n=l[o];n&&(typeof a=="object"&&typeof n=="object"?(a=T.deepClone(a),this.j(a,n)):a=n),u[o]=a}return new D(u,this.keys,this.overrides)}j(r,l){for(const u of Object.keys(l)){if(u in r&&S.isObject(r[u])&&S.isObject(l[u])){this.j(r[u],l[u]);continue}r[u]=T.deepClone(l[u])}}k(r){return this.a&&!Object.isFrozen(r)?T.deepFreeze(r):r}l(r){let l=null,u=null;const o=a=>{a&&(u?this.j(u,a):u=T.deepClone(a))};for(const a of this.overrides)c.equals(a.identifiers,[r])?l=a.contents:a.identifiers.includes(r)&&o(a.contents);return o(l),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,l){this.m(r),(0,L.addToValueTree)(this.contents,r,l,u=>{throw new Error(u)})}removeValue(r){this.n(r)&&(0,L.removeFromValueTree)(this.contents,r)}m(r){let l=this.keys.length;for(let u=0;u<l;u++)r.indexOf(this.keys[u])===0&&(l=u);this.keys.splice(l,1,r)}n(r){const l=this.keys.indexOf(r);return l!==-1?(this.keys.splice(l,1),!0):!1}}e.ConfigurationModel=D;class v{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,l){if(!S.isUndefinedOrNull(r)){const u=this.g(r);this.parseRaw(u,l)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,l){this.a=r;const{contents:u,keys:o,overrides:a,restricted:n,hasExcludedProperties:i}=this.h(r,l);this.b=new D(u,o,a,i?[r]:void 0),this.c=n||[]}g(r){let l={},u=null,o=[];const a=[],n=[];function i(k){Array.isArray(o)?o.push(k):u!==null&&(o[u]=k)}const f={onObjectBegin:()=>{const k={};i(k),a.push(o),o=k,u=null},onObjectProperty:k=>{u=k},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const k=[];i(k),a.push(o),o=k,u=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:i,onError:(k,R,B)=>{n.push({error:k,offset:R,length:B})}};if(r)try{I.visit(r,f),l=o[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return l}h(r,l){const u=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),o=this.j(r,u,!0,l);r=o.raw;const a=(0,L.toValuesTree)(r,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),n=Object.keys(r),i=this.l(r,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:a,keys:n,overrides:i,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(r,l,u,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:a};const n={},i=[];for(const f in r)if(P.OVERRIDE_PROPERTY_REGEX.test(f)&&u){const k=this.j(r[f],l,!1,o);n[f]=k.raw,a=a||k.hasExcludedProperties,i.push(...k.restricted)}else{const k=l[f],R=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&i.push(f),(R===void 0||o.scopes===void 0||o.scopes.includes(R))&&!(o.skipRestricted&&k?.restricted)?n[f]=r[f]:a=!0}return{raw:n,restricted:i,hasExcludedProperties:a}}l(r,l){const u=[];for(const o of Object.keys(r))if(P.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const n in r[o])a[n]=r[o][n];u.push({identifiers:(0,P.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,L.toValuesTree)(a,l)})}return u}}e.ConfigurationModelParser=v;class d extends A.Disposable{constructor(r,l,u,o){super(),this.f=r,this.g=l,this.h=o,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(u.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&u.isEqual(a.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new D}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class m{constructor(r,l,u,o,a,n,i,f,k,R,B,X,q){this.a=r,this.b=l,this.value=u,this.overrideIdentifiers=o,this.c=a,this.d=n,this.f=i,this.g=f,this.h=k,this.j=R,this.k=B,this.l=X,this.m=q}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class h{constructor(r,l,u,o,a=new D,n=new D,i=new C.ResourceMap,f=new D,k=new C.ResourceMap,R=!0){this.c=r,this.d=l,this.f=u,this.g=o,this.h=a,this.j=n,this.l=i,this.m=f,this.n=k,this.p=R,this.a=null,this.b=new C.ResourceMap,this.q=null}getValue(r,l,u){return this.s(r,l,u).getValue(r)}updateValue(r,l,u={}){let o;u.resource?(o=this.n.get(u.resource),o||(o=new D,this.n.set(u.resource,o))):o=this.m,l===void 0?o.removeValue(r):o.setValue(r,l),u.resource||(this.a=null)}inspect(r,l,u){const o=this.s(r,l,u),a=this.w(l.resource,u),n=l.resource?this.n.get(l.resource)||this.m:this.m,i=new Set;for(const f of o.overrides)for(const k of f.identifiers)o.getOverrideValue(r,k)!==void 0&&i.add(k);return new m(r,l,o.getValue(r),i.size?[...i]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),u?this.j.freeze():void 0,a?a.freeze():void 0,n.inspect(r,l.overrideIdentifier))}keys(r){const l=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:l?l.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,l){this.l.set(r,l),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,l){const u=[];if(!l){const{added:o,updated:a,removed:n}=g(this.c,r);l=[...o,...a,...n]}for(const o of l)for(const a of(0,P.overrideIdentifiersFromKey)(o)){const n=this.c.getKeysForOverrideIdentifier(a),i=r.getKeysForOverrideIdentifier(a),f=[...i.filter(k=>n.indexOf(k)===-1),...n.filter(k=>i.indexOf(k)===-1),...n.filter(k=>!T.equals(this.c.override(a).getValue(k),r.override(a).getValue(k)))];u.push([a,f])}return this.updateDefaultConfiguration(r),{keys:l,overrides:u}}compareAndUpdatePolicyConfiguration(r){const{added:l,updated:u,removed:o}=g(this.d,r),a=[...l,...u,...o];return a.length&&this.updatePolicyConfiguration(r),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:l,updated:u,removed:o,overrides:a}=g(this.applicationConfiguration,r),n=[...l,...u,...o];return n.length&&this.updateApplicationConfiguration(r),{keys:n,overrides:a}}compareAndUpdateLocalUserConfiguration(r){const{added:l,updated:u,removed:o,overrides:a}=g(this.localUserConfiguration,r),n=[...l,...u,...o];return n.length&&this.updateLocalUserConfiguration(r),{keys:n,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:l,updated:u,removed:o,overrides:a}=g(this.remoteUserConfiguration,r),n=[...l,...u,...o];return n.length&&this.updateRemoteUserConfiguration(r),{keys:n,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:l,updated:u,removed:o,overrides:a}=g(this.workspaceConfiguration,r),n=[...l,...u,...o];return n.length&&this.updateWorkspaceConfiguration(r),{keys:n,overrides:a}}compareAndUpdateFolderConfiguration(r,l){const u=this.r.get(r),{added:o,updated:a,removed:n,overrides:i}=g(u,l),f=[...o,...a,...n];return(f.length||!u)&&this.updateFolderConfiguration(r,l),{keys:f,overrides:i}}compareAndDeleteFolderConfiguration(r){const l=this.r.get(r);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:u,updated:o,removed:a,overrides:n}=g(l,void 0);return{keys:[...u,...o,...a],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,l,u){let o=this.t(l,u);return l.overrideIdentifier&&(o=o.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(o=o.merge(this.d)),o}t({resource:r},l){let u=this.u();if(l&&r){const o=l.getFolder(r);o&&(u=this.v(o.uri)||u);const a=this.n.get(r);a&&(u=u.merge(a))}return u}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let l=this.b.get(r);if(!l){const u=this.u(),o=this.l.get(r);o?(l=u.merge(o),this.p&&(l=l.freeze()),this.b.set(r,l)):l=u}return l}w(r,l){if(l&&r){const u=l.getFolder(r);if(u)return this.l.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,l)=>{const{contents:u,overrides:o,keys:a}=this.l.get(l);return r.push([l,{contents:u,overrides:o,keys:a}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(l=>r.add(l)),this.userConfiguration.freeze().keys.forEach(l=>r.add(l)),this.j.freeze().keys.forEach(l=>r.add(l)),this.l.forEach(l=>l.freeze().keys.forEach(u=>r.add(u))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(l=>r.add(l)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(l=>r.add(l)),this.j.freeze().getAllOverrideIdentifiers().forEach(l=>r.add(l)),this.l.forEach(l=>l.freeze().getAllOverrideIdentifiers().forEach(u=>r.add(u))),[...r.values()]}y(r){const l=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(u=>l.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(u=>l.add(u)),this.j.getKeysForOverrideIdentifier(r).forEach(u=>l.add(u)),this.l.forEach(u=>u.getKeysForOverrideIdentifier(r).forEach(o=>l.add(o))),[...l.values()]}static parse(r){const l=this.z(r.defaults),u=this.z(r.policy),o=this.z(r.application),a=this.z(r.user),n=this.z(r.workspace),i=r.folders.reduce((f,k)=>(f.set(y.URI.revive(k[0]),this.z(k[1])),f),new C.ResourceMap);return new h(l,u,o,a,new D,n,i,new D,new C.ResourceMap,!1)}static z(r){return new D(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=h;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,l=new Map;for(const o of s)o.keys.forEach(a=>r.add(a)),o.overrides.forEach(([a,n])=>{const i=(0,C.getOrSet)(l,a,new Set);n.forEach(f=>i.add(f))});const u=[];return l.forEach((o,a)=>u.push([a,[...o.values()]])),{keys:[...r.values()],overrides:u}}e.mergeChanges=b;class p{constructor(r,l,u,o){this.change=r,this.b=l,this.c=u,this.d=o,this.f=void 0;const a=new Set;r.keys.forEach(i=>a.add(i)),r.overrides.forEach(([,i])=>i.forEach(f=>a.add(f))),this.affectedKeys=[...a.values()];const n=new D;this.affectedKeys.forEach(i=>n.setValue(i,{})),this.a=n.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=h.parse(this.b.data)),this.f}affectsConfiguration(r,l){if(this.g(this.a,r)){if(l){const u=this.previousConfiguration?this.previousConfiguration.getValue(r,l,this.b?.workspace):void 0,o=this.c.getValue(r,l,this.d);return!T.equals(u,o)}return!0}return!1}g(r,l){let u=(0,L.toValuesTree)({[l]:!0},()=>{}),o;for(;typeof u=="object"&&(o=Object.keys(u)[0]);){if(r=r[o],!r)return!1;u=u[o]}return!0}}e.ConfigurationChangeEvent=p;function g(s,r){const{added:l,removed:u,updated:o}=w(r?.rawConfiguration,s?.rawConfiguration),a=[],n=s?.getAllOverrideIdentifiers()||[],i=r?.getAllOverrideIdentifiers()||[];if(r){const f=i.filter(k=>!n.includes(k));for(const k of f)a.push([k,r.getKeysForOverrideIdentifier(k)])}if(s){const f=n.filter(k=>!i.includes(k));for(const k of f)a.push([k,s.getKeysForOverrideIdentifier(k)])}if(r&&s){for(const f of n)if(i.includes(f)){const k=w({contents:s.getOverrideValue(void 0,f)||{},keys:s.getKeysForOverrideIdentifier(f)},{contents:r.getOverrideValue(void 0,f)||{},keys:r.getKeysForOverrideIdentifier(f)});a.push([f,[...k.added,...k.removed,...k.updated]])}}return{added:l,removed:u,updated:o,overrides:a}}function w(s,r){const l=s?r?s.keys.filter(a=>r.keys.indexOf(a)===-1):[...s.keys]:[],u=r?s?r.keys.filter(a=>s.keys.indexOf(a)===-1):[...r.keys]:[],o=[];if(s&&r){for(const a of r.keys)if(s.keys.indexOf(a)!==-1){const n=(0,L.getConfigurationValue)(r.contents,a),i=(0,L.getConfigurationValue)(s.contents,a);T.equals(n,i)||o.push(a)}}return{added:l,removed:u,updated:o}}}),define(Se[127],ye([1,0,10,3]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var I;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends c.ErrorNoTelemetry{static isNotAvailable(T){return T instanceof A&&T._code===I.NotAvailable}static isTemporarilyNotAvailable(T){return T instanceof A&&T._code===I.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof A&&T._code===I.NoResolverFound}static isHandled(T){return T instanceof A&&T.isHandled}constructor(T,S=I.Unknown,y){super(T),this._message=T,this._code=S,this._detail=y,this.isHandled=S===I.NotAvailable&&y===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(Se[67],ye([1,0,15]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(y){return y.scheme===c.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=t;function I(y){if(!y)return;const L=y.indexOf("+");return L<0?y:y.substr(0,L)}e.getRemoteName=I;function A(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.getRemoteServerRootPath=A;function C(y){const{host:L,port:P}=S(y);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:P}}e.parseAuthorityWithPort=C;function T(y,L){let{host:P,port:E}=S(y);return typeof E>"u"&&(E=L),{host:P,port:E}}e.parseAuthorityWithOptionalPort=T;function S(y){const L=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const P=y.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const E=y.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:y,port:void 0}}}),define(Se[27],ye([1,0,8,3,67]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=A;function C(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var S;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(d){this.value=d,this.c=d.toLowerCase()}static equals(d,m){if(typeof d>"u"||d===null)return typeof m>"u"||m===null;if(typeof m>"u"||m===null)return!1;if(typeof d=="string"||typeof m=="string"){const h=typeof d=="string"?d:d.value,b=typeof m=="string"?m:m.value;return c.equalsIgnoreCase(h,b)}return d.c===m.c}static toKey(d){return typeof d=="string"?d.toLowerCase():d.c}}e.ExtensionIdentifier=y;function L(v){return P(v)}e.isApplicationScopedExtension=L;function P(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function E(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function D(v,d){if(d){const m=`onResolveRemoteAuthority:${(0,I.getRemoteName)(d)}`;return v.activationEvents?.indexOf(m)!==-1}return!1}e.isResolverExtension=D,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Se[203],ye([1,0,8,121,27,12,2,10,36]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function y(r,l){return r.uuid&&l.uuid?r.uuid===l.uuid:r.id===l.id?!0:(0,c.compareIgnoreCase)(r.id,l.id)===0}e.areSameExtensions=y;const L=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{static create(l){const u=l.manifest?l.manifest.version:l.version,o=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new P(l.identifier,u,o)}static parse(l){const u=L.exec(l);return u&&u[1]&&u[2]?new P({id:u[1]},u[2],u[4]||void 0):null}constructor(l,u,o="undefined"){this.version=u,this.targetPlatform=o,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof P?y(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=P;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(r){const l=E.exec(r);return l&&l[1]?[d(l[1]),l[2]]:[d(r),void 0]}e.getIdAndVersion=D;function v(r,l){return`${r}.${l}`}e.getExtensionId=v;function d(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function m(r,l){return d(v(r,l))}e.getGalleryExtensionId=m;function h(r,l){const u=[],o=a=>{for(const n of u)if(n.some(i=>y(l(i),l(a))))return n;return null};for(const a of r){const n=o(a);n?n.push(a):u.push([a])}return u}e.groupByExtension=h;function b(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function p(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function g(r,l){const u=[],o=l.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&u.every(n=>!y(n.identifier,{id:a}))){const n=r.filter(i=>y(i.identifier,{id:a}));n.length===1&&(u.push(n[0]),o.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.getExtensionDependencies=g;async function w(r,l){if(!A.isLinux)return!1;let u;try{u=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){l.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(a))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=w;async function s(r,l){const u=await w(r,l),o=(0,t.getTargetPlatform)(u?"alpine":A.platform,S.arch);return l.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(Se[204],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c{constructor(){this.b=new Map}c(){return new Promise((I,A)=>ne(["vsda"],I,A))}async createNewMessage(I){try{const A=await this.c(),C=new A.validator;if(C){const T=String(c.a++);return this.b.set(T,C),{id:T,data:C.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,A){if(!I.id)return!0;const C=this.b.get(I.id);if(!C)return!1;this.b.delete(I.id);try{return C.validate(A)==="ok"}catch{return!1}}async sign(I){try{const A=await this.c(),C=new A.signer;if(C)return C.sign(I)}catch{}return I}}e.SignService=c,c.a=1}),define(Se[205],ye([1,0,12,36,2,30]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(y){if(c.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function T(y,L,P,E,D,v,d,m,h,b){const p=Object.create(null);p["common.machineId"]=d,p.sessionID=(0,A.generateUuid)()+Date.now(),p.commitHash=D,p.version=v,p["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,c.PlatformToString)(c.platform),p["common.nodePlatform"]=t.platform,p["common.nodeArch"]=E,p["common.product"]=b||"desktop",m&&(p["common.msftInternal"]=m);let g=0;const w=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),c.isLinuxSnap&&(p["common.snap"]="true");const s=C(P);s&&(p["common.platformDetail"]=s);try{const r=await y.readFile(I.URI.file(h));p["common.source"]=r.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=T;function S(y){const L=t.env.USERDNSDOMAIN;if(!L)return!1;const P=L.toLowerCase();return y.some(E=>P===E)}e.verifyMicrosoftInternalDomain=S}),define(Se[206],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var I;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(I=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Se[128],ye([1,0,23,11,52,67,205,206]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class S{constructor(a){this.value=a}}e.TrustedTelemetryValue=S;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,n){return Promise.resolve(void 0)}publicLog2(a,n){return this.publicLog(a,n)}publicLogError(a,n){return Promise.resolve(void 0)}publicLogError2(a,n){return this.publicLogError(a,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class L{async publicLog(a,n,i){}async publicLogError(a,n,i){}}e.NullEndpointTelemetryService=L,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(o,a){return a.onDidChangeConfiguration(n=>{n.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,I.ConfigurationTargetToString)(n.source),configurationKeys:p(n.sourceConfig)})})}e.configurationTelemetry=P;function E(o,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!o.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=E;function D(o,a){return!(a.isBuilt||a.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=D;function v(o){const a=o.getValue(T.TELEMETRY_SETTING_ID),n=o.getValue("telemetry.enableCrashReporter");if(o.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function d(o){const a={},n={},i={};b(o,i);for(let f in i){f=f.length>150?f.substr(f.length-149):f;const k=i[f];typeof k=="number"?n[f]=k:typeof k=="boolean"?n[f]=k?1:0:typeof k=="string"?(k.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${k.length}`),a[f]=k.substring(0,8191)):typeof k<"u"&&k!==null&&(a[f]=k)}return{properties:a,measurements:n}}e.validateTelemetryData=d;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function h(o){if(!o)return"none";const a=(0,A.getRemoteName)(o);return m.has(a)?a:"other"}e.cleanRemoteAuthority=h;function b(o,a,n=0,i){if(!!o)for(const f of Object.getOwnPropertyNames(o)){const k=o[f],R=i?i+f:f;Array.isArray(k)?a[R]=(0,c.safeStringify)(k):k instanceof Date?a[R]=k.toISOString():(0,t.isObject)(k)?n<2?b(k,a,n+1,R+"."):a[R]=(0,c.safeStringify)(k):a[R]=k}}function p(o){if(!o)return[];const a=[];return g(a,"",o),a}function g(o,a,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(i=>g(o,a?`${a}.${i}`:i,n[i])):o.push(a)}function w(o,a){const n=o.msftInternalDomains||[],i=a.getValue("telemetry.internalTesting");return(0,C.verifyMicrosoftInternalDomain)(n)||i}e.isInternalTelemetry=w;function s(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=s;function r(o,a){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let n=o;const i=[];for(const B of a)for(;;){const X=B.exec(o);if(!X)break;i.push([X.index,B.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,k=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let R=0;for(n="";;){const B=k.exec(o);if(!B)break;const X=i.some(([q,N])=>B.index<N&&q<k.lastIndex);!f.test(B[0])&&!X&&(n+=o.substring(R,B.index)+"<REDACTED: user-file-path>",R=k.lastIndex)}return R<o.length&&(n+=o.substr(R)),n}function l(o){if(!o)return o;const a=o.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const i of n)if(i.regex.test(a))return`<REDACTED: ${i.label}>`;return o}function u(o,a){return(0,c.cloneAndChange)(o,n=>{if(n instanceof S)return n.value;if(typeof n=="string"){let i=n.replaceAll("%20"," ");i=r(i,a);for(const f of a)i=i.replace(f,"");return i=l(i),i}})}e.cleanData=u}),define(Se[207],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,A,C=5){const T=A(S=>{const y=typeof S=="string"?S:S.data;let L=this.a.get(I);if(L){L.data.push(y);return}const P=setTimeout(()=>this.flushBuffer(I),C);L={data:[y],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(I),T.dispose()}},this.a.set(I,L)});return T}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const A=this.a.get(I);A&&(this.a.delete(I),this.b(I,A.data.join("")))}}e.TerminalDataBufferer=c}),define(Se[208],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var c;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(c=e.ColorScheme||(e.ColorScheme={}));function t(A){return A===c.HIGH_CONTRAST_DARK||A===c.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function I(A){return A===c.DARK||A===c.HIGH_CONTRAST_DARK}e.isDark=I}),define(Se[89],ye([1,0,79,4,6,3,43,208]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(m){function h(b){return b&&typeof b=="object"&&typeof b.id=="string"}m.isThemeColor=h})(S=e.ThemeColor||(e.ThemeColor={}));function y(m){return{id:m}}e.themeColorFromId=y;var L;(function(m){function h(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||S.isThemeColor(u.color))}m.isThemeIcon=h;const b=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function p(u){const o=b.exec(u);if(!o)return;const[,a]=o;return{id:a}}m.fromString=p;function g(u){return{id:u}}m.fromId=g;function w(u,o){let a=u.id;const n=a.lastIndexOf("~");return n!==-1&&(a=a.substring(0,n)),o&&(a=`${a}~${o}`),{id:a}}m.modify=w;function s(u){const o=u.id.lastIndexOf("~");if(o!==-1)return u.id.substring(o+1)}m.getModifier=s;function r(u,o){return u.id===o.id&&u.color?.id===o.color?.id}m.isEqual=r;function l(u,o){return{id:u.id,color:o?y(o):void 0}}m.asThemeIcon=l,m.asClassNameArray=c.CSSIcon.asClassNameArray,m.asClassName=c.CSSIcon.asClassName,m.asCSSSelector=c.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function P(m){switch(m){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case T.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(h){return this.a.push(h),this.b.fire(h),(0,I.toDisposable)(()=>{const b=this.a.indexOf(h);this.a.splice(b,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const D=new E;C.Registry.add(e.Extensions.ThemingContribution,D);function v(m){return D.onColorThemeChange(m)}e.registerThemingParticipant=v;class d extends I.Disposable{constructor(h){super(),this.k=h,this.h=h.getColorTheme(),this.B(this.k.onDidColorThemeChange(b=>this.n(b)))}n(h){this.h=h,this.updateStyles()}updateStyles(){}w(h,b){let p=this.h.getColor(h);return p&&b&&(p=b(p,this.h)),p?p.toString():null}}e.Themable=d}),define(Se[129],ye([1,0,4,52,3,13]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var C;(function(d){d.Http="http",d.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=P;function E(d,m,h,b){if(h===1)return!1;if(h===2&&P(m)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(p?.length===4&&parseInt(p[1])>=18)return!1}return d<1024}e.isPortPrivileged=E;class D{constructor(m,h,b){this.remoteAddress=m,this.localAddress=h,this.b=b,this.a=new c.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=D;let v=class{constructor(m,h){this.i=m,this.j=h,this.a=new c.Emitter,this.onTunnelOpened=this.a.event,this.b=new c.Emitter,this.onTunnelClosed=this.b.event,this.c=new c.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const m=this.j.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this.e=m,m?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this.f=m.elevation,this.g=m.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const m=[],h=Array.from(this.d.values());for(const b of h){const p=Array.from(b.values());for(const g of p){const w=await g.value;w&&m.push(w)}}return m}async dispose(){for(const m of this.d.values()){for(const{value:h}of m.values())await h.then(b=>b?.dispose());m.clear()}this.d.clear()}setEnvironmentTunnel(m,h,b,p,g){this.o(m,h,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:h,localAddress:b,privacy:p,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,h){(P(m)||L(m))&&(m=e.LOCALHOST_ADDRESSES[0]);const b=this.q(m,h);if(b)return++b.refcount,b.value}openTunnel(m,h,b,p,g=!1,w,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${b} on local port ${p}.`),!m)return;if(h||(h="localhost"),this.e&&this.h.has(b)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(m,h,b,p,g,w,s);return r?r.then(l=>{if(!l){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,b);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.m(l);return(l.tunnelRemoteHost!==h||l.tunnelRemotePort!==b)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(u),u}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const h=this.d.get(m.tunnelRemoteHost);if(h){const b=h.get(m.tunnelRemotePort);b&&(b.refcount--,await this.n(m.tunnelRemoteHost,m.tunnelRemotePort,b))}}}}async n(m,h,b){if(b.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${h}.`);const p=b.value.then(async g=>{g&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.d.has(m)&&this.d.get(m).delete(h),p}}async closeTunnel(m,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${h} `);const b=this.d.get(m);if(b&&b.has(h)){const p=b.get(h);p.refcount=0,await this.n(m,h,p)}}o(m,h,b){this.d.has(m)||this.d.set(m,new Map),this.d.get(m).set(h,{refcount:1,value:b})}async p(m,h){const b=this.d.get(m);b&&(await b.get(h)||b.delete(h),b.size===0&&this.d.delete(m))}q(m,h){const b=[m];L(m)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):P(m)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const p=b.map(g=>this.d.get(g));for(const g of p){const w=g?.get(h);if(w)return w}}canTunnel(m){return!!y(m)}s(m,h,b,p,g,w,s){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${b} on local port ${p}.`);const r=b;this.h.add(r);const l=p===void 0?b:p,u={elevationRequired:g?this.isPortPrivileged(l):!1},o={remoteAddress:{host:h,port:b},localAddressPort:p,privacy:w,public:w?w!==T.Private:void 0,protocol:s},a=m.forwardPort(o,u);return a?(this.o(h,b,a),a.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),a}};v=qe([He(0,A.ILogService),He(1,t.IConfigurationService)],v),e.AbstractTunnelService=v}),define(Se[209],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var t;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Se[210],ye([1,0,15]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(S){return S.scheme!==c.Schemas.file&&S.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=t;function I(S){if(S.folders.length)return S.folders.every(y=>t(y.uri))?S.folders[0].uri:void 0;if(S.configuration&&t(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=I;function A(S){return I(S)?.scheme}e.getVirtualWorkspaceScheme=A;function C(S){return I(S)?.authority}e.getVirtualWorkspaceAuthority=C;function T(S){return I(S)!==void 0}e.isVirtualWorkspace=T}),define(Se[46],ye([1,0,172,9,64,24,2,3,15]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function y(r){const l=r;return typeof l?.id=="string"&&C.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=y,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function L(r,l){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,t.basename)(r)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const u=r;if(u.configuration)return{id:u.id,configPath:u.configuration};if(u.folders.length===1)return{id:u.id,uri:u.folders[0].uri}}e.toWorkspaceIdentifier=L;function P(r){const l=r;return typeof l?.id=="string"&&C.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=P;function E(r){const l=r;if(l?.uri)return{id:l.id,uri:C.URI.revive(l.uri)};const u=r;if(u?.configPath)return{id:u.id,configPath:C.URI.revive(u.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=E;var D;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function v(r){const l=r;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=v;function d(r){const l=r;return!!(l&&typeof l=="object"&&C.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=d;class m{constructor(l,u,o,a,n){this.h=l,this.j=o,this.k=a,this.l=n,this.c=I.TernarySearchTree.forUris(this.l,()=>!0),this.folders=u}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=I.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class h{constructor(l,u){this.raw=u,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,A.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function b(r){return new h({uri:r,index:0,name:(0,A.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(r,l){return A.extUriBiasedIgnorePathCase.isEqualOrParent(r,l.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function g(r){let l;return C.URI.isUri(r)?l=r:l=r.configuration,l?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=g;function w(r,l){return!p(r,l)&&!g(r)}e.isSavedWorkspace=w;function s(r){return(typeof r=="string"?(0,t.extname)(r):(0,A.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Se[68],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const A=this.c++;return this.b.set(A,I),this.e(),A}get(I,A){return this.b.has(I)?this.b.get(I)[A]:void 0}delete(I){this.b.delete(I),this.e()}e(){!c.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=c,c.a=!1}),define(Se[47],ye([1,0,15,24,3]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this.a=new Set(Object.keys(c.Schemas)),this.b=new Map,this.extUri=new t.ExtUri(T=>{const S=this.b.get(T.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(T,S){S===null?this.b.delete(T.scheme):this.b.set(T.scheme,S)}isFreeScheme(T){return!this.b.has(T)&&!this.a.has(T)}getCapabilities(T){return this.b.get(T)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(Se[25],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(Se[211],ye([1,0,18]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(C,T,S){this.h=new Map,this.a=C,this.b=T,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new c.RunOnceScheduler(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of y.values())L.complete()}catch(L){for(const P of y.values())P.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,T){let S=this.f[C];return typeof S>"u"&&(S=T),S}update(C,T){this.f[C]=T;const S=this.h.get(C);if(S!==void 0)return S.p;const y=new c.DeferredPromise;return this.h.set(C,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.ExtensionMemento=t;class I extends t{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,T){super(C.identifier.value,!0,T),this.j=C}}e.ExtensionGlobalMemento=I}),define(Se[212],ye([1,0,4,2]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class I{constructor(C){this.c=C,this.a=new c.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new c.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,T,S,y){const P=this.c.getNotebookDocument(t.URI.revive(C)).acceptModelChanged(T.value,S,y);this.b.fire(P)}$acceptDirtyStateChanged(C,T){this.c.getNotebookDocument(t.URI.revive(C)).acceptDirty(T)}$acceptModelSaved(C){const T=this.c.getNotebookDocument(t.URI.revive(C));this.a.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=I}),define(Se[16],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class t{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=t});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,c):I?I.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[213],ye([1,0,27,4]),function(ne,e,c,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(T,S){I.set(this,void 0),this.b=new t.Emitter,this.onDidChange=this.b.event,this.a=c.ExtensionIdentifier.toKey(T.identifier),Je(this,I,S,"f"),Me(this,I,"f").onDidChangePassword(y=>{y.extensionId===this.a&&this.b.fire({key:y.key})})}get(T){return Me(this,I,"f").get(this.a,T)}store(T,S){return Me(this,I,"f").store(this.a,T,S)}delete(T){return Me(this,I,"f").delete(this.a,T)}}e.ExtensionSecrets=A,I=new WeakMap}),define(Se[54],ye([1,0,3,129,4,16]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function y(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:P.protocol}}S.fromApiTunnel=y;function L(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==t.TunnelPrivacyId.ConstantPrivate&&P.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}S.fromServiceTunnel=L})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let T=class{constructor(y){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,L){}async getTunnels(){return[]}async setTunnelFactory(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,L){return{dispose:()=>{}}}async $providePortAttributes(y,L,P,E,D){return[]}async $forwardPort(y,L){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=qe([He(0,A.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(Se[55],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class t{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=t}),define(Se[214],ye([1,0,22]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let y=this.buffers.indexOf(S);return y<0&&(y=this.buffers.length,this.buffers.push(S)),y}}function I(T,S){if(S.serializeBuffersForPostMessage){const y=new t,L=(D,v)=>{if(v instanceof ArrayBuffer){const d=y.add(v);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(v)){const d=A(v);if(d){const m=y.add(v.buffer);return{$$vscode_array_buffer_reference$$:!0,index:m,view:{type:d,byteLength:v.byteLength,byteOffset:v.byteOffset}}}}return v},P=JSON.stringify(T,L),E=y.buffers.map(D=>{const v=new Uint8Array(D);return c.VSBuffer.wrap(v)});return{message:P,buffers:E}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=I;function A(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(T,S){const y=S.map(E=>{const D=new ArrayBuffer(E.byteLength);return new Uint8Array(D).set(E.buffer),D}),L=S.length?(E,D)=>{if(D&&typeof D=="object"&&D.$$vscode_array_buffer_reference$$){const v=D,{index:d}=v,m=y[d];if(v.view)switch(v.view.type){case 1:return new Int8Array(m,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return D}:void 0;return{message:JSON.parse(T,L),arrayBuffers:y}}e.deserializeWebviewMessage=C}),define(Se[215],ye([1,0,112]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(A){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:A,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function I(A){return new c.URITransformer(t(A))}e.createURITransformer=I}),define(Se[130],ye([1,0,182,11,2,6,3,43,38,15]),function(ne,e,c,t,I,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var L;(function(x){x[x.PROGRAMMATIC=1]="PROGRAMMATIC",x[x.USER=2]="USER",x[x.EDIT=3]="EDIT",x[x.NAVIGATION=4]="NAVIGATION",x[x.JUMP=5]="JUMP"})(L=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var P;(function(x){x[x.IDENTICAL=1]="IDENTICAL",x[x.SIMILAR=2]="SIMILAR",x[x.DIFFERENT=3]="DIFFERENT"})(P=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(x){const V=x;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}e.isEditorPaneWithSelection=E;function D(x,V,_){for(const Q of _.visibleEditorPanes)if(Q.group.id===V&&x.matches(Q.input))return Q.getViewState()}e.findViewStateForEditor=D;function v(x){if(o(x))return!1;const V=x;return I.URI.isUri(V?.resource)}e.isResourceEditorInput=v;function d(x){if(o(x))return!1;const V=x;return V?.original!==void 0&&V.modified!==void 0}e.isResourceDiffEditorInput=d;function m(x){if(o(x)||d(x))return!1;const V=x;return V?.primary!==void 0&&V.secondary!==void 0}e.isResourceSideBySideEditorInput=m;function h(x){if(o(x))return!1;const V=x;return V?V.resource===void 0||V.resource.scheme===y.Schemas.untitled||V.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=h;const b=/Untitled-\d+/;function p(x){return x.scheme===y.Schemas.untitled&&x.path.length>1&&!b.test(x.path)}e.isUntitledWithAssociatedResource=p;function g(x){if(o(x))return!1;const V=x;return I.URI.isUri(V?.base?.resource)&&I.URI.isUri(V?.input1?.resource)&&I.URI.isUri(V?.input2?.resource)&&I.URI.isUri(V?.result?.resource)}e.isResourceMergeEditorInput=g;var w;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var s;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.a=new Map}registerSource(V,_){let Q=this.a.get(V);return Q||(Q={source:V,label:_},this.a.set(V,Q)),Q.source}getSourceLabel(V){return this.a.get(V)?.label??V}}e.SaveSourceRegistry=new r;var l;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription",x[x.CanDropIntoEditor=128]="CanDropIntoEditor",x[x.MultipleEditors=256]="MultipleEditors"})(l=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class u extends A.Disposable{}e.AbstractEditorInput=u;function o(x){return x instanceof u}e.isEditorInput=o;function a(x){const V=x;return I.URI.isUri(V?.preferredResource)}function n(x){const V=x;return o(V?.primary)&&o(V?.secondary)}e.isSideBySideEditorInput=n;function i(x){const V=x;return o(V?.modified)&&o(V?.original)}e.isDiffEditorInput=i;function f(x){return o(x?.editor)}e.isEditorInputWithOptions=f;function k(x){const V=x;return f(x)&&V?.group!==void 0}e.isEditorInputWithOptionsAndGroup=k;function R(x){const V=x;return typeof V?.groupId=="number"&&o(V.editor)}e.isEditorIdentifier=R;var B;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var X;(function(x){x[x.GROUP_ACTIVE=0]="GROUP_ACTIVE",x[x.GROUP_INDEX=1]="GROUP_INDEX",x[x.GROUP_LOCKED=2]="GROUP_LOCKED",x[x.EDITOR_OPEN=3]="EDITOR_OPEN",x[x.EDITOR_CLOSE=4]="EDITOR_CLOSE",x[x.EDITOR_MOVE=5]="EDITOR_MOVE",x[x.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",x[x.EDITOR_LABEL=7]="EDITOR_LABEL",x[x.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",x[x.EDITOR_PIN=9]="EDITOR_PIN",x[x.EDITOR_STICKY=10]="EDITOR_STICKY",x[x.EDITOR_DIRTY=11]="EDITOR_DIRTY",x[x.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(X=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var q;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(q=e.SideBySideEditor||(e.SideBySideEditor={}));class N{getOriginalUri(V,_){if(!V)return;if(g(V))return e.EditorResourceAccessor.getOriginalUri(V.result,_);if(_?.supportSideBySide){const{primary:J,secondary:te}=this.a(V);if(J&&te){if(_?.supportSideBySide===q.BOTH)return{primary:this.getOriginalUri(J,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(te,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===q.ANY)return this.getOriginalUri(J,{filterByScheme:_.filterByScheme})??this.getOriginalUri(te,{filterByScheme:_.filterByScheme});V=_.supportSideBySide===q.PRIMARY?J:te}}if(d(V)||m(V)||g(V))return;const Q=a(V)?V.preferredResource:V.resource;return!Q||!_||!_.filterByScheme?Q:this.b(Q,_.filterByScheme)}a(V){return n(V)||m(V)?{primary:V.primary,secondary:V.secondary}:i(V)||d(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,_){if(!V)return;if(g(V))return e.EditorResourceAccessor.getCanonicalUri(V.result,_);if(_?.supportSideBySide){const{primary:J,secondary:te}=this.a(V);if(J&&te){if(_?.supportSideBySide===q.BOTH)return{primary:this.getCanonicalUri(J,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(te,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===q.ANY)return this.getCanonicalUri(J,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(te,{filterByScheme:_.filterByScheme});V=_.supportSideBySide===q.PRIMARY?J:te}}if(d(V)||m(V)||g(V))return;const Q=V.resource;return!Q||!_||!_.filterByScheme?Q:this.b(Q,_.filterByScheme)}b(V,_){if(Array.isArray(_)){if(_.some(Q=>V.scheme===Q))return V}else if(_===V.scheme)return V}}e.EditorResourceAccessor=new N;var M;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})(M=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(V){const _=this.a=V.get(C.IInstantiationService);for(const[Q,J]of this.c)this.e(Q,J,_);this.c.clear()}e(V,_,Q){const J=Q.createInstance(_);this.d.set(V,J)}registerFileEditorFactory(V){if(this.b)throw new Error("Can only register one file editor factory.");this.b=V}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(V,_){if(this.c.has(V)||this.d.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.a?this.e(V,_,this.a):this.c.set(V,_),(0,A.toDisposable)(()=>{this.c.delete(V),this.d.delete(V)})}getEditorSerializer(V){return this.d.get(typeof V=="string"?V:V.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new F);async function z(x,V,_){return!x||!x.length?[]:await Promise.all(x.map(async Q=>{const J=I.URI.revive(Q.fileUri);if(!J){_.info("Cannot resolve the path because it is not valid.",Q);return}if(!await V.canHandleResource(J)){_.info("Cannot resolve the path because it cannot be handled",Q);return}let le=Q.exists,Z=Q.type;if(typeof le!="boolean"||typeof Z!="number")try{Z=(await V.stat(J)).isDirectory?S.FileType.Directory:S.FileType.Unknown,le=!0}catch(ve){_.error(ve),le=!1}if(!le&&Q.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",Q);return}if(Z===S.FileType.Directory){_.info("Cannot resolve the path because it is a directory",Q);return}const ge={...Q.options,pinned:!0};return le?{resource:J,options:ge}:{resource:J,options:ge,forceUntitled:!0}}))}e.pathsToEditors=z;var U;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}));function W(x){const V=x;if(!V)return!1;const _=V;if(_.modified)return W(_.modified);const Q=V;return!!(Q.contributionsState&&Q.viewState&&Array.isArray(Q.cursorState))}e.isTextEditorViewState=W}),define(Se[131],ye([1,0,4,18,183]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.f=new Map,this.k=[],this.m=new c.Emitter,this.n=new c.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(T){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=T}onEvent(T){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=T}onRequest(T){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.s("response",T)}sendRequest(T,S,y,L){const P={command:T};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.s("request",P),typeof L=="number"){const E=setTimeout(()=>{clearTimeout(E);const D=this.f.get(P.seq);if(D){this.f.delete(P.seq);const v={type:"response",seq:0,request_seq:P.seq,success:!1,command:T,message:(0,I.localize)(0,null,L,T)};D(v)}},L)}return y&&this.f.set(P.seq,y),P.seq}acceptMessage(T){this.j?this.j(T):(this.k.push(T),this.k.length===1&&this.q())}o(T,S){return T.type!=="event"||S.type!=="event"}async q(){let T;for(;this.k.length;){if((!T||this.o(this.k[0],T))&&await(0,t.timeout)(0),T=this.k.shift(),!T)return;switch(T.type){case"event":this.i?.(T);break;case"request":this.g?.(T);break;case"response":{const S=T,y=this.f.get(S.request_seq);y&&(this.f.delete(S.request_seq),y(S));break}}}}s(T,S){S.type=T,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((S,y)=>T.set(y,S)),await(0,t.timeout)(500),T.forEach((S,y)=>{S({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=A}),define(Se[216],ye([1,0,184,53,3]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new t.RawContextKey("hasDebugged",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(50,null)});const A=E=>c.localize(51,null,E);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(52,null)};var C;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(C=e.State||(e.State={}));function T(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var S;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var y;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(y=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,I.createDecorator)("debugService");var P;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(P=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Se[217],ye([1,0,8,2,9,23,15]),function(ne,e,c,t,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function S(l,u,o){return l.replace(T,function(a,n){return u&&n.length>0&&n[0]!=="_"?a:o&&o.hasOwnProperty(n)?o[n]:a})}e.formatPII=S;function y(l){const u={};for(const o of Object.keys(l))o.startsWith("!")||(u[o]=l[o]);return u}e.filterExceptionsFromTelemetry=y;function L(l){return l.configuration.request==="attach"&&!P(l)&&(!l.parentSession||L(l.parentSession))}e.isSessionAttach=L;function P(l){let u=l.configuration.type;if(!!u)return u==="vslsShare"&&(u=l.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(u,"extensionhost")||(0,c.equalsIgnoreCase)(u,"pwa-extensionhost")?l:l.parentSession?P(l.parentSession):void 0}e.getExtensionHostDebugSession=P;function E(l){return l.type&&(l.label||l.program||l.runtime)}e.isDebuggerMainContribution=E;function D(l,u,o){let a,n=0;const i=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=i.exec(l);){const k=f.index+1,R=k+f[0].length;if(k<=u&&R>=o){a=f[0],n=k;break}}if(a){const k=/\w+/g;let R=null;for(;(R=k.exec(a))&&!(R.index+1+n+R[0].length>=o););R&&(a=a.substring(0,k.lastIndex))}return a?{start:n,end:n+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=D;const v=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(l){return!!(l&&l.match(v))}e.isUri=d;function m(l){if(typeof l.path=="string"&&!(typeof l.sourceReference=="number"&&l.sourceReference>0)){if(d(l.path))return t.URI.parse(l.path);if((0,I.isAbsolute)(l.path))return t.URI.file(l.path)}return l.path}function h(l){if(typeof l.path=="object"){const u=t.URI.revive(l.path);if(u)return u.scheme===C.Schemas.file?u.fsPath:u.toString()}return l.path}function b(l,u){const o=u?m:h,a=(0,A.deepClone)(l);return g(a,(n,i)=>{n&&i&&(i.path=o(i))}),a}e.convertToDAPaths=b;function p(l,u){const o=u?m:h,a=(0,A.deepClone)(l);return g(a,(n,i)=>{!n&&i&&(i.path=o(i))}),a}e.convertToVSCPaths=p;function g(l,u){switch(l.type){case"event":{const o=l;switch(o.event){case"output":u(!1,o.body.source);break;case"loadedSource":u(!1,o.body.source);break;case"breakpoint":u(!1,o.body.breakpoint.source);break;default:break}break}case"request":{const o=l;switch(o.command){case"setBreakpoints":u(!0,o.arguments.source);break;case"breakpointLocations":u(!0,o.arguments.source);break;case"source":u(!0,o.arguments.source);break;case"gotoTargets":u(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(a=>u(!1,a));break;default:break}break}case"response":{const o=l;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(a=>u(!1,a.source));break;case"loadedSources":o.body.sources.forEach(a=>u(!1,a));break;case"scopes":o.body.scopes.forEach(a=>u(!1,a.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(a=>u(!1,a.source));break;case"setBreakpoints":o.body.breakpoints.forEach(a=>u(!1,a.source));break;case"disassemble":o.body?.instructions.forEach(n=>u(!1,n.location));break;default:break}break}}}function w(l){return l.filter(u=>!u.presentation?.hidden).sort((u,o)=>u.presentation?o.presentation?u.presentation.group?o.presentation.group?u.presentation.group!==o.presentation.group?u.presentation.group.localeCompare(o.presentation.group):s(u.presentation.order,o.presentation.order):-1:o.presentation.group?1:s(u.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=w;function s(l,u){return typeof l!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:l-u}async function r(l,u){const o=l.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(o!=="none"&&(await u.saveAll(),o==="allEditorsInActiveGroup")){const a=u.activeEditorPane;a&&a.input.resource?.scheme===C.Schemas.untitled&&await u.save({editor:a.input,groupId:a.group.id})}await l.reloadConfiguration()}e.saveAllBeforeDebugStart=r}),define(Se[218],ye([1,0,45,219,23,9,12,8,29,185,131]),function(ne,e,c,t,I,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(h,b){this.p=b,this.r=Buffer.allocUnsafe(0),this.t=-1,h.on("data",p=>this.w(p))}sendMessage(h){if(this.p){const b=JSON.stringify(h);this.p.write(`Content-Length: ${Buffer.byteLength(b,"utf8")}${P.a}${b}`,"utf8")}}w(h){for(this.r=Buffer.concat([this.r,h]);;){if(this.t>=0){if(this.r.length>=this.t){const b=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,b.length>0)try{this.acceptMessage(JSON.parse(b))}catch(p){this.m.fire(new Error((p.message||p)+`
`+b))}continue}}else{const b=this.r.indexOf(P.a);if(b!==-1){const g=this.r.toString("utf8",0,b).split(P.b);for(const w of g){const s=w.split(P.l);s[0]==="Content-Length"&&(this.t=Number(s[1]))}this.r=this.r.slice(b+P.a.length);continue}}break}}}e.StreamDebugAdapter=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */;class E extends P{startSession(){return new Promise((h,b)=>{let p=!1;this.x=this.y(()=>{this.v(this.x,this.x),h(),p=!0}),this.x.on("close",()=>{p?this.m.fire(new Error("connection closed")):b(new Error("connection closed"))}),this.x.on("error",g=>{p?this.m.fire(g):b(g)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=E;class D extends E{constructor(h){super(),this.z=h}y(h){return t.createConnection(this.z.port,this.z.host||"127.0.0.1",h)}}e.SocketDebugAdapter=D;class v extends E{constructor(h){super(),this.z=h}y(h){return t.createConnection(this.z.path,h)}}e.NamedPipeDebugAdapter=v;class d extends P{constructor(h,b){super(),this.y=h,this.z=b}async startSession(){const h=this.y.command,b=this.y.args,p=this.y.options||{};try{if(h)if(A.isAbsolute(h)){if(!await S.Promises.exists(h))throw new Error(y.localize(0,null,h))}else h.indexOf("/")<0&&h.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let g=process.env;if(p.env&&Object.keys(p.env).length>0&&(g=I.mixin(I.deepClone(process.env),p.env)),h==="node")if(Array.isArray(b)&&b.length>0){const w=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:g,execArgv:w?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};p.cwd&&(s.cwd=p.cwd);const r=c.fork(b[0],b.slice(1),s);if(!r.pid)throw new Error(y.localize(2,null,b[0]));this.x=r}else throw new Error(y.localize(3,null));else{const w={env:g};p.cwd&&(w.cwd=p.cwd),this.x=c.spawn(h,b,w)}this.x.on("error",w=>{this.m.fire(w)}),this.x.on("exit",(w,s)=>{this.n.fire(w)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",w=>{this.m.fire(w)}),this.x.stdin.on("error",w=>{this.m.fire(w)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(g){this.m.fire(g)}}async stopSession(){return this.x?(await this.u(),C.isWindows?new Promise((h,b)=>{const p=c.exec(`taskkill /F /T /PID ${this.x.pid}`,function(g,w,s){if(g)return b(g)});p.on("exit",h),p.on("error",b)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(h,b){if(!h)return;const p=Object.create(null);h.runtime&&(h.runtime.indexOf("./")===0?p.runtime=A.join(b,h.runtime):p.runtime=h.runtime),h.runtimeArgs&&(p.runtimeArgs=h.runtimeArgs),h.program&&(A.isAbsolute(h.program)?p.program=h.program:p.program=A.join(b,h.program)),h.args&&(p.args=h.args);const g=h;return g.win&&(p.win=d.A(g.win,b)),g.winx86&&(p.winx86=d.A(g.winx86,b)),g.windows&&(p.windows=d.A(g.windows,b)),g.osx&&(p.osx=d.A(g.osx,b)),g.linux&&(p.linux=d.A(g.linux,b)),p}static platformAdapterExecutable(h,b){let p=Object.create(null);b=b.toLowerCase();for(const u of h)if(u.contributes){const o=u.contributes.debuggers;o&&o.length>0&&o.filter(a=>typeof a.type=="string"&&T.equalsIgnoreCase(a.type,b)).forEach(a=>{const n=d.A(a,u.extensionLocation.fsPath);p=I.mixin(p,n,u.isBuiltin)})}let g;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=p.winx86||p.win||p.windows:C.isWindows?g=p.win||p.windows:C.isMacintosh?g=p.osx:C.isLinux&&(g=p.linux),g=g||p;const w=g.program||p.program,s=g.args||p.args,r=g.runtime||p.runtime,l=g.runtimeArgs||p.runtimeArgs;if(r)return{type:"executable",command:r,args:(l||[]).concat(typeof w=="string"?[w]:[]).concat(s||[])};if(w)return{type:"executable",command:w,args:s||[]}}}e.ExecutableDebugAdapter=d}),define(Se[220],ye([1,0,45,32,12]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(y,L){return new Promise((P,E)=>{let D="";const v=c.spawn(y,L);v.pid&&v.stdout.on("data",d=>{D+=d.toString()}),v.on("error",d=>{E(d)}),v.on("close",d=>{P(D)})})}async function C(y){if(y)if(I.isWindows){const L=await new Promise((P,E)=>{ne(["windows-process-tree"],P,E)});return new Promise(P=>{L.getProcessTree(y,E=>{P(!!E&&E.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(y)]).then(L=>{const P=L.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var T;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(T||(T={}));function S(y,L,P,E,D){y=y.trim().toLowerCase();let v;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?v=1:y.indexOf("cmd.exe")>=0?v=0:y.indexOf("bash")>=0?v=2:I.isWindows?v=0:v=2;let d,m=" ";switch(v){case 1:if(d=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),E){const h=(0,t.getDriveLetter)(E);h&&(m+=`${h}:; `),m+=`cd ${d(E)}; `}if(D)for(const h in D){const b=D[h];b===null?m+=`Remove-Item env:${h}; `:m+=`\${env:${h}}='${b}'; `}if(L.length>0){const h=L.shift(),b=P?h:d(h);m+=b[0]==="'"?`& ${b} `:`${b} `;for(const p of L)m+=p==="<"||p===">"||P?p:d(p),m+=" "}break;case 0:if(d=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(b=>h.includes(b))||h.length===0?`"${h}"`:h),E){const h=(0,t.getDriveLetter)(E);h&&(m+=`${h}: && `),m+=`cd ${d(E)} && `}if(D){m+='cmd /C "';for(const h in D){let b=D[h];b===null?m+=`set "${h}=" && `:(b=b.replace(/[&^|<>]/g,p=>`^${p}`),m+=`set "${h}=${b}" && `)}}for(const h of L)m+=h==="<"||h===">"||P?h:d(h),m+=" ";D&&(m+='"');break;case 2:{d=b=>(b=b.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),b.length===0?'""':b);const h=b=>/[^\w@%\/+=,.:^-]/.test(b)?`'${b.replace(/'/g,"'\\''")}'`:b;if(E&&(m+=`cd ${d(E)} ; `),D){m+="/usr/bin/env";for(const b in D){const p=D[b];p===null?m+=` -u ${h(b)}`:m+=` ${h(`${b}=${p}`)}`}m+=" "}for(const b of L)m+=b==="<"||b===">"||P?b:d(b),m+=" ";break}}return m}e.prepareCommand=S}),define(Se[90],ye([1,0,22,37,62,83,15,9,12,53]),function(ne,e,c,t,I,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json",A.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var E;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(E=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var D;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(D=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var m;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(m=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var b;(function(z){z.scheme=C.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],W=new RegExp(`^[${U.join("")}]+`),x=7;function V(Z,ge){const ve=ge.toString(x),Re=`${ve.length<U.length?U[ve.length-1]:"z"}${ve}s${(0,c.encodeBase64)(c.VSBuffer.fromString(Z.scheme),!0,!0)}`;return Z.with({scheme:z.scheme,fragment:Re})}z.generate=V;function _(Z){if(Z.scheme!==z.scheme)return;const ge=Z.fragment.indexOf("s");if(ge<0)return;const ve=parseInt(Z.fragment.substring(0,ge).replace(W,""),x),De=(0,c.decodeBase64)(Z.fragment.substring(ge+1)).toString();if(!isNaN(ve))return{handle:ve,notebook:Z.with({scheme:De,fragment:null})}}z.parse=_;function Q(Z,ge){return Z.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${ge??""},${Z.scheme!==C.Schemas.file?Z.scheme:""}`})}z.generateCellOutputUri=Q;function J(Z){if(Z.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const ge=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Z.fragment);if(!ge)return;const ve=ge[1]&&ge[1]!==""?ge[1]:void 0,De=ge[2];return{outputId:ve,notebook:Z.with({scheme:De||C.Schemas.file,fragment:null})}}z.parseCellOutputUri=J;function te(Z,ge,ve){return z.generate(Z,ge).with({scheme:ve})}z.generateCellPropertyUri=te;function le(Z,ge){if(Z.scheme===ge)return z.parse(Z.with({scheme:z.scheme}))}z.parseCellPropertyUri=le})(b=e.CellUri||(e.CellUri={}));const p=z=>S.isWindows?z.replace(/\//g,"\\"):z;class g{constructor(U=[],W=e.NOTEBOOK_DISPLAY_ORDER){this.e=W,this.d=[...new Set(U)].map(x=>({pattern:x,matches:t.parse(p(x))}))}sort(U){const W=new Map(I.Iterable.map(U,V=>[V,p(V)]));let x=[];for(const{matches:V}of this.d)for(const[_,Q]of W)if(V(Q)){x.push(_),W.delete(_);break}return W.size&&(x=x.concat([...W.keys()].sort((V,_)=>this.e.indexOf(V)-this.e.indexOf(_)))),x}prioritize(U,W){const x=this.f(U);if(x===-1){this.d.unshift({pattern:U,matches:t.parse(p(U))});return}const V=new Set(W.map(Q=>this.f(Q,x)));V.delete(-1);const _=Array.from(V).sort();this.d.splice(x+1,0,..._.map(Q=>this.d[Q]));for(let Q=_.length-1;Q>=0;Q--)this.d.splice(_[Q],1)}toArray(){return this.d.map(U=>U.pattern)}f(U,W=this.d.length){const x=p(U);for(let V=0;V<W;V++)if(this.d[V].matches(x))return V;return-1}}e.MimeTypeDisplayOrder=g;function w(z,U,W,x=(V,_)=>V===_){const V=[];function _(te,le,Z){if(le===0&&Z.length===0)return;const ge=V[V.length-1];ge&&ge.start+ge.deleteCount===te?(ge.deleteCount+=le,ge.toInsert.push(...Z)):V.push({start:te,deleteCount:le,toInsert:Z})}let Q=0,J=0;for(;;){if(Q===z.length){_(Q,0,U.slice(J));break}if(J===U.length){_(Q,z.length-Q,[]);break}const te=z[Q],le=U[J];if(x(te,le)){Q+=1,J+=1;continue}W(le)?(_(Q,1,[]),Q+=1):(_(Q,0,[le]),J+=1)}return V}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(z){z.default="default",z.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(z){const U=z;return!!((typeof U.include=="string"||t.isRelativePattern(U.include))&&(typeof U.exclude=="string"||t.isRelativePattern(U.exclude)))}e.isDocumentExcludePattern=r;function l(z,U,W){if(Array.isArray(z.viewType)&&z.viewType.indexOf(U)>=0||z.viewType===U)return!0;if(z.filenamePattern){const x=r(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,V=r(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(t.match(x,(0,T.basename)(W.fsPath).toLowerCase()))return!(V&&t.match(V,(0,T.basename)(W.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var u;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(U){return`${o.d}${U}`}static parse(U){if(U.startsWith(o.d))return U.substring(o.d.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o.d="notebook/";function a(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.isTextStreamMime=a;const n=new TextDecoder;function i(z){const U=[];let W=!1;for(const x of z)(U.length===0||W)&&(U.push(x),W=!0);return B(U),F(c.VSBuffer.concat(U.map(x=>c.VSBuffer.wrap(x))))}e.compressOutputItemStreams=i;const f=`${String.fromCharCode(27)}[A`,k=f.split("").map(z=>z.charCodeAt(0)),R=10;function B(z){z.forEach((U,W)=>{if(W===0||U.length<f.length)return;const x=z[W-1],V=U.subarray(0,f.length);if(V[0]===k[0]&&V[1]===k[1]&&V[2]===k[2]){const _=x.lastIndexOf(R);if(_===-1)return;z[W-1]=x.subarray(0,_),z[W]=U.subarray(f.length)}})}function X(z){let U=z;do z=U,U=z.replace(/[^\n]\x08/gm,"");while(U.length<z.length);return z}function q(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const U=z.match(/^(.*)\r+/m)[1];let W=z.match(/\r+(.*)$/m)[1];W=W+U.slice(W.length,U.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,W)}return z}const N="\b".charCodeAt(0),M="\r".charCodeAt(0);function F(z){return!z.buffer.includes(N)&&!z.buffer.includes(M)?z:c.VSBuffer.fromString(q(X(n.decode(z.buffer))))}}),define(Se[221],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(Se[222],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=c;function t(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=t;function I(C){return Array.from(C.entries()).map(T=>[T[0],c(T[1].map)])}e.serializeEnvironmentVariableCollections=I;function A(C){return new Map(C.map(T=>[T[0],{map:t(T[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(Se[56],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(A){A.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{static fromExtHostTestItem(C,T,S=C.parent){if(C._isRoot)return new I([T]);const y=[C.id];for(let L=S;L&&L.id!==T;L=L.parent)y.push(L.id);return y.push(T),new I(y.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const T=C.indexOf("\0");return T===-1?C:C.slice(0,T)}static fromString(C){return new I(C.split("\0"))}static join(C,T){return new I([...C.path,T])}static joinToString(C,T){return C.toString()+"\0"+T}static parentId(C){const T=C.lastIndexOf("\0");return T===-1?void 0:C.slice(0,T)}static compare(C,T){return C===T?0:T.startsWith(C+"\0")?2:C.startsWith(T+"\0")?3:1}constructor(C,T=C.length){if(this.path=C,this.d=T,C.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new I(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new I(this.path,C)}compare(C){if(typeof C=="string")return I.compare(this.toString(),C);for(let T=0;T<C.d&&T<this.d;T++)if(C.path[T]!==this.path[T])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=I}),define(Se[69],ye([1,0,2,35,56]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var A;(function(a){a[a.Unset=0]="Unset",a[a.Queued=1]="Queued",a[a.Running=2]="Running",a[a.Passed=3]="Passed",a[a.Failed=4]="Failed",a[a.Skipped=5]="Skipped",a[a.Errored=6]="Errored"})(A=e.TestResultState||(e.TestResultState={}));var C;(function(a){a[a.Run=2]="Run",a[a.Debug=4]="Debug",a[a.Coverage=8]="Coverage",a[a.HasNonDefaultProfile=16]="HasNonDefaultProfile",a[a.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var T;(function(a){a.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),a.deserialize=n=>({range:t.Range.lift(n.range),uri:c.URI.revive(n.uri)})})(T=e.IRichLocation||(e.IRichLocation={}));var S;(function(a){a[a.Error=0]="Error",a[a.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var y;(function(a){a.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&T.serialize(n.location)}),a.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&T.deserialize(n.location)})})(y=e.ITestErrorMessage||(e.ITestErrorMessage={}));const L=(a,n)=>`${n?"s":"e"}${a}`;e.getMarkId=L;var P;(function(a){a.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&T.serialize(n.location)}),a.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&T.deserialize(n.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(a){a.serialize=n=>n.type===0?y.serialize(n):P.serialize(n),a.deserialize=n=>n.type===0?y.deserialize(n):P.deserialize(n)})(E=e.ITestMessage||(e.ITestMessage={}));var D;(function(a){a.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),a.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(E.serialize)}),a.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(E.deserialize)})})(D=e.ITestTaskState||(e.ITestTaskState={}));const v="\0",d=(a,n)=>a+v+n;e.namespaceTestTag=d;const m=a=>{const n=a.indexOf(v);return{ctrlId:a.slice(0,n),tagId:a.slice(n+1)}};e.denamespaceTestTag=m;var h;(function(a){a.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),a.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?c.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(h=e.ITestItem||(e.ITestItem={}));var b;(function(a){a[a.NotExpandable=0]="NotExpandable",a[a.Expandable=1]="Expandable",a[a.BusyExpanding=2]="BusyExpanding",a[a.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var p;(function(a){a.serialize=n=>({expand:n.expand,item:h.serialize(n.item)}),a.deserialize=n=>({controllerId:I.TestId.root(n.item.extId),expand:n.expand,item:h.deserialize(n.item)})})(p=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(a){a.serialize=n=>{let i;return n.item&&(i={},n.item.label!==void 0&&(i.label=n.item.label),n.item.tags!==void 0&&(i.tags=n.item.tags),n.item.busy!==void 0&&(i.busy=n.item.busy),n.item.uri!==void 0&&(i.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(i.range=n.item.range?.toJSON()),n.item.description!==void 0&&(i.description=n.item.description),n.item.error!==void 0&&(i.error=n.item.error),n.item.sortText!==void 0&&(i.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:i}},a.deserialize=n=>{let i;return n.item&&(i={},n.item.label!==void 0&&(i.label=n.item.label),n.item.tags!==void 0&&(i.tags=n.item.tags),n.item.busy!==void 0&&(i.busy=n.item.busy),n.item.range!==void 0&&(i.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(i.description=n.item.description),n.item.error!==void 0&&(i.error=n.item.error),n.item.sortText!==void 0&&(i.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:i}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(a,n)=>{n.expand!==void 0&&(a.expand=n.expand),n.item!==void 0&&(a.item=a.item?Object.assign(a.item,n.item):n.item)};e.applyTestItemUpdate=w;var s;(function(a){a.serializeWithoutMessages=n=>({...p.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(D.serializeWithoutMessages),retired:n.retired}),a.serialize=n=>({...p.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(D.serialize),retired:n.retired}),a.deserialize=n=>({...p.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(D.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var r;(function(a){a[a.Function=0]="Function",a[a.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var l;(function(a){a[a.Add=0]="Add",a[a.Update=1]="Update",a[a.DocumentSynced=2]="DocumentSynced",a[a.Remove=3]="Remove",a[a.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",a[a.Retire=5]="Retire",a[a.AddTag=6]="AddTag",a[a.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(a){a.deserialize=n=>n.op===0?{op:n.op,item:p.deserialize(n.item)}:n.op===1?{op:n.op,item:g.deserialize(n.item)}:n.op===2?{op:n.op,uri:c.URI.revive(n.uri),docv:n.docv}:n,a.serialize=n=>n.op===0?{op:n.op,item:p.serialize(n.item)}:n.op===1?{op:n.op,item:g.serialize(n.item)}:n})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class o{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const i=this.o();for(const f of n)switch(f.op){case 0:this.j(p.deserialize(f.item),i);break;case 1:this.k(g.deserialize(f.item),i);break;case 3:this.l(f.itemId,i);break;case 5:this.m(f.itemId);break;case 4:this.updatePendingRoots(f.amount);break;case 6:this.c.set(f.tag.id,f.tag);break;case 7:this.c.delete(f.id);break}i.complete?.()}j(n,i){const f=I.TestId.parentId(n.item.extId)?.toString();let k;if(!f)k=this.p(n),this.f.add(k),this.d.set(n.item.extId,k);else if(this.d.has(f)){const R=this.d.get(f);R.children.add(n.item.extId),k=this.p(n,R),this.d.set(n.item.extId,k)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return i.add?.(k),n.expand===2&&this.g++,k}k(n,i){const f=this.d.get(n.extId);if(!!f)return n.expand!==void 0&&(f.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(f,n),i.update?.(f),f}l(n,i){const f=this.d.get(n);if(!f)return;const k=I.TestId.parentId(f.item.extId)?.toString();k?this.d.get(k).children.delete(f.item.extId):this.f.delete(f);const R=[[n]];for(;R.length;)for(const B of R.pop()){const X=this.d.get(B);X&&(R.push(X.children),this.d.delete(B),i.remove?.(X,X!==f),X.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=o}),define(Se[91],ye([1,0,18,4,6,49,69,56]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(b){b[b.Upsert=0]="Upsert",b[b.SetTags=1]="SetTags",b[b.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",b[b.RemoveChild=3]="RemoveChild",b[b.SetProp=4]="SetProp",b[b.Bulk=5]="Bulk",b[b.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const y=(b,p)=>b===p,P=Object.entries({range:(b,p)=>b===p?!0:!b||!p?!1:b.equalsRange(p),busy:y,label:y,description:y,error:y,sortText:y,tags:(b,p)=>!(b.length!==p.length||b.some(g=>!p.includes(g)))}),E=(b,p)=>{let g;for(const[w,s]of P)s(b[w],p[w])||(g?g[w]=p[w]:g={[w]:p[w]});return g};class D extends I.Disposable{get root(){return this.m.root}constructor(p){super(),this.m=p,this.f=this.B(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(p){this.h=p;for(const g of this.tree.values())this.G(g)}collectDiff(){const p=this.k;return this.k=[],p}pushDiff(p){switch(p.op){case 2:{for(const g of this.k)if(g.op===2&&g.uri===p.uri){g.docv=p.docv;return}break}case 1:{const g=this.k[this.k.length-1];if(g){if(g.op===1&&g.item.extId===p.item.extId){(0,C.applyTestItemUpdate)(g.item,p.item);return}if(g.op===0&&g.item.item.extId===p.item.extId){(0,C.applyTestItemUpdate)(g.item,p.item);return}}break}}this.k.push(p),this.f.isScheduled()||this.f.schedule()}expand(p,g){const w=this.tree.get(p);if(!!w){if((w.expandLevels===void 0||g>w.expandLevels)&&(w.expandLevels=g),w.expand===1){const s=this.I(w);return s.isOpen()?this.H(w,g-1):s.wait().then(()=>this.H(w,g-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.H(w,g-1)):this.H(w,g-1)}}dispose(){for(const p of this.tree.values())this.m.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(p,g){switch(g.op){case 3:this.L(T.TestId.joinToString(p.fullId,g.id));break;case 0:this.u(g.item,p);break;case 5:for(const w of g.ops)this.p(p,w);break;case 1:this.w(g.new,g.old,p.fullId.toString());break;case 2:this.G(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:g.update}});break;case 6:this.s(p.actual.uri);break;default:(0,A.assertNever)(g)}}s(p){p&&this.pushDiff({op:2,uri:p,docv:this.m.getDocumentVersion(p)})}u(p,g){const w=T.TestId.fromExtHostTestItem(p,this.root.id,g?.actual),s=this.m.getApiFor(p);s.parent&&s.parent!==g?.actual&&this.m.getChildren(s.parent).delete(p.id);let r=this.tree.get(w.toString());if(!r){r={fullId:w,actual:p,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},p.tags.forEach(this.y,this),this.tree.set(r.fullId.toString(),r),this.C(p,g),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:r.expand,item:this.m.toITestItem(p)}}),this.F(p,r,g);return}if(r.actual===p){this.D(p,r,g);return}if(r.actual.uri?.toString()!==p.uri?.toString())return this.L(w.toString()),this.u(p,g);const l=this.m.getChildren(r.actual),u=r.actual,o=E(this.m.toITestItem(u),this.m.toITestItem(p));this.m.getApiFor(u).listener=void 0,r.actual=p,r.expand=0,o&&(o.hasOwnProperty("tags")&&(this.w(p.tags,u.tags,w.toString()),delete o.tags),this.p(r,{op:4,update:o})),this.F(p,r,g);for(const[a,n]of l)this.m.getChildren(p).get(n.id)||this.L(T.TestId.joinToString(w,n.id));this.s(r.actual.uri)}w(p,g,w){const s=new Set(g.map(r=>r.id));for(const r of p)s.delete(r.id)||this.y(r);this.pushDiff({op:1,item:{extId:w,item:{tags:p.map(r=>(0,C.namespaceTestTag)(this.m.controllerId,r.id))}}}),s.forEach(this.z,this)}y(p){const g=this.j.get(p.id);g?g.refCount++:(this.j.set(p.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,p.id)}}))}z(p){const g=this.j.get(p);g&&!--g.refCount&&(this.j.delete(p),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,p)}))}C(p,g){this.m.getApiFor(p).parent=g&&g.actual!==this.root?g.actual:void 0}D(p,g,w){this.C(p,w);const s=this.m.getApiFor(p);s.parent=w?.actual,s.listener=r=>this.p(g,r),this.G(g)}F(p,g,w){this.D(p,g,w);for(const[s,r]of this.m.getChildren(p))this.u(r,g)}G(p){let g;this.h?p.resolveBarrier?g=p.resolveBarrier.isOpen()?3:2:g=p.actual.canResolveChildren?1:0:g=0,g!==p.expand&&(p.expand=g,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:g}}),g===1&&p.expandLevels!==void 0&&this.I(p))}H(p,g){if(g<0)return;const w=[];for(const[s,r]of this.m.getChildren(p.actual)){const l=this.expand(T.TestId.joinToString(p.fullId,r.id),g);(0,c.isThenable)(l)&&w.push(l)}if(w.length)return Promise.all(w).then(()=>{})}I(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this.h){const r=new c.Barrier;return r.open(),r}p.expand=2,this.J(p);const g=p.resolveBarrier=new c.Barrier,w=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,r)};let s;try{s=this.h(p.actual===this.root?void 0:p.actual)}catch(r){w(r)}return(0,c.isThenable)(s)?s.catch(w).then(()=>{g.open(),this.G(p)}):(g.open(),this.G(p)),p.resolveBarrier}J(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}L(p){const g=this.tree.get(p);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:p});const w=[g];for(;w.length;){const s=w.pop();if(!!s){this.m.getApiFor(s.actual).listener=void 0;for(const r of s.actual.tags)this.z(r.id);this.tree.delete(s.fullId.toString());for(const[r,l]of this.m.getChildren(s.actual))w.push(this.tree.get(T.TestId.joinToString(s.fullId,l.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.g.fire(p)}}e.TestItemCollection=D;class v extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.DuplicateTestItemError=v;class d extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class m extends Error{constructor(p,g,w){super(`TestItem with ID "${p}" is from controller "${g}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=m;const h=(b,p,g)=>{let w=new Map;return{get size(){return w.size},forEach(s,r){for(const l of w.values())s.call(r,l,this)},[Symbol.iterator](){return w.entries()},replace(s){const r=new Map,l=new Set(w.keys()),u={op:5,ops:[]};for(const o of s){if(!(o instanceof g))throw new d(o.id);const a=p(o).controllerId;if(a!==b.controllerId)throw new m(o.id,a,b.controllerId);if(r.has(o.id))throw new v(o.id);r.set(o.id,o),l.delete(o.id),u.ops.push({op:0,item:o})}for(const o of l.keys())u.ops.push({op:3,id:o});b.listener?.(u),w=r},add(s){if(!(s instanceof g))throw new d(s.id);w.set(s.id,s),b.listener?.({op:0,item:s})},delete(s){w.delete(s)&&b.listener?.({op:3,id:s})},get(s){return w.get(s)},toJSON(){return Array.from(w.values())}}};e.createTestItemChildren=h}),define(Se[132],ye([1,0,91]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,I=(C,T)=>{const S={controllerId:T};return t.set(C,S),S};e.createPrivateApiFor=I;const A=C=>{const T=t.get(C);if(!T)throw new c.InvalidTestItemError(C?.id||"<unknown>");return T};e.getPrivateApiFor=A}),define(Se[92],ye([1,0,15,2]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function I(T,S){return T.scheme===c.Schemas.http||T.scheme===c.Schemas.https?T:(S&&S.authority&&S.isRemote&&T.scheme===c.Schemas.file&&(T=t.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:T.path})),t.URI.from({scheme:c.Schemas.https,authority:`${T.scheme}+${A(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=I;function A(T){return T.replace(/./g,S=>{const y=S.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?S:"-"+y.toString(16).padStart(4,"0")})}function C(T){return T.replace(/-([0-9a-f]{4})/g,(S,y)=>String.fromCharCode(parseInt(y,16)))}e.decodeAuthority=C}),define(Se[223],ye([1,0,4,6,92]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(T,S,y){this.d=T,this.e=S,this.f=y,this.a=0,this.b=new t.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const L=S.getVisibleTextEditors();for(const P of this.c.values())L.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,S,y,L,P){let E;for(const p of this.e.getVisibleTextEditors(!0))if(p.value===T){E=p;break}if(!E)throw new Error("not a visible editor");const D=this,v=this.a++,d=new c.Emitter,m=new c.Emitter,h=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(p){return(0,I.asWebviewUri)(p,D.f)}get cspSource(){return I.webviewGenericCspSource}set options(p){this.b=p,D.d.$setOptions(v,p)}get options(){return this.b}set html(p){this.a=p,D.d.$setHtml(v,p)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(p){return D.d.$postMessage(v,p)}},b=new class{constructor(){this.editor=T,this.line=S,this.height=y,this.webview=h,this.onDidDispose=m.event}dispose(){D.c.has(v)&&(D.c.delete(v),D.d.$disposeEditorInset(v),m.fire(),m.dispose(),d.dispose())}};return this.d.$createEditorInset(v,E.id,E.value.document.uri,S+1,y,L||{},P.identifier,P.extensionLocation),this.c.set(v,{editor:T,inset:b,onDidReceiveMessage:d}),b}$onDidDispose(T){const S=this.c.get(T);S&&S.inset.dispose()}$onDidReceiveMessage(T,S){this.c.get(T)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(Se[224],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var t;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class I extends Error{constructor(C,T){super(T),this.variable=C}}e.VariableError=I}),define(Se[225],ye([1,0,9,36,11,23,12,111,188,224,8]),function(ne,e,c,t,I,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(D,v,d,m){this.g=new Map,this.a=D,this.b=v,this.d=d,m&&(this.c=m.then(h=>this.h(h)))}h(D){if(C.isWindows){const v=Object.create(null);return Object.keys(D).forEach(d=>{v[d.toLowerCase()]=D[d]}),v}return D}resolveWithEnvironment(D,v,d){return this.j({env:this.h(D),userHome:void 0},v?v.uri:void 0,d)}async resolveAsync(D,v){const d={env:await this.c,userHome:await this.d};return this.j(d,D?D.uri:void 0,v)}async i(D,v,d,m){const h=A.deepClone(v);C.isWindows&&h.windows?Object.keys(h.windows).forEach(p=>h[p]=h.windows[p]):C.isMacintosh&&h.osx?Object.keys(h.osx).forEach(p=>h[p]=h.osx[p]):C.isLinux&&h.linux&&Object.keys(h.linux).forEach(p=>h[p]=h.linux[p]),delete h.windows,delete h.osx,delete h.linux;const b={env:await this.c,userHome:await this.d};return this.j(b,D?D.uri:void 0,h,d,m)}async resolveAnyAsync(D,v,d){return this.i(D,v,d)}async resolveAnyMap(D,v,d){const m=new Map;return{newConfig:await this.i(D,v,d,m),resolvedVariables:m}}resolveWithInteractionReplace(D,v,d,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,v,d,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,v){if(this.g.has(D))throw new Error("Variable "+D+" is contributed twice.");this.g.set(D,v)}async j(D,v,d,m,h){if(I.isString(d))return this.l(D,v,d,m,h);if(Array.isArray(d))return Promise.all(d.map(b=>this.j(D,v,b,m,h)));if(I.isObject(d)){const b=Object.create(null),p=await Promise.all(Object.keys(d).map(async g=>[await this.l(D,v,g,m,h),await this.j(D,v,d[g],m,h)]));for(const[g,w]of p)b[g]=w;return b}return d}l(D,v,d,m,h){return(0,L.replaceAsync)(d,P.VARIABLE_REGEXP,async(b,p)=>{if(p.includes(P.VARIABLE_LHS))return b;let g=await this.n(D,b,p,v,m);return h?.set(p,g),g!==b&&I.isString(g)&&g.match(P.VARIABLE_REGEXP)&&(g=await this.l(D,v,g,m,h)),g})}m(D){return this.b?this.b.getUriLabel(D,{noPrefix:!0}):D.fsPath}async n(D,v,d,m,h){let b;const p=d.split(":");p.length>1&&(d=p[0],b=p[1]);const g=r=>{const l=this.a.getFilePath();if(l)return(0,T.normalizeDriveLetter)(l);throw new y.VariableError(r,(0,S.localize)(0,null,v))},w=r=>{const l=g(r);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,T.normalizeDriveLetter)(u)}throw new y.VariableError(r,(0,S.localize)(1,null,v,c.basename(l)))},s=r=>{if(b){const l=this.a.getFolderUri(b);if(l)return l;throw new y.VariableError(r,(0,S.localize)(2,null,v,b))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new y.VariableError(r,(0,S.localize)(3,null,v)):new y.VariableError(r,(0,S.localize)(4,null,v))};switch(d){case"env":if(b){if(D.env){const r=D.env[C.isWindows?b.toLowerCase():b];if(I.isString(r))return r}return""}throw new y.VariableError(y.VariableKind.Env,(0,S.localize)(5,null,v));case"config":if(b){const r=this.a.getConfigurationValue(m,b);if(I.isUndefinedOrNull(r))throw new y.VariableError(y.VariableKind.Config,(0,S.localize)(6,null,v,b));if(I.isObject(r))throw new y.VariableError(y.VariableKind.Config,(0,S.localize)(7,null,v,b));return r}throw new y.VariableError(y.VariableKind.Config,(0,S.localize)(8,null,v));case"command":return this.o(y.VariableKind.Command,v,b,h,"command");case"input":return this.o(y.VariableKind.Input,v,b,h,"input");case"extensionInstallFolder":if(b){const r=await this.a.getExtension(b);if(!r)throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,v,b));return this.m(r.extensionLocation)}throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,v));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.m(s(y.VariableKind.WorkspaceFolder)));case"cwd":return m||b?(0,T.normalizeDriveLetter)(this.m(s(y.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.normalizeDriveLetter)(c.basename(this.m(s(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(D.userHome)return D.userHome;throw new y.VariableError(y.VariableKind.UserHome,(0,S.localize)(11,null,v))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new y.VariableError(y.VariableKind.LineNumber,(0,S.localize)(12,null,v))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new y.VariableError(y.VariableKind.SelectedText,(0,S.localize)(13,null,v))}case"file":return g(y.VariableKind.File);case"fileWorkspaceFolder":return w(y.VariableKind.FileWorkspaceFolder);case"relativeFile":return m||b?c.relative(this.m(s(y.VariableKind.RelativeFile)),g(y.VariableKind.RelativeFile)):g(y.VariableKind.RelativeFile);case"relativeFileDirname":{const r=c.dirname(g(y.VariableKind.RelativeFileDirname));if(m||b){const l=c.relative(this.m(s(y.VariableKind.RelativeFileDirname)),r);return l.length===0?".":l}return r}case"fileDirname":return c.dirname(g(y.VariableKind.FileDirname));case"fileExtname":return c.extname(g(y.VariableKind.FileExtname));case"fileBasename":return c.basename(g(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=c.basename(g(y.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-c.extname(r).length)}case"fileDirnameBasename":return c.basename(c.dirname(g(y.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||v}case"execInstallFolder":{const r=this.a.getAppRoot();return r||v}case"pathSeparator":return c.sep;default:try{const r=b?`${d}:${b}`:d;return this.o(y.VariableKind.Unknown,v,r,h,void 0)}catch{return v}}}}o(D,v,d,m,h){if(d&&m){const b=h===void 0?m[d]:m[h+":"+d];if(typeof b=="string")return b;throw new y.VariableError(D,(0,S.localize)(14,null,v))}return v}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[133],ye([1,0,3,130]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var I;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var A;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var T;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function y(v){const d=v;return(0,t.isEditorInput)(d?.editor)&&(0,t.isEditorInput)(d?.replacement)}e.isEditorReplacement=y;var L;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function E(v){const d=v;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=E;function D(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=D}),define(Se[226],ye([1,0,3,133]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(A){const C=A;return typeof A=="number"||(0,t.isEditorGroup)(C)}e.isPreferredGroup=I}),define(Se[227],ye([1,0,3,194]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(t.IEnvironmentService)}),define(Se[134],ye([1,0,27,4,9]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=A;class C{static isHostExtension(P,E,D){if(E.getExtensionDescription(P))return!1;const v=D.getExtensionDescription(P);return v?!!((v.main||v.browser)&&v.api==="none"):!1}constructor(P){this.c=new t.Emitter,this.onDidChange=this.c.event,this.d=P,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const P of this.d){if(this.e.has(c.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this.e.set(c.ExtensionIdentifier.toKey(P.identifier),P),this.f.push(P),Array.isArray(P.activationEvents))for(let E of P.activationEvents)E==="onUri"&&(E=`onUri:${c.ExtensionIdentifier.toKey(P.identifier)}`),this.g.has(E)||this.g.set(E,[]),this.g.get(E).push(P)}}set(P){this.d=P,this.h(),this.c.fire(void 0)}deltaExtensions(P,E){this.d=y(this.d,E),this.d=this.d.concat(P);const D=C.j(this.d);return this.d=y(this.d,D.map(v=>v.identifier)),this.h(),this.c.fire(void 0),new A(D)}static j(P){const E=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,b){this.addNode(h),this.addNode(b),this.c.has(h)?this.c.get(h).push(b):this.c.set(h,[b])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,b){const p=E.getArcs(h);for(let g=0;g<p.length;g++)if(!b.has(p[g]))return!1;return!0}getNodes(){return this.e}},D=new Map;for(const h of P){const b=c.ExtensionIdentifier.toKey(h.identifier);if(D.set(b,h),h.extensionDependencies)for(const p of h.extensionDependencies){const g=c.ExtensionIdentifier.toKey(p);E.addArc(b,g)}}const v=new Set;E.getNodes().filter(h=>E.getArcs(h).length===0).forEach(h=>v.add(h));const d=E.getNodes().filter(h=>!v.has(h));let m;do{m=!1;for(let h=0;h<d.length;h++){const b=d[h];E.hasOnlyGoodArcs(b,v)&&(d.splice(h,1),h--,v.add(b),m=!0)}}while(m);return d.map(h=>D.get(h))}containsActivationEvent(P){return this.g.has(P)}containsExtension(P){return this.e.has(c.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const E=this.g.get(P);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(P){const E=this.e.get(c.ExtensionIdentifier.toKey(P));return E||void 0}getExtensionDescriptionByUUID(P){for(const E of this.f)if(E.uuid===P)return E}getExtensionDescriptionByIdOrUUID(P,E){return this.getExtensionDescription(P)??(E?this.getExtensionDescriptionByUUID(E):void 0)}}e.ExtensionDescriptionRegistry=C;var T;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(T||(T={}));function S(L,P){const E=L.isBuiltin?0:L.isUnderDevelopment?2:1,D=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(E!==D)return E-D;const v=I.posix.basename(L.extensionLocation.path),d=I.posix.basename(P.extensionLocation.path);return v<d?-1:v>d?1:0}function y(L,P){const E=new Set;return P.forEach(D=>E.add(c.ExtensionIdentifier.toKey(D))),L.filter(D=>!E.has(c.ExtensionIdentifier.toKey(D.identifier)))}}),define(Se[228],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(c=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class I{constructor(){this.type=2}serialize(P){P[I.ENV_KEY]="1"}}e.SocketExtHostConnection=I,I.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class A{constructor(){this.type=3}serialize(P){P[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A,A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function C(L){delete L[t.ENV_KEY],delete L[I.ENV_KEY],delete L[A.ENV_KEY]}function T(L,P){C(P),L.serialize(P)}e.writeExtHostConnection=T;function S(L){if(L[t.ENV_KEY])return y(L,new t(L[t.ENV_KEY]));if(L[I.ENV_KEY])return y(L,new I);if(L[A.ENV_KEY])return y(L,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function y(L,P){return C(L),P}}),define(Se[93],ye([1,0,22]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var I;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function C(y){const L=c.VSBuffer.alloc(1);switch(y){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=C;function T(y,L){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=T;var S;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Se[94],ye([1,0,3,4,13,25,93,67,128,23,2]),function(ne,e,c,t,I,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let P=class{constructor(d,m){this.i=d,this.a=new t.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new t.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=m.createLogger(L.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(d,m){const h=this.getTelemetryDetails(),b=new E(m,d,this.g,this.f,this.getBuiltInCommonProperties(d),{isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled});return this.h.set(d.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(d,m,h){this.d=d,this.f=m,this.c=h??{usage:!0,error:!0}}getBuiltInCommonProperties(d){const m={};switch(m["common.extname"]=d.name,m["common.extversion"]=d.version,m["common.vscodemachineid"]=this.i.telemetryInfo.machineId,m["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,m["common.vscodeversion"]=this.i.version,m["common.isnewappinstall"]=D(this.i.telemetryInfo.firstSessionDate),m["common.product"]=this.i.environment.appHost,this.i.uiKind){case C.UIKind.Web:m["common.uikind"]="web";break;case C.UIKind.Desktop:m["common.uikind"]="desktop";break;default:m["common.uikind"]="unknown"}return m["common.remotename"]=(0,T.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),m}$onDidChangeTelemetryLevel(d){this.e=this.getTelemetryConfiguration(),this.d=d;const m=this.getTelemetryDetails();this.h.forEach(h=>{h.updateTelemetryEnablements(m.isUsageEnabled,m.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(d,m){const h=this.h.get(d.value);return h?(h.logError(m),!0):!1}};P=qe([He(0,A.IExtHostInitDataService),He(1,I.ILoggerService)],P),e.ExtHostTelemetry=P;class E{constructor(d,m,h,b,p,g){this.e=m,this.f=h,this.g=b,this.h=p,this.b=new t.Emitter,this.a=d,this.c={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(d,m){this.d&&(this.c={isUsageEnabled:d,isErrorsEnabled:m},this.b.fire(this.d))}mixInCommonPropsAndCleanData(d){let m=d.properties??d;return m=(0,S.cleanData)(m,[]),this.a.additionalCommonProperties&&(m=(0,y.mixin)(m,this.a.additionalCommonProperties)),this.a.ignoreBuiltInCommonProperties||(m=(0,y.mixin)(m,this.h)),d.properties?d.properties=m:d=m,d}i(d,m){this.e.publisher==="vscode"?d=this.e.name+"/"+d:d=this.e.identifier.value+"/"+d,m=this.mixInCommonPropsAndCleanData(m||{}),this.g||this.a.logEvent(d,m),this.f.trace(d,m)}logUsage(d,m){!this.c.isUsageEnabled||this.i(d,m)}logError(d,m){!this.c.isErrorsEnabled||(typeof d=="string"?this.i(d,m):this.a.logException(d,m))}get apiTelemetryLogger(){if(!this.d){const d=this,m={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.c.isUsageEnabled},get isErrorsEnabled(){return d.c.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.b.event.bind(d)};this.d=Object.freeze(m)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=E;function D(v){const d=Date.now()-new Date(v).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=D,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(Se[26],ye([1,0,4,2,3,27,203]),function(ne,e,c,t,I,A,C){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");class S{constructor(a){this.affinity=a,this.kind=1}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class y{constructor(a){this.affinity=a,this.kind=2}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=y;class L{constructor(){this.kind=3,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class P{constructor(a){this.dependency=a}}e.MissingExtensionDependency=P;var E;(function(o){o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));function D(o){if(o===null)return"None";switch(o){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=D;class v{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(a,n){const i=[],f=[],k=[],R=[],B=h(this.c),X=h(a),q=(z,U)=>z.extensionLocation.toString()===U.extensionLocation.toString()||z.isBuiltin===U.isBuiltin||z.isUserBuiltin===U.isUserBuiltin||z.isUnderDevelopment===U.isUnderDevelopment;for(const z of this.c){const U=X.get(A.ExtensionIdentifier.toKey(z.identifier));if(!U){i.push(z.identifier),B.delete(A.ExtensionIdentifier.toKey(z.identifier));continue}if(!q(z,U)){i.push(z.identifier),B.delete(A.ExtensionIdentifier.toKey(z.identifier));continue}}for(const z of a){const U=B.get(A.ExtensionIdentifier.toKey(z.identifier));if(!U){f.push(z);continue}if(!q(U,z)){i.push(U.identifier),B.delete(A.ExtensionIdentifier.toKey(U.identifier));continue}}const N=m(this.d),M=m(n);for(const z of this.d)M.has(A.ExtensionIdentifier.toKey(z))||k.push(z);for(const z of n)N.has(A.ExtensionIdentifier.toKey(z))||R.push(z);const F={toRemove:i,toAdd:f,myToRemove:k,myToAdd:R};return this.delta(F),F}delta(a){const{toRemove:n,toAdd:i,myToRemove:f,myToAdd:k}=a,R=m(n),B=m(f);for(let X=0;X<this.c.length;X++)R.has(A.ExtensionIdentifier.toKey(this.c[X].identifier))&&(this.c.splice(X,1),X--);for(let X=0;X<this.d.length;X++)B.has(A.ExtensionIdentifier.toKey(this.d[X]))&&(this.d.splice(X,1),X--);for(const X of i)this.c.push(X);for(const X of k)this.d.push(X)}containsExtension(a){for(const n of this.d)if(A.ExtensionIdentifier.equals(n,a))return!0;return!1}}e.ExtensionHostExtensions=v;class d{constructor(a){if(this[T]="ExtensionIdentifierSet",this.c=new Map,this.d=A.ExtensionIdentifier.toKey,a)for(const n of a)this.add(n)}get size(){return this.c.size}add(a){return this.c.set(this.d(a),a),this}clear(){this.c.clear()}delete(a){return this.c.delete(this.d(a))}has(a){return this.c.has(this.d(a))}forEach(a,n){this.c.forEach(i=>a.call(n,i,i,this))}*entries(){for(const[a,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=d;function m(o){const a=new Set;for(const n of o)a.add(A.ExtensionIdentifier.toKey(n));return a}e.extensionIdentifiersArrayToSet=m;function h(o){const a=new Map;for(const n of o)a.set(A.ExtensionIdentifier.toKey(n.identifier),n);return a}function b(o,a){return o.enabledApiProposals?o.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=b;function p(o,a){if(!b(o,a))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=p;class g{constructor(a,n,i,f){this.codeLoadingTime=a,this.activateCallTime=n,this.activateResolvedTime=i,this.activationReason=f}}e.ActivationTimes=g;class w{constructor(a,n){this.description=a,this.value=n}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function r(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function l(o,a){return{identifier:new A.ExtensionIdentifier((0,C.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!a,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,browserNlsBundleUris:o.browserNlsBundleUris}}e.toExtensionDescription=l;class u{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a,n){return Promise.resolve(0)}getInspectPorts(a,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u}),define(Se[229],ye([1,0,10,134,27,26,13,18]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(h,b,p,g){this.startup=h,this.codeLoadingTime=b,this.activateCallTime=p,this.activateResolvedTime=g}}e.ExtensionActivationTimes=S,S.NONE=new S(!1,-1,-1,-1);class y{constructor(h){this.a=h,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(h,b){return h===-1||b===-1?-1:b-h}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=y;class L{constructor(h,b,p,g,w,s){this.activationFailed=h,this.activationFailedError=b,this.activationTimes=p,this.module=g,this.exports=w,this.subscriptions=s}}e.ActivatedExtension=L;class P extends L{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class E extends L{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=E;class D extends L{constructor(h){super(!0,h,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(h,b,p,g){this.g=g,this.a=h,this.b=b,this.c=p,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[h,b]of this.d)b.dispose()}isActivated(h){const b=this.d.get(I.ExtensionIdentifier.toKey(h));return Boolean(b&&b.value)}getActivatedExtension(h){const b=this.d.get(I.ExtensionIdentifier.toKey(h));if(!b||!b.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return b.value}async activateByEvent(h,b){if(this.f[h])return;const p=this.a.getExtensionDescriptionsForActivationEvent(h);await this.h(p.map(g=>({id:g.identifier,reason:{startup:b,extensionId:g.identifier,activationEvent:h}}))),this.f[h]=!0}activateById(h,b){const p=this.a.getExtensionDescription(h);if(!p)throw new Error(`Extension '${h}' is not known`);return this.h([{id:p.identifier,reason:b}])}async h(h){const b=h.filter(p=>!this.isActivated(p.id)).map(p=>this.j(p));await Promise.all(b.map(p=>p.wait()))}j(h){if(this.d.has(I.ExtensionIdentifier.toKey(h.id)))return this.d.get(I.ExtensionIdentifier.toKey(h.id));if(this.l(h.id))return this.k(h,null,[],null);const b=this.a.getExtensionDescription(h.id);if(!b){const w=new Error(`Cannot activate unknown extension '${h.id.value}'`),s=this.k(h,null,[],new D(w));return this.c.onExtensionActivationError(h.id,w,new A.MissingExtensionDependency(h.id.value)),s}const p=[],g=typeof b.extensionDependencies>"u"?[]:b.extensionDependencies;for(const w of g){if(this.m(w))continue;const s=this.d.get(I.ExtensionIdentifier.toKey(w));if(s){p.push(s);continue}if(this.l(w)){p.push(this.j({id:this.b.getExtensionDescription(w).identifier,reason:h.reason}));continue}const r=this.a.getExtensionDescription(w);if(r){if(!r.main&&!r.browser)continue;p.push(this.j({id:r.identifier,reason:h.reason}));continue}const l=b.displayName||b.identifier.value,u=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${w}'`),o=this.k(h,b.displayName,[],new D(u));return this.c.onExtensionActivationError(b.identifier,u,new A.MissingExtensionDependency(w)),o}return this.k(h,b.displayName,p,null)}k(h,b,p,g){const w=new d(h.id,b,h.reason,p,g,this.c,this.g);return this.d.set(I.ExtensionIdentifier.toKey(h.id),w),w}l(h){return t.ExtensionDescriptionRegistry.isHostExtension(h,this.a,this.b)}m(h){const b=this.b.getExtensionDescription(h);return b?!b.main&&!b.browser:!1}};v=qe([He(3,C.ILogService)],v),e.ExtensionsActivator=v;let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(h,b,p,g,w,s,r){this.c=h,this.d=b,this.f=p,this.g=g,this.h=w,this.j=s,this.k=r,this.a=new T.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let h=0;h<this.g.length;h++){const b=this.g[h];if(b.value&&!b.value.activationFailed){this.g.splice(h,1),h--;continue}if(b.value&&b.value.activationFailed){const p=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${b.friendlyName}' failed to activate`);p.detail=b.value.activationFailedError,this.h=new D(p),this.j.onExtensionActivationError(this.c,p,null);return}}this.g.length>0&&await Promise.race(this.g.map(h=>h.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(h){const b=new Error;if(h&&h.name&&(b.name=h.name),h&&h.message?b.message=`Activating extension '${this.c.value}' failed: ${h.message}.`:b.message=`Activating extension '${this.c.value}' failed: ${h}.`,h&&h.stack&&(b.stack=h.stack),this.h=new D(b),this.b&&c.isCancellationError(h))return;this.j.onExtensionActivationError(this.c,b,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(h)}}};d=qe([He(6,C.ILogService)],d)}),define(Se[230],ye([1,0,13,25,26]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends c.LogService{constructor(T,S){super(T.createLogger(S.logFile,{name:I.ExtensionHostLogFileName}))}};A=qe([He(0,c.ILoggerService),He(1,t.IExtHostInitDataService)],A),e.ExtHostLogService=A});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,c):I?I.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[7],ye([1,0,17,10,110,28,83,8,11,2,30,38,127,90,26]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v){"use strict";var d,m,h,b,p,g,w,s,r,l,u,o,a,n,i,f,k,R,B,X,q,N,M;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(G){return Object.assign(G,{apply:function(){const fe=arguments.length===1?[]:arguments[1];return Reflect.construct(G,fe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[fe,...Te]=arguments;return Reflect.construct(G,Te,fe.constructor)}}})}var z;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(z=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var U;(function(G){G[G.Command=0]="Command",G[G.Opener=1]="Opener"})(U=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let W=g=class{static from(...j){let fe=j;return new g(function(){if(fe){for(const Te of fe)Te&&typeof Te.dispose=="function"&&Te.dispose();fe=void 0}})}constructor(j){d.set(this,void 0),Je(this,d,j,"f")}dispose(){typeof Me(this,d,"f")=="function"&&(Me(this,d,"f").call(this),Je(this,d,void 0,"f"))}};d=new WeakMap,W=g=qe([F],W),e.Disposable=W;let x=w=class{static Min(...j){if(j.length===0)throw new TypeError;let fe=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isBefore(fe)&&(fe=Ke)}return fe}static Max(...j){if(j.length===0)throw new TypeError;let fe=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isAfter(fe)&&(fe=Ke)}return fe}static isPosition(j){if(!j)return!1;if(j instanceof w)return!0;const{line:fe,character:Te}=j;return typeof fe=="number"&&typeof Te=="number"}static of(j){if(j instanceof w)return j;if(this.isPosition(j))return new w(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,fe){if(j<0)throw(0,t.illegalArgument)("line must be non-negative");if(fe<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=j,this.e=fe}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,fe=0){if(j===null||fe===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=0:typeof j=="number"?Te=j:(Te=typeof j.lineDelta=="number"?j.lineDelta:0,fe=typeof j.characterDelta=="number"?j.characterDelta:0),Te===0&&fe===0?this:new w(this.line+Te,this.character+fe)}with(j,fe=this.character){if(j===null||fe===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=this.line:typeof j=="number"?Te=j:(Te=typeof j.line=="number"?j.line:this.line,fe=typeof j.character=="number"?j.character:this.character),Te===this.line&&fe===this.character?this:new w(Te,fe)}toJSON(){return{line:this.line,character:this.character}}};x=w=qe([F],x),e.Position=x;let V=s=class{static isRange(j){return j instanceof s?!0:j?x.isPosition(j.start)&&x.isPosition(j.end):!1}static of(j){if(j instanceof s)return j;if(this.isRange(j))return new s(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,fe,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new x(j,fe),ct=new x(Te,Ke)):x.isPosition(j)&&x.isPosition(fe)&&(Ye=x.of(j),ct=x.of(fe)),!Ye||!ct)throw new Error("Invalid arguments");Ye.isBefore(ct)?(this.c=Ye,this.e=ct):(this.c=ct,this.e=Ye)}contains(j){return s.isRange(j)?this.contains(j.start)&&this.contains(j.end):x.isPosition(j)?!(x.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const fe=x.Max(j.start,this.c),Te=x.Min(j.end,this.e);if(!fe.isAfter(Te))return new s(fe,Te)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const fe=x.Min(j.start,this.c),Te=x.Max(j.end,this.end);return new s(fe,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,fe=this.end){if(j===null||fe===null)throw(0,t.illegalArgument)();let Te;return j?x.isPosition(j)?Te=j:(Te=j.start||this.start,fe=j.end||this.end):Te=this.start,Te.isEqual(this.c)&&fe.isEqual(this.end)?this:new s(Te,fe)}toJSON(){return[this.start,this.end]}};V=s=qe([F],V),e.Range=V;let _=r=class extends V{static isSelection(j){return j instanceof r?!0:j?V.isRange(j)&&x.isPosition(j.anchor)&&x.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,fe,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new x(j,fe),ct=new x(Te,Ke)):x.isPosition(j)&&x.isPosition(fe)&&(Ye=x.of(j),ct=x.of(fe)),!Ye||!ct)throw new Error("Invalid arguments");super(Ye,ct),this.f=Ye,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};_=r=qe([F],_),e.Selection=_;class Q{constructor(j,fe,Te){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("host");if(typeof fe!="number"||fe===0||Math.round(fe)!==fe)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=j,this.port=Math.round(fe),this.connectionToken=Te}}e.ResolvedAuthority=Q;class J extends Error{static NotAvailable(j,fe){return new J(j,E.RemoteAuthorityResolverErrorCode.NotAvailable,fe)}static TemporarilyNotAvailable(j){return new J(j,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,fe=E.RemoteAuthorityResolverErrorCode.Unknown,Te){super(j),this._message=j,this._code=fe,this._detail=Te,Object.setPrototypeOf(this,J.prototype)}}e.RemoteAuthorityResolverError=J;var te;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(te=e.EndOfLine||(e.EndOfLine={}));var le;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(le=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Z=l=class{static isTextEdit(j){return j instanceof l?!0:j?V.isRange(j)&&typeof j.newText=="string":!1}static replace(j,fe){return new l(j,fe)}static insert(j,fe){return l.replace(new V(j,j),fe)}static delete(j){return l.replace(j,"")}static setEndOfLine(j){const fe=new l(new V(new x(0,0),new x(0,0)),"");return fe.newEol=j,fe}get range(){return this.c}set range(j){if(j&&!V.isRange(j))throw(0,t.illegalArgument)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,t.illegalArgument)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,t.illegalArgument)("newEol");this.f=j}constructor(j,fe){this.c=j,this.e=fe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};Z=l=qe([F],Z),e.TextEdit=Z;let ge=u=class{static isNotebookCellEdit(j){return j instanceof u?!0:j?Gt.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,fe){return new u(j,fe)}static insertCells(j,fe){return new u(new Gt(j,j),fe)}static deleteCells(j){return new u(j,[])}static updateCellMetadata(j,fe){const Te=new u(new Gt(j,j),[]);return Te.newCellMetadata=fe,Te}static updateNotebookMetadata(j){const fe=new u(new Gt(0,0),[]);return fe.newNotebookMetadata=j,fe}constructor(j,fe){this.range=j,this.newCells=fe}};ge=u=qe([F],ge),e.NotebookEdit=ge;class ve{static isSnippetTextEdit(j){return j instanceof ve?!0:j?V.isRange(j.range)&&ze.isSnippetString(j.snippet):!1}static replace(j,fe){return new ve(j,fe)}static insert(j,fe){return ve.replace(new V(j,j),fe)}constructor(j,fe){this.range=j,this.snippet=fe}}e.SnippetTextEdit=ve;var De;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(De=e.FileEditType||(e.FileEditType={}));let Re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,fe,Te,Ke){this.c.push({_type:1,from:j,to:fe,options:Te,metadata:Ke})}createFile(j,fe,Te){this.c.push({_type:1,from:void 0,to:j,options:fe,metadata:Te})}deleteFile(j,fe,Te){this.c.push({_type:1,from:j,to:void 0,options:fe,metadata:Te})}e(j,fe,Te){this.c.push({_type:3,metadata:Te,uri:j,edit:{editType:5,metadata:fe},notebookMetadata:fe})}f(j,fe,Te,Ke){const Ye=fe.start,ct=fe.end;(Ye!==ct||Te.length>0)&&this.c.push({_type:5,uri:j,index:Ye,count:ct-Ye,cells:Te,metadata:Ke})}g(j,fe,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:j,edit:{editType:8,index:fe,metadata:Te}})}replace(j,fe,Te,Ke){this.c.push({_type:2,uri:j,edit:new Z(fe,Te),metadata:Ke})}insert(j,fe,Te,Ke){this.replace(j,new V(fe,fe),Te,Ke)}delete(j,fe,Te){this.replace(j,fe,"",Te)}has(j){return this.c.some(fe=>fe._type===2&&fe.uri.toString()===j.toString())}set(j,fe){if(fe)for(const Te of fe){if(!Te)continue;let Ke,Ye;Array.isArray(Te)?(Ke=Te[0],Ye=Te[1]):Ke=Te,ge.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(j,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(j,Ke.newNotebookMetadata,Ye):this.f(j,Ke.range,Ke.newCells,Ye):ve.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:j,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:j,edit:Ke,metadata:Ye})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===j.toString()&&(this.c[Te]=void 0);break}}(0,c.coalesceInPlace)(this.c)}}get(j){const fe=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===j.toString()&&fe.push(Te.edit);return fe}entries(){const j=new A.ResourceMap;for(const fe of this.c)if(fe._type===2){let Te=j.get(fe.uri);Te||(Te=[fe.uri,[]],j.set(fe.uri,Te)),Te[1].push(fe.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Re=qe([F],Re),e.WorkspaceEdit=Re;let ze=o=class{static isSnippetString(j){return j instanceof o?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=o.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,fe=this.e++){if(typeof j=="function"){const Te=new o;Te.e=this.e,j(Te),this.e=Te.e,j=Te.value}else j=o.c(j);return this.value+="${",this.value+=fe,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,fe=this.e++){const Te=j.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=fe,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(j,fe){if(typeof fe=="function"){const Te=new o;Te.e=this.e,fe(Te),this.e=Te.e,fe=Te.value}else typeof fe=="string"&&(fe=fe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,fe&&(this.value+=":",this.value+=fe),this.value+="}",this}};ze=o=qe([F],ze),e.SnippetString=ze;var se;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let he=a=class{static isLocation(j){return j instanceof a?!0:j?V.isRange(j.range)&&y.URI.isUri(j.uri):!1}constructor(j,fe){if(this.uri=j,fe)if(V.isRange(fe))this.range=V.of(fe);else if(x.isPosition(fe))this.range=new V(fe,fe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};he=a=qe([F],he),e.Location=he;let ee=class{static is(j){return j?typeof j.message=="string"&&j.location&&V.isRange(j.location.range)&&y.URI.isUri(j.location.uri):!1}constructor(j,fe){this.location=j,this.message=fe}static isEqual(j,fe){return j===fe?!0:!j||!fe?!1:j.message===fe.message&&j.location.range.isEqual(fe.location.range)&&j.location.uri.toString()===fe.location.uri.toString()}};ee=qe([F],ee),e.DiagnosticRelatedInformation=ee;let oe=class{constructor(j,fe,Te=ue.Error){if(!V.isRange(j))throw new TypeError("range must be set");if(!fe)throw new TypeError("message must be set");this.range=j,this.message=fe,this.severity=Te}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,fe){return j===fe?!0:!j||!fe?!1:j.message===fe.message&&j.severity===fe.severity&&j.code===fe.code&&j.severity===fe.severity&&j.source===fe.source&&j.range.isEqual(fe.range)&&(0,c.equals)(j.tags,fe.tags)&&(0,c.equals)(j.relatedInformation,fe.relatedInformation,ee.isEqual)}};oe=qe([F],oe),e.Diagnostic=oe;let ie=class{constructor(j,fe){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=fe}};ie=qe([F],ie),e.Hover=ie;var O;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(O=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let H=class{constructor(j,fe=O.Text){this.range=j,this.kind=fe}toJSON(){return{range:this.range,kind:O[this.kind]}}};H=qe([F],H),e.DocumentHighlight=H;var K;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(K=e.SymbolKind||(e.SymbolKind={}));var Y;(function(G){G[G.Deprecated=1]="Deprecated"})(Y=e.SymbolTag||(e.SymbolTag={}));let de=n=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,fe,Te,Ke,Ye){this.name=j,this.kind=fe,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ke instanceof he?this.location=Ke:Te instanceof V&&(this.location=new he(Ke,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:K[this.kind],location:this.location,containerName:this.containerName}}};de=n=qe([F],de),e.SymbolInformation=de;let be=i=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(i.validate)}constructor(j,fe,Te,Ke,Ye){this.name=j,this.detail=fe,this.kind=Te,this.range=Ke,this.selectionRange=Ye,this.children=[],i.validate(this)}};be=i=qe([F],be),e.DocumentSymbol=be;var Pe;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(j,fe){this.title=j,this.kind=fe}};pe=qe([F],pe),e.CodeAction=pe;let Ce=f=class{constructor(j){this.value=j}append(j){return new f(this.value?this.value+f.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+f.c)}};Ce.c=".",Ce=f=qe([F],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let ke=class{constructor(j,fe){if(this.range=j,this.parent=fe,fe&&!fe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=qe([F],ke),e.SelectionRange=ke;class je{constructor(j,fe,Te,Ke,Ye,ct){this.kind=j,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.CallHierarchyItem=je;class Ge{constructor(j,fe){this.fromRanges=fe,this.from=j}}e.CallHierarchyIncomingCall=Ge;class et{constructor(j,fe){this.fromRanges=fe,this.to=j}}e.CallHierarchyOutgoingCall=et;var _e;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(_e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(j,fe){this.range=j,this.command=fe}get isResolved(){return!!this.command}};nt=qe([F],nt),e.CodeLens=nt;let st=k=class{static isMarkdownString(j){return j instanceof k?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,fe=!1){m.set(this,void 0),Je(this,m,new I.MarkdownString(j,{supportThemeIcons:fe}),"f")}get value(){return Me(this,m,"f").value}set value(j){Me(this,m,"f").value=j}get isTrusted(){return Me(this,m,"f").isTrusted}set isTrusted(j){Me(this,m,"f").isTrusted=j}get supportThemeIcons(){return Me(this,m,"f").supportThemeIcons}set supportThemeIcons(j){Me(this,m,"f").supportThemeIcons=j}get supportHtml(){return Me(this,m,"f").supportHtml}set supportHtml(j){Me(this,m,"f").supportHtml=j}get baseUri(){return Me(this,m,"f").baseUri}set baseUri(j){Me(this,m,"f").baseUri=j}appendText(j){return Me(this,m,"f").appendText(j),this}appendMarkdown(j){return Me(this,m,"f").appendMarkdown(j),this}appendCodeblock(j,fe){return Me(this,m,"f").appendCodeblock(fe??"",j),this}};m=new WeakMap,st=k=qe([F],st),e.MarkdownString=st;let ht=class{constructor(j,fe){this.label=j,this.documentation=fe}};ht=qe([F],ht),e.ParameterInformation=ht;let Fe=class{constructor(j,fe){this.label=j,this.documentation=fe,this.parameters=[]}};Fe=qe([F],Fe),e.SignatureInformation=Fe;let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};it=qe([F],it),e.SignatureHelp=it;var ae;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ae=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})($=e.InlayHintKind||(e.InlayHintKind={}));let ce=class{constructor(j){this.value=j}};ce=qe([F],ce),e.InlayHintLabelPart=ce;let Ie=class{constructor(j,fe,Te){this.position=j,this.label=fe,this.kind=Te}};Ie=qe([F],Ie),e.InlayHint=Ie;var Le;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var xe;(function(G){G[G.Deprecated=1]="Deprecated"})(xe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(j,fe){this.label=j,this.kind=fe}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([F],Ze),e.CompletionItem=Ze;let mt=class{constructor(j=[],fe=!1){this.items=j,this.isIncomplete=fe}};mt=qe([F],mt),e.CompletionList=mt;let ft=class{constructor(j,fe,Te){this.insertText=j,this.range=fe,this.command=Te}};ft=qe([F],ft),e.InlineSuggestion=ft;let lt=class{constructor(j){this.commands=void 0,this.items=j}};lt=qe([F],lt),e.InlineSuggestionList=lt;var ot;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var rt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Tt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(Tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Pt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var gt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(gt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var It;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(It=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Bt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Bt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function j(fe){switch(fe){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=j}(gt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Mt=class{constructor(j,fe){if(fe&&!y.URI.isUri(fe))throw(0,t.illegalArgument)("target");if(!V.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.target=fe}};Mt=qe([F],Mt),e.DocumentLink=Mt;let Xe=class{constructor(j,fe,Te,Ke){this.red=j,this.green=fe,this.blue=Te,this.alpha=Ke}};Xe=qe([F],Xe),e.Color=Xe;let Rt=class{constructor(j,fe){if(fe&&!(fe instanceof Xe))throw(0,t.illegalArgument)("color");if(!V.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.color=fe}};Rt=qe([F],Rt),e.ColorInformation=Rt;let Ut=class{constructor(j){if(!j||typeof j!="string")throw(0,t.illegalArgument)("label");this.label=j}};Ut=qe([F],Ut),e.ColorPresentation=Ut;var Ht;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Ht=e.ColorFormat||(e.ColorFormat={}));var pt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(pt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var At;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(At=e.TerminalExitReason||(e.TerminalExitReason={}));class Ae{constructor(j,fe,Te){if(this.startIndex=j,this.length=fe,this.tooltip=Te,typeof j!="number"||j<0)throw(0,t.illegalArgument)("startIndex");if(typeof fe!="number"||fe<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Ae;class Oe{constructor(j){this.uri=j}}e.TerminalQuickFixOpener=Oe;class Ee{constructor(j){this.terminalCommand=j}}e.TerminalQuickFixCommand=Ee;var re;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(re=e.TerminalLocation||(e.TerminalLocation={}));class Ne{constructor(j){if(this.options=j,typeof j!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ne;var $e;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})($e=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=R=class{static from(j){switch(j){case"clean":return R.Clean;case"build":return R.Build;case"rebuild":return R.Rebuild;case"test":return R.Test;default:return}}constructor(j,fe){if(this.label=fe,typeof j!="string"||typeof fe!="string")throw(0,t.illegalArgument)("name");this.c=j}get id(){return this.c}};Ve.Clean=new R("clean","Clean"),Ve.Build=new R("build","Build"),Ve.Rebuild=new R("rebuild","Rebuild"),Ve.Test=new R("test","Test"),Ve=R=qe([F],Ve),e.TaskGroup=Ve;function tt(G){let j="";for(let fe=0;fe<G.length;fe++)j+=G[fe].replace(/,/g,",,")+",";return j}let St=class{constructor(j,fe,Te){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=j,fe!==void 0&&(Array.isArray(fe)?(this.e=fe,this.f=Te):this.f=fe)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const fe of this.e)j.push(fe);return tt(j)}};St=qe([F],St),e.ProcessExecution=St;let yt=class{constructor(j,fe,Te){if(this.f=[],Array.isArray(fe)){if(!j)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j,this.f=fe,this.g=Te}else{if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j,this.g=fe}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const fe of this.f)j.push(typeof fe=="string"?fe:fe.value);return tt(j)}};yt=qe([F],yt),e.ShellExecution=yt;var kt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(kt=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class Et{constructor(j){this.c=j}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(j){this.c=j}get callback(){return this.c}}e.CustomExecution=Et;let bt=B=class{constructor(j,fe,Te,Ke,Ye,ct){this.j=!1,this.k=this.definition=j;let dt;typeof fe=="string"?(this.m=this.name=fe,this.t=this.source=Te,this.execution=Ke,dt=Ye,this.j=!0):fe===vt.Global||fe===vt.Workspace?(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct):(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(j){this.h=j}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof St?this.k={type:B.e,id:this.n.computeId()}:this.n instanceof yt?this.k={type:B.f,id:this.n.computeId()}:this.n instanceof Et?this.k={type:B.c,id:this.n.computeId()}:this.k={type:B.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(j){if(j==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=j}get scope(){return this.l}set target(j){this.y(),this.l=j}get name(){return this.m}set name(j){if(typeof j!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=j}get execution(){return this.n}set execution(j){j===null&&(j=void 0),this.y(),this.n=j;const fe=this.k.type;(B.g===fe||B.e===fe||B.f===fe||B.c===fe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(j){if(Array.isArray(j))this.y(),this.o=j,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.y(),this.r=j}get source(){return this.t}set source(j){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=j}get group(){return this.u}set group(j){j===null&&(j=void 0),this.y(),this.u=j}get detail(){return this.x}set detail(j){j===null&&(j=void 0),this.x=j}get presentationOptions(){return this.v}set presentationOptions(j){j==null&&(j=Object.create(null)),this.y(),this.v=j}get runOptions(){return this.w}set runOptions(j){j==null&&(j=Object.create(null)),this.y(),this.w=j}};bt.c="customExecution",bt.e="process",bt.f="shell",bt.g="$empty",bt=B=qe([F],bt),e.Task=bt;var jt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(jt=e.ProgressLocation||(e.ProgressLocation={}));var on;(function(G){function j(fe){const Te=fe;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}G.isViewBadge=j})(on=e.ViewBadge||(e.ViewBadge={}));let Ct=X=class{static isTreeItem(j,fe){if(j instanceof X)return!0;const Te=j;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!y.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!y.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!y.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!y.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<tn.None&&Te.collapsibleState>tn.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,v.checkProposedApiEnabled)(fe,"treeItemCheckbox");const Ke=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==an.Checked&&Ke!==an.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(j,fe=tn.None){this.collapsibleState=fe,y.URI.isUri(j)?this.resourceUri=j:this.label=j}};Ct=X=qe([F],Ct),e.TreeItem=Ct;var tn;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(tn=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var an;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(an=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j,fe){this.value=j,this.id=fe??(0,L.generateUuid)()}};Yt=qe([F],Yt),e.DataTransferItem=Yt;let vn=class{constructor(j){h.set(this,new Map);for(const[fe,Te]of j??[]){const Ke=Me(this,h,"f").get(fe);Ke?Ke.push(Te):Me(this,h,"f").set(fe,[Te])}}get(j){return Me(this,h,"f").get(j)?.[0]}set(j,fe){Me(this,h,"f").set(j,[fe])}forEach(j,fe){for(const[Te,Ke]of Me(this,h,"f"))for(const Ye of Ke)j.call(fe,Ye,Te,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[j,fe]of Me(this,h,"f"))for(const Te of fe)yield[j,Te]}};vn=qe([F],vn),e.DataTransfer=vn;let Lt=class{constructor(j){this.insertText=j}};Lt=qe([F],Lt),e.DocumentDropEdit=Lt;let cn=class{constructor(j){this.insertText=j}};cn=qe([F],cn),e.DocumentPasteEdit=cn;let Vt=class{constructor(j,fe){this.id=j,this.color=fe}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};Vt=qe([F],Vt),e.ThemeIcon=Vt,Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let Jt=class{constructor(j){this.id=j}};Jt=qe([F],Jt),e.ThemeColor=Jt;var ln;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(ln=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ut=class{get base(){return this.c}set base(j){this.c=j,this.e=y.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,fe){if(typeof j!="string"&&(!j||!y.URI.isUri(j)&&!y.URI.isUri(j.uri)))throw(0,t.illegalArgument)("base");if(typeof fe!="string")throw(0,t.illegalArgument)("pattern");typeof j=="string"?this.baseUri=y.URI.file(j):y.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=fe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ut=qe([F],ut),e.RelativePattern=ut;let Zt=class{constructor(j,fe,Te,Ke){this.enabled=typeof j=="boolean"?j:!0,typeof fe=="string"&&(this.condition=fe),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,L.generateUuid)()),this.c}};Zt=qe([F],Zt),e.Breakpoint=Zt;let qt=class extends Zt{constructor(j,fe,Te,Ke,Ye){if(super(fe,Te,Ke,Ye),j===null)throw(0,t.illegalArgument)("location");this.location=j}};qt=qe([F],qt),e.SourceBreakpoint=qt;let Xt=class extends Zt{constructor(j,fe,Te,Ke,Ye){super(fe,Te,Ke,Ye),this.functionName=j}};Xt=qe([F],Xt),e.FunctionBreakpoint=Xt;let un=class extends Zt{constructor(j,fe,Te,Ke,Ye,ct,dt){if(super(Ke,Ye,ct,dt),!fe)throw(0,t.illegalArgument)("dataId");this.label=j,this.dataId=fe,this.canPersist=Te}};un=qe([F],un),e.DataBreakpoint=un;let En=class{constructor(j,fe,Te){this.command=j,this.args=fe||[],this.options=Te}};En=qe([F],En),e.DebugAdapterExecutable=En;let dn=class{constructor(j,fe){this.port=j,this.host=fe}};dn=qe([F],dn),e.DebugAdapterServer=dn;let Sn=class{constructor(j){this.path=j}};Sn=qe([F],Sn),e.DebugAdapterNamedPipeServer=Sn;let hn=class{constructor(j){this.implementation=j}};hn=qe([F],hn),e.DebugAdapterInlineImplementation=hn;let en=class{constructor(j,fe){this.range=j,this.expression=fe}};en=qe([F],en),e.EvaluatableExpression=en;var Un;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Un=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let nn=class{constructor(j,fe){this.range=j,this.text=fe}};nn=qe([F],nn),e.InlineValueText=nn;let rn=class{constructor(j,fe,Te=!0){this.range=j,this.variableName=fe,this.caseSensitiveLookup=Te}};rn=qe([F],rn),e.InlineValueVariableLookup=rn;let yn=class{constructor(j,fe){this.range=j,this.expression=fe}};yn=qe([F],yn),e.InlineValueEvaluatableExpression=yn;let Cn=class{constructor(j,fe){this.frameId=j,this.stoppedLocation=fe}};Cn=qe([F],Cn),e.InlineValueContext=Cn;var sn;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(sn=e.FileChangeType||(e.FileChangeType={}));let Dn=q=class extends Error{static FileExists(j){return new q(j,P.FileSystemProviderErrorCode.FileExists,q.FileExists)}static FileNotFound(j){return new q(j,P.FileSystemProviderErrorCode.FileNotFound,q.FileNotFound)}static FileNotADirectory(j){return new q(j,P.FileSystemProviderErrorCode.FileNotADirectory,q.FileNotADirectory)}static FileIsADirectory(j){return new q(j,P.FileSystemProviderErrorCode.FileIsADirectory,q.FileIsADirectory)}static NoPermissions(j){return new q(j,P.FileSystemProviderErrorCode.NoPermissions,q.NoPermissions)}static Unavailable(j){return new q(j,P.FileSystemProviderErrorCode.Unavailable,q.Unavailable)}constructor(j,fe=P.FileSystemProviderErrorCode.Unknown,Te){super(y.URI.isUri(j)?j.toString(!0):j),this.code=Te?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,fe),Object.setPrototypeOf(this,q.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Dn=q=qe([F],Dn),e.FileSystemError=Dn;let In=class{constructor(j,fe,Te){this.start=j,this.end=fe,this.kind=Te}};In=qe([F],In),e.FoldingRange=In;var Bn;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(Bn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var zn;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(zn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var $n;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})($n=e.CommentMode||(e.CommentMode={}));var kn;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(kn=e.CommentThreadState||(e.CommentThreadState={}));class Rn{constructor(j,fe=[]){this.tokenTypes=j,this.tokenModifiers=fe}}e.SemanticTokensLegend=Rn;function Ln(G){return typeof G>"u"||(0,S.isStringArray)(G)}class We{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,j){this.l=!0;for(let fe=0,Te=j.tokenTypes.length;fe<Te;fe++)this.j.set(j.tokenTypes[fe],fe);for(let fe=0,Te=j.tokenModifiers.length;fe<Te;fe++)this.k.set(j.tokenModifiers[fe],fe)}}push(j,fe,Te,Ke,Ye){if(typeof j=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(j,fe,Te,Ke,Ye);if(V.isRange(j)&&typeof fe=="string"&&Ln(Te))return this.m(j,fe,Te);throw(0,t.illegalArgument)()}m(j,fe,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(fe))throw new Error("`tokenType` is not in the provided legend");const Ke=j.start.line,Ye=j.start.character,ct=j.end.character-j.start.character,dt=this.j.get(fe);let Nt=0;if(Te)for(const Wt of Te){if(!this.k.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const Kt=this.k.get(Wt);Nt|=1<<Kt>>>0}this.n(Ke,Ye,ct,dt,Nt)}n(j,fe,Te,Ke,Ye){if(this.f&&(j<this.c||j===this.c&&fe<this.e)){this.f=!1;const Nt=this.g.length/5|0;let Wt=0,Kt=0;for(let xt=0;xt<Nt;xt++){let _t=this.g[5*xt],Pn=this.g[5*xt+1];_t===0?(_t=Wt,Pn+=Kt):_t+=Wt,this.g[5*xt]=_t,this.g[5*xt+1]=Pn,Wt=_t,Kt=Pn}}let ct=j,dt=fe;this.f&&this.h>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=j,this.e=fe}static o(j){const fe=[],Te=j.length/5|0;for(let dt=0;dt<Te;dt++)fe[dt]=dt;fe.sort((dt,Nt)=>{const Wt=j[5*dt],Kt=j[5*Nt];if(Wt===Kt){const xt=j[5*dt+1],_t=j[5*Nt+1];return xt-_t}return Wt-Kt});const Ke=new Uint32Array(j.length);let Ye=0,ct=0;for(let dt=0;dt<Te;dt++){const Nt=5*fe[dt],Wt=j[Nt+0],Kt=j[Nt+1],xt=j[Nt+2],_t=j[Nt+3],Pn=j[Nt+4],ni=Wt-Ye,Ti=ni===0?Kt-ct:Kt,An=5*dt;Ke[An+0]=ni,Ke[An+1]=Ti,Ke[An+2]=xt,Ke[An+3]=_t,Ke[An+4]=Pn,Ye=Wt,ct=Kt}return Ke}build(j){return this.f?new $t(new Uint32Array(this.g),j):new $t(We.o(this.g),j)}}e.SemanticTokensBuilder=We;class $t{constructor(j,fe){this.resultId=fe,this.data=j}}e.SemanticTokens=$t;class On{constructor(j,fe,Te){this.start=j,this.deleteCount=fe,this.data=Te}}e.SemanticTokensEdit=On;class wt{constructor(j,fe){this.resultId=fe,this.edits=j}}e.SemanticTokensEdits=wt;var Wn;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Wn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let fn=class{constructor(){}};fn.Back={iconPath:new Vt("arrow-left")},fn=qe([F],fn),e.QuickInputButtons=fn;var Nn;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Nn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Hn;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Hn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var mn;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(mn=e.ExtensionKind||(e.ExtensionKind={}));class jn{static validate(j){if(typeof j.badge=="string"){let fe=(0,T.nextCharLength)(j.badge,0);if(fe<j.badge.length&&(fe+=(0,T.nextCharLength)(j.badge,fe)),j.badge.length>fe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!Vt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,fe,Te){this.badge=j,this.tooltip=fe,this.color=Te}}e.FileDecoration=jn;let Tn=class{constructor(j){this.kind=j}};Tn=qe([F],Tn),e.ColorTheme=Tn;var Vn;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Vn=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{static isNotebookRange(j){return j instanceof Gt?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,fe){if(j<0)throw(0,t.illegalArgument)("start must be positive");if(fe<0)throw(0,t.illegalArgument)("end must be positive");j<=fe?(this.c=j,this.e=fe):(this.c=fe,this.e=j)}with(j){let fe=this.c,Te=this.e;return j.start!==void 0&&(fe=j.start),j.end!==void 0&&(Te=j.end),fe===this.c&&Te===this.e?this:new Gt(fe,Te)}}e.NotebookRange=Gt;class gn{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(fe=>gn.isNotebookCellData(fe))}static isNotebookCellData(j){return!0}constructor(j,fe,Te,Ke,Ye,ct,dt){this.kind=j,this.value=fe,this.languageId=Te,this.mime=Ke,this.outputs=Ye??[],this.metadata=ct,this.executionSummary=dt,gn.validate(this)}}e.NotebookCellData=gn;class qn{constructor(j){this.cells=j}}e.NotebookData=qn;class zt{static isNotebookCellOutputItem(j){return j instanceof zt?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const fe={name:j.name,message:j.message,stack:j.stack};return zt.json(fe,"application/vnd.code.notebook.error")}static stdout(j){return zt.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return zt.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,fe="application/octet-stream"){return new zt(j,fe)}static text(j,fe=C.Mimes.text){const Te=Me(zt,b,"f",p).encode(String(j));return new zt(Te,fe)}static json(j,fe="text/x-json"){const Te=JSON.stringify(j,void 0,"	");return zt.text(Te,fe)}constructor(j,fe){this.data=j,this.mime=fe;const Te=(0,C.normalizeMimeType)(fe,!0);if(!Te)throw new Error(`INVALID mime type: ${fe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=zt,b=zt,p={value:new TextEncoder};class pn{static isNotebookCellOutput(j){return j instanceof pn?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,fe=!1){const Te=new Set,Ke=new Set;for(let Ye=0;Ye<j.length;Ye++){const ct=j[Ye],dt=(0,C.normalizeMimeType)(ct.mime);if(!Te.has(dt)||(0,D.isTextStreamMime)(dt)){Te.add(dt);continue}Ke.add(Ye),fe&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?j:j.filter((Ye,ct)=>!Ke.has(ct))}constructor(j,fe,Te){this.items=pn.ensureUniqueMimeTypes(j,!0),typeof fe=="string"?(this.id=fe,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=fe??Te)}}e.NotebookCellOutput=pn;var Gn;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Gn=e.NotebookCellKind||(e.NotebookCellKind={}));var Kn;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(Kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var me;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(me=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var we;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(we=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ue{constructor(j,fe){this.text=j,this.alignment=fe}}e.NotebookCellStatusBarItem=Ue;var at;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(at=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Dt;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(Dt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Ot{constructor(j,fe=[]){this.uri=j,this.provides=(0,c.asArray)(fe)}}e.NotebookRendererScript=Ot;class oi{constructor(j){this.label=j}}e.NotebookKernelSourceAction=oi;let xn=class{constructor(j,fe){this.label=j,this.timestamp=fe}};xn=qe([F],xn),e.TimelineItem=xn;var ai;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(ai=e.ExtensionMode||(e.ExtensionMode={}));var ci;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(ci=e.ExtensionRuntime||(e.ExtensionRuntime={}));var li;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(li=e.StandardTokenType||(e.StandardTokenType={}));class ui{constructor(j,fe){this.ranges=j,this.wordPattern=fe}}e.LinkedEditingRanges=ui;class di{constructor(j,fe){this.c=j,this.e=fe}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=di;var hi;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(hi=e.TestResultState||(e.TestResultState={}));var fi;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(fi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Xn=class{constructor(j=void 0,fe=void 0,Te=void 0){this.include=j,this.exclude=fe,this.profile=Te}};Xn=qe([F],Xn),e.TestRunRequest=Xn;let _n=N=class{static diff(j,fe,Te){const Ke=new N(j);return Ke.expectedOutput=fe,Ke.actualOutput=Te,Ke}constructor(j){this.message=j}};_n=N=qe([F],_n),e.TestMessage=_n;let Qn=class{constructor(j){this.id=j}};Qn=qe([F],Qn),e.TestTag=Qn;let bn=class{constructor(j,fe){this.covered=j,this.total=fe}};bn=qe([F],bn),e.CoveredCount=bn;let Yn=M=class{static fromDetails(j,fe){const Te=new bn(0,0),Ke=new bn(0,0),Ye=new bn(0,0);for(const dt of fe)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Nt of dt.branches)Ke.total+=1,Ke.covered+=Nt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ct=new M(j,Te,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ct.detailedCoverage=fe,ct}constructor(j,fe,Te,Ke){this.uri=j,this.statementCoverage=fe,this.branchCoverage=Te,this.functionCoverage=Ke}};Yn=M=qe([F],Yn),e.FileCoverage=Yn;let Jn=class{constructor(j,fe,Te=[]){this.executionCount=j,this.location=fe,this.branches=Te}};Jn=qe([F],Jn),e.StatementCoverage=Jn;let Zn=class{constructor(j,fe){this.executionCount=j,this.location=fe}};Zn=qe([F],Zn),e.BranchCoverage=Zn;let ei=class{constructor(j,fe){this.executionCount=j,this.location=fe}};ei=qe([F],ei),e.FunctionCoverage=ei;var mi;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(mi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var gi;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var pi;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(pi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class bi{constructor(j,fe,Te,Ke,Ye,ct){this.kind=j,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.TypeHierarchyItem=bi;class wi{constructor(j){this.uri=j}}e.TextTabInput=wi;class vi{constructor(j,fe){this.original=j,this.modified=fe}}e.TextDiffTabInput=vi;class Ei{constructor(j,fe,Te,Ke){this.base=j,this.input1=fe,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=Ei;class Si{constructor(j,fe){this.uri=j,this.viewType=fe}}e.CustomEditorTabInput=Si;class yi{constructor(j){this.viewType=j}}e.WebviewEditorTabInput=yi;class Ci{constructor(j,fe){this.uri=j,this.notebookType=fe}}e.NotebookEditorTabInput=Ci;class Di{constructor(j,fe,Te){this.original=j,this.modified=fe,this.notebookType=Te}}e.NotebookDiffEditorTabInput=Di;class Ii{constructor(){}}e.TerminalEditorTabInput=Ii;class ki{constructor(j,fe){this.uri=j,this.inputBoxUri=fe}}e.InteractiveWindowInput=ki}),define(Se[135],ye([1,0,49,15,8,162,104,7,17]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const y=new Map;function L(v,d){d?y.set(v,d):y.delete(v)}e.setWordDefinitionFor=L;function P(v){return y.get(v)}class E extends A.MirrorTextModel{constructor(d,m,h,b,p,g,w,s){super(m,h,b,p),this.m=d,this.p=g,this.q=w,this.notebook=s,this.b=!1}dispose(){(0,c.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,S.equals)(this.d,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.c},get fileName(){return d.c.fsPath},get isUntitled(){return d.c.scheme===t.Schemas.untitled},get languageId(){return d.p},get version(){return d.g},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(m){return m?d.s(m):d.getText()},get eol(){return d.f===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return d.d.length},lineAt(m){return d.t(m)},offsetAt(m){return d.u(m)},positionAt(m){return d.v(m)},validateRange(m){return d.w(m)},validatePosition(m){return d.x(m)},getWordRangeAtPosition(m,h){return d.y(m,h)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,c.ok)(!this.b),this.p=d}_acceptIsDirty(d){(0,c.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(d){const m=this.w(d);if(m.isEmpty)return"";if(m.isSingleLine)return this.d[m.start.line].substring(m.start.character,m.end.character);const h=this.f,b=m.start.line,p=m.end.line,g=[];g.push(this.d[b].substring(m.start.character));for(let w=b+1;w<p;w++)g.push(this.d[w]);return g.push(this.d[p].substring(0,m.end.character)),g.join(h)}t(d){let m;if(d instanceof T.Position?m=d.line:typeof d=="number"&&(m=d),typeof m!="number"||m<0||m>=this.d.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new D(m,this.d[m],m===this.d.length-1)}u(d){return d=this.x(d),this.k(),this.h.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.k();const m=this.h.getIndexOf(d),h=this.d[m.index].length;return new T.Position(m.index,Math.min(m.remainder,h))}w(d){if(!(d instanceof T.Range))throw new Error("Invalid argument");const m=this.x(d.start),h=this.x(d.end);return m===d.start&&h===d.end?d:new T.Range(m.line,m.character,h.line,h.character)}x(d){if(!(d instanceof T.Position))throw new Error("Invalid argument");if(this.d.length===0)return d.with(0,0);let{line:m,character:h}=d,b=!1;if(m<0)m=0,h=0,b=!0;else if(m>=this.d.length)m=this.d.length-1,h=this.d[m].length,b=!0;else{const p=this.d[m].length;h<0?(h=0,b=!0):h>p&&(h=p,b=!0)}return b?new T.Position(m,h):d}y(d,m){const h=this.x(d);if(!m)m=P(this.p);else if((0,I.regExpLeadsToEndlessLoop)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const b=(0,C.getWordAtText)(h.character+1,(0,C.ensureValidWordDefinition)(m),this.d[h.line],0);if(b)return new T.Range(h.line,b.startColumn-1,h.line,b.endColumn-1)}}e.ExtHostDocumentData=E;class D{constructor(d,m,h){this.a=d,this.b=m,this.c=h}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=D}),define(Se[231],ye([1,0,7,16,4]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(T){this.a=new c.ColorTheme(c.ColorThemeKind.Dark),this.b=new I.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(T){let S;switch(T){case"light":S=c.ColorThemeKind.Light;break;case"hcDark":S=c.ColorThemeKind.HighContrast;break;case"hcLight":S=c.ColorThemeKind.HighContrastLight;break;default:S=c.ColorThemeKind.Dark}this.a=new c.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};A=qe([He(0,t.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(Se[14],ye([1,0,17,22,148,61,110,28,147,85,83,23,11,2,35,66,122,132,130,90,56,69,226,7]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b,p,g,w,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(Ae){function Oe(re){const{selectionStartLineNumber:Ne,selectionStartColumn:$e,positionLineNumber:Qe,positionColumn:Ve}=re,tt=new r.Position(Ne-1,$e-1),St=new r.Position(Qe-1,Ve-1);return new r.Selection(tt,St)}Ae.to=Oe;function Ee(re){const{anchor:Ne,active:$e}=re;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}Ae.from=Ee})(l=e.Selection||(e.Selection={}));var u;(function(Ae){function Oe(re){if(!re)return;const{start:Ne,end:$e}=re;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}Ae.from=Oe;function Ee(re){if(!re)return;const{startLineNumber:Ne,startColumn:$e,endLineNumber:Qe,endColumn:Ve}=re;return new r.Range(Ne-1,$e-1,Qe-1,Ve-1)}Ae.to=Ee})(u=e.Range||(e.Range={}));var o;(function(Ae){function Oe(Ee){switch(Ee){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ae.to=Oe})(o=e.TokenType||(e.TokenType={}));var a;(function(Ae){function Oe(re){return new r.Position(re.lineNumber-1,re.column-1)}Ae.to=Oe;function Ee(re){return{lineNumber:re.line+1,column:re.character+1}}Ae.from=Ee})(a=e.Position||(e.Position={}));var n;(function(Ae){function Oe(Ne,$e){return(0,c.coalesce)((0,c.asArray)(Ne).map(Qe=>Ee(Qe,$e)))}Ae.from=Oe;function Ee(Ne,$e){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:re(Ne.scheme,$e),pattern:$.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function re(Ne,$e){return $e&&typeof Ne=="string"?$e.transformOutgoingScheme(Ne):Ne}})(n=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(Ae){function Oe(re){switch(re){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Ee(re){switch(re){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ae.to=Ee})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(Ae){function Oe(re){let Ne;return re.code&&((0,E.isString)(re.code)||(0,E.isNumber)(re.code)?Ne=String(re.code):Ne={value:String(re.code.value),target:re.code.target}),{...u.from(re.range),message:re.message,source:re.source,code:Ne,severity:R.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(k.from),tags:Array.isArray(re.tags)?(0,c.coalesce)(re.tags.map(i.from)):void 0}}Ae.from=Oe;function Ee(re){const Ne=new r.Diagnostic(u.to(re),re.message,R.to(re.severity));return Ne.source=re.source,Ne.code=(0,E.isString)(re.code)?re.code:re.code?.value,Ne.relatedInformation=re.relatedInformation&&re.relatedInformation.map(k.to),Ne.tags=re.tags&&(0,c.coalesce)(re.tags.map(i.to)),Ne}Ae.to=Ee})(f=e.Diagnostic||(e.Diagnostic={}));var k;(function(Ae){function Oe(re){return{...u.from(re.location.range),message:re.message,resource:re.location.uri}}Ae.from=Oe;function Ee(re){return new r.DiagnosticRelatedInformation(new r.Location(re.resource,u.to(re)),re.message)}Ae.to=Ee})(k=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var R;(function(Ae){function Oe(re){switch(re){case r.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}Ae.from=Oe;function Ee(re){switch(re){case m.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ae.to=Ee})(R=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var B;(function(Ae){function Oe(re){return typeof re=="number"&&re>=r.ViewColumn.One?re-1:re===r.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}Ae.from=Oe;function Ee(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Ee})(B=e.ViewColumn||(e.ViewColumn={}));function X(Ae){return typeof Ae.range<"u"}function q(Ae){return Ae.length===0?!0:!!X(Ae[0])}e.isDecorationOptionsArr=q;var N;(function(Ae){function Oe(Ve){return Ve.map(Ae.from)}Ae.fromMany=Oe;function Ee(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function re(Ve){let tt;if(Ee(Ve)){const{language:vt,value:Et}=Ve;tt={value:"```"+vt+`
`+Et+"\n```\n"}}else r.MarkdownString.isMarkdownString(Ve)?tt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?tt={value:Ve}:tt={value:""};const St=Object.create(null);tt.uris=St;const yt=vt=>{try{let Et=D.URI.parse(vt,!0);Et=Et.with({query:Ne(Et.query,St)}),St[vt]=Et}catch{}return""},kt=new S.marked.Renderer;return kt.link=yt,kt.image=vt=>typeof vt=="string"?yt(C.parseHrefAndDimensions(vt).href):"",(0,S.marked)(tt.value,{renderer:kt}),tt}Ae.from=re;function Ne(Ve,tt){if(!Ve)return Ve;let St;try{St=(0,y.parse)(Ve)}catch{}if(!St)return Ve;let yt=!1;return St=(0,P.cloneAndChange)(St,kt=>{if(D.URI.isUri(kt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[vt]=kt,yt=!0,vt}else return}),yt?JSON.stringify(St):Ve}function $e(Ve){const tt=new r.MarkdownString(Ve.value,Ve.supportThemeIcons);return tt.isTrusted=Ve.isTrusted,tt.supportHtml=Ve.supportHtml,tt.baseUri=Ve.baseUri?D.URI.from(Ve.baseUri):void 0,tt}Ae.to=$e;function Qe(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Ae.from(Ve)}Ae.fromStrict=Qe})(N=e.MarkdownString||(e.MarkdownString={}));function M(Ae){return q(Ae)?Ae.map(Oe=>({range:u.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?N.fromMany(Oe.hoverMessage):Oe.hoverMessage?N.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:u.from(Oe)}))}e.fromRangeOrRangeWithMessage=M;function F(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?D.URI.file(Ae):Ae}e.pathOrURIToURI=F;var z;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?F(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Ae.from=Oe})(z=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?F(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?z.from(Ee.before):void 0,after:Ee.after?z.from(Ee.after):void 0}}Ae.from=Oe})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var W;(function(Ae){function Oe(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(W=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(Ae){function Oe(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?W.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?U.from(Ee.light):void 0,dark:Ee.dark?U.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?F(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?z.from(Ee.before):void 0,after:Ee.after?z.from(Ee.after):void 0}}Ae.from=Oe})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Ae){function Oe(re){return{text:re.newText,eol:re.newEol&&st.from(re.newEol),range:u.from(re.range)}}Ae.from=Oe;function Ee(re){const Ne=new r.TextEdit(u.to(re.range),re.text);return Ne.newEol=typeof re.eol>"u"?void 0:st.to(re.eol),Ne}Ae.to=Ee})(V=e.TextEdit||(e.TextEdit={}));var _;(function(Ae){function Oe(re,Ne){const $e={edits:[]};if(re instanceof r.WorkspaceEdit){const Qe=new T.ResourceSet;for(const Ve of re._allEntries())Ve._type===1&&D.URI.isUri(Ve.to)&&Ve.from===void 0&&Qe.add(Ve.to);for(const Ve of re._allEntries())Ve._type===1?$e.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?$e.edits.push({resource:Ve.uri,textEdit:V.from(Ve.edit),versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?$e.edits.push({resource:Ve.uri,textEdit:{range:u.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(mt.from)}})}return $e}Ae.from=Oe;function Ee(re){const Ne=new r.WorkspaceEdit;for(const $e of re.edits)$e.textEdit?Ne.replace(D.URI.revive($e.resource),u.to($e.textEdit.range),$e.textEdit.text):Ne.renameFile(D.URI.revive($e.oldResource),D.URI.revive($e.newResource),$e.options);return Ne}Ae.to=Ee})(_=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(Ae){const Oe=Object.create(null);Oe[r.SymbolKind.File]=0,Oe[r.SymbolKind.Module]=1,Oe[r.SymbolKind.Namespace]=2,Oe[r.SymbolKind.Package]=3,Oe[r.SymbolKind.Class]=4,Oe[r.SymbolKind.Method]=5,Oe[r.SymbolKind.Property]=6,Oe[r.SymbolKind.Field]=7,Oe[r.SymbolKind.Constructor]=8,Oe[r.SymbolKind.Enum]=9,Oe[r.SymbolKind.Interface]=10,Oe[r.SymbolKind.Function]=11,Oe[r.SymbolKind.Variable]=12,Oe[r.SymbolKind.Constant]=13,Oe[r.SymbolKind.String]=14,Oe[r.SymbolKind.Number]=15,Oe[r.SymbolKind.Boolean]=16,Oe[r.SymbolKind.Array]=17,Oe[r.SymbolKind.Object]=18,Oe[r.SymbolKind.Key]=19,Oe[r.SymbolKind.Null]=20,Oe[r.SymbolKind.EnumMember]=21,Oe[r.SymbolKind.Struct]=22,Oe[r.SymbolKind.Event]=23,Oe[r.SymbolKind.Operator]=24,Oe[r.SymbolKind.TypeParameter]=25;function Ee(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Ae.from=Ee;function re(Ne){for(const $e in Oe)if(Oe[$e]===Ne)return Number($e);return r.SymbolKind.Property}Ae.to=re})(Q=e.SymbolKind||(e.SymbolKind={}));var J;(function(Ae){function Oe(re){switch(re){case r.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Ee(re){switch(re){case 1:return r.SymbolTag.Deprecated}}Ae.to=Ee})(J=e.SymbolTag||(e.SymbolTag={}));var te;(function(Ae){function Oe(re){return{name:re.name,kind:Q.from(re.kind),tags:re.tags&&re.tags.map(J.from),containerName:re.containerName,location:De.from(re.location)}}Ae.from=Oe;function Ee(re){const Ne=new r.SymbolInformation(re.name,Q.to(re.kind),re.containerName,De.to(re.location));return Ne.tags=re.tags&&re.tags.map(J.to),Ne}Ae.to=Ee})(te=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(Ae){function Oe(re){const Ne={name:re.name||"!!MISSING: name!!",detail:re.detail,range:u.from(re.range),selectionRange:u.from(re.selectionRange),kind:Q.from(re.kind),tags:re.tags?.map(J.from)??[]};return re.children&&(Ne.children=re.children.map(Oe)),Ne}Ae.from=Oe;function Ee(re){const Ne=new r.DocumentSymbol(re.name,re.detail,Q.to(re.kind),u.to(re.range),u.to(re.selectionRange));return(0,c.isNonEmptyArray)(re.tags)&&(Ne.tags=re.tags.map(J.to)),re.children&&(Ne.children=re.children.map(Ee)),Ne}Ae.to=Ee})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var Z;(function(Ae){function Oe(re){const Ne=new r.CallHierarchyItem(Q.to(re.kind),re.name,re.detail||"",D.URI.revive(re.uri),u.to(re.range),u.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Ae.to=Oe;function Ee(re,Ne,$e){if(Ne=Ne??re._sessionId,$e=$e??re._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,name:re.name,detail:re.detail,kind:Q.from(re.kind),uri:re.uri,range:u.from(re.range),selectionRange:u.from(re.selectionRange),tags:re.tags?.map(J.from)}}Ae.from=Ee})(Z=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ge;(function(Ae){function Oe(Ee){return new r.CallHierarchyIncomingCall(Z.to(Ee.from),Ee.fromRanges.map(re=>u.to(re)))}Ae.to=Oe})(ge=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(Ae){function Oe(Ee){return new r.CallHierarchyOutgoingCall(Z.to(Ee.to),Ee.fromRanges.map(re=>u.to(re)))}Ae.to=Oe})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var De;(function(Ae){function Oe(re){return{range:re.range&&u.from(re.range),uri:re.uri}}Ae.from=Oe;function Ee(re){return new r.Location(D.URI.revive(re.uri),u.to(re.range))}Ae.to=Ee})(De=e.location||(e.location={}));var Re;(function(Ae){function Oe(re){const Ne=re,$e=re;return{originSelectionRange:Ne.originSelectionRange?u.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:$e.uri,range:u.from(Ne.targetRange?Ne.targetRange:$e.range),targetSelectionRange:Ne.targetSelectionRange?u.from(Ne.targetSelectionRange):void 0}}Ae.from=Oe;function Ee(re){return{targetUri:D.URI.revive(re.uri),targetRange:u.to(re.range),targetSelectionRange:re.targetSelectionRange?u.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?u.to(re.originSelectionRange):void 0}}Ae.to=Ee})(Re=e.DefinitionLink||(e.DefinitionLink={}));var ze;(function(Ae){function Oe(re){return{range:u.from(re.range),contents:N.fromMany(re.contents)}}Ae.from=Oe;function Ee(re){return new r.Hover(re.contents.map(N.to),u.to(re.range))}Ae.to=Ee})(ze=e.Hover||(e.Hover={}));var se;(function(Ae){function Oe(re){return{range:u.from(re.range),expression:re.expression}}Ae.from=Oe;function Ee(re){return new r.EvaluatableExpression(u.to(re.range),re.expression)}Ae.to=Ee})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ue;(function(Ae){function Oe(re){if(re instanceof r.InlineValueText)return{type:"text",range:u.from(re.range),text:re.text};if(re instanceof r.InlineValueVariableLookup)return{type:"variable",range:u.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Ee(re){switch(re.type){case"text":return{range:u.to(re.range),text:re.text};case"variable":return{range:u.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:u.to(re.range),expression:re.expression}}}Ae.to=Ee})(ue=e.InlineValue||(e.InlineValue={}));var he;(function(Ae){function Oe(re){return{frameId:re.frameId,stoppedLocation:u.from(re.stoppedLocation)}}Ae.from=Oe;function Ee(re){return new r.InlineValueContext(re.frameId,u.to(re.stoppedLocation))}Ae.to=Ee})(he=e.InlineValueContext||(e.InlineValueContext={}));var ee;(function(Ae){function Oe(re){return{range:u.from(re.range),kind:re.kind}}Ae.from=Oe;function Ee(re){return new r.DocumentHighlight(u.to(re.range),re.kind)}Ae.to=Ee})(ee=e.DocumentHighlight||(e.DocumentHighlight={}));var oe;(function(Ae){function Oe(Ee){switch(Ee){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ae.to=Oe})(oe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ie;(function(Ae){function Oe(Ee){return{triggerKind:oe.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Ae.to=Oe})(ie=e.CompletionContext||(e.CompletionContext={}));var O;(function(Ae){function Oe(re){switch(re){case r.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Ee(re){switch(re){case 1:return r.CompletionItemTag.Deprecated}}Ae.to=Ee})(O=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(Ae){const Oe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ee($e){return Oe.get($e)??9}Ae.from=Ee;const re=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ne($e){return re.get($e)??r.CompletionItemKind.Property}Ae.to=Ne})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(Ae){function Oe(Ee,re){const Ne=new r.CompletionItem(Ee.label);return Ne.insertText=Ee.insertText,Ne.kind=H.to(Ee.kind),Ne.tags=Ee.tags?.map(O.to),Ne.detail=Ee.detail,Ne.documentation=C.isMarkdownString(Ee.documentation)?N.to(Ee.documentation):Ee.documentation,Ne.sortText=Ee.sortText,Ne.filterText=Ee.filterText,Ne.preselect=Ee.preselect,Ne.commitCharacters=Ee.commitCharacters,v.Range.isIRange(Ee.range)?Ne.range=u.to(Ee.range):typeof Ee.range=="object"&&(Ne.range={inserting:u.to(Ee.range.insert),replacing:u.to(Ee.range.replace)}),Ne.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:Boolean(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Ne.insertText=new r.SnippetString(Ee.insertText):(Ne.insertText=Ee.insertText,Ne.textEdit=Ne.range instanceof r.Range?new r.TextEdit(Ne.range,Ne.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Ee.additionalTextEdits.map($e=>V.to($e))),Ne.command=re&&Ee.command?re.fromInternal(Ee.command):void 0,Ne}Ae.to=Oe})(K=e.CompletionItem||(e.CompletionItem={}));var Y;(function(Ae){function Oe(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:N.fromStrict(re.documentation)}}Ae.from=Oe;function Ee(re){return{label:re.label,documentation:C.isMarkdownString(re.documentation)?N.to(re.documentation):re.documentation}}Ae.to=Ee})(Y=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(Ae){function Oe(re){return{label:re.label,documentation:N.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(Y.from):[],activeParameter:re.activeParameter}}Ae.from=Oe;function Ee(re){return{label:re.label,documentation:C.isMarkdownString(re.documentation)?N.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(Y.to):[],activeParameter:re.activeParameter}}Ae.to=Ee})(de=e.SignatureInformation||(e.SignatureInformation={}));var be;(function(Ae){function Oe(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(de.from):[]}}Ae.from=Oe;function Ee(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(de.to):[]}}Ae.to=Ee})(be=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(Ae){function Oe(Ee,re){const Ne=new r.InlayHint(a.to(re.position),typeof re.label=="string"?re.label:re.label.map(pe.to.bind(void 0,Ee)),re.kind&&Ce.to(re.kind));return Ne.textEdits=re.textEdits&&re.textEdits.map(V.to),Ne.tooltip=C.isMarkdownString(re.tooltip)?N.to(re.tooltip):re.tooltip,Ne.paddingLeft=re.paddingLeft,Ne.paddingRight=re.paddingRight,Ne}Ae.to=Oe})(Pe=e.InlayHint||(e.InlayHint={}));var pe;(function(Ae){function Oe(Ee,re){const Ne=new r.InlayHintLabelPart(re.label);return Ne.tooltip=C.isMarkdownString(re.tooltip)?N.to(re.tooltip):re.tooltip,d.Command.is(re.command)&&(Ne.command=Ee.fromInternal(re.command)),re.location&&(Ne.location=De.to(re.location)),Ne}Ae.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Ae){function Oe(re){return re}Ae.from=Oe;function Ee(re){return re}Ae.to=Ee})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Ae){function Oe(re){return{range:u.from(re.range),url:re.target,tooltip:re.tooltip}}Ae.from=Oe;function Ee(re){let Ne;if(re.url)try{Ne=typeof re.url=="string"?D.URI.parse(re.url,!0):D.URI.revive(re.url)}catch{}return new r.DocumentLink(u.to(re.range),Ne)}Ae.to=Ee})(ke=e.DocumentLink||(e.DocumentLink={}));var je;(function(Ae){function Oe(re){const Ne=new r.ColorPresentation(re.label);return re.textEdit&&(Ne.textEdit=V.to(re.textEdit)),re.additionalTextEdits&&(Ne.additionalTextEdits=re.additionalTextEdits.map($e=>V.to($e))),Ne}Ae.to=Oe;function Ee(re){return{label:re.label,textEdit:re.textEdit?V.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Ne=>V.from(Ne)):void 0}}Ae.from=Ee})(je=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Ae){function Oe(re){return new r.Color(re[0],re[1],re[2],re[3])}Ae.to=Oe;function Ee(re){return[re.red,re.green,re.blue,re.alpha]}Ae.from=Ee})(Ge=e.Color||(e.Color={}));var et;(function(Ae){function Oe(re){return{range:u.from(re.range)}}Ae.from=Oe;function Ee(re){return new r.SelectionRange(u.to(re.range))}Ae.to=Ee})(et=e.SelectionRange||(e.SelectionRange={}));var _e;(function(Ae){function Oe(Ee){switch(Ee){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Ae){function Oe(re){switch(re){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Ee(re){switch(re){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ae.to=Ee})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Ae){function Oe(re){if(re===r.EndOfLine.CRLF)return 1;if(re===r.EndOfLine.LF)return 0}Ae.from=Oe;function Ee(re){if(re===1)return r.EndOfLine.CRLF;if(re===0)return r.EndOfLine.LF}Ae.to=Ee})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Ae){function Oe(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(Ae){function Oe(Ee){const re={start:Ee.start+1,end:Ee.end+1};return Ee.kind&&(re.kind=it.from(Ee.kind)),re}Ae.from=Oe})(Fe=e.FoldingRange||(e.FoldingRange={}));var it;(function(Ae){function Oe(Ee){if(Ee)switch(Ee){case r.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Ae.from=Oe})(it=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ae;(function(Ae){function Oe(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?u.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?b.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(ae=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var $;(function(Ae){function Oe($e){return $e instanceof r.RelativePattern?$e.toJSON():typeof $e=="string"?$e:Ee($e)||re($e)?new r.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}Ae.from=Oe;function Ee($e){const Qe=$e;return Qe?D.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function re($e){const Qe=$e;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Ne($e){return typeof $e=="string"?$e:new r.RelativePattern(D.URI.revive($e.baseUri),$e.pattern)}Ae.to=Ne})($=e.GlobPattern||(e.GlobPattern={}));var ce;(function(Ae){function Oe(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Oe);if(typeof Ee=="string")return Ee;{const re=Ee;return{language:re.language,scheme:re.scheme,pattern:$.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Ae.from=Oe})(ce=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Ae){function Oe(re){return{start:re.start,end:re.end}}Ae.from=Oe;function Ee(re){return new r.NotebookRange(re.start,re.end)}Ae.to=Ee})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Ae){function Oe(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Ae.to=Oe;function Ee(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Ae.from=Ee})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Ae){function Oe(Ee){if(Ee===p.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ee===p.NotebookCellExecutionState.Pending)return;if(Ee===p.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Ae.to=Oe})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xe;(function(Ae){function Oe(re){switch(re){case r.NotebookCellKind.Markup:return p.CellKind.Markup;case r.NotebookCellKind.Code:default:return p.CellKind.Code}}Ae.from=Oe;function Ee(re){switch(re){case p.CellKind.Markup:return r.NotebookCellKind.Markup;case p.CellKind.Code:default:return r.NotebookCellKind.Code}}Ae.to=Ee})(xe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Ae){function Oe(re){const Ne={metadata:re.metadata??Object.create(null),cells:[]};for(const $e of re.cells)r.NotebookCellData.validate($e),Ne.cells.push(mt.from($e));return Ne}Ae.from=Oe;function Ee(re){const Ne=new r.NotebookData(re.cells.map(mt.to));return(0,E.isEmptyObject)(re.metadata)||(Ne.metadata=re.metadata),Ne}Ae.to=Ee})(Ze=e.NotebookData||(e.NotebookData={}));var mt;(function(Ae){function Oe(re){return{cellKind:xe.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Le.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(lt.from):[]}}Ae.from=Oe;function Ee(re){return new r.NotebookCellData(xe.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(lt.to):void 0,re.metadata,re.internalMetadata?Le.to(re.internalMetadata):void 0)}Ae.to=Ee})(mt=e.NotebookCellData||(e.NotebookCellData={}));var ft;(function(Ae){function Oe(re){return{mime:re.mime,valueBytes:t.VSBuffer.wrap(re.data)}}Ae.from=Oe;function Ee(re){return new r.NotebookCellOutputItem(re.valueBytes.buffer,re.mime)}Ae.to=Ee})(ft=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(Ae){function Oe(re){return{outputId:re.id,items:re.items.map(ft.from),metadata:re.metadata}}Ae.from=Oe;function Ee(re){const Ne=re.items.map(ft.to);return new r.NotebookCellOutput(Ne,re.outputId,re.metadata)}Ae.to=Ee})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(Ae){function Oe(Ne){return re(Ne)?{include:(0,E.withNullAsUndefined)($.from(Ne.include)),exclude:(0,E.withNullAsUndefined)($.from(Ne.exclude))}:(0,E.withNullAsUndefined)($.from(Ne))}Ae.from=Oe;function Ee(Ne){return re(Ne)?{include:$.to(Ne.include),exclude:$.to(Ne.exclude)}:$.to(Ne)}Ae.to=Ee;function re(Ne){const $e=Ne;return $e?!(0,E.isUndefinedOrNull)($e.include)&&!(0,E.isUndefinedOrNull)($e.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Ae){function Oe(Ee,re,Ne){const $e=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal($e,Ne),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Ae.from=Oe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Tt;(function(Ae){function Oe(Ee,re,Ne){const $e=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:re.toInternal($e,Ne),label:Ee.label,description:Ee.description,detail:Ee.detail}}Ae.from=Oe})(Tt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Pt;(function(Ae){function Oe(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Ae.from=Oe})(Pt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(Ae){function Oe(re){return{uri:re.uri,provides:re.provides}}Ae.from=Oe;function Ee(re){return new r.NotebookRendererScript(D.URI.revive(re.uri),re.provides)}Ae.to=Ee})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var gt;(function(Ae){function Oe(re){return{message:N.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,location:re.location&&{range:u.from(re.location.range),uri:re.location.uri}}}Ae.from=Oe;function Ee(re){const Ne=new r.TestMessage(typeof re.message=="string"?re.message:N.to(re.message));return Ne.actualOutput=re.actual,Ne.expectedOutput=re.expected,Ne.location=re.location?De.to(re.location):void 0,Ne}Ae.to=Ee})(gt=e.TestMessage||(e.TestMessage={}));var It;(function(Ae){Ae.namespace=w.namespaceTestTag,Ae.denamespace=w.denamespaceTestTag})(It=e.TestTag||(e.TestTag={}));var Bt;(function(Ae){function Oe(re){const Ne=(0,h.getPrivateApiFor)(re).controllerId;return{extId:g.TestId.fromExtHostTestItem(re,Ne).toString(),label:re.label,uri:D.URI.revive(re.uri),busy:re.busy,tags:re.tags.map($e=>It.namespace(Ne,$e.id)),range:v.Range.lift(u.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&N.fromStrict(re.error)||null}}Ae.from=Oe;function Ee(re){return{parent:void 0,error:void 0,id:g.TestId.fromString(re.extId).localId,label:re.label,uri:D.URI.revive(re.uri),tags:(re.tags||[]).map(Ne=>{const{tagId:$e}=It.denamespace(Ne);return new r.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Ae.toPlain=Ee})(Bt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(re){return{id:re.id}}Ae.from=Oe;function Ee(re){return new r.TestTag(re.id)}Ae.to=Ee}(It=e.TestTag||(e.TestTag={}));var Mt;(function(Ae){const Oe=(re,Ne)=>{const $e=[];for(const[Ve,tt]of Ne)g.TestId.compare(tt.item.extId,Ve)===2&&(Ne.delete(Ve),$e.push(tt));const Qe={...Bt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(tt=>tt.type===0).map(gt.to)})),children:$e.map(Ve=>Oe(Ve,Ne))};for(const Ve of Qe.children)Ve.parent=Qe;return Qe};function Ee(re){const Ne=[],$e=new Map;for(const Qe of re.items){$e.set(Qe.item.extId,Qe);const Ve=g.TestId.root(Qe.item.extId);re.request.targets.some(tt=>tt.controllerId===Ve&&tt.testIds.includes(Qe.item.extId))&&Ne.push(Qe)}return{completedAt:re.completedAt,results:Ne.map(Qe=>Oe(Qe,$e))}}Ae.to=Ee})(Mt=e.TestResults||(e.TestResults={}));var Xe;(function(Ae){function Oe($e){return{covered:$e.covered,total:$e.covered}}function Ee($e){return"line"in $e?a.from($e):u.from($e)}function re($e){return"branches"in $e?{count:$e.executionCount,location:Ee($e.location),type:1,branches:$e.branches.length?$e.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&Ee(Qe.location)})):void 0}:{type:0,count:$e.executionCount,location:Ee($e.location)}}Ae.fromDetailed=re;function Ne($e){return{uri:$e.uri,statement:Oe($e.statementCoverage),branch:$e.branchCoverage&&Oe($e.branchCoverage),function:$e.functionCoverage&&Oe($e.functionCoverage),details:$e.detailedCoverage?.map(re)}}Ae.fromFile=Ne})(Xe=e.TestCoverage||(e.TestCoverage={}));var Rt;(function(Ae){function Oe(Ee){switch(Ee){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Rt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ut;(function(Ae){function Oe(re){const Ne=new r.TypeHierarchyItem(Q.to(re.kind),re.name,re.detail||"",D.URI.revive(re.uri),u.to(re.range),u.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Ae.to=Oe;function Ee(re,Ne,$e){if(Ne=Ne??re._sessionId,$e=$e??re._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,kind:Q.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:u.from(re.range),selectionRange:u.from(re.selectionRange),tags:re.tags?.map(J.from)}}Ae.from=Ee})(Ut=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ht;(function(Ae){function Oe(Ee){if(!!Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Ae.from=Oe})(Ht=e.ViewBadge||(e.ViewBadge={}));var pt;(function(Ae){function Oe($e,Qe,Ve){const tt=Qe.fileData;return tt?new class extends r.DataTransferItem{asFile(){return{name:tt.name,uri:D.URI.revive(tt.uri),data:(0,A.once)(()=>Ve())}}}("",Qe.id):$e===L.Mimes.uriList&&Qe.uriListData?new r.DataTransferItem(Ne(Qe.uriListData)):new r.DataTransferItem(Qe.asString)}Ae.to=Oe;async function Ee($e,Qe){const Ve=await Qe.asString();if($e===L.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:re(Ve)};const tt=Qe.asFile();return{id:Qe.id,asString:Ve,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Ae.from=Ee;function re($e){return I.UriList.split($e).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return D.URI.parse(Qe)}catch{}return Qe})}function Ne($e){return I.UriList.create($e.map(Qe=>typeof Qe=="string"?Qe:D.URI.revive(Qe)))}})(pt=e.DataTransferItem||(e.DataTransferItem={}));var At;(function(Ae){function Oe(re,Ne){const $e=re.items.map(([Qe,Ve])=>[Qe,pt.to(Qe,Ve,()=>Ne(Ve.id))]);return new r.DataTransfer($e)}Ae.toDataTransfer=Oe;async function Ee(re){const Ne={items:[]},$e=[];return re.forEach((Qe,Ve)=>{$e.push((async()=>{Ne.items.push([Ve,await pt.from(Ve,Qe)])})())}),await Promise.all($e),Ne}Ae.toDataTransferDTO=Ee})(At=e.DataTransfer||(e.DataTransfer={}))}),define(Se[232],ye([1,0,2,10,7,14,63]),function(ne,e,c,t,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(y,L,P,E={timeout:1500,errors:3}){this.c=y,this.d=L,this.f=P,this.g=E,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(L,P,E)=>{const v={dispose:this.a.push([L,P,y])};return Array.isArray(E)&&E.push(v),v}}async $participateInSave(y,L){const P=c.URI.revive(y);let E=!1;const D=setTimeout(()=>E=!0,this.g.timeout),v=[];try{for(const d of[...this.a]){if(E)break;const m=this.d.getDocument(P),h=await this.h(d,{document:m,reason:A.TextDocumentSaveReason.to(L)});v.push(h)}}finally{clearTimeout(D)}return v}h([y,L,P],E){const D=this.b.get(y);return typeof D=="number"&&D>this.g.errors?Promise.resolve(!1):this.i(P,y,L,E).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const d=this.b.get(y);this.b.set(y,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,L,P,E){const D=[],v=Date.now(),{document:d,reason:m}=E,{version:h}=d,b=Object.freeze({document:d,reason:m,waitUntil(p){if(Object.isFrozen(D))throw(0,t.illegalState)("waitUntil can not be called async");D.push(Promise.resolve(p))}});try{L.apply(P,[b])}catch(p){return Promise.reject(p)}return Object.freeze(D),new Promise((p,g)=>{const w=setTimeout(()=>g(new Error("timeout")),this.g.timeout);return Promise.all(D).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(w),p(s)}).catch(s=>{clearTimeout(w),g(s)})}).then(p=>{const g={edits:[]};for(const w of p)if(Array.isArray(w)&&w.every(s=>s instanceof I.TextEdit))for(const{newText:s,newEol:r,range:l}of w)g.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:l&&A.Range.from(l),text:s,eol:r&&A.EndOfLine.from(r)}});if(g.edits.length!==0)return h===d.version?this.f.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(Se[233],ye([1,0,15,2,14,7,90]),function(ne,e,c,t,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(P,E,D,v){this.start=P,this.deletedCount=E,this.deletedItems=D,this.items=v}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(P,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,E,D){this.notebook=P,this.h=E,this.j=D,this.handle=D.handle,this.uri=t.URI.revive(D.uri),this.cellKind=D.cellKind,this.a=D.outputs.map(I.NotebookCellOutput.to),this.e=D.internalMetadata??{},this.b=Object.freeze(D.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(D.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,E=this.h.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const D={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:E.document,get mime(){return P.g},set mime(v){P.g=v},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(D)}return this.f}setOutputs(P){this.a=P.map(I.NotebookCellOutput.to)}setOutputItems(P,E,D){const v=D.map(I.NotebookCellOutputItem.to),d=this.a.find(m=>m.id===P);if(d&&(E||(d.items.length=0),d.items.push(...v),d.items.length>1&&d.items.every(m=>C.isTextStreamMime(m.mime)))){const m=new Map,h=[];d.items.forEach(b=>{let p;m.has(b.mime)?p=m.get(b.mime):(p=[],m.set(b.mime,p),h.push(b.mime)),p.push(b.data)}),d.items.length=0,h.forEach(b=>{const p=C.compressOutputItemStreams(m.get(b));d.items.push({mime:b,data:p.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=S;class y{constructor(P,E,D,v,d){this.k=P,this.l=E,this.m=D,this.uri=v,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,E={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===c.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(D){return D=P.n(D),P.b[D].apiCell},getCells(D){return(D?P.p(D):P.b).map(d=>d.apiCell)},save(){return P.q()}};this.e=Object.freeze(E)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,E,D){this.g=P.versionId,this.h=E,this.acceptDocumentPropertiesChanged({metadata:D});const v={notebook:this.apiNotebook,metadata:D,cellChanges:[],contentChanges:[]},d=[];for(const h of P.rawEvents)h.kind===C.NotebookCellsChangeType.ModelChange?this.r(h.changes,!1,v.contentChanges):h.kind===C.NotebookCellsChangeType.Move?this.s(h.index,h.length,h.newIdx,v.contentChanges):h.kind===C.NotebookCellsChangeType.Output?(this.t(h.index,h.outputs),d.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===C.NotebookCellsChangeType.OutputItem?(this.u(h.index,h.outputId,h.append,h.outputItems),d.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(h.index,h.language),d.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document})):h.kind===C.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document}):h.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(h.index,h.mime):h.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(h.index,h.metadata),d.push({cell:this.b[h.index].apiCell,metadata:this.b[h.index].apiCell.metadata})):h.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(h.index,h.internalMetadata),d.push({cell:this.b[h.index].apiCell,executionSummary:this.b[h.index].apiCell.executionSummary}));const m=new Map;for(let h=0;h<d.length;h++){const b=d[h],p=m.get(b.cell);if(p===void 0){const g=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...b});m.set(b.cell,g-1)}else v.cellChanges[p]={...v.cellChanges[p],...b}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let E=P.start|0,D=P.end|0;return E<0&&(E=0),D>this.b.length&&(D=this.b.length),P.with({start:E,end:D})}p(P){P=this.o(P);const E=[];for(let D=P.start;D<P.end;D++)E.push(this.b[D]);return E}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,E,D){if(this.j)return;const v=[],d=[],m=[];if(P.reverse().forEach(h=>{const p=h[2].map(s=>{const r=new S(this,this.l,s);return E||d.push(S.asModelAddData(this.apiNotebook,s)),r}),g=new T(h[0],h[1],[],p),w=this.b.splice(h[0],h[1],...p);for(const s of w)m.push(s.uri),g.deletedItems.push(s.apiCell);v.push(g)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:m}),D)for(const h of v)D.push(h.asApiEvent())}s(P,E,D,v){const d=this.b.splice(P,E);this.b.splice(D,0,...d);const m=[new T(P,E,d.map(h=>h.apiCell),[]),new T(D,0,[],d)];for(const h of m)v.push(h.asApiEvent())}t(P,E){this.b[P].setOutputs(E)}u(P,E,D,v){this.b[P].setOutputItems(E,D,v)}v(P,E){const D=this.b[P];D.apiCell.document.languageId!==E&&this.m.$acceptModelLanguageChanged(D.uri,E)}w(P,E){const D=this.b[P];D.apiCell.mime=E}x(P,E){this.b[P].setMetadata(E)}y(P,E){this.b[P].setInternalMetadata(E)}getCellFromApiCell(P){return this.b.find(E=>E.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(E=>E.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.ExtHostNotebookDocument=y,y.a=0}),define(Se[136],ye([1,0,10,14,7]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(T,S,y,L,P,E){this.id=T,this.f=S,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=L,this.c=E}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(S){this.selections=[S]},get selections(){return T.a},set selections(S){if(!Array.isArray(S)||!S.every(I.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");T.a=S,T.g(S)},get visibleRanges(){return T.b},revealRange(S,y){T.f.$tryRevealRange(T.id,t.NotebookRange.from(S),y??I.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(t.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(Se[234],ye([1,0,4,13,14]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(T,S){this.c=T,this.d=S,this.a=new c.Emitter,this.b=new c.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,S);const y=this.d.getEditorById(T);S.visibleRanges&&y._acceptVisibleRanges(S.visibleRanges.ranges.map(I.NotebookRange.to)),S.selections&&y._acceptSelections(S.selections.selections.map(I.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const S in T)this.d.getEditorById(S)._acceptViewColumn(I.ViewColumn.to(T[S]))}};A=qe([He(0,t.ILogService)],A),e.ExtHostNotebookEditors=A}),define(Se[235],ye([1,0,14,124,175,21,60,10]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,D,v){const d=this.b++,{title:m,location:h,cancellable:b}=D,p={label:(0,I.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this.a.$startProgress(d,{location:c.ProgressLocation.from(h),title:m,source:p,cancellable:b},E.isUnderDevelopment?void 0:E.identifier.value).catch(T.onUnexpectedExternalError),this.d(d,v,!!b)}d(E,D,v){let d;v&&(d=new A.CancellationTokenSource,this.c.set(E,d));const m=b=>{this.a.$progressEnd(b),this.c.delete(b),d?.dispose()};let h;try{h=D(new L(this.a,E),v&&d?d.token:A.CancellationToken.None)}catch(b){throw m(E),b}return h.then(b=>m(E),b=>m(E)),h}$acceptProgressCanceled(E){const D=this.c.get(E);D&&(D.cancel(),this.c.delete(E))}}e.ExtHostProgress=S;function y(P,E){return P.message=E.message,typeof E.increment=="number"&&(typeof P.increment=="number"?P.increment+=E.increment:P.increment=E.increment),P}class L extends t.Progress{constructor(E,D){super(v=>this.throttledReport(v)),this.c=E,this.d=D}throttledReport(E){this.c.$progressReport(this.d,E)}}qe([(0,C.throttle)(100,(P,E)=>y(P,E),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(Se[137],ye([1,0,35,132,56,91,69,14,2]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const y=(p,g,w,s)=>{let r=g;return{enumerable:!0,configurable:!1,get(){return r},set(l){if(!w(r,l)){const u=r;r=l,p.listener?.(s(l,u))}}}},L=(p,g)=>p===g,P={range:(p,g)=>p===g?!0:!p||!g?!1:p.isEqual(g),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(p,g)=>!(p.length!==g.length||p.some(w=>!g.find(s=>w.id===s.id)))},E=p=>g=>({op:4,update:p(g)}),D=(p,g)=>({range:(()=>{let w;const s=E(r=>({range:c.Range.lift(T.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return w},set(r){p.listener?.({op:6}),P.range(w,r)||(w=r,p.listener?.(s(r)))}}})(),label:y(p,g,P.label,E(w=>({label:w}))),description:y(p,void 0,P.description,E(w=>({description:w}))),sortText:y(p,void 0,P.sortText,E(w=>({sortText:w}))),canResolveChildren:y(p,!1,P.canResolveChildren,w=>({op:2,state:w})),busy:y(p,!1,P.busy,E(w=>({busy:w}))),error:y(p,void 0,P.error,E(w=>({error:T.MarkdownString.fromStrict(w)||null}))),tags:y(p,[],P.tags,(w,s)=>({op:1,new:w.map(T.TestTag.from),old:s.map(T.TestTag.from)}))}),v=p=>{const g=I.TestId.fromString(p.extId),w=new m(g.controllerId,g.localId,p.label,S.URI.revive(p.uri)||void 0);return w.range=T.Range.to(p.range||void 0),w.description=p.description||void 0,w.sortText=p.sortText||void 0,w.tags=p.tags.map(s=>T.TestTag.to({id:(0,C.denamespaceTestTag)(s).tagId})),w},d=p=>{let g;for(const w of p.tests){const s=v(w.item);(0,t.getPrivateApiFor)(s).parent=g,g=s}return g};e.toItemFromContext=d;class m{constructor(g,w,s,r){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const l=(0,t.createPrivateApiFor)(this,g);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof h?void 0:l.parent}},children:{value:(0,A.createTestItemChildren)(l,t.getPrivateApiFor,m),enumerable:!0,writable:!1},...D(l,s)})}}e.TestItemImpl=m;class h extends m{constructor(g,w){super(g,g,w,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class b extends A.TestItemCollection{constructor(g,w,s){super({controllerId:g,getDocumentVersion:r=>r&&s.getDocument(r)?.version,getApiFor:t.getPrivateApiFor,getChildren:r=>r.children,root:new h(g,w),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=b}),define(Se[138],ye([1,0,49,10,99,14,7]),function(ne,e,c,t,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class T{constructor(E,D,v){const d=T.c.nextId();E.$registerTextEditorDecorationType(D.identifier,d,A.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:d,dispose(){E.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=T,T.c=new I.IdGenerator("TextEditorDecorationType");class S{constructor(E,D){this.g=[],this.h=void 0,this.j=!1,this.c=E,this.d=E.version,this.e=D.undoStopBefore,this.f=D.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(E,D){this.k();let v=null;if(E instanceof C.Position)v=new C.Range(E,E);else if(E instanceof C.Range)v=E;else throw new Error("Unrecognized location");this.l(v,D,!1)}insert(E,D){this.k(),this.l(new C.Range(E,E),D,!0)}delete(E){this.k();let D=null;if(E instanceof C.Range)D=E;else throw new Error("Unrecognized location");this.l(D,null,!0)}l(E,D,v){const d=this.c.validateRange(E);this.g.push({range:d,text:D,forceMoveMarkers:v})}setEndOfLine(E){if(this.k(),E!==C.EndOfLine.LF&&E!==C.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this.h=E}}class y{constructor(E,D,v,d){this.c=E,this.d=D,this._accept(v),this.e=d;const m=this;this.value={get tabSize(){return m.f},set tabSize(h){m.m(h)},get indentSize(){return m.g},set indentSize(h){m.o(h)},get insertSpaces(){return m.h},set insertSpaces(h){m.q(h)},get cursorStyle(){return m.j},set cursorStyle(h){m.s(h)},get lineNumbers(){return m.k},set lineNumbers(h){m.t(h)}}}_accept(E){this.f=E.tabSize,this.g=E.indentSize,this.h=E.insertSpaces,this.j=E.cursorStyle,this.k=A.TextEditorLineNumbersStyle.to(E.lineNumbers)}l(E){if(E==="auto")return"auto";if(typeof E=="number"){const D=Math.floor(E);return D>0?D:null}if(typeof E=="string"){const D=parseInt(E,10);return isNaN(D)?null:D>0?D:null}return null}m(E){const D=this.l(E);if(D!==null){if(typeof D=="number"){if(this.f===D)return;this.f=D}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:D}))}}n(E){if(E==="tabSize")return"tabSize";if(typeof E=="number"){const D=Math.floor(E);return D>0?D:null}if(typeof E=="string"){const D=parseInt(E,10);return isNaN(D)?null:D>0?D:null}return null}o(E){const D=this.n(E);if(D!==null){if(typeof D=="number"){if(this.g===D)return;this.g=D}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:D}))}}p(E){return E==="auto"?"auto":E==="false"?!1:Boolean(E)}q(E){const D=this.p(E);if(typeof D=="boolean"){if(this.h===D)return;this.h=D}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:D}))}s(E){this.j!==E&&(this.j=E,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:E})))}t(E){this.k!==E&&(this.k=E,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(E)})))}assign(E){const D={};let v=!1;if(typeof E.tabSize<"u"){const d=this.l(E.tabSize);d==="auto"?(v=!0,D.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,v=!0,D.tabSize=d)}if(typeof E.indentSize<"u"){const d=this.n(E.indentSize);d==="tabSize"?(v=!0,D.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,v=!0,D.indentSize=d)}if(typeof E.insertSpaces<"u"){const d=this.p(E.insertSpaces);d==="auto"?(v=!0,D.insertSpaces=d):this.h!==d&&(this.h=d,v=!0,D.insertSpaces=d)}typeof E.cursorStyle<"u"&&this.j!==E.cursorStyle&&(this.j=E.cursorStyle,v=!0,D.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this.k!==E.lineNumbers&&(this.k=E.lineNumbers,v=!0,D.lineNumbers=A.TextEditorLineNumbersStyle.from(E.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,D))}u(E,D){D.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this.e.warn(v)})}}e.ExtHostTextEditorOptions=y;class L{constructor(E,D,v,d,m,h,b,p){this.id=E,this.j=D,this.k=v,this.g=!1,this.h=new Set,this.c=m,this.d=new y(this.j,this.id,h,v),this.e=b,this.f=p;const g=this;this.value=Object.freeze({get document(){return d.getValue()},set document(w){throw(0,t.readonly)("document")},get selection(){return g.c&&g.c[0]},set selection(w){if(!(w instanceof C.Selection))throw(0,t.illegalArgument)("selection");g.c=[w],g.l()},get selections(){return g.c},set selections(w){if(!Array.isArray(w)||w.some(s=>!(s instanceof C.Selection)))throw(0,t.illegalArgument)("selections");g.c=w,g.l()},get visibleRanges(){return g.e},set visibleRanges(w){throw(0,t.readonly)("visibleRanges")},get options(){return g.d.value},set options(w){g.g||g.d.assign(w)},get viewColumn(){return g.f},set viewColumn(w){throw(0,t.readonly)("viewColumn")},edit(w,s={undoStopBefore:!0,undoStopAfter:!0}){if(g.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new S(d.getValue(),s);return w(r),g.m(r)},insertSnippet(w,s,r={undoStopBefore:!0,undoStopAfter:!0}){if(g.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!s||Array.isArray(s)&&s.length===0)l=g.c.map(u=>A.Range.from(u));else if(s instanceof C.Position){const{lineNumber:u,column:o}=A.Position.from(s);l=[{startLineNumber:u,startColumn:o,endLineNumber:u,endColumn:o}]}else if(s instanceof C.Range)l=[A.Range.from(s)];else{l=[];for(const u of s)if(u instanceof C.Range)l.push(A.Range.from(u));else{const{lineNumber:o,column:a}=A.Position.from(u);l.push({startLineNumber:o,startColumn:a,endLineNumber:o,endColumn:a})}}return D.$tryInsertSnippet(E,d.getValue().version,w.value,l,r)},setDecorations(w,s){const r=s.length===0;r&&!g.h.has(w.key)||(r?g.h.delete(w.key):g.h.add(w.key),g.n(()=>{if(A.isDecorationOptionsArr(s))return D.$trySetDecorations(E,w.key,A.fromRangeOrRangeWithMessage(s));{const l=new Array(4*s.length);for(let u=0,o=s.length;u<o;u++){const a=s[u];l[4*u]=a.start.line+1,l[4*u+1]=a.start.character+1,l[4*u+2]=a.end.line+1,l[4*u+3]=a.end.character+1}return D.$trySetDecorationsFast(E,w.key,l)}}))},revealRange(w,s){g.n(()=>D.$tryRevealRange(E,A.Range.from(w),s||C.TextEditorRevealType.Default))},show(w){D.$tryShowEditor(E,A.ViewColumn.from(w))},hide(){D.$tryHideEditor(E)}})}dispose(){(0,c.ok)(!this.g),this.g=!0}_acceptOptions(E){(0,c.ok)(!this.g),this.d._accept(E)}_acceptVisibleRanges(E){(0,c.ok)(!this.g),this.e=E}_acceptViewColumn(E){(0,c.ok)(!this.g),this.f=E}_acceptSelections(E){(0,c.ok)(!this.g),this.c=E}async l(){const E=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,E)),this.value}m(E){const D=E.finalize();if(D.edits.length===0&&!D.setEndOfLine)return Promise.resolve(!0);const v=D.edits.map(m=>m.range);v.sort((m,h)=>m.end.line===h.end.line?m.end.character===h.end.character?m.start.line===h.start.line?m.start.character-h.start.character:m.start.line-h.start.line:m.end.character-h.end.character:m.end.line-h.end.line);for(let m=0,h=v.length-1;m<h;m++){const b=v[m].end;if(v[m+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=D.edits.map(m=>({range:A.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,D.documentVersionId,d,{setEndOfLine:typeof D.setEndOfLine=="number"?A.EndOfLine.from(D.setEndOfLine):void 0,undoStopBefore:D.undoStopBefore,undoStopAfter:D.undoStopAfter})}n(E){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,D=>(D instanceof Error&&D.name==="DISPOSED"||this.k.warn(D),null))}}e.ExtHostTextEditor=L}),define(Se[236],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[237],ye([1,0,189,10,42,121,125,43,27,236,201,191]),function(ne,e,c,t,I,A,C,T,S,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const E=T.Registry.as(C.Extensions.JSONContribution);class D{constructor(w,s,r){this.a=w,this.b=s,this.c=r}d(w,s){this.a({type:w,message:s,extensionId:this.b.identifier,extensionPointId:this.c})}error(w){this.d(I.default.Error,w)}warn(w){this.d(I.default.Warning,w)}info(w){this.d(I.default.Info,w)}}e.ExtensionMessageCollector=D;class v{static a(w){const s=new Set;for(let r=0,l=w.length;r<l;r++)s.add(S.ExtensionIdentifier.toKey(w[r].description.identifier));return s}static compute(w,s){if(!w||!w.length)return new v(s,[]);if(!s||!s.length)return new v([],w);const r=this.a(w),l=this.a(s),u=s.filter(a=>!r.has(S.ExtensionIdentifier.toKey(a.description.identifier))),o=w.filter(a=>!l.has(S.ExtensionIdentifier.toKey(a.description.identifier)));return new v(u,o)}constructor(w,s){this.added=w,this.removed=s}}e.ExtensionPointUserDelta=v;class d{constructor(w,s){this.name=w,this.defaultExtensionKind=s,this.a=null,this.b=null,this.c=null}setHandler(w){if(this.a!==null)throw new Error("Handler already set!");this.a=w,this.d()}acceptUsers(w){this.c=v.compute(this.b,w),this.b=w,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(w){(0,t.onUnexpectedError)(w)}}}e.ExtensionPoint=d;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:c.localize(15,null),type:"string",enum:["none"],enumDescriptions:[c.localize(16,null)]},activationEvents:{description:c.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(32,null)},{label:"onUri",body:"onUri",description:c.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(37,null)},{label:"onRenderer",description:c.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:c.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(41,null)},{label:"*",description:c.localize(42,null),body:"*"}]}},badges:{type:"array",description:c.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(44,null)},href:{type:"string",description:c.localize(45,null)},description:{type:"string",description:c.localize(46,null)}}}},markdown:{type:"string",description:c.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(51,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(52,null)},{body:["workspace"],description:c.localize(53,null)},{body:["ui","workspace"],description:c.localize(54,null)},{body:["workspace","ui"],description:c.localize(55,null)},{body:[],description:c.localize(56,null)}]},capabilities:{description:c.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(60,null),c.localize(61,null),c.localize(62,null)]},description:{type:"string",markdownDescription:c.localize(63,null)}}},untrustedWorkspaces:{description:c.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null)]},restrictedConfigurations:{description:c.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(70,null)}}}}},sponsor:{description:c.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(73,null),type:"string"},"vscode:uninstall":{description:c.localize(74,null),type:"string"}}},icon:{type:"string",description:c.localize(75,null)},l10n:{type:"string",description:c.localize(76,null)}}};class b{constructor(){this.a=new Map}registerExtensionPoint(w){if(this.a.has(w.extensionPoint))throw new Error("Duplicate extension point: "+w.extensionPoint);const s=new d(w.extensionPoint,w.defaultExtensionKind);return this.a.set(w.extensionPoint,s),w.activationEventsGenerator&&P.ImplicitActivationEvents.register(w.extensionPoint,w.activationEventsGenerator),e.schema.properties.contributes.properties[w.extensionPoint]=w.jsonSchema,E.registerSchema(h,e.schema),s}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=b;const p={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(p.ExtensionsRegistry,new b),e.ExtensionsRegistry=T.Registry.as(p.ExtensionsRegistry),E.registerSchema(h,e.schema),E.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Se[238],ye([1,0,186,11,23,237,53,4]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var y;(function(E){function D(v,d,m){if(!v)return;const h=t.isString(v.type)?v.type:void 0;if(!h||h.length===0){m.error(c.localize(3,null));return}const b=[];if(Array.isArray(v.required))for(const p of v.required)t.isString(p)&&b.push(p);return{extensionId:d.value,taskType:h,required:b,properties:v.properties?I.deepClone(v.properties):{},when:v.when?C.ContextKeyExpr.deserialize(v.when):void 0}}E.from=D})(y||(y={}));const L=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:c.localize(4,null),type:"array",items:S}});class P{constructor(){this.d=new T.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((D,v)=>{L.setHandler((d,m)=>{this.c=void 0;try{for(const h of m.removed){const b=h.value;for(const p of b)this.a&&p.type&&this.a[p.type]&&delete this.a[p.type]}for(const h of m.added){const b=h.value;for(const p of b){const g=y.from(p,h.description.identifier,h.collector);g&&(this.a[g.taskType]=g)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}D(void 0)})})}onReady(){return this.b}get(D){return this.a[D]}all(){return Object.keys(this.a).map(D=>this.a[D])}getJsonSchema(){if(this.c===void 0){const D=[];for(const v of this.all()){const d={type:"object",additionalProperties:!1};v.required.length>0&&(d.required=v.required.slice(0)),v.properties!==void 0?d.properties=I.deepClone(v.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[v.taskType]},D.push(d)}this.c={oneOf:D}}return this.c}}e.TaskDefinitionRegistry=new P}),define(Se[239],ye([1,0,187,11,24,23,53,238]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function z(U){if(!U)return F.Strong;switch(U.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=z}(S=e.ShellQuoting||(e.ShellQuoting={}));var y;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(y=e.CommandOptions||(e.CommandOptions={}));var L;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(F){function z(U){switch(U.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=z}(L=e.RevealKind||(e.RevealKind={}));var P;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(P=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function z(U){switch(U.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=z}(P=e.RevealProblemKind||(e.RevealProblemKind={}));var E;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(E=e.PanelKind||(e.PanelKind={})),function(F){function z(U){switch(U.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=z}(E=e.PanelKind||(e.PanelKind={}));var D;(function(F){F.defaults={echo:!0,reveal:L.Always,revealProblems:P.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(D=e.PresentationOptions||(e.PresentationOptions={}));var v;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(v=e.RuntimeType||(e.RuntimeType={})),function(F){function z(W){switch(W.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=z;function U(W){switch(W){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=U}(v=e.RuntimeType||(e.RuntimeType={}));var d;(function(F){function z(U){return t.isString(U)?U:U.value}F.value=z})(d=e.CommandString||(e.CommandString={}));var m;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function z(W){return W===F.Clean._id||W===F.Build._id||W===F.Rebuild._id||W===F.Test._id}F.is=z;function U(W){if(W!==void 0)return t.isString(W)?z(W)?{_id:W,isDefault:!1}:void 0:W}F.from=U})(m=e.TaskGroup||(e.TaskGroup={}));var h;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(h=e.TaskScope||(e.TaskScope={}));var b;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function z(U){switch(U){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=z})(b=e.TaskSourceKind||(e.TaskSourceKind={}));var p;(function(F){F.parallel="parallel",F.sequence="sequence"})(p=e.DependsOrder||(e.DependsOrder={}));var g;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(g=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:g.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class s{constructor(z,U,W,x,V,_){this._label="",this._id=z,U&&(this._label=U),W&&(this.type=W),this.runOptions=x,this.configurationProperties=V,this._source=_}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,U=!1){if(z===void 0)return!1;if(t.isString(z))return z===this._label||z===this.configurationProperties.identifier||U&&z===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.CommonTask=s;class r extends s{constructor(z,U,W,x,V,_,Q,J){super(z,W,void 0,Q,J,U),this.command={},this._source=U,this.hasDefinedMatchers=_,V&&(this.command=V)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case v.Shell:U="shell";break;case v.Process:U="process";break;case v.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(z){return z instanceof r}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let U=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(U+=this._source.kind);const W={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:U};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new r(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.CustomTask=r;class l extends s{constructor(z,U,W,x,V,_,Q){super(z,W,x,_,Q,U),this._source=U,this.configures=V}static is(z){return z instanceof l}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let U=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(U+=this._source.kind);const W={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:U};return JSON.stringify(W)}}e.ConfiguringTask=l;class u extends s{constructor(z,U,W,x,V,_,Q,J,te){super(z,W,x,J,te,U),this.defines=V,this.hasDefinedMatchers=Q,this.command=_,this.icon=te.icon,this.hide=te.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof u}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new u(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.ContributedTask=u;class o extends s{constructor(z,U,W,x,V,_){super(z,W,x,V,_,U),this._source=U}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new o(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.InMemoryTask=o;var a;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(a=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(a=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class i{constructor(z){this.c=new Map;for(let U=0;U<z.length;U++)this.c.set(z[U].uri.toString(),U)}compare(z,U){const W=z.getWorkspaceFolder(),x=U.getWorkspaceFolder();if(W&&x){let V=this.c.get(W.uri.toString());V=V===void 0?0:V+1;let _=this.c.get(x.uri.toString());return _=_===void 0?0:_+1,V===_?z._label.localeCompare(U._label):V-_}else return!W&&x?-1:W&&!x?1:0}}e.TaskSorter=i;var f;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(f=e.TaskEventKind||(e.TaskEventKind={}));var k;(function(F){F.SingleRun="singleRun",F.Background="background"})(k=e.TaskRunType||(e.TaskRunType={}));var R;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(R=e.TaskRunSource||(e.TaskRunSource={}));var B;(function(F){function z(U,W,x,V){if(W){const _={kind:U,taskId:W._id,taskName:W.configurationProperties.name,runType:W.configurationProperties.isBackground?"background":"singleRun",group:W.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:x,__task:W};return U==="start"?_.resolvedVariables=V:U==="processStarted"?_.processId=V:U==="processEnded"&&(_.exitCode=V),Object.freeze(_)}else return Object.freeze({kind:"changed"})}F.create=z})(B=e.TaskEvent||(e.TaskEvent={}));var X;(function(F){function z(W){const x=Object.keys(W).sort();let V="";for(const _ of x){let Q=W[_];Q instanceof Object?Q=z(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),V+=_+","+Q+","}return V}function U(W){const V={_key:z(W),type:W.taskType};return Object.assign(V,W),V}F.create=U})(X=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var q;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(q=e.TaskSettingId||(e.TaskSettingId={}));var N;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(N=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var M;(function(F){function z(U,W){const x=T.TaskDefinitionRegistry.get(U.type);if(x===void 0){const J=A.deepClone(U);return delete J._key,X.create(J)}const V=Object.create(null);V.type=x.taskType;const _=new Set;x.required.forEach(J=>_.add(J));const Q=x.properties;for(const J of Object.keys(Q)){const te=U[J];if(te!=null)V[J]=te;else if(_.has(J)){const le=Q[J];if(le.default!==void 0)V[J]=A.deepClone(le.default);else switch(le.type){case"boolean":V[J]=!1;break;case"number":case"integer":V[J]=0;break;case"string":V[J]="";break;default:W.error(c.localize(2,null,JSON.stringify(U,void 0,0),J));return}}}return X.create(V)}F.createTaskIdentifier=z})(M=e.TaskDefinition||(e.TaskDefinition={}))}),define(Se[240],ye([1,0,10]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,T)=>{this.b=C,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,c.onUnexpectedError)(C))}then(C,T){return this.j().then(C,T)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=t;class I extends t{constructor(){super(),this.h=!0,this.i=new c.CancellationError}}e.CanceledLazyPromise=I}),define(Se[57],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const t=[];function I(T){const S=new c(T);return t[S.nid]=S,S}e.createProxyIdentifier=I;function A(T){return t[T].sid}e.getStringIdentifierForProxy=A;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(Se[5],ye([1,0,57]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var A;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(A=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var y;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(y=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(m){return m._id=P.a++,m}}e.IdObject=P,P.a=0;var E;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var D;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(D=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,c.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,c.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization")}}),define(Se[70],ye([1,0,3,13,5,16]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,y){this.c=y,this.a=new Set,this.b=S.getProxy(I.MainContext.MainThreadTelemetry)}report(S,y,L){const P=this.d(S,y);this.a.has(P)||(this.a.add(P),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:S}))}d(S,y){return`${S}-${y.identifier.value}`}};C=qe([He(0,A.IExtHostRpcService),He(1,t.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(T,S,y){}})}),define(Se[241],ye([1,0,4,5,7,27]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this.b=new Map,this.c=[],this.d=new c.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,y,L,P={}){const E=A.ExtensionIdentifier.toKey(S.identifier),D=this.f.get(E)||[],v=[...L].sort().join(" ");let d=D.find(m=>m.providerId===y&&m.scopes===v);if(d)return d.result;{const m=this.g(S,E,y,L,P);d={providerId:y,scopes:v,result:m},D.push(d),this.f.set(E,D);try{await m}finally{const h=D.findIndex(b=>b.providerId===y&&b.scopes===v);h>-1&&(D.splice(h),this.f.set(E,D))}return m}}async g(S,y,L,P,E={}){await this.a.$ensureProvider(L);const D=S.displayName||S.name;return this.a.$getSession(L,P,y,D,E)}async removeSession(S,y){const L=this.b.get(S);return L?L.provider.removeSession(y):this.a.$removeSession(S,y)}registerAuthenticationProvider(S,y,L,P){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:y,provider:L,options:P??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===S)||this.c.push({id:S,label:y});const E=L.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions(S,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider(S,y,P?.supportsMultipleAccounts??!1),new I.Disposable(()=>{E.dispose(),this.b.delete(S);const D=this.c.findIndex(v=>v.id===S);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,y){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.createSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,y){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.removeSession(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,y){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.getSessions(y));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,y){return this.d.fire({provider:{id:S,label:y}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(Se[242],ye([1,0,5,16,14]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(T,S){this.a=T.getProxy(c.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>S.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,S,y){const L=I.WorkspaceEdit.from(T,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,y?.isRefactoring??!1)}};A=qe([He(0,t.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(Se[243],ye([1,0,5]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(A){const C=A.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(T){return C.$writeText(T)}})}}e.ExtHostClipboard=t});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,c):I?I.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[39],ye([1,0,11,7,14,23,5,17,13,85,35,50,2,6,3,16,137,22,57,51,44]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b,p,g){"use strict";var w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(i,f){w.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),Je(this,w,i.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=f,Je(this,s,i.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,k=>{const R=this.c.get(k);return R?.result===o.Void?R:void 0},f),this.f=[{processArgument(k){return(0,y.revive)(k)}},{processArgument(k){return(0,A.cloneAndChange)(k,function(R){if(L.Range.isIRange(R))return I.Range.to(R);if(P.Position.isIPosition(R))return I.Position.to(R);if(L.Range.isIRange(R.range)&&E.URI.isUri(R.uri))return I.location.to(R);if(R instanceof h.VSBuffer)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(i){this.f.push(i)}registerApiCommand(i){const f=this.registerCommand(!1,i.id,async(...k)=>{const R=i.args.map((X,q)=>{if(!X.validate(k[q]))throw new Error(`Invalid argument '${X.name}' when running '${i.id}', received: ${k[q]}`);return X.convert(k[q])}),B=await this.executeCommand(i.internalId,...R);return i.result.convert(B,k,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this.c.set(i.id,i),new t.Disposable(()=>{f.dispose(),this.c.delete(i.id)})}registerCommand(i,f,k,R,B,X){if(this.d.trace("ExtHostCommands#registerCommand",f),!f.trim().length)throw new Error("invalid id");if(this.b.has(f))throw new Error(`command '${f}' already exists`);return this.b.set(f,{callback:k,thisArg:R,description:B,extension:X}),i&&Me(this,w,"f").$registerCommand(f),new t.Disposable(()=>{this.b.delete(f)&&i&&Me(this,w,"f").$unregisterCommand(f)})}executeCommand(i,...f){return this.d.trace("ExtHostCommands#executeCommand",i),this.g(i,f,!0)}async g(i,f,k){if(this.b.has(i))return Me(this,w,"f").$fireCommandActivationEvent(i),this.h(i,f,!1);{let R=!1;const B=(0,A.cloneAndChange)(f,function(X){if(X instanceof t.Position)return I.Position.from(X);if(X instanceof t.Range)return I.Range.from(X);if(X instanceof t.Location)return I.location.from(X);if(t.NotebookRange.isNotebookRange(X))return I.NotebookRange.from(X);if(X instanceof ArrayBuffer)return R=!0,h.VSBuffer.wrap(new Uint8Array(X));if(X instanceof Uint8Array)return R=!0,h.VSBuffer.wrap(X);if(X instanceof h.VSBuffer)return R=!0,X;if(!Array.isArray(X))return X});try{const X=await Me(this,w,"f").$executeCommand(i,R?new b.SerializableObjectWithBuffers(B):B,k);return(0,y.revive)(X)}catch(X){if(X instanceof Error&&X.message==="$executeCommand:retry")return this.g(i,f,!1);throw X}}}async h(i,f,k){const R=this.b.get(i);if(!R)throw new Error("Unknown command");const{callback:B,thisArg:X,description:q}=R;if(q)for(let M=0;M<q.args.length;M++)try{(0,c.validateConstraint)(f[M],q.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${q.args[M].name}' - ${q.args[M].description}`)}const N=g.StopWatch.create();try{return await B.apply(X,f)}catch(M){if(i===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...f);F&&(i=F.command)}throw this.d.error(M,i,R.extension?.identifier),k?new class extends Error{constructor(){super((0,p.toErrorMessage)(M)),this.id=i,this.source=R.extension?.displayName??R.extension?.name}}:M}finally{this.j(R,i,N.elapsed())}}j(i,f,k){!i.extension||Me(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:i.extension.identifier.value,id:f,duration:k})}$executeContributedCommand(i,...f){return this.d.trace("ExtHostCommands#$executeContributedCommand",i),this.b.has(i)?(f=f.map(k=>this.f.reduce((R,B)=>B.processArgument(R),k)),this.h(i,f,!0)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this.d.trace("ExtHostCommands#getCommands",i),Me(this,w,"f").$getCommands().then(f=>(i&&(f=f.filter(k=>k[0]!=="_")),f))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(const[f,k]of this.b){const{description:R}=k;R&&(i[f]=R)}return Promise.resolve(i)}};w=new WeakMap,s=new WeakMap,r=qe([He(0,d.IExtHostRpcService),He(1,S.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class l{constructor(i,f,k){this.d=i,this.f=f,this.g=k,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(i,f){if(!i)return;const k={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return k;const R=this.f(i.command);if(R)k.id=R.internalId,k.arguments=R.args.map((B,X)=>B.convert(i.arguments&&i.arguments[X]));else if((0,T.isNonEmptyArray)(i.arguments)){const B=`${i.command}/${++this.c}`;this.b.set(B,i),f.add((0,D.toDisposable)(()=>{this.b.delete(B),this.g.trace("CommandsConverter#DISPOSE",B)})),k.$ident=B,k.id=this.delegatingCommandId,k.arguments=[B],this.g.trace("CommandsConverter#CREATE",i.command,B)}return k}fromInternal(i){return typeof i.$ident=="string"?this.b.get(i.$ident):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this.b.get(i[0])}h(...i){const f=this.getActualCommand(...i);return this.g.trace("CommandsConverter#EXECUTE",i[0],f?f.command:"MISSING"),f?this.d.executeCommand(f.command,...f.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${i[0]}`)}}e.CommandsConverter=l;class u{constructor(i,f,k,R){this.name=i,this.description=f,this.validate=k,this.convert=R}optional(){return new u(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,f){return new u(i??this.name,f??this.description,this.validate,this.convert)}}e.ApiCommandArgument=u,u.Uri=new u("uri","Uri of a text document",n=>E.URI.isUri(n),n=>n),u.Position=new u("position","A position in a text document",n=>t.Position.isPosition(n),I.Position.from),u.Range=new u("range","A range in a text document",n=>t.Range.isRange(n),I.Range.from),u.Selection=new u("selection","A selection in a text document",n=>t.Selection.isSelection(n),I.Selection.from),u.Number=new u("number","",n=>typeof n=="number",n=>n),u.String=new u("string","",n=>typeof n=="string",n=>n),u.CallHierarchyItem=new u("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),u.TypeHierarchyItem=new u("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),u.TestItem=new u("testItem","A VS Code TestItem",n=>n instanceof m.TestItemImpl,I.TestItem.from);class o{constructor(i,f){this.description=i,this.convert=f}}e.ApiCommandResult=o,o.Void=new o("no result",n=>n);class a{constructor(i,f,k,R,B){this.id=i,this.internalId=f,this.description=k,this.args=R,this.result=B}}e.ApiCommand=a}),define(Se[244],ye([1,0,2,14,7,66,39,17,118,123,15]),function(ne,e,c,t,I,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",D(t.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,m)=>{if((0,T.isFalsyOrEmpty)(d))return;class h extends I.SymbolInformation{static to(p){const g=new h(p.name,t.SymbolKind.to(p.kind),p.containerName||"",new I.Location(m[0],t.Range.to(p.range)));return g.detail=p.detail,g.range=g.location.range,g.selectionRange=t.Range.to(p.selectionRange),g.children=p.children?p.children.map(h.to):[],g}}return d.map(h.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(t.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(t.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(t.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",D(t.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",D(t.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(m=>I.Position.isPosition(m)),d=>d.map(t.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(m=>{let h;for(const b of m.reverse())h=new I.SelectionRange(t.Range.to(b),h);return h}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(t.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",d=>d.map(t.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",d=>d.map(t.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",d=>d.map(t.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(!!d)return{range:t.Range.to(d.range),placeholder:d.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return t.WorkspaceEdit.to(d)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(t.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const m=(0,S.decodeSemanticTokensDto)(d);if(m.type==="full")return new I.SemanticTokens(m.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const m=(0,S.decodeSemanticTokensDto)(d);if(m.type==="full")return new I.SemanticTokens(m.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,m,h)=>{if(!d)return new I.CompletionList([]);const b=d.suggestions.map(p=>t.CompletionItem.to(p,h));return new I.CompletionList(b,d.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return t.SignatureHelp.to(d)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,m,h)=>D(b=>new I.CodeLens(t.Range.to(b.range),b.command&&h.fromInternal(b.command)))(d))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>I.Range.isRange(d),d=>I.Selection.isSelection(d)?t.Selection.from(d):t.Range.from(d)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,m,h)=>D(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(b.command)}else{const p=new I.CodeAction(b.title,b.kind?new I.CodeActionKind(b.kind):void 0);return b.edit&&(p.edit=t.WorkspaceEdit.to(b.edit)),b.command&&(p.command=h.fromInternal(b.command)),p.isPreferred=b.isPreferred,p}})(d))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(m=>new I.ColorInformation(t.Range.to(m.range),t.Color.to(m.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",d=>d instanceof I.Color,t.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:t.Range.from(d.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(t.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,m,h)=>d.map(t.InlayHint.to.bind(void 0,h)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",D(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(m=>t.NotebookExclusiveDocumentPattern.to(m))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(t.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>c.URI.isUri(d)||typeof d=="string"&&(0,y.matchesSomeScheme)(d,L.Schemas.http,L.Schemas.https),d=>d),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void),new C.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[C.ApiCommandArgument.String.with("name","The context key name"),new C.ApiCommandArgument("value","The context key value",()=>!0,d=>d)],C.ApiCommandResult.Void)];class E{static register(m){P.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=E;function D(d){return m=>{if(Array.isArray(m))return m.map(d)}}function v(d){if(!Array.isArray(d))return;const m=[];for(const h of d)A.isLocationLink(h)?m.push(t.DefinitionLink.to(h)):m.push(t.location.to(h));return m}}),define(Se[245],ye([1,0,18,60,4,6,2,66,27,14,7,26,5]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function D(v,d,m){const h=v.getProxy(E.MainContext.MainThreadComments);class b{constructor(){this.b=new Map,this.c=new Map,d.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===6){const n=this.b.get(a.handle);return n?n.value:a}else if(a&&a.$mid===7){const n=this.b.get(a.commentControlHandle);if(!n)return a;const i=n.getCommentThread(a.commentThreadHandle);return i?i.value:a}else if(a&&(a.$mid===9||a.$mid===8)){const n=this.b.get(a.thread.commentControlHandle);if(!n)return a;const i=n.getCommentThread(a.thread.commentThreadHandle);return i?a.$mid===8?i.value:{thread:i.value,text:a.text}:a}else if(a&&a.$mid===10){const n=this.b.get(a.thread.commentControlHandle);if(!n)return a;const i=n.getCommentThread(a.thread.commentThreadHandle);if(!i)return a;const f=a.commentUniqueId,k=i.getCommentByUniqueId(f);return k||a}else if(a&&a.$mid===11){const n=this.b.get(a.thread.commentControlHandle);if(!n)return a;const i=n.getCommentThread(a.thread.commentThreadHandle);if(!i)return a;const f=a.text,k=a.commentUniqueId,R=i.getCommentByUniqueId(k);return R?(typeof R.body=="string"?R.body=f:R.body=new L.MarkdownString(f),R):a}return a}})}createCommentController(a,n,i){const f=b.a++,k=new g(a,f,n,i);this.b.set(k.handle,k);const R=this.c.get(S.ExtensionIdentifier.toKey(a.identifier))||[];return R.push(k),this.c.set(S.ExtensionIdentifier.toKey(a.identifier),R),k.value}$createCommentThreadTemplate(a,n,i){const f=this.b.get(a);!f||f.$createCommentThreadTemplate(n,i)}async $updateCommentThreadTemplate(a,n,i){const f=this.b.get(a);!f||f.$updateCommentThreadTemplate(n,i)}$deleteCommentThread(a,n){this.b.get(a)?.$deleteCommentThread(n)}$provideCommentingRanges(a,n,i){const f=this.b.get(a);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const k=m.getDocument(C.URI.revive(n));return(0,c.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(k,i)).then(R=>R?R.map(B=>y.Range.from(B)):void 0)}$toggleReaction(a,n,i,f,k){const R=this.b.get(a);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const B=R.getCommentThread(n);if(B){const X=B.getCommentByUniqueId(f.uniqueIdInThread);if(R!==void 0&&X&&R.reactionHandler)return R.reactionHandler(X,r(k))}return Promise.resolve(void 0)})}dispose(){}}b.a=0;class p{set threadId(a){this.n=a}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(a){a.isEqual(this.p)||(this.p=a,this.b.range=a,this.c.fire())}get range(){return this.p}set canReply(a){this.d!==a&&(this.d=a,this.b.canReply=a,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(a){this.e=a,this.b.label=a,this.c.fire()}get contextValue(){return this.f}set contextValue(a){this.f=a,this.b.contextValue=a,this.c.fire()}get comments(){return this.q}set comments(a){this.q=a,this.b.comments=a,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(a){this.g=a,this.b.collapsibleState=a,this.c.fire()}get state(){return(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(a){(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=a,this.b.state=a,this.c.fire()}get isDisposed(){return this.j}constructor(a,n,i,f,k,R,B,X){this.m=n,this.n=i,this.o=f,this.p=k,this.q=R,this.extensionDescription=B,this.r=X,this.handle=p.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.MutableDisposable,this.l.value=new A.DisposableStore,this.n===void 0&&(this.n=`${a}.${this.handle}`),h.$createCommentThread(n,this.handle,this.n,this.o,y.Range.from(this.p),B.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this.i.push({dispose:()=>{h.$deleteCommentThread(n,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(N){q.range=N},get comments(){return q.comments},set comments(N){q.comments=N},get collapsibleState(){return q.collapsibleState},set collapsibleState(N){q.collapsibleState=N},get canReply(){return q.canReply},set canReply(N){q.canReply=N},get contextValue(){return q.contextValue},set contextValue(N){q.contextValue=N},get label(){return q.label},set label(N){q.label=N},get state(){return q.state},set state(N){q.state=N},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.DisposableStore);const a=i=>Object.prototype.hasOwnProperty.call(this.b,i),n={};a("range")&&(n.range=y.Range.from(this.p)),a("label")&&(n.label=this.label),a("contextValue")&&(n.contextValue=this.contextValue??null),a("comments")&&(n.comments=this.q.map(i=>w(this,i,this.k))),a("collapsibleState")&&(n.collapseState=l(this.g)),a("canReply")&&(n.canReply=this.canReply),a("state")&&(n.state=u(this.h)),a("isTemplate")&&(n.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(a){for(const n of this.k){const i=n[0],f=n[1];if(a===f)return i}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(a=>a.dispose())}}p.a=0,qe([(0,t.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class g{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(a){this.b=a,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(a){this.c=a,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this.d}set options(a){this.d=a,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(a,n,i,f){this.f=a,this.g=n,this.h=i,this.i=f,this.a=new Map,h.$registerCommentController(this.handle,i,f);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(R){k.options=R},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(R){k.commentingRangeProvider=R},get reactionHandler(){return k.reactionHandler},set reactionHandler(R){k.reactionHandler=R},createCommentThread(R,B,X){return k.createCommentThread(R,B,X).value},dispose:()=>{k.dispose()}}),this.e=[],this.e.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(a,n,i,f){if(typeof a=="string"){const k=new p(this.id,this.handle,a,n,i,f,this.f,!1);return this.a.set(k.handle,k),k}else{const k=new p(this.id,this.handle,void 0,a,n,i,this.f,!1);return this.a.set(k.handle,k),k}}$createCommentThreadTemplate(a,n){const i=new p(this.id,this.handle,void 0,C.URI.revive(a),y.Range.to(n),[],this.f,!0);return i.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this.a.set(i.handle,i),i}$updateCommentThreadTemplate(a,n){const i=this.a.get(a);i&&(i.range=y.Range.to(n))}$deleteCommentThread(a){this.a.get(a)?.dispose(),this.a.delete(a)}getCommentThread(a){return this.a.get(a)}dispose(){this.a.forEach(a=>{a.dispose()}),this.e.forEach(a=>a.dispose())}}function w(o,a,n){let i=n.get(a);i||(i=++o.commentHandle,n.set(a,i));const f=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:i,body:typeof a.body=="string"?a.body:y.MarkdownString.from(a.body),userName:a.author.name,userIconPath:f,label:a.label,commentReactions:a.reactions?a.reactions.map(k=>s(k)):void 0,timestamp:a.timestamp?.toJSON()}}function s(o){return{label:o.label,iconPath:o.iconPath?y.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function r(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?C.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function l(o){if(o!==void 0)switch(o){case L.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function u(o){if(o!==void 0)switch(o){case L.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new b}e.createExtHostComments=D}),define(Se[246],ye([1,0,23,5,25,16]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(L,P){this.a=L.getProxy(t.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,P){const E=this,D=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){E.e(L,P,D,arguments)}})}e(L,P,E,D){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:S(D,this.b)}),this.c&&this.f(L,E,D)}};C=qe([He(0,A.IExtHostRpcService),He(1,I.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const T=1e5;function S(y,L){const P=[];if(y.length)for(let E=0;E<y.length;E++){let D=y[E];if(typeof D>"u")D="undefined";else if(D instanceof Error){const v=D;v.stack?D=v.stack:D=v.toString()}P.push(D)}if(L){const E=new Error().stack;E&&P.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,c.safeStringify)(P);return E.length>T?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(Se[139],ye([1,0,2,5,7,3,16,13,17,8,9,26]),function(ne,e,c,t,I,A,C,T,S,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class Fn{constructor(v,d){this.h=d,this.f=new Map,this.g=v.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(v,d){const m=Fn.c++;this.f.set(m,{provider:v,extensionDescription:d}),this.g.$registerDecorationProvider(m,d.identifier.value);const h=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(b=>{if(!b){this.g.$onDidChange(m,null);return}const p=(0,S.asArray)(b);if(p.length<=Fn.d){this.g.$onDidChange(m,p);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,p.length);const g=p.map(r=>({uri:r,rank:(0,y.count)(r.path,"/")})),w=(0,S.groupBy)(g,(r,l)=>r.rank-l.rank||(0,y.compare)(r.uri.path,l.uri.path)),s=[];e:for(const r of w){let l;for(const u of r){const o=(0,L.dirname)(u.uri.path);if(l!==o&&(l=o,s.push(u.uri)>=Fn.d))break e}}this.g.$onDidChange(m,s)});return new I.Disposable(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(m),this.f.delete(m)})}async $provideDecorations(v,d,m){if(!this.f.has(v))return Object.create(null);const h=Object.create(null),{provider:b,extensionDescription:p}=this.f.get(v);return await Promise.all(d.map(async g=>{try{const{uri:w,id:s}=g,r=await Promise.resolve(b.provideFileDecoration(c.URI.revive(w),m));if(!r)return;try{I.FileDecoration.validate(r),r.badge&&typeof r.badge!="string"&&(0,P.checkProposedApiEnabled)(p,"codiconDecoration"),h[s]=[r.propagate,r.tooltip,r.badge,r.color]}catch(l){this.h.warn(`INVALID decoration from extension '${p}': ${l}`)}}catch(w){this.h.error(w)}})),h}};E.c=0,E.d=250,E=qe([He(0,C.IExtHostRpcService),He(1,T.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,c):I?I.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[247],ye([1,0,173,122,2,5,7,14,4,13,28,47]),function(ne,e,c,t,I,A,C,T,S,y,L,P){"use strict";var E,D,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(b,p,g,w,s,r,l){this.d=b,this.e=p,this.f=g,this.g=w,E.set(this,void 0),D.set(this,void 0),v.set(this,void 0),this.c=!1,Je(this,v,new L.ResourceMap(u=>s.getComparisonKey(u)),"f"),Je(this,E,r,"f"),Je(this,D,l,"f")}dispose(){this.c||(Me(this,D,"f").fire([...Me(this,v,"f").keys()]),Me(this,E,"f")?.$clear(this.e),Me(this,v,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(b,p){if(!b){this.clear();return}this.h();let g=[];if(I.URI.isUri(b)){if(!p){this.delete(b);return}Me(this,v,"f").set(b,p.slice()),g=[b]}else if(Array.isArray(b)){g=[];let s;b=[...b].sort(d.j);for(const r of b){const[l,u]=r;if((!s||l.toString()!==s.toString())&&(s&&Me(this,v,"f").get(s).length===0&&Me(this,v,"f").delete(s),s=l,g.push(l),Me(this,v,"f").set(l,[])),u)Me(this,v,"f").get(l)?.push(...u);else{const o=Me(this,v,"f").get(l);o&&(o.length=0)}}}if(Me(this,D,"f").fire(g),!Me(this,E,"f"))return;const w=[];for(const s of g){let r=[];const l=Me(this,v,"f").get(s);if(l)if(l.length>this.f){r=[];const u=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const a of l)if(a.severity===u[o]&&r.push({...T.Diagnostic.from(a),modelVersionId:this.g(s)})===this.f)break e;r.push({severity:t.MarkerSeverity.Info,message:(0,c.localize)(0,null,l.length-this.f),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=l.map(u=>({...T.Diagnostic.from(u),modelVersionId:this.g(s)}));w.push([s,r])}Me(this,E,"f").$changeMany(this.e,w)}delete(b){this.h(),Me(this,D,"f").fire([b]),Me(this,v,"f").delete(b),Me(this,E,"f")?.$changeMany(this.e,[[b,void 0]])}clear(){this.h(),Me(this,D,"f").fire([...Me(this,v,"f").keys()]),Me(this,v,"f").clear(),Me(this,E,"f")?.$clear(this.e)}forEach(b,p){this.h();for(const[g,w]of this)b.call(p,g,w,this)}*[(E=new WeakMap,D=new WeakMap,v=new WeakMap,Symbol.iterator)](){this.h();for(const b of Me(this,v,"f").keys())yield[b,this.get(b)]}get(b){this.h();const p=Me(this,v,"f").get(b);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has(b){return this.h(),Array.isArray(Me(this,v,"f").get(b))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(b,p){return b[0].toString()<p[0].toString()?-1:b[0].toString()>p[0].toString()?1:0}}e.DiagnosticCollection=d;let m=class wn{static _mapper(b){const p=new L.ResourceMap;for(const g of b)p.set(g,g);return{uris:Object.freeze(Array.from(p.values()))}}constructor(b,p,g,w){this.h=p,this.j=g,this.k=w,this.f=new Map,this.g=new S.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,wn._mapper),this.e=b.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(b,p){const{f:g,e:w,g:s,h:r,j:l,k:u}=this,o=new class{$changeMany(i,f){w.$changeMany(i,f),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,i,f.length===0?"CLEARING":f)}$clear(i){w.$clear(i),r.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,i)}dispose(){w.dispose()}};let a;if(!p)p="_generated_diagnostic_collection_name_#"+wn.c++,a=p;else if(!g.has(p))a=p;else{this.h.warn(`DiagnosticCollection with name '${p}' does already exist.`);do a=p+wn.c++;while(g.has(a))}return new class extends d{constructor(){super(p,a,wn.d,i=>u.getDocument(i)?.version,l.extUri,o,s),g.set(a,this)}dispose(){super.dispose(),g.delete(a)}}}getDiagnostics(b){if(b)return this.l(b);{const p=new Map,g=[];for(const w of this.f.values())w.forEach((s,r)=>{let l=p.get(s.toString());typeof l>"u"&&(l=g.length,p.set(s.toString(),l),g.push([s,[]])),g[l][1]=g[l][1].concat(...r)});return g}}l(b){let p=[];for(const g of this.f.values())g.has(b)&&(p=p.concat(g.get(b)));return p}$acceptMarkersChange(b){if(!this.m){const p="_generated_mirror",g=new d(p,p,wn.d,w=>{},this.j.extUri,void 0,this.g);this.f.set(p,g),this.m=g}for(const[p,g]of b)this.m.set(I.URI.revive(p),g.map(T.Diagnostic.to))}};m.c=0,m.d=1e3,m=qe([He(1,y.ILogService),He(2,P.IExtHostFileSystemInfo)],m),e.ExtHostDiagnostics=m}),define(Se[248],ye([1,0,2,5]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(C){this.a=C.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(T=>T?T.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(T=>T?c.URI.revive(T):void 0)}}e.ExtHostDialogs=I}),define(Se[249],ye([1,0,10,2,7,5,15,21,8]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class y{constructor(P,E,D){this.d=E,this.e=D,this.b=new Map,this.c=P.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,E){if(Object.keys(C.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const D=y.a++;this.b.set(D,E),this.c.$registerTextContentProvider(D,P);let v;return typeof E.onDidChange=="function"&&(v=E.onDidChange(d=>{if(d.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(D,d).then(m=>{if(!m&&typeof m!="string")return;const h=this.d.getDocument(d);if(!h)return;const b=(0,S.splitLines)(m);if(!h.equalLines(b))return this.c.$onVirtualDocumentChange(d,m)},c.onUnexpectedError)})),new I.Disposable(()=>{this.b.delete(D)&&this.c.$unregisterTextContentProvider(D),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(P,E){const D=this.b.get(P);return D?Promise.resolve(D.provideTextDocumentContent(t.URI.revive(E),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=y,y.a=0}),define(Se[250],ye([1,0,4,6,2,5,135,14,11,23,7]),function(ne,e,c,t,I,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(D,v){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new t.DisposableStore,this.h=new Map,this.f=D.getProxy(A.MainContext.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(d=>{for(const m of d)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const m of d)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const v=this.g.getDocument(D);if(v)return v}getDocument(D){const v=this.getDocumentData(D);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return v.document}ensureDocumentData(D){const v=this.g.getDocument(D);if(v)return Promise.resolve(v);let d=this.h.get(D.toString());return d||(d=this.f.$tryOpenDocument(D).then(m=>{this.h.delete(D.toString());const h=I.URI.revive(m);return(0,S.assertIsDefined)(this.g.getDocument(h))},m=>(this.h.delete(D.toString()),Promise.reject(m))),this.h.set(D.toString(),d)),d}createDocumentData(D){return this.f.$tryCreateDocument(D).then(v=>I.URI.revive(v))}$acceptModelLanguageChanged(D,v){const d=I.URI.revive(D),m=this.g.getDocument(d);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(v),this.a.fire(m.document)}$acceptModelSaved(D){const v=I.URI.revive(D),d=this.g.getDocument(v);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(D,v){const d=I.URI.revive(D),m=this.g.getDocument(d);if(!m)throw new Error("unknown document");m._acceptIsDirty(v),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,v,d){const m=I.URI.revive(D),h=this.g.getDocument(m);if(!h)throw new Error("unknown document");h._acceptIsDirty(d),h.onEvents(v);let b;v.isUndoing?b=L.TextDocumentChangeReason.Undo:v.isRedoing&&(b=L.TextDocumentChangeReason.Redo),this.c.fire((0,y.deepFreeze)({document:h.document,contentChanges:v.changes.map(p=>({range:T.Range.to(p.range),rangeOffset:p.rangeOffset,rangeLength:p.rangeLength,text:p.text})),reason:b}))}setWordDefinitionFor(D,v){(0,C.setWordDefinitionFor)(D,v)}}e.ExtHostDocuments=P}),define(Se[58],ye([1,0,49,4,6,2,3,5,135,16,138,14,13,28,15,62,81]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(g){this.value=g,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let b=class{constructor(g,w){this.h=g,this.i=w,this.a=null,this.b=new Map,this.c=new D.ResourceMap,this.d=new t.Emitter,this.e=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const w=[],s=[],r=[];if(g.removedDocuments)for(const l of g.removedDocuments){const u=A.URI.revive(l),o=this.c.get(u);o?.unref()&&(this.c.delete(u),w.push(o.value))}if(g.addedDocuments)for(const l of g.addedDocuments){const u=A.URI.revive(l.uri);let o=this.c.get(u);if(o&&u.scheme!==v.Schemas.vscodeNotebookCell&&u.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);o||(o=new h(new S.ExtHostDocumentData(this.h.getProxy(T.MainContext.MainThreadDocuments),u,l.lines,l.EOL,l.versionId,l.languageId,l.isDirty,l.notebook)),this.c.set(u,o),s.push(o.value)),o.ref()}if(g.removedEditors)for(const l of g.removedEditors){const u=this.b.get(l);this.b.delete(l),u&&r.push(u)}if(g.addedEditors)for(const l of g.addedEditors){const u=A.URI.revive(l.documentUri);c.ok(this.c.has(u),`document '${u}' does not exist`),c.ok(!this.b.has(l.id),`editor '${l.id}' already exists!`);const o=this.c.get(u).value,a=new L.ExtHostTextEditor(l.id,this.h.getProxy(T.MainContext.MainThreadTextEditors),this.i,new m.Lazy(()=>o.document),l.selections.map(P.Selection.to),l.options,l.visibleRanges.map(n=>P.Range.to(n)),typeof l.editorPosition=="number"?P.ViewColumn.to(l.editorPosition):void 0);this.b.set(l.id,a)}g.newActiveEditor!==void 0&&(c.ok(g.newActiveEditor===null||this.b.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this.a=g.newActiveEditor),(0,I.dispose)(w),(0,I.dispose)(r),g.removedDocuments&&this.e.fire(w),g.addedDocuments&&this.d.fire(s),(g.removedEditors||g.addedEditors)&&this.f.fire(this.allEditors().map(l=>l.value)),g.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(g){return this.c.get(g)?.value}allDocuments(){return d.Iterable.map(this.c.values(),g=>g.value)}getEditor(g){return this.b.get(g)}activeEditor(g){if(!this.a)return;const w=this.b.get(this.a);return g?w:w?.value}allEditors(){return[...this.b.values()]}};b=qe([He(0,y.IExtHostRpcService),He(1,E.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(Se[59],ye([1,0,14,5,2,4,3,7,16,11,80]),function(ne,e,c,t,I,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class P{constructor(m,h,b){this.e=b,this.d=h,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,h={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(h)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.TextTabInput(I.URI.revive(this.b.input.uri));case 2:return new T.TextDiffTabInput(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new T.TextMergeTabInput(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new T.CustomEditorTabInput(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.WebviewEditorTabInput(this.b.input.viewType);case 4:return new T.NotebookEditorTabInput(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));default:return}}}class E{constructor(m,h){this.c=[],this.d="",this.b=m,this.e=h;for(const b of m.tabs)b.isActive&&(this.d=b.id),this.c.push(new P(b,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,h={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return c.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(b=>b.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(b=>b.apiObject))}};this.a=Object.freeze(h)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const b=new P(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,b),m.tabDto.isActive&&(this.d=b.tabId),b}else if(m.kind===1){const b=this.c.splice(m.index,1)[0];if(!b)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return b.tabId===this.d&&(this.d=""),b}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const b=this.c.splice(m.oldIndex,1)[0];if(!b)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,b),b}const h=this.c.find(b=>b.tabId===m.tabDto.id);if(!h)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),h.acceptDtoUpdate(m.tabDto),h}activeTabId(){return this.d}}let D=class{constructor(m){this.b=new A.Emitter,this.c=new A.Emitter,this.e=[],this.a=m.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,h={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(b=>b.apiObject))},get activeTabGroup(){const b=m.d;return(0,y.assertIsDefined)(m.e.find(g=>g.groupId===b)?.apiObject)},close:async(b,p)=>{const g=Array.isArray(b)?b:[b];return g.length?v(g[0])?this.j(g,p):this.i(g,p):!0}};this.f=Object.freeze(h)}return this.f}$acceptEditorTabModel(m){const h=new Set(this.e.map(l=>l.groupId)),b=new Set(m.map(l=>l.groupId)),p=(0,L.diffSets)(h,b),g=this.e.filter(l=>p.removed.includes(l.groupId)).map(l=>l.apiObject),w=[],s=[];this.e=m.map(l=>{const u=new E(l,()=>this.d);return p.added.includes(u.groupId)?w.push(u.apiObject):s.push(u.apiObject),u});const r=(0,y.assertIsDefined)(m.find(l=>l.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:w,closed:g,changed:s}))}$acceptTabGroupUpdate(m){const h=this.e.find(b=>b.groupId===m.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const h=this.e.find(p=>p.groupId===m.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const b=h.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[b.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[b.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[b.apiObject]}));return}}g(m){for(const h of this.e)for(const b of h.tabs)if(b.apiObject===m)return b}h(m){return this.e.find(h=>h.apiObject===m)}async i(m,h){const b=[];for(const p of m){const g=this.g(p);if(!g)throw new Error("Tab close: Invalid tab not found!");b.push(g.tabId)}return this.a.$closeTab(b,h)}async j(m,h){const b=[];for(const p of m){const g=this.h(p);if(!g)throw new Error("Group close: Invalid group not found!");b.push(g.groupId)}return this.a.$closeGroup(b,h)}};D=qe([He(0,S.IExtHostRpcService)],D),e.ExtHostEditorTabs=D;function v(d){return d.tabs!==void 0}}),define(Se[251],ye([1,0,2,5,6,7,14,153,8,22,26]),function(ne,e,c,t,I,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const d=this.a.indexOf(v);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),d=[];let m,h,b=14,p=14;for(const g of v){let w=m?(0,S.commonPrefixLength)(m,g):0;for(w===0?h=1:h=p;w<g.length;w++)w+1===g.length?(b=p,p=9):p+=1,d.push([h,g.toUpperCase().charCodeAt(w),p]),d.push([h,g.toLowerCase().charCodeAt(w),p]),h=p;m=g,p=b}d.push([9,58,10]),d.push([10,47,12]),this.b=new T.StateMachine(d)}}provideDocumentLinks(v){this.c();const d=[],m=T.LinkComputer.computeLinks({getLineContent(h){return v.lineAt(h-1).text},getLineCount(){return v.lineCount}},this.b);for(const h of m){const b=C.DocumentLink.to(h);b.target&&d.push(b)}return d}}class E{constructor(v,d){this.i=d,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,d,m,h={}){if(this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const b=this.h++;this.b.add(d),this.d.add(d),this.c.set(b,m);let p=2;h.isCaseSensitive&&(p+=1024),h.isReadonly&&(p+=2048),typeof m.copy=="function"&&(p+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&((0,L.checkProposedApiEnabled)(v,"fsChunks"),p+=4),this.a.$registerFileSystemProvider(b,d,p).catch(w=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${d}`),console.error(w)});const g=m.onDidChangeFile(w=>{const s=[];for(const r of w){const{uri:l,type:u}=r;if(l.scheme!==d)continue;let o;switch(u){case A.FileChangeType.Changed:o=0;break;case A.FileChangeType.Created:o=1;break;case A.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:l,type:o})}this.a.$onFileSystemChange(b,s)});return(0,I.toDisposable)(()=>{g.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(b),this.a.$unregisterProvider(b)})}static j(v){const{type:d,ctime:m,mtime:h,size:b,permissions:p}=v;return{type:d,ctime:m,mtime:h,size:b,permissions:p}}$stat(v,d){return Promise.resolve(this.k(v).stat(c.URI.revive(d))).then(m=>E.j(m))}$readdir(v,d){return Promise.resolve(this.k(v).readDirectory(c.URI.revive(d)))}$readFile(v,d){return Promise.resolve(this.k(v).readFile(c.URI.revive(d))).then(m=>y.VSBuffer.wrap(m))}$writeFile(v,d,m,h){return Promise.resolve(this.k(v).writeFile(c.URI.revive(d),m.buffer,h))}$delete(v,d,m){return Promise.resolve(this.k(v).delete(c.URI.revive(d),m))}$rename(v,d,m,h){return Promise.resolve(this.k(v).rename(c.URI.revive(d),c.URI.revive(m),h))}$copy(v,d,m,h){const b=this.k(v);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(c.URI.revive(d),c.URI.revive(m),h))}$mkdir(v,d){return Promise.resolve(this.k(v).createDirectory(c.URI.revive(d)))}$watch(v,d,m,h){const b=this.k(v).watch(c.URI.revive(m),h);this.f.set(d,b)}$unwatch(v,d){const m=this.f.get(d);m&&(m.dispose(),this.f.delete(d))}$open(v,d,m){const h=this.k(v);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(c.URI.revive(d),m))}$close(v,d){const m=this.k(v);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(d))}$read(v,d,m,h){const b=this.k(v);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const p=y.VSBuffer.alloc(h);return Promise.resolve(b.read(d,m,p.buffer,0,h)).then(g=>p.slice(0,g))}$write(v,d,m,h){const b=this.k(v);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(d,m,h.buffer,0,h.byteLength))}k(v){const d=this.c.get(v);if(!d){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return d}}e.ExtHostFileSystem=E}),define(Se[71],ye([1,0,5,38,7,22,3,16,47,6]),function(ne,e,c,t,I,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Qt{constructor(E,D){this.b=new Map,this.a=E.getProxy(c.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(d){try{const m=v.b.get(d.scheme);if(!m)return await v.a.$stat(d);await v.a.$ensureActivation(d.scheme);const h=await m.stat(d);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions}}catch(m){Qt.c(m)}},async readDirectory(d){try{const m=v.b.get(d.scheme);return m?(await v.a.$ensureActivation(d.scheme),(await m.readDirectory(d)).slice()):await v.a.$readdir(d)}catch(m){return Qt.c(m)}},async createDirectory(d){try{return await v.a.$mkdir(d)}catch(m){return Qt.c(m)}},async readFile(d){try{const m=v.b.get(d.scheme);return m?(await v.a.$ensureActivation(d.scheme),(await m.readFile(d)).slice()):(await v.a.$readFile(d)).buffer}catch(m){return Qt.c(m)}},async writeFile(d,m){try{return await v.a.$writeFile(d,A.VSBuffer.wrap(m))}catch(h){return Qt.c(h)}},async delete(d,m){try{const h=v.b.get(d.scheme);return h?(await v.a.$ensureActivation(d.scheme),await h.delete(d,{recursive:!1,...m})):await v.a.$delete(d,{recursive:!1,useTrash:!1,...m})}catch(h){return Qt.c(h)}},async rename(d,m,h){try{return await v.a.$rename(d,m,{overwrite:!1,...h})}catch(b){return Qt.c(b)}},async copy(d,m,h){try{return await v.a.$copy(d,m,{overwrite:!1,...h})}catch(b){return Qt.c(b)}},isWritableFileSystem(d){const m=D.getCapabilities(d);if(typeof m=="number")return!(m&2048)}})}static c(E){if(E instanceof I.FileSystemError)throw E;if(!(E instanceof Error))throw new I.FileSystemError(String(E));if(E.name==="ENOPRO")throw I.FileSystemError.Unavailable(E.message);switch(E.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(E.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(E.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(E.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(E.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(E.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(E.message);default:throw new I.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,D){return this.b.set(E,D),(0,y.toDisposable)(()=>this.b.delete(E))}};L=qe([He(0,T.IExtHostRpcService),He(1,S.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(Se[252],ye([1,0,4,37,2,5,14,7]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(P,E,D,v,d,m,h,b){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter;const p=this.h(P,D,d);this.g=0,m&&(this.g+=1),h&&(this.g+=2),b&&(this.g+=4);const g=(0,t.parse)(d),w=typeof d=="string",s=v(r=>{if(!m)for(const l of r.created){const u=I.URI.revive(l);g(u.fsPath)&&(!w||E.getWorkspaceFolder(u))&&this.a.fire(u)}if(!h)for(const l of r.changed){const u=I.URI.revive(l);g(u.fsPath)&&(!w||E.getWorkspaceFolder(u))&&this.b.fire(u)}if(!b)for(const l of r.deleted){const u=I.URI.revive(l);g(u.fsPath)&&(!w||E.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=T.Disposable.from(p,this.a,this.b,this.c,s)}h(P,E,D){const v=T.Disposable.from();if(typeof D=="string")return v;const d=P.getProxy(A.MainContext.MainThreadFileSystem);let m=!1;(D.pattern.includes(t.GLOBSTAR)||D.pattern.includes(t.GLOB_SPLIT))&&(m=!0);const h=Math.random();return d.$watch(E.identifier.value,h,D.baseUri,{recursive:m,excludes:[]}),T.Disposable.from({dispose:()=>d.$unwatch(h)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class y{constructor(P,E,D){this.j=P,this.k=E,this.l=D,this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.g=new c.AsyncEmitter,this.h=new c.AsyncEmitter,this.i=new c.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,E,D,v,d,m){return new S(this.j,P,E,this.a.event,C.GlobPattern.from(D),v,d,m)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,E){switch(P){case 2:this.b.fire(Object.freeze({files:E.map(D=>({oldUri:I.URI.revive(D.source),newUri:I.URI.revive(D.target)}))}));break;case 1:this.d.fire(Object.freeze({files:E.map(D=>I.URI.revive(D.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:E.map(D=>I.URI.revive(D.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,E){return(D,v,d)=>{const m=function(b){D.call(v,b)};return m.extension=P,E.event(m,void 0,d)}}async $onWillRunFileOperation(P,E,D,v){switch(P){case 2:return await this.n(this.g,{files:E.map(d=>({oldUri:I.URI.revive(d.source),newUri:I.URI.revive(d.target)}))},D,v);case 1:return await this.n(this.i,{files:E.map(d=>I.URI.revive(d.target))},D,v);case 0:case 3:return await this.n(this.h,{files:E.map(d=>I.URI.revive(d.target))},D,v)}}async n(P,E,D,v){const d=new Set,m=[];if(await P.fireAsync(E,v,async(b,p)=>{const g=Date.now(),w=await Promise.resolve(b);w instanceof T.WorkspaceEdit&&(m.push([p.extension,w]),d.add(p.extension.displayName??p.extension.identifier.value)),Date.now()-g>D&&this.k.warn("SLOW file-participant",p.extension.identifier)}),v.isCancellationRequested||m.length===0)return;const h={edits:[]};for(const[,b]of m){const{edits:p}=C.WorkspaceEdit.from(b,{getTextDocumentVersion:g=>this.l.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(p)}return{edit:h,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=y}),define(Se[253],ye([1,0,2,39]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(C,T,S,y,L){this.a=T,this.b=S,this.c=y;const P=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new t.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new t.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new t.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new t.ApiCommandResult("Notebook and input URI",E=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const D=this.a.getEditorById(E.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",D.id),{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri),notebookEditor:D.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:c.URI.revive(E.notebookUri),inputUri:c.URI.revive(E.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(C,T,S,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(c.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=I}),define(Se[254],ye([1,0,6,5]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(C){this.b=0,this.a=C.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,C),(0,c.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=I}),define(Se[255],ye([1,0,2,23,14,7,66,5,8,35,17,11,149,21,6,118,99,68,44,10,18,26]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b,p,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(O,H){this.d=O,this.e=H}async provideDocumentSymbols(O,H){const K=this.d.getDocument(O),Y=await this.e.provideDocumentSymbols(K,H);if(!(0,L.isFalsyOrEmpty)(Y))return Y[0]instanceof A.DocumentSymbol?Y.map(I.DocumentSymbol.from):s.f(Y)}static f(O){O=O.slice(0).sort((Y,de)=>{let be=Y.location.range.start.compareTo(de.location.range.start);return be===0&&(be=de.location.range.end.compareTo(Y.location.range.end)),be});const H=[],K=[];for(const Y of O){const de={name:Y.name||"!!MISSING: name!!",kind:I.SymbolKind.from(Y.kind),tags:Y.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:Y.containerName,range:I.Range.from(Y.location.range),selectionRange:I.Range.from(Y.location.range),children:[]};for(;;){if(K.length===0){K.push(de),H.push(de);break}const be=K[K.length-1];if(y.Range.containsRange(be.range,de.range)&&!y.Range.equalsRange(be.range,de.range)){be.children?.push(de),K.push(de);break}K.pop()}}return H}}class r{constructor(O,H,K){this.g=O,this.h=H,this.j=K,this.e=new h.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(O,H){const K=this.g.getDocument(O),Y=await this.j.provideCodeLenses(K,H);if(!Y||H.isCancellationRequested)return;const de=this.e.add(Y),be=new v.DisposableStore;this.f.set(de,be);const Pe={cacheId:de,lenses:[]};for(let pe=0;pe<Y.length;pe++)Pe.lenses.push({cacheId:[de,pe],range:I.Range.from(Y[pe].range),command:this.h.toInternal(Y[pe].command,be)});return Pe}async resolveCodeLens(O,H){const K=O.cacheId&&this.e.get(...O.cacheId);if(!K)return;let Y;if(typeof this.j.resolveCodeLens!="function"||K.isResolved?Y=K:Y=await this.j.resolveCodeLens(K,H),Y||(Y=K),H.isCancellationRequested)return;const de=O.cacheId&&this.f.get(O.cacheId[0]);if(!!de)return O.command=this.h.toInternal(Y.command??r.d,de),O}releaseCodeLenses(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}}r.d={command:"missing",title:"!!MISSING: command!!"};function l(ie){return Array.isArray(ie)?ie.map(I.DefinitionLink.from):ie?[I.DefinitionLink.from(ie)]:[]}class u{constructor(O,H){this.d=O,this.e=H}async provideDefinition(O,H,K){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideDefinition(Y,de,K);return l(be)}}class o{constructor(O,H){this.d=O,this.e=H}async provideDeclaration(O,H,K){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideDeclaration(Y,de,K);return l(be)}}class a{constructor(O,H){this.d=O,this.e=H}async provideImplementation(O,H,K){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideImplementation(Y,de,K);return l(be)}}class n{constructor(O,H){this.d=O,this.e=H}async provideTypeDefinition(O,H,K){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideTypeDefinition(Y,de,K);return l(be)}}class i{constructor(O,H){this.d=O,this.e=H}async provideHover(O,H,K){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideHover(Y,de,K);if(!(!be||(0,L.isFalsyOrEmpty)(be.contents)))return be.range||(be.range=Y.getWordRangeAtPosition(de)),be.range||(be.range=new A.Range(de,de)),I.Hover.from(be)}}class f{constructor(O,H){this.d=O,this.e=H}async provideEvaluatableExpression(O,H,K){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideEvaluatableExpression(Y,de,K);if(be)return I.EvaluatableExpression.from(be)}}class k{constructor(O,H){this.d=O,this.e=H}async provideInlineValues(O,H,K,Y){const de=this.d.getDocument(O),be=await this.e.provideInlineValues(de,I.Range.to(H),I.InlineValueContext.to(K),Y);if(Array.isArray(be))return be.map(Pe=>I.InlineValue.from(Pe))}}class R{constructor(O,H){this.d=O,this.e=H}async provideDocumentHighlights(O,H,K){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideDocumentHighlights(Y,de,K);if(Array.isArray(be))return be.map(I.DocumentHighlight.from)}}class B{constructor(O,H){this.d=O,this.e=H}async provideLinkedEditingRanges(O,H,K){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideLinkedEditingRanges(Y,de,K);if(be&&Array.isArray(be.ranges))return{ranges:(0,L.coalesce)(be.ranges.map(I.Range.from)),wordPattern:be.wordPattern}}}class X{constructor(O,H){this.d=O,this.e=H}async provideReferences(O,H,K,Y){const de=this.d.getDocument(O),be=I.Position.to(H),Pe=await this.e.provideReferences(de,be,K,Y);if(Array.isArray(Pe))return Pe.map(I.location.from)}}class q{constructor(O,H,K,Y,de,be,Pe){this.g=O,this.h=H,this.j=K,this.k=Y,this.l=de,this.m=be,this.n=Pe,this.e=new h.Cache("CodeAction"),this.f=new Map}async provideCodeActions(O,H,K,Y){const de=this.g.getDocument(O),be=E.Selection.isISelection(H)?I.Selection.to(H):I.Range.to(H),Pe=[];for(const et of this.j.getDiagnostics(O))if(be.intersection(et.range)&&Pe.push(et)>q.d)break;const pe={diagnostics:Pe,only:K.only?new A.CodeActionKind(K.only):void 0,triggerKind:I.CodeActionTriggerKind.to(K.trigger)},Ce=await this.k.provideCodeActions(de,be,pe,Y);if(!(0,L.isNonEmptyArray)(Ce)||Y.isCancellationRequested)return;const ke=this.e.add(Ce),je=new v.DisposableStore;this.f.set(ke,je);const Ge=[];for(let et=0;et<Ce.length;et++){const _e=Ce[et];!_e||(q.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,je)})):(pe.only&&(_e.kind?pe.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,et],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,je),diagnostics:_e.diagnostics&&_e.diagnostics.map(I.Diagnostic.from),edit:_e.edit&&I.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(O,H){const[K,Y]=O,de=this.e.get(K,Y);if(!de||q.o(de)||!this.k.resolveCodeAction)return;const be=await this.k.resolveCodeAction(de,H)??de;return be?.edit?I.WorkspaceEdit.from(be.edit,void 0):void 0}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}q.d=1e3;class N{constructor(O,H,K,Y){this.d=O,this.e=H,this.f=K,this.g=Y}async prepareDocumentPaste(O,H,K,Y){if(!this.f.prepareDocumentPaste)return;const de=this.e.getDocument(O),be=H.map(pe=>I.Range.to(pe)),Pe=I.DataTransfer.toDataTransfer(K,()=>{throw new p.NotImplementedError});return await this.f.prepareDocumentPaste(de,be,Pe,Y),I.DataTransfer.toDataTransferDTO(Pe)}async providePasteEdits(O,H,K,Y,de){const be=this.e.getDocument(H),Pe=K.map(ke=>I.Range.to(ke)),pe=I.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolvePasteFileData(this.g,O,ke)).buffer),Ce=await this.f.provideDocumentPasteEdits(be,Pe,pe,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?I.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class M{constructor(O,H){this.d=O,this.e=H}async provideDocumentFormattingEdits(O,H,K){const Y=this.d.getDocument(O),de=await this.e.provideDocumentFormattingEdits(Y,H,K);if(Array.isArray(de))return de.map(I.TextEdit.from)}}class F{constructor(O,H){this.d=O,this.e=H}async provideDocumentRangeFormattingEdits(O,H,K,Y){const de=this.d.getDocument(O),be=I.Range.to(H),Pe=await this.e.provideDocumentRangeFormattingEdits(de,be,K,Y);if(Array.isArray(Pe))return Pe.map(I.TextEdit.from)}}class z{constructor(O,H){this.d=O,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,H,K,Y,de){const be=this.d.getDocument(O),Pe=I.Position.to(H),pe=await this.e.provideOnTypeFormattingEdits(be,Pe,K,Y,de);if(Array.isArray(pe))return pe.map(I.TextEdit.from)}}class U{constructor(O,H){this.e=O,this.f=H,this.d=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,H){const K=await this.e.provideWorkspaceSymbols(O,H);if(!(0,L.isNonEmptyArray)(K))return{symbols:[]};const Y=this.d.add(K),de={cacheId:Y,symbols:[]};for(let be=0;be<K.length;be++){const Pe=K[be];if(!Pe||!Pe.name){this.f.warn("INVALID SymbolInformation",Pe);continue}de.symbols.push({...I.WorkspaceSymbol.from(Pe),cacheId:[Y,be]})}return de}async resolveWorkspaceSymbol(O,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const K=this.d.get(...O.cacheId);if(K){const Y=await this.e.resolveWorkspaceSymbol(K,H);return Y&&(0,t.mixin)(O,I.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class W{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,H,K){this.d=O,this.e=H,this.f=K}async provideRenameEdits(O,H,K,Y){const de=this.d.getDocument(O),be=I.Position.to(H);try{const Pe=await this.e.provideRenameEdits(de,be,K,Y);return Pe?I.WorkspaceEdit.from(Pe):void 0}catch(Pe){const pe=W.g(Pe);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Pe)}}async resolveRenameLocation(O,H,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Y=this.d.getDocument(O),de=I.Position.to(H);try{const be=await this.e.prepareRename(Y,de,K);let Pe,pe;if(A.Range.isRange(be)?(Pe=be,pe=Y.getText(be)):(0,P.isObject)(be)&&(Pe=be.range,pe=be.placeholder),!Pe||!pe)return;if(Pe.start.line>de.line||Pe.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Pe),text:pe}}catch(be){const Pe=W.g(be);return Pe?{rejectReason:Pe,range:void 0,text:void 0}:Promise.reject(be)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class x{constructor(O,H){this.resultId=O,this.tokens=H}}class V{constructor(O,H){this.f=O,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,H,K){const Y=this.f.getDocument(O),de=H!==0?this.d.get(H):null;let be=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Y,de.resultId,K):await this.g.provideDocumentSemanticTokens(Y,K);return de&&this.d.delete(H),be?(be=V.h(be),this.o(V.n(de,be),be)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return V.j(O)?V.k(O)?O:new A.SemanticTokens(new Uint32Array(O.data),O.resultId):V.l(O)?V.m(O)?O:new A.SemanticTokensEdits(O.edits.map(H=>new A.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const H of O.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(O,H){if(!V.j(H)||!O||!O.tokens)return H;const K=O.tokens,Y=K.length,de=H.data,be=de.length;let Pe=0;const pe=Math.min(Y,be);for(;Pe<pe&&K[Pe]===de[Pe];)Pe++;if(Pe===Y&&Pe===be)return new A.SemanticTokensEdits([],H.resultId);let Ce=0;const ke=pe-Pe;for(;Ce<ke&&K[Y-Ce-1]===de[be-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Pe,deleteCount:Y-Pe-Ce,data:de.subarray(Pe,be-Ce)}],H.resultId)}o(O,H){if(V.j(O)){const K=this.e++;return this.d.set(K,new x(O.resultId,O.data)),(0,d.encodeSemanticTokensDto)({id:K,type:"full",data:O.data})}if(V.l(O)){const K=this.e++;return V.j(H)?this.d.set(K,new x(H.resultId,H.data)):this.d.set(K,new x(O.resultId)),(0,d.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(O.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}class _{constructor(O,H){this.d=O,this.e=H}async provideDocumentRangeSemanticTokens(O,H,K){const Y=this.d.getDocument(O),de=await this.e.provideDocumentRangeSemanticTokens(Y,I.Range.to(H),K);return de?this.f(de):null}f(O){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class Q{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,H,K,Y,de){this.f=O,this.g=H,this.h=K,this.j=Y,this.k=de,this.d=new h.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(O,H,K,Y){const de=this.f.getDocument(O),be=I.Position.to(H),Pe=de.getWordRangeAtPosition(be)||new A.Range(be,be),pe=Pe.with({end:be}),Ce=new b.StopWatch(!0),ke=await this.h.provideCompletionItems(de,be,Y,I.CompletionContext.to(K));if(!ke||Y.isCancellationRequested)return;const je=Array.isArray(ke)?new A.CompletionList(ke):ke,Ge=Q.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),et=new v.DisposableStore;this.e.set(Ge,et);const _e=[],nt={x:Ge,b:_e,a:{replace:I.Range.from(Pe),insert:I.Range.from(pe)},c:je.isIncomplete||void 0,d:Ce.elapsed()};for(let st=0;st<je.items.length;st++){const ht=je.items[st],Fe=this.l(ht,[Ge,st],pe,Pe);_e.push(Fe)}return nt}async resolveCompletionItem(O,H){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...O);if(!K)return;const Y=await this.h.resolveCompletionItem(K,H);if(!!Y)return this.l(Y,O)}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,H,K,Y){const de=this.e.get(H[0]);if(!de)throw Error("DisposableStore is missing...");const be=this.g.toInternal(O.command,de),Pe={x:H,a:O.label,b:O.kind!==void 0?I.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(I.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:I.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(I.TextEdit.from),n:be?.$ident,o:be?.id,p:be?.$ident?void 0:be?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Pe.h=O.textEdit.newText):typeof O.insertText=="string"?Pe.h=O.insertText:O.insertText instanceof A.SnippetString&&(Pe.h=O.insertText.value,Pe.i|=4);let pe;return O.textEdit?pe=O.textEdit.range:O.range&&(pe=O.range),A.Range.isRange(pe)?Pe.j=I.Range.from(pe):pe&&(!K?.isEqual(pe.inserting)||!Y?.isEqual(pe.replacing))&&(Pe.j={insert:I.Range.from(pe.inserting),replace:I.Range.from(pe.replacing)}),Pe}}class J{async provideInlineCompletions(O,H,K,Y){}disposeCompletions(O){}handleDidShowCompletionItem(O,H){}}class te extends J{constructor(O,H,K,Y){super(),this.f=O,this.g=H,this.h=K,this.j=Y,this.d=new le,this.e=(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,H,K,Y){const de=this.g.getDocument(O),be=I.Position.to(H),Pe=await this.h.provideInlineCompletionItems(de,be,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:I.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},Y);if(!Pe||Y.isCancellationRequested)return;const pe=Array.isArray(Pe)?Pe:Pe.items,Ce=this.e?Array.isArray(Pe)?[]:Pe.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:pe}),items:pe.map((Ge,et)=>{let _e;Ge.command&&(ke||(ke=new v.DisposableStore),_e=this.j.toInternal(Ge.command,ke));const nt=Ge.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ge.filterText,range:Ge.range?I.Range.from(Ge.range):void 0,command:_e,idx:et,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:Ce.map(Ge=>(ke||(ke=new v.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,H){const K=this.d.get(O)?.items[H];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K)}}class le{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const H=this.e++;return this.d.set(H,O),H}disposeReferenceId(O){const H=this.d.get(O);return this.d.delete(O),H}get(O){return this.d.get(O)}}class Z{constructor(O,H){this.e=O,this.f=H,this.d=new h.Cache("SignatureHelp")}async provideSignatureHelp(O,H,K,Y){const de=this.e.getDocument(O),be=I.Position.to(H),Pe=this.g(K),pe=await this.f.provideSignatureHelp(de,be,Y,Pe);if(pe){const Ce=this.d.add([pe]);return{...I.SignatureHelp.from(pe),id:Ce}}}g(O){let H;if(O.activeSignatureHelp){const K=I.SignatureHelp.to(O.activeSignatureHelp),Y=this.d.get(O.activeSignatureHelp.id,0);Y?(H=Y,H.activeSignature=K.activeSignature,H.activeParameter=K.activeParameter):H=K}return{...O,activeSignatureHelp:H}}releaseSignatureHelp(O){this.d.delete(O)}}class ge{constructor(O,H,K,Y,de){this.f=O,this.g=H,this.h=K,this.j=Y,this.k=de,this.d=new h.Cache("InlayHints"),this.e=new Map}async provideInlayHints(O,H,K){const Y=this.f.getDocument(O),de=I.Range.to(H),be=await this.h.provideInlayHints(Y,de,K);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${H}`);return}if(K.isCancellationRequested)return;const Pe=this.d.add(be);this.e.set(Pe,new v.DisposableStore);const pe={hints:[],cacheId:Pe};for(let Ce=0;Ce<be.length;Ce++)this.l(be[Ce],de)&&pe.hints.push(this.m(be[Ce],[Pe,Ce]));return this.j.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this.k.identifier.value}' for ${H}`),pe}async resolveInlayHint(O,H){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...O);if(!K)return;const Y=await this.h.resolveInlayHint(K,H);if(!!Y&&!!this.l(Y))return this.m(Y,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,H){return O.label.length===0||Array.isArray(O.label)&&O.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(H&&!H.contains(O.position))}m(O,H){const K=this.e.get(H[0]);if(!K)throw Error("DisposableStore is missing...");const Y={label:"",cacheId:H,tooltip:I.MarkdownString.fromStrict(O.tooltip),position:I.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(I.TextEdit.from),kind:O.kind&&I.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?Y.label=O.label:Y.label=O.label.map(de=>{const be={label:de.value};return be.tooltip=I.MarkdownString.fromStrict(de.tooltip),A.Location.isLocation(de.location)&&(be.location=I.location.from(de.location)),de.command&&(be.command=this.g.toInternal(de.command,K)),be}),Y}}class ve{constructor(O,H){this.e=O,this.f=H,this.d=new h.Cache("DocumentLink")}async provideLinks(O,H){const K=this.e.getDocument(O),Y=await this.f.provideDocumentLinks(K,H);if(!(!Array.isArray(Y)||Y.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Y.filter(ve.g).map(I.DocumentLink.from)};{const de=this.d.add(Y),be={links:[],cacheId:de};for(let Pe=0;Pe<Y.length;Pe++){if(!ve.g(Y[Pe]))continue;const pe=I.DocumentLink.from(Y[Pe]);pe.cacheId=[de,Pe],be.links.push(pe)}return be}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,H){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...O);if(!K)return;const Y=await this.f.resolveDocumentLink(K,H);if(!(!Y||!ve.g(Y)))return I.DocumentLink.from(Y)}releaseLinks(O){this.d.delete(O)}}class De{constructor(O,H){this.d=O,this.e=H}async provideColors(O,H){const K=this.d.getDocument(O),Y=await this.e.provideDocumentColors(K,H);return Array.isArray(Y)?Y.map(be=>({color:I.Color.from(be.color),range:I.Range.from(be.range)})):[]}async provideColorPresentations(O,H,K){const Y=this.d.getDocument(O),de=I.Range.to(H.range),be=I.Color.to(H.color),Pe=await this.e.provideColorPresentations(be,{document:Y,range:de},K);if(!!Array.isArray(Pe))return Pe.map(I.ColorPresentation.from)}}class Re{constructor(O,H){this.d=O,this.e=H}async provideFoldingRanges(O,H,K){const Y=this.d.getDocument(O),de=await this.e.provideFoldingRanges(Y,H,K);if(!!Array.isArray(de))return de.map(I.FoldingRange.from)}}class ze{constructor(O,H,K){this.d=O,this.e=H,this.f=K}async provideSelectionRanges(O,H,K){const Y=this.d.getDocument(O),de=H.map(I.Position.to),be=await this.e.provideSelectionRanges(Y,de,K);if(!(0,L.isNonEmptyArray)(be))return[];if(be.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Pe=[];for(let pe=0;pe<de.length;pe++){const Ce=[];Pe.push(Ce);let ke=de[pe],je=be[pe];for(;;){if(!je.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(I.SelectionRange.from(je)),!je.parent)break;ke=je.range,je=je.parent}}return Pe}}class se{constructor(O,H){this.f=O,this.g=H,this.d=new m.IdGenerator(""),this.e=new Map}async prepareSession(O,H,K){const Y=this.f.getDocument(O),de=I.Position.to(H),be=await this.g.prepareCallHierarchy(Y,de,K);if(!be)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(be)?be.map(pe=>this.h(Pe,pe)):[this.h(Pe,be)]}async provideCallsTo(O,H,K){const Y=this.j(O,H);if(!Y)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(Y,K);if(!!de)return de.map(be=>({from:this.h(O,be.from),fromRanges:be.fromRanges.map(Pe=>I.Range.from(Pe))}))}async provideCallsFrom(O,H,K){const Y=this.j(O,H);if(!Y)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(Y,K);if(!!de)return de.map(be=>({to:this.h(O,be.to),fromRanges:be.fromRanges.map(Pe=>I.Range.from(Pe))}))}releaseSession(O){this.e.delete(O)}h(O,H){const K=this.e.get(O),Y=I.CallHierarchyItem.from(H,O,K.size.toString(36));return K.set(Y._itemId,H),Y}j(O,H){return this.e.get(O)?.get(H)}}class ue{constructor(O,H){this.f=O,this.g=H,this.d=new m.IdGenerator(""),this.e=new Map}async prepareSession(O,H,K){const Y=this.f.getDocument(O),de=I.Position.to(H),be=await this.g.prepareTypeHierarchy(Y,de,K);if(!be)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(be)?be.map(pe=>this.h(Pe,pe)):[this.h(Pe,be)]}async provideSupertypes(O,H,K){const Y=this.j(O,H);if(!Y)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(Y,K);if(!!de)return de.map(be=>this.h(O,be))}async provideSubtypes(O,H,K){const Y=this.j(O,H);if(!Y)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(Y,K);if(!!de)return de.map(be=>this.h(O,be))}releaseSession(O){this.e.delete(O)}h(O,H){const K=this.e.get(O),Y=I.TypeHierarchyItem.from(H,O,K.size.toString(36));return K.set(Y._itemId,H),Y}j(O,H){return this.e.get(O)?.get(H)}}class he{constructor(O,H,K,Y){this.d=O,this.e=H,this.f=K,this.g=Y}async provideDocumentOnDropEdits(O,H,K,Y,de){const be=this.e.getDocument(H),Pe=I.Position.to(K),pe=I.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,ke)).buffer),Ce=await this.f.provideDocumentDropEdits(be,Pe,pe,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?I.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class ee{constructor(O,H){this.adapter=O,this.extension=H}}class oe{constructor(O,H,K,Y,de,be,Pe,pe){this.g=H,this.h=K,this.j=Y,this.k=de,this.l=be,this.m=Pe,this.n=pe,this.f=new Map,this.e=O.getProxy(T.MainContext.MainThreadLanguageFeatures)}o(O){return I.DocumentSelector.from(O,this.g)}p(O){return new A.Disposable(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return oe.d++}async s(O,H,K,Y,de,be=!1){const Pe=this.f.get(O);if(!Pe||!(Pe.adapter instanceof H))return Y;const pe=Date.now();be||this.l.trace(`[${Pe.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ce=K(Pe.adapter,Pe.extension);return Promise.resolve(Ce).catch(ke=>{(0,p.isCancellationError)(ke)||(this.l.error(`[${Pe.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Pe.extension.identifier,ke))}).finally(()=>{be||this.l.trace(`[${Pe.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),D.CancellationToken.isCancellationToken(de)?(0,g.raceCancellationError)(Ce,de):Ce}t(O,H){const K=this.q();return this.f.set(K,new ee(O,H)),K}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,H,K,Y){const de=this.t(new s(this.h,K),O),be=Y&&Y.label||oe.u(O);return this.e.$registerDocumentSymbolProvider(de,this.o(H),be),this.p(de)}$provideDocumentSymbols(O,H,K){return this.s(O,s,Y=>Y.provideDocumentSymbols(c.URI.revive(H),K),void 0,K)}registerCodeLensProvider(O,H,K){const Y=this.q(),de=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Y,new ee(new r(this.h,this.j.converter,K),O)),this.e.$registerCodeLensSupport(Y,this.o(H),de);let be=this.p(Y);if(de!==void 0){const Pe=K.onDidChangeCodeLenses(pe=>this.e.$emitCodeLensEvent(de));be=A.Disposable.from(be,Pe)}return be}$provideCodeLenses(O,H,K){return this.s(O,r,Y=>Y.provideCodeLenses(c.URI.revive(H),K),void 0,K)}$resolveCodeLens(O,H,K){return this.s(O,r,Y=>Y.resolveCodeLens(H,K),void 0,void 0)}$releaseCodeLenses(O,H){this.s(O,r,K=>Promise.resolve(K.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(O,H,K){const Y=this.t(new u(this.h,K),O);return this.e.$registerDefinitionSupport(Y,this.o(H)),this.p(Y)}$provideDefinition(O,H,K,Y){return this.s(O,u,de=>de.provideDefinition(c.URI.revive(H),K,Y),[],Y)}registerDeclarationProvider(O,H,K){const Y=this.t(new o(this.h,K),O);return this.e.$registerDeclarationSupport(Y,this.o(H)),this.p(Y)}$provideDeclaration(O,H,K,Y){return this.s(O,o,de=>de.provideDeclaration(c.URI.revive(H),K,Y),[],Y)}registerImplementationProvider(O,H,K){const Y=this.t(new a(this.h,K),O);return this.e.$registerImplementationSupport(Y,this.o(H)),this.p(Y)}$provideImplementation(O,H,K,Y){return this.s(O,a,de=>de.provideImplementation(c.URI.revive(H),K,Y),[],Y)}registerTypeDefinitionProvider(O,H,K){const Y=this.t(new n(this.h,K),O);return this.e.$registerTypeDefinitionSupport(Y,this.o(H)),this.p(Y)}$provideTypeDefinition(O,H,K,Y){return this.s(O,n,de=>de.provideTypeDefinition(c.URI.revive(H),K,Y),[],Y)}registerHoverProvider(O,H,K,Y){const de=this.t(new i(this.h,K),O);return this.e.$registerHoverProvider(de,this.o(H)),this.p(de)}$provideHover(O,H,K,Y){return this.s(O,i,de=>de.provideHover(c.URI.revive(H),K,Y),void 0,Y)}registerEvaluatableExpressionProvider(O,H,K,Y){const de=this.t(new f(this.h,K),O);return this.e.$registerEvaluatableExpressionProvider(de,this.o(H)),this.p(de)}$provideEvaluatableExpression(O,H,K,Y){return this.s(O,f,de=>de.provideEvaluatableExpression(c.URI.revive(H),K,Y),void 0,Y)}registerInlineValuesProvider(O,H,K,Y){const de=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new k(this.h,K),O);this.e.$registerInlineValuesProvider(be,this.o(H),de);let Pe=this.p(be);if(de!==void 0){const pe=K.onDidChangeInlineValues(Ce=>this.e.$emitInlineValuesEvent(de));Pe=A.Disposable.from(Pe,pe)}return Pe}$provideInlineValues(O,H,K,Y,de){return this.s(O,k,be=>be.provideInlineValues(c.URI.revive(H),K,Y,de),void 0,de)}registerDocumentHighlightProvider(O,H,K){const Y=this.t(new R(this.h,K),O);return this.e.$registerDocumentHighlightProvider(Y,this.o(H)),this.p(Y)}$provideDocumentHighlights(O,H,K,Y){return this.s(O,R,de=>de.provideDocumentHighlights(c.URI.revive(H),K,Y),void 0,Y)}registerLinkedEditingRangeProvider(O,H,K){const Y=this.t(new B(this.h,K),O);return this.e.$registerLinkedEditingRangeProvider(Y,this.o(H)),this.p(Y)}$provideLinkedEditingRanges(O,H,K,Y){return this.s(O,B,async de=>{const be=await de.provideLinkedEditingRanges(c.URI.revive(H),K,Y);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?oe.w(be.wordPattern):void 0}},void 0,Y)}registerReferenceProvider(O,H,K){const Y=this.t(new X(this.h,K),O);return this.e.$registerReferenceSupport(Y,this.o(H)),this.p(Y)}$provideReferences(O,H,K,Y,de){return this.s(O,X,be=>be.provideReferences(c.URI.revive(H),K,Y,de),void 0,de)}registerCodeActionProvider(O,H,K,Y){const de=new v.DisposableStore,be=this.t(new q(this.h,this.j.converter,this.k,K,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(be,this.o(H),{providedKinds:Y?.providedCodeActionKinds?.map(Pe=>Pe.value),documentation:Y?.documentation?.map(Pe=>({kind:Pe.kind.value,command:this.j.converter.toInternal(Pe.command,de)}))},oe.u(O),Boolean(K.resolveCodeAction)),de.add(this.p(be)),de}$provideCodeActions(O,H,K,Y,de){return this.s(O,q,be=>be.provideCodeActions(c.URI.revive(H),K,Y,de),void 0,de)}$resolveCodeAction(O,H,K){return this.s(O,q,Y=>Y.resolveCodeAction(H,K),void 0,void 0)}$releaseCodeActions(O,H){this.s(O,q,K=>Promise.resolve(K.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(O,H,K){const Y=this.t(new M(this.h,K),O);return this.e.$registerDocumentFormattingSupport(Y,this.o(H),O.identifier,O.displayName||O.name),this.p(Y)}$provideDocumentFormattingEdits(O,H,K,Y){return this.s(O,M,de=>de.provideDocumentFormattingEdits(c.URI.revive(H),K,Y),void 0,Y)}registerDocumentRangeFormattingEditProvider(O,H,K){const Y=this.t(new F(this.h,K),O);return this.e.$registerRangeFormattingSupport(Y,this.o(H),O.identifier,O.displayName||O.name),this.p(Y)}$provideDocumentRangeFormattingEdits(O,H,K,Y,de){return this.s(O,F,be=>be.provideDocumentRangeFormattingEdits(c.URI.revive(H),K,Y,de),void 0,de)}registerOnTypeFormattingEditProvider(O,H,K,Y){const de=this.t(new z(this.h,K),O);return this.e.$registerOnTypeFormattingSupport(de,this.o(H),Y,O.identifier),this.p(de)}$provideOnTypeFormattingEdits(O,H,K,Y,de,be){return this.s(O,z,Pe=>Pe.provideOnTypeFormattingEdits(c.URI.revive(H),K,Y,de,be),void 0,be)}registerWorkspaceSymbolProvider(O,H){const K=this.t(new U(H,this.l),O);return this.e.$registerNavigateTypeSupport(K,typeof H.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(O,H,K){return this.s(O,U,Y=>Y.provideWorkspaceSymbols(H,K),{symbols:[]},K)}$resolveWorkspaceSymbol(O,H,K){return this.s(O,U,Y=>Y.resolveWorkspaceSymbol(H,K),void 0,void 0)}$releaseWorkspaceSymbols(O,H){this.s(O,U,K=>K.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(O,H,K){const Y=this.t(new W(this.h,K,this.l),O);return this.e.$registerRenameSupport(Y,this.o(H),W.supportsResolving(K)),this.p(Y)}$provideRenameEdits(O,H,K,Y,de){return this.s(O,W,be=>be.provideRenameEdits(c.URI.revive(H),K,Y,de),void 0,de)}$resolveRenameLocation(O,H,K,Y){return this.s(O,W,de=>de.resolveRenameLocation(c.URI.revive(H),K,Y),void 0,Y)}registerDocumentSemanticTokensProvider(O,H,K,Y){const de=this.t(new V(this.h,K),O),be=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(H),Y,be);let Pe=this.p(de);if(be){const pe=K.onDidChangeSemanticTokens(Ce=>this.e.$emitDocumentSemanticTokensEvent(be));Pe=A.Disposable.from(Pe,pe)}return Pe}$provideDocumentSemanticTokens(O,H,K,Y){return this.s(O,V,de=>de.provideDocumentSemanticTokens(c.URI.revive(H),K,Y),null,Y)}$releaseDocumentSemanticTokens(O,H){this.s(O,V,K=>K.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,H,K,Y){const de=this.t(new _(this.h,K),O);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(H),Y),this.p(de)}$provideDocumentRangeSemanticTokens(O,H,K,Y){return this.s(O,_,de=>de.provideDocumentRangeSemanticTokens(c.URI.revive(H),K,Y),null,Y)}registerCompletionItemProvider(O,H,K,Y){const de=this.t(new Q(this.h,this.j.converter,K,this.m,O),O);return this.e.$registerCompletionsProvider(de,this.o(H),Y,Q.supportsResolving(K),`${O.identifier.value}(${Y.join("")})`),this.p(de)}$provideCompletionItems(O,H,K,Y,de){return this.s(O,Q,be=>be.provideCompletionItems(c.URI.revive(H),K,Y,de),void 0,de)}$resolveCompletionItem(O,H,K){return this.s(O,Q,Y=>Y.resolveCompletionItem(H,K),void 0,K)}$releaseCompletionItems(O,H){this.s(O,Q,K=>K.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(O,H,K){const Y=new te(O,this.h,K,this.j.converter),de=this.t(Y,O);return this.e.$registerInlineCompletionsSupport(de,this.o(H),Y.supportsHandleDidShowCompletionItem),this.p(de)}$provideInlineCompletions(O,H,K,Y,de){return this.s(O,J,be=>be.provideInlineCompletions(c.URI.revive(H),K,Y,de),void 0,de)}$handleInlineCompletionDidShow(O,H,K){this.s(O,J,async Y=>{Y.handleDidShowCompletionItem(H,K)},void 0,void 0)}$freeInlineCompletionsList(O,H){this.s(O,J,async K=>{K.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(O,H,K,Y){const de=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,be=this.t(new Z(this.h,K),O);return this.e.$registerSignatureHelpProvider(be,this.o(H),de),this.p(be)}$provideSignatureHelp(O,H,K,Y,de){return this.s(O,Z,be=>be.provideSignatureHelp(c.URI.revive(H),K,Y,de),void 0,de)}$releaseSignatureHelp(O,H){this.s(O,Z,K=>K.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(O,H,K){const Y=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new ge(this.h,this.j.converter,K,this.l,O),O);this.e.$registerInlayHintsProvider(de,this.o(H),typeof K.resolveInlayHint=="function",Y,oe.u(O));let be=this.p(de);if(Y!==void 0){const Pe=K.onDidChangeInlayHints(pe=>this.e.$emitInlayHintsEvent(Y));be=A.Disposable.from(be,Pe)}return be}$provideInlayHints(O,H,K,Y){return this.s(O,ge,de=>de.provideInlayHints(c.URI.revive(H),K,Y),void 0,Y)}$resolveInlayHint(O,H,K){return this.s(O,ge,Y=>Y.resolveInlayHint(H,K),void 0,K)}$releaseInlayHints(O,H){this.s(O,ge,K=>K.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(O,H,K){const Y=this.t(new ve(this.h,K),O);return this.e.$registerDocumentLinkProvider(Y,this.o(H),typeof K.resolveDocumentLink=="function"),this.p(Y)}$provideDocumentLinks(O,H,K){return this.s(O,ve,Y=>Y.provideLinks(c.URI.revive(H),K),void 0,K,H.scheme==="output")}$resolveDocumentLink(O,H,K){return this.s(O,ve,Y=>Y.resolveLink(H,K),void 0,void 0,!0)}$releaseDocumentLinks(O,H){this.s(O,ve,K=>K.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(O,H,K){const Y=this.t(new De(this.h,K),O);return this.e.$registerDocumentColorProvider(Y,this.o(H)),this.p(Y)}$provideDocumentColors(O,H,K){return this.s(O,De,Y=>Y.provideColors(c.URI.revive(H),K),[],K)}$provideColorPresentations(O,H,K,Y){return this.s(O,De,de=>de.provideColorPresentations(c.URI.revive(H),K,Y),void 0,Y)}registerFoldingRangeProvider(O,H,K){const Y=this.q(),de=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Y,new ee(new Re(this.h,K),O)),this.e.$registerFoldingRangeProvider(Y,this.o(H),O.identifier,de);let be=this.p(Y);if(de!==void 0){const Pe=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));be=A.Disposable.from(be,Pe)}return be}$provideFoldingRanges(O,H,K,Y){return this.s(O,Re,de=>de.provideFoldingRanges(c.URI.revive(H),K,Y),void 0,Y)}registerSelectionRangeProvider(O,H,K){const Y=this.t(new ze(this.h,K,this.l),O);return this.e.$registerSelectionRangeProvider(Y,this.o(H)),this.p(Y)}$provideSelectionRanges(O,H,K,Y){return this.s(O,ze,de=>de.provideSelectionRanges(c.URI.revive(H),K,Y),[],Y)}registerCallHierarchyProvider(O,H,K){const Y=this.t(new se(this.h,K),O);return this.e.$registerCallHierarchyProvider(Y,this.o(H)),this.p(Y)}$prepareCallHierarchy(O,H,K,Y){return this.s(O,se,de=>Promise.resolve(de.prepareSession(c.URI.revive(H),K,Y)),void 0,Y)}$provideCallHierarchyIncomingCalls(O,H,K,Y){return this.s(O,se,de=>de.provideCallsTo(H,K,Y),void 0,Y)}$provideCallHierarchyOutgoingCalls(O,H,K,Y){return this.s(O,se,de=>de.provideCallsFrom(H,K,Y),void 0,Y)}$releaseCallHierarchy(O,H){this.s(O,se,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(O,H,K){const Y=this.t(new ue(this.h,K),O);return this.e.$registerTypeHierarchyProvider(Y,this.o(H)),this.p(Y)}$prepareTypeHierarchy(O,H,K,Y){return this.s(O,ue,de=>Promise.resolve(de.prepareSession(c.URI.revive(H),K,Y)),void 0,Y)}$provideTypeHierarchySupertypes(O,H,K,Y){return this.s(O,ue,de=>de.provideSupertypes(H,K,Y),void 0,Y)}$provideTypeHierarchySubtypes(O,H,K,Y){return this.s(O,ue,de=>de.provideSubtypes(H,K,Y),void 0,Y)}$releaseTypeHierarchy(O,H){this.s(O,ue,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(O,H,K){const Y=this.q();return this.f.set(Y,new ee(new he(this.e,this.h,K,Y),O)),this.e.$registerDocumentOnDropEditProvider(Y,this.o(H)),this.p(Y)}$provideDocumentOnDropEdits(O,H,K,Y,de,be){return this.s(O,he,Pe=>Promise.resolve(Pe.provideDocumentOnDropEdits(H,c.URI.revive(K),Y,de,be)),void 0,void 0)}registerDocumentPasteEditProvider(O,H,K,Y){const de=this.q();return this.f.set(de,new ee(new N(this.e,this.h,K,de),O)),this.e.$registerPasteEditProvider(de,this.o(H),!!K.prepareDocumentPaste,Y.pasteMimeTypes),this.p(de)}$prepareDocumentPaste(O,H,K,Y,de){return this.s(O,N,be=>be.prepareDocumentPaste(c.URI.revive(H),K,Y,de),void 0,de)}$providePasteEdits(O,H,K,Y,de,be){return this.s(O,N,Pe=>Pe.providePasteEdits(H,c.URI.revive(K),Y,de,be),void 0,be)}static w(O){return{pattern:O.source,flags:(0,S.regExpFlags)(O)}}static y(O){return{decreaseIndentPattern:oe.w(O.decreaseIndentPattern),increaseIndentPattern:oe.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?oe.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?oe.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:oe.w(O.beforeText),afterText:O.afterText?oe.w(O.afterText):void 0,previousLineText:O.previousLineText?oe.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(oe.z)}setLanguageConfiguration(O,H,K){const{wordPattern:Y}=K;if(Y&&(0,S.regExpLeadsToEndlessLoop)(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this.h.setWordDefinitionFor(H,Y):this.h.setWordDefinitionFor(H,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const de=this.q(),be={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?oe.w(K.wordPattern):void 0,indentationRules:K.indentationRules?oe.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?oe.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport};return this.e.$setLanguageConfiguration(de,H,be),this.p(de)}$setWordDefinitions(O){for(const H of O)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=oe,oe.d=0}),define(Se[256],ye([1,0,5,14,7,42,18,6]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(L,P,E,D){this.c=P,this.d=E,this.e=D,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,P){await this.a.$changeLanguage(L,P);const E=this.c.getDocumentData(L);if(!E)throw new Error(`document '${L.toString()}' NOT found`);return E.document}async tokenAtPosition(L,P){const E=L.version,D=t.Position.from(P),v=await this.a.$tokensAtPosition(L.uri,D),d={type:I.StandardTokenType.Other,range:L.getWordRangeAtPosition(P)??new I.Range(P.line,P.character,P.line,P.character)};if(!v)return d;const m={range:t.Range.to(v.range),type:t.TokenType.to(v.type)};return!m.range.contains(P)||E!==L.version?d:m}createLanguageStatusItem(L,P,E){const D=this.f++,v=this.a,d=this.g,m=`${L.identifier.value}/${P}`;if(d.has(m))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);d.add(m);const h={selector:E,id:P,name:L.displayName??L.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const p=new T.DisposableStore,g=()=>{b?.dispose(),b=(0,C.disposableTimeout)(()=>{p.clear(),this.a.$setLanguageStatus(D,{id:m,name:h.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===I.LanguageStatusSeverity.Error?A.default.Error:h.severity===I.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:h.command&&this.d.toInternal(h.command,p),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},w={dispose(){p.dispose(),b?.dispose(),v.$removeLanguageStatus(D),d.delete(m)},get id(){return h.id},get name(){return h.name},set name(s){h.name=s,g()},get selector(){return h.selector},set selector(s){h.selector=s,g()},get text(){return h.text},set text(s){h.text=s,g()},get detail(){return h.detail},set detail(s){h.detail=s,g()},get severity(){return h.severity},set severity(s){h.severity=s,g()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(s){h.accessibilityInformation=s,g()},get command(){return h.command},set command(s){h.command=s,g()},get busy(){return h.busy},set busy(s){h.busy=s,g()}};return g(),w}}e.ExtHostLanguages=S}),define(Se[95],ye([1,0,12,8,2,3,13,5,25,16]),function(ne,e,c,t,I,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(E,D,v){this.f=v,this.d=new Map,this.a=D.getProxy(T.MainContext.MainThreadLocalization),this.b=E.environment.appLanguage,this.c=this.b===c.LANGUAGE_DEFAULT}getMessage(E,D){const{message:v,args:d,comment:m}=D;if(this.c)return(0,t.format2)(v,d??{});let h=v;m&&m.length>0&&(h+=`/${Array.isArray(m)?m.join():m}`);const b=this.d.get(E)?.contents[h];return b||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,t.format2)(b??v,d??{})}getBundle(E){return this.d.get(E)?.contents}getBundleUri(E){return this.d.get(E)?.uri}async initializeLocalizedMessages(E){if(this.c||!E.l10n&&!E.isBuiltin||this.d.has(E.identifier.value))return;let D;const v=await this.g(E);if(!v){this.f.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(v),m=JSON.parse(d);D=E.isBuiltin?m.contents?.bundle:m}catch(d){this.f.error(`Failed to load translations for ${E.identifier.value} from ${v}: ${d.message}`);return}D&&this.d.set(E.identifier.value,{contents:D,uri:v})}async g(E){if(E.isBuiltin){const D=await this.a.$fetchBuiltInBundleUri(E.identifier.value);return I.URI.revive(D)}return E.l10n?I.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=qe([He(0,S.IExtHostInitDataService),He(1,y.IExtHostRpcService),He(2,C.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(Se[140],ye([1,0,13,5,25,16,2,4,11]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends c.AbstractLoggerService{constructor(E,D){super(D.logLevel,T.Event.None),this.g=E.getProxy(t.MainContext.MainThreadLogger)}$setLevel(E,D){D?this.setLevel(C.URI.revive(D),E):(0,S.isUndefined)(E)||this.setLevel(E)}f(E,D,v){return new L(this.g,E,D,v)}};y=qe([He(0,A.IExtHostRpcService),He(1,I.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class L extends c.AbstractMessageLogger{constructor(E,D,v,d){super(d?.always),this.m=E,this.n=D,this.k=!1,this.l=[],this.setLevel(v),this.m.$createLogger(D,d).then(()=>{this.r(this.l),this.k=!0})}g(E,D){const v=[[E,D]];this.k?this.r(v):this.l.push(...v)}r(E){this.m.$log(this.n,E)}}}),define(Se[257],ye([1,0,5,13,26]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(T){return T&&T.title}let C=class{constructor(S,y){this.b=y,this.a=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,y,L,P,E){const D={source:{identifier:S.identifier,label:S.displayName||S.name}};let v;typeof P=="string"||A(P)?v=[P,...E]:(D.modal=P?.modal,D.useCustom=P?.useCustom,D.detail=P?.detail,v=E),D.useCustom&&(0,I.checkProposedApiEnabled)(S,"resolvers");const d=[];for(let m=0;m<v.length;m++){const h=v[m];if(typeof h=="string")d.push({title:h,handle:m,isCloseAffordance:!1});else if(typeof h=="object"){const{title:b,isCloseAffordance:p}=h;d.push({title:b,isCloseAffordance:!!p,handle:m})}else this.b.warn("Invalid message item:",h)}return this.a.$showMessage(y,L,D,d).then(m=>{if(typeof m=="number")return v[m]})}};C=qe([He(1,t.ILogService)],C),e.ExtHostMessageService=C}),define(Se[258],ye([1,0,22,4,6,28,8,11,2,68,5,39,14,7,57,233,136]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(p=>p.apiEditor)}constructor(p,g,w,s){this.q=w,this.r=s,this.f=new Map,this.g=new A.ResourceMap,this.h=new Map,this.j=new t.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new t.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new t.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new y.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=p.getProxy(L.MainContext.MainThreadNotebook),this.c=p.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=p.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=g.converter,g.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const l=r.notebookEditor?.notebookUri,u=r.cell.handle,a=this.g.get(l)?.getCell(u);if(a)return a.apiCell}if(r&&r.$mid===14){const l=r.uri,u=this.g.get(l);if(u)return u.apiNotebook}return r}}),h.x(g)}getEditorById(p){const g=this.h.get(p);if(!g)throw new Error(`unknown text editor: ${p}. known editors: ${[...this.h.keys()]} `);return g}getIdByEditor(p){for(const[g,w]of this.h)if(w.apiEditor===p)return g}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(p,g){const w=this.g.get(p);if(!w&&!g)throw new Error(`NO notebook document for '${p}'`);return w}static s(p,g){if(!g)return;const w=g.filenamePattern.map(s=>E.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(g.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:p.identifier,providerDisplayName:p.displayName||p.name,displayName:g.displayName,filenamePattern:w,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(p,g,w){const s=h.a++,r=typeof w.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(s,w),this.b.$registerNotebookCellStatusBarItemProvider(s,r,g);let l;return r!==void 0&&(l=w.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(r))),new D.Disposable(()=>{this.f.delete(s),this.b.$unregisterNotebookCellStatusBarItemProvider(s,r),l?.dispose()})}async createNotebookDocument(p){const g=await this.c.$tryCreateNotebook({viewType:p.viewType,content:p.content&&E.NotebookData.from(p.content)});return S.URI.revive(g)}async openNotebookDocument(p){const g=this.g.get(p);if(g)return g.apiNotebook;const w=await this.c.$tryOpenNotebook(p),s=this.g.get(S.URI.revive(w));return(0,T.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(p,g){S.URI.isUri(p)&&(p=await this.openNotebookDocument(p));let w;typeof g=="object"?w={position:E.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(E.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:w={preserveFocus:!1};const s=await this.d.$tryShowNotebookDocument(p.uri,p.notebookType,w),r=s&&this.h.get(s)?.apiEditor;if(r)return r;throw s?new Error(`Could NOT open editor for "${p.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${p.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(p,g,w,s){const r=this.f.get(p),l=S.URI.revive(g),u=this.g.get(l);if(!u||!r)return;const o=u.getCellFromIndex(w);if(!o)return;const a=await r.provideCellStatusBarItems(o.apiCell,s);if(!a)return;const n=new I.DisposableStore,i=this.p.add([n]),k=(Array.isArray(a)?a:[a]).map(R=>E.NotebookStatusBarItem.from(R,this.i,n));return{cacheId:i,items:k}}$releaseNotebookCellStatusBarItems(p){this.p.delete(p)}registerNotebookSerializer(p,g,w,s,r){if((0,C.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");const l=this.t++;return this.u.set(l,w),this.b.$registerNotebookSerializer(l,{id:p.identifier,location:p.extensionLocation},g,E.NotebookDocumentContentOptions.from(s),h.s(p,r)),(0,I.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(l)})}async $dataToNotebook(p,g,w){const s=this.u.get(p);if(!s)throw new Error("NO serializer found");const r=await s.deserializeNotebook(g.buffer,w);return new v.SerializableObjectWithBuffers(E.NotebookData.from(r))}async $notebookToData(p,g,w){const s=this.u.get(p);if(!s)throw new Error("NO serializer found");const r=await s.serializeNotebook(E.NotebookData.to(g.value),w);return c.VSBuffer.wrap(r)}w(p,g,w){if(this.h.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const s=new m.ExtHostNotebookEditor(g,this.d,p,w.visibleRanges.map(E.NotebookRange.to),w.selections.map(E.NotebookRange.to),typeof w.viewColumn=="number"?E.ViewColumn.to(w.viewColumn):void 0);this.h.set(g,s)}$acceptDocumentAndEditorsDelta(p){if(p.value.removedDocuments)for(const w of p.value.removedDocuments){const s=S.URI.revive(w),r=this.g.get(s);r&&(r.dispose(),this.g.delete(s),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(l=>l.document.uri)}),this.n.fire(r.apiNotebook));for(const l of this.h.values())l.notebookData.uri.toString()===s.toString()&&this.h.delete(l.id)}if(p.value.addedDocuments){const w=[];for(const s of p.value.addedDocuments){const r=S.URI.revive(s.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const l=new d.ExtHostNotebookDocument(this.c,this.q,this.r,r,s);w.push(...s.cells.map(u=>d.ExtHostCell.asModelAddData(l.apiNotebook,u))),this.g.get(r)?.dispose(),this.g.set(r,l),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(l.apiNotebook)}}if(p.value.addedEditors)for(const w of p.value.addedEditors){if(this.h.has(w.id))return;const s=S.URI.revive(w.documentUri),r=this.g.get(s);r&&this.w(r,w.id,w)}const g=[];if(p.value.removedEditors)for(const w of p.value.removedEditors){const s=this.h.get(w);s&&(this.h.delete(w),this.k?.id===s.id&&(this.k=void 0),g.push(s))}if(p.value.visibleEditors){this.l=p.value.visibleEditors.map(s=>this.h.get(s)).filter(s=>!!s);const w=new Set;this.l.forEach(s=>w.add(s.id));for(const s of this.h.values()){const r=w.has(s.id);s._acceptVisibility(r)}this.l=[...this.h.values()].map(s=>s).filter(s=>s.visible),this.o.fire(this.visibleNotebookEditors)}p.value.newActiveEditor===null?this.k=void 0:p.value.newActiveEditor&&(this.k=this.h.get(p.value.newActiveEditor)),p.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(p){const g=P.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[g,new P.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>c.VSBuffer.wrap(r))],new P.ApiCommandResult("Notebook Data",r=>E.NotebookData.to(r.value))),s=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[g,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new v.SerializableObjectWithBuffers(E.NotebookData.from(r)))],new P.ApiCommandResult("Bytes",r=>r.buffer));p.registerApiCommand(w),p.registerApiCommand(s)}}e.ExtHostNotebookController=h,h.a=0}),define(Se[259],ye([1,0,17,18,21,4,6,28,2,27,13,68,5,39,14,7,92,221,26,57]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let g=class{constructor(o,a,n,i,f){this.k=a,this.l=n,this.m=i,this.n=f,this.b=new T.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new P.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=o.getProxy(E.MainContext.MainThreadNotebookKernels);const k=new D.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new D.ApiCommandArgument("options","Select kernel options",R=>!0,R=>{if(R&&"notebookEditor"in R&&"id"in R){const B=this.l.getIdByEditor(R.notebookEditor);return{id:R.id,extension:R.extension,notebookEditorId:B}}else if(R&&"notebookEditor"in R){const B=this.l.getIdByEditor(R.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${R.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return R})],D.ApiCommandResult.Void);this.m.registerApiCommand(k)}createNotebookController(o,a,n,i,f,k){for(const J of this.h.values())if(J.controller.id===a&&y.ExtensionIdentifier.equals(o.identifier,J.extensionId))throw new Error(`notebook controller with id '${a}' ALREADY exist`);const R=this.i++,B=this;this.n.trace(`NotebookController[${R}], CREATED by ${o.identifier.value}, ${a}`);const X=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${o.identifier}'`);let q=!1;const N=new C.DisposableStore,M=new A.Emitter,F=new A.Emitter,z={id:l(o.identifier,a),notebookType:n,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:i||o.identifier.value,preloads:k?k.map(v.NotebookRendererScript.from):[]};let U=f??X,W;this.a.$addKernel(R,z).catch(J=>{console.log(J),q=!0});let x=0;const V=()=>{if(q)return;const J=++x;Promise.resolve().then(()=>{J===x&&this.a.$updateKernel(R,z)})},_=new T.ResourceMap,Q={get id(){return a},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return z.label},set label(J){z.label=J??o.displayName??o.name,V()},get detail(){return z.detail??""},set detail(J){z.detail=J,V()},get description(){return z.description??""},set description(J){z.description=J,V()},get kind(){return(0,b.checkProposedApiEnabled)(o,"notebookControllerKind"),z.kind??""},set kind(J){(0,b.checkProposedApiEnabled)(o,"notebookControllerKind"),z.kind=J,V()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(J){z.supportedLanguages=J,V()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(J){z.supportsExecutionOrder=J,V()},get rendererScripts(){return z.preloads?z.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(J){U=J??X},get interruptHandler(){return W},set interruptHandler(J){W=J,z.supportsInterrupt=Boolean(J),V()},createNotebookCellExecution(J){if(q)throw new Error("notebook controller is DISPOSED");if(!_.has(J.notebook.uri))throw B.n.trace(`NotebookController[${R}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${J.notebook.uri.toString()}`);return B._createNotebookCellExecution(J,l(o.identifier,this.id))},dispose:()=>{q||(this.n.trace(`NotebookController[${R}], DISPOSED`),q=!0,this.h.delete(R),N.dispose(),M.dispose(),F.dispose(),this.a.$removeKernel(R))},updateNotebookAffinity(J,te){te===d.NotebookControllerAffinity2.Hidden&&(0,b.checkProposedApiEnabled)(o,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(R,J.uri,te)},onDidReceiveMessage:F.event,postMessage(J,te){return(0,b.checkProposedApiEnabled)(o,"notebookMessaging"),B.a.$postMessage(R,te&&B.l.getIdByEditor(te),J)},asWebviewUri(J){return(0,b.checkProposedApiEnabled)(o,"notebookMessaging"),(0,m.asWebviewUri)(J,B.k.remote)}};return this.h.set(R,{extensionId:o.identifier,controller:Q,onDidReceiveMessage:F,onDidChangeSelection:M,associatedNotebooks:_}),Q}getIdByController(o){for(const[a,n]of this.h)if(n.controller===o)return l(n.extensionId,o.id);return null}createNotebookControllerDetectionTask(o,a){const n=this.d++,i=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${o.identifier.value}`),this.a.$addKernelDetectionTask(n,a);const f={dispose:()=>{this.c.delete(n),i.a.$removeKernelDetectionTask(n)}};return this.c.set(n,f),f}registerKernelSourceActionProvider(o,a,n){const i=this.f++,f=this;return this.e.set(i,n),this.n.trace(`NotebookKernelSourceActionProvider[${i}], CREATED by ${o.identifier.value}`),this.a.$addKernelSourceActionProvider(i,a),{dispose:()=>{this.e.delete(i),f.a.$removeKernelSourceActionProvider(i)}}}async $provideKernelSourceActions(o,a){const n=this.e.get(o);if(n){const i=new C.DisposableStore;return this.g.add([i]),(await n.provideNotebookKernelSourceActions(a)??[]).map(k=>v.NotebookKernelSourceAction.from(k,this.m.converter,i))}return[]}$acceptNotebookAssociation(o,a,n){const i=this.h.get(o);if(i){const f=this.l.getNotebookDocument(S.URI.revive(a));n?i.associatedNotebooks.set(f.uri,!0):i.associatedNotebooks.delete(f.uri),this.n.trace(`NotebookController[${o}] ASSOCIATE notebook`,f.uri.toString(),n),i.onDidChangeSelection.fire({selected:n,notebook:f.apiNotebook})}}async $executeCells(o,a,n){const i=this.h.get(o);if(!i)return;const f=this.l.getNotebookDocument(S.URI.revive(a)),k=[];for(const R of n){const B=f.getCell(R);B&&k.push(B.apiCell)}try{this.n.trace(`NotebookController[${o}] EXECUTE cells`,f.uri.toString(),k.length),await i.controller.executeHandler.call(i.controller,k,f.apiNotebook,i.controller)}catch(R){this.n.error(`NotebookController[${o}] execute cells FAILED`,R),console.error(R)}}async $cancelCells(o,a,n){const i=this.h.get(o);if(!i)return;const f=this.l.getNotebookDocument(S.URI.revive(a));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,f.apiNotebook);else for(const k of n){const R=f.getCell(k);R&&this.b.get(R.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,a,n){const i=this.h.get(o);if(!i)return;const f=this.l.getEditorById(a);i.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:n}))}$cellExecutionChanged(o,a,n){const f=this.l.getNotebookDocument(S.URI.revive(o)).getCell(a);if(f){const k=n?v.NotebookCellExecutionState.to(n):d.NotebookCellExecutionState.Idle;k!==void 0&&this.j.fire({cell:f.apiCell,state:k})}}_createNotebookCellExecution(o,a){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this.l.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!i)throw new Error("invalid cell");if(this.b.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const f=new s(a,i,this.a);this.b.set(i.uri,f);const k=f.onDidChangeState(()=>{f.state===w.Resolved&&(f.dispose(),k.dispose(),this.b.delete(i.uri))});return f.asApiObject()}};g=qe([He(4,L.ILogService)],g),e.ExtHostNotebookKernels=g;var w;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(w||(w={}));class s extends C.Disposable{get state(){return this.f}constructor(o,a,n){super(),this.j=a,this.k=n,this.b=s.a++,this.c=new A.Emitter,this.onDidChangeState=this.c.event,this.f=w.Init,this.g=this.B(new I.CancellationTokenSource),this.h=new r(10,i=>this.m(i)),this.i=a.internalMetadata.executionOrder,this.k.$createExecution(this.b,o,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(o){await this.h.addItem(o)}async m(o){const a=Array.isArray(o)?o:[o];return this.k.$updateExecution(this.b,new p.SerializableObjectWithBuffers(a))}n(){if(this.f===w.Init)throw new Error("Must call start before modifying cell output");if(this.f===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(o){let a=this.j;if(o&&(a=this.j.notebook.getCellFromApiCell(o)),!a)throw new Error("INVALID cell");return a.handle}s(o){return o.map(a=>{const n=d.NotebookCellOutput.ensureUniqueMimeTypes(a.items,!0);return n===a.items?v.NotebookCellOutput.from(a):v.NotebookCellOutput.from({items:n,id:a.id,metadata:a.metadata})})}async t(o,a,n){const i=this.r(a),f=this.s((0,c.asArray)(o));return this.l({editType:h.CellExecutionUpdateType.Output,cellHandle:i,append:n,outputs:f})}async w(o,a,n){return o=d.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(o),!0),this.l({editType:h.CellExecutionUpdateType.OutputItems,items:o.map(v.NotebookCellOutputItem.from),outputId:a.id,append:n})}asApiObject(){const o=this;return Object.freeze({get token(){return o.g.token},get cell(){return o.j.apiCell},get executionOrder(){return o.i},set executionOrder(n){o.i=n,o.m([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:o.i}])},start(n){if(o.f===w.Resolved||o.f===w.Started)throw new Error("Cannot call start again");o.f=w.Started,o.c.fire(),o.m({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,i){if(o.f===w.Resolved)throw new Error("Cannot call resolve twice");o.f=w.Resolved,o.c.fire(),o.h.flush(),o.k.$completeExecution(o.b,new p.SerializableObjectWithBuffers({runEndTime:i,lastRunSuccess:n}))},clearOutput(n){return o.n(),o.t([],n,!1)},appendOutput(n,i){return o.n(),o.t(n,i,!0)},replaceOutput(n,i){return o.n(),o.t(n,i,!1)},appendOutputItems(n,i){return o.n(),o.w(n,i,!0)},replaceOutputItems(n,i){return o.n(),o.w(n,i,!1)}})}}s.a=0;class r{constructor(o,a){this.d=o,this.e=a,this.a=[],this.b=Date.now()}addItem(o){return this.a.push(o),this.c||(this.c=new t.DeferredPromise,this.b=Date.now(),(0,t.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const o=this.c;this.c=void 0;const a=this.a;return this.a=[],this.e(a).finally(()=>o.complete())}}function l(u,o){return`${u.value}/${o}`}e.createKernelId=l}),define(Se[260],ye([1,0,4,5,136]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(T,S){this.c=S,this.a=new Map,this.b=T.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,S,y){const L=this.c.getEditorById(T);this.a.get(S)?.fire({editor:L.apiEditor,message:y})}createRendererMessaging(T,S){if(!T.contributes?.notebookRenderer?.some(L=>L.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(L,P,E)=>this.d(S).event(L,P,E),postMessage:(L,P)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,P]=[P,L]);const E=P&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(E?.id,S,L)}}}d(T){let S=this.a.get(T);return S||(S=new c.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(T)}}),this.a.set(T,S),S)}}e.ExtHostNotebookRenderers=A}),define(Se[261],ye([1,0,6,2,26,5]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class C{constructor(S){this.b=new Map,this.a=S.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,y,L){if((0,I.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(y))throw new Error(`Handler with id '${y}' already registered`);return this.b.set(y,L),this.a.$registerProfileContentHandler(y,L.name,S.identifier.value),(0,c.toDisposable)(()=>{this.b.delete(y),this.a.$unregisterProfileContentHandler(y)})}async $saveProfile(S,y,L,P){const E=this.b.get(S);if(!E)throw new Error(`Unknown handler with id: ${S}`);return E.saveProfile(y,L,P)}async $readProfile(S,y,L){const P=this.b.get(S);if(!P)throw new Error(`Unknown handler with id: ${S}`);return P.readProfile(t.URI.revive(y),L)}}e.ExtHostProfileContentHandlers=C}),define(Se[262],ye([1,0,21,4,6,5,2,7,10,17,42,89]),function(ne,e,c,t,I,A,C,T,S,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(D,v,d){const m=D.getProxy(A.MainContext.MainThreadQuickOpen);class h{constructor(o,a){this.e=new Map,this.f=0,this.a=o,this.b=a}showQuickPick(o,a,n=c.CancellationToken.None){this.c=void 0;const i=Promise.resolve(o),f=++this.f,k=m.$show(f,{title:a?.title,placeHolder:a?.placeHolder,matchOnDescription:a?.matchOnDescription,matchOnDetail:a?.matchOnDetail,ignoreFocusLost:a?.ignoreFocusOut,canPickMany:a?.canPickMany},n),R={},B=k.then(()=>R);return Promise.race([B,i]).then(X=>{if(X!==R)return i.then(q=>{const N=[];for(let M=0;M<q.length;M++){const F=q[M];typeof F=="string"?N.push({label:F,handle:M}):F.kind===T.QuickPickItemKind.Separator?N.push({type:"separator",label:F.label}):N.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:M})}return a&&typeof a.onDidSelectItem=="function"&&(this.c=M=>{a.onDidSelectItem(q[M])}),m.$setItems(f,N),k.then(M=>{if(typeof M=="number")return q[M];if(Array.isArray(M))return M.map(F=>q[F])})})}).then(void 0,X=>{if(!(0,S.isCancellationError)(X))return m.$setError(f,X),Promise.reject(X)})}$onItemSelected(o){this.c?.(o)}showInput(o,a=c.CancellationToken.None){return this.d=o?.validateInput,m.$input(o,typeof this.d=="function",a).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(o){if(!this.d)return;const a=await this.d(o);if(!a||typeof a=="string")return a;let n;switch(a.severity){case T.InputBoxValidationSeverity.Info:n=L.default.Info;break;case T.InputBoxValidationSeverity.Warning:n=L.default.Warning;break;case T.InputBoxValidationSeverity.Error:n=L.default.Error;break;default:n=a.message?L.default.Error:L.default.Ignore;break}return{content:a.message,severity:n}}async showWorkspaceFolderPick(o,a=c.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!n)return;const i=await this.a.getWorkspaceFolders2();if(!!i)return i.find(f=>f.uri.toString()===n.uri.toString())}createQuickPick(o){const a=new r(o,()=>this.e.delete(a._id));return this.e.set(a._id,a),a}createInputBox(o){const a=new l(o,()=>this.e.delete(a._id));return this.e.set(a._id,a),a}$onDidChangeValue(o,a){this.e.get(o)?._fireDidChangeValue(a)}$onDidAccept(o){this.e.get(o)?._fireDidAccept()}$onDidChangeActive(o,a){const n=this.e.get(o);n instanceof r&&n._fireDidChangeActive(a)}$onDidChangeSelection(o,a){const n=this.e.get(o);n instanceof r&&n._fireDidChangeSelection(a)}$onDidTriggerButton(o,a){this.e.get(o)?._fireDidTriggerButton(a)}$onDidTriggerItemButton(o,a,n){const i=this.e.get(o);i instanceof r&&i._fireDidTriggerItemButton(a,n)}$onDidHide(o){this.e.get(o)?._fireDidHide()}}class b{constructor(o,a){this.x=o,this.y=a,this._id=r.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new t.Emitter,this.q=new t.Emitter,this.r=new t.Emitter,this.s=new t.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(o){this.b=o,this.z({title:o})}get step(){return this.c}set step(o){this.c=o,this.z({step:o})}get totalSteps(){return this.d}set totalSteps(o){this.d=o,this.z({totalSteps:o})}get enabled(){return this.g}set enabled(o){this.g=o,this.z({enabled:o})}get busy(){return this.j}set busy(o){this.j=o,this.z({busy:o})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(o){this.k=o,this.z({ignoreFocusOut:o})}get value(){return this.l}set value(o){this.l=o,this.z({value:o})}get placeholder(){return this.m}set placeholder(o){this.m=o,this.z({placeholder:o})}get buttons(){return this.n}set buttons(o){this.n=o.slice(),this.o.clear(),o.forEach((a,n)=>{const i=a===T.QuickInputButtons.Back?-1:n;this.o.set(i,a)}),this.z({buttons:o.map((a,n)=>({...s(a),tooltip:a.tooltip,handle:a===T.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(o){this.l=o,this.q.fire(o)}_fireDidTriggerButton(o){const a=this.o.get(o);a&&this.r.fire(a)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),m.$dispose(this._id))}z(o){if(!this.v){for(const a of Object.keys(o)){const n=o[a];this.u[a]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){m.$createOrUpdate(this.u),this.u={id:this._id}}}b.a=1;function p(u){if(u instanceof T.ThemeIcon)return{id:u.id};const o=w(u),a=g(u);return{dark:typeof o=="string"?C.URI.file(o):o,light:typeof a=="string"?C.URI.file(a):a}}function g(u){return typeof u=="object"&&"light"in u?u.light:u}function w(u){return typeof u=="object"&&"dark"in u?u.dark:u}function s(u){const o=p(u.iconPath);let a,n;return"id"in o?n=P.ThemeIcon.asClassName(o):a=o,{iconPath:a,iconClass:n}}class r extends b{constructor(o,a){super(o.identifier,a),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new t.Emitter,this.L=[],this.M=new t.Emitter,this.N=new t.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(o){this.B=o.slice(),this.C.clear(),this.D.clear(),o.forEach((n,i)=>{this.C.set(i,n),this.D.set(n,i)});const a=[];for(let n=0;n<o.length;n++){const i=o[n];i.kind===T.QuickPickItemKind.Separator?a.push({type:"separator",label:i.label}):a.push({handle:n,label:i.label,description:i.description,detail:i.detail,picked:i.picked,alwaysShow:i.alwaysShow,buttons:i.buttons?.map((f,k)=>({...s(f),tooltip:f.tooltip,handle:k}))})}this.z({items:a})}get canSelectMany(){return this.E}set canSelectMany(o){this.E=o,this.z({canSelectMany:o})}get matchOnDescription(){return this.F}set matchOnDescription(o){this.F=o,this.z({matchOnDescription:o})}get matchOnDetail(){return this.G}set matchOnDetail(o){this.G=o,this.z({matchOnDetail:o})}get sortByLabel(){return this.H}set sortByLabel(o){this.H=o,this.z({sortByLabel:o})}get keepScrollPosition(){return this.I}set keepScrollPosition(o){this.I=o,this.z({keepScrollPosition:o})}get activeItems(){return this.J}set activeItems(o){this.J=o.filter(a=>this.D.has(a)),this.z({activeItems:this.J.map(a=>this.D.get(a))})}get selectedItems(){return this.L}set selectedItems(o){this.L=o.filter(a=>this.D.has(a)),this.z({selectedItems:this.L.map(a=>this.D.get(a))})}_fireDidChangeActive(o){const a=(0,y.coalesce)(o.map(n=>this.C.get(n)));this.J=a,this.K.fire(a)}_fireDidChangeSelection(o){const a=(0,y.coalesce)(o.map(n=>this.C.get(n)));this.L=a,this.M.fire(a)}_fireDidTriggerItemButton(o,a){const n=this.C.get(o);if(!n||!n.buttons||!n.buttons.length)return;const i=n.buttons[a];i&&this.N.fire({button:i,item:n})}}class l extends b{constructor(o,a){super(o.identifier,a),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(o){this.B=o,this.z({password:o})}get prompt(){return this.C}set prompt(o){this.C=o,this.z({prompt:o})}get valueSelection(){return this.D}set valueSelection(o){this.D=o,this.z({valueSelection:o})}get validationMessage(){return this.E}set validationMessage(o){this.E=o,o?typeof o=="string"?this.z({validationMessage:o,severity:L.default.Error}):this.z({validationMessage:o.message,severity:o.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new h(v,d)}e.createExtHostQuickOpen=E});var Me=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,c):I?I.value=c:e.set(ne,c),c};define(Se[263],ye([1,0,2,4,60,6,18,5,17,108,13,27,89,14,26]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v){"use strict";var d,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(i){if(i)return typeof i.iconPath=="string"?c.URI.file(i.iconPath):c.URI.isUri(i.iconPath)||E.ThemeIcon.isThemeIcon(i.iconPath)?i.iconPath:void 0}function b(i,f){if(!i.iconPath&&!f.iconPath)return 0;if(i.iconPath){if(!f.iconPath)return 1}else return-1;const k=typeof i.iconPath=="string"?i.iconPath:c.URI.isUri(i.iconPath)?i.iconPath.fsPath:i.iconPath.id,R=typeof f.iconPath=="string"?f.iconPath:c.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,y.comparePaths)(k,R)}function p(i,f){let k=0;if(i.strikeThrough!==f.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==f.faded)return i.faded?1:-1;if(i.tooltip!==f.tooltip)return(i.tooltip||"").localeCompare(f.tooltip||"");if(k=b(i,f),k!==0)return k;if(i.light&&f.light)k=b(i.light,f.light);else{if(i.light)return 1;if(f.light)return-1}if(k!==0)return k;if(i.dark&&f.dark)k=b(i.dark,f.dark);else{if(i.dark)return 1;if(f.dark)return-1}return k}function g(i,f){if(i.command!==f.command)return i.command<f.command?-1:1;if(i.title!==f.title)return i.title<f.title?-1:1;if(i.tooltip!==f.tooltip){if(i.tooltip!==void 0&&f.tooltip!==void 0)return i.tooltip<f.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(i.arguments===f.arguments)return 0;if(i.arguments)if(f.arguments){if(i.arguments.length!==f.arguments.length)return i.arguments.length-f.arguments.length}else return 1;else return-1;for(let k=0;k<i.arguments.length;k++){const R=i.arguments[k],B=f.arguments[k];if(R!==B)return R<B?-1:1}return 0}function w(i,f){let k=(0,y.comparePaths)(i.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(k!==0)return k;if(i.command&&f.command)k=g(i.command,f.command);else{if(i.command)return 1;if(f.command)return-1}if(k!==0)return k;if(i.decorations&&f.decorations)k=p(i.decorations,f.decorations);else{if(i.decorations)return 1;if(f.decorations)return-1}return k}function s(i,f){for(let k=0;k<i.length;k++)if(i[k]!==f[k])return!1;return!0}function r(i,f){return i.command===f.command&&i.title===f.title&&i.tooltip===f.tooltip&&(i.arguments&&f.arguments?s(i.arguments,f.arguments):i.arguments===f.arguments)}function l(i,f){return(0,S.equals)(i,f,r)}class u{get value(){return this.d}set value(f){f=f??"",Me(this,d,"f").$setInputBoxValue(this.l,f),this.m(f)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(f){Me(this,d,"f").$setInputBoxPlaceholder(this.l,f),this.f=f}get validateInput(){return(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(f){if((0,v.checkProposedApiEnabled)(this.k,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=f,Me(this,d,"f").$setValidationProviderIsEnabled(this.l,!!f)}get enabled(){return this.h}set enabled(f){f=!!f,this.h!==f&&(this.h=f,Me(this,d,"f").$setInputBoxEnablement(this.l,f))}get visible(){return this.j}set visible(f){f=!!f,this.j!==f&&(this.j=f,Me(this,d,"f").$setInputBoxVisibility(this.l,f))}constructor(f,k,R){this.k=f,this.l=R,d.set(this,void 0),this.d="",this.e=new t.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,d,k,"f")}showValidationMessage(f,k){(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),Me(this,d,"f").$showValidationMessage(this.l,f,k)}$onInputBoxValueChange(f){this.m(f)}m(f){this.d=f,this.e.fire(f)}}e.ExtHostSCMInputBox=u,d=new WeakMap;class o{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(f){this.v=f,this.q.$updateGroupLabel(this.t,this.handle,f)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(f){this.p=f,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(f){this.f=[...f],this.k.fire()}constructor(f,k,R,B,X){this.q=f,this.s=k,this.t=R,this.u=B,this.v=X,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new t.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new t.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=o.d++}getResourceState(f){return this.g.get(f)}$executeResourceCommand(f,k){const R=this.h.get(f);return R?(0,C.asPromise)(()=>this.s.executeCommand(R.command,...R.arguments||[],k)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this.f].sort(w),R=(0,S.sortedDiff)(this.o,f,w).map(q=>{const N=q.toInsert.map(M=>{const F=this.e++;this.g.set(F,M);const z=M.resourceUri;let U;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const ge=new A.DisposableStore;U=this.s.converter.toInternal(M.command,ge),this.j.set(F,ge)}else this.h.set(F,M.command);const W=h(M.decorations),x=M.decorations&&h(M.decorations.light)||W,V=M.decorations&&h(M.decorations.dark)||W,_=[x,V],Q=M.decorations&&M.decorations.tooltip||"",J=M.decorations&&!!M.decorations.strikeThrough,te=M.decorations&&!!M.decorations.faded,le=M.contextValue||"";return{rawResource:[F,z,_,Q,J,te,le,U],handle:F}});return{start:q.start,deleteCount:q.deleteCount,toInsert:N}}),B=R.map(({start:q,deleteCount:N,toInsert:M})=>[q,N,M.map(F=>F.rawResource)]),X=R.reverse();for(const{start:q,deleteCount:N,toInsert:M}of X){const F=M.map(U=>U.handle),z=this.n.splice(q,N,...F);for(const U of z)this.g.delete(U),this.h.delete(U),this.j.get(U)?.dispose(),this.j.delete(U)}return this.o=f,B}dispose(){this.l=!0,this.m.fire()}}o.d=0;class a{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(f){this.g!==f&&(this.g=f,Me(this,m,"f").$updateSourceControl(this.t,{count:f}))}get quickDiffProvider(){return this.h}set quickDiffProvider(f){this.h=f,Me(this,m,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this.j}set commitTemplate(f){f!==this.j&&(this.j=f,Me(this,m,"f").$updateSourceControl(this.t,{commitTemplate:f}))}get acceptInputCommand(){return this.l}set acceptInputCommand(f){this.k.value=new A.DisposableStore,this.l=f;const k=this.v.converter.toInternal(f,this.k.value);Me(this,m,"f").$updateSourceControl(this.t,{acceptInputCommand:k})}get actionButton(){return(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(f){(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new A.DisposableStore,this.n=f;const k=f!==void 0?{command:this.v.converter.toInternal(f.command,this.m.value),secondaryCommands:f.secondaryCommands?.map(R=>R.map(B=>this.v.converter.toInternal(B,this.m.value))),description:f.description,enabled:f.enabled}:void 0;Me(this,m,"f").$updateSourceControl(this.t,{actionButton:k??null})}get statusBarCommands(){return this.p}set statusBarCommands(f){if(this.p&&f&&l(this.p,f))return;this.o.value=new A.DisposableStore,this.p=f;const k=(f||[]).map(R=>this.v.converter.toInternal(R,this.o.value));Me(this,m,"f").$updateSourceControl(this.t,{statusBarCommands:k})}get selected(){return this.q}constructor(f,k,R,B,X,q){this.u=f,this.v=R,this.w=B,this.x=X,this.y=q,m.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new A.MutableDisposable,this.l=void 0,this.m=new A.MutableDisposable,this.o=new A.MutableDisposable,this.p=void 0,this.q=!1,this.s=new t.Emitter,this.onDidChangeSelection=this.s.event,this.t=a.d++,this.z=new Map,this.A=new Set,Je(this,m,k,"f"),this.f=new u(f,Me(this,m,"f"),this.t),Me(this,m,"f").$registerSourceControl(this.t,B,X,q)}createResourceGroup(f,k){const R=new o(Me(this,m,"f"),this.v,this.t,f,k),B=t.Event.once(R.onDidDispose)(()=>this.z.delete(R));return this.z.set(R,B),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const f=[],k=[];for(const[R,B]of this.z){B.dispose();const X=R.onDidUpdateResourceStates(()=>{this.A.add(R),this.eventuallyUpdateResourceStates()});t.Event.once(R.onDidDispose)(()=>{this.A.delete(R),X.dispose(),this.e.delete(R.handle),Me(this,m,"f").$unregisterGroup(this.t,R.handle)}),f.push([R.handle,R.id,R.label,R.features]);const q=R._takeResourceStateSnapshot();q.length>0&&k.push([R.handle,q]),this.e.set(R.handle,R)}Me(this,m,"f").$registerGroups(this.t,f,k),this.z.clear()}eventuallyUpdateResourceStates(){const f=[];this.A.forEach(k=>{const R=k._takeResourceStateSnapshot();R.length!==0&&f.push([k.handle,R])}),f.length>0&&Me(this,m,"f").$spliceResourceStates(this.t,f),this.A.clear()}getResourceGroup(f){return this.e.get(f)}setSelectionState(f){this.q=f,this.s.fire(f)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(f=>f.dispose()),Me(this,m,"f").$unregisterSourceControl(this.t)}}m=new WeakMap,a.d=0,qe([(0,I.debounce)(100)],a.prototype,"eventuallyAddResourceGroups",null),qe([(0,I.debounce)(100)],a.prototype,"eventuallyUpdateResourceStates",null);let n=class ii{get onDidChangeActiveProvider(){return this.j.event}constructor(f,k,R){this.l=k,this.m=R,this.g=new Map,this.h=new Map,this.j=new t.Emitter,this.e=f.getProxy(T.MainContext.MainThreadSCM),this.f=f.getProxy(T.MainContext.MainThreadTelemetry),k.registerArgumentProcessor({processArgument:B=>{if(B&&B.$mid===3){const X=this.g.get(B.sourceControlHandle);if(!X)return B;const q=X.getResourceGroup(B.groupHandle);return q?q.getResourceState(B.handle):B}else if(B&&B.$mid===4){const X=this.g.get(B.sourceControlHandle);return X?X.getResourceGroup(B.groupHandle):B}else if(B&&B.$mid===5){const X=this.g.get(B.handle);return X||B}return B}})}createSourceControl(f,k,R,B){this.m.trace("ExtHostSCM#createSourceControl",f.identifier.value,k,R,B),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const X=ii.d++,q=new a(f,this.e,this.l,k,R,B);this.g.set(X,q);const N=this.h.get(P.ExtensionIdentifier.toKey(f.identifier))||[];return N.push(q),this.h.set(P.ExtensionIdentifier.toKey(f.identifier),N),q}getLastInputBox(f){this.m.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const k=this.h.get(P.ExtensionIdentifier.toKey(f.identifier)),R=k&&k[k.length-1];return R&&R.inputBox}$provideOriginalResource(f,k,R){const B=c.URI.revive(k);this.m.trace("ExtHostSCM#$provideOriginalResource",f,B.toString());const X=this.g.get(f);return!X||!X.quickDiffProvider||!X.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>X.quickDiffProvider.provideOriginalResource(B,R)).then(q=>q||null)}$onInputBoxValueChange(f,k){this.m.trace("ExtHostSCM#$onInputBoxValueChange",f);const R=this.g.get(f);return R&&R.inputBox.$onInputBoxValueChange(k),Promise.resolve(void 0)}$executeResourceCommand(f,k,R,B){this.m.trace("ExtHostSCM#$executeResourceCommand",f,k,R);const X=this.g.get(f);if(!X)return Promise.resolve(void 0);const q=X.getResourceGroup(k);return q?q.$executeResourceCommand(R,B):Promise.resolve(void 0)}$validateInput(f,k,R){this.m.trace("ExtHostSCM#$validateInput",f);const B=this.g.get(f);return!B||!B.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>B.inputBox.validateInput(k,R)).then(X=>{if(!X)return Promise.resolve(void 0);const q=D.MarkdownString.fromStrict(X.message);return q?Promise.resolve([q,X.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this.g.get(f)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=f,Promise.resolve(void 0)}};n.d=0,n=qe([He(2,L.ILogService)],n),e.ExtHostSCM=n}),define(Se[96],ye([1,0,5,4,3]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(T){this.b=new t.Emitter,this.onDidChangePassword=this.b.event,this.a=T.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,S){return this.a.$getPassword(T,S)}store(T,S,y){return this.a.$setPassword(T,S,y)}delete(T,S){return this.a.$deletePassword(T,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,c):I?I.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[264],ye([1,0,7,5,176,6,14,11]),function(ne,e,c,t,I,A,C,T){"use strict";var S,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(v,d,m,h,b=c.StatusBarAlignment.Left,p){S.set(this,void 0),y.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new A.DisposableStore,Je(this,S,v,"f"),Je(this,y,d,"f"),this.c=L.a++,this.e=m,this.f=h,this.g=b,this.h=this.t(p)}t(v){if(!!(0,T.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(v){this.k=v,this.u()}set name(v){this.m=v,this.u()}set tooltip(v){this.l=v,this.u()}set color(v){this.n=v,this.u()}set backgroundColor(v){v&&!L.b.has(v.id)&&(v=void 0),this.o=v,this.u()}set command(v){this.q?.fromApi!==v&&(this.p.clear(),typeof v=="string"?this.q={fromApi:v,internal:Me(this,y,"f").toInternal({title:"",command:v},this.p)}:v?this.q={fromApi:v,internal:Me(this,y,"f").toInternal(v,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(v){this.s=v,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Me(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let d;this.m?d=this.m:d=(0,I.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=L.b.get(this.o.id));const h=C.MarkdownString.fromStrict(this.l);Me(this,S,"f").$setEntry(this.c,v,d,this.k,h,this.q?.internal,m,this.o,this.g===c.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=L,S=new WeakMap,y=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const d={message:v};return this.b.unshift(d),this.c(),new c.Disposable(()=>{const m=this.b.indexOf(d);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class E{constructor(v,d){this.a=v.getProxy(t.MainContext.MainThreadStatusBar),this.b=d,this.c=new P(this)}createStatusBarEntry(v,d,m,h){return new L(this.a,this.b,v,d,m,h)}setStatusBarMessage(v,d){const m=this.c.setMessage(v);let h;return typeof d=="number"?h=setTimeout(()=>m.dispose(),d):typeof d<"u"&&d.then(()=>m.dispose(),()=>m.dispose()),new c.Disposable(()=>{m.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=E}),define(Se[97],ye([1,0,5,4,3]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(T,S){this.c=S,this.b=new t.Emitter,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,S){this.a.$registerExtensionStorageKeysToSync(T,S)}async initializeExtensionStorage(T,S,y){const L=await this.a.$initializeExtensionStorage(T,S);let P;return L&&(P=this.d(T,S,L)),P||y}setValue(T,S,y){return this.a.$setValue(T,S,y)}$acceptValue(T,S,y){const L=this.d(T,S,y);L&&this.b.fire({shared:T,key:S,value:L})}d(T,S,y){try{return JSON.parse(y)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${T}): ${L}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(Se[72],ye([1,0,3,25,13,71,2]),function(ne,e,c,t,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let T=class{constructor(y,L,P){this.d=L,this.f=P,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(E=>this.c=E)}async g(y){return C.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,L=await this.g(y);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(C.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(y){if(this.c)return C.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return C.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=qe([He(0,t.IExtHostInitDataService),He(1,I.ILogService),He(2,A.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(Se[40],ye([1,0,4,5,3,2,16,6,7,177,10,222,21,30,207,89,11,18,14]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class p{constructor(n,i,f,k){this.k=n,this._id=i,this.l=f,this.m=k,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(B=>this.f=B);const R=this;this.value={get name(){return R.m||""},get processId(){return R.b},get creationOptions(){return R.l},get exitStatus(){return R.h},get state(){return R.j},sendText(B,X=!0){R.o(),R.k.$sendText(R._id,B,X)},show(B){R.o(),R.k.$show(R._id,B)},hide(){R.o(),R.k.$hide(R._id)},dispose(){R.a||(R.a=!0,R.k.$dispose(R._id))},get dimensions(){if(!(R.d===void 0||R.g===void 0))return{columns:R.d,rows:R.g}}}}async create(n,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,m.withNullAsUndefined)(n.shellPath),shellArgs:(0,m.withNullAsUndefined)(n.shellArgs),cwd:(0,m.withNullAsUndefined)(n.cwd),env:(0,m.withNullAsUndefined)(n.env),icon:(0,m.withNullAsUndefined)(u(n.iconPath)),color:d.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,m.withNullAsUndefined)(n.message),strictEnv:(0,m.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,m.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,m.withNullAsUndefined)(i?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,m.withNullAsUndefined)(i?.useShellEnvironment),location:i?.location||this.n(n.location,i?.resolvedExtHostIdentifier),isTransient:(0,m.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,i,f,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:f,color:d.ThemeColor.isThemeColor(k)?k.id:void 0,location:this.n(n,i),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,i){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&i?{parentTerminal:i}:"viewColumn"in n?{viewColumn:b.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,i){this.h=Object.freeze({code:n,reason:i})}setDimensions(n,i){return n===this.d&&i===this.g||n===0||i===0?!1:(this.d=n,this.g=i,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(i=>{i!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=p;class g{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new c.Emitter,this.onProcessData=this.a.event,this.b=new c.Emitter,this.d=new c.Emitter,this.onDidChangeProperty=this.d.event,this.f=new c.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,i){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${i}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,i){this.g.setDimensions?.({columns:n,rows:i})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(i=>this.a.fire(i)),this.g.onDidClose?.((i=void 0)=>{this.f.fire(i===void 0?void 0:i)}),this.g.onDidOverrideDimensions?.(i=>{i&&this.d.fire({type:"overrideDimensions",value:{cols:i.columns,rows:i.rows}})}),this.g.onDidChangeName?.(i=>{this.d.fire({type:"title",value:i})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let w=1,s=class extends T.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,i){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new c.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new c.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new c.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new c.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new c.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new c.Emitter,this.onDidChangeShell=this.J.event,this.a=i.getProxy(t.MainContext.MainThreadTerminalService),this.s=new v.TerminalDataBufferer(this.a.$sendProcessData),this.I=new c.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[f,k]of this.g)k.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,i){const f=new p(this.a,(0,D.generateUuid)(),n,n.name),k=new g(n.pty);return f.createExtensionTerminal(n.location,this.L(n,i).resolvedExtHostIdentifier,u(n.iconPath),o(n.color)).then(R=>{const B=this.M(R,k);this.h[R]=B}),this.f.push(f),f.value}L(n,i){if(i=i||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const f=n.location.parentTerminal;if(f){const k=this.f.find(R=>R.value===f);k&&(i.resolvedExtHostIdentifier=k._id)}}else n.location&&typeof n.location!="object"?i.location=n.location:i.location&&typeof i.location=="object"&&"splitActiveTerminal"in i.location&&(i.location={splitActiveTerminal:!0});return i}attachPtyToTerminal(n,i){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const k=new g(i),R=this.M(n,k);this.h[n]=R}async $acceptActiveTerminalChanged(n){const i=this.b;if(n===null){this.b=void 0,i!==this.b&&this.F.fire(this.b);return}const f=this.O(n);f&&(this.b=f,i!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,i){const f=this.O(n);f&&this.I.fire({terminal:f.value,data:i})}async $acceptTerminalDimensions(n,i,f){const k=this.O(n);k&&k.setDimensions(i,f)&&this.G.fire({terminal:k.value,dimensions:k.value.dimensions})}async $acceptTerminalMaximumDimensions(n,i,f){this.g.get(n)?.resize(i,f)}async $acceptTerminalTitleChange(n,i){const f=this.O(n);f&&(f.name=i)}async $acceptTerminalClosed(n,i,f){const k=this.Q(this.f,n);if(k!==null){const R=this.f.splice(k,1)[0];R.setExitStatus(i,f),this.C.fire(R.value)}}$acceptTerminalOpened(n,i,f,k){if(i){const X=this.Q(this.f,i);if(X!==null){this.f[X]._id=n,this.D.fire(this.terminals[X]),this.f[X].isOpen=!0;return}}const R={name:k.name,shellPath:k.executable,shellArgs:k.args,cwd:typeof k.cwd=="string"?k.cwd:A.URI.revive(k.cwd),env:k.env,hideFromUser:k.hideFromUser},B=new p(this.a,n,R,f);this.f.push(B),this.D.fire(B.value),B.isOpen=!0}async $acceptTerminalProcessId(n,i){this.O(n)?._setProcessId(i)}async $startExtensionTerminal(n,i){const f=this.O(n);if(!f)return{message:(0,y.localize)(0,null,n)};f.isOpen||await new Promise(R=>{const B=this.onDidOpenTerminal(async X=>{X===f.value&&(B.dispose(),R())})});const k=this.g.get(n);k?k.startSendingEvents(i):this.j[n]={initialDimensions:i}}M(n,i){const f=new T.DisposableStore;f.add(i.onProcessReady(R=>this.a.$sendProcessReady(n,R.pid,R.cwd))),f.add(i.onDidChangeProperty(R=>this.a.$sendProcessProperty(n,R))),this.s.startBuffering(n,i.onProcessData),f.add(i.onProcessExit(R=>this.N(n,R))),this.g.set(n,i);const k=this.j[n];return k&&i instanceof g&&(i.startSendingEvents(k.initialDimensions),delete this.j[n]),f}$acceptProcessAckDataEvent(n,i){this.g.get(n)?.acknowledgeDataEvent(i)}$acceptProcessInput(n,i){this.g.get(n)?.input(i)}$acceptTerminalInteraction(n){const i=this.O(n);i?.setInteractedWith()&&this.H.fire(i.value)}$acceptProcessResize(n,i,f){try{this.g.get(n)?.resize(i,f)}catch(k){if(k.code!=="EPIPE"&&k.code!=="ERR_IPC_CHANNEL_CLOSED")throw k}}$acceptProcessShutdown(n,i){this.g.get(n)?.shutdown(i)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(i=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:i}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(i=>this.a.$sendProcessProperty(n,{type:"cwd",value:i}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,i,f){if(this.v.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this.v.set(i,f),this.a.$registerProfileProvider(i,n.identifier.value),new S.Disposable(()=>{this.v.delete(i),this.a.$unregisterProfileProvider(i)})}registerTerminalQuickFixProvider(n,i,f){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,f),this.a.$registerQuickFixProvider(n,i),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,i){const f=new E.CancellationTokenSource().token;if(f.isCancellationRequested)return;const k=this.w.get(n);if(!k)return;const R=await k.provideTerminalQuickFixes(i,f);if(R!==null)return R}async $createContributedProfileTerminal(n,i){const f=new E.CancellationTokenSource().token;let k=await this.v.get(n)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(k&&!("options"in k)&&(k={options:k}),!k||!("options"in k))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in k.options){this.createExtensionTerminal(k.options,i);return}this.createTerminalFromOptions(k.options,i)}}async $provideLinks(n,i){const f=this.O(n);if(!f)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const R=new E.CancellationTokenSource;this.z.set(n,R);const B=[],X={terminal:f.value,line:i},q=[];for(const F of this.u)q.push(h.Promises.withAsyncBody(async z=>{R.token.onCancellationRequested(()=>z({provider:F,links:[]}));const U=await F.provideTerminalLinks(X,R.token)||[];R.token.isCancellationRequested||z({provider:F,links:U})}));const N=await Promise.all(q);if(R.token.isCancellationRequested)return[];const M=new Map;for(const F of N)F&&F.links.length>0&&B.push(...F.links.map(z=>{const U={id:w++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return M.set(U.id,{provider:F.provider,link:z}),U}));return this.y.set(n,M),B}$activateLink(n,i){const f=this.y.get(n)?.get(i);!f||f.provider.handleTerminalLink(f.link)}N(n,i){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const f=this.h[n];f&&(f.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,i)}O(n){return this.P(this.f,n)}P(n,i){const f=this.Q(n,i);return f!==null?n[f]:null}Q(n,i){let f=null;return n.some((k,R)=>k._id===i?(f=R,!0):!1),f}getEnvironmentVariableCollection(n){let i=this.l.get(n.identifier.value);return i||(i=new r,this.S(n.identifier.value,i)),i}R(n,i){const f=(0,P.serializeEnvironmentVariableCollection)(i.map);this.a.$setEnvironmentVariableCollection(n,i.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(n){n.forEach(i=>{const f=i[0],k=new r(i[1]);this.S(f,k)})}$acceptDefaultProfile(n,i){const f=this.m;this.m=n,this.n=i,f?.path!==n.path&&this.J.fire(n.path)}S(n,i){this.l.set(n,i),i.onDidChangeCollection(()=>{this.R(n,i)})}};s=qe([He(1,C.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class r{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new c.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,i){this.d(n,{value:i,type:S.EnvironmentVariableMutatorType.Replace})}append(n,i){this.d(n,{value:i,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,i){this.d(n,{value:i,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,i){const f=this.map.get(n);(!f||f.value!==i.value||f.type!==i.type)&&(this.map.set(n,i),this.b.fire())}get(n){return this.map.get(n)}forEach(n,i){this.map.forEach((f,k)=>n.call(i,k,f,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let l=class extends s{constructor(n){super(!1,n)}createTerminal(n,i,f){throw new L.NotSupportedError}createTerminalFromOptions(n,i){throw new L.NotSupportedError}};l=qe([He(0,C.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l;function u(a){if(!(!a||typeof a=="string"))return"id"in a?{id:a.id,color:a.color}:a}function o(a){return d.ThemeColor.isThemeColor(a)?a:void 0}});var Me=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,c):I?I.value=c:e.set(ne,c),c};define(Se[265],ye([1,0,17,18,22,21,4,61,84,6,23,11,30,5,16,137,14,7,56,91,69]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b,p,g){"use strict";var w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(M,F,z){this.j=z,this.c=new C.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=M.getProxy(D.MainContext.MainThreadTesting),this.h=new B(this.f),this.g=new a(this.f),F.registerArgumentProcessor({processArgument:U=>{if(U?.$mid!==15)return U;const W=U,x=W.tests[W.tests.length-1].item.extId;return this.d.get(b.TestId.root(x))?.collection.tree.get(x)?.actual??(0,d.toItemFromContext)(U)}})}createTestController(M,F,z){if(this.d.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const U=new y.DisposableStore,W=U.add(new d.ExtHostTestItemCollection(M,F,this.j));W.root.label=F;const x=new Map,V=this.f,_={items:W.root.children,get label(){return F},set label(J){F=J,W.root.label=J,V.$updateController(M,{label:F})},get refreshHandler(){return z},set refreshHandler(J){z=J,V.$updateController(M,{canRefresh:!!J})},get id(){return M},createRunProfile:(J,te,le,Z,ge)=>{let ve=(0,S.hash)(J);for(;x.has(ve);)ve++;return new X(this.f,x,M,ve,J,te,le,Z,ge)},createTestItem(J,te,le){return new d.TestItemImpl(M,J,te,le)},createTestRun:(J,te,le=!0)=>this.g.createTestRun(M,W,J,te,le),set resolveHandler(J){W.resolveHandler=J},get resolveHandler(){return W.resolveHandler},dispose:()=>{U.dispose()}};V.$registerTestController(M,F,!!z),U.add((0,y.toDisposable)(()=>V.$unregisterTestController(M)));const Q={controller:_,collection:W,profiles:x};return this.d.set(M,Q),U.add((0,y.toDisposable)(()=>this.d.delete(M))),U.add(W.onDidGenerateDiff(J=>V.$publishDiff(M,J.map(g.TestsDiffOp.serialize)))),_}createTestObserver(){return this.h.checkout()}async runTests(M,F=A.CancellationToken.None){const z=n(M);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.d.get(z.controllerId);if(!U)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(W=>b.TestId.fromExtHostTestItem(W,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:q[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:M.exclude?.map(W=>W.id)},F)}$syncTests(){for(const{collection:M}of this.d.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,F,z){return(0,c.mapFind)(this.g.trackers,W=>W.id===M?W.getCoverage(F):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(M,F,z,U){return(0,c.mapFind)(this.g.trackers,x=>x.id===M?x.getCoverage(F):void 0)?.resolveFileCoverage(z,U)??Promise.resolve([])}$configureRunProfile(M,F){this.d.get(M)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(M,F){await this.d.get(M)?.controller.refreshHandler?.(F)}$publishTestResults(M){this.results=Object.freeze(M.map(F=>(0,L.deepFreeze)(m.TestResults.to(F))).concat(this.results).sort((F,z)=>z.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(M,F){const z=this.d.get(b.TestId.fromString(M).controllerId)?.collection;z&&(await z.expand(M,F<0?1/0:F),z.flushDiff())}$acceptDiff(M){this.h.applyDiff(M.map(g.TestsDiffOp.deserialize))}async $runControllerTests(M,F){return Promise.all(M.map(z=>this.runControllerTestRequest(z,F)))}async runControllerTestRequest(M,F){const z=this.d.get(M.controllerId);if(!z)return{};const{collection:U,profiles:W}=z,x=W.get(M.profileId);if(!x)return{};const V=M.testIds.map(te=>U.tree.get(te)).filter(P.isDefined),_=M.excludeExtIds.map(te=>z.collection.tree.get(te)).filter(P.isDefined).filter(te=>V.some(le=>le.fullId.compare(te.fullId)===2));if(!V.length)return{};const Q=new h.TestRunRequest(V.some(te=>te.actual instanceof d.TestItemRootImpl)?void 0:V.map(te=>te.actual),_.map(te=>te.actual),x),J=this.g.prepareForMainThreadTestRun(Q,i.fromInternal(M,z.collection),F);try{return await x.runHandler(Q,F),{}}catch(te){return{error:String(te)}}finally{J.hasRunningTasks&&!F.isCancellationRequested&&await C.Event.toPromise(J.onEnd),J.dispose()}}$cancelExtensionTestRun(M){M===void 0?this.g.cancelAllRuns():this.g.cancelRunById(M)}};r=qe([He(0,v.IExtHostRpcService)],r),e.ExtHostTesting=r;const l=1e4;var u;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(u||(u={}));class o extends y.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(M,F,z){super(),this.k=M,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new C.Emitter),this.onEnd=this.j.event,this.h=this.B(new A.CancellationTokenSource(z));const U=this.B(new t.RunOnceScheduler(()=>this.m(),l));this.B(this.h.token.onCancellationRequested(()=>U.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const F=this.k.id,z=this.k.controllerId,U=(0,E.generateUuid)(),W=new f(this.l,F,U),x=J=>(te,...le)=>{if(_){console.warn(`Setting the state of test "${te.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(te)||(this.s(te),J(te,...le))},V=(J,te)=>{const le=te instanceof Array?te.map(m.TestMessage.from):[m.TestMessage.from(te)];if(J.uri&&J.range){const Z={range:m.Range.from(J.range),uri:J.uri};for(const ge of le)ge.location=ge.location||Z}this.l.$appendTestMessagesInRun(F,U,b.TestId.fromExtHostTestItem(J,z).toString(),le)};let _=!1;const Q={isPersisted:this.k.isPersisted,token:this.h.token,name:M,get coverageProvider(){return W.coverageProvider},set coverageProvider(J){W.coverageProvider=J},enqueued:x(J=>{this.l.$updateTestStateInRun(F,U,b.TestId.fromExtHostTestItem(J,z).toString(),1)}),skipped:x(J=>{this.l.$updateTestStateInRun(F,U,b.TestId.fromExtHostTestItem(J,z).toString(),5)}),started:x(J=>{this.l.$updateTestStateInRun(F,U,b.TestId.fromExtHostTestItem(J,z).toString(),2)}),errored:x((J,te,le)=>{V(J,te),this.l.$updateTestStateInRun(F,U,b.TestId.fromExtHostTestItem(J,z).toString(),6,le)}),failed:x((J,te,le)=>{V(J,te),this.l.$updateTestStateInRun(F,U,b.TestId.fromExtHostTestItem(J,z).toString(),4,le)}),passed:x((J,te)=>{this.l.$updateTestStateInRun(F,U,b.TestId.fromExtHostTestItem(J,this.k.controllerId).toString(),3,te)}),appendOutput:(J,te,le)=>{_||(le&&(this.k.isIncluded(le)?this.s(le):le=void 0),this.l.$appendOutputToRun(F,U,I.VSBuffer.fromString(J),te&&m.location.from(te),le&&b.TestId.fromExtHostTestItem(le,z).toString()))},end:()=>{_||(_=!0,this.l.$finishedTestRunTask(F,U),this.f.delete(U),this.f.size||this.p())}};return this.f.set(U,{run:Q,coverage:W}),this.l.$startedTestRunTask(F,{id:U,name:M,running:!0}),Q}m(){for(const{run:M}of this.f.values())M.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(M){if(!(M instanceof d.TestItemImpl))throw new p.InvalidTestItemError(M.id);if(this.g.has(b.TestId.fromExtHostTestItem(M,this.k.controllerId).toString()))return;const F=[],z=this.k.colllection.root;for(;;){const U=m.TestItem.from(M);if(F.unshift(U),this.g.has(U.extId)||(this.g.add(U.extId),M===z))break;M=M.parent||z}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class a{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,F,z){return this.f(M,F,z)}cancelRunById(M){for(const F of this.c.values())if(F.id===M){F.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,F,z,U,W){const x=this.c.get(z);if(x)return x.createRun(U);const V=i.fromPublic(M,F,z,W),_=n(z);this.d.$startedExtensionTestRun({controllerId:M,profile:_&&{group:q[_.kind],id:_.profileId},exclude:z.exclude?.map(J=>b.TestId.fromExtHostTestItem(J,F.root.id).toString())??[],id:V.id,include:z.include?.map(J=>b.TestId.fromExtHostTestItem(J,F.root.id).toString())??[F.root.id],persist:W});const Q=this.f(z,V);return Q.onEnd(()=>{this.d.$finishedExtensionTestRun(V.id),Q.dispose()}),Q.createRun(U)}f(M,F,z){const U=new o(F,this.d,z);return this.c.set(M,U),U.onEnd(()=>this.c.delete(M)),U}}e.TestRunCoordinator=a;const n=N=>{if(!!N.profile){if(!(N.profile instanceof X))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class i{static fromPublic(M,F,z,U){return new i(M,(0,E.generateUuid)(),z.include?.map(W=>b.TestId.fromExtHostTestItem(W,M).toString())??[M],z.exclude?.map(W=>b.TestId.fromExtHostTestItem(W,M).toString())??[],U,F)}static fromInternal(M,F){return new i(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,F)}constructor(M,F,z,U,W,x){this.controllerId=M,this.id=F,this.isPersisted=W,this.colllection=x,this.c=z.map(V=>V+"\0"),this.d=U.map(V=>V+"\0")}isIncluded(M){const F=b.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const z of this.d)if(F===z||F.startsWith(z))return!1;for(const z of this.c)if(F===z||F.startsWith(z))return!0;return!1}}e.TestRunDto=i;class f{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,F,z){this.f=M,this.g=F,this.h=z}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(m.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(M,F){const z=await this.d;let U=z?.[M];return!this.c||!z||!U?[]:(U.detailedCoverage||(U=z[M]=await this.c.resolveFileCoverage?.(U,F)??U),U.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class k{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,m.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const F=b.TestId.parentId(M.item.extId);if(F&&this.g.has(F.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:F,f:z}=this;return{get added(){return[...M].map(U=>U.revived)},get updated(){return[...F].map(U=>U.revived)},get removed(){return[...z].map(U=>U.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class R extends g.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new C.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,F){return{...M,revived:m.TestItem.toPlain(M.item),depth:F?F.depth+1:0,children:new Set}}o(){return new k(this.q)}}e.MirroredTestCollection=R;class B{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(F=>F.revived)},dispose:(0,T.once)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new R;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class X{get label(){return this.d}set label(M){M!==this.d&&(this.d=M,Me(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,Me(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Me(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?m.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,Me(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,F,z,U,W,x,V,_=!1,Q=void 0){this.controllerId=z,this.profileId=U,this.d=W,this.kind=x,this.runHandler=V,this.f=_,this._tag=Q,w.set(this,void 0),s.set(this,void 0),Je(this,w,M,"f"),Je(this,s,F,"f"),F.set(U,this);const J=q[x];if(typeof J!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Me(this,w,"f").$publishTestRunProfile({profileId:U,controllerId:z,tag:Q?m.TestTag.namespace(this.controllerId,Q.id):null,label:W,group:J,isDefault:_,hasConfigurationHandler:!1})}dispose(){Me(this,s,"f")?.delete(this.profileId)&&(Je(this,s,void 0,"f"),Me(this,w,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=X,w=new WeakMap,s=new WeakMap;const q={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(Se[266],ye([1,0,17,4,5,138,14,7]),function(ne,e,c,t,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(L,P){this.i=P,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(I.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(E=>this.g.fire(E)),this.i.onDidChangeActiveTextEditor(E=>this.f.fire(E))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const P=this.i.allEditors();return L?P:P.map(E=>E.value)}async showTextDocument(L,P,E){let D;typeof P=="number"?D={position:C.ViewColumn.from(P),preserveFocus:E}:typeof P=="object"?D={position:C.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?C.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:D={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(L.uri,D),d=v&&this.i.getEditor(v);if(d)return d.value;throw v?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,P){return new A.TextEditorDecorationType(this.h,L,P).value}$acceptEditorPropertiesChanged(L,P){const E=this.i.getEditor(L);if(!E)throw new Error("unknown text editor");if(P.options&&E._acceptOptions(P.options),P.selections){const D=P.selections.selections.map(C.Selection.to);E._acceptSelections(D)}if(P.visibleRanges){const D=c.coalesce(P.visibleRanges.map(C.Range.to));E._acceptVisibleRanges(D)}if(P.options&&this.b.fire({textEditor:E.value,options:{...P.options,lineNumbers:C.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const D=T.TextEditorSelectionChangeKind.fromValue(P.selections.source),v=P.selections.selections.map(C.Selection.to);this.a.fire({textEditor:E.value,selections:v,kind:D})}if(P.visibleRanges){const D=c.coalesce(P.visibleRanges.map(C.Range.to));this.c.fire({textEditor:E.value,visibleRanges:D})}}$acceptEditorPositionData(L){for(const P in L){const E=this.i.getEditor(P);if(!E)throw new Error("Unknown text editor");const D=C.ViewColumn.to(L[P]);E.value.viewColumn!==D&&(E._acceptViewColumn(D),this.d.fire({textEditor:E.value,viewColumn:D}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=S}),define(Se[267],ye([1,0,2,3,5,6,7,14,11]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class y{constructor(E,D){this.b=new Map,this.c=new Map,this.a=E.getProxy(I.MainContext.MainThreadTimeline),D.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===12){const d=v.uri===void 0?void 0:c.URI.revive(v.uri);return this.c.get(v.source)?.get(L(d))?.get(v.handle)}return v}})}async $getTimeline(E,D,v,d){return this.b.get(E)?.provideTimeline(c.URI.revive(D),v,d)}registerTimelineProvider(E,D,v,d){const m=new A.DisposableStore,h=this.d(D.id,d,m).bind(this);let b;D.onDidChange&&(b=D.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:D.id}),this));const p=this.c;return this.f({...D,scheme:E,onDidChange:void 0,async provideTimeline(g,w,s){w?.resetCache&&(m.clear(),p.get(D.id)?.clear());const r=await D.provideTimeline(g,w,s);if(r==null)return;const l=h(g,w);return{...r,source:D.id,items:r.items.map(l)}},dispose(){for(const g of p.values())g.get(D.id)?.clear();b?.dispose(),m.dispose()}})}d(E,D,v){return(d,m)=>{let h;if(m?.cacheResults){let b=this.c.get(E);b===void 0&&(b=new Map,this.c.set(E,b));const p=L(d);h=b.get(p),h===void 0&&(h=new Map,b.set(p,h))}return b=>{const{iconPath:p,...g}=b,w=`${E}|${b.id??b.timestamp}`;h?.set(w,b);let s,r,l;b.iconPath&&(p instanceof C.ThemeIcon?l={id:p.id,color:p.color}:c.URI.isUri(p)?(s=p,r=p):{light:s,dark:r}=p);let u;return C.MarkdownString.isMarkdownString(g.tooltip)?u=T.MarkdownString.from(g.tooltip):(0,S.isString)(g.tooltip)?u=g.tooltip:C.MarkdownString.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=T.MarkdownString.from(g.detail)):(0,S.isString)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=g.detail),{...g,id:g.id??void 0,handle:w,source:E,command:b.command?D.toInternal(b.command,v):void 0,icon:s,iconDark:r,themeIcon:l,tooltip:u,accessibilityInformation:b.accessibilityInformation}}}}f(E){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,E),(0,A.toDisposable)(()=>{for(const v of this.c.values())v.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=y;function L(P){return P?.toString()}}),define(Se[268],ye([1,0,6,15,2,5]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this.c=new Map,this.b=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,y,L,P){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const E=P.schemes.find(D=>!C.a.has(D));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this.c.set(y,L),this.b.$registerUriOpener(y,P.schemes,S,P.label),(0,c.toDisposable)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri(S,y,L){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const E=I.URI.revive(y);return P.canOpenExternalUri(E,L)}async $openUri(S,y,L){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(I.URI.revive(y.resolvedUri),{sourceUri:I.URI.revive(y.sourceUri)},L)}}e.ExtHostUriOpeners=C,C.a=new Set([t.Schemas.http,t.Schemas.https])}),define(Se[269],ye([1,0,5,2,6,10,27]),function(ne,e,c,t,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(y){this.c=new Set,this.d=new Map,this.b=y.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(y,L){if(this.c.has(C.ExtensionIdentifier.toKey(y)))throw new Error(`Protocol handler already registered for extension ${y}`);const P=T.a++;return this.c.add(C.ExtensionIdentifier.toKey(y)),this.d.set(P,L),this.b.$registerUriHandler(P,y),(0,I.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(y)),this.d.delete(P),this.b.$unregisterUriHandler(P)})}$handleExternalUri(y,L){const P=this.d.get(y);if(!P)return Promise.resolve(void 0);try{P.handleUri(t.URI.revive(L))}catch(E){(0,A.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(y){return t.URI.revive(await this.b.$createAppUri(y))}}e.ExtHostUrls=T,T.a=0});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,c):I?I.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[73],ye([1,0,4,15,23,2,192,214,92,5]),function(ne,e,c,t,I,A,C,T,S,y){"use strict";var L,P,E,D,v,d,m,h,b,p,g,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class r{constructor(R,B,X,q,N,M,F){L.set(this,void 0),P.set(this,void 0),E.set(this,void 0),D.set(this,void 0),v.set(this,void 0),d.set(this,void 0),m.set(this,""),h.set(this,void 0),b.set(this,!1),p.set(this,!1),g.set(this,void 0),w.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new c.Emitter),this._onDidDispose=Me(this,s,"f").event,Je(this,L,R,"f"),Je(this,P,B,"f"),Je(this,h,X,"f"),Je(this,D,q,"f"),Je(this,v,N,"f"),Je(this,d,M,"f"),Je(this,g,l(M),"f"),Je(this,w,u(M),"f"),Je(this,E,F,"f")}dispose(){Je(this,b,!0,"f"),Me(this,s,"f").fire(),Me(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(R){return Je(this,p,!0,"f"),(0,S.asWebviewUri)(R,Me(this,D,"f"))}get cspSource(){const R=Me(this,d,"f").extensionLocation;if(R.scheme===t.Schemas.https||R.scheme===t.Schemas.http){let B=R.toString();return B.endsWith("/")||(B+="/"),B+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Me(this,m,"f")}set html(R){this.a(),Me(this,m,"f")!==R&&(Je(this,m,R,"f"),Me(this,w,"f")&&!Me(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(R)&&(Je(this,p,!0,"f"),Me(this,E,"f").report("Webview vscode-resource: uris",Me(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,P,"f").$setHtml(Me(this,L,"f"),this.b(R)))}get options(){return this.a(),Me(this,h,"f")}set options(R){this.a(),I.equals(Me(this,h,"f"),R)||Me(this,P,"f").$setOptions(Me(this,L,"f"),n(Me(this,d,"f"),Me(this,v,"f"),R)),Je(this,h,R,"f")}async postMessage(R){if(Me(this,b,"f"))return!1;const B=(0,T.serializeWebviewMessage)(R,{serializeBuffersForPostMessage:Me(this,g,"f")});return Me(this,P,"f").$postMessage(Me(this,L,"f"),B.message,...B.buffers)}a(){if(Me(this,b,"f"))throw new Error("Webview is disposed")}b(R){if(!Me(this,w,"f"))return R;const B=Me(this,d,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,X=Me(this,d,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Me(this,d,"f").extensionLocation.authority:void 0;return R.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,N,M,F,z,U)=>{const W=A.URI.from({scheme:F||"file",path:decodeURIComponent(z)}),x=(0,S.asWebviewUri)(W,{isRemote:B,authority:X}).toString();return`${N}${x}${U}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,N,M,F,z,U)=>{const W=A.URI.from({scheme:F||"file",path:decodeURIComponent(z)}),x=(0,S.asWebviewUri)(W,{isRemote:B,authority:X}).toString();return`${N}${x}${U}`})}}e.ExtHostWebview=r,L=new WeakMap,P=new WeakMap,E=new WeakMap,D=new WeakMap,v=new WeakMap,d=new WeakMap,m=new WeakMap,h=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,w=new WeakMap,s=new WeakMap;function l(k){try{const R=(0,C.normalizeVersion)((0,C.parseVersion)(k.engines.vscode));return!!R&&R.majorBase>=1&&R.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;function u(k){try{const R=(0,C.normalizeVersion)((0,C.parseVersion)(k.engines.vscode));return R?R.majorBase<1||R.majorBase===1&&R.minorBase<60:!1}catch{return!1}}class o{constructor(R,B,X,q,N){this.c=B,this.d=X,this.e=q,this.f=N,this.b=new Map,this.a=R.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(R,B,X){const q=this.g(R);if(q){const{message:N}=(0,T.deserializeWebviewMessage)(B,X.value);q._onMessageEmitter.fire(N)}}$onMissingCsp(R,B){this.e.warn(`${B} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(R,B,X){const q=new r(R,this.a,i(B),this.c,this.d,X,this.f);return this.b.set(R,q),q._onDidDispose(()=>{this.b.delete(R)}),q}deleteWebview(R){this.b.delete(R)}g(R){return this.b.get(R)}}e.ExtHostWebviews=o;function a(k){return{id:k.identifier,location:k.extensionLocation}}e.toExtensionData=a;function n(k,R,B){return{enableCommandUris:B.enableCommandUris,enableScripts:B.enableScripts,enableForms:B.enableForms,portMapping:B.portMapping,localResourceRoots:B.localResourceRoots||f(k,R)}}e.serializeWebviewOptions=n;function i(k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots?.map(R=>A.URI.from(R))}}function f(k,R){return[...(R?.getWorkspaceFolders()||[]).map(B=>B.uri),k.extensionLocation]}}),define(Se[270],ye([1,0,21,84,6,15,24,2,14,73,68,5,7]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class D{constructor(r,l){this.document=r,this.b=l,this.a=1,this.c=new L.Cache("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,l){await this.f(r).undo(),l||this.disposeBackup()}async redo(r,l){await this.f(r).redo(),l||this.disposeBackup()}disposeEdits(r){for(const l of r)this.c.delete(l)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=w(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const l=this.c.get(r,0);if(!l)throw new Error("No edit found");return l}}class v{constructor(){this.a=new Map}get(r,l){return this.a.get(this.b(r,l))}add(r,l,u){const o=this.b(r,l.uri);if(this.a.has(o))throw new Error(`Document already exists for viewType:${r} resource:${l.uri}`);const a=new D(l,u);return this.a.set(o,a),a}delete(r,l){const u=this.b(r,l.uri);this.a.delete(u)}b(r,l){return`${r}@@@${l}`}}var d;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(d||(d={}));class m{constructor(){this.a=new Map}addTextProvider(r,l,u){return this.b(0,r,l,u)}addCustomProvider(r,l,u){return this.b(1,r,l,u)}get(r){return this.a.get(r)}b(r,l,u,o){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,{type:r,extension:u,provider:o}),new E.Disposable(()=>this.a.delete(l))}}class h{constructor(r,l,u,o,a){this.d=l,this.f=u,this.g=o,this.h=a,this.b=new m,this.c=new v,this.a=r.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,l,u,o){const a=new I.DisposableStore;return p(u)?(a.add(this.b.addTextProvider(l,r,u)),this.a.$registerTextEditorProvider((0,y.toExtensionData)(r),l,o.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,y.shouldSerializeBuffersForPostMessage)(r))):(a.add(this.b.addCustomProvider(l,r,u)),b(u)&&a.add(u.onDidChangeCustomDocument(n=>{const i=this.i(l,n.document.uri);if(g(n)){const f=i.addEdit(n);this.a.$onDidEdit(n.document.uri,l,f,n.label)}else this.a.$onContentChange(n.document.uri,l)})),this.a.$registerCustomEditorProvider((0,y.toExtensionData)(r),l,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,y.shouldSerializeBuffersForPostMessage)(r))),E.Disposable.from(a,new E.Disposable(()=>{this.a.$unregisterEditorProvider(l)}))}async $createCustomDocument(r,l,u,o,a){const n=this.b.get(l);if(!n)throw new Error(`No provider found for '${l}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${l}'`);const i=T.URI.revive(r),f=await n.provider.openCustomDocument(i,{backupId:u,untitledDocumentData:o?.buffer},a);let k;return b(n.provider)&&this.f&&(k=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(l,f,k),{editable:b(n.provider)}}async $disposeCustomDocument(r,l){const u=this.b.get(l);if(!u)throw new Error(`No provider found for '${l}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${l}'`);const o=T.URI.revive(r),{document:a}=this.i(l,o);this.c.delete(l,a),a.dispose()}async $resolveCustomEditor(r,l,u,o,a,n){console.log("xxxx");const i=this.b.get(u);if(!i)throw new Error(`No provider found for '${u}'`);const f=S.ViewColumn.to(a),k=this.g.createNewWebview(l,o.contentOptions,i.extension),R=this.h.createNewWebviewPanel(l,u,o.title,f,o.options,k,!0),B=T.URI.revive(r);switch(i.type){case 1:{const{document:X}=this.i(u,B);return i.provider.resolveCustomEditor(X,R,n)}case 0:{const X=this.d.getDocument(B);return i.provider.resolveCustomTextEditor(X,R,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,l,u){this.i(l,r).disposeEdits(u)}async $onMoveCustomEditor(r,l,u){const o=this.b.get(u);if(!o)throw new Error(`No provider found for '${u}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const a=this.h.getWebviewPanel(r);if(!a)throw new Error("No webview found");const n=T.URI.revive(l),i=this.d.getDocument(n);await o.provider.moveCustomTextEditor(i,a,c.CancellationToken.None)}async $undo(r,l,u,o){return this.i(l,r).undo(u,o)}async $redo(r,l,u,o){return this.i(l,r).redo(u,o)}async $revert(r,l,u){const o=this.i(l,r);await this.j(l).revertCustomDocument(o.document,u),o.disposeBackup()}async $onSave(r,l,u){const o=this.i(l,r);await this.j(l).saveCustomDocument(o.document,u),o.disposeBackup()}async $onSaveAs(r,l,u,o){const a=this.i(l,r);return this.j(l).saveCustomDocumentAs(a.document,T.URI.revive(u),o)}async $backup(r,l,u){const o=this.i(l,r),n=await this.j(l).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},u);return o.updateBackup(n),n.id}i(r,l){const u=this.c.get(r,T.URI.revive(l));if(!u)throw new Error("No custom document found");return u}j(r){const u=this.b.get(r)?.provider;if(!u||!b(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=h;function b(s){return!!s.onDidChangeCustomDocument}function p(s){return typeof s.resolveCustomTextEditor=="function"}function g(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function w(s){const r=s.scheme===A.Schemas.file||s.scheme===A.Schemas.untitled?s.fsPath:s.toString();return(0,t.hash)(r)+""}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,c):I?I.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[271],ye([1,0,4,6,2,30,14,73,5,7]),function(ne,e,c,t,I,A,C,T,S,y){"use strict";var L,P,E,D,v,d,m,h,b,p,g,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends t.Disposable{constructor(a,n,i,f){super(),L.set(this,void 0),P.set(this,void 0),E.set(this,void 0),D.set(this,void 0),v.set(this,void 0),d.set(this,void 0),m.set(this,void 0),h.set(this,void 0),b.set(this,!0),p.set(this,void 0),g.set(this,!1),w.set(this,this.B(new c.Emitter)),this.onDidDispose=Me(this,w,"f").event,s.set(this,this.B(new c.Emitter)),this.onDidChangeViewState=Me(this,s,"f").event,Je(this,L,a,"f"),Je(this,P,n,"f"),Je(this,D,i,"f"),Je(this,E,f.viewType,"f"),Je(this,v,f.panelOptions,"f"),Je(this,h,f.viewColumn,"f"),Je(this,d,f.title,"f"),Je(this,p,f.active,"f")}dispose(){Me(this,g,"f")||(Je(this,g,!0,"f"),Me(this,w,"f").fire(),Me(this,P,"f").$disposeWebview(Me(this,L,"f")),Me(this,D,"f").dispose(),super.dispose())}get webview(){return this.c(),Me(this,D,"f")}get viewType(){return this.c(),Me(this,E,"f")}get title(){return this.c(),Me(this,d,"f")}set title(a){this.c(),Me(this,d,"f")!==a&&(Je(this,d,a,"f"),Me(this,P,"f").$setTitle(Me(this,L,"f"),a))}get iconPath(){return this.c(),Me(this,m,"f")}set iconPath(a){this.c(),Me(this,m,"f")!==a&&(Je(this,m,a,"f"),Me(this,P,"f").$setIconPath(Me(this,L,"f"),I.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return Me(this,v,"f")}get viewColumn(){if(this.c(),!(typeof Me(this,h,"f")=="number"&&Me(this,h,"f")<0))return Me(this,h,"f")}get active(){return this.c(),Me(this,p,"f")}get visible(){return this.c(),Me(this,b,"f")}_updateViewState(a){Me(this,g,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(Je(this,p,a.active,"f"),Je(this,b,a.visible,"f"),Je(this,h,a.viewColumn,"f"),Me(this,s,"f").fire({webviewPanel:this}))}reveal(a,n){this.c(),Me(this,P,"f").$reveal(Me(this,L,"f"),{viewColumn:typeof a>"u"?void 0:C.ViewColumn.from(a),preserveFocus:!!n})}c(){if(Me(this,g,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,P=new WeakMap,E=new WeakMap,D=new WeakMap,v=new WeakMap,d=new WeakMap,m=new WeakMap,h=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,w=new WeakMap,s=new WeakMap;class l{static c(){return(0,A.generateUuid)()}constructor(a,n,i){this.g=n,this.h=i,this.e=new Map,this.f=new Map,this.d=a.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(a,n,i,f,k={}){const R=typeof f=="object"?f.viewColumn:f,B={viewColumn:C.ViewColumn.from(R),preserveFocus:typeof f=="object"&&!!f.preserveFocus},X=(0,T.shouldSerializeBuffersForPostMessage)(a),q=l.c();this.d.$createWebviewPanel((0,T.toExtensionData)(a),q,n,{title:i,panelOptions:u(k),webviewOptions:(0,T.serializeWebviewOptions)(a,this.h,k),serializeBuffersForPostMessage:X},B);const N=this.g.createNewWebview(q,k,a);return this.createNewWebviewPanel(q,n,i,R,k,N,!0)}$onDidChangeWebviewPanelViewStates(a){const n=Object.keys(a);n.sort((i,f)=>{const k=a[i],R=a[f];return k.active?1:R.active?-1:+k.visible-+R.visible});for(const i of n){const f=this.getWebviewPanel(i);if(!f)continue;const k=a[i];f._updateViewState({active:k.active,visible:k.visible,viewColumn:C.ViewColumn.to(k.position)})}}async $onDidDisposeWebviewPanel(a){this.getWebviewPanel(a)?.dispose(),this.e.delete(a),this.g.deleteWebview(a)}registerWebviewPanelSerializer(a,n,i){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:i,extension:a}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(a)}),new y.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(a,n,i,f){const k=this.f.get(n);if(!k)throw new Error(`No serializer found for '${n}'`);const{serializer:R,extension:B}=k,X=this.g.createNewWebview(a,i.webviewOptions,B),q=this.createNewWebviewPanel(a,n,i.title,f,i.panelOptions,X,i.active);await R.deserializeWebviewPanel(q,i.state)}createNewWebviewPanel(a,n,i,f,k,R,B){const X=new r(a,this.d,R,{viewType:n,title:i,viewColumn:f,panelOptions:k,active:B});return this.e.set(a,X),X}getWebviewPanel(a){return this.e.get(a)}}e.ExtHostWebviewPanels=l;function u(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,c):I?I.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[272],ye([1,0,4,6,73,14,5,7]),function(ne,e,c,t,I,A,C,T){"use strict";var S,y,L,P,E,D,v,d,m,h,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends t.Disposable{constructor(s,r,l,u,o,a){super(),S.set(this,void 0),y.set(this,void 0),L.set(this,void 0),P.set(this,void 0),E.set(this,!1),D.set(this,void 0),v.set(this,void 0),d.set(this,void 0),m.set(this,void 0),h.set(this,this.B(new c.Emitter)),this.onDidChangeVisibility=Me(this,h,"f").event,b.set(this,this.B(new c.Emitter)),this.onDidDispose=Me(this,b,"f").event,Je(this,L,l,"f"),Je(this,v,u,"f"),Je(this,S,s,"f"),Je(this,y,r,"f"),Je(this,P,o,"f"),Je(this,D,a,"f")}dispose(){Me(this,E,"f")||(Je(this,E,!0,"f"),Me(this,b,"f").fire(),Me(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Me(this,v,"f")}set title(s){this.a(),Me(this,v,"f")!==s&&(Je(this,v,s,"f"),Me(this,y,"f").$setWebviewViewTitle(Me(this,S,"f"),s))}get description(){return this.a(),Me(this,d,"f")}set description(s){this.a(),Me(this,d,"f")!==s&&(Je(this,d,s,"f"),Me(this,y,"f").$setWebviewViewDescription(Me(this,S,"f"),s))}get visible(){return Me(this,D,"f")}get webview(){return Me(this,P,"f")}get viewType(){return Me(this,L,"f")}_setVisible(s){s===Me(this,D,"f")||Me(this,E,"f")||(Je(this,D,s,"f"),Me(this,h,"f").fire())}get badge(){return this.a(),Me(this,m,"f")}set badge(s){this.a(),!(s?.value===Me(this,m,"f")?.value&&s?.tooltip===Me(this,m,"f")?.tooltip)&&(Je(this,m,A.ViewBadge.from(s),"f"),Me(this,y,"f").$setWebviewViewBadge(Me(this,S,"f"),s))}show(s){this.a(),Me(this,y,"f").$show(Me(this,S,"f"),!!s)}a(){if(Me(this,E,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,y=new WeakMap,L=new WeakMap,P=new WeakMap,E=new WeakMap,D=new WeakMap,v=new WeakMap,d=new WeakMap,m=new WeakMap,h=new WeakMap,b=new WeakMap;class g{constructor(s,r){this.d=r,this.b=new Map,this.c=new Map,this.a=s.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,r,l,u){if(this.b.has(r))throw new Error(`View provider for '${r}' already registered`);return this.b.set(r,{provider:l,extension:s}),this.a.$registerWebviewViewProvider((0,I.toExtensionData)(s),r,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(s)}),new T.Disposable(()=>{this.b.delete(r),this.a.$unregisterWebviewViewProvider(r)})}async $resolveWebviewView(s,r,l,u,o){const a=this.b.get(r);if(!a)throw new Error(`No view provider found for '${r}'`);const{provider:n,extension:i}=a,f=this.d.createNewWebview(s,{},i),k=new p(s,this.a,r,l,f,!0);this.c.set(s,k),await n.resolveWebviewView(k,{state:u},o)}async $onDidChangeWebviewViewVisibility(s,r){this.e(s)._setVisible(r)}async $disposeWebviewView(s){const r=this.e(s);this.c.delete(s),r.dispose(),this.d.deleteWebview(s)}e(s){const r=this.c.get(s);if(!r)throw new Error("No webview found");return r}}e.ExtHostWebviewViews=g}),define(Se[141],ye([1,0,4,5,2,15,8,3,16]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let y=class ri{get state(){return this.d}constructor(P){this.c=new c.Emitter,this.onDidChangeWindowState=this.c.event,this.d=ri.a,this.b=P.getProxy(t.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}$onDidChangeWindowFocus(P){P!==this.d.focused&&(this.d={...this.d,focused:P},this.c.fire(this.d))}openUri(P,E){let D;if(typeof P=="string"){D=P;try{P=I.URI.parse(P)}catch{return Promise.reject(`Invalid uri - '${P}'`)}}return(0,C.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this.b.$openUri(P,D,E)}async asExternalUri(P,E){if((0,C.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const D=await this.b.$asExternalUri(P,E);return I.URI.from(D)}};y.a={focused:!0},y=qe([He(0,S.IExtHostRpcService)],y),e.ExtHostWindow=y,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(Se[273],ye([1,0,117,274,65,39,2,13,46]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class y{constructor(E,D,v){this.b=E,this.c=D,this.f=v,this.a=t.createServer((d,m)=>this.h(d,m)),this.g().catch(d=>(D.error(d),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",E=>this.c.error(E))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(E,D){const v=(m,h)=>{D.writeHead(m,{"content-type":"application/json"}),D.end(JSON.stringify(h||null),b=>b&&this.c.error(b))},d=[];E.setEncoding("utf8"),E.on("data",m=>d.push(m)),E.on("end",async()=>{try{const m=JSON.parse(d.join(""));let h;switch(m.type){case"open":h=await this.i(m);break;case"openExternal":h=await this.j(m);break;case"status":h=await this.l(m);break;case"extensionManagement":h=await this.k(m);break;default:v(404,`Unknown message type: ${m.type}`);break}v(200,h)}catch(m){const h=m instanceof Error?m.message:JSON.stringify(m);v(500,h),this.c.error("Error while processing pipe request",m)}})}async i(E){const{fileURIs:D,folderURIs:v,forceNewWindow:d,diffMode:m,mergeMode:h,addMode:b,forceReuseWindow:p,gotoLineMode:g,waitMarkerFilePath:w,remoteAuthority:s}=E,r=[];if(Array.isArray(v))for(const a of v)try{r.push({folderUri:C.URI.parse(a)})}catch{}if(Array.isArray(D))for(const a of D)try{(0,S.hasWorkspaceFileExtension)(a)?r.push({workspaceUri:C.URI.parse(a)}):r.push({fileUri:C.URI.parse(a)})}catch{}const l=w?C.URI.file(w):void 0,o={forceNewWindow:d,diffMode:m,mergeMode:h,addMode:b,gotoLineMode:g,forceReuseWindow:p,preferNewWindow:!p&&!l&&!b,waitMarkerFileURI:l,remoteAuthority:s};return this.b.executeCommand("_remoteCLI.windowOpen",r,o),""}async j(E){for(const D of E.uris){const v=C.URI.parse(D),d=v.scheme==="file"?v:D;await this.b.executeCommand("_remoteCLI.openExternal",d)}}async k(E){const D=d=>d?.map(m=>/\.vsix$/i.test(m)?C.URI.parse(m):m),v={list:E.list,install:D(E.install),uninstall:D(E.uninstall),force:E.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(E){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&I.existsSync(this.f)&&I.unlinkSync(this.f)}}e.CLIServerBase=y;let L=class extends y{constructor(E,D){super(E,D,(0,c.createRandomIPCHandle)())}};L=qe([He(0,A.IExtHostCommands),He(1,T.ILogService)],L),e.CLIServer=L}),define(Se[275],ye([1,0,246,25,16]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let C=class extends c.AbstractExtHostConsoleForwarder{constructor(S,y){super(S,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,y,L){const P=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),y.apply(console,L),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,y){const L=process[S],P=L.write;let E="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(D,v,d)=>{if(!this.g){E+=D.toString(v);const m=E.length>A?E.length:E.lastIndexOf(`
`);m!==-1&&(console[y](E.slice(0,m)),E=E.slice(m+1))}P.call(L,D,v,d)}})}};C=qe([He(0,I.IExtHostRpcService),He(1,t.IExtHostInitDataService)],C),e.ExtHostConsoleForwarder=C}),define(Se[276],ye([1,0,9,86,30,39,6,5,2,16]),function(ne,e,c,t,I,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends C.Disposable{constructor(E,D){super();const v=E.getProxy(T.MainContext.MainThreadDownloadService);D.registerCommand(!1,"_workbench.downloadResource",async d=>{const m=S.URI.file((0,c.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await v.$download(d,m),m})}};L=qe([He(0,y.IExtHostRpcService),He(1,A.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(Se[277],ye([1,0,140,15,198,30]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends c.ExtHostLoggerService{f(S,y,L){return S.scheme===t.Schemas.file?new I.SpdLogLogger(L?.name||(0,A.generateUuid)(),S.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,y):super.f(S,y,L)}}e.ExtHostLoggerService=C}),define(Se[278],ye([1,0,65,9,2,72,6,15,18,29]),function(ne,e,c,t,I,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends A.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(s){const r=await super.g(s);if(r.scheme!==T.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const l=r.fsPath;let u=0;do{let o;u===0?o=l:o=/[/\\]$/.test(l)?`${l.substr(0,l.length-1)}-${u}`:`${l}-${u}`,await P(o);const a=t.join(o,"vscode.lock"),n=await d(this.d,a,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),I.URI.file(o);u++}while(u<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function P(w){try{await y.Promises.stat(w);return}catch{}try{await y.Promises.mkdir(w,{recursive:!0})}catch{}}const E=1e3,D=10*60*1e3;class v extends C.Disposable{constructor(s,r){super(),this.b=s,this.c=r,this.a=this.B(new S.IntervalTimer),this.a.cancelAndSet(async()=>{const l=await m(s,r);(!l||l.pid!==process.pid)&&(s.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(r,new Date,new Date)}catch(u){s.error(u),s.info(`Lock '${r}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{c.unlinkSync(this.c)}catch{}}async setWillRelease(s){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${s} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+s};await y.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function d(w,s,r){try{const u={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(s,JSON.stringify(u),{flag:"wx"})}catch(u){w.error(u)}const l=await m(w,s);return!l||l.pid!==process.pid?r?(w.info(`Lock '${s}': Could not acquire lock, giving up.`),null):(w.info(`Lock '${s}': Could not acquire lock, checking if the file is stale.`),p(w,s)):(w.info(`Lock '${s}': Lock acquired.`),new v(w,s))}async function m(w,s){let r;try{r=await y.Promises.readFile(s)}catch(l){return w.error(l),null}try{return JSON.parse(String(r))}catch(l){return w.error(l),null}}async function h(w,s){let r;try{r=await y.Promises.stat(s)}catch(l){return w.error(l),0}return r.mtime.getTime()}function b(w){try{return process.kill(w,0),!0}catch{return!1}}async function p(w,s){const r=await m(w,s);if(!r)return w.info(`Lock '${s}': Could not read pid of lock holder.`),g(w,s);if(r.willReleaseAt){let n=r.willReleaseAt-Date.now();if(n<5e3){for(n>0?w.info(`Lock '${s}': The lockfile is scheduled to be released in ${n} ms.`):w.info(`Lock '${s}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await h(w,s)===0)return g(w,s);n=r.willReleaseAt-Date.now()}return g(w,s)}}if(!b(r.pid))return w.info(`Lock '${s}': The pid ${r.pid} appears to be gone.`),g(w,s);const l=await h(w,s),u=Date.now()-l;if(u<=D)return w.info(`Lock '${s}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;w.info(`Lock '${s}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const o=await h(w,s),a=Date.now()-o;return a<=D?(w.info(`Lock '${s}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null):(w.info(`Lock '${s}': The lock looks stale even after waiting for 2s.`),g(w,s))}async function g(w,s){w.info(`Lock '${s}': Deleting a stale lock.`);try{await y.Promises.unlink(s)}catch{}return d(w,s,!0)}}),define(Se[279],ye([1,0,30,16,40]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends I.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,S,y){return this.createTerminalFromOptions({name:T,shellPath:S,shellArgs:y})}createTerminalFromOptions(T,S){const y=new I.ExtHostTerminal(this.a,(0,c.generateUuid)(),T,T.name);return this.f.push(y),y.create(T,this.L(T,S)),y.value}};A=qe([He(0,t.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(Se[280],ye([1,0,5,16,181,6,25,2,45,24,29,7,12,54,4,129,100,13]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class b extends d.DisposableTunnel{}function p(n){const i=n.trim().split(`
`),f=[];return i.forEach(R=>{const B=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);B&&B.length>=3&&f.push({pid:parseInt(B[1],10),socket:parseInt(B[2],10)})}),f.reduce((R,B)=>(R[B.socket]=B,R),{})}e.getSockets=p;function g(...n){const i=[].concat(...n.map(s));return[...new Map(i.filter(f=>f.st==="0A").map(f=>{const k=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:w(k[0]),port:parseInt(k[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=g;function w(n){let i="";if(n.length===8)for(let f=n.length-2;f>=0;f-=2)i+=parseInt(n.substr(f,2),16),f!==0&&(i+=".");else for(let f=n.length-4;f>=0;f-=4)i+=parseInt(n.substr(f,4),16).toString(16),f!==0&&(i+=":");return i}function s(n){const i=n.trim().split(`
`),f=i.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return i.map(R=>R.trim().split(/\s+/).reduce((B,X,q)=>(B[f[q]||q]=X,B),{}))}e.loadConnectionTable=s;function r(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function l(n){const i=n.trim().split(`
`),f=[];return i.forEach(k=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(k);R&&R.length>=4&&f.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),f}e.getRootProcesses=l;async function u(n,i,f){const k=f.reduce((B,X)=>(B[X.pid]=X,B),{}),R=[];return n.forEach(({socket:B,ip:X,port:q})=>{const N=i[B]?i[B].pid:void 0,M=N?k[N]?.cmd:void 0;N&&M&&!r(M)&&R.push({host:X,port:q,detail:M,pid:N})}),R}e.findPorts=u;function o(n,i,f){const k=new Map,R=l(i);for(const B of n){const X=f.get(B.port);if(X){k.set(B.port,X);continue}const q=R.find(N=>N.cmd.includes(`${B.port}`));if(q){let N=q,M;do M=R.find(F=>F.ppid===N.pid),M&&(N=M);while(M);k.set(B.port,{host:B.ip,port:B.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else k.set(B.port,{host:B.ip,port:B.port,ppid:Number.MAX_VALUE})}return k}e.tryFindRootPorts=o;let a=class extends A.Disposable{constructor(i,f,k){super(),this.n=k,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new v.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=i.getProxy(c.MainContext.MainThreadTunnelService),E.isLinux&&f.remote.isRemote&&f.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(i,f){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const k=await this.a.$openTunnel(f,i.displayName);if(k){const R=new b(k.remoteAddress,k.localAddress,()=>this.a.$closeTunnel(k.remoteAddress));return this.B(R),R}}async getTunnels(){return this.a.$getTunnels()}p(i){return Math.max(i*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(i,f){const k=this.r();return this.l.set(k,{selector:i,provider:f}),this.a.$registerPortsAttributesProvider(i,k),new P.Disposable(()=>{this.l.delete(k),this.a.$unregisterPortsAttributesProvider(k)})}async $providePortAttributes(i,f,k,R,B){const X=[];for(const N of i){const M=this.l.get(N);if(!M)return[];X.push(...await Promise.all(f.map(async F=>M.provider.providePortAttributes(F,k,R,B))))}const q=X.filter(N=>!!N);return q.length>0?q.map(N=>({autoForwardAction:N.autoForwardAction,port:N.port})):[]}async $registerCandidateFinder(i){if(i&&this.h)return;this.h=i;const f=new m.MovingAverage;let k;for(;this.h;){const R=new Date().getTime(),B=(await this.findCandidatePorts()).filter(q=>(0,d.isLocalhost)(q.host)||(0,d.isAllInterfaces)(q.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${B.map(q=>q.port).join(", ")}`);const X=new Date().getTime()-R;f.update(X),(!k||JSON.stringify(k)!==JSON.stringify(B))&&(k=B,await this.a.$onFoundNewCandidates(k)),await new Promise(q=>setTimeout(()=>q(),this.p(f.value)))}}async setTunnelFactory(i){if(i){if(i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.c=i.showCandidatePort,this.a.$setCandidateFilter()),i.tunnelFactory){this.b=i.tunnelFactory;let f=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const k=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:f}:void 0;this.a.$setTunnelProvider(k)}}else this.b=void 0;return(0,A.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(i,f){if(this.f.has(i.host)){const k=this.f.get(i.host);k.has(i.port)&&(f&&k.get(i.port).disposeListener.dispose(),await k.get(i.port).tunnel.dispose(),k.delete(i.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(i,f){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const k=this.b(i,f);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),k!==void 0){const R=await k;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(i.remoteAddress.host)||this.f.set(i.remoteAddress.host,new Map);const B=this.B(R.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(R.remoteAddress))));return this.f.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:R,disposeListener:B}),D.TunnelDtoConverter.fromApiTunnel(R)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(i){const f=await Promise.all(i.map(R=>this.c(R.host,R.port,R.detail??""))),k=i.filter((R,B)=>f[B]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(R=>R.port).join(", ")} to ${k.map(R=>R.port).join(", ")}`),k}async findCandidatePorts(){let i="",f="";try{i=await L.Promises.readFile("/proc/net/tcp","utf8"),f=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const k=g(i,f),R=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(W,x,V)=>{U(x)})}),B=p(R),X=await L.Promises.readdir("/proc"),q=[];for(const U of X)try{const W=Number(U),x=y.joinPath(T.URI.file("/proc"),U);if((await L.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(W)){const _=await L.Promises.readlink(y.joinPath(x,"cwd").fsPath),Q=await L.Promises.readFile(y.joinPath(x,"cmdline").fsPath,"utf8");q.push({pid:W,cwd:_,cmd:Q})}}catch{}const N=[],M=k.filter(U=>{const W=B[U.socket];return W||N.push(U),W}),F=u(M,B,q);let z;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const U=await new Promise(W=>{(0,S.exec)("ps -F -A -l | grep root",(x,V,_)=>{W(V)})});this.j=o(N,U,this.j),z=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${z.map(W=>W.port).join(", ")}`)}return F.then(U=>z?U.concat(z):U)}};a=qe([He(0,t.IExtHostRpcService),He(1,C.IExtHostInitDataService),He(2,h.ILogService)],a),e.ExtHostTunnelService=a}),define(Se[281],ye([1,0,18,22,21,10,4,6,112,240,57]),function(ne,e,c,t,I,A,C,T,S,y,L){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(k,R){try{return JSON.stringify(k,R)}catch{return"null"}}const D="$$ref$$",v={[D]:-1};class d{constructor(R,B){this.jsonString=R,this.referencedBuffers=B}}function m(k,R=null,B=!1){const X=[];return{jsonString:(B?E:JSON.stringify)(k,(N,M)=>{if(typeof M>"u")return v;if(typeof M=="object"){if(M instanceof t.VSBuffer){const F=X.push(M)-1;return{[D]:F}}if(R)return R(N,M)}return M}),referencedBuffers:X}}e.stringifyJsonWithBufferRefs=m;function h(k,R,B){return JSON.parse(k,(X,q)=>{if(q){const N=q[D];if(typeof N=="number")return R[N];if(B&&q.$mid===1)return B.transformIncoming(q)}return q})}e.parseJsonAndRestoreBufferRefs=h;function b(k,R){return JSON.stringify(k,R)}function p(k){return k?(R,B)=>B&&B.$mid===1?k.transformOutgoing(B):B:null}var g;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},r=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class u extends T.Disposable{constructor(R,B=null,X=null){super(),this[P]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=R,this.f=B,this.g=X,this.h=p(this.g),this.j=!1,this.k=[],this.l=[];for(let q=0,N=L.ProxyIdentifier.count;q<N;q++)this.k[q]=null,this.l[q]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new c.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(q=>this.G(q))}dispose(){this.j=!0,Object.keys(this.s).forEach(R=>{this.s[R].resolveErr(A.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(R){this.u===0&&(this.v=Date.now()+u.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(R){this.v=Date.now()+u.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(R){this.t!==R&&(this.t=R,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(R){return this.g?(0,S.transformIncomingURIs)(R,this.g):R}getProxy(R){const{nid:B,sid:X}=R;return this.l[B]||(this.l[B]=this.F(B,X)),this.l[B]}F(R,B){const X={get:(q,N)=>(typeof N=="string"&&!q[N]&&N.charCodeAt(0)===36&&(q[N]=(...M)=>this.O(R,N,M)),N===l?B:q[N])};return new Proxy(Object.create(null),X)}set(R,B){return this.k[R.nid]=B,B}assertRegistered(R){for(let B=0,X=R.length;B<X;B++){const q=R[B];if(!this.k[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}G(R){if(this.j)return;const B=R.byteLength,X=o.read(R,0),q=X.readUInt8(),N=X.readUInt32();switch(q){case 1:case 2:{let{rpcId:M,method:F,args:z}=n.deserializeRequestJSONArgs(X);this.g&&(z=(0,S.transformIncomingURIs)(z,this.g)),this.H(B,N,M,F,z,q===2);break}case 3:case 4:{let{rpcId:M,method:F,args:z}=n.deserializeRequestMixedArgs(X);this.g&&(z=(0,S.transformIncomingURIs)(z,this.g)),this.H(B,N,M,F,z,q===4);break}case 5:{this.f?.logIncoming(B,N,0,"ack"),this.z(N);break}case 6:{this.I(B,N);break}case 7:{this.J(B,N,void 0);break}case 9:{let M=n.deserializeReplyOKJSON(X);this.g&&(M=(0,S.transformIncomingURIs)(M,this.g)),this.J(B,N,M);break}case 10:{const M=n.deserializeReplyOKJSONWithBuffers(X,this.g);this.J(B,N,M);break}case 8:{const M=n.deserializeReplyOKVSBuffer(X);this.J(B,N,M);break}case 11:{let M=n.deserializeReplyErrError(X);this.g&&(M=(0,S.transformIncomingURIs)(M,this.g)),this.L(B,N,M);break}case 12:{this.L(B,N,void 0);break}default:console.error("received unexpected message"),console.error(R)}}H(R,B,X,q,N,M){this.f?.logIncoming(R,B,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(X)}.${q}(`,N);const F=String(B);let z,U;if(M){const x=new I.CancellationTokenSource;N.push(x.token),z=this.M(X,q,N),U=()=>x.cancel()}else z=this.M(X,q,N),U=s;this.p[F]=U;const W=n.serializeAcknowledged(B);this.f?.logOutgoing(W.byteLength,B,1,"ack"),this.c.send(W),z.then(x=>{delete this.p[F];const V=n.serializeReplyOK(B,x,this.h);this.f?.logOutgoing(V.byteLength,B,1,"reply:",x),this.c.send(V)},x=>{delete this.p[F];const V=n.serializeReplyErr(B,x);this.f?.logOutgoing(V.byteLength,B,1,"replyErr:",x),this.c.send(V)})}I(R,B){this.f?.logIncoming(R,B,1,"receiveCancel");const X=String(B);this.p[X]?.()}J(R,B,X){this.f?.logIncoming(R,B,0,"receiveReply:",X);const q=String(B);if(!this.s.hasOwnProperty(q))return;const N=this.s[q];delete this.s[q],N.resolveOk(X)}L(R,B,X){this.f?.logIncoming(R,B,0,"receiveReplyErr:",X);const q=String(B);if(!this.s.hasOwnProperty(q))return;const N=this.s[q];delete this.s[q];let M;X&&(X.$isError?(M=new Error,M.name=X.name,M.message=X.message,M.stack=X.stack):M=X),N.resolveErr(M)}M(R,B,X){try{return Promise.resolve(this.N(R,B,X))}catch(q){return Promise.reject(q)}}N(R,B,X){const q=this.k[R];if(!q)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(R));const N=q[B];if(typeof N!="function")throw new Error("Unknown method "+B+" on actor "+(0,L.getStringIdentifierForProxy)(R));return N.apply(q,X)}O(R,B,X){if(this.j)return new y.CanceledLazyPromise;let q=null;if(X.length>0&&I.CancellationToken.isCancellationToken(X[X.length-1])&&(q=X.pop()),q&&q.isCancellationRequested)return Promise.reject(A.canceled());const N=n.serializeRequestArguments(X,this.h),M=++this.m,F=String(M),z=new y.LazyPromise;q&&q.onCancellationRequested(()=>{const W=n.serializeCancel(M);this.f?.logOutgoing(W.byteLength,M,0,"cancel"),this.c.send(n.serializeCancel(M))}),this.s[F]=z,this.y(M);const U=n.serializeRequest(M,R,B,N,!!q);return this.f?.logOutgoing(U.byteLength,M,0,`request: ${(0,L.getStringIdentifierForProxy)(R)}.${B}(`,X),this.c.send(U),z}}e.RPCProtocol=u,P=r,u.a=3*1e3;class o{static alloc(R,B,X){const q=new o(t.VSBuffer.alloc(X+1+4),0);return q.writeUInt8(R),q.writeUInt32(B),q}static read(R,B){return new o(R,B)}get buffer(){return this.a}constructor(R,B){this.a=R,this.b=B}static sizeUInt8(){return 1}writeUInt8(R){this.a.writeUInt8(R,this.b),this.b+=1}readUInt8(){const R=this.a.readUInt8(this.b);return this.b+=1,R}writeUInt32(R){this.a.writeUInt32BE(R,this.b),this.b+=4}readUInt32(){const R=this.a.readUInt32BE(this.b);return this.b+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this.a.writeUInt8(R.byteLength,this.b),this.b+=1,this.a.set(R,this.b),this.b+=R.byteLength}readShortString(){const R=this.a.readUInt8(this.b);this.b+=1;const X=this.a.slice(this.b,this.b+R).toString();return this.b+=R,X}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readLongString(){const R=this.a.readUInt32BE(this.b);this.b+=4;const X=this.a.slice(this.b,this.b+R).toString();return this.b+=R,X}writeBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readVSBuffer(){const R=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+R);return this.b+=R,B}static sizeMixedArray(R){let B=0;B+=1;for(let X=0,q=R.length;X<q;X++){const N=R[X];switch(B+=1,N.type){case 1:B+=this.sizeLongString(N.value);break;case 2:B+=this.sizeVSBuffer(N.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(N.value);for(let M=0;M<N.buffers.length;++M)B+=this.sizeVSBuffer(N.buffers[M]);break;case 4:break}}return B}writeMixedArray(R){this.a.writeUInt8(R.length,this.b),this.b+=1;for(let B=0,X=R.length;B<X;B++){const q=R[B];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let N=0;N<q.buffers.length;++N)this.writeBuffer(q.buffers[N]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this.a.readUInt8(this.b);this.b+=1;const B=new Array(R);for(let X=0;X<R;X++)switch(this.readUInt8()){case 1:B[X]=this.readLongString();break;case 2:B[X]=this.readVSBuffer();break;case 3:{const N=this.readUInt32(),M=this.readLongString(),F=[];for(let z=0;z<N;++z)F.push(this.readVSBuffer());B[X]=new L.SerializableObjectWithBuffers(h(M,F,null));break}case 4:B[X]=void 0;break}return B}}o.sizeUInt32=4;var a;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(a||(a={}));class n{static a(R){for(let B=0,X=R.length;B<X;B++)if(R[B]instanceof t.VSBuffer||R[B]instanceof L.SerializableObjectWithBuffers||typeof R[B]>"u")return!0;return!1}static serializeRequestArguments(R,B){if(this.a(R)){const X=[];for(let q=0,N=R.length;q<N;q++){const M=R[q];if(M instanceof t.VSBuffer)X[q]={type:2,value:M};else if(typeof M>"u")X[q]={type:4};else if(M instanceof L.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:z}=m(M.value,B);X[q]={type:3,value:t.VSBuffer.fromString(F),buffers:z}}else X[q]={type:1,value:t.VSBuffer.fromString(b(M,B))}}return{type:1,args:X}}return{type:0,args:b(R,B)}}static serializeRequest(R,B,X,q,N){switch(q.type){case 0:return this.b(R,B,X,q.args,N);case 1:return this.c(R,B,X,q.args,N)}}static b(R,B,X,q,N){const M=t.VSBuffer.fromString(X),F=t.VSBuffer.fromString(q);let z=0;z+=o.sizeUInt8(),z+=o.sizeShortString(M),z+=o.sizeLongString(F);const U=o.alloc(N?2:1,R,z);return U.writeUInt8(B),U.writeShortString(M),U.writeLongString(F),U.buffer}static deserializeRequestJSONArgs(R){const B=R.readUInt8(),X=R.readShortString(),q=R.readLongString();return{rpcId:B,method:X,args:JSON.parse(q)}}static c(R,B,X,q,N){const M=t.VSBuffer.fromString(X);let F=0;F+=o.sizeUInt8(),F+=o.sizeShortString(M),F+=o.sizeMixedArray(q);const z=o.alloc(N?4:3,R,F);return z.writeUInt8(B),z.writeShortString(M),z.writeMixedArray(q),z.buffer}static deserializeRequestMixedArgs(R){const B=R.readUInt8(),X=R.readShortString(),q=R.readMixedArray(),N=new Array(q.length);for(let M=0,F=q.length;M<F;M++){const z=q[M];typeof z=="string"?N[M]=JSON.parse(z):N[M]=z}return{rpcId:B,method:X,args:N}}static serializeAcknowledged(R){return o.alloc(5,R,0).buffer}static serializeCancel(R){return o.alloc(6,R,0).buffer}static serializeReplyOK(R,B,X){if(typeof B>"u")return this.d(R);if(B instanceof t.VSBuffer)return this.e(R,B);if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:N}=m(B.value,X,!0);return this.g(R,q,N)}else return this.f(R,E(B,X))}static d(R){return o.alloc(7,R,0).buffer}static e(R,B){let X=0;X+=o.sizeVSBuffer(B);const q=o.alloc(8,R,X);return q.writeVSBuffer(B),q.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static f(R,B){const X=t.VSBuffer.fromString(B);let q=0;q+=o.sizeLongString(X);const N=o.alloc(9,R,q);return N.writeLongString(X),N.buffer}static g(R,B,X){const q=t.VSBuffer.fromString(B);let N=0;N+=o.sizeUInt32,N+=o.sizeLongString(q);for(const F of X)N+=o.sizeVSBuffer(F);const M=o.alloc(10,R,N);M.writeUInt32(X.length),M.writeLongString(q);for(const F of X)M.writeBuffer(F);return M.buffer}static deserializeReplyOKJSON(R){const B=R.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(R,B){const X=R.readUInt32(),q=R.readLongString(),N=[];for(let M=0;M<X;++M)N.push(R.readVSBuffer());return new L.SerializableObjectWithBuffers(h(q,N,B))}static serializeReplyErr(R,B){const X=B?E(A.transformErrorForSerialization(B),null):void 0;if(typeof X!="string")return this.h(R);const q=t.VSBuffer.fromString(X);let N=0;N+=o.sizeLongString(q);const M=o.alloc(11,R,N);return M.writeLongString(q),M.buffer}static deserializeReplyErrError(R){const B=R.readLongString();return JSON.parse(B)}static h(R){return o.alloc(12,R,0).buffer}}var i;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(i||(i={}));var f;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(f||(f={}))}),define(Se[282],ye([1,0,4,43,53,3,38,10,18]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)(e.OUTPUT_SERVICE_ID);var y;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.a=new Map,this.b=new c.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new c.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(v){this.a.has(v.id)||(this.a.set(v.id,v),this.b.fire(v.id))}getChannels(){const v=[];return this.a.forEach(d=>v.push(d)),v}getChannel(v){return this.a.get(v)}removeChannel(v){this.a.delete(v),this.c.fire(v)}}t.Registry.add(e.Extensions.OutputChannels,new L);function P(D,v,d,m,h){return(0,S.createCancelablePromise)(async b=>{await(0,C.whenProviderRegistered)(d,m);const p=t.Registry.as(e.Extensions.OutputChannels);try{await E(d,1,m,h,b),p.registerChannel({id:D,label:v,file:d,log:!0})}catch(g){(0,T.isCancellationError)(g)||h.error("Error while registering log channel",d.toString(),(0,T.getErrorMessage)(g))}})}e.registerLogChannel=P;async function E(D,v,d,m,h){if(!await d.exists(D)){if(h.isCancellationRequested)throw new T.CancellationError;if(v>10)throw new Error("Timed out while waiting for file to be created");m.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",D.toString()),await(0,S.timeout)(1e3,h),await E(D,v+1,d,m,h)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new I.RawContextKey("activeOutputChannel","")}),define(Se[142],ye([1,0,5,3,16,27,13,282,71,25,47,156,22,11,38,4,6]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class h extends C.AbstractMessageLogger{get disposed(){return this.l}constructor(w,s,r,l,u){super(),this.id=w,this.name=s,this.m=r,this.n=l,this.extension=u,this.k=0,this.l=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(o=>this.setLevel(o)))}get logLevel(){return this.getLevel()}appendLine(w){this.append(w+`
`)}append(w){this.info(w)}clear(){const w=this.k;this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Clear,w)}replace(w){const s=this.k;this.info(w),this.n.$update(this.id,T.OutputChannelUpdateMode.Replace,s),this.visible&&this.m.flush()}show(w,s){this.m.flush(),this.n.$reveal(this.id,!!(typeof w=="boolean"?w:s))}hide(){this.n.$close(this.id)}g(w,s){this.k+=E.VSBuffer.fromString(s).byteLength,(0,C.log)(this.m,w,s),this.visible&&(this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class b extends h{appendLine(w){this.append(w)}}let p=class{constructor(w,s,r,l,u,o){this.i=s,this.j=r,this.k=l,this.l=u,this.m=o,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=w.getProxy(c.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(s.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.h=w;for(const[s,r]of this.g)r.visible=s===this.h}createOutputChannel(w,s,r){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const l=typeof s=="object"&&s.log,u=(0,D.isString)(s)?s:void 0;if((0,D.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let o;const a=this.i.environment.extensionLogLevel?.find(([i])=>A.ExtensionIdentifier.equals(r.identifier,i))?.[1];a&&(o=(0,C.parseLogLevel)(a));const n=l?this.o(w,o,r):this.n(w,u,r);return n.then(i=>{this.g.set(i.id,i),i.visible=i.id===this.h}),l?this.r(w,o??this.m.getLevel(),n):this.q(w,n)}async n(w,s,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const l=await this.c,u=this.k.extUri.joinPath(l,`${this.f++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),a=await this.a.$register(w,u,!1,s,r.identifier.value);return new h(a,w,o,this.a,r)}async o(w,s,r){const l=await this.p(r),u=this.k.extUri.joinPath(l,`${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(u,{name:w},s),a=await this.a.$register(w,u,!0,void 0,r.identifier.value);return new b(a,w,o,this.a,r)}p(w){let s=this.d.get(w.identifier.value);if(!s){const r=this.k.extUri.joinPath(this.i.logsLocation,w.identifier.value);this.d.set(w.identifier.value,s=(async()=>{try{await this.j.value.createDirectory(r)}catch(l){if((0,v.toFileSystemProviderErrorCode)(l)!==v.FileSystemProviderErrorCode.FileExists)throw l}return r})())}return s}q(w,s){let r=!1;const l=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return w},append(u){l(),s.then(o=>o.append(u))},appendLine(u){l(),s.then(o=>o.appendLine(u))},clear(){l(),s.then(u=>u.clear())},replace(u){l(),s.then(o=>o.replace(u))},show(u,o){l(),s.then(a=>a.show(u,o))},hide(){l(),s.then(u=>u.hide())},dispose(){r=!0,s.then(u=>u.dispose())}}}r(w,s,r){const l=new m.DisposableStore,u=()=>{if(l.isDisposed)throw new Error("Channel has been closed")},o=l.add(new d.Emitter);return r.then(a=>{l.add(a),l.add(a.onDidChangeLogLevel(n=>{s=n,o.fire(n)}))}),{...this.q(w,r),get logLevel(){return s},onDidChangeLogLevel:o.event,trace(a,...n){u(),r.then(i=>i.trace(a,...n))},debug(a,...n){u(),r.then(i=>i.debug(a,...n))},info(a,...n){u(),r.then(i=>i.info(a,...n))},warn(a,...n){u(),r.then(i=>i.warn(a,...n))},error(a,...n){u(),r.then(i=>i.error(a,...n))},dispose(){l.dispose()}}}};p=qe([He(0,I.IExtHostRpcService),He(1,y.IExtHostInitDataService),He(2,S.IExtHostConsumerFileSystem),He(3,L.IExtHostFileSystemInfo),He(4,C.ILoggerService),He(5,C.ILogService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(Se[283],ye([1,0,3]),function(ne,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(Se[284],ye([1,0,32,15,9,12,24,2,3,210,46,227,283]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let D=class si{constructor(d,m,h,b){this.d=d,this.e=m,this.f=h,this.g=b,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const p=await this.e.getEnvironment();return this.c=p?.userHome??d})()}hasValidBasename(d,m,h){return typeof m=="string"||typeof m>"u"?this.a.then(b=>this.h(d,b,m)):this.h(d,m,h)}h(d,m,h){return d.scheme===t.Schemas.file||d.scheme===t.Schemas.vscodeRemote?(0,c.isValidBasename)(h??(0,C.basename)(d),m===1):!0}get defaultUriScheme(){return si.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,m){if(d.remoteAuthority)return t.Schemas.vscodeRemote;const h=(0,y.getVirtualWorkspaceScheme)(m.getWorkspace());if(h)return h;const b=m.getWorkspace().folders[0];if(b)return b.uri.scheme;const p=m.getWorkspace().configuration;return p?p.scheme:t.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?I.win32:I.posix)}async fileURI(d){let m="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const b=d.indexOf("/",2);b===-1?(m=d.substring(2),d="/"):(m=d.substring(2,b),d=d.substring(b)||"/")}return T.URI.from({scheme:t.Schemas.file,authority:m,path:d,query:"",fragment:""})}};D=qe([He(1,E.IRemoteAgentService),He(2,P.IWorkbenchEnvironmentService),He(3,L.IWorkspaceContextService)],D),e.AbstractPathService=D}),define(Se[74],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(C,T){this.line=C,this.character=T}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,T){return new c(0,0)}with(C){return new c(0,0)}}e.Position=c;class t{constructor(C,T,S,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(C,T),this.end=new c(S,y)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new t(0,0,0,0)}with(C){return new t(0,0,0,0)}}e.Range=t;var I;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Se[31],ye([1,0,17,37,23,32,8,3,9,10,74,18]),function(ne,e,c,t,I,A,C,T,S,y,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",D=" characters skipped \u27EB",v=(E.length+D.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var d;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var m;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(m=e.QueryType||(e.QueryType={}));function h(Q){return!!Q.preview}e.resultIsMatch=h;function b(Q){return!!Q.resource}e.isFileMatch=b;function p(Q){return!!Q.message}e.isProgressMessage=p;var g;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(g=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(J){this.resource=J,this.results=[]}}e.FileMatch=w;class s{constructor(J,te,le){this.ranges=te;const Z=Array.isArray(te)?te:[te];if(le&&le.matchLines===1&&r(Z)){J=(0,C.getNLines)(J,le.matchLines);let ge="",ve=0,De=0;const Re=Math.floor(le.charsPerLine/5),ze=[];for(const se of Z){const ue=Math.max(se.startColumn-Re,0),he=se.startColumn+le.charsPerLine;if(ue>De+Re+v){const ee=E+(ue-De)+D;ge+=ee+J.slice(ue,he),ve+=ue-(De+ee.length)}else ge+=J.slice(De,he);ze.push(new u(0,se.startColumn-ve,se.endColumn-ve)),De=he}this.preview={text:ge,matches:Array.isArray(this.ranges)?ze:ze[0]}}else{const ge=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:J,matches:(0,c.mapArrayOrNot)(te,ve=>new l(ve.startLineNumber-ge,ve.startColumn,ve.endLineNumber-ge,ve.endColumn))}}}}e.TextSearchMatch=s;function r(Q){const J=Q[0].startLineNumber;for(const te of Q)if(te.startLineNumber!==J||te.endLineNumber!==J)return!1;return!0}class l{constructor(J,te,le,Z){this.startLineNumber=J,this.startColumn=te,this.endLineNumber=le,this.endColumn=Z}}e.SearchRange=l;class u extends l{constructor(J,te,le){super(J,te,J,le)}}e.OneLineRange=u;var o;(function(Q){Q.List="list",Q.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var a;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(a=e.SearchSortOrder||(e.SearchSortOrder={}));function n(Q,J=!0){const te=Q&&Q.files&&Q.files.exclude,le=J&&Q&&Q.search&&Q.search.exclude;if(!te&&!le)return;if(!te||!le)return te||le;let Z=Object.create(null);return Z=I.mixin(Z,I.deepClone(te)),Z=I.mixin(Z,I.deepClone(le),!0),Z}e.getExcludes=n;function i(Q,J){return Q.excludePattern&&t.match(Q.excludePattern,J)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&t.match(Q.includePattern,J)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(te=>{const le=te.folder.fsPath;if(A.isEqualOrParent(J,le)){const Z=S.relative(le,J);return!te.includePattern||!!t.match(te.includePattern,Z)}else return!1}):!1:!0}e.pathIncludedInQuery=i;var f;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class k extends Error{constructor(J,te){super(J),this.code=te}}e.SearchError=k;function R(Q){const J=Q.message;if((0,y.isCancellationError)(Q))return new k(J,f.canceled);try{const te=JSON.parse(J);return new k(te.message,te.code)}catch{return new k(J,f.other)}}e.deserializeSearchError=R;function B(Q){const J={message:Q.message,code:Q.code};return new Error(JSON.stringify(J))}e.serializeSearchError=B;function X(Q){return Q.type==="error"?!0:Q.type==="success"}e.isSerializedSearchComplete=X;function q(Q){return Q.type==="success"}e.isSerializedSearchSuccess=q;function N(Q){return!!Q.path}e.isSerializedFileMatch=N;function M(Q,J){const te=Q.searchPath?Q.searchPath:Q.relativePath;return(0,C.fuzzyContains)(te,J)}e.isFilePatternMatch=M;class F{constructor(J){this.path=J,this.results=[]}addMatch(J){this.results.push(J)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function z(Q,J){const te={...Q||{},...J||{}};return Object.keys(te).filter(le=>{const Z=te[le];return typeof Z=="boolean"&&Z})}e.resolvePatternsForProvider=z;class U{constructor(J,te){this.c=null,this.a={...J.excludePattern||{},...te.excludePattern||{}},this.b=t.parse(this.a);let le=J.includePattern;te.includePattern&&(le?le={...le,...te.includePattern}:le=te.includePattern),le&&(this.c=t.parse(le))}matchesExcludesSync(J,te,le){return!!(this.b&&this.b(J,te,le))}includedInQuerySync(J,te,le){return!(this.b&&this.b(J,te,le)||this.c&&!this.c(J,te,le))}includedInQuery(J,te,le){const Z=this.b(J,te,le),ge=()=>this.c?!!this.c(J,te,le):!0;return(0,P.isThenable)(Z)?Z.then(ve=>ve?!1:ge()):ge()}hasSiblingExcludeClauses(){return W(this.a)}}e.QueryGlobTester=U;function W(Q){for(const J in Q)if(typeof Q[J]!="boolean")return!0;return!1}function x(Q){if(!Q)return;let J;return te=>(J||(J=(Q()||Promise.resolve([])).then(le=>le?_(le):{})),J.then(le=>!!le[te]))}e.hasSiblingPromiseFn=x;function V(Q){if(!Q)return;let J;return te=>{if(!J){const le=Q();J=le?_(le):{}}return!!J[te]}}e.hasSiblingFn=V;function _(Q){const J={};for(const te of Q)J[te]=!0;return J}}),define(Se[33],ye([1,0,17,18,21,4,6,64,15,100,24,8,11,2,179,3,13,199,46,47,25,16,14,7,55,31,5]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b,p,g,w,s,r,l,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(q,N,M){return new L.ExtUri(F=>k(F,M)).isEqual(q,N)}function n(q,N,M){return a(q.uri,N.uri,M)?0:(0,P.compare)(q.uri.toString(),N.uri.toString())}function i(q,N,M){return q.index!==N.index?q.index<N.index?-1:1:a(q.uri,N.uri,M)?(0,P.compare)(q.name,N.name):(0,P.compare)(q.uri.toString(),N.uri.toString())}function f(q,N,M,F){const z=q.slice(0).sort((W,x)=>M(W,x,F)),U=N.slice(0).sort((W,x)=>M(W,x,F));return(0,c.delta)(z,U,(W,x)=>M(W,x,F))}function k(q,N){const M=N.getCapabilities(q.scheme);return!(M&&M&1024)}class R extends b.Workspace{static toExtHostWorkspace(N,M,F,z){if(!N)return{workspace:null,added:[],removed:[]};const{id:U,name:W,folders:x,configuration:V,transient:_,isUntitled:Q}=N,J=[],te=M;M?x.forEach((ve,De)=>{const Re=D.URI.revive(ve.uri),ze=R.e(F||M,Re,z);ze?(ze.name=ve.name,ze.index=ve.index,J.push(ze)):J.push({uri:Re,name:ve.name,index:De})}):J.push(...x.map(({uri:ve,name:De,index:Re})=>({uri:D.URI.revive(ve),name:De,index:Re}))),J.sort((ve,De)=>ve.index<De.index?-1:1);const le=new R(U,W,J,!!_,V?D.URI.revive(V):null,!!Q,ve=>k(ve,z)),{added:Z,removed:ge}=f(te?te.workspaceFolders:[],le.workspaceFolders,n,z);return{workspace:le,added:Z,removed:ge}}static e(N,M,F){for(let z=0;z<N.folders.length;z++){const U=N.workspaceFolders[z];if(a(U.uri,M,F))return U}}constructor(N,M,F,z,U,W,x){super(N,F.map(V=>new b.WorkspaceFolder(V)),z,U,x),this.s=M,this.t=W,this.o=[],this.q=T.TernarySearchTree.forUris(x),F.forEach(V=>{this.o.push(V),this.q.set(V.uri,V)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(N,M){return M&&this.q.get(N)&&(N=(0,L.dirname)(N)),this.q.findSubstr(N)}resolveWorkspaceFolder(N){return this.q.get(N)}}let B=class{constructor(N,M,F,z,U){this.c=new A.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new A.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=z,this.q=F,this.s=U,this.h=new y.Counter,this.j=new t.Barrier,this.n=N.getProxy(o.MainContext.MainThreadWorkspace),this.o=N.getProxy(o.MainContext.MainThreadMessageService);const W=M.workspace;this.k=W?new R(W.id,W.name,[],!!W.transient,W.configuration?D.URI.revive(W.configuration):null,!!W.isUntitled,x=>k(x,F)):void 0}$initializeWorkspace(N,M){this.u=M,this.$acceptWorkspaceData(N),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?D.URI.from({scheme:S.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(N,M,F,...z){const U=[];if(Array.isArray(z)&&z.forEach(Q=>{D.URI.isUri(Q.uri)&&!U.some(J=>a(J.uri,Q.uri,this.q))&&U.push({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri)})}),this.l||[M,F].some(Q=>typeof Q!="number"||Q<0)||F===0&&U.length===0)return!1;const W=this.w?this.w.workspaceFolders:[];if(M+F>W.length)return!1;const x=W.slice(0);x.splice(M,F,...U.map(Q=>({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<x.length;Q++){const J=x[Q];if(x.some((te,le)=>le!==Q&&a(J.uri,te.uri,this.q)))return!1}x.forEach((Q,J)=>Q.index=J);const{added:V,removed:_}=f(W,x,i,this.q);if(V.length===0&&_.length===0)return!1;if(this.n){const Q=N.displayName||N.name;this.n.$updateWorkspaceFolders(Q,M,F,U).then(void 0,J=>{this.l=void 0;const te={source:{identifier:N.identifier,label:N.displayName||N.name}};this.o.$showMessage(h.Severity.Error,(0,v.localize)(0,null,Q,J.toString()),te,[])})}return this.x(x),!0}getWorkspaceFolder(N,M){if(!!this.w)return this.w.getWorkspaceFolder(N,M)}async getWorkspaceFolder2(N,M){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(N,M)}async resolveWorkspaceFolder(N){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(N)}getPath(){if(!this.w)return;const{folders:N}=this.w;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,M){let F,z="";if(typeof N=="string"?(F=D.URI.file(N),z=N):typeof N<"u"&&(F=N,z=N.fsPath),!F)return z;const U=this.getWorkspaceFolder(F,!0);if(!U)return z;typeof M>"u"&&this.w&&(M=this.w.folders.length>1);let W=(0,L.relativePath)(U.uri,F);return M&&U.name&&(W=`${U.name}/${W}`),W}x(N){this.w&&(this.l=R.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:N,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:M,added:F,removed:z}=R.toExtHostWorkspace(N,this.k,this.l,this.q);this.k=M||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:z}))}findFiles(N,M,F,z,U=I.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let W;if(M===null?W=!1:M&&(typeof M=="string"?W=M:W=M.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:V}=X(s.GlobPattern.from(N));return this.n.$startFileSearch((0,E.withUndefinedAsNull)(x),(0,E.withUndefinedAsNull)(V),(0,E.withUndefinedAsNull)(W),(0,E.withUndefinedAsNull)(F),U).then(_=>Array.isArray(_)?_.map(Q=>D.URI.revive(Q)):[])}async findTextInFiles(N,M,F,z,U=I.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const W=this.h.getNext(),x=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:V,folder:_}=X(s.GlobPattern.from(M.include)),Q=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,J={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:x,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:V,excludePattern:Q},te=!1;if(this.t[W]=le=>{if(te)return;const Z=D.URI.revive(le.resource);le.results.forEach(ge=>{(0,u.resultIsMatch)(ge)?F({uri:Z,preview:{text:ge.preview.text,matches:(0,c.mapArrayOrNot)(ge.preview.matches,ve=>new r.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,c.mapArrayOrNot)(ge.ranges,ve=>new r.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):F({uri:Z,text:ge.text,lineNumber:ge.lineNumber})})},U.isCancellationRequested)return{};try{const le=await this.n.$startTextSearch(N,(0,E.withUndefinedAsNull)(_),J,W,U);return delete this.t[W],le||{}}catch(le){throw delete this.t[W],le}}$handleTextSearchResult(N,M){this.t[M]?.(N)}saveAll(N){return this.n.$saveAll(N)}resolveProxy(N){return this.n.$resolveProxy(N)}get trusted(){return this.u}requestWorkspaceTrust(N){return this.n.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(N,M){if(this.v.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.v.set(N,M);const F=this.s.transformOutgoingScheme(N),z=this.y++;return this.n.$registerEditSessionIdentityProvider(z,F),(0,C.toDisposable)(()=>{this.v.delete(N),this.n.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(N,M){this.g.info("Getting edit session identifier for workspaceFolder",N);const F=await this.resolveWorkspaceFolder(D.URI.revive(N));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const z=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!z),!z)return;const U=await z.provideEditSessionIdentity(F,M);if(this.g.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(N,M,F,z){this.g.info("Getting edit session identifier for workspaceFolder",N);const U=await this.resolveWorkspaceFolder(D.URI.revive(N));if(!U){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const W=this.v.get(U.uri.scheme);if(this.g.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!W),!W)return;const x=await W.provideEditSessionIdentityMatch?.(M,F,z);if(this.g.info("Provider returned edit session identifier match result: ",x),!!x)return x}};B=qe([He(0,w.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,p.IExtHostFileSystemInfo),He(3,m.ILogService),He(4,l.IURITransformerService)],B),e.ExtHostWorkspace=B,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function X(q){let N,M;return q&&(typeof q=="string"?N=q:(N=q.pattern,M=D.URI.revive(q.baseUri))),{includePattern:N,folder:M}}}),define(Se[34],ye([1,0,23,4,33,5,7,202,126,11,18,3,16,13,2]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(r,l){if(l){const u=l.split(".");let o=r;for(let a=0;o&&a<u.length;a++)o=o[u[a]];return o}}function m(r){return r instanceof v.URI}function h(r){return r&&r.uri instanceof v.URI&&r.languageId&&typeof r.languageId=="string"}function b(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function p(r){return r&&r.uri instanceof v.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function g(r){if(m(r))return{resource:r};if(h(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(b(r))return{overrideIdentifier:r.languageId};if(p(r))return{resource:r.uri};if(r===null)return{resource:null}}let w=class{constructor(l,u,o){this.a=l.getProxy(A.MainContext.MainThreadConfiguration),this.c=u,this.b=o,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new s(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,u){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(l,u))}};w=qe([He(0,E.IExtHostRpcService),He(1,I.IExtHostWorkspace),He(2,D.ILogService)],w),e.ExtHostConfiguration=w;class s{constructor(l,u,o,a){this.a=new t.Emitter,this.b=l,this.f=a,this.c=u,this.e=T.Configuration.parse(o),this.d=this.k(o.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,u){const o={data:this.e.toData(),workspace:this.c.workspace};this.e=T.Configuration.parse(l),this.d=this.k(l.configurationScopes),this.a.fire(this.j(u,o))}getConfiguration(l,u,o){const a=g(u)||{},n=this.g(l?d(this.e.getValue(void 0,a,this.c.workspace),l):this.e.getValue(void 0,a,this.c.workspace));l&&this.h(l,a,o?.identifier);function i(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(k){return typeof d(n,k)<"u"},get:(k,R)=>{this.h(l?`${l}.${k}`:k,a,o?.identifier);let B=d(n,k);if(typeof B>"u")B=R;else{let X;const q=(N,M)=>{let F;const z=()=>{X=X||(0,c.deepClone)(n),F=F||d(X,M)};return(0,y.isObject)(N)?new Proxy(N,{get:(U,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return z(),()=>F;if(X)return F=F||d(X,M),F[W];const x=U[W];return typeof W=="string"?q(x,`${M}.${W}`):x},set:(U,W,x)=>(z(),F&&(F[W]=x),!0),deleteProperty:(U,W)=>(z(),F&&delete F[W],!0),defineProperty:(U,W,x)=>(z(),F&&Object.defineProperty(F,W,x),!0)}):N};B=q(B,k)}return B},update:(k,R,B,X)=>{k=l?`${l}.${k}`:k;const q=i(B);return R!==void 0?this.b.$updateConfigurationOption(q,k,R,a,X):this.b.$removeConfigurationOption(q,k,a,X)},inspect:k=>{k=l?`${l}.${k}`:k;const R=this.e.inspect(k,a,this.c.workspace);if(R)return{key:k,defaultValue:(0,c.deepClone)(R.policy?.value??R.default?.value),globalValue:(0,c.deepClone)(R.user?.value??R.application?.value),workspaceValue:(0,c.deepClone)(R.workspace?.value),workspaceFolderValue:(0,c.deepClone)(R.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(R.default?.override),globalLanguageValue:(0,c.deepClone)(R.user?.override??R.application?.override),workspaceLanguageValue:(0,c.deepClone)(R.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(R.workspaceFolder?.override),languageIds:(0,c.deepClone)(R.overrideIdentifiers)}}};return typeof n=="object"&&(0,c.mixin)(f,n,!1),Object.freeze(f)}g(l){const u=o=>(0,y.isObject)(o)?new Proxy(o,{get:(a,n)=>u(a[n]),set:(a,n,i)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(a,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(a,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return u(l)}h(l,u,o){const a=S.OVERRIDE_PROPERTY_REGEX.test(l)?4:this.d.get(l),n=o?`[${o.value}] `:"";if(a===4){typeof u?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){u?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,u){const o=new T.ConfigurationChangeEvent(l,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(a,n)=>o.affectsConfiguration(a,g(n))})}k(l){return l.reduce((u,o)=>(u.set(o[0],o[1]),u),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,c):I?I.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[75],ye([1,0,2,18,4,5,7,33,58,34,21,40,16,25,3,15,12,13,70,239,10]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b,p,g){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(N){function M(z){if(z!=null)return z}N.from=M;function F(z){if(z!=null)return z}N.to=F})(s||(s={}));var r;(function(N){function M(z){if(z!=null)return z}N.from=M;function F(z){if(z!=null)return z}N.to=F})(r||(r={}));var l;(function(N){function M(z){if(z!=null)return z}N.from=M;function F(z){if(z!=null)return z}N.to=F})(l||(l={}));var u;(function(N){function M(U){if(U){const W=U;return W&&!!W.process}else return!1}N.is=M;function F(U){if(U==null)return;const W={process:U.process,args:U.args};return U.options&&(W.options=l.from(U.options)),W}N.from=F;function z(U){if(U!=null)return new C.ProcessExecution(U.process,U.args,U.options)}N.to=z})(u||(u={}));var o;(function(N){function M(z){if(z!=null)return z}N.from=M;function F(z){if(z!=null)return z}N.to=F})(o||(o={}));var a;(function(N){function M(U){if(U){const W=U;return W&&(!!W.commandLine||!!W.command)}else return!1}N.is=M;function F(U){if(U==null)return;const W={};return U.commandLine!==void 0?W.commandLine=U.commandLine:(W.command=U.command,W.args=U.args),U.options&&(W.options=o.from(U.options)),W}N.from=F;function z(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new C.ShellExecution(U.commandLine,U.options):new C.ShellExecution(U.command,U.args?U.args:[],U.options)}N.to=z})(a||(a={}));var n;(function(N){function M(U){if(U){const W=U;return W&&W.customExecution==="customExecution"}else return!1}N.is=M;function F(U){return{customExecution:"customExecution"}}N.from=F;function z(U,W){return W.get(U)}N.to=z})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var i;(function(N){function M(F,z){let U;return F.scope!==void 0&&typeof F.scope!="number"?U=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===C.TaskScope.Workspace&&z&&z.workspaceFile?U=z.workspaceFile:U=p.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:U}}N.from=M})(i=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(N){function M(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}N.from=M})(f||(f={}));var k;(function(N){function M(U,W){if(U==null)return[];const x=[];for(const V of U){const _=F(V,W);_&&x.push(_)}return x}N.fromMany=M;function F(U,W){if(U==null)return;let x;U.execution instanceof C.ProcessExecution?x=u.from(U.execution):U.execution instanceof C.ShellExecution?x=a.from(U.execution):U.execution&&U.execution instanceof C.CustomExecution&&(x=n.from(U.execution));const V=s.from(U.definition);let _;return U.scope?typeof U.scope=="number"?_=U.scope:_=U.scope.uri:_=C.TaskScope.Workspace,!V||!_?void 0:{_id:U._id,definition:V,name:U.name,source:{extensionId:W.identifier.value,label:U.source,scope:_},execution:x,isBackground:U.isBackground,group:f.from(U.group),presentationOptions:r.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}N.from=F;async function z(U,W,x){if(U==null)return;let V;u.is(U.execution)?V=u.to(U.execution):a.is(U.execution)?V=a.to(U.execution):n.is(U.execution)&&(V=n.to(U._id,x));const _=s.to(U.definition);let Q;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?Q=U.source.scope:Q=await W.resolveWorkspaceFolder(c.URI.revive(U.source.scope)):Q=C.TaskScope.Workspace),!_||!Q)return;const J=new C.Task(_,Q,U.name,U.source.label,V,U.problemMatchers);return U.isBackground!==void 0&&(J.isBackground=U.isBackground),U.group!==void 0&&(J.group=C.TaskGroup.from(U.group._id),J.group&&U.group.isDefault&&(J.group=new C.TaskGroup(J.group.id,J.group.label),U.group.isDefault===!0&&(J.group.isDefault=U.group.isDefault))),U.presentationOptions&&(J.presentationOptions=r.to(U.presentationOptions)),U._id&&(J._id=U._id),U.detail&&(J.detail=U.detail),J}N.to=z})(k=e.TaskDTO||(e.TaskDTO={}));var R;(function(N){function M(z){return z}N.from=M;function F(z){if(!!z)return Object.assign(Object.create(null),z)}N.to=F})(R||(R={}));class B{constructor(M,F,z){this._id=F,this.a=z,w.set(this,void 0),Je(this,w,M,"f")}get task(){return this.a}terminate(){Me(this,w,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}w=new WeakMap;let X=class{constructor(M,F,z,U,W,x,V,_){this.q=new I.Emitter,this.r=new I.Emitter,this.s=new I.Emitter,this.t=new I.Emitter,this.a=M.getProxy(A.MainContext.MainThreadTask),this.b=z,this.c=U,this.d=W,this.e=x,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=V,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,F,z){if(!z)return new C.Disposable(()=>{});const U=this.w();return this.j.set(U,{type:F,provider:z,extension:M}),this.a.$registerTaskProvider(U,F),new C.Disposable(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(M,F){this.a.$registerTaskSystem(M,F)}fetchTasks(M){return this.a.$fetchTasks(R.from(M)).then(async F=>{const z=[];for(const U of F){const W=await k.to(U,this.b,this.m);W&&z.push(W)}return z})}get taskExecutions(){const M=[];return this.k.forEach(F=>M.push(F)),M}terminateTask(M){if(!(M instanceof B))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,F,z){const U=this.m.get(M.id);U&&(this.o.set(M.id,U),this.e.attachPtyToTerminal(F,await U.callback(z))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const F=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const F=await this.y(M.id);this.s.fire({execution:F,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const F=await this.y(M.id);this.t.fire({execution:F,exitCode:M.exitCode})}$provideTasks(M,F){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));const U=[],W=(0,t.asPromise)(()=>z.provider.provideTasks(L.CancellationToken.None)).then(x=>this.u(F,U,z,x));return new Promise(x=>{W.then(V=>{Promise.all(U).then(()=>{x(V)})})})}async $resolveTask(M,F){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));if(F.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${z.type}].`);const U=await k.to(F,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const W=await z.provider.resolveTask(U,L.CancellationToken.None);if(!W)return;this.z(W,z);const x=k.from(W,z.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(x.execution)&&await this.x(x,W,!0),await this.v(x)}w(){return this.h++}async x(M,F,z){const U=await this.a.$createTaskId(M);!z&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,F.execution)),this.m.set(U,F.execution)}async y(M,F){if(typeof M=="string"){const W=this.l.get(M);if(!W)throw new g.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return W}const z=this.l.get(M.id);if(z)return z;const U=new Promise((W,x)=>{function V(_,Q,J){J?W(new B(_,Q.id,J)):x("Unexpected: Task does not exist.")}F?V(this,M,F):k.to(M.task,this.b,this.m).then(_=>V(this,M,_))});return this.l.set(M.id,U),U.then(W=>(this.k.set(M.id,W),W),W=>Promise.reject(W))}z(M,F){M._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const z=this.n.values();let U=z.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=z.next()}};X=qe([He(0,E.IExtHostRpcService),He(1,D.IExtHostInitDataService),He(2,T.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,y.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,h.ILogService),He(7,b.IExtHostApiDeprecationService)],X),e.ExtHostTaskBase=X;let q=class extends X{constructor(M,F,z,U,W,x,V,_){super(M,F,z,U,W,x,V,_),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:m.PlatformToString(0)})}async executeTask(M,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const z=k.from(F,M);if(z===void 0)throw new Error("Task is not valid");if(n.is(z.execution))await this.x(z,F,!1);else throw new g.NotSupportedError;const U=await this.y(await this.a.$getTaskExecution(z),F);return this.a.$executeTask(z).catch(W=>{throw new Error(W)}),U}u(M,F,z,U){const W=[];if(U)for(const x of U){this.z(x,z),(!x.definition||!M[x.definition.type])&&this.f.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const V=k.from(x,z.extension);V&&n.is(V.execution)?(W.push(V),F.push(this.x(V,x,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:z.extension}}async v(M){if(n.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,F,z){}};q=qe([He(0,E.IExtHostRpcService),He(1,D.IExtHostInitDataService),He(2,T.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,y.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,h.ILogService),He(7,b.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(Se[285],ye([1,0,9,21,51,37,24,44,31]),function(ne,e,c,t,I,A,C,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class y{constructor(E,D,v){this.k=E,this.l=D,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=E.filePattern,this.b=E.includePattern&&A.parse(E.includePattern),this.c=E.maxResults||void 0,this.d=E.exists,this.h=new Set,this.j=E.excludePattern&&A.parse(E.excludePattern)}cancel(){this.g=!0,this.h.forEach(E=>E.cancel()),this.h=new Set}search(E){const D=this.k.folderQueries||[];return new Promise((v,d)=>{const m=h=>{this.f++,E(h)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(h=>{const b=h.toString(),p=c.basename(b);this.j&&this.j(b,p)||this.v(m,{base:h,basename:p})}),Promise.all(D.map(h=>this.p(h,m))).then(h=>{v({limitHit:this.e,stats:h[0]||void 0})},h=>{d(new Error((0,I.toErrorMessage)(h)))})})}async p(E,D){const v=new t.CancellationTokenSource,d=this.q(E),m=this.r(),h=new S.QueryGlobTester(this.k,E),b=!h.hasSiblingExcludeClauses();let p;try{this.h.add(v),p=T.StopWatch.create();const g=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,v.token),w=p.elapsed(),s=T.StopWatch.create();return this.g&&!this.e||(g&&g.forEach(r=>{const l=c.posix.relative(E.folder.path,r.path);if(b){const u=c.basename(r.path);this.v(D,{base:E.folder,relativePath:l,basename:u});return}this.s(m,E.folder,l,D)}),this.g&&!this.e)?null:(this.u(m,h,D),{providerTime:w,postProcessTime:s.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(E){const D=(0,S.resolvePatternsForProvider)(this.k.includePattern,E.includePattern),v=(0,S.resolvePatternsForProvider)(this.k.excludePattern,E.excludePattern);return{folder:E.folder,excludes:v,includes:D,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}s({pathToEntries:E},D,v,d){if(v===this.a){const h=c.basename(this.a);this.v(d,{base:D,relativePath:this.a,basename:h})}function m(h){const b=c.basename(h),p=c.dirname(h);let g=E[p];g||(g=E[p]=[],m(p)),g.push({base:D,relativePath:h,basename:b})}m(v)}u({rootEntries:E,pathToEntries:D},v,d){const m=this,h=this.a;function b(p){const g=(0,S.hasSiblingFn)(()=>p.map(w=>w.basename));for(let w=0,s=p.length;w<s;w++){const r=p[w],{relativePath:l,basename:u}=r;if(v.matchesExcludesSync(l,u,h!==u?g:void 0))continue;const o=D[l];if(o)b(o);else{if(l===h)continue;m.v(d,r)}if(m.e)break}}b(E)}v(E,D){(!this.b||D.relativePath&&this.b(D.relativePath,D.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||E(D))}}class L{constructor(){this.b=new Map}fileSearch(E,D,v,d){const m=this.c(E.cacheKey),h=new y(E,D,m&&m.token);let b=0;const p=g=>{b+=g.length,v(g.map(w=>this.d(w)))};return this.e(h,L.a,p,d).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:g.stats}}))}clearCache(E){this.c(E)?.cancel()}c(E){if(!!E)return this.b.has(E)||this.b.set(E,new t.CancellationTokenSource),this.b.get(E)}d(E){return E.relativePath?{resource:C.joinPath(E.base,E.relativePath)}:{resource:E.base}}e(E,D,v,d){d.onCancellationRequested(()=>{E.cancel()});const m=b=>{b&&(h.push(b),D>0&&h.length>=D&&(v(h),h=[]))};let h=[];return E.search(m).then(b=>(h.length&&v(h),b),b=>(h.length&&v(h),Promise.reject(b)))}}e.FileSearchManager=L,L.a=512}),define(Se[286],ye([1,0,17,80,37,111,28,15,9,24,8,11,2,163,190,52,13,46,133,284,31]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(f,k,R,B,X){this.a=f,this.b=k,this.c=R,this.d=B,this.e=X}text(f,k,R={}){f=this.f(f,R);const B=this.a.getValue(),X=k&&k.some(N=>!this.a.getValue({resource:N}).search.useRipgrep);return{...this.h(k?.map(h.toWorkspaceFolder),R),type:2,contentPattern:f,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:B.search.usePCRE2||X||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(f,k){const R=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const B={...f,wordSeparators:R.editor.wordSeparators};return this.j(f,k)&&(B.isCaseSensitive=!0),this.k(f)&&(B.isMultiline=!0),B}file(f,k={}){return{...this.h(f,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(f,k){return f?(f=Array.isArray(f)?f.map(o):o(f),k?this.parseSearchPaths(f):{pattern:r(...Array.isArray(f)?f:[f])}):{}}h(f=[],k={}){const R=this.g(k.includePattern,k.expandPatterns),B=this.g(k.excludePattern,k.expandPatterns),X=f.length>1,q=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(F=>this.q(F,k,B)):f.map(F=>this.r(F,k,B,X))).filter(F=>!!F),N={_reason:k._reason,folderQueries:q,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:B.pattern,includePattern:R.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const F=c.coalesce(c.flatten(this.c.groups.map(W=>W.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const z=F.filter(W=>(0,g.pathIncludedInQuery)(N,W.fsPath)),U=this.i(z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(U)),{...N,...U}}const M=k.extraFileResources&&k.extraFileResources.filter(F=>(0,g.pathIncludedInQuery)(N,F.fsPath));return N.extraFileResources=M&&M.length?M:void 0,N}i(f){const k=[],R=new C.ResourceMap,B={};let X=!1;return f.forEach(q=>{if(q.scheme===T.Schemas.walkThrough)return;if((0,y.isAbsolutePath)(q)){const M=this.b.getWorkspaceFolder(q)?.uri??q.with({path:S.dirname(q.fsPath)});let F=R.get(M);F||(X=!0,F={folder:M,includePattern:{}},k.push(F),R.set(M,F));const z=S.relative(M.fsPath,q.fsPath);(0,P.assertIsDefined)(F.includePattern)[z.replace(/\\/g,"/")]=!0}else q.fsPath&&(X=!0,B[q.fsPath]=!0)}),{folderQueries:k,includePattern:B,usingSearchPaths:!0,excludePattern:X?void 0:{"**/*":!0}}}j(f,k){if(k.isSmartCase){if(f.isRegExp){if(L.containsUppercaseCharacter(f.pattern,!0))return!0}else if(L.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,D.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const k=U=>S.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),B=(Array.isArray(f)?f:l(f)).map(U=>{const W=this.e.resolvedUserHome;return W?(0,A.untildify)(U,W.scheme===T.Schemas.file?W.fsPath:W.path):U}),X=t.groupBy(B,U=>k(U)?"searchPaths":"exprSegments"),q=(X.exprSegments||[]).map(U=>L.rtrim(U,"/")).map(U=>L.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),u(U))),N={},M=this.m(X.searchPaths||[]);M&&M.length&&(N.searchPaths=M);const F=c.flatten(q),z=r(...F);return z&&(N.pattern=z),N}l(f,k){return k.disregardExcludeSettings?void 0:(0,g.getExcludes)(f,!k.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const k=c.flatten(f.map(B=>{let{pathPortion:X,globPortion:q}=s(B);q&&(q=a(q));const N=this.n(X);return c.flatten(N.map(M=>this.o(M,q)))})),R=new Map;return k.forEach(B=>{const X=B.searchPath.toString(),q=R.get(X);q?B.pattern&&(q.pattern=q.pattern||{},q.pattern[B.pattern]=!0):R.set(X,{searchPath:B.searchPath,pattern:B.pattern?r(B.pattern):void 0})}),Array.from(R.values())}n(f){if(S.isAbsolute(f)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==T.Schemas.file?[{searchPath:k[0].uri.with({path:f})}]:[{searchPath:E.URI.file(S.normalize(f))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(f=o(f),f.startsWith("../")||f===".."){const B=S.posix.resolve(k.path,f);return[{searchPath:k.with({path:B})}]}const R=a(f);return[{searchPath:k,pattern:R}]}else{if(f==="./"||f===".\\")return[];{const k=f.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(X=>{const q=k.match(new RegExp(`^${L.escapeRegExpCharacters(X.name)}(?:/(.*)|$)`));return q?{match:q,folder:X}:null}).filter(P.isDefined);if(B.length)return B.map(X=>{const q=X.match[1];return{searchPath:X.folder.uri,pattern:q&&a(q)}});{const X=f.match(/\.[\/\\](.+)[\/\\]?/),q=X?X[1]:f,N=v.localize(0,null,q);throw new Error(N)}}}}o(f,k){const R=f.pattern&&k?`${f.pattern}/${k}`:f.pattern||k,B=[{searchPath:f.searchPath,pattern:R}];return R&&!R.endsWith("**")&&B.push({searchPath:f.searchPath,pattern:R+"/**"}),B}q(f,k,R){const B=this.r((0,h.toWorkspaceFolder)(f.searchPath),k,R,!1);return B?{...B,includePattern:f.pattern}:null}r(f,k,R,B){let X;const q=E.URI.isUri(f)?f:f.uri;if(R.searchPaths){const U=R.searchPaths.filter(W=>(0,y.isEqual)(W.searchPath,q))[0];if(U&&!U.pattern)return null;U&&(X=U.pattern)}const N=this.a.getValue({resource:q}),F={...this.l(N,k)||{},...X||{}},z=E.URI.isUri(f)?(0,y.basename)(f):f.name;return{folder:q,folderName:B?z:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!N.search.followSymlinks}}};w=qe([He(0,d.IConfigurationService),He(1,h.IWorkspaceContextService),He(2,b.IEditorGroupsService),He(3,m.ILogService),He(4,p.IPathService)],w),e.QueryBuilder=w;function s(i){const f=i.match(/[\*\{\}\(\)\[\]\?]/);if(f){const k=f.index,R=i.substr(0,k).match(/[/|\\][^/\\]*$/);if(R){let B=i.substr(0,R.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:i.substr((R.index||0)+1)}}}return{pathPortion:i}}function r(...i){return i.length?i.reduce((f,k)=>(f[k]=!0,f),Object.create(null)):void 0}function l(i){return I.splitGlobAware(i,",").map(f=>f.trim()).filter(f=>!!f.length)}function u(i){return[`**/${i}/**`,`**/${i}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function o(i){return i.replace(/\\/g,"/")}function a(i){return o(i).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(i,f){i=c.distinct(i,B=>B.toString());const k=[],R=f.getWorkspace();return i&&i.forEach(B=>{let X;if(f.getWorkbenchState()===2)X=(0,y.relativePath)(R.folders[0].uri,B),X&&X!=="."&&(X="./"+X);else{const q=f.getWorkspaceFolder(B);if(q){const N=q.name;if(R.folders.filter(F=>F.name===N).length===1){const F=(0,y.relativePath)(q.uri,B);F===""?X=`./${q.name}`:X=`./${q.name}/${F}`}else X=B.fsPath}}X&&k.push(X)}),k}e.resolveResourcesForSearchIncludes=n}),define(Se[287],ye([1,0,24,2,21,10,3,286,31,46]),function(ne,e,c,t,I,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function P(d,m){const h=m.activationEvents;if(!h)return Promise.resolve(void 0);const b=[],p=[];for(const u of h)if(/^workspaceContains:/.test(u)){const o=u.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||d.forceUsingSearch?p.push(o):b.push(o)}if(b.length===0&&p.length===0)return Promise.resolve(void 0);let g;const w=new Promise((u,o)=>{g=u}),s=u=>g({activationEvent:u}),r=Promise.all(b.map(u=>E(d,u,s))).then(()=>{}),l=D(d,m.identifier,p,s);return Promise.all([r,l]).then(()=>{g(void 0)}),w}e.checkActivateWorkspaceContainsExtension=P;async function E(d,m,h){for(const b of d.folders)if(await d.exists(c.joinPath(t.URI.revive(b),m))){h(`workspaceContains:${m}`);return}}async function D(d,m,h,b){if(h.length===0)return Promise.resolve(void 0);const p=new I.CancellationTokenSource,g=d.checkExists(d.folders,h,p.token),w=setTimeout(async()=>{p.cancel(),d.logService.info(`Not activating extension '${m.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},L);let s=!1;try{s=await g}catch(r){A.isCancellationError(r)||A.onUnexpectedError(r)}p.dispose(),clearTimeout(w),s&&b(`workspaceContains:${h.join(",")}`)}function v(d,m,h,b){const p=d.get(C.IInstantiationService),g=d.get(S.ISearchService),s=p.createInstance(T.QueryBuilder).file(m.map(r=>(0,y.toWorkspaceFolder)(t.URI.revive(r))),{_reason:"checkExists",includePattern:h,exists:!0});return g.fileSearch(s,b).then(r=>!!r.limitHit,r=>A.isCancellationError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=v});var Je=this&&this.__classPrivateFieldSet||function(ne,e,c,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,c):I?I.value=c:e.set(ne,c),c},Me=this&&this.__classPrivateFieldGet||function(ne,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[41],ye([1,0,174,9,76,24,18,6,64,2,13,5,34,229,97,33,26,134,10,27,22,211,7,127,3,25,72,16,88,54,40,4,287,96,213,15,95]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b,p,g,w,s,r,l,u,o,a,n,i,f,k,R,B,X,q,N){"use strict";var M,F,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let U=class Mn extends T.Disposable{constructor(te,le,Z,ge,ve,De,Re,ze,se,ue,he){super(),this.a=this.B(new k.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=le,this.g=Z,this.f=Re,this.j=ge,this.k=ve,this.l=De,this.m=se,this.p=ue,this.s=he,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.z=new C.Barrier,this.C=new C.Barrier,this.F=new h.ExtensionDescriptionRegistry(this.f.allExtensions);const ee=(0,m.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new h.ExtensionDescriptionRegistry(V(this.F,ee)),this.G=new v.ExtHostStorage(this.g,this.l),this.H=new B.ExtHostSecretState(this.g),this.I=ze,this.h=te.createChild(new n.ServiceCollection([v.IExtHostStorage,this.G],[B.IExtHostSecretState,this.H])),this.J=this.B(new D.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(oe,ie,O)=>{this.v.$onExtensionActivationError(oe,b.transformErrorForSerialization(ie),O)},actualActivateExtension:async(oe,ie)=>{if(h.ExtensionDescriptionRegistry.isHostExtension(oe,this.D,this.F))return await this.v.$activateExtension(oe,ie),new D.HostExtension;const O=this.D.getExtensionDescription(oe);return this.Y(O,ie)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(te){b.onUnexpectedError(te)}}async Q(){this.I.onWillDeactivateAll();let te=[];try{te=this.D.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.X(ve))}catch{}await Promise.all(te)}terminate(te,le=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${te}`),this.l.flush(),this.p.dispose(),this.J.dispose(),b.setUnexpectedErrorHandler(ge=>{this.l.error(ge)}),this.g.dispose();const Z=this.Q();Promise.race([(0,C.timeout)(5e3),Z]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${le}`):this.l.info(`Extension host exiting with code ${le}`),this.l.flush(),this.l.dispose(),this.c.exit(le)})}isActivated(te){return this.z.isOpen()?this.J.isActivated(te):!1}async getExtension(te){const le=await this.v.$getExtension(te);let Z;if(le?.browserNlsBundleUris){Z={};for(const ge of Object.keys(le.browserNlsBundleUris))Z[ge]=y.URI.revive(le.browserNlsBundleUris[ge])}return le&&{...le,identifier:new p.ExtensionIdentifier(le.identifier.value),extensionLocation:y.URI.revive(le.extensionLocation),browserNlsBundleUris:Z}}R(te,le){return this.J.activateByEvent(te,le)}S(te,le){return this.J.activateById(te,le)}activateByIdWithErrors(te,le){return this.S(te,le).then(()=>{const Z=this.J.getActivatedExtension(te);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(te=>this.D)}getExtensionExports(te){return this.z.isOpen()?this.J.getActivatedExtension(te).exports:null}async U(te){if(te.scheme!==q.Schemas.file)return te;const le=await this.c.realpath(te.fsPath);return y.URI.file(le)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(te=>new Q(te))),this.L}async W(te){const le=S.TernarySearchTree.forUris(Z=>A.extUriBiasedIgnorePathCase.ignorePathCasing(Z));return await Promise.all(te.map(async Z=>{if(this.ob(Z)){const ge=await this.U(Z.extensionLocation);le.set(ge,Z)}})),le}X(te){let le=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(te))return le;const Z=this.J.getActivatedExtension(te);if(!Z)return le;try{typeof Z.module.deactivate=="function"&&(le=Promise.resolve(Z.module.deactivate()).then(void 0,ge=>(this.l.error(ge),Promise.resolve(void 0))))}catch(ge){this.l.error(`An error occurred when deactivating the extension '${te.value}':`),this.l.error(ge)}try{(0,T.dispose)(Z.subscriptions)}catch(ge){this.l.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this.l.error(ge)}return le}async Y(te,le){return this.f.remote.isRemote?this.v.$onWillActivateExtension(te.identifier):await this.v.$onWillActivateExtension(te.identifier),this.ab(te,le).then(Z=>{const ge=Z.activationTimes;return this.v.$onDidActivateExtension(te.identifier,ge.codeLoadingTime,ge.activateCallTime,ge.activateResolvedTime,le),this.Z(te,le,"success",ge),Z},Z=>{throw this.Z(te,le,"failure"),Z})}Z(te,le,Z,ge){const ve=W(te,le);this.u.$publicLog2("extensionActivationTimes",{...ve,...ge||{},outcome:Z})}ab(te,le){const Z=W(te,le);this.u.$publicLog2("activatePlugin",Z);const ge=this.ob(te);if(!ge)return Promise.resolve(new D.EmptyExtension(D.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${te.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this.l.flush();const ve=new D.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this.pb(te,(0,A.joinPath)(te.extensionLocation,ge),ve),this.bb(te)]).then(De=>(I.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Mn.cb(this.l,te.identifier,De[0],De[1],ve))).then(De=>(I.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),De))}bb(te){const le=new w.ExtensionGlobalMemento(te,this.G),Z=new w.ExtensionMemento(te.identifier.value,!1,this.G),ge=new X.ExtensionSecrets(te,this.H),ve=te.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,De=this.f.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([le.whenReady,Z.whenReady,this.I.whenReady]).then(()=>{const Re=this;let ze,se;const ue=(0,m.isProposedApiEnabled)(te,"ipc")?this.f.messagePorts?.get(p.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:le,workspaceState:Z,secrets:ge,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(he){return t.join(te.extensionLocation.fsPath,he)},get storagePath(){return Re.I.workspaceValue(te)?.fsPath},get globalStoragePath(){return Re.I.globalValue(te).fsPath},get logPath(){return t.join(Re.f.logsLocation.fsPath,te.identifier.value)},get logUri(){return y.URI.joinPath(Re.f.logsLocation,te.identifier.value)},get storageUri(){return Re.I.workspaceValue(te)},get globalStorageUri(){return Re.I.globalValue(te)},get extensionMode(){return ve},get extension(){return ze===void 0&&(ze=new x(Re,te.identifier,te,De,!1)),ze},get extensionRuntime(){return(0,m.checkProposedApiEnabled)(te,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re.p.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!se){if(!ue)return;const he=k.Event.buffer(k.Event.fromDOMEventEmitter(ue,"message",ee=>ee.data));ue.start(),se={onDidReceiveMessage:he,postMessage:ue.postMessage.bind(ue)}}return se}})})}static cb(te,le,Z,ge,ve){return Z=Z||{activate:void 0,deactivate:void 0},this.db(te,le,Z,ge,ve).then(De=>new D.ActivatedExtension(!1,null,ve.build(),Z,De,ge.subscriptions))}static db(te,le,Z,ge,ve){if(typeof Z.activate=="function")try{ve.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${le.value}`);const De=typeof global=="object"?global:self,Re=Z.activate.apply(De,[ge]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Re).then(ze=>(ve.activateResolveStop(),ze))}catch(De){return Promise.reject(De)}else return Promise.resolve(Z)}eb(te,le){this.S(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:le}).then(void 0,Z=>{this.l.error(Z)})}fb(){this.v.$setPerformanceMarks(I.getMarks());for(const te of this.D.getAllExtensionDescriptions())if(te.activationEvents)for(const le of te.activationEvents)le==="onStartupFinished"&&this.eb(te,le)}gb(){const te=this.R("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.hb(ve.added)));const le=this.j.workspace?this.j.workspace.folders:[],Z=this.hb(le),ge=Promise.all([te,Z]).then(()=>{});return Promise.race([ge,(0,C.timeout)(1e4)]).then(()=>{this.fb()}),ge}hb(te){return te.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(le=>this.ib(te,le))).then(()=>{})}async ib(te,le){if(this.isActivated(le.identifier))return;const Z=!this.f.remote.isRemote&&!!this.f.remote.authority,ge={logService:this.l,folders:te.map(De=>De.uri),forceUsingSearch:Z,exists:De=>this.c.exists(De.fsPath),checkExists:(De,Re,ze)=>this.t.$checkExists(De,Re,ze)},ve=await(0,R.checkActivateWorkspaceContainsExtension)(ge,le);if(!!ve)return this.S(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:ve.activationEvent}).then(void 0,De=>this.l.error(De))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(te){throw console.error(te),te}}async jb(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:le}=this.f.environment;if(!te||!le)throw new Error(c.localize(0,null));const Z=await this.pb(null,le,new D.ExtensionActivationTimesBuilder(!1));if(!Z||typeof Z.run!="function")throw new Error(c.localize(1,null,le.toString()));return new Promise((ge,ve)=>{const De=(se,ue)=>{se?ve(se):ge(typeof ue=="number"&&ue>0?1:0)},Re=(0,A.originalFSPath)(le),ze=Z.run(Re,De);ze&&ze.then&&ze.then(()=>{ge(0)}).catch(se=>{ve(se instanceof Error&&se.stack?se.stack:String(se))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,le){return this.M[te]=le,(0,T.toDisposable)(()=>{delete this.M[te]})}async lb(te){const le=te.indexOf("+");if(le===-1)throw new Error("Not an authority that can be resolved!");const Z=te.substr(0,le);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this.M[Z]}}async $resolveAuthority(te,le){this.l.info(`$resolveAuthority invoked for authority (${_(te)})`);const{authorityPrefix:Z,resolver:ge}=await this.lb(te);if(!ge)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Z}.`,detail:void 0}};try{this.B(await this.m.setTunnelFactory(ge)),I.mark(`code/extHost/willResolveAuthority/${Z}`);const ve=await ge.resolve(te,{resolveAttempt:le});I.mark(`code/extHost/didResolveAuthorityOK/${Z}`);const De={authority:te,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Re={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:De,options:Re,tunnelInformation:{environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures}}}}catch(ve){if(I.mark(`code/extHost/didResolveAuthorityError/${Z}`),ve instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}async $getCanonicalURI(te,le){this.l.info(`$getCanonicalURI invoked for authority (${_(te)})`);const{resolver:Z}=await this.lb(te);if(!Z)return null;const ge=y.URI.revive(le);if(typeof Z.getCanonicalURI>"u")return ge;const ve=await(0,C.asPromise)(()=>Z.getCanonicalURI(ge));return ve||ge}static mb(te,le,Z){const ge=new h.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ge.deltaExtensions(Z.toAdd,Z.toRemove);const ve=(0,m.extensionIdentifiersArrayToSet)(le.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Z.myToRemove)ve.delete(p.ExtensionIdentifier.toKey(Re));for(const Re of Z.myToAdd)ve.add(p.ExtensionIdentifier.toKey(Re));const De=V(ge,ve);return{globalRegistry:ge,myExtensions:De}}$startExtensionHost(te){te.toAdd.forEach(ge=>ge.extensionLocation=y.URI.revive(ge.extensionLocation));const{globalRegistry:le,myExtensions:Z}=Mn.mb(this.F,this.D,te);return this.F.set(le.getAllExtensionDescriptions()),this.D.set(Z),this.kb()}$activateByEvent(te,le){return le===1?this.R(te,!1):this.z.wait().then(Z=>this.R(te,!1))}async $activate(te,le){return await this.z.wait(),this.D.getExtensionDescription(te)?(await this.S(te,le),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(De=>De.extensionLocation=y.URI.revive(De.extensionLocation));const{globalRegistry:le,myExtensions:Z}=Mn.mb(this.F,this.D,te),ge=await this.W(Z);return(await this.getExtensionPathIndex()).setSearchTree(ge),this.F.set(le.getAllExtensionDescriptions()),this.D.set(Z),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const le=g.VSBuffer.alloc(te),Z=Math.random()%256;for(let ge=0;ge<te;ge++)le.writeUInt8(Z,ge);return le}async $updateRemoteConnectionData(te){this.P=te,this.a.fire()}};U=qe([He(0,l.IInstantiationService),He(1,e.IHostUtils),He(2,a.IExtHostRpcService),He(3,d.IExtHostWorkspace),He(4,E.IExtHostConfiguration),He(5,L.ILogService),He(6,u.IExtHostInitDataService),He(7,o.IExtensionStoragePaths),He(8,i.IExtHostTunnelService),He(9,f.IExtHostTerminalService),He(10,N.IExtHostLocalizationService)],U),e.AbstractExtHostExtensionService=U;function W(J,te){return{id:J.identifier.value,name:J.name,extensionVersion:J.version,publisherDisplayName:J.publisher,activationEvents:J.activationEvents?J.activationEvents.join(","):null,isBuiltin:J.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class x{constructor(te,le,Z,ge,ve){M.set(this,void 0),F.set(this,void 0),z.set(this,void 0),Je(this,M,te,"f"),Je(this,F,le,"f"),Je(this,z,Z.identifier,"f"),this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=t.normalize((0,A.originalFSPath)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=ge,this.isFromDifferentExtensionHost=ve}get isActive(){return Me(this,M,"f").isActivated(Me(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Me(this,M,"f").getExtensionExports(Me(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Me(this,M,"f").activateByIdWithErrors(Me(this,z,"f"),{startup:!1,extensionId:Me(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=x,M=new WeakMap,F=new WeakMap,z=new WeakMap;function V(J,te){return J.getAllExtensionDescriptions().filter(le=>te.has(p.ExtensionIdentifier.toKey(le.identifier)))}function _(J){const te=J.indexOf("+");return te===-1?J:J.substring(0,te)}class Q{constructor(te){this.a=te}setSearchTree(te){this.a=te}findSubstr(te){return this.a.findSubstr(te)}forEach(te){return this.a.forEach(te)}}e.ExtensionPaths=Q}),define(Se[288],ye([1,0,76,2,5,34,26,27,16,25,3,41,36,13,8]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(w,s,r,l,u,o,a){this.c=w,this.d=s,this.e=r,this.f=l,this.g=u,this.h=o,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),c.mark("code/extHost/willWaitForConfig");const w=await this.f.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new h(this.c,s,this.d,w,this.i)),this.register(this.e.createInstance(b,s)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(p,s,this.h.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const s of w.nodeModuleName)this.a.set(s,w);else this.a.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this.b.push(s=>w.alternativeModuleName(s))}};d=qe([He(2,L.IInstantiationService),He(3,A.IExtHostConfiguration),He(4,P.IExtHostExtensionService),He(5,y.IExtHostInitDataService),He(6,D.ILogService)],d),e.RequireInterceptor=d;let m=class ti{constructor(w){if(w.environment.appRoot&&ti.a.size){const s=(0,v.escapeRegExpCharacters)(this.c(w.environment.appRoot.fsPath)),r="[a-z0-9_.-]",l=`@${r}+\\/${r}+|${r}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${u}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(w){if(!this.b)return;const s=this.b.exec(this.c(w));if(!s)return;const[,r,l,u]=s,o=ti.a.get(l);if(o!==void 0)return console.warn(`${l} as been renamed to ${o}, please update your imports`),r+o+u}c(w){return w.replace(/\\/g,"/")}};m.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),m=qe([He(0,y.IExtHostInitDataService)],m);class h{constructor(w,s,r,l,u){this.c=w,this.d=s,this.e=r,this.f=l,this.g=u,this.nodeModuleName="vscode",this.a=new Map}load(w,s){const r=this.d.findSubstr(s);if(r){let l=this.a.get(T.ExtensionIdentifier.toKey(r.identifier));return l||(l=this.c(r,this.e,this.f),this.a.set(T.ExtensionIdentifier.toKey(r.identifier),l)),l}if(!this.b){let l="";this.d.forEach((u,o)=>l+=`	${o} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${l}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let b=class{constructor(w,s,r){this.d=w,this.nodeModuleName="keytar",this.a=s.getProxy(I.MainContext.MainThreadTelemetry);const{environment:l}=r,u=s.getProxy(I.MainContext.MainThreadKeytar);if(l.appRoot){let o=l.appRoot.fsPath;E.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.b=new Set,this.b.add(`${o}/node_modules.asar/keytar`),this.b.add(`${o}/node_modules/keytar`)}this.c={getPassword:(o,a)=>u.$getPassword(o,a),setPassword:(o,a,n)=>u.$setPassword(o,a,n),deletePassword:(o,a)=>u.$deletePassword(o,a),findPassword:o=>u.$findPassword(o),findCredentials(o){return u.$findCredentials(o)}}}load(w,s){const r=this.d.findSubstr(s);return this.a.$publicLog2("shimming.keytar",{extension:r?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(w){const s=w.length;if(s<=7||!this.b)return;const r=s-7;if((w.charAt(r)==="/"||w.charAt(r)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.b.has(w)))return"keytar"}};b=qe([He(1,S.IExtHostRpcService),He(2,y.IExtHostInitDataService)],b);let p=class{constructor(w,s,r){this.e=w,this.f=s,this.nodeModuleName=["open","opn"],this.d=r.getProxy(I.MainContext.MainThreadTelemetry);const l=r.getProxy(I.MainContext.MainThreadWindow);this.c=(u,o)=>{const a=t.URI.parse(u);return o?this.g(u,o):a.scheme==="http"||a.scheme==="https"?l.$openUri(a,u,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?l.$openUri(a,u,{}):this.g(u,o)}}load(w,s,r){const l=this.e.findSubstr(s);return l&&(this.a=l.identifier.value,this.h()),this.b=r(w),this.c}g(w,s){return this.i(),this.b(w,s)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};p=qe([He(2,S.IExtHostRpcService)],p)}),define(Se[48],ye([1,0,81,6,9,36,3,58,59,41,7,33,225,34]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class v extends E.AbstractVariableResolverService{constructor(h,b,p,g,w,s,r){function l(){if(p){const u=p.activeEditor();if(u)return u.document.uri;const o=g.tabGroups.all.find(a=>a.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof L.TextDiffTabInput||o.input instanceof L.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof L.TextTabInput||o.input instanceof L.NotebookEditorTabInput||o.input instanceof L.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:u=>{const o=s.folders.filter(a=>a.name===u);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(u,o)=>w.getConfiguration(void 0,u).get(o),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=l();if(u)return I.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const u=l();if(u){const o=b.getWorkspaceFolder(u);if(o)return I.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(p){const u=p.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(p){const u=p.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>h.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(A.env))}}let d=class extends t.Disposable{constructor(h,b,p,g,w){super(),this.b=h,this.c=b,this.g=p,this.h=g,this.i=w,this.a=new c.Lazy(async()=>{const s=await this.h.getConfigProvider(),l={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{l.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.i,s,l,this.j())})}getResolver(){return this.a.getValue()}j(){}};d=qe([He(0,y.IExtHostExtensionService),He(1,P.IExtHostWorkspace),He(2,T.IExtHostDocumentsAndEditors),He(3,D.IExtHostConfiguration),He(4,S.IExtHostEditorTabs)],d),e.ExtHostVariableResolverProviderService=d}),define(Se[77],ye([1,0,18,4,11,2,3,5,59,41,16,7,33,131,217,34,48]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(l,u,o,a,n,i){this.D=u,this.E=o,this.F=a,this.G=n,this.H=i,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new t.Emitter,this.n=new t.Emitter,this.o=new t.Emitter,this.u=new t.Emitter,this.k=l.getProxy(T.MainContext.MainThreadDebugService),this.z=new t.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new p(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(f=>{f.onDidChange(k=>{this.I(f)}),this.I(f)})}asDebugSourceUri(l,u){const o=l;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let a=`debug:${encodeURIComponent(o.path||"")}`,n="?";return u&&(a+=`${n}session=${encodeURIComponent(u.id)}`,n="&"),a+=`${n}ref=${o.sourceReference}`,A.URI.parse(a)}else{if(o.path)return A.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(l){const u=[];for(const o of l.getAllExtensionDescriptions())if(o.contributes){const a=o.contributes.debuggers;if(a&&a.length>0)for(const n of a)(0,v.isDebuggerMainContribution)(n)&&u.push(n.type)}this.k.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const l=[];return this.w.forEach(u=>l.push(u)),l}addBreakpoints(l){this.T();const u=l.filter(n=>{const i=n.id;return this.w.has(i)?!1:(this.w.set(i,n),!0)});this.U(u,[],[]);const o=[],a=new Map;for(const n of u)if(n instanceof P.SourceBreakpoint){let i=a.get(n.location.uri.toString());i||(i={type:"sourceMulti",uri:n.location.uri,lines:[]},a.set(n.location.uri.toString(),i),o.push(i)),i.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof P.FunctionBreakpoint&&o.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(l){this.T();const u=l.filter(i=>this.w.delete(i.id));this.U([],u,[]);const o=u.filter(i=>i instanceof P.SourceBreakpoint).map(i=>i.id),a=u.filter(i=>i instanceof P.FunctionBreakpoint).map(i=>i.id),n=u.filter(i=>i instanceof P.DataBreakpoint).map(i=>i.id);return this.k.$unregisterBreakpoints(o,a,n)}startDebugging(l,u,o){return this.k.$startDebugging(l?l.uri:void 0,u,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(l){return this.k.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,u,o){if(!u)return new P.Disposable(()=>{});const a=this.d++;return this.f.push({type:l,handle:a,provider:u}),this.k.$registerDebugConfigurationProvider(l,o,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,a),new P.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==u),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(l,u,o){if(!o)return new P.Disposable(()=>{});if(!this.P(l,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.M(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:u,handle:a,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(u,a),new P.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(l,u){if(!u)return new P.Disposable(()=>{});const o=this.i++;return this.j.push({type:l,handle:o,factory:u}),new P.Disposable(()=>{this.j=this.j.filter(a=>a.factory!==u)})}async $runInTerminal(l,u){return Promise.resolve(void 0)}async $substituteVariables(l,u){let o;const a=await this.W(l);return a&&(o={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(o,u)}J(l,u){if(l.type==="implementation")return new w(l.implementation)}K(){}async $startDASession(l,u){const o=this,a=await this.V(u);return this.R(this.M(a.type),a).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const i=this.L(n),f=this.J(i,a);if(!f)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const k=f;return this.A.set(l,k),this.Q(a).then(R=>(R&&this.B.set(l,R),k.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const X=B,q={type:"response",seq:0,command:X.command,request_seq:X.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const N=await this.C.sign(X.arguments.value);q.body={signature:N},k.sendResponse(q)}else throw new Error("no signer")}catch(N){q.success=!1,q.message=N.message,k.sendResponse(q)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(B),B=(0,v.convertToVSCPaths)(B,!0),o.k.$acceptDAMessage(l,B)}),k.onError(B=>{R&&R.onError&&R.onError(B),this.k.$acceptDAError(l,B.name,B.message,B.stack)}),k.onExit(B=>{R&&R.onExit&&R.onExit((0,I.withNullAsUndefined)(B),void 0),this.k.$acceptDAExit(l,(0,I.withNullAsUndefined)(B),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),k.startSession()))})}$sendDAMessage(l,u){u=(0,v.convertToDAPaths)(u,!1);const o=this.B.get(l);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(u),this.A.get(l)?.sendMessage(u)}$stopDASession(l){const u=this.B.get(l);this.B.delete(l),u&&u.onWillStopSession&&u.onWillStopSession();const o=this.A.get(l);return this.A.delete(l),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const u=[],o=[],a=[];if(l.added)for(const n of l.added){const i=n.id;if(i&&!this.w.has(i)){let f;if(n.type==="function")f=new P.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")f=new P.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const k=A.URI.revive(n.uri);f=new P.SourceBreakpoint(new P.Location(k,new P.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}f._id=i,this.w.set(i,f),u.push(f)}}if(l.removed)for(const n of l.removed){const i=this.w.get(n);i&&(this.w.delete(n),o.push(i))}if(l.changed){for(const n of l.changed)if(n.id){const i=this.w.get(n.id);if(i){if(i instanceof P.FunctionBreakpoint&&n.type==="function"){const f=i;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.functionName=n.functionName}else if(i instanceof P.SourceBreakpoint&&n.type==="source"){const f=i;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.location=new P.Location(A.URI.revive(n.uri),new P.Position(n.line,n.character))}a.push(i)}}}this.U(u,o,a)}$provideDebugConfigurations(l,u,o){return(0,c.asPromise)(async()=>{const a=this.O(l);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(u);return a.provideDebugConfigurations(n,o)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(l,u,o,a){return(0,c.asPromise)(async()=>{const n=this.O(l);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const i=await this.W(u);return n.resolveDebugConfiguration(i,o,a)})}$resolveDebugConfigurationWithSubstitutedVariables(l,u,o,a){return(0,c.asPromise)(async()=>{const n=this.O(l);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const i=await this.W(u);return n.resolveDebugConfigurationWithSubstitutedVariables(i,o,a)})}async $provideDebugAdapter(l,u){const o=this.N(l);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(u);return this.R(o,a).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(l){const u=await this.V(l);this.m.fire(u)}async $acceptDebugSessionTerminated(l){const u=await this.V(l);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(l){this.q=l?await this.V(l):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(l,u){(await this.V(l))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(l,u){const a={session:await this.V(l),event:u.event,body:u.body};this.u.fire(a)}L(l){if(l instanceof P.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof P.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}M(l){const u=this.h.filter(o=>o.type===l);if(u.length>0)return u[0].factory}N(l){const u=this.h.filter(o=>o.handle===l);if(u.length>0)return u[0].factory}O(l){const u=this.f.filter(o=>o.handle===l);if(u.length>0)return u[0].provider}P(l,u){if(l.contributes){const o=l.contributes.debuggers;if(o&&o.length>0){for(const a of o)if(a.label&&a.type&&a.type===u)return!0}}return!1}Q(l){const o=l.configuration.type,a=this.j.filter(n=>n.type===o||n.type==="*").map(n=>(0,c.asPromise)(()=>n.factory.createDebugAdapterTracker(l)).then(i=>i,i=>null));return Promise.race([Promise.all(a).then(n=>{const i=n.filter(f=>!!f);if(i.length>0)return new g(i)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(l,u){const o=u.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new P.DebugAdapterServer(o));if(l){const n=await this.E.getExtensionRegistry();return(0,c.asPromise)(()=>l.createDebugAdapterDescriptor(u,this.S(u,n))).then(i=>{if(i)return i})}const a=await this.E.getExtensionRegistry();return Promise.resolve(this.S(u,a))}S(l,u){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(l,u,o){(l.length>0||u.length>0||o.length>0)&&this.z.fire(Object.freeze({added:l,removed:u,changed:o}))}async V(l){if(l)if(typeof l=="string"){const u=this.l.get(l);if(u)return u}else{let u=this.l.get(l.id);if(!u){const o=await this.W(l.folderUri),a=l.parent?this.l.get(l.parent):void 0;u=new b(this.k,l.id,l.type,l.name,o,l.configuration,a),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(l){if(l){const u=A.URI.revive(l);return this.D.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};h=qe([He(0,L.IExtHostRpcService),He(1,E.IExtHostWorkspace),He(2,y.IExtHostExtensionService),He(3,d.IExtHostConfiguration),He(4,S.IExtHostEditorTabs),He(5,m.IExtHostVariableResolverProvider)],h),e.ExtHostDebugServiceBase=h;class b{constructor(l,u,o,a,n,i,f){this.d=l,this.f=u,this.g=o,this.h=a,this.i=n,this.j=i,this.k=f}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(l){this.h=l,this.d.$setDebugSessionName(this.f,l)}get parentSession(){return this.k}_acceptNameChanged(l){this.h=l}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(l,u){return this.d.$customDebugAdapterRequest(this.f,l,u)}getDebugProtocolBreakpoint(l){return this.d.$getDebugProtocolBreakpoint(this.f,l.id)}}e.ExtHostDebugSession=b;class p{constructor(l){this.value=Object.freeze({append(u){l.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=p;class g{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(u=>u.onError?u.onError(l):void 0)}onExit(l,u){this.d.forEach(o=>o.onExit?o.onExit(l,u):void 0)}}class w extends D.AbstractDebugAdapter{constructor(l){super(),this.h=l,l.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends h{constructor(l,u,o,a,n,i){super(l,u,o,a,n,i)}};s=qe([He(0,L.IExtHostRpcService),He(1,E.IExtHostWorkspace),He(2,y.IExtHostExtensionService),He(3,d.IExtHostConfiguration),He(4,S.IExtHostEditorTabs),He(5,m.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(Se[289],ye([1,0,10,76,2,5,281,13,87,88,25,197,16,55,41,94]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class m{static async installEarlyHandler(p){const g=p.get(T.ILogService),s=p.get(E.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(r=>{g.error(r);const l=c.transformErrorForSerialization(r);s.$onUnexpectedError(l)})}static async installFullHandler(p){const g=p.get(T.ILogService),w=p.get(E.IExtHostRpcService),s=p.get(v.IExtHostExtensionService),r=p.get(d.IExtHostTelemetry),l=w.getProxy(A.MainContext.MainThreadExtensionService),u=w.getProxy(A.MainContext.MainThreadErrors),o=await s.getExtensionPathIndex(),a=new WeakMap;Error.prepareStackTrace=(n,i)=>{let f="",k,R;for(const B of i)f+=`
	at ${B.toString()}`,R=B.getFileName(),!k&&R&&(k=o.findSubstr(I.URI.file(R)));return a.set(n,k?.identifier),`${n.name||"Error"}: ${n.message||""}${f}`},c.setUnexpectedErrorHandler(n=>{g.error(n);const i=c.transformErrorForSerialization(n),f=a.get(n);if(!f){u.$onUnexpectedError(i);return}l.$onExtensionRuntimeError(f,i);const k=r.onExtensionError(f,n);g.trace("forwarded error to extension?",k,f)})}}Error.stackTraceLimit=100;class h{constructor(p,g,w,s,r){this.a=w,this.b=new C.RPCProtocol(p,null,s),g=h.e(g,this.b);const l=new y.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());l.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:r}),l.set(E.IExtHostRpcService,new E.ExtHostRpcService(this.b)),l.set(D.IURITransformerService,new D.URITransformerService(s)),l.set(v.IHostUtils,w);const u=new P.InstantiationService(l,!0);u.invokeFunction(m.installEarlyHandler),this.d=u.invokeFunction(o=>o.get(T.ILogService)),t.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",g),this.c=u.invokeFunction(o=>o.get(v.IExtHostExtensionService)),this.c.initialize(),u.invokeFunction(m.installFullHandler)}async asBrowserUri(p){const g=this.b.getProxy(A.MainContext.MainThreadExtensionService);return I.URI.revive(await g.$asBrowserUri(p))}terminate(p){this.c.terminate(p)}static e(p,g){p.allExtensions.forEach(s=>{s.extensionLocation=I.URI.revive(g.transformIncomingURIs(s.extensionLocation));const r={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(l=>r[l]=I.URI.revive(g.transformIncomingURIs(s.browserNlsBundleUris[l]))),s.browserNlsBundleUris=r)}),p.environment.appRoot=I.URI.revive(g.transformIncomingURIs(p.environment.appRoot));const w=p.environment.extensionDevelopmentLocationURI;return w&&(p.environment.extensionDevelopmentLocationURI=w.map(s=>I.URI.revive(g.transformIncomingURIs(s)))),p.environment.extensionTestsLocationURI=I.URI.revive(g.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=I.URI.revive(g.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=I.URI.revive(g.transformIncomingURIs(p.environment.workspaceStorageHome)),p.environment.extensionTelemetryLogResource=I.URI.revive(g.transformIncomingURIs(p.environment.extensionTelemetryLogResource)),p.nlsBaseUrl=I.URI.revive(g.transformIncomingURIs(p.nlsBaseUrl)),p.logsLocation=I.URI.revive(g.transformIncomingURIs(p.logsLocation)),p.logFile=I.URI.revive(g.transformIncomingURIs(p.logFile)),p.workspace=g.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=h}),define(Se[290],ye([1,0,18,12,180,196,204,77,59,41,16,40,7,48,33,218,220,34]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let b=class extends T.ExtHostDebugServiceBase{constructor(r,l,u,o,a,n,i){super(r,l,u,o,n,i),this.Z=a,this.X=new w}J(r,l){switch(r.type){case"server":return new d.SocketDebugAdapter(r);case"pipeServer":return new d.NamedPipeDebugAdapter(r);case"executable":return new d.ExecutableDebugAdapter(r,l.type)}return super.J(r,l)}S(r,l){const u=d.ExecutableDebugAdapter.platformAdapterExecutable(l.getAllExtensionDescriptions(),r.type);if(u)return new E.DebugAdapterExecutable(u.command,u.args,u.options)}K(){return new C.SignService}async $runInTerminal(r,l){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(N=>{this.X.onTerminalClosed(N)}));const u=await this.F.getConfigProvider(),o=this.Z.getDefaultShell(!0),a=this.Z.getDefaultShellArgs(!0),n=r.title||I.localize(0,null),i=JSON.stringify({shell:o,shellArgs:a});let f=await this.X.checkout(i,n),k,R=!1;if(f)k=r.cwd;else{const N={shellPath:o,shellArgs:a,cwd:r.cwd,name:n,iconPath:new E.ThemeIcon("debug")};R=!0,f=this.Z.createTerminalFromOptions(N,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(f,i)}f.show(!0);const B=await f.processId;R?await new Promise(N=>setTimeout(N,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(o.indexOf("powershell")>=0||o.indexOf("pwsh")>=0||o.indexOf("cmd.exe")>=0?f.sendText("cls"):o.indexOf("bash")>=0?f.sendText("clear"):t.isWindows?f.sendText("cls"):f.sendText("clear"));const X=(0,m.prepareCommand)(o,r.args,!!r.argsCanBeInterpretedByShell,k,r.env);f.sendText(X);const q=this.onDidTerminateDebugSession(N=>{N.id===l&&(this.X.free(f),q.dispose())});return B}else if(r.kind==="external")return g(r,await this.F.getConfigProvider());return super.$runInTerminal(r,l)}};b=qe([He(0,L.IExtHostRpcService),He(1,v.IExtHostWorkspace),He(2,y.IExtHostExtensionService),He(3,h.IExtHostConfiguration),He(4,P.IExtHostTerminalService),He(5,S.IExtHostEditorTabs),He(6,D.IExtHostVariableResolverProvider)],b),e.ExtHostDebugService=b;let p;function g(s,r){if(!p)if(t.isWindows)p=new A.WindowsExternalTerminalService;else if(t.isMacintosh)p=new A.MacExternalTerminalService;else if(t.isLinux)p=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const l=r.getConfiguration("terminal");return p.runInTerminal(s.title,s.cwd,s.args,s.env||{},l.external||{})}class w{constructor(){this.b=new Map}async checkout(r,l){const o=[...this.b.entries()].map(([a,n])=>(0,c.createCancelablePromise)(async i=>{if(a.name!==l||n.lastUsedAt!==-1&&await(0,m.hasChildProcesses)(await a.processId))return null;const f=Date.now();return n.lastUsedAt+w.a>f||i.isCancellationRequested||n.config!==r?null:(n.lastUsedAt=f,a)}));return await(0,c.firstParallel)(o,a=>!!a)}insert(r,l){this.b.set(r,{lastUsedAt:Date.now(),config:l})}free(r){const l=this.b.get(r);l&&(l.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}w.a=1e3}),define(Se[291],ye([1,0,9,2,114,33,58,34,46,40,16,25,75,15,13,70,24,86,48]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let p=class extends E.ExtHostTaskBase{constructor(w,s,r,l,u,o,a,n,i){super(w,s,r,l,u,o,a,n),this.B=r,this.C=i,s.remote.isRemote&&s.remote.authority?this.registerTaskSystem(D.Schemas.vscodeRemote,{scheme:D.Schemas.vscodeRemote,authority:s.remote.authority,platform:process.platform}):this.registerTaskSystem(D.Schemas.file,{scheme:D.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(w,s){const r=s;if(!s.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const l=E.TaskHandleDTO.from(r,this.B),u=await this.a.$getTaskExecution(l);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.y(u,s);return this.a.$executeTask(l).catch(()=>{}),o}else{const l=E.TaskDTO.from(s,w);if(l===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(l.execution)&&await this.x(l,s,!1);const u=await this.y(await this.a.$getTaskExecution(l),s);return this.a.$executeTask(l).catch(()=>{}),u}}u(w,s,r,l){const u=[];if(l)for(const o of l){this.z(o,r),(!o.definition||!w[o.definition.type])&&this.f.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const a=E.TaskDTO.from(o,r.extension);a&&(u.push(a),E.CustomExecutionDTO.is(a.execution)&&s.push(this.x(a,o,!0)))}return{tasks:u,extension:r.extension}}async v(w){return w}async F(w){let s=w&&w.length>0?w[0]:void 0;if(!s){const r=t.URI.file((0,h.homedir)());s=new S.WorkspaceFolder({uri:r,name:m.basename(r),index:0})}return{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(w,s){const r=t.URI.revive(w),l={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(r),o=await this.b.getWorkspaceFolders2()??[],a=await this.C.getResolver(),n=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(o);for(const i of s.variables)l.variables[i]=await a.resolveAsync(n,i);if(s.process!==void 0){let i;if(s.process.path!==void 0){i=s.process.path.split(c.delimiter);for(let f=0;f<i.length;f++)i[f]=await a.resolveAsync(n,i[f])}l.process=await I.win32.findExecutable(await a.resolveAsync(n,s.process.name),s.process.cwd!==void 0?await a.resolveAsync(n,s.process.cwd):void 0,i)}return l}async $jsonTasksSupported(){return!0}async $findExecutable(w,s,r){return I.win32.findExecutable(w,s,r)}};p=qe([He(0,L.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,A.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,T.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,v.ILogService),He(7,d.IExtHostApiDeprecationService),He(8,b.IExtHostVariableResolverProvider)],p),e.ExtHostTask=p}),define(Se[292],ye([1,0,86,48]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class I extends t.ExtHostVariableResolverProviderService{j(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=I}),define(Se[143],ye([1,0,17,18,21,51,15,9,24,2,31]),function(ne,e,c,t,I,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(b,p,g,w){this.d=b,this.e=p,this.f=g,this.g=w,this.a=null,this.b=!1,this.c=0}search(b,p){const g=this.d.folderQueries||[],w=new I.CancellationTokenSource;return p.onCancellationRequested(()=>w.cancel()),new Promise((s,r)=>{this.a=new D(b);let l=!1;const u=(o,a)=>{if(!l&&!this.b){const n=this.h(o);d(o)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,l=!0,w.cancel(),o=this.j(o,this.d.maxResults-this.c));const i=this.h(o);this.c+=i,(i>0||!d(o))&&this.a.add(o,a)}};Promise.all(g.map((o,a)=>this.k(o,n=>u(n,a),w.token))).then(o=>{w.dispose(),this.a.flush();const a=o.some(n=>!!n&&!!n.limitHit);s({limitHit:this.b||a,messages:(0,c.flatten)(o.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},o=>{w.dispose();const a=(0,A.toErrorMessage)(o);r(new Error(a))})})}h(b){return d(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}j(b,p){const g=Array.isArray(b.ranges)?b.ranges:[b.ranges],w=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:g.slice(0,p),preview:{matches:w.slice(0,p),text:b.preview.text},uri:b.uri}}async k(b,p,g){const w=new L.QueryGlobTester(this.d,b),s=[],r={report:o=>{if(!this.l(o))return;const a=b.folder.scheme===C.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(o.uri))):void 0,n=S.relativePath(b.folder,o.uri);if(n){const i=w.includedInQuery(n,T.basename(n),a);(0,t.isThenable)(i)?s.push(i.then(f=>{f&&p(o)})):i&&p(o)}}},l=this.n(b),u=await this.e.provideTextSearchResults(E(this.d.contentPattern),l,r,g);return s.length&&await Promise.all(s),u}l(b){if(d(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(b){const p=(0,L.resolvePatternsForProvider)(this.d.includePattern,b.includePattern),g=(0,L.resolvePatternsForProvider)(this.d.excludePattern,b.excludePattern),w={folder:y.URI.from(b.folder),excludes:g,includes:p,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.f.toCanonicalName(b.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return w.usePCRE2=this.d.usePCRE2,w}}e.TextSearchManager=P;function E(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class D{constructor(b){this.e=b,this.b=-1,this.d=null,this.a=new m(512,p=>this.g(p))}add(b,p){this.d&&(this.b!==p||!S.isEqual(this.c,b.uri))&&(this.f(),this.d=null),this.d||(this.b=p,this.d={resource:b.uri,results:[]}),this.d.results.push(v(b))}f(){const b=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,b)}flush(){this.f(),this.a.flush()}g(b){this.e(b)}}e.TextSearchResultsCollector=D;function v(h){return d(h)?{preview:{matches:(0,c.mapArrayOrNot)(h.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:h.preview.text},ranges:(0,c.mapArrayOrNot)(h.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function d(h){return!!h.preview}e.extensionResultIsMatch=d;class m{constructor(b,p){this.g=b,this.h=p,this.c=0,this.d=[],this.e=0}addItem(b,p){!b||this.j(b,p)}addItems(b,p){!b||this.k(b,p)}j(b,p){this.d.push(b),this.e+=p,this.l()}k(b,p){this.d=this.d.concat(b),this.e+=p,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=m,m.a=4e3,m.b=50}),define(Se[78],ye([1,0,6,5,3,285,16,55,13,2,143]),function(ne,e,c,t,I,A,C,T,S,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let P=class{constructor(d,m,h){this.k=d,this.l=m,this.n=h,this.c=this.k.getProxy(t.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.FileSearchManager}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,m){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const h=this.d++;return this.e.set(h,m),this.c.$registerTextSearchProvider(h,this.o(d)),(0,c.toDisposable)(()=>{this.g.delete(d),this.e.delete(h),this.c.$unregisterProvider(h)})}registerFileSearchProvider(d,m){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const h=this.d++;return this.h.set(h,m),this.c.$registerFileSearchProvider(h,this.o(d)),(0,c.toDisposable)(()=>{this.i.delete(d),this.h.delete(h),this.c.$unregisterProvider(h)})}$provideFileSearchResults(d,m,h,b){const p=E(h),g=this.h.get(d);if(g)return this.j.fileSearch(p,g,w=>{this.c.$handleFileMatch(d,m,w.map(s=>s.resource))},b);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,m,h,b){const p=this.e.get(d);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const g=E(h);return this.q(g,p).search(s=>this.c.$handleTextMatch(d,m,s),b)}$enableExtensionHostSearch(){}q(d,m){return new L.TextSearchManager(d,m,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};P=qe([He(0,C.IExtHostRpcService),He(1,T.IURITransformerService),He(2,S.ILogService)],P),e.ExtHostSearch=P;function E(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(D),extraFileResources:v.extraFileResources&&v.extraFileResources.map(d=>y.URI.revive(d))}}e.reviveQuery=E;function D(v){return{...v,folder:y.URI.revive(v.folder)}}}),define(Se[293],ye([1,0,87,142,33,139,34,39,58,40,75,77,78,97,54,70,141,71,47,96,94,59,140,13,230,48,95]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b,p,g,w,s,r,l,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,c.registerSingleton)(r.ILoggerService,s.ExtHostLoggerService,1),(0,c.registerSingleton)(r.ILogService,l.ExtHostLogService,1),(0,c.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,0),(0,c.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,c.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,c.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,c.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,0),(0,c.registerSingleton)(D.IExtHostStorage,D.ExtHostStorage,0),(0,c.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,c.registerSingleton)(y.IExtHostTerminalService,y.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService,0),(0,c.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow,0),(0,c.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace,0),(0,c.registerSingleton)(p.IExtHostSecretState,p.ExtHostSecretState,0),(0,c.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry,0),(0,c.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,0),(0,c.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(Se[98],ye([1,0,17,13,31,74]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=C;function T(P,E,D,v){const d=(0,c.mapArrayOrNot)(D,S),m=new I.TextSearchMatch(E,d,v),h=m.preview.matches;return{ranges:(0,c.mapArrayOrNot)(d,y),uri:P,preview:{text:m.preview.text,matches:(0,c.mapArrayOrNot)(h,y)}}}e.createTextSearchResult=T;function S(P){return new I.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function y(P){return new A.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let L=class{constructor(E,D){this.a=E,this.b=D}appendLine(E){this.b.debug(`${this.a}#search`,E)}};L=qe([He(1,t.ILogService)],L),e.OutputChannel=L}),define(Se[294],ye([1,0,45,9,82,32,12,8,98,295]),function(ne,e,c,t,I,A,C,T,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(p,g,w,s){const r=E(p,g,w,s),l=g.folder.fsPath;return{cmd:c.spawn(L,r.args,{cwd:l}),rgDiskPath:L,siblingClauses:r.siblingClauses,rgArgs:r,cwd:l}}e.spawnRipgrepCmd=P;function E(p,g,w,s){const r=["--files","--hidden","--case-sensitive"];v([g],w,!1).forEach(u=>{const o=(0,S.anchorGlob)(u);if(r.push("-g",o),C.isMacintosh){const a=(0,I.normalizeNFD)(o);a!==o&&r.push("-g",a)}});const l=D([g],s,void 0,!1);return l.globArgs.forEach(u=>{const o=`!${(0,S.anchorGlob)(u)}`;if(r.push("-g",o),C.isMacintosh){const a=(0,I.normalizeNFD)(o);a!==o&&r.push("-g",a)}}),g.disregardIgnoreFiles!==!1?r.push("--no-ignore"):g.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),g.ignoreSymlinks||r.push("--follow"),p.exists&&r.push("--quiet"),r.push("--no-config"),g.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:l.siblingClauses}}function D(p,g,w,s=!0){const r=[];let l={};return p.forEach(u=>{const o=Object.assign({},u.excludePattern||{},g||{}),a=d(o,s?u.folder.fsPath:void 0,w);r.push(...a.globArgs),a.siblingClauses&&(l=Object.assign(l,a.siblingClauses))}),{globArgs:r,siblingClauses:l}}function v(p,g,w=!0){const s=[];return p.forEach(r=>{const l=Object.assign({},g||{},r.includePattern||{}),u=d(l,w?r.folder.fsPath:void 0);s.push(...u.globArgs)}),s}function d(p,g,w){const s=[],r={};return Object.keys(p).forEach(l=>{if(w&&w.has(l)||!l)return;const u=p[l];l=h(g?m(g,l):l),l.startsWith("\\\\")?l="\\\\"+l.substr(2).replace(/\\/g,"/"):l=l.replace(/\\/g,"/"),typeof u=="boolean"&&u?(l.startsWith("\\\\")&&(l+="**"),s.push(b(l))):u&&u.when&&(r[l]=u)}),{globArgs:s,siblingClauses:r}}function m(p,g){return t.isAbsolute(g)?g:t.join(p,g)}e.getAbsoluteGlob=m;function h(p){return p=T.rtrim(p,"\\"),T.rtrim(p,"/")}function b(p){return A.getRoot(p).toLowerCase()==="c:/"?p.replace(/^c:[/\\]/i,"/"):p}e.fixDriveC=b}),define(Se[296],ye([1,0,45,65,9,297,17,51,37,82,32,12,44,8,11,29,31,294,109]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const p=new Set;process.on("exit",()=>{p.forEach(l=>l())});class g{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&S.parse(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,b.prepareQuery)(this.b).normalizedLowercase),this.u=u.excludePattern&&S.parse(u.excludePattern),this.t=new Map,u.folderQueries.forEach(o=>{const a=Object.assign({},o.excludePattern||{},this.a.excludePattern||{}),n=o.folder.fsPath;u.folderQueries.map(i=>i.folder.fsPath).filter(i=>i!==n).forEach(i=>{(0,L.isEqualOrParent)(i,n)&&(a[I.relative(n,i)]=!0)}),this.t.set(n,new s(a,n))})}cancel(){this.l=!0,p.forEach(u=>u())}walk(u,o,a,n,i){if(this.m=E.StopWatch.create(!1),this.l)return i(null,this.j);o.forEach(f=>{const k=I.basename(f.fsPath);this.u&&this.u(f.fsPath,k)||this.J(a,{relativePath:f.fsPath,searchPath:void 0})}),this.r=E.StopWatch.create(!1),this.w(u,(f,k)=>{this.x(this.y,this,f,a,n,R=>{if(R){const B=(0,T.toErrorMessage)(R);console.error(B),this.q.push(B),k(R,void 0)}else k(null,void 0)})},(f,k)=>{this.m.stop();const R=f?C.coalesce(f)[0]:null;i(R,this.j)})}w(u,o,a){const n=new Array(u.length),i=new Array(u.length);let f=!1,k=0;if(u.length===0)return a(null,[]);u.forEach((R,B)=>{o(R,(X,q)=>{if(X?(f=!0,n[B]=null,i[B]=X):(n[B]=q,i[B]=null),++k===u.length)return a(f?i:null,n)})})}x(u,o,...a){try{u.apply(o,a)}catch(n){a[a.length-1](n)}}y(u,o,a,n){const i=u.folder.fsPath,f=P.isMacintosh,k=()=>N&&N.kill();p.add(k);let R=U=>{p.delete(k),R=()=>{},n(U)},B="";const X=this.D(),q=(0,h.spawnRipgrepCmd)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),N=q.cmd,M=!Object.keys(q.siblingClauses).length,F=q.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let z=`${q.rgDiskPath} ${F}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),a({message:z}),this.s=0,this.z(N,"utf8",a,(U,W,x)=>{if(U){R(U);return}if(this.j){R();return}const _=(B+(f?y.normalizeNFC(W||""):W)).split(`
`);if(x){const Q=_.length;_[Q-1]=_[Q-1].trim(),_[Q-1]||_.pop()}else B=_.pop()||"";if(_.length&&_[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.s+=_.length,M){for(const Q of _)if(this.J(o,{base:i,relativePath:Q,searchPath:this.N(u,Q)}),this.j){k();break}(x||this.j)&&R();return}this.G(u,X,i,_,o),x&&(this.H(X,i,o),R())})}spawnFindCmd(u){const o=this.t.get(u.folder.fsPath),a=o.getBasenameTerms(),n=o.getPathTerms(),i=["-L","."];if(a.length||n.length){i.push("-not","(","(");for(const f of a)i.push("-name",f),i.push("-o");for(const f of n)i.push("-path",f),i.push("-o");i.pop(),i.push(")","-prune",")")}return i.push("-type","f"),c.spawn("find",i,{cwd:u.folder.fsPath})}readStdout(u,o,a){let n="";this.z(u,o,()=>{},(i,f,k)=>{if(i){a(i);return}n+=f,k&&a(null,n)})}z(u,o,a,n){let i=(R,B,X)=>{(R||X)&&(i=()=>{},this.r?.stop()),n(R,B,X)},f=!1;u.stdout?(this.A(u.stdout,o,i),u.stdout.once("data",()=>f=!0)):a({message:"stdout is null"});let k;u.stderr?k=this.B(u.stderr):a({message:"stderr is null"}),u.on("error",R=>{i(R)}),u.on("close",R=>{let B;!f&&(B=this.C(k,o))&&r(B)?i(new Error(`command failed with error code ${R}: ${this.C(k,o)}`)):(this.g&&R===0&&(this.j=!0),i(null,"",!0))})}A(u,o,a){const n=new A.StringDecoder(o);return u.on("data",i=>{a(null,n.write(i))}),n}B(u){const o=[];return u.on("data",a=>{o.push(a)}),o}C(u,o){const a=new A.StringDecoder(o);return u.map(n=>a.write(n)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:o},a,n,i){n.indexOf(this.b)!==-1&&this.J(i,{base:a,relativePath:this.b,searchPath:this.N(u,this.b)});const f=k=>{const R=I.basename(k),B=I.dirname(k);let X=o[B];X||(X=o[B]=[],f(B)),X.push({base:a,relativePath:k,basename:R,searchPath:this.N(u,k)})};n.forEach(f)}H({rootEntries:u,pathToEntries:o},a,n){const i=this,f=this.t.get(a),k=this.b;function R(B){i.o++;const X=(0,m.hasSiblingFn)(()=>B.map(q=>q.basename));for(let q=0,N=B.length;q<N;q++){const M=B[q],{relativePath:F,basename:z}=M;if(f.test(F,z,k!==z?X:void 0))continue;const U=o[F];if(U)R(U);else{if(i.p++,F===k)continue;i.J(n,M)}if(i.j)break}}R(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,o,a,n,i){const f=u.folder,k=(0,m.hasSiblingFn)(()=>a);this.w(a,(R,B)=>{if(this.l||this.j)return B(null);const X=o?[o,R].join(I.sep):R;if(this.t.get(u.folder.fsPath).test(X,R,this.a.filePattern!==R?k:void 0))return B(null);const q=[f.fsPath,X].join(I.sep);t.lstat(q,(N,M)=>{if(N||this.l||this.j)return B(null);this.L(q,M,(F,z)=>F||this.l||this.j?B(null):z.isDirectory()?(this.o++,this.M(q,M,(U,W)=>U||this.l||this.j||(W=W||"",this.v[W])?B(null):(this.v[W]=!0,d.Promises.readdir(q).then(x=>{if(this.l||this.j)return B(null);this.I(u,X,x,n,V=>B(V||null))},x=>{B(null)})))):(this.p++,X===this.b||this.h&&v.isNumber(z.size)&&z.size>this.h||this.J(n,{base:f.fsPath,relativePath:X,searchPath:this.N(u,X)}),B(null,void 0)))})},R=>{const B=R&&C.coalesce(R);return i(B&&B.length>0?B[0]:void 0)})}J(u,o){this.K(o)&&(!this.d||this.d(o.relativePath,I.basename(o.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(o))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.isFilePatternMatch)(u,this.c)}return!0}L(u,o,a){return o.isSymbolicLink()?t.stat(u,a):a(null,o)}M(u,o,a){return o.isSymbolicLink()?t.realpath(u,(n,i)=>n?a(n):a(null,i)):a(null,u)}N(u,o){return u.folderName?I.join(u.folderName,o):o}}e.FileWalker=g;class w{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new g(u)}search(u,o,a){this.c.walk(this.a,this.b,u,o,(n,i)=>{a(n,{limitHit:i,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=w;class s{constructor(u,o){this.expression=u,this.c=o,this.d(u)}d(u){let o,a;Object.keys(u).filter(n=>u[n]).forEach(n=>{I.isAbsolute(n)?(o=o||S.getEmptyExpression(),o[n]=u[n]):(a=a||S.getEmptyExpression(),a[n]=u[n])}),this.a=o&&S.parse(o,{trimForExclusions:!0}),this.b=a&&S.parse(a,{trimForExclusions:!0})}test(u,o,a){return this.b&&this.b(u,o,a)||this.a&&this.a(I.join(this.c,u),o,a)}getBasenameTerms(){const u=[];return this.a&&u.push(...S.getBasenameTerms(this.a)),this.b&&u.push(...S.getBasenameTerms(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...S.getPathTerms(this.a)),this.b&&u.push(...S.getPathTerms(this.b)),u}}function r(l){const u=l.trim().split(`
`),o=u[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return D.uppercaseFirstLetter(u[u.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}}),define(Se[298],ye([1,0,101,22]),function(ne,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(l){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===l)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,C=512,T=512*8,S=512*128;var y;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(y=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(u,o){super(u),this.decodeStreamErrorKind=o}}e.DecodeStreamError=L;class P{static async create(u){let o;if(u!==e.UTF8)o=(await new Promise((n,i)=>{ne(["@vscode/iconv-lite-umd"],n,i)})).getDecoder(d(u));else{const a=new TextDecoder;o={write(n){return a.decode(n,{stream:!0})},end(){return a.decode()}}}return new P(o)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function E(l,u){const o=u.minBytesRequiredForDetection??u.guessEncoding?T:C;return new Promise((a,n)=>{const i=(0,c.newWriteableStream)(q=>q.join("")),f=[];let k=0,R,B;const X=async()=>{try{const q=await r({buffer:t.VSBuffer.concat(f),bytesRead:k},u.guessEncoding);if(q.seemsBinary&&u.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);q.encoding=await u.overwriteEncoding(q.encoding),R=await P.create(q.encoding);const N=R.write(t.VSBuffer.concat(f).buffer);i.write(N),f.length=0,k=0,a({stream:i,detected:q})}catch(q){B?.dispose(),i.destroy(),n(q)}};B=(0,c.listenStream)(l,{onData:async q=>{R?i.write(R.write(q.buffer)):(f.push(q),k+=q.byteLength,k>=o&&(l.pause(),await X(),setTimeout(()=>l.resume())))},onError:q=>i.error(q),onEnd:async()=>{R||await X(),i.end(R?.end())}})})}e.toDecodeStream=E;async function D(l,u,o){const n=(await new Promise((k,R)=>{ne(["@vscode/iconv-lite-umd"],k,R)})).getEncoder(d(u),o);let i=!1,f=!1;return{read(){if(f)return null;const k=l.read();if(typeof k!="string"){if(f=!0,!i&&o?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=n.end();return R&&R.length>0?(i=!0,t.VSBuffer.wrap(R)):null}return i=!0,t.VSBuffer.wrap(n.write(k))}}}e.toEncodeReadable=D;async function v(l){return(await new Promise((o,a)=>{ne(["@vscode/iconv-lite-umd"],o,a)})).encodingExists(d(l))}e.encodingExists=v;function d(l){return l===e.UTF8_with_bom||l===null?e.UTF8:l}e.toNodeEncoding=d;function m(l,u){if(!l||u<e.UTF16be_BOM.length)return null;const o=l.readUInt8(0),a=l.readUInt8(1);if(o===e.UTF16be_BOM[0]&&a===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&a===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const n=l.readUInt8(2);return o===e.UTF8_BOM[0]&&a===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=m;const h=["ascii","utf-16","utf-32"];async function b(l){const u=await new Promise((f,k)=>{ne(["jschardet"],f,k)}),o=l.slice(0,S),a=w(o.buffer),n=u.detect(a);if(!n||!n.encoding)return null;const i=n.encoding.toLowerCase();return 0<=h.indexOf(i)?null:g(n.encoding)}const p={ibm866:"cp866",big5:"cp950"};function g(l){const u=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return p[u]||u}function w(l){let u="";for(let o=0;o<l.length;o++)u+=String.fromCharCode(l[o]);return u}function s(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=l.match(/windows(\d+)/);return u?"windows-"+u[1]:l}}}e.toCanonicalName=s;function r({buffer:l,bytesRead:u},o){let a=m(l,u),n=!1;if(a!==e.UTF16be&&a!==e.UTF16le&&l){let i=!0,f=!0,k=!1;for(let R=0;R<u&&R<A;R++){const B=R%2===1,X=l.readUInt8(R)===0;if(X&&(k=!0),i&&(B&&!X||!B&&X)&&(i=!1),f&&(B&&X||!B&&!X)&&(f=!1),X&&!i&&!f)break}k&&(i?a=e.UTF16le:f?a=e.UTF16be:n=!0)}return o&&!n&&!a&&l?b(l.slice(0,u)).then(i=>({seemsBinary:!1,encoding:i})):{seemsBinary:n,encoding:a}}e.detectEncodingFromBuffer=r,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[144],ye([1,0,298,29,143]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends I.TextSearchManager{constructor(T,S,y=t,L="searchProcess"){super(T,S,{readdir:P=>y.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,c.toCanonicalName)(P)},L)}}e.NativeTextSearchManager=A}),define(Se[299],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class c{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(I){if(I&&this.a.has(I)){const A=this.a.get(I);return this.a.delete(I),A}}addDragOperationTransfer(I,A){this.a.set(I,A)}getRenderedTreeElement(I){if(this.b.has(I))return this.b.get(I)}addRenderedTreeItemElement(I,A){this.b.set(I,A)}removeRenderedTreeItemElement(I){this.b.has(I)&&this.b.delete(I)}}e.TreeviewsService=c}),define(Se[300],ye([1,0,178,7,24,2,4,6,18,7,11,17,14,21,299,26]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(p,g){if((0,L.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let w;return Array.isArray(p.highlights)&&(w=p.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),w=w.length?w:void 0),{label:p.label,highlights:w}}}class h{constructor(g,w,s){this.d=g,this.e=w,this.f=s,this.a=new Map,this.b=new v.TreeviewsService;function r(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:l=>r(l)?this.i(l):Array.isArray(l)&&l.length>0?l.map(u=>r(u)?this.i(u):u):l})}registerTreeDataProvider(g,w,s){const r=this.createTreeView(g,{treeDataProvider:w},s);return{dispose:()=>r.dispose()}}createTreeView(g,w,s){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=w.dragAndDropController?.dropMimeTypes??[],l=w.dragAndDropController?.dragMimeTypes??[],u=!!w.dragAndDropController?.handleDrag,o=!!w.dragAndDropController?.handleDrop,a=this.h(g,w,s),n=this.d.$registerTreeViewDataProvider(g,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:r,dragMimeTypes:l,hasHandleDrag:u,hasHandleDrop:o});return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(s,"treeItemCheckbox"),a.onDidChangeCheckboxState},get message(){return a.message},set message(i){a.message=i},get title(){return a.title},set title(i){a.title=i},get description(){return a.description},set description(i){a.description=i},get badge(){return a.badge},set badge(i){i!==void 0&&y.ViewBadge.isViewBadge(i)?a.badge={value:Math.floor(Math.abs(i.value)),tooltip:i.tooltip}:i===void 0&&(a.badge=void 0)},reveal:(i,f)=>a.reveal(i,f),dispose:async()=>{await n,this.a.delete(g),a.dispose()}}}$getChildren(g,w){const s=this.a.get(g);return s?s.getChildren(w):Promise.reject(new Error((0,c.localize)(0,null,g)))}async $handleDrop(g,w,s,r,l,u,o,a){const n=this.a.get(g);if(!n)return Promise.reject(new Error((0,c.localize)(1,null,g)));const i=E.DataTransfer.toDataTransfer(s,async f=>(await this.d.$resolveDropFileData(g,w,f)).buffer);return o===g&&a&&await this.g(i,n,a,l,u),n.onDrop(i,r,l)}async g(g,w,s,r,l){const u=this.b.removeDragOperationTransfer(l);if(u)(await u)?.forEach((o,a)=>{o&&g.set(a,o)});else if(l&&w.handleDrag){const o=w.handleDrag(s,g,r);this.b.addDragOperationTransfer(l,o),await o}return g}async $handleDrag(g,w,s,r){const l=this.a.get(g);if(!l)return Promise.reject(new Error((0,c.localize)(2,null,g)));const u=await this.g(new t.DataTransfer,l,w,r,s);if(!!u)return E.DataTransfer.toDataTransferDTO(u)}async $hasResolve(g){const w=this.a.get(g);if(!w)throw new Error((0,c.localize)(3,null,g));return w.hasResolve}$resolve(g,w,s){const r=this.a.get(g);if(!r)throw new Error((0,c.localize)(4,null,g));return r.resolveTreeItem(w,s)}$setExpanded(g,w,s){const r=this.a.get(g);if(!r)throw new Error((0,c.localize)(5,null,g));r.setExpanded(w,s)}$setSelection(g,w){const s=this.a.get(g);if(!s)throw new Error((0,c.localize)(6,null,g));s.setSelection(w)}$setFocus(g,w){const s=this.a.get(g);if(!s)throw new Error((0,c.localize)(7,null,g));s.setFocus(w)}$setVisible(g,w){const s=this.a.get(g);if(!s)throw new Error((0,c.localize)(8,null,g));s.setVisible(w)}$changeCheckboxState(g,w){const s=this.a.get(g);if(!s)throw new Error((0,c.localize)(9,null,g));s.setCheckboxState(w)}h(g,w,s){const r=new b(g,w,this.d,this.e.converter,this.f,s);return this.a.set(g,r),r}i(g){const w=this.a.get(g.$treeViewId);return w&&"$treeItemHandle"in g?w.getExtensionElement(g.$treeItemHandle):w&&"$focusedTreeItem"in g&&g.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=h;class b extends T.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(g=>this.getExtensionElement(g)).filter(g=>!(0,L.isUndefinedOrNull)(g))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(g,w,s,r,l,u){if(super(),this.C=g,this.D=s,this.F=r,this.G=l,this.H=u,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new D.CancellationTokenSource,u.contributes&&u.contributes.views)for(const n in u.contributes.views)for(const i of u.contributes.views[n])i.id===g&&(this.J=i.name);this.f=w.treeDataProvider,this.g=w.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let o,a;this.B(C.Event.debounce(this.w.event,(n,i)=>(n||(n={message:!1,elements:[]}),i.element!==!1&&(o||(o=new Promise(f=>a=f),this.y=this.y.then(()=>o)),Array.isArray(i.element)?n.elements.push(...i.element):n.elements.push(i.element)),i.message&&(n.message=!0),n),200,!0)(({message:n,elements:i})=>{i.length&&(this.z=this.z.then(()=>{const f=a;return o=null,this.U(i).then(()=>f())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(g){const w=g?this.getExtensionElement(g):void 0;if(g&&!w)return this.G.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let s=this.Q(g);return s||(s=await this.R(w)),s?s.map(r=>r.item):void 0}getExtensionElement(g){return this.i.get(g)}reveal(g,w){w=w||{select:!0,focus:!1};const s=(0,L.isUndefinedOrNull)(w.select)?!0:w.select,r=(0,L.isUndefinedOrNull)(w.focus)?!1:w.focus,l=(0,L.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.y.then(()=>this.N(g)).then(u=>this.P(g,u[u.length-1]).then(o=>this.D.$reveal(this.C,{item:o.item,parentChain:u.map(a=>a.item)},{select:s,focus:r,expand:l})),u=>this.G.error(u)):this.D.$reveal(this.C,void 0,{select:s,focus:r,expand:l})}get message(){return this.I}set message(g){this.I=g,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(g){this.J=g,this.D.$setTitle(this.C,g,this.L)}get description(){return this.L}set description(g){this.L=g,this.D.$setTitle(this.C,this.J,g)}get badge(){return this.M}set badge(g){this.M?.value===g?.value&&this.M?.tooltip===g?.tooltip||(this.M=E.ViewBadge.from(g),this.D.$setBadge(this.C,g))}setExpanded(g,w){const s=this.getExtensionElement(g);s&&(w?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(g){(0,P.equals)(this.l,g)||(this.l=g,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(g){this.m=g}setVisible(g){g!==this.k&&(this.k=g,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(g){const w=(await Promise.all(g.map(async s=>{const r=this.getExtensionElement(s.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:s.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);w.forEach(s=>{s.treeItem.checkboxState=s.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.v.fire({items:w.map(s=>[s.extensionItem,s.newState])})}async handleDrag(g,w,s){const r=[];for(const l of g){const u=this.getExtensionElement(l);u&&r.push(u)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,w,s),w}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,w,s){const r=w?this.getExtensionElement(w):void 0;if(!(!r&&w||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,g,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,w){if(!this.f.resolveTreeItem)return;const s=this.i.get(g);if(s){const r=this.j.get(s);if(r){const l=await this.f.resolveTreeItem(r.extensionItem,s,w)??r.extensionItem;return this.db(l),r.item.tooltip=this.ab(l.tooltip),r.item.command=this.bb(r.disposableStore,l.command),r.item}}}N(g){return this.O(g).then(w=>w?this.N(w).then(s=>this.P(w,s[s.length-1]).then(r=>(s.push(r),s))):Promise.resolve([]))}O(g){const w=this.j.get(g);return w?Promise.resolve(w.parent?this.i.get(w.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(g))}P(g,w){const s=this.j.get(g);return s?Promise.resolve(s):(0,S.asPromise)(()=>this.f.getTreeItem(g)).then(r=>this.gb(g,r,w,!0)).then(r=>this.getChildren(w?w.item.handle:void 0).then(()=>{const l=this.getExtensionElement(r);if(l){const u=this.j.get(l);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(g){if(g){let w;if(typeof g=="string"){const s=this.getExtensionElement(g);w=s?this.j.get(s):void 0}else w=g;return w&&w.children||void 0}return this.h}async R(g){this.nb(g);const w=new D.CancellationTokenSource(this.S.token);try{const s=g?this.j.get(g):void 0,r=await this.f.getChildren(g);if(w.token.isCancellationRequested)return;const l=await Promise.all((0,P.coalesce)(r||[]).map(async u=>{const o=await this.f.getTreeItem(u);return o&&!w.token.isCancellationRequested?this.Z(u,o,s):null}));return w.token.isCancellationRequested?void 0:(0,P.coalesce)(l)}finally{w.dispose()}}U(g){if(g.some(s=>!s))return this.S.dispose(!0),this.S=new D.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const s=this.W(g);if(s.length)return this.X(s)}return Promise.resolve(void 0)}W(g){const w=new Set,s=g.map(l=>this.j.get(l));for(const l of s)if(l&&!w.has(l.item.handle)){let u=l;for(;u&&u.parent&&s.findIndex(o=>u&&u.parent&&o&&o.item.handle===u.parent.item.handle)===-1;){const o=this.i.get(u.parent.item.handle);u=o?this.j.get(o):void 0}u&&!u.parent&&w.add(l.item.handle)}const r=[];return w.forEach(l=>{const u=this.i.get(l);if(u){const o=this.j.get(u);o&&(!o.parent||!w.has(o.parent.item.handle))&&r.push(l)}}),r}X(g){const w={};return Promise.all(g.map(s=>this.Y(s).then(r=>{r&&(w[s]=r.item)}))).then(()=>Object.keys(w).length?this.D.$refresh(this.C,w):void 0)}Y(g){const w=this.getExtensionElement(g);if(w){const s=this.j.get(w);if(s)return this.nb(w),(0,S.asPromise)(()=>this.f.getTreeItem(w)).then(r=>{if(r){const l=this.eb(w,r,s.parent);return this.lb(w,l,s,s.parent),s.dispose(),l}return null})}return Promise.resolve(null)}Z(g,w,s){const r=this.eb(g,w,s);if(w.id&&this.i.has(r.item.handle))throw new Error((0,c.localize)(10,null,w.id));return this.kb(g,r),this.mb(r,s),r}ab(g){return y.MarkdownString.isMarkdownString(g)?E.MarkdownString.from(g):g}bb(g,w){return w?{...this.F.toInternal(w,g),originalId:w.command}:void 0}cb(g){if(!g.checkboxState)return;let w,s;return typeof g.checkboxState=="number"?w=g.checkboxState:(w=g.checkboxState.state,s=g.checkboxState.tooltip),{isChecked:w===y.TreeItemCheckboxState.Checked,tooltip:s}}db(g){if(!y.TreeItem.isTreeItem(g,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(g,w,s){this.db(w);const r=new T.DisposableStore,l=this.gb(g,w,s),u=this.hb(w);return{item:{handle:l,parentHandle:s?s.item.handle:void 0,label:m(w.label,this.H),description:w.description,resourceUri:w.resourceUri,tooltip:this.ab(w.tooltip),command:this.bb(r,w.command),contextValue:w.contextValue,icon:u,iconDark:this.ib(w)||u,themeIcon:this.fb(w),collapsibleState:(0,L.isUndefinedOrNull)(w.collapsibleState)?y.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.cb(w)},extensionItem:w,parent:s,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(g){return g.iconPath instanceof y.ThemeIcon?g.iconPath:void 0}gb(g,{id:w,label:s,resourceUri:r},l,u){if(w)return`${b.b}/${w}`;const o=m(s,this.H),a=l?l.item.handle:b.a;let n=o?o.label:r?(0,I.basename)(r):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const i=this.j.has(g)?this.j.get(g).item.handle:void 0,f=this.Q(l)||[];let k,R=0;do{if(k=`${a}/${R}:${n}`,u||!this.i.has(k)||i===k)break;R++}while(R<=f.length);return k}hb(g){if(g.iconPath&&!(g.iconPath instanceof y.ThemeIcon))return typeof g.iconPath=="string"||A.URI.isUri(g.iconPath)?this.jb(g.iconPath):this.jb(g.iconPath.light)}ib(g){if(g.iconPath&&!(g.iconPath instanceof y.ThemeIcon)&&g.iconPath.dark)return this.jb(g.iconPath.dark)}jb(g){return A.URI.isUri(g)?g:A.URI.file(g)}kb(g,w){this.i.set(w.item.handle,g),this.j.set(g,w)}lb(g,w,s,r){this.i.delete(w.item.handle),this.j.delete(g),w.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(g,w);const l=this.Q(r)||[],u=l.filter(o=>o.item.handle===s.item.handle)[0];u&&l.splice(l.indexOf(u),1,w)}mb(g,w){w?(w.children||(w.children=[]),w.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}nb(g){if(g){const w=this.j.get(g);if(w){if(w.children)for(const s of w.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}w.children=void 0}}else this.pb()}ob(g){const w=this.j.get(g);if(w){if(w.children)for(const s of w.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}this.j.delete(g),this.i.delete(w.item.handle),w.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(g=>g.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(Se[301],ye([1,0,21,10,4,42,2,119,105,152,161,38,5,93,244,243,39,245,34,247,248,249,232,250,58,41,251,252,255,256,257,142,235,262,263,264,97,40,266,300,14,7,128,269,73,141,33,223,254,67,139,75,77,78,13,55,16,25,258,231,54,70,241,267,72,71,272,270,271,242,47,265,268,96,59,94,259,74,260,15,123,234,212,253,6,26,216,95,209,261]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b,p,g,w,s,r,l,u,o,a,n,i,f,k,R,B,X,q,N,M,F,z,U,W,x,V,_,Q,J,te,le,Z,ge,ve,De,Re,ze,se,ue,he,ee,oe,ie,O,H,K,Y,de,be,Pe,pe,Ce,ke,je,Ge,et,_e,nt,st,ht,Fe,it,ae,$,ce,Ie,Le,Be,xe,Ze,mt,ft){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function lt(ot){const rt=ot.get(he.IExtHostInitDataService),Tt=ot.get(ke.IExtHostFileSystemInfo),Pt=ot.get(de.IExtHostConsumerFileSystem),Ft=ot.get(u.IExtHostExtensionService),gt=ot.get(J.IExtHostWorkspace),It=ot.get(nt.IExtHostTelemetry),Bt=ot.get(b.IExtHostConfiguration),Mt=ot.get(se.IURITransformerService),Xe=ot.get(ue.IExtHostRpcService),Rt=ot.get(N.IExtHostStorage),Ut=ot.get(Y.IExtensionStoragePaths),Ht=ot.get(ze.ILoggerService),pt=ot.get(ze.ILogService),At=ot.get(ie.IExtHostTunnelService),Ae=ot.get(O.IExtHostApiDeprecationService),Oe=ot.get(Q.IExtHostWindow),Ee=ot.get(et.IExtHostSecretState),re=ot.get(_e.IExtHostEditorTabs);Xe.set(E.ExtHostContext.ExtHostFileSystemInfo,Tt),Xe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,Ht),Xe.set(E.ExtHostContext.ExtHostWorkspace,gt),Xe.set(E.ExtHostContext.ExtHostConfiguration,Bt),Xe.set(E.ExtHostContext.ExtHostExtensionService,Ft),Xe.set(E.ExtHostContext.ExtHostStorage,Rt),Xe.set(E.ExtHostContext.ExtHostTunnelService,At),Xe.set(E.ExtHostContext.ExtHostWindow,Oe),Xe.set(E.ExtHostContext.ExtHostSecretState,Ee),Xe.set(E.ExtHostContext.ExtHostTelemetry,It),Xe.set(E.ExtHostContext.ExtHostEditorTabs,re);const Ne=Xe.set(E.ExtHostContext.ExtHostDecorations,ot.get(ge.IExtHostDecorations)),$e=Xe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(l.IExtHostDocumentsAndEditors)),Qe=Xe.set(E.ExtHostContext.ExtHostCommands,ot.get(m.IExtHostCommands)),Ve=Xe.set(E.ExtHostContext.ExtHostTerminalService,ot.get(M.IExtHostTerminalService)),tt=Xe.set(E.ExtHostContext.ExtHostDebugService,ot.get(De.IExtHostDebugService)),St=Xe.set(E.ExtHostContext.ExtHostSearch,ot.get(Re.IExtHostSearch)),yt=Xe.set(E.ExtHostContext.ExtHostTask,ot.get(ve.IExtHostTask)),kt=Xe.set(E.ExtHostContext.ExtHostOutputService,ot.get(k.IExtHostOutputService)),vt=Xe.set(E.ExtHostContext.ExtHostLocalization,ot.get(Ze.IExtHostLocalizationService)),Et=Xe.set(E.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(Xe)),bt=Xe.set(E.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(Xe,$e)),jt=Xe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Xe,$e,pt)),on=Xe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(pt,bt,Xe.getProxy(E.MainContext.MainThreadBulkEdits))),Ct=Xe.set(E.ExtHostContext.ExtHostNotebook,new ee.ExtHostNotebookController(Xe,Qe,$e,bt)),tn=Xe.set(E.ExtHostContext.ExtHostNotebookDocuments,new ce.ExtHostNotebookDocuments(Ct)),an=Xe.set(E.ExtHostContext.ExtHostNotebookEditors,new $.ExtHostNotebookEditors(pt,Ct)),Yt=Xe.set(E.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Xe,rt,Ct,Qe,pt)),vn=Xe.set(E.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Xe,Ct)),Lt=Xe.set(E.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Xe,$e)),cn=Xe.set(E.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(Xe.getProxy(E.MainContext.MainThreadTreeViews),Qe,pt)),Vt=Xe.set(E.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(Xe.getProxy(E.MainContext.MainThreadEditorInsets),Lt,rt.remote)),Jt=Xe.set(E.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(Xe,pt,Tt,$e)),ln=Xe.set(E.ExtHostContext.ExtHostLanguages,new i.ExtHostLanguages(Xe,bt,Qe.converter,Mt)),ut=Xe.set(E.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,Mt,bt,Qe,Jt,pt,Ae,It)),Zt=Xe.set(E.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(Xe,ut)),qt=Xe.set(E.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(Xe,pt,$e)),Xt=Xe.set(E.ExtHostContext.ExtHostQuickOpen,(0,B.createExtHostQuickOpen)(Xe,gt,Qe)),un=Xe.set(E.ExtHostContext.ExtHostSCM,new X.ExtHostSCM(Xe,Qe,pt)),En=Xe.set(E.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(Xe,Qe,bt)),dn=Xe.set(E.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Xe.getProxy(E.MainContext.MainThreadProgress))),Sn=Xe.set(E.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Xe)),hn=Xe.set(E.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Xe)),en=Xe.set(E.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(Xe)),Un=Xe.set(E.ExtHostContext.ExtHostTimeline,new K.ExtHostTimeline(Xe,Qe)),nn=Xe.set(E.ExtHostContext.ExtHostWebviews,new _.ExtHostWebviews(Xe,rt.remote,gt,pt,Ae)),rn=Xe.set(E.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(Xe,nn,gt)),yn=Xe.set(E.ExtHostContext.ExtHostCustomEditors,new Pe.ExtHostCustomEditors(Xe,bt,Ut,nn,rn)),Cn=Xe.set(E.ExtHostContext.ExtHostWebviewViews,new be.ExtHostWebviewViews(Xe,nn)),sn=Xe.set(E.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(Xe,Qe,$e)),Dn=Xe.set(E.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(Xe)),In=Xe.set(E.ExtHostContext.ExtHostProfileContentHandlers,new ft.ExtHostProfileContentHandlers(Xe));Xe.set(E.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Xe,Ct,$e,Qe,pt));const Bn=Object.values(E.ExtHostContext);Xe.assertRegistered(Bn);const zn=new Ce.ExtHostBulkEdits(Xe,$e),$n=new d.ExtHostClipboard(Xe),kn=new f.ExtHostMessageService(Xe,pt),Rn=new g.ExtHostDialogs(Xe),Ln=new q.ExtHostStatusBar(Xe,Qe.converter);return v.ExtHostApiCommands.register(Qe),function(We,$t,On){const wt=function(){let me=!We.isUnderDevelopment;function we(){me||(pt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function Ue(at){if(Array.isArray(at))at.forEach(Ue);else if(typeof at=="string")we();else{const Dt=at;typeof Dt.scheme>"u"&&we(),typeof Dt.exclusive=="boolean"&&(0,Be.checkProposedApiEnabled)(We,"documentFiltersExclusive")}return at}}(),Wn={getSession(me,we,Ue){return en.getSession(We,me,we,Ue)},async hasSession(me,we){return(0,Be.checkProposedApiEnabled)(We,"authSession"),!!await en.getSession(We,me,we,{silent:!0})},get onDidChangeSessions(){return en.onDidChangeSessions},registerAuthenticationProvider(me,we,Ue,at){return en.registerAuthenticationProvider(me,we,Ue,at)}},fn={registerCommand(me,we,Ue){return Qe.registerCommand(!0,me,we,Ue,void 0,We)},registerTextEditorCommand(me,we,Ue){return Qe.registerCommand(!0,me,(...at)=>{const Dt=Lt.getActiveTextEditor();if(!Dt){pt.warn("Cannot execute "+me+" because there is no active text editor.");return}return Dt.edit(Ot=>{we.apply(Ue,[Dt,Ot,...at])}).then(Ot=>{Ot||pt.warn("Edits from command "+me+" were not applied.")},Ot=>{pt.warn("An error occurred while running command "+me,Ot)})},void 0,void 0,We)},registerDiffInformationCommand:(me,we,Ue)=>((0,Be.checkProposedApiEnabled)(We,"diffCommand"),Qe.registerCommand(!0,me,async(...at)=>{const Dt=$e.activeEditor(!0);if(!Dt){pt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Ot=await Lt.getDiffInformation(Dt.id);we.apply(Ue,[Ot,...at])},void 0,void 0,We)),executeCommand(me,...we){return Qe.executeCommand(me,...we)},getCommands(me=!1){return Qe.getCommands(me)}},Nn={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return Ve.getDefaultShell(!1)},get onDidChangeShell(){return(0,Be.checkProposedApiEnabled)(We,"envShellEvent"),Ve.onDidChangeShell},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(We,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(We,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(me){return(0,Be.checkProposedApiEnabled)(We,"telemetryLogger"),It.instantiateLogger(We,me)},openExternal(me,we){return Oe.openUri(me,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===rt.environment.appUriScheme)return Et.createAppUri(me);try{return await Oe.asExternalUri(me,{allowTunneling:!!rt.remote.authority})}catch(we){if((0,ae.matchesScheme)(me,it.Schemas.http)||(0,ae.matchesScheme)(me,it.Schemas.https))return me;throw we}},get remoteName(){return(0,Z.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Be.checkProposedApiEnabled)(We,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return pt.getLevel()},get onDidChangeLogLevel(){return pt.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Nn);const Hn={createTestController(me,we,Ue){return sn.createTestController(me,we,Ue)},createTestObserver(){return(0,Be.checkProposedApiEnabled)(We,"testObserver"),sn.createTestObserver()},runTests(me){return(0,Be.checkProposedApiEnabled)(We,"testObserver"),sn.runTests(me)},get onDidChangeTestResults(){return(0,Be.checkProposedApiEnabled)(We,"testObserver"),sn.onResultsChanged},get testResults(){return(0,Be.checkProposedApiEnabled)(We,"testObserver"),sn.results}},mn=rt.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,jn={getExtension(me,we){(0,Be.isProposedApiEnabled)(We,"extensionsAny")||(we=!1);const Ue=$t.mine.getExtensionDescription(me);if(Ue)return new u.Extension(Ft,We.identifier,Ue,mn,!1);if(we){const at=$t.all.getExtensionDescription(me);if(at)return new u.Extension(Ft,We.identifier,at,mn,!0)}},get all(){const me=[];for(const we of $t.mine.getAllExtensionDescriptions())me.push(new u.Extension(Ft,We.identifier,we,mn,!1));return me},get allAcrossExtensionHosts(){(0,Be.checkProposedApiEnabled)(We,"extensionsAny");const me=new Be.ExtensionIdentifierSet($t.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),we=[];for(const Ue of $t.all.getAllExtensionDescriptions()){const at=!me.has(Ue.identifier);we.push(new u.Extension(Ft,We.identifier,Ue,mn,at))}return we},get onDidChange(){return(0,Be.isProposedApiEnabled)(We,"extensionsAny")?I.Event.any($t.mine.onDidChange,$t.all.onDidChange):$t.mine.onDidChange}},Tn={createDiagnosticCollection(me){return Jt.createDiagnosticCollection(We.identifier,me)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:me=>Jt.getDiagnostics(me),getLanguages(){return ln.getLanguages()},setTextDocumentLanguage(me,we){return ln.changeLanguage(me.uri,we)},match(me,we){const Ue=bt.getDocumentData(we.uri)?.notebook;return(0,L.score)(U.LanguageSelector.from(me),we.uri,we.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(me,we,Ue){return ut.registerCodeActionProvider(We,wt(me),we,Ue)},registerDocumentPasteEditProvider(me,we,Ue){return(0,Be.checkProposedApiEnabled)(We,"documentPaste"),ut.registerDocumentPasteEditProvider(We,wt(me),we,Ue)},registerCodeLensProvider(me,we){return ut.registerCodeLensProvider(We,wt(me),we)},registerDefinitionProvider(me,we){return ut.registerDefinitionProvider(We,wt(me),we)},registerDeclarationProvider(me,we){return ut.registerDeclarationProvider(We,wt(me),we)},registerImplementationProvider(me,we){return ut.registerImplementationProvider(We,wt(me),we)},registerTypeDefinitionProvider(me,we){return ut.registerTypeDefinitionProvider(We,wt(me),we)},registerHoverProvider(me,we){return ut.registerHoverProvider(We,wt(me),we,We.identifier)},registerEvaluatableExpressionProvider(me,we){return ut.registerEvaluatableExpressionProvider(We,wt(me),we,We.identifier)},registerInlineValuesProvider(me,we){return ut.registerInlineValuesProvider(We,wt(me),we,We.identifier)},registerDocumentHighlightProvider(me,we){return ut.registerDocumentHighlightProvider(We,wt(me),we)},registerLinkedEditingRangeProvider(me,we){return ut.registerLinkedEditingRangeProvider(We,wt(me),we)},registerReferenceProvider(me,we){return ut.registerReferenceProvider(We,wt(me),we)},registerRenameProvider(me,we){return ut.registerRenameProvider(We,wt(me),we)},registerDocumentSymbolProvider(me,we,Ue){return ut.registerDocumentSymbolProvider(We,wt(me),we,Ue)},registerWorkspaceSymbolProvider(me){return ut.registerWorkspaceSymbolProvider(We,me)},registerDocumentFormattingEditProvider(me,we){return ut.registerDocumentFormattingEditProvider(We,wt(me),we)},registerDocumentRangeFormattingEditProvider(me,we){return ut.registerDocumentRangeFormattingEditProvider(We,wt(me),we)},registerOnTypeFormattingEditProvider(me,we,Ue,...at){return ut.registerOnTypeFormattingEditProvider(We,wt(me),we,[Ue].concat(at))},registerDocumentSemanticTokensProvider(me,we,Ue){return ut.registerDocumentSemanticTokensProvider(We,wt(me),we,Ue)},registerDocumentRangeSemanticTokensProvider(me,we,Ue){return ut.registerDocumentRangeSemanticTokensProvider(We,wt(me),we,Ue)},registerSignatureHelpProvider(me,we,Ue,...at){return typeof Ue=="object"?ut.registerSignatureHelpProvider(We,wt(me),we,Ue):ut.registerSignatureHelpProvider(We,wt(me),we,typeof Ue>"u"?[]:[Ue,...at])},registerCompletionItemProvider(me,we,...Ue){return ut.registerCompletionItemProvider(We,wt(me),we,Ue)},registerInlineCompletionItemProvider(me,we){return we.handleDidShowCompletionItem&&(0,Be.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(We,wt(me),we)},registerDocumentLinkProvider(me,we){return ut.registerDocumentLinkProvider(We,wt(me),we)},registerColorProvider(me,we){return ut.registerColorProvider(We,wt(me),we)},registerFoldingRangeProvider(me,we){return ut.registerFoldingRangeProvider(We,wt(me),we)},registerSelectionRangeProvider(me,we){return ut.registerSelectionRangeProvider(We,me,we)},registerCallHierarchyProvider(me,we){return ut.registerCallHierarchyProvider(We,me,we)},registerTypeHierarchyProvider(me,we){return ut.registerTypeHierarchyProvider(We,me,we)},setLanguageConfiguration:(me,we)=>ut.setLanguageConfiguration(We,me,we),getTokenInformationAtPosition(me,we){return(0,Be.checkProposedApiEnabled)(We,"tokenInformation"),ln.tokenAtPosition(me,we)},registerInlayHintsProvider(me,we){return ut.registerInlayHintsProvider(We,me,we)},createLanguageStatusItem(me,we){return ln.createLanguageStatusItem(We,me,we)},registerDocumentDropEditProvider(me,we){return ut.registerDocumentOnDropEditProvider(We,me,we)}},Vn={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return Ve.activeTerminal},get terminals(){return Ve.terminals},async showTextDocument(me,we,Ue){const at=await(C.URI.isUri(me)?Promise.resolve(Gt.openTextDocument(me)):Promise.resolve(me));return Lt.showTextDocument(at,we,Ue)},createTextEditorDecorationType(me){return Lt.createTextEditorDecorationType(We,me)},onDidChangeActiveTextEditor(me,we,Ue){return Lt.onDidChangeActiveTextEditor(me,we,Ue)},onDidChangeVisibleTextEditors(me,we,Ue){return Lt.onDidChangeVisibleTextEditors(me,we,Ue)},onDidChangeTextEditorSelection(me,we,Ue){return Lt.onDidChangeTextEditorSelection(me,we,Ue)},onDidChangeTextEditorOptions(me,we,Ue){return Lt.onDidChangeTextEditorOptions(me,we,Ue)},onDidChangeTextEditorVisibleRanges(me,we,Ue){return Lt.onDidChangeTextEditorVisibleRanges(me,we,Ue)},onDidChangeTextEditorViewColumn(me,we,Ue){return Lt.onDidChangeTextEditorViewColumn(me,we,Ue)},onDidCloseTerminal(me,we,Ue){return Ve.onDidCloseTerminal(me,we,Ue)},onDidOpenTerminal(me,we,Ue){return Ve.onDidOpenTerminal(me,we,Ue)},onDidChangeActiveTerminal(me,we,Ue){return Ve.onDidChangeActiveTerminal(me,we,Ue)},onDidChangeTerminalDimensions(me,we,Ue){return(0,Be.checkProposedApiEnabled)(We,"terminalDimensions"),Ve.onDidChangeTerminalDimensions(me,we,Ue)},onDidChangeTerminalState(me,we,Ue){return Ve.onDidChangeTerminalState(me,we,Ue)},onDidWriteTerminalData(me,we,Ue){return(0,Be.checkProposedApiEnabled)(We,"terminalDataWriteEvent"),Ve.onDidWriteTerminalData(me,we,Ue)},get state(){return Oe.state},onDidChangeWindowState(me,we,Ue){return Oe.onDidChangeWindowState(me,we,Ue)},showInformationMessage(me,...we){return kn.showMessage(We,A.default.Info,me,we[0],we.slice(1))},showWarningMessage(me,...we){return kn.showMessage(We,A.default.Warning,me,we[0],we.slice(1))},showErrorMessage(me,...we){return kn.showMessage(We,A.default.Error,me,we[0],we.slice(1))},showQuickPick(me,we,Ue){return Xt.showQuickPick(me,we,Ue)},showWorkspaceFolderPick(me){return Xt.showWorkspaceFolderPick(me)},showInputBox(me,we){return Xt.showInput(me,we)},showOpenDialog(me){return Rn.showOpenDialog(me)},showSaveDialog(me){return Rn.showSaveDialog(me)},createStatusBarItem(me,we,Ue){let at,Dt,Ot;return typeof me=="string"?(at=me,Dt=we,Ot=Ue):(Dt=me,Ot=we),Ln.createStatusBarEntry(We,at,Dt,Ot)},setStatusBarMessage(me,we){return Ln.setStatusBarMessage(me,we)},withScmProgress(me){return Ae.report("window.withScmProgress",We,"Use 'withProgress' instead."),dn.withProgress(We,{location:W.ProgressLocation.SourceControl},(we,Ue)=>me({report(at){}}))},withProgress(me,we){return dn.withProgress(We,me,we)},createOutputChannel(me,we){return kt.createOutputChannel(me,we,We)},createWebviewPanel(me,we,Ue,at){return rn.createWebviewPanel(We,me,we,Ue,at)},createWebviewTextEditorInset(me,we,Ue,at){return(0,Be.checkProposedApiEnabled)(We,"editorInsets"),Vt.createWebviewEditorInset(me,we,Ue,at,We)},createTerminal(me,we,Ue){return typeof me=="object"?"pty"in me?Ve.createExtensionTerminal(me):Ve.createTerminalFromOptions(me):Ve.createTerminal(me,we,Ue)},registerTerminalLinkProvider(me){return Ve.registerLinkProvider(me)},registerTerminalProfileProvider(me,we){return Ve.registerProfileProvider(We,me,we)},registerTerminalQuickFixProvider(me,we){return(0,Be.checkProposedApiEnabled)(We,"terminalQuickFixProvider"),Ve.registerTerminalQuickFixProvider(me,We.identifier.value,we)},registerTreeDataProvider(me,we){return cn.registerTreeDataProvider(me,we,We)},createTreeView(me,we){return cn.createTreeView(me,we,We)},registerWebviewPanelSerializer:(me,we)=>rn.registerWebviewPanelSerializer(We,me,we),registerCustomEditorProvider:(me,we,Ue={})=>yn.registerCustomEditorProvider(We,me,we,Ue),registerFileDecorationProvider(me){return Ne.registerFileDecorationProvider(me,We)},registerUriHandler(me){return Et.registerUriHandler(We.identifier,me)},createQuickPick(){return Xt.createQuickPick(We)},createInputBox(){return Xt.createInputBox(We)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(me,we,Ue){return hn.onDidChangeActiveColorTheme(me,we,Ue)},registerWebviewViewProvider(me,we,Ue){return Cn.registerWebviewViewProvider(We,me,we,Ue?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,we,Ue){return Ct.onDidChangeActiveNotebookEditor(me,we,Ue)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,we,Ue){return an.onDidChangeNotebookEditorSelection(me,we,Ue)},onDidChangeNotebookEditorVisibleRanges(me,we,Ue){return an.onDidChangeNotebookEditorVisibleRanges(me,we,Ue)},showNotebookDocument(me,we){return Ct.showNotebookDocument(me,we)},registerExternalUriOpener(me,we,Ue){return(0,Be.checkProposedApiEnabled)(We,"externalUriOpener"),Dn.registerExternalUriOpener(We.identifier,me,we,Ue)},registerProfileContentHandler(me,we){return(0,Be.checkProposedApiEnabled)(We,"profileContentHandlers"),In.registrProfileContentHandler(We,me,we)},get tabGroups(){return re.tabGroups}},Gt={get rootPath(){return Ae.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(me){throw t.readonly()},getWorkspaceFolder(me){return gt.getWorkspaceFolder(me)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(me){throw t.readonly()},get workspaceFile(){return gt.workspaceFile},set workspaceFile(me){throw t.readonly()},updateWorkspaceFolders:(me,we,...Ue)=>gt.updateWorkspaceFolders(We,me,we||0,...Ue),onDidChangeWorkspaceFolders:function(me,we,Ue){return gt.onDidChangeWorkspace(me,we,Ue)},asRelativePath:(me,we)=>gt.getRelativePath(me,we),findFiles:(me,we,Ue,at)=>gt.findFiles(me,we,Ue,We.identifier,at),findTextInFiles:(me,we,Ue,at)=>{(0,Be.checkProposedApiEnabled)(We,"findTextInFiles");let Dt,Ot;return typeof we=="object"?(Dt=we,Ot=Ue):(Dt={},Ot=we,at=Ue),gt.findTextInFiles(me,Dt||{},Ot,We.identifier,at)},saveAll:me=>gt.saveAll(me),applyEdit(me,we){return zn.applyWorkspaceEdit(me,We,we)},createFileSystemWatcher:(me,we,Ue,at)=>qt.createFileSystemWatcher(gt,We,me,we,Ue,at),get textDocuments(){return bt.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw t.readonly()},openTextDocument(me){let we;const Ue=me;if(typeof me=="string")we=Promise.resolve(C.URI.file(me));else if(C.URI.isUri(me))we=Promise.resolve(me);else if(!Ue||typeof Ue=="object")we=bt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(at=>bt.ensureDocumentData(at).then(Dt=>Dt.document))},onDidOpenTextDocument:(me,we,Ue)=>bt.onDidAddDocument(me,we,Ue),onDidCloseTextDocument:(me,we,Ue)=>bt.onDidRemoveDocument(me,we,Ue),onDidChangeTextDocument:(me,we,Ue)=>bt.onDidChangeDocument(me,we,Ue),onDidSaveTextDocument:(me,we,Ue)=>bt.onDidSaveDocument(me,we,Ue),onWillSaveTextDocument:(me,we,Ue)=>on.getOnWillSaveTextDocumentEvent(We)(me,we,Ue),get notebookDocuments(){return Ct.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,we){let Ue;if(C.URI.isUri(me))Ue=me,await Ct.openNotebookDocument(me);else if(typeof me=="string")Ue=C.URI.revive(await Ct.createNotebookDocument({viewType:me,content:we}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(me,we,Ue){return tn.onDidSaveNotebookDocument(me,we,Ue)},onDidChangeNotebookDocument(me,we,Ue){return tn.onDidChangeNotebookDocument(me,we,Ue)},get onDidOpenNotebookDocument(){return Ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Ct.onDidCloseNotebookDocument},registerNotebookSerializer(me,we,Ue,at){return Ct.registerNotebookSerializer(We,me,we,Ue,(0,Be.isProposedApiEnabled)(We,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(me,we,Ue)=>On.onDidChangeConfiguration(me,we,Ue),getConfiguration(me,we){return we=arguments.length===1?void 0:we,On.getConfiguration(me,we,We)},registerTextDocumentContentProvider(me,we){return jt.registerTextDocumentContentProvider(me,we)},registerTaskProvider:(me,we)=>(Ae.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(We,me,we)),registerFileSystemProvider(me,we,Ue){return(0,Le.combinedDisposable)(Zt.registerFileSystemProvider(We,me,we,Ue),Pt.addFileSystemProvider(me,we))},get fs(){return Pt.value},registerFileSearchProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"fileSearchProvider"),St.registerFileSearchProvider(me,we)),registerTextSearchProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"textSearchProvider"),St.registerTextSearchProvider(me,we)),registerRemoteAuthorityResolver:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"resolvers"),Ft.registerRemoteAuthorityResolver(me,we)),registerResourceLabelFormatter:me=>((0,Be.checkProposedApiEnabled)(We,"resolvers"),Sn.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,we,Ue)=>qt.onDidCreateFile(me,we,Ue),onDidDeleteFiles:(me,we,Ue)=>qt.onDidDeleteFile(me,we,Ue),onDidRenameFiles:(me,we,Ue)=>qt.onDidRenameFile(me,we,Ue),onWillCreateFiles:(me,we,Ue)=>qt.getOnWillCreateFileEvent(We)(me,we,Ue),onWillDeleteFiles:(me,we,Ue)=>qt.getOnWillDeleteFileEvent(We)(me,we,Ue),onWillRenameFiles:(me,we,Ue)=>qt.getOnWillRenameFileEvent(We)(me,we,Ue),openTunnel:me=>((0,Be.checkProposedApiEnabled)(We,"tunnels"),At.openTunnel(We,me).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,Be.checkProposedApiEnabled)(We,"tunnels"),At.getTunnels()},onDidChangeTunnels:(me,we,Ue)=>((0,Be.checkProposedApiEnabled)(We,"tunnels"),At.onDidChangeTunnels(me,we,Ue)),registerPortAttributesProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"portsAttributes"),At.registerPortsAttributesProvider(me,we)),registerTimelineProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"timeline"),Un.registerTimelineProvider(me,we,We.identifier,Qe.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:me=>((0,Be.checkProposedApiEnabled)(We,"workspaceTrust"),gt.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,we,Ue)=>gt.onDidGrantWorkspaceTrust(me,we,Ue),registerEditSessionIdentityProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(me,we))},gn={get inputBox(){return Ae.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),un.getLastInputBox(We)},createSourceControl(me,we,Ue){return un.createSourceControl(We,me,we,Ue)}},qn={createCommentController(me,we){return En.createCommentController(We,me,we)}},zt={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(me,we,Ue){return tt.onDidStartDebugSession(me,we,Ue)},onDidTerminateDebugSession(me,we,Ue){return tt.onDidTerminateDebugSession(me,we,Ue)},onDidChangeActiveDebugSession(me,we,Ue){return tt.onDidChangeActiveDebugSession(me,we,Ue)},onDidReceiveDebugSessionCustomEvent(me,we,Ue){return tt.onDidReceiveDebugSessionCustomEvent(me,we,Ue)},onDidChangeBreakpoints(me,we,Ue){return tt.onDidChangeBreakpoints(me,we,Ue)},registerDebugConfigurationProvider(me,we,Ue){return tt.registerDebugConfigurationProvider(me,we,Ue||xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,we){return tt.registerDebugAdapterDescriptorFactory(We,me,we)},registerDebugAdapterTrackerFactory(me,we){return tt.registerDebugAdapterTrackerFactory(me,we)},startDebugging(me,we,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?tt.startDebugging(me,we,{parentSession:Ue}):tt.startDebugging(me,we,Ue||{})},stopDebugging(me){return tt.stopDebugging(me)},addBreakpoints(me){return tt.addBreakpoints(me)},removeBreakpoints(me){return tt.removeBreakpoints(me)},asDebugSourceUri(me,we){return tt.asDebugSourceUri(me,we)}},pn={registerTaskProvider:(me,we)=>yt.registerTaskProvider(We,me,we),fetchTasks:me=>yt.fetchTasks(me),executeTask:me=>yt.executeTask(We,me),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(me,we,Ue)=>yt.onDidStartTask(me,we,Ue),onDidEndTask:(me,we,Ue)=>yt.onDidEndTask(me,we,Ue),onDidStartTaskProcess:(me,we,Ue)=>yt.onDidStartTaskProcess(me,we,Ue),onDidEndTaskProcess:(me,we,Ue)=>yt.onDidEndTaskProcess(me,we,Ue)},Gn={createNotebookController(me,we,Ue,at,Dt){return Yt.createNotebookController(We,me,we,Ue,at,(0,Be.isProposedApiEnabled)(We,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(me,we)=>Ct.registerNotebookCellStatusBarItemProvider(We,me,we),createRendererMessaging(me){return vn.createRendererMessaging(We,me)},createNotebookControllerDetectionTask(me){return(0,Be.checkProposedApiEnabled)(We,"notebookKernelSource"),Yt.createNotebookControllerDetectionTask(We,me)},registerKernelSourceActionProvider(me,we){return(0,Be.checkProposedApiEnabled)(We,"notebookKernelSource"),Yt.registerKernelSourceActionProvider(We,me,we)},onDidChangeNotebookCellExecutionState(me,we,Ue){return(0,Be.checkProposedApiEnabled)(We,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(me,we,Ue)}},Kn={t(...me){if(typeof me[0]=="string"){const we=me.shift(),Ue=!me||typeof me[0]!="object"?me:me[0];return vt.getMessage(We.identifier.value,{message:we,args:Ue})}return vt.getMessage(We.identifier.value,me[0])},get bundle(){return vt.getBundle(We.identifier.value)},get uri(){return vt.getBundleUri(We.identifier.value)}};return{version:rt.version,authentication:Wn,commands:fn,comments:qn,debug:zt,env:Nn,extensions:jn,l10n:Kn,languages:Tn,notebooks:Gn,scm:gn,tasks:pn,tests:Hn,window:Vn,workspace:Gt,Breakpoint:W.Breakpoint,TerminalOutputAnchor:W.TerminalOutputAnchor,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CommentThreadState:W.CommentThreadState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileDecoration2:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestionList,Hover:W.Hover,IndentAction:y.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalQuickFixCommand:W.TerminalQuickFixCommand,TerminalQuickFixOpener:W.TerminalQuickFixOpener,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TerminalExitReason:W.TerminalExitReason,TerminalQuickFixType:W.TerminalQuickFixType,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,SnippetTextEdit:W.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItem2:W.TreeItem,TreeItemCheckboxState:W.TreeItemCheckboxState,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:D.UIKind,Uri:C.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,DocumentDropEdit:W.DocumentDropEdit,DocumentPasteEdit:W.DocumentPasteEdit,InlayHint:W.InlayHint,InlayHintLabelPart:W.InlayHintLabelPart,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,NotebookControllerAffinity2:W.NotebookControllerAffinity2,NotebookEdit:W.NotebookEdit,NotebookKernelSourceAction:W.NotebookKernelSourceAction,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestMessage:W.TestMessage,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:W.DataTransfer,DataTransferItem:W.DataTransferItem,CoveredCount:W.CoveredCount,FileCoverage:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,FunctionCoverage:W.FunctionCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity,QuickPickItemKind:W.QuickPickItemKind,InputBoxValidationSeverity:W.InputBoxValidationSeverity,TabInputText:W.TextTabInput,TabInputTextDiff:W.TextDiffTabInput,TabInputTextMerge:W.TextMergeTabInput,TabInputCustom:W.CustomEditorTabInput,TabInputNotebook:W.NotebookEditorTabInput,TabInputNotebookDiff:W.NotebookDiffEditorTabInput,TabInputWebview:W.WebviewEditorTabInput,TabInputTerminal:W.TerminalEditorTabInput,TabInputInteractiveWindow:W.InteractiveWindowInput,TrustedTelemetryValue:x.TrustedTelemetryValue,LogLevel:ze.LogLevel,EditSessionIdentityMatch:mt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=lt}),define(Se[302],ye([1,0,274,311,312,2,313]),function(ne,e,c,t,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(P,E,D,v,d,m){const h=m.environment.useHostProxy,b=typeof h=="boolean"?h:!m.remote.isRemote,p=(0,C.createProxyResolver)({resolveProxy:w=>P.resolveProxy(w),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(w,s,...r)=>{switch(w){case C.LogLevel.Trace:v.trace(s,...r);break;case C.LogLevel.Debug:v.debug(s,...r);break;case C.LogLevel.Info:v.info(s,...r);break;case C.LogLevel.Warning:v.warn(s,...r);break;case C.LogLevel.Error:v.error(s,...r);break;case C.LogLevel.Critical:v.error(s,...r);break;case C.LogLevel.Off:break;default:l(w,s,r);break}function l(u,o,...a){v.error("Unknown log level",u),v.error(o,...a)}},getLogLevel:()=>v.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:b,env:process.env}),g=S(E,p);return L(D,g)}e.connectProxyResolver=T;function S(P,E){const D={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(d=>{D.config=P.getConfiguration("http").get("proxySupport")||"off"});const v={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(d=>{v.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,C.createHttpPatch)(c,E,{config:"off"},v,!0)),on:Object.assign({},c,(0,C.createHttpPatch)(c,E,{config:"on"},v,!0)),override:Object.assign({},c,(0,C.createHttpPatch)(c,E,{config:"override"},v,!0)),onRequest:Object.assign({},c,(0,C.createHttpPatch)(c,E,D,v,!0)),default:Object.assign(c,(0,C.createHttpPatch)(c,E,D,v,!1))},https:{off:Object.assign({},t,(0,C.createHttpPatch)(t,E,{config:"off"},v,!0)),on:Object.assign({},t,(0,C.createHttpPatch)(t,E,{config:"on"},v,!0)),override:Object.assign({},t,(0,C.createHttpPatch)(t,E,{config:"override"},v,!0)),onRequest:Object.assign({},t,(0,C.createHttpPatch)(t,E,D,v,!0)),default:Object.assign(t,(0,C.createHttpPatch)(t,E,D,v,!1))},tls:Object.assign(I,(0,C.createTlsPatch)(I))}}const y=new Map;function L(P,E){return P.getExtensionPathIndex().then(D=>{const v=globalThis._VSCODE_NODE_MODULES.module,d=v._load;v._load=function(h,b,p){if(h==="tls")return E.tls;if(h!=="http"&&h!=="https")return d.apply(this,arguments);const g=E[h],w=D.findSubstr(A.URI.file(b.filename));let s=y.get(w);if(s||y.set(w,s={}),!s[h]){const r=g.default;s[h]={...r}}return s[h]}})}}),define(Se[303],ye([1,0,76,301,288,302,41,276,2,15,7,273,113,275]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class v extends I.RequireInterceptor{j(){const h=this,b=globalThis._VSCODE_NODE_MODULES.module,p=b._load;b._load=function(r,l,u){return r=w(r),h.a.has(r)?h.a.get(r).load(r,S.URI.file((0,E.realpathSync)(l.filename)),o=>p.apply(this,[o,l,u])):p.apply(this,arguments)};const g=b._resolveLookupPaths;b._resolveLookupPaths=(s,r)=>g.call(this,w(s),r);const w=s=>{for(const r of h.b){const l=r(s);if(l){s=l;break}}return s}}}class d extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async nb(){this.h.createInstance(D.ExtHostConsoleForwarder);const h=this.h.invokeFunction(t.createApiFactoryAndRegisterActors);if(this.h.createInstance(T.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const g=this.h.createInstance(P.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=g.ipcHandlePath}await this.h.createInstance(v,h,{mine:this.D,all:this.F}).install(),c.mark("code/extHost/didInitAPI");const p=await this.k.getConfigProvider();await(0,A.connectProxyResolver)(this.j,p,this,this.l,this.u,this.f),c.mark("code/extHost/didInitProxyResolver")}ob(h){return h.main}async pb(h,b,p){if(b.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let g=null;p.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this.l.flush();const w=h?.identifier.value;h&&await this.s.initializeLocalizedMessages(h);try{w&&c.mark(`code/extHost/willLoadExtensionCode/${w}`),g=ne.__$__nodeRequire(b.fsPath)}finally{w&&c.mark(`code/extHost/didLoadExtensionCode/${w}`),p.codeLoadingStop()}return g}async $setRemoteEnvironment(h){if(!!this.f.remote.isRemote)for(const b in h){const p=h[b];p===null?delete process.env[b]:process.env[b]=p}}}e.ExtHostExtensionService=d}),define(Se[145],ye([1,0,45,314,297,17,80,37,9,8,2,31,74,315,295,98]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const m=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(f){this.a=f}provideTextSearchResults(f,k,R,B){return this.a.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...k,folder:k.folder.toString()})}`),new Promise((X,q)=>{B.onCancellationRequested(()=>V());const N=r(f,k),M=k.folder.fsPath,F=N.map(le=>le.match(/^-/)?le:`'${le}'`).join(" ");this.a.appendLine(`${m} ${F}
 - cwd: ${M}`);let z=c.spawn(m,N,{cwd:M});z.on("error",le=>{console.error(le),this.a.appendLine("Error: "+(le&&le.message)),q((0,P.serializeSearchError)(new P.SearchError(le&&le.message,P.SearchErrorCode.rgProcessError)))});let U=!1;const W=new g(k.maxResults,M,k.previewOptions);W.on("result",le=>{U=!0,Q="",R.report(le)});let x=!1;const V=()=>{x=!0,z?.kill(),W?.cancel()};let _=!1;W.on("hitLimit",()=>{_=!0,V()});let Q="";z.stdout.on("data",le=>{W.handleData(le),U||(Q+=le)});let J=!1;z.stdout.once("data",()=>J=!0);let te="";z.stderr.on("data",le=>{const Z=le.toString();this.a.appendLine(Z),te.length+Z.length<1e6&&(te+=Z)}),z.on("close",()=>{if(this.a.appendLine(J?"Got data from stdout":"No data from stdout"),this.a.appendLine(U?"Got result from parser":"No result from parser"),Q&&this.a.appendLine(`Got data without result: ${Q}`),this.a.appendLine(""),x)X({limitHit:_});else{W.flush(),z=null;let le;te&&!J&&(le=b(te))?q((0,P.serializeSearchError)(new P.SearchError(le.message,le.code))):X({limitHit:_})}})})}}e.RipgrepTextSearchEngine=h;function b(i){const f=i.split(`
`),k=f[0].trim();if(f.some(B=>B.startsWith("regex parse error")))return new P.SearchError(p(f),P.SearchErrorCode.regexParseError);const R=k.match(/grep config error: unknown encoding: (.*)/);if(R)return new P.SearchError(`Unknown encoding: ${R[1]}`,P.SearchErrorCode.unknownEncoding);if(k.startsWith("error parsing glob"))return new P.SearchError(k.charAt(0).toUpperCase()+k.substr(1),P.SearchErrorCode.globParseError);if(k.startsWith("the literal"))return new P.SearchError(k.charAt(0).toUpperCase()+k.substr(1),P.SearchErrorCode.invalidLiteral);if(k.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(k,P.SearchErrorCode.regexParseError)}function p(i){const f=["Regex parse error"],k=i.filter(R=>R.startsWith("PCRE2:"));if(k.length>=1){const R=k[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const B=R.split(":")[1];f.push(":"+B)}}return f.join("")}class g extends t.EventEmitter{constructor(f,k,R){super(),this.g=f,this.h=k,this.j=R,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new I.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(f,k){return super.on(f,k),this}handleData(f){if(this.b)return;const k=typeof f=="string"?f:this.d.write(f);this.k(k)}k(f){let k=f.indexOf(`
`);const R=this.a+f;if(k>=0)k+=this.a.length;else{this.a=R;return}let B=0;for(;k>=0;)this.m(R.substring(B,k).trim()),B=k+1,k=R.indexOf(`
`,B);this.a=R.substring(B)}m(f){if(this.b||!f)return;let k;try{k=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(k.type==="match"){const R=w(k.data.path),B=L.URI.file(S.join(this.h,R)),X=this.n(k.data,B);this.p(X),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(k.type==="context"){const R=w(k.data.path),B=L.URI.file(S.join(this.h,R));this.o(k.data,B).forEach(q=>this.p(q))}}n(f,k){const R=f.line_number-1,B=w(f.lines),X=Buffer.from(B);let q=0,N=0,M=R;f.submatches.length===0&&f.submatches.push(B.length?{start:0,end:1,match:{text:B[0]}}:{start:0,end:0,match:{text:""}});const F=(0,A.coalesce)(f.submatches.map((z,U)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const W=w(z.match),x=X.slice(q,z.start).toString(),V=s(x),_=V.numLines>0?V.lastLineLength:V.lastLineLength+N,Q=s(W),J=V.numLines+M,te=Q.numLines+J,le=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+_;return q=z.end,N=le,M=te,new E.Range(J,_,te,le)}));return(0,d.createTextSearchResult)(k,B,F,this.j)}o(f,k){const R=w(f.lines),B=f.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((X,q)=>({text:X,uri:k,lineNumber:B+q}))}p(f){this.emit("result",f)}}e.RipgrepParser=g;function w(i){return i.bytes?Buffer.from(i.bytes,"base64").toString():i.text}function s(i){const f=/\n/g;let k=0,R=-1,B;for(;B=f.exec(i);)k++,R=B.index;const X=R>=0?i.length-R-1:i.length;return{numLines:k,lastLineLength:X}}function r(i,f){const k=["--hidden"];k.push(i.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:B}=(0,C.groupBy)(f.includes,q=>q.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(B&&B.length){const q=new Set;B.forEach(N=>{q.add(N)}),k.push("-g","!*"),q.forEach(N=>{l(N).map(d.anchorGlob).forEach(M=>{k.push("-g",M)})})}R&&R.length&&R.forEach(q=>{k.push("-g",q)}),f.excludes.map(d.anchorGlob).forEach(q=>k.push("-g",`!${q}`)),f.maxFileSize&&k.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||k.push("--no-ignore-parent"):k.push("--no-ignore"),f.followSymlinks&&k.push("--follow"),f.encoding&&f.encoding!=="utf8"&&k.push("--encoding",f.encoding),i.pattern==="--"&&(i.isRegExp=!0,i.pattern="\\-\\-"),i.isMultiline&&!i.isRegExp&&(i.pattern=(0,y.escapeRegExpCharacters)(i.pattern),i.isRegExp=!0),f.usePCRE2&&k.push("--pcre2"),k.push("--crlf"),i.isRegExp&&(i.pattern=u(i.pattern),k.push("--engine","auto"));let X;if(i.isWordMatch){const N=(0,y.createRegExp)(i.pattern,!!i.isRegExp,{wholeWord:i.isWordMatch}).source.replace(/\\\//g,"/");k.push("--regexp",N)}else if(i.isRegExp){let q=a(i.pattern);q=n(q),k.push("--regexp",q)}else X=i.pattern,k.push("--fixed-strings");return k.push("--no-config"),f.useGlobalIgnoreFiles||k.push("--no-ignore-global"),k.push("--json"),i.isMultiline&&k.push("--multiline"),f.beforeContext&&k.push("--before-context",f.beforeContext+""),f.afterContext&&k.push("--after-context",f.afterContext+""),k.push("--"),X&&k.push(X),k.push("."),k}function l(i){const f=(0,T.splitGlobAware)(i,"/");return f.map((k,R)=>f.slice(0,R+1).join("/"))}function u(i){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;i.match(f);)i=i.replace(f,"$1\\x{$2}");const k=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;i.match(k);)i=i.replace(k,"$1\\x{$2}");return i}e.unicodeEscapesToPCRE2=u;const o=i=>i.type==="Assertion"&&i.kind==="lookbehind";function a(i){let f;try{f=new D.RegExpParser().parsePattern(i)}catch{return i}let k="",R=0;const B=(N,M,F)=>{k+=i.slice(R,N)+F,R=M},X=[];return new D.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const M=X[0];if(!M)B(N.start,N.end,"\\r?\\n");else if(!X.some(o))if(M.type==="CharacterClass")if(M.negate){const F=i.slice(M.start+2,N.start)+i.slice(N.end,M.end-1);M.parent?.type==="Quantifier"?B(M.start,M.end,F?`[^${F}]`:"."):B(M.start,M.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=i.slice(M.start+1,N.start)+i.slice(N.end,M.end-1);B(M.start,M.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else M.type==="Quantifier"&&B(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){X.unshift(N)},onQuantifierLeave(){X.shift()},onCharacterClassRangeEnter(N){X.unshift(N)},onCharacterClassRangeLeave(){X.shift()},onCharacterClassEnter(N){X.unshift(N)},onCharacterClassLeave(){X.shift()},onAssertionEnter(N){o(N)&&X.push(N)},onAssertionLeave(N){X[0]===N&&X.shift()}}).visit(f),k+=i.slice(R),k}e.fixRegexNewline=a;function n(i){return i.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(Se[304],ye([1,0,21,145,124,15]),function(ne,e,c,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,L,P,E){const D=new t.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===A.Schemas.vscodeUserData){const v={...L,folder:L.folder.with({scheme:A.Schemas.file})},d=new I.Progress(m=>P.report({...m,uri:m.uri.with({scheme:L.folder.scheme})}));return this.c(E,m=>D.provideTextSearchResults(y,v,d,m))}else return this.c(E,v=>D.provideTextSearchResults(y,L,P,v))}async c(y,L){const P=T(y);this.a.add(P);const E=await L(P.token);return this.a.delete(P),E}d(){this.a.forEach(y=>y.cancel())}}e.RipgrepSearchProvider=C;function T(S){const y=new c.CancellationTokenSource;return S.onCancellationRequested(()=>y.cancel()),y}}),define(Se[305],ye([1,0,29,145,144]),function(ne,e,c,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(S){this.a=S}search(S,y,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(D){L({message:D})}},E=new I.NativeTextSearchManager(this.a,new t.RipgrepTextSearchEngine(P),c);return new Promise((D,v)=>E.search(d=>{y(d.map(C))},S).then(d=>D({limitHit:d.limitHit,type:"success",stats:d.stats}),v))}}e.TextSearchEngineAdapter=A;function C(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((S,y)=>{if(y.ranges){const L=y;return S+(Array.isArray(L.ranges)?L.ranges.length:1)}else return S+1},0)}}}),define(Se[306],ye([1,0,17,18,10,4,109,9,44,2,38,31,296,305]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class v{constructor(g="searchProcess"){this.d=g,this.b=Object.create(null)}fileSearch(g){let w;const s=h(g),r=new A.Emitter({onDidAddFirstListener:()=>{w=(0,t.createCancelablePromise)(l=>this.doFileSearchWithEngine(E.Engine,s,u=>r.fire(u),l)),w.then(l=>r.fire(l),l=>r.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{w.cancel()}});return r.event}textSearch(g){let w;const s=h(g),r=new A.Emitter({onDidAddFirstListener:()=>{w=(0,t.createCancelablePromise)(l=>this.f(s,u=>r.fire(u),l)),w.then(l=>r.fire(l),l=>r.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{w.cancel()}});return r.event}f(g,w,s){return g.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new D.TextSearchEngineAdapter(g).search(s,w,w)}doFileSearch(g,w,s){return this.doFileSearchWithEngine(E.Engine,g,w,s)}doFileSearchWithEngine(g,w,s,r,l=v.a){let u=0;const o=n=>{Array.isArray(n)?(u+=n.length,s(n.map(i=>this.g(i)))):n.relativePath?(u++,s(this.g(n))):s(n)};if(w.sortByScore){let n=this.k(w,o,r);if(!n){const i=w.maxResults?Object.assign({},w,{maxResults:null}):w,f=new g(i);n=this.h(f,w,s,o,r)}return new Promise((i,f)=>{n.then(([k,R])=>{const B=R.map(X=>this.g(X));this.n(B,s,l),i(k)},f)})}const a=new g(w);return this.q(a,o,l,r).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}g(g){return{path:g.base?(0,T.join)(g.base,g.relativePath):g.relativePath}}h(g,w,s,r,l){const u=new A.Emitter;let o=(0,t.createCancelablePromise)(n=>{let i=[];const f=k=>{Array.isArray(k)?i=k:(r(k),u.fire(k))};return this.q(g,f,-1,n).then(k=>[k,i])}),a;if(w.cacheKey){a=this.j(w.cacheKey);const n={promise:o,event:u.event,resolved:!1};a.resultsToSearchCache[w.filePattern||""]=n,o.then(()=>{n.resolved=!0},i=>{delete a.resultsToSearchCache[w.filePattern||""]}),o=this.r(o)}return o.then(([n,i])=>{const f=a?a.scorerCache:Object.create(null),k=(typeof w.maxResults!="number"||w.maxResults>0)&&S.StopWatch.create(!1);return this.l(w,i,f,l).then(R=>{const B=k?k.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:B,fromCache:!1,type:this.d,workspaceFolderCount:w.folderQueries.length,resultCount:R.length},messages:n.messages,limitHit:n.limitHit||typeof w.maxResults=="number"&&i.length>w.maxResults},R]})})}j(g){const w=this.b[g];return w||(this.b[g]=new d)}k(g,w,s){const r=g.cacheKey&&this.b[g.cacheKey];if(!r)return;const l=this.o(r,g.filePattern||"",w,s);if(l)return l.then(([u,o,a])=>{const n=S.StopWatch.create(!1);return this.l(g,o,r.scorerCache,s).then(i=>{const f=n.elapsed(),k={fromCache:!0,detailStats:a,type:this.d,resultCount:o.length,sortingTime:f};return[{type:"success",limitHit:u.limitHit||typeof g.maxResults=="number"&&o.length>g.maxResults,stats:k},i]})})}l(g,w,s,r){const l=(0,C.prepareQuery)(g.filePattern||""),u=(a,n)=>(0,C.compareItemsByFuzzyScore)(a,n,l,!0,m,s),o=typeof g.maxResults=="number"?g.maxResults:Number.MAX_VALUE;return c.topAsync(w,u,o,1e4,r)}n(g,w,s){if(s&&s>0)for(let r=0;r<g.length;r+=s)w(g.slice(r,r+s));else w(g)}o(g,w,s,r){const l=S.StopWatch.create(!1),u=w.indexOf(T.sep)>=0;let o;for(const f in g.resultsToSearchCache)if(w.startsWith(f)){if(u&&f.indexOf(T.sep)<0&&f!=="")continue;const k=g.resultsToSearchCache[f];o={promise:this.r(k.promise),event:k.event,resolved:k.resolved};break}if(!o)return null;const a=l.elapsed(),n=S.StopWatch.create(!1),i=o.event(s);return r&&r.onCancellationRequested(()=>{i.dispose()}),o.promise.then(([f,k])=>{if(r&&r.isCancellationRequested)throw(0,I.canceled)();const R=[],B=(0,C.prepareQuery)(w).normalizedLowercase;for(const X of k)!(0,P.isFilePatternMatch)(X,B)||R.push(X);return[f,R,{cacheWasResolved:o.resolved,cacheLookupTime:a,cacheFilterTime:n.elapsed(),cacheEntryCount:k.length}]})}q(g,w,s,r){return new Promise((l,u)=>{let o=[];r?.onCancellationRequested(()=>g.cancel()),g.search(a=>{a&&(s?(o.push(a),s>0&&o.length>=s&&(w(o),o=[])):w(a))},a=>{w(a)},(a,n)=>{o.length&&w(o),a?u(a):l(n)})})}clearCache(g){return delete this.b[g],Promise.resolve(void 0)}r(g){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(w,s){return g.then(w,s)}catch(w){return this.then(void 0,w)}finally(w){return g.finally(w)}}}}e.SearchService=v,v.a=512;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(p){return(0,T.basename)(p.relativePath)}getItemDescription(p){return(0,T.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function h(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(b),extraFileResources:p.extraFileResources&&p.extraFileResources.map(g=>y.URI.revive(g))}}function b(p){return{...p,folder:y.URI.revive(p.folder)}}}),define(Se[307],ye([1,0,6,15,2,29,13,25,16,78,55,31,306,304,98,144]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let m=class extends y.ExtHostSearch{constructor(b,p,g,w){super(b,g,w),this.s=A,this.t=-1,this.v=null,this.w=!1;const s=new v.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new D.RipgrepSearchProvider(s)),p.remote.isRemote&&p.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const b=new v.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(t.Schemas.file,new D.RipgrepSearchProvider(b)),this.y(t.Schemas.file,new E.SearchService("fileSearchProvider"))}y(b,p){const g=this.d++;return this.v=p,this.t=g,this.c.$registerFileSearchProvider(g,this.o(b)),(0,c.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(g)})}$provideFileSearchResults(b,p,g,w){const s=(0,y.reviveQuery)(g);return b===this.t?this.z(b,p,s,w):super.$provideFileSearchResults(b,p,g,w)}z(b,p,g,w){const s=r=>{if((0,P.isSerializedFileMatch)(r)&&(r=[r]),Array.isArray(r)){this.c.$handleFileMatch(b,p,r.map(l=>I.URI.file(l.path)));return}r.message&&this.n.debug("ExtHostSearch",r.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(g,s,w)}$clearCache(b){return this.v?.clearCache(b),super.$clearCache(b)}q(b,p){return new d.NativeTextSearchManager(b,p,void 0,"textSearchProvider")}};m=qe([He(0,S.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,L.IURITransformerService),He(3,C.ILogService)],m),e.NativeExtHostSearch=m}),define(Se[308],ye([1,0,87,279,291,290,307,303,280,77,41,78,75,40,54,72,278,277,13,292,48]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(L.IExtHostExtensionService,T.ExtHostExtensionService,0),(0,c.registerSingleton)(b.ILoggerService,h.ExtHostLoggerService,1),(0,c.registerSingleton)(d.IExtensionStoragePaths,m.ExtensionStoragePaths,0),(0,c.registerSingleton)(y.IExtHostDebugService,A.ExtHostDebugService,0),(0,c.registerSingleton)(P.IExtHostSearch,C.NativeExtHostSearch,0),(0,c.registerSingleton)(E.IExtHostTask,I.ExtHostTask,0),(0,c.registerSingleton)(D.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,c.registerSingleton)(v.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,c.registerSingleton)(g.IExtHostVariableResolverProvider,p.NodeExtHostVariableResolverProviderService,0)}),define(Se[316],ye([1,0,219,317,76,10,116,117,200,93,289,22,29,113,18,119,215,228,293,308]),function(ne,e,c,t,I,A,C,T,S,y,L,P,E,D,v,d,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let a=0;a<process.execArgv.length;a++)process.execArgv[a]==="--inspect-port=0"&&(process.execArgv.splice(a,1),a--)}();const b=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const o=globalThis._VSCODE_NODE_MODULES.module,a=o._load;o._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return a.apply(this,arguments)}})();const p=process.exit.bind(process);function g(o){process.exit=function(a){if(o)p(a);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const a=new Error("An extension called process.crash() and this was prevented.");console.warn(a.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let w=function(o){p()};function s(){const o=(0,h.readExtHostConnection)(process.env);if(o.type===3)return new Promise((a,n)=>{const i=f=>{const k=f[0],R=new C.BufferedEmitter;k.on("message",B=>R.fire(P.VSBuffer.wrap(B.data))),k.on("close",()=>{w("renderer closed the MessagePort")}),k.start(),a({onMessage:R.event,send:B=>k.postMessage(B.buffer)})};process?.parentPort.on("message",f=>i(f.ports))});if(o.type===2)return new Promise((a,n)=>{let i=null;const f=setTimeout(()=>{w("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),k=108e5,R=3e5,B=new v.ProcessTimeRunOnceScheduler(()=>w("renderer disconnected for too long (1)"),k),X=new v.ProcessTimeRunOnceScheduler(()=>w("renderer disconnected for too long (2)"),R);process.on("message",(N,M)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const F=P.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let z;if(N.skipWebSocketFrames)z=new T.NodeSocket(M,"extHost-socket");else{const U=P.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));z=new T.WebSocketNodeSocket(new T.NodeSocket(M,"extHost-socket"),N.permessageDeflate,U,!1)}i?(B.cancel(),X.cancel(),i.beginAcceptReconnection(z,F),i.endAcceptReconnection(),i.sendResume()):(clearTimeout(f),i=new C.PersistentProtocol(z,F),i.sendResume(),i.onDidDispose(()=>w("renderer disconnected")),a(i),i.onSocketClose(()=>{B.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(X.isScheduled())return;B.isScheduled()&&X.schedule()}});const q={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(q)});{const a=o.pipeName;return new Promise((n,i)=>{const f=c.createConnection(a,()=>{f.removeListener("error",i);const k=new C.PersistentProtocol(new T.NodeSocket(f,"extHost-renderer"));k.sendResume(),n(k)});f.once("error",i),f.on("close",()=>{w("renderer closed the socket")})})}}async function r(){const o=await s();return new class{constructor(){this.a=new C.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,o.onMessage(a=>{(0,y.isMessageOfType)(a,2)?(this.b=!0,w("received terminate message from renderer")):this.a.fire(a)})}send(a){this.b||o.send(a)}async drain(){if(o.drain)return o.drain()}}}function l(o){return new Promise(a=>{const n=o.onMessage(i=>{n.dispose();const f=JSON.parse(i.toString()),k=f.commit,R=S.default.commit;if(k&&R&&k!==R&&p(55),f.parentPid){let B=0;setInterval(function(){try{process.kill(f.parentPid,0),B=0}catch(q){q&&q.code==="EPERM"?(B++,B>=3&&w(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${q.message} (code: ${q.code}) (errno: ${q.errno})`)):w(`parent process ${f.parentPid} does not exist anymore: ${q.message} (code: ${q.code}) (errno: ${q.errno})`)}},1e3);let X;try{X=globalThis._VSCODE_NODE_MODULES["native-watchdog"],X.start(f.parentPid)}catch(q){(0,A.onUnexpectedError)(q)}}o.send((0,y.createMessageOfType)(0)),a({protocol:o,initData:f})});o.send((0,y.createMessageOfType)(1))})}async function u(){const o=[];process.on("unhandledRejection",(B,X)=>{o.push(X),setTimeout(()=>{const q=o.indexOf(X);q>=0&&X.catch(N=>{o.splice(q,1),(0,A.isCancellationError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),B&&(0,A.onUnexpectedError)(B))})},1e3)}),process.on("rejectionHandled",B=>{const X=o.indexOf(B);X>=0&&o.splice(X,1)}),process.on("uncaughtException",function(B){(0,A.onUnexpectedError)(B)}),I.mark("code/extHost/willConnectToRenderer");const a=await r();I.mark("code/extHost/didConnectToRenderer");const n=await l(a);I.mark("code/extHost/didWaitForInitData");const{initData:i}=n;g(!!i.environment.extensionTestsLocationURI),i.environment.useHostProxy=b.useHostProxy!==void 0?b.useHostProxy!=="false":void 0,i.environment.skipWorkspaceStorageLock=(0,d.boolean)(b.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(X){p(X)}exists(X){return E.Promises.exists(X)}realpath(X){return(0,D.realpath)(X)}};let k=null;i.remote.authority&&b.transformURIs&&(k=(0,m.createURITransformer)(i.remote.authority));const R=new L.ExtensionHostMain(n.protocol,i,f,k);w=B=>R.terminate(B)}u().catch(o=>console.log(o))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/44531ffc7b7477dbe82750040d8ed69bae2bb140/core/vs/workbench/api/node/extensionHostProcess.js.map
